/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/platform/contextkey/common/contextkey","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/base/common/themables","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(he){for(var e=[],d=0,O=he.length;d<O;d++)e[d]=Se[he[d]];return e};define(Se[163],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class d{static get(){const L=new Map,R=new Map,N=new Map,b=new Map;function $(y,v){y.has(v.detail)||y.set(v.detail,-v.timestamp)}function k(y,v){const h=y.get(v.detail);h&&(h>=0||y.set(v.detail,h+v.timestamp))}let A=[];typeof he=="function"&&typeof he.getStats=="function"&&(A=he.getStats().slice(0).sort((y,v)=>y.timestamp-v.timestamp));for(const y of A)switch(y.type){case 10:$(L,y);break;case 11:case 12:k(L,y);break;case 21:$(R,y);break;case 22:k(R,y);break;case 33:$(N,y);break;case 34:k(N,y);break;case 31:$(b,y);break;case 32:k(b,y);break}let C=0;N.forEach(y=>C+=y);function p(y){const v=[];return y.forEach((h,l)=>v.push([l,h])),v}return{amdLoad:p(L),amdInvoke:p(R),nodeRequire:p(N),nodeEval:p(b),nodeRequireTotal:C}}static toMarkdownTable(L,R){let N="";const b=[];return L.forEach(($,k)=>{b[k]=$.length}),R.forEach($=>{$.forEach((k,A)=>{typeof k>"u"&&(k=$[A]="-");const C=k.toString().length;b[A]=Math.max(C,b[A])})}),L.forEach(($,k)=>{N+=`| ${$+" ".repeat(b[k]-$.toString().length)} `}),N+=`|
`,L.forEach(($,k)=>{N+=`| ${"-".repeat(b[k])} `}),N+=`|
`,R.forEach($=>{$.forEach((k,A)=>{typeof k<"u"&&(N+=`| ${k+" ".repeat(b[A]-k.toString().length)} `)}),N+=`|
`}),N}}e.$U=d}),define(Se[164],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=d,e.$gb=O,e.$hb=L,e.$ib=R,e.$jb=N,e.$kb=b,e.$lb=$,e.$nb=A,e.$ob=C,e.$pb=p,e.$qb=y,e.$rb=v;function d(h,l){const o=O(h,l);if(o!==-1)return h[o]}function O(h,l,o=h.length-1){for(let n=o;n>=0;n--){const i=h[n];if(l(i))return n}return-1}function L(h,l){const o=R(h,l);return o===-1?void 0:h[o]}function R(h,l,o=0,n=h.length){let i=o,u=n;for(;i<u;){const s=Math.floor((i+u)/2);l(h[s])?i=s+1:u=s}return i-1}function N(h,l){const o=b(h,l);return o===h.length?void 0:h[o]}function b(h,l,o=0,n=h.length){let i=o,u=n;for(;i<u;){const s=Math.floor((i+u)/2);l(h[s])?u=s:i=s+1}return i}function $(h,l,o=0,n=h.length){const i=b(h,l,o,n);return i===h.length?-1:i}class k{static{this.assertInvariants=!1}constructor(l){this.e=l,this.c=0}findLastMonotonous(l){if(k.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!l(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=l}const o=R(this.e,l,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=k;function A(h,l){if(h.length===0)return;let o=h[0];for(let n=1;n<h.length;n++){const i=h[n];l(i,o)>0&&(o=i)}return o}function C(h,l){if(h.length===0)return;let o=h[0];for(let n=1;n<h.length;n++){const i=h[n];l(i,o)>=0&&(o=i)}return o}function p(h,l){return A(h,(o,n)=>-l(o,n))}function y(h,l){if(h.length===0)return-1;let o=0;for(let n=1;n<h.length;n++){const i=h[n];l(i,h[o])>0&&(o=n)}return o}function v(h,l){for(const o of h){const n=l(o);if(n!==void 0)return n}}}),define(Se[74],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=d,e.$L=O,e.$M=L,e.$N=R;function d(N,b){const $=Object.create(null);for(const k of N){const A=b(k);let C=$[A];C||(C=$[A]=[]),C.push(k)}return $}function O(N,b){const $=[],k=[];for(const A of N)b.has(A)||$.push(A);for(const A of b)N.has(A)||k.push(A);return{removed:$,added:k}}function L(N,b){const $=[],k=[];for(const[A,C]of N)b.has(A)||$.push(C);for(const[A,C]of b)N.has(A)||k.push(C);return{removed:$,added:k}}function R(N,b){const $=new Set;for(const k of b)N.has(k)&&$.add(k);return $}}),define(Se[56],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=O,e.$2h=L,e.$3h=R;function d(N){return(b,$,k)=>{let A=null,C=null;if(typeof k.value=="function"?(A="value",C=k.value):typeof k.get=="function"&&(A="get",C=k.get),!C)throw new Error("not supported");k[A]=N(C,$)}}function O(N,b,$){let k=null,A=null;if(typeof $.value=="function"?(k="value",A=$.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(k="get",A=$.get),!A)throw new Error("not supported");const C=`$memoize$${b}`;$[k]=function(...p){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,p)}),this[C]}}function L(N,b,$){return d((k,A)=>{const C=`$debounce$${A}`,p=`$debounce$result$${A}`;return function(...y){this[p]||(this[p]=$?$():void 0),clearTimeout(this[C]),b&&(this[p]=b(this[p],...y),y=[this[p]]),this[C]=setTimeout(()=>{k.apply(this,y),this[p]=$?$():void 0},N)}})}function R(N,b,$){return d((k,A)=>{const C=`$throttle$timer$${A}`,p=`$throttle$result$${A}`,y=`$throttle$lastRun$${A}`,v=`$throttle$pending$${A}`;return function(...h){if(this[p]||(this[p]=$?$():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),b&&(this[p]=b(this[p],...h)),this[v])return;const l=this[y]+N;l<=Date.now()?(this[y]=Date.now(),k.apply(this,[this[p]]),this[p]=$?$():void 0):(this[v]=!0,this[C]=setTimeout(()=>{this[v]=!1,this[y]=Date.now(),k.apply(this,[this[p]]),this[p]=$?$():void 0},l-Date.now()))}})}}),define(Se[13],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=O,e.$Z=L,e.$1=R,e.$2=N,e.$3=b,e.$4=k,e.$6=C,e.$7=p,e.$8=y,e.$0=h;class d{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(c=>{c(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=d,e.$X=new d;function O(s){e.$X.setUnexpectedErrorHandler(s)}function L(s){if(!s||typeof s!="object")return!1;const t=s;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(s){k(s)||e.$X.onUnexpectedError(s)}function N(s){k(s)||e.$X.onUnexpectedExternalError(s)}function b(s){if(s instanceof Error){const{name:t,message:c}=s,r=s.stacktrace||s.stack;return{$isError:!0,name:t,message:c,stack:r,noTelemetry:i.isErrorNoTelemetry(s)}}return s}const $="Canceled";function k(s){return s instanceof A?!0:s instanceof Error&&s.name===$&&s.message===$}class A extends Error{constructor(){super($),this.name=this.message}}e.$5=A;function C(){const s=new Error($);return s.name=s.message,s}function p(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function y(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class v extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=v;function h(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class l extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=l;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const c=new i;return c.message=t.message,c.stack=t.stack,c}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class u extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}e.$cb=u}),define(Se[19],De([1,0,13,164]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=L,e.$tb=R,e.$ub=N,e.$vb=b,e.$wb=$,e.$xb=k,e.$yb=A,e.$zb=C,e.$Ab=p,e.$Bb=y,e.$Cb=v,e.$Db=h,e.$Eb=l,e.top=o,e.$Gb=n,e.$Hb=u,e.$Ib=s,e.$Jb=t,e.$Kb=c,e.$Lb=r,e.$Mb=a,e.$Nb=f,e.$Ob=g,e.$Pb=w,e.$Qb=S,e.$Rb=m,e.$Sb=E,e.$Tb=D,e.$Ub=P,e.$Vb=I,e.$Wb=F,e.$Xb=T,e.$Yb=z,e.$Zb=M,e.$1b=j,e.$2b=U,e.$3b=Z,e.$4b=ie,e.$5b=q,e.$6b=ne,e.$7b=be,e.$0b=ee;function L(ue,ce=0){return ue[ue.length-(1+ce)]}function R(ue){if(ue.length===0)throw new Error("Invalid tail call");return[ue.slice(0,ue.length-1),ue[ue.length-1]]}function N(ue,ce,oe=(le,K)=>le===K){if(ue===ce)return!0;if(!ue||!ce||ue.length!==ce.length)return!1;for(let le=0,K=ue.length;le<K;le++)if(!oe(ue[le],ce[le]))return!1;return!0}function b(ue,ce){const oe=ue.length-1;ce<oe&&(ue[ce]=ue[oe]),ue.pop()}function $(ue,ce,oe){return k(ue.length,le=>oe(ue[le],ce))}function k(ue,ce){let oe=0,le=ue-1;for(;oe<=le;){const K=(oe+le)/2|0,se=ce(K);if(se<0)oe=K+1;else if(se>0)le=K-1;else return K}return-(oe+1)}function A(ue,ce,oe){if(ue=ue|0,ue>=ce.length)throw new TypeError("invalid index");const le=ce[Math.floor(ce.length*Math.random())],K=[],se=[],$e=[];for(const ve of ce){const Re=oe(ve,le);Re<0?K.push(ve):Re>0?se.push(ve):$e.push(ve)}return ue<K.length?A(ue,K,oe):ue<K.length+$e.length?$e[0]:A(ue-(K.length+$e.length),se,oe)}function C(ue,ce){const oe=[];let le;for(const K of ue.slice(0).sort(ce))!le||ce(le[0],K)!==0?(le=[K],oe.push(le)):le.push(K);return oe}function*p(ue,ce){let oe,le;for(const K of ue)le!==void 0&&ce(le,K)?oe.push(K):(oe&&(yield oe),oe=[K]),le=K;oe&&(yield oe)}function y(ue,ce){for(let oe=0;oe<=ue.length;oe++)ce(oe===0?void 0:ue[oe-1],oe===ue.length?void 0:ue[oe])}function v(ue,ce){for(let oe=0;oe<ue.length;oe++)ce(oe===0?void 0:ue[oe-1],ue[oe],oe+1===ue.length?void 0:ue[oe+1])}function h(ue,ce,oe){const le=[];function K(ve,Re,ge){if(Re===0&&ge.length===0)return;const Ie=le[le.length-1];Ie&&Ie.start+Ie.deleteCount===ve?(Ie.deleteCount+=Re,Ie.toInsert.push(...ge)):le.push({start:ve,deleteCount:Re,toInsert:ge})}let se=0,$e=0;for(;;){if(se===ue.length){K(se,0,ce.slice($e));break}if($e===ce.length){K(se,ue.length-se,[]);break}const ve=ue[se],Re=ce[$e],ge=oe(ve,Re);ge===0?(se+=1,$e+=1):ge<0?(K(se,1,[]),se+=1):ge>0&&(K(se,0,[Re]),$e+=1)}return le}function l(ue,ce,oe){const le=h(ue,ce,oe),K=[],se=[];for(const $e of le)K.push(...ue.slice($e.start,$e.start+$e.deleteCount)),se.push(...$e.toInsert);return{removed:K,added:se}}function o(ue,ce,oe){if(oe===0)return[];const le=ue.slice(0,oe).sort(ce);return i(ue,ce,le,oe,ue.length),le}function n(ue,ce,oe,le,K){return oe===0?Promise.resolve([]):new Promise((se,$e)=>{(async()=>{const ve=ue.length,Re=ue.slice(0,oe).sort(ce);for(let ge=oe,Ie=Math.min(oe+le,ve);ge<ve;ge=Ie,Ie=Math.min(Ie+le,ve)){if(ge>oe&&await new Promise(Ae=>setTimeout(Ae)),K&&K.isCancellationRequested)throw new d.$5;i(ue,ce,Re,ge,Ie)}return Re})().then(se,$e)})}function i(ue,ce,oe,le,K){for(const se=oe.length;le<K;le++){const $e=ue[le];if(ce($e,oe[se-1])<0){oe.pop();const ve=(0,O.$kb)(oe,Re=>ce($e,Re)<0);oe.splice(ve,0,$e)}}}function u(ue){return ue.filter(ce=>!!ce)}function s(ue){let ce=0;for(let oe=0;oe<ue.length;oe++)ue[oe]&&(ue[ce]=ue[oe],ce+=1);ue.length=ce}function t(ue,ce,oe){ue.splice(oe,0,ue.splice(ce,1)[0])}function c(ue){return!Array.isArray(ue)||ue.length===0}function r(ue){return Array.isArray(ue)&&ue.length>0}function a(ue,ce=oe=>oe){const oe=new Set;return ue.filter(le=>{const K=ce(le);return oe.has(K)?!1:(oe.add(K),!0)})}function f(ue){const ce=new Set;return oe=>{const le=ue(oe);return ce.has(le)?!1:(ce.add(le),!0)}}function g(ue,ce){return ue.length>0?ue[0]:ce}function w(ue,ce){return ue.length>0?ue[ue.length-1]:ce}function S(ue,ce,oe=(le,K)=>le===K){let le=0;for(let K=0,se=Math.min(ue.length,ce.length);K<se&&oe(ue[K],ce[K]);K++)le++;return le}function m(ue,ce){let oe=typeof ce=="number"?ue:0;typeof ce=="number"?oe=ue:(oe=0,ce=ue);const le=[];if(oe<=ce)for(let K=oe;K<ce;K++)le.push(K);else for(let K=oe;K>ce;K--)le.push(K);return le}function E(ue,ce,oe){return ue.reduce((le,K)=>(le[ce(K)]=oe?oe(K):K,le),Object.create(null))}function D(ue,ce){return ue.push(ce),()=>P(ue,ce)}function P(ue,ce){const oe=ue.indexOf(ce);if(oe>-1)return ue.splice(oe,1),ce}function I(ue,ce,oe){const le=ue.slice(0,ce),K=ue.slice(ce);return le.concat(oe,K)}function F(ue,ce){let oe;if(typeof ce=="number"){let le=ce;oe=()=>{const K=Math.sin(le++)*179426549;return K-Math.floor(K)}}else oe=Math.random;for(let le=ue.length-1;le>0;le-=1){const K=Math.floor(oe()*(le+1)),se=ue[le];ue[le]=ue[K],ue[K]=se}}function T(ue,ce){const oe=ue.indexOf(ce);oe>-1&&(ue.splice(oe,1),ue.unshift(ce))}function z(ue,ce){const oe=ue.indexOf(ce);oe>-1&&(ue.splice(oe,1),ue.push(ce))}function M(ue,ce){for(const oe of ce)ue.push(oe)}function j(ue,ce){return Array.isArray(ue)?ue.map(ce):ce(ue)}function U(ue){return Array.isArray(ue)?ue:[ue]}function Z(ue){return ue[Math.floor(Math.random()*ue.length)]}function ie(ue,ce,oe){const le=G(ue,ce),K=ue.length,se=oe.length;ue.length=K+se;for(let $e=K-1;$e>=le;$e--)ue[$e+se]=ue[$e];for(let $e=0;$e<se;$e++)ue[$e+le]=oe[$e]}function q(ue,ce,oe,le){const K=G(ue,ce);let se=ue.splice(K,oe);return se===void 0&&(se=[]),ie(ue,K,le),se}function G(ue,ce){return ce<0?Math.max(ce+ue.length,0):Math.min(ce,ue.length)}var x;(function(ue){function ce(se){return se<0}ue.isLessThan=ce;function oe(se){return se<=0}ue.isLessThanOrEqual=oe;function le(se){return se>0}ue.isGreaterThan=le;function K(se){return se===0}ue.isNeitherLessOrGreaterThan=K,ue.greaterThan=1,ue.lessThan=-1,ue.neitherLessOrGreaterThan=0})(x||(e.CompareResult=x={}));function ne(ue,ce){return(oe,le)=>ce(ue(oe),ue(le))}function be(...ue){return(ce,oe)=>{for(const le of ue){const K=le(ce,oe);if(!x.isNeitherLessOrGreaterThan(K))return K}return x.neitherLessOrGreaterThan}}const ae=(ue,ce)=>ue-ce;e.$8b=ae;const Ce=(ue,ce)=>(0,e.$8b)(ue?1:0,ce?1:0);e.$9b=Ce;function ee(ue){return(ce,oe)=>-ue(ce,oe)}class B{constructor(ce){this.g=ce,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ce){let oe=this.c;for(;oe<this.g.length&&ce(this.g[oe]);)oe++;const le=oe===this.c?null:this.g.slice(this.c,oe);return this.c=oe,le}takeFromEndWhile(ce){let oe=this.d;for(;oe>=0&&ce(this.g[oe]);)oe--;const le=oe===this.d?null:this.g.slice(oe+1,this.d+1);return this.d=oe,le}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ce=this.g[this.c];return this.c++,ce}removeLast(){const ce=this.g[this.d];return this.d--,ce}takeCount(ce){const oe=this.g.slice(this.c,this.c+ce);return this.c+=ce,oe}}e.$$b=B;class _{static{this.empty=new _(ce=>{})}constructor(ce){this.iterate=ce}forEach(ce){this.iterate(oe=>(ce(oe),!0))}toArray(){const ce=[];return this.iterate(oe=>(ce.push(oe),!0)),ce}filter(ce){return new _(oe=>this.iterate(le=>ce(le)?oe(le):!0))}map(ce){return new _(oe=>this.iterate(le=>oe(ce(le))))}some(ce){let oe=!1;return this.iterate(le=>(oe=ce(le),!oe)),oe}findFirst(ce){let oe;return this.iterate(le=>ce(le)?(oe=le,!1):!0),oe}findLast(ce){let oe;return this.iterate(le=>(ce(le)&&(oe=le),!0)),oe}findLastMaxBy(ce){let oe,le=!0;return this.iterate(K=>((le||x.isGreaterThan(ce(K,oe)))&&(le=!1,oe=K),!0)),oe}}e.$_b=_;class pe{constructor(ce){this.c=ce}static createSortPermutation(ce,oe){const le=Array.from(ce.keys()).sort((K,se)=>oe(ce[K],ce[se]));return new pe(le)}apply(ce){return ce.map((oe,le)=>ce[this.c[le]])}inverse(){const ce=this.c.slice();for(let oe=0;oe<this.c.length;oe++)ce[this.c[oe]]=oe;return new pe(ce)}}e.$ac=pe}),define(Se[62],De([1,0,13]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=O,e.$ed=L,e.$fd=R,e.$gd=N,e.$hd=b,e.$id=$;function O(k,A){if(!k)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}function L(k,A="Unreachable"){throw new Error(A)}function R(k){if(!k)throw new d.$cb("Assertion Failed")}function N(k){k||(0,d.$1)(new d.$cb("Soft Assertion Failed"))}function b(k){if(!k()){debugger;k(),(0,d.$1)(new d.$cb("Assertion Failed"))}}function $(k,A){let C=0;for(;C<k.length-1;){const p=k[C],y=k[C+1];if(!A(p,y))return!1;C++}return!0}}),define(Se[165],De([1,0,19]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=L,e.$8c=R,e.$9c=N,e.$0c=b,e.$$c=$,e.$_c=k;const O=(y,v)=>y===v;e.$6c=O;function L(y=e.$6c){return(v,h)=>d.$ub(v,h,y)}function R(){return(y,v)=>JSON.stringify(y)===JSON.stringify(v)}function N(){return(y,v)=>y.equals(v)}function b(y,v,h){return!y||!v?y===v:h(y,v)}function $(y,v){if(y===v)return!0;if(Array.isArray(y)&&Array.isArray(v)){if(y.length!==v.length)return!1;for(let h=0;h<y.length;h++)if(!$(y[h],v[h]))return!1;return!0}if(y&&typeof y=="object"&&v&&typeof v=="object"&&Object.getPrototypeOf(y)===Object.prototype&&Object.getPrototypeOf(v)===Object.prototype){const h=y,l=v,o=Object.keys(h),n=Object.keys(l),i=new Set(n);if(o.length!==n.length)return!1;for(const u of o)if(!i.has(u)||!$(h[u],l[u]))return!1;return!0}return!1}function k(y){return JSON.stringify(p(y))}let A=0;const C=new WeakMap;function p(y){if(Array.isArray(y))return y.map(p);if(y&&typeof y=="object")if(Object.getPrototypeOf(y)===Object.prototype){const v=y,h=Object.create(null);for(const l of Object.keys(v).sort())h[l]=p(v[l]);return h}else{let v=C.get(y);return v===void 0&&(v=A++,C.set(y,v)),v+"----2b76a038c20c4bcc"}return y}}),define(Se[75],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=d;function d(O,L){const R=this;let N=!1,b;return function(){if(N)return b;if(N=!0,L)try{b=O.apply(R,arguments)}finally{L()}else b=O.apply(R,arguments);return b}}}),define(Se[125],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FP=e.$EP=void 0;class d{constructor(L){this.a=L,this.b=0}nextId(){return this.a+ ++this.b}}e.$EP=d,e.$FP=new d("id#")}),define(Se[39],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var d;(function(O){function L(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}O.is=L;const R=Object.freeze([]);function N(){return R}O.empty=N;function*b(t){yield t}O.single=b;function $(t){return L(t)?t:b(t)}O.wrap=$;function k(t){return t||R}O.from=k;function*A(t){for(let c=t.length-1;c>=0;c--)yield t[c]}O.reverse=A;function C(t){return!t||t[Symbol.iterator]().next().done===!0}O.isEmpty=C;function p(t){return t[Symbol.iterator]().next().value}O.first=p;function y(t,c){for(const r of t)if(c(r))return!0;return!1}O.some=y;function v(t,c){for(const r of t)if(c(r))return r}O.find=v;function*h(t,c){for(const r of t)c(r)&&(yield r)}O.filter=h;function*l(t,c){let r=0;for(const a of t)yield c(a,r++)}O.map=l;function*o(...t){for(const c of t)yield*c}O.concat=o;function n(t,c,r){let a=r;for(const f of t)a=c(a,f);return a}O.reduce=n;function*i(t,c,r=t.length){for(c<0&&(c+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);c<r;c++)yield t[c]}O.slice=i;function u(t,c=Number.POSITIVE_INFINITY){const r=[];if(c===0)return[r,t];const a=t[Symbol.iterator]();for(let f=0;f<c;f++){const g=a.next();if(g.done)return[r,O.empty()];r.push(g.value)}return[r,{[Symbol.iterator](){return a}}]}O.consume=u;async function s(t){const c=[];for await(const r of t)c.push(r);return Promise.resolve(c)}O.asyncToArray=s})(d||(e.Iterable=d={}))}),define(Se[166],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Hn=N,e.$In=C,e.$Jn=p,e.$Kn=y,e.$Ln=v,e.$Mn=h,e.$Nn=l,e.$On=o,e.$Pn=n,e.$Qn=i,e.$Rn=u,e.$Sn=s;var d;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(d||(e.ScanError=d={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function N(t,c=!1){let r=0;const a=t.length;let f="",g=0,w=16,S=0;function m(z){let M=0,j=0;for(;M<z;){const U=t.charCodeAt(r);if(U>=48&&U<=57)j=j*16+U-48;else if(U>=65&&U<=70)j=j*16+U-65+10;else if(U>=97&&U<=102)j=j*16+U-97+10;else break;r++,M++}return M<z&&(j=-1),j}function E(z){r=z,f="",g=0,w=16,S=0}function D(){const z=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&k(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&k(t.charCodeAt(r)))for(r++;r<t.length&&k(t.charCodeAt(r));)r++;else return S=3,t.substring(z,r);let M=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&k(t.charCodeAt(r))){for(r++;r<t.length&&k(t.charCodeAt(r));)r++;M=r}else S=3;return t.substring(z,M)}function P(){let z="",M=r;for(;;){if(r>=a){z+=t.substring(M,r),S=2;break}const j=t.charCodeAt(r);if(j===34){z+=t.substring(M,r),r++;break}if(j===92){if(z+=t.substring(M,r),r++,r>=a){S=2;break}switch(t.charCodeAt(r++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const Z=m(4);Z>=0?z+=String.fromCharCode(Z):S=4;break}default:S=5}M=r;continue}if(j>=0&&j<=31)if($(j)){z+=t.substring(M,r),S=2;break}else S=6;r++}return z}function I(){if(f="",S=0,g=r,r>=a)return g=a,w=17;let z=t.charCodeAt(r);if(b(z)){do r++,f+=String.fromCharCode(z),z=t.charCodeAt(r);while(b(z));return w=15}if($(z))return r++,f+=String.fromCharCode(z),z===13&&t.charCodeAt(r)===10&&(r++,f+=`
`),w=14;switch(z){case 123:return r++,w=1;case 125:return r++,w=2;case 91:return r++,w=3;case 93:return r++,w=4;case 58:return r++,w=6;case 44:return r++,w=5;case 34:return r++,f=P(),w=10;case 47:{const M=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<a&&!$(t.charCodeAt(r));)r++;return f=t.substring(M,r),w=12}if(t.charCodeAt(r+1)===42){r+=2;const j=a-1;let U=!1;for(;r<j;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,U=!0;break}r++}return U||(r++,S=1),f=t.substring(M,r),w=13}return f+=String.fromCharCode(z),r++,w=16}case 45:if(f+=String.fromCharCode(z),r++,r===a||!k(t.charCodeAt(r)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return f+=D(),w=11;default:for(;r<a&&F(z);)r++,z=t.charCodeAt(r);if(g!==r){switch(f=t.substring(g,r),f){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return f+=String.fromCharCode(z),r++,w=16}}function F(z){if(b(z)||$(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let z;do z=I();while(z>=12&&z<=15);return z}return{setPosition:E,getPosition:()=>r,scan:c?T:I,getToken:()=>w,getTokenValue:()=>f,getTokenOffset:()=>g,getTokenLength:()=>r-g,getTokenError:()=>S}}function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function C(t,c){const r=[],a=new Object;let f;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function S(m,E,D,P){g.value=m,g.offset=E,g.length=D,g.type=P,g.colonOffset=void 0,f=g}try{i(t,{onObjectBegin:(m,E)=>{if(c<=m)throw a;f=void 0,w=c>m,r.push("")},onObjectProperty:(m,E,D)=>{if(c<E||(S(m,E,D,"property"),r[r.length-1]=m,c<=E+D))throw a},onObjectEnd:(m,E)=>{if(c<=m)throw a;f=void 0,r.pop()},onArrayBegin:(m,E)=>{if(c<=m)throw a;f=void 0,r.push(0)},onArrayEnd:(m,E)=>{if(c<=m)throw a;f=void 0,r.pop()},onLiteralValue:(m,E,D)=>{if(c<E||(S(m,E,D,s(m)),c<=E+D))throw a},onSeparator:(m,E,D)=>{if(c<=E)throw a;if(m===":"&&f&&f.type==="property")f.colonOffset=E,w=!1,f=void 0;else if(m===","){const P=r[r.length-1];typeof P=="number"?r[r.length-1]=P+1:(w=!0,r[r.length-1]=""),f=void 0}}})}catch(m){if(m!==a)throw m}return{path:r,previousNode:f,isAtPropertyKey:w,matches:m=>{let E=0;for(let D=0;E<m.length&&D<r.length;D++)if(m[E]===r[D]||m[E]==="*")E++;else if(m[E]!=="**")return!1;return E===m.length}}}function p(t,c=[],r=R.DEFAULT){let a=null,f=[];const g=[];function w(m){Array.isArray(f)?f.push(m):a!==null&&(f[a]=m)}return i(t,{onObjectBegin:()=>{const m={};w(m),g.push(f),f=m,a=null},onObjectProperty:m=>{a=m},onObjectEnd:()=>{f=g.pop()},onArrayBegin:()=>{const m=[];w(m),g.push(f),f=m,a=null},onArrayEnd:()=>{f=g.pop()},onLiteralValue:w,onError:(m,E,D)=>{c.push({error:m,offset:E,length:D})}},r),f[0]}function y(t,c=[],r=R.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function f(m){a.type==="property"&&(a.length=m-a.offset,a=a.parent)}function g(m){return a.children.push(m),m}i(t,{onObjectBegin:m=>{a=g({type:"object",offset:m,length:-1,parent:a,children:[]})},onObjectProperty:(m,E,D)=>{a=g({type:"property",offset:E,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:m,offset:E,length:D,parent:a})},onObjectEnd:(m,E)=>{a.length=m+E-a.offset,a=a.parent,f(m+E)},onArrayBegin:(m,E)=>{a=g({type:"array",offset:m,length:-1,parent:a,children:[]})},onArrayEnd:(m,E)=>{a.length=m+E-a.offset,a=a.parent,f(m+E)},onLiteralValue:(m,E,D)=>{g({type:s(m),offset:E,length:D,parent:a,value:m}),f(E+D)},onSeparator:(m,E,D)=>{a.type==="property"&&(m===":"?a.colonOffset=E:m===","&&f(E))},onError:(m,E,D)=>{c.push({error:m,offset:E,length:D})}},r);const S=a.children[0];return S&&delete S.parent,S}function v(t,c){if(!t)return;let r=t;for(const a of c)if(typeof a=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let f=!1;for(const g of r.children)if(Array.isArray(g.children)&&g.children[0].value===a){r=g.children[1],f=!0;break}if(!f)return}else{const f=a;if(r.type!=="array"||f<0||!Array.isArray(r.children)||f>=r.children.length)return;r=r.children[f]}return r}function h(t){if(!t.parent||!t.parent.children)return[];const c=h(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;c.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&c.push(r)}return c}function l(t){switch(t.type){case"array":return t.children.map(l);case"object":{const c=Object.create(null);for(const r of t.children){const a=r.children[1];a&&(c[r.children[0].value]=l(a))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,c,r=!1){return c>=t.offset&&c<t.offset+t.length||r&&c===t.offset+t.length}function n(t,c,r=!1){if(o(t,c,r)){const a=t.children;if(Array.isArray(a))for(let f=0;f<a.length&&a[f].offset<=c;f++){const g=n(a[f],c,r);if(g)return g}return t}}function i(t,c,r=R.DEFAULT){const a=N(t,!1);function f(be){return be?()=>be(a.getTokenOffset(),a.getTokenLength()):()=>!0}function g(be){return be?ae=>be(ae,a.getTokenOffset(),a.getTokenLength()):()=>!0}const w=f(c.onObjectBegin),S=g(c.onObjectProperty),m=f(c.onObjectEnd),E=f(c.onArrayBegin),D=f(c.onArrayEnd),P=g(c.onLiteralValue),I=g(c.onSeparator),F=f(c.onComment),T=g(c.onError),z=r&&r.disallowComments,M=r&&r.allowTrailingComma;function j(){for(;;){const be=a.scan();switch(a.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:z||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(be){case 12:case 13:z?U(10):F();break;case 16:U(1);break;case 15:case 14:break;default:return be}}}function U(be,ae=[],Ce=[]){if(T(be),ae.length+Ce.length>0){let ee=a.getToken();for(;ee!==17;){if(ae.indexOf(ee)!==-1){j();break}else if(Ce.indexOf(ee)!==-1)break;ee=j()}}}function Z(be){const ae=a.getTokenValue();return be?P(ae):S(ae),j(),!0}function ie(){switch(a.getToken()){case 11:{let be=0;try{be=JSON.parse(a.getTokenValue()),typeof be!="number"&&(U(2),be=0)}catch{U(2)}P(be);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return j(),!0}function q(){return a.getToken()!==10?(U(3,[],[2,5]),!1):(Z(!1),a.getToken()===6?(I(":"),j(),ne()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function G(){w(),j();let be=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(be||U(4,[],[]),I(","),j(),a.getToken()===2&&M)break}else be&&U(6,[],[]);q()||U(4,[],[2,5]),be=!0}return m(),a.getToken()!==2?U(7,[2],[]):j(),!0}function x(){E(),j();let be=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(be||U(4,[],[]),I(","),j(),a.getToken()===4&&M)break}else be&&U(6,[],[]);ne()||U(4,[],[4,5]),be=!0}return D(),a.getToken()!==4?U(8,[4],[]):j(),!0}function ne(){switch(a.getToken()){case 3:return x();case 1:return G();case 10:return Z(!0);default:return ie()}}return j(),a.getToken()===17?r.allowEmptyContent?!0:(U(4,[],[]),!1):ne()?(a.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}function u(t,c){const r=N(t),a=[];let f,g=0,w;do switch(w=r.getPosition(),f=r.scan(),f){case 12:case 13:case 17:g!==w&&a.push(t.substring(g,w)),c!==void 0&&a.push(r.getTokenValue().replace(/[^\r\n]/g,c)),g=r.getPosition();break}while(f!==17);return a.join("")}function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Se[46],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class d{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=d}),define(Se[76],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class d{static{this.Undefined=new d(void 0)}constructor(R){this.element=R,this.next=d.Undefined,this.prev=d.Undefined}}class O{constructor(){this.a=d.Undefined,this.b=d.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===d.Undefined}clear(){let R=this.a;for(;R!==d.Undefined;){const N=R.next;R.prev=d.Undefined,R.next=d.Undefined,R=N}this.a=d.Undefined,this.b=d.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,N){const b=new d(R);if(this.a===d.Undefined)this.a=b,this.b=b;else if(N){const k=this.b;this.b=b,b.prev=k,k.next=b}else{const k=this.a;this.a=b,b.next=k,k.prev=b}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(b))}}shift(){if(this.a!==d.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==d.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==d.Undefined&&R.next!==d.Undefined){const N=R.prev;N.next=R.next,R.next.prev=N}else R.prev===d.Undefined&&R.next===d.Undefined?(this.a=d.Undefined,this.b=d.Undefined):R.next===d.Undefined?(this.b=this.b.prev,this.b.next=d.Undefined):R.prev===d.Undefined&&(this.a=this.a.next,this.a.prev=d.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==d.Undefined;)yield R.element,R=R.next}}e.$5c=O}),define(Se[27],De([1,0]),function(he,e){"use strict";var d,O,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=R,e.$yc=N,e.$zc=b,e.$Ic=u;function R(s,t,c){let r=s.get(t);return r===void 0&&(r=c,s.set(t,r)),r}function N(s){const t=[];return s.forEach((c,r)=>{t.push(`${r} => ${c}`)}),`Map(${s.size}) {${t.join(", ")}}`}function b(s){const t=[];return s.forEach(c=>{t.push(c)}),`Set(${s.size}) {${t.join(", ")}}`}class ${constructor(t,c){this.uri=t,this.value=c}}function k(s){return Array.isArray(s)}class A{static{this.c=t=>t.toString()}constructor(t,c){if(this[d]="ResourceMap",t instanceof A)this.d=new Map(t.d),this.e=c??A.c;else if(k(t)){this.d=new Map,this.e=c??A.c;for(const[r,a]of t)this.set(r,a)}else this.d=new Map,this.e=t??A.c}set(t,c){return this.d.set(this.e(t),new $(t,c)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,c){typeof c<"u"&&(t=t.bind(c));for(const[r,a]of this.d)t(a.value,a.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(d=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=A;class C{constructor(t,c){this[O]="ResourceSet",!t||typeof t=="function"?this.c=new A(t):(this.c=new A(c),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,c){this.c.forEach((r,a)=>t.call(c,a,a,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=C;var p;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class y{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,c=0){const r=this.c.get(t);if(r)return c!==0&&this.m(r,c),r.value}set(t,c,r=0){let a=this.c.get(t);if(a)a.value=c,r!==0&&this.m(a,r);else{switch(a={key:t,value:c,next:void 0,previous:void 0},r){case 0:this.k(a);break;case 1:this.j(a);break;case 2:this.k(a);break;default:this.k(a);break}this.c.set(t,a),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const c=this.c.get(t);if(c)return this.c.delete(t),this.l(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,c){const r=this.g;let a=this.d;for(;a;){if(c?t.bind(c)(a.value,a.key,this):t(a.value,a.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const t=this,c=this.g;let r=this.d;const a={[Symbol.iterator](){return a},next(){if(t.g!==c)throw new Error("LinkedMap got modified during iteration.");if(r){const f={value:r.key,done:!1};return r=r.next,f}else return{value:void 0,done:!0}}};return a}values(){const t=this,c=this.g;let r=this.d;const a={[Symbol.iterator](){return a},next(){if(t.g!==c)throw new Error("LinkedMap got modified during iteration.");if(r){const f={value:r.value,done:!1};return r=r.next,f}else return{value:void 0,done:!0}}};return a}entries(){const t=this,c=this.g;let r=this.d;const a={[Symbol.iterator](){return a},next(){if(t.g!==c)throw new Error("LinkedMap got modified during iteration.");if(r){const f={value:[r.key,r.value],done:!1};return r=r.next,f}else return{value:void 0,done:!0}}};return a}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this.d,r=this.size;for(;c&&r>t;)this.c.delete(c.key),c=c.next,r--;this.d=c,this.f=r,c&&(c.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this.e,r=this.size;for(;c&&r>t;)this.c.delete(c.key),c=c.previous,r--;this.e=c,this.f=r,c&&(c.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const c=t.next,r=t.previous;if(!c||!r)throw new Error("Invalid list");c.previous=r,r.next=c}t.next=void 0,t.previous=void 0,this.g++}m(t,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(t===this.d)return;const r=t.next,a=t.previous;t===this.e?(a.next=void 0,this.e=a):(r.previous=a,a.next=r),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(c===2){if(t===this.e)return;const r=t.next,a=t.previous;t===this.d?(r.previous=void 0,this.d=r):(r.previous=a,a.next=r),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((c,r)=>{t.push([r,c])}),t}fromJSON(t){this.clear();for(const[c,r]of t)this.set(c,r)}}e.$Cc=y;class v extends y{constructor(t,c=1){super(),this.n=t,this.o=Math.min(Math.max(0,c),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,c=2){return super.get(t,c)}peek(t){return super.get(t,0)}set(t,c){return super.set(t,c,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class h extends v{constructor(t,c=1){super(t,c)}q(t){this.h(t)}set(t,c){return super.set(t,c),this.p(),this}}e.$Dc=h;class l extends v{constructor(t,c=1){super(t,c)}q(t){this.i(t)}set(t,c){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,c),this}}e.$Ec=l;class o{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let c=this.c.get(t)||0;return c===0?!1:(c--,c===0?this.c.delete(t):this.c.set(t,c),!0)}has(t){return this.c.has(t)}}e.$Fc=o;class n{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[c,r]of t)this.set(c,r)}clear(){this.c.clear(),this.d.clear()}set(t,c){this.c.set(t,c),this.d.set(c,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const c=this.c.get(t);return c===void 0?!1:(this.c.delete(t),this.d.delete(c),!0)}forEach(t,c){this.c.forEach((r,a)=>{t.call(c,r,a,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=n;class i{constructor(){this.c=new Map}add(t,c){let r=this.c.get(t);r||(r=new Set,this.c.set(t,r)),r.add(c)}delete(t,c){const r=this.c.get(t);r&&(r.delete(c),r.size===0&&this.c.delete(t))}forEach(t,c){const r=this.c.get(t);r&&r.forEach(c)}get(t){const c=this.c.get(t);return c||new Set}}e.$Hc=i;function u(s,t){if(s===t)return!0;if(s.size!==t.size)return!1;for(const[c,r]of s)if(!t.has(c)||t.get(c)!==r)return!1;for(const[c]of t)if(!s.has(c))return!1;return!0}}),define(Se[3],De([1,0,19,74,27,75,39]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=A,e.$Lc=C,e.$Mc=p,e.$Nc=h,e.$Oc=l,e.$Pc=o,e.$Qc=n,e.$Rc=i,e.$Sc=u,e.$3c=m;const b=!1;let $=null;class k{constructor(){this.b=new Map}static{this.a=0}c(P){let I=this.b.get(P);return I||(I={parent:null,source:null,isSingleton:!1,value:P,idx:k.a++},this.b.set(P,I)),I}trackDisposable(P){const I=this.c(P);I.source||(I.source=new Error().stack)}setParent(P,I){const F=this.c(P);F.parent=I}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,I){const F=I.get(P);if(F)return F;const T=P.parent?this.f(this.c(P.parent),I):P;return I.set(P,T),T}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,P).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(P=10,I){let F;if(I)F=I;else{const U=new Map,Z=[...this.b.values()].filter(q=>q.source!==null&&!this.f(q,U).isSingleton);if(Z.length===0)return;const ie=new Set(Z.map(q=>q.value));if(F=Z.filter(q=>!(q.parent&&ie.has(q.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function T(U){function Z(q,G){for(;q.length>0&&G.some(x=>typeof x=="string"?x===q[0]:q[0].match(x));)q.shift()}const ie=U.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return Z(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const z=new L.$Hc;for(const U of F){const Z=T(U);for(let ie=0;ie<=Z.length;ie++)z.add(Z.slice(0,ie).join(`
`),U)}F.sort((0,d.$6b)(U=>U.idx,d.$8b));let M="",j=0;for(const U of F.slice(0,P)){j++;const Z=T(U),ie=[];for(let q=0;q<Z.length;q++){let G=Z[q];G=`(shared with ${z.get(Z.slice(0,q+1).join(`
`)).size}/${F.length} leaks) at ${G}`;const ne=z.get(Z.slice(0,q).join(`
`)),be=(0,O.$K)([...ne].map(ae=>T(ae)[q]),ae=>ae);delete be[Z[q]];for(const[ae,Ce]of Object.entries(be))ie.unshift(`    - stacktraces of ${Ce.length} other leaks continue with ${ae}`);ie.unshift(G)}M+=`


==================== Leaking disposable ${j}/${F.length}: ${U.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return F.length>P&&(M+=`


... and ${F.length-P} more leaking disposables

`),{leaks:F,details:M}}}e.$Jc=k;function A(D){$=D}if(b){const D="__is_disposable_tracked__";A(new class{trackDisposable(P){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[D]||console.log(I)},3e3)}setParent(P,I){if(P&&P!==t.None)try{P[D]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[D]=!0}catch{}}markAsSingleton(P){}})}function C(D){return $?.trackDisposable(D),D}function p(D){$?.markAsDisposed(D)}function y(D,P){$?.setParent(D,P)}function v(D,P){if($)for(const I of D)$.setParent(I,P)}function h(D){return $?.markAsSingleton(D),D}function l(D){return typeof D=="object"&&D!==null&&typeof D.dispose=="function"&&D.dispose.length===0}function o(D){if(N.Iterable.is(D)){const P=[];for(const I of D)if(I)try{I.dispose()}catch(F){P.push(F)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(D)?[]:D}else if(D)return D.dispose(),D}function n(D){for(const P of D)l(P)&&P.dispose();return[]}function i(...D){const P=u(()=>o(D));return v(D,P),P}function u(D){const P=C({dispose:(0,R.$db)(()=>{p(P),D()})});return P}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return y(P,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),y(P,null))}}e.$Tc=s;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,C(this),y(this.q,this)}dispose(){p(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Uc=t;class c{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&y(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&y(P,null),P}}e.$Vc=c;class r{constructor(P){this.a=new c,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=r;class a{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=a;class f{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(P){let I=P;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,p(this))},this}}e.$Yc=f;class g{constructor(){this.a=new Map}acquire(P,...I){let F=this.a.get(P);F||(F={counter:0,object:this.b(P,...I)},this.a.set(P,F));const{object:T}=F,z=(0,R.$db)(()=>{--F.counter===0&&(this.c(P,F.object),this.a.delete(P))});return F.counter++,{object:T,dispose:z}}}e.$Zc=g;class w{constructor(P){this.a=P}async acquire(P,...I){const F=this.a.acquire(P,...I);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(T){throw F.dispose(),T}}}e.$1c=w;class S{constructor(P){this.object=P}dispose(){}}e.$2c=S;function m(D){const P=new s;try{D(P)}finally{P.dispose()}}class E{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,I,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(P)?.dispose(),this.a.set(P,I)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=E}),function(he,e){typeof define=="function"&&define.amd?define(Se[167],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(he=typeof globalThis<"u"?globalThis:he||self,e(he.marked={}))}(this,function(he){"use strict";function e(ce,oe){for(var le=0;le<oe.length;le++){var K=oe[le];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(ce,K.key,K)}}function d(ce,oe,le){return oe&&e(ce.prototype,oe),le&&e(ce,le),Object.defineProperty(ce,"prototype",{writable:!1}),ce}function O(ce,oe){if(ce){if(typeof ce=="string")return L(ce,oe);var le=Object.prototype.toString.call(ce).slice(8,-1);if(le==="Object"&&ce.constructor&&(le=ce.constructor.name),le==="Map"||le==="Set")return Array.from(ce);if(le==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(le))return L(ce,oe)}}function L(ce,oe){(oe==null||oe>ce.length)&&(oe=ce.length);for(var le=0,K=new Array(oe);le<oe;le++)K[le]=ce[le];return K}function R(ce,oe){var le=typeof Symbol<"u"&&ce[Symbol.iterator]||ce["@@iterator"];if(le)return(le=le.call(ce)).next.bind(le);if(Array.isArray(ce)||(le=O(ce))||oe&&ce&&typeof ce.length=="number"){le&&(ce=le);var K=0;return function(){return K>=ce.length?{done:!0}:{done:!1,value:ce[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function N(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}he.defaults=N();function b(ce){he.defaults=ce}var $=/[&<>"']/,k=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(oe){return p[oe]};function v(ce,oe){if(oe){if($.test(ce))return ce.replace(k,y)}else if(A.test(ce))return ce.replace(C,y);return ce}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(ce){return ce.replace(h,function(oe,le){return le=le.toLowerCase(),le==="colon"?":":le.charAt(0)==="#"?le.charAt(1)==="x"?String.fromCharCode(parseInt(le.substring(2),16)):String.fromCharCode(+le.substring(1)):""})}var o=/(^|[^\[])\^/g;function n(ce,oe){ce=typeof ce=="string"?ce:ce.source,oe=oe||"";var le={replace:function(se,$e){return $e=$e.source||$e,$e=$e.replace(o,"$1"),ce=ce.replace(se,$e),le},getRegex:function(){return new RegExp(ce,oe)}};return le}var i=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function s(ce,oe,le){if(ce){var K;try{K=decodeURIComponent(l(le)).replace(i,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}oe&&!u.test(le)&&(le=f(oe,le));try{le=encodeURI(le).replace(/%25/g,"%")}catch{return null}return le}var t={},c=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function f(ce,oe){t[" "+ce]||(c.test(ce)?t[" "+ce]=ce+"/":t[" "+ce]=m(ce,"/",!0)),ce=t[" "+ce];var le=ce.indexOf(":")===-1;return oe.substring(0,2)==="//"?le?oe:ce.replace(r,"$1")+oe:oe.charAt(0)==="/"?le?oe:ce.replace(a,"$1")+oe:ce+oe}var g={exec:function(){}};function w(ce){for(var oe=1,le,K;oe<arguments.length;oe++){le=arguments[oe];for(K in le)Object.prototype.hasOwnProperty.call(le,K)&&(ce[K]=le[K])}return ce}function S(ce,oe){var le=ce.replace(/\|/g,function($e,ve,Re){for(var ge=!1,Ie=ve;--Ie>=0&&Re[Ie]==="\\";)ge=!ge;return ge?"|":" |"}),K=le.split(/ \|/),se=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>oe)K.splice(oe);else for(;K.length<oe;)K.push("");for(;se<K.length;se++)K[se]=K[se].trim().replace(/\\\|/g,"|");return K}function m(ce,oe,le){var K=ce.length;if(K===0)return"";for(var se=0;se<K;){var $e=ce.charAt(K-se-1);if($e===oe&&!le)se++;else if($e!==oe&&le)se++;else break}return ce.slice(0,K-se)}function E(ce,oe){if(ce.indexOf(oe[1])===-1)return-1;for(var le=ce.length,K=0,se=0;se<le;se++)if(ce[se]==="\\")se++;else if(ce[se]===oe[0])K++;else if(ce[se]===oe[1]&&(K--,K<0))return se;return-1}function D(ce){ce&&ce.sanitize&&!ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ce,oe){if(oe<1)return"";for(var le="";oe>1;)oe&1&&(le+=ce),oe>>=1,ce+=ce;return le+ce}function I(ce,oe,le,K){var se=oe.href,$e=oe.title?v(oe.title):null,ve=ce[1].replace(/\\([\[\]])/g,"$1");if(ce[0].charAt(0)!=="!"){K.state.inLink=!0;var Re={type:"link",raw:le,href:se,title:$e,text:ve,tokens:K.inlineTokens(ve)};return K.state.inLink=!1,Re}return{type:"image",raw:le,href:se,title:$e,text:v(ve)}}function F(ce,oe){var le=ce.match(/^(\s+)(?:```)/);if(le===null)return oe;var K=le[1];return oe.split(`
`).map(function(se){var $e=se.match(/^\s+/);if($e===null)return se;var ve=$e[0];return ve.length>=K.length?se.slice(K.length):se}).join(`
`)}var T=function(){function ce(le){this.options=le||he.defaults}var oe=ce.prototype;return oe.space=function(K){var se=this.rules.block.newline.exec(K);if(se&&se[0].length>0)return{type:"space",raw:se[0]}},oe.code=function(K){var se=this.rules.block.code.exec(K);if(se){var $e=se[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:se[0],codeBlockStyle:"indented",text:this.options.pedantic?$e:m($e,`
`)}}},oe.fences=function(K){var se=this.rules.block.fences.exec(K);if(se){var $e=se[0],ve=F($e,se[3]||"");return{type:"code",raw:$e,lang:se[2]?se[2].trim():se[2],text:ve}}},oe.heading=function(K){var se=this.rules.block.heading.exec(K);if(se){var $e=se[2].trim();if(/#$/.test($e)){var ve=m($e,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&($e=ve.trim())}return{type:"heading",raw:se[0],depth:se[1].length,text:$e,tokens:this.lexer.inline($e)}}},oe.hr=function(K){var se=this.rules.block.hr.exec(K);if(se)return{type:"hr",raw:se[0]}},oe.blockquote=function(K){var se=this.rules.block.blockquote.exec(K);if(se){var $e=se[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:se[0],tokens:this.lexer.blockTokens($e,[]),text:$e}}},oe.list=function(K){var se=this.rules.block.list.exec(K);if(se){var $e,ve,Re,ge,Ie,Ae,ze,V,W,J,X,de,we=se[1].trim(),je=we.length>1,Ve={type:"list",raw:"",ordered:je,start:je?+we.slice(0,-1):"",loose:!1,items:[]};we=je?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=je?we:"[*+-]");for(var Je=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(de=!1,!(!(se=Je.exec(K))||this.rules.block.hr.test(K)));){if($e=se[0],K=K.substring($e.length),V=se[2].split(`
`,1)[0],W=K.split(`
`,1)[0],this.options.pedantic?(ge=2,X=V.trimLeft()):(ge=se[2].search(/[^ ]/),ge=ge>4?1:ge,X=V.slice(ge),ge+=se[1].length),Ae=!1,!V&&/^ *$/.test(W)&&($e+=W+`
`,K=K.substring(W.length+1),de=!0),!de)for(var tt=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,ge-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,ge-1)+"}#");K&&(J=K.split(`
`,1)[0],V=J,this.options.pedantic&&(V=V.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(V)||it.test(V)||tt.test(V)||_e.test(K)));){if(V.search(/[^ ]/)>=ge||!V.trim())X+=`
`+V.slice(ge);else if(!Ae)X+=`
`+V;else break;!Ae&&!V.trim()&&(Ae=!0),$e+=J+`
`,K=K.substring(J.length+1)}Ve.loose||(ze?Ve.loose=!0:/\n *\n *$/.test($e)&&(ze=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(X),ve&&(Re=ve[0]!=="[ ] ",X=X.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:$e,task:!!ve,checked:Re,loose:!1,text:X}),Ve.raw+=$e}Ve.items[Ve.items.length-1].raw=$e.trimRight(),Ve.items[Ve.items.length-1].text=X.trimRight(),Ve.raw=Ve.raw.trimRight();var rt=Ve.items.length;for(Ie=0;Ie<rt;Ie++){this.lexer.state.top=!1,Ve.items[Ie].tokens=this.lexer.blockTokens(Ve.items[Ie].text,[]);var at=Ve.items[Ie].tokens.filter(function(ye){return ye.type==="space"}),Ne=at.every(function(ye){for(var qe=ye.raw.split(""),te=0,re=R(qe),Pe;!(Pe=re()).done;){var He=Pe.value;if(He===`
`&&(te+=1),te>1)return!0}return!1});!Ve.loose&&at.length&&Ne&&(Ve.loose=!0,Ve.items[Ie].loose=!0)}return Ve}},oe.html=function(K){var se=this.rules.block.html.exec(K);if(se){var $e={type:"html",raw:se[0],pre:!this.options.sanitizer&&(se[1]==="pre"||se[1]==="script"||se[1]==="style"),text:se[0]};if(this.options.sanitize){var ve=this.options.sanitizer?this.options.sanitizer(se[0]):v(se[0]);$e.type="paragraph",$e.text=ve,$e.tokens=this.lexer.inline(ve)}return $e}},oe.def=function(K){var se=this.rules.block.def.exec(K);if(se){se[3]&&(se[3]=se[3].substring(1,se[3].length-1));var $e=se[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$e,raw:se[0],href:se[2],title:se[3]}}},oe.table=function(K){var se=this.rules.block.table.exec(K);if(se){var $e={type:"table",header:S(se[1]).map(function(ze){return{text:ze}}),align:se[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:se[3]&&se[3].trim()?se[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($e.header.length===$e.align.length){$e.raw=se[0];var ve=$e.align.length,Re,ge,Ie,Ae;for(Re=0;Re<ve;Re++)/^ *-+: *$/.test($e.align[Re])?$e.align[Re]="right":/^ *:-+: *$/.test($e.align[Re])?$e.align[Re]="center":/^ *:-+ *$/.test($e.align[Re])?$e.align[Re]="left":$e.align[Re]=null;for(ve=$e.rows.length,Re=0;Re<ve;Re++)$e.rows[Re]=S($e.rows[Re],$e.header.length).map(function(ze){return{text:ze}});for(ve=$e.header.length,ge=0;ge<ve;ge++)$e.header[ge].tokens=this.lexer.inline($e.header[ge].text);for(ve=$e.rows.length,ge=0;ge<ve;ge++)for(Ae=$e.rows[ge],Ie=0;Ie<Ae.length;Ie++)Ae[Ie].tokens=this.lexer.inline(Ae[Ie].text);return $e}}},oe.lheading=function(K){var se=this.rules.block.lheading.exec(K);if(se)return{type:"heading",raw:se[0],depth:se[2].charAt(0)==="="?1:2,text:se[1],tokens:this.lexer.inline(se[1])}},oe.paragraph=function(K){var se=this.rules.block.paragraph.exec(K);if(se){var $e=se[1].charAt(se[1].length-1)===`
`?se[1].slice(0,-1):se[1];return{type:"paragraph",raw:se[0],text:$e,tokens:this.lexer.inline($e)}}},oe.text=function(K){var se=this.rules.block.text.exec(K);if(se)return{type:"text",raw:se[0],text:se[0],tokens:this.lexer.inline(se[0])}},oe.escape=function(K){var se=this.rules.inline.escape.exec(K);if(se)return{type:"escape",raw:se[0],text:v(se[1])}},oe.tag=function(K){var se=this.rules.inline.tag.exec(K);if(se)return!this.lexer.state.inLink&&/^<a /i.test(se[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(se[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(se[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(se[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:se[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):v(se[0]):se[0]}},oe.link=function(K){var se=this.rules.inline.link.exec(K);if(se){var $e=se[2].trim();if(!this.options.pedantic&&/^</.test($e)){if(!/>$/.test($e))return;var ve=m($e.slice(0,-1),"\\");if(($e.length-ve.length)%2===0)return}else{var Re=E(se[2],"()");if(Re>-1){var ge=se[0].indexOf("!")===0?5:4,Ie=ge+se[1].length+Re;se[2]=se[2].substring(0,Re),se[0]=se[0].substring(0,Ie).trim(),se[3]=""}}var Ae=se[2],ze="";if(this.options.pedantic){var V=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);V&&(Ae=V[1],ze=V[3])}else ze=se[3]?se[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test($e)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),I(se,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},se[0],this.lexer)}},oe.reflink=function(K,se){var $e;if(($e=this.rules.inline.reflink.exec(K))||($e=this.rules.inline.nolink.exec(K))){var ve=($e[2]||$e[1]).replace(/\s+/g," ");if(ve=se[ve.toLowerCase()],!ve||!ve.href){var Re=$e[0].charAt(0);return{type:"text",raw:Re,text:Re}}return I($e,ve,$e[0],this.lexer)}},oe.emStrong=function(K,se,$e){$e===void 0&&($e="");var ve=this.rules.inline.emStrong.lDelim.exec(K);if(ve&&!(ve[3]&&$e.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Re=ve[1]||ve[2]||"";if(!Re||Re&&($e===""||this.rules.inline.punctuation.exec($e))){var ge=ve[0].length-1,Ie,Ae,ze=ge,V=0,W=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(W.lastIndex=0,se=se.slice(-1*K.length+ge);(ve=W.exec(se))!=null;)if(Ie=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!Ie){if(Ae=Ie.length,ve[3]||ve[4]){ze+=Ae;continue}else if((ve[5]||ve[6])&&ge%3&&!((ge+Ae)%3)){V+=Ae;continue}if(ze-=Ae,!(ze>0)){if(Ae=Math.min(Ae,Ae+ze+V),Math.min(ge,Ae)%2){var J=K.slice(1,ge+ve.index+Ae);return{type:"em",raw:K.slice(0,ge+ve.index+Ae+1),text:J,tokens:this.lexer.inlineTokens(J)}}var X=K.slice(2,ge+ve.index+Ae-1);return{type:"strong",raw:K.slice(0,ge+ve.index+Ae+1),text:X,tokens:this.lexer.inlineTokens(X)}}}}}},oe.codespan=function(K){var se=this.rules.inline.code.exec(K);if(se){var $e=se[2].replace(/\n/g," "),ve=/[^ ]/.test($e),Re=/^ /.test($e)&&/ $/.test($e);return ve&&Re&&($e=$e.substring(1,$e.length-1)),$e=v($e,!0),{type:"codespan",raw:se[0],text:$e}}},oe.br=function(K){var se=this.rules.inline.br.exec(K);if(se)return{type:"br",raw:se[0]}},oe.del=function(K){var se=this.rules.inline.del.exec(K);if(se)return{type:"del",raw:se[0],text:se[2],tokens:this.lexer.inlineTokens(se[2])}},oe.autolink=function(K,se){var $e=this.rules.inline.autolink.exec(K);if($e){var ve,Re;return $e[2]==="@"?(ve=v(this.options.mangle?se($e[1]):$e[1]),Re="mailto:"+ve):(ve=v($e[1]),Re=ve),{type:"link",raw:$e[0],text:ve,href:Re,tokens:[{type:"text",raw:ve,text:ve}]}}},oe.url=function(K,se){var $e;if($e=this.rules.inline.url.exec(K)){var ve,Re;if($e[2]==="@")ve=v(this.options.mangle?se($e[0]):$e[0]),Re="mailto:"+ve;else{var ge;do ge=$e[0],$e[0]=this.rules.inline._backpedal.exec($e[0])[0];while(ge!==$e[0]);ve=v($e[0]),$e[1]==="www."?Re="http://"+ve:Re=ve}return{type:"link",raw:$e[0],text:ve,href:Re,tokens:[{type:"text",raw:ve,text:ve}]}}},oe.inlineText=function(K,se){var $e=this.rules.inline.text.exec(K);if($e){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($e[0]):v($e[0]):$e[0]:ve=v(this.options.smartypants?se($e[0]):$e[0]),{type:"text",raw:$e[0],text:ve}}},ce}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=w({},z),z.gfm=w({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=w({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=n(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=n(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=n(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=n(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=n(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=n(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=n(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=n(M.reflink).replace("label",M._label).replace("ref",z._label).getRegex(),M.nolink=n(M.nolink).replace("ref",z._label).getRegex(),M.reflinkSearch=n(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=w({},M),M.pedantic=w({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=w({},M.normal,{escape:n(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=n(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=w({},M.gfm,{br:n(M.br).replace("{2,}","*").getRegex(),text:n(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(ce){return ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(ce){var oe="",le,K,se=ce.length;for(le=0;le<se;le++)K=ce.charCodeAt(le),Math.random()>.5&&(K="x"+K.toString(16)),oe+="&#"+K+";";return oe}var Z=function(){function ce(le){this.tokens=[],this.tokens.links=Object.create(null),this.options=le||he.defaults,this.options.tokenizer=this.options.tokenizer||new T,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:z.normal,inline:M.normal};this.options.pedantic?(K.block=z.pedantic,K.inline=M.pedantic):this.options.gfm&&(K.block=z.gfm,this.options.breaks?K.inline=M.breaks:K.inline=M.gfm),this.tokenizer.rules=K}ce.lex=function(K,se){var $e=new ce(se);return $e.lex(K)},ce.lexInline=function(K,se){var $e=new ce(se);return $e.inlineTokens(K)};var oe=ce.prototype;return oe.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var se;se=this.inlineQueue.shift();)this.inlineTokens(se.src,se.tokens);return this.tokens},oe.blockTokens=function(K,se){var $e=this;se===void 0&&(se=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(ze,V,W){return V+"    ".repeat(W.length)});for(var ve,Re,ge,Ie;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(ve=ze.call({lexer:$e},K,se))?(K=K.substring(ve.raw.length),se.push(ve),!0):!1}))){if(ve=this.tokenizer.space(K)){K=K.substring(ve.raw.length),ve.raw.length===1&&se.length>0?se[se.length-1].raw+=`
`:se.push(ve);continue}if(ve=this.tokenizer.code(K)){K=K.substring(ve.raw.length),Re=se[se.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+ve.raw,Re.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):se.push(ve);continue}if(ve=this.tokenizer.fences(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.heading(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.hr(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.blockquote(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.list(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.html(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.def(K)){K=K.substring(ve.raw.length),Re=se[se.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+ve.raw,Re.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.lheading(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ge=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,V=K.slice(1),W=void 0;$e.options.extensions.startBlock.forEach(function(J){W=J.call({lexer:this},V),typeof W=="number"&&W>=0&&(ze=Math.min(ze,W))}),ze<1/0&&ze>=0&&(ge=K.substring(0,ze+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(ge))){Re=se[se.length-1],Ie&&Re.type==="paragraph"?(Re.raw+=`
`+ve.raw,Re.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):se.push(ve),Ie=ge.length!==K.length,K=K.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(K)){K=K.substring(ve.raw.length),Re=se[se.length-1],Re&&Re.type==="text"?(Re.raw+=`
`+ve.raw,Re.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):se.push(ve);continue}if(K){var Ae="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,se},oe.inline=function(K,se){return se===void 0&&(se=[]),this.inlineQueue.push({src:K,tokens:se}),se},oe.inlineTokens=function(K,se){var $e=this;se===void 0&&(se=[]);var ve,Re,ge,Ie=K,Ae,ze,V;if(this.tokens.links){var W=Object.keys(this.tokens.links);if(W.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)W.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Ae.index)+"["+P("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"["+P("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(ze||(V=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(X){return(ve=X.call({lexer:$e},K,se))?(K=K.substring(ve.raw.length),se.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.tag(K)){K=K.substring(ve.raw.length),Re=se[se.length-1],Re&&ve.type==="text"&&Re.type==="text"?(Re.raw+=ve.raw,Re.text+=ve.text):se.push(ve);continue}if(ve=this.tokenizer.link(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(ve.raw.length),Re=se[se.length-1],Re&&ve.type==="text"&&Re.type==="text"?(Re.raw+=ve.raw,Re.text+=ve.text):se.push(ve);continue}if(ve=this.tokenizer.emStrong(K,Ie,V)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.codespan(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.br(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.del(K)){K=K.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.autolink(K,U)){K=K.substring(ve.raw.length),se.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(K,U))){K=K.substring(ve.raw.length),se.push(ve);continue}if(ge=K,this.options.extensions&&this.options.extensions.startInline&&function(){var X=1/0,de=K.slice(1),we=void 0;$e.options.extensions.startInline.forEach(function(je){we=je.call({lexer:this},de),typeof we=="number"&&we>=0&&(X=Math.min(X,we))}),X<1/0&&X>=0&&(ge=K.substring(0,X+1))}(),ve=this.tokenizer.inlineText(ge,j)){K=K.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(V=ve.raw.slice(-1)),ze=!0,Re=se[se.length-1],Re&&Re.type==="text"?(Re.raw+=ve.raw,Re.text+=ve.text):se.push(ve);continue}if(K){var J="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return se},d(ce,null,[{key:"rules",get:function(){return{block:z,inline:M}}}]),ce}(),ie=function(){function ce(le){this.options=le||he.defaults}var oe=ce.prototype;return oe.code=function(K,se,$e){var ve=(se||"").match(/\S*/)[0];if(this.options.highlight){var Re=this.options.highlight(K,ve);Re!=null&&Re!==K&&($e=!0,K=Re)}return K=K.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+v(ve,!0)+'">'+($e?K:v(K,!0))+`</code></pre>
`:"<pre><code>"+($e?K:v(K,!0))+`</code></pre>
`},oe.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},oe.html=function(K){return K},oe.heading=function(K,se,$e,ve){if(this.options.headerIds){var Re=this.options.headerPrefix+ve.slug($e);return"<h"+se+' id="'+Re+'">'+K+"</h"+se+`>
`}return"<h"+se+">"+K+"</h"+se+`>
`},oe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},oe.list=function(K,se,$e){var ve=se?"ol":"ul",Re=se&&$e!==1?' start="'+$e+'"':"";return"<"+ve+Re+`>
`+K+"</"+ve+`>
`},oe.listitem=function(K){return"<li>"+K+`</li>
`},oe.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},oe.paragraph=function(K){return"<p>"+K+`</p>
`},oe.table=function(K,se){return se&&(se="<tbody>"+se+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+se+`</table>
`},oe.tablerow=function(K){return`<tr>
`+K+`</tr>
`},oe.tablecell=function(K,se){var $e=se.header?"th":"td",ve=se.align?"<"+$e+' align="'+se.align+'">':"<"+$e+">";return ve+K+("</"+$e+`>
`)},oe.strong=function(K){return"<strong>"+K+"</strong>"},oe.em=function(K){return"<em>"+K+"</em>"},oe.codespan=function(K){return"<code>"+K+"</code>"},oe.br=function(){return this.options.xhtml?"<br/>":"<br>"},oe.del=function(K){return"<del>"+K+"</del>"},oe.link=function(K,se,$e){if(K=s(this.options.sanitize,this.options.baseUrl,K),K===null)return $e;var ve='<a href="'+v(K)+'"';return se&&(ve+=' title="'+se+'"'),ve+=">"+$e+"</a>",ve},oe.image=function(K,se,$e){if(K=s(this.options.sanitize,this.options.baseUrl,K),K===null)return $e;var ve='<img src="'+K+'" alt="'+$e+'"';return se&&(ve+=' title="'+se+'"'),ve+=this.options.xhtml?"/>":">",ve},oe.text=function(K){return K},ce}(),q=function(){function ce(){}var oe=ce.prototype;return oe.strong=function(K){return K},oe.em=function(K){return K},oe.codespan=function(K){return K},oe.del=function(K){return K},oe.html=function(K){return K},oe.text=function(K){return K},oe.link=function(K,se,$e){return""+$e},oe.image=function(K,se,$e){return""+$e},oe.br=function(){return""},ce}(),G=function(){function ce(){this.seen={}}var oe=ce.prototype;return oe.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},oe.getNextSafeSlug=function(K,se){var $e=K,ve=0;if(this.seen.hasOwnProperty($e)){ve=this.seen[K];do ve++,$e=K+"-"+ve;while(this.seen.hasOwnProperty($e))}return se||(this.seen[K]=ve,this.seen[$e]=0),$e},oe.slug=function(K,se){se===void 0&&(se={});var $e=this.serialize(K);return this.getNextSafeSlug($e,se.dryrun)},ce}(),x=function(){function ce(le){this.options=le||he.defaults,this.options.renderer=this.options.renderer||new ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new q,this.slugger=new G}ce.parse=function(K,se){var $e=new ce(se);return $e.parse(K)},ce.parseInline=function(K,se){var $e=new ce(se);return $e.parseInline(K)};var oe=ce.prototype;return oe.parse=function(K,se){se===void 0&&(se=!0);var $e="",ve,Re,ge,Ie,Ae,ze,V,W,J,X,de,we,je,Ve,Je,tt,_e,nt,it,rt=K.length;for(ve=0;ve<rt;ve++){if(X=K[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[X.type]&&(it=this.options.extensions.renderers[X.type].call({parser:this},X),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(X.type))){$e+=it||"";continue}switch(X.type){case"space":continue;case"hr":{$e+=this.renderer.hr();continue}case"heading":{$e+=this.renderer.heading(this.parseInline(X.tokens),X.depth,l(this.parseInline(X.tokens,this.textRenderer)),this.slugger);continue}case"code":{$e+=this.renderer.code(X.text,X.lang,X.escaped);continue}case"table":{for(W="",V="",Ie=X.header.length,Re=0;Re<Ie;Re++)V+=this.renderer.tablecell(this.parseInline(X.header[Re].tokens),{header:!0,align:X.align[Re]});for(W+=this.renderer.tablerow(V),J="",Ie=X.rows.length,Re=0;Re<Ie;Re++){for(ze=X.rows[Re],V="",Ae=ze.length,ge=0;ge<Ae;ge++)V+=this.renderer.tablecell(this.parseInline(ze[ge].tokens),{header:!1,align:X.align[ge]});J+=this.renderer.tablerow(V)}$e+=this.renderer.table(W,J);continue}case"blockquote":{J=this.parse(X.tokens),$e+=this.renderer.blockquote(J);continue}case"list":{for(de=X.ordered,we=X.start,je=X.loose,Ie=X.items.length,J="",Re=0;Re<Ie;Re++)Je=X.items[Re],tt=Je.checked,_e=Je.task,Ve="",Je.task&&(nt=this.renderer.checkbox(tt),je?Je.tokens.length>0&&Je.tokens[0].type==="paragraph"?(Je.tokens[0].text=nt+" "+Je.tokens[0].text,Je.tokens[0].tokens&&Je.tokens[0].tokens.length>0&&Je.tokens[0].tokens[0].type==="text"&&(Je.tokens[0].tokens[0].text=nt+" "+Je.tokens[0].tokens[0].text)):Je.tokens.unshift({type:"text",text:nt}):Ve+=nt),Ve+=this.parse(Je.tokens,je),J+=this.renderer.listitem(Ve,_e,tt);$e+=this.renderer.list(J,de,we);continue}case"html":{$e+=this.renderer.html(X.text);continue}case"paragraph":{$e+=this.renderer.paragraph(this.parseInline(X.tokens));continue}case"text":{for(J=X.tokens?this.parseInline(X.tokens):X.text;ve+1<rt&&K[ve+1].type==="text";)X=K[++ve],J+=`
`+(X.tokens?this.parseInline(X.tokens):X.text);$e+=se?this.renderer.paragraph(J):J;continue}default:{var at='Token with "'+X.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return $e},oe.parseInline=function(K,se){se=se||this.renderer;var $e="",ve,Re,ge,Ie=K.length;for(ve=0;ve<Ie;ve++){if(Re=K[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Re.type]&&(ge=this.options.extensions.renderers[Re.type].call({parser:this},Re),ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Re.type))){$e+=ge||"";continue}switch(Re.type){case"escape":{$e+=se.text(Re.text);break}case"html":{$e+=se.html(Re.text);break}case"link":{$e+=se.link(Re.href,Re.title,this.parseInline(Re.tokens,se));break}case"image":{$e+=se.image(Re.href,Re.title,Re.text);break}case"strong":{$e+=se.strong(this.parseInline(Re.tokens,se));break}case"em":{$e+=se.em(this.parseInline(Re.tokens,se));break}case"codespan":{$e+=se.codespan(Re.text);break}case"br":{$e+=se.br();break}case"del":{$e+=se.del(this.parseInline(Re.tokens,se));break}case"text":{$e+=se.text(Re.text);break}default:{var Ae='Token with "'+Re.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return $e},ce}();function ne(ce,oe,le){if(typeof ce>"u"||ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");if(typeof oe=="function"&&(le=oe,oe=null),oe=w({},ne.defaults,oe||{}),D(oe),le){var K=oe.highlight,se;try{se=Z.lex(ce,oe)}catch(Ie){return le(Ie)}var $e=function(Ae){var ze;if(!Ae)try{oe.walkTokens&&ne.walkTokens(se,oe.walkTokens),ze=x.parse(se,oe)}catch(V){Ae=V}return oe.highlight=K,Ae?le(Ae):le(null,ze)};if(!K||K.length<3||(delete oe.highlight,!se.length))return $e();var ve=0;ne.walkTokens(se,function(Ie){Ie.type==="code"&&(ve++,setTimeout(function(){K(Ie.text,Ie.lang,function(Ae,ze){if(Ae)return $e(Ae);ze!=null&&ze!==Ie.text&&(Ie.text=ze,Ie.escaped=!0),ve--,ve===0&&$e()})},0))}),ve===0&&$e();return}function Re(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+v(Ie.message+"",!0)+"</pre>";throw Ie}try{var ge=Z.lex(ce,oe);if(oe.walkTokens){if(oe.async)return Promise.all(ne.walkTokens(ge,oe.walkTokens)).then(function(){return x.parse(ge,oe)}).catch(Re);ne.walkTokens(ge,oe.walkTokens)}return x.parse(ge,oe)}catch(Ie){Re(Ie)}}ne.options=ne.setOptions=function(ce){return w(ne.defaults,ce),b(ne.defaults),ne},ne.getDefaults=N,ne.defaults=he.defaults,ne.use=function(){for(var ce=arguments.length,oe=new Array(ce),le=0;le<ce;le++)oe[le]=arguments[le];var K=w.apply(void 0,[{}].concat(oe)),se=ne.defaults.extensions||{renderers:{},childTokens:{}},$e;oe.forEach(function(ve){if(ve.extensions&&($e=!0,ve.extensions.forEach(function(ge){if(!ge.name)throw new Error("extension name required");if(ge.renderer){var Ie=se.renderers?se.renderers[ge.name]:null;Ie?se.renderers[ge.name]=function(){for(var Ae=arguments.length,ze=new Array(Ae),V=0;V<Ae;V++)ze[V]=arguments[V];var W=ge.renderer.apply(this,ze);return W===!1&&(W=Ie.apply(this,ze)),W}:se.renderers[ge.name]=ge.renderer}if(ge.tokenizer){if(!ge.level||ge.level!=="block"&&ge.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");se[ge.level]?se[ge.level].unshift(ge.tokenizer):se[ge.level]=[ge.tokenizer],ge.start&&(ge.level==="block"?se.startBlock?se.startBlock.push(ge.start):se.startBlock=[ge.start]:ge.level==="inline"&&(se.startInline?se.startInline.push(ge.start):se.startInline=[ge.start]))}ge.childTokens&&(se.childTokens[ge.name]=ge.childTokens)})),ve.renderer&&function(){var ge=ne.defaults.renderer||new ie,Ie=function(V){var W=ge[V];ge[V]=function(){for(var J=arguments.length,X=new Array(J),de=0;de<J;de++)X[de]=arguments[de];var we=ve.renderer[V].apply(ge,X);return we===!1&&(we=W.apply(ge,X)),we}};for(var Ae in ve.renderer)Ie(Ae);K.renderer=ge}(),ve.tokenizer&&function(){var ge=ne.defaults.tokenizer||new T,Ie=function(V){var W=ge[V];ge[V]=function(){for(var J=arguments.length,X=new Array(J),de=0;de<J;de++)X[de]=arguments[de];var we=ve.tokenizer[V].apply(ge,X);return we===!1&&(we=W.apply(ge,X)),we}};for(var Ae in ve.tokenizer)Ie(Ae);K.tokenizer=ge}(),ve.walkTokens){var Re=ne.defaults.walkTokens;K.walkTokens=function(ge){var Ie=[];return Ie.push(ve.walkTokens.call(this,ge)),Re&&(Ie=Ie.concat(Re.call(this,ge))),Ie}}$e&&(K.extensions=se),ne.setOptions(K)})},ne.walkTokens=function(ce,oe){for(var le=[],K=function(){var Re=$e.value;switch(le=le.concat(oe.call(ne,Re)),Re.type){case"table":{for(var ge=R(Re.header),Ie;!(Ie=ge()).done;){var Ae=Ie.value;le=le.concat(ne.walkTokens(Ae.tokens,oe))}for(var ze=R(Re.rows),V;!(V=ze()).done;)for(var W=V.value,J=R(W),X;!(X=J()).done;){var de=X.value;le=le.concat(ne.walkTokens(de.tokens,oe))}break}case"list":{le=le.concat(ne.walkTokens(Re.items,oe));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[Re.type]?ne.defaults.extensions.childTokens[Re.type].forEach(function(we){le=le.concat(ne.walkTokens(Re[we],oe))}):Re.tokens&&(le=le.concat(ne.walkTokens(Re.tokens,oe)))}},se=R(ce),$e;!($e=se()).done;)K();return le},ne.parseInline=function(ce,oe){if(typeof ce>"u"||ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");oe=w({},ne.defaults,oe||{}),D(oe);try{var le=Z.lexInline(ce,oe);return oe.walkTokens&&ne.walkTokens(le,oe.walkTokens),x.parseInline(le,oe)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+v(K.message+"",!0)+"</pre>";throw K}},ne.Parser=x,ne.parser=x.parse,ne.Renderer=ie,ne.TextRenderer=q,ne.Lexer=Z,ne.lexer=Z.lex,ne.Tokenizer=T,ne.Slugger=G,ne.parse=ne;var be=ne.options,ae=ne.setOptions,Ce=ne.use,ee=ne.walkTokens,B=ne.parseInline,_=ne,pe=x.parse,ue=Z.lex;he.Lexer=Z,he.Parser=x,he.Renderer=ie,he.Slugger=G,he.TextRenderer=q,he.Tokenizer=T,he.getDefaults=N,he.lexer=ue,he.marked=ne,he.options=be,he.parse=_,he.parseInline=B,he.parser=pe,he.setOptions=ae,he.use=Ce,he.walkTokens=ee,Object.defineProperty(he,"__esModule",{value:!0})}),define(Se[168],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=d;function d(h){const l=R(h);if(l&&l.length>0)return new Uint32Array(l)}let O=0;const L=new Uint32Array(10);function R(h){if(O=0,N(h,C,4352),O>0||(N(h,p,4449),O>0)||(N(h,y,4520),O>0)||(N(h,v,12593),O))return L.subarray(0,O);if(h>=44032&&h<=55203){const l=h-44032,o=l%588,n=Math.floor(l/588),i=Math.floor(o/28),u=o%28-1;if(n<C.length?N(n,C,0):4352+n-12593<v.length&&N(4352+n,v,12593),i<p.length?N(i,p,0):4449+i-12593<v.length&&N(4449+i-12593,v,12593),u>=0&&(u<y.length?N(u,y,0):4520+u-12593<v.length&&N(4520+u-12593,v,12593)),O>0)return L.subarray(0,O)}}function N(h,l,o){h>=o&&h<o+l.length&&b(l[h-o])}function b(h){h!==0&&(L[O++]=h&255,h>>8&&(L[O++]=h>>8&255),h>>16&&(L[O++]=h>>16&255))}var $;(function(h){h[h.InitialConsonant=4352]="InitialConsonant",h[h.Vowel=4449]="Vowel",h[h.FinalConsonant=4520]="FinalConsonant",h[h.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var k;(function(h){h[h.NUL=0]="NUL",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z"})(k||(k={}));var A;(function(h){h[h.fa=24934]="fa",h[h.fg=26470]="fg",h[h.fq=29030]="fq",h[h.fr=29286]="fr",h[h.ft=29798]="ft",h[h.fv=30310]="fv",h[h.fx=30822]="fx",h[h.hk=27496]="hk",h[h.hl=27752]="hl",h[h.ho=28520]="ho",h[h.ml=27757]="ml",h[h.nj=27246]="nj",h[h.nl=27758]="nl",h[h.np=28782]="np",h[h.qt=29809]="qt",h[h.rt=29810]="rt",h[h.sg=26483]="sg",h[h.sw=30579]="sw"})(A||(A={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),p=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),y=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),v=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Se[77],De([1,0,27]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=void 0,e.$bm=L,e.$cm=N;const O=new d.$Dc(1e4);function L(k){return $(k,"NFC",O)}const R=new d.$Dc(1e4);function N(k){return $(k,"NFD",R)}const b=/[^\u0000-\u0080]/;function $(k,A,C){if(!k)return k;const p=C.get(k);if(p)return p;let y;return b.test(k)?y=k.normalize(A):y=k,C.set(k,y),y}e.$dm=function(){const k=/[\u0300-\u036f]/g;return function(A){return N(A).replace(k,"")}}()}),define(Se[126],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=void 0,e.$Bm=d,e.rot=O;function d(b,$,k){return Math.min(Math.max(b,$),k)}function O(b,$){return($+b%$)%$}class L{constructor(){this.a=0}getNext(){return this.a++}}e.$Dm=L;class R{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Em=R;class N{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const k=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Fm=N}),define(Se[169],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=R,e.$cd=p;class d{constructor(v,h,l){this.owner=v,this.debugNameSource=h,this.referenceFn=l}getDebugName(v){return R(v,this)}}e.$ad=d;const O=new Map,L=new WeakMap;function R(y,v){const h=L.get(y);if(h)return h;const l=N(y,v);if(l){let o=O.get(l)??0;o++,O.set(l,o);const n=o===1?l:`${l}#${o}`;return L.set(y,n),n}}function N(y,v){const h=L.get(y);if(h)return h;const l=v.owner?A(v.owner)+".":"";let o;const n=v.debugNameSource;if(n!==void 0)if(typeof n=="function"){if(o=n(),o!==void 0)return l+o}else return l+n;const i=v.referenceFn;if(i!==void 0&&(o=p(i),o!==void 0))return l+o;if(v.owner!==void 0){const u=b(v.owner,y);if(u!==void 0)return l+u}}function b(y,v){for(const h in y)if(y[h]===v)return h}const $=new Map,k=new WeakMap;function A(y){const v=k.get(y);if(v)return v;const h=C(y);let l=$.get(h)??0;l++,$.set(h,l);const o=l===1?h:`${h}#${l}`;return k.set(y,o),o}function C(y){const v=y.constructor;return v?v.name:"Object"}function p(y){const v=y.toString(),l=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(v);return(l?l[1]:void 0)?.trim()}}),define(Se[170],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=O,e.$Id=L;let d;function O(h){d=h}function L(){return d}class R{constructor(){this.a=0,this.d=new WeakMap}b(l){return N([b(y("|  ",this.a)),l])}c(l){return l.hadValue?l.didChange?[b(" "),k(A(l.oldValue,70),{color:"red",strikeThrough:!0}),b(" "),k(A(l.newValue,60),{color:"green"})]:[b(" (unchanged)")]:[b(" "),k(A(l.newValue,60),{color:"green"}),b(" (initial)")]}handleObservableChanged(l,o){console.log(...this.b([$("observable value changed"),k(l.debugName,{color:"BlueViolet"}),...this.c(o)]))}formatChanges(l){if(l.size!==0)return k(" (changed deps: "+[...l].map(o=>o.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(l){const o=l.handleChange;this.d.set(l,new Set),l.handleChange=(n,i)=>(this.d.get(l).add(n),o.apply(l,[n,i]))}handleDerivedRecomputed(l,o){const n=this.d.get(l);console.log(...this.b([$("derived recomputed"),k(l.debugName,{color:"BlueViolet"}),...this.c(o),this.formatChanges(n),{data:[{fn:l._computeFn}]}])),n.clear()}handleFromEventObservableTriggered(l,o){console.log(...this.b([$("observable from event triggered"),k(l.debugName,{color:"BlueViolet"}),...this.c(o),{data:[{fn:l._getValue}]}]))}handleAutorunCreated(l){const o=l.handleChange;this.d.set(l,new Set),l.handleChange=(n,i)=>(this.d.get(l).add(n),o.apply(l,[n,i]))}handleAutorunTriggered(l){const o=this.d.get(l);console.log(...this.b([$("autorun"),k(l.debugName,{color:"BlueViolet"}),this.formatChanges(o),{data:[{fn:l._runFn}]}])),o.clear(),this.a++}handleAutorunFinished(l){this.a--}handleBeginTransaction(l){let o=l.getDebugName();o===void 0&&(o=""),console.log(...this.b([$("transaction"),k(o,{color:"BlueViolet"}),{data:[{fn:l._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=R;function N(h){const l=new Array,o=[];let n="";function i(s){if("length"in s)for(const t of s)t&&i(t);else"text"in s?(n+=`%c${s.text}`,l.push(s.style),s.data&&o.push(...s.data)):"data"in s&&o.push(...s.data)}i(h);const u=[n,...l];return u.push(...o),u}function b(h){return k(h,{color:"black"})}function $(h){return k(v(`${h}: `,10),{color:"black",bold:!0})}function k(h,l={color:"black"}){function o(i){return Object.entries(i).reduce((u,[s,t])=>`${u}${s}:${t};`,"")}const n={color:l.color};return l.strikeThrough&&(n["text-decoration"]="line-through"),l.bold&&(n["font-weight"]="bold"),{text:h,style:o(n)}}function A(h,l){switch(typeof h){case"number":return""+h;case"string":return h.length+2<=l?`"${h}"`:`"${h.substr(0,l-7)}"+...`;case"boolean":return h?"true":"false";case"undefined":return"undefined";case"object":return h===null?"null":Array.isArray(h)?C(h,l):p(h,l);case"symbol":return h.toString();case"function":return`[[Function${h.name?" "+h.name:""}]]`;default:return""+h}}function C(h,l){let o="[ ",n=!0;for(const i of h){if(n||(o+=", "),o.length-5>l){o+="...";break}n=!1,o+=`${A(i,l-o.length)}`}return o+=" ]",o}function p(h,l){let o="{ ",n=!0;for(const[i,u]of Object.entries(h)){if(n||(o+=", "),o.length-5>l){o+="...";break}n=!1,o+=`${i}: ${A(u,l-o.length)}`}return o+=" }",o}function y(h,l){let o="";for(let n=1;n<=l;n++)o+=h;return o}function v(h,l){for(;h.length<l;)h+=" ";return h}}),define(Se[171],De([1,0,165,169,170]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5d=e.$3d=e.$Zd=e.$Ud=e.$Td=void 0,e.$Qd=N,e.$Rd=$,e.$Sd=A,e.$Vd=y,e.$Wd=h,e.$Xd=l,e.$Yd=o,e.$1d=i,e.$2d=u,e.$4d=t;let R;function N(r){R=r}let b;function $(r){b=r}let k;function A(r){k=r}class C{get TChange(){return null}reportChanges(){this.get()}read(a){return a?a.readObservable(this):this.get()}map(a,f){const g=f===void 0?void 0:a,w=f===void 0?a:f;return k({owner:g,debugName:()=>{const S=(0,O.$cd)(w);if(S!==void 0)return S;const E=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(w.toString());if(E)return`${this.debugName}.${E[2]}`;if(!g)return`${this.debugName} (mapped)`},debugReferenceFn:w},S=>w(this.read(S),S))}recomputeInitiallyAndOnChange(a,f){return a.add(R(this,f)),this}keepObserved(a){return a.add(b(this)),this}get a(){return this.get()}}e.$Td=C;class p extends C{constructor(){super(...arguments),this.b=new Set}addObserver(a){const f=this.b.size;this.b.add(a),f===0&&this.c()}removeObserver(a){this.b.delete(a)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Ud=p;function y(r,a){const f=new n(r,a);try{r(f)}finally{f.finish()}}let v;function h(r){if(v)r(v);else{const a=new n(r,void 0);v=a;try{r(a)}finally{a.finish(),v=void 0}}}async function l(r,a){const f=new n(r,a);try{await r(f)}finally{f.finish()}}function o(r,a,f){r?a(r):y(a,f)}class n{constructor(a,f){this._fn=a,this.b=f,this.a=[],(0,L.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,O.$cd)(this._fn)}updateObserver(a,f){this.a.push({observer:a,observable:f}),a.beginUpdate(f)}finish(){const a=this.a;for(let f=0;f<a.length;f++){const{observer:g,observable:w}=a[f];g.endUpdate(w)}this.a=null,(0,L.$Id)()?.handleEndTransaction()}}e.$Zd=n;function i(r,a){let f;return typeof r=="string"?f=new O.$ad(void 0,r,void 0):f=new O.$ad(r,void 0,void 0),new s(f,a,d.$6c)}function u(r,a){return new s(new O.$ad(r.owner,r.debugName,void 0),a,r.equalsFn??d.$6c)}class s extends p{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(a,f,g){super(),this.e=a,this.g=g,this.d=f}get(){return this.d}set(a,f,g){if(this.g(this.d,a))return;let w;f||(f=w=new n(()=>{},()=>`Setting ${this.debugName}`));try{const S=this.d;this.h(a),(0,L.$Id)()?.handleObservableChanged(this,{oldValue:S,newValue:a,change:g,didChange:!0,hadValue:!0});for(const m of this.b)f.updateObserver(m,this),m.handleChange(this,g)}finally{w&&w.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(a){this.d=a}}e.$3d=s;function t(r,a){let f;return typeof r=="string"?f=new O.$ad(void 0,r,void 0):f=new O.$ad(r,void 0,void 0),new c(f,a,d.$6c)}class c extends s{h(a){this.d!==a&&(this.d&&this.d.dispose(),this.d=a)}dispose(){this.d?.dispose()}}e.$5d=c}),function(){function he(L){const R=[];typeof L=="number"&&R.push("code/timeOrigin",L);function N($){R.push($,Date.now())}function b(){const $=[];for(let k=0;k<R.length;k+=2)$.push({name:R[k],startTime:R[k+1]});return $}return{mark:N,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?he():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const N of performance.getEntriesByType("mark"))R.push({name:N.name,startTime:Math.round(L+N.startTime)});return R}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return he(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),he()}function d(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=d(O))}(),define(Se[172],De([1,0,39]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oP=void 0;const O=Symbol("unset");class L{constructor(){this.a=new N,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||d.Iterable.empty()}insert($,k,A){this.d($,C=>C._value=k,A)}mutate($,k){this.d($,A=>A._value=k(A._value===O?void 0:A._value))}delete($){const k=this.c($);if(!k)return;let A=k.length-1;const C=k[A].node._value;if(C!==O){for(this.b--,k[A].node._value=O;A>0;A--){const{node:p,part:y}=k[A];if(p.children?.size||p._value!==O)break;k[A-1].node.children.delete(y)}return C}}*deleteRecursive($){const k=this.c($);if(!k)return;const A=k[k.length-1].node;for(let C=k.length-1;C>0;C--){const p=k[C-1];if(p.node.children.delete(k[C].part),p.node.children.size>0||p.node._value!==O)break}for(const C of R(A))C._value!==O&&(this.b--,yield C._value)}find($){let k=this.a;for(const A of $){const C=k.children?.get(A);if(!C)return;k=C}return k._value===O?void 0:k._value}hasKeyOrParent($){let k=this.a;for(const A of $){const C=k.children?.get(A);if(!C)return!1;if(C._value!==O)return!0;k=C}return!1}hasKeyOrChildren($){let k=this.a;for(const A of $){const C=k.children?.get(A);if(!C)return!1;k=C}return!0}hasKey($){let k=this.a;for(const A of $){const C=k.children?.get(A);if(!C)return!1;k=C}return k._value!==O}c($){const k=[{part:"",node:this.a}];let A=0;for(const C of $){const p=k[A].node.children?.get(C);if(!p)return;k.push({part:C,node:p}),A++}return k}d($,k,A){let C=this.a;for(const v of $){if(C.children)if(C.children.has(v))C=C.children.get(v);else{const h=new N;C.children.set(v,h),C=h}else{const h=new N;C.children=new Map([[v,h]]),C=h}A?.(C)}const p=C._value===O?0:1;k(C);const y=C._value===O?0:1;this.b+=y-p}*values(){for(const{_value:$}of R(this.a))$!==O&&(yield $)}}e.$oP=L;function*R(b){const $=[b];for(;$.length>0;){const k=$.pop();if(yield k,k.children)for(const A of k.children.values())$.push(A)}}class N{constructor(){this._value=O}get value(){return this._value===O?void 0:this._value}set value($){this._value=$===void 0?O:$}}}),function(he,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var d=e();for(var O in d)(typeof exports=="object"?exports:he)[O]=d[O]}}(typeof self<"u"?self:this,function(){return function(he){var e={};function d(O){if(e[O])return e[O].exports;var L=e[O]={i:O,l:!1,exports:{}};return he[O].call(L.exports,L,L.exports,d),L.l=!0,L.exports}return d.m=he,d.c=e,d.d=function(O,L,R){d.o(O,L)||Object.defineProperty(O,L,{enumerable:!0,get:R})},d.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},d.t=function(O,L){if(1&L&&(O=d(O)),8&L||4&L&&typeof O=="object"&&O&&O.__esModule)return O;var R=Object.create(null);if(d.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:O}),2&L&&typeof O!="string")for(var N in O)d.d(R,N,function(b){return O[b]}.bind(null,N));return R},d.n=function(O){var L=O&&O.__esModule?function(){return O.default}:function(){return O};return d.d(L,"a",L),L},d.o=function(O,L){return Object.prototype.hasOwnProperty.call(O,L)},d.p="",d(d.s=0)}([function(he,e,d){(function(O){var L;e=he.exports=Ce,L=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],$=e.src=[],k=0,A=k++;$[A]="0|[1-9]\\d*";var C=k++;$[C]="[0-9]+";var p=k++;$[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=k++;$[y]="("+$[A]+")\\.("+$[A]+")\\.("+$[A]+")";var v=k++;$[v]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var h=k++;$[h]="(?:"+$[A]+"|"+$[p]+")";var l=k++;$[l]="(?:"+$[C]+"|"+$[p]+")";var o=k++;$[o]="(?:-("+$[h]+"(?:\\."+$[h]+")*))";var n=k++;$[n]="(?:-?("+$[l]+"(?:\\."+$[l]+")*))";var i=k++;$[i]="[0-9A-Za-z-]+";var u=k++;$[u]="(?:\\+("+$[i]+"(?:\\."+$[i]+")*))";var s=k++,t="v?"+$[y]+$[o]+"?"+$[u]+"?";$[s]="^"+t+"$";var c="[v=\\s]*"+$[v]+$[n]+"?"+$[u]+"?",r=k++;$[r]="^"+c+"$";var a=k++;$[a]="((?:<|>)?=?)";var f=k++;$[f]=$[C]+"|x|X|\\*";var g=k++;$[g]=$[A]+"|x|X|\\*";var w=k++;$[w]="[v=\\s]*("+$[g]+")(?:\\.("+$[g]+")(?:\\.("+$[g]+")(?:"+$[o]+")?"+$[u]+"?)?)?";var S=k++;$[S]="[v=\\s]*("+$[f]+")(?:\\.("+$[f]+")(?:\\.("+$[f]+")(?:"+$[n]+")?"+$[u]+"?)?)?";var m=k++;$[m]="^"+$[a]+"\\s*"+$[w]+"$";var E=k++;$[E]="^"+$[a]+"\\s*"+$[S]+"$";var D=k++;$[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=k++;$[P]="(?:~>?)";var I=k++;$[I]="(\\s*)"+$[P]+"\\s+",b[I]=new RegExp($[I],"g");var F=k++;$[F]="^"+$[P]+$[w]+"$";var T=k++;$[T]="^"+$[P]+$[S]+"$";var z=k++;$[z]="(?:\\^)";var M=k++;$[M]="(\\s*)"+$[z]+"\\s+",b[M]=new RegExp($[M],"g");var j=k++;$[j]="^"+$[z]+$[w]+"$";var U=k++;$[U]="^"+$[z]+$[S]+"$";var Z=k++;$[Z]="^"+$[a]+"\\s*("+c+")$|^$";var ie=k++;$[ie]="^"+$[a]+"\\s*("+t+")$|^$";var q=k++;$[q]="(\\s*)"+$[a]+"\\s*("+c+"|"+$[w]+")",b[q]=new RegExp($[q],"g");var G=k++;$[G]="^\\s*("+$[w]+")\\s+-\\s+("+$[w]+")\\s*$";var x=k++;$[x]="^\\s*("+$[S]+")\\s+-\\s+("+$[S]+")\\s*$";var ne=k++;$[ne]="(<|>)?=?\\s*\\*";for(var be=0;be<35;be++)L(be,$[be]),b[be]||(b[be]=new RegExp($[be]));function ae(W,J){if(W instanceof Ce)return W;if(typeof W!="string"||W.length>R||!(J?b[r]:b[s]).test(W))return null;try{return new Ce(W,J)}catch{return null}}function Ce(W,J){if(W instanceof Ce){if(W.loose===J)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Ce))return new Ce(W,J);L("SemVer",W,J),this.loose=J;var X=W.trim().match(J?b[r]:b[s]);if(!X)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var we=+de;if(we>=0&&we<N)return we}return de}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}e.parse=ae,e.valid=function(W,J){var X=ae(W,J);return X?X.version:null},e.clean=function(W,J){var X=ae(W.trim().replace(/^[=v]+/,""),J);return X?X.version:null},e.SemVer=Ce,Ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ce.prototype.toString=function(){return this.version},Ce.prototype.compare=function(W){return L("SemVer.compare",this.version,this.loose,W),W instanceof Ce||(W=new Ce(W,this.loose)),this.compareMain(W)||this.comparePre(W)},Ce.prototype.compareMain=function(W){return W instanceof Ce||(W=new Ce(W,this.loose)),B(this.major,W.major)||B(this.minor,W.minor)||B(this.patch,W.patch)},Ce.prototype.comparePre=function(W){if(W instanceof Ce||(W=new Ce(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var J=0;do{var X=this.prerelease[J],de=W.prerelease[J];if(L("prerelease compare",J,X,de),X===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(X===void 0)return-1;if(X!==de)return B(X,de)}while(++J)},Ce.prototype.inc=function(W,J){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},e.inc=function(W,J,X,de){typeof X=="string"&&(de=X,X=void 0);try{return new Ce(W,X).inc(J,de).version}catch{return null}},e.diff=function(W,J){if(ce(W,J))return null;var X=ae(W),de=ae(J);if(X.prerelease.length||de.prerelease.length){for(var we in X)if((we==="major"||we==="minor"||we==="patch")&&X[we]!==de[we])return"pre"+we;return"prerelease"}for(var we in X)if((we==="major"||we==="minor"||we==="patch")&&X[we]!==de[we])return we},e.compareIdentifiers=B;var ee=/^[0-9]+$/;function B(W,J){var X=ee.test(W),de=ee.test(J);return X&&de&&(W=+W,J=+J),X&&!de?-1:de&&!X?1:W<J?-1:W>J?1:0}function _(W,J,X){return new Ce(W,X).compare(new Ce(J,X))}function pe(W,J,X){return _(W,J,X)>0}function ue(W,J,X){return _(W,J,X)<0}function ce(W,J,X){return _(W,J,X)===0}function oe(W,J,X){return _(W,J,X)!==0}function le(W,J,X){return _(W,J,X)>=0}function K(W,J,X){return _(W,J,X)<=0}function se(W,J,X,de){var we;switch(J){case"===":typeof W=="object"&&(W=W.version),typeof X=="object"&&(X=X.version),we=W===X;break;case"!==":typeof W=="object"&&(W=W.version),typeof X=="object"&&(X=X.version),we=W!==X;break;case"":case"=":case"==":we=ce(W,X,de);break;case"!=":we=oe(W,X,de);break;case">":we=pe(W,X,de);break;case">=":we=le(W,X,de);break;case"<":we=ue(W,X,de);break;case"<=":we=K(W,X,de);break;default:throw new TypeError("Invalid operator: "+J)}return we}function $e(W,J){if(W instanceof $e){if(W.loose===J)return W;W=W.value}if(!(this instanceof $e))return new $e(W,J);L("comparator",W,J),this.loose=J,this.parse(W),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(W,J){return B(J,W)},e.major=function(W,J){return new Ce(W,J).major},e.minor=function(W,J){return new Ce(W,J).minor},e.patch=function(W,J){return new Ce(W,J).patch},e.compare=_,e.compareLoose=function(W,J){return _(W,J,!0)},e.rcompare=function(W,J,X){return _(J,W,X)},e.sort=function(W,J){return W.sort(function(X,de){return e.compare(X,de,J)})},e.rsort=function(W,J){return W.sort(function(X,de){return e.rcompare(X,de,J)})},e.gt=pe,e.lt=ue,e.eq=ce,e.neq=oe,e.gte=le,e.lte=K,e.cmp=se,e.Comparator=$e;var ve={};function Re(W,J){if(W instanceof Re)return W.loose===J?W:new Re(W.raw,J);if(W instanceof $e)return new Re(W.value,J);if(!(this instanceof Re))return new Re(W,J);if(this.loose=J,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function ge(W){return!W||W.toLowerCase()==="x"||W==="*"}function Ie(W,J,X,de,we,je,Ve,Je,tt,_e,nt,it,rt){return((J=ge(X)?"":ge(de)?">="+X+".0.0":ge(we)?">="+X+"."+de+".0":">="+J)+" "+(Je=ge(tt)?"":ge(_e)?"<"+(+tt+1)+".0.0":ge(nt)?"<"+tt+"."+(+_e+1)+".0":it?"<="+tt+"."+_e+"."+nt+"-"+it:"<="+Je)).trim()}function Ae(W,J){for(var X=0;X<W.length;X++)if(!W[X].test(J))return!1;if(J.prerelease.length){for(X=0;X<W.length;X++)if(L(W[X].semver),W[X].semver!==ve&&W[X].semver.prerelease.length>0){var de=W[X].semver;if(de.major===J.major&&de.minor===J.minor&&de.patch===J.patch)return!0}return!1}return!0}function ze(W,J,X){try{J=new Re(J,X)}catch{return!1}return J.test(W)}function V(W,J,X,de){var we,je,Ve,Je,tt;switch(W=new Ce(W,de),J=new Re(J,de),X){case">":we=pe,je=K,Ve=ue,Je=">",tt=">=";break;case"<":we=ue,je=le,Ve=pe,Je="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(W,J,de))return!1;for(var _e=0;_e<J.set.length;++_e){var nt=J.set[_e],it=null,rt=null;if(nt.forEach(function(at){at.semver===ve&&(at=new $e(">=0.0.0")),it=it||at,rt=rt||at,we(at.semver,it.semver,de)?it=at:Ve(at.semver,rt.semver,de)&&(rt=at)}),it.operator===Je||it.operator===tt||(!rt.operator||rt.operator===Je)&&je(W,rt.semver)||rt.operator===tt&&Ve(W,rt.semver))return!1}return!0}$e.prototype.parse=function(W){var J=this.loose?b[Z]:b[ie],X=W.match(J);if(!X)throw new TypeError("Invalid comparator: "+W);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new Ce(X[2],this.loose):this.semver=ve},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(W){return L("Comparator.test",W,this.loose),this.semver===ve||(typeof W=="string"&&(W=new Ce(W,this.loose)),se(W,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(W,J){if(!(W instanceof $e))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new Re(W.value,J),ze(this.value,X,J);if(W.operator==="")return X=new Re(this.value,J),ze(W.semver,X,J);var de=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),je=this.semver.version===W.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Je=se(this.semver,"<",W.semver,J)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),tt=se(this.semver,">",W.semver,J)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return de||we||je&&Ve||Je||tt},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(W){var J=this.loose;W=W.trim(),L("range",W,J);var X=J?b[x]:b[G];W=W.replace(X,Ie),L("hyphen replace",W),W=W.replace(b[q],"$1$2$3"),L("comparator trim",W,b[q]),W=(W=(W=W.replace(b[I],"$1~")).replace(b[M],"$1^")).split(/\s+/).join(" ");var de=J?b[Z]:b[ie],we=W.split(" ").map(function(je){return function(Ve,Je){return L("comp",Ve),Ve=function(tt,_e){return tt.trim().split(/\s+/).map(function(nt){return function(it,rt){L("caret",it,rt);var at=rt?b[U]:b[j];return it.replace(at,function(Ne,ye,qe,te,re){var Pe;return L("caret",it,Ne,ye,qe,te,re),ge(ye)?Pe="":ge(qe)?Pe=">="+ye+".0.0 <"+(+ye+1)+".0.0":ge(te)?Pe=ye==="0"?">="+ye+"."+qe+".0 <"+ye+"."+(+qe+1)+".0":">="+ye+"."+qe+".0 <"+(+ye+1)+".0.0":re?(L("replaceCaret pr",re),re.charAt(0)!=="-"&&(re="-"+re),Pe=ye==="0"?qe==="0"?">="+ye+"."+qe+"."+te+re+" <"+ye+"."+qe+"."+(+te+1):">="+ye+"."+qe+"."+te+re+" <"+ye+"."+(+qe+1)+".0":">="+ye+"."+qe+"."+te+re+" <"+(+ye+1)+".0.0"):(L("no pr"),Pe=ye==="0"?qe==="0"?">="+ye+"."+qe+"."+te+" <"+ye+"."+qe+"."+(+te+1):">="+ye+"."+qe+"."+te+" <"+ye+"."+(+qe+1)+".0":">="+ye+"."+qe+"."+te+" <"+(+ye+1)+".0.0"),L("caret return",Pe),Pe})}(nt,_e)}).join(" ")}(Ve,Je),L("caret",Ve),Ve=function(tt,_e){return tt.trim().split(/\s+/).map(function(nt){return function(it,rt){var at=rt?b[T]:b[F];return it.replace(at,function(Ne,ye,qe,te,re){var Pe;return L("tilde",it,Ne,ye,qe,te,re),ge(ye)?Pe="":ge(qe)?Pe=">="+ye+".0.0 <"+(+ye+1)+".0.0":ge(te)?Pe=">="+ye+"."+qe+".0 <"+ye+"."+(+qe+1)+".0":re?(L("replaceTilde pr",re),re.charAt(0)!=="-"&&(re="-"+re),Pe=">="+ye+"."+qe+"."+te+re+" <"+ye+"."+(+qe+1)+".0"):Pe=">="+ye+"."+qe+"."+te+" <"+ye+"."+(+qe+1)+".0",L("tilde return",Pe),Pe})}(nt,_e)}).join(" ")}(Ve,Je),L("tildes",Ve),Ve=function(tt,_e){return L("replaceXRanges",tt,_e),tt.split(/\s+/).map(function(nt){return function(it,rt){it=it.trim();var at=rt?b[E]:b[m];return it.replace(at,function(Ne,ye,qe,te,re,Pe){L("xRange",it,Ne,ye,qe,te,re,Pe);var He=ge(qe),Le=He||ge(te),st=Le||ge(re);return ye==="="&&st&&(ye=""),He?Ne=ye===">"||ye==="<"?"<0.0.0":"*":ye&&st?(Le&&(te=0),st&&(re=0),ye===">"?(ye=">=",Le?(qe=+qe+1,te=0,re=0):st&&(te=+te+1,re=0)):ye==="<="&&(ye="<",Le?qe=+qe+1:te=+te+1),Ne=ye+qe+"."+te+"."+re):Le?Ne=">="+qe+".0.0 <"+(+qe+1)+".0.0":st&&(Ne=">="+qe+"."+te+".0 <"+qe+"."+(+te+1)+".0"),L("xRange return",Ne),Ne})}(nt,_e)}).join(" ")}(Ve,Je),L("xrange",Ve),Ve=function(tt,_e){return L("replaceStars",tt,_e),tt.trim().replace(b[ne],"")}(Ve,Je),L("stars",Ve),Ve}(je,J)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(je){return!!je.match(de)})),we=we.map(function(je){return new $e(je,J)})},Re.prototype.intersects=function(W,J){if(!(W instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(de){return W.set.some(function(we){return we.every(function(je){return de.intersects(je,J)})})})})},e.toComparators=function(W,J){return new Re(W,J).set.map(function(X){return X.map(function(de){return de.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new Ce(W,this.loose));for(var J=0;J<this.set.length;J++)if(Ae(this.set[J],W))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(W,J,X){var de=null,we=null;try{var je=new Re(J,X)}catch{return null}return W.forEach(function(Ve){je.test(Ve)&&(de&&we.compare(Ve)!==-1||(we=new Ce(de=Ve,X)))}),de},e.minSatisfying=function(W,J,X){var de=null,we=null;try{var je=new Re(J,X)}catch{return null}return W.forEach(function(Ve){je.test(Ve)&&(de&&we.compare(Ve)!==1||(we=new Ce(de=Ve,X)))}),de},e.validRange=function(W,J){try{return new Re(W,J).range||"*"}catch{return null}},e.ltr=function(W,J,X){return V(W,J,"<",X)},e.gtr=function(W,J,X){return V(W,J,">",X)},e.outside=V,e.prerelease=function(W,J){var X=ae(W,J);return X&&X.prerelease.length?X.prerelease:null},e.intersects=function(W,J,X){return W=new Re(W,X),J=new Re(J,X),W.intersects(J)},e.coerce=function(W){if(W instanceof Ce)return W;if(typeof W!="string")return null;var J=W.match(b[D]);return J==null?null:ae((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,d(1))},function(he,e){var d,O,L=he.exports={};function R(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function b(l){if(d===setTimeout)return setTimeout(l,0);if((d===R||!d)&&setTimeout)return d=setTimeout,setTimeout(l,0);try{return d(l,0)}catch{try{return d.call(null,l,0)}catch{return d.call(this,l,0)}}}(function(){try{d=typeof setTimeout=="function"?setTimeout:R}catch{d=R}try{O=typeof clearTimeout=="function"?clearTimeout:N}catch{O=N}})();var $,k=[],A=!1,C=-1;function p(){A&&$&&(A=!1,$.length?k=$.concat(k):C=-1,k.length&&y())}function y(){if(!A){var l=b(p);A=!0;for(var o=k.length;o;){for($=k,k=[];++C<o;)$&&$[C].run();C=-1,o=k.length}$=null,A=!1,function(n){if(O===clearTimeout)return clearTimeout(n);if((O===N||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(n);try{O(n)}catch{try{return O.call(null,n)}catch{return O.call(this,n)}}}(l)}}function v(l,o){this.fun=l,this.array=o}function h(){}L.nextTick=function(l){var o=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)o[n-1]=arguments[n];k.push(new v(l,o)),k.length!==1||A||b(y)},v.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=h,L.addListener=h,L.once=h,L.off=h,L.removeListener=h,L.removeAllListeners=h,L.emit=h,L.prependListener=h,L.prependOnceListener=h,L.listeners=function(l){return[]},L.binding=function(l){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(l){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(Se[40],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=void 0;const d=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(R){return new O(R)}constructor(R){this.c=d&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$_d=O}),define(Se[4],De([1,0,13,75,3,76,40]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$be=e.Event=void 0,e.$ce=y;const b=!1,$=!1,k=!1;var A;(function(I){I.None=()=>L.$Uc.None;function F(Re){if(k){const{onDidAddListener:ge}=Re,Ie=h.create();let Ae=0;Re.onDidAddListener=()=>{++Ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ie.print()),ge?.()}}}function T(Re,ge){return ne(Re,()=>{},0,void 0,!0,void 0,ge)}I.defer=T;function z(Re){return(ge,Ie=null,Ae)=>{let ze=!1,V;return V=Re(W=>{if(!ze)return V?V.dispose():ze=!0,ge.call(Ie,W)},null,Ae),ze&&V.dispose(),V}}I.once=z;function M(Re,ge,Ie){return G((Ae,ze=null,V)=>Re(W=>Ae.call(ze,ge(W)),null,V),Ie)}I.map=M;function j(Re,ge,Ie){return G((Ae,ze=null,V)=>Re(W=>{ge(W),Ae.call(ze,W)},null,V),Ie)}I.forEach=j;function U(Re,ge,Ie){return G((Ae,ze=null,V)=>Re(W=>ge(W)&&Ae.call(ze,W),null,V),Ie)}I.filter=U;function Z(Re){return Re}I.signal=Z;function ie(...Re){return(ge,Ie=null,Ae)=>{const ze=(0,L.$Rc)(...Re.map(V=>V(W=>ge.call(Ie,W))));return x(ze,Ae)}}I.any=ie;function q(Re,ge,Ie,Ae){let ze=Ie;return M(Re,V=>(ze=ge(ze,V),ze),Ae)}I.reduce=q;function G(Re,ge){let Ie;const Ae={onWillAddFirstListener(){Ie=Re(ze.fire,ze)},onDidRemoveLastListener(){Ie?.dispose()}};ge||F(Ae);const ze=new s(Ae);return ge?.add(ze),ze.event}function x(Re,ge){return ge instanceof Array?ge.push(Re):ge&&ge.add(Re),Re}function ne(Re,ge,Ie=100,Ae=!1,ze=!1,V,W){let J,X,de,we=0,je;const Ve={leakWarningThreshold:V,onWillAddFirstListener(){J=Re(tt=>{we++,X=ge(X,tt),Ae&&!de&&(Je.fire(X),X=void 0),je=()=>{const _e=X;X=void 0,de=void 0,(!Ae||we>1)&&Je.fire(_e),we=0},typeof Ie=="number"?(clearTimeout(de),de=setTimeout(je,Ie)):de===void 0&&(de=0,queueMicrotask(je))})},onWillRemoveListener(){ze&&we>0&&je?.()},onDidRemoveLastListener(){je=void 0,J.dispose()}};W||F(Ve);const Je=new s(Ve);return W?.add(Je),Je.event}I.debounce=ne;function be(Re,ge=0,Ie){return I.debounce(Re,(Ae,ze)=>Ae?(Ae.push(ze),Ae):[ze],ge,void 0,!0,void 0,Ie)}I.accumulate=be;function ae(Re,ge=(Ae,ze)=>Ae===ze,Ie){let Ae=!0,ze;return U(Re,V=>{const W=Ae||!ge(V,ze);return Ae=!1,ze=V,W},Ie)}I.latch=ae;function Ce(Re,ge,Ie){return[I.filter(Re,ge,Ie),I.filter(Re,Ae=>!ge(Ae),Ie)]}I.split=Ce;function ee(Re,ge=!1,Ie=[],Ae){let ze=Ie.slice(),V=Re(X=>{ze?ze.push(X):J.fire(X)});Ae&&Ae.add(V);const W=()=>{ze?.forEach(X=>J.fire(X)),ze=null},J=new s({onWillAddFirstListener(){V||(V=Re(X=>J.fire(X)),Ae&&Ae.add(V))},onDidAddFirstListener(){ze&&(ge?setTimeout(W):W())},onDidRemoveLastListener(){V&&V.dispose(),V=null}});return Ae&&Ae.add(J),J.event}I.buffer=ee;function B(Re,ge){return(Ae,ze,V)=>{const W=ge(new pe);return Re(function(J){const X=W.evaluate(J);X!==_&&Ae.call(ze,X)},void 0,V)}}I.chain=B;const _=Symbol("HaltChainable");class pe{constructor(){this.f=[]}map(ge){return this.f.push(ge),this}forEach(ge){return this.f.push(Ie=>(ge(Ie),Ie)),this}filter(ge){return this.f.push(Ie=>ge(Ie)?Ie:_),this}reduce(ge,Ie){let Ae=Ie;return this.f.push(ze=>(Ae=ge(Ae,ze),Ae)),this}latch(ge=(Ie,Ae)=>Ie===Ae){let Ie=!0,Ae;return this.f.push(ze=>{const V=Ie||!ge(ze,Ae);return Ie=!1,Ae=ze,V?ze:_}),this}evaluate(ge){for(const Ie of this.f)if(ge=Ie(ge),ge===_)break;return ge}}function ue(Re,ge,Ie=Ae=>Ae){const Ae=(...J)=>W.fire(Ie(...J)),ze=()=>Re.on(ge,Ae),V=()=>Re.removeListener(ge,Ae),W=new s({onWillAddFirstListener:ze,onDidRemoveLastListener:V});return W.event}I.fromNodeEventEmitter=ue;function ce(Re,ge,Ie=Ae=>Ae){const Ae=(...J)=>W.fire(Ie(...J)),ze=()=>Re.addEventListener(ge,Ae),V=()=>Re.removeEventListener(ge,Ae),W=new s({onWillAddFirstListener:ze,onDidRemoveLastListener:V});return W.event}I.fromDOMEventEmitter=ce;function oe(Re){return new Promise(ge=>z(Re)(ge))}I.toPromise=oe;function le(Re){const ge=new s;return Re.then(Ie=>{ge.fire(Ie)},()=>{ge.fire(void 0)}).finally(()=>{ge.dispose()}),ge.event}I.fromPromise=le;function K(Re,ge,Ie){return ge(Ie),Re(Ae=>ge(Ae))}I.runAndSubscribe=K;class se{constructor(ge,Ie){this._observable=ge,this.f=0,this.g=!1;const Ae={onWillAddFirstListener:()=>{ge.addObserver(this)},onDidRemoveLastListener:()=>{ge.removeObserver(this)}};Ie||F(Ae),this.emitter=new s(Ae),Ie&&Ie.add(this.emitter)}beginUpdate(ge){this.f++}handlePossibleChange(ge){}handleChange(ge,Ie){this.g=!0}endUpdate(ge){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function $e(Re,ge){return new se(Re,ge).emitter.event}I.fromObservable=$e;function ve(Re){return(ge,Ie,Ae)=>{let ze=0,V=!1;const W={beginUpdate(){ze++},endUpdate(){ze--,ze===0&&(Re.reportChanges(),V&&(V=!1,ge.call(Ie)))},handlePossibleChange(){},handleChange(){V=!0}};Re.addObserver(W),Re.reportChanges();const J={dispose(){Re.removeObserver(W)}};return Ae instanceof L.$Tc?Ae.add(J):Array.isArray(Ae)&&Ae.push(J),J}}I.fromObservableLight=ve})(A||(e.Event=A={}));class C{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${C.f++}`,C.all.add(this)}start(F){this.g=new N.$_d,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$be=C;let p=-1;function y(I){const F=p;return p=I,{dispose(){p=F}}}class v{constructor(F,T=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=T,this.g=0}dispose(){this.f?.clear()}check(F,T){const z=this.threshold;if(z<=0||T<z)return;this.f||(this.f=new Map);const M=this.f.get(F.value)||0;if(this.f.set(F.value,M+1),this.g-=1,this.g<=0){this.g=z*.5;let j,U=0;for(const[Z,ie]of this.f)(!j||U<ie)&&(j=Z,U=ie);console.warn(`[${this.name}] potential listener LEAK detected, having ${T} listeners already. MOST frequent listener (${U}):`),console.warn(j)}return()=>{const j=this.f.get(F.value)||0;this.f.set(F.value,j-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let l=0;class o{constructor(F){this.value=F,this.id=l++}}const n=2,i=(I,F)=>{if(I instanceof o)F(I);else for(let T=0;T<I.length;T++){const z=I[T];z&&F(z)}},u=b?new FinalizationRegistry(I=>{typeof I=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(I))}):void 0;class s{constructor(F){this.w=0,this.f=F,this.g=p>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??p):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if($){const F=this.t;queueMicrotask(()=>{i(F,T=>T.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,T,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Uc.None;if(this.m)return L.$Uc.None;T&&(F=F.bind(T));const M=new o(F);let j,U;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(M.stack=h.create(),j=this.g.check(M.stack,this.w+1)),$&&(M.stack=U??h.create()),this.t?this.t instanceof o?(this.u??=new c,this.t=[this.t,M]):this.t.push(M):(this.f?.onWillAddFirstListener?.(this),this.t=M,this.f?.onDidAddFirstListener?.(this)),this.w++;const Z=(0,L.$Sc)(()=>{u?.unregister(Z),j?.(),this.x(M)});if(z instanceof L.$Tc?z.add(Z):Array.isArray(z)&&z.push(Z),u){const ie=new Error().stack.split(`
`).slice(2).join(`
`).trim();u.register(Z,ie,Z)}return Z},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const T=this.t,z=T.indexOf(F);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,T[z]=void 0;const M=this.u.current===this;if(this.w*n<=T.length){let j=0;for(let U=0;U<T.length;U++)T[U]?T[j++]=T[U]:M&&(this.u.end--,j<this.u.i&&this.u.i--);T.length=j}}y(F,T){if(!F)return;const z=this.f?.onListenerError||d.$1;if(!z){F.value(T);return}try{F.value(T)}catch(M){z(M)}}z(F){const T=F.current.t;for(;F.i<F.end;)this.y(T[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof o)this.y(this.t,F);else{const T=this.u;T.enqueue(this,F,this.t.length),this.z(T)}this.j?.stop()}hasListeners(){return this.w>0}}e.$de=s;const t=()=>new c;e.$ee=t;class c{constructor(){this.i=-1,this.end=0}enqueue(F,T,z){this.i=0,this.end=z,this.current=F,this.value=T}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends s{async fireAsync(F,T,z){if(this.t)for(this.h||(this.h=new R.$5c),i(this.t,M=>this.h.push([M.value,F]));this.h.size>0&&!T.isCancellationRequested;){const[M,j]=this.h.shift(),U=[],Z={...j,token:T,waitUntil:ie=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");z&&(ie=z(ie,M)),U.push(ie)}};try{M(Z)}catch(ie){(0,d.$1)(ie);continue}Object.freeze(U),await Promise.allSettled(U).then(ie=>{for(const q of ie)q.status==="rejected"&&(0,d.$1)(q.reason)})}}}e.$fe=r;class a extends s{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new R.$5c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$ge=a;class f extends a{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$he=f;class g extends s{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(T=>super.fire(T)),this.h=[]}))}}e.$ie=g;class w{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const T={event:F,listener:null};this.h.push(T),this.g&&this.m(T);const z=()=>{this.g&&this.o(T);const M=this.h.indexOf(T);this.h.splice(M,1)};return(0,L.$Sc)((0,O.$db)(z))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(T=>this.f.fire(T))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$je=w;class S{constructor(F,T,z,M){this.f=new L.$Tc;const j=this.f.add(new w),U=this.f.add(new L.$4c);function Z(ie){U.set(ie,j.add(M(ie)))}for(const ie of F)Z(ie);this.f.add(T(ie=>{Z(ie)})),this.f.add(z(ie=>{U.deleteAndDispose(ie)})),this.event=j.event}dispose(){this.f.dispose()}}e.$ke=S;class m{constructor(){this.f=[]}wrapEvent(F,T,z){return(M,j,U)=>F(Z=>{const ie=this.f[this.f.length-1];if(!T){ie?ie.buffers.push(()=>M.call(j,Z)):M.call(j,Z);return}const q=ie;if(!q){M.call(j,T(z,Z));return}q.items??=[],q.items.push(Z),q.buffers.length===0&&ie.buffers.push(()=>{q.reducedResult??=z?q.items.reduce(T,z):q.items.reduce(T),M.call(j,q.reducedResult)})},void 0,U)}bufferEvents(F){const T={buffers:new Array};this.f.push(T);const z=F();return this.f.pop(),T.buffers.forEach(M=>M()),z}}e.$le=m;class E{constructor(){this.f=!1,this.g=A.None,this.h=L.$Uc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$me=E;class D{static const(F){return new P(F)}constructor(F){this.g=F,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$ne=D;class P{constructor(F){this.value=F,this.onDidChange=A.None}}}),define(Se[22],De([1,0,4]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=e.CancellationToken=void 0,e.$pe=b;const O=Object.freeze(function($,k){const A=setTimeout($.bind(k),0);return{dispose(){clearTimeout(A)}}});var L;(function($){function k(A){return A===$.None||A===$.Cancelled||A instanceof R?!0:!A||typeof A!="object"?!1:typeof A.isCancellationRequested=="boolean"&&typeof A.onCancellationRequested=="function"}$.isCancellationToken=k,$.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:d.Event.None}),$.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(L||(e.CancellationToken=L={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new d.$de),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=L.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=L.None}}e.$oe=N;function b($){const k=new N;return $.add({dispose(){k.cancel()}}),k.token}}),define(Se[173],De([1,0,22]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4e=e.$3e=e.$1e=void 0,e.$2e=L;class O{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new d.$oe,k=this.b($.token);return this.a={promise:k,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$1e=O;function L(b){return b}class R{constructor($,k){this.a=void 0,this.b=void 0,typeof $=="function"?(this.c=$,this.d=L):(this.c=k,this.d=$.getCacheKey)}get($){const k=this.d($);return this.b!==k&&(this.b=k,this.a=this.c($)),this.a}}e.$3e=R;class N{get cachedValues(){return this.a}constructor($,k){this.a=new Map,this.b=new Map,typeof $=="function"?(this.c=$,this.d=L):(this.c=k,this.d=$.getCacheKey)}get($){const k=this.d($);if(this.b.has(k))return this.b.get(k);const A=this.c($);return this.a.set($,A),this.b.set(k,A),A}}e.$4e=N}),define(Se[98],De([1,0,13,3]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=L,e.$re=R,e.$se=N,e.$te=b,e.$ue=k,e.$ve=A,e.$we=C,e.$xe=p,e.$ye=y,e.$ze=v,e.$Ae=h,e.$Be=l,e.$Ce=o,e.$De=n,e.$Ee=i;function L(u){const s=u;return s?typeof s.read=="function":!1}function R(u){const s=u;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}function N(u){const s=u;return s?R(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function b(u,s){return new $(u,s)}class ${constructor(s,t){this.e=s,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(t=>t(s))}h(s){this.c.error.length===0?(0,d.$1)(s):this.c.error.slice(0).forEach(t=>t(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,t){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(s,t){if(this.a.destroyed)return;let c;switch(s){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const r=c.indexOf(t);r>=0&&c.splice(r,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(u,s){const t=[];let c;for(;(c=u.read())!==null;)t.push(c);return s(t)}function A(u,s,t){const c=[];let r;for(;(r=u.read())!==null&&c.length<t;)c.push(r);return r===null&&c.length>0?s(c):{read:()=>{if(c.length>0)return c.shift();if(typeof r<"u"){const a=r;return r=void 0,a}return u.read()}}}function C(u,s){return new Promise((t,c)=>{const r=[];p(u,{onData:a=>{s&&r.push(a)},onError:a=>{s?c(a):t(void 0)},onEnd:()=>{t(s?s(r):void 0)}})})}function p(u,s,t){u.on("error",c=>{t?.isCancellationRequested||s.onError(c)}),u.on("end",()=>{t?.isCancellationRequested||s.onEnd()}),u.on("data",c=>{t?.isCancellationRequested||s.onData(c)})}function y(u,s){return new Promise((t,c)=>{const r=new O.$Tc,a=[],f=S=>{if(a.push(S),a.length>s)return r.dispose(),u.pause(),t({stream:u,buffer:a,ended:!1})},g=S=>(r.dispose(),c(S)),w=()=>(r.dispose(),t({stream:u,buffer:a,ended:!0}));r.add((0,O.$Sc)(()=>u.removeListener("error",g))),u.on("error",g),r.add((0,O.$Sc)(()=>u.removeListener("end",w))),u.on("end",w),r.add((0,O.$Sc)(()=>u.removeListener("data",f))),u.on("data",f)})}function v(u,s){const t=b(s);return t.end(u),t}function h(){const u=b(()=>{throw new Error("not supported")});return u.end(),u}function l(u){let s=!1;return{read:()=>s?null:(s=!0,u)}}function o(u,s,t){const c=b(t);return p(u,{onData:r=>c.write(s.data(r)),onError:r=>c.error(s.error?s.error(r):r),onEnd:()=>c.end()}),c}function n(u,s,t){let c=!1;return{read:()=>{const r=s.read();return c?r:(c=!0,r!==null?t([u,r]):u)}}}function i(u,s,t){let c=!1;const r=b(t);return p(s,{onData:a=>c?r.write(a):(c=!0,r.write(t([u,a]))),onError:a=>r.error(a),onEnd:()=>{c||(c=!0,r.write(u)),r.end()}}),r}}),define(Se[21],De([1,0,46,98]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=void 0,e.$Ge=k,e.$He=A,e.$Ie=C,e.$Je=p,e.$Ke=y,e.$Le=v,e.$Me=h,e.$Ne=l,e.$Oe=o,e.$Pe=n,e.$Qe=i,e.$Re=u,e.$Se=s,e.$Te=t,e.$Ue=c,e.$Ve=r,e.$We=a,e.$Xe=f,e.$Ye=g,e.$Ze=m;const L=typeof Buffer<"u",R=new d.$V(()=>new Uint8Array(256));let N,b;class ${static alloc(D){return L?new $(Buffer.allocUnsafe(D)):new $(new Uint8Array(D))}static wrap(D){return L&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new $(D)}static fromString(D,P){return!(P?.dontUseNodeBuffer||!1)&&L?new $(Buffer.from(D)):(N||(N=new TextEncoder),new $(N.encode(D)))}static fromByteArray(D){const P=$.alloc(D.length);for(let I=0,F=D.length;I<F;I++)P.buffer[I]=D[I];return P}static concat(D,P){if(typeof P>"u"){P=0;for(let T=0,z=D.length;T<z;T++)P+=D[T].byteLength}const I=$.alloc(P);let F=0;for(let T=0,z=D.length;T<z;T++){const M=D[T];I.set(M,F),F+=M.byteLength}return I}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=$.alloc(this.byteLength);return D.set(this),D}toString(){return L?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(D,P){return new $(this.buffer.subarray(D,P))}set(D,P){if(D instanceof $)this.buffer.set(D.buffer,P);else if(D instanceof Uint8Array)this.buffer.set(D,P);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),P);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return p(this.buffer,D)}writeUInt32BE(D,P){y(this.buffer,D,P)}readUInt32LE(D){return v(this.buffer,D)}writeUInt32LE(D,P){h(this.buffer,D,P)}readUInt8(D){return l(this.buffer,D)}writeUInt8(D,P){o(this.buffer,D,P)}indexOf(D,P=0){return k(this.buffer,D instanceof $?D.buffer:D,P)}}e.$Fe=$;function k(E,D,P=0){const I=D.byteLength,F=E.byteLength;if(I===0)return 0;if(I===1)return E.indexOf(D[0]);if(I>F-P)return-1;const T=R.value;T.fill(D.length);for(let U=0;U<D.length;U++)T[D[U]]=D.length-U-1;let z=P+D.length-1,M=z,j=-1;for(;z<F;)if(E[z]===D[M]){if(M===0){j=z;break}z--,M--}else z+=Math.max(D.length-M,T[E[z]]),M=D.length-1;return j}function A(E,D){return E[D+0]<<0>>>0|E[D+1]<<8>>>0}function C(E,D,P){E[P+0]=D&255,D=D>>>8,E[P+1]=D&255}function p(E,D){return E[D]*2**24+E[D+1]*2**16+E[D+2]*2**8+E[D+3]}function y(E,D,P){E[P+3]=D,D=D>>>8,E[P+2]=D,D=D>>>8,E[P+1]=D,D=D>>>8,E[P]=D}function v(E,D){return E[D+0]<<0>>>0|E[D+1]<<8>>>0|E[D+2]<<16>>>0|E[D+3]<<24>>>0}function h(E,D,P){E[P+0]=D&255,D=D>>>8,E[P+1]=D&255,D=D>>>8,E[P+2]=D&255,D=D>>>8,E[P+3]=D&255}function l(E,D){return E[D]}function o(E,D,P){E[P]=D}function n(E){return O.$ue(E,D=>$.concat(D))}function i(E){return O.$Be(E)}function u(E){return O.$we(E,D=>$.concat(D))}async function s(E){return E.ended?$.concat(E.buffer):$.concat([...E.buffer,await u(E.stream)])}function t(E){return O.$ze(E,D=>$.concat(D))}function c(E){return O.$Ce(E,{data:D=>typeof D=="string"?$.fromString(D):$.wrap(D)},D=>$.concat(D))}function r(E){return O.$te(D=>$.concat(D),E)}function a(E,D){return O.$De(E,D,P=>$.concat(P))}function f(E,D){return O.$Ee(E,D,P=>$.concat(P))}function g(E){let D=0,P=0,I=0;const F=new Uint8Array(Math.floor(E.length/4*3)),T=M=>{switch(P){case 3:F[I++]=D|M,P=0;break;case 2:F[I++]=D|M>>>2,D=M<<6,P=3;break;case 1:F[I++]=D|M>>>4,D=M<<4,P=2;break;default:D=M<<2,P=1}};for(let M=0;M<E.length;M++){const j=E.charCodeAt(M);if(j>=65&&j<=90)T(j-65);else if(j>=97&&j<=122)T(j-97+26);else if(j>=48&&j<=57)T(j-48+52);else if(j===43||j===45)T(62);else if(j===47||j===95)T(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${E[M]}`)}}const z=I;for(;P>0;)T(0);return $.wrap(F).slice(0,z)}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:E},D=!0,P=!1){const I=P?S:w;let F="";const T=E.byteLength%3;let z=0;for(;z<E.byteLength-T;z+=3){const M=E[z+0],j=E[z+1],U=E[z+2];F+=I[M>>>2],F+=I[(M<<4|j>>>4)&63],F+=I[(j<<2|U>>>6)&63],F+=I[U&63]}if(T===1){const M=E[z+0];F+=I[M>>>2],F+=I[M<<4&63],D&&(F+="==")}else if(T===2){const M=E[z+0],j=E[z+1];F+=I[M>>>2],F+=I[(M<<4|j>>>4)&63],F+=I[j<<2&63],D&&(F+="=")}return F}}),define(Se[14],De([1,0,173,46]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=e.GraphemeBreakType=e.$Vf=e.$Nf=e.$Gf=e.$Ff=void 0,e.$7e=L,e.$8e=N,e.$9e=$,e.$0e=k,e.$$e=A,e.$_e=C,e.$af=p,e.$bf=y,e.$cf=v,e.$df=h,e.$ef=l,e.$ff=o,e.$gf=n,e.$hf=i,e.$if=u,e.$jf=s,e.$kf=t,e.$lf=c,e.$mf=r,e.$nf=a,e.$of=f,e.$pf=g,e.$qf=w,e.$rf=S,e.$sf=m,e.$tf=E,e.$uf=D,e.$vf=P,e.$wf=I,e.$xf=F,e.$yf=T,e.$zf=z,e.$Af=M,e.$Bf=j,e.$Cf=U,e.$Df=Z,e.$Ef=ie,e.$Hf=ne,e.$If=be,e.$Jf=ae,e.$Kf=Ce,e.$Lf=_,e.$Mf=ue,e.$Of=ce,e.$Pf=oe,e.$Qf=le,e.$Rf=K,e.$Sf=$e,e.$Tf=ve,e.$Uf=ge,e.$Wf=Ie,e.$Xf=Ae,e.$Yf=ze,e.$Zf=V,e.$1f=W,e.$2f=J,e.$3f=X,e.$4f=de,e.$5f=tt;function L(Ne){return!Ne||typeof Ne!="string"?!0:Ne.trim().length===0}const R=/{(\d+)}/g;function N(Ne,...ye){return ye.length===0?Ne:Ne.replace(R,function(qe,te){const re=parseInt(te,10);return isNaN(re)||re<0||re>=ye.length?qe:ye[re]})}const b=/{([^}]+)}/g;function $(Ne,ye){return Object.keys(ye).length===0?Ne:Ne.replace(b,(qe,te)=>ye[te]??qe)}function k(Ne){return Ne.replace(/[<>"'&]/g,ye=>{switch(ye){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ye})}function A(Ne){return Ne.replace(/[<>&]/g,function(ye){switch(ye){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ye}})}function C(Ne){return Ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function p(Ne,ye){let qe=0,te=Ne.indexOf(ye);for(;te!==-1;)qe++,te=Ne.indexOf(ye,te+ye.length);return qe}function y(Ne,ye,qe="\u2026"){return Ne.length<=ye?Ne:`${Ne.substr(0,ye)}${qe}`}function v(Ne,ye,qe="\u2026"){if(Ne.length<=ye)return Ne;const te=Math.ceil(ye/2)-qe.length/2,re=Math.floor(ye/2)-qe.length/2;return`${Ne.substr(0,te)}${qe}${Ne.substr(Ne.length-re)}`}function h(Ne,ye=" "){const qe=l(Ne,ye);return o(qe,ye)}function l(Ne,ye){if(!Ne||!ye)return Ne;const qe=ye.length;if(qe===0||Ne.length===0)return Ne;let te=0;for(;Ne.indexOf(ye,te)===te;)te=te+qe;return Ne.substring(te)}function o(Ne,ye){if(!Ne||!ye)return Ne;const qe=ye.length,te=Ne.length;if(qe===0||te===0)return Ne;let re=te,Pe=-1;for(;Pe=Ne.lastIndexOf(ye,re-1),!(Pe===-1||Pe+qe!==re);){if(Pe===0)return"";re=Pe}return Ne.substring(0,re)}function n(Ne){return Ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Ne){return Ne.replace(/\*/g,"")}function u(Ne,ye,qe={}){if(!Ne)throw new Error("Cannot create regex from empty string");ye||(Ne=C(Ne)),qe.wholeWord&&(/\B/.test(Ne.charAt(0))||(Ne="\\b"+Ne),/\B/.test(Ne.charAt(Ne.length-1))||(Ne=Ne+"\\b"));let te="";return qe.global&&(te+="g"),qe.matchCase||(te+="i"),qe.multiline&&(te+="m"),qe.unicode&&(te+="u"),new RegExp(Ne,te)}function s(Ne){return Ne.source==="^"||Ne.source==="^$"||Ne.source==="$"||Ne.source==="^\\s*$"?!1:!!(Ne.exec("")&&Ne.lastIndex===0)}function t(Ne){return Ne.split(/\r\n|\r|\n/)}function c(Ne){const ye=[],qe=Ne.split(/(\r\n|\r|\n)/);for(let te=0;te<Math.ceil(qe.length/2);te++)ye.push(qe[2*te]+(qe[2*te+1]??""));return ye}function r(Ne){for(let ye=0,qe=Ne.length;ye<qe;ye++){const te=Ne.charCodeAt(ye);if(te!==32&&te!==9)return ye}return-1}function a(Ne,ye=0,qe=Ne.length){for(let te=ye;te<qe;te++){const re=Ne.charCodeAt(te);if(re!==32&&re!==9)return Ne.substring(ye,te)}return Ne.substring(ye,qe)}function f(Ne,ye=Ne.length-1){for(let qe=ye;qe>=0;qe--){const te=Ne.charCodeAt(qe);if(te!==32&&te!==9)return qe}return-1}function g(Ne,ye,qe){const te=[];let re=0;for(const Pe of Ne.matchAll(ye)){if(te.push(Ne.slice(re,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");re=Pe.index+Pe[0].length,te.push(qe(Pe[0],...Pe.slice(1),Pe.index,Ne,Pe.groups))}return te.push(Ne.slice(re)),Promise.all(te).then(Pe=>Pe.join(""))}function w(Ne,ye){return Ne<ye?-1:Ne>ye?1:0}function S(Ne,ye,qe=0,te=Ne.length,re=0,Pe=ye.length){for(;qe<te&&re<Pe;qe++,re++){const st=Ne.charCodeAt(qe),lt=ye.charCodeAt(re);if(st<lt)return-1;if(st>lt)return 1}const He=te-qe,Le=Pe-re;return He<Le?-1:He>Le?1:0}function m(Ne,ye){return E(Ne,ye,0,Ne.length,0,ye.length)}function E(Ne,ye,qe=0,te=Ne.length,re=0,Pe=ye.length){for(;qe<te&&re<Pe;qe++,re++){let st=Ne.charCodeAt(qe),lt=ye.charCodeAt(re);if(st===lt)continue;if(st>=128||lt>=128)return S(Ne.toLowerCase(),ye.toLowerCase(),qe,te,re,Pe);P(st)&&(st-=32),P(lt)&&(lt-=32);const mt=st-lt;if(mt!==0)return mt}const He=te-qe,Le=Pe-re;return He<Le?-1:He>Le?1:0}function D(Ne){return Ne>=48&&Ne<=57}function P(Ne){return Ne>=97&&Ne<=122}function I(Ne){return Ne>=65&&Ne<=90}function F(Ne,ye){return Ne.length===ye.length&&E(Ne,ye)===0}function T(Ne,ye){const qe=ye.length;return ye.length>Ne.length?!1:E(Ne,ye,0,qe)===0}function z(Ne,ye){const qe=Math.min(Ne.length,ye.length);let te;for(te=0;te<qe;te++)if(Ne.charCodeAt(te)!==ye.charCodeAt(te))return te;return qe}function M(Ne,ye){const qe=Math.min(Ne.length,ye.length);let te;const re=Ne.length-1,Pe=ye.length-1;for(te=0;te<qe;te++)if(Ne.charCodeAt(re-te)!==ye.charCodeAt(Pe-te))return te;return qe}function j(Ne){return 55296<=Ne&&Ne<=56319}function U(Ne){return 56320<=Ne&&Ne<=57343}function Z(Ne,ye){return(Ne-55296<<10)+(ye-56320)+65536}function ie(Ne,ye,qe){const te=Ne.charCodeAt(qe);if(j(te)&&qe+1<ye){const re=Ne.charCodeAt(qe+1);if(U(re))return Z(te,re)}return te}function q(Ne,ye){const qe=Ne.charCodeAt(ye-1);if(U(qe)&&ye>1){const te=Ne.charCodeAt(ye-2);if(j(te))return Z(te,qe)}return qe}class G{get offset(){return this.e}constructor(ye,qe=0){this.c=ye,this.d=ye.length,this.e=qe}setOffset(ye){this.e=ye}prevCodePoint(){const ye=q(this.c,this.e);return this.e-=ye>=65536?2:1,ye}nextCodePoint(){const ye=ie(this.c,this.d,this.e);return this.e+=ye>=65536?2:1,ye}eol(){return this.e>=this.d}}e.$Ff=G;class x{get offset(){return this.c.offset}constructor(ye,qe=0){this.c=new G(ye,qe)}nextGraphemeLength(){const ye=Ve.getInstance(),qe=this.c,te=qe.offset;let re=ye.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const Pe=qe.offset,He=ye.getGraphemeBreakType(qe.nextCodePoint());if(we(re,He)){qe.setOffset(Pe);break}re=He}return qe.offset-te}prevGraphemeLength(){const ye=Ve.getInstance(),qe=this.c,te=qe.offset;let re=ye.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const Pe=qe.offset,He=ye.getGraphemeBreakType(qe.prevCodePoint());if(we(He,re)){qe.setOffset(Pe);break}re=He}return te-qe.offset}eol(){return this.c.eol()}}e.$Gf=x;function ne(Ne,ye){return new x(Ne,ye).nextGraphemeLength()}function be(Ne,ye){return new x(Ne,ye).prevGraphemeLength()}function ae(Ne,ye){ye>0&&U(Ne.charCodeAt(ye))&&ye--;const qe=ye+ne(Ne,ye);return[qe-be(Ne,qe),qe]}function Ce(Ne){const ye=new x(Ne);let qe=0;for(;!ye.eol();)qe++,ye.nextGraphemeLength();return qe}let ee;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(Ne){return ee||(ee=B()),ee.test(Ne)}const pe=/^[\t\n\r\x20-\x7E]*$/;function ue(Ne){return pe.test(Ne)}e.$Nf=/[\u2028\u2029]/;function ce(Ne){return e.$Nf.test(Ne)}function oe(Ne){return Ne>=11904&&Ne<=55215||Ne>=63744&&Ne<=64255||Ne>=65281&&Ne<=65374}function le(Ne){return Ne>=127462&&Ne<=127487||Ne===8986||Ne===8987||Ne===9200||Ne===9203||Ne>=9728&&Ne<=10175||Ne===11088||Ne===11093||Ne>=127744&&Ne<=128591||Ne>=128640&&Ne<=128764||Ne>=128992&&Ne<=129008||Ne>=129280&&Ne<=129535||Ne>=129648&&Ne<=129782}function K(Ne,ye,qe=""){const te=Ne.trimStart();if(te.length<ye)return te;const re=/\b/g;let Pe=0;for(;re.test(te)&&!(te.length-re.lastIndex<ye);)Pe=re.lastIndex,re.lastIndex+=1;return Pe===0?te:qe+te.substring(Pe).trimStart()}const se=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*$e(Ne){let ye=0;for(const qe of Ne.matchAll(se))ye!==qe.index&&(yield{isCode:!1,str:Ne.substring(ye,qe.index)}),yield{isCode:!0,str:qe[0]},ye=qe.index+qe[0].length;ye!==Ne.length&&(yield{isCode:!1,str:Ne.substring(ye)})}function ve(Ne){return Ne&&(Ne=Ne.replace(se,"")),Ne}const Re=/\\\[.*?\\\]/g;function ge(Ne){return ve(Ne).replace(Re,"")}e.$Vf="\uFEFF";function Ie(Ne){return!!(Ne&&Ne.length>0&&Ne.charCodeAt(0)===65279)}function Ae(Ne){return Ie(Ne)?Ne.substr(1):Ne}function ze(Ne,ye){if(!Ne||!ye||Ne.length<ye.length)return!1;const qe=ye.length,te=Ne.toLowerCase();let re=0,Pe=-1;for(;re<qe;){const He=te.indexOf(ye[re],Pe+1);if(He<0)return!1;Pe=He,re++}return!0}function V(Ne,ye=!1){return Ne?(ye&&(Ne=Ne.replace(/\\./g,"")),Ne.toLowerCase()!==Ne):!1}function W(Ne){return Ne.charAt(0).toUpperCase()+Ne.slice(1)}function J(Ne,ye=1){if(ye===0)return"";let qe=-1;do qe=Ne.indexOf(`
`,qe+1),ye--;while(ye>0&&qe>=0);return qe===-1?Ne:(Ne[qe-1]==="\r"&&qe--,Ne.substr(0,qe))}function X(Ne){return Ne=Ne%(2*26),Ne<26?String.fromCharCode(97+Ne):String.fromCharCode(65+Ne-26)}function de(Ne){return Ve.getInstance().getGraphemeBreakType(Ne)}function we(Ne,ye){return Ne===0?ye!==5&&ye!==7:Ne===2&&ye===3?!1:Ne===4||Ne===2||Ne===3||ye===4||ye===2||ye===3?!0:!(Ne===8&&(ye===8||ye===9||ye===11||ye===12)||(Ne===11||Ne===9)&&(ye===9||ye===10)||(Ne===12||Ne===10)&&ye===10||ye===5||ye===13||ye===7||Ne===1||Ne===13&&ye===14||Ne===6&&ye===6)}var je;(function(Ne){Ne[Ne.Other=0]="Other",Ne[Ne.Prepend=1]="Prepend",Ne[Ne.CR=2]="CR",Ne[Ne.LF=3]="LF",Ne[Ne.Control=4]="Control",Ne[Ne.Extend=5]="Extend",Ne[Ne.Regional_Indicator=6]="Regional_Indicator",Ne[Ne.SpacingMark=7]="SpacingMark",Ne[Ne.L=8]="L",Ne[Ne.V=9]="V",Ne[Ne.T=10]="T",Ne[Ne.LV=11]="LV",Ne[Ne.LVT=12]="LVT",Ne[Ne.ZWJ=13]="ZWJ",Ne[Ne.Extended_Pictographic=14]="Extended_Pictographic"})(je||(e.GraphemeBreakType=je={}));class Ve{static{this.c=null}static getInstance(){return Ve.c||(Ve.c=new Ve),Ve.c}constructor(){this.d=Je()}getGraphemeBreakType(ye){if(ye<32)return ye===10?3:ye===13?2:4;if(ye<127)return 0;const qe=this.d,te=qe.length/3;let re=1;for(;re<=te;)if(ye<qe[3*re])re=2*re;else if(ye>qe[3*re+1])re=2*re+1;else return qe[3*re+2];return 0}}function Je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function tt(Ne,ye){if(Ne===0)return 0;const qe=_e(Ne,ye);if(qe!==void 0)return qe;const te=new G(ye,Ne);return te.prevCodePoint(),te.offset}function _e(Ne,ye){const qe=new G(ye,Ne);let te=qe.prevCodePoint();for(;nt(te)||te===65039||te===8419;){if(qe.offset===0)return;te=qe.prevCodePoint()}if(!le(te))return;let re=qe.offset;return re>0&&qe.prevCodePoint()===8205&&(re=qe.offset),re}function nt(Ne){return 127995<=Ne&&Ne<=127999}var it;(function(Ne){Ne[Ne.zwj=8205]="zwj",Ne[Ne.emojiVariantSelector=65039]="emojiVariantSelector",Ne[Ne.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),e.$6f="\xA0";class rt{static{this.c=new O.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new d.$3e({getCacheKey:JSON.stringify},ye=>{function qe(mt){const Pt=new Map;for(let It=0;It<mt.length;It+=2)Pt.set(mt[It],mt[It+1]);return Pt}function te(mt,Pt){const It=new Map(mt);for(const[Bt,Ut]of Pt)It.set(Bt,Ut);return It}function re(mt,Pt){if(!mt)return Pt;const It=new Map;for(const[Bt,Ut]of mt)Pt.has(Bt)&&It.set(Bt,Ut);return It}const Pe=this.c.value;let He=ye.filter(mt=>!mt.startsWith("_")&&mt in Pe);He.length===0&&(He=["_default"]);let Le;for(const mt of He){const Pt=qe(Pe[mt]);Le=re(Le,Pt)}const st=qe(Pe._common),lt=te(st,Le);return new rt(lt)})}static getInstance(ye){return rt.d.get(Array.from(ye))}static{this.e=new O.$V(()=>Object.keys(rt.c.value).filter(ye=>!ye.startsWith("_")))}static getLocales(){return rt.e.value}constructor(ye){this.f=ye}isAmbiguous(ye){return this.f.has(ye)}getPrimaryConfusable(ye){return this.f.get(ye)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$7f=rt;class at{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(at.c())),this.d}static isInvisibleCharacter(ye){return at.e().has(ye)}static get codePoints(){return at.e()}}e.$8f=at}),define(Se[127],De([1,0,27,168,14]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.FuzzyScore=e.$yk=e.$xk=void 0,e.or=R,e.$zk=b,e.$Ak=$,e.$Bk=C,e.$Ck=g,e.$Dk=w,e.$Ek=I,e.$Fk=F,e.$Gk=T,e.$Hk=z,e.$Ik=_,e.$Kk=oe,e.$Lk=se,e.$Mk=$e;function R(...ge){return function(Ie,Ae){for(let ze=0,V=ge.length;ze<V;ze++){const W=ge[ze](Ie,Ae);if(W)return W}return null}}e.$xk=N.bind(void 0,!1),e.$yk=N.bind(void 0,!0);function N(ge,Ie,Ae){if(!Ae||Ae.length<Ie.length)return null;let ze;return ge?ze=L.$yf(Ae,Ie):ze=Ae.indexOf(Ie)===0,ze?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function b(ge,Ie){const Ae=Ie.toLowerCase().indexOf(ge.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+ge.length}]}function $(ge,Ie){return k(ge.toLowerCase(),Ie.toLowerCase(),0,0)}function k(ge,Ie,Ae,ze){if(Ae===ge.length)return[];if(ze===Ie.length)return null;if(ge[Ae]===Ie[ze]){let V=null;return(V=k(ge,Ie,Ae+1,ze+1))?u({start:ze,end:ze+1},V):null}return k(ge,Ie,Ae,ze+1)}function A(ge){return 97<=ge&&ge<=122}function C(ge){return 65<=ge&&ge<=90}function p(ge){return 48<=ge&&ge<=57}function y(ge){return ge===32||ge===9||ge===10||ge===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ge=>v.add(ge.charCodeAt(0)));function h(ge){return y(ge)||v.has(ge)}function l(ge,Ie){return ge===Ie||h(ge)&&h(Ie)}const o=new Map;function n(ge){if(o.has(ge))return o.get(ge);let Ie;const Ae=(0,O.$vk)(ge);return Ae&&(Ie=Ae),o.set(ge,Ie),Ie}function i(ge){return A(ge)||C(ge)||p(ge)}function u(ge,Ie){return Ie.length===0?Ie=[ge]:ge.end===Ie[0].start?Ie[0].start=ge.start:Ie.unshift(ge),Ie}function s(ge,Ie){for(let Ae=Ie;Ae<ge.length;Ae++){const ze=ge.charCodeAt(Ae);if(C(ze)||p(ze)||Ae>0&&!i(ge.charCodeAt(Ae-1)))return Ae}return ge.length}function t(ge,Ie,Ae,ze){if(Ae===ge.length)return[];if(ze===Ie.length)return null;if(ge[Ae]!==Ie[ze].toLowerCase())return null;{let V=null,W=ze+1;for(V=t(ge,Ie,Ae+1,ze+1);!V&&(W=s(Ie,W))<Ie.length;)V=t(ge,Ie,Ae+1,W),W++;return V===null?null:u({start:ze,end:ze+1},V)}}function c(ge){let Ie=0,Ae=0,ze=0,V=0,W=0;for(let je=0;je<ge.length;je++)W=ge.charCodeAt(je),C(W)&&Ie++,A(W)&&Ae++,i(W)&&ze++,p(W)&&V++;const J=Ie/ge.length,X=Ae/ge.length,de=ze/ge.length,we=V/ge.length;return{upperPercent:J,lowerPercent:X,alphaPercent:de,numericPercent:we}}function r(ge){const{upperPercent:Ie,lowerPercent:Ae}=ge;return Ae===0&&Ie>.6}function a(ge){const{upperPercent:Ie,lowerPercent:Ae,alphaPercent:ze,numericPercent:V}=ge;return Ae>.2&&Ie<.8&&ze>.6&&V<.2}function f(ge){let Ie=0,Ae=0,ze=0,V=0;for(let W=0;W<ge.length;W++)ze=ge.charCodeAt(W),C(ze)&&Ie++,A(ze)&&Ae++,y(ze)&&V++;return(Ie===0||Ae===0)&&V===0?ge.length<=30:Ie<=5}function g(ge,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!f(ge))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Ae=c(Ie);if(!a(Ae)){if(!r(Ae))return null;Ie=Ie.toLowerCase()}let ze=null,V=0;for(ge=ge.toLowerCase();V<Ie.length&&(ze=t(ge,Ie,0,V))===null;)V=s(Ie,V+1);return ze}function w(ge,Ie,Ae=!1){if(!Ie||Ie.length===0)return null;let ze=null,V=0;for(ge=ge.toLowerCase(),Ie=Ie.toLowerCase();V<Ie.length&&(ze=S(ge,Ie,0,V,Ae),ze===null);)V=m(Ie,V+1);return ze}function S(ge,Ie,Ae,ze,V){let W=0;if(Ae===ge.length)return[];if(ze===Ie.length)return null;if(!l(ge.charCodeAt(Ae),Ie.charCodeAt(ze))){const de=n(ge.charCodeAt(Ae));if(!de)return null;for(let we=0;we<de.length;we++)if(!l(de[we],Ie.charCodeAt(ze+we)))return null;W+=de.length-1}let J=null,X=ze+W+1;if(J=S(ge,Ie,Ae+1,X,V),!V)for(;!J&&(X=m(Ie,X))<Ie.length;)J=S(ge,Ie,Ae+1,X,V),X++;if(!J)return null;if(ge.charCodeAt(Ae)!==Ie.charCodeAt(ze)){const de=n(ge.charCodeAt(Ae));if(!de)return J;for(let we=0;we<de.length;we++)if(de[we]!==Ie.charCodeAt(ze+we))return J}return u({start:ze,end:ze+W+1},J)}function m(ge,Ie){for(let Ae=Ie;Ae<ge.length;Ae++)if(h(ge.charCodeAt(Ae))||Ae>0&&h(ge.charCodeAt(Ae-1)))return Ae;return ge.length}const E=R(e.$yk,g,b),D=R(e.$yk,g,$),P=new d.$Dc(1e4);function I(ge,Ie,Ae=!1){if(typeof ge!="string"||typeof Ie!="string")return null;let ze=P.get(ge);ze||(ze=new RegExp(L.$gf(ge),"i"),P.set(ge,ze));const V=ze.exec(Ie);return V?[{start:V.index,end:V.index+V[0].length}]:Ae?D(ge,Ie):E(ge,Ie)}function F(ge,Ie){const Ae=oe(ge,ge.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?z(Ae):null}function T(ge,Ie,Ae,ze,V,W){const J=Math.min(13,ge.length);for(;Ae<J;Ae++){const X=oe(ge,Ie,Ae,ze,V,W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(X)return X}return[0,W]}function z(ge){if(typeof ge>"u")return[];const Ie=[],Ae=ge[1];for(let ze=ge.length-1;ze>1;ze--){const V=ge[ze]+Ae,W=Ie[Ie.length-1];W&&W.end===V?W.end=V+1:Ie.push({start:V,end:V+1})}return Ie}const M=128;function j(){const ge=[],Ie=[];for(let Ae=0;Ae<=M;Ae++)Ie[Ae]=0;for(let Ae=0;Ae<=M;Ae++)ge.push(Ie.slice(0));return ge}function U(ge){const Ie=[];for(let Ae=0;Ae<=ge;Ae++)Ie[Ae]=0;return Ie}const Z=U(2*M),ie=U(2*M),q=j(),G=j(),x=j(),ne=!1;function be(ge,Ie,Ae,ze,V){function W(X,de,we=" "){for(;X.length<de;)X=we+X;return X}let J=` |   |${ze.split("").map(X=>W(X,3)).join("|")}
`;for(let X=0;X<=Ae;X++)X===0?J+=" |":J+=`${Ie[X-1]}|`,J+=ge[X].slice(0,V+1).map(de=>W(de.toString(),3)).join("|")+`
`;return J}function ae(ge,Ie,Ae,ze){ge=ge.substr(Ie),Ae=Ae.substr(ze),console.log(be(G,ge,ge.length,Ae,Ae.length)),console.log(be(x,ge,ge.length,Ae,Ae.length)),console.log(be(q,ge,ge.length,Ae,Ae.length))}function Ce(ge,Ie){if(Ie<0||Ie>=ge.length)return!1;const Ae=ge.codePointAt(Ie);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$Qf(Ae)}}function ee(ge,Ie){if(Ie<0||Ie>=ge.length)return!1;switch(ge.charCodeAt(Ie)){case 32:case 9:return!0;default:return!1}}function B(ge,Ie,Ae){return Ie[ge]!==Ae[ge]}function _(ge,Ie,Ae,ze,V,W,J=!1){for(;Ie<Ae&&V<W;)ge[Ie]===ze[V]&&(J&&(Z[Ie]=V),Ie+=1),V+=1;return Ie===Ae}var pe;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var ue;(function(ge){ge.Default=[-100,0];function Ie(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}ge.isDefault=Ie})(ue||(e.FuzzyScore=ue={}));class ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Ae){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Ae}}e.$Jk=ce;function oe(ge,Ie,Ae,ze,V,W,J=ce.default){const X=ge.length>M?M:ge.length,de=ze.length>M?M:ze.length;if(Ae>=X||W>=de||X-Ae>de-W||!_(Ie,Ae,X,V,W,de,!0))return;le(X,de,Ae,W,Ie,V);let we=1,je=1,Ve=Ae,Je=W;const tt=[!1];for(we=1,Ve=Ae;Ve<X;we++,Ve++){const at=Z[Ve],Ne=ie[Ve],ye=Ve+1<X?ie[Ve+1]:de;for(je=at-W+1,Je=at;Je<ye;je++,Je++){let qe=Number.MIN_SAFE_INTEGER,te=!1;Je<=Ne&&(qe=K(ge,Ie,Ve,Ae,ze,V,Je,de,W,q[we-1][je-1]===0,tt));let re=0;qe!==Number.MAX_SAFE_INTEGER&&(te=!0,re=qe+G[we-1][je-1]);const Pe=Je>at,He=Pe?G[we][je-1]+(q[we][je-1]>0?-5:0):0,Le=Je>at+1&&q[we][je-1]>0,st=Le?G[we][je-2]+(q[we][je-2]>0?-5:0):0;if(Le&&(!Pe||st>=He)&&(!te||st>=re))G[we][je]=st,x[we][je]=3,q[we][je]=0;else if(Pe&&(!te||He>=re))G[we][je]=He,x[we][je]=2,q[we][je]=0;else if(te)G[we][je]=re,x[we][je]=1,q[we][je]=q[we-1][je-1]+1;else throw new Error("not possible")}}if(ne&&ae(ge,Ae,ze,W),!tt[0]&&!J.firstMatchCanBeWeak)return;we--,je--;const _e=[G[we][je],W];let nt=0,it=0;for(;we>=1;){let at=je;do{const Ne=x[we][at];if(Ne===3)at=at-2;else if(Ne===2)at=at-1;else break}while(at>=1);nt>1&&Ie[Ae+we-1]===V[W+je-1]&&!B(at+W-1,ze,V)&&nt+1>q[we][at]&&(at=je),at===je?nt++:nt=1,it||(it=at),we--,je=at-1,_e.push(je)}de-W===X&&J.boostFullMatch&&(_e[0]+=2);const rt=it-X;return _e[0]-=rt,_e}function le(ge,Ie,Ae,ze,V,W){let J=ge-1,X=Ie-1;for(;J>=Ae&&X>=ze;)V[J]===W[X]&&(ie[J]=X,J--),X--}function K(ge,Ie,Ae,ze,V,W,J,X,de,we,je){if(Ie[Ae]!==W[J])return Number.MIN_SAFE_INTEGER;let Ve=1,Je=!1;return J===Ae-ze?Ve=ge[Ae]===V[J]?7:5:B(J,V,W)&&(J===0||!B(J-1,V,W))?(Ve=ge[Ae]===V[J]?7:5,Je=!0):Ce(W,J)&&(J===0||!Ce(W,J-1))?Ve=5:(Ce(W,J-1)||ee(W,J-1))&&(Ve=5,Je=!0),Ve>1&&Ae===ze&&(je[0]=!0),Je||(Je=B(J,V,W)||Ce(W,J-1)||ee(W,J-1)),Ae===ze?J>de&&(Ve-=Je?3:5):we?Ve+=Je?2:0:Ve+=Je?0:1,J+1===X&&(Ve-=Je?3:5),Ve}function se(ge,Ie,Ae,ze,V,W,J){return ve(ge,Ie,Ae,ze,V,W,!0,J)}function $e(ge,Ie,Ae,ze,V,W,J){return ve(ge,Ie,Ae,ze,V,W,!1,J)}function ve(ge,Ie,Ae,ze,V,W,J,X){let de=oe(ge,Ie,Ae,ze,V,W,X);if(de&&!J)return de;if(ge.length>=3){const we=Math.min(7,ge.length-1);for(let je=Ae+1;je<we;je++){const Ve=Re(ge,je);if(Ve){const Je=oe(Ve,Ve.toLowerCase(),Ae,ze,V,W,X);Je&&(Je[0]-=3,(!de||Je[0]>de[0])&&(de=Je))}}}return de}function Re(ge,Ie){if(Ie+1>=ge.length)return;const Ae=ge[Ie],ze=ge[Ie+1];if(Ae!==ze)return ge.slice(0,Ie)+ze+Ae+ge.slice(Ie+2)}}),define(Se[57],De([1,0,14]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$oj=void 0,e.$kj=O,e.$lj=L,e.$mj=R,e.$nj=b,e.$pj=h;function O(o){return L(o,0)}function L(o,n){switch(typeof o){case"object":return o===null?R(349,n):Array.isArray(o)?$(o,n):k(o,n);case"string":return b(o,n);case"boolean":return N(o,n);case"number":return R(o,n);case"undefined":return R(937,n);default:return R(617,n)}}function R(o,n){return(n<<5)-n+o|0}function N(o,n){return R(o?433:863,n)}function b(o,n){n=R(149417,n);for(let i=0,u=o.length;i<u;i++)n=R(o.charCodeAt(i),n);return n}function $(o,n){return n=R(104579,n),o.reduce((i,u)=>L(u,i),n)}function k(o,n){return n=R(181387,n),Object.keys(o).sort().reduce((i,u)=>(i=b(u,i),L(o[u],i)),n)}class A{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=L(n,this.g),this.g}}e.$oj=A;var C;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function p(o,n,i=32){const u=i-n,s=~((1<<u)-1);return(o<<n|(s&o)>>>u)>>>0}function y(o,n=0,i=o.byteLength,u=0){for(let s=0;s<i;s++)o[n+s]=u}function v(o,n,i="0"){for(;o.length<n;)o=i+o;return o}function h(o,n=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(i=>i.toString(16).padStart(2,"0")).join(""):v((o>>>0).toString(16),n/4)}class l{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const u=this.p;let s=this.r,t=this.u,c,r;for(t!==0?(c=t,r=-1,t=0):(c=n.charCodeAt(0),r=0);;){let a=c;if(d.$Bf(c))if(r+1<i){const f=n.charCodeAt(r+1);d.$Cf(f)?(r++,a=d.$Df(c,f)):a=65533}else{t=c;break}else d.$Cf(c)&&(a=65533);if(s=this.w(u,s,a),r++,r<i)c=n.charCodeAt(r);else break}this.r=s,this.u=t}w(n,i,u){return u<128?n[i++]=u:u<2048?(n[i++]=192|(u&1984)>>>6,n[i++]=128|(u&63)>>>0):u<65536?(n[i++]=224|(u&61440)>>>12,n[i++]=128|(u&4032)>>>6,n[i++]=128|(u&63)>>>0):(n[i++]=240|(u&1835008)>>>18,n[i++]=128|(u&258048)>>>12,n[i++]=128|(u&4032)>>>6,n[i++]=128|(u&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=l.g,i=this.q;for(let w=0;w<64;w+=4)n.setUint32(w,i.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)n.setUint32(w,p(n.getUint32(w-12,!1)^n.getUint32(w-32,!1)^n.getUint32(w-56,!1)^n.getUint32(w-64,!1),1),!1);let u=this.h,s=this.l,t=this.m,c=this.n,r=this.o,a,f,g;for(let w=0;w<80;w++)w<20?(a=s&t|~s&c,f=1518500249):w<40?(a=s^t^c,f=1859775393):w<60?(a=s&t|s&c|t&c,f=2400959708):(a=s^t^c,f=3395469782),g=p(u,5)+a+r+f+n.getUint32(w*4,!1)&4294967295,r=c,c=t,t=p(s,30),s=u,u=g;this.h=this.h+u&4294967295,this.l=this.l+s&4294967295,this.m=this.m+t&4294967295,this.n=this.n+c&4294967295,this.o=this.o+r&4294967295}}e.$qj=l}),define(Se[41],De([1,0,14]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(O||(O={})),function(L){const R="error",N="warning",b="warn",$="info",k="ignore";function A(p){return p?d.$xf(R,p)?L.Error:d.$xf(N,p)||d.$xf(b,p)?L.Warning:d.$xf($,p)?L.Info:L.Ignore:L.Ignore}L.fromValue=A;function C(p){switch(p){case L.Error:return R;case L.Warning:return N;case L.Info:return $;default:return k}}L.toString=C}(O||(O={})),e.default=O}),define(Se[174],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=void 0,e.$ae=Symbol("MicrotaskDelay")}),define(Se[78],De([1,0,19,14]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class L{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const v=y.charCodeAt(0),h=this.b.charCodeAt(this.c);return v-h}value(){return this.b[this.c]}}e.$yi=L;class R{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,O.$rf)(y,this.b,0,y.length,this.c,this.d):(0,O.$tf)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$zi=R;class N{constructor(y=!0,v=!0){this.f=y,this.g=v}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let v=y.length-1;v>=0;v--,this.c--){const h=this.b.charCodeAt(v);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,O.$rf)(y,this.b,0,y.length,this.d,this.e):(0,O.$tf)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ai=N;var b;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(b||(b={}));class ${constructor(y,v){this.f=y,this.g=v,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new N(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,O.$sf)(y,this.c.scheme);if(this.d[this.e]===2)return(0,O.$sf)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,O.$qf)(y,this.c.query);if(this.d[this.e]===5)return(0,O.$qf)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Bi=$;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(A||(A={}));class C{static forUris(y=()=>!1,v=()=>!1){return new C(new $(y,v))}static forPaths(y=!1){return new C(new N(void 0,!y))}static forStrings(){return new C(new L)}static forConfigKeys(){return new C(new R)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,v){if(v){const h=v.slice(0);(0,d.$Wb)(h);for(const l of h)this.set(l,y)}else{const h=y.slice(0);(0,d.$Wb)(h);for(const l of h)this.set(l[0],l[1])}}set(y,v){const h=this.b.reset(y);let l;this.c||(this.c=new k,this.c.segment=h.value());const o=[];for(l=this.c;;){const i=h.cmp(l.segment);if(i>0)l.left||(l.left=new k,l.left.segment=h.value()),o.push([-1,l]),l=l.left;else if(i<0)l.right||(l.right=new k,l.right.segment=h.value()),o.push([1,l]),l=l.right;else if(h.hasNext())h.next(),l.mid||(l.mid=new k,l.mid.segment=h.value()),o.push([0,l]),l=l.mid;else break}const n=l.value;l.value=v,l.key=y;for(let i=o.length-1;i>=0;i--){const u=o[i][1];u.updateHeight();const s=u.balanceFactor();if(s<-1||s>1){const t=o[i][0],c=o[i+1][0];if(t===1&&c===1)o[i][1]=u.rotateLeft();else if(t===-1&&c===-1)o[i][1]=u.rotateRight();else if(t===1&&c===-1)u.right=o[i+1][1]=o[i+1][1].rotateRight(),o[i][1]=u.rotateLeft();else if(t===-1&&c===1)u.left=o[i+1][1]=o[i+1][1].rotateLeft(),o[i][1]=u.rotateRight();else throw new Error;if(i>0)switch(o[i-1][0]){case-1:o[i-1][1].left=o[i][1];break;case 1:o[i-1][1].right=o[i][1];break;case 0:o[i-1][1].mid=o[i][1];break}else this.c=o[0][1]}}return n}get(y){return this.d(y)?.value}d(y){const v=this.b.reset(y);let h=this.c;for(;h;){const l=v.cmp(h.segment);if(l>0)h=h.left;else if(l<0)h=h.right;else if(v.hasNext())v.next(),h=h.mid;else break}return h}has(y){const v=this.d(y);return!(v?.value===void 0&&v?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,v){const h=this.b.reset(y),l=[];let o=this.c;for(;o;){const n=h.cmp(o.segment);if(n>0)l.push([-1,o]),o=o.left;else if(n<0)l.push([1,o]),o=o.right;else if(h.hasNext())h.next(),l.push([0,o]),o=o.mid;else break}if(o){if(v?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const n=this.f(o.right);if(n.key){const{key:i,value:u,segment:s}=n;this.e(n.key,!1),o.key=i,o.value=u,o.segment=s}}else{const n=o.left??o.right;if(l.length>0){const[i,u]=l[l.length-1];switch(i){case-1:u.left=n;break;case 0:u.mid=n;break;case 1:u.right=n;break}}else this.c=n}for(let n=l.length-1;n>=0;n--){const i=l[n][1];i.updateHeight();const u=i.balanceFactor();if(u>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),l[n][1]=i.rotateLeft()):u<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),l[n][1]=i.rotateRight()),n>0)switch(l[n-1][0]){case-1:l[n-1][1].left=l[n][1];break;case 1:l[n-1][1].right=l[n][1];break;case 0:l[n-1][1].mid=l[n][1];break}else this.c=l[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const v=this.b.reset(y);let h=this.c,l;for(;h;){const o=v.cmp(h.segment);if(o>0)h=h.left;else if(o<0)h=h.right;else if(v.hasNext())v.next(),l=h.value||l,h=h.mid;else break}return h&&h.value||l}findSuperstr(y){return this.g(y,!1)}g(y,v){const h=this.b.reset(y);let l=this.c;for(;l;){const o=h.cmp(l.segment);if(o>0)l=l.left;else if(o<0)l=l.right;else if(h.hasNext())h.next(),l=l.mid;else return l.mid?this.h(l.mid):v?l.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[v,h]of this)y(h,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const v=[];return this.j(y,v),v[Symbol.iterator]()}j(y,v){y&&(y.left&&this.j(y.left,v),y.value&&v.push([y.key,y.value]),y.mid&&this.j(y.mid,v),y.right&&this.j(y.right,v))}_isBalanced(){const y=v=>{if(!v)return!0;const h=v.balanceFactor();return h<-1||h>1?!1:y(v.left)&&y(v.right)};return y(this.c)}}e.$Ci=C}),define(Se[18],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9f=d,e.$0f=O,e.$$f=L,e.$_f=R,e.$ag=N,e.$bg=b,e.$cg=$,e.$dg=k,e.$eg=A,e.$fg=C,e.$gg=p,e.$hg=y,e.$ig=v,e.$jg=l,e.$kg=o,e.$lg=n,e.$mg=i,e.$ng=u;function d(s){return typeof s=="string"}function O(s){return Array.isArray(s)&&s.every(t=>d(t))}function L(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function R(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}function N(s){return typeof s=="number"&&!isNaN(s)}function b(s){return!!s&&typeof s[Symbol.iterator]=="function"}function $(s){return s===!0||s===!1}function k(s){return typeof s>"u"}function A(s){return!C(s)}function C(s){return k(s)||s===null}function p(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function y(s){if(C(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function v(...s){const t=[];for(let c=0;c<s.length;c++){const r=s[c];if(C(r))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);t.push(r)}return t}const h=Object.prototype.hasOwnProperty;function l(s){if(!L(s))return!1;for(const t in s)if(h.call(s,t))return!1;return!0}function o(s){return typeof s=="function"}function n(...s){return s.length>0&&s.every(o)}function i(s,t){const c=Math.min(s.length,t.length);for(let r=0;r<c;r++)u(s[r],t[r])}function u(s,t){if(d(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(s instanceof t)return}catch{}if(!C(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Se[99],De([1,0,18]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=L,e.$Rj=R;const O=Object.create(null);function L(N,b){if((0,d.$9f)(b)){const $=O[b];if($===void 0)throw new Error(`${N} references an unknown codicon: ${b}`);b=$}return O[N]=b,{id:N}}function R(){return O}}),define(Se[175],De([1,0,99]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=void 0,e.$Sj={add:(0,d.$Qj)("add",6e4),plus:(0,d.$Qj)("plus",6e4),gistNew:(0,d.$Qj)("gist-new",6e4),repoCreate:(0,d.$Qj)("repo-create",6e4),lightbulb:(0,d.$Qj)("lightbulb",60001),lightBulb:(0,d.$Qj)("light-bulb",60001),repo:(0,d.$Qj)("repo",60002),repoDelete:(0,d.$Qj)("repo-delete",60002),gistFork:(0,d.$Qj)("gist-fork",60003),repoForked:(0,d.$Qj)("repo-forked",60003),gitPullRequest:(0,d.$Qj)("git-pull-request",60004),gitPullRequestAbandoned:(0,d.$Qj)("git-pull-request-abandoned",60004),recordKeys:(0,d.$Qj)("record-keys",60005),keyboard:(0,d.$Qj)("keyboard",60005),tag:(0,d.$Qj)("tag",60006),gitPullRequestLabel:(0,d.$Qj)("git-pull-request-label",60006),tagAdd:(0,d.$Qj)("tag-add",60006),tagRemove:(0,d.$Qj)("tag-remove",60006),person:(0,d.$Qj)("person",60007),personFollow:(0,d.$Qj)("person-follow",60007),personOutline:(0,d.$Qj)("person-outline",60007),personFilled:(0,d.$Qj)("person-filled",60007),gitBranch:(0,d.$Qj)("git-branch",60008),gitBranchCreate:(0,d.$Qj)("git-branch-create",60008),gitBranchDelete:(0,d.$Qj)("git-branch-delete",60008),sourceControl:(0,d.$Qj)("source-control",60008),mirror:(0,d.$Qj)("mirror",60009),mirrorPublic:(0,d.$Qj)("mirror-public",60009),star:(0,d.$Qj)("star",60010),starAdd:(0,d.$Qj)("star-add",60010),starDelete:(0,d.$Qj)("star-delete",60010),starEmpty:(0,d.$Qj)("star-empty",60010),comment:(0,d.$Qj)("comment",60011),commentAdd:(0,d.$Qj)("comment-add",60011),alert:(0,d.$Qj)("alert",60012),warning:(0,d.$Qj)("warning",60012),search:(0,d.$Qj)("search",60013),searchSave:(0,d.$Qj)("search-save",60013),logOut:(0,d.$Qj)("log-out",60014),signOut:(0,d.$Qj)("sign-out",60014),logIn:(0,d.$Qj)("log-in",60015),signIn:(0,d.$Qj)("sign-in",60015),eye:(0,d.$Qj)("eye",60016),eyeUnwatch:(0,d.$Qj)("eye-unwatch",60016),eyeWatch:(0,d.$Qj)("eye-watch",60016),circleFilled:(0,d.$Qj)("circle-filled",60017),primitiveDot:(0,d.$Qj)("primitive-dot",60017),closeDirty:(0,d.$Qj)("close-dirty",60017),debugBreakpoint:(0,d.$Qj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,d.$Qj)("debug-breakpoint-disabled",60017),debugHint:(0,d.$Qj)("debug-hint",60017),terminalDecorationSuccess:(0,d.$Qj)("terminal-decoration-success",60017),primitiveSquare:(0,d.$Qj)("primitive-square",60018),edit:(0,d.$Qj)("edit",60019),pencil:(0,d.$Qj)("pencil",60019),info:(0,d.$Qj)("info",60020),issueOpened:(0,d.$Qj)("issue-opened",60020),gistPrivate:(0,d.$Qj)("gist-private",60021),gitForkPrivate:(0,d.$Qj)("git-fork-private",60021),lock:(0,d.$Qj)("lock",60021),mirrorPrivate:(0,d.$Qj)("mirror-private",60021),close:(0,d.$Qj)("close",60022),removeClose:(0,d.$Qj)("remove-close",60022),x:(0,d.$Qj)("x",60022),repoSync:(0,d.$Qj)("repo-sync",60023),sync:(0,d.$Qj)("sync",60023),clone:(0,d.$Qj)("clone",60024),desktopDownload:(0,d.$Qj)("desktop-download",60024),beaker:(0,d.$Qj)("beaker",60025),microscope:(0,d.$Qj)("microscope",60025),vm:(0,d.$Qj)("vm",60026),deviceDesktop:(0,d.$Qj)("device-desktop",60026),file:(0,d.$Qj)("file",60027),fileText:(0,d.$Qj)("file-text",60027),more:(0,d.$Qj)("more",60028),ellipsis:(0,d.$Qj)("ellipsis",60028),kebabHorizontal:(0,d.$Qj)("kebab-horizontal",60028),mailReply:(0,d.$Qj)("mail-reply",60029),reply:(0,d.$Qj)("reply",60029),organization:(0,d.$Qj)("organization",60030),organizationFilled:(0,d.$Qj)("organization-filled",60030),organizationOutline:(0,d.$Qj)("organization-outline",60030),newFile:(0,d.$Qj)("new-file",60031),fileAdd:(0,d.$Qj)("file-add",60031),newFolder:(0,d.$Qj)("new-folder",60032),fileDirectoryCreate:(0,d.$Qj)("file-directory-create",60032),trash:(0,d.$Qj)("trash",60033),trashcan:(0,d.$Qj)("trashcan",60033),history:(0,d.$Qj)("history",60034),clock:(0,d.$Qj)("clock",60034),folder:(0,d.$Qj)("folder",60035),fileDirectory:(0,d.$Qj)("file-directory",60035),symbolFolder:(0,d.$Qj)("symbol-folder",60035),logoGithub:(0,d.$Qj)("logo-github",60036),markGithub:(0,d.$Qj)("mark-github",60036),github:(0,d.$Qj)("github",60036),terminal:(0,d.$Qj)("terminal",60037),console:(0,d.$Qj)("console",60037),repl:(0,d.$Qj)("repl",60037),zap:(0,d.$Qj)("zap",60038),symbolEvent:(0,d.$Qj)("symbol-event",60038),error:(0,d.$Qj)("error",60039),stop:(0,d.$Qj)("stop",60039),variable:(0,d.$Qj)("variable",60040),symbolVariable:(0,d.$Qj)("symbol-variable",60040),array:(0,d.$Qj)("array",60042),symbolArray:(0,d.$Qj)("symbol-array",60042),symbolModule:(0,d.$Qj)("symbol-module",60043),symbolPackage:(0,d.$Qj)("symbol-package",60043),symbolNamespace:(0,d.$Qj)("symbol-namespace",60043),symbolObject:(0,d.$Qj)("symbol-object",60043),symbolMethod:(0,d.$Qj)("symbol-method",60044),symbolFunction:(0,d.$Qj)("symbol-function",60044),symbolConstructor:(0,d.$Qj)("symbol-constructor",60044),symbolBoolean:(0,d.$Qj)("symbol-boolean",60047),symbolNull:(0,d.$Qj)("symbol-null",60047),symbolNumeric:(0,d.$Qj)("symbol-numeric",60048),symbolNumber:(0,d.$Qj)("symbol-number",60048),symbolStructure:(0,d.$Qj)("symbol-structure",60049),symbolStruct:(0,d.$Qj)("symbol-struct",60049),symbolParameter:(0,d.$Qj)("symbol-parameter",60050),symbolTypeParameter:(0,d.$Qj)("symbol-type-parameter",60050),symbolKey:(0,d.$Qj)("symbol-key",60051),symbolText:(0,d.$Qj)("symbol-text",60051),symbolReference:(0,d.$Qj)("symbol-reference",60052),goToFile:(0,d.$Qj)("go-to-file",60052),symbolEnum:(0,d.$Qj)("symbol-enum",60053),symbolValue:(0,d.$Qj)("symbol-value",60053),symbolRuler:(0,d.$Qj)("symbol-ruler",60054),symbolUnit:(0,d.$Qj)("symbol-unit",60054),activateBreakpoints:(0,d.$Qj)("activate-breakpoints",60055),archive:(0,d.$Qj)("archive",60056),arrowBoth:(0,d.$Qj)("arrow-both",60057),arrowDown:(0,d.$Qj)("arrow-down",60058),arrowLeft:(0,d.$Qj)("arrow-left",60059),arrowRight:(0,d.$Qj)("arrow-right",60060),arrowSmallDown:(0,d.$Qj)("arrow-small-down",60061),arrowSmallLeft:(0,d.$Qj)("arrow-small-left",60062),arrowSmallRight:(0,d.$Qj)("arrow-small-right",60063),arrowSmallUp:(0,d.$Qj)("arrow-small-up",60064),arrowUp:(0,d.$Qj)("arrow-up",60065),bell:(0,d.$Qj)("bell",60066),bold:(0,d.$Qj)("bold",60067),book:(0,d.$Qj)("book",60068),bookmark:(0,d.$Qj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,d.$Qj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,d.$Qj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,d.$Qj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,d.$Qj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,d.$Qj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,d.$Qj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,d.$Qj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,d.$Qj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,d.$Qj)("debug-breakpoint-log-disabled",60075),briefcase:(0,d.$Qj)("briefcase",60076),broadcast:(0,d.$Qj)("broadcast",60077),browser:(0,d.$Qj)("browser",60078),bug:(0,d.$Qj)("bug",60079),calendar:(0,d.$Qj)("calendar",60080),caseSensitive:(0,d.$Qj)("case-sensitive",60081),check:(0,d.$Qj)("check",60082),checklist:(0,d.$Qj)("checklist",60083),chevronDown:(0,d.$Qj)("chevron-down",60084),chevronLeft:(0,d.$Qj)("chevron-left",60085),chevronRight:(0,d.$Qj)("chevron-right",60086),chevronUp:(0,d.$Qj)("chevron-up",60087),chromeClose:(0,d.$Qj)("chrome-close",60088),chromeMaximize:(0,d.$Qj)("chrome-maximize",60089),chromeMinimize:(0,d.$Qj)("chrome-minimize",60090),chromeRestore:(0,d.$Qj)("chrome-restore",60091),circleOutline:(0,d.$Qj)("circle-outline",60092),circle:(0,d.$Qj)("circle",60092),debugBreakpointUnverified:(0,d.$Qj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,d.$Qj)("terminal-decoration-incomplete",60092),circleSlash:(0,d.$Qj)("circle-slash",60093),circuitBoard:(0,d.$Qj)("circuit-board",60094),clearAll:(0,d.$Qj)("clear-all",60095),clippy:(0,d.$Qj)("clippy",60096),closeAll:(0,d.$Qj)("close-all",60097),cloudDownload:(0,d.$Qj)("cloud-download",60098),cloudUpload:(0,d.$Qj)("cloud-upload",60099),code:(0,d.$Qj)("code",60100),collapseAll:(0,d.$Qj)("collapse-all",60101),colorMode:(0,d.$Qj)("color-mode",60102),commentDiscussion:(0,d.$Qj)("comment-discussion",60103),creditCard:(0,d.$Qj)("credit-card",60105),dash:(0,d.$Qj)("dash",60108),dashboard:(0,d.$Qj)("dashboard",60109),database:(0,d.$Qj)("database",60110),debugContinue:(0,d.$Qj)("debug-continue",60111),debugDisconnect:(0,d.$Qj)("debug-disconnect",60112),debugPause:(0,d.$Qj)("debug-pause",60113),debugRestart:(0,d.$Qj)("debug-restart",60114),debugStart:(0,d.$Qj)("debug-start",60115),debugStepInto:(0,d.$Qj)("debug-step-into",60116),debugStepOut:(0,d.$Qj)("debug-step-out",60117),debugStepOver:(0,d.$Qj)("debug-step-over",60118),debugStop:(0,d.$Qj)("debug-stop",60119),debug:(0,d.$Qj)("debug",60120),deviceCameraVideo:(0,d.$Qj)("device-camera-video",60121),deviceCamera:(0,d.$Qj)("device-camera",60122),deviceMobile:(0,d.$Qj)("device-mobile",60123),diffAdded:(0,d.$Qj)("diff-added",60124),diffIgnored:(0,d.$Qj)("diff-ignored",60125),diffModified:(0,d.$Qj)("diff-modified",60126),diffRemoved:(0,d.$Qj)("diff-removed",60127),diffRenamed:(0,d.$Qj)("diff-renamed",60128),diff:(0,d.$Qj)("diff",60129),diffSidebyside:(0,d.$Qj)("diff-sidebyside",60129),discard:(0,d.$Qj)("discard",60130),editorLayout:(0,d.$Qj)("editor-layout",60131),emptyWindow:(0,d.$Qj)("empty-window",60132),exclude:(0,d.$Qj)("exclude",60133),extensions:(0,d.$Qj)("extensions",60134),eyeClosed:(0,d.$Qj)("eye-closed",60135),fileBinary:(0,d.$Qj)("file-binary",60136),fileCode:(0,d.$Qj)("file-code",60137),fileMedia:(0,d.$Qj)("file-media",60138),filePdf:(0,d.$Qj)("file-pdf",60139),fileSubmodule:(0,d.$Qj)("file-submodule",60140),fileSymlinkDirectory:(0,d.$Qj)("file-symlink-directory",60141),fileSymlinkFile:(0,d.$Qj)("file-symlink-file",60142),fileZip:(0,d.$Qj)("file-zip",60143),files:(0,d.$Qj)("files",60144),filter:(0,d.$Qj)("filter",60145),flame:(0,d.$Qj)("flame",60146),foldDown:(0,d.$Qj)("fold-down",60147),foldUp:(0,d.$Qj)("fold-up",60148),fold:(0,d.$Qj)("fold",60149),folderActive:(0,d.$Qj)("folder-active",60150),folderOpened:(0,d.$Qj)("folder-opened",60151),gear:(0,d.$Qj)("gear",60152),gift:(0,d.$Qj)("gift",60153),gistSecret:(0,d.$Qj)("gist-secret",60154),gist:(0,d.$Qj)("gist",60155),gitCommit:(0,d.$Qj)("git-commit",60156),gitCompare:(0,d.$Qj)("git-compare",60157),compareChanges:(0,d.$Qj)("compare-changes",60157),gitMerge:(0,d.$Qj)("git-merge",60158),githubAction:(0,d.$Qj)("github-action",60159),githubAlt:(0,d.$Qj)("github-alt",60160),globe:(0,d.$Qj)("globe",60161),grabber:(0,d.$Qj)("grabber",60162),graph:(0,d.$Qj)("graph",60163),gripper:(0,d.$Qj)("gripper",60164),heart:(0,d.$Qj)("heart",60165),home:(0,d.$Qj)("home",60166),horizontalRule:(0,d.$Qj)("horizontal-rule",60167),hubot:(0,d.$Qj)("hubot",60168),inbox:(0,d.$Qj)("inbox",60169),issueReopened:(0,d.$Qj)("issue-reopened",60171),issues:(0,d.$Qj)("issues",60172),italic:(0,d.$Qj)("italic",60173),jersey:(0,d.$Qj)("jersey",60174),json:(0,d.$Qj)("json",60175),kebabVertical:(0,d.$Qj)("kebab-vertical",60176),key:(0,d.$Qj)("key",60177),law:(0,d.$Qj)("law",60178),lightbulbAutofix:(0,d.$Qj)("lightbulb-autofix",60179),linkExternal:(0,d.$Qj)("link-external",60180),link:(0,d.$Qj)("link",60181),listOrdered:(0,d.$Qj)("list-ordered",60182),listUnordered:(0,d.$Qj)("list-unordered",60183),liveShare:(0,d.$Qj)("live-share",60184),loading:(0,d.$Qj)("loading",60185),location:(0,d.$Qj)("location",60186),mailRead:(0,d.$Qj)("mail-read",60187),mail:(0,d.$Qj)("mail",60188),markdown:(0,d.$Qj)("markdown",60189),megaphone:(0,d.$Qj)("megaphone",60190),mention:(0,d.$Qj)("mention",60191),milestone:(0,d.$Qj)("milestone",60192),gitPullRequestMilestone:(0,d.$Qj)("git-pull-request-milestone",60192),mortarBoard:(0,d.$Qj)("mortar-board",60193),move:(0,d.$Qj)("move",60194),multipleWindows:(0,d.$Qj)("multiple-windows",60195),mute:(0,d.$Qj)("mute",60196),noNewline:(0,d.$Qj)("no-newline",60197),note:(0,d.$Qj)("note",60198),octoface:(0,d.$Qj)("octoface",60199),openPreview:(0,d.$Qj)("open-preview",60200),package:(0,d.$Qj)("package",60201),paintcan:(0,d.$Qj)("paintcan",60202),pin:(0,d.$Qj)("pin",60203),play:(0,d.$Qj)("play",60204),run:(0,d.$Qj)("run",60204),plug:(0,d.$Qj)("plug",60205),preserveCase:(0,d.$Qj)("preserve-case",60206),preview:(0,d.$Qj)("preview",60207),project:(0,d.$Qj)("project",60208),pulse:(0,d.$Qj)("pulse",60209),question:(0,d.$Qj)("question",60210),quote:(0,d.$Qj)("quote",60211),radioTower:(0,d.$Qj)("radio-tower",60212),reactions:(0,d.$Qj)("reactions",60213),references:(0,d.$Qj)("references",60214),refresh:(0,d.$Qj)("refresh",60215),regex:(0,d.$Qj)("regex",60216),remoteExplorer:(0,d.$Qj)("remote-explorer",60217),remote:(0,d.$Qj)("remote",60218),remove:(0,d.$Qj)("remove",60219),replaceAll:(0,d.$Qj)("replace-all",60220),replace:(0,d.$Qj)("replace",60221),repoClone:(0,d.$Qj)("repo-clone",60222),repoForcePush:(0,d.$Qj)("repo-force-push",60223),repoPull:(0,d.$Qj)("repo-pull",60224),repoPush:(0,d.$Qj)("repo-push",60225),report:(0,d.$Qj)("report",60226),requestChanges:(0,d.$Qj)("request-changes",60227),rocket:(0,d.$Qj)("rocket",60228),rootFolderOpened:(0,d.$Qj)("root-folder-opened",60229),rootFolder:(0,d.$Qj)("root-folder",60230),rss:(0,d.$Qj)("rss",60231),ruby:(0,d.$Qj)("ruby",60232),saveAll:(0,d.$Qj)("save-all",60233),saveAs:(0,d.$Qj)("save-as",60234),save:(0,d.$Qj)("save",60235),screenFull:(0,d.$Qj)("screen-full",60236),screenNormal:(0,d.$Qj)("screen-normal",60237),searchStop:(0,d.$Qj)("search-stop",60238),server:(0,d.$Qj)("server",60240),settingsGear:(0,d.$Qj)("settings-gear",60241),settings:(0,d.$Qj)("settings",60242),shield:(0,d.$Qj)("shield",60243),smiley:(0,d.$Qj)("smiley",60244),sortPrecedence:(0,d.$Qj)("sort-precedence",60245),splitHorizontal:(0,d.$Qj)("split-horizontal",60246),splitVertical:(0,d.$Qj)("split-vertical",60247),squirrel:(0,d.$Qj)("squirrel",60248),starFull:(0,d.$Qj)("star-full",60249),starHalf:(0,d.$Qj)("star-half",60250),symbolClass:(0,d.$Qj)("symbol-class",60251),symbolColor:(0,d.$Qj)("symbol-color",60252),symbolConstant:(0,d.$Qj)("symbol-constant",60253),symbolEnumMember:(0,d.$Qj)("symbol-enum-member",60254),symbolField:(0,d.$Qj)("symbol-field",60255),symbolFile:(0,d.$Qj)("symbol-file",60256),symbolInterface:(0,d.$Qj)("symbol-interface",60257),symbolKeyword:(0,d.$Qj)("symbol-keyword",60258),symbolMisc:(0,d.$Qj)("symbol-misc",60259),symbolOperator:(0,d.$Qj)("symbol-operator",60260),symbolProperty:(0,d.$Qj)("symbol-property",60261),wrench:(0,d.$Qj)("wrench",60261),wrenchSubaction:(0,d.$Qj)("wrench-subaction",60261),symbolSnippet:(0,d.$Qj)("symbol-snippet",60262),tasklist:(0,d.$Qj)("tasklist",60263),telescope:(0,d.$Qj)("telescope",60264),textSize:(0,d.$Qj)("text-size",60265),threeBars:(0,d.$Qj)("three-bars",60266),thumbsdown:(0,d.$Qj)("thumbsdown",60267),thumbsup:(0,d.$Qj)("thumbsup",60268),tools:(0,d.$Qj)("tools",60269),triangleDown:(0,d.$Qj)("triangle-down",60270),triangleLeft:(0,d.$Qj)("triangle-left",60271),triangleRight:(0,d.$Qj)("triangle-right",60272),triangleUp:(0,d.$Qj)("triangle-up",60273),twitter:(0,d.$Qj)("twitter",60274),unfold:(0,d.$Qj)("unfold",60275),unlock:(0,d.$Qj)("unlock",60276),unmute:(0,d.$Qj)("unmute",60277),unverified:(0,d.$Qj)("unverified",60278),verified:(0,d.$Qj)("verified",60279),versions:(0,d.$Qj)("versions",60280),vmActive:(0,d.$Qj)("vm-active",60281),vmOutline:(0,d.$Qj)("vm-outline",60282),vmRunning:(0,d.$Qj)("vm-running",60283),watch:(0,d.$Qj)("watch",60284),whitespace:(0,d.$Qj)("whitespace",60285),wholeWord:(0,d.$Qj)("whole-word",60286),window:(0,d.$Qj)("window",60287),wordWrap:(0,d.$Qj)("word-wrap",60288),zoomIn:(0,d.$Qj)("zoom-in",60289),zoomOut:(0,d.$Qj)("zoom-out",60290),listFilter:(0,d.$Qj)("list-filter",60291),listFlat:(0,d.$Qj)("list-flat",60292),listSelection:(0,d.$Qj)("list-selection",60293),selection:(0,d.$Qj)("selection",60293),listTree:(0,d.$Qj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,d.$Qj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,d.$Qj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,d.$Qj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,d.$Qj)("debug-stackframe-active",60297),circleSmallFilled:(0,d.$Qj)("circle-small-filled",60298),debugStackframeDot:(0,d.$Qj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,d.$Qj)("terminal-decoration-mark",60298),debugStackframe:(0,d.$Qj)("debug-stackframe",60299),debugStackframeFocused:(0,d.$Qj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,d.$Qj)("debug-breakpoint-unsupported",60300),symbolString:(0,d.$Qj)("symbol-string",60301),debugReverseContinue:(0,d.$Qj)("debug-reverse-continue",60302),debugStepBack:(0,d.$Qj)("debug-step-back",60303),debugRestartFrame:(0,d.$Qj)("debug-restart-frame",60304),debugAlt:(0,d.$Qj)("debug-alt",60305),callIncoming:(0,d.$Qj)("call-incoming",60306),callOutgoing:(0,d.$Qj)("call-outgoing",60307),menu:(0,d.$Qj)("menu",60308),expandAll:(0,d.$Qj)("expand-all",60309),feedback:(0,d.$Qj)("feedback",60310),gitPullRequestReviewer:(0,d.$Qj)("git-pull-request-reviewer",60310),groupByRefType:(0,d.$Qj)("group-by-ref-type",60311),ungroupByRefType:(0,d.$Qj)("ungroup-by-ref-type",60312),account:(0,d.$Qj)("account",60313),gitPullRequestAssignee:(0,d.$Qj)("git-pull-request-assignee",60313),bellDot:(0,d.$Qj)("bell-dot",60314),debugConsole:(0,d.$Qj)("debug-console",60315),library:(0,d.$Qj)("library",60316),output:(0,d.$Qj)("output",60317),runAll:(0,d.$Qj)("run-all",60318),syncIgnored:(0,d.$Qj)("sync-ignored",60319),pinned:(0,d.$Qj)("pinned",60320),githubInverted:(0,d.$Qj)("github-inverted",60321),serverProcess:(0,d.$Qj)("server-process",60322),serverEnvironment:(0,d.$Qj)("server-environment",60323),pass:(0,d.$Qj)("pass",60324),issueClosed:(0,d.$Qj)("issue-closed",60324),stopCircle:(0,d.$Qj)("stop-circle",60325),playCircle:(0,d.$Qj)("play-circle",60326),record:(0,d.$Qj)("record",60327),debugAltSmall:(0,d.$Qj)("debug-alt-small",60328),vmConnect:(0,d.$Qj)("vm-connect",60329),cloud:(0,d.$Qj)("cloud",60330),merge:(0,d.$Qj)("merge",60331),export:(0,d.$Qj)("export",60332),graphLeft:(0,d.$Qj)("graph-left",60333),magnet:(0,d.$Qj)("magnet",60334),notebook:(0,d.$Qj)("notebook",60335),redo:(0,d.$Qj)("redo",60336),checkAll:(0,d.$Qj)("check-all",60337),pinnedDirty:(0,d.$Qj)("pinned-dirty",60338),passFilled:(0,d.$Qj)("pass-filled",60339),circleLargeFilled:(0,d.$Qj)("circle-large-filled",60340),circleLarge:(0,d.$Qj)("circle-large",60341),circleLargeOutline:(0,d.$Qj)("circle-large-outline",60341),combine:(0,d.$Qj)("combine",60342),gather:(0,d.$Qj)("gather",60342),table:(0,d.$Qj)("table",60343),variableGroup:(0,d.$Qj)("variable-group",60344),typeHierarchy:(0,d.$Qj)("type-hierarchy",60345),typeHierarchySub:(0,d.$Qj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,d.$Qj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,d.$Qj)("git-pull-request-create",60348),runAbove:(0,d.$Qj)("run-above",60349),runBelow:(0,d.$Qj)("run-below",60350),notebookTemplate:(0,d.$Qj)("notebook-template",60351),debugRerun:(0,d.$Qj)("debug-rerun",60352),workspaceTrusted:(0,d.$Qj)("workspace-trusted",60353),workspaceUntrusted:(0,d.$Qj)("workspace-untrusted",60354),workspaceUnknown:(0,d.$Qj)("workspace-unknown",60355),terminalCmd:(0,d.$Qj)("terminal-cmd",60356),terminalDebian:(0,d.$Qj)("terminal-debian",60357),terminalLinux:(0,d.$Qj)("terminal-linux",60358),terminalPowershell:(0,d.$Qj)("terminal-powershell",60359),terminalTmux:(0,d.$Qj)("terminal-tmux",60360),terminalUbuntu:(0,d.$Qj)("terminal-ubuntu",60361),terminalBash:(0,d.$Qj)("terminal-bash",60362),arrowSwap:(0,d.$Qj)("arrow-swap",60363),copy:(0,d.$Qj)("copy",60364),personAdd:(0,d.$Qj)("person-add",60365),filterFilled:(0,d.$Qj)("filter-filled",60366),wand:(0,d.$Qj)("wand",60367),debugLineByLine:(0,d.$Qj)("debug-line-by-line",60368),inspect:(0,d.$Qj)("inspect",60369),layers:(0,d.$Qj)("layers",60370),layersDot:(0,d.$Qj)("layers-dot",60371),layersActive:(0,d.$Qj)("layers-active",60372),compass:(0,d.$Qj)("compass",60373),compassDot:(0,d.$Qj)("compass-dot",60374),compassActive:(0,d.$Qj)("compass-active",60375),azure:(0,d.$Qj)("azure",60376),issueDraft:(0,d.$Qj)("issue-draft",60377),gitPullRequestClosed:(0,d.$Qj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,d.$Qj)("git-pull-request-draft",60379),debugAll:(0,d.$Qj)("debug-all",60380),debugCoverage:(0,d.$Qj)("debug-coverage",60381),runErrors:(0,d.$Qj)("run-errors",60382),folderLibrary:(0,d.$Qj)("folder-library",60383),debugContinueSmall:(0,d.$Qj)("debug-continue-small",60384),beakerStop:(0,d.$Qj)("beaker-stop",60385),graphLine:(0,d.$Qj)("graph-line",60386),graphScatter:(0,d.$Qj)("graph-scatter",60387),pieChart:(0,d.$Qj)("pie-chart",60388),bracket:(0,d.$Qj)("bracket",60175),bracketDot:(0,d.$Qj)("bracket-dot",60389),bracketError:(0,d.$Qj)("bracket-error",60390),lockSmall:(0,d.$Qj)("lock-small",60391),azureDevops:(0,d.$Qj)("azure-devops",60392),verifiedFilled:(0,d.$Qj)("verified-filled",60393),newline:(0,d.$Qj)("newline",60394),layout:(0,d.$Qj)("layout",60395),layoutActivitybarLeft:(0,d.$Qj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,d.$Qj)("layout-activitybar-right",60397),layoutPanelLeft:(0,d.$Qj)("layout-panel-left",60398),layoutPanelCenter:(0,d.$Qj)("layout-panel-center",60399),layoutPanelJustify:(0,d.$Qj)("layout-panel-justify",60400),layoutPanelRight:(0,d.$Qj)("layout-panel-right",60401),layoutPanel:(0,d.$Qj)("layout-panel",60402),layoutSidebarLeft:(0,d.$Qj)("layout-sidebar-left",60403),layoutSidebarRight:(0,d.$Qj)("layout-sidebar-right",60404),layoutStatusbar:(0,d.$Qj)("layout-statusbar",60405),layoutMenubar:(0,d.$Qj)("layout-menubar",60406),layoutCentered:(0,d.$Qj)("layout-centered",60407),target:(0,d.$Qj)("target",60408),indent:(0,d.$Qj)("indent",60409),recordSmall:(0,d.$Qj)("record-small",60410),errorSmall:(0,d.$Qj)("error-small",60411),terminalDecorationError:(0,d.$Qj)("terminal-decoration-error",60411),arrowCircleDown:(0,d.$Qj)("arrow-circle-down",60412),arrowCircleLeft:(0,d.$Qj)("arrow-circle-left",60413),arrowCircleRight:(0,d.$Qj)("arrow-circle-right",60414),arrowCircleUp:(0,d.$Qj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,d.$Qj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,d.$Qj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,d.$Qj)("layout-sidebar-left-off",60418),blank:(0,d.$Qj)("blank",60419),heartFilled:(0,d.$Qj)("heart-filled",60420),map:(0,d.$Qj)("map",60421),mapHorizontal:(0,d.$Qj)("map-horizontal",60421),foldHorizontal:(0,d.$Qj)("fold-horizontal",60421),mapFilled:(0,d.$Qj)("map-filled",60422),mapHorizontalFilled:(0,d.$Qj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,d.$Qj)("fold-horizontal-filled",60422),circleSmall:(0,d.$Qj)("circle-small",60423),bellSlash:(0,d.$Qj)("bell-slash",60424),bellSlashDot:(0,d.$Qj)("bell-slash-dot",60425),commentUnresolved:(0,d.$Qj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,d.$Qj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,d.$Qj)("git-pull-request-new-changes",60428),searchFuzzy:(0,d.$Qj)("search-fuzzy",60429),commentDraft:(0,d.$Qj)("comment-draft",60430),send:(0,d.$Qj)("send",60431),sparkle:(0,d.$Qj)("sparkle",60432),insert:(0,d.$Qj)("insert",60433),mic:(0,d.$Qj)("mic",60434),thumbsdownFilled:(0,d.$Qj)("thumbsdown-filled",60435),thumbsupFilled:(0,d.$Qj)("thumbsup-filled",60436),coffee:(0,d.$Qj)("coffee",60437),snake:(0,d.$Qj)("snake",60438),game:(0,d.$Qj)("game",60439),vr:(0,d.$Qj)("vr",60440),chip:(0,d.$Qj)("chip",60441),piano:(0,d.$Qj)("piano",60442),music:(0,d.$Qj)("music",60443),micFilled:(0,d.$Qj)("mic-filled",60444),repoFetch:(0,d.$Qj)("repo-fetch",60445),copilot:(0,d.$Qj)("copilot",60446),lightbulbSparkle:(0,d.$Qj)("lightbulb-sparkle",60447),robot:(0,d.$Qj)("robot",60448),sparkleFilled:(0,d.$Qj)("sparkle-filled",60449),diffSingle:(0,d.$Qj)("diff-single",60450),diffMultiple:(0,d.$Qj)("diff-multiple",60451),surroundWith:(0,d.$Qj)("surround-with",60452),share:(0,d.$Qj)("share",60453),gitStash:(0,d.$Qj)("git-stash",60454),gitStashApply:(0,d.$Qj)("git-stash-apply",60455),gitStashPop:(0,d.$Qj)("git-stash-pop",60456),vscode:(0,d.$Qj)("vscode",60457),vscodeInsiders:(0,d.$Qj)("vscode-insiders",60458),codeOss:(0,d.$Qj)("code-oss",60459),runCoverage:(0,d.$Qj)("run-coverage",60460),runAllCoverage:(0,d.$Qj)("run-all-coverage",60461),coverage:(0,d.$Qj)("coverage",60462),githubProject:(0,d.$Qj)("github-project",60463),mapVertical:(0,d.$Qj)("map-vertical",60464),foldVertical:(0,d.$Qj)("fold-vertical",60464),mapVerticalFilled:(0,d.$Qj)("map-vertical-filled",60465),foldVerticalFilled:(0,d.$Qj)("fold-vertical-filled",60465),goToSearch:(0,d.$Qj)("go-to-search",60466),percentage:(0,d.$Qj)("percentage",60467),sortPercentage:(0,d.$Qj)("sort-percentage",60467)}}),define(Se[79],De([1,0,99,175]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=void 0,e.$Tj=L;function L(){return Object.values(e.$Vj)}e.$Uj={dialogError:(0,d.$Qj)("dialog-error","error"),dialogWarning:(0,d.$Qj)("dialog-warning","warning"),dialogInfo:(0,d.$Qj)("dialog-info","info"),dialogClose:(0,d.$Qj)("dialog-close","close"),treeItemExpanded:(0,d.$Qj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,d.$Qj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,d.$Qj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,d.$Qj)("tree-filter-clear","close"),treeItemLoading:(0,d.$Qj)("tree-item-loading","loading"),menuSelection:(0,d.$Qj)("menu-selection","check"),menuSubmenu:(0,d.$Qj)("menu-submenu","chevron-right"),menuBarMore:(0,d.$Qj)("menubar-more","more"),scrollbarButtonLeft:(0,d.$Qj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,d.$Qj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,d.$Qj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,d.$Qj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,d.$Qj)("toolbar-more","more"),quickInputBack:(0,d.$Qj)("quick-input-back","arrow-left"),dropDownButton:(0,d.$Qj)("drop-down-button",60084),symbolCustomColor:(0,d.$Qj)("symbol-customcolor",60252),exportIcon:(0,d.$Qj)("export",60332),workspaceUnspecified:(0,d.$Qj)("workspace-unspecified",60355),newLine:(0,d.$Qj)("newline",60394),thumbsDownFilled:(0,d.$Qj)("thumbsdown-filled",60435),thumbsUpFilled:(0,d.$Qj)("thumbsup-filled",60436),gitFetch:(0,d.$Qj)("git-fetch",60445),lightbulbSparkleAutofix:(0,d.$Qj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,d.$Qj)("debug-breakpoint-pending",60377)},e.$Vj={...O.$Sj,...e.$Uj}}),define(Se[24],De([1,0,18]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=O,e.$4n=L,e.$5n=N,e.$6n=$,e.$7n=k,e.$8n=A,e.$9n=C,e.$0n=p,e.$$n=y,e.$_n=v,e.$ao=h,e.$bo=l;function O(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const n=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([i,u])=>{n[i]=u&&typeof u=="object"?O(u):u}),n}function L(o){if(!o||typeof o!="object")return o;const n=[o];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const u in i)if(R.call(i,u)){const s=i[u];typeof s=="object"&&!Object.isFrozen(s)&&!(0,d.$_f)(s)&&n.push(s)}}return o}const R=Object.prototype.hasOwnProperty;function N(o,n){return b(o,n,new Set)}function b(o,n,i){if((0,d.$fg)(o))return o;const u=n(o);if(typeof u<"u")return u;if(Array.isArray(o)){const s=[];for(const t of o)s.push(b(t,n,i));return s}if((0,d.$$f)(o)){if(i.has(o))throw new Error("Cannot clone recursive data-structure");i.add(o);const s={};for(const t in o)R.call(o,t)&&(s[t]=b(o[t],n,i));return i.delete(o),s}return o}function $(o,n,i=!0){return(0,d.$$f)(o)?((0,d.$$f)(n)&&Object.keys(n).forEach(u=>{u in o?i&&((0,d.$$f)(o[u])&&(0,d.$$f)(n[u])?$(o[u],n[u],i):o[u]=n[u]):o[u]=n[u]}),o):n}function k(o,n){if(o===n)return!0;if(o==null||n===null||n===void 0||typeof o!=typeof n||typeof o!="object"||Array.isArray(o)!==Array.isArray(n))return!1;let i,u;if(Array.isArray(o)){if(o.length!==n.length)return!1;for(i=0;i<o.length;i++)if(!k(o[i],n[i]))return!1}else{const s=[];for(u in o)s.push(u);s.sort();const t=[];for(u in n)t.push(u);if(t.sort(),!k(s,t))return!1;for(i=0;i<s.length;i++)if(!k(o[s[i]],n[s[i]]))return!1}return!0}function A(o){const n=new Set;return JSON.stringify(o,(i,u)=>{if((0,d.$$f)(u)||Array.isArray(u)){if(n.has(u))return"[Circular]";n.add(u)}return typeof u=="bigint"?`[BigInt ${u.toString()}]`:u})}function C(o,n){const i=Object.create(null);return!o||!n||Object.keys(n).forEach(s=>{const t=o[s],c=n[s];k(t,c)||(i[s]=c)}),i}function p(o,n){const i=n.toLowerCase(),u=Object.keys(o).find(s=>s.toLowerCase()===i);return u?o[u]:o[n]}function y(o,n){const i=Object.create(null);for(const[u,s]of Object.entries(o))n(u,s)&&(i[u]=s);return i}function v(o){let n=[];for(;Object.prototype!==o;)n=n.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return n}function h(o){const n=[];for(const i of v(o))typeof o[i]=="function"&&n.push(i);return n}function l(o,n){const i=s=>function(){const t=Array.prototype.slice.call(arguments,0);return n(s,t)},u={};for(const s of o)u[s]=i(s);return u}}),define(Se[50],De([1,0,79]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Wj=L;var O;(function(N){function b($){return $&&typeof $=="object"&&typeof $.id=="string"}N.isThemeColor=b})(O||(e.ThemeColor=O={}));function L(N){return{id:N}}var R;(function(N){N.iconNameSegment="[A-Za-z0-9]+",N.iconNameExpression="[A-Za-z0-9-]+",N.iconModifierExpression="~[A-Za-z]+",N.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${N.iconNameExpression})(${N.iconModifierExpression})?$`);function $(n){const i=b.exec(n.id);if(!i)return $(d.$Vj.error);const[,u,s]=i,t=["codicon","codicon-"+u];return s&&t.push("codicon-modifier-"+s.substring(1)),t}N.asClassNameArray=$;function k(n){return $(n).join(" ")}N.asClassName=k;function A(n){return"."+$(n).join(".")}N.asCSSSelector=A;function C(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||O.isThemeColor(n.color))}N.isThemeIcon=C;const p=new RegExp(`^\\$\\((${N.iconNameExpression}(?:${N.iconModifierExpression})?)\\)$`);function y(n){const i=p.exec(n);if(!i)return;const[,u]=i;return{id:u}}N.fromString=y;function v(n){return{id:n}}N.fromId=v;function h(n,i){let u=n.id;const s=u.lastIndexOf("~");return s!==-1&&(u=u.substring(0,s)),i&&(u=`${u}~${i}`),{id:u}}N.modify=h;function l(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}N.getModifier=l;function o(n,i){return n.id===i.id&&n.color?.id===i.color?.id}N.isEqual=o})(R||(e.ThemeIcon=R={}))}),define(Se[176],De([1,0,127,14,50]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=$,e.$Ok=A,e.$Pk=p,e.$Qk=y,e.$Rk=h,e.$Sk=l;const R="$(",N=new RegExp(`\\$\\(${L.ThemeIcon.iconNameExpression}(?:${L.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${N.source}`,"g");function $(o){return o.replace(b,(n,i)=>i?n:`\\${n}`)}const k=new RegExp(`\\\\${N.source}`,"g");function A(o){return o.replace(k,n=>`\\${n}`)}const C=new RegExp(`(\\s)?(\\\\)?${N.source}(\\s)?`,"g");function p(o){return o.indexOf(R)===-1?o:o.replace(C,(n,i,u,s)=>u?n:i||s||"")}function y(o){return o?o.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const v=new RegExp(`\\$\\(${L.ThemeIcon.iconNameCharacter}+\\)`,"g");function h(o){v.lastIndex=0;let n="";const i=[];let u=0;for(;;){const s=v.lastIndex,t=v.exec(o),c=o.substring(s,t?.index);if(c.length>0){n+=c;for(let r=0;r<c.length;r++)i.push(u)}if(!t)break;u+=t[0].length}return{text:n,iconOffsets:i}}function l(o,n,i=!1){const{text:u,iconOffsets:s}=n;if(!s||s.length===0)return(0,d.$Ek)(o,u,i);const t=(0,O.$ef)(u," "),c=u.length-t.length,r=(0,d.$Ek)(o,t,i);if(r)for(const a of r){const f=s[a.start+c]+c;a.start+=f,a.end+=f}return r}}),define(Se[128],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$5e=O,e.$6e=L;var d;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(d||(e.Constants=d={}));function O(R){return R<0?0:R>255?255:R|0}function L(R){return R<0?0:R>4294967295?4294967295:R|0}}),define(Se[30],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=O;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(L){return d.test(L)}e.$Sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(b){for(let $=0;$<b.length;$++)b[$]=Math.floor(Math.random()*256);return b};const R=new Uint8Array(16),N=[];for(let b=0;b<256;b++)N.push(b.toString(16).padStart(2,"0"));return function(){L(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let $=0,k="";return k+=N[R[$++]],k+=N[R[$++]],k+=N[R[$++]],k+=N[R[$++]],k+="-",k+=N[R[$++]],k+=N[R[$++]],k+="-",k+=N[R[$++]],k+=N[R[$++]],k+="-",k+=N[R[$++]],k+=N[R[$++]],k+="-",k+=N[R[$++]],k+=N[R[$++]],k+=N[R[$++]],k+=N[R[$++]],k+=N[R[$++]],k+=N[R[$++]],k}}()}),define(Se[177],De([1,0,19,39,30]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.$St=void 0,e.$Qt=R,e.$Rt=N,e.$Tt=k;function R(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}function N(C,p,y){const v={id:(0,L.$Sg)(),name:C,uri:p,data:y};return{asString:async()=>"",asFile:()=>v,value:void 0}}class b{constructor(){this.a=new Map}get size(){let p=0;for(const y of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const y=[...this.a.keys()];return O.Iterable.some(this,([v,h])=>h.asFile())&&y.push("files"),A($(p),y)}get(p){return this.a.get(this.b(p))?.[0]}append(p,y){const v=this.a.get(p);v?v.push(y):this.a.set(this.b(p),[y])}replace(p,y){this.a.set(this.b(p),[y])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,y]of this.a)for(const v of y)yield[p,v]}b(p){return $(p)}}e.$St=b;function $(C){return C.toLowerCase()}function k(C,p){return A($(C),p.map($))}function A(C,p){if(C==="*/*")return p.length>0;if(p.includes(C))return!0;const y=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[v,h,l]=y;return l==="*"?p.some(o=>o.startsWith(h+"/")):!1}e.$Ut=Object.freeze({create:C=>(0,d.$Mb)(C.map(p=>p.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$Ut.split(C).filter(p=>!p.startsWith("#"))})}),define(Se[178],De([1,0,63]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=void 0,e.$Ug=O,e.$Wg=R;function O(b,$,k,A=1){let C=!1;return new Promise(p=>{const y=setTimeout(()=>{if(!C)return C=!0,p(0)},k);L(b,$,A,v=>{if(!C)return C=!0,clearTimeout(y),p(v)})})}function L(b,$,k,A){if($===0)return A(0);const C=new d.Socket;C.once("connect",()=>(N(C),L(b+k,$-1,k,A))),C.once("data",()=>{}),C.once("error",p=>(N(C),p.code!=="ECONNREFUSED"?L(b+k,$-1,k,A):A(b))),C.connect(b,"127.0.0.1")}e.$Vg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(b,$,k,A="127.0.0.1"){let C=!1,p,y=1;const v=d.createServer({pauseOnConnect:!0});function h(l,o){C||(C=!0,v.removeAllListeners(),v.close(),p&&clearTimeout(p),o(l))}return new Promise(l=>{p=setTimeout(()=>{h(0,l)},k),v.on("listening",()=>{h(b,l)}),v.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&y<$?(b++,y++,v.listen(b,A)):h(0,l)}),v.on("close",()=>{h(0,l)}),v.listen(b,A)})}function N(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch($){console.error($)}}}),define(Se[129],De([1,0,128]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=e.$It=void 0;class O{constructor(b){const $=(0,d.$5e)(b);this.c=$,this.a=O.d($),this.b=new Map}static d(b){const $=new Uint8Array(256);return $.fill(b),$}set(b,$){const k=(0,d.$5e)($);b>=0&&b<256?this.a[b]=k:this.b.set(b,k)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$It=O;var L;(function(N){N[N.False=0]="False",N[N.True=1]="True"})(L||(L={}));class R{constructor(){this.a=new O(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$Jt=R}),define(Se[179],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$1t=O;var d;(function(L){L[L.Unknown=0]="Unknown",L[L.Invalid=3]="Invalid",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(d||(e.StringEOL=d={}));function O(L){let R=0,N=0,b=0,$=0;for(let k=0,A=L.length;k<A;k++){const C=L.charCodeAt(k);C===13?(R===0&&(N=k),R++,k+1<A&&L.charCodeAt(k+1)===10?($|=2,k++):$|=3,b=k+1):C===10&&($|=1,R===0&&(N=k),R++,b=k+1)}return R===0&&(N=L.length),[R,N,L.length-b,$]}}),define(Se[51],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=void 0;class d{constructor(L,R){this.lineNumber=L,this.column=R}with(L=this.lineNumber,R=this.column){return L===this.lineNumber&&R===this.column?this:new d(L,R)}delta(L=0,R=0){return this.with(this.lineNumber+L,this.column+R)}equals(L){return d.equals(this,L)}static equals(L,R){return!L&&!R?!0:!!L&&!!R&&L.lineNumber===R.lineNumber&&L.column===R.column}isBefore(L){return d.isBefore(this,L)}static isBefore(L,R){return L.lineNumber<R.lineNumber?!0:R.lineNumber<L.lineNumber?!1:L.column<R.column}isBeforeOrEqual(L){return d.isBeforeOrEqual(this,L)}static isBeforeOrEqual(L,R){return L.lineNumber<R.lineNumber?!0:R.lineNumber<L.lineNumber?!1:L.column<=R.column}static compare(L,R){const N=L.lineNumber|0,b=R.lineNumber|0;if(N===b){const $=L.column|0,k=R.column|0;return $-k}return N-b}clone(){return new d(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(L){return new d(L.lineNumber,L.column)}static isIPosition(L){return L&&typeof L.lineNumber=="number"&&typeof L.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$tt=d}),define(Se[29],De([1,0,51]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=void 0;class O{constructor(R,N,b,$){R>b||R===b&&N>$?(this.startLineNumber=b,this.startColumn=$,this.endLineNumber=R,this.endColumn=N):(this.startLineNumber=R,this.startColumn=N,this.endLineNumber=b,this.endColumn=$)}isEmpty(){return O.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return O.containsPosition(this,R)}static containsPosition(R,N){return!(N.lineNumber<R.startLineNumber||N.lineNumber>R.endLineNumber||N.lineNumber===R.startLineNumber&&N.column<R.startColumn||N.lineNumber===R.endLineNumber&&N.column>R.endColumn)}static strictContainsPosition(R,N){return!(N.lineNumber<R.startLineNumber||N.lineNumber>R.endLineNumber||N.lineNumber===R.startLineNumber&&N.column<=R.startColumn||N.lineNumber===R.endLineNumber&&N.column>=R.endColumn)}containsRange(R){return O.containsRange(this,R)}static containsRange(R,N){return!(N.startLineNumber<R.startLineNumber||N.endLineNumber<R.startLineNumber||N.startLineNumber>R.endLineNumber||N.endLineNumber>R.endLineNumber||N.startLineNumber===R.startLineNumber&&N.startColumn<R.startColumn||N.endLineNumber===R.endLineNumber&&N.endColumn>R.endColumn)}strictContainsRange(R){return O.strictContainsRange(this,R)}static strictContainsRange(R,N){return!(N.startLineNumber<R.startLineNumber||N.endLineNumber<R.startLineNumber||N.startLineNumber>R.endLineNumber||N.endLineNumber>R.endLineNumber||N.startLineNumber===R.startLineNumber&&N.startColumn<=R.startColumn||N.endLineNumber===R.endLineNumber&&N.endColumn>=R.endColumn)}plusRange(R){return O.plusRange(this,R)}static plusRange(R,N){let b,$,k,A;return N.startLineNumber<R.startLineNumber?(b=N.startLineNumber,$=N.startColumn):N.startLineNumber===R.startLineNumber?(b=N.startLineNumber,$=Math.min(N.startColumn,R.startColumn)):(b=R.startLineNumber,$=R.startColumn),N.endLineNumber>R.endLineNumber?(k=N.endLineNumber,A=N.endColumn):N.endLineNumber===R.endLineNumber?(k=N.endLineNumber,A=Math.max(N.endColumn,R.endColumn)):(k=R.endLineNumber,A=R.endColumn),new O(b,$,k,A)}intersectRanges(R){return O.intersectRanges(this,R)}static intersectRanges(R,N){let b=R.startLineNumber,$=R.startColumn,k=R.endLineNumber,A=R.endColumn;const C=N.startLineNumber,p=N.startColumn,y=N.endLineNumber,v=N.endColumn;return b<C?(b=C,$=p):b===C&&($=Math.max($,p)),k>y?(k=y,A=v):k===y&&(A=Math.min(A,v)),b>k||b===k&&$>A?null:new O(b,$,k,A)}equalsRange(R){return O.equalsRange(this,R)}static equalsRange(R,N){return!R&&!N?!0:!!R&&!!N&&R.startLineNumber===N.startLineNumber&&R.startColumn===N.startColumn&&R.endLineNumber===N.endLineNumber&&R.endColumn===N.endColumn}getEndPosition(){return O.getEndPosition(this)}static getEndPosition(R){return new d.$tt(R.endLineNumber,R.endColumn)}getStartPosition(){return O.getStartPosition(this)}static getStartPosition(R){return new d.$tt(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,N){return new O(this.startLineNumber,this.startColumn,R,N)}setStartPosition(R,N){return new O(R,N,this.endLineNumber,this.endColumn)}collapseToStart(){return O.collapseToStart(this)}static collapseToStart(R){return new O(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return O.collapseToEnd(this)}static collapseToEnd(R){return new O(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new O(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,N=R){return new O(R.lineNumber,R.column,N.lineNumber,N.column)}static lift(R){return R?new O(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,N){return!(R.endLineNumber<N.startLineNumber||R.endLineNumber===N.startLineNumber&&R.endColumn<N.startColumn||N.endLineNumber<R.startLineNumber||N.endLineNumber===R.startLineNumber&&N.endColumn<R.startColumn)}static areIntersecting(R,N){return!(R.endLineNumber<N.startLineNumber||R.endLineNumber===N.startLineNumber&&R.endColumn<=N.startColumn||N.endLineNumber<R.startLineNumber||N.endLineNumber===R.startLineNumber&&N.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,N){if(R&&N){const k=R.startLineNumber|0,A=N.startLineNumber|0;if(k===A){const C=R.startColumn|0,p=N.startColumn|0;if(C===p){const y=R.endLineNumber|0,v=N.endLineNumber|0;if(y===v){const h=R.endColumn|0,l=N.endColumn|0;return h-l}return y-v}return C-p}return k-A}return(R?1:0)-(N?1:0)}static compareRangesUsingEnds(R,N){return R.endLineNumber===N.endLineNumber?R.endColumn===N.endColumn?R.startLineNumber===N.startLineNumber?R.startColumn-N.startColumn:R.startLineNumber-N.startLineNumber:R.endColumn-N.endColumn:R.endLineNumber-N.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$ut=O}),define(Se[180],De([1,0,29]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0;class O{static insert(R,N){return{range:new d.$ut(R.lineNumber,R.column,R.lineNumber,R.column),text:N,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,N){return{range:R,text:N}}static replaceMove(R,N){return{range:R,text:N,forceMoveMarkers:!0}}}e.$vt=O}),define(Se[181],De([1,0,51,29]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.SelectionDirection=void 0;var L;(function(N){N[N.LTR=0]="LTR",N[N.RTL=1]="RTL"})(L||(e.SelectionDirection=L={}));class R extends O.$ut{constructor(b,$,k,A){super(b,$,k,A),this.selectionStartLineNumber=b,this.selectionStartColumn=$,this.positionLineNumber=k,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return R.selectionsEqual(this,b)}static selectionsEqual(b,$){return b.selectionStartLineNumber===$.selectionStartLineNumber&&b.selectionStartColumn===$.selectionStartColumn&&b.positionLineNumber===$.positionLineNumber&&b.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,$){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,b,$):new R(b,$,this.startLineNumber,this.startColumn)}getPosition(){return new d.$tt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new d.$tt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,$){return this.getDirection()===0?new R(b,$,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,b,$)}static fromPositions(b,$=b){return new R(b.lineNumber,b.column,$.lineNumber,$.column)}static fromRange(b,$){return $===0?new R(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new R(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new R(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,$){if(b&&!$||!b&&$)return!1;if(!b&&!$)return!0;if(b.length!==$.length)return!1;for(let k=0,A=b.length;k<A;k++)if(!this.selectionsEqual(b[k],$[k]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,$,k,A,C){return C===0?new R(b,$,k,A):new R(k,A,b,$)}}e.$wt=R}),define(Se[182],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=void 0,e.$4s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[183],De([1,0,27,129]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=e.WordCharacterClass=void 0,e.$Lt=b;var L;(function($){$[$.Regular=0]="Regular",$[$.Whitespace=1]="Whitespace",$[$.WordSeparator=2]="WordSeparator"})(L||(e.WordCharacterClass=L={}));class R extends O.$It{constructor(k,A){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=A,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let C=0,p=k.length;C<p;C++)this.set(k.charCodeAt(C),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(k,A){let C=null;for(const p of this.h(k)){if(p.index>A)break;C=p}return C}findNextIntlWordAtOrAfterOffset(k,A){for(const C of this.h(k))if(!(C.index<A))return C;return null}h(k){return this.e?this.f===k?this.g:(this.f=k,this.g=this.j(this.e.segment(k)),this.g):[]}j(k){const A=[];for(const C of k)this.k(C)&&A.push(C);return A}k(k){return!!k.isWordLike}}e.$Kt=R;const N=new d.$Dc(10);function b($,k){const A=`${$}/${k.join(",")}`;let C=N.get(A);return C||(C=new R($,k),N.set(A,C)),C}}),define(Se[130],De([1,0,39,3,76]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=e.$5s=void 0,e.$7s=N,e.$8s=$,e.$9s=k,e.$5s="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(C=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$5s)C.indexOf(y)>=0||(p+="\\"+y);return p+="\\s]+)",new RegExp(p,"g")}e.$6s=R();function N(C){let p=e.$6s;if(C&&C instanceof RegExp)if(C.global)p=C;else{let y="g";C.ignoreCase&&(y+="i"),C.multiline&&(y+="m"),C.unicode&&(y+="u"),p=new RegExp(C.source,y)}return p.lastIndex=0,p}const b=new L.$5c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(C){const p=b.unshift(C);return(0,O.$Sc)(p)}function k(C,p,y,v,h){if(p=N(p),h||(h=d.Iterable.first(b)),y.length>h.maxLen){let u=C-h.maxLen/2;return u<0?u=0:v+=u,y=y.substring(u,C+h.maxLen/2),k(C,p,y,v,h)}const l=Date.now(),o=C-1-v;let n=-1,i=null;for(let u=1;!(Date.now()-l>=h.timeBudget);u++){const s=o-h.windowSize*u;p.lastIndex=Math.max(0,s);const t=A(p,y,o,n);if(!t&&i||(i=t,s<=0))break;n=s}if(i){const u={word:i[0],startColumn:v+1+i.index,endColumn:v+1+i.index+i[0].length};return p.lastIndex=0,u}return null}function A(C,p,y,v){let h;for(;h=C.exec(p);){const l=h.index||0;if(l<=y&&C.lastIndex>=y)return h;if(v>0&&l>v)return null}return null}}),define(Se[184],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=e.$ku=e.IndentAction=void 0;var d;(function(N){N[N.None=0]="None",N[N.Indent=1]="Indent",N[N.IndentOutdent=2]="IndentOutdent",N[N.Outdent=3]="Outdent"})(d||(e.IndentAction=d={}));class O{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let $=0,k=b.notIn.length;$<k;$++)switch(b.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,$){if(b.getTokenCount()===0)return!0;const k=b.findTokenIndexAtOffset($-2),A=b.getStandardTokenType(k);return this.isOK(A)}g(b,$){for(let k=b;k<=$;k++){const A=String.fromCharCode(k);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$ku=O;class L{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of b)R(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),R(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),R(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),R(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&R(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$lu=L;function R(N,b,$){N.has(b)?N.get(b).push($):N.set(b,[$])}}),define(Se[185],De([1,0,129]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x3=e.$w3=e.State=void 0,e.$y3=p;var O;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(O||(e.State=O={}));class L{constructor(v,h,l){const o=new Uint8Array(v*h);for(let n=0,i=v*h;n<i;n++)o[n]=l;this.a=o,this.rows=v,this.cols=h}get(v,h){return this.a[v*this.cols+h]}set(v,h,l){this.a[v*this.cols+h]=l}}class R{constructor(v){let h=0,l=0;for(let n=0,i=v.length;n<i;n++){const[u,s,t]=v[n];s>h&&(h=s),u>l&&(l=u),t>l&&(l=t)}h++,l++;const o=new L(l,h,0);for(let n=0,i=v.length;n<i;n++){const[u,s,t]=v[n];o.set(u,s,t)}this.a=o,this.b=h}nextState(v,h){return h<0||h>=this.b?0:this.a.get(v,h)}}e.$w3=R;let N=null;function b(){return N===null&&(N=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),N}var $;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})($||($={}));let k=null;function A(){if(k===null){k=new d.$It(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<y.length;h++)k.set(y.charCodeAt(h),1);const v=".,;:";for(let h=0;h<v.length;h++)k.set(v.charCodeAt(h),2)}return k}class C{static a(v,h,l,o,n){let i=n-1;do{const u=h.charCodeAt(i);if(v.get(u)!==2)break;i--}while(i>o);if(o>0){const u=h.charCodeAt(o-1),s=h.charCodeAt(i);(u===40&&s===41||u===91&&s===93||u===123&&s===125)&&i--}return{range:{startLineNumber:l,startColumn:o+1,endLineNumber:l,endColumn:i+2},url:h.substring(o,i+1)}}static computeLinks(v,h=b()){const l=A(),o=[];for(let n=1,i=v.getLineCount();n<=i;n++){const u=v.getLineContent(n),s=u.length;let t=0,c=0,r=0,a=1,f=!1,g=!1,w=!1,S=!1;for(;t<s;){let m=!1;const E=u.charCodeAt(t);if(a===13){let D;switch(E){case 40:f=!0,D=0;break;case 41:D=f?0:1;break;case 91:w=!0,g=!0,D=0;break;case 93:w=!1,D=g?0:1;break;case 123:S=!0,D=0;break;case 125:D=S?0:1;break;case 39:case 34:case 96:r===E?D=1:r===39||r===34||r===96?D=0:D=1;break;case 42:D=r===42?1:0;break;case 124:D=r===124?1:0;break;case 32:D=w?0:1;break;default:D=l.get(E)}D===1&&(o.push(C.a(l,u,n,c,t)),m=!0)}else if(a===12){let D;E===91?(g=!0,D=0):D=l.get(E),D===1?m=!0:a=13}else a=h.nextState(a,E),a===0&&(m=!0);m&&(a=1,f=!1,g=!1,S=!1,c=t+1,r=E),t++}a===13&&o.push(C.a(l,u,n,c,s))}return o}}e.$x3=C;function p(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:C.computeLinks(y)}}),define(Se[80],De([1,0,24]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jv=e.$Iv=e.$Hv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$Fv=e.$Ev=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$Gv=v,e.$Kv=u;var O;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(O||(e.OverviewRulerLane=O={}));var L;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(L||(e.GlyphMarginLane=L={}));var R;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var N;(function(s){s[s.Normal=1]="Normal",s[s.Underlined=2]="Underlined"})(N||(e.MinimapSectionHeaderStyle=N={}));var b;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(b||(e.InjectedTextCursorStops=b={}));var $;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var k;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(k||(e.DefaultEndOfLine=k={}));var A;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(A||(e.EndOfLineSequence=A={}));class C{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,d.$7n)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$Ev=C;class p{constructor(t,c){this._findMatchBrand=void 0,this.range=t,this.matches=c}}e.$Fv=p;var y;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(y||(e.TrackedRangeStickiness=y={}));function v(s){return s&&typeof s.read=="function"}var h;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(h||(e.PositionAffinity=h={}));var l;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(l||(e.ModelConstants=l={}));class o{constructor(t,c,r,a,f,g){this.identifier=t,this.range=c,this.text=r,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=f,this._isTracked=g}}e.$Hv=o;class n{constructor(t,c,r){this.regex=t,this.wordSeparators=c,this.simpleSearch=r}}e.$Iv=n;class i{constructor(t,c,r){this.reverseEdits=t,this.changes=c,this.trimAutoWhitespaceLineNumbers=r}}e.$Jv=i;function u(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}}),define(Se[186],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GC=e.NodeColor=e.$FC=void 0,e.$HC=L,e.$IC=R,e.$JC=k,e.$KC=A,e.$LC=C,e.$MC=p,e.$NC=y,e.$OC=v;class d{constructor(l,o){this.piece=l,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$GC)return L(this.right);let l=this;for(;l.parent!==e.$GC&&l.parent.left!==l;)l=l.parent;return l.parent===e.$GC?e.$GC:l.parent}prev(){if(this.left!==e.$GC)return R(this.left);let l=this;for(;l.parent!==e.$GC&&l.parent.right!==l;)l=l.parent;return l.parent===e.$GC?e.$GC:l.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$FC=d;var O;(function(h){h[h.Black=0]="Black",h[h.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$GC=new d(null,0),e.$GC.parent=e.$GC,e.$GC.left=e.$GC,e.$GC.right=e.$GC,e.$GC.color=0;function L(h){for(;h.left!==e.$GC;)h=h.left;return h}function R(h){for(;h.right!==e.$GC;)h=h.right;return h}function N(h){return h===e.$GC?0:h.size_left+h.piece.length+N(h.right)}function b(h){return h===e.$GC?0:h.lf_left+h.piece.lineFeedCnt+b(h.right)}function $(){e.$GC.parent=e.$GC}function k(h,l){const o=l.right;o.size_left+=l.size_left+(l.piece?l.piece.length:0),o.lf_left+=l.lf_left+(l.piece?l.piece.lineFeedCnt:0),l.right=o.left,o.left!==e.$GC&&(o.left.parent=l),o.parent=l.parent,l.parent===e.$GC?h.root=o:l.parent.left===l?l.parent.left=o:l.parent.right=o,o.left=l,l.parent=o}function A(h,l){const o=l.left;l.left=o.right,o.right!==e.$GC&&(o.right.parent=l),o.parent=l.parent,l.size_left-=o.size_left+(o.piece?o.piece.length:0),l.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),l.parent===e.$GC?h.root=o:l===l.parent.right?l.parent.right=o:l.parent.left=o,o.right=l,l.parent=o}function C(h,l){let o,n;if(l.left===e.$GC?(n=l,o=n.right):l.right===e.$GC?(n=l,o=n.left):(n=L(l.right),o=n.right),n===h.root){h.root=o,o.color=0,l.detach(),$(),h.root.parent=e.$GC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=o:n.parent.right=o,n===l?(o.parent=n.parent,v(h,o)):(n.parent===l?o.parent=n:o.parent=n.parent,v(h,o),n.left=l.left,n.right=l.right,n.parent=l.parent,n.color=l.color,l===h.root?h.root=n:l===l.parent.left?l.parent.left=n:l.parent.right=n,n.left!==e.$GC&&(n.left.parent=n),n.right!==e.$GC&&(n.right.parent=n),n.size_left=l.size_left,n.lf_left=l.lf_left,v(h,n)),l.detach(),o.parent.left===o){const s=N(o),t=b(o);if(s!==o.parent.size_left||t!==o.parent.lf_left){const c=s-o.parent.size_left,r=t-o.parent.lf_left;o.parent.size_left=s,o.parent.lf_left=t,y(h,o.parent,c,r)}}if(v(h,o.parent),i){$();return}let u;for(;o!==h.root&&o.color===0;)o===o.parent.left?(u=o.parent.right,u.color===1&&(u.color=0,o.parent.color=1,k(h,o.parent),u=o.parent.right),u.left.color===0&&u.right.color===0?(u.color=1,o=o.parent):(u.right.color===0&&(u.left.color=0,u.color=1,A(h,u),u=o.parent.right),u.color=o.parent.color,o.parent.color=0,u.right.color=0,k(h,o.parent),o=h.root)):(u=o.parent.left,u.color===1&&(u.color=0,o.parent.color=1,A(h,o.parent),u=o.parent.left),u.left.color===0&&u.right.color===0?(u.color=1,o=o.parent):(u.left.color===0&&(u.right.color=0,u.color=1,k(h,u),u=o.parent.left),u.color=o.parent.color,o.parent.color=0,u.left.color=0,A(h,o.parent),o=h.root));o.color=0,$()}function p(h,l){for(v(h,l);l!==h.root&&l.parent.color===1;)if(l.parent===l.parent.parent.left){const o=l.parent.parent.right;o.color===1?(l.parent.color=0,o.color=0,l.parent.parent.color=1,l=l.parent.parent):(l===l.parent.right&&(l=l.parent,k(h,l)),l.parent.color=0,l.parent.parent.color=1,A(h,l.parent.parent))}else{const o=l.parent.parent.left;o.color===1?(l.parent.color=0,o.color=0,l.parent.parent.color=1,l=l.parent.parent):(l===l.parent.left&&(l=l.parent,A(h,l)),l.parent.color=0,l.parent.parent.color=1,k(h,l.parent.parent))}h.root.color=0}function y(h,l,o,n){for(;l!==h.root&&l!==e.$GC;)l.parent.left===l&&(l.parent.size_left+=o,l.parent.lf_left+=n),l=l.parent}function v(h,l){let o=0,n=0;if(l!==h.root){for(;l!==h.root&&l===l.parent.right;)l=l.parent;if(l!==h.root)for(l=l.parent,o=N(l.left)-l.size_left,n=b(l.left)-l.lf_left,l.size_left+=o,l.lf_left+=n;l!==h.root&&(o!==0||n!==0);)l.parent.left===l&&(l.parent.size_left+=o,l.parent.lf_left+=n),l=l.parent}}}),define(Se[187],De([1,0,19,128]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5v=e.$4v=e.$3v=void 0;class L{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,k){$=(0,O.$6e)($);const A=this.a,C=this.b,p=k.length;return p===0?!1:(this.a=new Uint32Array(A.length+p),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($),$+p),this.a.set(k,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue($,k){return $=(0,O.$6e)($),k=(0,O.$6e)(k),this.a[$]===k?!1:(this.a[$]=k,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,k){$=(0,O.$6e)($),k=(0,O.$6e)(k);const A=this.a,C=this.b;if($>=A.length)return!1;const p=A.length-$;return k>=p&&(k=p),k===0?!1:(this.a=new Uint32Array(A.length-k),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($+k),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,O.$6e)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let k=this.c[0]+1;k===0&&(this.b[0]=this.a[0],k++),$>=this.a.length&&($=this.a.length-1);for(let A=k;A<=$;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let k=0,A=this.a.length-1,C=0,p=0,y=0;for(;k<=A;)if(C=k+(A-k)/2|0,p=this.b[C],y=p-this.a[C],$<y)A=C-1;else if($>=p)k=C+1;else break;return new N(C,$-y)}}e.$3v=L;class R{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const k=this.e[$],A=k>0?this.d[k-1]:0;return new N(k,$-A)}removeValues($,k){this.a.splice($,k),this.f($)}insertValues($,k){this.a=(0,d.$Vb)(this.a,$,k),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,k=this.a.length;$<k;$++){const A=this.a[$],C=$>0?this.d[$-1]:0;this.d[$]=C+A;for(let p=0;p<A;p++)this.e[C+p]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,k){this.a[$]!==k&&(this.a[$]=k,this.f($))}}e.$4v=R;class N{constructor($,k){this.index=$,this.remainder=k,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=k}}e.$5v=N}),define(Se[188],De([1,0,14,51,187]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6v=void 0;class R{constructor(b,$,k,A){this.d=b,this.f=$,this.g=k,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const $=b.changes;for(const k of $)this.o(k.range),this.p(new O.$tt(k.range.startLineNumber,k.range.startColumn),k.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,$=this.f.length,k=new Uint32Array($);for(let A=0;A<$;A++)k[A]=this.f[A].length+b;this.j=new L.$3v(k)}}n(b,$){this.f[b]=$,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,$){if($.length===0)return;const k=(0,d.$kf)($);if(k.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+k[0]+this.f[b.lineNumber-1].substring(b.column-1));return}k[k.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+k[0]);const A=new Uint32Array(k.length-1);for(let C=1;C<k.length;C++)this.f.splice(b.lineNumber+C-1,0,k[C]),A[C-1]=k[C].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,A)}}e.$6v=R}),define(Se[100],De([1,0,14,183,51,29,80]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=e.$SC=e.$PC=void 0,e.$QC=k,e.$RC=A,e.$TC=h;const b=999;class ${constructor(n,i,u,s){this.searchString=n,this.isRegex=i,this.matchCase=u,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=k(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=d.$if(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let u=!this.isRegex&&!n;return u&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(u=this.matchCase),new N.$Iv(i,this.wordSeparators?(0,O.$Lt)(this.wordSeparators,[]):null,u?this.searchString:null)}}e.$PC=$;function k(o){if(!o||o.length===0)return!1;for(let n=0,i=o.length;n<i;n++){const u=o.charCodeAt(n);if(u===10)return!0;if(u===92){if(n++,n>=i)break;const s=o.charCodeAt(n);if(s===110||s===114||s===87)return!0}}return!1}function A(o,n,i){if(!i)return new N.$Fv(o,null);const u=[];for(let s=0,t=n.length;s<t;s++)u[s]=n[s];return new N.$Fv(o,u)}class C{constructor(n){const i=[];let u=0;for(let s=0,t=n.length;s<t;s++)n.charCodeAt(s)===10&&(i[u++]=s);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let u=0,s=i.length-1;if(s===-1||n<=i[0])return 0;for(;u<s;){const t=u+((s-u)/2>>0);i[t]>=n?s=t-1:i[t+1]>=n?(u=t,s=t):u=t+1}return u+1}}class p{static findMatches(n,i,u,s,t){const c=i.parseSearchRequest();return c?c.regex.multiline?this.b(n,u,new l(c.wordSeparators,c.regex),s,t):this.c(n,u,c,s,t):[]}static a(n,i,u,s,t,c){let r,a=0;s?(a=s.findLineFeedCountBeforeOffset(t),r=i+t+a):r=i+t;let f;if(s){const m=s.findLineFeedCountBeforeOffset(t+c.length)-a;f=r+c.length+m}else f=r+c.length;const g=n.getPositionAt(r),w=n.getPositionAt(f);return new R.$ut(g.lineNumber,g.column,w.lineNumber,w.column)}static b(n,i,u,s,t){const c=n.getOffsetAt(i.getStartPosition()),r=n.getValueInRange(i,1),a=n.getEOL()===`\r
`?new C(r):null,f=[];let g=0,w;for(u.reset(0);w=u.next(r);)if(f[g++]=A(this.a(n,c,r,a,w.index,w[0]),w,s),g>=t)return f;return f}static c(n,i,u,s,t){const c=[];let r=0;if(i.startLineNumber===i.endLineNumber){const f=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return r=this.d(u,f,i.startLineNumber,i.startColumn-1,r,c,s,t),c}const a=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);r=this.d(u,a,i.startLineNumber,i.startColumn-1,r,c,s,t);for(let f=i.startLineNumber+1;f<i.endLineNumber&&r<t;f++)r=this.d(u,n.getLineContent(f),f,0,r,c,s,t);if(r<t){const f=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);r=this.d(u,f,i.endLineNumber,0,r,c,s,t)}return c}static d(n,i,u,s,t,c,r,a){const f=n.wordSeparators;if(!r&&n.simpleSearch){const S=n.simpleSearch,m=S.length,E=i.length;let D=-m;for(;(D=i.indexOf(S,D+m))!==-1;)if((!f||h(f,i,E,D,m))&&(c[t++]=new N.$Fv(new R.$ut(u,D+1+s,u,D+1+m+s),null),t>=a))return t;return t}const g=new l(n.wordSeparators,n.regex);let w;g.reset(0);do if(w=g.next(i),w&&(c[t++]=A(new R.$ut(u,w.index+1+s,u,w.index+1+w[0].length+s),w,r),t>=a))return t;while(w);return t}static findNextMatch(n,i,u,s){const t=i.parseSearchRequest();if(!t)return null;const c=new l(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,u,c,s):this.f(n,u,c,s)}static e(n,i,u,s){const t=new L.$tt(i.lineNumber,1),c=n.getOffsetAt(t),r=n.getLineCount(),a=n.getValueInRange(new R.$ut(t.lineNumber,t.column,r,n.getLineMaxColumn(r)),1),f=n.getEOL()===`\r
`?new C(a):null;u.reset(i.column-1);const g=u.next(a);return g?A(this.a(n,c,a,f,g.index,g[0]),g,s):i.lineNumber!==1||i.column!==1?this.e(n,new L.$tt(1,1),u,s):null}static f(n,i,u,s){const t=n.getLineCount(),c=i.lineNumber,r=n.getLineContent(c),a=this.g(u,r,c,i.column,s);if(a)return a;for(let f=1;f<=t;f++){const g=(c+f-1)%t,w=n.getLineContent(g+1),S=this.g(u,w,g+1,1,s);if(S)return S}return null}static g(n,i,u,s,t){n.reset(s-1);const c=n.next(i);return c?A(new R.$ut(u,c.index+1,u,c.index+1+c[0].length),c,t):null}static findPreviousMatch(n,i,u,s){const t=i.parseSearchRequest();if(!t)return null;const c=new l(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,u,c,s):this.j(n,u,c,s)}static h(n,i,u,s){const t=this.b(n,new R.$ut(1,1,i.lineNumber,i.column),u,s,10*b);if(t.length>0)return t[t.length-1];const c=n.getLineCount();return i.lineNumber!==c||i.column!==n.getLineMaxColumn(c)?this.h(n,new L.$tt(c,n.getLineMaxColumn(c)),u,s):null}static j(n,i,u,s){const t=n.getLineCount(),c=i.lineNumber,r=n.getLineContent(c).substring(0,i.column-1),a=this.k(u,r,c,s);if(a)return a;for(let f=1;f<=t;f++){const g=(t+c-f-1)%t,w=n.getLineContent(g+1),S=this.k(u,w,g+1,s);if(S)return S}return null}static k(n,i,u,s){let t=null,c;for(n.reset(0);c=n.next(i);)t=A(new R.$ut(u,c.index+1,u,c.index+1+c[0].length),c,s);return t}}e.$SC=p;function y(o,n,i,u,s){if(u===0)return!0;const t=n.charCodeAt(u-1);if(o.get(t)!==0||t===13||t===10)return!0;if(s>0){const c=n.charCodeAt(u);if(o.get(c)!==0)return!0}return!1}function v(o,n,i,u,s){if(u+s===i)return!0;const t=n.charCodeAt(u+s);if(o.get(t)!==0||t===13||t===10)return!0;if(s>0){const c=n.charCodeAt(u+s-1);if(o.get(c)!==0)return!0}return!1}function h(o,n,i,u,s){return y(o,n,i,u,s)&&v(o,n,i,u,s)}class l{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let u;do{if(this.b+this.c===i||(u=this.a.exec(n),!u))return null;const s=u.index,t=u[0].length;if(s===this.b&&t===this.c){if(t===0){d.$Ef(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=s,this.c=t,!this._wordSeparators||h(this._wordSeparators,n,i,s,t))return u}while(u);return null}}e.$UC=l}),define(Se[131],De([1,0,51,29,80,186,100]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZC=e.$YC=e.$XC=void 0,e.$VC=A,e.$WC=C;const b=65535;function $(o){let n;return o[o.length-1]<65536?n=new Uint16Array(o.length):n=new Uint32Array(o.length),n.set(o,0),n}class k{constructor(n,i,u,s,t){this.lineStarts=n,this.cr=i,this.lf=u,this.crlf=s,this.isBasicASCII=t}}function A(o,n=!0){const i=[0];let u=1;for(let s=0,t=o.length;s<t;s++){const c=o.charCodeAt(s);c===13?s+1<t&&o.charCodeAt(s+1)===10?(i[u++]=s+2,s++):i[u++]=s+1:c===10&&(i[u++]=s+1)}return n?$(i):i}function C(o,n){o.length=0,o[0]=0;let i=1,u=0,s=0,t=0,c=!0;for(let a=0,f=n.length;a<f;a++){const g=n.charCodeAt(a);g===13?a+1<f&&n.charCodeAt(a+1)===10?(t++,o[i++]=a+2,a++):(u++,o[i++]=a+1):g===10?(s++,o[i++]=a+1):c&&g!==9&&(g<32||g>126)&&(c=!1)}const r=new k($(o),u,s,t,c);return o.length=0,r}class p{constructor(n,i,u,s,t){this.bufferIndex=n,this.start=i,this.end=u,this.lineFeedCnt=s,this.length=t}}e.$XC=p;class y{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$YC=y;class v{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==R.$GC&&n.iterate(n.root,u=>(u!==R.$GC&&this.a.push(u.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class h{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const u=this.b[i];if(u.nodeStartOffset<=n&&u.nodeStartOffset+u.node.piece.length>=n)return u}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const u=this.b[i];if(u.nodeStartLineNumber&&u.nodeStartLineNumber<n&&u.nodeStartLineNumber+u.node.piece.lineFeedCnt>=n)return u}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const u=this.b;for(let s=0;s<u.length;s++){const t=u[s];if(t.node.parent===null||t.nodeStartOffset>=n){u[s]=null,i=!0;continue}}if(i){const s=[];for(const t of u)t!==null&&s.push(t);this.b=s}}}class l{constructor(n,i,u){this.create(n,i,u)}create(n,i,u){this.a=[new y("",[0])],this.g={line:0,column:0},this.root=R.$GC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=u;let s=null;for(let t=0,c=n.length;t<c;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=A(n[t].buffer));const r=new p(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),s=this.S(s,r)}this.h=new h(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=b,u=i-Math.floor(i/3),s=u*2;let t="",c=0;const r=[];if(this.iterate(this.root,a=>{const f=this.R(a),g=f.length;if(c<=u||c+g<s)return t+=f,c+=g,!0;const w=t.replace(/\r\n|\r|\n/g,n);return r.push(new y(w,A(w))),t=f,c=g,!0}),c>0){const a=t.replace(/\r\n|\r|\n/g,n);r.push(new y(a,A(a)))}this.create(r,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new v(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,s=>{if(s===R.$GC)return!0;const t=this.R(s),c=t.length,r=n.G(i),a=n.G(i+c),f=n.getValueInRange2(r,a);return i+=c,t===f})}getOffsetAt(n,i){let u=0,s=this.root;for(;s!==R.$GC;)if(s.left!==R.$GC&&s.lf_left+1>=n)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt+1>=n){u+=s.size_left;const t=this.B(s,n-s.lf_left-2);return u+=t+i-1}else n-=s.lf_left+s.piece.lineFeedCnt,u+=s.size_left+s.piece.length,s=s.right;return u}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,u=0;const s=n;for(;i!==R.$GC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(u+=i.lf_left+t.index,t.index===0){const c=this.getOffsetAt(u+1,1),r=s-c;return new d.$tt(u+1,r+1)}return new d.$tt(u+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,u+=i.lf_left+i.piece.lineFeedCnt,i.right===R.$GC){const t=this.getOffsetAt(u+1,1),c=s-n-t;return new d.$tt(u+1,c+1)}else i=i.right;return new d.$tt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const u=this.H(n.startLineNumber,n.startColumn),s=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(u,s);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const r=n.node,a=this.a[r.piece.bufferIndex].buffer,f=this.u(r.piece.bufferIndex,r.piece.start);return a.substring(f+n.remainder,f+i.remainder)}let u=n.node;const s=this.a[u.piece.bufferIndex].buffer,t=this.u(u.piece.bufferIndex,u.piece.start);let c=s.substring(t+n.remainder,t+u.piece.length);for(u=u.next();u!==R.$GC;){const r=this.a[u.piece.bufferIndex].buffer,a=this.u(u.piece.bufferIndex,u.piece.start);if(u===i.node){c+=r.substring(a,a+i.remainder);break}else c+=r.substr(a,u.piece.length);u=u.next()}return c}getLinesContent(){const n=[];let i=0,u="",s=!1;return this.iterate(this.root,t=>{if(t===R.$GC)return!0;const c=t.piece;let r=c.length;if(r===0)return!0;const a=this.a[c.bufferIndex].buffer,f=this.a[c.bufferIndex].lineStarts,g=c.start.line,w=c.end.line;let S=f[g]+c.start.column;if(s&&(a.charCodeAt(S)===10&&(S++,r--),n[i++]=u,u="",s=!1,r===0))return!0;if(g===w)return!this.f&&a.charCodeAt(S+r-1)===13?(s=!0,u+=a.substr(S,r-1)):u+=a.substr(S,r),!0;u+=this.f?a.substring(S,Math.max(S,f[g+1]-this.e)):a.substring(S,f[g+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=u;for(let m=g+1;m<w;m++)u=this.f?a.substring(f[m],f[m+1]-this.e):a.substring(f[m],f[m+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=u;return!this.f&&a.charCodeAt(f[w]+c.end.column-1)===13?(s=!0,c.end.column===0?i--:u=a.substr(f[w],c.end.column-1)):u=a.substr(f[w],c.end.column),!0}),s&&(n[i++]=u,u=""),n[i++]=u,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const u=this.a[i.piece.bufferIndex],s=this.u(i.piece.bufferIndex,i.piece.start);return u.buffer.charCodeAt(s)}else{const i=this.a[n.node.piece.bufferIndex],s=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(s)}}getLineCharCode(n,i){const u=this.H(n,i+1);return this.l(u)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,u,s,t,c,r,a,f,g,w){const S=this.a[n.piece.bufferIndex],m=this.u(n.piece.bufferIndex,n.piece.start),E=this.u(n.piece.bufferIndex,t),D=this.u(n.piece.bufferIndex,c);let P;const I={line:0,column:0};let F,T;i._wordSeparators?(F=S.buffer.substring(E,D),T=z=>z+E,i.reset(0)):(F=S.buffer,T=z=>z,i.reset(E));do if(P=i.next(F),P){if(T(P.index)>=D)return g;this.s(n,T(P.index)-m,I);const z=this.t(n.piece.bufferIndex,t,I),M=I.line===t.line?I.column-t.column+s:I.column+1,j=M+P[0].length;if(w[g++]=(0,N.$RC)(new O.$ut(u+z,M,u+z,j),P,a),T(P.index)+P[0].length>=D||g>=f)return g}while(P);return g}findMatchesLineByLine(n,i,u,s){const t=[];let c=0;const r=new N.$UC(i.wordSeparators,i.regex);let a=this.H(n.startLineNumber,n.startColumn);if(a===null)return[];const f=this.H(n.endLineNumber,n.endColumn);if(f===null)return[];let g=this.s(a.node,a.remainder);const w=this.s(f.node,f.remainder);if(a.node===f.node)return this.findMatchesInNode(a.node,r,n.startLineNumber,n.startColumn,g,w,i,u,s,c,t),t;let S=n.startLineNumber,m=a.node;for(;m!==f.node;){const D=this.t(m.piece.bufferIndex,g,m.piece.end);if(D>=1){const I=this.a[m.piece.bufferIndex].lineStarts,F=this.u(m.piece.bufferIndex,m.piece.start),T=I[g.line+D],z=S===n.startLineNumber?n.startColumn:1;if(c=this.findMatchesInNode(m,r,S,z,g,this.s(m,T-F),i,u,s,c,t),c>=s)return t;S+=D}const P=S===n.startLineNumber?n.startColumn-1:0;if(S===n.endLineNumber){const I=this.getLineContent(S).substring(P,n.endColumn-1);return c=this.n(i,r,I,n.endLineNumber,P,c,t,u,s),t}if(c=this.n(i,r,this.getLineContent(S).substr(P),S,P,c,t,u,s),c>=s)return t;S++,a=this.H(S,1),m=a.node,g=this.s(a.node,a.remainder)}if(S===n.endLineNumber){const D=S===n.startLineNumber?n.startColumn-1:0,P=this.getLineContent(S).substring(D,n.endColumn-1);return c=this.n(i,r,P,n.endLineNumber,D,c,t,u,s),t}const E=S===n.startLineNumber?n.startColumn:1;return c=this.findMatchesInNode(f.node,r,S,E,g,w,i,u,s,c,t),t}n(n,i,u,s,t,c,r,a,f){const g=n.wordSeparators;if(!a&&n.simpleSearch){const S=n.simpleSearch,m=S.length,E=u.length;let D=-m;for(;(D=u.indexOf(S,D+m))!==-1;)if((!g||(0,N.$TC)(g,u,E,D,m))&&(r[c++]=new L.$Fv(new O.$ut(s,D+1+t,s,D+1+m+t),null),c>=f))return c;return c}let w;i.reset(0);do if(w=i.next(u),w&&(r[c++]=(0,N.$RC)(new O.$ut(s,w.index+1+t,s,w.index+1+w[0].length+t),w,a),c>=f))return c;while(w);return c}insert(n,i,u=!1){if(this.f=this.f&&u,this.j.lineNumber=0,this.j.value="",this.root!==R.$GC){const{node:s,remainder:t,nodeStartOffset:c}=this.G(n),r=s.piece,a=r.bufferIndex,f=this.s(s,t);if(s.piece.bufferIndex===0&&r.end.line===this.g.line&&r.end.column===this.g.column&&c+r.length===n&&i.length<b){this.F(s,i),this.y();return}if(c===n)this.o(i,s),this.h.validate(n);else if(c+s.piece.length>n){const g=[];let w=new p(r.bufferIndex,f,r.end,this.t(r.bufferIndex,f,r.end),this.u(a,r.end)-this.u(a,f));if(this.K()&&this.M(i)&&this.I(s,t)===10){const D={line:w.start.line+1,column:0};w=new p(w.bufferIndex,D,w.end,this.t(w.bufferIndex,D,w.end),w.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(s,t-1)===13){const D=this.s(s,t-1);this.C(s,D),i="\r"+i,s.piece.length===0&&g.push(s)}else this.C(s,f);else this.C(s,f);const S=this.w(i);w.length>0&&this.S(s,w);let m=s;for(let E=0;E<S.length;E++)m=this.S(m,S[E]);this.v(g)}else this.q(i,s)}else{const s=this.w(i);let t=this.T(null,s[0]);for(let c=1;c<s.length;c++)t=this.S(t,s[c])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===R.$GC)return;const u=this.G(n),s=this.G(n+i),t=u.node,c=s.node;if(t===c){const S=this.s(t,u.remainder),m=this.s(t,s.remainder);if(u.nodeStartOffset===n){if(i===t.piece.length){const E=t.next();(0,R.$LC)(this,t),this.N(E),this.y();return}this.D(t,m),this.h.validate(n),this.N(t),this.y();return}if(u.nodeStartOffset+t.piece.length===n+i){this.C(t,S),this.O(t),this.y();return}this.E(t,S,m),this.y();return}const r=[],a=this.s(t,u.remainder);this.C(t,a),this.h.validate(n),t.piece.length===0&&r.push(t);const f=this.s(c,s.remainder);this.D(c,f),c.piece.length===0&&r.push(c);const g=t.next();for(let S=g;S!==R.$GC&&S!==c;S=S.next())r.push(S);const w=t.piece.length===0?t.prev():t;this.v(r),this.O(w),this.y()}o(n,i){const u=[];if(this.K()&&this.M(n)&&this.L(i)){const c=i.piece,r={line:c.start.line+1,column:0},a=new p(c.bufferIndex,r,c.end,this.t(c.bufferIndex,r,c.end),c.length-1);i.piece=a,n+=`
`,(0,R.$NC)(this,i,-1,-1),i.piece.length===0&&u.push(i)}const s=this.w(n);let t=this.T(i,s[s.length-1]);for(let c=s.length-2;c>=0;c--)t=this.T(t,s[c]);this.N(t),this.v(u)}q(n,i){this.Q(n,i)&&(n+=`
`);const u=this.w(n),s=this.S(i,u[0]);let t=s;for(let c=1;c<u.length;c++)t=this.S(t,u[c]);this.N(s)}s(n,i,u){const s=n.piece,t=n.piece.bufferIndex,c=this.a[t].lineStarts,a=c[s.start.line]+s.start.column+i;let f=s.start.line,g=s.end.line,w=0,S=0,m=0;for(;f<=g&&(w=f+(g-f)/2|0,m=c[w],w!==g);)if(S=c[w+1],a<m)g=w-1;else if(a>=S)f=w+1;else break;return u?(u.line=w,u.column=a-m,null):{line:w,column:a-m}}t(n,i,u){if(u.column===0)return u.line-i.line;const s=this.a[n].lineStarts;if(u.line===s.length-1)return u.line-i.line;const t=s[u.line+1],c=s[u.line]+u.column;if(t>c+1)return u.line-i.line;const r=c-1;return this.a[n].buffer.charCodeAt(r)===13?u.line-i.line+1:u.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,R.$LC)(this,n[i])}w(n){if(n.length>b){const g=[];for(;n.length>b;){const S=n.charCodeAt(b-1);let m;S===13||S>=55296&&S<=56319?(m=n.substring(0,b-1),n=n.substring(b-1)):(m=n.substring(0,b),n=n.substring(b));const E=A(m);g.push(new p(this.a.length,{line:0,column:0},{line:E.length-1,column:m.length-E[E.length-1]},E.length-1,m.length)),this.a.push(new y(m,E))}const w=A(n);return g.push(new p(this.a.length,{line:0,column:0},{line:w.length-1,column:n.length-w[w.length-1]},w.length-1,n.length)),this.a.push(new y(n,w)),g}let i=this.a[0].buffer.length;const u=A(n,!1);let s=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},s=this.g;for(let g=0;g<u.length;g++)u[g]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let g=0;g<u.length;g++)u[g]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,c=this.a[0].lineStarts.length-1,r=t-this.a[0].lineStarts[c],a={line:c,column:r},f=new p(0,s,a,this.t(0,s,a),t-i);return this.g=a,[f]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let u=this.root,s="";const t=this.h.get2(n);if(t){u=t.node;const c=this.B(u,n-t.nodeStartLineNumber-1),r=this.a[u.piece.bufferIndex].buffer,a=this.u(u.piece.bufferIndex,u.piece.start);if(t.nodeStartLineNumber+u.piece.lineFeedCnt===n)s=r.substring(a+c,a+u.piece.length);else{const f=this.B(u,n-t.nodeStartLineNumber);return r.substring(a+c,a+f-i)}}else{let c=0;const r=n;for(;u!==R.$GC;)if(u.left!==R.$GC&&u.lf_left>=n-1)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt>n-1){const a=this.B(u,n-u.lf_left-2),f=this.B(u,n-u.lf_left-1),g=this.a[u.piece.bufferIndex].buffer,w=this.u(u.piece.bufferIndex,u.piece.start);return c+=u.size_left,this.h.set({node:u,nodeStartOffset:c,nodeStartLineNumber:r-(n-1-u.lf_left)}),g.substring(w+a,w+f-i)}else if(u.lf_left+u.piece.lineFeedCnt===n-1){const a=this.B(u,n-u.lf_left-2),f=this.a[u.piece.bufferIndex].buffer,g=this.u(u.piece.bufferIndex,u.piece.start);s=f.substring(g+a,g+u.piece.length);break}else n-=u.lf_left+u.piece.lineFeedCnt,c+=u.size_left+u.piece.length,u=u.right}for(u=u.next();u!==R.$GC;){const c=this.a[u.piece.bufferIndex].buffer;if(u.piece.lineFeedCnt>0){const r=this.B(u,0),a=this.u(u.piece.bufferIndex,u.piece.start);return s+=c.substring(a,a+r-i),s}else{const r=this.u(u.piece.bufferIndex,u.piece.start);s+=c.substr(r,u.piece.length)}u=u.next()}return s}y(){let n=this.root,i=1,u=0;for(;n!==R.$GC;)i+=n.lf_left+n.piece.lineFeedCnt,u+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=u,this.h.validate(this.c)}A(n,i){const u=n.piece,s=this.s(n,i),t=s.line-u.start.line;if(this.u(u.bufferIndex,u.end)-this.u(u.bufferIndex,u.start)===i){const c=this.t(n.piece.bufferIndex,u.start,s);if(c!==t)return{index:c,remainder:0}}return{index:t,remainder:s.column}}B(n,i){if(i<0)return 0;const u=n.piece,s=this.a[u.bufferIndex].lineStarts,t=u.start.line+i+1;return t>u.end.line?s[u.end.line]+u.end.column-s[u.start.line]-u.start.column:s[t]-s[u.start.line]-u.start.column}C(n,i){const u=n.piece,s=u.lineFeedCnt,t=this.u(u.bufferIndex,u.end),c=i,r=this.u(u.bufferIndex,c),a=this.t(u.bufferIndex,u.start,c),f=a-s,g=r-t,w=u.length+g;n.piece=new p(u.bufferIndex,u.start,c,a,w),(0,R.$NC)(this,n,g,f)}D(n,i){const u=n.piece,s=u.lineFeedCnt,t=this.u(u.bufferIndex,u.start),c=i,r=this.t(u.bufferIndex,c,u.end),a=this.u(u.bufferIndex,c),f=r-s,g=t-a,w=u.length+g;n.piece=new p(u.bufferIndex,c,u.end,r,w),(0,R.$NC)(this,n,g,f)}E(n,i,u){const s=n.piece,t=s.start,c=s.end,r=s.length,a=s.lineFeedCnt,f=i,g=this.t(s.bufferIndex,s.start,f),w=this.u(s.bufferIndex,i)-this.u(s.bufferIndex,t);n.piece=new p(s.bufferIndex,s.start,f,g,w),(0,R.$NC)(this,n,w-r,g-a);const S=new p(s.bufferIndex,u,c,this.t(s.bufferIndex,u,c),this.u(s.bufferIndex,c)-this.u(s.bufferIndex,u)),m=this.S(n,S);this.N(m)}F(n,i){this.Q(i,n)&&(i+=`
`);const u=this.K()&&this.L(i)&&this.M(n),s=this.a[0].buffer.length;this.a[0].buffer+=i;const t=A(i,!1);for(let m=0;m<t.length;m++)t[m]+=s;if(u){const m=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:s-m}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const c=this.a[0].lineStarts.length-1,r=this.a[0].buffer.length-this.a[0].lineStarts[c],a={line:c,column:r},f=n.piece.length+i.length,g=n.piece.lineFeedCnt,w=this.t(0,n.piece.start,a),S=w-g;n.piece=new p(n.piece.bufferIndex,n.piece.start,a,w,f),this.g=a,(0,R.$NC)(this,n,i.length,S)}G(n){let i=this.root;const u=this.h.get(n);if(u)return{node:u.node,nodeStartOffset:u.nodeStartOffset,remainder:n-u.nodeStartOffset};let s=0;for(;i!==R.$GC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){s+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:s};return this.h.set(t),t}else n-=i.size_left+i.piece.length,s+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let u=this.root,s=0;for(;u!==R.$GC;)if(u.left!==R.$GC&&u.lf_left>=n-1)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt>n-1){const t=this.B(u,n-u.lf_left-2),c=this.B(u,n-u.lf_left-1);return s+=u.size_left,{node:u,remainder:Math.min(t+i-1,c),nodeStartOffset:s}}else if(u.lf_left+u.piece.lineFeedCnt===n-1){const t=this.B(u,n-u.lf_left-2);if(t+i-1<=u.piece.length)return{node:u,remainder:t+i-1,nodeStartOffset:s};i-=u.piece.length-t;break}else n-=u.lf_left+u.piece.lineFeedCnt,s+=u.size_left+u.piece.length,u=u.right;for(u=u.next();u!==R.$GC;){if(u.piece.lineFeedCnt>0){const t=this.B(u,0),c=this.J(u);return{node:u,remainder:Math.min(i-1,t),nodeStartOffset:c}}else if(u.piece.length>=i-1){const t=this.J(u);return{node:u,remainder:i-1,nodeStartOffset:t}}else i-=u.piece.length;u=u.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const u=this.a[n.piece.bufferIndex],s=this.u(n.piece.bufferIndex,n.piece.start)+i;return u.buffer.charCodeAt(s)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===R.$GC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,u=this.a[i.bufferIndex].lineStarts,s=i.start.line,t=u[s]+i.start.column;return s===u.length-1||u[s+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===R.$GC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const u=[],s=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:s[n.piece.end.line]-s[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const c=n.piece.length-1,r=n.piece.lineFeedCnt-1;n.piece=new p(n.piece.bufferIndex,n.piece.start,t,r,c),(0,R.$NC)(this,n,-1,-1),n.piece.length===0&&u.push(n);const a={line:i.piece.start.line+1,column:0},f=i.piece.length-1,g=this.t(i.piece.bufferIndex,a,i.piece.end);i.piece=new p(i.piece.bufferIndex,a,i.piece.end,g,f),(0,R.$NC)(this,i,-1,-1),i.piece.length===0&&u.push(i);const w=this.w(`\r
`);this.S(n,w[0]);for(let S=0;S<u.length;S++)(0,R.$LC)(this,u[S])}Q(n,i){if(this.K()&&this.M(n)){const u=i.next();if(this.L(u)){if(n+=`
`,u.piece.length===1)(0,R.$LC)(this,u);else{const s=u.piece,t={line:s.start.line+1,column:0},c=s.length-1,r=this.t(s.bufferIndex,t,s.end);u.piece=new p(s.bufferIndex,t,s.end,r,c),(0,R.$NC)(this,u,-1,-1)}return!0}}return!1}iterate(n,i){if(n===R.$GC)return i(R.$GC);const u=this.iterate(n.left,i);return u&&i(n)&&this.iterate(n.right,i)}R(n){if(n===R.$GC)return"";const i=this.a[n.piece.bufferIndex],u=n.piece,s=this.u(u.bufferIndex,u.start),t=this.u(u.bufferIndex,u.end);return i.buffer.substring(s,t)}getPieceContent(n){const i=this.a[n.bufferIndex],u=this.u(n.bufferIndex,n.start),s=this.u(n.bufferIndex,n.end);return i.buffer.substring(u,s)}S(n,i){const u=new R.$FC(i,1);if(u.left=R.$GC,u.right=R.$GC,u.parent=R.$GC,u.size_left=0,u.lf_left=0,this.root===R.$GC)this.root=u,u.color=0;else if(n.right===R.$GC)n.right=u,u.parent=n;else{const t=(0,R.$HC)(n.right);t.left=u,u.parent=t}return(0,R.$MC)(this,u),u}T(n,i){const u=new R.$FC(i,1);if(u.left=R.$GC,u.right=R.$GC,u.parent=R.$GC,u.size_left=0,u.lf_left=0,this.root===R.$GC)this.root=u,u.color=0;else if(n.left===R.$GC)n.left=u,u.parent=n;else{const s=(0,R.$IC)(n.left);s.right=u,u.parent=s}return(0,R.$MC)(this,u),u}U(n){let i="";return this.iterate(n,u=>(i+=this.R(u),!0)),i}}e.$ZC=l}),define(Se[189],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w$=e.$v$=void 0;class d{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const N=this.a.get(R);return this.a.delete(R),N}}addDragOperationTransfer(R,N){this.a.set(R,N)}}e.$v$=d;class O{constructor(R){this.identifier=R}}e.$w$=O}),define(Se[190],De([1,0,4,3]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zt=void 0;class L{constructor(){this.a=new Map,this.b=new Map,this.c=new d.$de,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,$){return this.a.set(b,$),this.handleChange([b]),(0,O.$Sc)(()=>{this.a.get(b)===$&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,$){this.b.get(b)?.dispose();const k=new R(this,b,$);return this.b.set(b,k),(0,O.$Sc)(()=>{const A=this.b.get(b);!A||A!==k||(this.b.delete(b),A.dispose())})}async getOrCreate(b){const $=this.get(b);if($)return $;const k=this.b.get(b);return!k||k.isResolved?null:(await k.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const k=this.b.get(b);return!!(!k||k.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Zt=L;class R extends O.$Uc{get isResolved(){return this.c}constructor(b,$,k){super(),this.f=b,this.g=$,this.h=k,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(Se[191],De([9,10]),function(he,e){return he.create("vs/base/common/actions",e)}),define(Se[192],De([1,0,4,3,191]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=void 0,e.$gj=A;class R extends O.$Uc{constructor(p,y="",v="",h=!0,l){super(),this.h=this.B(new d.$de),this.onDidChange=this.h.event,this.w=!0,this.j=p,this.m=y,this.u=v,this.w=h,this.C=l}get id(){return this.j}get label(){return this.m}set label(p){this.D(p)}D(p){this.m!==p&&(this.m=p,this.h.fire({label:p}))}get tooltip(){return this.n||""}set tooltip(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.h.fire({tooltip:p}))}get class(){return this.u}set class(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.h.fire({class:p}))}get enabled(){return this.w}set enabled(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.h.fire({enabled:p}))}get checked(){return this.z}set checked(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.h.fire({checked:p}))}async run(p,y){this.C&&await this.C(p)}}e.$bj=R;class N extends O.$Uc{constructor(){super(...arguments),this.f=this.B(new d.$de),this.onWillRun=this.f.event,this.m=this.B(new d.$de),this.onDidRun=this.m.event}async run(p,y){if(!p.enabled)return;this.f.fire({action:p});let v;try{await this.u(p,y)}catch(h){v=h}this.m.fire({action:p,error:v})}async u(p,y){await p.run(y)}}e.$cj=N;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let y=[];for(const v of p)v.length&&(y.length?y=[...y,new b,...v]:y=v);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$dj=b;class ${get actions(){return this.a}constructor(p,y,v,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=y,this.class=h,this.a=v}async run(){}}e.$ej=$;class k extends R{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,L.localize(0,null),void 0,!1)}}e.$fj=k;function A(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked,run:async(...p)=>C.run(...p),tooltip:C.label}}}),define(Se[193],De([9,10]),function(he,e){return he.create("vs/base/common/date",e)}),define(Se[194],De([1,0,193]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=k,e.$3m=A,e.$4m=C;const O=60,L=O*60,R=L*24,N=R*7,b=R*30,$=R*365;function k(p,y,v,h){typeof p!="number"&&(p=p.getTime());const l=Math.round((new Date().getTime()-p)/1e3);if(l<-30)return(0,d.localize)(0,null,k(new Date().getTime()+l*1e3,!1));if(!h&&l<30)return(0,d.localize)(1,null);let o;return l<O?(o=l,y?o===1?v?(0,d.localize)(2,null,o):(0,d.localize)(3,null,o):v?(0,d.localize)(4,null,o):(0,d.localize)(5,null,o):o===1?v?(0,d.localize)(6,null,o):(0,d.localize)(7,null,o):v?(0,d.localize)(8,null,o):(0,d.localize)(9,null,o)):l<L?(o=Math.floor(l/O),y?o===1?v?(0,d.localize)(10,null,o):(0,d.localize)(11,null,o):v?(0,d.localize)(12,null,o):(0,d.localize)(13,null,o):o===1?v?(0,d.localize)(14,null,o):(0,d.localize)(15,null,o):v?(0,d.localize)(16,null,o):(0,d.localize)(17,null,o)):l<R?(o=Math.floor(l/L),y?o===1?v?(0,d.localize)(18,null,o):(0,d.localize)(19,null,o):v?(0,d.localize)(20,null,o):(0,d.localize)(21,null,o):o===1?v?(0,d.localize)(22,null,o):(0,d.localize)(23,null,o):v?(0,d.localize)(24,null,o):(0,d.localize)(25,null,o)):l<N?(o=Math.floor(l/R),y?o===1?(0,d.localize)(26,null,o):(0,d.localize)(27,null,o):o===1?(0,d.localize)(28,null,o):(0,d.localize)(29,null,o)):l<b?(o=Math.floor(l/N),y?o===1?v?(0,d.localize)(30,null,o):(0,d.localize)(31,null,o):v?(0,d.localize)(32,null,o):(0,d.localize)(33,null,o):o===1?v?(0,d.localize)(34,null,o):(0,d.localize)(35,null,o):v?(0,d.localize)(36,null,o):(0,d.localize)(37,null,o)):l<$?(o=Math.floor(l/b),y?o===1?v?(0,d.localize)(38,null,o):(0,d.localize)(39,null,o):v?(0,d.localize)(40,null,o):(0,d.localize)(41,null,o):o===1?v?(0,d.localize)(42,null,o):(0,d.localize)(43,null,o):v?(0,d.localize)(44,null,o):(0,d.localize)(45,null,o)):(o=Math.floor(l/$),y?o===1?v?(0,d.localize)(46,null,o):(0,d.localize)(47,null,o):v?(0,d.localize)(48,null,o):(0,d.localize)(49,null,o):o===1?v?(0,d.localize)(50,null,o):(0,d.localize)(51,null,o):v?(0,d.localize)(52,null,o):(0,d.localize)(53,null,o))}function A(p,y){const v=Math.abs(p/1e3);return v<1?y?(0,d.localize)(54,null,p):(0,d.localize)(55,null,p):v<O?y?(0,d.localize)(56,null,Math.round(p)/1e3):(0,d.localize)(57,null,Math.round(p)/1e3):v<L?y?(0,d.localize)(58,null,Math.round(p/(1e3*O))):(0,d.localize)(59,null,Math.round(p/(1e3*O))):v<R?y?(0,d.localize)(60,null,Math.round(p/(1e3*L))):(0,d.localize)(61,null,Math.round(p/(1e3*L))):(0,d.localize)(62,null,Math.round(p/(1e3*R)))}function C(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Se[195],De([9,10]),function(he,e){return he.create("vs/base/common/errorMessage",e)}),define(Se[47],De([1,0,19,18,195]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=$,e.$ij=k,e.$jj=A;function R(C,p){return p&&(C.stack||C.stacktrace)?L.localize(0,null,b(C),N(C.stack)||N(C.stacktrace)):b(C)}function N(C){return Array.isArray(C)?C.join(`
`):C}function b(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?L.localize(1,null,C.message):C.message||L.localize(2,null)}function $(C=null,p=!1){if(!C)return L.localize(3,null);if(Array.isArray(C)){const y=d.$Hb(C),v=$(y[0],p);return y.length>1?L.localize(4,null,v,y.length):v}if(O.$9f(C))return C;if(C.detail){const y=C.detail;if(y.error)return R(y.error,p);if(y.exception)return R(y.exception,p)}return C.stack?R(C,p):C.message?C.message:L.localize(5,null)}function k(C){const p=C;return p instanceof Error&&Array.isArray(p.actions)}function A(C,p){let y;return typeof C=="string"?y=new Error(C):y=C,y.actions=p,y}}),define(Se[196],De([9,10]),function(he,e){return he.create("vs/base/common/platform",e)}),define(Se[12],De([1,0,196]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=c,e.$D=S,e.$J=m,e.$g="en";let O=!1,L=!1,R=!1,N=!1,b=!1,$=!1,k=!1,A=!1,C=!1,p=!1,y,v=e.$g,h=e.$g,l,o;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const u=typeof i?.versions?.electron=="string",s=u&&i?.type==="renderer";if(typeof i=="object"){O=i.platform==="win32",L=i.platform==="darwin",R=i.platform==="linux",N=R&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,k=u,C=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,v=e.$g;const E=i.env.VSCODE_NLS_CONFIG;if(E)try{const D=JSON.parse(E),P=D.availableLanguages["*"];y=D.locale,h=D.osLocale,v=P||e.$g,l=D._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!s?(o=navigator.userAgent,O=o.indexOf("Windows")>=0,L=o.indexOf("Macintosh")>=0,A=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=o.indexOf("Linux")>=0,p=o?.indexOf("Mobi")>=0,$=!0,y=d.getConfiguredDefaultLocale(d.localize(0,null))||e.$g,v=y,h=navigator.language):console.error("Unable to resolve platform.");var t;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(t||(e.Platform=t={}));function c(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let r=0;L?r=1:O?r=3:R&&(r=2),e.$i=O,e.$j=L,e.$k=R,e.$l=N,e.$m=b,e.$n=k,e.$o=$,e.$p=$&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=A,e.$s=p,e.$t=C,e.$u=r,e.$v=o,e.$w=v;var a;(function(E){function D(){return e.$w}E.value=D;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}E.isDefaultVariant=P;function I(){return e.$w==="en"}E.isDefault=I})(a||(e.Language=a={})),e.$x=y,e.$y=h,e.$z=l,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const E=[];n.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let I=0,F=E.length;I<F;I++){const T=E[I];if(T.id===P.data.vscodeScheduleAsyncWork){E.splice(I,1),T.callback();return}}});let D=0;return P=>{const I=++D;E.push({id:I,callback:P}),n.postMessage({vscodeScheduleAsyncWork:I},"*")}}return E=>setTimeout(E)})();var f;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(f||(e.OperatingSystem=f={})),e.OS=L||A?2:O?1:3;let g=!0,w=!1;function S(){if(!w){w=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,g=new Uint16Array(E.buffer)[0]===513}return g}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function m(E){return parseFloat(E)>=20}}),define(Se[52],De([1,0,12]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let O;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const R=L.process;O={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return d.$i?"win32":d.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$dc=O.platform,e.$ec=O.arch}),define(Se[17],De([1,0,52]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const O=65,L=97,R=90,N=122,b=46,$=47,k=92,A=58,C=63;class p extends Error{constructor(c,r,a){let f;typeof r=="string"&&r.indexOf("not ")===0?(f="must not be",r=r.replace(/^not /,"")):f="must be";const g=c.indexOf(".")!==-1?"property":"argument";let w=`The "${c}" ${g} ${f} of type ${r}`;w+=`. Received type ${typeof a}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,c){if(t===null||typeof t!="object")throw new p(c,"Object",t)}function v(t,c){if(typeof t!="string")throw new p(c,"string",t)}const h=d.$dc==="win32";function l(t){return t===$||t===k}function o(t){return t===$}function n(t){return t>=O&&t<=R||t>=L&&t<=N}function i(t,c,r,a){let f="",g=0,w=-1,S=0,m=0;for(let E=0;E<=t.length;++E){if(E<t.length)m=t.charCodeAt(E);else{if(a(m))break;m=$}if(a(m)){if(!(w===E-1||S===1))if(S===2){if(f.length<2||g!==2||f.charCodeAt(f.length-1)!==b||f.charCodeAt(f.length-2)!==b){if(f.length>2){const D=f.lastIndexOf(r);D===-1?(f="",g=0):(f=f.slice(0,D),g=f.length-1-f.lastIndexOf(r)),w=E,S=0;continue}else if(f.length!==0){f="",g=0,w=E,S=0;continue}}c&&(f+=f.length>0?`${r}..`:"..",g=2)}else f.length>0?f+=`${r}${t.slice(w+1,E)}`:f=t.slice(w+1,E),g=E-w-1;w=E,S=0}else m===b&&S!==-1?++S:S=-1}return f}function u(t,c){y(c,"pathObject");const r=c.dir||c.root,a=c.base||`${c.name||""}${c.ext||""}`;return r?r===c.root?`${r}${a}`:`${r}${t}${a}`:a}e.$fc={resolve(...t){let c="",r="",a=!1;for(let f=t.length-1;f>=-1;f--){let g;if(f>=0){if(g=t[f],v(g,"path"),g.length===0)continue}else c.length===0?g=d.cwd():(g=d.env[`=${c}`]||d.cwd(),(g===void 0||g.slice(0,2).toLowerCase()!==c.toLowerCase()&&g.charCodeAt(2)===k)&&(g=`${c}\\`));const w=g.length;let S=0,m="",E=!1;const D=g.charCodeAt(0);if(w===1)l(D)&&(S=1,E=!0);else if(l(D))if(E=!0,l(g.charCodeAt(1))){let P=2,I=P;for(;P<w&&!l(g.charCodeAt(P));)P++;if(P<w&&P!==I){const F=g.slice(I,P);for(I=P;P<w&&l(g.charCodeAt(P));)P++;if(P<w&&P!==I){for(I=P;P<w&&!l(g.charCodeAt(P));)P++;(P===w||P!==I)&&(m=`\\\\${F}\\${g.slice(I,P)}`,S=P)}}}else S=1;else n(D)&&g.charCodeAt(1)===A&&(m=g.slice(0,2),S=2,w>2&&l(g.charCodeAt(2))&&(E=!0,S=3));if(m.length>0)if(c.length>0){if(m.toLowerCase()!==c.toLowerCase())continue}else c=m;if(a){if(c.length>0)break}else if(r=`${g.slice(S)}\\${r}`,a=E,E&&c.length>0)break}return r=i(r,!a,"\\",l),a?`${c}\\${r}`:`${c}${r}`||"."},normalize(t){v(t,"path");const c=t.length;if(c===0)return".";let r=0,a,f=!1;const g=t.charCodeAt(0);if(c===1)return o(g)?"\\":t;if(l(g))if(f=!0,l(t.charCodeAt(1))){let S=2,m=S;for(;S<c&&!l(t.charCodeAt(S));)S++;if(S<c&&S!==m){const E=t.slice(m,S);for(m=S;S<c&&l(t.charCodeAt(S));)S++;if(S<c&&S!==m){for(m=S;S<c&&!l(t.charCodeAt(S));)S++;if(S===c)return`\\\\${E}\\${t.slice(m)}\\`;S!==m&&(a=`\\\\${E}\\${t.slice(m,S)}`,r=S)}}}else r=1;else n(g)&&t.charCodeAt(1)===A&&(a=t.slice(0,2),r=2,c>2&&l(t.charCodeAt(2))&&(f=!0,r=3));let w=r<c?i(t.slice(r),!f,"\\",l):"";return w.length===0&&!f&&(w="."),w.length>0&&l(t.charCodeAt(c-1))&&(w+="\\"),a===void 0?f?`\\${w}`:w:f?`${a}\\${w}`:`${a}${w}`},isAbsolute(t){v(t,"path");const c=t.length;if(c===0)return!1;const r=t.charCodeAt(0);return l(r)||c>2&&n(r)&&t.charCodeAt(1)===A&&l(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let c,r;for(let g=0;g<t.length;++g){const w=t[g];v(w,"path"),w.length>0&&(c===void 0?c=r=w:c+=`\\${w}`)}if(c===void 0)return".";let a=!0,f=0;if(typeof r=="string"&&l(r.charCodeAt(0))){++f;const g=r.length;g>1&&l(r.charCodeAt(1))&&(++f,g>2&&(l(r.charCodeAt(2))?++f:a=!1))}if(a){for(;f<c.length&&l(c.charCodeAt(f));)f++;f>=2&&(c=`\\${c.slice(f)}`)}return e.$fc.normalize(c)},relative(t,c){if(v(t,"from"),v(c,"to"),t===c)return"";const r=e.$fc.resolve(t),a=e.$fc.resolve(c);if(r===a||(t=r.toLowerCase(),c=a.toLowerCase(),t===c))return"";let f=0;for(;f<t.length&&t.charCodeAt(f)===k;)f++;let g=t.length;for(;g-1>f&&t.charCodeAt(g-1)===k;)g--;const w=g-f;let S=0;for(;S<c.length&&c.charCodeAt(S)===k;)S++;let m=c.length;for(;m-1>S&&c.charCodeAt(m-1)===k;)m--;const E=m-S,D=w<E?w:E;let P=-1,I=0;for(;I<D;I++){const T=t.charCodeAt(f+I);if(T!==c.charCodeAt(S+I))break;T===k&&(P=I)}if(I!==D){if(P===-1)return a}else{if(E>D){if(c.charCodeAt(S+I)===k)return a.slice(S+I+1);if(I===2)return a.slice(S+I)}w>D&&(t.charCodeAt(f+I)===k?P=I:I===2&&(P=3)),P===-1&&(P=0)}let F="";for(I=f+P+1;I<=g;++I)(I===g||t.charCodeAt(I)===k)&&(F+=F.length===0?"..":"\\..");return S+=P,F.length>0?`${F}${a.slice(S,m)}`:(a.charCodeAt(S)===k&&++S,a.slice(S,m))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const c=e.$fc.resolve(t);if(c.length<=2)return t;if(c.charCodeAt(0)===k){if(c.charCodeAt(1)===k){const r=c.charCodeAt(2);if(r!==C&&r!==b)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(n(c.charCodeAt(0))&&c.charCodeAt(1)===A&&c.charCodeAt(2)===k)return`\\\\?\\${c}`;return t},dirname(t){v(t,"path");const c=t.length;if(c===0)return".";let r=-1,a=0;const f=t.charCodeAt(0);if(c===1)return l(f)?t:".";if(l(f)){if(r=a=1,l(t.charCodeAt(1))){let S=2,m=S;for(;S<c&&!l(t.charCodeAt(S));)S++;if(S<c&&S!==m){for(m=S;S<c&&l(t.charCodeAt(S));)S++;if(S<c&&S!==m){for(m=S;S<c&&!l(t.charCodeAt(S));)S++;if(S===c)return t;S!==m&&(r=a=S+1)}}}}else n(f)&&t.charCodeAt(1)===A&&(r=c>2&&l(t.charCodeAt(2))?3:2,a=r);let g=-1,w=!0;for(let S=c-1;S>=a;--S)if(l(t.charCodeAt(S))){if(!w){g=S;break}}else w=!1;if(g===-1){if(r===-1)return".";g=r}return t.slice(0,g)},basename(t,c){c!==void 0&&v(c,"ext"),v(t,"path");let r=0,a=-1,f=!0,g;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(r=2),c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let w=c.length-1,S=-1;for(g=t.length-1;g>=r;--g){const m=t.charCodeAt(g);if(l(m)){if(!f){r=g+1;break}}else S===-1&&(f=!1,S=g+1),w>=0&&(m===c.charCodeAt(w)?--w===-1&&(a=g):(w=-1,a=S))}return r===a?a=S:a===-1&&(a=t.length),t.slice(r,a)}for(g=t.length-1;g>=r;--g)if(l(t.charCodeAt(g))){if(!f){r=g+1;break}}else a===-1&&(f=!1,a=g+1);return a===-1?"":t.slice(r,a)},extname(t){v(t,"path");let c=0,r=-1,a=0,f=-1,g=!0,w=0;t.length>=2&&t.charCodeAt(1)===A&&n(t.charCodeAt(0))&&(c=a=2);for(let S=t.length-1;S>=c;--S){const m=t.charCodeAt(S);if(l(m)){if(!g){a=S+1;break}continue}f===-1&&(g=!1,f=S+1),m===b?r===-1?r=S:w!==1&&(w=1):r!==-1&&(w=-1)}return r===-1||f===-1||w===0||w===1&&r===f-1&&r===a+1?"":t.slice(r,f)},format:u.bind(null,"\\"),parse(t){v(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const r=t.length;let a=0,f=t.charCodeAt(0);if(r===1)return l(f)?(c.root=c.dir=t,c):(c.base=c.name=t,c);if(l(f)){if(a=1,l(t.charCodeAt(1))){let P=2,I=P;for(;P<r&&!l(t.charCodeAt(P));)P++;if(P<r&&P!==I){for(I=P;P<r&&l(t.charCodeAt(P));)P++;if(P<r&&P!==I){for(I=P;P<r&&!l(t.charCodeAt(P));)P++;P===r?a=P:P!==I&&(a=P+1)}}}}else if(n(f)&&t.charCodeAt(1)===A){if(r<=2)return c.root=c.dir=t,c;if(a=2,l(t.charCodeAt(2))){if(r===3)return c.root=c.dir=t,c;a=3}}a>0&&(c.root=t.slice(0,a));let g=-1,w=a,S=-1,m=!0,E=t.length-1,D=0;for(;E>=a;--E){if(f=t.charCodeAt(E),l(f)){if(!m){w=E+1;break}continue}S===-1&&(m=!1,S=E+1),f===b?g===-1?g=E:D!==1&&(D=1):g!==-1&&(D=-1)}return S!==-1&&(g===-1||D===0||D===1&&g===S-1&&g===w+1?c.base=c.name=t.slice(w,S):(c.name=t.slice(w,g),c.base=t.slice(w,S),c.ext=t.slice(g,S))),w>0&&w!==a?c.dir=t.slice(0,w-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(h){const t=/\\/g;return()=>{const c=d.cwd().replace(t,"/");return c.slice(c.indexOf("/"))}}return()=>d.cwd()})();e.$gc={resolve(...t){let c="",r=!1;for(let a=t.length-1;a>=-1&&!r;a--){const f=a>=0?t[a]:s();v(f,"path"),f.length!==0&&(c=`${f}/${c}`,r=f.charCodeAt(0)===$)}return c=i(c,!r,"/",o),r?`/${c}`:c.length>0?c:"."},normalize(t){if(v(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===$,r=t.charCodeAt(t.length-1)===$;return t=i(t,!c,"/",o),t.length===0?c?"/":r?"./":".":(r&&(t+="/"),c?`/${t}`:t)},isAbsolute(t){return v(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let c;for(let r=0;r<t.length;++r){const a=t[r];v(a,"path"),a.length>0&&(c===void 0?c=a:c+=`/${a}`)}return c===void 0?".":e.$gc.normalize(c)},relative(t,c){if(v(t,"from"),v(c,"to"),t===c||(t=e.$gc.resolve(t),c=e.$gc.resolve(c),t===c))return"";const r=1,a=t.length,f=a-r,g=1,w=c.length-g,S=f<w?f:w;let m=-1,E=0;for(;E<S;E++){const P=t.charCodeAt(r+E);if(P!==c.charCodeAt(g+E))break;P===$&&(m=E)}if(E===S)if(w>S){if(c.charCodeAt(g+E)===$)return c.slice(g+E+1);if(E===0)return c.slice(g+E)}else f>S&&(t.charCodeAt(r+E)===$?m=E:E===0&&(m=0));let D="";for(E=r+m+1;E<=a;++E)(E===a||t.charCodeAt(E)===$)&&(D+=D.length===0?"..":"/..");return`${D}${c.slice(g+m)}`},toNamespacedPath(t){return t},dirname(t){if(v(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===$;let r=-1,a=!0;for(let f=t.length-1;f>=1;--f)if(t.charCodeAt(f)===$){if(!a){r=f;break}}else a=!1;return r===-1?c?"/":".":c&&r===1?"//":t.slice(0,r)},basename(t,c){c!==void 0&&v(c,"ext"),v(t,"path");let r=0,a=-1,f=!0,g;if(c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let w=c.length-1,S=-1;for(g=t.length-1;g>=0;--g){const m=t.charCodeAt(g);if(m===$){if(!f){r=g+1;break}}else S===-1&&(f=!1,S=g+1),w>=0&&(m===c.charCodeAt(w)?--w===-1&&(a=g):(w=-1,a=S))}return r===a?a=S:a===-1&&(a=t.length),t.slice(r,a)}for(g=t.length-1;g>=0;--g)if(t.charCodeAt(g)===$){if(!f){r=g+1;break}}else a===-1&&(f=!1,a=g+1);return a===-1?"":t.slice(r,a)},extname(t){v(t,"path");let c=-1,r=0,a=-1,f=!0,g=0;for(let w=t.length-1;w>=0;--w){const S=t.charCodeAt(w);if(S===$){if(!f){r=w+1;break}continue}a===-1&&(f=!1,a=w+1),S===b?c===-1?c=w:g!==1&&(g=1):c!==-1&&(g=-1)}return c===-1||a===-1||g===0||g===1&&c===a-1&&c===r+1?"":t.slice(c,a)},format:u.bind(null,"/"),parse(t){v(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const r=t.charCodeAt(0)===$;let a;r?(c.root="/",a=1):a=0;let f=-1,g=0,w=-1,S=!0,m=t.length-1,E=0;for(;m>=a;--m){const D=t.charCodeAt(m);if(D===$){if(!S){g=m+1;break}continue}w===-1&&(S=!1,w=m+1),D===b?f===-1?f=m:E!==1&&(E=1):f!==-1&&(E=-1)}if(w!==-1){const D=g===0&&r?1:g;f===-1||E===0||E===1&&f===w-1&&f===g+1?c.base=c.name=t.slice(D,w):(c.name=t.slice(D,f),c.base=t.slice(D,w),c.ext=t.slice(f,w))}return g>0?c.dir=t.slice(0,g-1):r&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=h?e.$fc.normalize:e.$gc.normalize,e.$ic=h?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=h?e.$fc.join:e.$gc.join,e.$kc=h?e.$fc.resolve:e.$gc.resolve,e.$lc=h?e.$fc.relative:e.$gc.relative,e.$mc=h?e.$fc.dirname:e.$gc.dirname,e.$nc=h?e.$fc.basename:e.$gc.basename,e.$oc=h?e.$fc.extname:e.$gc.extname,e.$pc=h?e.$fc.format:e.$gc.format,e.$qc=h?e.$fc.parse:e.$gc.parse,e.$rc=h?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=h?e.$fc.sep:e.$gc.sep,e.$tc=h?e.$fc.delimiter:e.$gc.delimiter}),define(Se[132],De([1,0,46,17]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=b,e.$hr=$,e.$ir=k,e.$jr=A,e.$kr=C,e.$lr=p,e.$mr=y,e.$nr=v,e.$or=h,e.$pr=l,e.$qr=f,e.$rr=g,e.$sr=w;const L=new d.$V(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),R=new d.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),N=new d.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(S,m,E=!1){const D=S||"",P=m||"",I=L.value.collator.compare(D,P);return L.value.collatorIsNumeric&&I===0&&D!==P?D<P?-1:1:I}function $(S,m){const E=R.value.collator;return S=S||"",m=m||"",u(E,S,m)}function k(S,m){const E=R.value.collator;return S=S||"",m=m||"",r(S,m)||u(E,S,m)}function A(S,m){const E=R.value.collator;return S=S||"",m=m||"",c(S,m)||u(E,S,m)}function C(S,m){return S=S||"",m=m||"",S===m?0:S<m?-1:1}function p(S,m){const[E,D]=n(S),[P,I]=n(m);let F=L.value.collator.compare(D,I);if(F===0){if(L.value.collatorIsNumeric&&D!==I)return D<I?-1:1;if(F=L.value.collator.compare(E,P),L.value.collatorIsNumeric&&F===0&&E!==P)return E<P?-1:1}return F}function y(S,m){S=S||"",m=m||"";const E=i(S),D=i(m),P=R.value.collator,I=N.value.collator;return u(I,E,D)||u(P,S,m)}function v(S,m){S=S||"",m=m||"";const E=i(S),D=i(m),P=R.value.collator,I=N.value.collator;return u(I,E,D)||r(S,m)||u(P,S,m)}function h(S,m){S=S||"",m=m||"";const E=i(S),D=i(m),P=R.value.collator,I=N.value.collator;return u(I,E,D)||c(S,m)||u(P,S,m)}function l(S,m){S=S||"",m=m||"";const E=i(S).toLowerCase(),D=i(m).toLowerCase();return E!==D?E<D?-1:1:S!==m?S<m?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function n(S,m=!1){const E=S?o.exec(S):[];let D=[E&&E[1]||"",E&&E[3]||""];return m&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function i(S){const m=S?o.exec(S):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function u(S,m,E){const D=S.compare(m,E);return D!==0?D:m.length!==E.length?m.length<E.length?-1:1:0}function s(S){const m=S.charAt(0);return m.toLocaleUpperCase()!==m}function t(S){const m=S.charAt(0);return m.toLocaleLowerCase()!==m}function c(S,m){return s(S)&&t(m)?-1:t(S)&&s(m)?1:0}function r(S,m){return t(S)&&s(m)?-1:s(S)&&t(m)?1:0}function a(S,m,E=!1){return E||(S=S&&S.toLowerCase(),m=m&&m.toLowerCase()),S===m?0:S<m?-1:1}function f(S,m,E=!1){const D=S.split(O.sep),P=m.split(O.sep),I=D.length-1,F=P.length-1;let T,z;for(let M=0;;M++){if(T=I===M,z=F===M,T&&z)return b(D[M],P[M],E);if(T)return-1;if(z)return 1;const j=a(D[M],P[M],E);if(j!==0)return j}}function g(S,m,E){const D=S.toLowerCase(),P=m.toLowerCase(),I=w(S,m,E);if(I)return I;const F=D.endsWith(E),T=P.endsWith(E);if(F!==T)return F?-1:1;const z=b(D,P);return z!==0?z:D.localeCompare(P)}function w(S,m,E){const D=S.toLowerCase(),P=m.toLowerCase(),I=D.startsWith(E),F=P.startsWith(E);if(I!==F)return I?-1:1;if(I&&F){if(D.length<P.length)return-1;if(D.length>P.length)return 1}return 0}}),define(Se[31],De([1,0,17,12,14,18]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=N,e.$pg=b,e.$qg=$,e.$rg=k,e.$sg=A,e.$tg=v,e.$ug=h,e.$vg=l,e.$wg=o,e.$xg=n,e.$yg=i,e.$zg=u,e.$Ag=s,e.$Bg=t,e.$Cg=c,e.$Dg=r,e.$Eg=g;function N(w){return w===47||w===92}function b(w){return w.replace(/[\\/]/g,d.$gc.sep)}function $(w){return w.indexOf("/")===-1&&(w=b(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function k(w,S=d.$gc.sep){if(!w)return"";const m=w.length,E=w.charCodeAt(0);if(N(E)){if(N(w.charCodeAt(1))&&!N(w.charCodeAt(2))){let P=3;const I=P;for(;P<m&&!N(w.charCodeAt(P));P++);if(I!==P&&!N(w.charCodeAt(P+1))){for(P+=1;P<m;P++)if(N(w.charCodeAt(P)))return w.slice(0,P+1).replace(/[\\/]/g,S)}}return S}else if(o(E)&&w.charCodeAt(1)===58)return N(w.charCodeAt(2))?w.slice(0,2)+S:w.slice(0,2);let D=w.indexOf("://");if(D!==-1){for(D+=3;D<m;D++)if(N(w.charCodeAt(D)))return w.slice(0,D+1)}return""}function A(w){if(!O.$i||!w||w.length<5)return!1;let S=w.charCodeAt(0);if(S!==92||(S=w.charCodeAt(1),S!==92))return!1;let m=2;const E=m;for(;m<w.length&&(S=w.charCodeAt(m),S!==92);m++);return!(E===m||(S=w.charCodeAt(m+1),isNaN(S)||S===92))}const C=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(w,S=O.$i){const m=S?C:p;return!(!w||w.length===0||/^\s+$/.test(w)||(m.lastIndex=0,m.test(w))||S&&y.test(w)||w==="."||w===".."||S&&w[w.length-1]==="."||S&&w.length!==w.trim().length||w.length>255)}function h(w,S,m){const E=w===S;return!m||E?E:!w||!S?!1:(0,L.$xf)(w,S)}function l(w,S,m,E=d.sep){if(w===S)return!0;if(!w||!S||S.length>w.length)return!1;if(m){if(!(0,L.$yf)(w,S))return!1;if(S.length===w.length)return!0;let P=S.length;return S.charAt(S.length-1)===E&&P--,w.charAt(P)===E}return S.charAt(S.length-1)!==E&&(S+=E),w.indexOf(S)===0}function o(w){return w>=65&&w<=90||w>=97&&w<=122}function n(w,S){return O.$i&&w.endsWith(":")&&(w+=d.sep),(0,d.$ic)(w)||(w=(0,d.$jc)(S,w)),w=(0,d.$hc)(w),i(w)}function i(w){return O.$i?(w=(0,L.$ff)(w,d.sep),w.endsWith(":")&&(w+=d.sep)):(w=(0,L.$ff)(w,d.sep),w||(w=d.sep)),w}function u(w){const S=(0,d.$hc)(w);return O.$i?w.length>3?!1:s(S)&&(w.length===2||S.charCodeAt(2)===92):S===d.$gc.sep}function s(w,S=O.$i){return S?o(w.charCodeAt(0))&&w.charCodeAt(1)===58:!1}function t(w,S=O.$i){return s(w,S)?w[0]:void 0}function c(w,S,m){return S.length>w.length?-1:w===S?0:(m&&(w=w.toLowerCase(),S=S.toLowerCase()),w.indexOf(S))}function r(w){const S=w.split(":");let m,E,D;for(const P of S){const I=Number(P);(0,R.$ag)(I)?E===void 0?E=I:D===void 0&&(D=I):m=m?[m,P].join(":"):P}if(!m)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:m,line:E!==void 0?E:void 0,column:D!==void 0?D:E!==void 0?1:void 0}}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",f="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function g(w,S,m=8){let E="";for(let P=0;P<m;P++){let I;P===0&&O.$i&&!S&&(m===3||m===4)?I=f:I=a,E+=I.charAt(Math.floor(Math.random()*I.length))}let D;return S?D=`${S}-${E}`:D=E,w?(0,d.$jc)(w,D):D}}),define(Se[133],De([1,0,132,127,57,17,12,14]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=A,e.$ur=l,e.$vr=r,e.$wr=E,e.$xr=z,e.$yr=j;const $=0,k=[$,[]];function A(U,Z,ie,q){if(!U||!Z)return k;const G=U.length,x=Z.length;if(G<x)return k;const ne=U.toLowerCase();return C(Z,ie,x,U,ne,G,q)}function C(U,Z,ie,q,G,x,ne){const be=[],ae=[];for(let _=0;_<ie;_++){const pe=_*x,ue=pe-x,ce=_>0,oe=U[_],le=Z[_];for(let K=0;K<x;K++){const se=K>0,$e=pe+K,ve=$e-1,Re=ue+K-1,ge=se?be[ve]:0,Ie=ce&&se?be[Re]:0,Ae=ce&&se?ae[Re]:0;let ze;!Ie&&ce?ze=0:ze=p(oe,le,q,G,K,Ae),ze&&Ie+ze>=ge&&(ne||ce||G.startsWith(Z,K))?(ae[$e]=Ae+1,be[$e]=Ie+ze):(ae[$e]=$,be[$e]=ge)}}const Ce=[];let ee=ie-1,B=x-1;for(;ee>=0&&B>=0;){const _=ee*x+B;ae[_]===$||(Ce.push(B),ee--),B--}return[be[ie*x-1],Ce.reverse()]}function p(U,Z,ie,q,G,x){let ne=0;if(!y(Z,q[G]))return ne;if(ne+=1,x>0&&(ne+=x*5),U===ie[G]&&(ne+=1),G===0)ne+=8;else{const be=v(ie.charCodeAt(G-1));be?ne+=be:(0,O.$Bk)(ie.charCodeAt(G))&&x===0&&(ne+=2)}return ne}function y(U,Z){return U===Z?!0:U==="/"||U==="\\"?Z==="/"||Z==="\\":!1}function v(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const h=[void 0,[]];function l(U,Z,ie=0,q=0){const G=Z;return G.values&&G.values.length>1?o(U,G.values,ie,q):n(U,Z,ie,q)}function o(U,Z,ie,q){let G=0;const x=[];for(const ne of Z){const[be,ae]=n(U,ne,ie,q);if(typeof be!="number")return h;G+=be,x.push(...ae)}return[G,S(x)]}function n(U,Z,ie,q){const G=(0,O.$Kk)(Z.original,Z.originalLowercase,ie,U,U.toLowerCase(),q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return G?[G[0],(0,O.$Hk)(G)]:h}const i=Object.freeze({score:0}),u=1<<18,s=1<<17,t=65536;function c(U,Z,ie,q){const G=q.values?q.values:[q];return(0,L.$kj)({[q.normalized]:{values:G.map(ne=>({value:ne.normalized,expectContiguousMatch:ne.expectContiguousMatch})),label:U,description:Z,allowNonContiguousMatches:ie}})}function r(U,Z,ie,q,G){if(!U||!Z.normalized)return i;const x=q.getItemLabel(U);if(!x)return i;const ne=q.getItemDescription(U),be=c(x,ne,ie,Z),ae=G[be];if(ae)return ae;const Ce=a(x,ne,q.getItemPath(U),Z,ie);return G[be]=Ce,Ce}function a(U,Z,ie,q,G){const x=!ie||!q.containsPathSeparator;return ie&&(N.$k?q.pathNormalized===ie:(0,b.$xf)(q.pathNormalized,ie))?{score:u,labelMatch:[{start:0,end:U.length}],descriptionMatch:Z?[{start:0,end:Z.length}]:void 0}:q.values&&q.values.length>1?f(U,Z,ie,q.values,x,G):g(U,Z,ie,q,x,G)}function f(U,Z,ie,q,G,x){let ne=0;const be=[],ae=[];for(const Ce of q){const{score:ee,labelMatch:B,descriptionMatch:_}=g(U,Z,ie,Ce,G,x);if(ee===$)return i;ne+=ee,B&&be.push(...B),_&&ae.push(..._)}return{score:ne,labelMatch:S(be),descriptionMatch:S(ae)}}function g(U,Z,ie,q,G,x){if(G||!Z){const[ne,be]=A(U,q.normalized,q.normalizedLowercase,x&&!q.expectContiguousMatch);if(ne){const ae=(0,O.$yk)(q.normalized,U);let Ce;if(ae){Ce=s;const ee=Math.round(q.normalized.length/U.length*100);Ce+=ee}else Ce=t;return{score:Ce+ne,labelMatch:ae||w(be)}}}if(Z){let ne=Z;ie&&(ne=`${Z}${R.sep}`);const be=ne.length,ae=`${ne}${U}`,[Ce,ee]=A(ae,q.normalized,q.normalizedLowercase,x&&!q.expectContiguousMatch);if(Ce){const B=w(ee),_=[],pe=[];return B.forEach(ue=>{ue.start<be&&ue.end>be?(_.push({start:0,end:ue.end-be}),pe.push({start:ue.start,end:be})):ue.start>=be?_.push({start:ue.start-be,end:ue.end-be}):pe.push(ue)}),{score:Ce,labelMatch:_,descriptionMatch:pe}}}return i}function w(U){const Z=[];if(!U)return Z;let ie;for(const q of U)ie&&ie.end===q?ie.end+=1:(ie={start:q,end:q+1},Z.push(ie));return Z}function S(U){const Z=U.sort((G,x)=>G.start-x.start),ie=[];let q;for(const G of Z)!q||!m(q,G)?(q=G,ie.push(G)):(q.start=Math.min(q.start,G.start),q.end=Math.max(q.end,G.end));return ie}function m(U,Z){return!(U.end<Z.start||Z.end<U.start)}function E(U,Z,ie,q,G,x){const ne=r(U,ie,q,G,x),be=r(Z,ie,q,G,x),ae=ne.score,Ce=be.score;if((ae===u||Ce===u)&&ae!==Ce)return ae===u?-1:1;if(ae>t||Ce>t){if(ae!==Ce)return ae>Ce?-1:1;if(ae<s&&Ce<s){const oe=P(ne.labelMatch,be.labelMatch);if(oe!==0)return oe}const ue=G.getItemLabel(U)||"",ce=G.getItemLabel(Z)||"";if(ue.length!==ce.length)return ue.length-ce.length}if(ae!==Ce)return ae>Ce?-1:1;const ee=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0,B=Array.isArray(be.labelMatch)&&be.labelMatch.length>0;if(ee&&!B)return-1;if(B&&!ee)return 1;const _=D(U,ne,G),pe=D(Z,be,G);return _&&pe&&_!==pe?pe>_?-1:1:I(U,Z,ie,G)}function D(U,Z,ie){let q=-1,G=-1;if(Z.descriptionMatch&&Z.descriptionMatch.length?q=Z.descriptionMatch[0].start:Z.labelMatch&&Z.labelMatch.length&&(q=Z.labelMatch[0].start),Z.labelMatch&&Z.labelMatch.length){if(G=Z.labelMatch[Z.labelMatch.length-1].end,Z.descriptionMatch&&Z.descriptionMatch.length){const x=ie.getItemDescription(U);x&&(G+=x.length)}}else Z.descriptionMatch&&Z.descriptionMatch.length&&(G=Z.descriptionMatch[Z.descriptionMatch.length-1].end);return G-q}function P(U,Z){if(!U&&!Z||(!U||!U.length)&&(!Z||!Z.length))return 0;if(!Z||!Z.length)return-1;if(!U||!U.length)return 1;const ie=U[0].start,G=U[U.length-1].end-ie,x=Z[0].start,be=Z[Z.length-1].end-x;return G===be?0:be<G?1:-1}function I(U,Z,ie,q){const G=q.getItemLabel(U)||"",x=q.getItemLabel(Z)||"",ne=q.getItemDescription(U),be=q.getItemDescription(Z),ae=G.length+(ne?ne.length:0),Ce=x.length+(be?be.length:0);if(ae!==Ce)return ae-Ce;const ee=q.getItemPath(U),B=q.getItemPath(Z);return ee&&B&&ee.length!==B.length?ee.length-B.length:G!==x?(0,d.$rr)(G,x,ie.normalized):ne&&be&&ne!==be?(0,d.$rr)(ne,be,ie.normalized):ee&&B&&ee!==B?(0,d.$rr)(ee,B,ie.normalized):0}function F(U){return U.startsWith('"')&&U.endsWith('"')}const T=" ";function z(U){typeof U!="string"&&(U="");const Z=U.toLowerCase(),{pathNormalized:ie,normalized:q,normalizedLowercase:G}=M(U),x=ie.indexOf(R.sep)>=0,ne=F(U);let be;const ae=U.split(T);if(ae.length>1)for(const Ce of ae){const ee=F(Ce),{pathNormalized:B,normalized:_,normalizedLowercase:pe}=M(Ce);_&&(be||(be=[]),be.push({original:Ce,originalLowercase:Ce.toLowerCase(),pathNormalized:B,normalized:_,normalizedLowercase:pe,expectContiguousMatch:ee}))}return{original:U,originalLowercase:Z,pathNormalized:ie,normalized:q,normalizedLowercase:G,values:be,containsPathSeparator:x,expectContiguousMatch:ne}}function M(U){let Z;N.$i?Z=U.replace(/\//g,R.sep):Z=U.replace(/\\/g,R.sep);const ie=(0,b.$hf)(Z).replace(/\s|"/g,"");return{pathNormalized:Z,normalized:ie,normalizedLowercase:ie.toLowerCase()}}function j(U){return Array.isArray(U)?z(U.map(Z=>Z.original).join(T)):z(U.original)}}),define(Se[101],De([1,0,17]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0,e.$Rs=R,e.$Ss=N,e.$Ts=b,e.$Us=k,e.$Qs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(A){const C=(0,d.$oc)(A),p=O[C.toLowerCase()];return p!==void 0?p:N(A)}function N(A){const C=(0,d.$oc)(A);return L[C.toLowerCase()]}function b(A){for(const C in L)if(L[C]===A)return C}const $=/^(.+)\/(.+?)(;.+)?$/;function k(A,C){const p=$.exec(A);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:C?void 0:A}}),define(Se[102],De([1,0,12]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$mm=R,e.$nm=N;var O;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(O||(e.Source=O={}));var L;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function R(b,...$){const k=$.reduce((p,y)=>(p[y]=!0,p),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(p=>!k[p]).forEach(p=>{for(let y=0;y<A.length;y++)if(p.search(A[y])!==-1){delete b[p];break}})}function N(b){b&&(delete b.DEBUG,d.$j&&delete b.DYLD_LIBRARY_PATH,d.$k&&delete b.LD_PRELOAD)}}),define(Se[2],De([1,0,17,12]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=v,e.$wc=u;const L=/^\w[\w\d+.-]*$/,R=/^\//,N=/^\/\//;function b(a,f){if(!a.scheme&&f)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!L.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!R.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(N.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(a,f){return!a&&!f?"file":a}function k(a,f){switch(a){case"https":case"http":case"file":f?f[0]!==C&&(f=C+f):f=C;break}return f}const A="",C="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(f){return f instanceof y?!0:f?typeof f.authority=="string"&&typeof f.fragment=="string"&&typeof f.path=="string"&&typeof f.query=="string"&&typeof f.scheme=="string"&&typeof f.fsPath=="string"&&typeof f.with=="function"&&typeof f.toString=="function":!1}constructor(f,g,w,S,m,E=!1){typeof f=="object"?(this.scheme=f.scheme||A,this.authority=f.authority||A,this.path=f.path||A,this.query=f.query||A,this.fragment=f.fragment||A):(this.scheme=$(f,E),this.authority=g||A,this.path=k(this.scheme,w||A),this.query=S||A,this.fragment=m||A,b(this,E))}get fsPath(){return u(this,!1)}with(f){if(!f)return this;let{scheme:g,authority:w,path:S,query:m,fragment:E}=f;return g===void 0?g=this.scheme:g===null&&(g=A),w===void 0?w=this.authority:w===null&&(w=A),S===void 0?S=this.path:S===null&&(S=A),m===void 0?m=this.query:m===null&&(m=A),E===void 0?E=this.fragment:E===null&&(E=A),g===this.scheme&&w===this.authority&&S===this.path&&m===this.query&&E===this.fragment?this:new l(g,w,S,m,E)}static parse(f,g=!1){const w=p.exec(f);return w?new l(w[2]||A,r(w[4]||A),r(w[5]||A),r(w[7]||A),r(w[9]||A),g):new l(A,A,A,A,A)}static file(f){let g=A;if(O.$i&&(f=f.replace(/\\/g,C)),f[0]===C&&f[1]===C){const w=f.indexOf(C,2);w===-1?(g=f.substring(2),f=C):(g=f.substring(2,w),f=f.substring(w)||C)}return new l("file",g,f,A,A)}static from(f,g){return new l(f.scheme,f.authority,f.path,f.query,f.fragment,g)}static joinPath(f,...g){if(!f.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return O.$i&&f.scheme==="file"?w=y.file(d.$fc.join(u(f,!0),...g)).path:w=d.$gc.join(f.path,...g),f.with({path:w})}toString(f=!1){return s(this,f)}toJSON(){return this}static revive(f){if(f){if(f instanceof y)return f;{const g=new l(f);return g._formatted=f.external??null,g._fsPath=f._sep===h?f.fsPath??null:null,g}}else return f}}e.URI=y;function v(a){return!a||typeof a!="object"?!1:typeof a.scheme=="string"&&(typeof a.authority=="string"||typeof a.authority>"u")&&(typeof a.path=="string"||typeof a.path>"u")&&(typeof a.query=="string"||typeof a.query>"u")&&(typeof a.fragment=="string"||typeof a.fragment>"u")}const h=O.$i?1:void 0;class l extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(f=!1){return f?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const f={$mid:1};return this._fsPath&&(f.fsPath=this._fsPath,f._sep=h),this._formatted&&(f.external=this._formatted),this.path&&(f.path=this.path),this.scheme&&(f.scheme=this.scheme),this.authority&&(f.authority=this.authority),this.query&&(f.query=this.query),this.fragment&&(f.fragment=this.fragment),f}}const o={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(a,f,g){let w,S=-1;for(let m=0;m<a.length;m++){const E=a.charCodeAt(m);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||f&&E===47||g&&E===91||g&&E===93||g&&E===58)S!==-1&&(w+=encodeURIComponent(a.substring(S,m)),S=-1),w!==void 0&&(w+=a.charAt(m));else{w===void 0&&(w=a.substr(0,m));const D=o[E];D!==void 0?(S!==-1&&(w+=encodeURIComponent(a.substring(S,m)),S=-1),w+=D):S===-1&&(S=m)}}return S!==-1&&(w+=encodeURIComponent(a.substring(S))),w!==void 0?w:a}function i(a){let f;for(let g=0;g<a.length;g++){const w=a.charCodeAt(g);w===35||w===63?(f===void 0&&(f=a.substr(0,g)),f+=o[w]):f!==void 0&&(f+=a[g])}return f!==void 0?f:a}function u(a,f){let g;return a.authority&&a.path.length>1&&a.scheme==="file"?g=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?f?g=a.path.substr(1):g=a.path[1].toLowerCase()+a.path.substr(2):g=a.path,O.$i&&(g=g.replace(/\//g,"\\")),g}function s(a,f){const g=f?i:n;let w="",{scheme:S,authority:m,path:E,query:D,fragment:P}=a;if(S&&(w+=S,w+=":"),(m||S==="file")&&(w+=C,w+=C),m){let I=m.indexOf("@");if(I!==-1){const F=m.substr(0,I);m=m.substr(I+1),I=F.lastIndexOf(":"),I===-1?w+=g(F,!1,!1):(w+=g(F.substr(0,I),!1,!1),w+=":",w+=g(F.substr(I+1),!1,!0)),w+="@"}m=m.toLowerCase(),I=m.lastIndexOf(":"),I===-1?w+=g(m,!1,!0):(w+=g(m.substr(0,I),!1,!0),w+=m.substr(I))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const I=E.charCodeAt(1);I>=65&&I<=90&&(E=`/${String.fromCharCode(I+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const I=E.charCodeAt(0);I>=65&&I<=90&&(E=`${String.fromCharCode(I+32)}:${E.substr(2)}`)}w+=g(E,!0,!1)}return D&&(w+="?",w+=g(D,!1,!1)),P&&(w+="#",w+=f?P:n(P,!1,!1)),w}function t(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+t(a.substr(3)):a}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(a){return a.match(c)?a.replace(c,f=>t(f)):a}}),define(Se[197],De([1,0,2]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=O,e.$Wq=L,e.$Xq=R,e.log=b;function O(k){const A=k;return A&&typeof A.type=="string"&&typeof A.severity=="string"}function L(k){const A=[];let C;try{const p=JSON.parse(k.arguments),y=p[p.length-1];y&&y.__$stack&&(p.pop(),C=y.__$stack),A.push(...p)}catch{A.push("Unable to log remote console arguments",k.arguments)}return{args:A,stack:C}}function R(k){if(typeof k!="string")return R(L(k).stack);const A=k;if(A){const C=N(A),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(p&&p.length===4)return{uri:d.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}function N(k){if(!k)return k;const A=k.indexOf(`
`);return A===-1?k:k.substring(0,A)}function b(k,A){const{args:C,stack:p}=L(k),y=typeof C[0]=="string"&&C.length===1;let v=N(p);v&&(v=`(${v.trim()})`);let h=[];if(typeof C[0]=="string"?v&&y?h=[`%c[${A}] %c${C[0]} %c${v}`,$("blue"),$(""),$("grey")]:h=[`%c[${A}] %c${C[0]}`,$("blue"),$(""),...C.slice(1)]:h=[`%c[${A}]%`,$("blue"),...C],v&&!y&&h.push(v),typeof console[k.severity]!="function")throw new Error("Unknown console method");console[k.severity].apply(console,h)}function $(k){return`color: ${k}`}}),define(Se[58],De([1,0,21,2]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=L,e.$5h=R,e.$6h=b;function L($){return JSON.stringify($,N)}function R($){let k=JSON.parse($);return k=b(k),k}function N($,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function b($,k=0){if(!$||k>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return O.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof d.$Fe||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let A=0;A<$.length;++A)$[A]=b($[A],k+1);else for(const A in $)Object.hasOwnProperty.call($,A)&&($[A]=b($[A],k+1))}return $}}),define(Se[15],De([1,0,13,12,14,2,17]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Jg=e.$Ig=e.$Hg=e.Schemas=void 0,e.$Fg=$,e.$Gg=k,e.$Kg=C;var b;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatCodeBlock="vscode-chat-code-block",v.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm",v.commentsInput="comment",v.codeSetting="code-setting"})(b||(e.Schemas=b={}));function $(v,h){return R.URI.isUri(v)?(0,L.$xf)(v.scheme,h):(0,L.$yf)(v,h+":")}function k(v,...h){return h.some(l=>$(v,l))}e.$Hg="vscode-tkn",e.$Ig="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h,l){this.f=C(h,l)}getServerRootPath(){return this.f}get g(){return N.$gc.join(this.f,b.vscodeRemoteResource)}set(h,l,o){this.a[h]=l,this.b[h]=o}setConnectionToken(h,l){this.c[h]=l}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(s){return d.$1(s),h}const l=h.authority;let o=this.a[l];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const n=this.b[l],i=this.c[l];let u=`path=${encodeURIComponent(h.path)}`;return typeof i=="string"&&(u+=`&${e.$Ig}=${encodeURIComponent(i)}`),R.URI.from({scheme:O.$o?this.d:b.vscodeRemoteResource,authority:`${o}:${n}`,path:this.g,query:u})}}e.$Jg=new A;function C(v,h){return N.$gc.join(h??"/",`${v.quality??"oss"}-${v.commit??"dev"}`)}e.$Lg="vs/../../extensions",e.$Mg="vs/../../node_modules",e.$Ng="vs/../../node_modules.asar",e.$Og="vs/../../node_modules.asar.unpacked",e.$Pg="vscode-app";class p{static{this.a=e.$Pg}asBrowserUri(h){const l=this.b(h,he);return this.uriToBrowserUri(l)}uriToBrowserUri(h){return h.scheme===b.vscodeRemote?e.$Jg.rewrite(h):h.scheme===b.file&&(O.$m||O.$q===`${b.vscodeFileResource}://${p.a}`)?h.with({scheme:b.vscodeFileResource,authority:h.authority||p.a,query:null,fragment:null}):h}asFileUri(h){const l=this.b(h,he);return this.uriToFileUri(l)}uriToFileUri(h){return h.scheme===b.vscodeFileResource?h.with({scheme:b.file,authority:h.authority!==p.a?h.authority:null,query:null,fragment:null}):h}b(h,l){return R.URI.isUri(h)?h:R.URI.parse(l.toUrl(h))}}e.$Qg=new p;var y;(function(v){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(h.get("3"));const l="vscode-coi";function o(i){let u;typeof i=="string"?u=new URL(i).searchParams:i instanceof URL?u=i.searchParams:R.URI.isUri(i)&&(u=new URL(i.toString(!0)).searchParams);const s=u?.get(l);if(s)return h.get(s)}v.getHeadersFromQuery=o;function n(i,u,s){if(!globalThis.crossOriginIsolated)return;const t=u&&s?"3":s?"2":"1";i instanceof URLSearchParams?i.set(l,t):i[l]=t}v.addSearchParam=n})(y||(e.COI=y={}))}),define(Se[198],De([1,0,163,15,12,2]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8D=A;class N{constructor(p,y,v){this.id=p,this.dependencies=y,this.callback=v}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,y,v)=>{typeof p!="string"&&(v=y,y=p,p=null),(typeof y!="object"||!Array.isArray(y))&&(v=y,y=null),this.c.push(new N(p,y,v))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const y=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!y)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h(p){return new Promise((y,v)=>{const h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript");const l=()=>{h.removeEventListener("load",o),h.removeEventListener("error",n)},o=i=>{l(),y(this.c.pop())},n=i=>{l(),v(i)};h.addEventListener("load",o),h.addEventListener("error",n),this.f&&(p=this.f.createScriptURL(p)),h.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(h)})}i(p){return new Promise((y,v)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),y(this.c.pop())}catch(h){v(h)}})}async j(p){try{const y=globalThis._VSCODE_NODE_MODULES.fs,v=globalThis._VSCODE_NODE_MODULES.vm,h=globalThis._VSCODE_NODE_MODULES.module,l=R.URI.parse(p).fsPath,o=y.readFileSync(l).toString(),n=h.wrap(o.replace(/^#!.*/,""));return new v.Script(n).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const $=new Map;let k={};typeof globalThis.require=="object"&&(k=globalThis.require.paths??{});async function A(C,p,y){if(d.$T){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),k[C]&&(C=k[C]);const v=`${C}/${p}`;if($.has(v))return $.get(v);let h;if(/^\w[\w\d+.-]*:\/\//.test(v))h=v;else{const i=`${y&&!L.$o?O.$Ng:O.$Mg}/${v}`;h=O.$Qg.asBrowserUri(i).toString(!0)}const l=b.INSTANCE.load(h);return $.set(v,l),l}else return await new Promise((v,h)=>{he([C],v,h)})}}),define(Se[23],De([1,0,31,15,17,12,14,2]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=void 0,e.$Xg=$,e.$gh=A,e.$hh=p;function $(y){return(0,b.$wc)(y,!0)}class k{constructor(v){this.a=v}compare(v,h,l=!1){return v===h?0:(0,N.$qf)(this.getComparisonKey(v,l),this.getComparisonKey(h,l))}isEqual(v,h,l=!1){return v===h?!0:!v||!h?!1:this.getComparisonKey(v,l)===this.getComparisonKey(h,l)}getComparisonKey(v,h=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,h,l=!1){if(v.scheme===h.scheme){if(v.scheme===O.Schemas.file)return d.$vg($(v),$(h),this.a(v))&&v.query===h.query&&(l||v.fragment===h.fragment);if((0,e.$ch)(v.authority,h.authority))return d.$vg(v.path,h.path,this.a(v),"/")&&v.query===h.query&&(l||v.fragment===h.fragment)}return!1}joinPath(v,...h){return b.URI.joinPath(v,...h)}basenameOrAuthority(v){return(0,e.$7g)(v)||v.authority}basename(v){return L.$gc.basename(v.path)}extname(v){return L.$gc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let h;return v.scheme===O.Schemas.file?h=b.URI.file(L.$mc($(v))).path:(h=L.$gc.dirname(v.path),v.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),h="/")),v.with({path:h})}normalizePath(v){if(!v.path.length)return v;let h;return v.scheme===O.Schemas.file?h=b.URI.file(L.$hc($(v))).path:h=L.$gc.normalize(v.path),v.with({path:h})}relativePath(v,h){if(v.scheme!==h.scheme||!(0,e.$ch)(v.authority,h.authority))return;if(v.scheme===O.Schemas.file){const n=L.$lc($(v),$(h));return R.$i?d.$pg(n):n}let l=v.path||"/";const o=h.path||"/";if(this.a(v)){let n=0;for(const i=Math.min(l.length,o.length);n<i&&!(l.charCodeAt(n)!==o.charCodeAt(n)&&l.charAt(n).toLowerCase()!==o.charAt(n).toLowerCase());n++);l=o.substr(0,n)+l.substr(n)}return L.$gc.relative(l,o)}resolvePath(v,h){if(v.scheme===O.Schemas.file){const l=b.URI.file(L.$kc($(v),h));return v.with({authority:l.authority,path:l.path})}return h=d.$qg(h),v.with({path:L.$gc.resolve(v.path,h)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,h){return v===h||v!==void 0&&h!==void 0&&(0,N.$xf)(v,h)}hasTrailingPathSeparator(v,h=L.sep){if(v.scheme===O.Schemas.file){const l=$(v);return l.length>d.$rg(l).length&&l[l.length-1]===h}else{const l=v.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,h=L.sep){return(0,e.$dh)(v,h)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,h=L.sep){let l=!1;if(v.scheme===O.Schemas.file){const o=$(v);l=o!==void 0&&o.length===d.$rg(o).length&&o[o.length-1]===h}else{h="/";const o=v.path;l=o.length===1&&o.charCodeAt(o.length-1)===47}return!l&&!(0,e.$dh)(v,h)?v.with({path:v.path+"/"}):v}}e.$Yg=k,e.$Zg=new k(()=>!1),e.$1g=new k(y=>y.scheme===O.Schemas.file?!R.$k:!0),e.$2g=new k(y=>!0),e.$3g=e.$Zg.isEqual.bind(e.$Zg),e.$4g=e.$Zg.isEqualOrParent.bind(e.$Zg),e.$5g=e.$Zg.getComparisonKey.bind(e.$Zg),e.$6g=e.$Zg.basenameOrAuthority.bind(e.$Zg),e.$7g=e.$Zg.basename.bind(e.$Zg),e.$8g=e.$Zg.extname.bind(e.$Zg),e.$9g=e.$Zg.dirname.bind(e.$Zg),e.$0g=e.$Zg.joinPath.bind(e.$Zg),e.$$g=e.$Zg.normalizePath.bind(e.$Zg),e.$_g=e.$Zg.relativePath.bind(e.$Zg),e.$ah=e.$Zg.resolvePath.bind(e.$Zg),e.$bh=e.$Zg.isAbsolutePath.bind(e.$Zg),e.$ch=e.$Zg.isEqualAuthority.bind(e.$Zg),e.$dh=e.$Zg.hasTrailingPathSeparator.bind(e.$Zg),e.$eh=e.$Zg.removeTrailingPathSeparator.bind(e.$Zg),e.$fh=e.$Zg.addTrailingPathSeparator.bind(e.$Zg);function A(y,v){const h=[];for(let l=0;l<y.length;l++){const o=v(y[l]);y.some((n,i)=>i===l?!1:(0,e.$4g)(o,v(n)))||h.push(y[l])}return h}var C;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function v(h){const l=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(i=>{const[u,s]=i.split(":");u&&s&&l.set(u,s)});const n=h.path.substring(0,h.path.indexOf(";"));return n&&l.set(y.META_DATA_MIME,n),l}y.parseMetaData=v})(C||(e.DataUri=C={}));function p(y,v,h){if(v){let l=y.path;return l&&l[0]!==L.$gc.sep&&(l=L.$gc.sep+l),y.with({scheme:h,authority:v,path:l})}return y.with({scheme:h})}}),define(Se[7],De([1,0,22,13,4,3,23,12,174,46]),function(he,e,d,O,L,R,N,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.Promises=e.$Th=e.$Sh=e.$Rh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0,e.$ih=A,e.$jh=C,e.$kh=p,e.$lh=y,e.$mh=v,e.$nh=h,e.$oh=l,e.$ph=o,e.$xh=g,e.$yh=w,e.$zh=S,e.$Ah=m,e.$Bh=E,e.$Qh=G,e.$Yh=ce;function A(le){return!!le&&typeof le.then=="function"}function C(le){const K=new d.$oe,se=le(K.token),$e=new Promise((ve,Re)=>{const ge=K.token.onCancellationRequested(()=>{ge.dispose(),Re(new O.$5)});Promise.resolve(se).then(Ie=>{ge.dispose(),K.dispose(),ve(Ie)},Ie=>{ge.dispose(),K.dispose(),Re(Ie)})});return new class{cancel(){K.cancel(),K.dispose()}then(ve,Re){return $e.then(ve,Re)}catch(ve){return this.then(void 0,ve)}finally(ve){return $e.finally(ve)}}}function p(le,K,se){return new Promise(($e,ve)=>{const Re=K.onCancellationRequested(()=>{Re.dispose(),$e(se)});le.then($e,ve).finally(()=>Re.dispose())})}function y(le,K){return new Promise((se,$e)=>{const ve=K.onCancellationRequested(()=>{ve.dispose(),$e(new O.$5)});le.then(se,$e).finally(()=>ve.dispose())})}async function v(le){let K=-1;const se=le.map(($e,ve)=>$e.then(Re=>(K=ve,Re)));try{return await Promise.race(se)}finally{le.forEach(($e,ve)=>{ve!==K&&$e.cancel()})}}function h(le,K,se){let $e;const ve=setTimeout(()=>{$e?.(void 0),se?.()},K);return Promise.race([le.finally(()=>clearTimeout(ve)),new Promise(Re=>$e=Re)])}function l(le){return new Promise((K,se)=>{const $e=le();A($e)?$e.then(K,se):K($e)})}function o(){let le,K;return{promise:new Promise(($e,ve)=>{le=$e,K=ve}),resolve:le,reject:K}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const se=()=>{if(this.b=null,this.f)return;const $e=this.queue(this.d);return this.d=null,$e};this.b=new Promise($e=>{this.a.then(se,se).then($e)})}return new Promise((se,$e)=>{this.b.then(se,$e)})}return this.a=K(),new Promise((se,$e)=>{this.a.then(ve=>{this.a=null,se(ve)},ve=>{this.a=null,$e(ve)})})}dispose(){this.f=!0}}e.$qh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$rh=i;class u{constructor(){this.a=new Map}queue(K,se){const ve=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.a.get(K)===ve&&this.a.delete(K)});return this.a.set(K,ve),ve}}e.$sh=u;const s=(le,K)=>{let se=!0;const $e=setTimeout(()=>{se=!1,K()},le);return{isTriggered:()=>se,dispose:()=>{clearTimeout($e),se=!1}}},t=le=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,le())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class c{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,se=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((ve,Re)=>{this.d=ve,this.f=Re}).then(()=>{if(this.b=null,this.d=null,this.g){const ve=this.g;return this.g=null,ve()}}));const $e=()=>{this.a=null,this.d?.(null)};return this.a=se===$.$ae?t($e):s(se,$e),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$th=c;class r{constructor(K){this.a=new c(K),this.b=new n}trigger(K,se){return this.a.trigger(()=>this.b.queue(K),se)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$uh=r;class a{constructor(){this.a=!1,this.b=new Promise((K,se)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$vh=a;class f extends a{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$wh=f;function g(le,K){return K?new Promise((se,$e)=>{const ve=setTimeout(()=>{Re.dispose(),se()},le),Re=K.onCancellationRequested(()=>{clearTimeout(ve),Re.dispose(),$e(new O.$5)})}):C(se=>g(le,se))}function w(le,K=0,se){const $e=setTimeout(()=>{le(),se&&ve.dispose()},K),ve=(0,R.$Sc)(()=>{clearTimeout($e),se?.deleteAndLeak(ve)});return se?.add(ve),ve}function S(le){const K=[];let se=0;const $e=le.length;function ve(){return se<$e?le[se++]():null}function Re(ge){ge!=null&&K.push(ge);const Ie=ve();return Ie?Ie.then(Re):Promise.resolve(K)}return Promise.resolve(null).then(Re)}function m(le,K=$e=>!!$e,se=null){let $e=0;const ve=le.length,Re=()=>{if($e>=ve)return Promise.resolve(se);const ge=le[$e++];return Promise.resolve(ge()).then(Ae=>K(Ae)?Promise.resolve(Ae):Re())};return Re()}function E(le,K=$e=>!!$e,se=null){if(le.length===0)return Promise.resolve(se);let $e=le.length;const ve=()=>{$e=-1;for(const Re of le)Re.cancel?.()};return new Promise((Re,ge)=>{for(const Ie of le)Ie.then(Ae=>{--$e>=0&&K(Ae)?(ve(),Re(Ae)):$e===0&&Re(se)}).catch(Ae=>{--$e>=0&&(ve(),ge(Ae))})})}class D{constructor(K){this.a=0,this.b=!1,this.f=K,this.g=[],this.d=0,this.h=new L.$de}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(K){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((se,$e)=>{this.g.push({factory:K,c:se,e:$e}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const K=this.g.shift();this.d++;const se=K.factory();se.then(K.c,K.e),se.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ch=D;class P extends D{constructor(){super(1)}}e.$Dh=P;class I{constructor(){this.a=new x,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$Eh=I;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new ae;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueSize(K,se=N.$Zg){const $e=se.getComparisonKey(K);return this.a.get($e)?.size??0}queueFor(K,se,$e=N.$Zg){const ve=$e.getComparisonKey(K);let Re=this.a.get(ve);if(!Re){Re=new P;const ge=this.f++,Ie=L.Event.once(Re.onDrained)(()=>{Re?.dispose(),this.a.delete(ve),this.h(),this.d?.deleteAndDispose(ge),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$4c),this.d.set(ge,Ie),this.a.set(ve,Re)}return Re.queue(se)}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Fh=F;class T{constructor(K,se){this.a=-1,typeof K=="function"&&typeof se=="number"&&this.setIfNotSet(K,se)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,se){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},se)}setIfNotSet(K,se){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},se))}}e.$Gh=T;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(K,se,$e=globalThis){this.cancel();const ve=$e.setInterval(()=>{K()},se);this.d=(0,R.$Sc)(()=>{$e.clearInterval(ve),this.d=void 0})}dispose(){this.cancel()}}e.$Hh=z;class M{constructor(K,se){this.b=-1,this.a=K,this.d=se,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ih=M;class j{constructor(K,se){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.a=K,this.b=se,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Jh=j;class U extends M{constructor(K,se){super(K,se),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$Kh=U;class Z extends R.$Uc{constructor(K,se){super(),this.g=K,this.h=se,this.a=[],this.b=this.B(new R.$Vc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const se of K)this.a.push(se);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Lh=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Nh=(le,K)=>{(0,b.$B)(()=>{if(se)return;const $e=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$e-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e.$Nh=(le,K,se)=>{const $e=le.requestIdleCallback(K,typeof se=="number"?{timeout:se}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,le.cancelIdleCallback($e))}}},e.$Mh=le=>(0,e.$Nh)(globalThis,le)}();class ie{constructor(K,se){this.g=!1,this.d=()=>{try{this.j=se()}catch($e){this.l=$e}finally{this.g=!0}},this.f=(0,e.$Nh)(K,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Oh=ie;class q extends ie{constructor(K){super(globalThis,K)}}e.$Ph=q;async function G(le,K,se){let $e;for(let ve=0;ve<se;ve++)try{return await le()}catch(Re){$e=Re,await g(K)}throw $e}class x{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,se,$e){return this.a={taskId:K,cancel:()=>$e?.(),promise:se},se.then(()=>this.d(K),()=>this.d(K)),se}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{const{promise:se,resolve:$e,reject:ve}=o();this.b={run:K,promise:se,promiseResolve:$e,promiseReject:ve}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Rh=x;class ne{constructor(K,se=()=>Date.now()){this.d=K,this.f=se,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$Sh=ne;var be;(function(le){le[le.Resolved=0]="Resolved",le[le.Rejected=1]="Rejected"})(be||(be={}));class ae{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,se)=>{this.a=K,this.b=se})}complete(K){return new Promise(se=>{this.a(K),this.d={outcome:0,value:K},se()})}error(K){return new Promise(se=>{this.b(K),this.d={outcome:1,value:K},se()})}cancel(){return this.error(new O.$5)}}e.$Th=ae;var Ce;(function(le){async function K($e){let ve;const Re=await Promise.all($e.map(ge=>ge.then(Ie=>Ie,Ie=>{ve||(ve=Ie)})));if(typeof ve<"u")throw ve;return Re}le.settled=K;function se($e){return new Promise(async(ve,Re)=>{try{await $e(ve,Re)}catch(ge){Re(ge)}})}le.withAsyncBody=se})(Ce||(e.Promises=Ce={}));class ee{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(K){this.a=void 0,this.b=void 0,this.d=!1,this.promise=K.then(se=>(this.a=se,this.d=!0,se),se=>{throw this.b=se,this.d=!0,se})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Uh=ee;class B{constructor(K){this.b=K,this.a=new k.$V(()=>new ee(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Vh=B;var _;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(_||(_={}));class pe{static fromArray(K){return new pe(se=>{se.emitMany(K)})}static fromPromise(K){return new pe(async se=>{se.emitMany(await K)})}static fromPromises(K){return new pe(async se=>{await Promise.all(K.map(async $e=>se.emitOne(await $e)))})}static merge(K){return new pe(async se=>{await Promise.all(K.map(async $e=>{for await(const ve of $e)se.emitOne(ve)}))})}static{this.EMPTY=pe.fromArray([])}constructor(K,se){this.a=0,this.b=[],this.d=null,this.f=se,this.g=new L.$de,queueMicrotask(async()=>{const $e={emitOne:ve=>this.h(ve),emitMany:ve=>this.j(ve),reject:ve=>this.l(ve)};try{await Promise.resolve(K($e)),this.k()}catch(ve){this.l(ve)}finally{$e.emitOne=void 0,$e.emitMany=void 0,$e.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(K,se){return new pe(async $e=>{for await(const ve of K)$e.emitOne(se(ve))})}map(K){return pe.map(this,K)}static filter(K,se){return new pe(async $e=>{for await(const ve of K)se(ve)&&$e.emitOne(ve)})}filter(K){return pe.filter(this,K)}static coalesce(K){return pe.filter(K,se=>!!se)}coalesce(){return pe.coalesce(this)}static async toPromise(K){const se=[];for await(const $e of K)se.push($e);return se}toPromise(){return pe.toPromise(this)}h(K){this.a===0&&(this.b.push(K),this.g.fire())}j(K){this.a===0&&(this.b=this.b.concat(K),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(K){this.a===0&&(this.a=2,this.d=K,this.g.fire())}}e.$Wh=pe;class ue extends pe{constructor(K,se){super(se),this.m=K}cancel(){this.m.cancel()}}e.$Xh=ue;function ce(le){const K=new d.$oe,se=le(K.token);return new ue(K,async $e=>{const ve=K.token.onCancellationRequested(()=>{ve.dispose(),K.dispose(),$e.reject(new O.$5)});try{for await(const Re of se){if(K.token.isCancellationRequested)return;$e.emitOne(Re)}ve.dispose(),K.dispose()}catch(Re){ve.dispose(),K.dispose(),$e.reject(Re)}})}class oe{constructor(K){this.a=new ae,this.b=new pe(ve=>{if(se){ve.reject(se);return}return $e&&ve.emitMany($e),this.d=Re=>ve.reject(Re),this.f=Re=>ve.emitOne(Re),this.a.p},K);let se,$e;this.f=ve=>{$e||($e=[]),$e.push(ve)},this.d=ve=>{se||(se=ve)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(K){this.d(K),this.a.complete()}emitOne(K){this.f(K)}}e.$Zh=oe}),define(Se[35],De([1,0,19,7,31,27,17,12,14]),function(he,e,d,O,L,R,N,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nk=e.$mk=void 0,e.$lk=k,e.$ok=v,e.$pk=P,e.$qk=I,e.$rk=F,e.$sk=T,e.$tk=z,e.$uk=Z;function k(){return Object.create(null)}e.$mk="**",e.$nk="/";const A="[/\\\\]",C="[^/\\\\]",p=/\//g;function y(ie,q){switch(ie){case 0:return"";case 1:return`${C}*?`;default:return`(?:${A}|${C}+${A}${q?`|${A}${C}+`:""})*?`}}function v(ie,q){if(!ie)return[];const G=[];let x=!1,ne=!1,be="";for(const ae of ie){switch(ae){case q:if(!x&&!ne){G.push(be),be="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}be+=ae}return be&&G.push(be),G}function h(ie){if(!ie)return"";let q="";const G=v(ie,e.$nk);if(G.every(x=>x===e.$mk))q=".*";else{let x=!1;G.forEach((ne,be)=>{if(ne===e.$mk){if(x)return;q+=y(2,be===G.length-1)}else{let ae=!1,Ce="",ee=!1,B="";for(const _ of ne){if(_!=="}"&&ae){Ce+=_;continue}if(ee&&(_!=="]"||!B)){let pe;_==="-"?pe=_:(_==="^"||_==="!")&&!B?pe="^":_===e.$nk?pe="":pe=(0,$.$_e)(_),B+=pe;continue}switch(_){case"{":ae=!0;continue;case"[":ee=!0;continue;case"}":{const ue=`(?:${v(Ce,",").map(ce=>h(ce)).join("|")})`;q+=ue,ae=!1,Ce="";break}case"]":{q+="["+B+"]",ee=!1,B="";break}case"?":q+=C;continue;case"*":q+=y(1);continue;default:q+=(0,$.$_e)(_)}}be<G.length-1&&(G[be+1]!==e.$mk||be+2<G.length)&&(q+=A)}x=ne===e.$mk})}return q}const l=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Dc(1e4),c=function(){return!1},r=function(){return null};function a(ie,q){if(!ie)return r;let G;typeof ie!="string"?G=ie.pattern:G=ie,G=G.trim();const x=`${G}_${!!q.trimForExclusions}`;let ne=t.get(x);if(ne)return f(ne,ie);let be;return l.test(G)?ne=w(G.substr(4),G):(be=o.exec(g(G,q)))?ne=S(be[1],G):(q.trimForExclusions?i:n).test(G)?ne=m(G,q):(be=u.exec(g(G,q)))?ne=E(be[1].substr(1),G,!0):(be=s.exec(g(G,q)))?ne=E(be[1],G,!1):ne=D(G),t.set(x,ne),f(ne,ie)}function f(ie,q){if(typeof q=="string")return ie;const G=function(x,ne){return(0,L.$vg)(x,q.base,!b.$k)?ie((0,$.$ef)(x.substr(q.base.length),N.sep),ne):null};return G.allBasenames=ie.allBasenames,G.allPaths=ie.allPaths,G.basenames=ie.basenames,G.patterns=ie.patterns,G}function g(ie,q){return q.trimForExclusions&&ie.endsWith("/**")?ie.substr(0,ie.length-2):ie}function w(ie,q){return function(G,x){return typeof G=="string"&&G.endsWith(ie)?q:null}}function S(ie,q){const G=`/${ie}`,x=`\\${ie}`,ne=function(ae,Ce){return typeof ae!="string"?null:Ce?Ce===ie?q:null:ae===ie||ae.endsWith(G)||ae.endsWith(x)?q:null},be=[ie];return ne.basenames=be,ne.patterns=[q],ne.allBasenames=be,ne}function m(ie,q){const G=U(ie.slice(1,-1).split(",").map(Ce=>a(Ce,q)).filter(Ce=>Ce!==r),ie),x=G.length;if(!x)return r;if(x===1)return G[0];const ne=function(Ce,ee){for(let B=0,_=G.length;B<_;B++)if(G[B](Ce,ee))return ie;return null},be=G.find(Ce=>!!Ce.allBasenames);be&&(ne.allBasenames=be.allBasenames);const ae=G.reduce((Ce,ee)=>ee.allPaths?Ce.concat(ee.allPaths):Ce,[]);return ae.length&&(ne.allPaths=ae),ne}function E(ie,q,G){const x=N.sep===N.$gc.sep,ne=x?ie:ie.replace(p,N.sep),be=N.sep+ne,ae=N.$gc.sep+ie;let Ce;return G?Ce=function(ee,B){return typeof ee=="string"&&(ee===ne||ee.endsWith(be)||!x&&(ee===ie||ee.endsWith(ae)))?q:null}:Ce=function(ee,B){return typeof ee=="string"&&(ee===ne||!x&&ee===ie)?q:null},Ce.allPaths=[(G?"*/":"./")+ie],Ce}function D(ie){try{const q=new RegExp(`^${h(ie)}$`);return function(G){return q.lastIndex=0,typeof G=="string"&&q.test(G)?ie:null}}catch{return r}}function P(ie,q,G){return!ie||typeof q!="string"?!1:I(ie)(q,void 0,G)}function I(ie,q={}){if(!ie)return c;if(typeof ie=="string"||F(ie)){const G=a(ie,q);if(G===r)return c;const x=function(ne,be){return!!G(ne,be)};return G.allBasenames&&(x.allBasenames=G.allBasenames),G.allPaths&&(x.allPaths=G.allPaths),x}return M(ie,q)}function F(ie){const q=ie;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}function T(ie){return ie.allBasenames||[]}function z(ie){return ie.allPaths||[]}function M(ie,q){const G=U(Object.getOwnPropertyNames(ie).map(Ce=>j(Ce,ie[Ce],q)).filter(Ce=>Ce!==r)),x=G.length;if(!x)return r;if(!G.some(Ce=>!!Ce.requiresSiblings)){if(x===1)return G[0];const Ce=function(_,pe){let ue;for(let ce=0,oe=G.length;ce<oe;ce++){const le=G[ce](_,pe);if(typeof le=="string")return le;(0,O.$ih)(le)&&(ue||(ue=[]),ue.push(le))}return ue?(async()=>{for(const ce of ue){const oe=await ce;if(typeof oe=="string")return oe}return null})():null},ee=G.find(_=>!!_.allBasenames);ee&&(Ce.allBasenames=ee.allBasenames);const B=G.reduce((_,pe)=>pe.allPaths?_.concat(pe.allPaths):_,[]);return B.length&&(Ce.allPaths=B),Ce}const ne=function(Ce,ee,B){let _,pe;for(let ue=0,ce=G.length;ue<ce;ue++){const oe=G[ue];oe.requiresSiblings&&B&&(ee||(ee=(0,N.$nc)(Ce)),_||(_=ee.substr(0,ee.length-(0,N.$oc)(Ce).length)));const le=oe(Ce,ee,_,B);if(typeof le=="string")return le;(0,O.$ih)(le)&&(pe||(pe=[]),pe.push(le))}return pe?(async()=>{for(const ue of pe){const ce=await ue;if(typeof ce=="string")return ce}return null})():null},be=G.find(Ce=>!!Ce.allBasenames);be&&(ne.allBasenames=be.allBasenames);const ae=G.reduce((Ce,ee)=>ee.allPaths?Ce.concat(ee.allPaths):Ce,[]);return ae.length&&(ne.allPaths=ae),ne}function j(ie,q,G){if(q===!1)return r;const x=a(ie,G);if(x===r)return r;if(typeof q=="boolean")return x;if(q){const ne=q.when;if(typeof ne=="string"){const be=(ae,Ce,ee,B)=>{if(!B||!x(ae,Ce))return null;const _=ne.replace("$(basename)",()=>ee),pe=B(_);return(0,O.$ih)(pe)?pe.then(ue=>ue?ie:null):pe?ie:null};return be.requiresSiblings=!0,be}}return x}function U(ie,q){const G=ie.filter(Ce=>!!Ce.basenames);if(G.length<2)return ie;const x=G.reduce((Ce,ee)=>{const B=ee.basenames;return B?Ce.concat(B):Ce},[]);let ne;if(q){ne=[];for(let Ce=0,ee=x.length;Ce<ee;Ce++)ne.push(q)}else ne=G.reduce((Ce,ee)=>{const B=ee.patterns;return B?Ce.concat(B):Ce},[]);const be=function(Ce,ee){if(typeof Ce!="string")return null;if(!ee){let _;for(_=Ce.length;_>0;_--){const pe=Ce.charCodeAt(_-1);if(pe===47||pe===92)break}ee=Ce.substr(_)}const B=x.indexOf(ee);return B!==-1?ne[B]:null};be.basenames=x,be.patterns=ne,be.allBasenames=x;const ae=ie.filter(Ce=>!Ce.basenames);return ae.push(be),ae}function Z(ie,q){return(0,d.$ub)(ie,q,(G,x)=>typeof G=="string"&&typeof x=="string"?G===x:typeof G!="string"&&typeof x!="string"?G.base===x.base&&G.pattern===x.pattern:!1)}}),define(Se[81],De([1,0,13,176,23,14,2]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.MarkdownStringTextNewlineStyle=void 0,e.$Uk=k,e.$Vk=A,e.$Wk=C,e.$Xk=p,e.$Yk=y,e.$Zk=v,e.$1k=h,e.$2k=l;var b;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class ${constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,d.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=p(this.supportThemeIcons?(0,O.$Nk)(n):n).replace(/([ \t]+)/g,(u,s)=>"&nbsp;".repeat(s.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${y(i,n)}
`,this}appendLink(n,i,u){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),u&&(this.value+=` "${this.c(this.c(u,'"'),")")}"`),this.value+=")",this}c(n,i){const u=new RegExp((0,R.$_e)(i),"g");return n.replace(u,(s,t)=>n.charAt(t-1)!=="\\"?`\\${s}`:s)}}e.$Tk=$;function k(o){return A(o)?!o.value:Array.isArray(o)?o.every(k):!0}function A(o){return o instanceof $?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function C(o,n){return o===n?!0:!o||!n?!1:o.value===n.value&&o.isTrusted===n.isTrusted&&o.supportThemeIcons===n.supportThemeIcons&&o.supportHtml===n.supportHtml&&(o.baseUri===n.baseUri||!!o.baseUri&&!!n.baseUri&&(0,L.$3g)(N.URI.from(o.baseUri),N.URI.from(n.baseUri)))}function p(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function y(o,n){const i=o.match(/^`+/gm)?.reduce((s,t)=>s.length>t.length?s:t).length??0,u=i>=3?i+1:3;return[`${"`".repeat(u)}${n}`,o,`${"`".repeat(u)}`].join(`
`)}function v(o){return o.replace(/"/g,"&quot;")}function h(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function l(o){const n=[],i=o.split("|").map(s=>s.trim());o=i[0];const u=i[1];if(u){const s=/height=(\d+)/.exec(u),t=/width=(\d+)/.exec(u),c=s?s[1]:"",r=t?t[1]:"",a=isFinite(parseInt(r)),f=isFinite(parseInt(c));a&&n.push(`width="${r}"`),f&&n.push(`height="${c}"`)}return{href:o,dimensions:n}}}),define(Se[103],De([1,0,19,31,17,12,23,14]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dw=$,e.$Ew=A,e.$Fw=p,e.$Gw=y,e.$Hw=o,e.$Iw=i,e.$Jw=u,e.$Kw=s,e.$Lw=t,e.$Mw=c;function $(a,f){const{os:g,tildify:w,relative:S}=f;if(S){const D=k(a,S,g);if(typeof D=="string")return D}let m=a.fsPath;if(g===1&&!R.$i?m=m.replace(/\//g,"\\"):g!==1&&R.$i&&(m=m.replace(/\\/g,"/")),g!==1&&w?.userHome){const D=w.userHome.fsPath;let P;a.scheme!==w.userHome.scheme&&a.path[0]===L.$gc.sep&&a.path[1]!==L.$gc.sep?P=w.userHome.with({path:a.path}).fsPath:P=m,m=p(P,D,g)}return(g===1?L.$fc:L.$gc).normalize(A(m,g===1))}function k(a,f,g){const w=g===1?L.$fc:L.$gc,S=g===3?N.$Zg:N.$2g,m=f.getWorkspace(),E=(0,d.$Ob)(m.folders);if(!E)return;a.scheme!==E.uri.scheme&&a.path[0]===L.$gc.sep&&a.path[1]!==L.$gc.sep&&(a=E.uri.with({path:a.path}));const D=f.getWorkspaceFolder(a);if(!D)return;let P;if(S.isEqual(D.uri,a)?P="":P=S.relativePath(D.uri,a)??"",P&&(P=w.normalize(P)),m.folders.length>1&&!f.noPrefix){const I=D.name?D.name:S.basenameOrAuthority(D.uri);P=P?`${I} \u2022 ${P}`:I}return P}function A(a,f=R.$i){return(0,O.$Ag)(a,f)?a.charAt(0).toUpperCase()+a.slice(1):a}let C=Object.create(null);function p(a,f,g=R.OS){if(g===1||!a||!f)return a;let w=C.original===f?C.normalized:void 0;w||(w=f,R.$i&&(w=(0,O.$pg)(w)),w=`${(0,b.$ff)(w,L.$gc.sep)}${L.$gc.sep}`,C={original:f,normalized:w});let S=a;return R.$i&&(S=(0,O.$pg)(S)),(g===3?S.startsWith(w):(0,b.$yf)(S,w))?`~/${S.substr(w.length)}`:a}function y(a,f){return a.replace(/^~($|\/|\\)/,`${f}$1`)}const v="\u2026",h="\\\\",l="~";function o(a,f=L.sep){const g=new Array(a.length);let w=!1;for(let S=0;S<a.length;S++){const m=a[S];if(m===""){g[S]=`.${f}`;continue}if(!m){g[S]=m;continue}w=!0;let E="",D=m;D.indexOf(h)===0?(E=D.substr(0,D.indexOf(h)+h.length),D=D.substr(D.indexOf(h)+h.length)):D.indexOf(f)===0?(E=D.substr(0,D.indexOf(f)+f.length),D=D.substr(D.indexOf(f)+f.length)):D.indexOf(l)===0&&(E=D.substr(0,D.indexOf(l)+l.length),D=D.substr(D.indexOf(l)+l.length));const P=D.split(f);for(let I=1;w&&I<=P.length;I++)for(let F=P.length-I;w&&F>=0;F--){w=!1;let T=P.slice(F,F+I).join(f);for(let z=0;!w&&z<a.length;z++)if(z!==S&&a[z]&&a[z].indexOf(T)>-1){const M=F+I===P.length,j=F>0&&a[z].indexOf(f)>-1?f+T:T,U=a[z].endsWith(j);w=!M||U}if(!w){let z="";(P[0].endsWith(":")||E!=="")&&(F===1&&(F=0,I++,T=P[0]+f+T),F>0&&(z=P[0]+f),z=E+z),F>0&&(z=z+v+f),z=z+T,F+I<P.length&&(z=z+f+v),g[S]=z}}w&&(g[S]=m)}return g}var n;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(a,f=Object.create(null)){const g=[];let w=!1,S="";for(const m of a)if(m==="$"||w&&m==="{")S&&g.push({value:S,type:n.TEXT}),S="",w=!0;else if(m==="}"&&w){const E=f[S];if(typeof E=="string")E.length&&g.push({value:E,type:n.VARIABLE});else if(E){const D=g[g.length-1];(!D||D.type!==n.SEPARATOR)&&g.push({value:E.label,type:n.SEPARATOR})}S="",w=!1}else S+=m;return S&&!w&&g.push({value:S,type:n.TEXT}),g.filter((m,E)=>{if(m.type===n.SEPARATOR){const D=g[E-1],P=g[E+1];return[D,P].every(I=>I&&(I.type===n.VARIABLE||I.type===n.TEXT)&&I.value.length>0)}return!0}).map(m=>m.value).join("")}function u(a,f){return R.$j||f?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):a.replace(/&&|&/g,g=>g==="&"?"&&":"&")}function s(a,f){return R.$j||f?a.replace(/\(&&\w\)|&&/g,""):R.$i?a.replace(/&&|&/g,g=>g==="&"?"&&":"&"):a.replace(/&&/g,"_")}function t(a){return a.replace(/&/g,"&&")}function c(a){if(a.endsWith("]")){const f=a.lastIndexOf(" [",a.length-2);if(f!==-1){const g=r(a.substring(0,f)),w=a.substring(f);return{name:g.name+w,parentPath:g.parentPath}}}return r(a)}function r(a){const f=a.indexOf("/")!==-1?L.$gc:L.$fc,g=f.basename(a),w=f.dirname(a);return g.length?{name:g,parentPath:w}:{name:w,parentPath:""}}}),define(Se[134],De([1,0,21,2]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=void 0,e.$An=b,e.$Bn=k,e.$Cn=A;function L(C){return C.toJSON()}class R{constructor(p){this.a=p}transformIncoming(p){const y=this.a.transformIncoming(p);return y===p?p:L(O.URI.from(y))}transformOutgoing(p){const y=this.a.transformOutgoing(p);return y===p?p:L(O.URI.from(y))}transformOutgoingURI(p){const y=this.a.transformOutgoing(p);return y===p?p:O.URI.from(y)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$yn=R,e.$zn=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function N(C,p,y){if(!C||y>200)return null;if(typeof C=="object"){if(C instanceof O.URI)return p.transformOutgoing(C);for(const v in C)if(Object.hasOwnProperty.call(C,v)){const h=N(C[v],p,y+1);h!==null&&(C[v]=h)}}return null}function b(C,p){const y=N(C,p,0);return y===null?C:y}function $(C,p,y,v){if(!C||v>200)return null;if(typeof C=="object"){if(C.$mid===1)return y?O.URI.revive(p.transformIncoming(C)):p.transformIncoming(C);if(C instanceof d.$Fe)return null;for(const h in C)if(Object.hasOwnProperty.call(C,h)){const l=$(C[h],p,y,v+1);l!==null&&(C[h]=l)}}return null}function k(C,p){const y=$(C,p,!1,0);return y===null?C:y}function A(C,p){const y=$(C,p,!0,0);return y===null?C:y}}),define(Se[32],De([1,0,53,64,400,7,31,77,17,12,23,2]),function(he,e,d,O,L,R,N,b,$,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=l,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=g,e.writeFileSync=S;var p;(function(j){j[j.UNLINK=0]="UNLINK",j[j.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function y(j,U=p.UNLINK,Z){if((0,N.$zg)(j))throw new Error("rimraf - will refuse to recursively delete root");return U===p.UNLINK?h(j):v(j,Z)}async function v(j,U=(0,N.$Eg)((0,O.tmpdir)())){try{try{await d.promises.rename(j,U)}catch(Z){return Z.code==="ENOENT"?void 0:h(j)}h(U).catch(Z=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function h(j){return(0,L.promisify)(d.rm)(j,{recursive:!0,force:!0,maxRetries:3})}function l(j){if((0,N.$zg)(j))throw new Error("rimraf - will refuse to recursively delete root");d.rmSync(j,{recursive:!0,force:!0,maxRetries:3})}async function o(j,U){return u(await(U?n(j):(0,L.promisify)(d.readdir)(j)))}async function n(j){try{return await(0,L.promisify)(d.readdir)(j,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const U=[],Z=await o(j);for(const ie of Z){let q=!1,G=!1,x=!1;try{const ne=await e.Promises.lstat((0,$.$jc)(j,ie));q=ne.isFile(),G=ne.isDirectory(),x=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}U.push({name:ie,isFile:()=>q,isDirectory:()=>G,isSymbolicLink:()=>x})}return U}function i(j){return u(d.readdirSync(j))}function u(j){return j.map(U=>typeof U=="string"?k.$j?(0,b.$bm)(U):U:(U.name=k.$j?(0,b.$bm)(U.name):U.name,U))}async function s(j){const U=await o(j),Z=[];for(const ie of U)await c.existsDirectory((0,$.$jc)(j,ie))&&Z.push(ie);return Z}function t(j,U=1e3){return new Promise(Z=>{let ie=!1;const q=setInterval(()=>{ie||(ie=!0,d.access(j,G=>{ie=!1,G&&(clearInterval(q),Z(void 0))}))},U)})}var c;(function(j){async function U(q){let G;try{if(G=await e.Promises.lstat(q),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(k.$i&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw ne}throw x}}j.stat=U;async function Z(q){try{const{stat:G,symbolicLink:x}=await j.stat(q);return G.isFile()&&x?.dangling!==!0}catch{}return!1}j.existsFile=Z;async function ie(q){try{const{stat:G,symbolicLink:x}=await j.stat(q);return G.isDirectory()&&x?.dangling!==!0}catch{}return!1}j.existsDirectory=ie})(c||(e.SymlinkSupport=c={}));const r=new R.$Fh;function a(j,U,Z){return r.queueFor(C.URI.file(j),()=>{const ie=m(Z);return new Promise((q,G)=>w(j,U,ie,x=>x?G(x):q()))},A.$1g)}let f=!0;function g(j){f=j}function w(j,U,Z,ie){if(!f)return d.writeFile(j,U,{mode:Z.mode,flag:Z.flag},ie);d.open(j,Z.flag,Z.mode,(q,G)=>{if(q)return ie(q);d.writeFile(G,U,x=>{if(x)return d.close(G,()=>ie(x));d.fdatasync(G,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),g(!1)),d.close(G,be=>ie(be))))})})}function S(j,U,Z){const ie=m(Z);if(!f)return d.writeFileSync(j,U,{mode:ie.mode,flag:ie.flag});const q=d.openSync(j,ie.flag,ie.mode);try{d.writeFileSync(q,U);try{d.fdatasyncSync(q)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),g(!1)}}finally{d.closeSync(q)}}function m(j){return j?{mode:typeof j.mode=="number"?j.mode:438,flag:typeof j.flag=="string"?j.flag:"w"}:{mode:438,flag:"w"}}async function E(j,U,Z=6e4){if(j!==U)try{k.$i&&typeof Z=="number"?await D(j,U,Date.now(),Z):await(0,L.promisify)(d.rename)(j,U)}catch(ie){if(j.toLowerCase()!==U.toLowerCase()&&ie.code==="EXDEV"||j.endsWith("."))await P(j,U,{preserveSymlinks:!1}),await y(j,p.MOVE);else throw ie}}async function D(j,U,Z,ie,q=0){try{return await(0,L.promisify)(d.rename)(j,U)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-Z>=ie)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${G}`),G;if(q===0){let x=!1;try{const{stat:ne}=await c.stat(U);ne.isFile()||(x=!0)}catch{}if(x)throw G}return await(0,R.$xh)(Math.min(100,q*10)),D(j,U,Z,ie,q+1)}}async function P(j,U,Z){return F(j,U,{root:{source:j,target:U},options:Z,handledSourcePaths:new Set})}const I=511;async function F(j,U,Z){if(Z.handledSourcePaths.has(j))return;Z.handledSourcePaths.add(j);const{stat:ie,symbolicLink:q}=await c.stat(j);if(q){if(Z.options.preserveSymlinks)try{return await M(j,U,Z)}catch{}if(q.dangling)return}return ie.isDirectory()?T(j,U,ie.mode&I,Z):z(j,U,ie.mode&I)}async function T(j,U,Z,ie){await e.Promises.mkdir(U,{recursive:!0,mode:Z});const q=await o(j);for(const G of q)await F((0,$.$jc)(j,G),(0,$.$jc)(U,G),ie)}async function z(j,U,Z){await e.Promises.copyFile(j,U),await e.Promises.chmod(U,Z)}async function M(j,U,Z){let ie=await e.Promises.readlink(j);(0,N.$vg)(ie,Z.root.source,!k.$k)&&(ie=(0,$.$jc)(Z.root.target,ie.substr(Z.root.source.length+1))),await e.Promises.symlink(ie,U)}e.Promises=new class{get access(){return(0,L.promisify)(d.access)}get stat(){return(0,L.promisify)(d.stat)}get lstat(){return(0,L.promisify)(d.lstat)}get utimes(){return(0,L.promisify)(d.utimes)}get read(){return(j,U,Z,ie,q)=>new Promise((G,x)=>{d.read(j,U,Z,ie,q,(ne,be,ae)=>ne?x(ne):G({bytesRead:be,buffer:ae}))})}get readFile(){return(0,L.promisify)(d.readFile)}get write(){return(j,U,Z,ie,q)=>new Promise((G,x)=>{d.write(j,U,Z,ie,q,(ne,be,ae)=>ne?x(ne):G({bytesWritten:be,buffer:ae}))})}get appendFile(){return(0,L.promisify)(d.appendFile)}get fdatasync(){return(0,L.promisify)(d.fdatasync)}get truncate(){return(0,L.promisify)(d.truncate)}get copyFile(){return(0,L.promisify)(d.copyFile)}get open(){return(0,L.promisify)(d.open)}get close(){return(0,L.promisify)(d.close)}get symlink(){return(0,L.promisify)(d.symlink)}get readlink(){return(0,L.promisify)(d.readlink)}get chmod(){return(0,L.promisify)(d.chmod)}get mkdir(){return(0,L.promisify)(d.mkdir)}get unlink(){return(0,L.promisify)(d.unlink)}get rmdir(){return(0,L.promisify)(d.rmdir)}get realpath(){return(0,L.promisify)(d.realpath)}async exists(j){try{return await e.Promises.access(j),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return s}get writeFile(){return a}get rm(){return y}get rename(){return E}get copy(){return P}}}),define(Se[104],De([1,0,53,17,12,14,32]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=b,e.$5q=$,e.$6q=k,e.$7q=A;function b(p){if(L.$k)return p;const y=(0,O.$mc)(p);if(p===y)return p;const v=((0,O.$nc)(p)||p).toLowerCase();try{const l=(0,N.readdirSync)(y).filter(o=>o.toLowerCase()===v);if(l.length===1){const o=b(y);if(o)return(0,O.$jc)(o,l[0])}else if(l.length>1){const o=l.indexOf(v);if(o>=0){const n=b(y);if(n)return(0,O.$jc)(n,l[o])}}}catch{}return null}async function $(p,y){if(L.$k)return p;const v=(0,O.$mc)(p);if(p===v)return p;const h=((0,O.$nc)(p)||p).toLowerCase();try{if(y?.isCancellationRequested)return null;const o=(await N.Promises.readdir(v)).filter(n=>n.toLowerCase()===h);if(o.length===1){const n=await $(v,y);if(n)return(0,O.$jc)(n,o[0])}else if(o.length>1){const n=o.indexOf(h);if(n>=0){const i=await $(v,y);if(i)return(0,O.$jc)(i,o[n])}}}catch{}return null}async function k(p){try{return await N.Promises.realpath(p)}catch{const v=C(p);return await N.Promises.access(v,d.constants.R_OK),v}}function A(p){try{return d.realpathSync(p)}catch{const v=C(p);return d.accessSync(v,d.constants.R_OK),v}}function C(p){return(0,R.$ff)((0,O.$hc)(p),O.sep)}}),define(Se[105],De([1,0,17,12,52,102,18,32]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$om=$,e.$pm=k,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function $(C=L.env){return C.comspec||"cmd.exe"}function k(C){let p=[],y=!1;const v=function(h){if(y){p.push(h);return}(!C.send(h,o=>{if(o&&console.error(o),y=!1,p.length>0){const n=p.slice(0);p=[],n.forEach(i=>v(i))}})||O.$i)&&(y=!0)};return{send:v}}var A;(function(C){async function p(y,v,h){if(d.$ic(y))return y;if(v===void 0&&(v=L.cwd()),d.$mc(y)!=="."||(h===void 0&&N.$9f(L.env.PATH)&&(h=L.env.PATH.split(d.$tc)),h===void 0||h.length===0))return d.$jc(v,y);async function o(n){if(await b.Promises.exists(n)){let i;try{i=await b.Promises.stat(n)}catch(u){u.message.startsWith("EACCES")&&(i=await b.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of h){let i;if(d.$ic(n)?i=d.$jc(n,y):i=d.$jc(v,n,y),await o(i))return i;let u=i+".com";if(await o(u)||(u=i+".exe",await o(u)))return u}return d.$jc(v,y)}C.findExecutable=p})(A||(e.win32=A={}))});var Ge=this&&this.__decorate||function(he,e,d,O){var L=arguments.length,R=L<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,d):O,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(he,e,d,O);else for(var b=he.length-1;b>=0;b--)(N=he[b])&&(R=(L<3?N(R):L>3?N(e,d,R):N(e,d))||R);return L>3&&R&&Object.defineProperty(e,d,R),R};define(Se[82],De([1,0,19,7,21,22,56,13,4,3,58,14,18]),function(he,e,d,O,L,R,N,b,$,k,A,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.ProxyChannel=e.$ei=e.$bi=e.$ai=e.$_h=e.RequestInitiator=e.$$h=e.$8h=e.$7h=void 0,e.$9h=g,e.$0h=w,e.$ci=I,e.$di=F;var y;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(y||(y={}));function v(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(h||(h={}));function l(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(o||(o={}));function n(q){let G=0;for(let x=0;;x+=7){const ne=q.read(1);if(G|=(ne.buffer[0]&127)<<x,!(ne.buffer[0]&128))return G}}const i=r(0);function u(q,G){if(G===0){q.write(i);return}let x=0;for(let be=G;be!==0;be=be>>>7)x++;const ne=L.$Fe.alloc(x);for(let be=0;G!==0;be++)ne.buffer[be]=G&127,G=G>>>7,G>0&&(ne.buffer[be]|=128);q.write(ne)}class s{constructor(G){this.b=G,this.a=0}read(G){const x=this.b.slice(this.a,this.a+G);return this.a+=x.byteLength,x}}e.$7h=s;class t{constructor(){this.a=[]}get buffer(){return L.$Fe.concat(this.a)}write(G){this.a.push(G)}}e.$8h=t;var c;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(c||(c={}));function r(q){const G=L.$Fe.alloc(1);return G.writeUInt8(q,0),G}const a={Undefined:r(c.Undefined),String:r(c.String),Buffer:r(c.Buffer),VSBuffer:r(c.VSBuffer),Array:r(c.Array),Object:r(c.Object),Uint:r(c.Int)},f=typeof Buffer<"u";function g(q,G){if(typeof G>"u")q.write(a.Undefined);else if(typeof G=="string"){const x=L.$Fe.fromString(G);q.write(a.String),u(q,x.byteLength),q.write(x)}else if(f&&Buffer.isBuffer(G)){const x=L.$Fe.wrap(G);q.write(a.Buffer),u(q,x.byteLength),q.write(x)}else if(G instanceof L.$Fe)q.write(a.VSBuffer),u(q,G.byteLength),q.write(G);else if(Array.isArray(G)){q.write(a.Array),u(q,G.length);for(const x of G)g(q,x)}else if(typeof G=="number"&&(G|0)===G)q.write(a.Uint),u(q,G);else{const x=L.$Fe.fromString(JSON.stringify(G));q.write(a.Object),u(q,x.byteLength),q.write(x)}}function w(q){switch(q.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return q.read(n(q)).toString();case c.Buffer:return q.read(n(q)).buffer;case c.VSBuffer:return q.read(n(q));case c.Array:{const x=n(q),ne=[];for(let be=0;be<x;be++)ne.push(w(q));return ne}case c.Object:return JSON.parse(q.read(n(q)).toString());case c.Int:return n(q)}}class S{constructor(G,x,ne=null,be=1e3){this.h=G,this.j=x,this.k=ne,this.l=be,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(G,x){this.b.set(G,x),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case 200:{const x=this.o([G.type]);this.k?.logOutgoing(x,0,1,l(G.type));return}case 201:case 202:case 204:case 203:{const x=this.o([G.type,G.id],G.data);this.k?.logOutgoing(x,G.id,1,l(G.type),G.data);return}}}o(G,x=void 0){const ne=new t;return g(ne,G),g(ne,x),this.p(ne.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const x=new s(G),ne=w(x),be=w(x),ae=ne[0];switch(ae){case 100:return this.k?.logIncoming(G.byteLength,ne[1],1,`${v(ae)}: ${ne[2]}.${ne[3]}`,be),this.s({type:ae,id:ne[1],channelName:ne[2],name:ne[3],arg:be});case 102:return this.k?.logIncoming(G.byteLength,ne[1],1,`${v(ae)}: ${ne[2]}.${ne[3]}`,be),this.t({type:ae,id:ne[1],channelName:ne[2],name:ne[3],arg:be});case 101:return this.k?.logIncoming(G.byteLength,ne[1],1,`${v(ae)}`),this.u({type:ae,id:ne[1]});case 103:return this.k?.logIncoming(G.byteLength,ne[1],1,`${v(ae)}`),this.u({type:ae,id:ne[1]})}}s(G){const x=this.b.get(G.channelName);if(!x){this.v(G);return}const ne=new R.$oe;let be;try{be=x.call(this.j,G.name,G.arg,ne.token)}catch(ee){be=Promise.reject(ee)}const ae=G.id;be.then(ee=>{this.m({id:ae,data:ee,type:201})},ee=>{ee instanceof Error?this.m({id:ae,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split?ee.stack.split(`
`):ee.stack:void 0},type:202}):this.m({id:ae,data:ee,type:203})}).finally(()=>{Ce.dispose(),this.d.delete(G.id)});const Ce=(0,k.$Sc)(()=>ne.cancel());this.d.set(G.id,Ce)}t(G){const x=this.b.get(G.channelName);if(!x){this.v(G);return}const ne=G.id,ae=x.listen(this.j,G.name,G.arg)(Ce=>this.m({id:ne,data:Ce,type:204}));this.d.set(G.id,ae)}u(G){const x=this.d.get(G.id);x&&(x.dispose(),this.d.delete(G.id))}v(G){let x=this.g.get(G.channelName);x||(x=[],this.g.set(G.channelName,x));const ne=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:G,timeoutTimer:ne})}w(G){const x=this.g.get(G);if(x){for(const ne of x)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,k.$Pc)(this.d.values()),this.d.clear()}}e.$$h=S;var m;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));class E{constructor(G,x=null){this.l=G,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$de,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=x}getChannel(G){const x=this;return{call(ne,be,ae){return x.a?Promise.reject(new b.$5):x.m(G,ne,be,ae)},listen(ne,be){return x.a?$.Event.None:x.o(G,ne,be)}}}m(G,x,ne,be=R.CancellationToken.None){const ae=this.g++,ee={id:ae,type:100,channelName:G,name:x,arg:ne};if(be.isCancellationRequested)return Promise.reject(new b.$5);let B;return new Promise((pe,ue)=>{if(be.isCancellationRequested)return ue(new b.$5);const ce=()=>{const se=$e=>{switch($e.type){case 201:this.f.delete(ae),pe($e.data);break;case 202:{this.f.delete(ae);const ve=new Error($e.data.message);ve.stack=Array.isArray($e.data.stack)?$e.data.stack.join(`
`):$e.data.stack,ve.name=$e.data.name,ue(ve);break}case 203:this.f.delete(ae),ue($e.data);break}};this.f.set(ae,se),this.p(ee)};let oe=null;this.b===o.Idle?ce():(oe=(0,O.$jh)(se=>this.u()),oe.then(()=>{oe=null,ce()}));const le=()=>{oe?(oe.cancel(),oe=null):this.p({id:ae,type:101}),ue(new b.$5)},K=be.onCancellationRequested(le);B=(0,k.$Rc)((0,k.$Sc)(le),K),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(G,x,ne){const be=this.g++,Ce={id:be,type:102,channelName:G,name:x,arg:ne};let ee=null;const B=new $.$de({onWillAddFirstListener:()=>{ee=(0,O.$jh)(pe=>this.u()),ee.then(()=>{ee=null,this.d.add(B),this.p(Ce)})},onDidRemoveLastListener:()=>{ee?(ee.cancel(),ee=null):(this.d.delete(B),this.p({id:be,type:103}))}}),_=pe=>B.fire(pe.data);return this.f.set(be,_),B.event}p(G){switch(G.type){case 100:case 102:{const x=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(x,G.id,0,`${v(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const x=this.q([G.type,G.id]);this.j?.logOutgoing(x,G.id,0,v(G.type));return}}}q(G,x=void 0){const ne=new t;return g(ne,G),g(ne,x),this.r(ne.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const x=new s(G),ne=w(x),be=w(x),ae=ne[0];switch(ae){case 200:return this.j?.logIncoming(G.byteLength,0,0,l(ae)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(G.byteLength,ne[1],0,l(ae),be),this.t({type:ne[0],id:ne[1],data:be})}}t(G){if(G.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,k.$Pc)(this.d.values()),this.d.clear()}}e.$_h=E,Ge([N.$1h],E.prototype,"onDidInitializePromise",null);class D{get connections(){const G=[];return this.f.forEach(x=>G.push(x)),G}constructor(G,x,ne){this.a=new Map,this.f=new Set,this.g=new $.$de,this.onDidAddConnection=this.g.event,this.h=new $.$de,this.onDidRemoveConnection=this.h.event,this.j=new k.$Tc,this.j.add(G(({protocol:be,onDidClientDisconnect:ae})=>{const Ce=$.Event.once(be.onMessage);this.j.add(Ce(ee=>{const B=new s(ee),_=w(B),pe=new S(be,_,x,ne),ue=new E(be,x);this.a.forEach((oe,le)=>pe.registerChannel(le,oe));const ce={channelServer:pe,channelClient:ue,ctx:_};this.f.add(ce),this.g.fire(ce),this.j.add(ae(()=>{pe.dispose(),ue.dispose(),this.f.delete(ce),this.h.fire(ce)}))}))}))}getChannel(G,x){const ne=this;return{call(be,ae,Ce){let ee;if((0,p.$kg)(x)){const _=(0,d.$3b)(ne.connections.filter(x));ee=_?Promise.resolve(_):$.Event.toPromise($.Event.filter(ne.onDidAddConnection,x))}else ee=x.routeCall(ne,be,ae);const B=ee.then(_=>_.channelClient.getChannel(G));return I(B).call(be,ae,Ce)},listen(be,ae){if((0,p.$kg)(x))return ne.k(G,x,be,ae);const Ce=x.routeEvent(ne,be,ae).then(ee=>ee.channelClient.getChannel(G));return I(Ce).listen(be,ae)}}}k(G,x,ne,be){const ae=this;let Ce;const ee=new $.$de({onWillAddFirstListener:()=>{Ce=new k.$Tc;const B=new $.$je,_=new Map,pe=ce=>{const le=ce.channelClient.getChannel(G).listen(ne,be),K=B.add(le);_.set(ce,K)},ue=ce=>{const oe=_.get(ce);oe&&(oe.dispose(),_.delete(ce))};ae.connections.filter(x).forEach(pe),$.Event.filter(ae.onDidAddConnection,x)(pe,void 0,Ce),ae.onDidRemoveConnection(ue,void 0,Ce),B.event(ee.fire,ee,Ce),Ce.add(B)},onDidRemoveLastListener:()=>{Ce?.dispose(),Ce=void 0}});return ee.event}registerChannel(G,x){this.a.set(G,x);for(const ne of this.f)ne.channelServer.registerChannel(G,x)}dispose(){this.j.dispose();for(const G of this.f)G.channelClient.dispose(),G.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ai=D;class P{constructor(G,x,ne=null){const be=new t;g(be,x),G.send(be.buffer),this.a=new E(G,ne),this.d=new S(G,x,ne)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,x){this.d.registerChannel(G,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$bi=P;function I(q){return{call(G,x,ne){return q.then(be=>be.call(G,x,ne))},listen(G,x){const ne=new $.$me;return q.then(be=>ne.input=be.listen(G,x)),ne.event}}}function F(q){let G=!1;return{call(x,ne,be){return G?q.call(x,ne,be):(0,O.$xh)(0).then(()=>G=!0).then(()=>q.call(x,ne,be))},listen(x,ne){if(G)return q.listen(x,ne);const be=new $.$me;return(0,O.$xh)(0).then(()=>G=!0).then(()=>be.input=q.listen(x,ne)),be.event}}}class T{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const x of G.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await $.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.$ei=T;var z;(function(q){function G(ae,Ce,ee){const B=ae,_=ee&&ee.disableMarshalling,pe=new Map;for(const ue in B)ne(ue)&&pe.set(ue,$.Event.buffer(B[ue],!0,void 0,Ce));return new class{listen(ue,ce,oe){const le=pe.get(ce);if(le)return le;const K=B[ce];if(typeof K=="function"){if(be(ce))return K.call(B,oe);if(ne(ce))return pe.set(ce,$.Event.buffer(B[ce],!0,void 0,Ce)),pe.get(ce)}throw new b.$bb(`Event not found: ${ce}`)}call(ue,ce,oe){const le=B[ce];if(typeof le=="function"){if(!_&&Array.isArray(oe))for(let se=0;se<oe.length;se++)oe[se]=(0,A.$6h)(oe[se]);let K=le.apply(B,oe);return K instanceof Promise||(K=Promise.resolve(K)),K}throw new b.$bb(`Method not found: ${ce}`)}}}q.fromService=G;function x(ae,Ce){const ee=Ce&&Ce.disableMarshalling;return new Proxy({},{get(B,_){if(typeof _=="string")return Ce?.properties?.has(_)?Ce.properties.get(_):be(_)?function(pe){return ae.listen(_,pe)}:ne(_)?ae.listen(_):async function(...pe){let ue;Ce&&!(0,p.$fg)(Ce.context)?ue=[Ce.context,...pe]:ue=pe;const ce=await ae.call(_,ue);return ee?ce:(0,A.$6h)(ce)};throw new b.$bb(`Property not found: ${String(_)}`)}})}q.toService=x;function ne(ae){return ae[0]==="o"&&ae[1]==="n"&&C.$wf(ae.charCodeAt(2))}function be(ae){return/^onDynamic/.test(ae)&&C.$wf(ae.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const G=q.toString();if(G!=="[object Object]")return G}return q}function U(q){return Array.isArray(q)?q.map(j):j(q)}function Z(q,G,x,ne,be,ae,Ce){Ce=U(Ce);const ee=M[be],B=ee[ne%ee.length];let _=[`%c[${q}]%c[${String(G).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(ae)?(_=_.concat(Ce),_.push(")")):_.push(Ce),console.log.apply(console,_)}class ie{constructor(G,x){this.d=G,this.f=x,this.a=0,this.b=0}logOutgoing(G,x,ne,be,ae){this.b+=G,Z(this.d,this.b,G,x,ne,be,ae)}logIncoming(G,x,ne,be,ae){this.a+=G,Z(this.f,this.a,G,x,ne,be,ae)}}e.$fi=ie}),define(Se[83],De([1,0,21,4,3,82]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.ProtocolConstants=e.$gi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var N;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(N||(e.SocketDiagnosticsEventType=N={}));var b;(function(a){a.enableDiagnostics=!1,a.records=[];const f=new WeakMap;let g=0;function w(m,E){if(!f.has(m)){const D=String(++g);f.set(m,D)}return f.get(m)}function S(m,E,D,P){if(!a.enableDiagnostics)return;const I=w(m,E);if(P instanceof d.$Fe||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const F=d.$Fe.alloc(P.byteLength);F.set(P),a.records.push({timestamp:Date.now(),id:I,label:E,type:D,buff:F})}else a.records.push({timestamp:Date.now(),id:I,label:E,type:D,data:P})}a.traceSocketEvent=S})(b||(e.SocketDiagnostics=b={}));var $;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let k=null;function A(){return k||(k=d.$Fe.alloc(0)),k}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(f){this.a.push(f),this.b+=f.byteLength}read(f){return this.c(f,!0)}peek(f){return this.c(f,!1)}c(f,g){if(f===0)return A();if(f>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===f){const E=this.a[0];return g&&(this.a.shift(),this.b-=f),E}if(this.a[0].byteLength>f){const E=this.a[0].slice(0,f);return g&&(this.a[0]=this.a[0].slice(f),this.b-=f),E}const w=d.$Fe.alloc(f);let S=0,m=0;for(;f>0;){const E=this.a[m];if(E.byteLength>f){const D=E.slice(0,f);w.set(D,S),S+=f,g&&(this.a[m]=E.slice(f),this.b-=f),f-=f}else w.set(E,S),S+=E.byteLength,g?(this.a.shift(),this.b-=E.byteLength):m++,f-=E.byteLength}return w}}e.$gi=C;var p;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume",a[a.KeepAlive=9]="KeepAlive"})(p||(p={}));function y(a){switch(a){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",a[a.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class h{constructor(f,g,w,S){this.type=f,this.id=g,this.ack=w,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends L.$Uc{constructor(f){super(),this.f=this.B(new O.$de),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=f,this.b=!1,this.c=new C,this.B(this.a.onData(g=>this.acceptChunk(g))),this.lastReadTime=Date.now()}acceptChunk(f){if(!(!f||f.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(f);this.c.byteLength>=this.g.readLen;){const g=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=g.readUInt32BE(9),this.g.messageType=g.readUInt8(0),this.g.id=g.readUInt32BE(1),this.g.ack=g.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const w=this.g.messageType,S=this.g.id,m=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",g),this.f.fire(new h(w,S,m,g)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(f){this.k=null,this.a=!1,this.b=!1,this.c=f,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(f){if(this.a)return;f.writtenTime=Date.now(),this.lastWriteTime=Date.now();const g=d.$Fe.alloc(13);g.writeUInt8(f.type,0),g.writeUInt32BE(f.id,1),g.writeUInt32BE(f.ack,5),g.writeUInt32BE(f.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(f.type),id:f.id,ack:f.ack,messageSize:f.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",f.data),this.j(g,f.data)}g(f,g){const w=this.f===0;return this.d.push(f,g),this.f+=f.byteLength+g.byteLength,w}h(){const f=d.$Fe.concat(this.d,this.f);return this.d.length=0,this.f=0,f}j(f,g){this.g(f,g)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const f=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:f.byteLength}),this.c.write(f)}}class n extends L.$Uc{constructor(f){super(),this.f=new O.$de,this.onMessage=this.f.event,this.g=new O.$de,this.onDidDispose=this.g.event,this.a=f,this.b=this.B(new o(this.a)),this.c=this.B(new l(this.a)),this.B(this.c.onMessage(g=>{g.type===1&&this.f.fire(g.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(f){this.b.write(new h(1,0,0,f))}}e.$hi=n;class i extends R.$bi{static fromSocket(f,g){return new i(new n(f),g)}get onDidDispose(){return this.b.onDidDispose}constructor(f,g,w=null){super(f,g,w),this.b=f}dispose(){super.dispose();const f=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),f.end()}}e.$ii=i;class u{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$de({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(f){this.b?this.d.length>0?this.d.push(f):this.a.fire(f):this.d.push(f)}flushBuffer(){this.d=[]}}e.$ji=u;class s{constructor(f){this.data=f,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let f=0,g=this.a;for(;g;)g=g.next,f++;return f}peek(){return this.a?this.a.data:null}toArray(){const f=[];let g=0,w=this.a;for(;w;)f[g++]=w.data,w=w.next;return f}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(f){const g=new s(f);if(!this.a){this.a=g,this.b=g;return}this.b.next=g,this.b=g}}class c{static{this.a=10}static{this.b=null}static getInstance(){return c.b||(c.b=new c),c.b}constructor(){this.c=[];const f=Date.now();for(let g=0;g<c.a;g++)this.c[g]=f-1e3*g;setInterval(()=>{for(let g=c.a;g>=1;g--)this.c[g]=this.c[g-1];this.c[0]=Date.now()},1e3)}d(){const f=Date.now(),g=(1+c.a)*1e3;let w=0;for(let S=0;S<c.a;S++)f-this.c[S]<=g&&w++;return 1-w/c.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(f){this.u=new u,this.onControlMessage=this.u.event,this.v=new u,this.onMessage=this.v.event,this.w=new u,this.onDidDispose=this.w.event,this.x=new u,this.onSocketClose=this.x.event,this.y=new u,this.onSocketTimeout=this.y.event,this.s=f.loadEstimator??c.getInstance(),this.t=f.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Tc,this.o=f.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new l(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),f.initialChunk&&this.q.acceptChunk(f.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const f=new h(5,0,0,A());this.p.write(f),this.p.flush()}sendPause(){const f=new h(7,0,0,A());this.p.write(f)}sendResume(){const f=new h(8,0,0,A());this.p.write(f)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(f,g){this.a=!0,this.r.dispose(),this.r=new L.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=f,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new l(this.o)),this.r.add(this.q.onMessage(w=>this.z(w))),this.r.add(this.o.onClose(w=>this.x.fire(w))),this.q.acceptChunk(g)}endAcceptReconnection(){this.a=!1,this.h=this.g;const f=new h(3,0,this.h,A());this.p.write(f);const g=this.b.toArray();for(let w=0,S=g.length;w<S;w++)this.p.write(g[w]);this.B()}acceptDisconnect(){this.w.fire()}z(f){if(f.ack>this.d){this.d=f.ack;do{const g=this.b.peek();if(g&&g.id<=f.ack)this.b.pop();else break}while(!0)}switch(f.type){case 0:break;case 1:{if(f.id>this.g)if(f.id!==this.g+1){const g=Date.now();g-this.m>1e4&&(this.m=g,this.p.write(new h(6,0,0,A())))}else this.g=f.id,this.j=Date.now(),this.A(),this.v.fire(f.data);break}case 2:{this.u.fire(f.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const g=this.b.toArray();for(let w=0,S=g.length;w<S;w++)this.p.write(g[w]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(f){const g=++this.c;this.h=this.g;const w=new h(1,g,this.h,f);this.b.push(w),this.a||(this.p.write(w),this.B())}sendControl(f){const g=new h(2,0,0,f);this.p.write(g)}A(){if(this.g<=this.h||this.k)return;const f=Date.now()-this.j;if(f>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-f+5)}B(){if(this.c<=this.d||this.f||this.a)return;const f=this.b.peek(),g=Date.now()-f.writtenTime,w=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(g>=2e4&&w>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:g,timeSinceLastReceivedSomeData:w});return}const m=Math.max(2e4-g,2e4-w,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},m)}C(){if(this.g<=this.h)return;this.h=this.g;const f=new h(3,0,this.h,A());this.p.write(f)}D(){this.h=this.g;const f=new h(9,0,this.h,A());this.p.write(f)}}e.$ki=r}),define(Se[199],De([1,0,54,7,21,22,197,13,4,3,24,105,102,82]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;class v extends y.$$h{constructor(o){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",n=>L.$Fe.wrap(Buffer.from(n,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$Zq=v;class h{constructor(o,n){this.i=o,this.j=n,this.c=new Set,this.g=new Map,this.h=new $.$de,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new O.$th(i),this.d=null,this.f=null}getChannel(o){const n=this;return{call(i,u,s){return n.k(o,i,u,s)},listen(i,u){return n.l(o,i,u)}}}k(o,n,i,u=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const s=this.n(o),t=(0,O.$jh)(a=>s.call(n,i,a)),c=u.onCancellationRequested(()=>t.cancel()),r=(0,k.$Sc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{c.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,n,i){if(!this.b)return $.Event.None;this.b.cancel();let u;const s=new $.$de({onWillAddFirstListener:()=>{u=this.n(o).listen(n,i)(s.fire,s),this.c.add(u)},onDidRemoveLastListener:()=>{this.c.delete(u),u.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,A.$3n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(g=>!/^--inspect(-brk)?=/.test(g)).filter(g=>!g.startsWith("--vscode-"))),(0,p.$nm)(n.env),this.d=(0,d.fork)(this.i,o,n);const i=new $.$de,s=$.Event.fromNodeEventEmitter(this.d,"message",g=>g)(g=>{if((0,N.$Vq)(g)){(0,N.log)(g,`IPC Library: ${this.j.serverName}`);return}i.fire(L.$Fe.wrap(Buffer.from(g,"base64")))}),t=this.j.useQueue?(0,C.$pm)(this.d):this.d,c=g=>this.d&&this.d.connected&&t.send(g.buffer.toString("base64")),r=i.event,a={send:c,onMessage:r};this.f=new y.$_h(a);const f=()=>this.o();process.once("exit",f),this.d.on("error",g=>console.warn('IPC "'+this.j.serverName+'" errored with '+g)),this.d.on("exit",(g,w)=>{process.removeListener("exit",f),s.dispose(),this.c.forEach(S=>(0,k.$Pc)(S)),this.c.clear(),g!==0&&w!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+g+" and signal "+w),this.b?.cancel(),this.o(),this.h.fire({code:g,signal:w})})}return this.f}n(o){let n=this.g.get(o);return n||(n=this.m.getChannel(o),this.g.set(o,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$1q=h}),define(Se[200],De([1,0,7,4,3,58,18]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.StorageState=e.StorageHint=void 0,e.$Vp=$;var b;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function $(p){const y=p;return y?.changed instanceof Map||y?.deleted instanceof Set}var k;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(k||(e.StorageState=k={}));class A extends L.$Uc{static{this.a=100}constructor(y,v=Object.create(null)){super(),this.r=y,this.s=v,this.b=this.B(new O.$ge),this.onDidChangeStorage=this.b.event,this.c=k.None,this.f=new Map,this.g=this.B(new d.$uh(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((v,h)=>this.w(h,v)),y.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(y,v){if(this.c===k.Closed)return;let h=!1;(0,N.$fg)(v)?h=this.f.delete(y):this.f.get(y)!==v&&(this.f.set(y,v),h=!0),h&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===k.None&&(this.c=k.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,v){const h=this.f.get(y);return(0,N.$fg)(h)?v:h}getBoolean(y,v){const h=this.get(y);return(0,N.$fg)(h)?v:h==="true"}getNumber(y,v){const h=this.get(y);return(0,N.$fg)(h)?v:parseInt(h,10)}getObject(y,v){const h=this.get(y);return(0,N.$fg)(h)?v:(0,R.$5h)(h)}async set(y,v,h=!1){if(this.c===k.Closed)return;if((0,N.$fg)(v))return this.delete(y,h);const l=(0,N.$$f)(v)||Array.isArray(v)?(0,R.$4h)(v):String(v);if(this.f.get(y)!==l)return this.f.set(y,l),this.j.set(y,l),this.h.delete(y),this.b.fire({key:y,external:h}),this.D()}async delete(y,v=!1){if(!(this.c===k.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:v}),this.D()}async optimize(){if(this.c!==k.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=k.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(!(this.c===k.Closed||this.m))return this.D(y)}async D(y){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$Wp=A;class C{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((v,h)=>this.a.set(h,v)),y.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$Xp=C}),define(Se[201],De([1,0,14,12,21]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=void 0,e.$Dt=A,e.$Et=C;let R;function N(){return R||(R=new TextDecoder("UTF-16LE")),R}let b;function $(){return b||(b=new TextDecoder("UTF-16BE")),b}let k;function A(){return k||(k=O.$D()?N():$()),k}function C(v,h,l){const o=new Uint16Array(v.buffer,h,l);return l>0&&(o[0]===65279||o[0]===65534)?p(v,h,l):N().decode(o)}function p(v,h,l){const o=[];let n=0;for(let i=0;i<l;i++){const u=L.$He(v,h);h+=2,o[n++]=String.fromCharCode(u)}return o.join("")}class y{constructor(h){this.a=h|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const h=new Uint16Array(this.b.buffer,0,this.d);return A().decode(h)}f(){const h=this.e();this.d=0,this.c===null?this.c=[h]:this.c[this.c.length]=h}appendCharCode(h){const l=this.a-this.d;l<=1&&(l===0||d.$Bf(h))&&this.f(),this.b[this.d++]=h}appendASCIICharCode(h){this.d===this.a&&this.f(),this.b[this.d++]=h}appendString(h){const l=h.length;if(this.d+l>=this.a){this.f(),this.c[this.c.length]=h;return}for(let o=0;o<l;o++)this.b[this.d++]=h.charCodeAt(o)}}e.$Ft=y}),define(Se[202],De([1,0,21,201]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=void 0,e.$Ht=N;function L($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,A,C,p){this.oldPosition=k,this.oldText=A,this.newPosition=C,this.newText=p}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${L(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${L(this.oldText)}")`:`(replace@${this.oldPosition} "${L(this.oldText)}" with "${L(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,A,C){const p=A.length;d.$Ke(k,p,C),C+=4;for(let y=0;y<p;y++)d.$Ie(k,A.charCodeAt(y),C),C+=2;return C}static d(k,A){const C=d.$Je(k,A);return A+=4,(0,O.$Et)(k,A,C)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(k,A){return d.$Ke(k,this.oldPosition,A),A+=4,d.$Ke(k,this.newPosition,A),A+=4,A=R.c(k,this.oldText,A),A=R.c(k,this.newText,A),A}static read(k,A,C){const p=d.$Je(k,A);A+=4;const y=d.$Je(k,A);A+=4;const v=R.d(k,A);A+=R.a(v);const h=R.d(k,A);return A+=R.a(h),C.push(new R(p,v,y,h)),A}}e.$Gt=R;function N($,k){return $===null||$.length===0?k:new b($,k).compress()}class b{constructor(k,A){this.a=k,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,A=0,C=this.n(k),p=this.l(A);for(;k<this.f||A<this.h;){if(C===null){this.k(p),p=this.l(++A);continue}if(p===null){this.m(C),C=this.n(++k);continue}if(p.oldEnd<=C.newPosition){this.k(p),p=this.l(++A);continue}if(C.newEnd<=p.oldPosition){this.m(C),C=this.n(++k);continue}if(p.oldPosition<C.newPosition){const[o,n]=b.r(p,C.newPosition-p.oldPosition);this.k(o),p=n;continue}if(C.newPosition<p.oldPosition){const[o,n]=b.q(C,p.oldPosition-C.newPosition);this.m(o),C=n;continue}let h,l;if(p.oldEnd===C.newEnd)h=C,l=p,C=this.n(++k),p=this.l(++A);else if(p.oldEnd<C.newEnd){const[o,n]=b.q(C,p.oldLength);h=o,l=p,C=n,p=this.l(++A)}else{const[o,n]=b.r(p,C.newLength);h=C,l=o,C=this.n(++k),p=n}this.d[this.e++]=new R(h.oldPosition,h.oldText,l.newPosition,l.newText),this.g+=h.newLength-h.oldLength,this.j+=l.newLength-l.oldLength}const y=b.s(this.d);return b.t(y)}k(k){this.d[this.e++]=b.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=b.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,A){return new R(A.oldPosition-k,A.oldText,A.newPosition,A.newText)}static p(k,A){return new R(A.oldPosition,A.oldText,A.newPosition+k,A.newText)}static q(k,A){const C=k.newText.substr(0,A),p=k.newText.substr(A);return[new R(k.oldPosition,k.oldText,k.newPosition,C),new R(k.oldEnd,"",k.newPosition+A,p)]}static r(k,A){const C=k.oldText.substr(0,A),p=k.oldText.substr(A);return[new R(k.oldPosition,C,k.newPosition,k.newText),new R(k.oldPosition+A,p,k.newEnd,"")]}static s(k){if(k.length===0)return k;const A=[];let C=0,p=k[0];for(let y=1;y<k.length;y++){const v=k[y];p.oldEnd===v.oldPosition?p=new R(p.oldPosition,p.oldText+v.oldText,p.newPosition,p.newText+v.newText):(A[C++]=p,p=v)}return A[C++]=p,A}static t(k){if(k.length===0)return k;const A=[];let C=0;for(let p=0;p<k.length;p++){const y=k[p];y.oldText!==y.newText&&(A[C++]=y)}return A}}}),define(Se[203],De([1,0,35,17]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xt=L,e.$Yt=R;function L(N,b,$,k,A,C){if(Array.isArray(N)){let p=0;for(const y of N){const v=L(y,b,$,k,A,C);if(v===10)return v;v>p&&(p=v)}return p}else{if(typeof N=="string")return k?N==="*"?5:N===$?10:0:0;if(N){const{language:p,pattern:y,scheme:v,hasAccessToAllModels:h,notebookType:l}=N;if(!k&&!h)return 0;l&&A&&(b=A);let o=0;if(v)if(v===b.scheme)o=10;else if(v==="*")o=5;else return 0;if(p)if(p===$)o=10;else if(p==="*")o=Math.max(o,5);else return 0;if(l)if(l===C)o=10;else if(l==="*"&&C!==void 0)o=Math.max(o,5);else return 0;if(y){let n;if(typeof y=="string"?n=y:n={...y,base:(0,O.$hc)(y.base)},n===b.fsPath||(0,d.$pk)(n,b.fsPath))o=10;else return 0}return o}else return 0}}function R(N){return typeof N=="string"?!1:Array.isArray(N)?N.some(R):!!N.notebookType}}),define(Se[204],De([1,0,4,14,29,80,131,179,202,3]),function(he,e,d,O,L,R,N,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1C=void 0;class A extends k.$Uc{constructor(p,y,v,h,l,o,n){super(),this.m=this.B(new d.$de),this.onDidChangeContent=this.m.event,this.f=y,this.j=!o,this.g=h,this.h=l,this.c=new N.$ZC(p,v,n)}equals(p){return!(p instanceof A)||this.f!==p.f||this.getEOL()!==p.getEOL()?!1:this.c.equal(p.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(p){return this.c.createSnapshot(p?this.f:"")}getOffsetAt(p,y){return this.c.getOffsetAt(p,y)}getPositionAt(p){return this.c.getPositionAt(p)}getRangeAt(p,y){const v=p+y,h=this.getPositionAt(p),l=this.getPositionAt(v);return new L.$ut(h.lineNumber,h.column,l.lineNumber,l.column)}getValueInRange(p,y=0){if(p.isEmpty())return"";const v=this.n(y);return this.c.getValueInRange(p,v)}getValueLengthInRange(p,y=0){if(p.isEmpty())return 0;if(p.startLineNumber===p.endLineNumber)return p.endColumn-p.startColumn;const v=this.getOffsetAt(p.startLineNumber,p.startColumn),h=this.getOffsetAt(p.endLineNumber,p.endColumn);let l=0;const o=this.n(y),n=this.getEOL();if(o.length!==n.length){const i=o.length-n.length,u=p.endLineNumber-p.startLineNumber;l=i*u}return h-v+l}getCharacterCountInRange(p,y=0){if(this.j){let v=0;const h=p.startLineNumber,l=p.endLineNumber;for(let o=h;o<=l;o++){const n=this.getLineContent(o),i=o===h?p.startColumn-1:0,u=o===l?p.endColumn-1:n.length;for(let s=i;s<u;s++)O.$Bf(n.charCodeAt(s))?(v=v+1,s=s+1):v=v+1}return v+=this.n(y).length*(l-h),v}return this.getValueLengthInRange(p,y)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(p){return this.c.getLineContent(p)}getLineCharCode(p,y){return this.c.getLineCharCode(p,y)}getCharCode(p){return this.c.getCharCode(p)}getLineLength(p){return this.c.getLineLength(p)}getLineMinColumn(p){return 1}getLineMaxColumn(p){return this.getLineLength(p)+1}getLineFirstNonWhitespaceColumn(p){const y=O.$mf(this.getLineContent(p));return y===-1?0:y+1}getLineLastNonWhitespaceColumn(p){const y=O.$of(this.getLineContent(p));return y===-1?0:y+2}n(p){switch(p){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(p){this.c.setEOL(p)}applyEdits(p,y,v){let h=this.g,l=this.h,o=this.j,n=!0,i=[];for(let f=0;f<p.length;f++){const g=p[f];n&&g._isTracked&&(n=!1);const w=g.range;if(g.text){let P=!0;o||(P=!O.$Mf(g.text),o=P),!h&&P&&(h=O.$Lf(g.text)),!l&&P&&(l=O.$Of(g.text))}let S="",m=0,E=0,D=0;if(g.text){let P;[m,E,D,P]=(0,b.$1t)(g.text);const I=this.getEOL();P===0||P===(I===`\r
`?2:1)?S=g.text:S=g.text.replace(/\r\n|\r|\n/g,I)}i[f]={sortIndex:f,identifier:g.identifier||null,range:w,rangeOffset:this.getOffsetAt(w.startLineNumber,w.startColumn),rangeLength:this.getValueLengthInRange(w),text:S,eolCount:m,firstLineLength:E,lastLineLength:D,forceMoveMarkers:!!g.forceMoveMarkers,isAutoWhitespaceEdit:g.isAutoWhitespaceEdit||!1}}i.sort(A.u);let u=!1;for(let f=0,g=i.length-1;f<g;f++){const w=i[f].range.getEndPosition(),S=i[f+1].range.getStartPosition();if(S.isBeforeOrEqual(w)){if(S.isBefore(w))throw new Error("Overlapping ranges are not allowed!");u=!0}}n&&(i=this.s(i));const s=v||y?A._getInverseEditRanges(i):[],t=[];if(y)for(let f=0;f<i.length;f++){const g=i[f],w=s[f];if(g.isAutoWhitespaceEdit&&g.range.isEmpty())for(let S=w.startLineNumber;S<=w.endLineNumber;S++){let m="";S===w.startLineNumber&&(m=this.getLineContent(g.range.startLineNumber),O.$mf(m)!==-1)||t.push({lineNumber:S,oldContent:m})}}let c=null;if(v){let f=0;c=[];for(let g=0;g<i.length;g++){const w=i[g],S=s[g],m=this.getValueInRange(w.range),E=w.rangeOffset+f;f+=w.text.length-m.length,c[g]={sortIndex:w.sortIndex,identifier:w.identifier,range:S,text:m,textChange:new $.$Gt(w.rangeOffset,m,E,w.text)}}u||c.sort((g,w)=>g.sortIndex-w.sortIndex)}this.g=h,this.h=l,this.j=o;const r=this.t(i);let a=null;if(y&&t.length>0){t.sort((f,g)=>g.lineNumber-f.lineNumber),a=[];for(let f=0,g=t.length;f<g;f++){const w=t[f].lineNumber;if(f>0&&t[f-1].lineNumber===w)continue;const S=t[f].oldContent,m=this.getLineContent(w);m.length===0||m===S||O.$mf(m)!==-1||a.push(w)}}return this.m.fire(),new R.$Jv(c,r,a)}s(p){return p.length<1e3?p:[this._toSingleEditOperation(p)]}_toSingleEditOperation(p){let y=!1;const v=p[0].range,h=p[p.length-1].range,l=new L.$ut(v.startLineNumber,v.startColumn,h.endLineNumber,h.endColumn);let o=v.startLineNumber,n=v.startColumn;const i=[];for(let r=0,a=p.length;r<a;r++){const f=p[r],g=f.range;y=y||f.forceMoveMarkers,i.push(this.getValueInRange(new L.$ut(o,n,g.startLineNumber,g.startColumn))),f.text.length>0&&i.push(f.text),o=g.endLineNumber,n=g.endColumn}const u=i.join(""),[s,t,c]=(0,b.$1t)(u);return{sortIndex:0,identifier:p[0].identifier,range:l,rangeOffset:this.getOffsetAt(l.startLineNumber,l.startColumn),rangeLength:this.getValueLengthInRange(l,0),text:u,eolCount:s,firstLineLength:t,lastLineLength:c,forceMoveMarkers:y,isAutoWhitespaceEdit:!1}}t(p){p.sort(A.w);const y=[];for(let v=0;v<p.length;v++){const h=p[v],l=h.range.startLineNumber,o=h.range.startColumn,n=h.range.endLineNumber,i=h.range.endColumn;if(l===n&&o===i&&h.text.length===0)continue;h.text?(this.c.delete(h.rangeOffset,h.rangeLength),this.c.insert(h.rangeOffset,h.text,!0)):this.c.delete(h.rangeOffset,h.rangeLength);const u=new L.$ut(l,o,n,i);y.push({range:u,rangeLength:h.rangeLength,text:h.text,rangeOffset:h.rangeOffset,forceMoveMarkers:h.forceMoveMarkers})}return y}findMatchesLineByLine(p,y,v,h){return this.c.findMatchesLineByLine(p,y,v,h)}getPieceTree(){return this.c}static _getInverseEditRange(p,y){const v=p.startLineNumber,h=p.startColumn,[l,o,n]=(0,b.$1t)(y);let i;if(y.length>0){const u=l+1;u===1?i=new L.$ut(v,h,v,h+o):i=new L.$ut(v,h,v+u-1,n+1)}else i=new L.$ut(v,h,v,h);return i}static _getInverseEditRanges(p){const y=[];let v=0,h=0,l=null;for(let o=0,n=p.length;o<n;o++){const i=p[o];let u,s;l?l.range.endLineNumber===i.range.startLineNumber?(u=v,s=h+(i.range.startColumn-l.range.endColumn)):(u=v+(i.range.startLineNumber-l.range.endLineNumber),s=i.range.startColumn):(u=i.range.startLineNumber,s=i.range.startColumn);let t;if(i.text.length>0){const c=i.eolCount+1;c===1?t=new L.$ut(u,s,u,s+i.firstLineLength):t=new L.$ut(u,s,u+c-1,i.lastLineLength+1)}else t=new L.$ut(u,s,u,s);v=t.endLineNumber,h=t.endColumn,y.push(t),l=i}return y}static u(p,y){const v=L.$ut.compareRangesUsingEnds(p.range,y.range);return v===0?p.sortIndex-y.sortIndex:v}static w(p,y){const v=L.$ut.compareRangesUsingEnds(p.range,y.range);return v===0?y.sortIndex-p.sortIndex:-v}}e.$1C=A}),define(Se[205],De([1,0,14,131,204]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=void 0;class R{constructor($,k,A,C,p,y,v,h,l){this.a=$,this.b=k,this.c=A,this.d=C,this.e=p,this.f=y,this.g=v,this.h=h,this.j=l}k($){const k=this.c+this.d+this.e,A=this.c+this.e;return k===0?$===1?`
`:`\r
`:A>k/2?`\r
`:`
`}create($){const k=this.k($),A=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let p=0,y=A.length;p<y;p++){const v=A[p].buffer.replace(/\r\n|\r|\n/g,k),h=(0,O.$VC)(v);A[p]=new O.$YC(v,h)}const C=new L.$1C(A,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class N{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&d.$Wf($)&&(this.b=d.$Vf,$=$.substr(1));const k=$.charCodeAt($.length-1);k===13||k>=55296&&k<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=k):(this.m($,!1),this.c=!1,this.d=k)}m($,k){!k&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const k=(0,O.$WC)(this.e,$);this.a.push(new O.$YC($,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=d.$Lf($)),this.k||(this.k=d.$Of($)))}finish($=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const k=(0,O.$VC)($.buffer);$.lineStarts=k,this.d===13&&this.f++}}}e.$2C=N}),define(Se[135],De([1,0,21,12]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccb=$,e.$dcb=A;var L;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(L||(L={}));function R(C){for(let p=0,y=C.length;p<y;p+=4){const v=C[p+0],h=C[p+1],l=C[p+2],o=C[p+3];C[p+0]=o,C[p+1]=l,C[p+2]=h,C[p+3]=v}}function N(C){const p=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return O.$D()||R(p),d.$Fe.wrap(p)}function b(C){const p=C.buffer;if(O.$D()||R(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const y=new Uint8Array(p.byteLength);return y.set(p),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function $(C){const p=new Uint32Array(k(C));let y=0;if(p[y++]=C.id,C.type==="full")p[y++]=1,p[y++]=C.data.length,p.set(C.data,y),y+=C.data.length;else{p[y++]=2,p[y++]=C.deltas.length;for(const v of C.deltas)p[y++]=v.start,p[y++]=v.deleteCount,v.data?(p[y++]=v.data.length,p.set(v.data,y),y+=v.data.length):p[y++]=0}return N(p)}function k(C){let p=0;if(p+=2,C.type==="full")p+=1+C.data.length;else{p+=1,p+=3*C.deltas.length;for(const y of C.deltas)y.data&&(p+=y.data.length)}return p}function A(C){const p=b(C);let y=0;const v=p[y++];if(p[y++]===1){const n=p[y++],i=p.subarray(y,y+n);return y+=n,{id:v,type:"full",data:i}}const l=p[y++],o=[];for(let n=0;n<l;n++){const i=p[y++],u=p[y++],s=p[y++];let t;s>0&&(t=p.subarray(y,y+s),y+=s),o[n]={start:i,deleteCount:u,data:t}}return{id:v,type:"delta",deltas:o}}}),define(Se[206],De([9,10]),function(he,e){return he.create("vs/editor/common/config/editorOptions",e)}),define(Se[136],De([1,0,19,24,12,182,130,206]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=l,e.clampedInt=n,e.clampedFloat=u,e.stringSet=c,e.cursorStyleToString=D,e.filterValidationDecorations=ve;var $;(function(te){te[te.None=0]="None",te[te.Keep=1]="Keep",te[te.Brackets=2]="Brackets",te[te.Advanced=3]="Advanced",te[te.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(re){this.c=re}hasChanged(re){return this.c[re]}}e.ConfigurationChangedEvent=k;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class C{constructor(re,Pe,He,Le){this.id=re,this.name=Pe,this.defaultValue=He,this.schema=Le}applyUpdate(re,Pe){return y(re,Pe)}compute(re,Pe,He){return He}}class p{constructor(re,Pe){this.newValue=re,this.didChange=Pe}}e.ApplyUpdateResult=p;function y(te,re){if(typeof te!="object"||typeof re!="object"||!te||!re)return new p(re,te!==re);if(Array.isArray(te)||Array.isArray(re)){const He=Array.isArray(te)&&Array.isArray(re)&&d.$ub(te,re);return new p(re,!He)}let Pe=!1;for(const He in re)if(re.hasOwnProperty(He)){const Le=y(te[He],re[He]);Le.didChange&&(te[He]=Le.newValue,Pe=!0)}return new p(te,Pe)}class v{constructor(re){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0}applyUpdate(re,Pe){return y(re,Pe)}validate(re){return this.defaultValue}}class h{constructor(re,Pe,He,Le){this.id=re,this.name=Pe,this.defaultValue=He,this.schema=Le}applyUpdate(re,Pe){return y(re,Pe)}validate(re){return typeof re>"u"?this.defaultValue:re}compute(re,Pe,He){return He}}function l(te,re){return typeof te>"u"?re:te==="false"?!1:!!te}class o extends h{constructor(re,Pe,He,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=He),super(re,Pe,He,Le)}validate(re){return l(re,this.defaultValue)}}function n(te,re,Pe,He){if(typeof te>"u")return re;let Le=parseInt(te,10);return isNaN(Le)?re:(Le=Math.max(Pe,Le),Le=Math.min(He,Le),Le|0)}class i extends h{static clampedInt(re,Pe,He,Le){return n(re,Pe,He,Le)}constructor(re,Pe,He,Le,st,lt=void 0){typeof lt<"u"&&(lt.type="integer",lt.default=He,lt.minimum=Le,lt.maximum=st),super(re,Pe,He,lt),this.minimum=Le,this.maximum=st}validate(re){return i.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}function u(te,re,Pe,He){if(typeof te>"u")return re;const Le=s.float(te,re);return s.clamp(Le,Pe,He)}class s extends h{static clamp(re,Pe,He){return re<Pe?Pe:re>He?He:re}static float(re,Pe){if(typeof re=="number")return re;if(typeof re>"u")return Pe;const He=parseFloat(re);return isNaN(He)?Pe:He}constructor(re,Pe,He,Le,st){typeof st<"u"&&(st.type="number",st.default=He),super(re,Pe,He,st),this.validationFn=Le}validate(re){return this.validationFn(s.float(re,this.defaultValue))}}class t extends h{static string(re,Pe){return typeof re!="string"?Pe:re}constructor(re,Pe,He,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=He),super(re,Pe,He,Le)}validate(re){return t.string(re,this.defaultValue)}}function c(te,re,Pe,He){return typeof te!="string"?re:He&&te in He?He[te]:Pe.indexOf(te)===-1?re:te}class r extends h{constructor(re,Pe,He,Le,st=void 0){typeof st<"u"&&(st.type="string",st.enum=Le,st.default=He),super(re,Pe,He,st),this.c=Le}validate(re){return c(re,this.defaultValue,this.c)}}class a extends C{constructor(re,Pe,He,Le,st,lt,mt=void 0){typeof mt<"u"&&(mt.type="string",mt.enum=st,mt.default=Le),super(re,Pe,He,mt),this.c=st,this.d=lt}validate(re){return typeof re!="string"?this.defaultValue:this.c.indexOf(re)===-1?this.defaultValue:this.d(re)}}function f(te){switch(te){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,Pe,He){return He===0?re.accessibilitySupport:He}}class w extends C{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:b.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{insertSpace:l(Pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(Pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(te){te[te.Hidden=0]="Hidden",te[te.Blink=1]="Blink",te[te.Smooth=2]="Smooth",te[te.Phase=3]="Phase",te[te.Expand=4]="Expand",te[te.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function m(te){switch(te){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var E;(function(te){te[te.Line=1]="Line",te[te.Block=2]="Block",te[te.Underline=3]="Underline",te[te.LineThin=4]="LineThin",te[te.BlockOutline=5]="BlockOutline",te[te.UnderlineThin=6]="UnderlineThin"})(E||(e.TextEditorCursorStyle=E={}));function D(te){switch(te){case E.Line:return"line";case E.Block:return"block";case E.Underline:return"underline";case E.LineThin:return"line-thin";case E.BlockOutline:return"block-outline";case E.UnderlineThin:return"underline-thin"}}function P(te){switch(te){case"line":return E.Line;case"block":return E.Block;case"underline":return E.Underline;case"line-thin":return E.LineThin;case"block-outline":return E.BlockOutline;case"underline-thin":return E.UnderlineThin}}class I extends v{constructor(){super(142)}compute(re,Pe,He){const Le=["monaco-editor"];return Pe.get(39)&&Le.push(Pe.get(39)),re.extraEditorClassName&&Le.push(re.extraEditorClassName),Pe.get(74)==="default"?Le.push("mouse-default"):Pe.get(74)==="copy"&&Le.push("mouse-copy"),Pe.get(111)&&Le.push("showUnused"),Pe.get(140)&&Le.push("showDeprecated"),Le.join(" ")}}class F extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(re,Pe,He){return He&&re.emptySelectionClipboard}}class T extends C{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:re.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:b.localize(16,null),included:L.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:b.localize(18,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{cursorMoveOnType:l(Pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof re.seedSearchStringFromSelection=="boolean"?re.seedSearchStringFromSelection?"always":"never":c(Pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":c(Pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(Pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(Pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(Pe.loop,this.defaultValue.loop)}}}class z extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(re){return typeof re>"u"?this.defaultValue:typeof re=="string"?re==="false"||re.length===0?z.OFF:re==="true"?z.ON:re:re?z.ON:z.OFF}}e.EditorFontLigatures=z;class M extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(re){return typeof re>"u"?this.defaultValue:typeof re=="string"?re==="false"?M.OFF:re==="true"?M.TRANSLATE:re:re?M.TRANSLATE:M.OFF}compute(re,Pe,He){return re.fontInfo.fontVariationSettings}}e.EditorFontVariations=M;class j extends v{constructor(){super(50)}compute(re,Pe,He){return re.fontInfo}}class U extends h{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(re){const Pe=s.float(re,this.defaultValue);return Pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(Pe,6,100)}compute(re,Pe,He){return re.fontInfo.fontSize}}class Z extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Z.d,maximum:Z.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(re){return re==="normal"||re==="bold"?re:String(i.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,Z.d,Z.e))}}class ie extends C{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Pe},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Pe},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Pe},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Pe},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,enum:He,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,enum:He,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,enum:He,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,enum:He,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,enum:He,description:b.localize(41,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{multiple:c(Pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Pe.multipleDefinitions??c(Pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Pe.multipleTypeDefinitions??c(Pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Pe.multipleDeclarations??c(Pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Pe.multipleImplementations??c(Pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Pe.multipleReferences??c(Pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class q extends C{constructor(){const re={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:re.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:re.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:re.above,description:b.localize(46,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{enabled:l(Pe.enabled,this.defaultValue.enabled),delay:i.clampedInt(Pe.delay,this.defaultValue.delay,0,1e4),sticky:l(Pe.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:l(Pe.above,this.defaultValue.above)}}}var G;(function(te){te[te.None=0]="None",te[te.Text=1]="Text",te[te.Blocks=2]="Blocks"})(G||(e.RenderMinimap=G={}));class x extends v{constructor(){super(145)}compute(re,Pe,He){return x.computeLayout(Pe,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio,glyphMarginDecorationLaneCount:re.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(re){const Pe=re.height/re.lineHeight,He=Math.floor(re.paddingTop/re.lineHeight);let Le=Math.floor(re.paddingBottom/re.lineHeight);re.scrollBeyondLastLine&&(Le=Math.max(Le,Pe-1));const st=(He+re.viewLineCount+Le)/(re.pixelRatio*re.height),lt=Math.floor(re.viewLineCount/st);return{typicalViewportLineCount:Pe,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:Le,desiredRatio:st,minimapLineCount:lt}}static c(re,Pe){const He=re.outerWidth,Le=re.outerHeight,st=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const lt=Pe.stableMinimapLayoutInput,mt=lt&&re.outerHeight===lt.outerHeight&&re.lineHeight===lt.lineHeight&&re.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&re.pixelRatio===lt.pixelRatio&&re.scrollBeyondLastLine===lt.scrollBeyondLastLine&&re.paddingTop===lt.paddingTop&&re.paddingBottom===lt.paddingBottom&&re.minimap.enabled===lt.minimap.enabled&&re.minimap.side===lt.minimap.side&&re.minimap.size===lt.minimap.size&&re.minimap.showSlider===lt.minimap.showSlider&&re.minimap.renderCharacters===lt.minimap.renderCharacters&&re.minimap.maxColumn===lt.minimap.maxColumn&&re.minimap.scale===lt.minimap.scale&&re.verticalScrollbarWidth===lt.verticalScrollbarWidth&&re.isViewportWrapping===lt.isViewportWrapping,Pt=re.lineHeight,It=re.typicalHalfwidthCharacterWidth,Bt=re.scrollBeyondLastLine,Ut=re.minimap.renderCharacters;let kt=st>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const Yt=re.minimap.maxColumn,xt=re.minimap.size,xe=re.minimap.side,on=re.verticalScrollbarWidth,Kt=re.viewLineCount,ft=re.remainingWidth,$t=re.isViewportWrapping,_t=Ut?2:3;let Jt=Math.floor(st*Le);const Tt=Jt/st;let gt=!1,Vt=!1,en=_t*kt,Wt=kt/st,Ze=1;if(xt==="fill"||xt==="fit"){const{typicalViewportLineCount:jt,extraLinesBeforeFirstLine:tn,extraLinesBeyondLastLine:qt,desiredRatio:an,minimapLineCount:Ot}=x.computeContainedMinimapLineCount({viewLineCount:Kt,scrollBeyondLastLine:Bt,paddingTop:re.paddingTop,paddingBottom:re.paddingBottom,height:Le,lineHeight:Pt,pixelRatio:st});if(Kt/Ot>1)gt=!0,Vt=!0,kt=1,en=1,Wt=kt/st;else{let Mt=!1,At=kt+1;if(xt==="fit"){const pt=Math.ceil((tn+Kt+qt)*en);$t&&mt&&ft<=Pe.stableFitRemainingWidth?(Mt=!0,At=Pe.stableFitMaxMinimapScale):Mt=pt>Jt}if(xt==="fill"||Mt){gt=!0;const pt=kt;en=Math.min(Pt*st,Math.max(1,Math.floor(1/an))),$t&&mt&&ft<=Pe.stableFitRemainingWidth&&(At=Pe.stableFitMaxMinimapScale),kt=Math.min(At,Math.max(1,Math.floor(en/_t))),kt>pt&&(Ze=Math.min(2,kt/pt)),Wt=kt/st/Ze,Jt=Math.ceil(Math.max(jt,tn+Kt+qt)*en),$t?(Pe.stableMinimapLayoutInput=re,Pe.stableFitRemainingWidth=ft,Pe.stableFitMaxMinimapScale=kt):(Pe.stableMinimapLayoutInput=null,Pe.stableFitRemainingWidth=0)}}}const un=Math.floor(Yt*Wt),Xt=Math.min(un,Math.max(0,Math.floor((ft-on-2)*Wt/(It+Wt)))+e.MINIMAP_GUTTER_WIDTH);let Ht=Math.floor(st*Xt);const wt=Ht/st;Ht=Math.floor(Ht*Ze);const Ft=Ut?1:2,Rt=xe==="left"?0:He-Xt-on;return{renderMinimap:Ft,minimapLeft:Rt,minimapWidth:Xt,minimapHeightIsEditorHeight:gt,minimapIsSampling:Vt,minimapScale:kt,minimapLineHeight:en,minimapCanvasInnerWidth:Ht,minimapCanvasInnerHeight:Jt,minimapCanvasOuterWidth:wt,minimapCanvasOuterHeight:Tt}}static computeLayout(re,Pe){const He=Pe.outerWidth|0,Le=Pe.outerHeight|0,st=Pe.lineHeight|0,lt=Pe.lineNumbersDigitCount|0,mt=Pe.typicalHalfwidthCharacterWidth,Pt=Pe.maxDigitWidth,It=Pe.pixelRatio,Bt=Pe.viewLineCount,Ut=re.get(137),kt=Ut==="inherit"?re.get(136):Ut,Yt=kt==="inherit"?re.get(132):kt,xt=re.get(135),xe=Pe.isDominatedByLongLines,on=re.get(57),Kt=re.get(68).renderType!==0,ft=re.get(69),$t=re.get(105),_t=re.get(84),Jt=re.get(73),Tt=re.get(103),gt=Tt.verticalScrollbarSize,Vt=Tt.verticalHasArrows,en=Tt.arrowSize,Wt=Tt.horizontalScrollbarSize,Ze=re.get(43),un=re.get(110)!=="never";let Xt=re.get(66);Ze&&un&&(Xt+=16);let Ht=0;if(Kt){const sn=Math.max(lt,ft);Ht=Math.round(sn*Pt)}let wt=0;on&&(wt=st*Pe.glyphMarginDecorationLaneCount);let Ft=0,Rt=Ft+wt,jt=Rt+Ht,tn=jt+Xt;const qt=He-wt-Ht-Xt;let an=!1,Ot=!1,Lt=-1;kt==="inherit"&&xe?(an=!0,Ot=!0):Yt==="on"||Yt==="bounded"?Ot=!0:Yt==="wordWrapColumn"&&(Lt=xt);const Mt=x.c({outerWidth:He,outerHeight:Le,lineHeight:st,typicalHalfwidthCharacterWidth:mt,pixelRatio:It,scrollBeyondLastLine:$t,paddingTop:_t.top,paddingBottom:_t.bottom,minimap:Jt,verticalScrollbarWidth:gt,viewLineCount:Bt,remainingWidth:qt,isViewportWrapping:Ot},Pe.memory||new A);Mt.renderMinimap!==0&&Mt.minimapLeft===0&&(Ft+=Mt.minimapWidth,Rt+=Mt.minimapWidth,jt+=Mt.minimapWidth,tn+=Mt.minimapWidth);const At=qt-Mt.minimapWidth,pt=Math.max(1,Math.floor((At-gt-2)/mt)),St=Vt?en:0;return Ot&&(Lt=Math.max(1,pt),Yt==="bounded"&&(Lt=Math.min(Lt,xt))),{width:He,height:Le,glyphMarginLeft:Ft,glyphMarginWidth:wt,glyphMarginDecorationLaneCount:Pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Rt,lineNumbersWidth:Ht,decorationsLeft:jt,decorationsWidth:Xt,contentLeft:tn,contentWidth:At,minimap:Mt,viewportColumn:pt,isWordWrapMinified:an,isViewportWrapping:Ot,wrappingColumn:Lt,verticalScrollbarWidth:gt,horizontalScrollbarHeight:Wt,overviewRuler:{top:St,width:gt,height:Le-2*St,right:0}}}}e.EditorLayoutInfoComputer=x;class ne extends C{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(re){return c(re,"simple",["simple","advanced"])}compute(re,Pe,He){return Pe.get(2)===2?"advanced":He}}var be;(function(te){te.Off="off",te.OnCode="onCode",te.On="on"})(be||(e.ShowLightbulbIconMode=be={}));class ae extends C{constructor(){const re={enabled:be.On};super(65,"lightbulb",re,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[be.Off,be.OnCode,be.On],default:re.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:c(re.enabled,this.defaultValue.enabled,[be.Off,be.OnCode,be.On])}}}class Ce extends C{constructor(){const re={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",re,{"editor.stickyScroll.enabled":{type:"boolean",default:re.enabled,description:b.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:re.maxLineCount,minimum:1,maximum:20,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:re.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:re.scrollWithEditor,description:b.localize(57,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{enabled:l(Pe.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Pe.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:c(Pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:l(Pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ee extends C{constructor(){const re={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",re,{"editor.inlayHints.enabled":{type:"string",default:re.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:re.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:re.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:re.padding,description:b.localize(65,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return typeof Pe.enabled=="boolean"&&(Pe.enabled=Pe.enabled?"on":"off"),{enabled:c(Pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Pe.fontFamily,this.defaultValue.fontFamily),padding:l(Pe.padding,this.defaultValue.padding)}}}class B extends C{constructor(){super(66,"lineDecorationsWidth",10)}validate(re){return typeof re=="string"&&/^\d+(\.\d+)?ch$/.test(re)?-parseFloat(re.substring(0,re.length-2)):i.clampedInt(re,this.defaultValue,0,1e3)}compute(re,Pe,He){return He<0?i.clampedInt(-He*re.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class _ extends s{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,re=>s.clamp(re,0,150),{markdownDescription:b.localize(66,null)})}compute(re,Pe,He){return re.fontInfo.lineHeight}}class pe extends C{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:re.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:re.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:b.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:re.showRegionSectionHeaders,description:b.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:re.showMarkSectionHeaders,description:b.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:re.sectionHeaderFontSize,description:b.localize(80,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{enabled:l(Pe.enabled,this.defaultValue.enabled),autohide:l(Pe.autohide,this.defaultValue.autohide),size:c(Pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:c(Pe.side,this.defaultValue.side,["right","left"]),showSlider:c(Pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(Pe.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Pe.scale,1,1,3),maxColumn:i.clampedInt(Pe.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:l(Pe.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:l(Pe.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:s.clamp(Pe.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function ue(te){return te==="ctrlCmd"?L.$j?"metaKey":"ctrlKey":"altKey"}class ce extends C{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(82,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{top:i.clampedInt(Pe.top,0,0,1e3),bottom:i.clampedInt(Pe.bottom,0,0,1e3)}}}class oe extends C{constructor(){const re={enabled:!0,cycle:!0};super(86,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:b.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:b.localize(84,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{enabled:l(Pe.enabled,this.defaultValue.enabled),cycle:l(Pe.cycle,this.defaultValue.cycle)}}}class le extends v{constructor(){super(143)}compute(re,Pe,He){return re.pixelRatio}}class K extends C{constructor(){const re={other:"on",comments:"off",strings:"off"},Pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(85,null),b.localize(86,null),b.localize(87,null)]}];super(89,"quickSuggestions",re,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Pe,default:re.strings,description:b.localize(88,null)},comments:{anyOf:Pe,default:re.comments,description:b.localize(89,null)},other:{anyOf:Pe,default:re.other,description:b.localize(90,null)}},default:re,markdownDescription:b.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=re}validate(re){if(typeof re=="boolean"){const It=re?"on":"off";return{comments:It,strings:It,other:It}}if(!re||typeof re!="object")return this.defaultValue;const{other:Pe,comments:He,strings:Le}=re,st=["on","inline","off"];let lt,mt,Pt;return typeof Pe=="boolean"?lt=Pe?"on":"off":lt=c(Pe,this.defaultValue.other,st),typeof He=="boolean"?mt=He?"on":"off":mt=c(He,this.defaultValue.comments,st),typeof Le=="boolean"?Pt=Le?"on":"off":Pt=c(Le,this.defaultValue.strings,st),{other:lt,comments:mt,strings:Pt}}}var se;(function(te){te[te.Off=0]="Off",te[te.On=1]="On",te[te.Relative=2]="Relative",te[te.Interval=3]="Interval",te[te.Custom=4]="Custom"})(se||(e.RenderLineNumbersType=se={}));class $e extends C{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(92,null),b.localize(93,null),b.localize(94,null),b.localize(95,null)],default:"on",description:b.localize(96,null)})}validate(re){let Pe=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof re<"u"&&(typeof re=="function"?(Pe=4,He=re):re==="interval"?Pe=3:re==="relative"?Pe=2:re==="on"?Pe=1:Pe=0),{renderType:Pe,renderFn:He}}}function ve(te){const re=te.get(98);return re==="editable"?te.get(91):re!=="on"}class Re extends C{constructor(){const re=[],Pe={type:"number",description:b.localize(97,null)};super(102,"rulers",re,{type:"array",items:{anyOf:[Pe,{type:["object"],properties:{column:Pe,color:{type:"string",description:b.localize(98,null),format:"color-hex"}}}]},default:re,description:b.localize(99,null)})}validate(re){if(Array.isArray(re)){const Pe=[];for(const He of re)if(typeof He=="number")Pe.push({column:i.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const Le=He;Pe.push({column:i.clampedInt(Le.column,0,0,1e4),color:Le.color})}return Pe.sort((He,Le)=>He.column-Le.column),Pe}return this.defaultValue}}class ge extends C{constructor(){super(92,"readOnlyMessage",void 0)}validate(re){return!re||typeof re!="object"?this.defaultValue:re}}function Ie(te,re){if(typeof te!="string")return re;switch(te){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends C{constructor(){const re={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",re,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(100,null),b.localize(101,null),b.localize(102,null)],default:"auto",description:b.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(104,null),b.localize(105,null),b.localize(106,null)],default:"auto",description:b.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:re.verticalScrollbarSize,description:b.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:re.horizontalScrollbarSize,description:b.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:re.scrollByPage,description:b.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:re.ignoreHorizontalScrollbarInContentHeight,description:b.localize(111,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re,He=i.clampedInt(Pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=i.clampedInt(Pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Pe.vertical,this.defaultValue.vertical),horizontal:Ie(Pe.horizontal,this.defaultValue.horizontal),useShadows:l(Pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(Pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(Pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(Pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(Pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:i.clampedInt(Pe.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:i.clampedInt(Pe.verticalSliderSize,Le,0,1e3),scrollByPage:l(Pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:l(Pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends C{constructor(){const re={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",re,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.nonBasicASCII,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:re.invisibleCharacters,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:re.ambiguousCharacters,description:b.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.includeComments,description:b.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.includeStrings,description:b.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:re.allowedCharacters,description:b.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:re.allowedLocales,description:b.localize(118,null)}})}applyUpdate(re,Pe){let He=!1;Pe.allowedCharacters&&re&&(O.$7n(re.allowedCharacters,Pe.allowedCharacters)||(re={...re,allowedCharacters:Pe.allowedCharacters},He=!0)),Pe.allowedLocales&&re&&(O.$7n(re.allowedLocales,Pe.allowedLocales)||(re={...re,allowedLocales:Pe.allowedLocales},He=!0));const Le=super.applyUpdate(re,Pe);return He?new p(Le.newValue,!0):Le}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{nonBasicASCII:de(Pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:l(Pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:l(Pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:de(Pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:de(Pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(re.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(re.allowedLocales,this.defaultValue.allowedLocales)}}c(re,Pe){if(typeof re!="object"||!re)return Pe;const He={};for(const[Le,st]of Object.entries(re))st===!0&&(He[Le]=!0);return He}}class V extends C{constructor(){const re={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",re,{"editor.inlineSuggest.enabled":{type:"boolean",default:re.enabled,description:b.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:re.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(120,null),b.localize(121,null),b.localize(122,null)],description:b.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:re.suppressSuggestions,description:b.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:re.fontFamily,description:b.localize(125,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{enabled:l(Pe.enabled,this.defaultValue.enabled),mode:c(Pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:c(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:l(Pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:l(Pe.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Pe.fontFamily,this.defaultValue.fontFamily)}}}class W extends C{constructor(){const re={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",re,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:re.enabled,description:b.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:re.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(127,null),b.localize(128,null),b.localize(129,null)],description:b.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:re.fontFamily,description:b.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:re.backgroundColoring,description:b.localize(132,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{enabled:l(Pe.enabled,this.defaultValue.enabled),showToolbar:c(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Pe.fontFamily,this.defaultValue.fontFamily),keepOnBlur:l(Pe.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:l(Pe.backgroundColoring,this.defaultValue.backgroundColoring)}}}class J extends C{constructor(){const re={enabled:R.$4s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$4s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",re,{"editor.bracketPairColorization.enabled":{type:"boolean",default:re.enabled,markdownDescription:b.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:re.independentColorPoolPerBracketType,description:b.localize(134,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{enabled:l(Pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:l(Pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class X extends C{constructor(){const re={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",re,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(135,null),b.localize(136,null),b.localize(137,null)],default:re.bracketPairs,description:b.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(139,null),b.localize(140,null),b.localize(141,null)],default:re.bracketPairsHorizontal,description:b.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:re.highlightActiveBracketPair,description:b.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:re.indentation,description:b.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:re.highlightActiveIndentation,description:b.localize(148,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{bracketPairs:de(Pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:de(Pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:l(Pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:l(Pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:de(Pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function de(te,re,Pe){const He=Pe.indexOf(te);return He===-1?re:Pe[He]}class we extends C{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(149,null),b.localize(150,null)],default:re.insertMode,description:b.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:b.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:b.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:b.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(155,null),b.localize(156,null),b.localize(157,null),b.localize(158,null)],default:re.selectionMode,markdownDescription:b.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:b.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:b.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:b.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:re.preview,description:b.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:b.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(196,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{insertMode:c(Pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(Pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(Pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(Pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(Pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:c(Pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:l(Pe.showIcons,this.defaultValue.showIcons),showStatusBar:l(Pe.showStatusBar,this.defaultValue.showStatusBar),preview:l(Pe.preview,this.defaultValue.preview),previewMode:c(Pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(Pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(Pe.showMethods,this.defaultValue.showMethods),showFunctions:l(Pe.showFunctions,this.defaultValue.showFunctions),showConstructors:l(Pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(Pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:l(Pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:l(Pe.showFields,this.defaultValue.showFields),showVariables:l(Pe.showVariables,this.defaultValue.showVariables),showClasses:l(Pe.showClasses,this.defaultValue.showClasses),showStructs:l(Pe.showStructs,this.defaultValue.showStructs),showInterfaces:l(Pe.showInterfaces,this.defaultValue.showInterfaces),showModules:l(Pe.showModules,this.defaultValue.showModules),showProperties:l(Pe.showProperties,this.defaultValue.showProperties),showEvents:l(Pe.showEvents,this.defaultValue.showEvents),showOperators:l(Pe.showOperators,this.defaultValue.showOperators),showUnits:l(Pe.showUnits,this.defaultValue.showUnits),showValues:l(Pe.showValues,this.defaultValue.showValues),showConstants:l(Pe.showConstants,this.defaultValue.showConstants),showEnums:l(Pe.showEnums,this.defaultValue.showEnums),showEnumMembers:l(Pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(Pe.showKeywords,this.defaultValue.showKeywords),showWords:l(Pe.showWords,this.defaultValue.showWords),showColors:l(Pe.showColors,this.defaultValue.showColors),showFiles:l(Pe.showFiles,this.defaultValue.showFiles),showReferences:l(Pe.showReferences,this.defaultValue.showReferences),showFolders:l(Pe.showFolders,this.defaultValue.showFolders),showTypeParameters:l(Pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(Pe.showSnippets,this.defaultValue.showSnippets),showUsers:l(Pe.showUsers,this.defaultValue.showUsers),showIssues:l(Pe.showIssues,this.defaultValue.showIssues)}}}class je extends C{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(198,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:l(re.selectSubwords,this.defaultValue.selectSubwords)}}}class Ve extends C{constructor(){const re=[];super(130,"wordSegmenterLocales",re,{anyOf:[{description:b.localize(199,null),type:"string"},{description:b.localize(200,null),type:"array",items:{type:"string"}}]})}validate(re){if(typeof re=="string"&&(re=[re]),Array.isArray(re)){const Pe=[];for(const He of re)if(typeof He=="string")try{Intl.Segmenter.supportedLocalesOf(He).length>0&&Pe.push(He)}catch{}return Pe}return this.defaultValue}}var Je;(function(te){te[te.None=0]="None",te[te.Same=1]="Same",te[te.Indent=2]="Indent",te[te.DeepIndent=3]="DeepIndent"})(Je||(e.WrappingIndent=Je={}));class tt extends C{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(201,null),b.localize(202,null),b.localize(203,null),b.localize(204,null)],description:b.localize(205,null),default:"same"}})}validate(re){switch(re){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(re,Pe,He){return Pe.get(2)===2?0:He}}class _e extends v{constructor(){super(146)}compute(re,Pe,He){const Le=Pe.get(145);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class nt extends C{constructor(){const re={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",re,{"editor.dropIntoEditor.enabled":{type:"boolean",default:re.enabled,markdownDescription:b.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(208,null),b.localize(209,null)],default:"afterDrop"}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{enabled:l(Pe.enabled,this.defaultValue.enabled),showDropSelector:c(Pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends C{constructor(){const re={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",re,{"editor.pasteAs.enabled":{type:"boolean",default:re.enabled,markdownDescription:b.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(212,null),b.localize(213,null)],default:"afterPaste"}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Pe=re;return{enabled:l(Pe.enabled,this.defaultValue.enabled),showPasteSelector:c(Pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",Ne="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:L.$j?at:L.$k?Ne:rt,fontWeight:"normal",fontSize:L.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ye(te){return e.editorOptionsRegistry[te.id]=te,te}var qe;(function(te){te[te.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",te[te.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",te[te.accessibilitySupport=2]="accessibilitySupport",te[te.accessibilityPageSize=3]="accessibilityPageSize",te[te.ariaLabel=4]="ariaLabel",te[te.ariaRequired=5]="ariaRequired",te[te.autoClosingBrackets=6]="autoClosingBrackets",te[te.autoClosingComments=7]="autoClosingComments",te[te.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",te[te.autoClosingDelete=9]="autoClosingDelete",te[te.autoClosingOvertype=10]="autoClosingOvertype",te[te.autoClosingQuotes=11]="autoClosingQuotes",te[te.autoIndent=12]="autoIndent",te[te.automaticLayout=13]="automaticLayout",te[te.autoSurround=14]="autoSurround",te[te.bracketPairColorization=15]="bracketPairColorization",te[te.guides=16]="guides",te[te.codeLens=17]="codeLens",te[te.codeLensFontFamily=18]="codeLensFontFamily",te[te.codeLensFontSize=19]="codeLensFontSize",te[te.colorDecorators=20]="colorDecorators",te[te.colorDecoratorsLimit=21]="colorDecoratorsLimit",te[te.columnSelection=22]="columnSelection",te[te.comments=23]="comments",te[te.contextmenu=24]="contextmenu",te[te.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",te[te.cursorBlinking=26]="cursorBlinking",te[te.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",te[te.cursorStyle=28]="cursorStyle",te[te.cursorSurroundingLines=29]="cursorSurroundingLines",te[te.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",te[te.cursorWidth=31]="cursorWidth",te[te.disableLayerHinting=32]="disableLayerHinting",te[te.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",te[te.domReadOnly=34]="domReadOnly",te[te.dragAndDrop=35]="dragAndDrop",te[te.dropIntoEditor=36]="dropIntoEditor",te[te.emptySelectionClipboard=37]="emptySelectionClipboard",te[te.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",te[te.extraEditorClassName=39]="extraEditorClassName",te[te.fastScrollSensitivity=40]="fastScrollSensitivity",te[te.find=41]="find",te[te.fixedOverflowWidgets=42]="fixedOverflowWidgets",te[te.folding=43]="folding",te[te.foldingStrategy=44]="foldingStrategy",te[te.foldingHighlight=45]="foldingHighlight",te[te.foldingImportsByDefault=46]="foldingImportsByDefault",te[te.foldingMaximumRegions=47]="foldingMaximumRegions",te[te.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",te[te.fontFamily=49]="fontFamily",te[te.fontInfo=50]="fontInfo",te[te.fontLigatures=51]="fontLigatures",te[te.fontSize=52]="fontSize",te[te.fontWeight=53]="fontWeight",te[te.fontVariations=54]="fontVariations",te[te.formatOnPaste=55]="formatOnPaste",te[te.formatOnType=56]="formatOnType",te[te.glyphMargin=57]="glyphMargin",te[te.gotoLocation=58]="gotoLocation",te[te.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",te[te.hover=60]="hover",te[te.inDiffEditor=61]="inDiffEditor",te[te.inlineSuggest=62]="inlineSuggest",te[te.inlineEdit=63]="inlineEdit",te[te.letterSpacing=64]="letterSpacing",te[te.lightbulb=65]="lightbulb",te[te.lineDecorationsWidth=66]="lineDecorationsWidth",te[te.lineHeight=67]="lineHeight",te[te.lineNumbers=68]="lineNumbers",te[te.lineNumbersMinChars=69]="lineNumbersMinChars",te[te.linkedEditing=70]="linkedEditing",te[te.links=71]="links",te[te.matchBrackets=72]="matchBrackets",te[te.minimap=73]="minimap",te[te.mouseStyle=74]="mouseStyle",te[te.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",te[te.mouseWheelZoom=76]="mouseWheelZoom",te[te.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",te[te.multiCursorModifier=78]="multiCursorModifier",te[te.multiCursorPaste=79]="multiCursorPaste",te[te.multiCursorLimit=80]="multiCursorLimit",te[te.occurrencesHighlight=81]="occurrencesHighlight",te[te.overviewRulerBorder=82]="overviewRulerBorder",te[te.overviewRulerLanes=83]="overviewRulerLanes",te[te.padding=84]="padding",te[te.pasteAs=85]="pasteAs",te[te.parameterHints=86]="parameterHints",te[te.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",te[te.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",te[te.quickSuggestions=89]="quickSuggestions",te[te.quickSuggestionsDelay=90]="quickSuggestionsDelay",te[te.readOnly=91]="readOnly",te[te.readOnlyMessage=92]="readOnlyMessage",te[te.renameOnType=93]="renameOnType",te[te.renderControlCharacters=94]="renderControlCharacters",te[te.renderFinalNewline=95]="renderFinalNewline",te[te.renderLineHighlight=96]="renderLineHighlight",te[te.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",te[te.renderValidationDecorations=98]="renderValidationDecorations",te[te.renderWhitespace=99]="renderWhitespace",te[te.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",te[te.roundedSelection=101]="roundedSelection",te[te.rulers=102]="rulers",te[te.scrollbar=103]="scrollbar",te[te.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",te[te.scrollBeyondLastLine=105]="scrollBeyondLastLine",te[te.scrollPredominantAxis=106]="scrollPredominantAxis",te[te.selectionClipboard=107]="selectionClipboard",te[te.selectionHighlight=108]="selectionHighlight",te[te.selectOnLineNumbers=109]="selectOnLineNumbers",te[te.showFoldingControls=110]="showFoldingControls",te[te.showUnused=111]="showUnused",te[te.snippetSuggestions=112]="snippetSuggestions",te[te.smartSelect=113]="smartSelect",te[te.smoothScrolling=114]="smoothScrolling",te[te.stickyScroll=115]="stickyScroll",te[te.stickyTabStops=116]="stickyTabStops",te[te.stopRenderingLineAfter=117]="stopRenderingLineAfter",te[te.suggest=118]="suggest",te[te.suggestFontSize=119]="suggestFontSize",te[te.suggestLineHeight=120]="suggestLineHeight",te[te.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",te[te.suggestSelection=122]="suggestSelection",te[te.tabCompletion=123]="tabCompletion",te[te.tabIndex=124]="tabIndex",te[te.unicodeHighlighting=125]="unicodeHighlighting",te[te.unusualLineTerminators=126]="unusualLineTerminators",te[te.useShadowDOM=127]="useShadowDOM",te[te.useTabStops=128]="useTabStops",te[te.wordBreak=129]="wordBreak",te[te.wordSegmenterLocales=130]="wordSegmenterLocales",te[te.wordSeparators=131]="wordSeparators",te[te.wordWrap=132]="wordWrap",te[te.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",te[te.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",te[te.wordWrapColumn=135]="wordWrapColumn",te[te.wordWrapOverride1=136]="wordWrapOverride1",te[te.wordWrapOverride2=137]="wordWrapOverride2",te[te.wrappingIndent=138]="wrappingIndent",te[te.wrappingStrategy=139]="wrappingStrategy",te[te.showDeprecated=140]="showDeprecated",te[te.inlayHints=141]="inlayHints",te[te.editorClassName=142]="editorClassName",te[te.pixelRatio=143]="pixelRatio",te[te.tabFocusMode=144]="tabFocusMode",te[te.layoutInfo=145]="layoutInfo",te[te.wrappingInfo=146]="wrappingInfo",te[te.defaultColorDecorators=147]="defaultColorDecorators",te[te.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",te[te.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(qe||(e.EditorOption=qe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(214,null)})),acceptSuggestionOnEnter:ye(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(215,null),""],markdownDescription:b.localize(216,null)})),accessibilitySupport:ye(new g),accessibilityPageSize:ye(new i(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(217,null),tags:["accessibility"]})),ariaLabel:ye(new t(4,"ariaLabel",b.localize(218,null))),ariaRequired:ye(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ye(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:ye(new r(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(220,null),b.localize(221,null),""],description:b.localize(222,null)})),autoClosingComments:ye(new r(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(223,null),b.localize(224,null),""],description:b.localize(225,null)})),autoClosingDelete:ye(new r(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(226,null),""],description:b.localize(227,null)})),autoClosingOvertype:ye(new r(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(228,null),""],description:b.localize(229,null)})),autoClosingQuotes:ye(new r(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(230,null),b.localize(231,null),""],description:b.localize(232,null)})),autoIndent:ye(new a(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],f,{enumDescriptions:[b.localize(233,null),b.localize(234,null),b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),automaticLayout:ye(new o(13,"automaticLayout",!1)),autoSurround:ye(new r(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(239,null),b.localize(240,null),b.localize(241,null),""],description:b.localize(242,null)})),bracketPairColorization:ye(new J),bracketPairGuides:ye(new X),stickyTabStops:ye(new o(116,"stickyTabStops",!1,{description:b.localize(243,null)})),codeLens:ye(new o(17,"codeLens",!0,{description:b.localize(244,null)})),codeLensFontFamily:ye(new t(18,"codeLensFontFamily","",{description:b.localize(245,null)})),codeLensFontSize:ye(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(246,null)})),colorDecorators:ye(new o(20,"colorDecorators",!0,{description:b.localize(247,null)})),colorDecoratorActivatedOn:ye(new r(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(248,null),b.localize(249,null),b.localize(250,null)],description:b.localize(251,null)})),colorDecoratorsLimit:ye(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(252,null)})),columnSelection:ye(new o(22,"columnSelection",!1,{description:b.localize(253,null)})),comments:ye(new w),contextmenu:ye(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new o(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(254,null)})),cursorBlinking:ye(new a(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:b.localize(255,null)})),cursorSmoothCaretAnimation:ye(new r(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(256,null),b.localize(257,null),b.localize(258,null)],description:b.localize(259,null)})),cursorStyle:ye(new a(28,"cursorStyle",E.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:b.localize(260,null)})),cursorSurroundingLines:ye(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(261,null)})),cursorSurroundingLinesStyle:ye(new r(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(262,null),b.localize(263,null)],markdownDescription:b.localize(264,null)})),cursorWidth:ye(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(265,null)})),disableLayerHinting:ye(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new o(34,"domReadOnly",!1)),dragAndDrop:ye(new o(35,"dragAndDrop",!0,{description:b.localize(266,null)})),emptySelectionClipboard:ye(new F),dropIntoEditor:ye(new nt),stickyScroll:ye(new Ce),experimentalWhitespaceRendering:ye(new r(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(267,null),b.localize(268,null),b.localize(269,null)],description:b.localize(270,null)})),extraEditorClassName:ye(new t(39,"extraEditorClassName","")),fastScrollSensitivity:ye(new s(40,"fastScrollSensitivity",5,te=>te<=0?5:te,{markdownDescription:b.localize(271,null)})),find:ye(new T),fixedOverflowWidgets:ye(new o(42,"fixedOverflowWidgets",!1)),folding:ye(new o(43,"folding",!0,{description:b.localize(272,null)})),foldingStrategy:ye(new r(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(273,null),b.localize(274,null)],description:b.localize(275,null)})),foldingHighlight:ye(new o(45,"foldingHighlight",!0,{description:b.localize(276,null)})),foldingImportsByDefault:ye(new o(46,"foldingImportsByDefault",!1,{description:b.localize(277,null)})),foldingMaximumRegions:ye(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(278,null)})),unfoldOnClickAfterEndOfLine:ye(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(279,null)})),fontFamily:ye(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(280,null)})),fontInfo:ye(new j),fontLigatures2:ye(new z),fontSize:ye(new U),fontWeight:ye(new Z),fontVariations:ye(new M),formatOnPaste:ye(new o(55,"formatOnPaste",!1,{description:b.localize(281,null)})),formatOnType:ye(new o(56,"formatOnType",!1,{description:b.localize(282,null)})),glyphMargin:ye(new o(57,"glyphMargin",!0,{description:b.localize(283,null)})),gotoLocation:ye(new ie),hideCursorInOverviewRuler:ye(new o(59,"hideCursorInOverviewRuler",!1,{description:b.localize(284,null)})),hover:ye(new q),inDiffEditor:ye(new o(61,"inDiffEditor",!1)),letterSpacing:ye(new s(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,te=>s.clamp(te,-5,20),{description:b.localize(285,null)})),lightbulb:ye(new ae),lineDecorationsWidth:ye(new B),lineHeight:ye(new _),lineNumbers:ye(new $e),lineNumbersMinChars:ye(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new o(70,"linkedEditing",!1,{description:b.localize(286,null)})),links:ye(new o(71,"links",!0,{description:b.localize(287,null)})),matchBrackets:ye(new r(72,"matchBrackets","always",["always","near","never"],{description:b.localize(288,null)})),minimap:ye(new pe),mouseStyle:ye(new r(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new s(75,"mouseWheelScrollSensitivity",1,te=>te===0?1:te,{markdownDescription:b.localize(289,null)})),mouseWheelZoom:ye(new o(76,"mouseWheelZoom",!1,{markdownDescription:L.$j?b.localize(290,null):b.localize(291,null)})),multiCursorMergeOverlapping:ye(new o(77,"multiCursorMergeOverlapping",!0,{description:b.localize(292,null)})),multiCursorModifier:ye(new a(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[b.localize(293,null),b.localize(294,null)],markdownDescription:b.localize(295,null)})),multiCursorPaste:ye(new r(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(296,null),b.localize(297,null)],markdownDescription:b.localize(298,null)})),multiCursorLimit:ye(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(299,null)})),occurrencesHighlight:ye(new r(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(300,null),b.localize(301,null),b.localize(302,null)],markdownDescription:b.localize(303,null)})),overviewRulerBorder:ye(new o(82,"overviewRulerBorder",!0,{description:b.localize(304,null)})),overviewRulerLanes:ye(new i(83,"overviewRulerLanes",3,0,3)),padding:ye(new ce),pasteAs:ye(new it),parameterHints:ye(new oe),peekWidgetDefaultFocus:ye(new r(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(305,null),b.localize(306,null)],description:b.localize(307,null)})),definitionLinkOpensInPeek:ye(new o(88,"definitionLinkOpensInPeek",!1,{description:b.localize(308,null)})),quickSuggestions:ye(new K),quickSuggestionsDelay:ye(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(309,null)})),readOnly:ye(new o(91,"readOnly",!1)),readOnlyMessage:ye(new ge),renameOnType:ye(new o(93,"renameOnType",!1,{description:b.localize(310,null),markdownDeprecationMessage:b.localize(311,null)})),renderControlCharacters:ye(new o(94,"renderControlCharacters",!0,{description:b.localize(312,null),restricted:!0})),renderFinalNewline:ye(new r(95,"renderFinalNewline",L.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(313,null)})),renderLineHighlight:ye(new r(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(314,null)],description:b.localize(315,null)})),renderLineHighlightOnlyWhenFocus:ye(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(316,null)})),renderValidationDecorations:ye(new r(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new r(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(317,null),b.localize(318,null),b.localize(319,null),""],description:b.localize(320,null)})),revealHorizontalRightPadding:ye(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ye(new o(101,"roundedSelection",!0,{description:b.localize(321,null)})),rulers:ye(new Re),scrollbar:ye(new Ae),scrollBeyondLastColumn:ye(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(322,null)})),scrollBeyondLastLine:ye(new o(105,"scrollBeyondLastLine",!0,{description:b.localize(323,null)})),scrollPredominantAxis:ye(new o(106,"scrollPredominantAxis",!0,{description:b.localize(324,null)})),selectionClipboard:ye(new o(107,"selectionClipboard",!0,{description:b.localize(325,null),included:L.$k})),selectionHighlight:ye(new o(108,"selectionHighlight",!0,{description:b.localize(326,null)})),selectOnLineNumbers:ye(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:ye(new r(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(327,null),b.localize(328,null),b.localize(329,null)],description:b.localize(330,null)})),showUnused:ye(new o(111,"showUnused",!0,{description:b.localize(331,null)})),showDeprecated:ye(new o(140,"showDeprecated",!0,{description:b.localize(332,null)})),inlayHints:ye(new ee),snippetSuggestions:ye(new r(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(333,null),b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),smartSelect:ye(new je),smoothScrolling:ye(new o(114,"smoothScrolling",!1,{description:b.localize(338,null)})),stopRenderingLineAfter:ye(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new we),inlineSuggest:ye(new V),inlineEdit:ye(new W),inlineCompletionsAccessibilityVerbose:ye(new o(149,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(339,null)})),suggestFontSize:ye(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ye(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ye(new o(121,"suggestOnTriggerCharacters",!0,{description:b.localize(342,null)})),suggestSelection:ye(new r(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),tabCompletion:ye(new r(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null)],description:b.localize(350,null)})),tabIndex:ye(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:ye(new ze),unusualLineTerminators:ye(new r(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(351,null),b.localize(352,null),b.localize(353,null)],description:b.localize(354,null)})),useShadowDOM:ye(new o(127,"useShadowDOM",!0)),useTabStops:ye(new o(128,"useTabStops",!0,{description:b.localize(355,null)})),wordBreak:ye(new r(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(356,null),b.localize(357,null)],description:b.localize(358,null)})),wordSegmenterLocales:ye(new Ve),wordSeparators:ye(new t(131,"wordSeparators",N.$5s,{description:b.localize(359,null)})),wordWrap:ye(new r(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(360,null),b.localize(361,null),b.localize(362,null),b.localize(363,null)],description:b.localize(364,null)})),wordWrapBreakAfterCharacters:ye(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(365,null)})),wordWrapOverride1:ye(new r(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new r(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ye(new I),defaultColorDecorators:ye(new o(147,"defaultColorDecorators",!1,{markdownDescription:b.localize(366,null)})),pixelRatio:ye(new le),tabFocusMode:ye(new o(144,"tabFocusMode",!1,{markdownDescription:b.localize(367,null)})),layoutInfo:ye(new x),wrappingInfo:ye(new _e),wrappingIndent:ye(new tt),wrappingStrategy:ye(new ne)}}),define(Se[207],De([9,10]),function(he,e){return he.create("vs/editor/common/languages",e)}),define(Se[84],De([1,0,79,2,180,29,190,207]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$fu=e.$eu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$du=e.$cu=e.SymbolKinds=e.SymbolTag=e.$au=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$$t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$0t=e.$9t=e.$8t=void 0,e.$_t=r,e.$bu=f;class ${constructor(G,x,ne){this.offset=G,this.type=x,this.language=ne,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$8t=$;class k{constructor(G,x){this.tokens=G,this.endState=x,this._tokenizationResultBrand=void 0}}e.$9t=k;class A{constructor(G,x){this.tokens=G,this.endState=x,this._encodedTokenizationResultBrand=void 0}}e.$0t=A;var C;(function(q){q[q.Increase=0]="Increase",q[q.Decrease=1]="Decrease"})(C||(e.HoverVerbosityAction=C={}));var p;(function(q){q[q.Method=0]="Method",q[q.Function=1]="Function",q[q.Constructor=2]="Constructor",q[q.Field=3]="Field",q[q.Variable=4]="Variable",q[q.Class=5]="Class",q[q.Struct=6]="Struct",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Event=10]="Event",q[q.Operator=11]="Operator",q[q.Unit=12]="Unit",q[q.Value=13]="Value",q[q.Constant=14]="Constant",q[q.Enum=15]="Enum",q[q.EnumMember=16]="EnumMember",q[q.Keyword=17]="Keyword",q[q.Text=18]="Text",q[q.Color=19]="Color",q[q.File=20]="File",q[q.Reference=21]="Reference",q[q.Customcolor=22]="Customcolor",q[q.Folder=23]="Folder",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue",q[q.Snippet=27]="Snippet"})(p||(e.CompletionItemKind=p={}));var y;(function(q){const G=new Map;G.set(0,d.$Vj.symbolMethod),G.set(1,d.$Vj.symbolFunction),G.set(2,d.$Vj.symbolConstructor),G.set(3,d.$Vj.symbolField),G.set(4,d.$Vj.symbolVariable),G.set(5,d.$Vj.symbolClass),G.set(6,d.$Vj.symbolStruct),G.set(7,d.$Vj.symbolInterface),G.set(8,d.$Vj.symbolModule),G.set(9,d.$Vj.symbolProperty),G.set(10,d.$Vj.symbolEvent),G.set(11,d.$Vj.symbolOperator),G.set(12,d.$Vj.symbolUnit),G.set(13,d.$Vj.symbolValue),G.set(15,d.$Vj.symbolEnum),G.set(14,d.$Vj.symbolConstant),G.set(15,d.$Vj.symbolEnum),G.set(16,d.$Vj.symbolEnumMember),G.set(17,d.$Vj.symbolKeyword),G.set(27,d.$Vj.symbolSnippet),G.set(18,d.$Vj.symbolText),G.set(19,d.$Vj.symbolColor),G.set(20,d.$Vj.symbolFile),G.set(21,d.$Vj.symbolReference),G.set(22,d.$Vj.symbolCustomColor),G.set(23,d.$Vj.symbolFolder),G.set(24,d.$Vj.symbolTypeParameter),G.set(25,d.$Vj.account),G.set(26,d.$Vj.issues);function x(ae){let Ce=G.get(ae);return Ce||(console.info("No codicon found for CompletionItemKind "+ae),Ce=d.$Vj.symbolProperty),Ce}q.toIcon=x;const ne=new Map;ne.set("method",0),ne.set("function",1),ne.set("constructor",2),ne.set("field",3),ne.set("variable",4),ne.set("class",5),ne.set("struct",6),ne.set("interface",7),ne.set("module",8),ne.set("property",9),ne.set("event",10),ne.set("operator",11),ne.set("unit",12),ne.set("value",13),ne.set("constant",14),ne.set("enum",15),ne.set("enum-member",16),ne.set("enumMember",16),ne.set("keyword",17),ne.set("snippet",27),ne.set("text",18),ne.set("color",19),ne.set("file",20),ne.set("reference",21),ne.set("customcolor",22),ne.set("folder",23),ne.set("type-parameter",24),ne.set("typeParameter",24),ne.set("account",25),ne.set("issue",26);function be(ae,Ce){let ee=ne.get(ae);return typeof ee>"u"&&!Ce&&(ee=9),ee}q.fromString=be})(y||(e.CompletionItemKinds=y={}));var v;(function(q){q[q.Deprecated=1]="Deprecated"})(v||(e.CompletionItemTag=v={}));var h;(function(q){q[q.None=0]="None",q[q.KeepWhitespace=1]="KeepWhitespace",q[q.InsertAsSnippet=4]="InsertAsSnippet"})(h||(e.CompletionItemInsertTextRule=h={}));var l;(function(q){q[q.Word=0]="Word",q[q.Line=1]="Line",q[q.Suggest=2]="Suggest"})(l||(e.PartialAcceptTriggerKind=l={}));var o;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(o||(e.CompletionTriggerKind=o={}));var n;(function(q){q[q.Automatic=0]="Automatic",q[q.Explicit=1]="Explicit"})(n||(e.InlineCompletionTriggerKind=n={}));class i{constructor(G,x,ne,be){this.range=G,this.text=x,this.completionKind=ne,this.isSnippetText=be}equals(G){return R.$ut.lift(this.range).equalsRange(G.range)&&this.text===G.text&&this.completionKind===G.completionKind&&this.isSnippetText===G.isSnippetText}}e.$$t=i;var u;(function(q){q[q.Invoke=1]="Invoke",q[q.Auto=2]="Auto"})(u||(e.CodeActionTriggerType=u={}));var s;(function(q){q[q.Automatic=0]="Automatic",q[q.PasteAs=1]="PasteAs"})(s||(e.DocumentPasteTriggerKind=s={}));var t;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var c;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(c||(e.DocumentHighlightKind=c={}));function r(q){return q&&O.URI.isUri(q.uri)&&R.$ut.isIRange(q.range)&&(R.$ut.isIRange(q.originSelectionRange)||R.$ut.isIRange(q.targetSelectionRange))}var a;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(a||(e.SymbolKind=a={})),e.$au={17:(0,b.localize)(0,null),16:(0,b.localize)(1,null),4:(0,b.localize)(2,null),13:(0,b.localize)(3,null),8:(0,b.localize)(4,null),9:(0,b.localize)(5,null),21:(0,b.localize)(6,null),23:(0,b.localize)(7,null),7:(0,b.localize)(8,null),0:(0,b.localize)(9,null),11:(0,b.localize)(10,null),10:(0,b.localize)(11,null),19:(0,b.localize)(12,null),5:(0,b.localize)(13,null),1:(0,b.localize)(14,null),2:(0,b.localize)(15,null),20:(0,b.localize)(16,null),15:(0,b.localize)(17,null),18:(0,b.localize)(18,null),24:(0,b.localize)(19,null),3:(0,b.localize)(20,null),6:(0,b.localize)(21,null),14:(0,b.localize)(22,null),22:(0,b.localize)(23,null),25:(0,b.localize)(24,null),12:(0,b.localize)(25,null)};function f(q,G){return(0,b.localize)(26,null,q,e.$au[G])}var g;(function(q){q[q.Deprecated=1]="Deprecated"})(g||(e.SymbolTag=g={}));var w;(function(q){const G=new Map;G.set(0,d.$Vj.symbolFile),G.set(1,d.$Vj.symbolModule),G.set(2,d.$Vj.symbolNamespace),G.set(3,d.$Vj.symbolPackage),G.set(4,d.$Vj.symbolClass),G.set(5,d.$Vj.symbolMethod),G.set(6,d.$Vj.symbolProperty),G.set(7,d.$Vj.symbolField),G.set(8,d.$Vj.symbolConstructor),G.set(9,d.$Vj.symbolEnum),G.set(10,d.$Vj.symbolInterface),G.set(11,d.$Vj.symbolFunction),G.set(12,d.$Vj.symbolVariable),G.set(13,d.$Vj.symbolConstant),G.set(14,d.$Vj.symbolString),G.set(15,d.$Vj.symbolNumber),G.set(16,d.$Vj.symbolBoolean),G.set(17,d.$Vj.symbolArray),G.set(18,d.$Vj.symbolObject),G.set(19,d.$Vj.symbolKey),G.set(20,d.$Vj.symbolNull),G.set(21,d.$Vj.symbolEnumMember),G.set(22,d.$Vj.symbolStruct),G.set(23,d.$Vj.symbolEvent),G.set(24,d.$Vj.symbolOperator),G.set(25,d.$Vj.symbolTypeParameter);function x(ne){let be=G.get(ne);return be||(console.info("No codicon found for SymbolKind "+ne),be=d.$Vj.symbolProperty),be}q.toIcon=x})(w||(e.SymbolKinds=w={}));class S{static asEditOperation(G){return L.$vt.replace(R.$ut.lift(G.range),G.text)}}e.$cu=S;class m{static{this.Comment=new m("comment")}static{this.Imports=new m("imports")}static{this.Region=new m("region")}static fromValue(G){switch(G){case"comment":return m.Comment;case"imports":return m.Imports;case"region":return m.Region}return new m(G)}constructor(G){this.value=G}}e.$du=m;var E;(function(q){q[q.AIGenerated=1]="AIGenerated"})(E||(e.NewSymbolNameTag=E={}));var D;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(D||(e.NewSymbolNameTriggerKind=D={}));var P;(function(q){function G(x){return!x||typeof x!="object"?!1:typeof x.id=="string"&&typeof x.title=="string"}q.is=G})(P||(e.Command=P={}));var I;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(I||(e.CommentThreadCollapsibleState=I={}));var F;(function(q){q[q.Unresolved=0]="Unresolved",q[q.Resolved=1]="Resolved"})(F||(e.CommentThreadState=F={}));var T;(function(q){q[q.Current=0]="Current",q[q.Outdated=1]="Outdated"})(T||(e.CommentThreadApplicability=T={}));var z;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(z||(e.CommentMode=z={}));var M;(function(q){q[q.Published=0]="Published",q[q.Draft=1]="Draft"})(M||(e.CommentState=M={}));var j;(function(q){q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(j||(e.InlayHintKind=j={}));class U{constructor(G){this.b=G,this.a=null}dispose(){this.a&&this.a.then(G=>{G&&G.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$eu=U,e.$fu=new N.$Zt;var Z;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(Z||(e.ExternalUriOpenerPriority=Z={}));var ie;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(ie||(e.InlineEditTriggerKind=ie={}))}),define(Se[208],De([9,10]),function(he,e){return he.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[209],De([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[210],De([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/scanner",e)}),define(Se[211],De([9,10]),function(he,e){return he.create("vs/platform/dialogs/common/dialogs",e)}),define(Se[212],De([9,10]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[213],De([9,10]),function(he,e){return he.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[214],De([9,10]),function(he,e){return he.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[215],De([9,10]),function(he,e){return he.create("vs/platform/files/common/files",e)}),define(Se[216],De([9,10]),function(he,e){return he.create("vs/platform/files/common/io",e)}),define(Se[217],De([9,10]),function(he,e){return he.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[218],De([9,10]),function(he,e){return he.create("vs/platform/log/common/log",e)}),define(Se[219],De([9,10]),function(he,e){return he.create("vs/platform/markers/common/markers",e)}),define(Se[220],De([9,10]),function(he,e){return he.create("vs/platform/request/common/request",e)}),define(Se[221],De([9,10]),function(he,e){return he.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[222],De([9,10]),function(he,e){return he.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[223],De([9,10]),function(he,e){return he.create("vs/platform/workspace/common/workspace",e)}),define(Se[224],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[225],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[226],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[227],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Se[228],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[229],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[230],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[231],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[232],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[233],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[234],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[235],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[236],De([9,10]),function(he,e){return he.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[237],De([9,10]),function(he,e){return he.create("vs/workbench/common/configuration",e)}),define(Se[238],De([9,10]),function(he,e){return he.create("vs/workbench/common/editor",e)}),define(Se[239],De([9,10]),function(he,e){return he.create("vs/workbench/common/views",e)}),define(Se[240],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Se[241],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[242],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[243],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[244],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[245],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[246],De([9,10]),function(he,e){return he.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[247],De([9,10]),function(he,e){return he.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[248],De([9,10]),function(he,e){return he.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[249],De([9,10]),function(he,e){return he.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Se[250],De([9,10]),function(he,e){return he.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[251],De([1,0,13,210]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.TokenType=void 0;var L;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(L||(e.TokenType=L={}));function R(...k){switch(k.length){case 1:return(0,O.localize)(0,null,k[0]);case 2:return(0,O.localize)(1,null,k[0],k[1]);case 3:return(0,O.localize)(2,null,k[0],k[1],k[2]);default:return}}const N=(0,O.localize)(3,null),b=(0,O.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,d.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const C=this.d,p=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:p};this.g.push({offset:C,lexeme:p,additionalInfo:A}),this.f.push(y)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const C=this.c.substring(this.d,this.e),p=$.b.get(C);p?this.k(p):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,C=!1,p=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(b);return}const v=this.c.charCodeAt(A);if(C)C=!1;else if(v===47&&!p){A++;break}else v===91?p=!0:v===92?C=!0:v===93&&(p=!1);A++}for(;A<this.c.length&&$.a.has(this.c.charCodeAt(A));)A++;this.e=A;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$rj=$}),define(Se[252],De([1,0,23,41,213,401]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=$,e.$Hp=k,e.$Ip=A,e.$Jp=C,e.$Kp=p,e.$Lp=y,e.$Mp=v;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function $(o){return o=o.trim(),o==="*"||N.test(o)}function k(o){if(!$(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=o.match(N);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function A(o){if(!o)return null;const n=o.majorBase,i=o.majorMustEqual,u=o.minorBase;let s=o.minorMustEqual;const t=o.patchBase;let c=o.patchMustEqual;o.hasCaret&&(n===0||(s=!1),c=!1);let r=0;if(o.preRelease){const a=b.exec(o.preRelease);if(a){const[,f,g,w]=a;r=Date.UTC(Number(f),Number(g)-1,Number(w))}}return{majorBase:n,majorMustEqual:i,minorBase:u,minorMustEqual:s,patchBase:t,patchMustEqual:c,isMinimum:o.hasGreaterEquals,notBefore:r}}function C(o,n,i){let u;typeof o=="string"?u=A(k(o)):u=o;let s;n instanceof Date?s=n.getTime():typeof n=="string"&&(s=new Date(n).getTime());let t;if(typeof i=="string"?t=A(k(i)):t=i,!u||!t)return!1;const c=u.majorBase,r=u.minorBase,a=u.patchBase;let f=t.majorBase,g=t.minorBase,w=t.patchBase;const S=t.notBefore;let m=t.majorMustEqual,E=t.minorMustEqual,D=t.patchMustEqual;return t.isMinimum?c>f?!0:c<f?!1:r>g?!0:r<g||s&&s<S?!1:a>=w:(c===1&&f===0&&(!m||!E||!D)&&(f=1,g=0,w=0,m=!0,E=!1,D=!1),c<f?!1:c>f?!m:r<g?!1:r>g?!E:a<w?!1:a>w?!D:!(s&&s<S))}function p(o,n,i,u,s){const t=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return t.push([O.default.Error,L.localize(0,null)]),t;if(typeof u.name!="string")return t.push([O.default.Error,L.localize(1,null,"name")]),t;if(typeof u.version!="string")return t.push([O.default.Error,L.localize(2,null,"version")]),t;if(!u.engines)return t.push([O.default.Error,L.localize(3,null,"engines")]),t;if(typeof u.engines.vscode!="string")return t.push([O.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof u.extensionDependencies<"u"&&!l(u.extensionDependencies))return t.push([O.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof u.activationEvents<"u"){if(!l(u.activationEvents))return t.push([O.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof u.main>"u"&&typeof u.browser>"u")return t.push([O.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&t.push([O.default.Warning,L.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return t.push([O.default.Error,L.localize(9,null,"main")]),t;{const a=(0,d.$0g)(i,u.main);(0,d.$4g)(a,i)||t.push([O.default.Warning,L.localize(10,null,a.path,i.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return t.push([O.default.Error,L.localize(11,null,"browser")]),t;{const a=(0,d.$0g)(i,u.browser);(0,d.$4g)(a,i)||t.push([O.default.Warning,L.localize(12,null,a.path,i.path)])}}if(!R.valid(u.version))return t.push([O.default.Error,L.localize(13,null)]),t;const c=[];if(!y(o,n,u,s,c))for(const a of c)t.push([O.default.Error,a]);return t}function y(o,n,i,u,s){return u||typeof i.main>"u"&&typeof i.browser>"u"?!0:h(o,n,i.engines.vscode,s)}function v(o,n,i){return o==="*"||h(n,i,o)}function h(o,n,i,u=[]){const s=A(k(i));if(!s)return u.push(L.localize(14,null,i)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return u.push(L.localize(15,null,i)),!1}else if(!s.majorMustEqual)return u.push(L.localize(16,null,i)),!1;return C(o,n,s)?!0:(u.push(L.localize(17,null,o,i)),!1)}function l(o){if(!Array.isArray(o))return!1;for(let n=0,i=o.length;n<i;n++)if(typeof o[n]!="string")return!1;return!0}}),define(Se[106],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class d{constructor(L,R=[],N=!1){this.ctor=L,this.staticArguments=R,this.supportsDelayedInstantiation=N}}e.$ti=d}),define(Se[85],De([1,0,106]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$xs=R,e.$ys=N;const O=[];var L;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function R(b,$,k){$ instanceof d.$ti||($=new d.$ti($,[],!!k)),O.push([b,$])}function N(){return O}}),define(Se[253],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0;class d{constructor(R,N){this.key=R,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.$ar=d;class O{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const N of this.a.values())N.outgoing.size===0&&R.push(N);return R}insertEdge(R,N){const b=this.lookupOrInsertNode(R),$=this.lookupOrInsertNode(N);b.outgoing.set($.key,$),$.incoming.set(b.key,b)}removeNode(R){const N=this.b(R);this.a.delete(N);for(const b of this.a.values())b.outgoing.delete(N),b.incoming.delete(N)}lookupOrInsertNode(R){const N=this.b(R);let b=this.a.get(N);return b||(b=new d(N,R),this.a.set(N,b)),b}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[N,b]of this.a)R.push(`${N}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,N]of this.a){const b=new Set([R]),$=this.c(N,b);if($)return $}}c(R,N){for(const[b,$]of R.outgoing){if(N.has(b))return[...N,b].join(" -> ");N.add(b);const k=this.c($,N);if(k)return k;N.delete(b)}}}e.$br=O}),define(Se[5],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e._util=void 0,e.$wi=L,e.$xi=R;var d;(function(N){N.serviceIds=new Map,N.DI_TARGET="$di$target",N.DI_DEPENDENCIES="$di$dependencies";function b($){return $[N.DI_DEPENDENCIES]||[]}N.getServiceDependencies=b})(d||(e._util=d={})),e.$vi=L("instantiationService");function O(N,b,$){b[d.DI_TARGET]===b?b[d.DI_DEPENDENCIES].push({id:N,index:$}):(b[d.DI_DEPENDENCIES]=[{id:N,index:$}],b[d.DI_TARGET]=b)}function L(N){if(d.serviceIds.has(N))return d.serviceIds.get(N);const b=function($,k,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(b,$,A)};return b.toString=()=>N,d.serviceIds.set(N,b),b}function R(N){return N}}),define(Se[55],De([1,0,18,2,5]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$3i=void 0,e.$4i=R,e.$5i=N,e.$6i=$,e.$7i=k,e.$8i=A,e.$9i=C,e.$0i=p,e.$$i=v,e.$_i=h,e.$aj=l,e.$3i=(0,L.$wi)("configurationService");function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof O.URI)}function N(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof O.URI)}var b;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function $(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function k(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function A(o,n){const i=Object.create(null);for(const u in o)C(i,u,o[u],n);return i}function C(o,n,i,u){const s=n.split("."),t=s.pop();let c=o;for(let r=0;r<s.length;r++){const a=s[r];let f=c[a];switch(typeof f){case"undefined":f=c[a]=Object.create(null);break;case"object":if(f===null){u(`Ignoring ${n} as ${s.slice(0,r+1).join(".")} is null`);return}break;default:u(`Ignoring ${n} as ${s.slice(0,r+1).join(".")} is ${JSON.stringify(f)}`);return}c=f}if(typeof c=="object"&&c!==null)try{c[t]=i}catch{u(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(c)}`)}else u(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(c)}`)}function p(o,n){const i=n.split(".");y(o,i)}function y(o,n){const i=n.shift();if(n.length===0){delete o[i];return}if(Object.keys(o).indexOf(i)!==-1){const u=o[i];typeof u=="object"&&!Array.isArray(u)&&(y(u,n),Object.keys(u).length===0&&delete o[i])}}function v(o,n,i){function u(c,r){let a=c;for(const f of r){if(typeof a!="object"||a===null)return;a=a[f]}return a}const s=n.split("."),t=u(o,s);return typeof t>"u"?i:t}function h(o,n,i){Object.keys(n).forEach(u=>{u!=="__proto__"&&(u in o?d.$$f(o[u])&&d.$$f(n[u])?h(o[u],n[u],i):i&&(o[u]=n[u]):o[u]=n[u])})}function l(o){return o.replace(/[\[\]]/g,"")}}),define(Se[38],De([1,0,12,14,251,5,209,13]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$uj=e.$tj=e.ContextKeyExprType=void 0,e.$sj=k,e.$vj=c,e.$wj=r,e.$Pj=be;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",d.$j),$.set("isLinux",d.$k),$.set("isWindows",d.$i),$.set("isWeb",d.$o),$.set("isMacNative",d.$j&&!d.$o),$.set("isEdge",d.$H),$.set("isFirefox",d.$F),$.set("isChrome",d.$E),$.set("isSafari",d.$G);function k(ee,B){if($.get(ee)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(ee,B)}const A=Object.prototype.hasOwnProperty;var C;(function(ee){ee[ee.False=0]="False",ee[ee.True=1]="True",ee[ee.Defined=2]="Defined",ee[ee.Not=3]="Not",ee[ee.Equals=4]="Equals",ee[ee.NotEquals=5]="NotEquals",ee[ee.And=6]="And",ee[ee.Regex=7]="Regex",ee[ee.NotRegex=8]="NotRegex",ee[ee.Or=9]="Or",ee[ee.In=10]="In",ee[ee.NotIn=11]="NotIn",ee[ee.Greater=12]="Greater",ee[ee.GreaterEquals=13]="GreaterEquals",ee[ee.Smaller=14]="Smaller",ee[ee.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const p={regexParsingWithErrorRecovery:!0},y=(0,N.localize)(0,null),v=(0,N.localize)(1,null),h=(0,N.localize)(2,null),l=(0,N.localize)(3,null),o=(0,N.localize)(4,null),n=(0,N.localize)(5,null),i=(0,N.localize)(6,null),u=(0,N.localize)(7,null);class s{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=p){this.k=B,this.d=new L.$rj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const _=this.l();if(!this.E()){const pe=this.D(),ue=pe.type===17?n:void 0;throw this.h.push({message:o,offset:pe.offset,lexeme:L.$rj.getLexeme(pe),additionalInfo:ue}),s.c}return _}catch(_){if(_!==s.c)throw _;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const _=this.o();B.push(_)}return B.length===1?B[0]:t.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const _=this.s();B.push(_)}return B.length===1?B[0]:t.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),f.INSTANCE;case 12:return this.z(),g.INSTANCE;case 0:{this.z();const _=this.l();return this.A(1,l),_?.negate()}case 17:return this.z(),P.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const _=this.l();return this.A(1,l),_}case 17:{const _=B.lexeme;if(this.z(),this.y(9)){const ue=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ue.type!==10)throw this.B("REGEX",ue);const ce=ue.lexeme,oe=ce.lastIndexOf("/"),le=oe===ce.length-1?void 0:this.w(ce.substring(oe+1));let K;try{K=new RegExp(ce.substring(1,oe),le)}catch{throw this.B("REGEX",ue)}return j.create(_,K)}switch(ue.type){case 10:case 19:{const ce=[ue.lexeme];this.z();let oe=this.D(),le=0;for(let Re=0;Re<ue.lexeme.length;Re++)ue.lexeme.charCodeAt(Re)===40?le++:ue.lexeme.charCodeAt(Re)===41&&le--;for(;!this.E()&&oe.type!==15&&oe.type!==16;){switch(oe.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let Re=0;Re<oe.lexeme.length;Re++)oe.lexeme.charCodeAt(Re)===40?le++:ue.lexeme.charCodeAt(Re)===41&&le--}if(le<0)break;ce.push(L.$rj.getLexeme(oe)),this.z(),oe=this.D()}const K=ce.join(""),se=K.lastIndexOf("/"),$e=se===K.length-1?void 0:this.w(K.substring(se+1));let ve;try{ve=new RegExp(K.substring(1,se),$e)}catch{throw this.B("REGEX",ue)}return t.regex(_,ve)}case 18:{const ce=ue.lexeme;this.z();let oe=null;if(!(0,O.$7e)(ce)){const le=ce.indexOf("/"),K=ce.lastIndexOf("/");if(le!==K&&le>=0){const se=ce.slice(le+1,K),$e=ce[K+1]==="i"?"i":"";try{oe=new RegExp(se,$e)}catch{throw this.B("REGEX",ue)}}}if(oe===null)throw this.B("REGEX",ue);return j.create(_,oe)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,h);const ue=this.u();return t.notIn(_,ue)}switch(this.D().type){case 3:{this.z();const ue=this.u();if(this.x().type===18)return t.equals(_,ue);switch(ue){case"true":return t.has(_);case"false":return t.not(_);default:return t.equals(_,ue)}}case 4:{this.z();const ue=this.u();if(this.x().type===18)return t.notEquals(_,ue);switch(ue){case"true":return t.not(_);case"false":return t.has(_);default:return t.notEquals(_,ue)}}case 5:return this.z(),z.create(_,this.u());case 6:return this.z(),M.create(_,this.u());case 7:return this.z(),F.create(_,this.u());case 8:return this.z(),T.create(_,this.u());case 13:return this.z(),t.in(_,this.u());default:return t.has(_)}}case 20:throw this.h.push({message:i,offset:B.offset,lexeme:"",additionalInfo:u}),s.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,_){if(this.C(B))return this.z();throw this.B(_,this.D())}B(B,_,pe){const ue=(0,N.localize)(8,null,B,L.$rj.getLexeme(_)),ce=_.offset,oe=L.$rj.getLexeme(_);return this.h.push({message:ue,offset:ce,lexeme:oe,additionalInfo:pe}),s.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$tj=s;class t{static false(){return f.INSTANCE}static true(){return g.INSTANCE}static has(B){return w.create(B)}static equals(B,_){return S.create(B,_)}static notEquals(B,_){return D.create(B,_)}static regex(B,_){return j.create(B,_)}static in(B,_){return m.create(B,_)}static notIn(B,_){return E.create(B,_)}static not(B){return P.create(B)}static and(...B){return ie.create(B,null,!0)}static or(...B){return q.create(B,null,!0)}static greater(B,_){return F.create(B,_)}static greaterEquals(B,_){return T.create(B,_)}static smaller(B,_){return z.create(B,_)}static smallerEquals(B,_){return M.create(B,_)}static{this.c=new s({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$uj=t;function c(ee){const B=new s({regexParsingWithErrorRecovery:!1});return ee.map(_=>(B.parse(_),B.lexingErrors.length>0?B.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,N.localize)(9,null,pe.additionalInfo):(0,N.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}function r(ee,B){const _=ee?ee.substituteConstants():void 0,pe=B?B.substituteConstants():void 0;return!_&&!pe?!0:!_||!pe?!1:_.equals(pe)}function a(ee,B){return ee.cmp(B)}class f{static{this.INSTANCE=new f}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return g.INSTANCE}}e.$xj=f;class g{static{this.INSTANCE=new g}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return f.INSTANCE}}e.$yj=g;class w{static create(B,_=null){const pe=$.get(B);return typeof pe=="boolean"?pe?g.INSTANCE:f.INSTANCE:new w(B,_)}constructor(B,_){this.key=B,this.c=_,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:x(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=$.get(this.key);return typeof B=="boolean"?B?g.INSTANCE:f.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$zj=w;class S{static create(B,_,pe=null){if(typeof _=="boolean")return _?w.create(B,pe):P.create(B,pe);const ue=$.get(B);return typeof ue=="boolean"?_===(ue?"true":"false")?g.INSTANCE:f.INSTANCE:new S(B,_,pe)}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=$.get(this.c);if(typeof B=="boolean"){const _=B?"true":"false";return this.d===_?g.INSTANCE:f.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Aj=S;class m{static create(B,_){return new m(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const _=B.getValue(this.f),pe=B.getValue(this.d);return Array.isArray(_)?_.includes(pe):typeof pe=="string"&&typeof _=="object"&&_!==null?A.call(_,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Bj=m;class E{static create(B,_){return new E(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=11,this.c=m.create(B,_)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Cj=E;class D{static create(B,_,pe=null){if(typeof _=="boolean")return _?P.create(B,pe):w.create(B,pe);const ue=$.get(B);return typeof ue=="boolean"?_===(ue?"true":"false")?f.INSTANCE:g.INSTANCE:new D(B,_,pe)}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=$.get(this.c);if(typeof B=="boolean"){const _=B?"true":"false";return this.d===_?f.INSTANCE:g.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Dj=D;class P{static create(B,_=null){const pe=$.get(B);return typeof pe=="boolean"?pe?f.INSTANCE:g.INSTANCE:new P(B,_)}constructor(B,_){this.c=B,this.d=_,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:x(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=$.get(this.c);return typeof B=="boolean"?B?f.INSTANCE:g.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$Ej=P;function I(ee,B){if(typeof ee=="string"){const _=parseFloat(ee);isNaN(_)||(ee=_)}return typeof ee=="string"||typeof ee=="number"?B(ee):f.INSTANCE}class F{static create(B,_,pe=null){return I(_,ue=>new F(B,ue,pe))}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Fj=F;class T{static create(B,_,pe=null){return I(_,ue=>new T(B,ue,pe))}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Gj=T;class z{static create(B,_,pe=null){return I(_,ue=>new z(B,ue,pe))}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Hj=z;class M{static create(B,_,pe=null){return I(_,ue=>new M(B,ue,pe))}constructor(B,_,pe){this.c=B,this.d=_,this.f=pe,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Ij=M;class j{static create(B,_){return new j(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const _=this.f?this.f.source:"",pe=B.f?B.f.source:"";return _<pe?-1:_>pe?1:0}equals(B){if(B.type===this.type){const _=this.f?this.f.source:"",pe=B.f?B.f.source:"";return this.d===B.d&&_===pe}return!1}substituteConstants(){return this}evaluate(B){const _=B.getValue(this.d);return this.f?this.f.test(_):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=U.create(this)),this.c}}e.$Jj=j;class U{static create(B){return new U(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new U(this.c.map(B))}negate(){return this.c}}e.$Kj=U;function Z(ee){let B=null;for(let _=0,pe=ee.length;_<pe;_++){const ue=ee[_].substituteConstants();if(ee[_]!==ue&&B===null){B=[];for(let ce=0;ce<_;ce++)B[ce]=ee[ce]}B!==null&&(B[_]=ue)}return B===null?ee:B}class ie{static create(B,_,pe){return ie.d(B,_,pe)}constructor(B,_){this.expr=B,this.c=_,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let _=0,pe=this.expr.length;_<pe;_++){const ue=a(this.expr[_],B.expr[_]);if(ue!==0)return ue}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let _=0,pe=this.expr.length;_<pe;_++)if(!this.expr[_].equals(B.expr[_]))return!1;return!0}return!1}substituteConstants(){const B=Z(this.expr);return B===this.expr?this:ie.create(B,this.c,!1)}evaluate(B){for(let _=0,pe=this.expr.length;_<pe;_++)if(!this.expr[_].evaluate(B))return!1;return!0}static d(B,_,pe){const ue=[];let ce=!1;for(const oe of B)if(oe){if(oe.type===1){ce=!0;continue}if(oe.type===0)return f.INSTANCE;if(oe.type===6){ue.push(...oe.expr);continue}ue.push(oe)}if(ue.length===0&&ce)return g.INSTANCE;if(ue.length!==0){if(ue.length===1)return ue[0];ue.sort(a);for(let oe=1;oe<ue.length;oe++)ue[oe-1].equals(ue[oe])&&(ue.splice(oe,1),oe--);if(ue.length===1)return ue[0];for(;ue.length>1;){const oe=ue[ue.length-1];if(oe.type!==9)break;ue.pop();const le=ue.pop(),K=ue.length===0,se=q.create(oe.expr.map($e=>ie.create([$e,le],null,pe)),null,K);se&&(ue.push(se),ue.sort(a))}if(ue.length===1)return ue[0];if(pe){for(let oe=0;oe<ue.length;oe++)for(let le=oe+1;le<ue.length;le++)if(ue[oe].negate().equals(ue[le]))return f.INSTANCE;if(ue.length===1)return ue[0]}return new ie(ue,_)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const _ of this.expr)B.push(..._.keys());return B}map(B){return new ie(this.expr.map(_=>_.map(B)),null)}negate(){if(!this.c){const B=[];for(const _ of this.expr)B.push(_.negate());this.c=q.create(B,this,!0)}return this.c}}e.$Lj=ie;class q{static create(B,_,pe){return q.d(B,_,pe)}constructor(B,_){this.expr=B,this.c=_,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let _=0,pe=this.expr.length;_<pe;_++){const ue=a(this.expr[_],B.expr[_]);if(ue!==0)return ue}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let _=0,pe=this.expr.length;_<pe;_++)if(!this.expr[_].equals(B.expr[_]))return!1;return!0}return!1}substituteConstants(){const B=Z(this.expr);return B===this.expr?this:q.create(B,this.c,!1)}evaluate(B){for(let _=0,pe=this.expr.length;_<pe;_++)if(this.expr[_].evaluate(B))return!0;return!1}static d(B,_,pe){let ue=[],ce=!1;if(B){for(let oe=0,le=B.length;oe<le;oe++){const K=B[oe];if(K){if(K.type===0){ce=!0;continue}if(K.type===1)return g.INSTANCE;if(K.type===9){ue=ue.concat(K.expr);continue}ue.push(K)}}if(ue.length===0&&ce)return f.INSTANCE;ue.sort(a)}if(ue.length!==0){if(ue.length===1)return ue[0];for(let oe=1;oe<ue.length;oe++)ue[oe-1].equals(ue[oe])&&(ue.splice(oe,1),oe--);if(ue.length===1)return ue[0];if(pe){for(let oe=0;oe<ue.length;oe++)for(let le=oe+1;le<ue.length;le++)if(ue[oe].negate().equals(ue[le]))return g.INSTANCE;if(ue.length===1)return ue[0]}return new q(ue,_)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const _ of this.expr)B.push(..._.keys());return B}map(B){return new q(this.expr.map(_=>_.map(B)),null)}negate(){if(!this.c){const B=[];for(const _ of this.expr)B.push(_.negate());for(;B.length>1;){const _=B.shift(),pe=B.shift(),ue=[];for(const ce of Ce(_))for(const oe of Ce(pe))ue.push(ie.create([ce,oe],null,!1));B.unshift(q.create(ue,null,!1))}this.c=q.create(B,this,!0)}return this.c}}e.$Mj=q;class G extends w{static{this.d=[]}static all(){return G.d.values()}constructor(B,_,pe){super(B,null),this.f=_,typeof pe=="object"?G.d.push({...pe,key:B}):pe!==!0&&G.d.push({key:B,description:pe,type:_!=null?typeof _:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return S.create(this.key,B)}notEqualsTo(B){return D.create(this.key,B)}}e.$Nj=G,e.$Oj=(0,R.$wi)("contextKeyService");function x(ee,B){return ee<B?-1:ee>B?1:0}function ne(ee,B,_,pe){return ee<_?-1:ee>_?1:B<pe?-1:B>pe?1:0}function be(ee,B){if(ee.type===0||B.type===1)return!0;if(ee.type===9)return B.type===9?ae(ee.expr,B.expr):!1;if(B.type===9){for(const _ of B.expr)if(be(ee,_))return!0;return!1}if(ee.type===6){if(B.type===6)return ae(B.expr,ee.expr);for(const _ of ee.expr)if(be(_,B))return!0;return!1}return ee.equals(B)}function ae(ee,B){let _=0,pe=0;for(;_<ee.length&&pe<B.length;){const ue=ee[_].cmp(B[pe]);if(ue<0)return!1;ue===0&&_++,pe++}return _===ee.length}function Ce(ee){return ee.type===9?ee.expr:[ee]}}),define(Se[254],De([1,0,23,41,211,5,103,12,24]),function(he,e,d,O,L,R,N,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Pw=e.$Ow=e.$Nw=void 0,e.$Qw=y,e.$Rw=v,e.$Nw=(0,R.$wi)("dialogService");var k;(function(h){h[h.Confirmation=1]="Confirmation",h[h.Prompt=2]="Prompt",h[h.Input=3]="Input"})(k||(k={}));class A{a(l){return this.d(l,k.Confirmation)}b(l){return this.d(l,k.Prompt)}c(l){return this.d(l,k.Input)}d(l,o){const n=[];switch(o){case k.Confirmation:{const i=l;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(1,null));break}case k.Prompt:{const i=l;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(u=>u.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,L.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,L.localize)(3,null))),n.length===0&&n.push((0,L.localize)(4,null));break}case k.Input:{const i=l;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(6,null));break}}return n}e(l){if(typeof l=="string")return l;if(typeof l=="number")return l===O.default.Info?"info":l===O.default.Error?"error":l===O.default.Warning?"warning":"none"}f(l,o,n){const i=[...l.buttons??[]];l.cancelButton&&typeof l.cancelButton!="string"&&typeof l.cancelButton!="boolean"&&i.push(l.cancelButton);let u=i[o]?.run({checkboxChecked:n});return u instanceof Promise||(u=Promise.resolve(u)),{result:u,checkboxChecked:n}}}e.$Ow=A,e.$Pw=(0,R.$wi)("fileDialogService");var C;(function(h){h[h.SAVE=0]="SAVE",h[h.DONT_SAVE=1]="DONT_SAVE",h[h.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const p=10;function y(h){const l=[];return l.push(...h.slice(0,p).map(o=>typeof o=="string"?o:(0,d.$7g)(o))),h.length>p&&(h.length-p===1?l.push((0,L.localize)(7,null)):l.push((0,L.localize)(8,null,h.length-p))),l.push(""),l.join(`
`)}function v(h,l){const o=(0,$.$3n)(h);let n=(o.buttons??[]).map(t=>(0,N.$Kw)(t)),i=(h.buttons||[]).map((t,c)=>c),u=0,s=o.cancelId??n.length-1;if(n.length>1){const t=typeof s=="number"?n[s]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&n.length>1&&s!==1){n.splice(s,1),n.splice(1,0,t);const c=i[s];i.splice(s,1),i.splice(1,0,c),s=1}b.$k&&n.length>1&&(n=n.reverse(),i=i.reverse(),u=n.length-1,typeof t=="string"&&(s=u-1))}else if(b.$i&&typeof t=="string"&&n.length>1&&s!==n.length-1){n.splice(s,1),n.push(t);const c=i[s];i.splice(s,1),i.push(c),s=n.length-1}}return o.buttons=n,o.defaultId=u,o.cancelId=s,o.noLink=!0,o.title=o.title||l.nameLong,{options:o,buttonIndeces:i}}}),define(Se[137],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=void 0,e.$Di=(0,d.$wi)("environmentService"),e.$Ei=(0,d.$xi)(e.$Di)}),define(Se[138],De([1,0,212,5]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.ExtensionGalleryErrorCode=e.$7o=e.ExtensionManagementErrorCode=e.$6o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0,e.$Zo=L,e.$1o=R,e.$2o=N,e.$3o=b,e.$4o=$,e.$5o=k,e.$To="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Uo=new RegExp(e.$To),e.$Vo="__web_extension",e.$Wo="skipWalkthrough",e.$Xo="extensionsSync",e.$Yo="dependecyOrPackExtensionInstall";function L(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function R(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function N(n,i){switch(n){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function b(n,i){return i==="web"&&!n.includes("web")}function $(n,i,u){return b(i,u)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===u}function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var A;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var C;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var p;(function(n){n.Install="install",n.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var y;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$6o=(0,O.$wi)("extensionGalleryService");var v;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Cancelled="Cancelled",n.Unknown="Unknown",n.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));class h extends Error{constructor(i,u){super(i),this.code=u,this.name=u}}e.$7o=h;var l;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(l||(e.ExtensionGalleryErrorCode=l={}));class o extends Error{constructor(i,u){super(i),this.code=u,this.name=u}}e.$8o=o,e.$9o=(0,O.$wi)("extensionManagementService"),e.$0o="extensionsIdentifiers/disabled",e.$$o="extensionsIdentifiers/enabled",e.$_o=(0,O.$wi)("IGlobalExtensionEnablementService"),e.$ap=(0,O.$wi)("IExtensionTipsService"),e.$bp=(0,d.localize2)(0,"Extensions"),e.$cp=(0,d.localize2)(1,"Preferences")}),define(Se[255],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D7b=e.$C7b=void 0,e.$C7b=(0,d.$wi)("externalTerminal"),e.$D7b="Terminal.app"}),define(Se[256],De([1,0,54,56,15,17,12,102,32,105,214,255]),function(he,e,d,O,L,R,N,b,$,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=e.$Kcc=e.$Jcc=void 0;const p=A.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await l.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends y{static{this.b="cmd.exe"}openTerminal(s,t){return this.spawnTerminal(d,s,k.$om(),t)}spawnTerminal(s,t,c,r){const a=t.windowsExec||v.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const f=R.$nc(a,".exe").toLowerCase();if(f==="cmder")return s.spawn(a,r?[r]:void 0),Promise.resolve(void 0);const g=["/c","start","/wait"];return a.indexOf(" ")>=0&&g.push('""'),g.push(a),f==="wt"&&g.push("-d ."),new Promise((w,S)=>{const m=o(process),E=s.spawn(c,g,{cwd:r,env:m,detached:!0});E.on("error",S),E.on("exit",()=>w())})}async runInTerminal(s,t,c,r,a){const f="windowsExec"in a&&a.windowsExec?a.windowsExec:v.getDefaultTerminalWindows(),g=await v.f();return new Promise((w,S)=>{const m=`"${t} - ${p}"`,E=`"${c.join('" "')}" & pause`,D=Object.assign({},o(process),r);Object.keys(D).filter(z=>D[z]===null).forEach(z=>delete D[z]);const P={cwd:t,env:D,windowsVerbatimArguments:!0};let I,F;R.$nc(f,".exe")==="wt"?(I=f,F=["-d",".",v.b,"/c",E]):g?(I=g,F=["-d",".",f,"/c",E]):(I=v.b,F=["/c","start",m,"/wait",f,"/c",`"${E}"`]),d.spawn(I,F,P).on("error",z=>{S(n(z))}),w(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return v.d}static async f(){try{const s=await k.win32.findExecutable("wt");return await $.Promises.exists(s)?s:void 0}catch{return}}}e.$Jcc=v,Ge([O.$1h],v,"f",null);class h extends y{static{this.b="/usr/bin/osascript"}openTerminal(s,t){return this.spawnTerminal(d,s,t)}runInTerminal(s,t,c,r,a){const f=a.osxExec||C.$D7b;return new Promise((g,w)=>{if(f===C.$D7b||f==="iTerm.app"){const S=f===C.$D7b?"TerminalHelper":"iTermHelper",E=[L.$Qg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",s||p,"-w",t];for(const I of c)E.push("-a"),E.push(I);if(r){const I=Object.assign({},o(process),r);for(const F in I){const T=I[F];T===null?(E.push("-u"),E.push(F)):(E.push("-e"),E.push(`${F}=${T}`))}}let D="";const P=d.spawn(h.b,E);P.on("error",I=>{w(n(I))}),P.stderr.on("data",I=>{D+=I.toString()}),P.on("exit",I=>{if(I===0)g(void 0);else if(D){const F=D.split(`
`,1);w(new Error(F[0]))}else w(new Error(A.localize(1,null,S,I)))})}else w(new Error(A.localize(2,null,f)))})}spawnTerminal(s,t,c){const r=t.osxExec||C.$D7b;return new Promise((a,f)=>{const g=["-a",r];c&&g.push(c);const w=o(process),S=s.spawn("/usr/bin/open",g,{cwd:c,env:w});S.on("error",f),S.on("exit",()=>a())})}}e.$Kcc=h;class l extends y{static{this.b=A.localize(3,null)}openTerminal(s,t){return this.spawnTerminal(d,s,t)}runInTerminal(s,t,c,r,a){const f=a.linuxExec?Promise.resolve(a.linuxExec):l.getDefaultTerminalLinuxReady();return new Promise((g,w)=>{const S=[];f.then(m=>{m.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const E=`${i(c)}; echo; read -p "${l.b}" -n1;`;S.push(`''${E}''`);const D=Object.assign({},o(process),r);Object.keys(D).filter(T=>D[T]===null).forEach(T=>delete D[T]);const P={cwd:t,env:D};let I="";const F=d.spawn(m,S,P);F.on("error",T=>{w(n(T))}),F.stderr.on("data",T=>{I+=T.toString()}),F.on("exit",T=>{if(T===0)g(void 0);else if(I){const z=I.split(`
`,1);w(new Error(z[0]))}else w(new Error(A.localize(4,null,m,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!l.d)if(!N.$k)l.d=Promise.resolve("xterm");else{const s=await $.Promises.exists("/etc/debian_version");l.d=new Promise(t=>{s?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return l.d}spawnTerminal(s,t,c){const r=t.linuxExec?Promise.resolve(t.linuxExec):l.getDefaultTerminalLinuxReady();return new Promise((a,f)=>{r.then(g=>{const w=o(process),S=s.spawn(g,[],{cwd:c,env:w});S.on("error",f),S.on("exit",()=>a())})})}}e.$Lcc=l;function o(u){const s={...u.env};return(0,b.$mm)(s),s}function n(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(A.localize(5,null,u.path)):u}function i(u){let s="";for(const t of u)t.indexOf(" ")>=0?s+='"'+t+'"':s+=t,s+=" ";return s}}),define(Se[33],De([1,0,78,17,14,18,2,215,5,12,15,46]),function(he,e,d,O,L,R,N,b,$,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$vl=e.FileKind=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.FileOperationResult=e.$nl=e.$ml=e.$ll=e.$jl=e.FileChangeType=e.$il=e.FileOperation=e.$cl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$3k=void 0,e.$4k=p,e.$5k=l,e.$6k=n,e.$7k=i,e.$8k=u,e.$9k=s,e.$0k=t,e.$$k=c,e.$_k=r,e.$al=a,e.$bl=f,e.$dl=S,e.$el=m,e.$fl=E,e.$gl=D,e.$hl=P,e.$kl=M,e.$wl=G,e.$xl=x,e.$zl=be,e.$3k=(0,$.$wi)("fileService");function p(ae){return ae.create===!0}var y;(function(ae){ae[ae.Unknown=0]="Unknown",ae[ae.File=1]="File",ae[ae.Directory=2]="Directory",ae[ae.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var v;(function(ae){ae[ae.Readonly=1]="Readonly",ae[ae.Locked=2]="Locked"})(v||(e.FilePermission=v={}));var h;(function(ae){ae[ae.UPDATED=2]="UPDATED",ae[ae.ADDED=4]="ADDED",ae[ae.DELETED=8]="DELETED"})(h||(e.FileChangeFilter=h={}));function l(ae){const Ce=ae;return!!Ce&&typeof Ce.onDidChange=="function"}var o;(function(ae){ae[ae.None=0]="None",ae[ae.FileReadWrite=2]="FileReadWrite",ae[ae.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ae[ae.FileReadStream=16]="FileReadStream",ae[ae.FileFolderCopy=8]="FileFolderCopy",ae[ae.PathCaseSensitive=1024]="PathCaseSensitive",ae[ae.Readonly=2048]="Readonly",ae[ae.Trash=4096]="Trash",ae[ae.FileWriteUnlock=8192]="FileWriteUnlock",ae[ae.FileAtomicRead=16384]="FileAtomicRead",ae[ae.FileAtomicWrite=32768]="FileAtomicWrite",ae[ae.FileAtomicDelete=65536]="FileAtomicDelete",ae[ae.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function n(ae){return!!(ae.capabilities&2)}function i(ae){return!!(ae.capabilities&8)}function u(ae){return!!(ae.capabilities&131072)}function s(ae){return!!(ae.capabilities&4)}function t(ae){return!!(ae.capabilities&16)}function c(ae){return n(ae)?!!(ae.capabilities&16384):!1}function r(ae){return n(ae)?!!(ae.capabilities&32768):!1}function a(ae){return!!(ae.capabilities&65536)}function f(ae){return!!(ae.capabilities&2048)}var g;(function(ae){ae.FileExists="EntryExists",ae.FileNotFound="EntryNotFound",ae.FileNotADirectory="EntryNotADirectory",ae.FileIsADirectory="EntryIsADirectory",ae.FileExceedsStorageQuota="EntryExceedsStorageQuota",ae.FileTooLarge="EntryTooLarge",ae.FileWriteLocked="EntryWriteLocked",ae.NoPermissions="NoPermissions",ae.Unavailable="Unavailable",ae.Unknown="Unknown"})(g||(e.FileSystemProviderErrorCode=g={}));class w extends Error{static create(Ce,ee){const B=new w(Ce.toString(),ee);return E(B,ee),B}constructor(Ce,ee){super(Ce),this.code=ee}}e.$cl=w;function S(ae,Ce){return w.create(ae,Ce)}function m(ae){return ae||S((0,b.localize)(0,null),g.Unknown)}function E(ae,Ce){return ae.name=Ce?`${Ce} (FileSystemError)`:"FileSystemError",ae}function D(ae){if(!ae)return g.Unknown;if(ae instanceof w)return ae.code;const Ce=/^(.+) \(FileSystemError\)$/.exec(ae.name);if(!Ce)return g.Unknown;switch(Ce[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}function P(ae){if(ae instanceof j)return ae.fileOperationResult;switch(D(ae)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 9;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileTooLarge:return 7;default:return 10}}var I;(function(ae){ae[ae.CREATE=0]="CREATE",ae[ae.DELETE=1]="DELETE",ae[ae.MOVE=2]="MOVE",ae[ae.COPY=3]="COPY",ae[ae.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class F{constructor(Ce,ee,B){this.resource=Ce,this.operation=ee,this.target=B}isOperation(Ce){return this.operation===Ce}}e.$il=F;var T;(function(ae){ae[ae.UPDATED=0]="UPDATED",ae[ae.ADDED=1]="ADDED",ae[ae.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class z{static{this.a=null}constructor(Ce,ee){this.c=ee,this.b=void 0,this.d=new C.$V(()=>{const B=d.$Ci.forUris(()=>this.c);return B.fill(this.rawAdded.map(_=>[_,!0])),B}),this.f=new C.$V(()=>{const B=d.$Ci.forUris(()=>this.c);return B.fill(this.rawUpdated.map(_=>[_,!0])),B}),this.g=new C.$V(()=>{const B=d.$Ci.forUris(()=>this.c);return B.fill(this.rawDeleted.map(_=>[_,!0])),B}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const B of Ce){switch(B.type){case 1:this.rawAdded.push(B.resource);break;case 0:this.rawUpdated.push(B.resource);break;case 2:this.rawDeleted.push(B.resource);break}this.b!==z.a&&(typeof B.cId=="number"?this.b===void 0?this.b=B.cId:this.b!==B.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(Ce,...ee){return this.h(Ce,{includeChildren:!1},...ee)}affects(Ce,...ee){return this.h(Ce,{includeChildren:!0},...ee)}h(Ce,ee,...B){if(!Ce)return!1;const _=B.length>0;return!!((!_||B.includes(1))&&(this.d.value.get(Ce)||ee.includeChildren&&this.d.value.findSuperstr(Ce))||(!_||B.includes(0))&&(this.f.value.get(Ce)||ee.includeChildren&&this.f.value.findSuperstr(Ce))||(!_||B.includes(2))&&(this.g.value.findSubstr(Ce)||ee.includeChildren&&this.g.value.findSuperstr(Ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ce){return this.b===Ce}hasCorrelation(){return typeof this.b=="number"}}e.$jl=z;function M(ae,Ce,ee){return!ae||!Ce||ae===Ce||Ce.length>ae.length?!1:(Ce.charAt(Ce.length-1)!==O.sep&&(Ce+=O.sep),ee?(0,L.$yf)(ae,Ce):ae.indexOf(Ce)===0)}class j extends Error{constructor(Ce,ee,B){super(Ce),this.fileOperationResult=ee,this.options=B}}e.$ll=j;class U extends j{constructor(Ce,ee,B,_){super(Ce,ee,_),this.fileOperationResult=ee,this.size=B}}e.$ml=U;class Z extends j{constructor(Ce,ee,B){super(Ce,2,B),this.stat=ee}}e.$nl=Z;var ie;(function(ae){ae[ae.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ae[ae.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ae[ae.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ae[ae.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ae[ae.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ae[ae.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ae[ae.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ae[ae.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ae[ae.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ae[ae.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ae[ae.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$ol={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ql="files.associations",e.$rl="files.exclude",e.$sl="files.readonlyInclude",e.$tl="files.readonlyExclude",e.$ul="files.readonlyFromPermissions";var q;(function(ae){ae[ae.FILE=0]="FILE",ae[ae.FOLDER=1]="FOLDER",ae[ae.ROOT_FOLDER=2]="ROOT_FOLDER"})(q||(e.FileKind=q={})),e.$vl="";function G(ae){if(!(typeof ae.size!="number"||typeof ae.mtime!="number"))return ae.mtime.toString(29)+ae.size.toString(31)}async function x(ae,Ce){if(!Ce.hasProvider(N.URI.from({scheme:ae.scheme})))return new Promise(ee=>{const B=Ce.onDidChangeFileSystemProviderRegistrations(_=>{_.scheme===ae.scheme&&_.added&&(B.dispose(),ee())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(Ce){return(0,R.$ag)(Ce)||(Ce=0),Ce<ne.KB?(0,b.localize)(1,null,Ce.toFixed(0)):Ce<ne.MB?(0,b.localize)(2,null,(Ce/ne.KB).toFixed(2)):Ce<ne.GB?(0,b.localize)(3,null,(Ce/ne.MB).toFixed(2)):Ce<ne.TB?(0,b.localize)(4,null,(Ce/ne.GB).toFixed(2)):(0,b.localize)(5,null,(Ce/ne.TB).toFixed(2))}}e.$yl=ne;function be(ae){const Ce=typeof ae=="string"||ae?.scheme===A.Schemas.vscodeRemote;return typeof ae!="string"&&ae?.scheme===A.Schemas.file?1024*ne.MB:Ce?10*ne.MB:k.$o?50*ne.MB:1024*ne.MB}}),define(Se[257],De([1,0,21,13,216,33]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=N;async function N(A,C,p,y,v,h){let l;try{await b(A,C,p,y,v,h)}catch(o){l=o}finally{l&&v.errorTransformer&&(l=v.errorTransformer(l)),typeof l<"u"&&p.error(l),p.end()}}async function b(A,C,p,y,v,h){$(h);const l=await A.open(C,{create:!1});try{$(h);let o=0,n=0,i=v&&typeof v.length=="number"?v.length:void 0,u=d.$Fe.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),s=v&&typeof v.position=="number"?v.position:0,t=0;do n=await A.read(l,s,u.buffer,t,u.byteLength-t),s+=n,t+=n,o+=n,typeof i=="number"&&(i-=n),t===u.byteLength&&(await p.write(y(u)),u=d.$Fe.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&$(h)&&k(o,v));if(t>0){let c=t;typeof i=="number"&&(c=Math.min(t,i)),p.write(y(u.slice(0,c)))}}catch(o){throw(0,R.$el)(o)}finally{await A.close(l)}}function $(A){if(A.isCancellationRequested)throw(0,O.$6)();return!0}function k(A,C){if(typeof C?.limits?.size=="number"&&A>C.limits.size)throw(0,R.$dl)((0,L.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[65],De([1,0,35,3,17,12,2,33]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=e.$Lq=void 0,e.$Jq=$,e.$Kq=k,e.$Oq=y,e.$Pq=v,e.$Qq=h,e.$Rq=l,e.$Sq=n,e.$Tq=i;function $(u){return typeof u.correlationId=="number"}function k(u){return u.recursive===!0}class A extends O.$Uc{static{this.a=5}constructor(s,t,c,r){super(),this.h=s,this.j=t,this.m=c,this.n=r,this.c=this.B(new O.$Vc),this.f=void 0,this.g=0}s(){const s=new O.$Tc;this.c.value=s,this.b=this.r(s),this.b.setVerboseLogging(this.m),s.add(this.b.onDidChangeFile(t=>this.h(t))),s.add(this.b.onDidLogMessage(t=>this.j(t))),s.add(this.b.onDidError(t=>this.t(t)))}t(s){this.n.restartOnError?this.g<A.a&&this.f?(this.w(`restarting watcher after error: ${s}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${s}`):this.w(s)}u(s){this.g++,this.s(),this.watch(s)}async watch(s){this.f=s,await this.b?.watch(s)}async setVerboseLogging(s){this.m=s,await this.b?.setVerboseLogging(s)}w(s){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${s}`})}y(s){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${s}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Lq=A;class C extends A{constructor(s,t,c){super(s,t,c,{type:"node.js",restartOnError:!1})}}e.$Mq=C;class p extends A{constructor(s,t,c){super(s,t,c,{type:"universal",restartOnError:!0})}}e.$Nq=p;function y(u){return u.map(s=>({type:s.type,resource:N.URI.revive(s.resource),cId:s.cId}))}function v(u){const s=new o;for(const t of u)s.processEvent(t);return s.coalesce()}function h(u,s){return typeof s=="string"&&!s.startsWith(d.$mk)&&!(0,L.$ic)(s)?{base:u,pattern:s}:s}function l(u,s){const t=[];for(const c of s)t.push((0,d.$qk)(h(u,c)));return t}class o{constructor(){this.a=new Set,this.b=new Map}c(s){return R.$k?s.resource.fsPath:s.resource.fsPath.toLowerCase()}processEvent(s){const t=this.b.get(this.c(s));let c=!1;if(t){const r=t.type,a=s.type;t.resource.fsPath!==s.resource.fsPath&&(s.type===2||s.type===1)?c=!0:r===1&&a===2?(this.b.delete(this.c(s)),this.a.delete(t)):r===2&&a===1?t.type=0:r===1&&a===0||(t.type=a)}else c=!0;c&&(this.a.add(s),this.b.set(this.c(s),s))}coalesce(){const s=[],t=[];return Array.from(this.a).filter(c=>c.type!==2?(s.push(c),!1):!0).sort((c,r)=>c.resource.fsPath.length-r.resource.fsPath.length).filter(c=>t.some(r=>(0,b.$kl)(c.resource.fsPath,r,!R.$k))?!1:(t.push(c.resource.fsPath),!0)).concat(s)}}function n(u,s){if(typeof s=="number")switch(u.type){case 1:return(s&4)===0;case 2:return(s&8)===0;case 0:return(s&2)===0}return!1}function i(u){if(typeof u=="number"){const s=[];return u&4&&s.push("Added"),u&8&&s.push("Deleted"),u&2&&s.push("Updated"),s.length===0?"<all>":`[${s.join(", ")}]`}return"<none>"}}),define(Se[258],De([1,0,53,3,65,4,2,7]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class $ extends O.$Uc{constructor(){super(),this.a=this.B(new R.$de),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$de),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$de),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new O.$4c),this.m=new Set,this.n=5007,this.r=new b.$Th,this.P=!1,this.B(this.f(A=>this.s(A)))}s(A){this.t(A)&&this.w(A)}t(A){return(0,L.$Jq)(A)}async watch(A){this.r.isSettled||this.r.complete(),this.r=new b.$Th;try{this.h.clear(),this.g.clear();for(const C of A)this.t(C)?this.h.set(C.correlationId,C):this.g.add(C);for(const[C]of this.j)this.h.has(C)||(this.j.deleteAndDispose(C),this.m.delete(C));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(A=>!this.j.has(A.correlationId))])}isSuspended(A){return typeof A.correlationId!="number"?!1:this.m.has(A.correlationId)?"polling":this.j.has(A.correlationId)}async w(A){if(this.j.has(A.correlationId))return;const C=new O.$Tc;this.j.set(A.correlationId,C),await this.r.p,!C.isDisposed&&(this.z(A,C),this.u())}y(A){this.j.deleteAndDispose(A.correlationId),this.m.delete(A.correlationId),this.u()}z(A,C){this.C(A,C)?(this.N(`reusing an existing recursive watcher to monitor ${A.path}`),this.m.delete(A.correlationId)):(this.D(A,C),this.m.add(A.correlationId))}C(A,C){const p=this.M?.subscribe(A.path,(y,v)=>{C.isDisposed||(y?this.z(A,C):v?.type===1&&this.F(A))});return p?(C.add(p),!0):!1}D(A,C){let p=!1;const y=(v,h)=>{if(C.isDisposed)return;const l=this.G(v),o=this.G(h),n=p;p=l,!l&&(o||n)&&this.F(A)};this.N(`starting fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,d.watchFile)(A.path,{persistent:!1,interval:this.n},y)}catch(v){this.O(`fs.watchFile() failed with error ${v} on path ${A.path} (correlationId: ${A.correlationId})`)}C.add((0,O.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,d.unwatchFile)(A.path,y)}catch(v){this.O(`fs.unwatchFile() failed with error ${v} on path ${A.path} (correlationId: ${A.correlationId})`)}}))}F(A){this.N(`detected ${A.path} exists again, resuming watcher (correlationId: ${A.correlationId})`);const C={resource:N.URI.file(A.path),type:1,cId:A.correlationId};this.a.fire([C]),this.H(C,A),this.y(A)}G(A){return A.ctimeMs===0&&A.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(A,C){if(this.P){const p=` >> normalized ${A.type===1?"[ADDED]":A.type===2?"[DELETED]":"[CHANGED]"} ${A.resource.fsPath}`;this.I(p,C)}}I(A,C){this.P&&this.N(`${A}${typeof C.correlationId=="number"?` <${C.correlationId}> `:""}`)}J(A){return`${A.path} (excludes: ${A.excludes.length>0?A.excludes:"<none>"}, includes: ${A.includes&&A.includes.length>0?JSON.stringify(A.includes):"<all>"}, filter: ${(0,L.$Tq)(A.filter)}, correlationId: ${typeof A.correlationId=="number"?A.correlationId:"<none>"})`}async setVerboseLogging(A){this.P=A}}e.$3q=$}),define(Se[259],De([1,0,53,7,22,31,3,77,17,12,23,2,104,32,65]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0,e.$9q=l;class h extends N.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(n,i,u,s,t,c){super(),this.s=n,this.t=i,this.u=u,this.w=s,this.y=t,this.z=c,this.c=this.B(new O.$Lh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},r=>this.u(r))),this.f=this.B(new O.$Kh(r=>this.M(r),h.b)),this.g=(0,v.$Rq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,v.$Rq)(this.s.path,this.s.includes):void 0,this.j=(0,v.$Jq)(this.s)?this.s.filter:void 0,this.m=new L.$oe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const n=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const i=await y.Promises.stat(n);if(this.m.token.isCancellationRequested)return;this.B(await this.G(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.O(n):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${n})`),this.D()}}D(){this.r=!0,this.w?.()}async F(n){let i=n.path;try{i=await y.Promises.realpath(n.path),n.path===i&&(i=await(0,p.$5q)(n.path,this.m.token)??n.path),n.path!==i&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async G(n,i){const u=new N.$Tc;return this.H(n,i,u)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(n,i,u)),u}H(n,i,u){if(i)return!1;const s=C.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(c,r)=>{if(!u.isDisposed)if(c){const a=await this.G(n,i);u.isDisposed?a.dispose():u.add(a)}else r&&(typeof r.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:s,type:r.type,cId:this.s.correlationId},!0)});return t?(u.add(t),!0):!1}async I(n,i,u){if(k.$j&&(0,R.$vg)(n,"/Volumes/",!0)){this.O(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const s=new L.$oe(this.m.token);u.add((0,N.$Sc)(()=>s.dispose(!0)));const t=new N.$Tc;u.add(t);try{const c=C.URI.file(this.s.path),r=(0,$.$nc)(n),a=(0,d.watch)(n);t.add((0,N.$Sc)(()=>{a.removeAllListeners(),a.close()})),this.Q(`Started watching: '${n}'`);const f=new Set;if(i)try{for(const w of await y.Promises.readdir(n))f.add(w)}catch(w){this.O(w)}if(s.token.isCancellationRequested)return;const g=new Map;t.add((0,N.$Sc)(()=>{for(const[,w]of g)w.dispose();g.clear()})),a.on("error",(w,S)=>{s.token.isCancellationRequested||(this.O(`Failed to watch ${n} for changes using fs.watch() (${w}, ${S})`),this.D())}),a.on("change",(w,S)=>{if(s.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${w}"] ${S}`);let m="";if(S&&(m=S.toString(),k.$j&&(m=(0,b.$bm)(m))),!(!m||w!=="change"&&w!=="rename"))if(i)if(w==="rename"){g.get(m)?.dispose();const E=setTimeout(async()=>{if(g.delete(m),m===r&&!await y.Promises.exists(n)){this.J(c);return}if(s.token.isCancellationRequested)return;const D=await this.N((0,$.$jc)(n,m));if(s.token.isCancellationRequested)return;let P;D?f.has(m)?P=0:(P=1,f.add(m)):(f.delete(m),P=2),this.L({resource:(0,A.$0g)(c,m),type:P,cId:this.s.correlationId})},h.a);g.set(m,(0,N.$Sc)(()=>clearTimeout(E)))}else{let E;f.has(m)?E=0:(E=1,f.add(m)),this.L({resource:(0,A.$0g)(c,m),type:E,cId:this.s.correlationId})}else if(w==="rename"||m!==r){const E=setTimeout(async()=>{const D=await y.Promises.exists(n);s.token.isCancellationRequested||(D?(this.L({resource:c,type:0,cId:this.s.correlationId},!0),t.add(await this.G(n,!1))):this.J(c))},h.a);t.clear(),t.add((0,N.$Sc)(()=>clearTimeout(E)))}else this.L({resource:c,type:0,cId:this.s.correlationId},!0)})}catch(c){s.token.isCancellationRequested||this.O(`Failed to watch ${n} for changes using fs.watch() (${c.toString()})`),this.D()}}J(n){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:n,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(n,i=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(u=>u(n.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(u=>u(n.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}M(n){const i=(0,v.$Pq)(n),u=[];for(const t of i){if((0,v.$Sq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}u.push(t)}if(u.length===0)return;if(this.z)for(const t of u)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(u)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(n){if(k.$k)return y.Promises.exists(n);try{const i=(0,$.$nc)(n);return(await y.Promises.readdir((0,$.$mc)(n))).some(s=>s===i)}catch(i){return this.Q(i),!1}}setVerboseLogging(n){this.z=n}O(n){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}P(n){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}Q(n){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}R(n){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${n}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$8q=h;async function l(o,n,i,u,s=512){const t=await y.Promises.open(o,"r"),c=Buffer.allocUnsafe(s),r=new L.$oe(u);let a,f=!1;const g={path:o,excludes:[],recursive:!1},w=new h(g,void 0,S=>{(async()=>{for(const{type:m}of S)if(m===0){if(f)return;f=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:E}=await y.Promises.read(t,c,0,s,null);if(!E||r.token.isCancellationRequested)break;n(c.slice(0,E))}}catch(E){a=new Error(E),r.dispose(!0)}finally{f=!1}}})()});return await w.ready,i(),new Promise((S,m)=>{r.token.onCancellationRequested(async()=>{w.dispose();try{await y.Promises.close(t)}catch(E){a=new Error(E)}a?m(a):S()})})}}),define(Se[260],De([1,0,4,35,258,12,259,31]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;class $ extends L.$3q{constructor(A){super(),this.M=A,this.onDidError=d.Event.None,this.watchers=new Set}async L(A){A=this.X(A);const C=[],p=new Set(Array.from(this.watchers));for(const y of A){const v=this.S(y);v&&(0,O.$uk)(v.request.excludes,y.excludes)&&(0,O.$uk)(v.request.includes,y.includes)?p.delete(v):C.push(y)}C.length&&this.N(`Request to start watching: ${C.map(y=>this.J(y)).join(",")}`),p.size&&this.N(`Request to stop watching: ${Array.from(p).map(y=>this.J(y.request)).join(",")}`);for(const y of p)this.W(y);for(const y of C)this.U(y)}S(A){for(const C of this.watchers)if(typeof A.correlationId=="number"||typeof C.request.correlationId=="number"){if(C.request.correlationId===A.correlationId)return C}else if((0,b.$ug)(C.request.path,A.path,!R.$k))return C}U(A){const C=new N.$8q(A,this.M,y=>this.a.fire(y),()=>this.c.fire(A),y=>this.b.fire(y),this.P),p={request:A,instance:C};this.watchers.add(p)}async stop(){await super.stop();for(const A of this.watchers)this.W(A)}W(A){this.N("stopping file watcher",A),this.watchers.delete(A),A.instance.dispose()}X(A){const C=new Map;for(const p of A){const y=R.$k?p.path:p.path.toLowerCase();let v=C.get(p.correlationId);v||(v=new Map,C.set(p.correlationId,v)),v.has(y)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(p)}`),v.set(y,p)}return Array.from(C.values()).map(p=>Array.from(p.values())).flat()}async setVerboseLogging(A){super.setVerboseLogging(A);for(const C of this.watchers)C.instance.setVerboseLogging(A)}N(A,C){this.P&&this.b.fire({type:"trace",message:this.$(A,C)})}O(A){this.b.fire({type:"warn",message:this.$(A)})}$(A,C){return C?`[File Watcher (node.js)] ${A} (${this.J(C.request)})`:`[File Watcher (node.js)] ${A}`}}e.$0q=$}),define(Se[261],De([1,0,65,260]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class L extends d.$Mq{constructor(N,b,$){super(N,b,$),this.s()}r(N){return N.add(new O.$0q(void 0))}}e.$$q=L}),define(Se[262],De([1,0,15,82,199,65]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class N extends R.$Nq{constructor($,k,A){super($,k,A),this.s()}r($){const k=$.add(new L.$1q(d.$Qg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(k.onDidProcessExit(({code:A,signal:C})=>this.t(`terminated by itself with code ${A}, signal: ${C} (ETERM)`))),O.ProxyChannel.toService((0,O.$di)(k.getChannel("watcher")))}}e.$2q=N}),define(Se[107],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=void 0;class d{constructor(...L){this.a=new Map;for(const[R,N]of L)this.set(R,N)}set(L,R){const N=this.a.get(L);return this.a.set(L,R),N}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$ui=d}),define(Se[263],De([1,0,7,13,3,106,253,5,107,76]),function(he,e,d,O,L,R,N,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=void 0;const A=!1;class C extends Error{constructor(l){super("cyclic dependency between services"),this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class p{constructor(l=new $.$ui,o=!1,n,i=A){this.i=l,this.j=o,this.k=n,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(b.$vi,this),this._globalGraph=i?n?._globalGraph??new N.$br(u=>u):void 0}dispose(){if(!this.f){this.f=!0,(0,L.$Pc)(this.h),this.h.clear();for(const l of this.g)(0,L.$Oc)(l)&&l.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(l){this.m();const o=new class extends p{dispose(){this.h.delete(o),super.dispose()}}(l,this.j,this,this.l);return this.h.add(o),o}invokeFunction(l,...o){this.m();const n=v.traceInvocation(this.l,l);let i=!1;try{return l({get:s=>{if(i)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(s,n);if(!t)throw new Error(`[invokeFunction] unknown service '${s}'`);return t}},...o)}finally{i=!0,n.stop()}}createInstance(l,...o){this.m();let n,i;return l instanceof R.$ti?(n=v.traceCreation(this.l,l.ctor),i=this.o(l.ctor,l.staticArguments.concat(o),n)):(n=v.traceCreation(this.l,l),i=this.o(l,o,n)),n.stop(),i}o(l,o=[],n){const i=b._util.getServiceDependencies(l).sort((t,c)=>t.index-c.index),u=[];for(const t of i){const c=this.s(t.id,n);c||this.y(`[createInstance] ${l.name} depends on UNKNOWN service ${t.id}.`,!1),u.push(c)}const s=i.length>0?i[0].index:o.length;if(o.length!==s){console.trace(`[createInstance] First service dependency of ${l.name} at position ${s+1} conflicts with ${o.length} static arguments`);const t=s-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,s)}return Reflect.construct(l,o.concat(u))}q(l,o){if(this.i.get(l)instanceof R.$ti)this.i.set(l,o);else if(this.k)this.k.q(l,o);else throw new Error("illegalState - setting UNKNOWN service instance")}r(l){const o=this.i.get(l);return!o&&this.k?this.k.r(l):o}s(l,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(l));const n=this.r(l);return n instanceof R.$ti?this.u(l,n,o.branch(l,!0)):(o.branch(l,!1),n)}u(l,o,n){if(this.t.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this.t.add(l);try{return this.v(l,o,n)}finally{this.t.delete(l)}}v(l,o,n){const i=new N.$br(t=>t.id.toString());let u=0;const s=[{id:l,desc:o,_trace:n}];for(;s.length;){const t=s.pop();if(i.lookupOrInsertNode(t),u++>1e3)throw new C(i);for(const c of b._util.getServiceDependencies(t.desc.ctor)){const r=this.r(c.id);if(r||this.y(`[createInstance] ${l} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(c.id)),r instanceof R.$ti){const a={id:c.id,desc:r,_trace:t._trace.branch(c.id,!0)};i.insertEdge(t,a),s.push(a)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new C(i);break}for(const{data:c}of t){if(this.r(c.id)instanceof R.$ti){const a=this.w(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.q(c.id,a)}i.removeNode(c)}}return this.r(l)}w(l,o,n=[],i,u){if(this.i.get(l)instanceof R.$ti)return this.x(l,o,n,i,u,this.g);if(this.k)return this.k.w(l,o,n,i,u);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}x(l,o,n=[],i,u,s){if(i){const t=new p(void 0,this.j,this,this.l);t.c=String(l);const c=new Map,r=new d.$Ph(()=>{const a=t.o(o,n,u);for(const[f,g]of c){const w=a[f];if(typeof w=="function")for(const S of g)S.disposable=w.apply(a,S.listener)}return c.clear(),s.add(a),a});return new Proxy(Object.create(null),{get(a,f){if(!r.isInitialized&&typeof f=="string"&&(f.startsWith("onDid")||f.startsWith("onWill"))){let S=c.get(f);return S||(S=new k.$5c,c.set(f,S)),(E,D,P)=>{if(r.isInitialized)return r.value[f](E,D,P);{const I={listener:[E,D,P],disposable:void 0},F=S.push(I);return(0,L.$Sc)(()=>{F(),I.disposable?.dispose()})}}}if(f in a)return a[f];const g=r.value;let w=g[f];return typeof w!="function"||(w=w.bind(g),a[f]=w),w},set(a,f,g){return r.value[f]=g,!0},getPrototypeOf(a){return o.prototype}})}else{const t=this.o(o,n,u);return s.add(t),t}}y(l,o){if(o&&console.warn(l),this.j)throw new Error(l)}}e.$cr=p;var y;(function(h){h[h.None=0]="None",h[h.Creation=1]="Creation",h[h.Invocation=2]="Invocation",h[h.Branch=3]="Branch"})(y||(y={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(l,o){return l?new v(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(l,o){return l?new v(1,o.name):v.c}static{this.f=0}constructor(l,o){this.type=l,this.name=o,this.g=Date.now(),this.h=[]}branch(l,o){const n=new v(3,l.toString());return this.h.push([l,o,n]),n}stop(){const l=Date.now()-this.g;v.f+=l;let o=!1;function n(u,s){const t=[],c=new Array(u+1).join("	");for(const[r,a,f]of s.h)if(a&&f){o=!0,t.push(`${c}CREATES -> ${r}`);const g=n(u+1,f);g&&t.push(g)}else t.push(`${c}uses -> ${r}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(l>2||o)&&v.all.add(i.join(`
`))}}e.$dr=v}),define(Se[11],De([1,0,218,47,4,57,3,27,12,23,18,2,38,5]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$6j=e.LogLevel=e.$4j=e.$3j=void 0,e.$5j=h,e.log=o,e.$ek=w,e.$fk=S,e.$gk=m,e.$hk=E,e.$3j=(0,y.$wi)("logService"),e.$4j=(0,y.$wi)("loggerService");function v(){return new Date().toISOString()}function h(D){return(0,A.$ag)(D)}var l;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(l||(e.LogLevel=l={})),e.$6j=l.Info;function o(D,P,I){switch(P){case l.Trace:D.trace(I);break;case l.Debug:D.debug(I);break;case l.Info:D.info(I);break;case l.Warning:D.warn(I);break;case l.Error:D.error(I);break;case l.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function n(D,P=!1){let I="";for(let F=0;F<D.length;F++){let T=D[F];if(T instanceof Error&&(T=(0,O.$hj)(T,P)),typeof T=="object")try{T=JSON.stringify(T)}catch{}I+=(F>0?" ":"")+T}return I}class i extends N.$Uc{constructor(){super(...arguments),this.b=e.$6j,this.c=this.B(new L.$de),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==l.Off&&this.b<=P}}e.$8j=i;class u extends i{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...I){this.f(l.Trace)&&this.g(l.Trace,n([P,...I],!0))}debug(P,...I){this.f(l.Debug)&&this.g(l.Debug,n([P,...I]))}info(P,...I){this.f(l.Info)&&this.g(l.Info,n([P,...I]))}warn(P,...I){this.f(l.Warning)&&this.g(l.Warning,n([P,...I]))}error(P,...I){if(this.f(l.Error))if(P instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=P.stack,this.g(l.Error,n(F))}else this.g(l.Error,n([P,...I]))}flush(){}}e.$9j=u;class s extends i{constructor(P=e.$6j){super(),this.setLevel(P),this.g=!$.$i}trace(P,...I){this.f(l.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,P,...I):console.log(`[main ${v()}]`,P,...I))}debug(P,...I){this.f(l.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,P,...I):console.log(`[main ${v()}]`,P,...I))}info(P,...I){this.f(l.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,P,...I):console.log(`[main ${v()}]`,P,...I))}warn(P,...I){this.f(l.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,P,...I):console.warn(`[main ${v()}]`,P,...I))}error(P,...I){this.f(l.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,P,...I):console.error(`[main ${v()}]`,P,...I))}flush(){}}e.$0j=s;class t extends i{constructor(P=e.$6j,I=!0){super(),this.g=I,this.setLevel(P)}trace(P,...I){this.f(l.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...I):console.log(P,...I))}debug(P,...I){this.f(l.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...I):console.log(P,...I))}info(P,...I){this.f(l.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...I):console.log(P,...I))}warn(P,...I){this.f(l.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...I):console.log(P,...I))}error(P,...I){this.f(l.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...I):console.error(P,...I))}flush(){}}e.$$j=t;class c extends i{constructor(P,I=e.$6j){super(),this.g=P,this.setLevel(I)}trace(P,...I){this.f(l.Trace)&&this.g.log(l.Trace,[this.h(P),...I])}debug(P,...I){this.f(l.Debug)&&this.g.log(l.Debug,[this.h(P),...I])}info(P,...I){this.f(l.Info)&&this.g.log(l.Info,[this.h(P),...I])}warn(P,...I){this.f(l.Warning)&&this.g.log(l.Warning,[this.h(P),...I])}error(P,...I){this.f(l.Error)&&this.g.log(l.Error,[this.h(P),...I])}h(P){return typeof P=="string"?P:(0,O.$hj)(P,this.f(l.Trace))}flush(){}}e.$_j=c;class r extends i{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const I of this.g)I.setLevel(P);super.setLevel(P)}trace(P,...I){for(const F of this.g)F.trace(P,...I)}debug(P,...I){for(const F of this.g)F.debug(P,...I)}info(P,...I){for(const F of this.g)F.info(P,...I)}warn(P,...I){for(const F of this.g)F.warn(P,...I)}error(P,...I){for(const F of this.g)F.error(P,...I)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$ak=r;class a extends N.$Uc{constructor(P,I,F){if(super(),this.h=P,this.j=I,this.b=new b.$Ac,this.c=this.B(new L.$de),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$de),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$de),this.onDidChangeVisibility=this.g.event,F)for(const T of F)this.b.set(T.resource,{logger:void 0,info:T})}m(P){return(0,A.$9f)(P)?[...this.b.values()].find(I=>I.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,I){const F=this.n(P),T=(0,A.$9f)(P)?P:I?.id??(0,R.$kj)(F.toString()).toString(16);let z=this.b.get(F)?.logger;const M=I?.logLevel==="always"?l.Trace:I?.logLevel;z||(z=this.s(F,M??this.getLogLevel(F)??this.h,{...I,id:T}));const j={logger:z,info:{resource:F,id:T,logLevel:M,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(j.info),this.b.set(F,j),z}n(P){return(0,A.$9f)(P)?(0,k.$0g)(this.j,`${P}.log`):P}setLogLevel(P,I){if(C.URI.isUri(P)){const F=P,T=I,z=this.b.get(F);z&&T!==z.info.logLevel&&(z.info.logLevel=T===this.h?void 0:T,z.logger?.setLevel(T),this.b.set(z.info.resource,z),this.f.fire([F,T]))}else{this.h=P;for(const[F,T]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,I){const F=this.m(P);F&&I!==!F.info.hidden&&(F.info.hidden=!I,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,I]))}getLogLevel(P){let I;return P&&(I=this.b.get(P)?.info.logLevel),I??this.h}registerLogger(P){const I=this.b.get(P.resource);I?I.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const I=this.b.get(P);I&&(I.logger&&I.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bk=a;class f{constructor(){this.onDidChangeLogLevel=new L.$de().event}setLevel(P){}getLevel(){return l.Info}trace(P,...I){}debug(P,...I){}info(P,...I){}warn(P,...I){}error(P,...I){}critical(P,...I){}dispose(){}flush(){}}e.$ck=f;class g extends f{}e.$dk=g;function w(D){if(D.verbose)return l.Trace;if(typeof D.logLevel=="string"){const P=E(D.logLevel.toLowerCase());if(P!==void 0)return P}return e.$6j}function S(D){switch(D){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Off:return"off"}}function m(D){switch(D){case l.Trace:return{original:"Trace",value:d.localize(0,null)};case l.Debug:return{original:"Debug",value:d.localize(1,null)};case l.Info:return{original:"Info",value:d.localize(2,null)};case l.Warning:return{original:"Warning",value:d.localize(3,null)};case l.Error:return{original:"Error",value:d.localize(4,null)};case l.Off:return{original:"Off",value:d.localize(5,null)}}}function E(D){switch(D){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Error;case"off":return l.Off}}e.$ik=new p.$Nj("logLevel",S(l.Info))}),define(Se[264],De([1,0,19,7,13,4,31,3,17,65,11]),function(he,e,d,O,L,R,N,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class C extends b.$Uc{constructor(y,v){super(),this.a=y,this.b=v,this.c=this.B(new R.$de),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$de),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$uh(0)),this.w=[],this.y=this.B(new O.$uh(0))}watch(y,v){return v.recursive||this.b?.watcher?.forceUniversal?this.n(y,v):this.z(y,v)}n(y,v){const h={path:this.J(y),excludes:v.excludes,includes:v.includes,recursive:v.recursive,filter:v.filter,correlationId:v.correlationId},l=(0,d.$Tb)(this.j,h);return this.r(),(0,b.$Sc)(()=>{l(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,L.$1)(y))}s(){this.h||(this.h=this.B(this.t(v=>this.c.fire((0,k.$Oq)(v)),v=>this.G(v),this.a.getLevel()===A.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===A.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const v of this.j)(0,k.$Kq)(v)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const v of this.j)(0,k.$Kq)(v)&&y.includes(v.path)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,v){const h={path:this.J(y),excludes:v.excludes,includes:v.includes,recursive:!1,filter:v.filter,correlationId:v.correlationId},l=(0,d.$Tb)(this.w,h);return this.C(),(0,b.$Sc)(()=>{l(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,L.$1)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,k.$Oq)(y)),y=>this.G(y),this.a.getLevel()===A.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===A.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.H(y)}H(y){this.a[y.type](y.message)}I(y){return(0,$.$hc)(y.fsPath)}J(y){const v=this.I(y);return(0,N.$yg)(v)}}e.$Uq=C}),define(Se[265],De([1,0,53,402,7,27,21,4,31,3,17,12,23,98,32,217,33,257,264,47,262,261]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n,i,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0,(()=>{try{(0,O.gracefulify)(d)}catch(c){console.error(`Error enabling graceful-fs: ${(0,i.$hj)(c)}`)}})();class t extends n.$Uq{static{this.L=!1}constructor(r,a){super(r,a),this.onDidChangeCapabilities=b.Event.None,this.P=new R.$Ac(f=>p.$1g.getComparisonKey(f)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,C.$k&&(this.M|=1024)),this.M}async stat(r){try{const{stat:a,symbolicLink:f}=await v.SymlinkSupport.stat(this.I(r));return{type:this.O(a,f),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size,permissions:a.mode&128?void 0:l.FilePermission.Locked}}catch(a){throw this.hb(a)}}async N(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const a=await v.Promises.readdir(this.I(r),{withFileTypes:!0}),f=[];return await Promise.all(a.map(async g=>{try{let w;g.isSymbolicLink()?w=(await this.stat((0,p.$0g)(r,g.name))).type:w=this.O(g),f.push([g.name,w])}catch(w){this.a.trace(w)}})),f}catch(a){throw this.hb(a)}}O(r,a){let f;return a?.dangling?f=l.FileType.Unknown:r.isFile()?f=l.FileType.File:r.isDirectory()?f=l.FileType.Directory:f=l.FileType.Unknown,a&&(f|=l.FileType.SymbolicLink),f}async Q(r){const a=this.I(r);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let f;for(;f=this.P.get(r);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await f.wait();const g=new L.$vh;return this.P.set(r,g),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,k.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.P.get(r)===g&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.P.delete(r)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),g.open()})}async readFile(r,a){let f;try{a?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(r)})`),f=await this.Q(r));const g=this.I(r);return await v.Promises.readFile(g)}catch(g){throw this.hb(g)}finally{f?.dispose()}}R(r){t.L&&this.a.trace(r)}readFileStream(r,a,f){const g=(0,y.$te)(w=>N.$Fe.concat(w.map(S=>N.$Fe.wrap(S))).buffer);return(0,o.$Hq)(this,r,g,w=>w.buffer,{...a,bufferSize:256*1024},f),g}async writeFile(r,a,f){return f?.atomic!==!1&&f?.atomic?.postfix&&await this.S(r)?this.U(r,(0,p.$0g)((0,p.$9g)(r),`${(0,p.$7g)(r)}${f.atomic.postfix}`),a,f):this.W(r,a,f)}async S(r){try{const a=this.I(r),{symbolicLink:f}=await v.SymlinkSupport.stat(a);if(f)return!1}catch{}return!0}async U(r,a,f,g){const w=new k.$Tc;try{w.add(await this.Q(r)),w.add(await this.Q(a)),await this.W(a,f,g,!0);try{await this.rename(a,r,{overwrite:!0})}catch(S){try{await this.delete(a,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{w.dispose()}}async W(r,a,f,g){let w;try{const S=this.I(r);if(!f.create||!f.overwrite){if(await v.Promises.exists(S)){if(!f.overwrite)throw(0,l.$dl)((0,h.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!f.create)throw(0,l.$dl)((0,h.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(r,{create:!0,unlock:f.unlock},g),await this.write(w,0,a,0,a.byteLength)}catch(S){throw await this.ib(r,S)}finally{typeof w=="number"&&await this.close(w)}}static{this.$=!0}static configureFlushOnWrite(r){t.$=r}async open(r,a,f){const g=this.I(r);let w;(0,l.$4k)(a)&&!f&&(w=await this.Q(r));let S;try{if((0,l.$4k)(a)&&a.unlock)try{const{stat:E}=await v.SymlinkSupport.stat(g);E.mode&128||await v.Promises.chmod(g,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let m;if((0,l.$4k)(a)){if(C.$i)try{await v.Promises.truncate(g,0),m="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}m||(m="w")}else m="r";S=await v.Promises.open(g,m)}catch(m){throw w?.dispose(),(0,l.$4k)(a)?await this.ib(r,m):this.hb(m)}if(this.X.set(S,0),(0,l.$4k)(a)&&this.Z.set(S,r),w){const m=this.Y.get(S);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${g})`),this.Y.set(S,w),m&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${g})`),m.dispose())}return S}async close(r){const a=this.Y.get(r);try{if(this.X.delete(r),this.Z.delete(r)&&t.$)try{await v.Promises.fdatasync(r)}catch(f){t.configureFlushOnWrite(!1),this.a.error(f)}return await v.Promises.close(r)}catch(f){throw this.hb(f)}finally{a&&(this.Y.get(r)===a&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.Y.delete(r)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),a.dispose())}}async read(r,a,f,g,w){const S=this.ab(r,a);let m=null;try{m=(await v.Promises.read(r,f,g,w,S)).bytesRead}catch(E){throw this.hb(E)}finally{this.bb(r,S,m)}return m}ab(r,a){return a===this.X.get(r)?null:a}bb(r,a,f){const g=this.X.get(r);typeof g=="number"&&(typeof a=="number"||(typeof f=="number"?this.X.set(r,g+f):this.X.delete(r)))}async write(r,a,f,g,w){return(0,L.$Qh)(()=>this.cb(r,a,f,g,w),100,3)}async cb(r,a,f,g,w){const S=this.ab(r,a);let m=null;try{m=(await v.Promises.write(r,f,g,w,S)).bytesWritten}catch(E){throw await this.ib(this.Z.get(r),E)}finally{this.bb(r,S,m)}return m}async mkdir(r){try{await v.Promises.mkdir(this.I(r))}catch(a){throw this.hb(a)}}async delete(r,a){try{const f=this.I(r);if(a.recursive){let g;a?.atomic!==!1&&a.atomic.postfix&&(g=(0,A.$jc)((0,A.$mc)(f),`${(0,A.$nc)(f)}${a.atomic.postfix}`)),await v.Promises.rm(f,v.RimRafMode.MOVE,g)}else try{await v.Promises.unlink(f)}catch(g){if(g.code==="EPERM"||g.code==="EISDIR"){let w=!1;try{const{stat:S,symbolicLink:m}=await v.SymlinkSupport.stat(f);w=S.isDirectory()&&!m}catch{}if(w)await v.Promises.rmdir(f);else throw g}else throw g}}catch(f){throw this.hb(f)}}async rename(r,a,f){const g=this.I(r),w=this.I(a);if(g!==w)try{await this.db(r,a,"move",f.overwrite),await v.Promises.rename(g,w)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,h.localize)(2,null,(0,A.$nc)(g),(0,A.$nc)((0,A.$mc)(w)),S.toString()))),this.hb(S)}}async copy(r,a,f){const g=this.I(r),w=this.I(a);if(g!==w)try{await this.db(r,a,"copy",f.overwrite),await v.Promises.copy(g,w,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,h.localize)(3,null,(0,A.$nc)(g),(0,A.$nc)((0,A.$mc)(w)),S.toString()))),this.hb(S)}}async db(r,a,f,g){const w=this.I(r),S=this.I(a);let m=!1;if(!!(this.capabilities&1024)||(m=(0,$.$ug)(w,S,!0)),m){if(f==="copy")throw(0,l.$dl)((0,h.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(f==="move")return}const D=await this.N(r);if(!D)throw(0,l.$dl)((0,h.localize)(5,null),l.FileSystemProviderErrorCode.FileNotFound);const P=await this.N(a);if(P){if(!g)throw(0,l.$dl)((0,h.localize)(6,null),l.FileSystemProviderErrorCode.FileExists);D.type&l.FileType.File&&P.type&l.FileType.File||await this.delete(a,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,a){return this.eb(r,a,!1)}async eb(r,a,f){const g=this.I(r),w=this.I(a),S=!!(this.capabilities&1024);if((0,$.$ug)(g,w,!S))return;const m=new k.$Tc;try{m.add(await this.Q(r)),m.add(await this.Q(a)),f&&await v.Promises.mkdir((0,A.$mc)(w),{recursive:!0}),await v.Promises.copyFile(g,w)}catch(E){if(E.code==="ENOENT"&&!f)return this.eb(r,a,!0);throw this.hb(E)}finally{m.dispose()}}t(r,a,f){return new u.$2q(g=>r(g),g=>a(g),f)}F(r,a,f){return new s.$$q(g=>r(g),g=>a(g),f)}hb(r){if(r instanceof l.$cl)return r;let a=r,f;switch(r.code){case"ENOENT":f=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":f=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":f=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":f=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":f=l.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":a=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,f=l.FileSystemProviderErrorCode.Unknown;break;default:f=l.FileSystemProviderErrorCode.Unknown}return(0,l.$dl)(a,f)}async ib(r,a){let f=this.hb(a);if(r&&f.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:g}=await v.SymlinkSupport.stat(this.I(r));g.mode&128||(f=(0,l.$dl)(a,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(g){this.a.trace(g)}return f}}e.$_q=t}),define(Se[266],De([1,0,3,11]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZQ=void 0;class L extends d.$Uc{constructor(N,b=[]){super(),this.a=new O.$ak([N,...b]),this.B(N.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...b){this.a.trace(N,...b)}debug(N,...b){this.a.debug(N,...b)}info(N,...b){this.a.info(N,...b)}warn(N,...b){this.a.warn(N,...b)}error(N,...b){this.a.error(N,...b)}flush(){this.a.flush()}}e.$ZQ=L}),define(Se[267],De([1,0,33,11]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OQ=void 0;var L;(function(k){k[k.Trace=0]="Trace",k[k.Debug=1]="Debug",k[k.Info=2]="Info",k[k.Warning=3]="Warning",k[k.Error=4]="Error",k[k.Critical=5]="Critical",k[k.Off=6]="Off"})(L||(L={}));async function R(k,A,C,p,y){try{const v=await new Promise((l,o)=>{he(["@vscode/spdlog"],l,o)});v.setFlushOn(L.Trace);const h=await v.createAsyncRotatingLogger(k,A,C,p);return y?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(v){console.error(v)}return null}function N(k,A,C){switch(A){case O.LogLevel.Trace:k.trace(C);break;case O.LogLevel.Debug:k.debug(C);break;case O.LogLevel.Info:k.info(C);break;case O.LogLevel.Warning:k.warn(C);break;case O.LogLevel.Error:k.error(C);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function b(k,A){switch(A){case O.LogLevel.Trace:k.setLevel(L.Trace);break;case O.LogLevel.Debug:k.setLevel(L.Debug);break;case O.LogLevel.Info:k.setLevel(L.Info);break;case O.LogLevel.Warning:k.setLevel(L.Warning);break;case O.LogLevel.Error:k.setLevel(L.Error);break;case O.LogLevel.Off:k.setLevel(L.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class $ extends O.$9j{constructor(A,C,p,y,v){super(),this.m=[],this.setLevel(v),this.n=this.s(A,C,p,y),this.B(this.onDidChangeLogLevel(h=>{this.r&&b(this.r,h)}))}async s(A,C,p,y){const v=p?6:1,h=30/v*d.$yl.MB,l=await R(A,C,h,v,y);if(l){this.r=l,b(this.r,this.getLevel());for(const{level:o,message:n}of this.m)N(this.r,o,n);this.m=[]}}g(A,C){this.r?N(this.r,A,C):this.getLevel()<=A&&this.m.push({level:A,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$OQ=$}),define(Se[139],De([1,0,41,219,5]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7t=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var N;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(N||(e.MarkerSeverity=N={})),function($){function k(v,h){return h-v}$.compare=k;const A=Object.create(null);A[$.Error]=(0,O.localize)(0,null),A[$.Warning]=(0,O.localize)(1,null),A[$.Info]=(0,O.localize)(2,null);function C(v){return A[v]||""}$.toString=C;function p(v){switch(v){case d.default.Error:return $.Error;case d.default.Warning:return $.Warning;case d.default.Info:return $.Info;case d.default.Ignore:return $.Hint}}$.fromSeverity=p;function y(v){switch(v){case $.Error:return d.default.Error;case $.Warning:return d.default.Warning;case $.Info:return d.default.Info;case $.Hint:return d.default.Ignore}}$.toSeverity=y}(N||(e.MarkerSeverity=N={}));var b;(function($){const k="";function A(p){return C(p,!0)}$.makeKey=A;function C(p,y){const v=[k];return p.source?v.push(p.source.replace("\xA6","\\\xA6")):v.push(k),p.code?typeof p.code=="string"?v.push(p.code.replace("\xA6","\\\xA6")):v.push(p.code.value.replace("\xA6","\\\xA6")):v.push(k),p.severity!==void 0&&p.severity!==null?v.push(N.toString(p.severity)):v.push(k),p.message&&y?v.push(p.message.replace("\xA6","\\\xA6")):v.push(k),p.startLineNumber!==void 0&&p.startLineNumber!==null?v.push(p.startLineNumber.toString()):v.push(k),p.startColumn!==void 0&&p.startColumn!==null?v.push(p.startColumn.toString()):v.push(k),p.endLineNumber!==void 0&&p.endLineNumber!==null?v.push(p.endLineNumber.toString()):v.push(k),p.endColumn!==void 0&&p.endColumn!==null?v.push(p.endColumn.toString()):v.push(k),v.push(k),v.join("\xA6")}$.makeKeyOptionalMessage=C})(b||(e.IMarkerData=b={})),e.$7t=(0,L.$wi)("markerService")}),define(Se[268],De([1,0,4,41,5]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$0v=e.Severity=void 0,e.$$v=b,e.Severity=O.default,e.$0v=(0,L.$wi)("notificationService");var R;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var N;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(N||(e.NeverShowAgainScope=N={}));function b(C){if(C){const p=C;return typeof p.id=="string"&&typeof p.label=="string"}return!1}var $;(function(C){C[C.OFF=0]="OFF",C[C.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class k{constructor(){this.progress=new A,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity(p){}updateMessage(p){}updateActions(p){}close(){}}e.$_v=k;class A{infinite(){}done(){}total(p){}worked(p){}}e.$aw=A}),define(Se[269],De([1,0,52]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const R=L.context.configuration();if(R)O=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(O=globalThis._VSCODE_PRODUCT_JSON,d.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`,serverDataFolderName:O.serverDataFolderName?`${O.serverDataFolderName}-dev`:void 0}),!O.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(O,{version:R.version})}}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=O}),define(Se[108],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$jk=(0,d.$wi)("productService"),e.$kk="vscode://schemas/vscode-product"});var We=this&&this.__param||function(he,e){return function(d,O){e(d,O,he)}};define(Se[109],De([1,0,7,22,3,5]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.ProgressLocation=e.$bw=void 0,e.$bw=(0,R.$wi)("progressService");var N;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(N||(e.ProgressLocation=N={})),e.$cw=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(p){this.b=p}report(p){this.a=p,this.b(this.a)}}e.$dw=b;class ${get value(){return this.a}constructor(p){this.e=p}report(p){this.b?this.b.push(p):this.b=[p],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const p=this.b.shift();this.a=p,await this.e(this.a)}}finally{this.c=!1;const p=this.d;this.d=void 0,p?.()}}drain(){return this.c?new Promise(p=>{const y=this.d;this.d=()=>{y?.(),p()}}):Promise.resolve()}}e.$ew=$;let k=class extends L.$Uc{constructor(p,y){super(),this.a=new d.$Th,y.withProgress(p,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,L.$Sc)(()=>this.a.complete()))}report(p){this.b?this.b.report(p):this.c=p}};e.$fw=k,e.$fw=k=Ge([We(1,e.$bw)],k);class A extends L.$Uc{constructor(p){super(),this.g=p,this.a=0,this.b=this.B(new L.$Tc)}start(p){this.stop();const y=++this.a,v=new O.$oe;return this.f=setTimeout(()=>{y===this.a&&(this.c=this.g.show(!0))},p),this.b.add((0,L.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,L.$Sc)(()=>v.cancel())),this.b.add((0,L.$Sc)(()=>this.c?this.c.done():void 0)),{id:y,token:v.token,stop:()=>this.h(y),isCurrent:()=>this.a===y}}stop(){this.h(this.a)}h(p){this.a===p&&this.b.clear()}}e.$gw=A,e.$hw=(0,R.$wi)("editorProgressService")}),define(Se[36],De([1,0,62,18]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class L{constructor(){this.a=new Map}add(N,b){d.ok(O.$9f(N)),d.ok(O.$$f(b)),d.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,b)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.$co=new L}),define(Se[110],De([1,0,4,36]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=void 0,e.$do={JSONContribution:"base.contributions.json"};function L(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class R{constructor(){this.b=new d.$de,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,k){this.a[L($)]=k,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const N=new R;O.$co.add(e.$do.JSONContribution,N)}),define(Se[66],De([1,0,19,4,18,208,55,110,36]),function(he,e,d,O,L,R,N,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.ConfigurationScope=e.$ho=e.EditPresentationTypes=void 0,e.$so=h,e.$to=l,e.$uo=o,e.$vo=i,e.$wo=u;var k;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$ho={Configuration:"base.contributions.configuration"};var A;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo="vscode://schemas/settings/resourceLanguage",e.$po="vscode://schemas/settings/configurationDefaults";const C=$.$co.as(b.$do.JSONContribution);class p{constructor(){this.h=new Set,this.i=new O.$de,this.onDidSchemaChange=this.i.event,this.j=new O.$de,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$oo,this.g),this.v()}registerConfiguration(t,c=!0){this.registerConfigurations([t],c)}registerConfigurations(t,c=!0){const r=new Set;this.n(t,c,r),C.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const c=new Set;this.o(t,c),C.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:t,remove:c}){const r=new Set;this.o(c,r),this.n(t,!1,r),C.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const c=new Set;this.k(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(t,c){const r=[];for(const{overrides:a,source:f}of t)for(const g in a)if(c.add(g),e.$ro.test(g)){const w=this.a.get(g),S=w?.valuesSources??new Map;if(f)for(const P of Object.keys(a[g]))S.set(P,f);const m={...w?.value||{},...a[g]};this.a.set(g,{source:f,value:m,valuesSources:S});const E=(0,N.$aj)(g),D={type:"object",default:m,description:R.localize(1,null,E),$ref:e.$oo,defaultDefaultValue:m,source:L.$9f(f)?void 0:f,defaultValueSource:f};r.push(...h(g)),this.d[g]=D,this.b.properties[g]=D}else{this.a.set(g,{value:a[g],source:f});const w=this.d[g];w&&(this.w(g,w),this.r(g,w))}this.m(r)}deregisterDefaultConfigurations(t){const c=new Set;this.l(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(t,c){for(const{overrides:r,source:a}of t)for(const f in r){const g=this.a.get(f),w=L.$9f(a)?a:a?.id,S=L.$9f(g?.source)?g?.source:g?.source?.id;if(w===S)if(c.add(f),this.a.delete(f),e.$ro.test(f))delete this.d[f],delete this.b.properties[f];else{const m=this.d[f];m&&(this.w(f,m),this.r(f,m))}}this.u()}deltaConfiguration(t){let c=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),c=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),c=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const c of t)this.h.add(c);this.u()}n(t,c,r){t.forEach(a=>{this.p(a,c,a.extensionInfo,a.restrictedProperties,void 0,r),this.c.push(a),this.q(a)})}o(t,c){const r=a=>{if(a.properties)for(const f in a.properties){c.add(f);const g=this.d[f];g?.policy?.name&&this.e.delete(g.policy.name),delete this.d[f],this.s(f,a.properties[f])}a.allOf?.forEach(f=>r(f))};for(const a of t){r(a);const f=this.c.indexOf(a);f!==-1&&this.c.splice(f,1)}}p(t,c=!0,r,a,f=3,g){f=L.$fg(t.scope)?f:t.scope;const w=t.properties;if(w)for(const m in w){const E=w[m];if(c&&i(m,E)){delete w[m];continue}if(E.source=r,E.defaultDefaultValue=w[m].default,this.w(m,E),e.$ro.test(m)?E.scope=void 0:(E.scope=L.$fg(E.scope)?f:E.scope,E.restricted=L.$fg(E.restricted)?!!a?.includes(m):E.restricted),w[m].hasOwnProperty("included")&&!w[m].included){this.f[m]=w[m],delete w[m];continue}else this.d[m]=w[m],w[m].policy?.name&&this.e.set(w[m].policy.name,m);!w[m].deprecationMessage&&w[m].markdownDeprecationMessage&&(w[m].deprecationMessage=w[m].markdownDeprecationMessage),g.add(m)}const S=t.allOf;if(S)for(const m of S)this.p(m,c,r,a,f,g)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const c=r=>{const a=r.properties;if(a)for(const g in a)this.r(g,a[g]);r.allOf?.forEach(c)};c(t)}r(t,c){switch(e.$io.properties[t]=c,c.scope){case 1:e.$jo.properties[t]=c;break;case 2:e.$ko.properties[t]=c;break;case 6:e.$lo.properties[t]=c;break;case 3:e.$mo.properties[t]=c;break;case 4:e.$no.properties[t]=c;break;case 5:e.$no.properties[t]=c,this.g.properties[t]=c;break}}s(t,c){switch(delete e.$io.properties[t],c.scope){case 1:delete e.$jo.properties[t];break;case 2:delete e.$ko.properties[t];break;case 6:delete e.$lo.properties[t];break;case 3:delete e.$mo.properties[t];break;case 4:case 5:delete e.$no.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const c=`[${t}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$oo};this.w(c,r),e.$io.properties[c]=r,e.$jo.properties[c]=r,e.$ko.properties[c]=r,e.$lo.properties[c]=r,e.$mo.properties[c]=r,e.$no.properties[c]=r}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$oo};e.$io.patternProperties[e.$qo]=t,e.$jo.patternProperties[e.$qo]=t,e.$ko.patternProperties[e.$qo]=t,e.$lo.patternProperties[e.$qo]=t,e.$mo.patternProperties[e.$qo]=t,e.$no.patternProperties[e.$qo]=t,this.i.fire()}w(t,c){const r=this.a.get(t);let a=r?.value,f=r?.source;L.$dg(a)&&(a=c.defaultDefaultValue,f=void 0),L.$dg(a)&&(a=o(c.type)),c.default=a,c.defaultValueSource=f}}const y="\\[([^\\]]+)\\]",v=new RegExp(y,"g");e.$qo=`^(${y})+$`,e.$ro=new RegExp(e.$qo);function h(s){const t=[];if(e.$ro.test(s)){let c=v.exec(s);for(;c?.length;){const r=c[1].trim();r&&t.push(r),c=v.exec(s)}}return(0,d.$Mb)(t)}function l(s){return s.reduce((t,c)=>`${t}[${c}]`,"")}function o(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new p;$.$co.add(e.$ho.Configuration,n);function i(s,t){return s.trim()?e.$ro.test(s)?R.localize(7,null,s):n.getConfigurationProperties()[s]!==void 0?R.localize(8,null,s):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,s,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function u(){const s=[],t=n.getConfigurationProperties();for(const c of Object.keys(t))s.push([c,t[c].scope]);return s.push(["launch",4]),s.push(["task",4]),s}}),define(Se[270],De([1,0,19,4,166,3,27,24,18,2,55,66,36]),function(he,e,d,O,L,R,N,b,$,k,A,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Ao=e.$zo=e.$yo=e.$xo=void 0,e.$Bo=i;function y(c){return Object.isFrozen(c)?c:b.$4n(c)}class v{static createEmptyModel(r){return new v({},[],[],void 0,r)}constructor(r,a,f,g,w){this.b=r,this.c=a,this.d=f,this.raw=g,this.f=w,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(a=>{if(a instanceof v)return a;const f=new h("",this.f);return f.parseRaw(a),f.configurationModel});this.g=r.reduce((a,f)=>f===a?f:a.merge(f),r[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,A.$$i)(this.contents,r):this.contents}inspect(r,a){const f=this;return{get value(){return y(f.rawConfiguration.getValue(r))},get override(){return a?y(f.rawConfiguration.getOverrideValue(r,a)):void 0},get merged(){return y(a?f.rawConfiguration.override(a).getValue(r):f.rawConfiguration.getValue(r))},get overrides(){const g=[];for(const{contents:w,identifiers:S,keys:m}of f.rawConfiguration.overrides){const E=new v(w,m,[],void 0,f.f).getValue(r);E!==void 0&&g.push({identifiers:S,value:E})}return g.length?y(g):void 0}}}getOverrideValue(r,a){const f=this.j(a);return f?r?(0,A.$$i)(f,r):f:void 0}getKeysForOverrideIdentifier(r){const a=[];for(const f of this.overrides)f.identifiers.includes(r)&&a.push(...f.keys);return d.$Mb(a)}getAllOverrideIdentifiers(){const r=[];for(const a of this.overrides)r.push(...a.identifiers);return d.$Mb(r)}override(r){let a=this.a.get(r);return a||(a=this.h(r),this.a.set(r,a)),a}merge(...r){const a=b.$3n(this.contents),f=b.$3n(this.overrides),g=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const S of r)if(w.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.i(a,S.contents);for(const m of S.overrides){const[E]=f.filter(D=>d.$ub(D.identifiers,m.identifiers));E?(this.i(E.contents,m.contents),E.keys.push(...m.keys),E.keys=d.$Mb(E.keys)):f.push(b.$3n(m))}for(const m of S.keys)g.indexOf(m)===-1&&g.push(m)}return new v(a,g,f,w.every(S=>S instanceof v)?void 0:w,this.f)}h(r){const a=this.j(r);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const f={};for(const g of d.$Mb([...Object.keys(this.contents),...Object.keys(a)])){let w=this.contents[g];const S=a[g];S&&(typeof w=="object"&&typeof S=="object"?(w=b.$3n(w),this.i(w,S)):w=S),f[g]=w}return new v(f,this.keys,this.overrides,void 0,this.f)}i(r,a){for(const f of Object.keys(a)){if(f in r&&$.$$f(r[f])&&$.$$f(a[f])){this.i(r[f],a[f]);continue}r[f]=b.$3n(a[f])}}j(r){let a=null,f=null;const g=w=>{w&&(f?this.i(f,w):f=b.$3n(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===r?a=w.contents:w.identifiers.includes(r)&&g(w.contents);return g(a),f}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,a){this.k(r,a,!0)}setValue(r,a){this.k(r,a,!1)}removeValue(r){const a=this.keys.indexOf(r);a!==-1&&(this.keys.splice(a,1),(0,A.$0i)(this.contents,r),C.$ro.test(r)&&this.overrides.splice(this.overrides.findIndex(f=>d.$ub(f.identifiers,(0,C.$so)(r))),1))}k(r,a,f){(0,A.$9i)(this.contents,r,a,g=>this.f.error(g)),f=f||this.keys.indexOf(r)===-1,f&&this.keys.push(r),C.$ro.test(r)&&this.overrides.push({identifiers:(0,C.$so)(r),keys:Object.keys(this.contents[r]),contents:(0,A.$8i)(this.contents[r],g=>this.f.error(g))})}}e.$xo=v;class h{constructor(r,a){this.f=r,this.g=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||v.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,a){if(!$.$fg(r)){const f=this.h(r);this.parseRaw(f,a)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,a){this.a=r;const{contents:f,keys:g,overrides:w,restricted:S,hasExcludedProperties:m}=this.i(r,a);this.b=new v(f,g,w,m?[r]:void 0,this.g),this.c=S||[]}h(r){let a={},f=null,g=[];const w=[],S=[];function m(D){Array.isArray(g)?g.push(D):f!==null&&(g[f]=D)}const E={onObjectBegin:()=>{const D={};m(D),w.push(g),g=D,f=null},onObjectProperty:D=>{f=D},onObjectEnd:()=>{g=w.pop()},onArrayBegin:()=>{const D=[];m(D),w.push(g),g=D,f=null},onArrayEnd:()=>{g=w.pop()},onLiteralValue:m,onError:(D,P,I)=>{S.push({error:D,offset:P,length:I})}};if(r)try{L.$Qn(r,E),a=g[0]||{}}catch(D){this.g.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return a}i(r,a){const f=p.$co.as(C.$ho.Configuration).getConfigurationProperties(),g=this.j(r,f,!0,a);r=g.raw;const w=(0,A.$8i)(r,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`)),S=Object.keys(r),m=this.l(r,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:w,keys:S,overrides:m,restricted:g.restricted,hasExcludedProperties:g.hasExcludedProperties}}j(r,a,f,g){let w=!1;if(!g?.scopes&&!g?.skipRestricted&&!g?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:w};const S={},m=[];for(const E in r)if(C.$ro.test(E)&&f){const D=this.j(r[E],a,!1,g);S[E]=D.raw,w=w||D.hasExcludedProperties,m.push(...D.restricted)}else{const D=a[E],P=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&m.push(E),!g.exclude?.includes(E)&&(g.include?.includes(E)||(P===void 0||g.scopes===void 0||g.scopes.includes(P))&&!(g.skipRestricted&&D?.restricted))?S[E]=r[E]:w=!0}return{raw:S,restricted:m,hasExcludedProperties:w}}l(r,a){const f=[];for(const g of Object.keys(r))if(C.$ro.test(g)){const w={};for(const S in r[g])w[S]=r[g][S];f.push({identifiers:(0,C.$so)(g),keys:Object.keys(w),contents:(0,A.$8i)(w,a)})}return f}}e.$yo=h;class l extends R.$Uc{constructor(r,a,f,g,w){super(),this.c=r,this.f=a,this.g=g,this.h=w,this.b=this.B(new O.$de),this.onDidChange=this.b.event,this.a=new h(this.c.toString(),w),this.B(this.g.watch(f.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&f.isEqual(S.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return v.createEmptyModel(this.h)}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$zo=l;class o{constructor(r,a,f,g,w,S,m,E,D,P,I,F,T){this.a=r,this.b=a,this.c=f,this.overrideIdentifiers=g,this.d=w,this.f=S,this.g=m,this.h=E,this.i=D,this.j=P,this.k=I,this.l=F,this.m=T}get value(){return y(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(r,a,f,g,w,S,m,E,D,P){this.j=r,this.l=a,this.m=f,this.n=g,this.p=w,this.q=S,this.r=m,this.s=E,this.t=D,this.u=P,this.h=null,this.i=new N.$Ac,this.v=null}getValue(r,a,f){return this.w(r,a,f).getValue(r)}updateValue(r,a,f={}){let g;f.resource?(g=this.t.get(f.resource),g||(g=v.createEmptyModel(this.u),this.t.set(f.resource,g))):g=this.s,a===void 0?g.removeValue(r):g.setValue(r,a),f.resource||(this.h=null)}inspect(r,a,f){const g=this.w(r,a,f),w=this.A(a.resource,f),S=a.resource?this.t.get(a.resource)||this.s:this.s,m=new Set;for(const E of g.overrides)for(const D of E.identifiers)g.getOverrideValue(r,D)!==void 0&&m.add(D);return new o(r,a,g.getValue(r),m.size?[...m]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,f?this.q:void 0,w||void 0,S)}keys(r){const a=this.A(void 0,r);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(r){this.j=r,this.h=null,this.i.clear()}updatePolicyConfiguration(r){this.l=r}updateApplicationConfiguration(r){this.m=r,this.h=null,this.i.clear()}updateLocalUserConfiguration(r){this.n=r,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(r){this.p=r,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(r){this.q=r,this.h=null,this.i.clear()}updateFolderConfiguration(r,a){this.r.set(r,a),this.i.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.i.delete(r)}compareAndUpdateDefaultConfiguration(r,a){const f=[];if(!a){const{added:g,updated:w,removed:S}=s(this.j,r);a=[...g,...w,...S]}for(const g of a)for(const w of(0,C.$so)(g)){const S=this.j.getKeysForOverrideIdentifier(w),m=r.getKeysForOverrideIdentifier(w),E=[...m.filter(D=>S.indexOf(D)===-1),...S.filter(D=>m.indexOf(D)===-1),...S.filter(D=>!b.$7n(this.j.override(w).getValue(D),r.override(w).getValue(D)))];f.push([w,E])}return this.updateDefaultConfiguration(r),{keys:a,overrides:f}}compareAndUpdatePolicyConfiguration(r){const{added:a,updated:f,removed:g}=s(this.l,r),w=[...a,...f,...g];return w.length&&this.updatePolicyConfiguration(r),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:a,updated:f,removed:g,overrides:w}=s(this.applicationConfiguration,r),S=[...a,...f,...g];return S.length&&this.updateApplicationConfiguration(r),{keys:S,overrides:w}}compareAndUpdateLocalUserConfiguration(r){const{added:a,updated:f,removed:g,overrides:w}=s(this.localUserConfiguration,r),S=[...a,...f,...g];return S.length&&this.updateLocalUserConfiguration(r),{keys:S,overrides:w}}compareAndUpdateRemoteUserConfiguration(r){const{added:a,updated:f,removed:g,overrides:w}=s(this.remoteUserConfiguration,r),S=[...a,...f,...g];return S.length&&this.updateRemoteUserConfiguration(r),{keys:S,overrides:w}}compareAndUpdateWorkspaceConfiguration(r){const{added:a,updated:f,removed:g,overrides:w}=s(this.workspaceConfiguration,r),S=[...a,...f,...g];return S.length&&this.updateWorkspaceConfiguration(r),{keys:S,overrides:w}}compareAndUpdateFolderConfiguration(r,a){const f=this.folderConfigurations.get(r),{added:g,updated:w,removed:S,overrides:m}=s(f,a),E=[...g,...w,...S];return(E.length||!f)&&this.updateFolderConfiguration(r,a),{keys:E,overrides:m}}compareAndDeleteFolderConfiguration(r){const a=this.folderConfigurations.get(r);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:f,updated:g,removed:w,overrides:S}=s(a,void 0);return{keys:[...f,...g,...w],overrides:S}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(r,a,f){let g=this.x(a,f);return a.overrideIdentifier&&(g=g.override(a.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(r)!==void 0&&(g=g.merge(this.l)),g}x({resource:r},a){let f=this.y();if(a&&r){const g=a.getFolder(r);g&&(f=this.z(g.uri)||f);const w=this.t.get(r);w&&(f=f.merge(w))}return f}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(r){let a=this.i.get(r);if(!a){const f=this.y(),g=this.r.get(r);g?(a=f.merge(g),this.i.set(r,a)):a=f}return a}A(r,a){if(a&&r){const f=a.getFolder(r);if(f)return this.r.get(f.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((r,a)=>{const{contents:f,overrides:g,keys:w}=this.r.get(a);return r.push([a,{contents:f,overrides:g,keys:w}]),r},[])}}allKeys(){const r=new Set;return this.j.keys.forEach(a=>r.add(a)),this.userConfiguration.keys.forEach(a=>r.add(a)),this.q.keys.forEach(a=>r.add(a)),this.r.forEach(a=>a.keys.forEach(f=>r.add(f))),[...r.values()]}B(){const r=new Set;return this.j.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.q.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.r.forEach(a=>a.getAllOverrideIdentifiers().forEach(f=>r.add(f))),[...r.values()]}D(r){const a=new Set;return this.j.getKeysForOverrideIdentifier(r).forEach(f=>a.add(f)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(f=>a.add(f)),this.q.getKeysForOverrideIdentifier(r).forEach(f=>a.add(f)),this.r.forEach(f=>f.getKeysForOverrideIdentifier(r).forEach(g=>a.add(g))),[...a.values()]}static parse(r,a){const f=this.E(r.defaults,a),g=this.E(r.policy,a),w=this.E(r.application,a),S=this.E(r.user,a),m=this.E(r.workspace,a),E=r.folders.reduce((D,P)=>(D.set(k.URI.revive(P[0]),this.E(P[1],a)),D),new N.$Ac);return new n(f,g,w,S,v.createEmptyModel(a),m,E,v.createEmptyModel(a),new N.$Ac,a)}static E(r,a){return new v(r.contents,r.keys,r.overrides,void 0,a)}}e.$Ao=n;function i(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const r=new Set,a=new Map;for(const g of c)g.keys.forEach(w=>r.add(w)),g.overrides.forEach(([w,S])=>{const m=(0,N.$xc)(a,w,new Set);S.forEach(E=>m.add(E))});const f=[];return a.forEach((g,w)=>f.push([w,[...g.values()]])),{keys:[...r.values()],overrides:f}}class u{constructor(r,a,f,g,w){this.change=r,this.f=a,this.g=f,this.h=g,this.i=w,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const S of r.keys)this.affectedKeys.add(S);for(const[,S]of r.overrides)for(const m of S)this.affectedKeys.add(m);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(r,a){const f=this.a+r,g=this.d.indexOf(f);if(g<0)return!1;const w=g+f.length;if(w>=this.d.length)return!1;const S=this.d.charCodeAt(w);if(S!==this.b&&S!==this.c)return!1;if(a){const m=this.previousConfiguration?this.previousConfiguration.getValue(r,a,this.f?.workspace):void 0,E=this.g.getValue(r,a,this.h);return!b.$7n(m,E)}return!0}}e.$Co=u;function s(c,r){const{added:a,removed:f,updated:g}=t(r?.rawConfiguration,c?.rawConfiguration),w=[],S=c?.getAllOverrideIdentifiers()||[],m=r?.getAllOverrideIdentifiers()||[];if(r){const E=m.filter(D=>!S.includes(D));for(const D of E)w.push([D,r.getKeysForOverrideIdentifier(D)])}if(c){const E=S.filter(D=>!m.includes(D));for(const D of E)w.push([D,c.getKeysForOverrideIdentifier(D)])}if(r&&c){for(const E of S)if(m.includes(E)){const D=t({contents:c.getOverrideValue(void 0,E)||{},keys:c.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});w.push([E,[...D.added,...D.removed,...D.updated]])}}return{added:a,removed:f,updated:g,overrides:w}}function t(c,r){const a=c?r?c.keys.filter(w=>r.keys.indexOf(w)===-1):[...c.keys]:[],f=r?c?r.keys.filter(w=>c.keys.indexOf(w)===-1):[...r.keys]:[],g=[];if(c&&r){for(const w of r.keys)if(c.keys.indexOf(w)!==-1){const S=(0,A.$$i)(r.contents,w),m=(0,A.$$i)(c.contents,w);b.$7n(S,m)||g.push(w)}}return{added:a,removed:f,updated:g}}}),define(Se[271],De([1,0,21,4,3,83]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nvb=e.$lvb=e.$kvb=void 0,e.$mvb=b;const N=(k,A,C)=>{const p=new Uint8Array(16);for(let h=0;h<16;h++)p[h]=Math.round(Math.random()*256);const y=(0,d.$Ze)(d.$Fe.wrap(p));return[`GET ws://localhost${k}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$kvb=N,e.$lvb=d.$Fe.fromString(`\r
\r
`);async function b(k,A,C,p,y){k.write(d.$Fe.fromString((0,e.$kvb)(A,C,p)));const v=new L.$Tc;try{return await new Promise((h,l)=>{let o;v.add(k.onData(n=>{o?o=d.$Fe.concat([o,n],o.byteLength+n.byteLength):o=n;const i=o.indexOf(e.$lvb);if(i===-1)return;h(k),k.pauseData();const u=o.slice(i+e.$lvb.byteLength);u.byteLength&&y.onData.fire(u)})),v.add(k.onClose(n=>l(n??new Error("socket closed")))),v.add(k.onEnd(()=>l(new Error("socket ended"))))})}catch(h){throw k.dispose(),h}finally{v.dispose()}}class $ extends L.$Uc{constructor(A,C){super(),this.g=A,this.a=this.B(new O.$ge),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new O.$de),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(p=>this.a.fire(p))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,C){R.SocketDiagnostics.traceSocketEvent(this,this.g,A,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$nvb=$}),define(Se[67],De([1,0,13,5]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.RemoteAuthorityResolverErrorCode=e.$Jl=e.$Il=e.RemoteConnectionType=e.$Hl=void 0,e.$Ll=k,e.$Hl=(0,O.$wi)("remoteAuthorityResolverService");var L;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class R{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$Il=R;class N{constructor(C,p){this.host=C,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jl=N;var b;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class $ extends d.$bb{static isNotAvailable(C){return C instanceof $&&C._code===b.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof $&&C._code===b.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof $&&C._code===b.NoResolverFound}static isInvalidAuthority(C){return C instanceof $&&C._code===b.InvalidAuthority}static isHandled(C){return C instanceof $&&C.isHandled}constructor(C,p=b.Unknown,y){super(C),this._message=C,this._code=p,this._detail=y,this.isHandled=p===b.NotAvailable&&y===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Kl=$;function k(A){const C=A.indexOf("+");return C===-1?A:A.substring(0,C)}}),define(Se[272],De([1,0,7,21,22,13,4,3,15,59,40,30,83,67]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ql=S,e.$Rl=m,e.$Sl=D;const v=30*1e3;var h;(function(ee){ee[ee.Management=1]="Management",ee[ee.ExtensionHost=2]="ExtensionHost",ee[ee.Tunnel=3]="Tunnel"})(h||(e.ConnectionType=h={}));function l(ee){switch(ee){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(ee){const B=new L.$oe;return setTimeout(()=>B.cancel(),ee),B.token}function n(ee,B){if(ee.isCancellationRequested||B.isCancellationRequested)return L.CancellationToken.Cancelled;const _=new L.$oe;return ee.onCancellationRequested(()=>_.cancel()),B.onCancellationRequested(()=>_.cancel()),_.token}class i{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new b.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,d.$ph)(),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function u(ee,B){const _=new i(B);return _.registerDisposable(ee.onControlMessage(pe=>{const ue=JSON.parse(pe.toString()),ce=G(ue);ce?_.reject(ce):_.resolve(ue)})),_.promise}function s(ee,B,_,pe,ue,ce,oe,le){const K=new i(le),se=A.$_d.create(!1);return ee.info(`Creating a socket (${oe})...`),k.mark(`code/willCreateSocket/${ce}`),B.connect(_,pe,ue,oe).then($e=>{K.didTimeout?(k.mark(`code/didCreateSocketError/${ce}`),ee.info(`Creating a socket (${oe}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),$e?.dispose()):(k.mark(`code/didCreateSocketOK/${ce}`),ee.info(`Creating a socket (${oe}) was successful after ${se.elapsed()} ms.`),K.resolve($e))},$e=>{k.mark(`code/didCreateSocketError/${ce}`),ee.info(`Creating a socket (${oe}) returned an error after ${se.elapsed()} ms.`),ee.error($e),K.reject($e)}),K.promise}function t(ee,B){const _=new i(B);return ee.then(pe=>{_.didTimeout||_.resolve(pe)},pe=>{_.didTimeout||_.reject(pe)}),_.promise}async function c(ee,B,_,pe){const ue=ae(ee,B);ee.logService.trace(`${ue} 1/6. invoking socketFactory.connect().`);let ce;try{ce=await s(ee.logService,ee.remoteSocketFactoryService,ee.connectTo,$.$Jg.getServerRootPath(),`reconnectionToken=${ee.reconnectionToken}&reconnection=${ee.reconnectionProtocol?"true":"false"}`,l(B),`renderer-${l(B)}-${ee.reconnectionToken}`,pe)}catch($e){throw ee.logService.error(`${ue} socketFactory.connect() failed or timed out. Error:`),ee.logService.error($e),$e}ee.logService.trace(`${ue} 2/6. socketFactory.connect() was successful.`);let oe,le;ee.reconnectionProtocol?(ee.reconnectionProtocol.beginAcceptReconnection(ce,null),oe=ee.reconnectionProtocol,le=!1):(oe=new p.$ki({socket:ce}),le=!0),ee.logService.trace(`${ue} 3/6. sending AuthRequest control message.`);const K=await t(ee.signService.createNewMessage((0,C.$Sg)()),pe),se={type:"auth",auth:ee.connectionToken||"00000000000000000000",data:K.data};oe.sendControl(O.$Fe.fromString(JSON.stringify(se)));try{const $e=await u(oe,n(pe,o(1e4)));if($e.type!=="sign"||typeof $e.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(ee.logService.trace(`${ue} 4/6. received SignRequest control message.`),!await t(ee.signService.validate(K,$e.signedData),pe)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const Re=await t(ee.signService.sign($e.data),pe),ge={type:"connectionType",commit:ee.commit,signedData:Re,desiredConnectionType:B};return _&&(ge.args=_),ee.logService.trace(`${ue} 5/6. sending ConnectionTypeRequest control message.`),oe.sendControl(O.$Fe.fromString(JSON.stringify(ge))),{protocol:oe,ownsProtocol:le}}catch($e){throw $e&&$e.code==="ETIMEDOUT"&&(ee.logService.error(`${ue} the handshake timed out. Error:`),ee.logService.error($e)),$e&&$e.code==="VSCODE_CONNECTION_ERROR"&&(ee.logService.error(`${ue} received error control message when negotiating connection. Error:`),ee.logService.error($e)),le&&q(oe),$e}}async function r(ee,B,_,pe){const ue=Date.now(),ce=ae(ee,B),{protocol:oe,ownsProtocol:le}=await c(ee,B,_,pe),K=new i(pe);return K.registerDisposable(oe.onControlMessage(se=>{const $e=JSON.parse(se.toString()),ve=G($e);ve?(ee.logService.error(`${ce} received error control message when negotiating connection. Error:`),ee.logService.error(ve),le&&q(oe),K.reject(ve)):(ee.reconnectionProtocol?.endAcceptReconnection(),ee.logService.trace(`${ce} 6/6. handshake finished, connection is up and running after ${Ce(ue)}!`),K.resolve({protocol:oe,firstMessage:$e}))})),K.promise}async function a(ee,B){const{protocol:_}=await r(ee,1,void 0,B);return{protocol:_}}async function f(ee,B,_){const{protocol:pe,firstMessage:ue}=await r(ee,2,B,_),ce=ue&&ue.debugPort;return{protocol:pe,debugPort:ce}}async function g(ee,B,_){const pe=Date.now(),ue=ae(ee,3),{protocol:ce}=await c(ee,3,B,_);return ee.logService.trace(`${ue} 6/6. handshake finished, connection is up and running after ${Ce(pe)}!`),ce}async function w(ee,B,_){const{connectTo:pe,connectionToken:ue}=await ee.addressProvider.getAddress();return{commit:ee.commit,quality:ee.quality,connectTo:pe,connectionToken:ue,reconnectionToken:B,reconnectionProtocol:_,remoteSocketFactoryService:ee.remoteSocketFactoryService,signService:ee.signService,logService:ee.logService}}async function S(ee,B,_){return E(ee,async pe=>{const{protocol:ue}=await a(pe,L.CancellationToken.None);return new Z(ee,B,_,pe.reconnectionToken,ue)})}async function m(ee,B){return E(ee,async _=>{const{protocol:pe,debugPort:ue}=await f(_,B,L.CancellationToken.None);return new ie(ee,B,_.reconnectionToken,pe,ue)})}async function E(ee,B){for(let pe=1;;pe++)try{const ue=(0,C.$Sg)(),ce=await w(ee,ue,null);return await B(ce)}catch(ue){if(pe<5)ee.logService.error(`[remote-connection][attempt ${pe}] An error occurred in initial connection! Will retry... Error:`),ee.logService.error(ue);else throw ee.logService.error(`[remote-connection][attempt ${pe}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),ee.logService.error(ue),U.triggerPermanentFailure(0,0,y.$Kl.isHandled(ue)),ue}}async function D(ee,B,_){const pe=await w(ee,(0,C.$Sg)(),null);return await g(pe,{host:B,port:_},L.CancellationToken.None)}function P(ee){return(0,d.$jh)(B=>new Promise((_,pe)=>{const ue=setTimeout(_,ee*1e3);B.onCancellationRequested(()=>{clearTimeout(ue),_()})}))}var I;(function(ee){ee[ee.ConnectionLost=0]="ConnectionLost",ee[ee.ReconnectionWait=1]="ReconnectionWait",ee[ee.ReconnectionRunning=2]="ReconnectionRunning",ee[ee.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",ee[ee.ConnectionGain=4]="ConnectionGain"})(I||(e.PersistentConnectionEventType=I={}));class F{constructor(B,_){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.type=0}}e.$Tl=F;class T{constructor(B,_,pe,ue){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.durationSeconds=pe,this.c=ue,this.type=1}skipWait(){this.c.cancel()}}e.$Ul=T;class z{constructor(B,_,pe){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.attempt=pe,this.type=2}}e.$Vl=z;class M{constructor(B,_,pe){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.attempt=pe,this.type=4}}e.$Wl=M;class j{constructor(B,_,pe,ue){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.attempt=pe,this.handled=ue,this.type=3}}e.$Xl=j;class U extends b.$Uc{static triggerPermanentFailure(B,_,pe){this._permanentFailure=!0,this.f=B,this.g=_,this.h=pe,this.j.forEach(ue=>ue.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||U._permanentFailure}constructor(B,_,pe,ue,ce){super(),this.t=B,this.u=_,this.reconnectionToken=pe,this.protocol=ue,this.w=ce,this.m=this.B(new N.$de),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new M(this.reconnectionToken,0,0)),this.B(ue.onSocketClose(oe=>{const le=be(this.t,this.reconnectionToken,!0);oe?oe.type===0?(this.u.logService.info(`${le} received socket close event (hadError: ${oe.hadError}).`),oe.error&&this.u.logService.error(oe.error)):(this.u.logService.info(`${le} received socket close event (wasClean: ${oe.wasClean}, code: ${oe.code}, reason: ${oe.reason}).`),oe.event&&this.u.logService.error(oe.event)):this.u.logService.info(`${le} received socket close event.`),this.y()})),this.B(ue.onSocketTimeout(oe=>{const le=be(this.t,this.reconnectionToken,!0);this.u.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${oe.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${oe.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${oe.timeSinceLastReceivedSomeData}).`),this.y()})),U.j.push(this),this.B((0,b.$Sc)(()=>{const oe=U.j.indexOf(this);oe>=0&&U.j.splice(oe,1)})),this.n&&this.D(U.f,U.g,U.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=be(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let pe=-1;do{pe++;const ue=pe<_.length?_[pe]:_[_.length-1];try{if(ue>0){const oe=P(ue);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ue,oe)),this.u.logService.info(`${B} waiting for ${ue} seconds before reconnecting...`);try{await oe}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),pe+1)),this.u.logService.info(`${B} resolving connection...`);const ce=await w(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${ce.connectTo}...`),await this.G(ce,o(v)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),pe+1));break}catch(ce){if(ce.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}if(pe>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}if(y.$Kl.isTemporarilyNotAvailable(ce)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ce);continue}if((ce.code==="ETIMEDOUT"||ce.code==="ENETUNREACH"||ce.code==="ECONNREFUSED"||ce.code==="ECONNRESET")&&ce.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ce);continue}if((0,R.$4)(ce)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ce);continue}if(ce instanceof y.$Kl){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,y.$Kl.isHandled(ce));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}}while(!this.n&&!this.s)}C(B,_,pe){this.w?U.triggerPermanentFailure(B,_,pe):this.D(B,_,pe)}D(B,_,pe){this.m.fire(new j(this.reconnectionToken,B,_,pe)),q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Yl=U;class Z extends U{constructor(B,_,pe,ue,ce){super(1,B,ue,ce,!0),this.client=this.B(new p.$ii(ce,{remoteAuthority:_,clientId:pe},B.ipcLogger))}async G(B,_){await a(B,_)}}e.$Zl=Z;class ie extends U{constructor(B,_,pe,ue,ce){super(2,B,pe,ue,!1),this.H=_,this.debugPort=ce}async G(B,_){await f(B,this.H,_)}}e.$1l=ie;function q(ee){try{ee.acceptDisconnect();const B=ee.getSocket();ee.dispose(),B.dispose()}catch(B){(0,R.$1)(B)}}function G(ee){if(ee&&ee.type==="error"){const B=new Error(`Connection error: ${ee.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function x(ee,B){for(;ee.length<B;)ee+=" ";return ee}function ne(ee,B){return`[remote-connection][${x(l(ee),13)}][${B.substr(0,5)}\u2026]`}function be(ee,B,_){return`${ne(ee,B)}[${_?"reconnect":"initial"}]`}function ae(ee,B){return`${be(B,ee.reconnectionToken,!!ee.reconnectionProtocol)}[${ee.connectTo}]`}function Ce(ee){return`${Date.now()-ee} ms`}}),define(Se[86],De([1,0,15]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=O,e.$Im=L,e.$Jm=R,e.$Km=N;function O($){return $.scheme===d.Schemas.vscodeRemote?$.authority:void 0}function L($){if(!$)return;const k=$.indexOf("+");return k<0?$:$.substr(0,k)}function R($){const{host:k,port:A}=b($);if(typeof A>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:k,port:A}}function N($,k){let{host:A,port:C}=b($);return typeof C>"u"&&(C=k),{host:A,port:C}}function b($){const k=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(k)return{host:k[1],port:parseInt(k[2],10)};const A=$.match(/^(\[[0-9a-z:]+\])$/);if(A)return{host:A[1],port:void 0};const C=$.match(/(.*):(\d+)$/);return C?{host:C[1],port:parseInt(C[2],10)}:{host:$,port:void 0}}}),define(Se[25],De([1,0,14,5,86]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Tm=e.$Sm=e.$Rm=e.TargetPlatform=e.ExtensionType=e.$Qm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0,e.$Pm=R,e.$Um=C,e.$Vm=p,e.$Wm=y,e.$Xm=v,e.$Lm="extensions.user.cache",e.$Mm="extensions.builtin.cache",e.$Nm="undefined_publisher",e.$Om=["ui","workspace","web"];function R(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.$Qm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var N;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(N||(e.ExtensionType=N={}));var b;(function(h){h.WIN32_X64="win32-x64",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class ${constructor(l){this.value=l,this._lower=l.toLowerCase()}static equals(l,o){if(typeof l>"u"||l===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof l=="string"||typeof o=="string"){const n=typeof l=="string"?l:l.value,i=typeof o=="string"?o:o.value;return d.$xf(n,i)}return l._lower===o._lower}static toKey(l){return typeof l=="string"?l.toLowerCase():l._lower}}e.$Rm=$;class k{get size(){return this.c.size}constructor(l){if(this.c=new Set,l)for(const o of l)this.add(o)}add(l){this.c.add($.toKey(l))}delete(l){return this.c.delete($.toKey(l))}has(l){return this.c.has($.toKey(l))}}e.$Sm=k;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(l){this.c.delete($.toKey(l))}get(l){return this.c.get($.toKey(l))}has(l){return this.c.has($.toKey(l))}set(l,o){this.c.set($.toKey(l),o)}values(){return this.c.values()}forEach(l){this.c.forEach(l)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Tm=A;function C(h){return p(h)}function p(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}function y(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}function v(h,l){if(l){const o=`onResolveRemoteAuthority:${(0,L.$Im)(l)}`;return!!h.activationEvents?.includes(o)}return!1}e.$Ym=(0,O.$wi)("IBuiltinExtensionsScannerService")}),define(Se[140],De([1,0,13,25]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uG=e.$tG=void 0;class L{constructor(){this.a=new Map,this.b=new WeakMap}register(N,b){this.a.set(N,b)}readActivationEvents(N){return this.b.has(N)||this.b.set(N,this.c(N)),this.b.get(N)}createActivationEventsMap(N){const b=Object.create(null);for(const $ of N){const k=this.readActivationEvents($);k.length>0&&(b[O.$Rm.toKey($.identifier)]=k)}return b}c(N){if(typeof N.main>"u"&&typeof N.browser>"u")return[];const b=Array.isArray(N.activationEvents)?N.activationEvents.slice(0):[];for(let $=0;$<b.length;$++)b[$]==="onUri"&&(b[$]=`onUri:${O.$Rm.toKey(N.identifier)}`);if(!N.contributes)return b;for(const $ in N.contributes){const k=this.a.get($);if(!k)continue;const A=N.contributes[$],C=Array.isArray(A)?A:[A];try{k(C,b)}catch(p){(0,d.$1)(p)}}return b}}e.$tG=L,e.$uG=new L}),define(Se[273],De([1,0,3,5]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=void 0,e.$Ml=(0,O.$wi)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(N,b){return this.a[N]??=[],this.a[N].push(b),(0,d.$Sc)(()=>{const $=this.a[N]?.indexOf(b);typeof $=="number"&&$>=0&&this.a[N]?.splice($,1)})}b(N){return(this.a[N.type]||[]).find($=>$.supports(N))}connect(N,b,$,k){const A=this.b(N);if(!A)throw new Error(`No socket factory found for ${N}`);return A.connect(N,b,$,k)}}e.$Nl=L}),define(Se[274],De([1,0,21,13,3,220,66,5,11,36]),function(he,e,d,O,L,R,N,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=void 0,e.$Pp=p,e.$Qp=y,e.$Rp=v,e.$Sp=h,e.$Tp=l,e.$Up=o,e.$Np=(0,b.$wi)("requestService");class A{constructor(s){this.b=s}toJSON(){if(!this.a){const s=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?s[t]="*****":s[t]=this.b[t];this.a=s}return this.a}}class C extends L.$Uc{constructor(s){super(),this.b=0,this.a=s.createLogger("network",{name:(0,R.localize)(0,null),when:$.$ik.isEqualTo((0,$.$fk)($.LogLevel.Trace)).serialize()})}async c(s,t,c){const r=`${s} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new A(t.headers??{}));try{const a=await c();return this.a.trace(`${r} - end`,t.type,a.res.statusCode,a.res.headers),a}catch(a){throw this.a.error(`${r} - error`,t.type,(0,O.$0)(a)),a}}}e.$Op=C;function p(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}function y(u){return u.res.statusCode===204}async function v(u){return y(u)?null:(await(0,d.$Re)(u.stream)).toString()}async function h(u){if(!p(u))throw new Error("Server returned "+u.res.statusCode);return v(u)}async function l(u){if(!p(u))throw new Error("Server returned "+u.res.statusCode);if(y(u))return null;const t=(await(0,d.$Re)(u.stream)).toString();try{return JSON.parse(t)}catch(c){throw c.message+=`:
`+t,c}}function o(u){i(u)}let n;function i(u){const s=k.$co.as(N.$ho.Configuration),t=n;n={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},s.updateConfigurations({add:[n],remove:t?[t]:[]})}i(1)}),define(Se[275],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3$b=void 0;class d{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const R=await this.c();if(R){const N=String(d.a++);return this.b.set(N,R),{id:N,data:R.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,R){if(!L.id)return!0;const N=this.b.get(L.id);if(!N)return!1;this.b.delete(L.id);try{return N.validate(R)==="ok"}catch{return!1}finally{N.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$3$b=d}),define(Se[111],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=void 0,e.$Ol="signService",e.$Pl=(0,d.$wi)(e.$Ol)}),define(Se[141],De([1,0,275]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=void 0;class O extends d.$3$b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(N=>new N.signer().sign(R))}h(){return new Promise((R,N)=>he(["vsda"],R,N))}}e.$Ydc=O}),define(Se[276],De([1,0,12,52,30]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=N,e.$ep=b;function R($){if(d.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function N($,k,A,C,p,y,v,h,l){const o=Object.create(null);o["common.machineId"]=y,o["common.sqmId"]=v,o.sessionID=(0,L.$Sg)()+Date.now(),o.commitHash=C,o.version=p,o["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,d.$h)(d.$u),o["common.nodePlatform"]=O.$dc,o["common.nodeArch"]=A,o["common.product"]=l||"desktop",h&&(o["common.msftInternal"]=h);let n=0;const i=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),d.$l&&(o["common.snap"]="true");const u=R(k);return u&&(o["common.platformDetail"]=u),o}function b($){const k=O.env.USERDNSDOMAIN;if(!k)return!1;const A=k.toLowerCase();return $.some(C=>A===C)}}),define(Se[277],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=void 0,e.$2l=(0,d.$wi)("telemetryService"),e.$3l=(0,d.$wi)("customEndpointTelemetryService"),e.$4l="telemetry.currentSessionDate",e.$5l="telemetry.firstSessionDate",e.$6l="telemetry.lastSessionDate",e.$7l="telemetry.machineId",e.$8l="telemetry.sqmId",e.$9l="telemetry",e.$0l="telemetry.telemetryLevel",e.$$l="telemetry.enableCrashReporter",e.$_l="telemetry.enableTelemetry";var O;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var L;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(Se[87],De([1,0,24,18,86,276,277]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=void 0,e.$mp=A,e.$np=C,e.$op=p,e.$pp=y,e.$qp=h,e.$rp=o,e.$sp=n,e.$tp=s;class b{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.$fp=b;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$gp=$,e.$hp=new $;class k{async publicLog(c,r,a){}async publicLogError(c,r,a){}}e.$ip=k,e.$jp="telemetry",e.$kp="extensionTelemetryLog",e.$lp={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!t.enableTelemetry)}function C(t,c){return c.extensionTestsLocationURI?!0:!(c.isBuilt||c.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function p(t){const c=t.getValue(N.$0l),r=t.getValue(N.$$l);if(t.getValue(N.$_l)===!1||r===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function y(t){const c={},r={},a={};l(t,a);for(let f in a){f=f.length>150?f.substr(f.length-149):f;const g=a[f];typeof g=="number"?r[f]=g:typeof g=="boolean"?r[f]=g?1:0:typeof g=="string"?(g.length>8192&&console.warn(`Telemetry property: ${f} has been trimmed to 8192, the original length is ${g.length}`),c[f]=g.substring(0,8191)):typeof g<"u"&&g!==null&&(c[f]=g)}return{properties:c,measurements:r}}const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(t){if(!t)return"none";const c=(0,L.$Im)(t);return v.has(c)?c:"other"}function l(t,c,r=0,a){if(t)for(const f of Object.getOwnPropertyNames(t)){const g=t[f],w=a?a+f:f;Array.isArray(g)?c[w]=(0,d.$8n)(g):g instanceof Date?c[w]=g.toISOString():(0,O.$$f)(g)?r<2?l(g,c,r+1,w+"."):c[w]=(0,d.$8n)(g):c[w]=g}}function o(t,c){const r=t.msftInternalDomains||[],a=c.getValue("telemetry.internalTesting");return(0,R.$ep)(r)||a}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,c){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const a=[];for(const S of c)for(;;){const m=S.exec(t);if(!m)break;a.push([m.index,S.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(r="";;){const S=g.exec(t);if(!S)break;const m=a.some(([E,D])=>S.index<D&&E<g.lastIndex);!f.test(S[0])&&!m&&(r+=t.substring(w,S.index)+"<REDACTED: user-file-path>",w=g.lastIndex)}return w<t.length&&(r+=t.substr(w)),r}function u(t){if(!t)return t;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of c)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function s(t,c){return(0,d.$5n)(t,r=>{if(r instanceof b||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=i(a,c);for(const f of c)a=a.replace(f,"");return a=u(a),a}})}}),define(Se[278],De([1,0,14,138,25,12,2,13,52,87]),function(he,e,d,O,L,R,N,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$vp=void 0,e.$up=A,e.$wp=v,e.$xp=h,e.$yp=l,e.$zp=o,e.$Ap=n,e.$Bp=i,e.$Cp=u,e.$Ep=s,e.$Fp=c;function A(r,a){return r.uuid&&a.uuid?r.uuid===a.uuid:r.id===a.id?!0:(0,d.$sf)(r.id,a.id)===0}const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(a){const f=a.manifest?a.manifest.version:a.version,g=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new p(a.identifier,f,g)}static parse(a){const f=C.exec(a);return f&&f[1]&&f[2]?new p({id:f[1]},f[2],f[4]||void 0):null}constructor(a,f,g="undefined"){this.version=f,this.targetPlatform=g,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof p?A(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.$vp=p;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(r){const a=y.exec(r);return a&&a[1]?[l(a[1]),a[2]]:[l(r),void 0]}function h(r,a){return`${r}.${a}`}function l(r){return r.toLowerCase()}function o(r,a){return l(h(r??L.$Nm,a))}function n(r,a){const f=[],g=w=>{for(const S of f)if(S.some(m=>A(a(m),a(w))))return S;return null};for(const w of r){const S=g(w);S?S.push(w):f.push([w])}return f}function i(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function u(r){return{id:new k.$fp(r.identifier.id),name:new k.$fp(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Dp=new L.$Rm("pprice.better-merge");function s(r,a){const f=[],g=a.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const w=g.shift();if(w&&f.every(S=>!A(S.identifier,{id:w}))){const S=r.filter(m=>A(m.identifier,{id:w}));S.length===1&&(f.push(S[0]),g.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}async function t(r,a){if(!R.$k)return!1;let f;try{f=(await r.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{f=(await r.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(w){a.debug("Error while getting the os-release file.",(0,b.$0)(w))}}return!!f&&(f.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(r,a){const f=await t(r,a),g=(0,O.$2o)(f?"alpine":R.$u,$.$ec);return a.debug("ComputeTargetPlatform:",g),g}}),define(Se[279],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=d,e.$ms=O,e.$ns=L,e.$os=R,e.$ps=N,e.$qs=b;function d($){return[...$.entries()]}function O($){return $?[...$.entries()]:[]}function L($){return new Map($)}function R($){return new Map($??[])}function N($){return Array.from($.entries()).map(k=>[k[0],d(k[1].map),O(k[1].descriptionMap)])}function b($){return new Map($.map(k=>[k[0],{map:L(k[1]),descriptionMap:R(k[2])}]))}}),define(Se[280],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fvb=void 0;class d{constructor(L){this.b=L,this.a=new Map}dispose(){for(const L of this.a.values())L.dispose()}startBuffering(L,R,N=5){const b=R($=>{const k=typeof $=="string"?$:$.data;let A=this.a.get(L);if(A){A.data.push(k);return}const C=setTimeout(()=>this.flushBuffer(L),N);A={data:[k],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(L),b.dispose()}},this.a.set(L,A)});return b}stopBuffering(L){this.a.get(L)?.dispose()}flushBuffer(L){const R=this.a.get(L);R&&(this.a.delete(L),this.b(L,R.data.join("")))}}e.$Fvb=d}),define(Se[281],De([1,0,7,79,99,50,4,18,2,221,110,36]),function(he,e,d,O,L,R,N,b,$,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mx=e.$lx=e.$kx=e.$jx=e.$ix=e.$hx=e.IconFontDefinition=e.IconContribution=e.$ex=void 0,e.$fx=l,e.$gx=o,e.$ex={IconContribution:"base.contributions.icons"};var p;(function(s){function t(c,r){let a=c.defaults;for(;R.ThemeIcon.isThemeIcon(a);){const f=h.getIcon(a.id);if(!f)return;a=f.defaults}return a}s.getDefinition=t})(p||(e.IconContribution=p={}));var y;(function(s){function t(r){return{weight:r.weight,style:r.style,src:r.src.map(a=>({format:a.format,location:a.location.toString()}))}}s.toJSONObject=t;function c(r){const a=f=>(0,b.$9f)(f)?f:void 0;if(r&&Array.isArray(r.src)&&r.src.every(f=>(0,b.$9f)(f.format)&&(0,b.$9f)(f.location)))return{weight:a(r.weight),style:a(r.style),src:r.src.map(f=>({format:f.format,location:$.URI.parse(f.location)}))}}s.fromJSONObject=c})(y||(e.IconFontDefinition=y={}));class v{constructor(){this.a=new N.$de,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,c,r,a){const f=this.b[t];if(f){if(r&&!f.description){f.description=r,this.d.properties[t].markdownDescription=`${r} $(${t})`;const S=this.e.enum.indexOf(t);S!==-1&&(this.e.enumDescriptions[S]=r),this.a.fire()}return f}const g={id:t,description:r,defaults:c,deprecationMessage:a};this.b[t]=g;const w={$ref:"#/definitions/icons"};return a&&(w.deprecationMessage=a),r&&(w.markdownDescription=`${r}: $(${t})`),this.d.properties[t]=w,this.e.enum.push(t),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const c=this.e.enum.indexOf(t);c!==-1&&(this.e.enum.splice(c,1),this.e.enumDescriptions.splice(c,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,c){const r=this.f[t];return r||(this.f[t]=c,this.a.fire(),c)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(f,g)=>f.id.localeCompare(g.id),c=f=>{for(;R.ThemeIcon.isThemeIcon(f.defaults);)f=this.b[f.defaults.id];return`codicon codicon-${f?f.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.b).map(f=>this.b[f]);for(const f of a.filter(g=>!!g.description).sort(t))r.push(`|<i class="${c(f)}"></i>|${f.id}|${R.ThemeIcon.isThemeIcon(f.defaults)?f.defaults.id:f.id}|${f.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const f of a.filter(g=>!R.ThemeIcon.isThemeIcon(g.defaults)).sort(t))r.push(`|<i class="${c(f)}"></i>|${f.id}|`);return r.join(`
`)}}const h=new v;C.$co.add(e.$ex.IconContribution,h);function l(s,t,c,r){return h.registerIcon(s,t,c,r)}function o(){return h}function n(){const s=(0,L.$Rj)();for(const t in s){const c="\\"+s[t].toString(16);h.registerIcon(t,{fontCharacter:c})}}n(),e.$hx="vscode://schemas/icons";const i=C.$co.as(A.$do.JSONContribution);i.registerSchema(e.$hx,h.getIconSchema());const u=new d.$Ih(()=>i.notifySchemaChanged(e.$hx),200);h.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.$ix=l("widget-close",O.$Vj.close,(0,k.localize)(2,null)),e.$jx=l("goto-previous-location",O.$Vj.arrowUp,(0,k.localize)(3,null)),e.$kx=l("goto-next-location",O.$Vj.arrowDown,(0,k.localize)(4,null)),e.$lx=R.ThemeIcon.modify(O.$Vj.sync,"spin"),e.$mx=R.ThemeIcon.modify(O.$Vj.loading,"spin")}),define(Se[88],De([1,0,4,2,55,5,11]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tw=e.$sw=e.$pw=e.$nw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$jw=e.$iw=void 0,e.$kw=k,e.$lw=C,e.$mw=p,e.$ow=y,e.$qw=v,e.$rw=h,e.$iw=(0,R.$wi)("tunnelService"),e.$jw=(0,R.$wi)("sharedTunnelsService");var b;(function(n){n.Http="http",n.Https="https"})(b||(e.TunnelProtocol=b={}));var $;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})($||(e.TunnelPrivacyId=$={}));function k(n){return!!n.forwardPort}var A;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function C(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function p(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const u of i){const s=u.split("=")[1];if(/^https?:/.exec(s)){const t=C(O.URI.parse(s));if(t)return t}}}e.$nw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(n){return e.$nw.indexOf(n)>=0}e.$pw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(n){return e.$pw.indexOf(n)>=0}function h(n,i,u,s){if(u===1)return!1;if(u===2&&v(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class l{constructor(i,u,s){this.remoteAddress=i,this.localAddress=u,this.b=s,this.a=new d.$de,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$sw=l;let o=class{constructor(i,u){this.k=i,this.l=u,this.a=new d.$de,this.onTunnelOpened=this.a.event,this.b=new d.$de,this.onTunnelClosed=this.b.event,this.c=new d.$de,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],u=Array.from(this.e.values());for(const s of u){const t=Array.from(s.values());for(const c of t){const r=await c.value;r&&typeof r!="string"&&i.push(r)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:u}of i.values())await u.then(s=>typeof s!="string"?s?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,u,s,t,c){this.q(i,u,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:u,localAddress:s,privacy:t,protocol:c,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,u){(v(i)||y(i))&&(i=e.$nw[0]);const s=this.s(i,u);if(s)return++s.refcount,s.value}openTunnel(i,u,s,t,c,r=!1,a,f){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${s} on local port ${c}.`);const g=this.f??i;if(!g)return;if(u||(u="localhost"),t||(t=this.m),this.f&&this.j.has(s)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const w=this.t(g,u,s,t,c,r,a,f);return w?w.then(S=>{if(S){if(typeof S=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(u,s),S}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(u,s);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const m=this.o(S);return(S.tunnelRemoteHost!==u||S.tunnelRemotePort!==s)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&S.privacy!==a&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(m),m}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),w)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const u=this.e.get(i.tunnelRemoteHost);if(u){const s=u.get(i.tunnelRemotePort);s&&(s.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,s))}}}}async p(i,u,s){if(s.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${u}.`);const t=s.value.then(async c=>{c&&typeof c!="string"&&(await c.dispose(!0),this.b.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(u),t}}async closeTunnel(i,u){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${u} `);const s=this.e.get(i);if(s&&s.has(u)){const t=s.get(u);t.refcount=0,await this.p(i,u,t)}}q(i,u,s){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(u,{refcount:1,value:s})}async r(i,u){const s=this.e.get(i);if(s){const t=s.get(u),c=t?await t.value:void 0;(!c||typeof c=="string")&&s.delete(u),s.size===0&&this.e.delete(i)}}s(i,u){const s=[i];y(i)?(s.push(...e.$nw),s.push(...e.$pw)):v(i)&&s.push(...e.$pw);const t=s.map(c=>this.e.get(c));for(const c of t){const r=c?.get(u);if(r)return r}}canTunnel(i){return!!C(i)}u(i,u,s,t,c,r,a){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${s} on local port ${t}.`);const f=s;this.j.add(f);const g=t===void 0?s:t,w={elevationRequired:c?this.isPortPrivileged(g):!1},S={remoteAddress:{host:u,port:s},localAddressPort:t,privacy:r,public:r?r!==$.Private:void 0,protocol:a},m=i.forwardPort(S,w);return m?(this.q(u,s,m),m.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(f)})):this.j.delete(f),m}};e.$tw=o,e.$tw=o=Ge([We(0,N.$3j),We(1,L.$3i)],o)}),define(Se[282],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=void 0,e.$Al=(0,d.$wi)("IUriIdentityService")}),define(Se[283],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$uw=void 0,e.$uw=(0,d.$wi)("editSessionIdentityService");var O;(function(L){L[L.Complete=100]="Complete",L[L.Partial=50]="Partial",L[L.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(Se[284],De([1,0,15]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=O,e.$IM=L,e.$JM=R,e.$KM=N,e.$LM=b;function O($){return $.scheme!==d.Schemas.file&&$.scheme!==d.Schemas.vscodeRemote}function L($){if($.folders.length)return $.folders.every(k=>O(k.uri))?$.folders[0].uri:void 0;if($.configuration&&O($.configuration))return $.configuration}function R($){return L($)?.scheme}function N($){return L($)?.authority}function b($){return L($)!==void 0}}),define(Se[42],De([1,0,223,17,78,23,2,5,15]),function(he,e,d,O,L,R,N,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Qi=e.$Pi=e.WorkbenchState=e.$Ji=e.$Ii=e.$Fi=void 0,e.$Gi=k,e.$Hi=A,e.$Ki=C,e.$Li=p,e.$Mi=y,e.$Ni=h,e.$Oi=l,e.$Ri=i,e.$Wi=u,e.$Xi=s,e.$Zi=t,e.$1i=c,e.$2i=r,e.$Fi=(0,b.$wi)("contextService");function k(a){const f=a;return typeof f?.id=="string"&&N.URI.isUri(f.uri)}function A(a){return typeof a?.id=="string"&&!k(a)&&!p(a)}e.$Ii={id:"ext-dev"},e.$Ji={id:"empty-window"};function C(a,f){if(typeof a=="string"||typeof a>"u")return typeof a=="string"?{id:(0,O.$nc)(a)}:f?e.$Ii:e.$Ji;const g=a;return g.configuration?{id:g.id,configPath:g.configuration}:g.folders.length===1?{id:g.id,uri:g.folders[0].uri}:{id:g.id}}function p(a){const f=a;return typeof f?.id=="string"&&N.URI.isUri(f.configPath)}function y(a){const f=a;if(f?.uri)return{id:f.id,uri:N.URI.revive(f.uri)};const g=a;if(g?.configPath)return{id:g.id,configPath:N.URI.revive(g.configPath)};if(a?.id)return{id:a.id}}var v;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function h(a){const f=a;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}function l(a){const f=a;return!!(f&&typeof f=="object"&&N.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}class o{constructor(f,g,w,S,m){this.h=f,this.j=w,this.k=S,this.l=m,this.c=L.$Ci.forUris(this.l,()=>!0),this.folders=g}update(f){this.h=f.id,this.k=f.configuration,this.j=f.transient,this.l=f.l,this.folders=f.folders}get folders(){return this.g}set folders(f){this.g=f,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(f){this.k=f}getFolder(f){return f&&this.c.findSubstr(f)||null}n(){this.c=L.$Ci.forUris(this.l,()=>!0);for(const f of this.folders)this.c.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Pi=o;class n{constructor(f,g){this.raw=g,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,R.$0g)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Qi=n;function i(a){return new n({uri:a,index:0,name:(0,R.$6g)(a)},{uri:a.toString()})}e.$Si="code-workspace",e.$Ti=`.${e.$Si}`,e.$Ui=[{name:(0,d.localize)(0,null),extensions:[e.$Si]}],e.$Vi="workspace.json";function u(a,f){return R.$1g.isEqualOrParent(a,f.untitledWorkspacesHome)}function s(a){let f;return N.URI.isUri(a)?f=a:f=a.configuration,f?.scheme===$.Schemas.tmp}e.$Yi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(a){return a.id===e.$Yi}function c(a,f){return!u(a,f)&&!s(a)}function r(a){return(typeof a=="string"?(0,O.$oc)(a):(0,R.$8g)(a))===e.$Ti}}),define(Se[285],De([1,0,57,4,3,23,2,222,137,33,5,11,42,27,282,7,30,14,18]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$Cl=e.ProfileResourceType=void 0,e.$Bl=u,e.$Dl=s,e.$El=t;var i;(function(a){a.Settings="settings",a.Keybindings="keybindings",a.Snippets="snippets",a.Tasks="tasks",a.Extensions="extensions",a.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function u(a){const f=a;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&typeof f.isDefault=="boolean"&&typeof f.name=="string"&&N.URI.isUri(f.location)&&N.URI.isUri(f.globalStorageHome)&&N.URI.isUri(f.settingsResource)&&N.URI.isUri(f.keybindingsResource)&&N.URI.isUri(f.tasksResource)&&N.URI.isUri(f.snippetsHome)&&N.URI.isUri(f.extensionsResource))}e.$Cl=(0,A.$wi)("IUserDataProfilesService");function s(a,f){return{id:a.id,isDefault:a.isDefault,name:a.name,shortName:a.shortName,icon:a.icon,location:N.URI.revive(a.location).with({scheme:f}),globalStorageHome:N.URI.revive(a.globalStorageHome).with({scheme:f}),settingsResource:N.URI.revive(a.settingsResource).with({scheme:f}),keybindingsResource:N.URI.revive(a.keybindingsResource).with({scheme:f}),tasksResource:N.URI.revive(a.tasksResource).with({scheme:f}),snippetsHome:N.URI.revive(a.snippetsHome).with({scheme:f}),extensionsResource:N.URI.revive(a.extensionsResource).with({scheme:f}),cacheHome:N.URI.revive(a.cacheHome).with({scheme:f}),useDefaultFlags:a.useDefaultFlags,isTransient:a.isTransient}}function t(a,f,g,w,S,m){return{id:a,name:f,location:g,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:m&&S?.useDefaultFlags?.globalState?m.globalStorageHome:(0,R.$0g)(g,"globalStorage"),settingsResource:m&&S?.useDefaultFlags?.settings?m.settingsResource:(0,R.$0g)(g,"settings.json"),keybindingsResource:m&&S?.useDefaultFlags?.keybindings?m.keybindingsResource:(0,R.$0g)(g,"keybindings.json"),tasksResource:m&&S?.useDefaultFlags?.tasks?m.tasksResource:(0,R.$0g)(g,"tasks.json"),snippetsHome:m&&S?.useDefaultFlags?.snippets?m.snippetsHome:(0,R.$0g)(g,"snippets"),extensionsResource:m&&S?.useDefaultFlags?.extensions?m.extensionsResource:(0,R.$0g)(g,"extensions.json"),cacheHome:(0,R.$0g)(w,a),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let c=class extends L.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(f,g,w,S){super(),this.t=f,this.u=g,this.w=w,this.y=S,this.f=!0,this.h=this.B(new O.$de),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$de),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$de),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$de),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$Ac,emptyWindows:new Map},this.profilesHome=(0,R.$0g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$0g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(f){this.f!==f&&(this.z=void 0,this.f=f)}isEnabled(){return this.f}get C(){if(!this.z){const f=this.D(),g=[f];if(this.f)try{for(const m of this.O()){if(!m.name||!(0,n.$9f)(m.name)||!m.location){this.y.warn("Skipping the invalid stored profile",m.location||m.name);continue}g.push(t((0,R.$7g)(m.location),m.name,m.location,this.g,{shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags},f))}}catch(m){this.y.error(m)}const w=new y.$Ac,S=new Map;if(g.length)try{const m=this.Q();if(m.workspaces)for(const[E,D]of Object.entries(m.workspaces)){const P=N.URI.parse(E),I=g.find(F=>F.id===D);I&&w.set(P,I)}if(m.emptyWindows)for(const[E,D]of Object.entries(m.emptyWindows)){const P=g.find(I=>I.id===D);P&&S.set(E,P)}}catch(m){this.y.error(m)}this.z={profiles:g,workspaces:w,emptyWindows:S}}return this.z}D(){const f=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...f,extensionsResource:this.S()??f.extensionsResource,isDefault:!0}}async createTransientProfile(f){const g="Temp",w=new RegExp(`${(0,o.$_e)(g)}\\s(\\d+)`);let S=0;for(const E of this.profiles){const D=w.exec(E.name),P=D?parseInt(D[1]):0;S=P>S?P:S}const m=`${g} ${S+1}`;return this.createProfile((0,d.$kj)((0,l.$Sg)()).toString(16),m,{transient:!0},f)}async createNamedProfile(f,g,w){return this.createProfile((0,d.$kj)((0,l.$Sg)()).toString(16),f,g,w)}async createProfile(f,g,w,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=await this.F(f,g,w);return S&&await this.setProfileForWorkspace(S,m),m}async F(f,g,w){if(!(0,n.$9f)(g)||!g)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(g);return S||(S=(async()=>{try{if(this.profiles.find(P=>P.name===g||P.id===f))throw new Error(`Profile with ${g} name already exists`);const E=t(f,g,(0,R.$0g)(this.profilesHome,f),this.g,w,this.defaultProfile);await this.u.createFolder(E.location);const D=[];return this.j.fire({profile:E,join(P){D.push(P)}}),await h.Promises.settled(D),this.I([E],[],[]),E}finally{this.r.delete(g)}})(),this.r.set(g,S)),S}async updateProfile(f,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let w=this.profiles.find(S=>S.id===f.id);if(!w)throw new Error(`Profile '${f.name}' does not exist`);return w=t(w.id,g.name??w.name,w.location,this.g,{shortName:g.shortName??w.shortName,icon:g.icon===null?void 0:g.icon??w.icon,transient:g.transient??w.isTransient,useDefaultFlags:g.useDefaultFlags??w.useDefaultFlags},this.defaultProfile),this.I([],[],[w]),w}async removeProfile(f){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(f.isDefault)throw new Error("Cannot remove default profile");const g=this.profiles.find(S=>S.id===f.id);if(!g)throw new Error(`Profile '${f.name}' does not exist`);const w=[];this.m.fire({profile:g,join(S){w.push(S)}});try{await Promise.allSettled(w)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])g.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])g.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[g],[]);try{await this.u.del(g.cacheHome,{recursive:!0})}catch(S){(0,k.$hl)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(f,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=this.profiles.find(S=>S.id===g.id);if(!w)throw new Error(`Profile '${g.name}' does not exist`);this.L(f,w)}unsetWorkspace(f,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(f,void 0,g)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const f=await this.u.resolve(this.profilesHome);await Promise.all((f.children||[]).filter(g=>g.isDirectory&&this.profiles.every(w=>!this.w.extUri.isEqual(w.location,g.resource))).map(g=>this.u.del(g.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const f=this.s.profiles.filter(g=>!this.H(g));await Promise.allSettled(f.map(g=>this.removeProfile(g)))}getProfileForWorkspace(f){const g=this.G(f);return N.URI.isUri(g)?this.s.workspaces.get(g)??this.C.workspaces.get(g):this.s.emptyWindows.get(g)??this.C.emptyWindows.get(g)}G(f){return(0,p.$Gi)(f)?f.uri:(0,p.$Li)(f)?f.configPath:f.id}H(f){return!!([...this.s.emptyWindows.values()].some(g=>this.w.extUri.isEqual(g.location,f.location))||[...this.s.workspaces.values()].some(g=>this.w.extUri.isEqual(g.location,f.location))||[...this.C.emptyWindows.values()].some(g=>this.w.extUri.isEqual(g.location,f.location))||[...this.C.workspaces.values()].some(g=>this.w.extUri.isEqual(g.location,f.location)))}I(f,g,w){const S=[...this.profiles,...f],m=[];this.s.profiles=[];for(let E of S)E.isDefault||g.some(D=>E.id===D.id)||(E=w.find(D=>E.id===D.id)??E,E.isTransient?this.s.profiles.push(E):m.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(m),this.z=void 0,this.J(f,g,w)}J(f,g,w){this.h.fire({added:f,removed:g,updated:w,all:this.profiles})}L(f,g,w){w=g?.isTransient?!0:w,w||this.L(f,void 0,!0);const S=this.G(f),m=w?this.s:this.C;N.URI.isUri(S)?(m.workspaces.delete(S),g&&m.workspaces.set(S,g)):(m.emptyWindows.delete(S),g&&m.emptyWindows.set(S,g)),w||this.M()}M(){const f={};for(const[w,S]of this.C.workspaces.entries())f[w.toString()]=S.id;const g={};for(const[w,S]of this.C.emptyWindows.entries())g[w.toString()]=S.id;this.R({workspaces:f,emptyWindows:g}),this.z=void 0}N(f){const g={},w=this.D();if(f.workspaces)for(const[m,E]of Object.entries(f.workspaces)){const D=N.URI.parse(E);g[m]=this.w.extUri.isEqual(D,w.location)?w.id:this.w.extUri.basename(D)}const S={};if(f.emptyWindows)for(const[m,E]of Object.entries(f.emptyWindows)){const D=N.URI.parse(E);S[m]=this.w.extUri.isEqual(D,w.location)?w.id:this.w.extUri.basename(D)}return{workspaces:g,emptyWindows:S}}O(){return[]}P(f){throw new Error("not implemented")}Q(){return{}}R(f){throw new Error("not implemented")}S(){}};e.$Fl=c,e.$Fl=c=Ge([We(0,$.$Di),We(1,k.$3k),We(2,v.$Al),We(3,C.$3j)],c);class r extends c{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(f){this.a=f}Q(){return this.X}R(f){this.X=f}}e.$Gl=r}),define(Se[142],De([1,0,7,4,3,59,18,200,5,285]),function(he,e,d,O,L,R,N,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$3p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$1p=e.$Zp=e.$Yp=void 0,e.$2p=y,e.$4p=h,e.$6p=o,e.$Yp="__$__isNewStorageMarker",e.$Zp="__$__targetStorageMarker",e.$1p=(0,$.$wi)("storageService");var A;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var C;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var p;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function y(n){const i=n.get(e.$Zp);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class v extends L.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:v.a}){super(),this.m=i,this.b=this.B(new O.$ge),this.c=this.B(new O.$ge),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$de),this.onWillSaveState=this.f.event,this.h=this.B(new d.$Ih(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,u,s){return O.Event.filter(this.b.event,t=>t.scope===i&&(u===void 0||t.key===u),s)}n(){this.j.value=(0,d.$Mh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,u){const{key:s,external:t}=u;if(s===e.$Zp){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:s,target:this.J(i)[s],external:t})}w(i){this.f.fire({reason:i})}get(i,u,s){return this.P(u)?.get(i,s)}getBoolean(i,u,s){return this.P(u)?.getBoolean(i,s)}getNumber(i,u,s){return this.P(u)?.getNumber(i,s)}getObject(i,u,s){return this.P(u)?.getObject(i,s)}storeAll(i,u){this.y(()=>{for(const s of i)this.store(s.key,s.value,s.scope,s.target,u)})}store(i,u,s,t,c=!1){if((0,N.$fg)(u)){this.remove(i,s,c);return}this.y(()=>{this.z(i,s,t),this.P(s)?.set(i,u,c)})}remove(i,u,s=!1){this.y(()=>{this.z(i,u,void 0),this.P(u)?.delete(i,s)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,u){const s=[],t=this.J(i);for(const c of Object.keys(t))t[c]===u&&s.push(c);return s}z(i,u,s,t=!1){const c=this.J(u);typeof s=="number"?c[i]!==s&&(c[i]=s,this.P(u)?.set(e.$Zp,JSON.stringify(c),t)):typeof c[i]=="number"&&(delete c[i],this.P(u)?.set(e.$Zp,JSON.stringify(c),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const u=this.P(i);return u?y(u):Object.create(null)}isNew(i){return this.getBoolean(e.$Yp,i)===!0}async flush(i=A.NONE){this.f.fire({reason:i});const u=this.P(-1),s=this.P(0),t=this.P(1);switch(i){case A.NONE:await d.Promises.settled([u?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await d.Promises.settled([u?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,u=this.P(0)?.items??new Map,s=this.P(1)?.items??new Map;return o(i,u,s,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,u){return this.w(A.NONE),(0,k.$Bl)(i)?this.R(i,u):this.S(i,u)}M(i,u){return!(i.id===u.id||h(u)&&h(i))}N(i,u,s){this.y(()=>{const t=new Set;for(const[c,r]of i)t.add(c),u.get(c)!==r&&this.u(s,{key:c,external:!0});for(const[c]of u.items)t.has(c)||this.u(s,{key:c,external:!0})})}}e.$3p=v;function h(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class l extends v{constructor(){super(),this.U=this.B(new b.$Wp(new b.$Xp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$Wp(new b.$Xp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$Wp(new b.$Xp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$5p=l;async function o(n,i,u,s,t,c){const r=P=>{try{return JSON.parse(P)}catch{return P}},a=new Map,f=new Map;n.forEach((P,I)=>{a.set(I,P),f.set(I,r(P))});const g=new Map,w=new Map;i.forEach((P,I)=>{g.set(I,P),w.set(I,r(P))});const S=new Map,m=new Map;u.forEach((P,I)=>{S.set(I,P),m.set(I,r(P))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const E=[];if(a.forEach((P,I)=>{E.push({key:I,value:P})}),console.table(E),console.groupEnd(),console.log(f),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];g.forEach((I,F)=>{P.push({key:F,value:I})}),console.table(P),console.groupEnd(),console.log(w)}console.group(`Storage: Workspace (path: ${c})`);const D=[];S.forEach((P,I)=>{D.push({key:I,value:P})}),console.table(D),console.groupEnd(),console.log(m)}}),define(Se[112],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=void 0;class d{static{this.a=!1}constructor(L){this.d=L,this.b=new Map,this.c=1}add(L){const R=this.c++;return this.b.set(R,L),this.e(),R}get(L,R){return this.b.has(L)?this.b.get(L)[R]:void 0}delete(L){this.b.delete(L),this.e()}e(){d.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$plc=d}),define(Se[60],De([1,0,15,23,5]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=e.$ulc=void 0;class R{constructor(){this.a=new Set(Object.keys(d.Schemas)),this.b=new Map,this.extUri=new O.$Yg(b=>{const $=this.b.get(b.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(b,$){$===null?this.b.delete(b.scheme):this.b.set(b.scheme,$)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$ulc=R,e.$vlc=(0,L.$wi)("IExtHostFileSystemInfo")}),define(Se[28],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PP=void 0,e.$PP=(0,d.$wi)("IExtHostInitDataService")}),define(Se[286],De([1,0,228,11,266,28]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bnc=void 0;let N=class extends L.$ZQ{constructor($,k,A){const C=A.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",p=A.remote.isRemote?(0,d.localize)(0,null):$?(0,d.localize)(1,null):(0,d.localize)(2,null);super(k.createLogger(C,{name:p}))}};e.$Bnc=N,e.$Bnc=N=Ge([We(1,O.$4j),We(2,R.$PP)],N)}),define(Se[287],De([1,0,7]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=e.$amc=void 0;class O{constructor(N,b,$){this.h=new Map,this.a=N,this.b=b,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new d.$Ih(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of k.values())A.complete()}catch(A){for(const C of k.values())C.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,N])=>N!==void 0).map(([N])=>N)}get whenReady(){return this.d}get(N,b){let $=this.f[N];return typeof $>"u"&&($=b),$}update(N,b){this.f[N]=b;const $=this.h.get(N);if($!==void 0)return $.p;const k=new d.$Th;return this.h.set(N,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$amc=O;class L extends O{setKeysForSync(N){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},N)}constructor(N,b){super(N.identifier.value,!0,b),this.j=N}}e.$bmc=L}),define(Se[288],De([1,0,4,2]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=void 0;class L{constructor(N){this.c=N,this.a=new d.$de,this.onDidSaveNotebookDocument=this.a.event,this.b=new d.$de,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(N,b,$,k){const C=this.c.getNotebookDocument(O.URI.revive(N)).acceptModelChanged(b.value,$,k);this.b.fire(C)}$acceptDirtyStateChanged(N,b){this.c.getNotebookDocument(O.URI.revive(N)).acceptDirty(b)}$acceptModelSaved(N){const b=this.c.getNotebookDocument(O.URI.revive(N));this.a.fire(b.apiNotebook)}}e.$2mc=L}),define(Se[20],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AP=e.$zP=void 0,e.$zP=(0,d.$wi)("IExtHostRpcService");class O{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$AP=O}),define(Se[289],De([1,0,25,4]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kmc=void 0;class L{#e;constructor(N,b){this.b=new O.$de,this.onDidChange=this.b.event,this.a=d.$Rm.toKey(N.identifier),this.#e=b,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(N){return this.#e.get(this.a,N)}store(N,b){return this.#e.store(this.a,N,b)}delete(N){return this.#e.delete(this.a,N)}}e.$kmc=L}),define(Se[68],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Llc=e.$Klc=void 0,e.$Klc=(0,d.$wi)("IURITransformerService");class O{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=N=>N,this.transformOutgoing=N=>N,this.transformOutgoingURI=N=>N,this.transformOutgoingScheme=N=>N)}}e.$Llc=O}),define(Se[290],De([1,0,21]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Erb=L,e.$Frb=N;class O{constructor(){this.buffers=[]}add($){let k=this.buffers.indexOf($);return k<0&&(k=this.buffers.length,this.buffers.push($)),k}}function L(b,$){if($.serializeBuffersForPostMessage){const k=new O,C=JSON.stringify(b,(y,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(v)};if(ArrayBuffer.isView(v)){const h=R(v);if(h)return{$$vscode_array_buffer_reference$$:!0,index:k.add(v.buffer),view:{type:h,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),p=k.buffers.map(y=>{const v=new Uint8Array(y);return d.$Fe.wrap(v)});return{message:C,buffers:p}}else return{message:JSON.stringify(b),buffers:[]}}function R(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function N(b,$){const k=$.map(p=>{const y=new ArrayBuffer(p.byteLength);return new Uint8Array(y).set(p.buffer),y}),A=$.length?(p,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const v=y,{index:h}=v,l=k[h];if(v.view)switch(v.view.type){case 1:return new Int8Array(l,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(l,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(l,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(l,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(l,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(l,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(l,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(l,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(l,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(l,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(l,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return l}return y}:void 0;return{message:JSON.parse(b,A),arrayBuffers:k}}}),define(Se[291],De([1,0,292,403,404,63,2,11,405]),function(he,e,d,O,L,R,N,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0nc=A;const k=!1;function A(i,u,s,t,c,r){const a=r.environment.useHostProxy,f=typeof a=="boolean"?a:!r.remote.isRemote,g={resolveProxy:m=>i.resolveProxy(m),lookupProxyAuthorization:l.bind(void 0,t,c,u,{},r.remote.isRemote),getProxyURL:()=>u.getConfiguration("http").get("proxy"),getProxySupport:()=>u.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>p(u),addCertificatesV2:()=>y(u),log:t,getLogLevel:()=>{const m=t.getLevel();switch(m){case b.LogLevel.Trace:return $.LogLevel.Trace;case b.LogLevel.Debug:return $.LogLevel.Debug;case b.LogLevel.Info:return $.LogLevel.Info;case b.LogLevel.Warning:return $.LogLevel.Warning;case b.LogLevel.Error:return $.LogLevel.Error;case b.LogLevel.Off:return $.LogLevel.Off;default:return E(m)}function E(D){return t.error("Unknown log level",D),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:f,loadAdditionalCertificates:async()=>{const m=[];if(r.remote.isRemote&&m.push((0,$.loadSystemCertificates)({log:t})),f){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const E=i.loadCertificates();E.then(D=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",D.length)),m.push(E)}return(await Promise.all(m)).flat()},env:process.env},w=(0,$.createProxyResolver)(g),S=C(g,w);return h(s,S)}function C(i,u){return{http:Object.assign(d,(0,$.createHttpPatch)(i,d,u)),https:Object.assign(O,(0,$.createHttpPatch)(i,O,u)),net:Object.assign(R,(0,$.createNetPatch)(i,R)),tls:Object.assign(L,(0,$.createTlsPatch)(i,L))}}function p(i){const u=i.getConfiguration("http");return!u.get("experimental.systemCertificatesV2",k)&&!!u.get("systemCertificates")}function y(i){const u=i.getConfiguration("http");return!!u.get("experimental.systemCertificatesV2",k)&&!!u.get("systemCertificates")}const v=new Map;function h(i,u){return i.getExtensionPathIndex().then(s=>{const t=globalThis._VSCODE_NODE_MODULES.module,c=t._load;t._load=function(a,f,g){if(a==="net")return u.net;if(a==="tls")return u.tls;if(a!=="http"&&a!=="https")return c.apply(this,arguments);const w=s.findSubstr(N.URI.file(f.filename));let S=v.get(w);if(S||v.set(w,S={}),!S[a]){const m=u[a];S[a]={...m}}return S[a]}})}async function l(i,u,s,t,c,r,a,f){const g=t[r];a&&(t[r]=a),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${r}`,`proxyAuthenticate:${a}`,`proxyAuthenticateCache:${g}`);const w=a||g,S=Array.isArray(w)?w:typeof w=="string"?[w]:[];if(n(u,S,c),S.some(m=>/^(Negotiate|Kerberos)( |$)/i.test(m))&&!f.kerberosRequested)try{f.kerberosRequested=!0;const m=await new Promise((F,T)=>{he(["kerberos"],F,T)}),E=new URL(r),D=s.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${E.hostname}`:`HTTP@${E.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${r}`,`spn:${D}`),"Negotiate "+await(await m.initializeClient(D)).step("")}catch(m){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",m)}}let o=!1;function n(i,u,s){o||!u.length||(o=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:u.map(t=>t.split(" ")[0]).join(","),extensionHostType:s?"remote":"local"}))}}),define(Se[293],De([1,0,134]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=L;function O(R){return{transformIncoming:N=>N.scheme==="vscode-remote"?{scheme:"file",path:N.path,query:N.query,fragment:N.fragment}:N.scheme==="file"?{scheme:"vscode-local",path:N.path,query:N.query,fragment:N.fragment}:N,transformOutgoing:N=>N.scheme==="file"?{scheme:"vscode-remote",authority:R,path:N.path,query:N.query,fragment:N.fragment}:N.scheme==="vscode-local"?{scheme:"file",path:N.path,query:N.query,fragment:N.fragment}:N,transformOutgoingScheme:N=>N==="file"?"vscode-remote":N==="vscode-local"?"file":N}}function L(R){return new d.$yn(O(R))}}),define(Se[143],De([1,0,238,18,2,3,5,36,33,15,47,192,41]),function(he,e,d,O,L,R,N,b,$,k,A,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$RF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$IF=e.EditorInputCapabilities=e.$HF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=void 0,e.$yF=h,e.$zF=l,e.$AF=o,e.$BF=n,e.$CF=i,e.$DF=u,e.$EF=s,e.$FF=t,e.$GF=c,e.$JF=S,e.$KF=E,e.$LF=D,e.$MF=P,e.$NF=I,e.$OF=F,e.$PF=T,e.$QF=ie,e.$SF=x,e.$TF=be,e.$UF=ae,e.$VF=Ce,e.$tF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$uF={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.$vF="workbench.editor.sidebysideEditor",e.$wF="workbench.editors.textDiffEditor",e.$xF="workbench.editors.binaryResourceDiffEditor";var y;(function(ee){ee[ee.PROGRAMMATIC=1]="PROGRAMMATIC",ee[ee.USER=2]="USER",ee[ee.EDIT=3]="EDIT",ee[ee.NAVIGATION=4]="NAVIGATION",ee[ee.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var v;(function(ee){ee[ee.IDENTICAL=1]="IDENTICAL",ee[ee.SIMILAR=2]="SIMILAR",ee[ee.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function h(ee){const B=ee;return!!B&&typeof B.getSelection=="function"&&!!B.onDidChangeSelection}function l(ee){const B=ee;return!!B&&typeof B.getScrollPosition=="function"&&typeof B.setScrollPosition=="function"&&!!B.onDidChangeScroll}function o(ee,B,_){for(const pe of _.visibleEditorPanes)if(pe.group.id===B&&ee.matches(pe.input))return pe.getViewState()}function n(ee){if(S(ee))return!1;const B=ee;return L.URI.isUri(B?.resource)}function i(ee){if(S(ee))return!1;const B=ee;return B?.original!==void 0&&B.modified!==void 0}function u(ee){if(S(ee))return!1;const B=ee;return!B||B.resources&&!Array.isArray(B.resources)?!1:!!B.resources||!!B.multiDiffSource}function s(ee){if(S(ee)||i(ee))return!1;const B=ee;return B?.primary!==void 0&&B.secondary!==void 0}function t(ee){if(S(ee))return!1;const B=ee;return B?B.resource===void 0||B.resource.scheme===k.Schemas.untitled||B.forceUntitled===!0:!1}function c(ee){if(S(ee))return!1;const B=ee;return L.URI.isUri(B?.base?.resource)&&L.URI.isUri(B?.input1?.resource)&&L.URI.isUri(B?.input2?.resource)&&L.URI.isUri(B?.result?.resource)}var r;(function(ee){ee[ee.SHORT=0]="SHORT",ee[ee.MEDIUM=1]="MEDIUM",ee[ee.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var a;(function(ee){ee[ee.EXPLICIT=1]="EXPLICIT",ee[ee.AUTO=2]="AUTO",ee[ee.FOCUS_CHANGE=3]="FOCUS_CHANGE",ee[ee.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class f{constructor(){this.a=new Map}registerSource(B,_){let pe=this.a.get(B);return pe||(pe={source:B,label:_},this.a.set(B,pe)),pe.source}getSourceLabel(B){return this.a.get(B)?.label??B}}e.$HF=new f;var g;(function(ee){ee[ee.None=0]="None",ee[ee.Readonly=2]="Readonly",ee[ee.Untitled=4]="Untitled",ee[ee.Singleton=8]="Singleton",ee[ee.RequiresTrust=16]="RequiresTrust",ee[ee.CanSplitInGroup=32]="CanSplitInGroup",ee[ee.ForceDescription=64]="ForceDescription",ee[ee.CanDropIntoEditor=128]="CanDropIntoEditor",ee[ee.MultipleEditors=256]="MultipleEditors",ee[ee.Scratchpad=512]="Scratchpad"})(g||(e.EditorInputCapabilities=g={}));class w extends R.$Uc{}e.$IF=w;function S(ee){return ee instanceof w}function m(ee){const B=ee;return L.URI.isUri(B?.preferredResource)}function E(ee){const B=ee;return S(B?.primary)&&S(B?.secondary)}function D(ee){const B=ee;return S(B?.modified)&&S(B?.original)}function P(ee,B,_,pe,ue){return Ce(pe,[(0,C.$gj)({id:"workbench.action.openLargeFile",label:(0,d.localize)(2,null),run:()=>{const ce={..._,limits:{size:Number.MAX_VALUE}};ee.openEditor(B,ce)}}),(0,C.$gj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,d.localize)(3,null),run:()=>ue.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}function I(ee){return S(ee?.editor)}function F(ee){const B=ee;return I(ee)&&B?.group!==void 0}function T(ee){const B=ee;return typeof B?.groupId=="number"&&S(B.editor)}var z;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.REPLACE=1]="REPLACE",ee[ee.MOVE=2]="MOVE",ee[ee.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var M;(function(ee){ee[ee.GROUP_ACTIVE=0]="GROUP_ACTIVE",ee[ee.GROUP_INDEX=1]="GROUP_INDEX",ee[ee.GROUP_LABEL=2]="GROUP_LABEL",ee[ee.GROUP_LOCKED=3]="GROUP_LOCKED",ee[ee.EDITOR_OPEN=4]="EDITOR_OPEN",ee[ee.EDITOR_CLOSE=5]="EDITOR_CLOSE",ee[ee.EDITOR_MOVE=6]="EDITOR_MOVE",ee[ee.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ee[ee.EDITOR_LABEL=8]="EDITOR_LABEL",ee[ee.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ee[ee.EDITOR_PIN=10]="EDITOR_PIN",ee[ee.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ee[ee.EDITOR_STICKY=12]="EDITOR_STICKY",ee[ee.EDITOR_DIRTY=13]="EDITOR_DIRTY",ee[ee.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var j;(function(ee){ee[ee.PRIMARY=1]="PRIMARY",ee[ee.SECONDARY=2]="SECONDARY",ee[ee.BOTH=3]="BOTH",ee[ee.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class U{getOriginalUri(B,_){if(!B)return;if(c(B))return e.$RF.getOriginalUri(B.result,_);if(_?.supportSideBySide){const{primary:ue,secondary:ce}=this.a(B);if(ue&&ce){if(_?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(ce,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===j.ANY)return this.getOriginalUri(ue,{filterByScheme:_.filterByScheme})??this.getOriginalUri(ce,{filterByScheme:_.filterByScheme});B=_.supportSideBySide===j.PRIMARY?ue:ce}}if(i(B)||u(B)||s(B)||c(B))return;const pe=m(B)?B.preferredResource:B.resource;return!pe||!_||!_.filterByScheme?pe:this.b(pe,_.filterByScheme)}a(B){return E(B)||s(B)?{primary:B.primary,secondary:B.secondary}:D(B)||i(B)?{primary:B.modified,secondary:B.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(B,_){if(!B)return;if(c(B))return e.$RF.getCanonicalUri(B.result,_);if(_?.supportSideBySide){const{primary:ue,secondary:ce}=this.a(B);if(ue&&ce){if(_?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(ce,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===j.ANY)return this.getCanonicalUri(ue,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(ce,{filterByScheme:_.filterByScheme});B=_.supportSideBySide===j.PRIMARY?ue:ce}}if(i(B)||u(B)||s(B)||c(B))return;const pe=B.resource;return!pe||!_||!_.filterByScheme?pe:this.b(pe,_.filterByScheme)}b(B,_){if(Array.isArray(_)){if(_.some(pe=>B.scheme===pe))return B}else if(_===B.scheme)return B}}var Z;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.KEYBOARD=1]="KEYBOARD",ee[ee.MOUSE=2]="MOUSE"})(Z||(e.EditorCloseMethod=Z={}));function ie(ee,B,_,pe){if(!ee.isSticky(B))return!1;switch(pe.preventPinnedEditorClose){case"keyboardAndMouse":return _===Z.MOUSE||_===Z.KEYBOARD;case"mouse":return _===Z.MOUSE;case"keyboard":return _===Z.KEYBOARD}return!1}e.$RF=new U;var q;(function(ee){ee[ee.LEFT=0]="LEFT",ee[ee.RIGHT=1]="RIGHT"})(q||(e.CloseDirection=q={}));class G{constructor(){this.c=new Map,this.d=new Map}start(B){const _=this.a=B.get(N.$vi);for(const[pe,ue]of this.c)this.e(pe,ue,_);this.c.clear()}e(B,_,pe){const ue=pe.createInstance(_);this.d.set(B,ue)}registerFileEditorFactory(B){if(this.b)throw new Error("Can only register one file editor factory.");this.b=B}getFileEditorFactory(){return(0,O.$hg)(this.b)}registerEditorSerializer(B,_){if(this.c.has(B)||this.d.has(B))throw new Error(`A editor serializer with type ID '${B}' was already registered.`);return this.a?this.e(B,_,this.a):this.c.set(B,_),(0,R.$Sc)(()=>{this.c.delete(B),this.d.delete(B)})}getEditorSerializer(B){return this.d.get(typeof B=="string"?B:B.typeId)}}b.$co.add(e.$tF.EditorFactory,new G);async function x(ee,B,_){return!ee||!ee.length?[]:await Promise.all(ee.map(async pe=>{const ue=L.URI.revive(pe.fileUri);if(!ue){_.info("Cannot resolve the path because it is not valid.",pe);return}if(!await B.canHandleResource(ue)){_.info("Cannot resolve the path because it cannot be handled",pe);return}let oe=pe.exists,le=pe.type;if(typeof oe!="boolean"||typeof le!="number")try{le=(await B.stat(ue)).isDirectory?$.FileType.Directory:$.FileType.Unknown,oe=!0}catch(se){_.error(se),oe=!1}if(!oe&&pe.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",pe);return}if(le===$.FileType.Directory){_.info("Cannot resolve the path because it is a directory",pe);return}const K={...pe.options,pinned:!0};return oe?{resource:ue,options:K}:{resource:ue,options:K,forceUntitled:!0}}))}var ne;(function(ee){ee[ee.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ee[ee.SEQUENTIAL=1]="SEQUENTIAL"})(ne||(e.EditorsOrder=ne={}));function be(ee){const B=ee;if(!B)return!1;const _=B;if(_.modified)return be(_.modified);const pe=B;return!!(pe.contributionsState&&pe.viewState&&Array.isArray(pe.cursorState))}function ae(ee){return(0,A.$ij)(ee)}function Ce(ee,B,_){const pe=(0,A.$jj)(ee,B);return pe.forceMessage=_?.forceMessage,pe.forceSeverity=_?.forceSeverity,pe.allowDialog=_?.allowDialog,pe}}),define(Se[294],De([1,0,4,239,5,3,27,36,24,79,281]),function(he,e,d,O,L,R,N,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4F=e.$3F=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$2F=e.ViewContentGroups=e.$ZF=e.ViewContainerLocation=e.Extensions=e.$YF=e.$XF=e.$WF=void 0,e.$1F=y,e.$WF="views",e.$XF=(0,O.localize)(0,null),e.$YF=(0,A.$fx)("default-view-icon",k.$Vj.window,(0,O.localize)(1,null));var C;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(C||(e.Extensions=C={}));var p;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$ZF=[0,1,2];function y(t){switch(t){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class v extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new d.$de),this.onDidRegister=this.c.event,this.f=this.B(new d.$de),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(c,r,a){const f=this.get(c.id);if(f)return f;const g=c;return g.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,N.$xc)(this.g,r,[]).push(g),a?.isDefault&&this.h.push(g),this.c.fire({viewContainer:g,viewContainerLocation:r}),g}deregisterViewContainer(c){for(const r of this.g.keys()){const a=this.g.get(r),f=a?.indexOf(c);if(f!==-1){a?.splice(f,1),a.length===0&&this.g.delete(r),this.f.fire({viewContainer:c,viewContainerLocation:r});return}}}get(c){return this.all.filter(r=>r.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(r=>this.getViewContainers(r).filter(a=>a?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(r=>this.getViewContainerLocation(r)===c)}}b.$co.add(C.ViewContainersRegistry,new v);var h;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(h||(e.ViewContentGroups=h={}));function l(t,c){const r=t.group??h.More,a=c.group??h.More;return r!==a?r.localeCompare(a):(t.order??5)-(c.order??5)}class o extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new d.$de),this.onViewsRegistered=this.c.event,this.f=this.B(new d.$de),this.onViewsDeregistered=this.f.event,this.g=this.B(new d.$de),this.onDidChangeContainer=this.g.event,this.h=this.B(new d.$de),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new N.$Hc}registerViews(c,r){this.registerViews2([{views:c,viewContainer:r}])}registerViews2(c){c.forEach(({views:r,viewContainer:a})=>this.r(r,a)),this.c.fire(c)}deregisterViews(c,r){const a=this.s(c,r);a.length&&this.f.fire({views:a,viewContainer:r})}moveViews(c,r){for(const a of this.m.keys())if(a!==r){const f=this.s(c,a);f.length&&(this.r(f,r),this.g.fire({views:f,from:a,to:r}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const r of this.j){const a=(this.m.get(r)||[]).filter(f=>f.id===c)[0];if(a)return a}return null}getViewContainer(c){for(const r of this.j)if((this.m.get(r)||[]).filter(f=>f.id===c)[0])return r;return null}registerViewWelcomeContent(c,r){return this.n.add(c,r),this.h.fire(c),(0,R.$Sc)(()=>{this.n.delete(c,r),this.h.fire(c)})}registerViewWelcomeContent2(c,r){const a=new Map;for(const[f,g]of r)this.n.add(c,g),a.set(f,(0,R.$Sc)(()=>{this.n.delete(c,g),this.h.fire(c)}));return this.h.fire(c),a}getViewWelcomeContent(c){const r=[];return this.n.forEach(c,a=>r.push(a)),r.sort(l)}r(c,r){let a=this.m.get(r);a||(a=[],this.m.set(r,a),this.j.push(r));for(const f of c){if(this.getView(f.id)!==null)throw new Error((0,O.localize)(2,null,f.id));a.push(f)}}s(c,r){const a=this.m.get(r);if(!a)return[];const f=[],g=[];for(const w of a)c.includes(w)?f.push(w):g.push(w);return f.length&&(g.length?this.m.set(r,g):(this.m.delete(r),this.j.splice(this.j.indexOf(r),1))),f}}b.$co.add(C.ViewsRegistry,new o),e.$2F=(0,L.$wi)("viewDescriptorService");var n;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var i;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class u{constructor(c,r){this.c=!1,this.d=!1,(0,$.$6n)(this,c),this.d=!!r,this.resolve=async a=>{if(r&&!this.c){const f=await r(a);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$3F=u;class s extends Error{constructor(c){super((0,O.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$4F=s}),define(Se[295],De([1,0,240,38]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=void 0,e.$8F=new O.$Nj("chatSessionResponseVote","",{type:"string",description:(0,d.localize)(0,null)}),e.$9F=new O.$Nj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,d.localize)(1,null)}),e.$0F=new O.$Nj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,d.localize)(2,null)}),e.$$F=new O.$Nj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,d.localize)(3,null)}),e.$_F=new O.$Nj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,d.localize)(4,null)}),e.$aG=new O.$Nj("chatResponse",!1,{type:"boolean",description:(0,d.localize)(5,null)}),e.$bG=new O.$Nj("chatRequest",!1,{type:"boolean",description:(0,d.localize)(6,null)}),e.$cG=new O.$Nj("chatEditApplied",!1,{type:"boolean",description:(0,d.localize)(7,null)}),e.$dG=new O.$Nj("chatInputHasText",!1,{type:"boolean",description:(0,d.localize)(8,null)}),e.$eG=new O.$Nj("chatInputHasFocus",!1,{type:"boolean",description:(0,d.localize)(9,null)}),e.$fG=new O.$Nj("inChatInput",!1,{type:"boolean",description:(0,d.localize)(10,null)}),e.$gG=new O.$Nj("inChat",!1,{type:"boolean",description:(0,d.localize)(11,null)}),e.$hG=new O.$Nj("chatIsEnabled",!1,{type:"boolean",description:(0,d.localize)(12,null)}),e.$iG=new O.$Nj("chatCursorAtTop",!1),e.$jG=new O.$Nj("chatInputHasAgent",!1),e.$kG=new O.$Nj("chatLocation",void 0)}),define(Se[296],De([1,0,7,22,4,39,3,171,14,38,5,11,108,274,142,295]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.ChatAgentLocation=void 0;var o;(function(s){s.Panel="panel",s.Terminal="terminal",s.Notebook="notebook",s.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(s){function t(c){switch(c){case"panel":return s.Panel;case"terminal":return s.Terminal;case"notebook":return s.Notebook;case"editor":return s.Editor}return s.Panel}s.fromRaw=t}(o||(e.ChatAgentLocation=o={})),e.$iH=(0,A.$wi)("chatAgentService");let n=class{static{this.AGENT_LEADER="@"}constructor(t){this.f=t,this.b=[],this.d=new L.$de,this.onDidChangeAgents=this.d.event,this.e=h.$hG.bindTo(this.f)}registerAgent(t,c){if(this.getAgent(t))throw new Error(`Agent already registered: ${JSON.stringify(t)}`);const a=this,f=c.slashCommands;c={...c,get slashCommands(){return f.filter(w=>!w.when||a.f.contextMatchesRules(k.$uj.deserialize(w.when)))}};const g={data:c};return this.b.push(g),(0,N.$Sc)(()=>{this.b=this.b.filter(w=>w!==g),this.d.fire(void 0)})}registerAgentImplementation(t,c){const r=this.g(t);if(!r)throw new Error(`Unknown agent: ${JSON.stringify(t)}`);if(r.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(t)}`);return r.data.isDefault&&this.e.set(!0),r.impl=c,this.d.fire(new i(r.data,c)),(0,N.$Sc)(()=>{r.impl=void 0,this.d.fire(void 0),r.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(t,c){const r={data:t,impl:c};return this.b.push(r),this.d.fire(new i(t,c)),(0,N.$Sc)(()=>{this.b=this.b.filter(a=>a!==r),this.d.fire(void 0)})}updateAgent(t,c){const r=this.g(t);if(!r?.impl)throw new Error(`No activated agent with id ${JSON.stringify(t)} registered`);r.data.metadata={...r.data.metadata,...c},this.d.fire(new i(r.data,r.impl))}getDefaultAgent(t){return this.getActivatedAgents().find(c=>!!c.isDefault&&c.locations.includes(t))}getContributedDefaultAgent(t){return this.getAgents().find(c=>!!c.isDefault&&c.locations.includes(t))}getSecondaryAgent(){return R.Iterable.find(this.b.values(),t=>!!t.data.metadata.isSecondary)?.data}g(t){return this.b.find(c=>c.data.id===t)}getAgent(t){return this.g(t)?.data}getAgents(){return this.b.map(t=>t.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(t=>!!t.impl).map(t=>new i(t.data,t.impl))}getAgentsByName(t){return this.getAgents().filter(c=>c.name===t)}async invokeAgent(t,c,r,a,f){const g=this.g(t);if(!g?.impl)throw new Error(`No activated agent with id ${t}`);return await g.impl.invoke(c,r,a,f)}async getFollowups(t,c,r,a,f){const g=this.g(t);if(!g?.impl)throw new Error(`No activated agent with id ${t}`);return g.impl?.provideFollowups?g.impl.provideFollowups(c,r,a,f):[]}};e.$jH=n,e.$jH=n=Ge([We(0,k.$Oj)],n);class i{constructor(t,c){this.b=t,this.d=c}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.extensionPublisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(t,c,r,a){return this.d.invoke(t,c,r,a)}async provideFollowups(t,c,r,a){return this.d.provideFollowups?this.d.provideFollowups(t,c,r,a):[]}provideWelcomeMessage(t,c){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(t,c)}provideSampleQuestions(t,c){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(t,c)}}e.$kH=i,e.$lH=(0,A.$wi)("chatAgentNameService");let u=class{static{l=this}static{this.b="chat.participantNameRegistry"}constructor(t,c,r,a){if(this.g=c,this.h=r,this.i=a,this.e=(0,b.$1d)(this,Object.create(null)),this.f=!1,!t.chatParticipantRegistry)return;this.d=t.chatParticipantRegistry;const f=a.get(l.b,-1);try{this.e.set(JSON.parse(f??"{}"),void 0)}catch{a.remove(l.b,-1)}this.j()}j(){this.f||this.k().catch(t=>this.h.warn("Failed to fetch chat participant registry",t)).then(()=>(0,d.$xh)(5*60*1e3)).then(()=>this.j())}async k(){const t=await this.g.request({type:"GET",url:this.d},O.CancellationToken.None);if(t.res.statusCode!==200)throw new Error("Could not get extensions report.");const c=await(0,y.$Tp)(t);if(!c||c.version!==1)throw new Error("Unexpected chat participant registry response.");const r=c.restrictedChatParticipants;this.e.set(r,void 0),this.i.store(l.b,JSON.stringify(r),-1,1)}getAgentNameRestriction(t){return this.e.map(r=>r[t.name.toLowerCase()]).map(r=>r?r.some(a=>(0,$.$xf)(a,a.includes(".")?t.extensionId.value:t.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$mH=u,e.$mH=u=l=Ge([We(0,p.$jk),We(1,y.$Np),We(2,C.$3j),We(3,v.$1p)],u)}),define(Se[297],De([1,0,2,29,5]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sG=e.$rG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$pG=R,e.$qG=N;function R(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof d.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(O.$ut.isIRange)}function N(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(R)}var b;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var $;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$rG=(0,L.$wi)("IChatService"),e.$sG="accessibility.voice.keywordActivation"}),define(Se[144],De([1,0,4,7,241]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rrb=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new d.$de,this.o=new d.$de,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(b){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=b}onEvent(b){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=b}onRequest(b){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.u("response",b)}sendRequest(b,$,k,A){const C={command:b};if($&&Object.keys($).length>0&&(C.arguments=$),this.u("request",C),typeof A=="number"){const p=setTimeout(()=>{clearTimeout(p);const y=this.f.get(C.seq);if(y){this.f.delete(C.seq);const v={type:"response",seq:0,request_seq:C.seq,success:!1,command:b,message:(0,L.localize)(0,null,A,b)};y(v)}},A)}return k&&this.f.set(C.seq,k),C.seq}acceptMessage(b){this.k?this.k(b):(this.m.push(b),this.m.length===1&&this.s())}q(b,$){return b.type!=="event"||$.type!=="event"}async s(){let b;for(;this.m.length;){if((!b||this.q(this.m[0],b))&&await(0,O.$xh)(0),b=this.m.shift(),!b)return;switch(b.type){case"event":this.j?.(b);break;case"request":this.g?.(b);break;case"response":{const $=b,k=this.f.get($.request_seq);k&&(this.f.delete($.request_seq),k($));break}}}}u(b,$){$.type=b,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach(($,k)=>b.set(k,$)),await(0,O.$xh)(500),b.forEach(($,k)=>{$({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Rrb=R}),define(Se[298],De([1,0,2,242,38,5]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$CJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$AJ=e.MemoryRangeType=e.State=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=void 0,e.$zJ=$,e.$BJ=A,e.$nI="workbench.view.debug",e.$oI="workbench.debug.variablesView",e.$pI="workbench.debug.watchExpressionsView",e.$qI="workbench.debug.callStackView",e.$rI="workbench.debug.loadedScriptsView",e.$sI="workbench.debug.breakPointsView",e.$tI="workbench.debug.disassemblyView",e.$uI="workbench.panel.repl",e.$vI="workbench.panel.repl.view",e.$wI=new L.$Nj("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.$xI=new L.$Nj("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.$yI=new L.$Nj("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.$zI="debugUx",e.$AI=new L.$Nj(e.$zI,"default",{type:"string",description:O.localize(3,null)}),e.$BI=new L.$Nj("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.$CI=new L.$Nj("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.$DI=new L.$Nj("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.$EI=new L.$Nj("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.$FI=new L.$Nj("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.$GI=new L.$Nj("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.$HI=new L.$Nj("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.$II=new L.$Nj("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.$JI=new L.$Nj("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.$KI=new L.$Nj("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.$LI=new L.$Nj("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.$MI=new L.$Nj("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.$NI=new L.$Nj("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.$OI=new L.$Nj("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.$PI=new L.$Nj("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.$QI=new L.$Nj("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.$RI=new L.$Nj("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.$SI=new L.$Nj("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.$TI=new L.$Nj("breakpointItemBytes",void 0,{type:"boolean",description:O.localize(22,null)}),e.$UI=new L.$Nj("breakpointHasModes",!1,{type:"boolean",description:O.localize(23,null)}),e.$VI=new L.$Nj("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(24,null)}),e.$WI=new L.$Nj("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(25,null)}),e.$XI=new L.$Nj("loadedScriptsItemType",void 0,{type:"string",description:O.localize(26,null)}),e.$YI=new L.$Nj("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(27,null)}),e.$ZI=new L.$Nj("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(28,null)}),e.$1I=new L.$Nj("stepBackSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.$2I=new L.$Nj("restartFrameSupported",!1,{type:"boolean",description:O.localize(30,null)}),e.$3I=new L.$Nj("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(31,null)}),e.$4I=new L.$Nj("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.$5I=new L.$Nj("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(33,null)}),e.$6I=new L.$Nj("breakpointsExist",!1,{type:"boolean",description:O.localize(34,null)}),e.$7I=new L.$Nj("debuggersAvailable",!1,{type:"boolean",description:O.localize(35,null)}),e.$8I=new L.$Nj("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(36,null)}),e.$9I=new L.$Nj("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(37,null)}),e.$0I=new L.$Nj("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.$$I=new L.$Nj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.$_I=new L.$Nj("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.$aJ=new L.$Nj("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.$bJ=new L.$Nj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.$cJ=new L.$Nj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.$dJ=new L.$Nj("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(44,null)}),e.$eJ=new L.$Nj("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(45,null)}),e.$fJ=new L.$Nj("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(46,null)}),e.$gJ=new L.$Nj("variableIsReadonly",!1,{type:"boolean",description:O.localize(47,null)}),e.$hJ=new L.$Nj("variableValue",!1,{type:"string",description:O.localize(48,null)}),e.$iJ=new L.$Nj("variableType",!1,{type:"string",description:O.localize(49,null)}),e.$jJ=new L.$Nj("variableInterfaces",!1,{type:"array",description:O.localize(50,null)}),e.$kJ=new L.$Nj("variableName",!1,{type:"string",description:O.localize(51,null)}),e.$lJ=new L.$Nj("variableLanguage",!1,{type:"string",description:O.localize(52,null)}),e.$mJ=new L.$Nj("variableExtensionId",!1,{type:"string",description:O.localize(53,null)}),e.$nJ=new L.$Nj("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(54,null)}),e.$oJ=new L.$Nj("multiSessionRepl",!1,{type:"boolean",description:O.localize(55,null)}),e.$pJ=new L.$Nj("multiSessionDebug",!1,{type:"boolean",description:O.localize(56,null)}),e.$qJ=new L.$Nj("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(57,null)}),e.$rJ=new L.$Nj("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(58,null)}),e.$sJ=new L.$Nj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(59,null)}),e.$tJ=new L.$Nj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(60,null)});const N=i=>O.localize(61,null,i);e.$uJ=N,e.$vJ="editor.contrib.debug",e.$wJ="editor.contrib.breakpoint",e.$xJ="debug",e.$yJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(62,null)};var b;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(b||(e.State=b={}));function $(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var k;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$AJ="vscode-debug-memory";function A(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var C;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(C||(e.DataBreakpointSetType=C={}));var p;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(p||(e.DebugConfigurationProviderTriggerKind=p={}));var y;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(y||(e.DebuggerString=y={})),e.$CJ=(0,R.$wi)("debugService");var v;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(v||(e.BreakpointWidgetContext=v={}));var h;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(h||(e.DebugVisualizationType=h={}));var l;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(l||(e.DebugTreeItemCollapsibleState=l={}));var o;(function(i){i.deserialize=u=>u,i.serialize=u=>u})(o||(e.IDebugVisualizationTreeItem=o={}));var n;(function(i){i.deserialize=u=>({id:u.id,name:u.name,iconPath:u.iconPath&&{light:d.URI.revive(u.iconPath.light),dark:d.URI.revive(u.iconPath.dark)},iconClass:u.iconClass,visualization:u.visualization}),i.serialize=u=>u})(n||(e.IDebugVisualization=n={}))}),define(Se[299],De([1,0,14,2,17,24,15,29,22,19]),function(he,e,d,O,L,R,N,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BH=void 0,e.$pH=C,e.$qH=p,e.$rH=y,e.$sH=v,e.$tH=h,e.$uH=l,e.$vH=o,e.$wH=i,e.$xH=t,e.$yH=c,e.$zH=a,e.$AH=g;const A=/{([^}]+)}/g;function C(S,m,E){return S.replace(A,function(D,P){return m&&P.length>0&&P[0]!=="_"?D:E&&E.hasOwnProperty(P)?E[P]:D})}function p(S){const m={};for(const E of Object.keys(S))E.startsWith("!")||(m[E]=S[E]);return m}function y(S){return S.configuration.request==="attach"&&!v(S)&&(!S.parentSession||y(S.parentSession))}function v(S){let m=S.configuration.type;if(m)return m==="vslsShare"&&(m=S.configuration.adapterProxy.configuration.type),(0,d.$xf)(m,"extensionhost")||(0,d.$xf)(m,"pwa-extensionhost")?S:S.parentSession?v(S.parentSession):void 0}function h(S){return S.type&&(S.label||S.program||S.runtime)}function l(S,m,E){let D,P=0;const I=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let F=null;for(;F=I.exec(S);){const T=F.index+1,z=T+F[0].length;if(T<=m&&z>=E){D=F[0],P=T;break}}if(D){const T=/\w+/g;let z=null;for(;(z=T.exec(D))&&!(z.index+1+P+z[0].length>=E););z&&(D=D.substring(0,T.lastIndex))}return D?{start:P,end:P+D.length-1}:{start:0,end:0}}async function o(S,m,E,D){if(S.evaluatableExpressionProvider.has(m)){const P=S.evaluatableExpressionProvider.ordered(m),I=(0,k.$Hb)(await Promise.all(P.map(async F=>{try{return await F.provideEvaluatableExpression(m,E,D??$.CancellationToken.None)}catch{return}})));if(I.length>0){let F=I[0].expression;const T=I[0].range;return F||(F=m.getLineContent(E.lineNumber).substring(T.startColumn-1,T.endColumn-1)),{range:T,matchingExpression:F}}}else{const P=m.getLineContent(E.lineNumber),{start:I,end:F}=l(P,E.column,E.column),T=P.substring(I-1,F);return{matchingExpression:T,range:new b.$ut(E.lineNumber,I,E.lineNumber,I+T.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(S){return!!(S&&S.match(n))}function u(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(i(S.path))return O.URI.parse(S.path);if((0,L.$ic)(S.path))return O.URI.file(S.path)}return S.path}function s(S){if(typeof S.path=="object"){const m=O.URI.revive(S.path);if(m)return m.scheme===N.Schemas.file?m.fsPath:m.toString()}return S.path}function t(S,m){const E=m?u:s,D=(0,R.$3n)(S);return r(D,(P,I)=>{P&&I&&(I.path=E(I))}),D}function c(S,m){const E=m?u:s,D=(0,R.$3n)(S);return r(D,(P,I)=>{!P&&I&&(I.path=E(I))}),D}function r(S,m){switch(S.type){case"event":{const E=S;switch(E.event){case"output":m(!1,E.body.source);break;case"loadedSource":m(!1,E.body.source);break;case"breakpoint":m(!1,E.body.breakpoint.source);break;default:break}break}case"request":{const E=S;switch(E.command){case"setBreakpoints":m(!0,E.arguments.source);break;case"breakpointLocations":m(!0,E.arguments.source);break;case"source":m(!0,E.arguments.source);break;case"gotoTargets":m(!0,E.arguments.source);break;case"launchVSCode":E.arguments.args.forEach(D=>m(!1,D));break;default:break}break}case"response":{const E=S;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(D=>m(!1,D.source));break;case"loadedSources":E.body.sources.forEach(D=>m(!1,D));break;case"scopes":E.body.scopes.forEach(D=>m(!1,D.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(D=>m(!1,D.source));break;case"setBreakpoints":E.body.breakpoints.forEach(D=>m(!1,D.source));break;case"disassemble":E.body?.instructions.forEach(P=>m(!1,P.location));break;default:break}break}}}function a(S){return S.filter(m=>!m.presentation?.hidden).sort((m,E)=>m.presentation?E.presentation?m.presentation.group?E.presentation.group?m.presentation.group!==E.presentation.group?m.presentation.group.localeCompare(E.presentation.group):f(m.presentation.order,E.presentation.order):-1:E.presentation.group?1:f(m.presentation.order,E.presentation.order):-1:E.presentation?1:0)}function f(S,m){return typeof S!="number"?typeof m!="number"?0:1:typeof m!="number"?-1:S-m}async function g(S,m){const E=S.getValue("debug.saveBeforeStart",{overrideIdentifier:m.activeTextEditorLanguageId});if(E!=="none"&&(await m.saveAll(),E==="allEditorsInActiveGroup")){const D=m.activeEditorPane;D&&D.input.resource?.scheme===N.Schemas.untitled&&await m.save({editor:D.input,groupId:D.group.id})}await S.reloadConfiguration()}const w=(S,m)=>!S||!m?S===m:S.name===m.name&&S.path===m.path&&S.sourceReference===m.sourceReference;e.$BH=w}),define(Se[300],De([1,0,54,63,24,17,12,14,32,243,144]),function(he,e,d,O,L,R,N,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lnc=e.$Knc=e.$Jnc=e.$Inc=e.$Hnc=void 0;class C extends A.$Rrb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(o,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,o.on("data",i=>this.v(i))}sendMessage(o){if(this.l){const n=JSON.stringify(o);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${C.a}${n}`,"utf8")}}v(o){for(this.p=Buffer.concat([this.p,o]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(C.a);if(n!==-1){const u=this.p.toString("utf8",0,n).split(C.b);for(const s of u){const t=s.split(C.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+C.a.length);continue}}break}}}e.$Hnc=C;class p extends C{startSession(){return new Promise((o,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),o(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",u=>{i?this.n.fire(u):n(u)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$Inc=p;class y extends p{constructor(o){super(),this.z=o}y(o){return O.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$Jnc=y;class v extends p{constructor(o){super(),this.z=o}y(o){return O.createConnection(this.z.path,o)}}e.$Knc=v;class h extends C{constructor(o,n){super(),this.y=o,this.z=n}async startSession(){const o=this.y.command,n=this.y.args,i=this.y.options||{};try{if(o)if(R.$ic(o)){if(!await $.Promises.exists(o))throw new Error(k.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.z));let u=process.env;if(i.env&&Object.keys(i.env).length>0&&(u=L.$6n(L.$3n(process.env),i.env)),o==="node")if(Array.isArray(n)&&n.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:u,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const c=d.fork(n[0],n.slice(1),t);if(!c.pid)throw new Error(k.localize(2,null,n[0]));this.x=c}else throw new Error(k.localize(3,null));else{const s={env:u};i.cwd&&(s.cwd=i.cwd),this.x=d.spawn(o,n,s)}this.x.on("error",s=>{this.n.fire(s)}),this.x.on("exit",(s,t)=>{this.o.fire(s)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",s=>{this.n.fire(s)}),this.x.stdin.on("error",s=>{this.n.fire(s)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(u){this.n.fire(u)}}async stopSession(){return this.x?(await this.w(),N.$i?new Promise((o,n)=>{const i=d.exec(`taskkill /F /T /PID ${this.x.pid}`,function(u,s,t){if(u)return n(u)});i.on("exit",o),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,n){if(!o)return;const i=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?i.runtime=R.$jc(n,o.runtime):i.runtime=o.runtime),o.runtimeArgs&&(i.runtimeArgs=o.runtimeArgs),o.program&&(R.$ic(o.program)?i.program=o.program:i.program=R.$jc(n,o.program)),o.args&&(i.args=o.args);const u=o;return u.win&&(i.win=h.A(u.win,n)),u.winx86&&(i.winx86=h.A(u.winx86,n)),u.windows&&(i.windows=h.A(u.windows,n)),u.osx&&(i.osx=h.A(u.osx,n)),u.linux&&(i.linux=h.A(u.linux,n)),i}static platformAdapterExecutable(o,n){let i=Object.create(null);n=n.toLowerCase();for(const a of o)if(a.contributes){const f=a.contributes.debuggers;f&&f.length>0&&f.filter(g=>typeof g.type=="string"&&b.$xf(g.type,n)).forEach(g=>{const w=h.A(g,a.extensionLocation.fsPath);i=L.$6n(i,w,a.isBuiltin)})}let u;N.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?u=i.winx86||i.win||i.windows:N.$i?u=i.win||i.windows:N.$j?u=i.osx:N.$k&&(u=i.linux),u=u||i;const s=u.program||i.program,t=u.args||i.args,c=u.runtime||i.runtime,r=u.runtimeArgs||i.runtimeArgs;if(c)return{type:"executable",command:c,args:(r||[]).concat(typeof s=="string"?[s]:[]).concat(t||[])};if(s)return{type:"executable",command:s,args:t||[]}}}e.$Lnc=h}),define(Se[301],De([1,0,54,31,12]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnc=N,e.$Nnc=$;function R(k,A){return new Promise((C,p)=>{let y="";const v=d.spawn(k,A);v.pid&&v.stdout.on("data",h=>{y+=h.toString()}),v.on("error",h=>{p(h)}),v.on("close",h=>{C(y)})})}async function N(k){if(k)if(L.$i){const A=await new Promise((C,p)=>{he(["@vscode/windows-process-tree"],C,p)});return new Promise(C=>{A.getProcessTree(k,p=>{C(!!p&&p.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(k)]).then(A=>{const C=A.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}var b;(function(k){k[k.cmd=0]="cmd",k[k.powershell=1]="powershell",k[k.bash=2]="bash"})(b||(b={}));function $(k,A,C,p,y){k=k.trim().toLowerCase();let v;k.indexOf("powershell")>=0||k.indexOf("pwsh")>=0?v=1:k.indexOf("cmd.exe")>=0?v=0:k.indexOf("bash")>=0?v=2:L.$i?v=0:v=2;let h,l=" ";switch(v){case 1:if(h=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),p){const o=(0,O.$Bg)(p);o&&(l+=`${o}:; `),l+=`cd ${h(p)}; `}if(y)for(const o in y){const n=y[o];n===null?l+=`Remove-Item env:${o}; `:l+=`\${env:${o}}='${n}'; `}if(A.length>0){const o=A.shift(),n=C?o:h(o);l+=n[0]==="'"?`& ${n} `:`${n} `;for(const i of A)l+=i==="<"||i===">"||C?i:h(i),l+=" "}break;case 0:if(h=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(n=>o.includes(n))||o.length===0?`"${o}"`:o),p){const o=(0,O.$Bg)(p);o&&(l+=`${o}: && `),l+=`cd ${h(p)} && `}if(y){l+='cmd /C "';for(const o in y){let n=y[o];n===null?l+=`set "${o}=" && `:(n=n.replace(/[&^|<>]/g,i=>`^${i}`),l+=`set "${o}=${n}" && `)}}for(const o of A)l+=o==="<"||o===">"||C?o:h(o),l+=" ";y&&(l+='"');break;case 2:{h=n=>(n=n.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),n.length===0?'""':n);const o=n=>/[^\w@%\/+=,.:^-]/.test(n)?`'${n.replace(/'/g,"'\\''")}'`:n;if(p&&(l+=`cd ${h(p)} ; `),y){l+="/usr/bin/env";for(const n in y){const i=y[n];i===null?l+=` -u ${o(n)}`:l+=` ${o(`${n}=${i}`)}`}l+=" "}for(const n of A)l+=n==="<"||n===">"||C?n:h(n),l+=" ";break}}return l}}),define(Se[302],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.CellExecutionUpdateType=void 0;var O;(function(L){L[L.Output=1]="Output",L[L.OutputItems=2]="OutputItems",L[L.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$PK=(0,d.$wi)("INotebookExecutionService")}),define(Se[303],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jjb=e.$ijb=e.ProxyKernelState=e.$hjb=void 0,e.$hjb=100;var O;(function(L){L[L.Disconnected=1]="Disconnected",L[L.Connected=2]="Connected",L[L.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.$ijb=(0,d.$wi)("INotebookKernelService"),e.$jjb=(0,d.$wi)("INotebookKernelHistoryService")}),define(Se[304],De([1,0,3,29,205,100]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nXb=void 0;class N extends d.$Uc{constructor($,k,A){super(),this._source=$,this.b=k,this.c=A,this.a=void 0}f($){const k=$.getLineCount();return new O.$ut(1,1,k,this.g($,k))}g($,k){if(k<1||k>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const $=new L.$2C;$.acceptChunk(this._source);const k=$.finish(!0),{textBuffer:A,disposable:C}=k.create(1);this.b=A,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const k=new L.$2C;k.acceptChunk($);const A=k.finish(!0),{textBuffer:C,disposable:p}=A.create(1);return this.B(p),C})),this.a}findInInputs($){const A=new R.$PC($,!1,!1,null).parseSearchRequest();if(!A)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,A,!0,5e3)}findInOutputs($){const A=new R.$PC($,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(C=>{const p=C.findMatchesLineByLine(this.f(C),A,!0,5e3);if(p.length!==0)return{textBuffer:C,matches:p}}).filter(C=>!!C):[]}}e.$nXb=N}),define(Se[69],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(R){R.Delimiter="\0"})(d||(e.TestIdPathParts=d={}));var O;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class L{static fromExtHostTestItem(N,b,$=N.parent){if(N._isRoot)return new L([b]);const k=[N.id];for(let A=$;A&&A.id!==b;A=A.parent)k.push(A.id);return k.push(b),new L(k.reverse())}static isRoot(N){return!N.includes("\0")}static root(N){const b=N.indexOf("\0");return b===-1?N:N.slice(0,b)}static fromString(N){return new L(N.split("\0"))}static join(N,b){return new L([...N.path,b])}static joinToString(N,b){return N.toString()+"\0"+b}static parentId(N){const b=N.lastIndexOf("\0");return b===-1?void 0:N.slice(0,b)}static localId(N){const b=N.lastIndexOf("\0");return b===-1?N:N.slice(b+1)}static isChild(N,b){return b.startsWith(N)&&b[N.length]==="\0"}static compare(N,b){return N===b?0:L.isChild(N,b)?2:L.isChild(b,N)?3:1}constructor(N,b=N.length){if(this.path=N,this.d=b,N.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new L(this.path,1)}get parentId(){return this.d>1?new L(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let N=1;N<=this.d;N++)yield new L(this.path,N)}*idsToRoot(){for(let N=this.d;N>0;N--)yield new L(this.path,N)}compare(N){if(typeof N=="string")return L.compare(this.toString(),N);for(let b=0;b<N.d&&b<this.d;b++)if(N.path[b]!==this.path[b])return 1;return N.d>this.d?2:N.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let N=1;N<this.d;N++)this.c+="\0",this.c+=this.path[N]}return this.c}}e.$WL=L}),define(Se[89],De([1,0,2,51,29,69]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$5L=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$4L=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$3L=e.$2L=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$1L=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$ZL=e.$YL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$XL=e.TestResultState=void 0;var N;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(N||(e.TestResultState=N={})),e.$XL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var b;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var $;(function(M){M[M.Run=2]="Run",M[M.Debug=4]="Debug",M[M.Coverage=8]="Coverage",M[M.HasNonDefaultProfile=16]="HasNonDefaultProfile",M[M.HasConfigurable=32]="HasConfigurable",M[M.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$YL=[2,4,8,16,32,64];const k=M=>"runId"in M;e.$ZL=k;var A;(function(M){M.serialize=j=>({range:j.range.toJSON(),uri:j.uri.toJSON()}),M.deserialize=(j,U)=>({range:L.$ut.lift(U.range),uri:j.asCanonicalUri(d.URI.revive(U.uri))})})(A||(e.IRichLocation=A={}));var C;(function(M){M[M.Error=0]="Error",M[M.Output=1]="Output"})(C||(e.TestMessageType=C={}));var p;(function(M){M.serialize=j=>({message:j.message,type:0,expected:j.expected,actual:j.actual,contextValue:j.contextValue,location:j.location&&A.serialize(j.location)}),M.deserialize=(j,U)=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&A.deserialize(j,U.location)})})(p||(e.ITestErrorMessage=p={}));const y=(M,j)=>`${j?"s":"e"}${M}`;e.$1L=y;var v;(function(M){M.serialize=j=>({message:j.message,type:1,offset:j.offset,length:j.length,location:j.location&&A.serialize(j.location)}),M.deserialize=(j,U)=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&A.deserialize(j,U.location)})})(v||(e.ITestOutputMessage=v={}));var h;(function(M){M.serialize=j=>j.type===0?p.serialize(j):v.serialize(j),M.deserialize=(j,U)=>U.type===0?p.deserialize(j,U):v.deserialize(j,U)})(h||(e.ITestMessage=h={}));var l;(function(M){M.serializeWithoutMessages=j=>({state:j.state,duration:j.duration,messages:[]}),M.serialize=j=>({state:j.state,duration:j.duration,messages:j.messages.map(h.serialize)}),M.deserialize=(j,U)=>({state:U.state,duration:U.duration,messages:U.messages.map(Z=>h.deserialize(j,Z))})})(l||(e.ITestTaskState=l={}));const o="\0",n=(M,j)=>M+o+j;e.$2L=n;const i=M=>{const j=M.indexOf(o);return{ctrlId:M.slice(0,j),tagId:M.slice(j+1)}};e.$3L=i;var u;(function(M){M.serialize=j=>({extId:j.extId,label:j.label,tags:j.tags,busy:j.busy,children:void 0,uri:j.uri?.toJSON(),range:j.range?.toJSON()||null,description:j.description,error:j.error,sortText:j.sortText}),M.deserialize=(j,U)=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?j.asCanonicalUri(d.URI.revive(U.uri)):void 0,range:U.range?L.$ut.lift(U.range):null,description:U.description,error:U.error,sortText:U.sortText})})(u||(e.ITestItem=u={}));var s;(function(M){M[M.NotExpandable=0]="NotExpandable",M[M.Expandable=1]="Expandable",M[M.BusyExpanding=2]="BusyExpanding",M[M.Expanded=3]="Expanded"})(s||(e.TestItemExpandState=s={}));var t;(function(M){M.serialize=j=>({expand:j.expand,item:u.serialize(j.item)}),M.deserialize=(j,U)=>({controllerId:R.$WL.root(U.item.extId),expand:U.expand,item:u.deserialize(j,U.item)})})(t||(e.InternalTestItem=t={}));var c;(function(M){M.serialize=j=>{let U;return j.item&&(U={},j.item.label!==void 0&&(U.label=j.item.label),j.item.tags!==void 0&&(U.tags=j.item.tags),j.item.busy!==void 0&&(U.busy=j.item.busy),j.item.uri!==void 0&&(U.uri=j.item.uri?.toJSON()),j.item.range!==void 0&&(U.range=j.item.range?.toJSON()),j.item.description!==void 0&&(U.description=j.item.description),j.item.error!==void 0&&(U.error=j.item.error),j.item.sortText!==void 0&&(U.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:U}},M.deserialize=j=>{let U;return j.item&&(U={},j.item.label!==void 0&&(U.label=j.item.label),j.item.tags!==void 0&&(U.tags=j.item.tags),j.item.busy!==void 0&&(U.busy=j.item.busy),j.item.range!==void 0&&(U.range=j.item.range?L.$ut.lift(j.item.range):null),j.item.description!==void 0&&(U.description=j.item.description),j.item.error!==void 0&&(U.error=j.item.error),j.item.sortText!==void 0&&(U.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:U}}})(c||(e.ITestItemUpdate=c={}));const r=(M,j)=>{j.expand!==void 0&&(M.expand=j.expand),j.item!==void 0&&(M.item=M.item?Object.assign(M.item,j.item):j.item)};e.$4L=r;var a;(function(M){M.serializeWithoutMessages=j=>({...t.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(l.serializeWithoutMessages)}),M.serialize=j=>({...t.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(l.serialize)}),M.deserialize=(j,U)=>({...t.deserialize(j,U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(Z=>l.deserialize(j,Z)),retired:!0})})(a||(e.TestResultItem=a={}));var f;(function(M){M.empty=()=>({covered:0,total:0}),M.sum=(j,U)=>{j.covered+=U.covered,j.total+=U.total}})(f||(e.ICoverageCount=f={}));var g;(function(M){M.serialize=j=>({id:j.id,statement:j.statement,branch:j.branch,declaration:j.declaration,uri:j.uri.toJSON()}),M.deserialize=(j,U)=>({id:U.id,statement:U.statement,branch:U.branch,declaration:U.declaration,uri:j.asCanonicalUri(d.URI.revive(U.uri))})})(g||(e.IFileCoverage=g={}));function w(M){return{...M,location:M.location?.toJSON()}}function S(M){return M.location=M.location?O.$tt.isIPosition(M.location)?O.$tt.lift(M.location):L.$ut.lift(M.location):void 0,M}e.$5L=3;var m;(function(M){M[M.Declaration=0]="Declaration",M[M.Statement=1]="Statement",M[M.Branch=2]="Branch"})(m||(e.DetailType=m={}));var E;(function(M){M.serialize=j=>j.type===0?P.serialize(j):I.serialize(j),M.deserialize=j=>j.type===0?P.deserialize(j):I.deserialize(j)})(E||(e.CoverageDetails=E={}));var D;(function(M){M.serialize=w,M.deserialize=S})(D||(e.IBranchCoverage=D={}));var P;(function(M){M.serialize=w,M.deserialize=S})(P||(e.IDeclarationCoverage=P={}));var I;(function(M){M.serialize=j=>({...w(j),branches:j.branches?.map(D.serialize)}),M.deserialize=j=>({...S(j),branches:j.branches?.map(D.deserialize)})})(I||(e.IStatementCoverage=I={}));var F;(function(M){M[M.Add=0]="Add",M[M.Update=1]="Update",M[M.DocumentSynced=2]="DocumentSynced",M[M.Remove=3]="Remove",M[M.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",M[M.Retire=5]="Retire",M[M.AddTag=6]="AddTag",M[M.RemoveTag=7]="RemoveTag"})(F||(e.TestDiffOpType=F={}));var T;(function(M){M.deserialize=(j,U)=>U.op===0?{op:U.op,item:t.deserialize(j,U.item)}:U.op===1?{op:U.op,item:c.deserialize(U.item)}:U.op===2?{op:U.op,uri:j.asCanonicalUri(d.URI.revive(U.uri)),docv:U.docv}:U,M.serialize=j=>j.op===0?{op:j.op,item:t.serialize(j.item)}:j.op===1?{op:j.op,item:c.serialize(j.item)}:j})(T||(e.TestsDiffOp=T={}));class z{constructor(j){this.k=j,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(j){const U=this.v();for(const Z of j)switch(Z.op){case 0:this.l(t.deserialize(this.k,Z.item),U);break;case 1:this.o(c.deserialize(Z.item),U);break;case 3:this.p(Z.itemId,U);break;case 5:this.q(Z.itemId);break;case 4:this.updatePendingRoots(Z.amount);break;case 6:this.c.set(Z.tag.id,Z.tag);break;case 7:this.c.delete(Z.id);break}U.complete?.()}l(j,U){const Z=R.$WL.parentId(j.item.extId)?.toString();let ie;if(!Z)ie=this.w(j),this.g.add(ie),this.f.set(j.item.extId,ie);else if(this.f.has(Z)){const q=this.f.get(Z);q.children.add(j.item.extId),ie=this.w(j,q),this.f.set(j.item.extId,ie)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(j)}`);return}return U.add?.(ie),j.expand===2&&this.h++,ie}o(j,U){const Z=this.f.get(j.extId);if(Z)return j.expand!==void 0&&(Z.expand===2&&this.h--,j.expand===2&&this.h++),(0,e.$4L)(Z,j),U.update?.(Z),Z}p(j,U){const Z=this.f.get(j);if(!Z)return;const ie=R.$WL.parentId(Z.item.extId)?.toString();ie?this.f.get(ie).children.delete(Z.item.extId):this.g.delete(Z);const q=[[j]];for(;q.length;)for(const G of q.pop()){const x=this.f.get(G);x&&(q.push(x.children),this.f.delete(G),U.remove?.(x,x!==Z),x.expand===2&&this.h--)}}q(j){}updatePendingRoots(j){this.j+=j}v(){return{}}}e.$6L=z}),define(Se[113],De([1,0,7,4,3,62,89,69]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tP=e.$sP=e.$rP=e.$qP=e.$pP=e.TestItemEventOp=void 0;var $;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const k=(n,i)=>n===i,C=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:k,label:k,description:k,error:k,sortText:k,tags:(n,i)=>!(n.length!==i.length||n.some(u=>!i.includes(u)))}),p=(n,i)=>{let u;for(const[s,t]of C)t(n[s],i[s])||(u?u[s]=i[s]:u={[s]:i[s]});return u};class y extends L.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new d.$Ih(()=>this.flushDiff(),200)),this.g=this.B(new O.$de),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const u of this.tree.values())this.J(u)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const u of this.m)if(u.op===2&&u.uri===i.uri){u.docv=i.docv;return}break}case 1:{const u=this.m[this.m.length-1];if(u){if(u.op===1&&u.item.extId===i.item.extId){(0,N.$4L)(u.item,i.item);return}if(u.op===0&&u.item.item.extId===i.item.extId){(0,N.$4L)(u.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,u){const s=this.tree.get(i);if(s){if((s.expandLevels===void 0||u>s.expandLevels)&&(s.expandLevels=u),s.expand===1){const t=this.M(s);return t.isOpen()?this.L(s,u-1):t.wait().then(()=>this.L(s,u-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.L(s,u-1)):this.L(s,u-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,u){switch(u.op){case 3:this.O(b.$WL.joinToString(i.fullId,u.id));break;case 0:this.z(u.item,i);break;case 5:for(const s of u.ops)this.w(i,s);break;case 1:this.C(u.new,u.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:u.update}});break;case 6:this.y(i.actual.uri);break;default:(0,R.$ed)(u)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,u){const s=b.$WL.fromExtHostTestItem(i,this.root.id,u?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==u?.actual&&this.s.getChildren(t.parent).delete(i.id);let c=this.tree.get(s.toString());if(!c){c={fullId:s,actual:i,expandLevels:u?.expandLevels?u.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(c.fullId.toString(),c),this.G(i,u),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:c.expand,item:this.s.toITestItem(i)}}),this.I(i,c,u);return}if(c.actual===i){this.H(i,c,u);return}if(c.actual.uri?.toString()!==i.uri?.toString())return this.O(s.toString()),this.z(i,u);const r=this.s.getChildren(c.actual),a=c.actual,f=p(this.s.toITestItem(a),this.s.toITestItem(i));this.s.getApiFor(a).listener=void 0,c.actual=i,c.resolveBarrier=void 0,c.expand=0,f&&(f.hasOwnProperty("tags")&&(this.C(i.tags,a.tags,s.toString()),delete f.tags),this.w(c,{op:4,update:f})),this.I(i,c,u);for(const[w,S]of r)this.s.getChildren(i).get(S.id)||this.O(b.$WL.joinToString(s,S.id));const g=c.expandLevels;g!==void 0&&queueMicrotask(()=>{c.expand===1&&(c.expandLevels=void 0,this.expand(s.toString(),g))}),this.y(c.actual.uri)}C(i,u,s){const t=new Set(u.map(c=>c.id));for(const c of i)t.delete(c.id)||this.D(c);this.pushDiff({op:1,item:{extId:s,item:{tags:i.map(c=>(0,N.$2L)(this.s.controllerId,c.id))}}}),t.forEach(this.F,this)}D(i){const u=this.j.get(i.id);u?u.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,N.$2L)(this.s.controllerId,i.id)}}))}F(i){const u=this.j.get(i);u&&!--u.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,N.$2L)(this.s.controllerId,i)}))}G(i,u){this.s.getApiFor(i).parent=u&&u.actual!==this.root?u.actual:void 0}H(i,u,s){this.G(i,s);const t=this.s.getApiFor(i);t.parent=s?.actual,t.listener=c=>this.w(u,c),this.J(u)}I(i,u,s){this.H(i,u,s);for(const[t,c]of this.s.getChildren(i))this.z(c,u)}J(i){let u;this.h?i.resolveBarrier?u=i.resolveBarrier.isOpen()?3:2:u=i.actual.canResolveChildren?1:0:u=0,u!==i.expand&&(i.expand=u,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:u}}),u===1&&i.expandLevels!==void 0&&this.M(i))}L(i,u){if(u<0)return;const s=[];for(const[t,c]of this.s.getChildren(i.actual)){const r=this.expand(b.$WL.joinToString(i.fullId,c.id),u);(0,d.$ih)(r)&&s.push(r)}if(s.length)return Promise.all(s).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const c=new d.$vh;return c.open(),c}i.expand=2,this.N(i);const u=i.resolveBarrier=new d.$vh,s=c=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,c)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(c){s(c)}return(0,d.$ih)(t)?t.catch(s).then(()=>{u.open(),this.J(i)}):(u.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const u=this.tree.get(i);if(!u)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const s=[u];for(;s.length;){const t=s.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const c of t.actual.tags)this.F(c.id);this.tree.delete(t.fullId.toString());for(const[c,r]of this.s.getChildren(t.actual))s.push(this.tree.get(b.$WL.joinToString(t.fullId,r.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$pP=y;class v extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$qP=v;class h extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$rP=h;class l extends Error{constructor(i,u,s){super(`TestItem with ID "${i}" is from controller "${u}" and cannot be added as a child of an item from controller "${s}".`)}}e.$sP=l;const o=(n,i,u)=>{let s=new Map;return{get size(){return s.size},forEach(t,c){for(const r of s.values())t.call(c,r,this)},[Symbol.iterator](){return s.entries()},replace(t){const c=new Map,r=new Set(s.keys()),a={op:5,ops:[]};for(const f of t){if(!(f instanceof u))throw new h(f.id);const g=i(f).controllerId;if(g!==n.controllerId)throw new l(f.id,g,n.controllerId);if(c.has(f.id))throw new v(f.id);c.set(f.id,f),r.delete(f.id),a.ops.push({op:0,item:f})}for(const f of r.keys())a.ops.push({op:3,id:f});n.listener?.(a),s=c},add(t){if(!(t instanceof u))throw new h(t.id);s.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){s.delete(t)&&n.listener?.({op:3,id:t})},get(t){return s.get(t)},toJSON(){return Array.from(s.values())}}};e.$tP=o}),define(Se[145],De([1,0,113]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vP=e.$uP=void 0;const O=new WeakMap,L=(N,b)=>{const $={controllerId:b};return O.set(N,$),$};e.$uP=L;const R=N=>{const b=O.get(N);if(!b)throw new d.$rP(N?.id||"<unknown>");return b};e.$vP=R}),define(Se[114],De([1,0,15,2]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MAb=e.$LAb=e.$KAb=void 0,e.$NAb=L,e.$OAb=N,e.$KAb="vscode-cdn.net",e.$LAb=`vscode-resource.${e.$KAb}`,e.$MAb=`'self' https://*.${e.$KAb}`;function L(b,$){return b.scheme===d.Schemas.http||b.scheme===d.Schemas.https?b:($&&$.authority&&$.isRemote&&b.scheme===d.Schemas.file&&(b=O.URI.from({scheme:d.Schemas.vscodeRemote,authority:$.authority,path:b.path})),O.URI.from({scheme:d.Schemas.https,authority:`${b.scheme}+${R(b.authority)}.${e.$LAb}`,path:b.path,fragment:b.fragment,query:b.query}))}function R(b){return b.replace(/./g,$=>{const k=$.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?$:"-"+k.toString(16).padStart(4,"0")})}function N(b){return b.replace(/-([0-9a-f]{4})/g,($,k)=>String.fromCharCode(parseInt(k,16)))}}),define(Se[305],De([1,0,4,3,114]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=void 0;class R{constructor(b,$,k){this.d=b,this.e=$,this.f=k,this.a=0,this.b=new O.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const A=$.getVisibleTextEditors();for(const C of this.c.values())A.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,$,k,A,C){let p;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===b){p=i;break}if(!p)throw new Error("not a visible editor");const y=this,v=this.a++,h=new d.$de,l=new d.$de,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,L.$NAb)(i,y.f)}get cspSource(){return L.$MAb}set options(i){this.b=i,y.d.$setOptions(v,i)}get options(){return this.b}set html(i){this.a=i,y.d.$setHtml(v,i)}get html(){return this.a}get onDidReceiveMessage(){return h.event}postMessage(i){return y.d.$postMessage(v,i)}},n=new class{constructor(){this.editor=b,this.line=$,this.height=k,this.webview=o,this.onDidDispose=l.event}dispose(){y.c.has(v)&&(y.c.delete(v),y.d.$disposeEditorInset(v),l.fire(),l.dispose(),h.dispose())}};return this.d.$createEditorInset(v,p.id,p.value.document.uri,$+1,k,A||{},C.identifier,C.extensionLocation),this.c.set(v,{editor:b,inset:n,onDidReceiveMessage:h}),n}$onDidDispose(b){const $=this.c.get(b);$&&$.inset.dispose()}$onDidReceiveMessage(b,$){this.c.get(b)?.onDidReceiveMessage.fire($)}}e.$Ilc=R}),define(Se[146],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=e.$bM=e.$aM=void 0,e.$aM="__",e.$bM=(0,d.$wi)("IAuthenticationService"),e.$cM=(0,d.$wi)("IAuthenticationExtensionsService")}),define(Se[306],De([1,0,5]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=e.VariableKind=e.$nQ=void 0,e.$nQ=(0,d.$wi)("configurationResolverService");var O;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class L extends Error{constructor(N,b){super(b),this.variable=N}}e.$oQ=L}),define(Se[307],De([1,0,17,52,18,24,12,103,246,306,14]),function(he,e,d,O,L,R,N,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,v,h,l){this.h=new Map,this.a=y,this.b=v,this.g=h,l&&(this.c=l.then(o=>this.i(o)))}i(y){if(N.$i){const v=Object.create(null);return Object.keys(y).forEach(h=>{v[h.toLowerCase()]=y[h]}),v}return y}resolveWithEnvironment(y,v,h){return this.l({env:this.i(y),userHome:void 0},v?v.uri:void 0,h)}async resolveAsync(y,v){const h={env:await this.c,userHome:await this.g};return this.l(h,y?y.uri:void 0,v)}async j(y,v,h,l){const o=R.$3n(v);N.$i&&o.windows?Object.keys(o.windows).forEach(i=>o[i]=o.windows[i]):N.$j&&o.osx?Object.keys(o.osx).forEach(i=>o[i]=o.osx[i]):N.$k&&o.linux&&Object.keys(o.linux).forEach(i=>o[i]=o.linux[i]),delete o.windows,delete o.osx,delete o.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,y?y.uri:void 0,o,h,l)}async resolveAnyAsync(y,v,h){return this.j(y,v,h)}async resolveAnyMap(y,v,h){const l=new Map;return{newConfig:await this.j(y,v,h,l),resolvedVariables:l}}resolveWithInteractionReplace(y,v,h,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,v,h,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,v){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,v)}async l(y,v,h,l,o){if(L.$9f(h))return this.m(y,v,h,l,o);if(Array.isArray(h))return Promise.all(h.map(n=>this.l(y,v,n,l,o)));if(L.$$f(h)){const n=Object.create(null),i=await Promise.all(Object.keys(h).map(async u=>[await this.m(y,v,u,l,o),await this.l(y,v,h[u],l,o)]));for(const[u,s]of i)n[u]=s;return n}return h}m(y,v,h,l,o){return(0,A.$pf)(h,C.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(C.VARIABLE_LHS))return n;let u=await this.o(y,n,i,v,l);return o?.set(i,u),u!==n&&L.$9f(u)&&u.match(C.VARIABLE_REGEXP)&&(u=await this.m(y,v,u,l,o)),u})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,v,h,l,o){let n;const i=h.split(":");i.length>1&&(h=i[0],n=i[1]);const u=c=>{const r=this.a.getFilePath();if(r)return(0,b.$Ew)(r);throw new k.$oQ(c,(0,$.localize)(0,null,v))},s=c=>{const r=u(c);if(this.a.getWorkspaceFolderPathForFile){const a=this.a.getWorkspaceFolderPathForFile();if(a)return(0,b.$Ew)(a)}throw new k.$oQ(c,(0,$.localize)(1,null,v,d.$nc(r)))},t=c=>{if(n){const r=this.a.getFolderUri(n);if(r)return r;throw new k.$oQ(c,(0,$.localize)(2,null,v,n))}if(l)return l;throw this.a.getWorkspaceFolderCount()>1?new k.$oQ(c,(0,$.localize)(3,null,v)):new k.$oQ(c,(0,$.localize)(4,null,v))};switch(h){case"env":if(n){if(y.env){const c=y.env[N.$i?n.toLowerCase():n];if(L.$9f(c))return c}return""}throw new k.$oQ(k.VariableKind.Env,(0,$.localize)(5,null,v));case"config":if(n){const c=this.a.getConfigurationValue(l,n);if(L.$fg(c))throw new k.$oQ(k.VariableKind.Config,(0,$.localize)(6,null,v,n));if(L.$$f(c))throw new k.$oQ(k.VariableKind.Config,(0,$.localize)(7,null,v,n));return c}throw new k.$oQ(k.VariableKind.Config,(0,$.localize)(8,null,v));case"command":return this.p(k.VariableKind.Command,v,n,o,"command");case"input":return this.p(k.VariableKind.Input,v,n,o,"input");case"extensionInstallFolder":if(n){const c=await this.a.getExtension(n);if(!c)throw new k.$oQ(k.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,v,n));return this.n(c.extensionLocation)}throw new k.$oQ(k.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,v));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,b.$Ew)(this.n(t(k.VariableKind.WorkspaceFolder)));case"cwd":return l||n?(0,b.$Ew)(this.n(t(k.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$Ew)(d.$nc(this.n(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new k.$oQ(k.VariableKind.UserHome,(0,$.localize)(11,null,v))}case"lineNumber":{const c=this.a.getLineNumber();if(c)return c;throw new k.$oQ(k.VariableKind.LineNumber,(0,$.localize)(12,null,v))}case"selectedText":{const c=this.a.getSelectedText();if(c)return c;throw new k.$oQ(k.VariableKind.SelectedText,(0,$.localize)(13,null,v))}case"file":return u(k.VariableKind.File);case"fileWorkspaceFolder":return s(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return d.$nc(s(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return l||n?d.$lc(this.n(t(k.VariableKind.RelativeFile)),u(k.VariableKind.RelativeFile)):u(k.VariableKind.RelativeFile);case"relativeFileDirname":{const c=d.$mc(u(k.VariableKind.RelativeFileDirname));if(l||n){const r=d.$lc(this.n(t(k.VariableKind.RelativeFileDirname)),c);return r.length===0?".":r}return c}case"fileDirname":return d.$mc(u(k.VariableKind.FileDirname));case"fileExtname":return d.$oc(u(k.VariableKind.FileExtname));case"fileBasename":return d.$nc(u(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const c=d.$nc(u(k.VariableKind.FileBasenameNoExtension));return c.slice(0,c.length-d.$oc(c).length)}case"fileDirnameBasename":return d.$nc(d.$mc(u(k.VariableKind.FileDirnameBasename)));case"execPath":{const c=this.a.getExecPath();return c||v}case"execInstallFolder":{const c=this.a.getAppRoot();return c||v}case"pathSeparator":case"/":return d.sep;default:try{const c=n?`${h}:${n}`:h;return this.p(k.VariableKind.Unknown,v,c,o,void 0)}catch{return v}}}}p(y,v,h,l,o){if(h&&l){const n=o===void 0?l[h]:l[o+":"+h];if(typeof n=="string")return n;throw new k.$oQ(y,(0,$.localize)(14,null,v))}return v}}e.$DQ=C}),define(Se[147],De([1,0,5,143]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$YD=void 0,e.$ZD=k,e.$1D=p,e.$2D=y,e.$YD=(0,d.$wi)("editorGroupsService");var L;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(L||(e.GroupDirection=L={}));var R;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var N;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(N||(e.GroupLocation=N={}));var b;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var $;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function k(v){const h=v;return(0,O.$JF)(h?.editor)&&(0,O.$JF)(h?.replacement)}var A;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var C;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function p(v){const h=v;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}function y(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Se[308],De([1,0,5,147]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6D=e.$5D=e.$4D=e.$3D=void 0,e.$7D=L,e.$3D=(0,d.$wi)("editorService"),e.$4D=-1,e.$5D=-2,e.$6D=-3;function L(R){const N=R;return typeof R=="number"||(0,O.$1D)(N)}}),define(Se[148],De([1,0,5,137]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=void 0,e.$vM=(0,d.$xi)(O.$Di)}),define(Se[149],De([1,0,25,4,17,3,7]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6_b=e.$5_b=e.$4_b=e.$3_b=e.$2_b=void 0;class b{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$2_b=b;class ${static isHostExtension(n,i,u){if(i.getExtensionDescription(n))return!1;const s=u.getExtensionDescription(n);return s?!!((s.main||s.browser)&&s.api==="none"):!1}constructor(n,i){this.j=n,this.c=new O.$de,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(h),this.f=new d.$Tm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const u of i)this.h.has(u)||this.h.set(u,[]),this.h.get(u).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=l(this.e,i),this.e=this.e.concat(n);const u=$.l(this.e);return this.e=l(this.e,u.map(s=>s.identifier)),this.k(),this.d++,this.c.fire(void 0),new b(this.d,u)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,a){this.addNode(r),this.addNode(a),this.c.has(r)?this.c.get(r).push(a):this.c.set(r,[a])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,a){const f=i.getArcs(r);for(let g=0;g<f.length;g++)if(!a.has(f[g]))return!1;return!0}getNodes(){return this.e}},u=new d.$Tm;for(const r of n)if(u.set(r.identifier,r),r.extensionDependencies)for(const a of r.extensionDependencies)i.addArc(d.$Rm.toKey(r.identifier),d.$Rm.toKey(a));const s=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>s.add(r));const t=i.getNodes().filter(r=>!s.has(r));let c;do{c=!1;for(let r=0;r<t.length;r++){const a=t[r];i.hasOnlyGoodArcs(a,s)&&(t.splice(r,1),r--,s.add(a),c=!0)}}while(c);return t.map(r=>u.get(r))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$3_b=$;class k{constructor(n,i){this.versionId=n,this.extensions=i}}e.$4_b=k;class A{constructor(n){this.d=new y,this.c=new $(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new C(this,i)}deltaExtensions(n,i,u){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,u)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$5_b=A;class C extends R.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$6_b=C;class p{constructor(n){this.name=n;const i=(0,N.$ph)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class y{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new p(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const u=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),s=()=>{i&&(clearTimeout(u),i=!1,this.d=!1,this.e())};n.resolve((0,R.$Sc)(s))}}var v;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(v||(v={}));function h(o,n){const i=o.isBuiltin?0:o.isUnderDevelopment?2:1,u=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==u)return i-u;const s=L.$gc.basename(o.extensionLocation.path),t=L.$gc.basename(n.extensionLocation.path);return s<t?-1:s>t?1:0}function l(o,n){const i=new d.$Sm(n);return o.filter(u=>!i.has(u.identifier))}}),define(Se[309],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=e.$ln=e.$kn=e.ExtHostConnectionType=void 0,e.$nn=b,e.$on=$;var d;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(d||(e.ExtHostConnectionType=d={}));class O{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[O.ENV_KEY]=this.pipeName}}e.$kn=O;class L{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[L.ENV_KEY]="1"}}e.$ln=L;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[R.ENV_KEY]="1"}}e.$mn=R;function N(A){delete A[O.ENV_KEY],delete A[L.ENV_KEY],delete A[R.ENV_KEY]}function b(A,C){N(C),A.serialize(C)}function $(A){if(A[O.ENV_KEY])return k(A,new O(A[O.ENV_KEY]));if(A[L.ENV_KEY])return k(A,new L);if(A[R.ENV_KEY])return k(A,new R);throw new Error("No connection information defined in environment!")}function k(A,C){return N(A),C}}),define(Se[115],De([1,0,21]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Zm=N,e.$1m=b;var O;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(O||(e.UIKind=O={}));var L;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(L||(e.ExtensionHostExitCode=L={}));var R;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function N(k){const A=d.$Fe.alloc(1);switch(k){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}function b(k,A){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}var $;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Se[90],De([1,0,5,4,11,28,115,86,87,24,2,3,231]),function(he,e,d,O,L,R,N,b,$,k,A,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TP=e.$RP=e.$QP=void 0,e.$SP=h;let y=class extends C.$Uc{constructor(o,n){super(),this.s=o,this.t=n,this.a=this.B(new O.$de),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$de),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:$.$kp,name:(0,p.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,L.$5j)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===L.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,n,i){const u=this.getTelemetryDetails(),s=new v(n,i,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,s]),s.apiTelemetryLogger}$initializeTelemetryLevel(o,n,i){this.f=o,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const n=Object.create(null);switch(n["common.extname"]=`${o.publisher}.${o.name}`,n["common.extversion"]=o.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=h(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case N.UIKind.Web:n["common.uikind"]="web";break;case N.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,b.$Im)((0,$.$qp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const n=this.getTelemetryDetails();this.r.forEach((i,u)=>{const s=i.filter(t=>!t.isDisposed);s.length===0?this.r.delete(u):this.r.set(u,s)}),this.r.forEach(i=>{for(const u of i)u.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,n){const u=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!u)return this.r.delete(o.value),!1;let s=!1;for(const t of u)t.ignoreUnhandledExtHostErrors||(t.logError(n),s=!0);return s}};e.$QP=y,e.$QP=y=Ge([We(0,R.$PP),We(1,L.$4j)],y);class v{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,n,i,u,s,t,c){this.g=i,this.h=u,this.i=s,this.j=t,this.a=new O.$de,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}}updateTelemetryEnablements(o,n){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let n="properties"in o?o.properties??{}:o;return n=(0,$.$tp)(n,[]),this.c&&(n=(0,k.$6n)(n,this.c)),this.b||(n=(0,k.$6n)(n,this.j)),"properties"in o?o.properties=n:o=n,o}k(o,n){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(o,n),this.h.trace(o,n))}logUsage(o,n){this.d.isUsageEnabled&&this.k(o,n)}logError(o,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,n);else{const i={name:o.name,message:o.message,stack:o.stack,cause:o.cause},u=(0,$.$tp)(i,[]),s=new Error(u.message,{cause:u.cause});s.stack=u.stack,s.name=u.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(s,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const o=this,n={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$RP=v;function h(l){const o=Date.now()-new Date(l).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$TP=(0,d.$wi)("IExtHostTelemetry")}),define(Se[26],De([1,0,4,2,278,140,25,5]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UG=e.ActivationKind=e.$RG=e.$QG=e.$NG=e.ExtensionHostStartup=e.$MG=e.$LG=e.$KG=e.$JG=void 0,e.$OG=p,e.$PG=y,e.$SG=o,e.$TG=n,e.$JG=Object.freeze({identifier:new N.$Rm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$KG="extensions.webWorker",e.$LG=(0,b.$wi)("extensionService");class ${constructor(s){this.dependency=s}}e.$MG=$;var k;(function(u){u[u.EagerAutoStart=1]="EagerAutoStart",u[u.EagerManualStart=2]="EagerManualStart",u[u.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(s,t,c){this.c=s,this.d=t.slice(0),this.e=c.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$uG.createActivationEventsMap(this.d)}}set(s,t,c){if(this.c>s)throw new Error(`ExtensionHostExtensions: invalid versionId ${s} (current: ${this.c})`);const r=[],a=[],f=[],g=[],w=C(this.d),S=C(t),m=(F,T)=>F.extensionLocation.toString()===T.extensionLocation.toString()||F.isBuiltin===T.isBuiltin||F.isUserBuiltin===T.isUserBuiltin||F.isUnderDevelopment===T.isUnderDevelopment;for(const F of this.d){const T=S.get(F.identifier);if(!T){r.push(F.identifier),w.delete(F.identifier);continue}if(!m(F,T)){r.push(F.identifier),w.delete(F.identifier);continue}}for(const F of t){const T=w.get(F.identifier);if(!T){a.push(F);continue}if(!m(T,F)){r.push(T.identifier),w.delete(T.identifier);continue}}const E=new N.$Sm(this.e),D=new N.$Sm(c);for(const F of this.e)D.has(F)||f.push(F);for(const F of c)E.has(F)||g.push(F);const P=R.$uG.createActivationEventsMap(a),I={versionId:s,toRemove:r,toAdd:a,addActivationEvents:P,myToRemove:f,myToAdd:g};return this.delta(I),I}delta(s){if(this.c>=s.versionId)return null;const{toRemove:t,toAdd:c,myToRemove:r,myToAdd:a}=s,f=new N.$Sm(t),g=new N.$Sm(r);for(let w=0;w<this.d.length;w++)f.has(this.d[w].identifier)&&(this.d.splice(w,1),w--);for(let w=0;w<this.e.length;w++)g.has(this.e[w])&&(this.e.splice(w,1),w--);for(const w of c)this.d.push(w);for(const w of a)this.e.push(w);return this.f=null,s}containsExtension(s){for(const t of this.e)if(N.$Rm.equals(t,s))return!0;return!1}containsActivationEvent(s){return this.f||(this.f=this.g()),this.f.has(s)}g(){const s=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const c=R.$uG.readActivationEvents(t);for(const r of c)s.add(r)}return s}}e.$NG=A;function C(u){const s=new N.$Tm;for(const t of u)s.set(t.identifier,t);return s}function p(u,s){return u.enabledApiProposals?u.enabledApiProposals.includes(s):!1}function y(u,s){if(!p(u,s))throw new Error(`Extension '${u.identifier.value}' CANNOT use API proposal: ${s}.
Its package.json#enabledApiProposals-property declares: ${u.enabledApiProposals?.join(", ")??"[]"} but NOT ${s}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${u.identifier.value}`)}class v{constructor(s,t,c,r){this.codeLoadingTime=s,this.activateCallTime=t,this.activateResolvedTime=c,this.activationReason=r}}e.$QG=v;class h{constructor(s,t){this.description=s,this.value=t}}e.$RG=h;var l;(function(u){u[u.Normal=0]="Normal",u[u.Immediate=1]="Immediate"})(l||(e.ActivationKind=l={}));function o(u){return{type:u.isBuiltin?0:1,isBuiltin:u.isBuiltin||u.isUserBuiltin,identifier:{id:(0,L.$zp)(u.publisher,u.name),uuid:u.uuid},manifest:u,location:u.extensionLocation,targetPlatform:u.targetPlatform,validations:[],isValid:!0}}function n(u,s){return{identifier:new N.$Rm((0,L.$xp)(u.manifest.publisher,u.manifest.name)),isBuiltin:u.type===0,isUserBuiltin:u.type===1&&u.isBuiltin,isUnderDevelopment:!!s,extensionLocation:u.location,...u.manifest,uuid:u.identifier.uuid,targetPlatform:u.targetPlatform,publisherDisplayName:u.publisherDisplayName}}class i{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None,this.onWillStop=d.Event.None,this.extensions=[]}activateByEvent(s){return Promise.resolve(void 0)}activateById(s,t){return Promise.resolve(void 0)}activationEventIsDone(s){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(s){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(s,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(s){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$UG=i}),define(Se[310],De([1,0,13,149,25,26,11,7]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=e.$9lc=e.$8lc=e.$7lc=e.$6lc=e.$5lc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(o,n,i,u){this.startup=o,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=u}}e.$5lc=$;class k{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,n){return o===-1||n===-1?-1:n-o}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$6lc=k;class A{constructor(o,n,i,u,s,t){this.activationFailed=o,this.activationFailedError=n,this.activationTimes=i,this.module=u,this.exports=s,this.subscriptions=t}}e.$7lc=A;class C extends A{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$8lc=C;class p extends A{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$9lc=p;class y extends A{constructor(o){super(!0,o,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(o,n,i,u){this.g=u,this.a=o,this.b=n,this.c=i,this.d=new L.$Tm,this.f=Object.create(null)}dispose(){for(const[o,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const o=[];for(const[n,i]of this.d)o.push(i.wait());await Promise.all(o)}isActivated(o){const n=this.d.get(o);return!!(n&&n.value)}getActivatedExtension(o){const n=this.d.get(o);if(!n||!n.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return n.value}async activateByEvent(o,n){if(this.f[o])return;const i=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(i.map(u=>({id:u.identifier,reason:{startup:n,extensionId:u.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,n){const i=this.a.getExtensionDescription(o);if(!i)throw new Error(`Extension '${o.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(o){const n=o.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const n=this.a.getExtensionDescription(o.id);if(!n){const s=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new y(s));return this.c.onExtensionActivationError(o.id,s,new R.$MG(o.id.value)),t}const i=[],u=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const s of u){if(this.m(s))continue;const t=this.d.get(s);if(t){i.push(t);continue}if(this.l(s)){i.push(this.j({id:this.b.getExtensionDescription(s).identifier,reason:o.reason}));continue}const c=this.a.getExtensionDescription(s);if(c){if(!c.main&&!c.browser)continue;i.push(this.j({id:c.identifier,reason:o.reason}));continue}const r=n.displayName||n.identifier.value,a=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${s}'`),f=this.k(o,n.displayName,[],new y(a));return this.c.onExtensionActivationError(n.identifier,a,new R.$MG(s)),f}return this.k(o,n.displayName,i,null)}k(o,n,i,u){const s=new h(o.id,n,o.reason,i,u,this.c,this.g);return this.d.set(o.id,s),s}l(o){return O.$3_b.isHostExtension(o,this.a,this.b)}m(o){const n=this.b.getExtensionDescription(o);return n?!n.main&&!n.browser:!1}};e.$0lc=v,e.$0lc=v=Ge([We(3,N.$3j)],v);let h=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,n,i,u,s,t,c){this.c=o,this.d=n,this.f=i,this.g=u,this.h=s,this.j=t,this.k=c,this.a=new b.$vh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const n=this.g[o];if(n.value&&!n.value.activationFailed){this.g.splice(o,1),o--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new y(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const n=new Error;if(o&&o.name&&(n.name=o.name),o&&o.message?n.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(n.stack=o.stack),this.h=new y(n),this.b&&d.$4(o))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};h=Ge([We(6,N.$3j)],h)}),define(Se[311],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testPreserveFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testPreserveFocus.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[312],De([1,0,248,13,41,138,110,36,25,311,108,140]),function(he,e,d,O,L,R,N,b,$,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=void 0;const p=b.$co.as(N.$do.JSONContribution);class y{constructor(s,t,c){this.a=s,this.b=t,this.c=c}d(s,t){this.a({type:s,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(s){this.d(L.default.Error,s)}warn(s){this.d(L.default.Warning,s)}info(s){this.d(L.default.Info,s)}}e.$DG=y;class v{static a(s){const t=new $.$Sm;for(let c=0,r=s.length;c<r;c++)t.add(s[c].description.identifier);return t}static compute(s,t){if(!s||!s.length)return new v(t,[]);if(!t||!t.length)return new v([],s);const c=this.a(s),r=this.a(t),a=t.filter(g=>!c.has(g.description.identifier)),f=s.filter(g=>!r.has(g.description.identifier));return new v(a,f)}constructor(s,t){this.added=s,this.removed=t}}e.$EG=v;class h{constructor(s,t){this.name=s,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(s){if(this.a!==null)throw new Error("Handler already set!");this.a=s,this.d()}acceptUsers(s){this.c=v.compute(this.b,s),this.b=s,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(s){(0,O.$1)(s)}}}e.$FG=h;const l={type:"string",enum:["ui","workspace"],enumDescriptions:[d.localize(0,null),d.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$GG={properties:{engines:{type:"object",description:d.localize(2,null),properties:{vscode:{type:"string",description:d.localize(3,null),default:"^1.22.0"}}},publisher:{description:d.localize(4,null),type:"string"},displayName:{description:d.localize(5,null),type:"string"},categories:{description:d.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Qm},{type:"string",const:"Languages",deprecationMessage:d.localize(7,null)}]}},galleryBanner:{type:"object",description:d.localize(8,null),properties:{color:{description:d.localize(9,null),type:"string"},theme:{description:d.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:d.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:d.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:d.localize(13,null)},enabledApiProposals:{markdownDescription:d.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:d.localize(15,null),type:"string",enum:["none"],enumDescriptions:[d.localize(16,null)]},activationEvents:{description:d.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:d.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:d.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:d.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:d.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:d.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:d.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:d.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:d.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:d.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:d.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:d.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:d.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:d.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:d.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:d.localize(32,null)},{label:"onUri",body:"onUri",description:d.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:d.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:d.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:d.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:d.localize(37,null)},{label:"onRenderer",description:d.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:d.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:d.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:d.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:d.localize(42,null)},{label:"*",description:d.localize(43,null),body:"*"}]}},badges:{type:"array",description:d.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:d.localize(45,null)},href:{type:"string",description:d.localize(46,null)},description:{type:"string",description:d.localize(47,null)}}}},markdown:{type:"string",description:d.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:d.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:d.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$To}},extensionPack:{description:d.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$To}},extensionKind:{description:d.localize(52,null),type:"array",items:l,default:["workspace"],defaultSnippets:[{body:["ui"],description:d.localize(53,null)},{body:["workspace"],description:d.localize(54,null)},{body:["ui","workspace"],description:d.localize(55,null)},{body:["workspace","ui"],description:d.localize(56,null)},{body:[],description:d.localize(57,null)}]},capabilities:{description:d.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:d.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:d.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[d.localize(61,null),d.localize(62,null),d.localize(63,null)]},description:{type:"string",markdownDescription:d.localize(64,null)}}},untrustedWorkspaces:{description:d.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:d.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[d.localize(67,null),d.localize(68,null),d.localize(69,null)]},restrictedConfigurations:{description:d.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:d.localize(71,null)}}}}},sponsor:{description:d.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:d.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:d.localize(74,null),type:"string"},"vscode:uninstall":{description:d.localize(75,null),type:"string"}}},icon:{type:"string",description:d.localize(76,null)},l10n:{type:"string",description:d.localize(77,null)},pricing:{type:"string",markdownDescription:d.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(s){if(this.a.has(s.extensionPoint))throw new Error("Duplicate extension point: "+s.extensionPoint);const t=new h(s.extensionPoint,s.defaultExtensionKind);return this.a.set(s.extensionPoint,t),s.activationEventsGenerator&&C.$uG.register(s.extensionPoint,s.activationEventsGenerator),e.$GG.properties.contributes.properties[s.extensionPoint]=s.jsonSchema,p.registerSchema(o,e.$GG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$HG=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};b.$co.add(i.ExtensionsRegistry,new n),e.$IG=b.$co.as(i.ExtensionsRegistry),p.registerSchema(o,e.$GG),p.registerSchema(A.$kk,{properties:{extensionEnabledApiProposals:{description:d.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Se[313],De([1,0,244,18,24,312,38,4]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cI=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:d.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:d.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:d.localize(2,null),default:""}}};var k;(function(p){function y(v,h,l){if(!v)return;const o=O.$9f(v.type)?v.type:void 0;if(!o||o.length===0){l.error(d.localize(3,null));return}const n=[];if(Array.isArray(v.required))for(const i of v.required)O.$9f(i)&&n.push(i);return{extensionId:h.value,taskType:o,required:n,properties:v.properties?L.$3n(v.properties):{},when:v.when?N.$uj.deserialize(v.when):void 0}}p.from=y})(k||(k={}));const A=R.$IG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,y)=>{for(const v of p)v.type&&y.push(`onTaskType:${v.type}`)},jsonSchema:{description:d.localize(4,null),type:"array",items:$}});class C{constructor(){this.d=new b.$de,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,v)=>{A.setHandler((h,l)=>{this.c=void 0;try{for(const o of l.removed){const n=o.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const o of l.added){const n=o.value;for(const i of n){const u=k.from(i,o.description.identifier,o.collector);u&&(this.a[u.taskType]=u)}}(l.removed.length>0||l.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const v of this.all()){const h={type:"object",additionalProperties:!1};v.required.length>0&&(h.required=v.required.slice(0)),v.properties!==void 0?h.properties=L.$3n(v.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[v.taskType]},y.push(h)}this.c={oneOf:y}}return this.c}}e.$cI=new C}),define(Se[314],De([1,0,245,18,23,24,38,313]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$mI=e.JsonSchemaVersion=e.ExecutionEngine=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$gI=e.ShellQuoting=e.$fI=e.$eI=e.$dI=void 0,e.$dI="settings",e.$eI=new N.$Nj("taskRunning",!1,d.localize(0,null)),e.$fI=d.localize2(2,"Tasks");var $;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$gI="$customized",function(M){function j(U){if(!U)return M.Strong;switch(U.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=j}($||(e.ShellQuoting=$={}));var k;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var A;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(A||(e.RevealKind=A={})),function(M){function j(U){switch(U.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=j}(A||(e.RevealKind=A={}));var C;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(M){function j(U){switch(U.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=j}(C||(e.RevealProblemKind=C={}));var p;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(p||(e.PanelKind=p={})),function(M){function j(U){switch(U.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=j}(p||(e.PanelKind=p={}));var y;(function(M){M.defaults={echo:!0,reveal:A.Always,revealProblems:C.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var v;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(M){function j(Z){switch(Z.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=j;function U(Z){switch(Z){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=U}(v||(e.RuntimeType=v={}));var h;(function(M){function j(U){return O.$9f(U)?U:U.value}M.value=j})(h||(e.CommandString=h={}));var l;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function j(Z){return Z===M.Clean._id||Z===M.Build._id||Z===M.Rebuild._id||Z===M.Test._id}M.is=j;function U(Z){if(Z!==void 0)return O.$9f(Z)?j(Z)?{_id:Z,isDefault:!1}:void 0:Z}M.from=U})(l||(e.TaskGroup=l={}));var o;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var n;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function j(U){switch(U){case M.User:return 2;case M.WorkspaceFile:return 5;default:return 6}}M.toConfigurationTarget=j})(n||(e.TaskSourceKind=n={}));var i;(function(M){M.parallel="parallel",M.sequence="sequence"})(i||(e.DependsOrder=i={}));var u;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(u||(e.RunOnOptions=u={}));var s;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:u.default,instanceLimit:1}})(s||(e.RunOptions=s={}));class t{constructor(j,U,Z,ie,q,G){this._label="",this._id=j,U&&(this._label=U),Z&&(this.type=Z),this.runOptions=ie,this.configurationProperties=q,this._source=G}getDefinition(j){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const j={folder:this.d(),id:this._id};return JSON.stringify(j)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(j,U=!1){if(j===void 0)return!1;if(O.$9f(j))return j===this._label||j===this.configurationProperties.identifier||U&&j===this._id;const Z=this.getDefinition(!0);return Z!==void 0&&Z._key===j._key}getQualifiedLabel(){const j=this.getWorkspaceFolder();return j?`${this._label} (${j.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(j){this.c===void 0&&(this.c=[]),j&&(this.c=this.c.concat(j))}get taskLoadMessages(){return this.c}}e.$hI=t;class c extends t{constructor(j,U,Z,ie,q,G,x,ne){super(j,Z,void 0,x,ne,U),this.command={},this._source=U,this.hasDefinedMatchers=G,q&&(this.command=q)}clone(){return new c(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(j=!1){if(j&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case v.Shell:U="shell";break;case v.Process:U="process";break;case v.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(j){return j instanceof c}getMapKey(){const j=this._source.config.workspaceFolder;return j?`${j.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$dI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const j=this.d();if(!j)return;let U=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(U+=this._source.kind);const Z={type:e.$gI,folder:j,id:U};return JSON.stringify(Z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$7g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(j){return new c(j._id,j._source,j._label,j.type,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$iI=c;class r extends t{constructor(j,U,Z,ie,q,G,x){super(j,Z,ie,G,x,U),this._source=U,this.configures=q}static is(j){return j instanceof r}f(j){return j}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$7g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$dI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const j=this.d();if(!j)return;let U=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(U+=this._source.kind);const Z={type:e.$gI,folder:j,id:U};return JSON.stringify(Z)}}e.$jI=r;class a extends t{constructor(j,U,Z,ie,q,G,x,ne,be){super(j,Z,ie,ne,be,U),this.defines=q,this.hasDefinedMatchers=x,this.command=G,this.icon=be.icon,this.hide=be.hide}clone(){return new a(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(j){return j instanceof a}getMapKey(){const j=this._source.workspaceFolder;return j?`${this._source.scope.toString()}|${j.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const j={type:"contributed",scope:this._source.scope,id:this._id};return j.folder=this.d(),JSON.stringify(j)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(j){return new a(j._id,j._source,j._label,j.type,j.defines,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$kI=a;class f extends t{constructor(j,U,Z,ie,q,G){super(j,Z,ie,q,G,U),this._source=U}clone(){return new f(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(j){return j instanceof f}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(j){return new f(j._id,j._source,j._label,j.type,j.runOptions,j.configurationProperties)}}e.$lI=f;var g;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(g||(e.ExecutionEngine=g={})),function(M){M._default=M.Terminal}(g||(e.ExecutionEngine=g={}));var w;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(w||(e.JsonSchemaVersion=w={}));class S{constructor(j){this.c=new Map;for(let U=0;U<j.length;U++)this.c.set(j[U].uri.toString(),U)}compare(j,U){const Z=j.getWorkspaceFolder(),ie=U.getWorkspaceFolder();if(Z&&ie){let q=this.c.get(Z.uri.toString());q=q===void 0?0:q+1;let G=this.c.get(ie.uri.toString());return G=G===void 0?0:G+1,q===G?j._label.localeCompare(U._label):q-G}else return!Z&&ie?-1:Z&&!ie?1:0}}e.$mI=S;var m;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(m||(e.TaskEventKind=m={}));var E;(function(M){M.SingleRun="singleRun",M.Background="background"})(E||(e.TaskRunType=E={}));var D;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(D||(e.TaskRunSource=D={}));var P;(function(M){function j(ne){return{taskId:ne._id,taskName:ne.configurationProperties.name,runType:ne.configurationProperties.isBackground?"background":"singleRun",group:ne.configurationProperties.group,__task:ne}}function U(ne,be,ae){return{...j(ne),kind:"start",terminalId:be,resolvedVariables:ae}}M.start=U;function Z(ne,be,ae){return{...j(ne),kind:"processStarted",terminalId:be,processId:ae}}M.processStarted=Z;function ie(ne,be,ae){return{...j(ne),kind:"processEnded",terminalId:be,exitCode:ae}}M.processEnded=ie;function q(ne,be,ae){return{...j(ne),kind:"terminated",exitReason:ae,terminalId:be}}M.terminated=q;function G(ne,be,ae){return{...j(be),kind:ne,terminalId:ae}}M.general=G;function x(){return{kind:"changed"}}M.changed=x})(P||(e.TaskEvent=P={}));var I;(function(M){function j(Z){const ie=Object.keys(Z).sort();let q="";for(const G of ie){let x=Z[G];x instanceof Object?x=j(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),q+=G+","+x+","}return q}function U(Z){const q={_key:j(Z),type:Z.taskType};return Object.assign(q,Z),q}M.create=U})(I||(e.KeyedTaskIdentifier=I={}));var F;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(F||(e.TaskSettingId=F={}));var T;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(T||(e.TasksSchemaProperties=T={}));var z;(function(M){function j(U,Z){const ie=b.$cI.get(U.type);if(ie===void 0){const ne=R.$3n(U);return delete ne._key,I.create(ne)}const q=Object.create(null);q.type=ie.taskType;const G=new Set;ie.required.forEach(ne=>G.add(ne));const x=ie.properties;for(const ne of Object.keys(x)){const be=U[ne];if(be!=null)q[ne]=be;else if(G.has(ne)){const ae=x[ne];if(ae.default!==void 0)q[ne]=R.$3n(ae.default);else switch(ae.type){case"boolean":q[ne]=!1;break;case"number":case"integer":q[ne]=0;break;case"string":q[ne]="";break;default:Z.error(d.localize(1,null,JSON.stringify(U,void 0,0),ne));return}}}return I.create(q)}M.createTaskIdentifier=j})(z||(e.TaskDefinition=z={}))}),define(Se[315],De([1,0,13]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8_b=e.$7_b=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((N,b)=>{this.b=N,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(N){this.f||this.h||(this.f=!0,this.g=N,this.a&&this.b(N))}resolveErr(N){this.f||this.h||(this.h=!0,this.i=N,this.a?this.d(N):(0,d.$1)(N))}then(N,b){return this.j().then(N,b)}catch(N){return this.j().then(void 0,N)}finally(N){return this.j().finally(N)}}e.$7_b=O;class L extends O{constructor(){super(),this.h=!0,this.i=new d.$5}}e.$8_b=L}),define(Se[48],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bw=e.$yw=void 0,e.$zw=L,e.$Aw=R;class d{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++d.count}}e.$yw=d;const O=[];function L(b){const $=new d(b);return O[$.nid]=$,$}function R(b){return O[b].sid}class N{constructor($){this.value=$}}e.$Bw=N}),define(Se[6],De([1,0,48]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=e.$$M=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$0M=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var L;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput",h[h.ChatEditorInput=10]="ChatEditorInput",h[h.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(L||(e.TabInputKind=L={}));var R;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var N;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(N||(e.WebviewEditorCapabilities=N={}));var b;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var $;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var k;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var A;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output",h[h.Hybrid=3]="Hybrid"})(A||(e.CandidatePortSource=A={}));class C{static{this.a=0}static mixin(l){return l._id=C.a++,l}}e.$0M=C;var p;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.kindModifier="m",h.commandIdent="n",h.commandId="o",h.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var y;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var v;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$$M={MainThreadAuthentication:(0,d.$zw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,d.$zw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,d.$zw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,d.$zw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,d.$zw)("MainThreadChatVariables"),MainThreadClipboard:(0,d.$zw)("MainThreadClipboard"),MainThreadCommands:(0,d.$zw)("MainThreadCommands"),MainThreadComments:(0,d.$zw)("MainThreadComments"),MainThreadConfiguration:(0,d.$zw)("MainThreadConfiguration"),MainThreadConsole:(0,d.$zw)("MainThreadConsole"),MainThreadDebugService:(0,d.$zw)("MainThreadDebugService"),MainThreadDecorations:(0,d.$zw)("MainThreadDecorations"),MainThreadDiagnostics:(0,d.$zw)("MainThreadDiagnostics"),MainThreadDialogs:(0,d.$zw)("MainThreadDiaglogs"),MainThreadDocuments:(0,d.$zw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,d.$zw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,d.$zw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,d.$zw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,d.$zw)("MainThreadEditorTabs"),MainThreadErrors:(0,d.$zw)("MainThreadErrors"),MainThreadTreeViews:(0,d.$zw)("MainThreadTreeViews"),MainThreadDownloadService:(0,d.$zw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,d.$zw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,d.$zw)("MainThreadLanguages"),MainThreadLogger:(0,d.$zw)("MainThreadLogger"),MainThreadMessageService:(0,d.$zw)("MainThreadMessageService"),MainThreadOutputService:(0,d.$zw)("MainThreadOutputService"),MainThreadProgress:(0,d.$zw)("MainThreadProgress"),MainThreadQuickDiff:(0,d.$zw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,d.$zw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,d.$zw)("MainThreadStatusBar"),MainThreadSecretState:(0,d.$zw)("MainThreadSecretState"),MainThreadStorage:(0,d.$zw)("MainThreadStorage"),MainThreadSpeech:(0,d.$zw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,d.$zw)("MainThreadTelemetry"),MainThreadTerminalService:(0,d.$zw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,d.$zw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,d.$zw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,d.$zw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,d.$zw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,d.$zw)("MainThreadCustomEditors"),MainThreadUrls:(0,d.$zw)("MainThreadUrls"),MainThreadUriOpeners:(0,d.$zw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,d.$zw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,d.$zw)("MainThreadWorkspace"),MainThreadFileSystem:(0,d.$zw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,d.$zw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,d.$zw)("MainThreadExtensionService"),MainThreadSCM:(0,d.$zw)("MainThreadSCM"),MainThreadSearch:(0,d.$zw)("MainThreadSearch"),MainThreadShare:(0,d.$zw)("MainThreadShare"),MainThreadTask:(0,d.$zw)("MainThreadTask"),MainThreadWindow:(0,d.$zw)("MainThreadWindow"),MainThreadLabelService:(0,d.$zw)("MainThreadLabelService"),MainThreadNotebook:(0,d.$zw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,d.$zw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,d.$zw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,d.$zw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,d.$zw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,d.$zw)("MainThreadInteractive"),MainThreadInlineChat:(0,d.$zw)("MainThreadInlineChatShape"),MainThreadTheming:(0,d.$zw)("MainThreadTheming"),MainThreadTunnelService:(0,d.$zw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,d.$zw)("MainThreadManagedSockets"),MainThreadTimeline:(0,d.$zw)("MainThreadTimeline"),MainThreadTesting:(0,d.$zw)("MainThreadTesting"),MainThreadLocalization:(0,d.$zw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,d.$zw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,d.$zw)("MainThreadAiEmbeddingVector")},e.$_M={ExtHostCommands:(0,d.$zw)("ExtHostCommands"),ExtHostConfiguration:(0,d.$zw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,d.$zw)("ExtHostDiagnostics"),ExtHostDebugService:(0,d.$zw)("ExtHostDebugService"),ExtHostDecorations:(0,d.$zw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,d.$zw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,d.$zw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,d.$zw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,d.$zw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,d.$zw)("ExtHostEditors"),ExtHostTreeViews:(0,d.$zw)("ExtHostTreeViews"),ExtHostFileSystem:(0,d.$zw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,d.$zw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,d.$zw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,d.$zw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,d.$zw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,d.$zw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,d.$zw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,d.$zw)("ExtHostStatusBar"),ExtHostShare:(0,d.$zw)("ExtHostShare"),ExtHostExtensionService:(0,d.$zw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,d.$zw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,d.$zw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,d.$zw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,d.$zw)("ExtHostSCM"),ExtHostSearch:(0,d.$zw)("ExtHostSearch"),ExtHostTask:(0,d.$zw)("ExtHostTask"),ExtHostWorkspace:(0,d.$zw)("ExtHostWorkspace"),ExtHostWindow:(0,d.$zw)("ExtHostWindow"),ExtHostWebviews:(0,d.$zw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,d.$zw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,d.$zw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,d.$zw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,d.$zw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,d.$zw)("ExtHostEditorTabs"),ExtHostProgress:(0,d.$zw)("ExtHostProgress"),ExtHostComments:(0,d.$zw)("ExtHostComments"),ExtHostSecretState:(0,d.$zw)("ExtHostSecretState"),ExtHostStorage:(0,d.$zw)("ExtHostStorage"),ExtHostUrls:(0,d.$zw)("ExtHostUrls"),ExtHostUriOpeners:(0,d.$zw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,d.$zw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,d.$zw)("ExtHostOutputService"),ExtHostLabelService:(0,d.$zw)("ExtHostLabelService"),ExtHostNotebook:(0,d.$zw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,d.$zw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,d.$zw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,d.$zw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,d.$zw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,d.$zw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,d.$zw)("ExtHostInteractive"),ExtHostInlineChat:(0,d.$zw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,d.$zw)("ExtHostChatAgents"),ExtHostChatVariables:(0,d.$zw)("ExtHostChatVariables"),ExtHostChatProvider:(0,d.$zw)("ExtHostChatProvider"),ExtHostSpeech:(0,d.$zw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,d.$zw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,d.$zw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,d.$zw)("ExtHostTheming"),ExtHostTunnelService:(0,d.$zw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,d.$zw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,d.$zw)("ExtHostAuthentication"),ExtHostTimeline:(0,d.$zw)("ExtHostTimeline"),ExtHostTesting:(0,d.$zw)("ExtHostTesting"),ExtHostTelemetry:(0,d.$zw)("ExtHostTelemetry"),ExtHostLocalization:(0,d.$zw)("ExtHostLocalization")}}),define(Se[91],De([1,0,5,11,6,20]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=e.$slc=e.$rlc=void 0,e.$rlc=(0,d.$wi)("IExtHostApiDeprecationService");let N=class{constructor($,k){this.c=k,this.a=new Set,this.b=$.getProxy(L.$$M.MainThreadTelemetry)}report($,k,A){const C=this.d($,k);this.a.has(C)||(this.a.add(C),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:$}))}d($,k){return`${$}-${k.identifier.value}`}};e.$slc=N,e.$slc=N=Ge([We(0,R.$zP),We(1,O.$3j)],N),e.$tlc=Object.freeze(new class{report(b,$,k){}})}),define(Se[316],De([1,0,6]),function(he,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=void 0;class O{constructor(R){const N=R.getProxy(d.$$M.MainThreadClipboard);this.value=Object.freeze({readText(){return N.$readText()},writeText(b){return N.$writeText(b)}})}}e.$Glc=O}),define(Se[317],De([1,0,24,6,28,20]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Anc=void 0;let N=class{constructor(A,C){this.a=A.getProxy(O.$$M.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,C){const p=this,y=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){p.e(A,C,y,arguments)}})}e(A,C,p,y){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:$(y,this.b)}),this.c&&this.f(A,p,y)}};e.$Anc=N,e.$Anc=N=Ge([We(0,R.$zP),We(1,L.$PP)],N);const b=1e5;function $(k,A){const C=[];if(k.length)for(let p=0;p<k.length;p++){let y=k[p];if(typeof y>"u")y="undefined";else if(y instanceof Error){const v=y;v.stack?y=v.stack:y=v.toString()}C.push(y)}if(A){const p=new Error().stack;p&&C.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,d.$8n)(C);return p.length>b?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(Se[318],De([1,0,2,6,26]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dmc=void 0;class R{constructor(b){this.a=b.getProxy(O.$$M.MainThreadDialogs)}showOpenDialog(b,$){return $?.allowUIResources&&(0,L.$PG)(b,"showLocal"),this.a.$showOpenDialog($).then(k=>k?k.map(A=>d.URI.revive(A)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then($=>$?d.URI.revive($):void 0)}}e.$Dmc=R}),define(Se[319],De([1,0,3,6]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=void 0;class L{constructor(N){this.b=0,this.a=N.getProxy(O.$$M.MainThreadLabelService)}$registerResourceLabelFormatter(N){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,N),(0,d.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$Xmc=L}),define(Se[116],De([1,0,12,14,2,5,11,6,28,20]),function(he,e,d,O,L,R,N,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=e.$lmc=void 0;let A=class{constructor(p,y,v){this.f=v,this.d=new Map,this.a=y.getProxy(b.$$M.MainThreadLocalization),this.b=p.environment.appLanguage,this.c=this.b===d.$g}getMessage(p,y){const{message:v,args:h,comment:l}=y;if(this.c)return(0,O.$9e)(v,h??{});let o=v;l&&l.length>0&&(o+=`/${Array.isArray(l)?l.join(""):l}`);const n=this.d.get(p)?.contents[o];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,O.$9e)(n??v,h??{})}getBundle(p){return this.d.get(p)?.contents}getBundleUri(p){return this.d.get(p)?.uri}async initializeLocalizedMessages(p){if(this.c||!p.l10n&&!p.isBuiltin||this.d.has(p.identifier.value))return;let y;const v=await this.g(p);if(!v){this.f.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const h=await this.a.$fetchBundleContents(v),l=JSON.parse(h);y=p.isBuiltin?l.contents?.bundle:l}catch(h){this.f.error(`Failed to load translations for ${p.identifier.value} from ${v}: ${h.message}`);return}y&&this.d.set(p.identifier.value,{contents:y,uri:v})}async g(p){if(p.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(p.identifier.value,this.b);return L.URI.revive(y)}return p.l10n?L.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$lmc=A,e.$lmc=A=Ge([We(0,$.$PP),We(1,k.$zP),We(2,N.$3j)],A),e.$mmc=(0,R.$wi)("IExtHostLocalizationService")}),define(Se[150],De([1,0,11,6,28,20,2,58]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$znc=void 0;let $=class extends d.$bk{constructor(C,p){super(p.logLevel,p.logsLocation,p.loggers.map(y=>(0,b.$6h)(y))),this.r=C.getProxy(O.$$M.MainThreadLogger)}$setLogLevel(C,p){p?this.setLogLevel(N.URI.revive(p),C):this.setLogLevel(C)}setVisibility(C,p){super.setVisibility(C,p),this.r.$setVisibility(C,p)}s(C,p,y){return new k(this.r,C,p,y)}};e.$znc=$,e.$znc=$=Ge([We(0,R.$zP),We(1,L.$PP)],$);class k extends d.$9j{constructor(C,p,y,v){super(v?.logLevel==="always"),this.r=C,this.s=p,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger(p,v).then(()=>{this.u(this.n),this.m=!0})}g(C,p){const y=[[C,p]];this.m?this.u(y):this.n.push(...y)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(Se[117],De([1,0,6,5,3,20,21]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$omc=e.$nmc=void 0,e.$nmc=(0,O.$wi)("IExtHostManagedSockets");let b=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(d.$$M.MainThreadManagedSockets)}setFactory(C,p){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(C,p),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const p=++this.b,y=await this.c.makeConnection(),v=new L.$Tc;return this.d.set(p,new k(p,y,v)),v.add((0,L.$Sc)(()=>this.d.delete(p))),v.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(p),v.dispose()})),v.add(y.onDidClose(h=>{this.a.$onDidManagedSocketClose(p,h?.stack??h?.message),v.dispose()})),v.add(y.onDidReceiveMessage(h=>this.a.$onDidManagedSocketHaveData(p,N.$Fe.wrap(h)))),p}$remoteSocketWrite(C,p){this.d.get(C)?.actual.send(p.buffer)}$remoteSocketEnd(C){const p=this.d.get(C);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$omc=b,e.$omc=b=Ge([We(0,R.$zP)],b);class ${constructor(C,p){this.socketFactoryId=C,this.makeConnection=p}}class k extends L.$Uc{constructor(C,p,y){super(),this.socketId=C,this.actual=p,this.B(y)}}}),define(Se[320],De([1,0,6,11,26]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=void 0;function R(b){return b&&b.title}let N=class{constructor($,k){this.b=k,this.a=$.getProxy(d.$$M.MainThreadMessageService)}showMessage($,k,A,C,p){const y={source:{identifier:$.identifier,label:$.displayName||$.name}};let v;typeof C=="string"||R(C)?v=[C,...p]:(y.modal=C?.modal,y.useCustom=C?.useCustom,y.detail=C?.detail,v=p),y.useCustom&&(0,L.$PG)($,"resolvers");const h=[];let l=!1;for(let o=0;o<v.length;o++){const n=v[o];if(typeof n=="string")h.push({title:n,handle:o,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:u}=n;h.push({title:i,isCloseAffordance:!!u,handle:o}),u&&(l?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,n):l=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,n)}return this.a.$showMessage(k,A,y,h).then(o=>{if(typeof o=="number")return v[o]})}};e.$Zmc=N,e.$Zmc=N=Ge([We(1,O.$3j)],N)}),define(Se[321],De([1,0,3,18,2,26,6]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9mc=void 0;class b{constructor(k){this.b=new Map,this.a=k.getProxy(N.$$M.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,A,C){if((0,R.$PG)(k,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,C),this.a.$registerProfileContentHandler(A,C.name,C.description,k.identifier.value),(0,d.$Sc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(k,A,C,p){const y=this.b.get(k);if(!y)throw new Error(`Unknown handler with id: ${k}`);return y.saveProfile(A,C,p)}async $readProfile(k,A,C){const p=this.b.get(k);if(!p)throw new Error(`Unknown handler with id: ${k}`);return p.readProfile((0,O.$9f)(A)?A:L.URI.revive(A),C)}}e.$9mc=b}),define(Se[118],De([1,0,6,4,5]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=e.$imc=void 0;class R{constructor(b){this.b=new O.$de,this.onDidChangePassword=this.b.event,this.a=b.getProxy(d.$$M.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,$){return this.a.$getPassword(b,$)}store(b,$,k){return this.a.$setPassword(b,$,k)}delete(b,$){return this.a.$deletePassword(b,$)}}e.$imc=R,e.$jmc=(0,L.$wi)("IExtHostSecretState")}),define(Se[322],De([1,0,22,3,6]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dnc=void 0;class R{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.f=new Map,this.b=b.getProxy(L.$$M.MainThreadSpeech)}async $createSpeechToTextSession(b,$,k){const A=this.c.get(b);if(!A)return;const C=new O.$Tc,p=new d.$oe;this.d.set($,p);const y=C.add(A.provideSpeechToTextSession(p.token,k?{language:k}:void 0));C.add(y.onDidChange(v=>{p.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,v)})),C.add(p.token.onCancellationRequested(()=>C.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}async $createTextToSpeechSession(b,$){const k=this.c.get(b);if(!k)return;const A=new O.$Tc,C=new d.$oe;this.d.set($,C);const p=A.add(k.provideTextToSpeechSession(C.token));this.f.set($,p),A.add(p.onDidChange(y=>{C.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,y)})),A.add(C.token.onCancellationRequested(()=>A.dispose()))}async $synthesizeSpeech(b,$){const k=this.f.get(b);k&&k.synthesize($)}async $cancelTextToSpeechSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b),this.f.delete(b)}async $createKeywordRecognitionSession(b,$){const k=this.c.get(b);if(!k)return;const A=new O.$Tc,C=new d.$oe;this.d.set($,C);const p=A.add(k.provideKeywordRecognitionSession(C.token));A.add(p.onDidChange(y=>{C.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,y)})),A.add(C.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,$,k){const A=R.a++;return this.c.set(A,k),this.b.$registerProvider(A,$,{extension:b,displayName:b.value}),(0,O.$Sc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$dnc=R}),define(Se[119],De([1,0,6,4,5]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=e.$$lc=void 0;class R{constructor(b,$){this.c=$,this.b=new O.$de,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(d.$$M.MainThreadStorage)}registerExtensionStorageKeysToSync(b,$){this.a.$registerExtensionStorageKeysToSync(b,$)}async initializeExtensionStorage(b,$,k){const A=await this.a.$initializeExtensionStorage(b,$);let C;return A&&(C=this.d(b,$,A)),C||k}setValue(b,$,k){return this.a.$setValue(b,$,k)}$acceptValue(b,$,k){const A=this.d(b,$,k);A&&this.b.fire({shared:b,key:$,value:A})}d(b,$,k){try{return JSON.parse(k)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${b}): ${A}`)}}}e.$$lc=R,e.$_lc=(0,L.$wi)("IExtHostStorage")}),define(Se[323],De([1,0,3,15,2,6]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tnc=void 0;class N{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(R.$$M.MainThreadUriOpeners)}registerExternalUriOpener($,k,A,C){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const p=C.schemes.find(y=>!N.a.has(y));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this.c.set(k,A),this.b.$registerUriOpener(k,C.schemes,$,C.label),(0,d.$Sc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri($,k,A){const C=this.c.get($);if(!C)throw new Error(`Unknown opener with id: ${$}`);const p=L.URI.revive(k);return C.canOpenExternalUri(p,A)}async $openUri($,k,A){const C=this.c.get($);if(!C)throw new Error(`Unknown opener id: '${$}'`);return C.openExternalUri(L.URI.revive(k.resolvedUri),{sourceUri:L.URI.revive(k.sourceUri)},A)}}e.$tnc=N}),define(Se[324],De([1,0,6,2,3,13,25]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=void 0;class b{static{this.a=0}constructor(k){this.c=new N.$Sm,this.d=new Map,this.b=k.getProxy(d.$$M.MainThreadUrls)}registerUriHandler(k,A){const C=k.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const p=b.a++;return this.c.add(C),this.d.set(p,A),this.b.$registerUriHandler(p,C,k.displayName||k.name),(0,L.$Sc)(()=>{this.c.delete(C),this.d.delete(p),this.b.$unregisterUriHandler(p)})}$handleExternalUri(k,A){const C=this.d.get(k);if(!C)return Promise.resolve(void 0);try{C.handleUri(O.URI.revive(A))}catch(p){(0,R.$1)(p)}return Promise.resolve(void 0)}async createAppUri(k){return O.URI.revive(await this.b.$createAppUri(k))}}e.$unc=b}),define(Se[92],De([1,0,4,3,15,24,2,252,290,114,6]),function(he,e,d,O,L,R,N,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=e.$Vlc=void 0,e.$Wlc=p,e.$Ylc=h,e.$Zlc=l;class C{#e;#t;#n;#i;#s;#r;#a;#o;#c;#u;#l;#d;constructor(u,s,t,c,r,a,f){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new d.$de,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new d.$de,this._onDidDispose=this.#h.event,this.#e=u,this.#t=s,this.#o=t,this.#i=c,this.#s=r,this.#r=a,this.#l=p(a),this.#d=y(a),this.#n=f}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(u){return this.#u=!0,(0,k.$NAb)(u,this.#i)}get cspSource(){const u=this.#r.extensionLocation;if(u.scheme===L.Schemas.https||u.scheme===L.Schemas.http){let s=u.toString();return s.endsWith("/")||(s+="/"),s+" "+k.$MAb}return k.$MAb}get html(){return this.a(),this.#a}set html(u){this.a(),this.#a!==u&&(this.#a=u,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(u)&&(this.#u=!0,this.#n.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(u)))}get options(){return this.a(),this.#o}set options(u){this.a(),R.$7n(this.#o,u)||this.#t.$setOptions(this.#e,l(this.#r,this.#s,u)),this.#o=u}async postMessage(u){if(this.#c)return!1;const s=(0,$.$Erb)(u,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,s.message,...s.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(u){if(!this.#d)return u;const s=this.#r.extensionLocation?.scheme===L.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===L.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return u.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(c,r,a,f,g,w)=>{const S=N.URI.from({scheme:f||"file",path:decodeURIComponent(g)}),m=(0,k.$NAb)(S,{isRemote:s,authority:t}).toString();return`${r}${m}${w}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(c,r,a,f,g,w)=>{const S=N.URI.from({scheme:f||"file",path:decodeURIComponent(g)}),m=(0,k.$NAb)(S,{isRemote:s,authority:t}).toString();return`${r}${m}${w}`})}}e.$Vlc=C;function p(i){try{const u=(0,b.$Ip)((0,b.$Hp)(i.engines.vscode));return!!u&&u.majorBase>=1&&u.minorBase>=57}catch{return!1}}function y(i){try{const u=(0,b.$Ip)((0,b.$Hp)(i.engines.vscode));return u?u.majorBase<1||u.majorBase===1&&u.minorBase<60:!1}catch{return!1}}class v extends O.$Uc{constructor(u,s,t,c,r){super(),this.c=s,this.f=t,this.g=c,this.h=r,this.b=new Map,this.a=u.getProxy(A.$$M.MainThreadWebviews)}dispose(){super.dispose();for(const u of this.b.values())u.dispose();this.b.clear()}$onMessage(u,s,t){const c=this.j(u);if(c){const{message:r}=(0,$.$Frb)(s,t.value);c._onMessageEmitter.fire(r)}}$onMissingCsp(u,s){this.g.warn(`${s} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(u,s,t){const c=new C(u,this.a,o(s),this.c,this.f,t,this.h);this.b.set(u,c);const r=c._onDidDispose(()=>{r.dispose(),this.deleteWebview(u)});return c}deleteWebview(u){this.b.delete(u)}j(u){return this.b.get(u)}}e.$Xlc=v;function h(i){return{id:i.identifier,location:i.extensionLocation}}function l(i,u,s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots||n(i,u)}}function o(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(u=>N.URI.from(u))}}function n(i,u){return[...(u?.getWorkspaceFolders()||[]).map(s=>s.uri),i.extensionLocation]}}),define(Se[151],De([1,0,4,15,14,2,5,20,6]),function(he,e,d,O,L,R,N,b,$){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$xnc=e.$wnc=void 0;let A=class{static{k=this}static{this.a={focused:!0,active:!0}}getState(){const p=this.d;return{get focused(){return p.focused},get active(){return p.active}}}constructor(p){this.c=new d.$de,this.onDidChangeWindowState=this.c.event,this.d=k.a,this.b=p.getProxy($.$$M.MainThreadWindow),this.b.$getInitialState().then(({isFocused:y,isActive:v})=>{this.onDidChangeWindowProperty("focused",y),this.onDidChangeWindowProperty("active",v)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,y){y!==this.d[p]&&(this.d={...this.d,[p]:y},this.c.fire(this.d))}openUri(p,y){let v;if(typeof p=="string"){v=p;try{p=R.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,L.$7e)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,v,y)}async asExternalUri(p,y){if((0,L.$7e)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this.b.$asExternalUri(p,y);return R.URI.from(v)}};e.$wnc=A,e.$wnc=A=k=Ge([We(0,b.$zP)],A),e.$xnc=(0,N.$wi)("IExtHostWindow")}),define(Se[325],De([1,0,317,28,20]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_nc=void 0;const R=1024*1024;let N=class extends d.$Anc{constructor($,k){super($,k),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,k,A){const C=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),k.apply(console,A),C.write(`
END_NATIVE_LOG
`),this.g=!1}j($,k){const A=process[$],C=A.write;let p="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(y,v,h)=>{if(!this.g){p+=y.toString(v);const l=p.length>R?p.length:p.lastIndexOf(`
`);l!==-1&&(console[k](p.slice(0,l)),p=p.slice(l+1))}C.call(A,y,v,h)}})}};e.$_nc=N,e.$_nc=N=Ge([We(0,L.$zP),We(1,O.$PP)],N)}),define(Se[326],De([1,0,150,15,267,30]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$loc=void 0;class N extends d.$znc{s($,k,A){return $.scheme===O.Schemas.file?new L.$OQ(A?.name||(0,R.$Sg)(),$.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,k):super.s($,k,A)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$loc=N}),define(Se[327],De([1,0,7,21,22,13,4,3,134,315,48]),function(he,e,d,O,L,R,N,b,$,k,A){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$$_b=e.ResponsiveState=e.RequestInitiator=void 0,e.$9_b=l,e.$0_b=o;function p(D,P){try{return JSON.stringify(D,P)}catch{return"null"}}const y="$$ref$$",v={[y]:-1};class h{constructor(P,I){this.jsonString=P,this.referencedBuffers=I}}function l(D,P=null,I=!1){const F=[];return{jsonString:(I?p:JSON.stringify)(D,(z,M)=>{if(typeof M>"u")return v;if(typeof M=="object"){if(M instanceof O.$Fe){const j=F.push(M)-1;return{[y]:j}}if(P)return P(z,M)}return M}),referencedBuffers:F}}function o(D,P,I){return JSON.parse(D,(F,T)=>{if(T){const z=T[y];if(typeof z=="number")return P[z];if(I&&T.$mid===1)return I.transformIncoming(T)}return T})}function n(D,P){return JSON.stringify(D,P)}function i(D){return D?(P,I)=>I&&I.$mid===1?D.transformOutgoing(I):I:null}var u;(function(D){D[D.LocalSide=0]="LocalSide",D[D.OtherSide=1]="OtherSide"})(u||(e.RequestInitiator=u={}));var s;(function(D){D[D.Responsive=0]="Responsive",D[D.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const t=()=>{},c=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class a extends b.$Uc{static{C=c}static{this.a=3*1e3}constructor(P,I=null,F=null){super(),this[C]=!0,this.b=this.B(new N.$de),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=I,this.g=F,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let T=0,z=A.$yw.count;T<z;T++)this.m[T]=null,this.s[T]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new d.$Ih(()=>this.H(),1e3)),this.c.onMessage(T=>this.L(T))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const I=this.w[P];delete this.w[P],I.resolveErr(R.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+a.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+a.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,$.$Bn)(P,this.g):P}getProxy(P){const{nid:I,sid:F}=P;return this.s[I]||(this.s[I]=this.J(I,F)),this.s[I]}J(P,I){const F={get:(T,z)=>(typeof z=="string"&&!T[z]&&z.charCodeAt(0)===36&&(T[z]=(...M)=>this.U(P,z,M)),z===r?I:T[z])};return new Proxy(Object.create(null),F)}set(P,I){return this.m[P.nid]=I,I}assertRegistered(P){for(let I=0,F=P.length;I<F;I++){const T=P[I];if(!this.m[T.nid])throw new Error(`Missing proxy instance ${T.sid}`)}}L(P){if(this.j)return;const I=P.byteLength,F=g.read(P,0),T=F.readUInt8(),z=F.readUInt32();switch(T){case 1:case 2:{let{rpcId:M,method:j,args:U}=S.deserializeRequestJSONArgs(F);this.g&&(U=(0,$.$Bn)(U,this.g)),this.M(I,z,M,j,U,T===2);break}case 3:case 4:{let{rpcId:M,method:j,args:U}=S.deserializeRequestMixedArgs(F);this.g&&(U=(0,$.$Bn)(U,this.g)),this.M(I,z,M,j,U,T===4);break}case 5:{this.f?.logIncoming(I,z,0,"ack"),this.G(z);break}case 6:{this.N(I,z);break}case 7:{this.O(I,z,void 0);break}case 9:{let M=S.deserializeReplyOKJSON(F);this.g&&(M=(0,$.$Bn)(M,this.g)),this.O(I,z,M);break}case 10:{const M=S.deserializeReplyOKJSONWithBuffers(F,this.g);this.O(I,z,M);break}case 8:{const M=S.deserializeReplyOKVSBuffer(F);this.O(I,z,M);break}case 11:{let M=S.deserializeReplyErrError(F);this.g&&(M=(0,$.$Bn)(M,this.g)),this.P(I,z,M);break}case 12:{this.P(I,z,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,I,F,T,z,M){this.f?.logIncoming(P,I,1,`receiveRequest ${(0,A.$Aw)(F)}.${T}(`,z);const j=String(I);let U,Z;if(M){const q=new L.$oe;z.push(q.token),U=this.Q(F,T,z),Z=()=>q.cancel()}else U=this.Q(F,T,z),Z=t;this.u[j]=Z;const ie=S.serializeAcknowledged(I);this.f?.logOutgoing(ie.byteLength,I,1,"ack"),this.c.send(ie),U.then(q=>{delete this.u[j];const G=S.serializeReplyOK(I,q,this.h);this.f?.logOutgoing(G.byteLength,I,1,"reply:",q),this.c.send(G)},q=>{delete this.u[j];const G=S.serializeReplyErr(I,q);this.f?.logOutgoing(G.byteLength,I,1,"replyErr:",q),this.c.send(G)})}N(P,I){this.f?.logIncoming(P,I,1,"receiveCancel");const F=String(I);this.u[F]?.()}O(P,I,F){this.f?.logIncoming(P,I,0,"receiveReply:",F);const T=String(I);if(!this.w.hasOwnProperty(T))return;const z=this.w[T];delete this.w[T],z.resolveOk(F)}P(P,I,F){this.f?.logIncoming(P,I,0,"receiveReplyErr:",F);const T=String(I);if(!this.w.hasOwnProperty(T))return;const z=this.w[T];delete this.w[T];let M;F&&(F.$isError?(M=new Error,M.name=F.name,M.message=F.message,M.stack=F.stack):M=F),z.resolveErr(M)}Q(P,I,F){try{return Promise.resolve(this.S(P,I,F))}catch(T){return Promise.reject(T)}}S(P,I,F){const T=this.m[P];if(!T)throw new Error("Unknown actor "+(0,A.$Aw)(P));const z=T[I];if(typeof z!="function")throw new Error("Unknown method "+I+" on actor "+(0,A.$Aw)(P));return z.apply(T,F)}U(P,I,F){if(this.j)return new k.$8_b;let T=null;if(F.length>0&&L.CancellationToken.isCancellationToken(F[F.length-1])&&(T=F.pop()),T&&T.isCancellationRequested)return Promise.reject(R.$6());const z=S.serializeRequestArguments(F,this.h),M=++this.t,j=String(M),U=new k.$7_b,Z=new b.$Tc;T&&Z.add(T.onCancellationRequested(()=>{const q=S.serializeCancel(M);this.f?.logOutgoing(q.byteLength,M,0,"cancel"),this.c.send(S.serializeCancel(M))})),this.w[j]=new f(U,Z),this.F(M);const ie=S.serializeRequest(M,P,I,z,!!T);return this.f?.logOutgoing(ie.byteLength,M,0,`request: ${(0,A.$Aw)(P)}.${I}(`,F),this.c.send(ie),U}}e.$$_b=a;class f{constructor(P,I){this.a=P,this.b=I}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class g{static alloc(P,I,F){const T=new g(O.$Fe.alloc(F+1+4),0);return T.writeUInt8(P),T.writeUInt32(I),T}static read(P,I){return new g(P,I)}get buffer(){return this.a}constructor(P,I){this.a=P,this.b=I}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const F=this.a.slice(this.b,this.b+P).toString();return this.b+=P,F}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+P).toString();return this.b+=P,F}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const I=this.a.slice(this.b,this.b+P);return this.b+=P,I}static sizeMixedArray(P){let I=0;I+=1;for(let F=0,T=P.length;F<T;F++){const z=P[F];switch(I+=1,z.type){case 1:I+=this.sizeLongString(z.value);break;case 2:I+=this.sizeVSBuffer(z.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(z.value);for(let M=0;M<z.buffers.length;++M)I+=this.sizeVSBuffer(z.buffers[M]);break;case 4:break}}return I}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let I=0,F=P.length;I<F;I++){const T=P[I];switch(T.type){case 1:this.writeUInt8(1),this.writeLongString(T.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(T.value);break;case 3:this.writeUInt8(3),this.writeUInt32(T.buffers.length),this.writeLongString(T.value);for(let z=0;z<T.buffers.length;++z)this.writeBuffer(T.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const I=new Array(P);for(let F=0;F<P;F++)switch(this.readUInt8()){case 1:I[F]=this.readLongString();break;case 2:I[F]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),M=this.readLongString(),j=[];for(let U=0;U<z;++U)j.push(this.readVSBuffer());I[F]=new A.$Bw(o(M,j,null));break}case 4:I[F]=void 0;break}return I}}var w;(function(D){D[D.Simple=0]="Simple",D[D.Mixed=1]="Mixed"})(w||(w={}));class S{static a(P){for(let I=0,F=P.length;I<F;I++)if(P[I]instanceof O.$Fe||P[I]instanceof A.$Bw||typeof P[I]>"u")return!0;return!1}static serializeRequestArguments(P,I){if(this.a(P)){const F=[];for(let T=0,z=P.length;T<z;T++){const M=P[T];if(M instanceof O.$Fe)F[T]={type:2,value:M};else if(typeof M>"u")F[T]={type:4};else if(M instanceof A.$Bw){const{jsonString:j,referencedBuffers:U}=l(M.value,I);F[T]={type:3,value:O.$Fe.fromString(j),buffers:U}}else F[T]={type:1,value:O.$Fe.fromString(n(M,I))}}return{type:1,args:F}}return{type:0,args:n(P,I)}}static serializeRequest(P,I,F,T,z){switch(T.type){case 0:return this.b(P,I,F,T.args,z);case 1:return this.c(P,I,F,T.args,z)}}static b(P,I,F,T,z){const M=O.$Fe.fromString(F),j=O.$Fe.fromString(T);let U=0;U+=g.sizeUInt8(),U+=g.sizeShortString(M),U+=g.sizeLongString(j);const Z=g.alloc(z?2:1,P,U);return Z.writeUInt8(I),Z.writeShortString(M),Z.writeLongString(j),Z.buffer}static deserializeRequestJSONArgs(P){const I=P.readUInt8(),F=P.readShortString(),T=P.readLongString();return{rpcId:I,method:F,args:JSON.parse(T)}}static c(P,I,F,T,z){const M=O.$Fe.fromString(F);let j=0;j+=g.sizeUInt8(),j+=g.sizeShortString(M),j+=g.sizeMixedArray(T);const U=g.alloc(z?4:3,P,j);return U.writeUInt8(I),U.writeShortString(M),U.writeMixedArray(T),U.buffer}static deserializeRequestMixedArgs(P){const I=P.readUInt8(),F=P.readShortString(),T=P.readMixedArray(),z=new Array(T.length);for(let M=0,j=T.length;M<j;M++){const U=T[M];typeof U=="string"?z[M]=JSON.parse(U):z[M]=U}return{rpcId:I,method:F,args:z}}static serializeAcknowledged(P){return g.alloc(5,P,0).buffer}static serializeCancel(P){return g.alloc(6,P,0).buffer}static serializeReplyOK(P,I,F){if(typeof I>"u")return this.d(P);if(I instanceof O.$Fe)return this.e(P,I);if(I instanceof A.$Bw){const{jsonString:T,referencedBuffers:z}=l(I.value,F,!0);return this.g(P,T,z)}else return this.f(P,p(I,F))}static d(P){return g.alloc(7,P,0).buffer}static e(P,I){let F=0;F+=g.sizeVSBuffer(I);const T=g.alloc(8,P,F);return T.writeVSBuffer(I),T.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,I){const F=O.$Fe.fromString(I);let T=0;T+=g.sizeLongString(F);const z=g.alloc(9,P,T);return z.writeLongString(F),z.buffer}static g(P,I,F){const T=O.$Fe.fromString(I);let z=0;z+=g.sizeUInt32,z+=g.sizeLongString(T);for(const j of F)z+=g.sizeVSBuffer(j);const M=g.alloc(10,P,z);M.writeUInt32(F.length),M.writeLongString(T);for(const j of F)M.writeBuffer(j);return M.buffer}static deserializeReplyOKJSON(P){const I=P.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(P,I){const F=P.readUInt32(),T=P.readLongString(),z=[];for(let M=0;M<F;++M)z.push(P.readVSBuffer());return new A.$Bw(o(T,z,I))}static serializeReplyErr(P,I){const F=I?p(R.$3(I),null):void 0;if(typeof F!="string")return this.h(P);const T=O.$Fe.fromString(F);let z=0;z+=g.sizeLongString(T);const M=g.alloc(11,P,z);return M.writeLongString(T),M.buffer}static deserializeReplyErrError(P){const I=P.readLongString();return JSON.parse(I)}static h(P){return g.alloc(12,P,0).buffer}}var m;(function(D){D[D.RequestJSONArgs=1]="RequestJSONArgs",D[D.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",D[D.RequestMixedArgs=3]="RequestMixedArgs",D[D.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",D[D.Acknowledged=5]="Acknowledged",D[D.Cancel=6]="Cancel",D[D.ReplyOKEmpty=7]="ReplyOKEmpty",D[D.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",D[D.ReplyOKJSON=9]="ReplyOKJSON",D[D.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",D[D.ReplyErrError=11]="ReplyErrError",D[D.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var E;(function(D){D[D.String=1]="String",D[D.VSBuffer=2]="VSBuffer",D[D.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",D[D.Undefined=4]="Undefined"})(E||(E={}))}),define(Se[328],De([1,0,21,27,15,85,5]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$LK=void 0,e.$MK=A,e.$NK=C,e.$LK=(0,N.$wi)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${b.join("")}]+`),k=7;function A(y){if(y.scheme!==L.Schemas.vscodeNotebookCell)return;const v=y.fragment.indexOf("s");if(v<0)return;const h=parseInt(y.fragment.substring(0,v).replace($,""),k),l=(0,d.$Ye)(y.fragment.substring(v+1)).toString();if(!isNaN(h))return{handle:h,notebook:y.with({scheme:l,fragment:null})}}function C(y,v){const h=v.toString(k),o=`${h.length<b.length?b[h.length-1]:"z"}${h}s${(0,d.$Ze)(d.$Fe.fromString(y.scheme),!0,!0)}`;return y.with({scheme:L.Schemas.vscodeNotebookCell,fragment:o})}class p{constructor(){this.a=new O.$Ac}getNotebook(v){if(v.scheme===L.Schemas.vscodeNotebookCell){const h=A(v);if(h){const l=this.a.get(h.notebook);if(l)return l}}return this.a.get(v)}addNotebookDocument(v){this.a.set(v.uri,v)}removeNotebookDocument(v){this.a.delete(v.uri)}}e.$OK=p,(0,R.$xs)(e.$LK,p,1)}),define(Se[120],De([1,0,21,35,39,101,15,17,12,38,328]),function(he,e,d,O,L,R,N,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9K=e.$6K=e.CellStatusbarAlignment=e.$5K=e.NotebookEditorPriority=e.$2K=e.$1K=e.$YK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$XK=e.$WK=e.$VK=e.$UK=e.CellKind=e.$TK=e.$SK=e.$RK=void 0,e.$ZK=c,e.$3K=a,e.$4K=f,e.$7K=S,e.$8K=E,e.$RK="workbench.editor.notebook",e.$SK="workbench.editor.notebookTextDiffEditor",e.$TK="workbench.editor.interactive";var C;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(C||(e.CellKind=C={})),e.$UK=["application/json","application/javascript","text/html","image/svg+xml",R.$Qs.latex,R.$Qs.markdown,"image/png","image/jpeg",R.$Qs.text],e.$VK=[R.$Qs.latex,R.$Qs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Qs.text],e.$WK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$XK="_notAvailable";var p;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(p||(e.NotebookRunState=p={}));var y;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(y||(e.NotebookCellExecutionState=y={}));var v;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var h;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(h||(e.NotebookRendererMatch=h={}));var l;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(l||(e.RendererMessagingSpec=l={}));var o;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var n;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var u;(function(U){U.scheme=N.Schemas.vscodeNotebookCell;function Z(be,ae){return(0,A.$NK)(be,ae)}U.generate=Z;function ie(be){return(0,A.$MK)(be)}U.parse=ie;function q(be,ae){return be.with({scheme:N.Schemas.vscodeNotebookCellOutput,fragment:`op${ae??""},${be.scheme!==N.Schemas.file?be.scheme:""}`})}U.generateCellOutputUri=q;function G(be){if(be.scheme!==N.Schemas.vscodeNotebookCellOutput)return;const ae=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(be.fragment);if(!ae)return;const Ce=ae[1]&&ae[1]!==""?ae[1]:void 0,ee=ae[2];return{outputId:Ce,notebook:be.with({scheme:ee||N.Schemas.file,fragment:null})}}U.parseCellOutputUri=G;function x(be,ae,Ce){return U.generate(be,ae).with({scheme:Ce})}U.generateCellPropertyUri=x;function ne(be,ae){if(be.scheme===ae)return U.parse(be.with({scheme:U.scheme}))}U.parseCellPropertyUri=ne})(u||(e.CellUri=u={}));const s=U=>$.$i?U.replace(/\//g,"\\"):U;class t{constructor(Z=[],ie=e.$UK){this.e=ie,this.d=[...new Set(Z)].map(q=>({pattern:q,matches:O.$qk(s(q))}))}sort(Z){const ie=new Map(L.Iterable.map(Z,G=>[G,s(G)]));let q=[];for(const{matches:G}of this.d)for(const[x,ne]of ie)if(G(ne)){q.push(x),ie.delete(x);break}return ie.size&&(q=q.concat([...ie.keys()].sort((G,x)=>this.e.indexOf(G)-this.e.indexOf(x)))),q}prioritize(Z,ie){const q=this.f(Z);if(q===-1){this.d.unshift({pattern:Z,matches:O.$qk(s(Z))});return}const G=new Set(ie.map(ne=>this.f(ne,q)));G.delete(-1);const x=Array.from(G).sort();this.d.splice(q+1,0,...x.map(ne=>this.d[ne]));for(let ne=x.length-1;ne>=0;ne--)this.d.splice(x[ne],1)}toArray(){return this.d.map(Z=>Z.pattern)}f(Z,ie=this.d.length){const q=s(Z);for(let G=0;G<ie;G++)if(this.d[G].matches(q))return G;return-1}}e.$YK=t;function c(U,Z,ie,q=(G,x)=>G===x){const G=[];function x(ae,Ce,ee){if(Ce===0&&ee.length===0)return;const B=G[G.length-1];B&&B.start+B.deleteCount===ae?(B.deleteCount+=Ce,B.toInsert.push(...ee)):G.push({start:ae,deleteCount:Ce,toInsert:ee})}let ne=0,be=0;for(;;){if(ne===U.length){x(ne,0,Z.slice(be));break}if(be===Z.length){x(ne,U.length-ne,[]);break}const ae=U[ne],Ce=Z[be];if(q(ae,Ce)){ne+=1,be+=1;continue}ie(Ce)?(x(ne,1,[]),ne+=1):(x(ne,0,[Ce]),be+=1)}return G}e.$1K=new k.$Nj("notebookEditorCursorAtBoundary","none"),e.$2K=new k.$Nj("notebookEditorCursorAtLineBoundary","none");var r;(function(U){U.default="default",U.option="option"})(r||(e.NotebookEditorPriority=r={}));function a(U){const Z=U;return!!((typeof Z.include=="string"||O.$rk(Z.include))&&(typeof Z.exclude=="string"||O.$rk(Z.exclude)))}function f(U,Z,ie){if(Array.isArray(U.viewType)&&U.viewType.indexOf(Z)>=0||U.viewType===Z)return!0;if(U.filenamePattern){const q=a(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,G=a(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(O.$pk(q,(0,b.$nc)(ie.fsPath).toLowerCase()))return!(G&&O.$pk(G,(0,b.$nc)(ie.fsPath).toLowerCase()))}return!1}e.$5K={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var g;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(g||(e.CellStatusbarAlignment=g={}));class w{static{this.d="notebook/"}static create(Z){return`${w.d}${Z}`}static parse(Z){if(Z.startsWith(w.d))return Z.substring(w.d.length)}}e.$6K=w;function S(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}const m=new TextDecoder;function E(U){const Z=[];let ie=!1;for(const ne of U)(Z.length===0||ie)&&(Z.push(ne),ie=!0);let q=I(Z);const G=d.$Fe.concat(Z.map(ne=>d.$Fe.wrap(ne))),x=j(G);return q=q||x.byteLength!==G.byteLength,{data:x,didCompression:q}}e.$9K="\x1B[A";const D=e.$9K.split("").map(U=>U.charCodeAt(0)),P=10;function I(U){let Z=!1;return U.forEach((ie,q)=>{if(q===0||ie.length<e.$9K.length)return;const G=U[q-1],x=ie.subarray(0,e.$9K.length);if(x[0]===D[0]&&x[1]===D[1]&&x[2]===D[2]){const ne=G.lastIndexOf(P);if(ne===-1)return;Z=!0,U[q-1]=G.subarray(0,ne),U[q]=ie.subarray(e.$9K.length)}}),Z}function F(U){let Z=U;do U=Z,Z=U.replace(/[^\n]\x08/gm,"");while(Z.length<U.length);return U}function T(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const Z=U.match(/^(.*)\r+/m)[1];let ie=U.match(/\r+(.*)$/m)[1];ie=ie+Z.slice(ie.length,Z.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ie)}return U}const z=8,M=13;function j(U){return!U.buffer.includes(z)&&!U.buffer.includes(M)?U:d.$Fe.fromString(T(F(m.decode(U.buffer))))}}),define(Se[8],De([1,0,19,13,81,27,101,14,18,2,30,25,33,67,120]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v){"use strict";var h,l,o,n,i,u,s,t,c,r,a,f,g,w,S,m,E;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$nP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$mP=e.$lP=e.$kP=e.$jP=e.ChatLocation=e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$9O=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$8O=e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$VO=e.$UO=e.$TO=e.$SO=e.$QO=e.$PO=e.$OO=e.$NO=e.TestRunProfileKind=e.TestResultState=e.$MO=e.$LO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$KO=e.NotebookVariablesRequestKind=e.$JO=e.$IO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$HO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.ColorThemeKind=e.$BO=e.$AO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$zO=e.$yO=e.DebugConsoleMode=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$sO=e.$rO=e.FileChangeType=e.$qO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$pO=e.$oO=e.$nO=e.$mO=e.InlineCompletionTriggerKind=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$_N=e.ConfigurationTarget=e.$$N=e.$0N=e.$9N=e.$8N=e.DocumentPasteTriggerKind=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$1N=e.ViewBadge=e.ProgressLocation=e.$ZN=e.$YN=e.TaskScope=e.ShellQuoting=e.$XN=e.$WN=e.$VN=e.TaskPanelKind=e.TaskRevealKind=e.$UN=e.TerminalLocation=e.$TN=e.$SN=e.$RN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$QN=e.$PN=e.$ON=e.$NN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$LN=e.$KN=e.$JN=e.$IN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$HN=e.$GN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.LanguageStatusSeverity=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.CodeActionTriggerKind=e.$uN=e.$tN=e.SymbolTag=e.SymbolKind=e.$sN=e.$rN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.DiagnosticSeverity=e.DiagnosticTag=e.$lN=e.$kN=e.FileEditType=e.$jN=e.$iN=e.$hN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$MN=Pt,e.$aO=Qe,e.$RO=vi;function D(H){return Object.assign(H,{apply:function(...me){if(me.length===0)return Reflect.construct(H,[]);{const Me=me.length===1?[]:me[1];return Reflect.construct(H,Me,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(H,[]);{const[Me,...Xe]=me;return Reflect.construct(H,Xe,Me.constructor)}}})}var P;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var I;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(I||(e.TerminalQuickFixType=I={}));let F=h=class{static from(...Q){let me=Q;return new h(function(){if(me){for(const Me of me)Me&&typeof Me.dispose=="function"&&Me.dispose();me=void 0}})}#e;constructor(Q){this.#e=Q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$aN=F,e.$aN=F=h=Ge([D],F);let T=l=class{static Min(...Q){if(Q.length===0)throw new TypeError;let me=Q[0];for(let Me=1;Me<Q.length;Me++){const Xe=Q[Me];Xe.isBefore(me)&&(me=Xe)}return me}static Max(...Q){if(Q.length===0)throw new TypeError;let me=Q[0];for(let Me=1;Me<Q.length;Me++){const Xe=Q[Me];Xe.isAfter(me)&&(me=Xe)}return me}static isPosition(Q){if(!Q)return!1;if(Q instanceof l)return!0;const{line:me,character:Me}=Q;return typeof me=="number"&&typeof Me=="number"}static of(Q){if(Q instanceof l)return Q;if(this.isPosition(Q))return new l(Q.line,Q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(Q,me){if(Q<0)throw(0,O.$7)("line must be non-negative");if(me<0)throw(0,O.$7)("character must be non-negative");this.c=Q,this.e=me}isBefore(Q){return this.c<Q.c?!0:Q.c<this.c?!1:this.e<Q.e}isBeforeOrEqual(Q){return this.c<Q.c?!0:Q.c<this.c?!1:this.e<=Q.e}isAfter(Q){return!this.isBeforeOrEqual(Q)}isAfterOrEqual(Q){return!this.isBefore(Q)}isEqual(Q){return this.c===Q.c&&this.e===Q.e}compareTo(Q){return this.c<Q.c?-1:this.c>Q.line?1:this.e<Q.e?-1:this.e>Q.e?1:0}translate(Q,me=0){if(Q===null||me===null)throw(0,O.$7)();let Me;return typeof Q>"u"?Me=0:typeof Q=="number"?Me=Q:(Me=typeof Q.lineDelta=="number"?Q.lineDelta:0,me=typeof Q.characterDelta=="number"?Q.characterDelta:0),Me===0&&me===0?this:new l(this.line+Me,this.character+me)}with(Q,me=this.character){if(Q===null||me===null)throw(0,O.$7)();let Me;return typeof Q>"u"?Me=this.line:typeof Q=="number"?Me=Q:(Me=typeof Q.line=="number"?Q.line:this.line,me=typeof Q.character=="number"?Q.character:this.character),Me===this.line&&me===this.character?this:new l(Me,me)}toJSON(){return{line:this.line,character:this.character}}};e.$bN=T,e.$bN=T=l=Ge([D],T);let z=o=class{static isRange(Q){return Q instanceof o?!0:Q?T.isPosition(Q.start)&&T.isPosition(Q.end):!1}static of(Q){if(Q instanceof o)return Q;if(this.isRange(Q))return new o(Q.start,Q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(Q,me,Me,Xe){let et,dt;if(typeof Q=="number"&&typeof me=="number"&&typeof Me=="number"&&typeof Xe=="number"?(et=new T(Q,me),dt=new T(Me,Xe)):T.isPosition(Q)&&T.isPosition(me)&&(et=T.of(Q),dt=T.of(me)),!et||!dt)throw new Error("Invalid arguments");et.isBefore(dt)?(this.c=et,this.e=dt):(this.c=dt,this.e=et)}contains(Q){return o.isRange(Q)?this.contains(Q.start)&&this.contains(Q.end):T.isPosition(Q)?!(T.of(Q).isBefore(this.c)||this.e.isBefore(Q)):!1}isEqual(Q){return this.c.isEqual(Q.c)&&this.e.isEqual(Q.e)}intersection(Q){const me=T.Max(Q.start,this.c),Me=T.Min(Q.end,this.e);if(!me.isAfter(Me))return new o(me,Me)}union(Q){if(this.contains(Q))return this;if(Q.contains(this))return Q;const me=T.Min(Q.start,this.c),Me=T.Max(Q.end,this.end);return new o(me,Me)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(Q,me=this.end){if(Q===null||me===null)throw(0,O.$7)();let Me;return Q?T.isPosition(Q)?Me=Q:(Me=Q.start||this.start,me=Q.end||this.end):Me=this.start,Me.isEqual(this.c)&&me.isEqual(this.end)?this:new o(Me,me)}toJSON(){return[this.start,this.end]}};e.$cN=z,e.$cN=z=o=Ge([D],z);let M=n=class extends z{static isSelection(Q){return Q instanceof n?!0:Q?z.isRange(Q)&&T.isPosition(Q.anchor)&&T.isPosition(Q.active)&&typeof Q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(Q,me,Me,Xe){let et,dt;if(typeof Q=="number"&&typeof me=="number"&&typeof Me=="number"&&typeof Xe=="number"?(et=new T(Q,me),dt=new T(Me,Xe)):T.isPosition(Q)&&T.isPosition(me)&&(et=T.of(Q),dt=T.of(me)),!et||!dt)throw new Error("Invalid arguments");super(et,dt),this.f=et,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$dN=M,e.$dN=M=n=Ge([D],M);const j=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,O.$7)("connectionToken")};class U{static isResolvedAuthority(Q){return Q&&typeof Q=="object"&&typeof Q.host=="string"&&typeof Q.port=="number"&&(Q.connectionToken===void 0||typeof Q.connectionToken=="string")}constructor(Q,me,Me){if(typeof Q!="string"||Q.length===0)throw(0,O.$7)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,O.$7)("port");typeof Me<"u"&&j(Me),this.host=Q,this.port=Math.round(me),this.connectionToken=Me}}e.$eN=U;class Z{static isManagedResolvedAuthority(Q){return Q&&typeof Q=="object"&&typeof Q.makeConnection=="function"&&(Q.connectionToken===void 0||typeof Q.connectionToken=="string")}constructor(Q,me){this.makeConnection=Q,this.connectionToken=me,typeof me<"u"&&j(me)}}e.$fN=Z;class ie extends Error{static NotAvailable(Q,me){return new ie(Q,y.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(Q){return new ie(Q,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(Q,me=y.RemoteAuthorityResolverErrorCode.Unknown,Me){super(Q),this._message=Q,this._code=me,this._detail=Me,Object.setPrototypeOf(this,ie.prototype)}}e.$gN=ie;var q;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(q||(e.EndOfLine=q={}));var G;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(G||(e.EnvironmentVariableMutatorType=G={}));let x=i=class{static isTextEdit(Q){return Q instanceof i?!0:Q?z.isRange(Q)&&typeof Q.newText=="string":!1}static replace(Q,me){return new i(Q,me)}static insert(Q,me){return i.replace(new z(Q,Q),me)}static delete(Q){return i.replace(Q,"")}static setEndOfLine(Q){const me=new i(new z(new T(0,0),new T(0,0)),"");return me.newEol=Q,me}get range(){return this.c}set range(Q){if(Q&&!z.isRange(Q))throw(0,O.$7)("range");this.c=Q}get newText(){return this.e||""}set newText(Q){if(Q&&typeof Q!="string")throw(0,O.$7)("newText");this.e=Q}get newEol(){return this.f}set newEol(Q){if(Q&&typeof Q!="number")throw(0,O.$7)("newEol");this.f=Q}constructor(Q,me){this.c=Q,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$hN=x,e.$hN=x=i=Ge([D],x);let ne=u=class{static isNotebookCellEdit(Q){return Q instanceof u?!0:Q?fn.isNotebookRange(Q)&&Array.isArray(Q.newCells):!1}static replaceCells(Q,me){return new u(Q,me)}static insertCells(Q,me){return new u(new fn(Q,Q),me)}static deleteCells(Q){return new u(Q,[])}static updateCellMetadata(Q,me){const Me=new u(new fn(Q,Q),[]);return Me.newCellMetadata=me,Me}static updateNotebookMetadata(Q){const me=new u(new fn(0,0),[]);return me.newNotebookMetadata=Q,me}constructor(Q,me){this.range=Q,this.newCells=me}};e.$iN=ne,e.$iN=ne=u=Ge([D],ne);class be{static isSnippetTextEdit(Q){return Q instanceof be?!0:Q?z.isRange(Q.range)&&ee.isSnippetString(Q.snippet):!1}static replace(Q,me){return new be(Q,me)}static insert(Q,me){return be.replace(new z(Q,Q),me)}constructor(Q,me){this.range=Q,this.snippet=me}}e.$jN=be;var ae;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(ae||(e.FileEditType=ae={}));let Ce=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(Q,me,Me,Xe){this.c.push({_type:1,from:Q,to:me,options:Me,metadata:Xe})}createFile(Q,me,Me){this.c.push({_type:1,from:void 0,to:Q,options:me,metadata:Me})}deleteFile(Q,me,Me){this.c.push({_type:1,from:Q,to:void 0,options:me,metadata:Me})}e(Q,me,Me){this.c.push({_type:3,metadata:Me,uri:Q,edit:{editType:5,metadata:me},notebookMetadata:me})}f(Q,me,Me,Xe){const et=me.start,dt=me.end;(et!==dt||Me.length>0)&&this.c.push({_type:5,uri:Q,index:et,count:dt-et,cells:Me,metadata:Xe})}g(Q,me,Me,Xe){this.c.push({_type:3,metadata:Xe,uri:Q,edit:{editType:3,index:me,metadata:Me}})}replace(Q,me,Me,Xe){this.c.push({_type:2,uri:Q,edit:new x(me,Me),metadata:Xe})}insert(Q,me,Me,Xe){this.replace(Q,new z(me,me),Me,Xe)}delete(Q,me,Me){this.replace(Q,me,"",Me)}has(Q){return this.c.some(me=>me._type===2&&me.uri.toString()===Q.toString())}set(Q,me){if(me)for(const Me of me){if(!Me)continue;let Xe,et;Array.isArray(Me)?(Xe=Me[0],et=Me[1]):Xe=Me,ne.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.g(Q,Xe.range.start,Xe.newCellMetadata,et):Xe.newNotebookMetadata?this.e(Q,Xe.newNotebookMetadata,et):this.f(Q,Xe.range,Xe.newCells,et):be.isSnippetTextEdit(Xe)?this.c.push({_type:6,uri:Q,range:Xe.range,edit:Xe.snippet,metadata:et}):this.c.push({_type:2,uri:Q,edit:Xe,metadata:et})}else{for(let Me=0;Me<this.c.length;Me++){const Xe=this.c[Me];switch(Xe._type){case 2:case 6:case 3:case 5:Xe.uri.toString()===Q.toString()&&(this.c[Me]=void 0);break}}(0,d.$Ib)(this.c)}}get(Q){const me=[];for(const Me of this.c)Me._type===2&&Me.uri.toString()===Q.toString()&&me.push(Me.edit);return me}entries(){const Q=new R.$Ac;for(const me of this.c)if(me._type===2){let Me=Q.get(me.uri);Me||(Me=[me.uri,[]],Q.set(me.uri,Me)),Me[1].push(me.edit)}return[...Q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$kN=Ce,e.$kN=Ce=Ge([D],Ce);let ee=s=class{static isSnippetString(Q){return Q instanceof s?!0:Q?typeof Q.value=="string":!1}static c(Q){return Q.replace(/\$|}|\\/g,"\\$&")}constructor(Q){this.e=1,this.value=Q||""}appendText(Q){return this.value+=s.c(Q),this}appendTabstop(Q=this.e++){return this.value+="$",this.value+=Q,this}appendPlaceholder(Q,me=this.e++){if(typeof Q=="function"){const Me=new s;Me.e=this.e,Q(Me),this.e=Me.e,Q=Me.value}else Q=s.c(Q);return this.value+="${",this.value+=me,this.value+=":",this.value+=Q,this.value+="}",this}appendChoice(Q,me=this.e++){const Me=Q.map(Xe=>Xe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Me,this.value+="|}",this}appendVariable(Q,me){if(typeof me=="function"){const Me=new s;Me.e=this.e,me(Me),this.e=Me.e,me=Me.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=Q,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$lN=ee,e.$lN=ee=s=Ge([D],ee);var B;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(B||(e.DiagnosticTag=B={}));var _;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(_||(e.DiagnosticSeverity=_={}));let pe=t=class{static isLocation(Q){return Q instanceof t?!0:Q?z.isRange(Q.range)&&k.URI.isUri(Q.uri):!1}constructor(Q,me){if(this.uri=Q,me)if(z.isRange(me))this.range=z.of(me);else if(T.isPosition(me))this.range=new z(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$mN=pe,e.$mN=pe=t=Ge([D],pe);let ue=class{static is(Q){return Q?typeof Q.message=="string"&&Q.location&&z.isRange(Q.location.range)&&k.URI.isUri(Q.location.uri):!1}constructor(Q,me){this.location=Q,this.message=me}static isEqual(Q,me){return Q===me?!0:!Q||!me?!1:Q.message===me.message&&Q.location.range.isEqual(me.location.range)&&Q.location.uri.toString()===me.location.uri.toString()}};e.$nN=ue,e.$nN=ue=Ge([D],ue);let ce=class{constructor(Q,me,Me=_.Error){if(!z.isRange(Q))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=Q,this.message=me,this.severity=Me}toJSON(){return{severity:_[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(Q,me){return Q===me?!0:!Q||!me?!1:Q.message===me.message&&Q.severity===me.severity&&Q.code===me.code&&Q.severity===me.severity&&Q.source===me.source&&Q.range.isEqual(me.range)&&(0,d.$ub)(Q.tags,me.tags)&&(0,d.$ub)(Q.relatedInformation,me.relatedInformation,ue.isEqual)}};e.$oN=ce,e.$oN=ce=Ge([D],ce);let oe=class{constructor(Q,me){if(!Q)throw new Error("Illegal argument, contents must be defined");Array.isArray(Q)?this.contents=Q:this.contents=[Q],this.range=me}};e.$pN=oe,e.$pN=oe=Ge([D],oe);let le=class extends oe{constructor(Q,me,Me,Xe){super(Q,me),this.canIncreaseHover=Me,this.canDecreaseHover=Xe}};e.$qN=le,e.$qN=le=Ge([D],le);var K;(function(H){H[H.Increase=0]="Increase",H[H.Decrease=1]="Decrease"})(K||(e.HoverVerbosityAction=K={}));var se;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(se||(e.DocumentHighlightKind=se={}));let $e=class{constructor(Q,me=se.Text){this.range=Q,this.kind=me}toJSON(){return{range:this.range,kind:se[this.kind]}}};e.$rN=$e,e.$rN=$e=Ge([D],$e);let ve=class{constructor(Q,me){this.uri=Q,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(Q=>Q.toJSON())}}};e.$sN=ve,e.$sN=ve=Ge([D],ve);var Re;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(Re||(e.SymbolKind=Re={}));var ge;(function(H){H[H.Deprecated=1]="Deprecated"})(ge||(e.SymbolTag=ge={}));let Ie=c=class{static validate(Q){if(!Q.name)throw new Error("name must not be falsy")}constructor(Q,me,Me,Xe,et){this.name=Q,this.kind=me,this.containerName=et,typeof Me=="string"&&(this.containerName=Me),Xe instanceof pe?this.location=Xe:Me instanceof z&&(this.location=new pe(Xe,Me)),c.validate(this)}toJSON(){return{name:this.name,kind:Re[this.kind],location:this.location,containerName:this.containerName}}};e.$tN=Ie,e.$tN=Ie=c=Ge([D],Ie);let Ae=r=class{static validate(Q){if(!Q.name)throw new Error("name must not be falsy");if(!Q.range.contains(Q.selectionRange))throw new Error("selectionRange must be contained in fullRange");Q.children?.forEach(r.validate)}constructor(Q,me,Me,Xe,et){this.name=Q,this.detail=me,this.kind=Me,this.range=Xe,this.selectionRange=et,this.children=[],r.validate(this)}};e.$uN=Ae,e.$uN=Ae=r=Ge([D],Ae);var ze;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(ze||(e.CodeActionTriggerKind=ze={}));let V=class{constructor(Q,me){this.title=Q,this.kind=me}};e.$vN=V,e.$vN=V=Ge([D],V);let W=class{static{a=this}static{this.c="."}constructor(Q){this.value=Q}append(Q){return new a(this.value?this.value+a.c+Q:Q)}intersects(Q){return this.contains(Q)||Q.contains(this)}contains(Q){return this.value===Q.value||Q.value.startsWith(this.value+a.c)}};e.$wN=W,e.$wN=W=a=Ge([D],W),W.Empty=new W(""),W.QuickFix=W.Empty.append("quickfix"),W.Refactor=W.Empty.append("refactor"),W.RefactorExtract=W.Refactor.append("extract"),W.RefactorInline=W.Refactor.append("inline"),W.RefactorMove=W.Refactor.append("move"),W.RefactorRewrite=W.Refactor.append("rewrite"),W.Source=W.Empty.append("source"),W.SourceOrganizeImports=W.Source.append("organizeImports"),W.SourceFixAll=W.Source.append("fixAll"),W.Notebook=W.Empty.append("notebook");let J=class{constructor(Q,me){if(this.range=Q,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$xN=J,e.$xN=J=Ge([D],J);class X{constructor(Q,me,Me,Xe,et,dt){this.kind=Q,this.name=me,this.detail=Me,this.uri=Xe,this.range=et,this.selectionRange=dt}}e.$yN=X;class de{constructor(Q,me){this.fromRanges=me,this.from=Q}}e.$zN=de;class we{constructor(Q,me){this.fromRanges=me,this.to=Q}}e.$AN=we;var je;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(je||(e.LanguageStatusSeverity=je={}));let Ve=class{constructor(Q,me){this.range=Q,this.command=me}get isResolved(){return!!this.command}};e.$BN=Ve,e.$BN=Ve=Ge([D],Ve);let Je=f=class{#e;static isMarkdownString(Q){return Q instanceof f?!0:Q&&Q.appendCodeblock&&Q.appendMarkdown&&Q.appendText&&Q.value!==void 0}constructor(Q,me=!1){this.#e=new L.$Tk(Q,{supportThemeIcons:me})}get value(){return this.#e.value}set value(Q){this.#e.value=Q}get isTrusted(){return this.#e.isTrusted}set isTrusted(Q){this.#e.isTrusted=Q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(Q){this.#e.supportThemeIcons=Q}get supportHtml(){return this.#e.supportHtml}set supportHtml(Q){this.#e.supportHtml=Q}get baseUri(){return this.#e.baseUri}set baseUri(Q){this.#e.baseUri=Q}appendText(Q){return this.#e.appendText(Q),this}appendMarkdown(Q){return this.#e.appendMarkdown(Q),this}appendCodeblock(Q,me){return this.#e.appendCodeblock(me??"",Q),this}};e.$CN=Je,e.$CN=Je=f=Ge([D],Je);let tt=class{constructor(Q,me){this.label=Q,this.documentation=me}};e.$DN=tt,e.$DN=tt=Ge([D],tt);let _e=class{constructor(Q,me){this.label=Q,this.documentation=me,this.parameters=[]}};e.$EN=_e,e.$EN=_e=Ge([D],_e);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$FN=nt,e.$FN=nt=Ge([D],nt);var it;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var rt;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let at=class{constructor(Q){this.value=Q}};e.$GN=at,e.$GN=at=Ge([D],at);let Ne=class{constructor(Q,me,Me){this.position=Q,this.label=me,this.kind=Me}};e.$HN=Ne,e.$HN=Ne=Ge([D],Ne);var ye;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ye||(e.CompletionTriggerKind=ye={}));var qe;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(qe||(e.CompletionItemKind=qe={}));var te;(function(H){H[H.Deprecated=1]="Deprecated"})(te||(e.CompletionItemTag=te={}));let re=class{constructor(Q,me){this.label=Q,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&qe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$IN=re,e.$IN=re=Ge([D],re);let Pe=class{constructor(Q=[],me=!1){this.items=Q,this.isIncomplete=me}};e.$JN=Pe,e.$JN=Pe=Ge([D],Pe);let He=class{constructor(Q,me,Me){this.insertText=Q,this.range=me,this.command=Me}};e.$KN=He,e.$KN=He=Ge([D],He);let Le=class{constructor(Q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=Q}};e.$LN=Le,e.$LN=Le=Ge([D],Le);var st;(function(H){H[H.Unknown=0]="Unknown",H[H.Word=1]="Word",H[H.Line=2]="Line",H[H.Suggest=3]="Suggest"})(st||(e.PartialAcceptTriggerKind=st={}));var lt;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(lt||(e.ViewColumn=lt={}));var mt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(mt||(e.StatusBarAlignment=mt={}));function Pt(H,Q){return`${C.$Rm.toKey(H)}.${Q}`}var It;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval"})(It||(e.TextEditorLineNumbersStyle=It={}));var Bt;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Bt||(e.TextDocumentSaveReason=Bt={}));var Ut;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Ut||(e.TextEditorRevealType=Ut={}));var kt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(kt||(e.TextEditorSelectionChangeKind=kt={}));var Yt;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Yt||(e.TextDocumentChangeReason=Yt={}));var xt;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(xt||(e.DecorationRangeBehavior=xt={})),function(H){function Q(me){switch(me){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=Q}(kt||(e.TextEditorSelectionChangeKind=kt={}));var xe;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(xe||(e.SyntaxTokenType=xe={})),function(H){function Q(me){switch(me){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=Q}(xe||(e.SyntaxTokenType=xe={}));let on=class{constructor(Q,me){if(me&&!k.URI.isUri(me))throw(0,O.$7)("target");if(!z.isRange(Q)||Q.isEmpty)throw(0,O.$7)("range");this.range=Q,this.target=me}};e.$NN=on,e.$NN=on=Ge([D],on);let Kt=class{constructor(Q,me,Me,Xe){this.red=Q,this.green=me,this.blue=Me,this.alpha=Xe}};e.$ON=Kt,e.$ON=Kt=Ge([D],Kt);let ft=class{constructor(Q,me){if(me&&!(me instanceof Kt))throw(0,O.$7)("color");if(!z.isRange(Q)||Q.isEmpty)throw(0,O.$7)("range");this.range=Q,this.color=me}};e.$PN=ft,e.$PN=ft=Ge([D],ft);let $t=class{constructor(Q){if(!Q||typeof Q!="string")throw(0,O.$7)("label");this.label=Q}};e.$QN=$t,e.$QN=$t=Ge([D],$t);var _t;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(_t||(e.ColorFormat=_t={}));var Jt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var Tt;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(Tt||(e.TerminalExitReason=Tt={}));var gt;(function(H){H[H.Low=0]="Low",H[H.Medium=1]="Medium",H[H.High=2]="High"})(gt||(e.TerminalShellExecutionCommandLineConfidence=gt={}));class Vt{constructor(Q,me,Me){if(this.startIndex=Q,this.length=me,this.tooltip=Me,typeof Q!="number"||Q<0)throw(0,O.$7)("startIndex");if(typeof me!="number"||me<1)throw(0,O.$7)("length");if(Me!==void 0&&typeof Me!="string")throw(0,O.$7)("tooltip")}}e.$RN=Vt;class en{constructor(Q){this.uri=Q}}e.$SN=en;class Wt{constructor(Q){this.terminalCommand=Q}}e.$TN=Wt;var Ze;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(Ze||(e.TerminalLocation=Ze={}));class un{constructor(Q){if(this.options=Q,typeof Q!="object")throw(0,O.$7)("options")}}e.$UN=un;var Xt;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Xt||(e.TaskRevealKind=Xt={}));var Ht;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(Ht||(e.TaskPanelKind=Ht={}));let wt=class{static{g=this}static{this.Clean=new g("clean","Clean")}static{this.Build=new g("build","Build")}static{this.Rebuild=new g("rebuild","Rebuild")}static{this.Test=new g("test","Test")}static from(Q){switch(Q){case"clean":return g.Clean;case"build":return g.Build;case"rebuild":return g.Rebuild;case"test":return g.Test;default:return}}constructor(Q,me){if(this.label=me,typeof Q!="string"||typeof me!="string")throw(0,O.$7)("name");this.c=Q}get id(){return this.c}};e.$VN=wt,e.$VN=wt=g=Ge([D],wt);function Ft(H){let Q="";for(let me=0;me<H.length;me++)Q+=H[me].replace(/,/g,",,")+",";return Q}let Rt=class{constructor(Q,me,Me){if(typeof Q!="string")throw(0,O.$7)("process");this.e=[],this.c=Q,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Me):this.f=me)}get process(){return this.c}set process(Q){if(typeof Q!="string")throw(0,O.$7)("process");this.c=Q}get args(){return this.e}set args(Q){Array.isArray(Q)||(Q=[]),this.e=Q}get options(){return this.f}set options(Q){this.f=Q}computeId(){const Q=[];if(Q.push("process"),this.c!==void 0&&Q.push(this.c),this.e&&this.e.length>0)for(const me of this.e)Q.push(me);return Ft(Q)}};e.$WN=Rt,e.$WN=Rt=Ge([D],Rt);let jt=class{constructor(Q,me,Me){if(this.f=[],Array.isArray(me)){if(!Q)throw(0,O.$7)("command can't be undefined or null");if(typeof Q!="string"&&typeof Q.value!="string")throw(0,O.$7)("command");this.e=Q,this.f=me,this.g=Me}else{if(typeof Q!="string")throw(0,O.$7)("commandLine");this.c=Q,this.g=me}}get commandLine(){return this.c}set commandLine(Q){if(typeof Q!="string")throw(0,O.$7)("commandLine");this.c=Q}get command(){return this.e?this.e:""}set command(Q){if(typeof Q!="string"&&typeof Q.value!="string")throw(0,O.$7)("command");this.e=Q}get args(){return this.f}set args(Q){this.f=Q||[]}get options(){return this.g}set options(Q){this.g=Q}computeId(){const Q=[];if(Q.push("shell"),this.c!==void 0&&Q.push(this.c),this.e!==void 0&&Q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)Q.push(typeof me=="string"?me:me.value);return Ft(Q)}};e.$XN=jt,e.$XN=jt=Ge([D],jt);var tn;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(tn||(e.ShellQuoting=tn={}));var qt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(qt||(e.TaskScope=qt={}));class an{constructor(Q){this.c=Q}computeId(){return"customExecution"+(0,A.$Sg)()}set callback(Q){this.c=Q}get callback(){return this.c}}e.$YN=an;let Ot=class{static{w=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(Q,me,Me,Xe,et,dt){this.k=!1,this.l=this.definition=Q;let bt;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Me,this.execution=Xe,bt=et,this.k=!0):me===qt.Global||me===qt.Workspace?(this.target=me,this.o=this.name=Me,this.w=this.source=Xe,this.execution=et,bt=dt):(this.target=me,this.o=this.name=Me,this.w=this.source=Xe,this.execution=et,bt=dt),typeof bt=="string"?(this.r=[bt],this.t=!0):Array.isArray(bt)?(this.r=bt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(Q){this.j=Q}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Rt?this.l={type:w.e,id:this.q.computeId()}:this.q instanceof jt?this.l={type:w.f,id:this.q.computeId()}:this.q instanceof an?this.l={type:w.c,id:this.q.computeId()}:this.l={type:w.g,id:(0,A.$Sg)()}}get definition(){return this.l}set definition(Q){if(Q==null)throw(0,O.$7)("Kind can't be undefined or null");this.B(),this.l=Q}get scope(){return this.m}set target(Q){this.B(),this.m=Q}get name(){return this.o}set name(Q){if(typeof Q!="string")throw(0,O.$7)("name");this.B(),this.o=Q}get execution(){return this.q}set execution(Q){Q===null&&(Q=void 0),this.B(),this.q=Q;const me=this.l.type;(w.g===me||w.e===me||w.f===me||w.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(Q){if(Array.isArray(Q))this.B(),this.r=Q,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(Q){Q!==!0&&Q!==!1&&(Q=!1),this.B(),this.u=Q}get source(){return this.w}set source(Q){if(typeof Q!="string"||Q.length===0)throw(0,O.$7)("source must be a string of length > 0");this.B(),this.w=Q}get group(){return this.x}set group(Q){Q===null&&(Q=void 0),this.B(),this.x=Q}get detail(){return this.A}set detail(Q){Q===null&&(Q=void 0),this.A=Q}get presentationOptions(){return this.y}set presentationOptions(Q){Q==null&&(Q=Object.create(null)),this.B(),this.y=Q}get runOptions(){return this.z}set runOptions(Q){Q==null&&(Q=Object.create(null)),this.B(),this.z=Q}};e.$ZN=Ot,e.$ZN=Ot=w=Ge([D],Ot);var Lt;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Lt||(e.ProgressLocation=Lt={}));var Mt;(function(H){function Q(me){const Me=me;return(0,$.$ag)(Me.value)?Me.tooltip&&!(0,$.$9f)(Me.tooltip)?(console.log("INVALID view badge, invalid tooltip",Me.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Me.value),!1)}H.isViewBadge=Q})(Mt||(e.ViewBadge=Mt={}));let At=S=class{static isTreeItem(Q,me){const Me=Q;if(Me.checkboxState!==void 0){const Xe=(0,$.$ag)(Me.checkboxState)?Me.checkboxState:(0,$.$$f)(Me.checkboxState)&&(0,$.$ag)(Me.checkboxState.state)?Me.checkboxState.state:void 0,et=!(0,$.$ag)(Me.checkboxState)&&(0,$.$$f)(Me.checkboxState)?Me.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==St.Checked&&Xe!==St.Unchecked||et!==void 0&&!(0,$.$9f)(et))return console.log("INVALID tree item, invalid checkboxState",Me.checkboxState),!1}if(Q instanceof S)return!0;if(Me.label!==void 0&&!(0,$.$9f)(Me.label)&&!Me.label?.label)return console.log("INVALID tree item, invalid label",Me.label),!1;if(Me.id!==void 0&&!(0,$.$9f)(Me.id))return console.log("INVALID tree item, invalid id",Me.id),!1;if(Me.iconPath!==void 0&&!(0,$.$9f)(Me.iconPath)&&!k.URI.isUri(Me.iconPath)&&(!Me.iconPath||!(0,$.$9f)(Me.iconPath.id))){const Xe=Me.iconPath;if(!Xe||!(0,$.$9f)(Xe.light)&&!k.URI.isUri(Xe.light)&&!(0,$.$9f)(Xe.dark)&&!k.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Me.iconPath),!1}return Me.description!==void 0&&!(0,$.$9f)(Me.description)&&typeof Me.description!="boolean"?(console.log("INVALID tree item, invalid description",Me.description),!1):Me.resourceUri!==void 0&&!k.URI.isUri(Me.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Me.resourceUri),!1):Me.tooltip!==void 0&&!(0,$.$9f)(Me.tooltip)&&!(Me.tooltip instanceof Je)?(console.log("INVALID tree item, invalid tooltip",Me.tooltip),!1):Me.command!==void 0&&!Me.command.command?(console.log("INVALID tree item, invalid command",Me.command),!1):Me.collapsibleState!==void 0&&Me.collapsibleState<pt.None&&Me.collapsibleState>pt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Me.collapsibleState),!1):Me.contextValue!==void 0&&!(0,$.$9f)(Me.contextValue)?(console.log("INVALID tree item, invalid contextValue",Me.contextValue),!1):Me.accessibilityInformation!==void 0&&!Me.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Me.accessibilityInformation),!1):!0}constructor(Q,me=pt.None){this.collapsibleState=me,k.URI.isUri(Q)?this.resourceUri=Q:this.label=Q}};e.$1N=At,e.$1N=At=S=Ge([D],At);var pt;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(pt||(e.TreeItemCollapsibleState=pt={}));var St;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(St||(e.TreeItemCheckboxState=St={}));let sn=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(Q){this.value=Q}};e.$2N=sn,e.$2N=sn=Ge([D],sn);class Dt extends sn{}e.$3N=Dt;class mn extends Dt{#e;constructor(Q){super(""),this.#e=Q}asFile(){return this.#e}}e.$4N=mn;class nn{constructor(Q,me,Me,Xe){this.name=Q,this.uri=me,this._itemId=Me,this.c=Xe}data(){return this.c()}}e.$5N=nn;let bn=class{#e=new Map;constructor(Q){for(const[me,Me]of Q??[]){const Xe=this.#e.get(this.#t(me));Xe?Xe.push(Me):this.#e.set(this.#t(me),[Me])}}get(Q){return this.#e.get(this.#t(Q))?.[0]}set(Q,me){this.#e.set(this.#t(Q),[me])}forEach(Q,me){for(const[Me,Xe]of this.#e)for(const et of Xe)Q.call(me,et,Me,this)}*[Symbol.iterator](){for(const[Q,me]of this.#e)for(const Me of me)yield[Q,Me]}#t(Q){return Q.toLowerCase()}};e.$6N=bn,e.$6N=bn=Ge([D],bn);let ln=class{constructor(Q,me,Me){this.insertText=Q,this.title=me,this.kind=Me}};e.$7N=ln,e.$7N=ln=Ge([D],ln);var wn;(function(H){H[H.Automatic=0]="Automatic",H[H.PasteAs=1]="PasteAs"})(wn||(e.DocumentPasteTriggerKind=wn={}));class Ct{static{this.c="."}constructor(Q){this.value=Q}append(...Q){return new Ct((this.value?[this.value,...Q]:Q).join(Ct.c))}intersects(Q){return this.contains(Q)||Q.contains(this)}contains(Q){return this.value===Q.value||Q.value.startsWith(this.value+Ct.c)}}e.$8N=Ct,Ct.Empty=new Ct("");class Dn{constructor(Q,me,Me){this.title=me,this.insertText=Q,this.kind=Me}}e.$9N=Dn;let Oe=class{constructor(Q,me){this.id=Q,this.color=me}static isThemeIcon(Q){return typeof Q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",Q.id),!1):!0}};e.$0N=Oe,e.$0N=Oe=Ge([D],Oe),Oe.File=new Oe("file"),Oe.Folder=new Oe("folder");let Te=class{constructor(Q){this.id=Q}};e.$$N=Te,e.$$N=Te=Ge([D],Te);var ke;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(ke||(e.ConfigurationTarget=ke={}));let Y=class{get base(){return this.c}set base(Q){this.c=Q,this.e=k.URI.file(Q)}get baseUri(){return this.e}set baseUri(Q){this.e=Q,this.c=Q.fsPath}constructor(Q,me){if(typeof Q!="string"&&(!Q||!k.URI.isUri(Q)&&!k.URI.isUri(Q.uri)))throw(0,O.$7)("base");if(typeof me!="string")throw(0,O.$7)("pattern");typeof Q=="string"?this.baseUri=k.URI.file(Q):k.URI.isUri(Q)?this.baseUri=Q:this.baseUri=Q.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$_N=Y,e.$_N=Y=Ge([D],Y);const Fe=new WeakMap;function Qe(H,Q){Fe.set(H,Q)}let Ye=class{constructor(Q,me,Me,Xe,et){this.enabled=typeof Q=="boolean"?Q:!0,typeof me=="string"&&(this.condition=me),typeof Me=="string"&&(this.hitCondition=Me),typeof Xe=="string"&&(this.logMessage=Xe),typeof et=="string"&&(this.mode=et)}get id(){return this.c||(this.c=Fe.get(this)??(0,A.$Sg)()),this.c}};e.$bO=Ye,e.$bO=Ye=Ge([D],Ye);let Ke=class extends Ye{constructor(Q,me,Me,Xe,et,dt){if(super(me,Me,Xe,et,dt),Q===null)throw(0,O.$7)("location");this.location=Q}};e.$cO=Ke,e.$cO=Ke=Ge([D],Ke);let ht=class extends Ye{constructor(Q,me,Me,Xe,et,dt){super(me,Me,Xe,et,dt),this.functionName=Q}};e.$dO=ht,e.$dO=ht=Ge([D],ht);let Et=class extends Ye{constructor(Q,me,Me,Xe,et,dt,bt,Gt){if(super(Xe,et,dt,bt,Gt),!me)throw(0,O.$7)("dataId");this.label=Q,this.dataId=me,this.canPersist=Me}};e.$eO=Et,e.$eO=Et=Ge([D],Et);let zt=class{constructor(Q,me,Me){this.command=Q,this.args=me||[],this.options=Me}};e.$fO=zt,e.$fO=zt=Ge([D],zt);let Qt=class{constructor(Q,me){this.port=Q,this.host=me}};e.$gO=Qt,e.$gO=Qt=Ge([D],Qt);let ut=class{constructor(Q){this.path=Q}};e.$hO=ut,e.$hO=ut=Ge([D],ut);let Zt=class{constructor(Q){this.implementation=Q}};e.$iO=Zt,e.$iO=Zt=Ge([D],Zt);class $n{constructor(Q,me,Me){this.session=Q,this.threadId=me,this.frameId=Me}}e.$jO=$n;class En{constructor(Q,me){this.session=Q,this.threadId=me}}e.$kO=En;let Pn=class{constructor(Q,me){this.range=Q,this.expression=me}};e.$lO=Pn,e.$lO=Pn=Ge([D],Pn);var Kn;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Kn||(e.InlineCompletionTriggerKind=Kn={}));let On=class{constructor(Q,me){this.range=Q,this.text=me}};e.$mO=On,e.$mO=On=Ge([D],On);let Mn=class{constructor(Q,me,Me=!0){this.range=Q,this.variableName=me,this.caseSensitiveLookup=Me}};e.$nO=Mn,e.$nO=Mn=Ge([D],Mn);let Cn=class{constructor(Q,me){this.range=Q,this.expression=me}};e.$oO=Cn,e.$oO=Cn=Ge([D],Cn);let Tn=class{constructor(Q,me){this.frameId=Q,this.stoppedLocation=me}};e.$pO=Tn,e.$pO=Tn=Ge([D],Tn);var Fn;(function(H){H[H.AIGenerated=1]="AIGenerated"})(Fn||(e.NewSymbolNameTag=Fn={}));var Jn;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Jn||(e.NewSymbolNameTriggerKind=Jn={}));class jn{constructor(Q,me){this.newSymbolName=Q,this.tags=me}}e.$qO=jn;var In;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(In||(e.FileChangeType=In={}));let zn=m=class extends Error{static FileExists(Q){return new m(Q,p.FileSystemProviderErrorCode.FileExists,m.FileExists)}static FileNotFound(Q){return new m(Q,p.FileSystemProviderErrorCode.FileNotFound,m.FileNotFound)}static FileNotADirectory(Q){return new m(Q,p.FileSystemProviderErrorCode.FileNotADirectory,m.FileNotADirectory)}static FileIsADirectory(Q){return new m(Q,p.FileSystemProviderErrorCode.FileIsADirectory,m.FileIsADirectory)}static NoPermissions(Q){return new m(Q,p.FileSystemProviderErrorCode.NoPermissions,m.NoPermissions)}static Unavailable(Q){return new m(Q,p.FileSystemProviderErrorCode.Unavailable,m.Unavailable)}constructor(Q,me=p.FileSystemProviderErrorCode.Unknown,Me){super(k.URI.isUri(Q)?Q.toString(!0):Q),this.code=Me?.name??"Unknown",(0,p.$fl)(this,me),Object.setPrototypeOf(this,m.prototype),typeof Error.captureStackTrace=="function"&&typeof Me=="function"&&Error.captureStackTrace(this,Me)}};e.$rO=zn,e.$rO=zn=m=Ge([D],zn);let Bn=class{constructor(Q,me,Me){this.start=Q,this.end=me,this.kind=Me}};e.$sO=Bn,e.$sO=Bn=Ge([D],Bn);var vn;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(vn||(e.FoldingRangeKind=vn={}));var Xn;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Xn||(e.CommentThreadCollapsibleState=Xn={}));var Zn;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(Zn||(e.CommentMode=Zn={}));var Yn;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Yn||(e.CommentState=Yn={}));var An;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(An||(e.CommentThreadState=An={}));var xn;(function(H){H[H.Current=0]="Current",H[H.Outdated=1]="Outdated"})(xn||(e.CommentThreadApplicability=xn={}));class _n{constructor(Q,me=[]){this.tokenTypes=Q,this.tokenModifiers=me}}e.$tO=_n;function di(H){return typeof H>"u"||(0,$.$0f)(H)}class Rn{constructor(Q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,Q){this.m=!0;for(let me=0,Me=Q.tokenTypes.length;me<Me;me++)this.k.set(Q.tokenTypes[me],me);for(let me=0,Me=Q.tokenModifiers.length;me<Me;me++)this.l.set(Q.tokenModifiers[me],me)}}push(Q,me,Me,Xe,et){if(typeof Q=="number"&&typeof me=="number"&&typeof Me=="number"&&typeof Xe=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.q(Q,me,Me,Xe,et);if(z.isRange(Q)&&typeof me=="string"&&di(Me))return this.o(Q,me,Me);throw(0,O.$7)()}o(Q,me,Me){if(!this.m)throw new Error("Legend must be provided in constructor");if(Q.start.line!==Q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const Xe=Q.start.line,et=Q.start.character,dt=Q.end.character-Q.start.character,bt=this.k.get(me);let Gt=0;if(Me)for(const cn of Me){if(!this.l.has(cn))throw new Error("`tokenModifier` is not in the provided legend");const dn=this.l.get(cn);Gt|=1<<dn>>>0}this.q(Xe,et,dt,bt,Gt)}q(Q,me,Me,Xe,et){if(this.f&&(Q<this.c||Q===this.c&&me<this.e)){this.f=!1;const Gt=this.g.length/5|0;let cn=0,dn=0;for(let gn=0;gn<Gt;gn++){let pn=this.g[5*gn],Hn=this.g[5*gn+1];pn===0?(pn=cn,Hn+=dn):pn+=cn,this.g[5*gn]=pn,this.g[5*gn+1]=Hn,cn=pn,dn=Hn}}let dt=Q,bt=me;this.f&&this.j>0&&(dt-=this.c,dt===0&&(bt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=bt,this.g[this.j++]=Me,this.g[this.j++]=Xe,this.g[this.j++]=et,this.c=Q,this.e=me}static r(Q){const me=[],Me=Q.length/5|0;for(let bt=0;bt<Me;bt++)me[bt]=bt;me.sort((bt,Gt)=>{const cn=Q[5*bt],dn=Q[5*Gt];if(cn===dn){const gn=Q[5*bt+1],pn=Q[5*Gt+1];return gn-pn}return cn-dn});const Xe=new Uint32Array(Q.length);let et=0,dt=0;for(let bt=0;bt<Me;bt++){const Gt=5*me[bt],cn=Q[Gt+0],dn=Q[Gt+1],gn=Q[Gt+2],pn=Q[Gt+3],Hn=Q[Gt+4],Ti=cn-et,gr=Ti===0?dn-dt:dn,Gn=5*bt;Xe[Gn+0]=Ti,Xe[Gn+1]=gr,Xe[Gn+2]=gn,Xe[Gn+3]=pn,Xe[Gn+4]=Hn,et=cn,dt=dn}return Xe}build(Q){return this.f?new Un(new Uint32Array(this.g),Q):new Un(Rn.r(this.g),Q)}}e.$uO=Rn;class Un{constructor(Q,me){this.resultId=me,this.data=Q}}e.$vO=Un;class fi{constructor(Q,me,Me){this.start=Q,this.deleteCount=me,this.data=Me}}e.$wO=fi;class gi{constructor(Q,me){this.resultId=me,this.edits=Q}}e.$xO=gi;var ei;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(ei||(e.DebugConsoleMode=ei={}));class Wn{constructor(Q){this.name=Q}}e.$yO=Wn;let Nn=class{static{this.Back={iconPath:new Oe("arrow-left")}}constructor(){}};e.$zO=Nn,e.$zO=Nn=Ge([D],Nn);var Ue;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(Ue||(e.QuickPickItemKind=Ue={}));var hn;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(hn||(e.InputBoxValidationSeverity=hn={}));var Vn;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Vn||(e.ExtensionKind=Vn={}));class ot{static validate(Q){if(typeof Q.badge=="string"){let me=(0,b.$Hf)(Q.badge,0);if(me<Q.badge.length&&(me+=(0,b.$Hf)(Q.badge,me)),Q.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(Q.badge&&!Oe.isThemeIcon(Q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!Q.color&&!Q.badge&&!Q.tooltip)throw new Error("The decoration is empty");return!0}constructor(Q,me,Me){this.badge=Q,this.tooltip=me,this.color=Me}}e.$AO=ot;let vt=class{constructor(Q){this.kind=Q}};e.$BO=vt,e.$BO=vt=Ge([D],vt);var ti;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(ti||(e.ColorThemeKind=ti={}));class fn{static isNotebookRange(Q){return Q instanceof fn?!0:Q?typeof Q.start=="number"&&typeof Q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(Q,me){if(Q<0)throw(0,O.$7)("start must be positive");if(me<0)throw(0,O.$7)("end must be positive");Q<=me?(this.c=Q,this.e=me):(this.c=me,this.e=Q)}with(Q){let me=this.c,Me=this.e;return Q.start!==void 0&&(me=Q.start),Q.end!==void 0&&(Me=Q.end),me===this.c&&Me===this.e?this:new fn(me,Me)}}e.$CO=fn;class kn{static validate(Q){if(typeof Q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof Q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof Q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(Q){return Array.isArray(Q)&&Q.every(me=>kn.isNotebookCellData(me))}static isNotebookCellData(Q){return!0}constructor(Q,me,Me,Xe,et,dt,bt){this.kind=Q,this.value=me,this.languageId=Me,this.mime=Xe,this.outputs=et??[],this.metadata=dt,this.executionSummary=bt,kn.validate(this)}}e.$DO=kn;class mi{constructor(Q){this.cells=Q}}e.$EO=mi;class rn{static isNotebookCellOutputItem(Q){return Q instanceof rn?!0:Q?typeof Q.mime=="string"&&Q.data instanceof Uint8Array:!1}static error(Q){const me={name:Q.name,message:Q.message,stack:Q.stack};return rn.json(me,"application/vnd.code.notebook.error")}static stdout(Q){return rn.text(Q,"application/vnd.code.notebook.stdout")}static stderr(Q){return rn.text(Q,"application/vnd.code.notebook.stderr")}static bytes(Q,me="application/octet-stream"){return new rn(Q,me)}static#e=new TextEncoder;static text(Q,me=N.$Qs.text){const Me=rn.#e.encode(String(Q));return new rn(Me,me)}static json(Q,me="text/x-json"){const Me=JSON.stringify(Q,void 0,"	");return rn.text(Me,me)}constructor(Q,me){this.data=Q,this.mime=me;const Me=(0,N.$Us)(me,!0);if(!Me)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Me}}e.$FO=rn;class Ln{static isNotebookCellOutput(Q){return Q instanceof Ln?!0:!Q||typeof Q!="object"?!1:typeof Q.id=="string"&&Array.isArray(Q.items)}static ensureUniqueMimeTypes(Q,me=!1){const Me=new Set,Xe=new Set;for(let et=0;et<Q.length;et++){const dt=Q[et],bt=(0,N.$Us)(dt.mime);if(!Me.has(bt)||(0,v.$7K)(bt)){Me.add(bt);continue}Xe.add(et),me&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Xe.size===0?Q:Q.filter((et,dt)=>!Xe.has(dt))}constructor(Q,me,Me){this.items=Ln.ensureUniqueMimeTypes(Q,!0),typeof me=="string"?(this.id=me,this.metadata=Me):(this.id=(0,A.$Sg)(),this.metadata=me??Me)}}e.$GO=Ln;var ni;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(ni||(e.NotebookCellKind=ni={}));var ii;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(ii||(e.NotebookCellExecutionState=ii={}));var qn;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(qn||(e.NotebookCellStatusBarAlignment=qn={}));var ri;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ri||(e.NotebookEditorRevealType=ri={}));class $i{constructor(Q,me){this.text=Q,this.alignment=me}}e.$HO=$i;var si;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(si||(e.NotebookControllerAffinity=si={}));var oi;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(oi||(e.NotebookControllerAffinity2=oi={}));class pi{constructor(Q,me=[]){this.uri=Q,this.provides=(0,d.$2b)(me)}}e.$IO=pi;class bi{constructor(Q){this.label=Q}}e.$JO=bi;var ai;(function(H){H[H.Named=1]="Named",H[H.Indexed=2]="Indexed"})(ai||(e.NotebookVariablesRequestKind=ai={}));let Qn=class{constructor(Q,me){this.label=Q,this.timestamp=me}};e.$KO=Qn,e.$KO=Qn=Ge([D],Qn);var ci;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(ci||(e.ExtensionMode=ci={}));var ui;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(ui||(e.ExtensionRuntime=ui={}));var li;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(li||(e.StandardTokenType=li={}));class fe{constructor(Q,me){this.ranges=Q,this.wordPattern=me}}e.$LO=fe;class Ee{constructor(Q){this.c=Q}get autoForwardAction(){return this.c}}e.$MO=Ee;var Be;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(Be||(e.TestResultState=Be={}));var ct;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(ct||(e.TestRunProfileKind=ct={}));let yt=class{constructor(Q=void 0,me=void 0,Me=void 0,Xe=!1,et=!0){this.include=Q,this.exclude=me,this.profile=Me,this.continuous=Xe,this.preserveFocus=et}};e.$NO=yt,e.$NO=yt=Ge([D],yt);let Nt=E=class{static diff(Q,me,Me){const Xe=new E(Q);return Xe.expectedOutput=me,Xe.actualOutput=Me,Xe}constructor(Q){this.message=Q}};e.$OO=Nt,e.$OO=Nt=E=Ge([D],Nt);let Sn=class{constructor(Q){this.id=Q}};e.$PO=Sn,e.$PO=Sn=Ge([D],Sn);class hi{constructor(Q,me){this.covered=Q,this.total=me,vi(this)}}e.$QO=hi;function vi(H){if(H){if(H.covered>H.total)throw new Error(`The total number of covered items (${H.covered}) cannot be greater than the total (${H.total})`);if(H.total<0)throw new Error(`The number of covered items (${H.total}) cannot be negative`)}}class wi{static fromDetails(Q,me){const Me=new hi(0,0),Xe=new hi(0,0),et=new hi(0,0);for(const bt of me)if("branches"in bt){Me.total+=1,Me.covered+=bt.executed?1:0;for(const Gt of bt.branches)Xe.total+=1,Xe.covered+=Gt.executed?1:0}else et.total+=1,et.covered+=bt.executed?1:0;const dt=new wi(Q,Me,Xe.total>0?Xe:void 0,et.total>0?et:void 0);return dt.detailedCoverage=me,dt}constructor(Q,me,Me,Xe){this.uri=Q,this.statementCoverage=me,this.branchCoverage=Me,this.declarationCoverage=Xe}}e.$SO=wi;class Fi{get executionCount(){return+this.executed}set executionCount(Q){this.executed=Q}constructor(Q,me,Me=[]){this.executed=Q,this.location=me,this.branches=Me}}e.$TO=Fi;class ji{get executionCount(){return+this.executed}set executionCount(Q){this.executed=Q}constructor(Q,me,Me){this.executed=Q,this.location=me,this.label=Me}}e.$UO=ji;class zi{get executionCount(){return+this.executed}set executionCount(Q){this.executed=Q}constructor(Q,me,Me){this.name=Q,this.executed=me,this.location=Me}}e.$VO=zi;var yi;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(yi||(e.ExternalUriOpenerPriority=yi={}));var Ei;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(Ei||(e.WorkspaceTrustState=Ei={}));var ki;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(ki||(e.PortAutoForwardAction=ki={}));class Bi{constructor(Q,me,Me,Xe,et,dt){this.kind=Q,this.name=me,this.detail=Me,this.uri=Xe,this.range=et,this.selectionRange=dt}}e.$WO=Bi;class Ui{constructor(Q){this.uri=Q}}e.$XO=Ui;class Wi{constructor(Q,me){this.original=Q,this.modified=me}}e.$YO=Wi;class Vi{constructor(Q,me,Me,Xe){this.base=Q,this.input1=me,this.input2=Me,this.result=Xe}}e.$ZO=Vi;class qi{constructor(Q,me){this.uri=Q,this.viewType=me}}e.$1O=qi;class Qi{constructor(Q){this.viewType=Q}}e.$2O=Qi;class Hi{constructor(Q,me){this.uri=Q,this.notebookType=me}}e.$3O=Hi;class Gi{constructor(Q,me,Me){this.original=Q,this.modified=me,this.notebookType=Me}}e.$4O=Gi;class Ki{constructor(){}}e.$5O=Ki;class Ji{constructor(Q,me){this.uri=Q,this.inputBoxUri=me}}e.$6O=Ji;class Xi{constructor(){}}e.$7O=Xi;class Zi{constructor(Q){this.textDiffs=Q}}e.$8O=Zi;var Si;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})(Si||(e.InteractiveSessionVoteDirection=Si={}));var Di;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(Di||(e.ChatCopyKind=Di={}));var Pi;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(Pi||(e.ChatVariableLevel=Pi={}));class Yi{constructor(Q,me){this.label=Q,this.values=me}}e.$9O=Yi;var Ci;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted",H[H.Bug=4]="Bug"})(Ci||(e.InteractiveEditorResponseFeedbackKind=Ci={}));var Ii;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(Ii||(e.ChatResultFeedbackKind=Ii={}));class xi{constructor(Q){if(typeof Q!="string"&&Q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof Q=="string"?new Je(Q):Q}}e.$0O=xi;class _i{constructor(Q,me){if(typeof Q!="string"&&Q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof Q=="string"?new Je(Q):Q,this.vulnerabilities=me}}e.$$O=_i;class er{constructor(Q,me){this.participant=Q,this.command=me}}e.$_O=er;class tr{constructor(Q,me){this.value=Q,this.baseUri=me}}e.$aP=tr;class nr{constructor(Q,me){this.value=Q,this.title=me}}e.$bP=nr;class ir{constructor(Q){this.value=Q}}e.$cP=ir;class rr{constructor(Q){if(typeof Q!="string"&&Q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof Q=="string"?new Je(Q):Q}}e.$dP=rr;class sr{constructor(Q){this.value=Q}}e.$eP=sr;class or{constructor(Q,me){this.value=Q,this.iconPath=me}}e.$fP=or;class ar{constructor(Q,me){this.uri=Q,this.edits=Array.isArray(me)?me:[me]}}e.$gP=ar;class cr{constructor(Q,me,Me,Xe){this.prompt=Q,this.command=me,this.variables=Me,this.participant=Xe}}e.$hP=cr;class ur{constructor(Q,me,Me,Xe){this.response=Q,this.result=me,this.participant=Me,this.command=Xe}}e.$iP=ur;var Ai;(function(H){H[H.Panel=1]="Panel",H[H.Terminal=2]="Terminal",H[H.Notebook=3]="Notebook",H[H.Editor=4]="Editor"})(Ai||(e.ChatLocation=Ai={}));class lr{constructor(Q){this.content=Q}}e.$jP=lr;class hr{constructor(Q,me){this.content=Q,this.name=me}}e.$kP=hr;class dr{constructor(Q,me){this.content=Q,this.name=me}}e.$lP=dr;class yn extends Error{static NotFound(Q){return new yn(Q,yn.NotFound.name)}static NoPermissions(Q){return new yn(Q,yn.NoPermissions.name)}static Blocked(Q){return new yn(Q,yn.Blocked.name)}constructor(Q,me,Me){super(Q,{cause:Me}),this.name="LanguageModelError",this.code=me??""}}e.$mP=yn;var Ri;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(Ri||(e.RelatedInformationType=Ri={}));var Ni;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped",H[H.Error=5]="Error"})(Ni||(e.SpeechToTextStatus=Ni={}));var Li;(function(H){H[H.Started=1]="Started",H[H.Stopped=2]="Stopped",H[H.Error=3]="Error"})(Li||(e.TextToSpeechStatus=Li={}));var Oi;(function(H){H[H.Recognized=1]="Recognized",H[H.Stopped=2]="Stopped"})(Oi||(e.KeywordRecognitionStatus=Oi={}));class fr{constructor(Q,me){this.text=Q,this.range=me}}e.$nP=fr;var Mi;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Mi||(e.InlineEditTriggerKind=Mi={}))}),define(Se[329],De([1,0,6,8]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=void 0;class L{constructor(N){this.a=new Map,this.b=0,this.c=N.getProxy(d.$$M.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(N,b,$){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(N);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(b,$)??[]}getRelatedInformation(N,b,$){return this.c.$getAiRelatedInformation(b,$)}registerRelatedInformationProvider(N,b,$){const k=this.b;return this.b++,this.a.set(k,$),this.c.$registerAiRelatedInformationProvider(k,b),new O.$aN(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$qlc=L}),define(Se[121],De([1,0,4,6,8,25,146,5,20]),function(he,e,d,O,L,R,N,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Clc=e.$Blc=void 0,e.$Blc=(0,b.$wi)("IExtHostAuthentication");let k=class{constructor(p){this.b=new Map,this.c=new d.$de,this.onDidChangeSessions=this.c.event,this.d=new A,this.f=new A,this.a=p.getProxy(O.$$M.MainThreadAuthentication)}async getSession(p,y,v,h={}){const l=R.$Rm.toKey(p.identifier),o=[...v].sort().join(" ");return await this.d.getOrCreate(`${l} ${y} ${o}`,async()=>{await this.a.$ensureProvider(y);const n=p.displayName||p.name;return this.a.$getSession(y,v,l,n,h)})}async getSessions(p,y,v){const h=R.$Rm.toKey(p.identifier),l=[...v].sort().join(" ");return await this.f.getOrCreate(`${h} ${l}`,async()=>{await this.a.$ensureProvider(y);const o=p.displayName||p.name;return this.a.$getSessions(y,v,h,o)})}async removeSession(p,y){const v=this.b.get(p);return v?v.provider.removeSession(y):this.a.$removeSession(p,y)}registerAuthenticationProvider(p,y,v,h){if(this.b.get(p))throw new Error(`An authentication provider with id '${p}' is already registered.`);this.b.set(p,{label:y,provider:v,options:h??{supportsMultipleAccounts:!1}});const l=v.onDidChangeSessions(o=>this.a.$sendDidChangeSessions(p,o));return this.a.$registerAuthenticationProvider(p,y,h?.supportsMultipleAccounts??!1),new L.$aN(()=>{l.dispose(),this.b.delete(p),this.a.$unregisterAuthenticationProvider(p)})}async $createSession(p,y,v){const h=this.b.get(p);if(h)return await h.provider.createSession(y,v);throw new Error(`Unable to find authentication provider with handle: ${p}`)}async $removeSession(p,y){const v=this.b.get(p);if(v)return await v.provider.removeSession(y);throw new Error(`Unable to find authentication provider with handle: ${p}`)}async $getSessions(p,y){const v=this.b.get(p);if(v)return await v.provider.getSessions(y);throw new Error(`Unable to find authentication provider with handle: ${p}`)}$onDidChangeAuthenticationSessions(p,y){return p.startsWith(N.$aM)||this.c.fire({provider:{id:p,label:y}}),Promise.resolve()}};e.$Clc=k,e.$Clc=k=Ge([We(0,$.$zP)],k);class A{constructor(){this.a=new Map}getOrCreate(p,y){const v=this.a.get(p);if(v)return v;const h=y().finally(()=>this.a.delete(p));return this.a.set(p,h),h}}}),define(Se[152],De([1,0,2,6,8,5,20,11,19,14,17,26]),function(he,e,d,O,L,R,N,b,$,k,A,C){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=e.$Bmc=void 0;let y=class{static{p=this}static{this.c=0}static{this.d=250}constructor(h,l){this.h=l,this.f=new Map,this.g=h.getProxy(O.$$M.MainThreadDecorations)}registerFileDecorationProvider(h,l){const o=p.c++;this.f.set(o,{provider:h,extensionDescription:l}),this.g.$registerDecorationProvider(o,l.identifier.value);const n=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(o,null);return}const u=(0,$.$2b)(i);if(u.length<=p.d){this.g.$onDidChange(o,u);return}this.h.warn("[Decorations] CAPPING events from decorations provider",l.identifier.value,u.length);const s=u.map(r=>({uri:r,rank:(0,k.$af)(r.path,"/")})),t=(0,$.$zb)(s,(r,a)=>r.rank-a.rank||(0,k.$qf)(r.uri.path,a.uri.path)),c=[];e:for(const r of t){let a;for(const f of r){const g=(0,A.$mc)(f.uri.path);if(a!==g&&(a=g,c.push(f.uri)>=p.d))break e}}this.g.$onDidChange(o,c)});return new L.$aN(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(h,l,o){if(!this.f.has(h))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:u}=this.f.get(h);return await Promise.all(l.map(async s=>{try{const{uri:t,id:c}=s,r=await Promise.resolve(i.provideFileDecoration(d.URI.revive(t),o));if(!r)return;try{L.$AO.validate(r),r.badge&&typeof r.badge!="string"&&(0,C.$PG)(u,"codiconDecoration"),n[c]=[r.propagate,r.tooltip,r.badge,r.color]}catch(a){this.h.warn(`INVALID decoration from extension '${u.identifier.value}': ${a}`)}}catch(t){this.h.error(t)}})),n}};e.$Bmc=y,e.$Bmc=y=p=Ge([We(0,N.$zP),We(1,b.$3j)],y),e.$Cmc=(0,R.$wi)("IExtHostDecorations")}),define(Se[330],De([1,0,13,2,8,6,15,22,14]),function(he,e,d,O,L,R,N,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=void 0;class k{static{this.a=0}constructor(C,p,y){this.d=p,this.e=y,this.b=new Map,this.c=C.getProxy(R.$$M.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,p){if(Object.keys(N.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const y=k.a++;this.b.set(y,p),this.c.$registerTextContentProvider(y,C);let v;if(typeof p.onDidChange=="function"){let h;v=p.onDidChange(async l=>{if(l.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(l))return;h&&await h;const o=this.$provideTextDocumentContent(y,l).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(l);if(!i)return;const u=(0,$.$kf)(n);if(!i.equalLines(u))return this.c.$onVirtualDocumentChange(l,n)}).catch(d.$1).finally(()=>{h===o&&(h=void 0)});h=o})}return new L.$aN(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(C,p){const y=this.b.get(C);return y?Promise.resolve(y.provideTextDocumentContent(O.URI.revive(p),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.$Emc=k}),define(Se[153],De([1,0,62,15,14,188,130,8,19]),function(he,e,d,O,L,R,N,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=e.$CP=void 0,e.$BP=A;const k=new Map;function A(v,h){h?k.set(v,h):k.delete(v)}function C(v){return k.get(v)}class p extends R.$6v{constructor(h,l,o,n,i,u,s){super(l,o,n,i),this.c=h,this.m=u,this.q=s,this.b=!1}dispose(){(0,d.ok)(!this.b),this.b=!0,this.q=!1}equalLines(h){return(0,$.$ub)(this.f,h)}get document(){if(!this.a){const h=this;this.a={get uri(){return h.d},get fileName(){return h.d.fsPath},get isUntitled(){return h.d.scheme===O.Schemas.untitled},get languageId(){return h.m},get version(){return h.h},get isClosed(){return h.b},get isDirty(){return h.q},save(){return h.r()},getText(l){return l?h.s(l):h.getText()},get eol(){return h.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return h.f.length},lineAt(l){return h.t(l)},offsetAt(l){return h.u(l)},positionAt(l){return h.v(l)},validateRange(l){return h.w(l)},validatePosition(l){return h.x(l)},getWordRangeAtPosition(l,o){return h.y(l,o)}}}return Object.freeze(this.a)}_acceptLanguageId(h){(0,d.ok)(!this.b),this.m=h}_acceptIsDirty(h){(0,d.ok)(!this.b),this.q=h}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(h){const l=this.w(h);if(l.isEmpty)return"";if(l.isSingleLine)return this.f[l.start.line].substring(l.start.character,l.end.character);const o=this.g,n=l.start.line,i=l.end.line,u=[];u.push(this.f[n].substring(l.start.character));for(let s=n+1;s<i;s++)u.push(this.f[s]);return u.push(this.f[i].substring(0,l.end.character)),u.join(o)}t(h){let l;if(h instanceof b.$bN?l=h.line:typeof h=="number"&&(l=h),typeof l!="number"||l<0||l>=this.f.length||Math.floor(l)!==l)throw new Error("Illegal value for `line`");return new y(l,this.f[l],l===this.f.length-1)}u(h){return h=this.x(h),this.l(),this.j.getPrefixSum(h.line-1)+h.character}v(h){h=Math.floor(h),h=Math.max(0,h),this.l();const l=this.j.getIndexOf(h),o=this.f[l.index].length;return new b.$bN(l.index,Math.min(l.remainder,o))}w(h){if(!(h instanceof b.$cN))throw new Error("Invalid argument");const l=this.x(h.start),o=this.x(h.end);return l===h.start&&o===h.end?h:new b.$cN(l.line,l.character,o.line,o.character)}x(h){if(!(h instanceof b.$bN))throw new Error("Invalid argument");if(this.f.length===0)return h.with(0,0);let{line:l,character:o}=h,n=!1;if(l<0)l=0,o=0,n=!0;else if(l>=this.f.length)l=this.f.length-1,o=this.f[l].length,n=!0;else{const i=this.f[l].length;o<0?(o=0,n=!0):o>i&&(o=i,n=!0)}return n?new b.$bN(l,o):h}y(h,l){const o=this.x(h);if(!l)l=C(this.m);else if((0,L.$jf)(l))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${l.source}' because it matches the empty string.`);const n=(0,N.$9s)(o.character+1,(0,N.$7s)(l),this.f[o.line],0);if(n)return new b.$cN(o.line,n.startColumn-1,o.line,n.endColumn-1)}}e.$CP=p;class y{constructor(h,l,o){this.a=h,this.b=l,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$cN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$cN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$DP=y}),define(Se[331],De([1,0,6,8]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=void 0;class L{constructor(N){this.a=new Map,this.b=0,this.c=N.getProxy(d.$$M.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(N,b,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(N);if(!k)throw new Error("Embedding vector provider not found");const A=await k.provideEmbeddingVector(b,$);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(N,b,$){const k=this.b;return this.b++,this.a.set(k,$),this.c.$registerAiEmbeddingVectorProvider(b,k),new O.$aN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$Gmc=L}),define(Se[70],De([1,0,6,33,8,21,5,20,60,3,7,23,15]),function(he,e,d,O,L,R,N,b,$,k,A,C,p){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=e.$Rlc=void 0;let v=y=class{constructor(l,o){this.b=new Map,this.c=new A.$Fh,this.a=l.getProxy(d.$$M.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let u;const s=n.b.get(i.scheme);return s?(await n.a.$ensureActivation(i.scheme),u=await s.impl.stat(i)):u=await n.a.$stat(i),{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions===O.FilePermission.Readonly?1:void 0}}catch(u){y.e(u)}},async readDirectory(i){try{const u=n.b.get(i.scheme);return u?(await n.a.$ensureActivation(i.scheme),(await u.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(u){return y.e(u)}},async createDirectory(i){try{const u=n.b.get(i.scheme);return u&&!u.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(u.impl,u.extUri,i)):await n.a.$mkdir(i)}catch(u){return y.e(u)}},async readFile(i){try{const u=n.b.get(i.scheme);return u?(await n.a.$ensureActivation(i.scheme),(await u.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(u){return y.e(u)}},async writeFile(i,u){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(s.impl,s.extUri,s.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(s.impl.writeFile(i,u,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,R.$Fe.wrap(u))}catch(s){return y.e(s)}},async delete(i,u){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly&&!u?.useTrash?(await n.a.$ensureActivation(i.scheme),await s.impl.delete(i,{recursive:!1,...u})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...u})}catch(s){return y.e(s)}},async rename(i,u,s){try{return await n.a.$rename(i,u,{overwrite:!1,...s})}catch(t){return y.e(t)}},async copy(i,u,s){try{return await n.a.$copy(i,u,{overwrite:!1,...s})}catch(t){return y.e(t)}},isWritableFileSystem(i){const u=o.getCapabilities(i);if(typeof u=="number")return!(u&2048)}})}async d(l,o,n){const i=[];for(;!o.isEqual(n,o.dirname(n));)try{if(!((await l.stat(n)).type&O.FileType.Directory))throw L.$rO.FileExists(`Unable to create folder '${n.scheme===p.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(u){if(O.$gl(u)!==O.FileSystemProviderErrorCode.FileNotFound)throw u;i.push(o.basename(n)),n=o.dirname(n)}for(let u=i.length-1;u>=0;u--){n=o.joinPath(n,i[u]);try{await l.createDirectory(n)}catch(s){if(O.$gl(s)!==O.FileSystemProviderErrorCode.FileExists)throw s}}}static e(l){if(l instanceof L.$rO)throw l;if(l instanceof O.$cl)switch(l.code){case O.FileSystemProviderErrorCode.FileExists:throw L.$rO.FileExists(l.message);case O.FileSystemProviderErrorCode.FileNotFound:throw L.$rO.FileNotFound(l.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw L.$rO.FileNotADirectory(l.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw L.$rO.FileIsADirectory(l.message);case O.FileSystemProviderErrorCode.NoPermissions:throw L.$rO.NoPermissions(l.message);case O.FileSystemProviderErrorCode.Unavailable:throw L.$rO.Unavailable(l.message);default:throw new L.$rO(l.message,l.name)}if(!(l instanceof Error))throw new L.$rO(String(l));if(l.name==="ENOPRO"||l.message.includes("ENOPRO"))throw L.$rO.Unavailable(l.message);switch(l.name){case O.FileSystemProviderErrorCode.FileExists:throw L.$rO.FileExists(l.message);case O.FileSystemProviderErrorCode.FileNotFound:throw L.$rO.FileNotFound(l.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw L.$rO.FileNotADirectory(l.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw L.$rO.FileIsADirectory(l.message);case O.FileSystemProviderErrorCode.NoPermissions:throw L.$rO.NoPermissions(l.message);case O.FileSystemProviderErrorCode.Unavailable:throw L.$rO.Unavailable(l.message);default:throw new L.$rO(l.message,l.name)}}addFileSystemProvider(l,o,n){return this.b.set(l,{impl:o,extUri:n?.isCaseSensitive?C.$Zg:C.$2g,isReadonly:!!n?.isReadonly}),(0,k.$Sc)(()=>this.b.delete(l))}getFileSystemProviderExtUri(l){return this.b.get(l)?.extUri??C.$Zg}};e.$Rlc=v,e.$Rlc=v=y=Ge([We(0,b.$zP),We(1,$.$vlc)],v),e.$Slc=(0,N.$wi)("IExtHostConsumerFileSystem")}),define(Se[93],De([1,0,5,28,11,70,2]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=e.$Tlc=void 0,e.$Tlc=(0,d.$wi)("IExtensionStoragePaths");let b=class{constructor(k,A,C){this.d=A,this.f=C,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(p=>this.c=p)}async g(k){return N.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,A=await this.g(k);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(N.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:N.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(k){if(this.c)return N.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return N.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Ulc=b,e.$Ulc=b=Ge([We(0,O.$PP),We(1,L.$3j),We(2,R.$Slc)],b)}),define(Se[332],De([1,0,8,20,4]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pnc=void 0;let R=class{constructor(b){this.a=new d.$BO(d.ColorThemeKind.Dark),this.b=new L.$de}get activeColorTheme(){return this.a}$onColorThemeChange(b){let $;switch(b){case"light":$=d.ColorThemeKind.Light;break;case"hcDark":$=d.ColorThemeKind.HighContrast;break;case"hcLight":$=d.ColorThemeKind.HighContrastLight;break;default:$=d.ColorThemeKind.Dark}this.a=new d.$BO($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$pnc=R,e.$pnc=R=Ge([We(0,O.$zP)],R)}),define(Se[71],De([1,0,22,4,3,234,5,11,88,6,28,20,8]),function(he,e,d,O,L,R,N,b,$,k,A,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tDb=e.$sDb=e.TunnelDtoConverter=void 0;class y extends $.$sw{}var v;(function(l){function o(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:i.protocol}}l.fromApiTunnel=o;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==$.TunnelPrivacyId.ConstantPrivate&&i.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}l.fromServiceTunnel=n})(v||(e.TunnelDtoConverter=v={})),e.$sDb=(0,N.$wi)("IExtHostTunnelService");let h=class extends L.$Uc{constructor(o,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$de,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(k.$$M.MainThreadTunnelService)}async openTunnel(o,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,o.displayName);if(i){const u=new y(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(u),u}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,n){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:o,provider:n}),this.a.$registerPortsAttributesProvider(o,i),new p.$aN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(o,n,i,u,s){const t=[];for(const r of o){const a=this.r.get(r);if(!a)return[];t.push(...await Promise.all(n.map(async f=>{let g;try{g=await a.provider.providePortAttributes({port:f,pid:i,commandLine:u},s)}catch{g=await a.provider.providePortAttributes(f,i,u,s)}return{providedAttributes:g,port:f}})))}const c=t.filter(r=>!!r.providedAttributes);return c.length>0?c.map(r=>({autoForwardAction:r.providedAttributes.autoForwardAction,port:r.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(u,s)=>await o.provideTunnel(u,s,d.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,L.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,n){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const i=o.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let u=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const s=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:u,protocol:!0}:void 0;this.a.$setTunnelProvider(s)}}else this.b=void 0;return(0,L.$Sc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,n){if(this.g.has(o.host)){const i=this.g.get(o.host);i.has(o.port)&&(n&&i.get(o.port).disposeListener.dispose(),await i.get(o.port).tunnel.dispose(),i.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(o,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const u=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),u===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const s=this.B(u.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(u.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:u,disposeListener:s}),v.fromApiTunnel(u)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(o){const n=await Promise.all(o.map(u=>this.f(u.host,u.port,u.detail??""))),i=o.filter((u,s)=>n[s]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(u=>u.port).join(", ")} to ${i.map(u=>u.port).join(", ")}`),i}};e.$tDb=h,e.$tDb=h=Ge([We(0,C.$zP),We(1,A.$PP),We(2,b.$3j)],h)}),define(Se[16],De([1,0,19,21,177,75,81,27,167,58,101,24,172,23,50,18,2,29,84,139,145,143,296,120,69,89,308,8]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n,i,u,s,t,c,r,a,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$wP=U,e.$xP=ie,e.$yP=q;var w;(function(Oe){function Te(Y){const{selectionStartLineNumber:Fe,selectionStartColumn:Qe,positionLineNumber:Ye,positionColumn:Ke}=Y,ht=new g.$bN(Fe-1,Qe-1),Et=new g.$bN(Ye-1,Ke-1);return new g.$dN(ht,Et)}Oe.to=Te;function ke(Y){const{anchor:Fe,active:Qe}=Y;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Qe.line+1,positionColumn:Qe.character+1}}Oe.from=ke})(w||(e.Selection=w={}));var S;(function(Oe){function Te(Y){if(!Y)return;const{start:Fe,end:Qe}=Y;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Qe.line+1,endColumn:Qe.character+1}}Oe.from=Te;function ke(Y){if(!Y)return;const{startLineNumber:Fe,startColumn:Qe,endLineNumber:Ye,endColumn:Ke}=Y;return new g.$cN(Fe-1,Qe-1,Ye-1,Ke-1)}Oe.to=ke})(S||(e.Range=S={}));var m;(function(Oe){function Te(Y){return{uri:Y.uri,range:S.from(Y.range)}}Oe.from=Te;function ke(Y){return new g.$mN(l.URI.revive(Y.uri),S.to(Y.range))}Oe.to=ke})(m||(e.Location=m={}));var E;(function(Oe){function Te(ke){switch(ke){case 1:return g.StandardTokenType.Comment;case 0:return g.StandardTokenType.Other;case 3:return g.StandardTokenType.RegEx;case 2:return g.StandardTokenType.String}}Oe.to=Te})(E||(e.TokenType=E={}));var D;(function(Oe){function Te(Y){return new g.$bN(Y.lineNumber-1,Y.column-1)}Oe.to=Te;function ke(Y){return{lineNumber:Y.line+1,column:Y.character+1}}Oe.from=ke})(D||(e.Position=D={}));var P;(function(Oe){function Te(Fe,Qe,Ye){return(0,d.$Hb)((0,d.$2b)(Fe).map(Ke=>ke(Ke,Qe,Ye)))}Oe.from=Te;function ke(Fe,Qe,Ye){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:Ye?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:Y(Fe.scheme,Qe),pattern:Pe.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:Ye?.isBuiltin}}function Y(Fe,Qe){return Qe&&typeof Fe=="string"?Qe.transformOutgoingScheme(Fe):Fe}})(P||(e.DocumentSelector=P={}));var I;(function(Oe){function Te(Y){switch(Y){case g.DiagnosticTag.Unnecessary:return 1;case g.DiagnosticTag.Deprecated:return 2}}Oe.from=Te;function ke(Y){switch(Y){case 1:return g.DiagnosticTag.Unnecessary;case 2:return g.DiagnosticTag.Deprecated;default:return}}Oe.to=ke})(I||(e.DiagnosticTag=I={}));var F;(function(Oe){function Te(Y){let Fe;return Y.code&&((0,h.$9f)(Y.code)||(0,h.$ag)(Y.code)?Fe=String(Y.code):Fe={value:String(Y.code.value),target:Y.code.target}),{...S.from(Y.range),message:Y.message,source:Y.source,code:Fe,severity:z.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(T.from),tags:Array.isArray(Y.tags)?(0,d.$Hb)(Y.tags.map(I.from)):void 0}}Oe.from=Te;function ke(Y){const Fe=new g.$oN(S.to(Y),Y.message,z.to(Y.severity));return Fe.source=Y.source,Fe.code=(0,h.$9f)(Y.code)?Y.code:Y.code?.value,Fe.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(T.to),Fe.tags=Y.tags&&(0,d.$Hb)(Y.tags.map(I.to)),Fe}Oe.to=ke})(F||(e.Diagnostic=F={}));var T;(function(Oe){function Te(Y){return{...S.from(Y.location.range),message:Y.message,resource:Y.location.uri}}Oe.from=Te;function ke(Y){return new g.$nN(new g.$mN(Y.resource,S.to(Y)),Y.message)}Oe.to=ke})(T||(e.DiagnosticRelatedInformation=T={}));var z;(function(Oe){function Te(Y){switch(Y){case g.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case g.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case g.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case g.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}Oe.from=Te;function ke(Y){switch(Y){case i.MarkerSeverity.Info:return g.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return g.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return g.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return g.DiagnosticSeverity.Hint;default:return g.DiagnosticSeverity.Error}}Oe.to=ke})(z||(e.DiagnosticSeverity=z={}));var M;(function(Oe){function Te(Y){return typeof Y=="number"&&Y>=g.ViewColumn.One?Y-1:Y===g.ViewColumn.Beside?f.$5D:f.$4D}Oe.from=Te;function ke(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}Oe.to=ke})(M||(e.ViewColumn=M={}));function j(Oe){return typeof Oe.range<"u"}function U(Oe){return Oe.length===0?!0:!!j(Oe[0])}var Z;(function(Oe){function Te(Ke){return Ke.map(Oe.from)}Oe.fromMany=Te;function ke(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function Y(Ke){let ht;if(ke(Ke)){const{language:ut,value:Zt}=Ke;ht={value:"```"+ut+`
`+Zt+"\n```\n"}}else g.$CN.isMarkdownString(Ke)?ht={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?ht={value:Ke}:ht={value:""};const Et=Object.create(null);ht.uris=Et;const zt=ut=>{try{let Zt=l.URI.parse(ut,!0);Zt=Zt.with({query:Fe(Zt.query,Et)}),Et[ut]=Zt}catch{}return""},Qt=new $.marked.Renderer;return Qt.link=zt,Qt.image=ut=>typeof ut=="string"?zt(N.$2k(ut).href):"",(0,$.marked)(ht.value,{renderer:Qt}),ht}Oe.from=Y;function Fe(Ke,ht){if(!Ke)return Ke;let Et;try{Et=(0,k.$5h)(Ke)}catch{}if(!Et)return Ke;let zt=!1;return Et=(0,C.$5n)(Et,Qt=>{if(l.URI.isUri(Qt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[ut]=Qt,zt=!0,ut}else return}),zt?JSON.stringify(Et):Ke}function Qe(Ke){const ht=new g.$CN(Ke.value,Ke.supportThemeIcons);return ht.isTrusted=Ke.isTrusted,ht.supportHtml=Ke.supportHtml,ht.baseUri=Ke.baseUri?l.URI.from(Ke.baseUri):void 0,ht}Oe.to=Qe;function Ye(Ke){if(Ke)return typeof Ke=="string"?Ke:Oe.from(Ke)}Oe.fromStrict=Ye})(Z||(e.MarkdownString=Z={}));function ie(Oe){return U(Oe)?Oe.map(Te=>({range:S.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?Z.fromMany(Te.hoverMessage):Te.hoverMessage?Z.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Oe.map(Te=>({range:S.from(Te)}))}function q(Oe){return typeof Oe>"u"?Oe:typeof Oe=="string"?l.URI.file(Oe):Oe}var G;(function(Oe){function Te(ke){return typeof ke>"u"?ke:{contentText:ke.contentText,contentIconPath:ke.contentIconPath?q(ke.contentIconPath):void 0,border:ke.border,borderColor:ke.borderColor,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,color:ke.color,backgroundColor:ke.backgroundColor,margin:ke.margin,width:ke.width,height:ke.height}}Oe.from=Te})(G||(e.ThemableDecorationAttachmentRenderOptions=G={}));var x;(function(Oe){function Te(ke){return typeof ke>"u"?ke:{backgroundColor:ke.backgroundColor,outline:ke.outline,outlineColor:ke.outlineColor,outlineStyle:ke.outlineStyle,outlineWidth:ke.outlineWidth,border:ke.border,borderColor:ke.borderColor,borderRadius:ke.borderRadius,borderSpacing:ke.borderSpacing,borderStyle:ke.borderStyle,borderWidth:ke.borderWidth,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,cursor:ke.cursor,color:ke.color,opacity:ke.opacity,letterSpacing:ke.letterSpacing,gutterIconPath:ke.gutterIconPath?q(ke.gutterIconPath):void 0,gutterIconSize:ke.gutterIconSize,overviewRulerColor:ke.overviewRulerColor,before:ke.before?G.from(ke.before):void 0,after:ke.after?G.from(ke.after):void 0}}Oe.from=Te})(x||(e.ThemableDecorationRenderOptions=x={}));var ne;(function(Oe){function Te(ke){if(typeof ke>"u")return ke;switch(ke){case g.DecorationRangeBehavior.OpenOpen:return 0;case g.DecorationRangeBehavior.ClosedClosed:return 1;case g.DecorationRangeBehavior.OpenClosed:return 2;case g.DecorationRangeBehavior.ClosedOpen:return 3}}Oe.from=Te})(ne||(e.DecorationRangeBehavior=ne={}));var be;(function(Oe){function Te(ke){return{isWholeLine:ke.isWholeLine,rangeBehavior:ke.rangeBehavior?ne.from(ke.rangeBehavior):void 0,overviewRulerLane:ke.overviewRulerLane,light:ke.light?x.from(ke.light):void 0,dark:ke.dark?x.from(ke.dark):void 0,backgroundColor:ke.backgroundColor,outline:ke.outline,outlineColor:ke.outlineColor,outlineStyle:ke.outlineStyle,outlineWidth:ke.outlineWidth,border:ke.border,borderColor:ke.borderColor,borderRadius:ke.borderRadius,borderSpacing:ke.borderSpacing,borderStyle:ke.borderStyle,borderWidth:ke.borderWidth,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,cursor:ke.cursor,color:ke.color,opacity:ke.opacity,letterSpacing:ke.letterSpacing,gutterIconPath:ke.gutterIconPath?q(ke.gutterIconPath):void 0,gutterIconSize:ke.gutterIconSize,overviewRulerColor:ke.overviewRulerColor,before:ke.before?G.from(ke.before):void 0,after:ke.after?G.from(ke.after):void 0}}Oe.from=Te})(be||(e.DecorationRenderOptions=be={}));var ae;(function(Oe){function Te(Y){return{text:Y.newText,eol:Y.newEol&&Ne.from(Y.newEol),range:S.from(Y.range)}}Oe.from=Te;function ke(Y){const Fe=new g.$hN(S.to(Y.range),Y.text);return Fe.newEol=typeof Y.eol>"u"?void 0:Ne.to(Y.eol),Fe}Oe.to=ke})(ae||(e.TextEdit=ae={}));var Ce;(function(Oe){function Te(Y,Fe){const Qe={edits:[]};if(Y instanceof g.$kN){const Ye=new b.$Bc;for(const Ke of Y._allEntries())Ke._type===1&&l.URI.isUri(Ke.to)&&Ke.from===void 0&&Ye.add(Ke.to);for(const Ke of Y._allEntries())if(Ke._type===1){let ht;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?ht={type:"base64",value:(0,O.$Ze)(O.$Fe.wrap(Ke.options.contents))}:ht={type:"dataTransferItem",id:Ke.options.contents._itemId}),Qe.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:ht},metadata:Ke.metadata})}else Ke._type===2?Qe.edits.push({resource:Ke.uri,textEdit:ae.from(Ke.edit),versionId:Ye.has(Ke.uri)?void 0:Fe?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?Qe.edits.push({resource:Ke.uri,textEdit:{range:S.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Ye.has(Ke.uri)?void 0:Fe?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?Qe.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&Qe.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(Bt.from)}})}return Qe}Oe.from=Te;function ke(Y){const Fe=new g.$kN,Qe=new b.$Ac;for(const Ye of Y.edits)if(Ye.textEdit){const Ke=Ye,ht=l.URI.revive(Ke.resource),Et=S.to(Ke.textEdit.range),zt=Ke.textEdit.text,Qt=Ke.textEdit.insertAsSnippet;let ut;Qt?ut=g.$jN.replace(Et,new g.$lN(zt)):ut=g.$hN.replace(Et,zt);const Zt=Qe.get(ht);Zt?Zt.push(ut):Qe.set(ht,[ut])}else Fe.renameFile(l.URI.revive(Ye.oldResource),l.URI.revive(Ye.newResource),Ye.options);for(const[Ye,Ke]of Qe)Fe.set(Ye,Ke);return Fe}Oe.to=ke})(Ce||(e.WorkspaceEdit=Ce={}));var ee;(function(Oe){const Te=Object.create(null);Te[g.SymbolKind.File]=0,Te[g.SymbolKind.Module]=1,Te[g.SymbolKind.Namespace]=2,Te[g.SymbolKind.Package]=3,Te[g.SymbolKind.Class]=4,Te[g.SymbolKind.Method]=5,Te[g.SymbolKind.Property]=6,Te[g.SymbolKind.Field]=7,Te[g.SymbolKind.Constructor]=8,Te[g.SymbolKind.Enum]=9,Te[g.SymbolKind.Interface]=10,Te[g.SymbolKind.Function]=11,Te[g.SymbolKind.Variable]=12,Te[g.SymbolKind.Constant]=13,Te[g.SymbolKind.String]=14,Te[g.SymbolKind.Number]=15,Te[g.SymbolKind.Boolean]=16,Te[g.SymbolKind.Array]=17,Te[g.SymbolKind.Object]=18,Te[g.SymbolKind.Key]=19,Te[g.SymbolKind.Null]=20,Te[g.SymbolKind.EnumMember]=21,Te[g.SymbolKind.Struct]=22,Te[g.SymbolKind.Event]=23,Te[g.SymbolKind.Operator]=24,Te[g.SymbolKind.TypeParameter]=25;function ke(Fe){return typeof Te[Fe]=="number"?Te[Fe]:6}Oe.from=ke;function Y(Fe){for(const Qe in Te)if(Te[Qe]===Fe)return Number(Qe);return g.SymbolKind.Property}Oe.to=Y})(ee||(e.SymbolKind=ee={}));var B;(function(Oe){function Te(Y){switch(Y){case g.SymbolTag.Deprecated:return 1}}Oe.from=Te;function ke(Y){switch(Y){case 1:return g.SymbolTag.Deprecated}}Oe.to=ke})(B||(e.SymbolTag=B={}));var _;(function(Oe){function Te(Y){return{name:Y.name,kind:ee.from(Y.kind),tags:Y.tags&&Y.tags.map(B.from),containerName:Y.containerName,location:le.from(Y.location)}}Oe.from=Te;function ke(Y){const Fe=new g.$tN(Y.name,ee.to(Y.kind),Y.containerName,le.to(Y.location));return Fe.tags=Y.tags&&Y.tags.map(B.to),Fe}Oe.to=ke})(_||(e.WorkspaceSymbol=_={}));var pe;(function(Oe){function Te(Y){const Fe={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:S.from(Y.range),selectionRange:S.from(Y.selectionRange),kind:ee.from(Y.kind),tags:Y.tags?.map(B.from)??[]};return Y.children&&(Fe.children=Y.children.map(Te)),Fe}Oe.from=Te;function ke(Y){const Fe=new g.$uN(Y.name,Y.detail,ee.to(Y.kind),S.to(Y.range),S.to(Y.selectionRange));return(0,d.$Lb)(Y.tags)&&(Fe.tags=Y.tags.map(B.to)),Y.children&&(Fe.children=Y.children.map(ke)),Fe}Oe.to=ke})(pe||(e.DocumentSymbol=pe={}));var ue;(function(Oe){function Te(Y){const Fe=new g.$yN(ee.to(Y.kind),Y.name,Y.detail||"",l.URI.revive(Y.uri),S.to(Y.range),S.to(Y.selectionRange));return Fe._sessionId=Y._sessionId,Fe._itemId=Y._itemId,Fe}Oe.to=Te;function ke(Y,Fe,Qe){if(Fe=Fe??Y._sessionId,Qe=Qe??Y._itemId,Fe===void 0||Qe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Qe,name:Y.name,detail:Y.detail,kind:ee.from(Y.kind),uri:Y.uri,range:S.from(Y.range),selectionRange:S.from(Y.selectionRange),tags:Y.tags?.map(B.from)}}Oe.from=ke})(ue||(e.CallHierarchyItem=ue={}));var ce;(function(Oe){function Te(ke){return new g.$zN(ue.to(ke.from),ke.fromRanges.map(Y=>S.to(Y)))}Oe.to=Te})(ce||(e.CallHierarchyIncomingCall=ce={}));var oe;(function(Oe){function Te(ke){return new g.$AN(ue.to(ke.to),ke.fromRanges.map(Y=>S.to(Y)))}Oe.to=Te})(oe||(e.CallHierarchyOutgoingCall=oe={}));var le;(function(Oe){function Te(Y){return{range:Y.range&&S.from(Y.range),uri:Y.uri}}Oe.from=Te;function ke(Y){return new g.$mN(l.URI.revive(Y.uri),S.to(Y.range))}Oe.to=ke})(le||(e.location=le={}));var K;(function(Oe){function Te(Y){const Fe=Y,Qe=Y;return{originSelectionRange:Fe.originSelectionRange?S.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Qe.uri,range:S.from(Fe.targetRange?Fe.targetRange:Qe.range),targetSelectionRange:Fe.targetSelectionRange?S.from(Fe.targetSelectionRange):void 0}}Oe.from=Te;function ke(Y){return{targetUri:l.URI.revive(Y.uri),targetRange:S.to(Y.range),targetSelectionRange:Y.targetSelectionRange?S.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?S.to(Y.originSelectionRange):void 0}}Oe.to=ke})(K||(e.DefinitionLink=K={}));var se;(function(Oe){function Te(Y){return{range:S.from(Y.range),contents:Z.fromMany(Y.contents),canIncreaseVerbosity:Y.canIncreaseVerbosity,canDecreaseVerbosity:Y.canDecreaseVerbosity}}Oe.from=Te;function ke(Y){const Fe=Y.contents.map(Z.to),Qe=S.to(Y.range),Ye=Y.canIncreaseVerbosity,Ke=Y.canDecreaseVerbosity;return new g.$qN(Fe,Qe,Ye,Ke)}Oe.to=ke})(se||(e.Hover=se={}));var $e;(function(Oe){function Te(Y){return{range:S.from(Y.range),expression:Y.expression}}Oe.from=Te;function ke(Y){return new g.$lO(S.to(Y.range),Y.expression)}Oe.to=ke})($e||(e.EvaluatableExpression=$e={}));var ve;(function(Oe){function Te(Y){if(Y instanceof g.$mO)return{type:"text",range:S.from(Y.range),text:Y.text};if(Y instanceof g.$nO)return{type:"variable",range:S.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof g.$oO)return{type:"expression",range:S.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}Oe.from=Te;function ke(Y){switch(Y.type){case"text":return{range:S.to(Y.range),text:Y.text};case"variable":return{range:S.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:S.to(Y.range),expression:Y.expression}}}Oe.to=ke})(ve||(e.InlineValue=ve={}));var Re;(function(Oe){function Te(Y){return{frameId:Y.frameId,stoppedLocation:S.from(Y.stoppedLocation)}}Oe.from=Te;function ke(Y){return new g.$pO(Y.frameId,S.to(Y.stoppedLocation))}Oe.to=ke})(Re||(e.InlineValueContext=Re={}));var ge;(function(Oe){function Te(Y){return{range:S.from(Y.range),kind:Y.kind}}Oe.from=Te;function ke(Y){return new g.$rN(S.to(Y.range),Y.kind)}Oe.to=ke})(ge||(e.DocumentHighlight=ge={}));var Ie;(function(Oe){function Te(Y){return{uri:Y.uri,highlights:Y.highlights.map(ge.from)}}Oe.from=Te;function ke(Y){return new g.$sN(l.URI.revive(Y.uri),Y.highlights.map(ge.to))}Oe.to=ke})(Ie||(e.MultiDocumentHighlight=Ie={}));var Ae;(function(Oe){function Te(ke){switch(ke){case 1:return g.CompletionTriggerKind.TriggerCharacter;case 2:return g.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return g.CompletionTriggerKind.Invoke}}Oe.to=Te})(Ae||(e.CompletionTriggerKind=Ae={}));var ze;(function(Oe){function Te(ke){return{triggerKind:Ae.to(ke.triggerKind),triggerCharacter:ke.triggerCharacter}}Oe.to=Te})(ze||(e.CompletionContext=ze={}));var V;(function(Oe){function Te(Y){switch(Y){case g.CompletionItemTag.Deprecated:return 1}}Oe.from=Te;function ke(Y){switch(Y){case 1:return g.CompletionItemTag.Deprecated}}Oe.to=ke})(V||(e.CompletionItemTag=V={}));var W;(function(Oe){const Te=new Map([[g.CompletionItemKind.Method,0],[g.CompletionItemKind.Function,1],[g.CompletionItemKind.Constructor,2],[g.CompletionItemKind.Field,3],[g.CompletionItemKind.Variable,4],[g.CompletionItemKind.Class,5],[g.CompletionItemKind.Interface,7],[g.CompletionItemKind.Struct,6],[g.CompletionItemKind.Module,8],[g.CompletionItemKind.Property,9],[g.CompletionItemKind.Unit,12],[g.CompletionItemKind.Value,13],[g.CompletionItemKind.Constant,14],[g.CompletionItemKind.Enum,15],[g.CompletionItemKind.EnumMember,16],[g.CompletionItemKind.Keyword,17],[g.CompletionItemKind.Snippet,27],[g.CompletionItemKind.Text,18],[g.CompletionItemKind.Color,19],[g.CompletionItemKind.File,20],[g.CompletionItemKind.Reference,21],[g.CompletionItemKind.Folder,23],[g.CompletionItemKind.Event,10],[g.CompletionItemKind.Operator,11],[g.CompletionItemKind.TypeParameter,24],[g.CompletionItemKind.Issue,26],[g.CompletionItemKind.User,25]]);function ke(Qe){return Te.get(Qe)??9}Oe.from=ke;const Y=new Map([[0,g.CompletionItemKind.Method],[1,g.CompletionItemKind.Function],[2,g.CompletionItemKind.Constructor],[3,g.CompletionItemKind.Field],[4,g.CompletionItemKind.Variable],[5,g.CompletionItemKind.Class],[7,g.CompletionItemKind.Interface],[6,g.CompletionItemKind.Struct],[8,g.CompletionItemKind.Module],[9,g.CompletionItemKind.Property],[12,g.CompletionItemKind.Unit],[13,g.CompletionItemKind.Value],[14,g.CompletionItemKind.Constant],[15,g.CompletionItemKind.Enum],[16,g.CompletionItemKind.EnumMember],[17,g.CompletionItemKind.Keyword],[27,g.CompletionItemKind.Snippet],[18,g.CompletionItemKind.Text],[19,g.CompletionItemKind.Color],[20,g.CompletionItemKind.File],[21,g.CompletionItemKind.Reference],[23,g.CompletionItemKind.Folder],[10,g.CompletionItemKind.Event],[11,g.CompletionItemKind.Operator],[24,g.CompletionItemKind.TypeParameter],[25,g.CompletionItemKind.User],[26,g.CompletionItemKind.Issue]]);function Fe(Qe){return Y.get(Qe)??g.CompletionItemKind.Property}Oe.to=Fe})(W||(e.CompletionItemKind=W={}));var J;(function(Oe){function Te(ke,Y){const Fe=new g.$IN(ke.label);return Fe.insertText=ke.insertText,Fe.kind=W.to(ke.kind),Fe.tags=ke.tags?.map(V.to),Fe.detail=ke.detail,Fe.documentation=N.$Vk(ke.documentation)?Z.to(ke.documentation):ke.documentation,Fe.sortText=ke.sortText,Fe.filterText=ke.filterText,Fe.preselect=ke.preselect,Fe.commitCharacters=ke.commitCharacters,o.$ut.isIRange(ke.range)?Fe.range=S.to(ke.range):typeof ke.range=="object"&&(Fe.range={inserting:S.to(ke.range.insert),replacing:S.to(ke.range.replace)}),Fe.keepWhitespace=typeof ke.insertTextRules>"u"?!1:!!(ke.insertTextRules&1),typeof ke.insertTextRules<"u"&&ke.insertTextRules&4?Fe.insertText=new g.$lN(ke.insertText):(Fe.insertText=ke.insertText,Fe.textEdit=Fe.range instanceof g.$cN?new g.$hN(Fe.range,Fe.insertText):void 0),ke.additionalTextEdits&&ke.additionalTextEdits.length>0&&(Fe.additionalTextEdits=ke.additionalTextEdits.map(Qe=>ae.to(Qe))),Fe.command=Y&&ke.command?Y.fromInternal(ke.command):void 0,Fe}Oe.to=Te})(J||(e.CompletionItem=J={}));var X;(function(Oe){function Te(Y){if(typeof Y.label!="string"&&!Array.isArray(Y.label))throw new TypeError("Invalid label");return{label:Y.label,documentation:Z.fromStrict(Y.documentation)}}Oe.from=Te;function ke(Y){return{label:Y.label,documentation:N.$Vk(Y.documentation)?Z.to(Y.documentation):Y.documentation}}Oe.to=ke})(X||(e.ParameterInformation=X={}));var de;(function(Oe){function Te(Y){return{label:Y.label,documentation:Z.fromStrict(Y.documentation),parameters:Array.isArray(Y.parameters)?Y.parameters.map(X.from):[],activeParameter:Y.activeParameter}}Oe.from=Te;function ke(Y){return{label:Y.label,documentation:N.$Vk(Y.documentation)?Z.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(X.to):[],activeParameter:Y.activeParameter}}Oe.to=ke})(de||(e.SignatureInformation=de={}));var we;(function(Oe){function Te(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(de.from):[]}}Oe.from=Te;function ke(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(de.to):[]}}Oe.to=ke})(we||(e.SignatureHelp=we={}));var je;(function(Oe){function Te(ke,Y){const Fe=new g.$HN(D.to(Y.position),typeof Y.label=="string"?Y.label:Y.label.map(Ve.to.bind(void 0,ke)),Y.kind&&Je.to(Y.kind));return Fe.textEdits=Y.textEdits&&Y.textEdits.map(ae.to),Fe.tooltip=N.$Vk(Y.tooltip)?Z.to(Y.tooltip):Y.tooltip,Fe.paddingLeft=Y.paddingLeft,Fe.paddingRight=Y.paddingRight,Fe}Oe.to=Te})(je||(e.InlayHint=je={}));var Ve;(function(Oe){function Te(ke,Y){const Fe=new g.$GN(Y.label);return Fe.tooltip=N.$Vk(Y.tooltip)?Z.to(Y.tooltip):Y.tooltip,n.Command.is(Y.command)&&(Fe.command=ke.fromInternal(Y.command)),Y.location&&(Fe.location=le.to(Y.location)),Fe}Oe.to=Te})(Ve||(e.InlayHintLabelPart=Ve={}));var Je;(function(Oe){function Te(Y){return Y}Oe.from=Te;function ke(Y){return Y}Oe.to=ke})(Je||(e.InlayHintKind=Je={}));var tt;(function(Oe){function Te(Y){return{range:S.from(Y.range),url:Y.target,tooltip:Y.tooltip}}Oe.from=Te;function ke(Y){let Fe;if(Y.url)try{Fe=typeof Y.url=="string"?l.URI.parse(Y.url,!0):l.URI.revive(Y.url)}catch{}return new g.$NN(S.to(Y.range),Fe)}Oe.to=ke})(tt||(e.DocumentLink=tt={}));var _e;(function(Oe){function Te(Y){const Fe=new g.$QN(Y.label);return Y.textEdit&&(Fe.textEdit=ae.to(Y.textEdit)),Y.additionalTextEdits&&(Fe.additionalTextEdits=Y.additionalTextEdits.map(Qe=>ae.to(Qe))),Fe}Oe.to=Te;function ke(Y){return{label:Y.label,textEdit:Y.textEdit?ae.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(Fe=>ae.from(Fe)):void 0}}Oe.from=ke})(_e||(e.ColorPresentation=_e={}));var nt;(function(Oe){function Te(Y){return new g.$ON(Y[0],Y[1],Y[2],Y[3])}Oe.to=Te;function ke(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}Oe.from=ke})(nt||(e.Color=nt={}));var it;(function(Oe){function Te(Y){return{range:S.from(Y.range)}}Oe.from=Te;function ke(Y){return new g.$xN(S.to(Y.range))}Oe.to=ke})(it||(e.SelectionRange=it={}));var rt;(function(Oe){function Te(ke){switch(ke){case 2:return g.TextDocumentSaveReason.AfterDelay;case 1:return g.TextDocumentSaveReason.Manual;case 3:case 4:return g.TextDocumentSaveReason.FocusOut}}Oe.to=Te})(rt||(e.TextDocumentSaveReason=rt={}));var at;(function(Oe){function Te(Y){switch(Y){case g.TextEditorLineNumbersStyle.Off:return 0;case g.TextEditorLineNumbersStyle.Relative:return 2;case g.TextEditorLineNumbersStyle.Interval:return 3;case g.TextEditorLineNumbersStyle.On:default:return 1}}Oe.from=Te;function ke(Y){switch(Y){case 0:return g.TextEditorLineNumbersStyle.Off;case 2:return g.TextEditorLineNumbersStyle.Relative;case 3:return g.TextEditorLineNumbersStyle.Interval;case 1:default:return g.TextEditorLineNumbersStyle.On}}Oe.to=ke})(at||(e.TextEditorLineNumbersStyle=at={}));var Ne;(function(Oe){function Te(Y){if(Y===g.EndOfLine.CRLF)return 1;if(Y===g.EndOfLine.LF)return 0}Oe.from=Te;function ke(Y){if(Y===1)return g.EndOfLine.CRLF;if(Y===0)return g.EndOfLine.LF}Oe.to=ke})(Ne||(e.EndOfLine=Ne={}));var ye;(function(Oe){function Te(ke){if(typeof ke=="object")return ke.viewId;switch(ke){case g.ProgressLocation.SourceControl:return 3;case g.ProgressLocation.Window:return 10;case g.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Oe.from=Te})(ye||(e.ProgressLocation=ye={}));var qe;(function(Oe){function Te(Y){const Fe={start:Y.start+1,end:Y.end+1};return Y.kind&&(Fe.kind=te.from(Y.kind)),Fe}Oe.from=Te;function ke(Y){const Fe={start:Y.start-1,end:Y.end-1};return Y.kind&&(Fe.kind=te.to(Y.kind)),Fe}Oe.to=ke})(qe||(e.FoldingRange=qe={}));var te;(function(Oe){function Te(Y){if(Y)switch(Y){case g.FoldingRangeKind.Comment:return n.$du.Comment;case g.FoldingRangeKind.Imports:return n.$du.Imports;case g.FoldingRangeKind.Region:return n.$du.Region}}Oe.from=Te;function ke(Y){if(Y)switch(Y.value){case n.$du.Comment.value:return g.FoldingRangeKind.Comment;case n.$du.Imports.value:return g.FoldingRangeKind.Imports;case n.$du.Region.value:return g.FoldingRangeKind.Region}}Oe.to=ke})(te||(e.FoldingRangeKind=te={}));var re;(function(Oe){function Te(ke){if(ke)return{pinned:typeof ke.preview=="boolean"?!ke.preview:void 0,inactive:ke.background,preserveFocus:ke.preserveFocus,selection:typeof ke.selection=="object"?S.from(ke.selection):void 0,override:typeof ke.override=="boolean"?s.$uF.id:void 0}}Oe.from=Te})(re||(e.TextEditorOpenOptions=re={}));var Pe;(function(Oe){function Te(Qe){return Qe instanceof g.$_N?Qe.toJSON():typeof Qe=="string"?Qe:ke(Qe)||Y(Qe)?new g.$_N(Qe.baseUri??Qe.base,Qe.pattern).toJSON():Qe}Oe.from=Te;function ke(Qe){const Ye=Qe;return Ye?l.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function Y(Qe){const Ye=Qe;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Fe(Qe){return typeof Qe=="string"?Qe:new g.$_N(l.URI.revive(Qe.baseUri),Qe.pattern)}Oe.to=Fe})(Pe||(e.GlobPattern=Pe={}));var He;(function(Oe){function Te(ke){if(ke){if(Array.isArray(ke))return ke.map(Te);if(typeof ke=="string")return ke;{const Y=ke;return{language:Y.language,scheme:Y.scheme,pattern:Pe.from(Y.pattern),exclusive:Y.exclusive,notebookType:Y.notebookType}}}else return}Oe.from=Te})(He||(e.LanguageSelector=He={}));var Le;(function(Oe){function Te(Y){return!!Y&&typeof Y=="object"&&"documents"in Y&&Array.isArray(Y.documents)&&Y.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(Qe=>Qe&&typeof Qe=="object"&&"uri"in Qe&&l.URI.isUri(Qe.uri)&&"version"in Qe&&typeof Qe.version=="number"&&"ranges"in Qe&&Array.isArray(Qe.ranges)&&Qe.ranges.every(Ye=>Ye instanceof g.$cN)))}Oe.is=Te;function ke(Y){return{documents:Y.documents.map(Fe=>Fe.map(Qe=>({uri:l.URI.from(Qe.uri),version:Qe.version,ranges:Qe.ranges.map(Ye=>S.from(Ye))})))}}Oe.from=ke})(Le||(e.MappedEditsContext=Le={}));var st;(function(Oe){function Te(Y){return{start:Y.start,end:Y.end}}Oe.from=Te;function ke(Y){return new g.$CO(Y.start,Y.end)}Oe.to=ke})(st||(e.NotebookRange=st={}));var lt;(function(Oe){function Te(Y){return{timing:typeof Y.runStartTime=="number"&&typeof Y.runEndTime=="number"?{startTime:Y.runStartTime,endTime:Y.runEndTime}:void 0,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}Oe.to=Te;function ke(Y){return{lastRunSuccess:Y.success,runStartTime:Y.timing?.startTime,runEndTime:Y.timing?.endTime,executionOrder:Y.executionOrder}}Oe.from=ke})(lt||(e.NotebookCellExecutionSummary=lt={}));var mt;(function(Oe){function Te(ke){if(ke===c.NotebookCellExecutionState.Unconfirmed)return g.NotebookCellExecutionState.Pending;if(ke===c.NotebookCellExecutionState.Pending)return;if(ke===c.NotebookCellExecutionState.Executing)return g.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ke}`)}Oe.to=Te})(mt||(e.NotebookCellExecutionState=mt={}));var Pt;(function(Oe){function Te(Y){switch(Y){case g.NotebookCellKind.Markup:return c.CellKind.Markup;case g.NotebookCellKind.Code:default:return c.CellKind.Code}}Oe.from=Te;function ke(Y){switch(Y){case c.CellKind.Markup:return g.NotebookCellKind.Markup;case c.CellKind.Code:default:return g.NotebookCellKind.Code}}Oe.to=ke})(Pt||(e.NotebookCellKind=Pt={}));var It;(function(Oe){function Te(Y){const Fe={metadata:Y.metadata??Object.create(null),cells:[]};for(const Qe of Y.cells)g.$DO.validate(Qe),Fe.cells.push(Bt.from(Qe));return Fe}Oe.from=Te;function ke(Y){const Fe=new g.$EO(Y.cells.map(Bt.to));return(0,h.$jg)(Y.metadata)||(Fe.metadata=Y.metadata),Fe}Oe.to=ke})(It||(e.NotebookData=It={}));var Bt;(function(Oe){function Te(Y){return{cellKind:Pt.from(Y.kind),language:Y.languageId,mime:Y.mime,source:Y.value,metadata:Y.metadata,internalMetadata:lt.from(Y.executionSummary??{}),outputs:Y.outputs?Y.outputs.map(kt.from):[]}}Oe.from=Te;function ke(Y){return new g.$DO(Pt.to(Y.cellKind),Y.source,Y.language,Y.mime,Y.outputs?Y.outputs.map(kt.to):void 0,Y.metadata,Y.internalMetadata?lt.to(Y.internalMetadata):void 0)}Oe.to=ke})(Bt||(e.NotebookCellData=Bt={}));var Ut;(function(Oe){function Te(Y){return{mime:Y.mime,valueBytes:O.$Fe.wrap(Y.data)}}Oe.from=Te;function ke(Y){return new g.$FO(Y.valueBytes.buffer,Y.mime)}Oe.to=ke})(Ut||(e.NotebookCellOutputItem=Ut={}));var kt;(function(Oe){function Te(Y){return{outputId:Y.id,items:Y.items.map(Ut.from),metadata:Y.metadata}}Oe.from=Te;function ke(Y){const Fe=Y.items.map(Ut.to);return new g.$GO(Fe,Y.outputId,Y.metadata)}Oe.to=ke})(kt||(e.NotebookCellOutput=kt={}));var Yt;(function(Oe){function Te(Fe){return Y(Fe)?{include:Pe.from(Fe.include)??void 0,exclude:Pe.from(Fe.exclude)??void 0}:Pe.from(Fe)??void 0}Oe.from=Te;function ke(Fe){return Y(Fe)?{include:Pe.to(Fe.include),exclude:Pe.to(Fe.exclude)}:Pe.to(Fe)}Oe.to=ke;function Y(Fe){const Qe=Fe;return Qe?!(0,h.$fg)(Qe.include)&&!(0,h.$fg)(Qe.exclude):!1}})(Yt||(e.NotebookExclusiveDocumentPattern=Yt={}));var xt;(function(Oe){function Te(ke,Y,Fe){const Qe=typeof ke.command=="string"?{title:"",command:ke.command}:ke.command;return{alignment:ke.alignment===g.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(Qe,Fe),text:ke.text,tooltip:ke.tooltip,accessibilityInformation:ke.accessibilityInformation,priority:ke.priority}}Oe.from=Te})(xt||(e.NotebookStatusBarItem=xt={}));var xe;(function(Oe){function Te(ke,Y,Fe){const Qe=typeof ke.command=="string"?{title:"",command:ke.command}:ke.command;return{command:Y.toInternal(Qe,Fe),label:ke.label,description:ke.description,detail:ke.detail,documentation:ke.documentation}}Oe.from=Te})(xe||(e.NotebookKernelSourceAction=xe={}));var on;(function(Oe){function Te(ke){return{transientOutputs:ke?.transientOutputs??!1,transientCellMetadata:ke?.transientCellMetadata??{},transientDocumentMetadata:ke?.transientDocumentMetadata??{},cellContentMetadata:ke?.cellContentMetadata??{}}}Oe.from=Te})(on||(e.NotebookDocumentContentOptions=on={}));var Kt;(function(Oe){function Te(Y){return{uri:Y.uri,provides:Y.provides}}Oe.from=Te;function ke(Y){return new g.$IO(l.URI.revive(Y.uri),Y.provides)}Oe.to=ke})(Kt||(e.NotebookRendererScript=Kt={}));var ft;(function(Oe){function Te(Y){return{message:Z.fromStrict(Y.message)||"",type:0,expected:Y.expectedOutput,actual:Y.actualOutput,contextValue:Y.contextValue,location:Y.location&&{range:S.from(Y.location.range),uri:Y.location.uri}}}Oe.from=Te;function ke(Y){const Fe=new g.$OO(typeof Y.message=="string"?Y.message:Z.to(Y.message));return Fe.actualOutput=Y.actual,Fe.expectedOutput=Y.expected,Fe.contextValue=Y.contextValue,Fe.location=Y.location?le.to(Y.location):void 0,Fe}Oe.to=ke})(ft||(e.TestMessage=ft={}));var $t;(function(Oe){Oe.namespace=a.$2L,Oe.denamespace=a.$3L})($t||(e.TestTag=$t={}));var _t;(function(Oe){function Te(Y){const Fe=(0,u.$vP)(Y).controllerId;return{extId:r.$WL.fromExtHostTestItem(Y,Fe).toString(),label:Y.label,uri:l.URI.revive(Y.uri),busy:Y.busy,tags:Y.tags.map(Qe=>$t.namespace(Fe,Qe.id)),range:o.$ut.lift(S.from(Y.range)),description:Y.description||null,sortText:Y.sortText||null,error:Y.error&&Z.fromStrict(Y.error)||null}}Oe.from=Te;function ke(Y){return{parent:void 0,error:void 0,id:r.$WL.fromString(Y.extId).localId,label:Y.label,uri:l.URI.revive(Y.uri),tags:(Y.tags||[]).map(Fe=>{const{tagId:Qe}=$t.denamespace(Fe);return new g.$PO(Qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:S.to(Y.range||void 0),canResolveChildren:!1,busy:Y.busy,description:Y.description||void 0,sortText:Y.sortText||void 0}}Oe.toPlain=ke})(_t||(e.TestItem=_t={})),function(Oe){function Te(Y){return{id:Y.id}}Oe.from=Te;function ke(Y){return new g.$PO(Y.id)}Oe.to=ke}($t||(e.TestTag=$t={}));var Jt;(function(Oe){const Te=(Y,Fe)=>{const Qe=Y.value;if(!Qe)return;const Ye={..._t.toPlain(Qe.item),parent:Fe,taskStates:Qe.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(ht=>ht.type===0).map(ft.to)})),children:[]};if(Y.children)for(const Ke of Y.children.values()){const ht=Te(Ke,Ye);ht&&Ye.children.push(ht)}return Ye};function ke(Y){const Fe=new p.$oP;for(const Ke of Y.items)Fe.insert(r.$WL.fromString(Ke.item.extId).path,Ke);const Qe=[Fe.nodes],Ye=[];for(;Qe.length;)for(const Ke of Qe.pop())Ke.value?Ye.push(Ke):Ke.children&&Qe.push(Ke.children.values());return{completedAt:Y.completedAt,results:Ye.map(Ke=>Te(Ke)).filter(h.$eg)}}Oe.to=ke})(Jt||(e.TestResults=Jt={}));var Tt;(function(Oe){function Te(Qe){return{covered:Qe.covered,total:Qe.total}}function ke(Qe){return"line"in Qe?D.from(Qe):S.from(Qe)}function Y(Qe){if(typeof Qe.executed=="number"&&Qe.executed<0)throw new Error(`Invalid coverage count ${Qe.executed}`);return"branches"in Qe?{count:Qe.executed,location:ke(Qe.location),type:1,branches:Qe.branches.length?Qe.branches.map(Ye=>({count:Ye.executed,location:Ye.location&&ke(Ye.location),label:Ye.label})):void 0}:{type:0,name:Qe.name,count:Qe.executed,location:ke(Qe.location)}}Oe.fromDetails=Y;function Fe(Qe,Ye){return g.$RO(Ye.statementCoverage),g.$RO(Ye.branchCoverage),g.$RO(Ye.declarationCoverage),{id:Qe,uri:Ye.uri,statement:Te(Ye.statementCoverage),branch:Ye.branchCoverage&&Te(Ye.branchCoverage),declaration:Ye.declarationCoverage&&Te(Ye.declarationCoverage)}}Oe.fromFile=Fe})(Tt||(e.TestCoverage=Tt={}));var gt;(function(Oe){function Te(ke){switch(ke){case 1:return g.CodeActionTriggerKind.Invoke;case 2:return g.CodeActionTriggerKind.Automatic}}Oe.to=Te})(gt||(e.CodeActionTriggerKind=gt={}));var Vt;(function(Oe){function Te(Y){const Fe=new g.$WO(ee.to(Y.kind),Y.name,Y.detail||"",l.URI.revive(Y.uri),S.to(Y.range),S.to(Y.selectionRange));return Fe._sessionId=Y._sessionId,Fe._itemId=Y._itemId,Fe}Oe.to=Te;function ke(Y,Fe,Qe){if(Fe=Fe??Y._sessionId,Qe=Qe??Y._itemId,Fe===void 0||Qe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Qe,kind:ee.from(Y.kind),name:Y.name,detail:Y.detail??"",uri:Y.uri,range:S.from(Y.range),selectionRange:S.from(Y.selectionRange),tags:Y.tags?.map(B.from)}}Oe.from=ke})(Vt||(e.TypeHierarchyItem=Vt={}));var en;(function(Oe){function Te(ke){if(ke)return{value:ke.value,tooltip:ke.tooltip}}Oe.from=Te})(en||(e.ViewBadge=en={}));var Wt;(function(Oe){function Te(Qe,Ye,Ke){const ht=Ye.fileData;return ht?new g.$4N(new g.$5N(ht.name,l.URI.revive(ht.uri),ht.id,(0,R.$db)(()=>Ke(ht.id)))):Qe===A.$Qs.uriList&&Ye.uriListData?new g.$3N(Fe(Ye.uriListData)):new g.$3N(Ye.asString)}Oe.to=Te;async function ke(Qe,Ye){const Ke=await Ye.asString();if(Qe===A.$Qs.uriList)return{asString:Ke,fileData:void 0,uriListData:Y(Ke)};const ht=Ye.asFile();return{asString:Ke,fileData:ht?{name:ht.name,uri:ht.uri,id:ht._itemId??ht.id}:void 0}}Oe.from=ke;function Y(Qe){return L.$Ut.split(Qe).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return l.URI.parse(Ye)}catch{}return Ye})}function Fe(Qe){return L.$Ut.create(Qe.map(Ye=>typeof Ye=="string"?Ye:l.URI.revive(Ye)))}})(Wt||(e.DataTransferItem=Wt={}));var Ze;(function(Oe){function Te(Y,Fe){const Qe=Y.items.map(([Ye,Ke])=>[Ye,Wt.to(Ye,Ke,Fe)]);return new g.$6N(Qe)}Oe.toDataTransfer=Te;async function ke(Y){const Fe={items:[]},Qe=[];for(const[Ye,Ke]of Y)Qe.push((async()=>{Fe.items.push([Ye,await Wt.from(Ye,Ke)])})());return await Promise.all(Qe),Fe}Oe.from=ke})(Ze||(e.DataTransfer=Ze={}));var un;(function(Oe){function Te(Y,Fe){return{kind:"reply",agentId:Y.participant??Fe?.agentId??"",subCommand:Y.command??Fe?.command,message:Y.prompt,title:Y.label}}Oe.from=Te;function ke(Y){return{prompt:Y.message,label:Y.title,participant:Y.agentId,command:Y.subCommand}}Oe.to=ke})(un||(e.ChatFollowup=un={}));var Xt;(function(Oe){function Te(ke){return"commandId"in ke?{kind:"command",title:ke.title??"",commandId:ke.commandId??"",when:ke.when??"",args:ke.args}:{kind:"reply",message:ke.message,title:ke.title,tooltip:ke.tooltip}}Oe.from=Te})(Xt||(e.ChatInlineFollowup=Xt={}));var Ht;(function(Oe){function Te(Y){switch(Y.role){case 0:return new g.$jP(Y.content);case 1:return new g.$kP(Y.content);case 2:return new g.$lP(Y.content)}}Oe.to=Te;function ke(Y){if(Y instanceof g.$jP)return{role:0,content:Y.content};if(Y instanceof g.$kP)return{role:1,content:Y.content};if(Y instanceof g.$lP)return{role:2,content:Y.content};throw new Error("Invalid LanguageModelMessage")}Oe.from=ke})(Ht||(e.LanguageModelMessage=Ht={}));var wt;(function(Oe){function Te(ke){switch(ke){case 1:return g.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return g.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return g.InteractiveEditorResponseFeedbackKind.Undone;case 3:return g.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return g.InteractiveEditorResponseFeedbackKind.Bug}}Oe.to=Te})(wt||(e.InteractiveEditorResponseFeedbackKind=wt={}));var Ft;(function(Oe){function Te(Y){return{kind:"markdownContent",content:Z.from(Y.value)}}Oe.from=Te;function ke(Y){return new g.$0O(Z.to(Y.content))}Oe.to=ke})(Ft||(e.ChatResponseMarkdownPart=Ft={}));var Rt;(function(Oe){function Te(Y){return{kind:"markdownVuln",content:Z.from(Y.value),vulnerabilities:Y.vulnerabilities}}Oe.from=Te;function ke(Y){return new g.$$O(Z.to(Y.content),Y.vulnerabilities)}Oe.to=ke})(Rt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Rt={}));var jt;(function(Oe){function Te(Y){return{kind:"agentDetection",agentId:Y.participant,command:Y.command}}Oe.from=Te;function ke(Y){return new g.$_O(Y.agentId,Y.command)}Oe.to=ke})(jt||(e.ChatResponseDetectedParticipantPart=jt={}));var tn;(function(Oe){function Te(Y){const{value:Fe,baseUri:Qe}=Y;function Ye(Ke,ht){return Ke.map(Et=>{const zt=l.URI.joinPath(ht,Et.name);return{label:Et.name,uri:zt,children:Et.children&&Ye(Et.children,zt)}})}return{kind:"treeData",treeData:{label:(0,y.$7g)(Qe),uri:Qe,children:Ye(Fe,Qe)}}}Oe.from=Te;function ke(Y){const Fe=(0,k.$6h)(Y.treeData);function Qe(ht){return ht.map(Et=>({name:Et.label,children:Et.children&&Qe(Et.children)}))}const Ye=Fe.uri,Ke=Fe.children?Qe(Fe.children):[];return new g.$aP(Ke,Ye)}Oe.to=ke})(tn||(e.ChatResponseFilesPart=tn={}));var qt;(function(Oe){function Te(Y){return{kind:"inlineReference",name:Y.title,inlineReference:l.URI.isUri(Y.value)?Y.value:m.from(Y.value)}}Oe.from=Te;function ke(Y){const Fe=(0,k.$6h)(Y);return new g.$bP(l.URI.isUri(Fe.inlineReference)?Fe.inlineReference:m.to(Fe.inlineReference),Y.name)}Oe.to=ke})(qt||(e.ChatResponseAnchorPart=qt={}));var an;(function(Oe){function Te(Y){return{kind:"progressMessage",content:Z.from(Y.value)}}Oe.from=Te;function ke(Y){return new g.$cP(Y.content.value)}Oe.to=ke})(an||(e.ChatResponseProgressPart=an={}));var Ot;(function(Oe){function Te(Y){return{kind:"warning",content:Z.from(Y.value)}}Oe.from=Te;function ke(Y){return new g.$dP(Y.content.value)}Oe.to=ke})(Ot||(e.ChatResponseWarningPart=Ot={}));var Lt;(function(Oe){function Te(Y,Fe,Qe){return{kind:"command",command:Fe.toInternal(Y.value,Qe)??{command:Y.value.command,title:Y.value.title}}}Oe.from=Te;function ke(Y,Fe){return new g.$eP(Fe.fromInternal(Y.command)??{command:Y.command.id,title:Y.command.title})}Oe.to=ke})(Lt||(e.ChatResponseCommandButtonPart=Lt={}));var Mt;(function(Oe){function Te(Y){return{kind:"textEdit",uri:Y.uri,edits:Y.edits.map(Fe=>ae.from(Fe))}}Oe.from=Te;function ke(Y){return new g.$gP(l.URI.revive(Y.uri),Y.edits.map(Fe=>ae.to(Fe)))}Oe.to=ke})(Mt||(e.ChatResponseTextEditPart=Mt={}));var At;(function(Oe){function Te(Y){const Fe=v.ThemeIcon.isThemeIcon(Y.iconPath)?Y.iconPath:Y.iconPath&&"light"in Y.iconPath&&"dark"in Y.iconPath&&l.URI.isUri(Y.iconPath.light)&&l.URI.isUri(Y.iconPath.dark)?{light:l.URI.revive(Y.iconPath.light),dark:l.URI.revive(Y.iconPath.dark)}:void 0;return"variableName"in Y.value?{kind:"reference",reference:{variableName:Y.value.variableName,value:l.URI.isUri(Y.value.value)||!Y.value.value?Y.value.value:m.from(Y.value.value)},iconPath:Fe}:{kind:"reference",reference:l.URI.isUri(Y.value)?Y.value:m.from(Y.value),iconPath:Fe}}Oe.from=Te;function ke(Y){const Fe=(0,k.$6h)(Y),Qe=Ye=>l.URI.isUri(Ye)?Ye:m.to(Ye);return new g.$fP("variableName"in Fe.reference?{variableName:Fe.reference.variableName,value:Fe.reference.value&&Qe(Fe.reference.value)}:Qe(Fe.reference))}Oe.to=ke})(At||(e.ChatResponseReferencePart=At={}));var pt;(function(Oe){function Te(Fe,Qe,Ye){return Fe instanceof g.$0O?Ft.from(Fe):Fe instanceof g.$bP?qt.from(Fe):Fe instanceof g.$fP?At.from(Fe):Fe instanceof g.$cP?an.from(Fe):Fe instanceof g.$aP?tn.from(Fe):Fe instanceof g.$eP?Lt.from(Fe,Qe,Ye):Fe instanceof g.$gP?Mt.from(Fe):Fe instanceof g.$$O?Rt.from(Fe):Fe instanceof g.$_O?jt.from(Fe):{kind:"markdownContent",content:Z.from("")}}Oe.from=Te;function ke(Fe,Qe){switch(Fe.kind){case"reference":return At.to(Fe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Y(Fe,Qe)}}Oe.to=ke;function Y(Fe,Qe){switch(Fe.kind){case"markdownContent":return Ft.to(Fe);case"inlineReference":return qt.to(Fe);case"progressMessage":return;case"treeData":return tn.to(Fe);case"command":return Lt.to(Fe,Qe)}}Oe.toContent=Y})(pt||(e.ChatResponsePart=pt={}));var St;(function(Oe){function Te(ke){return{prompt:ke.message,command:ke.command,attempt:ke.attempt??0,enableCommandDetection:ke.enableCommandDetection??!0,variables:ke.variables.variables.map(Dt.to),location:sn.to(ke.location)}}Oe.to=Te})(St||(e.ChatAgentRequest=St={}));var sn;(function(Oe){function Te(ke){switch(ke){case t.ChatAgentLocation.Notebook:return g.ChatLocation.Notebook;case t.ChatAgentLocation.Terminal:return g.ChatLocation.Terminal;case t.ChatAgentLocation.Panel:return g.ChatLocation.Panel;case t.ChatAgentLocation.Editor:return g.ChatLocation.Editor}}Oe.to=Te})(sn||(e.ChatLocation=sn={}));var Dt;(function(Oe){function Te(ke){const Y=ke.value;if(!Y)throw new Error("Invalid value reference");return{name:ke.name,range:ke.range&&[ke.range.start,ke.range.endExclusive],value:(0,l.$vc)(Y)?l.URI.revive(Y):Y}}Oe.to=Te})(Dt||(e.ChatAgentValueReference=Dt={}));var mn;(function(Oe){function Te(ke,Y,Fe){return{label:ke.label,value:ke.values[0].value,insertText:ke.insertText,detail:ke.detail,documentation:ke.documentation,command:Y.toInternal(ke.command,Fe)}}Oe.from=Te})(mn||(e.ChatAgentCompletionItem=mn={}));var nn;(function(Oe){function Te(ke){return{errorDetails:ke.errorDetails,metadata:ke.metadata}}Oe.to=Te})(nn||(e.ChatAgentResult=nn={}));var bn;(function(Oe){function Te(ke,Y,Fe){if(Y.action.kind==="vote")return;const Qe=nn.to(ke);if(Y.action.kind==="command"){const Ye=Y.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Fe.fromInternal(Ye)??{command:Ye.id,title:Ye.title}}},result:Qe}}else return Y.action.kind==="followUp"?{action:{kind:"followUp",followup:un.to(Y.action.followup)},result:Qe}:Y.action.kind==="inlineChat"?{action:{kind:"editor",accepted:Y.action.action==="accepted"},result:Qe}:{action:Y.action,result:Qe}}Oe.to=Te})(bn||(e.ChatAgentUserActionEvent=bn={}));var ln;(function(Oe){function Te(ke,Y,Fe){return"terminalCommand"in ke?{terminalCommand:ke.terminalCommand,shouldExecute:ke.shouldExecute}:"uri"in ke?{uri:ke.uri}:Y.toInternal(ke,Fe)}Oe.from=Te})(ln||(e.TerminalQuickFix=ln={}));var wn;(function(Oe){function Te(ke){return{kind:Ct.to(ke.kind)}}Oe.to=Te})(wn||(e.PartialAcceptInfo=wn={}));var Ct;(function(Oe){function Te(ke){switch(ke){case 0:return g.PartialAcceptTriggerKind.Word;case 1:return g.PartialAcceptTriggerKind.Line;case 2:return g.PartialAcceptTriggerKind.Suggest;default:return g.PartialAcceptTriggerKind.Unknown}}Oe.to=Te})(Ct||(e.PartialAcceptTriggerKind=Ct={}));var Dn;(function(Oe){function Te(ke,Y){return{id:Y,label:ke.label,description:ke.description,canEdit:ke.canEdit,collapsibleState:ke.collapsibleState||0,contextValue:ke.contextValue}}Oe.from=Te})(Dn||(e.DebugTreeItem=Dn={}))}),define(Se[333],De([1,0,6,20,16,48]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=void 0;let N=class{constructor($,k){this.a=$.getProxy(d.$$M.MainThreadBulkEdits),this.b={getTextDocumentVersion:A=>k.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,k,A){const C=new R.$Bw(L.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(C,void 0,A?.isRefactoring??!1)}};e.$Dlc=N,e.$Dlc=N=Ge([We(0,O.$zP)],N)}),define(Se[334],De([1,0,19,7,47,4,39,3,40,18,2,25,6,16,8,297,26]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Elc=void 0;class o{constructor(s,t,c,r,a){this.j=s,this.k=t,this.l=c,this.m=r,this.n=a,this.b=$.$_d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(r){if(s.c){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,r),a}};const s=this;this.b.reset();const c=r=>{typeof this.d>"u"&&"content"in r&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,r)};this.g={markdown(r){t(this.markdown);const a=new v.$0O(r),f=y.ChatResponseMarkdownPart.from(a);return c(f),this},markdownWithVulnerabilities(r,a){t(this.markdown),a&&(0,l.$PG)(s.j,"chatParticipantAdditions");const f=new v.$$O(r,a),g=y.ChatResponseMarkdownWithVulnerabilitiesPart.from(f);return c(g),this},filetree(r,a){t(this.filetree);const f=new v.$aP(r,a),g=y.ChatResponseFilesPart.from(f);return c(g),this},anchor(r,a){t(this.anchor);const f=new v.$bP(r,a),g=y.ChatResponseAnchorPart.from(f);return c(g),this},button(r){t(this.anchor);const a=new v.$eP(r),f=y.ChatResponseCommandButtonPart.from(a,s.m,s.n);return c(f),this},progress(r){t(this.progress);const a=new v.$cP(r),f=y.ChatResponseProgressPart.from(a);return c(f),this},warning(r){t(this.progress);const a=new v.$dP(r),f=y.ChatResponseWarningPart.from(a);return c(f),this},reference(r,a){if(t(this.reference),"variableName"in r&&!r.value){const f=s.k.variables.variables.find(g=>g.name===r.variableName);if(f){let g;if(f.references?.length)g=f.references.map(w=>({kind:"reference",reference:{variableName:r.variableName,value:w.reference}}));else{const w=new v.$fP(r,a);g=[y.ChatResponseReferencePart.from(w)]}return g.forEach(w=>c(w)),this}}else{const f=new v.$fP(r,a),g=y.ChatResponseReferencePart.from(f);c(g)}return this},textEdit(r,a){t(this.textEdit),(0,l.$PG)(s.j,"chatParticipantAdditions");const f=new v.$gP(r,a),g=y.ChatResponseTextEditPart.from(f);return c(g),this},detectedParticipant(r,a){t(this.detectedParticipant),(0,l.$PG)(s.j,"chatParticipantAdditions");const f=new v.$_O(r,a),g=y.ChatResponseDetectedParticipantPart.from(f);return c(g),this},push(r){if(t(this.push),(r instanceof v.$gP||r instanceof v.$$O||r instanceof v.$_O)&&(0,l.$PG)(s.j,"chatParticipantAdditions"),r instanceof v.$fP)this.reference(r.value,r.iconPath);else{const a=y.ChatResponsePart.from(r,s.m,s.n);c(a)}return this}}}return this.g}}class n extends b.$Uc{static{this.b=0}constructor(s,t,c){super(),this.n=t,this.s=c,this.c=new Map,this.j=this.B(new b.$4c),this.m=this.B(new b.$4c),this.g=s.getProxy(p.$$M.MainThreadChatAgents2)}transferActiveChat(s){this.g.$transferActiveChatSession(s)}createChatAgent(s,t,c){const r=n.b++,a=new i(s,t,this.g,r,c);return this.c.set(r,a),this.g.$registerAgent(r,s.identifier,t,{},void 0),a.apiAgent}createDynamicChatAgent(s,t,c,r,a){const f=n.b++,g=new i(s,t,this.g,f,a);return this.c.set(f,g),this.g.$registerAgent(f,s.identifier,t,{isSticky:!0},{name:c,description:r}),g.apiAgent}async $invokeAgent(s,t,c,r){const a=this.c.get(s);if(!a)throw new Error(`[CHAT](${s}) CANNOT invoke agent because the agent is not registered`);let f=this.j.get(t.sessionId);f||(f=new b.$Tc,this.j.set(t.sessionId,f));const g=new o(a.extension,t,this.g,this.s.converter,f);try{const w=await this.t(t.agentId,c),S=a.invoke(y.ChatAgentRequest.to(t),{history:w},g.apiObject,r);return await(0,O.$kh)(Promise.resolve(S).then(m=>{if(m?.metadata)try{JSON.stringify(m.metadata)}catch(E){const D=`result.metadata MUST be JSON.stringify-able. Got error: ${E.message}`;return this.n.error(`[${a.extension.identifier.value}] [@${a.id}] ${D}`,a.extension),{errorDetails:{message:D},timings:g.timings}}return{errorDetails:m?.errorDetails,timings:g.timings,metadata:m?.metadata}}),r)}catch(w){return this.n.error(w,a.extension),{errorDetails:{message:(0,L.$hj)(w),responseIsIncomplete:!0}}}finally{g.close()}}async t(s,t){const c=[];for(const r of t.history){const a=y.ChatAgentResult.to(r.result),f=s===r.request.agentId?a:{...a,metadata:void 0};c.push(new v.$hP(r.request.message,r.request.command,r.request.variables.variables.map(y.ChatAgentValueReference.to),r.request.agentId));const g=(0,d.$Hb)(r.response.map(w=>y.ChatResponsePart.toContent(w,this.s.converter)));c.push(new v.$iP(g,f,r.request.agentId,r.request.command))}return c}$releaseSession(s){this.j.deleteAndDispose(s)}async $provideFollowups(s,t,c,r,a){const f=this.c.get(t);if(!f)return Promise.resolve([]);const g=await this.t(f.id,r),w=y.ChatAgentResult.to(c);return(await f.provideFollowups(w,{history:g},a)).filter(S=>{const m=!S.participant||N.Iterable.some(this.c.values(),E=>E.id===S.participant&&C.$Rm.equals(E.extension.identifier,f.extension.identifier));return m||this.n.warn(`[@${f.id}] ChatFollowup refers to an unknown participant: ${S.participant}`),m}).map(S=>y.ChatFollowup.from(S,s))}$acceptFeedback(s,t,c,r){const a=this.c.get(s);if(!a)return;const f=y.ChatAgentResult.to(t);let g;switch(c){case h.InteractiveSessionVoteDirection.Down:g=v.ChatResultFeedbackKind.Unhelpful;break;case h.InteractiveSessionVoteDirection.Up:g=v.ChatResultFeedbackKind.Helpful;break}a.acceptFeedback(Object.freeze(r?{result:f,kind:g,reportIssue:r}:{result:f,kind:g}))}$acceptAction(s,t,c){const r=this.c.get(s);if(!r||c.action.kind==="vote")return;const a=y.ChatAgentUserActionEvent.to(t,c,this.s.converter);a&&r.acceptAction(Object.freeze(a))}async $invokeCompletionProvider(s,t,c){const r=this.c.get(s);if(!r)return[];let a=this.m.get(s);return a?a.clear():(a=new b.$Tc,this.m.set(s,a)),(await r.invokeCompletionProvider(t,c)).map(g=>y.ChatAgentCompletionItem.from(g,this.s.converter,a))}async $provideWelcomeMessage(s,t,c){const r=this.c.get(s);if(r)return await r.provideWelcomeMessage(y.ChatLocation.to(t),c)}async $provideSampleQuestions(s,t,c){const r=this.c.get(s);if(r)return(await r.provideSampleQuestions(y.ChatLocation.to(t),c)).map(a=>y.ChatFollowup.from(a,void 0))}}e.$Elc=n;class i{constructor(s,t,c,r,a){this.extension=s,this.id=t,this.u=c,this.w=r,this.x=a,this.n=new R.$de,this.o=new R.$de}acceptFeedback(s){this.n.fire(s)}acceptAction(s){this.o.fire(s)}async invokeCompletionProvider(s,t){return this.q?await this.q.provider.provideCompletionItems(s,t)??[]:[]}async provideFollowups(s,t,c){if(!this.b)return[];const r=await this.b.provideFollowups(s,t,c);return r?r.filter(a=>!(a&&"commandId"in a)).filter(a=>!(a&&"message"in a)):[]}async provideWelcomeMessage(s,t){if(!this.s)return[];const c=await this.s.provideWelcomeMessage(s,t);return c?c.map(r=>typeof r=="string"?r:y.MarkdownString.from(r)):[]}async provideSampleQuestions(s,t){if(!this.s||!this.s.provideSampleQuestions)return[];const c=await this.s.provideSampleQuestions(s,t);return c||[]}get apiAgent(){let s=!1,t=!1;const c=()=>{s||t||(t=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof A.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof v.$0N?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:y.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:y.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:y.MarkdownString.from(this.l),supportIssueReporting:this.p,requester:this.t}),t=!1}))},r=this;return{get id(){return r.id},get fullName(){return(0,l.$PG)(r.extension,"defaultChatParticipant"),r.c??r.extension.displayName??r.extension.name},set fullName(a){(0,l.$PG)(r.extension,"defaultChatParticipant"),r.c=a,c()},get iconPath(){return r.d},set iconPath(a){r.d=a,c()},get requestHandler(){return r.x},set requestHandler(a){(0,k.$gg)(typeof a=="function","Invalid request handler"),r.x=a},get followupProvider(){return r.b},set followupProvider(a){r.b=a,c()},get isDefault(){return(0,l.$PG)(r.extension,"defaultChatParticipant"),r.g},set isDefault(a){(0,l.$PG)(r.extension,"defaultChatParticipant"),r.g=a,c()},get helpTextPrefix(){return(0,l.$PG)(r.extension,"defaultChatParticipant"),r.j},set helpTextPrefix(a){(0,l.$PG)(r.extension,"defaultChatParticipant"),r.j=a,c()},get helpTextVariablesPrefix(){return(0,l.$PG)(r.extension,"defaultChatParticipant"),r.k},set helpTextVariablesPrefix(a){(0,l.$PG)(r.extension,"defaultChatParticipant"),r.k=a,c()},get helpTextPostfix(){return(0,l.$PG)(r.extension,"defaultChatParticipant"),r.l},set helpTextPostfix(a){(0,l.$PG)(r.extension,"defaultChatParticipant"),r.l=a,c()},get isSecondary(){return(0,l.$PG)(r.extension,"defaultChatParticipant"),r.m},set isSecondary(a){(0,l.$PG)(r.extension,"defaultChatParticipant"),r.m=a,c()},get supportIssueReporting(){return(0,l.$PG)(r.extension,"chatParticipantAdditions"),r.p},set supportIssueReporting(a){(0,l.$PG)(r.extension,"chatParticipantAdditions"),r.p=a,c()},get onDidReceiveFeedback(){return r.n.event},set participantVariableProvider(a){if((0,l.$PG)(r.extension,"chatParticipantAdditions"),r.q=a,a){if(!a.triggerCharacters.length)throw new Error("triggerCharacters are required");r.u.$registerAgentCompletionsProvider(r.w,a.triggerCharacters)}else r.u.$unregisterAgentCompletionsProvider(r.w)},get participantVariableProvider(){return(0,l.$PG)(r.extension,"chatParticipantAdditions"),r.q},set welcomeMessageProvider(a){(0,l.$PG)(r.extension,"defaultChatParticipant"),r.s=a,c()},get welcomeMessageProvider(){return(0,l.$PG)(r.extension,"defaultChatParticipant"),r.s},onDidPerformAction:(0,l.$OG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(a){r.t=a,c()},get requester(){return r.t},dispose(){s=!0,r.b=void 0,r.n.dispose(),r.u.$unregisterAgent(r.w)}}}invoke(s,t,c,r){return this.x(s,t,c,r)}}}),define(Se[335],De([1,0,13,3,6,16,8,26]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=void 0;class ${static{this.a=0}constructor(C){this.b=new Map,this.c=C.getProxy(L.$$M.MainThreadChatVariables)}async $resolveVariable(C,p,y,v){const h=this.b.get(C);if(h)try{if(h.resolver.resolve2){(0,b.$PG)(h.extension,"chatParticipantAdditions");const l=new k(p,this.c),o=await h.resolver.resolve2(h.data.name,{prompt:y},l.apiObject,v);if(o&&o[0])return o[0].value}else{const l=await h.resolver.resolve(h.data.name,{prompt:y},v);if(l&&l[0])return l[0].value}}catch(l){(0,d.$2)(l)}}registerVariableResolver(C,p,y,v){const h=$.a++;return this.b.set(h,{extension:C,data:{name:p,description:y},resolver:v}),this.c.$registerVariable(h,{name:p,description:y}),(0,O.$Sc)(()=>{this.b.delete(h),this.c.$unregisterVariable(h)})}}e.$Flc=$;class k{constructor(C,p){this.c=C,this.d=p,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let p=function(v){if(C.a){const h=new Error("Response stream has been closed");throw Error.captureStackTrace(h,v),h}};const C=this,y=v=>{this.d.$handleProgressChunk(this.c,v)};this.b={progress(v){p(this.progress);const h=new N.$cP(v),l=R.ChatResponseProgressPart.from(h);return y(l),this},reference(v){p(this.reference);const h=new N.$fP(v),l=R.ChatResponseReferencePart.from(h);return y(l),this},push(v){return p(this.push),v instanceof N.$fP?y(R.ChatResponseReferencePart.from(v)):v instanceof N.$cP&&y(R.ChatResponseProgressPart.from(v)),this}}}return this.b}}}),define(Se[336],De([1,0,7,56,4,3,2,84,25,16,8,6,26]),function(he,e,d,O,L,R,N,b,$,k,A,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=y;function y(v,h,l){const o=v.getProxy(C.$$M.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$Tm,h.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===6){const S=this.b.get(w.handle);return S?S.value:w}else if(w&&w.$mid===7){const S=w,m=this.b.get(S.commentControlHandle);if(!m)return S;const E=m.getCommentThread(S.commentThreadHandle);return E?E.value:S}else if(w&&(w.$mid===9||w.$mid===8)){const S=this.b.get(w.thread.commentControlHandle);if(!S)return w;const m=S.getCommentThread(w.thread.commentThreadHandle);return m?w.$mid===8?m.value:{thread:m.value,text:w.text}:w}else if(w&&w.$mid===10){const S=this.b.get(w.thread.commentControlHandle);if(!S)return w;const m=S.getCommentThread(w.thread.commentThreadHandle);if(!m)return w;const E=w.commentUniqueId,D=m.getCommentByUniqueId(E);return D||w}else if(w&&w.$mid===11){const S=this.b.get(w.thread.commentControlHandle);if(!S)return w;const m=S.getCommentThread(w.thread.commentThreadHandle);if(!m)return w;const E=w.text,D=w.commentUniqueId,P=m.getCommentByUniqueId(D);return P?(typeof P.body=="string"?P.body=E:P.body=new A.$CN(E),P):w}return w}})}createCommentController(w,S,m){const E=n.a++,D=new u(w,E,S,m);this.b.set(D.handle,D);const P=this.c.get(w.identifier)||[];return P.push(D),this.c.set(w.identifier,P),D.value}async $createCommentThreadTemplate(w,S,m){const E=this.b.get(w);E&&E.$createCommentThreadTemplate(S,m)}async $setActiveComment(w,S){const m=this.b.get(w);m&&m.$setActiveComment(S??void 0)}async $updateCommentThreadTemplate(w,S,m){const E=this.b.get(w);E&&E.$updateCommentThreadTemplate(S,m)}$deleteCommentThread(w,S){this.b.get(w)?.$deleteCommentThread(S)}async $provideCommentingRanges(w,S,m){const E=this.b.get(w);if(!E||!E.commentingRangeProvider)return Promise.resolve(void 0);const D=await l.ensureDocumentData(N.URI.revive(S));return(0,d.$oh)(async()=>{const P=await E.commentingRangeProvider.provideCommentingRanges(D.document,m);let I;return Array.isArray(P)?I={ranges:P,fileComments:!1}:P?I={ranges:P.ranges||[],fileComments:P.fileComments||!1}:I=P??void 0,I}).then(P=>{let I;return P&&(I={ranges:P.ranges.map(F=>k.Range.from(F)),fileComments:P.fileComments}),I})}$toggleReaction(w,S,m,E,D){const P=this.b.get(w);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,d.$oh)(()=>{const I=P.getCommentThread(S);if(I){const F=I.getCommentByUniqueId(E.uniqueIdInThread);if(P!==void 0&&F&&P.reactionHandler)return P.reactionHandler(F,c(D))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(w){this.n=w}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(w){(w===void 0!=(this.p===void 0)||!w||!this.p||!w.isEqual(this.p))&&(this.p=w,this.b.range=w,this.c.fire())}get range(){return this.p}set canReply(w){this.d!==w&&(this.d=w,this.b.canReply=w,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(w){this.e=w,this.b.label=w,this.c.fire()}get contextValue(){return this.f}set contextValue(w){this.f=w,this.b.contextValue=w,this.c.fire()}get comments(){return this.q}set comments(w){this.q=w,this.b.comments=w,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(w){this.g=w,this.b.collapsibleState=w,this.c.fire()}get state(){return this.h}set state(w){this.h=w,typeof w=="object"?((0,p.$PG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=w.resolved,this.b.applicability=w.applicability):this.b.state=w,this.c.fire()}get isDisposed(){return this.j}constructor(w,S,m,E,D,P,I,F){this.m=S,this.n=m,this.o=E,this.p=D,this.q=P,this.extensionDescription=I,this.r=F,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new L.$de,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Vc,this.l.value=new R.$Tc,this.n===void 0&&(this.n=`${w}.${this.handle}`),o.$createCommentThread(S,this.handle,this.n,this.o,k.Range.from(this.p),I.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this.i.push({dispose:()=>{o.$deleteCommentThread(S,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(z){T.range=z},get comments(){return T.comments},set comments(z){T.comments=z},get collapsibleState(){return T.collapsibleState},set collapsibleState(z){T.collapsibleState=z},get canReply(){return T.canReply},set canReply(z){T.canReply=z},get contextValue(){return T.contextValue},set contextValue(z){T.contextValue=z},get label(){return T.label},set label(z){T.label=z},get state(){return T.state},set state(z){T.state=z},dispose:()=>{T.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Tc);const w=m=>Object.prototype.hasOwnProperty.call(this.b,m),S={};w("range")&&(S.range=k.Range.from(this.p)),w("label")&&(S.label=this.label),w("contextValue")&&(S.contextValue=this.contextValue??null),w("comments")&&(S.comments=this.q.map(m=>s(this,m,this.k,this.extensionDescription))),w("collapsibleState")&&(S.collapseState=r(this.g)),w("canReply")&&(S.canReply=this.canReply),w("state")&&(S.state=a(this.h)),w("applicability")&&(S.applicability=f(this.h)),w("isTemplate")&&(S.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(w){for(const S of this.k){const m=S[0],E=S[1];if(w===E)return m}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(w=>w.dispose())}}Ge([(0,O.$2h)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class u{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(w){this.b=w,w?.resourceHints&&(0,p.$PG)(this.h,"commentingRangeHint"),o.$updateCommentingRanges(this.handle,w?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(w){this.c=w,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!w})}get options(){return this.d}set options(w){this.d=w,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,p.$PG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,p.$PG)(this.h,"activeComment"),this.f}constructor(w,S,m,E){this.h=w,this.i=S,this.j=m,this.k=E,this.a=new Map,o.$registerCommentController(this.handle,m,E,this.h.identifier.value);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(P){D.options=P},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(P){D.commentingRangeProvider=P},get reactionHandler(){return D.reactionHandler},set reactionHandler(P){D.reactionHandler=P},get activeCommentThread(){return D.activeCommentThread},createCommentThread(P,I,F){return D.createCommentThread(P,I,F).value},dispose:()=>{D.dispose()}}),this.g=[],this.g.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(w,S,m){S===void 0&&(0,p.$PG)(this.h,"fileComments");const E=new i(this.id,this.handle,void 0,w,S,m,this.h,!1);return this.a.set(E.handle,E),E}$setActiveComment(w){if(!w){this.e=void 0,this.f=void 0;return}const S=this.a.get(w.commentThreadHandle);S&&(this.e=w.uniqueIdInThread?S.getCommentByUniqueId(w.uniqueIdInThread):void 0,this.f=S)}$createCommentThreadTemplate(w,S){const m=new i(this.id,this.handle,void 0,N.URI.revive(w),k.Range.to(S),[],this.h,!0);return m.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(m.handle,m),m}$updateCommentThreadTemplate(w,S){const m=this.a.get(w);m&&(m.range=k.Range.to(S))}$deleteCommentThread(w){this.a.get(w)?.dispose(),this.a.delete(w)}getCommentThread(w){return this.a.get(w)}dispose(){this.a.forEach(w=>{w.dispose()}),this.g.forEach(w=>w.dispose())}}function s(g,w,S,m){let E=S.get(w);return E||(E=++g.commentHandle,S.set(w,E)),w.state!==void 0&&(0,p.$PG)(m,"commentsDraftState"),w.reactions?.some(D=>D.reactors!==void 0)&&(0,p.$PG)(m,"commentReactor"),{mode:w.mode,contextValue:w.contextValue,uniqueIdInThread:E,body:typeof w.body=="string"?w.body:k.MarkdownString.from(w.body),userName:w.author.name,userIconPath:w.author.iconPath,label:w.label,commentReactions:w.reactions?w.reactions.map(D=>t(D)):void 0,state:w.state,timestamp:w.timestamp?.toJSON()}}function t(g){return{label:g.label,iconPath:g.iconPath?k.$yP(g.iconPath):void 0,count:g.count,hasReacted:g.authorHasReacted,reactors:g.reactors&&g.reactors.length>0&&typeof g.reactors[0]!="string"?g.reactors.map(w=>w.name):g.reactors}}function c(g){return{label:g.label||"",count:g.count||0,iconPath:g.iconPath?N.URI.revive(g.iconPath):"",authorHasReacted:g.hasReacted||!1,reactors:g.reactors?.map(w=>({name:w}))}}function r(g){if(g!==void 0)switch(g){case A.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function a(g){let w;if(typeof g=="object"?w=g.resolved:w=g,w!==void 0)switch(w){case A.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function f(g){let w;if(typeof g=="object"&&(w=g.applicability),w!==void 0)switch(w){case A.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case A.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new n}}),define(Se[337],De([1,0,22,57,3,15,23,2,16,92,112,6,8]),function(he,e,d,O,L,R,N,b,$,k,A,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=void 0;class y{constructor(c,r){this.document=c,this.b=r,this.a=1,this.c=new A.$plc("custom documents")}addEdit(c){return this.c.add([c])}async undo(c,r){await this.f(c).undo(),r||this.disposeBackup()}async redo(c,r){await this.f(c).redo(),r||this.disposeBackup()}disposeEdits(c){for(const r of c)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const c=s(this.document.uri)+this.a++;return(0,N.$0g)(this.b,c)}updateBackup(c){this.d?.delete(),this.d=c}disposeBackup(){this.d?.delete(),this.d=void 0}f(c){const r=this.c.get(c,0);if(!r)throw new Error("No edit found");return r}}class v{constructor(){this.a=new Map}get(c,r){return this.a.get(this.b(c,r))}add(c,r,a){const f=this.b(c,r.uri);if(this.a.has(f))throw new Error(`Document already exists for viewType:${c} resource:${r.uri}`);const g=new y(r,a);return this.a.set(f,g),g}delete(c,r){const a=this.b(c,r.uri);this.a.delete(a)}b(c,r){return`${c}@@@${r}`}}var h;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(h||(h={}));class l{constructor(){this.a=new Map}addTextProvider(c,r,a){return this.b(c,{type:0,extension:r,provider:a})}addCustomProvider(c,r,a){return this.b(c,{type:1,extension:r,provider:a})}get(c){return this.a.get(c)}b(c,r){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,r),new p.$aN(()=>this.a.delete(c))}}class o{constructor(c,r,a,f,g){this.d=r,this.f=a,this.g=f,this.h=g,this.b=new l,this.c=new v,this.a=c.getProxy(C.$$M.MainThreadCustomEditors)}registerCustomEditorProvider(c,r,a,f){const g=new L.$Tc;return i(a)?(g.add(this.b.addTextProvider(r,c,a)),this.a.$registerTextEditorProvider((0,k.$Ylc)(c),r,f.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,k.$Wlc)(c))):(g.add(this.b.addCustomProvider(r,c,a)),n(a)&&g.add(a.onDidChangeCustomDocument(w=>{const S=this.i(r,w.document.uri);if(u(w)){const m=S.addEdit(w);this.a.$onDidEdit(w.document.uri,r,m,w.label)}else this.a.$onContentChange(w.document.uri,r)})),this.a.$registerCustomEditorProvider((0,k.$Ylc)(c),r,f.webviewOptions||{},!!f.supportsMultipleEditorsPerDocument,(0,k.$Wlc)(c))),p.$aN.from(g,new p.$aN(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(c,r,a,f,g){const w=this.b.get(r);if(!w)throw new Error(`No provider found for '${r}'`);if(w.type!==1)throw new Error(`Invalid provide type for '${r}'`);const S=b.URI.revive(c),m=await w.provider.openCustomDocument(S,{backupId:a,untitledDocumentData:f?.buffer},g);let E;return n(w.provider)&&this.f&&(E=this.f.workspaceValue(w.extension)??this.f.globalValue(w.extension)),this.c.add(r,m,E),{editable:n(w.provider)}}async $disposeCustomDocument(c,r){const a=this.b.get(r);if(!a)throw new Error(`No provider found for '${r}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${r}'`);const f=b.URI.revive(c),{document:g}=this.i(r,f);this.c.delete(r,g),g.dispose()}async $resolveCustomEditor(c,r,a,f,g,w){const S=this.b.get(a);if(!S)throw new Error(`No provider found for '${a}'`);const m=$.ViewColumn.to(g),E=this.g.createNewWebview(r,f.contentOptions,S.extension),D=this.h.createNewWebviewPanel(r,a,f.title,m,f.options,E,f.active),P=b.URI.revive(c);switch(S.type){case 1:{const{document:I}=this.i(a,P);return S.provider.resolveCustomEditor(I,D,w)}case 0:{const I=this.d.getDocument(P);return S.provider.resolveCustomTextEditor(I,D,w)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(c,r,a){this.i(r,c).disposeEdits(a)}async $onMoveCustomEditor(c,r,a){const f=this.b.get(a);if(!f)throw new Error(`No provider found for '${a}'`);if(!f.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const g=this.h.getWebviewPanel(c);if(!g)throw new Error("No webview found");const w=b.URI.revive(r),S=this.d.getDocument(w);await f.provider.moveCustomTextEditor(S,g,d.CancellationToken.None)}async $undo(c,r,a,f){return this.i(r,c).undo(a,f)}async $redo(c,r,a,f){return this.i(r,c).redo(a,f)}async $revert(c,r,a){const f=this.i(r,c);await this.j(r).revertCustomDocument(f.document,a),f.disposeBackup()}async $onSave(c,r,a){const f=this.i(r,c);await this.j(r).saveCustomDocument(f.document,a),f.disposeBackup()}async $onSaveAs(c,r,a,f){const g=this.i(r,c);return this.j(r).saveCustomDocumentAs(g.document,b.URI.revive(a),f)}async $backup(c,r,a){const f=this.i(r,c),w=await this.j(r).backupCustomDocument(f.document,{destination:f.getNewBackupUri()},a);return f.updateBackup(w),w.id}i(c,r){const a=this.c.get(c,b.URI.revive(r));if(!a)throw new Error("No custom document found");return a}j(c){const a=this.b.get(c)?.provider;if(!a||!n(a))throw new Error("Custom document is not editable");return a}}e.$2lc=o;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function u(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function s(t){const c=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,O.$kj)(c)+""}}),define(Se[338],De([1,0,224,139,2,6,8,16,4,11,27,60]),function(he,e,d,O,L,R,N,b,$,k,A,C){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=e.$wlc=void 0;class y{#e;#t;#n;constructor(l,o,n,i,u,s,t,c){this.d=l,this.e=o,this.f=n,this.g=i,this.h=u,this.c=!1,this.f=Math.max(i,n),this.#n=new A.$Ac(r=>s.getComparisonKey(r)),this.#e=t,this.#t=c}dispose(){this.c||(this.#t.fire([...this.#n.keys()]),this.#e?.$clear(this.e),this.#n.clear(),this.c=!0)}get name(){return this.j(),this.d}set(l,o){if(!l){this.clear();return}this.j();let n=[];if(L.URI.isUri(l)){if(!o){this.delete(l);return}this.#n.set(l,o.slice()),n=[l]}else if(Array.isArray(l)){n=[];let s;l=[...l].sort(y.k);for(const t of l){const[c,r]=t;if((!s||c.toString()!==s.toString())&&(s&&this.#n.get(s).length===0&&this.#n.delete(s),s=c,n.push(c),this.#n.set(c,[])),r)this.#n.get(c)?.push(...r);else{const a=this.#n.get(c);a&&(a.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let u=0;for(const s of n){let t=[];const c=this.#n.get(s);if(c)if(c.length>this.g){t=[];const r=[N.DiagnosticSeverity.Error,N.DiagnosticSeverity.Warning,N.DiagnosticSeverity.Information,N.DiagnosticSeverity.Hint];e:for(let a=0;a<4;a++)for(const f of c)if(f.severity===r[a]&&t.push({...b.Diagnostic.from(f),modelVersionId:this.h(s)})===this.g)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,d.localize)(0,null,c.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=c.map(r=>({...b.Diagnostic.from(r),modelVersionId:this.h(s)}));if(i.push([s,t]),u+=t.length,u>this.f)break}this.#e.$changeMany(this.e,i)}delete(l){this.j(),this.#t.fire([l]),this.#n.delete(l),this.#e?.$changeMany(this.e,[[l,void 0]])}clear(){this.j(),this.#t.fire([...this.#n.keys()]),this.#n.clear(),this.#e?.$clear(this.e)}forEach(l,o){this.j();for(const[n,i]of this)l.call(o,n,i,this)}*[Symbol.iterator](){this.j();for(const l of this.#n.keys())yield[l,this.get(l)]}get(l){this.j();const o=this.#n.get(l);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(l){return this.j(),Array.isArray(this.#n.get(l))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(l,o){return l[0].toString()<o[0].toString()?-1:l[0].toString()>o[0].toString()?1:0}}e.$wlc=y;let v=class{static{p=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*p.d}static _mapper(l){const o=new A.$Ac;for(const n of l)o.set(n,n);return{uris:Object.freeze(Array.from(o.values()))}}constructor(l,o,n,i){this.j=o,this.k=n,this.l=i,this.g=new Map,this.h=new $.$he({merge:u=>u.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,p._mapper),this.f=l.getProxy(R.$$M.MainThreadDiagnostics)}createDiagnosticCollection(l,o){const{g:n,f:i,h:u,j:s,k:t,l:c}=this,r=new class{$changeMany(g,w){i.$changeMany(g,w),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,g,w.length===0?"CLEARING":w)}$clear(g){i.$clear(g),s.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,g)}dispose(){i.dispose()}};let a;if(!o)o="_generated_diagnostic_collection_name_#"+p.c++,a=o;else if(!n.has(o))a=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do a=o+p.c++;while(n.has(a))}return new class extends y{constructor(){super(o,a,p.e,p.d,g=>c.getDocument(g)?.version,t.extUri,r,u),n.set(a,this)}dispose(){super.dispose(),n.delete(a)}}}getDiagnostics(l){if(l)return this.m(l);{const o=new Map,n=[];for(const i of this.g.values())i.forEach((u,s)=>{let t=o.get(u.toString());typeof t>"u"&&(t=n.length,o.set(u.toString(),t),n.push([u,[]])),n[t][1]=n[t][1].concat(...s)});return n}}m(l){let o=[];for(const n of this.g.values())n.has(l)&&(o=o.concat(n.get(l)));return o}$acceptMarkersChange(l){if(!this.n){const o="_generated_mirror",n=new y(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(o,n),this.n=n}for(const[o,n]of l)this.n.set(L.URI.revive(o),n.map(b.Diagnostic.to))}};e.$xlc=v,e.$xlc=v=p=Ge([We(1,k.$3j),We(2,C.$vlc)],v)}),define(Se[339],De([1,0,2,13,8,16,76,48]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=void 0;class ${constructor(A,C,p,y={timeout:1500,errors:3}){this.c=A,this.d=C,this.f=p,this.g=y,this.a=new N.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(A){return(C,p,y)=>{const h={dispose:this.a.push([C,p,A])};return Array.isArray(y)&&y.push(h),h}}async $participateInSave(A,C){const p=d.URI.revive(A);let y=!1;const v=setTimeout(()=>y=!0,this.g.timeout),h=[];try{for(const l of[...this.a]){if(y)break;const o=this.d.getDocument(p),n=await this.h(l,{document:o,reason:R.TextDocumentSaveReason.to(C)});h.push(n)}}finally{clearTimeout(v)}return h}h([A,C,p],y){const v=this.b.get(A);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(p,A,C,y).then(()=>!0,h=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' threw ERROR`),this.c.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const l=this.b.get(A);this.b.set(A,l?l+1:1),typeof l=="number"&&l>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(A,C,p,y){const v=[],h=Date.now(),{document:l,reason:o}=y,{version:n}=l,i=Object.freeze({document:l,reason:o,waitUntil(u){if(Object.isFrozen(v))throw(0,O.$8)("waitUntil can not be called async");v.push(Promise.resolve(u))}});try{C.apply(p,[i])}catch(u){return Promise.reject(u)}return Object.freeze(v),new Promise((u,s)=>{const t=setTimeout(()=>s(new Error("timeout")),this.g.timeout);return Promise.all(v).then(c=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(t),u(c)}).catch(c=>{clearTimeout(t),s(c)})}).then(u=>{const s={edits:[]};for(const t of u)if(Array.isArray(t)&&t.every(c=>c instanceof L.$hN))for(const{newText:c,newEol:r,range:a}of t)s.edits.push({resource:l.uri,versionId:void 0,textEdit:{range:a&&R.Range.from(a),text:c,eol:r&&R.EndOfLine.from(r)}});if(s.edits.length!==0)return n===l.version?this.f.$tryApplyWorkspaceEdit(new b.$Bw(s)):Promise.reject(new Error("concurrent_edits"))})}}e.$Fmc=$}),define(Se[340],De([1,0,4,3,2,6,153,16,18,24,8]),function(he,e,d,O,L,R,N,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylc=void 0;class C{constructor(y,v){this.a=new d.$de,this.b=new d.$de,this.c=new d.$de,this.d=new d.$de,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Tc,this.h=new Map,this.f=y.getProxy(R.$$M.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(h=>{for(const l of h)this.b.fire(l.document)},void 0,this.e),this.g.onDidAddDocuments(h=>{for(const l of h)this.a.fire(l.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(y){if(!y)return;const v=this.g.getDocument(y);if(v)return v}getDocument(y){const v=this.getDocumentData(y);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${y}'`);return v.document}ensureDocumentData(y){const v=this.g.getDocument(y);if(v)return Promise.resolve(v);let h=this.h.get(y.toString());return h||(h=this.f.$tryOpenDocument(y).then(l=>{this.h.delete(y.toString());const o=L.URI.revive(l);return(0,$.$hg)(this.g.getDocument(o))},l=>(this.h.delete(y.toString()),Promise.reject(l))),this.h.set(y.toString(),h)),h}createDocumentData(y){return this.f.$tryCreateDocument(y).then(v=>L.URI.revive(v))}$acceptModelLanguageChanged(y,v){const h=L.URI.revive(y),l=this.g.getDocument(h);if(!l)throw new Error("unknown document");this.b.fire(l.document),l._acceptLanguageId(v),this.a.fire(l.document)}$acceptModelSaved(y){const v=L.URI.revive(y),h=this.g.getDocument(v);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(y,!1),this.d.fire(h.document)}$acceptDirtyStateChanged(y,v){const h=L.URI.revive(y),l=this.g.getDocument(h);if(!l)throw new Error("unknown document");l._acceptIsDirty(v),this.c.fire({document:l.document,contentChanges:[],reason:void 0})}$acceptModelChanged(y,v,h){const l=L.URI.revive(y),o=this.g.getDocument(l);if(!o)throw new Error("unknown document");o._acceptIsDirty(h),o.onEvents(v);let n;v.isUndoing?n=A.TextDocumentChangeReason.Undo:v.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,k.$4n)({document:o.document,contentChanges:v.changes.map(i=>({range:b.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(y,v){(0,N.$BP)(y,v)}}e.$ylc=C}),define(Se[72],De([1,0,74,4,18,2,5,6,20,16,8]),function(he,e,d,O,L,R,N,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=e.$3lc=void 0,e.$3lc=(0,N.$wi)("IExtHostEditorTabs");class C{constructor(l,o,n){this.e=n,this.d=o,this.acceptDtoUpdate(l)}get apiObject(){if(!this.a){const l=this,o={get isActive(){return l.b.id===l.e()},get label(){return l.b.label},get input(){return l.c},get isDirty(){return l.b.isDirty},get isPinned(){return l.b.isPinned},get isPreview(){return l.b.isPreview},get group(){return l.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(l){this.b=l,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$XO(R.URI.revive(this.b.input.uri));case 2:return new A.$YO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case 3:return new A.$ZO(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case 6:return new A.$1O(R.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$2O(this.b.input.viewType);case 4:return new A.$3O(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$4O(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$5O;case 9:return new A.$6O(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$7O;case 11:return new A.$8O(this.b.input.diffEditors.map(l=>new A.$YO(R.URI.revive(l.original),R.URI.revive(l.modified))));default:return}}}class p{constructor(l,o){this.c=[],this.d="",this.b=l,this.e=o;for(const n of l.tabs)n.isActive&&(this.d=n.id),this.c.push(new C(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const l=this,o={get isActive(){return l.b.groupId===l.e()},get viewColumn(){return k.ViewColumn.to(l.b.viewColumn)},get activeTab(){return l.c.find(n=>n.tabId===l.d)?.apiObject},get tabs(){return Object.freeze(l.c.map(n=>n.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(l){this.b=l}acceptTabOperation(l){if(l.kind===0){const n=new C(l.tabDto,this,()=>this.activeTabId());return this.c.splice(l.index,0,n),l.tabDto.isActive&&(this.d=n.tabId),n}else if(l.kind===1){const n=this.c.splice(l.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${l.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(l.kind===3){if(l.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(l.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${l.oldIndex} which does not exist`);return this.c.splice(l.index,0,n),n}const o=this.c.find(n=>n.tabId===l.tabDto.id);if(!o)throw new Error("INVALID tab");return l.tabDto.isActive?this.d=l.tabDto.id:this.d===l.tabDto.id&&!l.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(l.tabDto),o}activeTabId(){return this.d}}let y=class{constructor(l){this.b=new O.$de,this.c=new O.$de,this.e=[],this.a=l.getProxy(b.$$M.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const l=this,o={onDidChangeTabGroups:l.c.event,onDidChangeTabs:l.b.event,get all(){return Object.freeze(l.e.map(n=>n.apiObject))},get activeTabGroup(){const n=l.d;return(0,L.$hg)(l.e.find(u=>u.groupId===n)?.apiObject)},close:async(n,i)=>{const u=Array.isArray(n)?n:[n];return u.length?v(u[0])?this.j(u,i):this.i(u,i):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(l){const o=new Set(this.e.map(r=>r.groupId)),n=new Set(l.map(r=>r.groupId)),i=(0,d.$L)(o,n),u=this.e.filter(r=>i.removed.includes(r.groupId)).map(r=>r.apiObject),s=[],t=[];this.e=l.map(r=>{const a=new p(r,()=>this.d);return i.added.includes(a.groupId)?s.push(a.apiObject):t.push(a.apiObject),a});const c=(0,L.$hg)(l.find(r=>r.isActive===!0)?.groupId);c!==void 0&&this.d!==c&&(this.d=c),this.c.fire(Object.freeze({opened:s,closed:u,changed:t}))}$acceptTabGroupUpdate(l){const o=this.e.find(n=>n.groupId===l.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(l),l.isActive&&(this.d=l.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(l){const o=this.e.find(i=>i.groupId===l.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const n=o.acceptTabOperation(l);switch(l.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(l){for(const o of this.e)for(const n of o.tabs)if(n.apiObject===l)return n}h(l){return this.e.find(o=>o.apiObject===l)}async i(l,o){const n=[];for(const i of l){const u=this.g(i);if(!u)throw new Error("Tab close: Invalid tab not found!");n.push(u.tabId)}return this.a.$closeTab(n,o)}async j(l,o){const n=[];for(const i of l){const u=this.h(i);if(!u)throw new Error("Group close: Invalid group not found!");n.push(u.groupId)}return this.a.$closeGroup(n,o)}};e.$4lc=y,e.$4lc=y=Ge([We(0,$.$zP)],y);function v(h){return h.tabs!==void 0}}),define(Se[341],De([1,0,2,6,3,8,16,185,14,21,26,81]),function(he,e,d,O,L,R,N,b,$,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=void 0;class p{constructor(){this.a=[]}add(h){this.b=void 0,this.a.push(h)}delete(h){const l=this.a.indexOf(h);l>=0&&(this.a.splice(l,1),this.b=void 0)}c(){if(!this.b){const h=this.a.sort(),l=[];let o,n,i=14,u=14;for(const s of h){let t=o?(0,$.$zf)(o,s):0;for(t===0?n=1:n=u;t<s.length;t++)t+1===s.length?(i=u,u=9):u+=1,l.push([n,s.toUpperCase().charCodeAt(t),u]),l.push([n,s.toLowerCase().charCodeAt(t),u]),n=u;o=s,u=i}l.push([9,58,10]),l.push([10,47,12]),this.b=new b.$w3(l)}}provideDocumentLinks(h){this.c();const l=[],o=b.$x3.computeLinks({getLineContent(n){return h.lineAt(n-1).text},getLineCount(){return h.lineCount}},this.b);for(const n of o){const i=N.DocumentLink.to(n);i.target&&l.push(i)}return l}}class y{constructor(h,l){this.i=l,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=h.getProxy(O.$$M.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(h,l,o,n={}){if(y.j(o),this.d.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(h,"*",this.b));const i=this.h++;this.b.add(l),this.d.add(l),this.c.set(i,o);let u=2;n.isCaseSensitive&&(u+=1024),n.isReadonly&&(u+=2048),typeof o.copy=="function"&&(u+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,A.$PG)(h,"fsChunks"),u+=4);let s;n.isReadonly&&(0,C.$Vk)(n.isReadonly)&&n.isReadonly.value!==""&&(s={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,l,u,s).catch(c=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${l}`),console.error(c)});const t=o.onDidChangeFile(c=>{const r=[];for(const a of c){const{uri:f,type:g}=a;if(f.scheme!==l)continue;let w;switch(g){case R.FileChangeType.Changed:w=0;break;case R.FileChangeType.Created:w=1;break;case R.FileChangeType.Deleted:w=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:f,type:w})}this.a.$onFileSystemChange(i,r)});return(0,L.$Sc)(()=>{t.dispose(),this.b.delete(l),this.d.delete(l),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(h){if(!h)throw new Error("MISSING provider");if(typeof h.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof h.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof h.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof h.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof h.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof h.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof h.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof h.rename!="function")throw new Error("Provider does NOT implement rename")}static k(h){const{type:l,ctime:o,mtime:n,size:i,permissions:u}=h;return{type:l,ctime:o,mtime:n,size:i,permissions:u}}$stat(h,l){return Promise.resolve(this.l(h).stat(d.URI.revive(l))).then(o=>y.k(o))}$readdir(h,l){return Promise.resolve(this.l(h).readDirectory(d.URI.revive(l)))}$readFile(h,l){return Promise.resolve(this.l(h).readFile(d.URI.revive(l))).then(o=>k.$Fe.wrap(o))}$writeFile(h,l,o,n){return Promise.resolve(this.l(h).writeFile(d.URI.revive(l),o.buffer,n))}$delete(h,l,o){return Promise.resolve(this.l(h).delete(d.URI.revive(l),o))}$rename(h,l,o,n){return Promise.resolve(this.l(h).rename(d.URI.revive(l),d.URI.revive(o),n))}$copy(h,l,o,n){const i=this.l(h);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(d.URI.revive(l),d.URI.revive(o),n))}$mkdir(h,l){return Promise.resolve(this.l(h).createDirectory(d.URI.revive(l)))}$watch(h,l,o,n){const i=this.l(h).watch(d.URI.revive(o),n);this.f.set(l,i)}$unwatch(h,l){const o=this.f.get(l);o&&(o.dispose(),this.f.delete(l))}$open(h,l,o){const n=this.l(h);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(d.URI.revive(l),o))}$close(h,l){const o=this.l(h);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(l))}$read(h,l,o,n){const i=this.l(h);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const u=k.$Fe.alloc(n);return Promise.resolve(i.read(l,o,u.buffer,0,n)).then(s=>u.slice(0,s))}$write(h,l,o,n){const i=this.l(h);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(l,o,n.buffer,0,n.byteLength))}l(h){const l=this.c.get(h);if(!l){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return l}}e.$Hmc=y}),define(Se[342],De([1,0,4,35,2,6,16,8,46]),function(he,e,d,O,L,R,N,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(y,v,h,l,o,n){this.a=Math.random(),this.b=new d.$de,this.c=new d.$de,this.d=new d.$de,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,O.$qk)(o),u=typeof o=="string",s=n?.correlate,t=l(c=>{if(!(typeof c.session=="number"&&c.session!==this.a)&&!(s&&typeof c.session>"u")){if(!n?.ignoreCreateEvents)for(const r of c.created){const a=L.URI.revive(r);i(a.fsPath)&&(!u||v.getWorkspaceFolder(a))&&this.b.fire(a)}if(!n?.ignoreChangeEvents)for(const r of c.changed){const a=L.URI.revive(r);i(a.fsPath)&&(!u||v.getWorkspaceFolder(a))&&this.c.fire(a)}if(!n?.ignoreDeleteEvents)for(const r of c.deleted){const a=L.URI.revive(r);i(a.fsPath)&&(!u||v.getWorkspaceFolder(a))&&this.d.fire(a)}}});this.g=b.$aN.from(this.i(y,h,o,n,n?.correlate),this.b,this.c,this.d,t)}i(y,v,h,l,o){const n=b.$aN.from();if(typeof h=="string"||l?.ignoreChangeEvents&&l?.ignoreCreateEvents&&l?.ignoreDeleteEvents)return n;const i=y.getProxy(R.$$M.MainThreadFileSystemEventService);let u=!1;(h.pattern.includes(O.$mk)||h.pattern.includes(O.$nk))&&(u=!0);let s;return o&&(l?.ignoreChangeEvents||l?.ignoreCreateEvents||l?.ignoreDeleteEvents)&&(s=14,l?.ignoreChangeEvents&&(s&=-3),l?.ignoreCreateEvents&&(s&=-5),l?.ignoreDeleteEvents&&(s&=-9)),i.$watch(v.identifier.value,this.a,h.baseUri,{recursive:u,excludes:l?.excludes??[],filter:s},!!o),b.$aN.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(y){this.a=y,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(L.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(L.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(L.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(y,v,h){this.j=y,this.k=v,this.l=h,this.a=new d.$de,this.b=new d.$de,this.c=new d.$de,this.d=new d.$de,this.g=new d.$fe,this.h=new d.$fe,this.i=new d.$fe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,v,h,l){return new k(this.j,y,v,this.a.event,N.GlobPattern.from(h),l)}$onFileEvent(y){this.a.fire(new A(y))}$onDidRunFileOperation(y,v){switch(y){case 2:this.b.fire(Object.freeze({files:v.map(h=>({oldUri:L.URI.revive(h.source),newUri:L.URI.revive(h.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(h=>L.URI.revive(h.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(h=>L.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,v){return(h,l,o)=>{const n=function(u){h.call(l,u)};return n.extension=y,v.event(n,void 0,o)}}async $onWillRunFileOperation(y,v,h,l){switch(y){case 2:return await this.n(this.g,{files:v.map(o=>({oldUri:L.URI.revive(o.source),newUri:L.URI.revive(o.target)}))},h,l);case 1:return await this.n(this.i,{files:v.map(o=>L.URI.revive(o.target))},h,l);case 0:case 3:return await this.n(this.h,{files:v.map(o=>L.URI.revive(o.target))},h,l)}}async n(y,v,h,l){const o=new Set,n=[];if(await y.fireAsync(v,l,async(u,s)=>{const t=Date.now(),c=await Promise.resolve(u);c instanceof b.$kN&&(n.push([s.extension,c]),o.add(s.extension.displayName??s.extension.identifier.value)),Date.now()-t>h&&this.k.warn("SLOW file-participant",s.extension.identifier)}),l.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,u]of n){const{edits:s}=N.WorkspaceEdit.from(u,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(s)}return{edit:i,extensionNames:Array.from(o)}}}e.$Imc=C}),define(Se[343],De([1,0,19,7,22,13,125,3,24,40,14,18,2,29,181,84,135,226,25,16,8,26,112,6]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n,i,u,s,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=void 0;class r{constructor(V,W){this.d=V,this.e=W}async provideDocumentSymbols(V,W){const J=this.d.getDocument(V),X=await this.e.provideDocumentSymbols(J,W);if(!(0,d.$Kb)(X))return X[0]instanceof u.$uN?X.map(i.DocumentSymbol.from):r.f(X)}static f(V){V=V.slice(0).sort((X,de)=>{let we=X.location.range.start.compareTo(de.location.range.start);return we===0&&(we=de.location.range.end.compareTo(X.location.range.end)),we});const W=[],J=[];for(const X of V){const de={name:X.name||"!!MISSING: name!!",kind:i.SymbolKind.from(X.kind),tags:X.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:i.Range.from(X.location.range),selectionRange:i.Range.from(X.location.range),children:[]};for(;;){if(J.length===0){J.push(de),W.push(de);break}const we=J[J.length-1];if(y.$ut.containsRange(we.range,de.range)&&!y.$ut.equalsRange(we.range,de.range)){we.children?.push(de),J.push(de);break}J.pop()}}return W}}class a{constructor(V,W,J,X,de,we){this.f=V,this.g=W,this.h=J,this.j=X,this.k=de,this.l=we,this.d=new t.$plc("CodeLens"),this.e=new Map}async provideCodeLenses(V,W){const J=this.f.getDocument(V),X=await this.h.provideCodeLenses(J,W);if(!X||W.isCancellationRequested)return;const de=this.d.add(X),we=new b.$Tc;this.e.set(de,we);const je={cacheId:de,lenses:[]};for(let Ve=0;Ve<X.length;Ve++)je.lenses.push({cacheId:[de,Ve],range:i.Range.from(X[Ve].range),command:this.g.toInternal(X[Ve].command,we)});return je}async resolveCodeLens(V,W){const J=V.cacheId&&this.d.get(...V.cacheId);if(!J)return;let X;if(typeof this.h.resolveCodeLens!="function"||J.isResolved?X=J:X=await this.h.resolveCodeLens(J,W),X||(X=J),W.isCancellationRequested)return;const de=V.cacheId&&this.e.get(V.cacheId[0]);if(de){if(!X.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return V.command=this.g.toInternal(X.command,de),V}}releaseCodeLenses(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}}function f(ze){return Array.isArray(ze)?ze.map(i.DefinitionLink.from):ze?[i.DefinitionLink.from(ze)]:[]}class g{constructor(V,W){this.d=V,this.e=W}async provideDefinition(V,W,J){const X=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideDefinition(X,de,J);return f(we)}}class w{constructor(V,W){this.d=V,this.e=W}async provideDeclaration(V,W,J){const X=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideDeclaration(X,de,J);return f(we)}}class S{constructor(V,W){this.d=V,this.e=W}async provideImplementation(V,W,J){const X=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideImplementation(X,de,J);return f(we)}}class m{constructor(V,W){this.d=V,this.e=W}async provideTypeDefinition(V,W,J){const X=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideTypeDefinition(X,de,J);return f(we)}}class E{static{this.f=10}constructor(V,W){this.g=V,this.h=W,this.d=0,this.e=new Map}async provideHover(V,W,J,X){const de=this.g.getDocument(V),we=i.Position.to(W);let je;if(J&&J.verbosityRequest){const _e=J.verbosityRequest.previousHover.id,nt=this.e.get(_e);if(!nt)throw new Error(`Hover with id ${_e} not found`);const it={action:J.verbosityRequest.action,previousHover:nt};je=await this.h.provideHover(de,we,X,it)}else je=await this.h.provideHover(de,we,X);if(!je||(0,d.$Kb)(je.contents))return;je.range||(je.range=de.getWordRangeAtPosition(we)),je.range||(je.range=new u.$cN(we,we));const Ve=i.Hover.from(je),Je=this.d;if(this.e.size===E.f){const _e=Math.min(...this.e.keys());this.e.delete(_e)}return this.e.set(Je,je),this.d+=1,{...Ve,id:Je}}releaseHover(V){this.e.delete(V)}}class D{constructor(V,W){this.d=V,this.e=W}async provideEvaluatableExpression(V,W,J){const X=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideEvaluatableExpression(X,de,J);if(we)return i.EvaluatableExpression.from(we)}}class P{constructor(V,W){this.d=V,this.e=W}async provideInlineValues(V,W,J,X){const de=this.d.getDocument(V),we=await this.e.provideInlineValues(de,i.Range.to(W),i.InlineValueContext.to(J),X);if(Array.isArray(we))return we.map(je=>i.InlineValue.from(je))}}class I{constructor(V,W){this.d=V,this.e=W}async provideDocumentHighlights(V,W,J){const X=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideDocumentHighlights(X,de,J);if(Array.isArray(we))return we.map(i.DocumentHighlight.from)}}class F{constructor(V,W){this.d=V,this.e=W}async provideMultiDocumentHighlights(V,W,J,X){const de=this.d.getDocument(V),we=J.map(Je=>this.d.getDocument(Je)),je=i.Position.to(W),Ve=await this.e.provideMultiDocumentHighlights(de,je,we,X);if(Array.isArray(Ve))return Ve.map(i.MultiDocumentHighlight.from)}}class T{constructor(V,W){this.d=V,this.e=W}async provideLinkedEditingRanges(V,W,J){const X=this.d.getDocument(V),de=i.Position.to(W),we=await this.e.provideLinkedEditingRanges(X,de,J);if(we&&Array.isArray(we.ranges))return{ranges:(0,d.$Hb)(we.ranges.map(i.Range.from)),wordPattern:we.wordPattern}}}class z{constructor(V,W){this.d=V,this.e=W}async provideReferences(V,W,J,X){const de=this.d.getDocument(V),we=i.Position.to(W),je=await this.e.provideReferences(de,we,J,X);if(Array.isArray(je))return je.map(i.location.from)}}class M{static{this.d=1e3}constructor(V,W,J,X,de,we,je){this.g=V,this.h=W,this.j=J,this.k=X,this.l=de,this.m=we,this.n=je,this.e=new t.$plc("CodeAction"),this.f=new Map}async provideCodeActions(V,W,J,X){const de=this.g.getDocument(V),we=v.$wt.isISelection(W)?i.Selection.to(W):i.Range.to(W),je=[];for(const it of this.j.getDiagnostics(V))if(we.intersection(it.range)&&je.push(it)>M.d)break;const Ve={diagnostics:je,only:J.only?new u.$wN(J.only):void 0,triggerKind:i.CodeActionTriggerKind.to(J.trigger)},Je=await this.k.provideCodeActions(de,we,Ve,X);if(!(0,d.$Lb)(Je)||X.isCancellationRequested)return;const tt=this.e.add(Je),_e=new b.$Tc;this.f.set(tt,_e);const nt=[];for(let it=0;it<Je.length;it++){const rt=Je[it];if(rt)if(M.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,_e)});else{Ve.only&&(rt.kind?Ve.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=rt.ranges??[];nt.push({cacheId:[tt,it],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,_e),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,s.$OG)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,s.$OG)(this.m,"codeActionRanges")?(0,d.$Hb)(at.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:tt,actions:nt}}async resolveCodeAction(V,W){const[J,X]=V,de=this.e.get(J,X);if(!de||M.o(de))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(de,W)??de;let je;we.edit&&(je=i.WorkspaceEdit.from(we.edit,void 0));let Ve;if(we.command){const Je=this.f.get(J);Je&&(Ve=this.h.toInternal(we.command,Je))}return{edit:je,command:Ve}}releaseCodeActions(V){this.f.get(V)?.dispose(),this.f.delete(V),this.e.delete(V)}static o(V){return typeof V.command=="string"&&typeof V.title=="string"}}class j{constructor(V,W,J,X,de){this.e=V,this.f=W,this.g=J,this.h=X,this.j=de,this.d=new t.$plc("DocumentPasteEdit")}async prepareDocumentPaste(V,W,J,X){if(!this.g.prepareDocumentPaste)return;const de=this.f.getDocument(V),we=W.map(Je=>i.Range.to(Je)),je=i.DataTransfer.toDataTransfer(J,()=>{throw new R.$$});if(await this.g.prepareDocumentPaste(de,we,je,X),X.isCancellationRequested)return;const Ve=Array.from(je).filter(([,Je])=>!(Je instanceof u.$3N));return i.DataTransfer.from(Ve)}async providePasteEdits(V,W,J,X,de,we){if(!this.g.provideDocumentPasteEdits)return[];const je=this.f.getDocument(W),Ve=J.map(nt=>i.Range.to(nt)),Je=i.DataTransfer.toDataTransfer(X,async nt=>(await this.e.$resolvePasteFileData(this.h,V,nt)).buffer),tt=await this.g.provideDocumentPasteEdits(je,Ve,Je,{only:de.only?new u.$8N(de.only):void 0,triggerKind:de.triggerKind},we);if(!tt||we.isCancellationRequested)return[];const _e=this.d.add(tt);return tt.map((nt,it)=>({_cacheId:[_e,it],title:nt.title??(0,o.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(V,W){const[J,X]=V,de=this.d.get(J,X);if(!de||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(de,W)??de;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(V){this.d.delete(V)}}class U{constructor(V,W){this.d=V,this.e=W}async provideDocumentFormattingEdits(V,W,J){const X=this.d.getDocument(V),de=await this.e.provideDocumentFormattingEdits(X,W,J);if(Array.isArray(de))return de.map(i.TextEdit.from)}}class Z{constructor(V,W){this.d=V,this.e=W}async provideDocumentRangeFormattingEdits(V,W,J,X){const de=this.d.getDocument(V),we=i.Range.to(W),je=await this.e.provideDocumentRangeFormattingEdits(de,we,J,X);if(Array.isArray(je))return je.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(V,W,J,X){(0,C.$gg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const de=this.d.getDocument(V),we=W.map(i.Range.to),je=await this.e.provideDocumentRangesFormattingEdits(de,we,J,X);if(Array.isArray(je))return je.map(i.TextEdit.from)}}class ie{constructor(V,W){this.d=V,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,W,J,X,de){const we=this.d.getDocument(V),je=i.Position.to(W),Ve=await this.e.provideOnTypeFormattingEdits(we,je,J,X,de);if(Array.isArray(Ve))return Ve.map(i.TextEdit.from)}}class q{constructor(V,W){this.e=V,this.f=W,this.d=new t.$plc("WorkspaceSymbols")}async provideWorkspaceSymbols(V,W){const J=await this.e.provideWorkspaceSymbols(V,W);if(!(0,d.$Lb)(J))return{symbols:[]};const X=this.d.add(J),de={cacheId:X,symbols:[]};for(let we=0;we<J.length;we++){const je=J[we];if(!je||!je.name){this.f.warn("INVALID SymbolInformation",je);continue}de.symbols.push({...i.WorkspaceSymbol.from(je),cacheId:[X,we]})}return de}async resolveWorkspaceSymbol(V,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!V.cacheId)return V;const J=this.d.get(...V.cacheId);if(J){const X=await this.e.resolveWorkspaceSymbol(J,W);return X&&(0,$.$6n)(V,i.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(V){this.d.delete(V)}}class G{static supportsResolving(V){return typeof V.prepareRename=="function"}constructor(V,W,J){this.d=V,this.e=W,this.f=J}async provideRenameEdits(V,W,J,X){const de=this.d.getDocument(V),we=i.Position.to(W);try{const je=await this.e.provideRenameEdits(de,we,J,X);return je?i.WorkspaceEdit.from(je):void 0}catch(je){const Ve=G.g(je);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(je)}}async resolveRenameLocation(V,W,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const X=this.d.getDocument(V),de=i.Position.to(W);try{const we=await this.e.prepareRename(X,de,J);let je,Ve;if(u.$cN.isRange(we)?(je=we,Ve=X.getText(we)):(0,C.$$f)(we)&&(je=we.range,Ve=we.placeholder),!je||!Ve)return;if(je.start.line>de.line||je.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(je),text:Ve}}catch(we){const je=G.g(we);return je?{rejectReason:je,range:void 0,text:void 0}:Promise.reject(we)}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class x{static{this.d={[h.NewSymbolNameTriggerKind.Invoke]:u.NewSymbolNameTriggerKind.Invoke,[h.NewSymbolNameTriggerKind.Automatic]:u.NewSymbolNameTriggerKind.Automatic}}constructor(V,W,J){this.e=V,this.f=W,this.g=J}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(V,W,J,X){const de=this.e.getDocument(V),we=i.Range.to(W);try{const je=x.d[J],Ve=await this.f.provideNewSymbolNames(de,we,je,X);return Ve?Ve.map(Je=>typeof Je=="string"?{newSymbolName:Je}:{newSymbolName:Je.newSymbolName,tags:Je.tags}):void 0}catch(je){this.g.error(x.h(je)??JSON.stringify(je,null,"	"));return}}static h(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class ne{constructor(V,W){this.resultId=V,this.tokens=W}}class be{constructor(V,W){this.f=V,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(V,W,J){const X=this.f.getDocument(V),de=W!==0?this.d.get(W):null;let we=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(X,de.resultId,J):await this.g.provideDocumentSemanticTokens(X,J);return de&&this.d.delete(W),we?(we=be.h(we),this.o(be.n(de,we),we)):null}async releaseDocumentSemanticColoring(V){this.d.delete(V)}static h(V){return be.j(V)?be.k(V)?V:new u.$vO(new Uint32Array(V.data),V.resultId):be.l(V)?be.m(V)?V:new u.$xO(V.edits.map(W=>new u.$wO(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),V.resultId):V}static j(V){return V&&!!V.data}static k(V){return V.data instanceof Uint32Array}static l(V){return V&&Array.isArray(V.edits)}static m(V){for(const W of V.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(V,W){if(!be.j(W)||!V||!V.tokens)return W;const J=V.tokens,X=J.length,de=W.data,we=de.length;let je=0;const Ve=Math.min(X,we);for(;je<Ve&&J[je]===de[je];)je++;if(je===X&&je===we)return new u.$xO([],W.resultId);let Je=0;const tt=Ve-je;for(;Je<tt&&J[X-Je-1]===de[we-Je-1];)Je++;return new u.$xO([{start:je,deleteCount:X-je-Je,data:de.subarray(je,we-Je)}],W.resultId)}o(V,W){if(be.j(V)){const J=this.e++;return this.d.set(J,new ne(V.resultId,V.data)),(0,l.$ccb)({id:J,type:"full",data:V.data})}if(be.l(V)){const J=this.e++;return be.j(W)?this.d.set(J,new ne(W.resultId,W.data)):this.d.set(J,new ne(V.resultId)),(0,l.$ccb)({id:J,type:"delta",deltas:(V.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}class ae{constructor(V,W){this.d=V,this.e=W}async provideDocumentRangeSemanticTokens(V,W,J){const X=this.d.getDocument(V),de=await this.e.provideDocumentRangeSemanticTokens(X,i.Range.to(W),J);return de?this.f(de):null}f(V){return(0,l.$ccb)({id:0,type:"full",data:V.data})}}class Ce{static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}constructor(V,W,J,X,de){this.f=V,this.g=W,this.h=J,this.j=X,this.k=de,this.d=new t.$plc("CompletionItem"),this.e=new Map}async provideCompletionItems(V,W,J,X){const de=this.f.getDocument(V),we=i.Position.to(W),je=de.getWordRangeAtPosition(we)||new u.$cN(we,we),Ve=je.with({end:we}),Je=new k.$_d,tt=await this.h.provideCompletionItems(de,we,X,i.CompletionContext.to(J));if(!tt||X.isCancellationRequested)return;const _e=Array.isArray(tt)?new u.$JN(tt):tt,nt=Ce.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),it=new b.$Tc;this.e.set(nt,it);const rt=[],at={x:nt,b:rt,a:{replace:i.Range.from(je),insert:i.Range.from(Ve)},c:_e.isIncomplete||void 0,d:Je.elapsed()};for(let Ne=0;Ne<_e.items.length;Ne++){const ye=_e.items[Ne],qe=this.l(ye,[nt,Ne],Ve,je);rt.push(qe)}return at}async resolveCompletionItem(V,W){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...V);if(!J)return;const X=this.l(J,V),de=await this.h.resolveCompletionItem(J,W);if(!de)return;const we=this.l(de,V);return(X.h!==we.h||X.i!==we.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(X.n!==we.n||X.o!==we.o||!(0,$.$7n)(X.p,we.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...X,d:we.d,c:we.c,l:we.l,h:we.h,i:we.i,n:we.n,o:we.o,p:we.p}}releaseCompletionItems(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,W,J,X){const de=this.e.get(W[0]);if(!de)throw Error("DisposableStore is missing...");const we=this.g.toInternal(V.command,de),je={x:W,a:V.label,b:V.kind!==void 0?i.CompletionItemKind.from(V.kind):void 0,m:V.tags&&V.tags.map(i.CompletionItemTag.from),c:V.detail,d:typeof V.documentation>"u"?void 0:i.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters?.join(""),l:V.additionalTextEdits&&V.additionalTextEdits.map(i.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};V.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),je.h=V.textEdit.newText):typeof V.insertText=="string"?je.h=V.insertText:V.insertText instanceof u.$lN&&(je.h=V.insertText.value,je.i|=4);let Ve;return V.textEdit?Ve=V.textEdit.range:V.range&&(Ve=V.range),u.$cN.isRange(Ve)?je.j=i.Range.from(Ve):Ve&&(!J?.isEqual(Ve.inserting)||!X?.isEqual(Ve.replacing))&&(je.j={insert:i.Range.from(Ve.inserting),replace:i.Range.from(Ve.replacing)}),je}}class ee{async provideInlineCompletions(V,W,J,X){}disposeCompletions(V){}handleDidShowCompletionItem(V,W,J){}handlePartialAccept(V,W,J,X){}}class B extends ee{constructor(V,W,J,X){super(),this.f=V,this.g=W,this.h=J,this.j=X,this.d=new pe,this.e=(0,s.$OG)(this.f,"inlineCompletionsAdditions"),this.k={[h.InlineCompletionTriggerKind.Automatic]:u.InlineCompletionTriggerKind.Automatic,[h.InlineCompletionTriggerKind.Explicit]:u.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,s.$OG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(V,W,J,X){const de=this.g.getDocument(V),we=i.Position.to(W),je=await this.h.provideInlineCompletionItems(de,we,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:i.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},X);if(!je||X.isCancellationRequested)return;const Ve=Array.isArray(je)?je:je.items,Je=this.e?Array.isArray(je)?[]:je.commands||[]:[],tt=this.e&&!Array.isArray(je)?je.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:Ve}),items:Ve.map((it,rt)=>{let at;it.command&&(_e||(_e=new b.$Tc),at=this.j.toInternal(it.command,_e));const Ne=it.insertText;return{insertText:typeof Ne=="string"?Ne:{snippet:Ne.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:at,idx:rt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Je.map(it=>(_e||(_e=new b.$Tc),this.j.toInternal(it,_e))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(V){this.d.disposeReferenceId(V)?.dispose()}handleDidShowCompletionItem(V,W,J){const X=this.d.get(V)?.items[W];X&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(X,J)}handlePartialAccept(V,W,J,X){const de=this.d.get(V)?.items[W];de&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(de,J),this.h.handleDidPartiallyAcceptCompletionItem(de,i.PartialAcceptInfo.to(X)))}}class _{async provideInlineEdits(V,W,J){const X=this.f.getDocument(V),de=await this.g.provideInlineEdit(X,{triggerKind:this.e[W.triggerKind]},J);if(!de||J.isCancellationRequested)return;let we;const je=this.d.createReferenceId({dispose(){we?.dispose()},item:de});let Ve;de.accepted&&(we||(we=new b.$Tc),Ve=this.h.toInternal(de.accepted,we));let Je;return de.rejected&&(we||(we=new b.$Tc),Je=this.h.toInternal(de.rejected,we)),{pid:je,text:de.text,range:i.Range.from(de.range),accepted:Ve,rejected:Je}}disposeEdit(V){this.d.disposeReferenceId(V)?.dispose()}constructor(V,W,J,X){this.f=W,this.g=J,this.h=X,this.d=new pe,this.e={[h.InlineEditTriggerKind.Automatic]:u.InlineEditTriggerKind.Automatic,[h.InlineEditTriggerKind.Invoke]:u.InlineEditTriggerKind.Invoke}}}class pe{constructor(){this.d=new Map,this.e=1}createReferenceId(V){const W=this.e++;return this.d.set(W,V),W}disposeReferenceId(V){const W=this.d.get(V);return this.d.delete(V),W}get(V){return this.d.get(V)}}class ue{constructor(V,W){this.e=V,this.f=W,this.d=new t.$plc("SignatureHelp")}async provideSignatureHelp(V,W,J,X){const de=this.e.getDocument(V),we=i.Position.to(W),je=this.g(J),Ve=await this.f.provideSignatureHelp(de,we,X,je);if(Ve){const Je=this.d.add([Ve]);return{...i.SignatureHelp.from(Ve),id:Je}}}g(V){let W;if(V.activeSignatureHelp){const J=i.SignatureHelp.to(V.activeSignatureHelp),X=this.d.get(V.activeSignatureHelp.id,0);X?(W=X,W.activeSignature=J.activeSignature,W.activeParameter=J.activeParameter):W=J}return{...V,activeSignatureHelp:W}}releaseSignatureHelp(V){this.d.delete(V)}}class ce{constructor(V,W,J,X,de){this.f=V,this.g=W,this.h=J,this.j=X,this.k=de,this.d=new t.$plc("InlayHints"),this.e=new Map}async provideInlayHints(V,W,J){const X=this.f.getDocument(V),de=i.Range.to(W),we=await this.h.provideInlayHints(X,de,J);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`);return}if(J.isCancellationRequested)return;const je=this.d.add(we);this.e.set(je,new b.$Tc);const Ve={hints:[],cacheId:je};for(let Je=0;Je<we.length;Je++)this.l(we[Je],de)&&Ve.hints.push(this.m(we[Je],[je,Je]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`),Ve}async resolveInlayHint(V,W){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...V);if(!J)return;const X=await this.h.resolveInlayHint(J,W);if(X&&this.l(X))return this.m(X,V)}releaseHints(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,W){return V.label.length===0||Array.isArray(V.label)&&V.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",V),!1):!(W&&!W.contains(V.position))}m(V,W){const J=this.e.get(W[0]);if(!J)throw Error("DisposableStore is missing...");const X={label:"",cacheId:W,tooltip:i.MarkdownString.fromStrict(V.tooltip),position:i.Position.from(V.position),textEdits:V.textEdits&&V.textEdits.map(i.TextEdit.from),kind:V.kind&&i.InlayHintKind.from(V.kind),paddingLeft:V.paddingLeft,paddingRight:V.paddingRight};if(typeof V.label=="string")X.label=V.label;else{const de=[];X.label=de;for(const we of V.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const je={label:we.value,tooltip:i.MarkdownString.fromStrict(we.tooltip)};u.$mN.isLocation(we.location)&&(je.location=i.location.from(we.location)),we.command&&(je.command=this.g.toInternal(we.command,J)),de.push(je)}}return X}}class oe{constructor(V,W){this.e=V,this.f=W,this.d=new t.$plc("DocumentLink")}async provideLinks(V,W){const J=this.e.getDocument(V),X=await this.f.provideDocumentLinks(J,W);if(!(!Array.isArray(X)||X.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:X.filter(oe.g).map(i.DocumentLink.from)};{const de=this.d.add(X),we={links:[],cacheId:de};for(let je=0;je<X.length;je++){if(!oe.g(X[je]))continue;const Ve=i.DocumentLink.from(X[je]);Ve.cacheId=[de,je],we.links.push(Ve)}return we}}}static g(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,W){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...V);if(!J)return;const X=await this.f.resolveDocumentLink(J,W);if(!(!X||!oe.g(X)))return i.DocumentLink.from(X)}releaseLinks(V){this.d.delete(V)}}class le{constructor(V,W){this.d=V,this.e=W}async provideColors(V,W){const J=this.d.getDocument(V),X=await this.e.provideDocumentColors(J,W);return Array.isArray(X)?X.map(we=>({color:i.Color.from(we.color),range:i.Range.from(we.range)})):[]}async provideColorPresentations(V,W,J){const X=this.d.getDocument(V),de=i.Range.to(W.range),we=i.Color.to(W.color),je=await this.e.provideColorPresentations(we,{document:X,range:de},J);if(Array.isArray(je))return je.map(i.ColorPresentation.from)}}class K{constructor(V,W){this.d=V,this.e=W}async provideFoldingRanges(V,W,J){const X=this.d.getDocument(V),de=await this.e.provideFoldingRanges(X,W,J);if(Array.isArray(de))return de.map(i.FoldingRange.from)}}class se{constructor(V,W,J){this.d=V,this.e=W,this.f=J}async provideSelectionRanges(V,W,J){const X=this.d.getDocument(V),de=W.map(i.Position.to),we=await this.e.provideSelectionRanges(X,de,J);if(!(0,d.$Lb)(we))return[];if(we.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const je=[];for(let Ve=0;Ve<de.length;Ve++){const Je=[];je.push(Je);let tt=de[Ve],_e=we[Ve];for(;;){if(!_e.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Je.push(i.SelectionRange.from(_e)),!_e.parent)break;tt=_e.range,_e=_e.parent}}return je}}class $e{constructor(V,W){this.f=V,this.g=W,this.d=new N.$EP(""),this.e=new Map}async prepareSession(V,W,J){const X=this.f.getDocument(V),de=i.Position.to(W),we=await this.g.prepareCallHierarchy(X,de,J);if(!we)return;const je=this.d.nextId();return this.e.set(je,new Map),Array.isArray(we)?we.map(Ve=>this.h(je,Ve)):[this.h(je,we)]}async provideCallsTo(V,W,J){const X=this.j(V,W);if(!X)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(X,J);if(de)return de.map(we=>({from:this.h(V,we.from),fromRanges:we.fromRanges.map(je=>i.Range.from(je))}))}async provideCallsFrom(V,W,J){const X=this.j(V,W);if(!X)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(X,J);if(de)return de.map(we=>({to:this.h(V,we.to),fromRanges:we.fromRanges.map(je=>i.Range.from(je))}))}releaseSession(V){this.e.delete(V)}h(V,W){const J=this.e.get(V),X=i.CallHierarchyItem.from(W,V,J.size.toString(36));return J.set(X._itemId,W),X}j(V,W){return this.e.get(V)?.get(W)}}class ve{constructor(V,W){this.f=V,this.g=W,this.d=new N.$EP(""),this.e=new Map}async prepareSession(V,W,J){const X=this.f.getDocument(V),de=i.Position.to(W),we=await this.g.prepareTypeHierarchy(X,de,J);if(!we)return;const je=this.d.nextId();return this.e.set(je,new Map),Array.isArray(we)?we.map(Ve=>this.h(je,Ve)):[this.h(je,we)]}async provideSupertypes(V,W,J){const X=this.j(V,W);if(!X)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(X,J);if(de)return de.map(we=>this.h(V,we))}async provideSubtypes(V,W,J){const X=this.j(V,W);if(!X)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(X,J);if(de)return de.map(we=>this.h(V,we))}releaseSession(V){this.e.delete(V)}h(V,W){const J=this.e.get(V),X=i.TypeHierarchyItem.from(W,V,J.size.toString(36));return J.set(X._itemId,W),X}j(V,W){return this.e.get(V)?.get(W)}}class Re{constructor(V,W,J,X,de){this.e=V,this.f=W,this.g=J,this.h=X,this.j=de,this.d=new t.$plc("DocumentDropEdit")}async provideDocumentOnDropEdits(V,W,J,X,de){const we=this.f.getDocument(W),je=i.Position.to(J),Ve=i.DataTransfer.toDataTransfer(X,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,V,nt)).buffer),Je=await this.g.provideDocumentDropEdits(we,je,Ve,de);if(!Je)return;const tt=(0,d.$2b)(Je),_e=this.d.add(tt);return tt.map((nt,it)=>({_cacheId:[_e,it],title:nt.title??(0,o.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(V,W){const[J,X]=V,de=this.d.get(J,X);if(!de||!this.g.resolveDocumentDropEdit)return{};const we=await this.g.resolveDocumentDropEdit(de,W)??de;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releaseDropEdits(V){this.d.delete(V)}}class ge{constructor(V,W){this.d=V,this.e=W}async provideMappedEdits(V,W,J,X){const de=p.URI.revive(V),we=this.d.getDocument(de),je=J.documents.map(tt=>tt.map(_e=>({uri:p.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(nt=>i.Range.to(nt))}))),Ve={documents:je,selections:je[0]?.[0]?.ranges??[]},Je=await this.e.provideMappedEdits(we,W,Ve,X);return Je?i.WorkspaceEdit.from(Je):null}}class Ie{constructor(V,W){this.adapter=V,this.extension=W}}class Ae{static{this.d=0}constructor(V,W,J,X,de,we,je,Ve){this.g=W,this.h=J,this.j=X,this.k=de,this.l=we,this.m=je,this.n=Ve,this.f=new Map,this.e=V.getProxy(c.$$M.MainThreadLanguageFeatures)}o(V,W){return i.DocumentSelector.from(V,this.g,W)}p(V){return new u.$aN(()=>{this.f.delete(V),this.e.$unregister(V)})}q(){return Ae.d++}async s(V,W,J,X,de,we=!1){const je=this.f.get(V);if(!je||!(je.adapter instanceof W))return X;const Ve=Date.now();we||this.l.trace(`[${je.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Je=J(je.adapter,je.extension);return Promise.resolve(Je).catch(tt=>{(0,R.$4)(tt)||(this.l.error(`[${je.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(je.extension.identifier,tt))}).finally(()=>{we||this.l.trace(`[${je.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),L.CancellationToken.isCancellationToken(de)?(0,O.$lh)(Je,de):Je}t(V,W){const J=this.q();return this.f.set(J,new Ie(V,W)),J}static u(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,W,J,X){const de=this.t(new r(this.h,J),V),we=X&&X.label||Ae.u(V);return this.e.$registerDocumentSymbolProvider(de,this.o(W,V),we),this.p(de)}$provideDocumentSymbols(V,W,J){return this.s(V,r,X=>X.provideDocumentSymbols(p.URI.revive(W),J),void 0,J)}registerCodeLensProvider(V,W,J){const X=this.q(),de=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(X,new Ie(new a(this.h,this.j.converter,J,V,this.n,this.l),V)),this.e.$registerCodeLensSupport(X,this.o(W,V),de);let we=this.p(X);if(de!==void 0){const je=J.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(de));we=u.$aN.from(we,je)}return we}$provideCodeLenses(V,W,J){return this.s(V,a,X=>X.provideCodeLenses(p.URI.revive(W),J),void 0,J)}$resolveCodeLens(V,W,J){return this.s(V,a,X=>X.resolveCodeLens(W,J),void 0,void 0)}$releaseCodeLenses(V,W){this.s(V,a,J=>Promise.resolve(J.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(V,W,J){const X=this.t(new g(this.h,J),V);return this.e.$registerDefinitionSupport(X,this.o(W,V)),this.p(X)}$provideDefinition(V,W,J,X){return this.s(V,g,de=>de.provideDefinition(p.URI.revive(W),J,X),[],X)}registerDeclarationProvider(V,W,J){const X=this.t(new w(this.h,J),V);return this.e.$registerDeclarationSupport(X,this.o(W,V)),this.p(X)}$provideDeclaration(V,W,J,X){return this.s(V,w,de=>de.provideDeclaration(p.URI.revive(W),J,X),[],X)}registerImplementationProvider(V,W,J){const X=this.t(new S(this.h,J),V);return this.e.$registerImplementationSupport(X,this.o(W,V)),this.p(X)}$provideImplementation(V,W,J,X){return this.s(V,S,de=>de.provideImplementation(p.URI.revive(W),J,X),[],X)}registerTypeDefinitionProvider(V,W,J){const X=this.t(new m(this.h,J),V);return this.e.$registerTypeDefinitionSupport(X,this.o(W,V)),this.p(X)}$provideTypeDefinition(V,W,J,X){return this.s(V,m,de=>de.provideTypeDefinition(p.URI.revive(W),J,X),[],X)}registerHoverProvider(V,W,J,X){const de=this.t(new E(this.h,J),V);return this.e.$registerHoverProvider(de,this.o(W,V)),this.p(de)}$provideHover(V,W,J,X,de){return this.s(V,E,we=>we.provideHover(p.URI.revive(W),J,X,de),void 0,de)}$releaseHover(V,W){this.s(V,E,J=>Promise.resolve(J.releaseHover(W)),void 0,void 0)}registerEvaluatableExpressionProvider(V,W,J,X){const de=this.t(new D(this.h,J),V);return this.e.$registerEvaluatableExpressionProvider(de,this.o(W,V)),this.p(de)}$provideEvaluatableExpression(V,W,J,X){return this.s(V,D,de=>de.provideEvaluatableExpression(p.URI.revive(W),J,X),void 0,X)}registerInlineValuesProvider(V,W,J,X){const de=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new P(this.h,J),V);this.e.$registerInlineValuesProvider(we,this.o(W,V),de);let je=this.p(we);if(de!==void 0){const Ve=J.onDidChangeInlineValues(Je=>this.e.$emitInlineValuesEvent(de));je=u.$aN.from(je,Ve)}return je}$provideInlineValues(V,W,J,X,de){return this.s(V,P,we=>we.provideInlineValues(p.URI.revive(W),J,X,de),void 0,de)}registerDocumentHighlightProvider(V,W,J){const X=this.t(new I(this.h,J),V);return this.e.$registerDocumentHighlightProvider(X,this.o(W,V)),this.p(X)}registerMultiDocumentHighlightProvider(V,W,J){const X=this.t(new F(this.h,J),V);return this.e.$registerMultiDocumentHighlightProvider(X,this.o(W,V)),this.p(X)}$provideDocumentHighlights(V,W,J,X){return this.s(V,I,de=>de.provideDocumentHighlights(p.URI.revive(W),J,X),void 0,X)}$provideMultiDocumentHighlights(V,W,J,X,de){return this.s(V,F,we=>we.provideMultiDocumentHighlights(p.URI.revive(W),J,X.map(je=>p.URI.revive(je)),de),void 0,de)}registerLinkedEditingRangeProvider(V,W,J){const X=this.t(new T(this.h,J),V);return this.e.$registerLinkedEditingRangeProvider(X,this.o(W,V)),this.p(X)}$provideLinkedEditingRanges(V,W,J,X){return this.s(V,T,async de=>{const we=await de.provideLinkedEditingRanges(p.URI.revive(W),J,X);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Ae.w(we.wordPattern):void 0}},void 0,X)}registerReferenceProvider(V,W,J){const X=this.t(new z(this.h,J),V);return this.e.$registerReferenceSupport(X,this.o(W,V)),this.p(X)}$provideReferences(V,W,J,X,de){return this.s(V,z,we=>we.provideReferences(p.URI.revive(W),J,X,de),void 0,de)}registerCodeActionProvider(V,W,J,X){const de=new b.$Tc,we=this.t(new M(this.h,this.j.converter,this.k,J,this.l,V,this.m),V);return this.e.$registerQuickFixSupport(we,this.o(W,V),{providedKinds:X?.providedCodeActionKinds?.map(je=>je.value),documentation:X?.documentation?.map(je=>({kind:je.kind.value,command:this.j.converter.toInternal(je.command,de)}))},Ae.u(V),!!J.resolveCodeAction),de.add(this.p(we)),de}$provideCodeActions(V,W,J,X,de){return this.s(V,M,we=>we.provideCodeActions(p.URI.revive(W),J,X,de),void 0,de)}$resolveCodeAction(V,W,J){return this.s(V,M,X=>X.resolveCodeAction(W,J),{},void 0)}$releaseCodeActions(V,W){this.s(V,M,J=>Promise.resolve(J.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(V,W,J){const X=this.t(new U(this.h,J),V);return this.e.$registerDocumentFormattingSupport(X,this.o(W,V),V.identifier,V.displayName||V.name),this.p(X)}$provideDocumentFormattingEdits(V,W,J,X){return this.s(V,U,de=>de.provideDocumentFormattingEdits(p.URI.revive(W),J,X),void 0,X)}registerDocumentRangeFormattingEditProvider(V,W,J){const X=typeof J.provideDocumentRangesFormattingEdits=="function",de=this.t(new Z(this.h,J),V);return this.e.$registerRangeFormattingSupport(de,this.o(W,V),V.identifier,V.displayName||V.name,X),this.p(de)}$provideDocumentRangeFormattingEdits(V,W,J,X,de){return this.s(V,Z,we=>we.provideDocumentRangeFormattingEdits(p.URI.revive(W),J,X,de),void 0,de)}$provideDocumentRangesFormattingEdits(V,W,J,X,de){return this.s(V,Z,we=>we.provideDocumentRangesFormattingEdits(p.URI.revive(W),J,X,de),void 0,de)}registerOnTypeFormattingEditProvider(V,W,J,X){const de=this.t(new ie(this.h,J),V);return this.e.$registerOnTypeFormattingSupport(de,this.o(W,V),X,V.identifier),this.p(de)}$provideOnTypeFormattingEdits(V,W,J,X,de,we){return this.s(V,ie,je=>je.provideOnTypeFormattingEdits(p.URI.revive(W),J,X,de,we),void 0,we)}registerWorkspaceSymbolProvider(V,W){const J=this.t(new q(W,this.l),V);return this.e.$registerNavigateTypeSupport(J,typeof W.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(V,W,J){return this.s(V,q,X=>X.provideWorkspaceSymbols(W,J),{symbols:[]},J)}$resolveWorkspaceSymbol(V,W,J){return this.s(V,q,X=>X.resolveWorkspaceSymbol(W,J),void 0,void 0)}$releaseWorkspaceSymbols(V,W){this.s(V,q,J=>J.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(V,W,J){const X=this.t(new G(this.h,J,this.l),V);return this.e.$registerRenameSupport(X,this.o(W,V),G.supportsResolving(J)),this.p(X)}$provideRenameEdits(V,W,J,X,de){return this.s(V,G,we=>we.provideRenameEdits(p.URI.revive(W),J,X,de),void 0,de)}$resolveRenameLocation(V,W,J,X){return this.s(V,G,de=>de.resolveRenameLocation(p.URI.revive(W),J,X),void 0,X)}registerNewSymbolNamesProvider(V,W,J){const X=this.t(new x(this.h,J,this.l),V);return this.e.$registerNewSymbolNamesProvider(X,this.o(W,V)),this.p(X)}$supportsAutomaticNewSymbolNamesTriggerKind(V){return this.s(V,x,W=>W.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(V,W,J,X,de){return this.s(V,x,we=>we.provideNewSymbolNames(p.URI.revive(W),J,X,de),void 0,de)}registerDocumentSemanticTokensProvider(V,W,J,X){const de=this.t(new be(this.h,J),V),we=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(W,V),X,we);let je=this.p(de);if(we){const Ve=J.onDidChangeSemanticTokens(Je=>this.e.$emitDocumentSemanticTokensEvent(we));je=u.$aN.from(je,Ve)}return je}$provideDocumentSemanticTokens(V,W,J,X){return this.s(V,be,de=>de.provideDocumentSemanticTokens(p.URI.revive(W),J,X),null,X)}$releaseDocumentSemanticTokens(V,W){this.s(V,be,J=>J.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(V,W,J,X){const de=this.t(new ae(this.h,J),V);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(W,V),X),this.p(de)}$provideDocumentRangeSemanticTokens(V,W,J,X){return this.s(V,ae,de=>de.provideDocumentRangeSemanticTokens(p.URI.revive(W),J,X),null,X)}registerCompletionItemProvider(V,W,J,X){const de=this.t(new Ce(this.h,this.j.converter,J,this.m,V),V);return this.e.$registerCompletionsProvider(de,this.o(W,V),X,Ce.supportsResolving(J),V.identifier),this.p(de)}$provideCompletionItems(V,W,J,X,de){return this.s(V,Ce,we=>we.provideCompletionItems(p.URI.revive(W),J,X,de),void 0,de)}$resolveCompletionItem(V,W,J){return this.s(V,Ce,X=>X.resolveCompletionItem(W,J),void 0,J)}$releaseCompletionItems(V,W){this.s(V,Ce,J=>J.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(V,W,J,X){const de=new B(V,this.h,J,this.j.converter),we=this.t(de,V);return this.e.$registerInlineCompletionsSupport(we,this.o(W,V),de.supportsHandleEvents,n.$Rm.toKey(V.identifier.value),X?.yieldTo?.map(je=>n.$Rm.toKey(je))||[]),this.p(we)}$provideInlineCompletions(V,W,J,X,de){return this.s(V,ee,we=>we.provideInlineCompletions(p.URI.revive(W),J,X,de),void 0,de)}$handleInlineCompletionDidShow(V,W,J,X){this.s(V,ee,async de=>{de.handleDidShowCompletionItem(W,J,X)},void 0,void 0)}$handleInlineCompletionPartialAccept(V,W,J,X,de){this.s(V,ee,async we=>{we.handlePartialAccept(W,J,X,de)},void 0,void 0)}$freeInlineCompletionsList(V,W){this.s(V,ee,async J=>{J.disposeCompletions(W)},void 0,void 0)}registerInlineEditProvider(V,W,J){const X=new _(V,this.h,J,this.j.converter),de=this.t(X,V);return this.e.$registerInlineEditProvider(de,this.o(W,V),V.identifier),this.p(de)}$provideInlineEdit(V,W,J,X){return this.s(V,_,de=>de.provideInlineEdits(p.URI.revive(W),J,X),void 0,X)}$freeInlineEdit(V,W){this.s(V,_,async J=>{J.disposeEdit(W)},void 0,void 0)}registerSignatureHelpProvider(V,W,J,X){const de=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,we=this.t(new ue(this.h,J),V);return this.e.$registerSignatureHelpProvider(we,this.o(W,V),de),this.p(we)}$provideSignatureHelp(V,W,J,X,de){return this.s(V,ue,we=>we.provideSignatureHelp(p.URI.revive(W),J,X,de),void 0,de)}$releaseSignatureHelp(V,W){this.s(V,ue,J=>J.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(V,W,J){const X=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new ce(this.h,this.j.converter,J,this.l,V),V);this.e.$registerInlayHintsProvider(de,this.o(W,V),typeof J.resolveInlayHint=="function",X,Ae.u(V));let we=this.p(de);if(X!==void 0){const je=J.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(X));we=u.$aN.from(we,je)}return we}$provideInlayHints(V,W,J,X){return this.s(V,ce,de=>de.provideInlayHints(p.URI.revive(W),J,X),void 0,X)}$resolveInlayHint(V,W,J){return this.s(V,ce,X=>X.resolveInlayHint(W,J),void 0,J)}$releaseInlayHints(V,W){this.s(V,ce,J=>J.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(V,W,J){const X=this.t(new oe(this.h,J),V);return this.e.$registerDocumentLinkProvider(X,this.o(W,V),typeof J.resolveDocumentLink=="function"),this.p(X)}$provideDocumentLinks(V,W,J){return this.s(V,oe,X=>X.provideLinks(p.URI.revive(W),J),void 0,J,W.scheme==="output")}$resolveDocumentLink(V,W,J){return this.s(V,oe,X=>X.resolveLink(W,J),void 0,void 0,!0)}$releaseDocumentLinks(V,W){this.s(V,oe,J=>J.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(V,W,J){const X=this.t(new le(this.h,J),V);return this.e.$registerDocumentColorProvider(X,this.o(W,V)),this.p(X)}$provideDocumentColors(V,W,J){return this.s(V,le,X=>X.provideColors(p.URI.revive(W),J),[],J)}$provideColorPresentations(V,W,J,X){return this.s(V,le,de=>de.provideColorPresentations(p.URI.revive(W),J,X),void 0,X)}registerFoldingRangeProvider(V,W,J){const X=this.q(),de=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(X,new Ie(new K(this.h,J),V)),this.e.$registerFoldingRangeProvider(X,this.o(W,V),V.identifier,de);let we=this.p(X);if(de!==void 0){const je=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));we=u.$aN.from(we,je)}return we}$provideFoldingRanges(V,W,J,X){return this.s(V,K,de=>de.provideFoldingRanges(p.URI.revive(W),J,X),void 0,X)}registerSelectionRangeProvider(V,W,J){const X=this.t(new se(this.h,J,this.l),V);return this.e.$registerSelectionRangeProvider(X,this.o(W,V)),this.p(X)}$provideSelectionRanges(V,W,J,X){return this.s(V,se,de=>de.provideSelectionRanges(p.URI.revive(W),J,X),[],X)}registerCallHierarchyProvider(V,W,J){const X=this.t(new $e(this.h,J),V);return this.e.$registerCallHierarchyProvider(X,this.o(W,V)),this.p(X)}$prepareCallHierarchy(V,W,J,X){return this.s(V,$e,de=>Promise.resolve(de.prepareSession(p.URI.revive(W),J,X)),void 0,X)}$provideCallHierarchyIncomingCalls(V,W,J,X){return this.s(V,$e,de=>de.provideCallsTo(W,J,X),void 0,X)}$provideCallHierarchyOutgoingCalls(V,W,J,X){return this.s(V,$e,de=>de.provideCallsFrom(W,J,X),void 0,X)}$releaseCallHierarchy(V,W){this.s(V,$e,J=>Promise.resolve(J.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(V,W,J){const X=this.t(new ve(this.h,J),V);return this.e.$registerTypeHierarchyProvider(X,this.o(W,V)),this.p(X)}$prepareTypeHierarchy(V,W,J,X){return this.s(V,ve,de=>Promise.resolve(de.prepareSession(p.URI.revive(W),J,X)),void 0,X)}$provideTypeHierarchySupertypes(V,W,J,X){return this.s(V,ve,de=>de.provideSupertypes(W,J,X),void 0,X)}$provideTypeHierarchySubtypes(V,W,J,X){return this.s(V,ve,de=>de.provideSubtypes(W,J,X),void 0,X)}$releaseTypeHierarchy(V,W){this.s(V,ve,J=>Promise.resolve(J.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(V,W,J,X){const de=this.q();return this.f.set(de,new Ie(new Re(this.e,this.h,J,de,V),V)),this.e.$registerDocumentOnDropEditProvider(de,this.o(W,V),(0,s.$OG)(V,"documentPaste")&&X?{supportsResolve:!!J.resolveDocumentDropEdit,dropMimeTypes:X.dropMimeTypes}:void 0),this.p(de)}$provideDocumentOnDropEdits(V,W,J,X,de,we){return this.s(V,Re,je=>Promise.resolve(je.provideDocumentOnDropEdits(W,p.URI.revive(J),X,de,we)),void 0,void 0)}$resolveDropEdit(V,W,J){return this.s(V,Re,X=>X.resolveDropEdit(W,J),{},void 0)}$releaseDropEdits(V,W){this.s(V,Re,J=>Promise.resolve(J.releaseDropEdits(W)),void 0,void 0)}registerMappedEditsProvider(V,W,J){const X=this.t(new ge(this.h,J),V);return this.e.$registerMappedEditsProvider(X,this.o(W,V)),this.p(X)}$provideMappedEdits(V,W,J,X,de){return this.s(V,ge,we=>Promise.resolve(we.provideMappedEdits(W,J,X,de)),null,de)}registerDocumentPasteEditProvider(V,W,J,X){const de=this.q();return this.f.set(de,new Ie(new j(this.e,this.h,J,de,V),V)),this.e.$registerPasteEditProvider(de,this.o(W,V),{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,supportsResolve:!!J.resolveDocumentPasteEdit,providedPasteEditKinds:X.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:X.copyMimeTypes,pasteMimeTypes:X.pasteMimeTypes}),this.p(de)}$prepareDocumentPaste(V,W,J,X,de){return this.s(V,j,we=>we.prepareDocumentPaste(p.URI.revive(W),J,X,de),void 0,de)}$providePasteEdits(V,W,J,X,de,we,je){return this.s(V,j,Ve=>Ve.providePasteEdits(W,p.URI.revive(J),X,de,we,je),void 0,je)}$resolvePasteEdit(V,W,J){return this.s(V,j,X=>X.resolvePasteEdit(W,J),{},void 0)}$releasePasteEdits(V,W){this.s(V,j,J=>Promise.resolve(J.releasePasteEdits(W)),void 0,void 0)}static w(V){return{pattern:V.source,flags:V.flags}}static y(V){return{decreaseIndentPattern:Ae.w(V.decreaseIndentPattern),increaseIndentPattern:Ae.w(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Ae.w(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Ae.w(V.unIndentedLinePattern):void 0}}static z(V){return{beforeText:Ae.w(V.beforeText),afterText:V.afterText?Ae.w(V.afterText):void 0,previousLineText:V.previousLineText?Ae.w(V.previousLineText):void 0,action:V.action}}static B(V){return V.map(Ae.z)}static C(V){return{open:V.open,close:V.close,notIn:V.notIn?V.notIn.map(W=>u.SyntaxTokenType.toString(W)):void 0}}static D(V){return V.map(Ae.C)}setLanguageConfiguration(V,W,J){const{wordPattern:X}=J;if(X&&(0,A.$jf)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this.h.setWordDefinitionFor(W,X):this.h.setWordDefinitionFor(W,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const de=this.q(),we={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Ae.w(J.wordPattern):void 0,indentationRules:J.indentationRules?Ae.y(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Ae.B(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?Ae.D(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(de,W,we),this.p(de)}$setWordDefinitions(V){for(const W of V)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.$zlc=Ae}),define(Se[122],De([1,0,3,6,16,8,109,25,7,4,227,146,13,5,20,121,11,39]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=e.$gmc=void 0,e.$gmc=(0,y.$wi)("IExtHostLanguageModels");class i{constructor(c,r){this.option=c,this.stream=new $.$Zh,this.stream=r??new $.$Zh}}class u{constructor(){this.a=new Map,this.b=new $.$Zh,this.c=!1,this.d=!1;const c=this;this.apiObject={stream:c.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,c]of this.a)yield c.stream;else yield this.b}handleFragment(c){if(this.c)return;this.d=!0;let r=this.a.get(c.index);r||(this.a.size===0?r=new i(c.index,this.b):r=new i(c.index),this.a.set(c.index,r)),r.stream.emitOne(c.part)}get isStreaming(){return this.d}reject(c){this.c=!0;for(const r of this.f())r.reject(c)}resolve(){this.c=!0;for(const c of this.f())c.resolve()}}let s=class{static{n=this}static{this.a=1}constructor(c,r,a){this.j=r,this.k=a,this.c=new k.$de,this.d=new k.$de,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new b.$Tm,this.i=new Map,this.o=new Set,this.b=c.getProxy(O.$$M.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(c,r,a,f){const g=n.a++;this.f.set(g,{extension:c.identifier,provider:a,languageModelId:r});let w;f.auth&&(w={providerLabel:c.displayName||c.name,accountLabel:typeof f.auth=="object"?f.auth.label:void 0}),this.b.$registerLanguageModelProvider(g,r,{extension:c.identifier,identifier:r,name:f.name??"",version:f.version,tokens:f.tokens,auth:w});const S=a.onDidReceiveLanguageModelResponse2?.(({extensionId:m,participant:E,tokenCount:D})=>{this.b.$whenLanguageModelChatRequestMade(r,new b.$Rm(m),E,D)});return(0,d.$Sc)(()=>{this.f.delete(g),this.b.$unregisterProvider(g),S?.dispose()})}async $provideLanguageModelResponse(c,r,a,f,g,w){const S=this.f.get(c);if(!S)return;const m=new N.$dw(async E=>{if(w.isCancellationRequested){this.j.warn(`[CHAT](${S.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(r,{index:E.index,part:E.part})});return S.provider.provideLanguageModelResponse2(f.map(L.LanguageModelMessage.to),g,b.$Rm.toKey(a),m,w)}$provideTokenLength(c,r,a){const f=this.f.get(c);return f?Promise.resolve(f.provider.provideTokenCount(r,a)):Promise.resolve(0)}$updateLanguageModels(c){const r=[],a=[];if(c.added)for(const f of c.added)this.g.set(f.identifier,f),r.push(f.identifier);if(c.removed)for(const f of c.removed){this.g.delete(f),a.push(f);for(const[g,w]of this.i)w.languageModelId===f&&(w.res.reject(new p.$5),this.i.delete(g))}this.d.fire(Object.freeze({added:Object.freeze(r),removed:Object.freeze(a)})),c.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(c){const r=new Array;for(const{from:a,to:f,enabled:g}of c){const w=this.h.get(a)??new b.$Sm;if(w.has(f)!==g){g?w.add(f):w.delete(f),this.h.set(a,w);const m={from:a,to:f};r.push(m),this.c.fire(m)}}}async sendChatRequest(c,r,a,f,g){const w=c.identifier,S=await this.b.$prepareChatAccess(w,r,f.justification);if(!S||!this.g.has(r))throw R.$mP.NotFound(`Language model '${r}' is unknown.`);if(this.m(w,S)&&(!await this.l(c,{identifier:S.extension,displayName:S.auth.providerLabel},f.justification,f.silent)||!this.h.get(w)?.has(S.extension)))throw R.$mP.NoPermissions(`Language model '${r}' cannot be used by '${w.value}'.`);const m=Math.random()*1e6|0,E=this.b.$fetchResponse(w,r,m,a.map(L.LanguageModelMessage.from),f.modelOptions??{},g),D=new $.$vh,P=new u;this.i.set(m,{languageModelId:r,res:P});let I;if(E.catch(F=>{D.isOpen()?P.reject(F):I=F}).finally(()=>{this.i.delete(m),P.resolve(),D.open()}),await D.wait(),I)throw I.name===R.$mP.name?I:new R.$mP(`Language model '${r}' errored, check cause for more details`,"Unknown",I);return P.apiObject}async $handleResponseFragment(c,r){const a=this.i.get(c);a&&a.res.handleFragment(r)}async l(c,r,a,f){const g=C.$aM+r.identifier.value;if(await this.k.getSession(c,g,[],{silent:!0}))return this.$updateModelAccesslist([{from:c.identifier,to:r.identifier,enabled:!0}]),!0;if(f)return!1;try{const S=a?(0,A.localize)(0,null,r.displayName,a):(0,A.localize)(1,null,r.displayName);return await this.k.getSession(c,g,[],{forceNewSession:{detail:S}}),this.$updateModelAccesslist([{from:c.identifier,to:r.identifier,enabled:!0}]),!0}catch{return!1}}m(c,r){return!!r.auth&&!b.$Rm.equals(r.extension,c)}async n(c){for(const r of this.o)try{await this.l(r,{identifier:c.extension,displayName:""},void 0,!0)}catch(a){this.j.error("Fake Auth request failed"),this.j.error(a)}}async computeTokenLength(c,r,a){const f=this.g.get(c);if(!f)throw R.$mP.NotFound(`Language model '${c}' is unknown.`);const g=o.Iterable.find(this.f.values(),w=>w.languageModelId===c);return g?g.provider.provideTokenCount(r,a):this.b.$countTokens(f.identifier,typeof r=="string"?r:L.LanguageModelMessage.from(r),a)}getLanguageModelInfo(c){const r=this.g.get(c);if(r)return{id:r.identifier,name:r.name,version:r.version,tokens:r.tokens}}createLanguageModelAccessInformation(c){this.o.add(c);const r=this,a=k.Event.signal(k.Event.filter(this.c.event,g=>b.$Rm.equals(g.from,c.identifier))),f=k.Event.signal(this.d.event);return{get onDidChange(){return k.Event.any(a,f)},canSendRequest(g){const w=r.g.get(g);if(!w)return;if(!r.m(c.identifier,w))return!0;const S=r.h.get(c.identifier);if(S)return S.has(w.extension)}}}};e.$hmc=s,e.$hmc=s=n=Ge([We(0,v.$zP),We(1,l.$3j),We(2,h.$Blc)],s)}),define(Se[344],De([1,0,6,16,8,41,7,3,26]),function(he,e,d,O,L,R,N,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ymc=void 0;class k{constructor(C,p,y,v){this.c=p,this.d=y,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(d.$$M.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,p){await this.a.$changeLanguage(C,p);const y=this.c.getDocumentData(C);if(!y)throw new Error(`document '${C.toString()}' NOT found`);return y.document}async tokenAtPosition(C,p){const y=C.version,v=O.Position.from(p),h=await this.a.$tokensAtPosition(C.uri,v),l={type:L.StandardTokenType.Other,range:C.getWordRangeAtPosition(p)??new L.$cN(p.line,p.character,p.line,p.character)};if(!h)return l;const o={range:O.Range.to(h.range),type:O.TokenType.to(h.type)};return!o.range.contains(p)||y!==C.version?l:o}createLanguageStatusItem(C,p,y){const v=this.f++,h=this.a,l=this.g,o=`${C.identifier.value}/${p}`;if(l.has(o))throw new Error(`LanguageStatusItem with id '${p}' ALREADY exists`);l.add(o);const n={selector:y,id:p,name:C.displayName??C.name,severity:L.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const u=new b.$Tc,s=()=>{if(i?.dispose(),!l.has(o)){console.warn(`LanguageStatusItem (${p}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,N.$yh)(()=>{u.clear(),this.a.$setLanguageStatus(v,{id:o,name:n.name??C.displayName??C.name,source:C.displayName??C.name,selector:O.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===L.LanguageStatusSeverity.Error?R.default.Error:n.severity===L.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:n.command&&this.d.toInternal(n.command,u),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){u.dispose(),i?.dispose(),h.$removeLanguageStatus(v),l.delete(o)},get id(){return n.id},get name(){return n.name},set name(c){n.name=c,s()},get selector(){return n.selector},set selector(c){n.selector=c,s()},get text(){return n.text},set text(c){n.text=c,s()},set text2(c){(0,$.$PG)(C,"languageStatusText"),n.text=c,s()},get text2(){return(0,$.$PG)(C,"languageStatusText"),n.text},get detail(){return n.detail},set detail(c){n.detail=c,s()},get severity(){return n.severity},set severity(c){n.severity=c,s()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(c){n.accessibilityInformation=c,s()},get command(){return n.command},set command(c){n.command=c,s()},get busy(){return n.busy},set busy(c){n.busy=c,s()}};return s(),t}}e.$Ymc=k}),define(Se[345],De([1,0,15,2,16,8,120]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=e.$Kmc=void 0;class b{constructor(C,p,y,v){this.start=C,this.deletedCount=p,this.deletedItems=y,this.items=v}asApiEvent(){return{range:new R.$CO(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(C){return{EOL:C.eol,lines:C.source,languageId:C.language,uri:C.uri,isDirty:!1,versionId:1}}constructor(C,p,y){this.notebook=C,this.h=p,this.j=y,this.handle=y.handle,this.uri=O.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(L.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(L.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,p=this.h.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:L.NotebookCellKind.to(this.j.cellKind),document:p.document,get mime(){return C.g},set mime(v){C.g=v},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(y)}return this.f}setOutputs(C){this.a=C.map(L.NotebookCellOutput.to)}setOutputItems(C,p,y){const v=y.map(L.NotebookCellOutputItem.to),h=this.a.find(l=>l.id===C);if(h&&(p||(h.items.length=0),h.items.push(...v),h.items.length>1&&h.items.every(l=>N.$7K(l.mime)))){const l=new Map,o=[];h.items.forEach(n=>{let i;l.has(n.mime)?i=l.get(n.mime):(i=[],l.set(n.mime,i),o.push(n.mime)),i.push(n.data)}),h.items.length=0,o.forEach(n=>{const i=N.$8K(l.get(n));h.items.push({mime:n,data:i.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(L.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$Kmc=$;class k{static{this.a=0}constructor(C,p,y,v,h){this.k=C,this.l=p,this.m=y,this.uri=v,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=h.viewType,this.f=Object.freeze(h.metadata??Object.create(null)),this.r([[0,0,h.cells]],!0,void 0),this.g=h.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,p={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===d.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(y){return y=C.n(y),C.b[y].apiCell},getCells(y){return(y?C.p(y):C.b).map(h=>h.apiCell)},save(){return C.q()}};this.e=Object.freeze(p)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,p,y){this.g=C.versionId,this.h=p,this.acceptDocumentPropertiesChanged({metadata:y});const v={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},h=[];for(const o of C.rawEvents)o.kind===N.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,v.contentChanges):o.kind===N.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,v.contentChanges):o.kind===N.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),h.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===N.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),h.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===N.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),h.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===N.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===N.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===N.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),h.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===N.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),h.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const l=new Map;for(let o=0;o<h.length;o++){const n=h[o],i=l.get(n.cell);if(i===void 0){const u=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});l.set(n.cell,u-1)}else v.cellChanges[i]={...v.cellChanges[i],...n}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let p=C.start|0,y=C.end|0;return p<0&&(p=0),y>this.b.length&&(y=this.b.length),C.with({start:p,end:y})}p(C){C=this.o(C);const p=[];for(let y=C.start;y<C.end;y++)p.push(this.b[y]);return p}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,p,y){if(this.j)return;const v=[],h=[],l=[];if(C.reverse().forEach(o=>{const i=o[2].map(t=>{const c=new $(this,this.l,t);return p||h.push($.asModelAddData(t)),c}),u=new b(o[0],o[1],[],i),s=this.b.splice(o[0],o[1],...i);for(const t of s)l.push(t.uri),u.deletedItems.push(t.apiCell);v.push(u)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:l}),y)for(const o of v)y.push(o.asApiEvent())}s(C,p,y,v){const h=this.b.splice(C,p);this.b.splice(y,0,...h);const l=[new b(C,p,h.map(o=>o.apiCell),[]),new b(y,0,[],h)];for(const o of l)v.push(o.asApiEvent())}t(C,p){this.b[C].setOutputs(p)}u(C,p,y,v){this.b[C].setOutputItems(p,y,v)}v(C,p){const y=this.b[C];y.apiCell.document.languageId!==p&&this.m.$acceptModelLanguageChanged(y.uri,p)}w(C,p){const y=this.b[C];y.apiCell.mime=p}x(C,p){this.b[C].setMetadata(p)}y(C,p){this.b[C].setInternalMetadata(p)}getCellFromApiCell(C){return this.b.find(p=>p.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(p=>p.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$Lmc=k}),define(Se[346],De([1,0,4,2,16,8,48]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=void 0;class b{constructor(k,A,C,p={timeout:1500,errors:3}){this.b=k,this.c=A,this.d=C,this.f=p,this.a=new d.$fe}dispose(){}getOnWillSaveNotebookDocumentEvent(k){return(A,C,p)=>{const y=function(h){A.call(C,h)};return y.extension=k,this.a.event(y,void 0,p)}}async $participateInSave(k,A,C){const p=O.URI.revive(k),y=this.c.getNotebookDocument(p);if(!y)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:y.apiNotebook,reason:L.TextDocumentSaveReason.to(A)},C,async(l,o)=>{const n=Date.now(),i=await await Promise.resolve(l);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!C.isCancellationRequested&&i&&(i instanceof R.$kN?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),C.isCancellationRequested)return!1;if(v.length===0)return!0;const h={edits:[]};for(const l of v){const{edits:o}=L.WorkspaceEdit.from(l);h.edits=h.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(new N.$Bw(h))}}e.$1mc=b}),define(Se[154],De([1,0,13,16,8]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,$,k,A,C,p){this.id=b,this.f=$,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=A,this.c=p}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection($){this.selections=[$]},get selections(){return b.a},set selections($){if(!Array.isArray($)||!$.every(L.$CO.isNotebookRange))throw(0,d.$7)("selections");b.a=$,b.g($)},get visibleRanges(){return b.b},revealRange($,k){b.f.$tryRevealRange(b.id,O.NotebookRange.from($),k??L.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(O.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$Mmc=R}),define(Se[347],De([1,0,4,11,16]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3mc=void 0;let R=class{constructor(b,$){this.c=b,this.d=$,this.a=new d.$de,this.b=new d.$de,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,$);const k=this.d.getEditorById(b);$.visibleRanges&&k._acceptVisibleRanges($.visibleRanges.ranges.map(L.NotebookRange.to)),$.selections&&k._acceptSelections($.selections.selections.map(L.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const $ in b)this.d.getEditorById($)._acceptViewColumn(L.ViewColumn.to(b[$]))}};e.$3mc=R,e.$3mc=R=Ge([We(0,O.$3j)],R)}),define(Se[348],De([1,0,4,6,154]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=void 0;class R{constructor(b,$){this.c=$,this.a=new Map,this.b=b.getProxy(O.$$M.MainThreadNotebookRenderers)}$postRendererMessage(b,$,k){const A=this.c.getEditorById(b);this.a.get($)?.fire({editor:A.apiEditor,message:k})}createRendererMessaging(b,$){if(!b.contributes?.notebookRenderer?.some(A=>A.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(A,C,p)=>this.d($).event(A,C,p),postMessage:(A,C)=>{L.$Mmc.apiEditorsToExtHost.has(A)&&([A,C]=[C,A]);const p=C&&L.$Mmc.apiEditorsToExtHost.get(C);return this.b.$postMessage(p?.id,$,A)}}}d(b){let $=this.a.get(b);return $||($=new d.$de({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(b)}}),this.a.set(b,$),$)}}e.$6mc=R}),define(Se[349],De([1,0,16,109,22,56,13]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=void 0;class b{constructor(C){this.b=0,this.c=new Map,this.a=C}async withProgress(C,p,y){const v=this.b++,{title:h,location:l,cancellable:o}=p,n={label:C.displayName||C.name,id:C.identifier.value};return this.a.$startProgress(v,{location:d.ProgressLocation.from(l),title:h,source:n,cancellable:o},C.isUnderDevelopment?void 0:C.identifier.value).catch(N.$2),this.d(v,y,!!o)}d(C,p,y){let v;y&&(v=new L.$oe,this.c.set(C,v));const h=o=>{this.a.$progressEnd(o),this.c.delete(o),v?.dispose()};let l;try{l=p(new k(this.a,C),y&&v?v.token:L.CancellationToken.None)}catch(o){throw h(C),o}return l.then(o=>h(C),o=>h(C)),l}$acceptProgressCanceled(C){const p=this.c.get(C);p&&(p.cancel(),this.c.delete(C))}}e.$0mc=b;function $(A,C){return A.message=C.message,typeof C.increment=="number"&&(typeof A.increment=="number"?A.increment+=C.increment:A.increment=C.increment),A}class k extends O.$dw{constructor(C,p){super(y=>this.throttledReport(y)),this.c=C,this.d=p}throttledReport(C){this.c.$progressReport(this.d,C)}}Ge([(0,R.$3h)(100,(A,C)=>$(A,C),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(Se[350],De([1,0,2,6,7,16]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=void 0;class N{static{this.a=0}constructor($,k){this.d=k,this.c=new Map,this.b=$.getProxy(O.$$M.MainThreadQuickDiff)}$provideOriginalResource($,k,A){const C=d.URI.revive(k),p=this.c.get($);return p?(0,L.$oh)(()=>p.provideOriginalResource(C,A)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider($,k,A,C){const p=N.a++;return this.c.set(p,k),this.b.$registerQuickDiffProvider(p,R.DocumentSelector.from($,this.d),A,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(p),this.c.delete(p)}}}}e.$$mc=N}),define(Se[351],De([1,0,22,4,3,6,2,8,13,19,41,50,26,16]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=v;function v(h,l,o){const n=h.getProxy(R.$$M.MainThreadQuickOpen);class i{constructor(w,S){this.e=new Map,this.f=0,this.a=w,this.b=S}showQuickPick(w,S,m,E=d.CancellationToken.None){this.c=void 0;const D=Promise.resolve(S),P=++this.f,I=n.$show(P,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},E),F={},T=I.then(()=>F);return Promise.race([T,D]).then(z=>{if(z===F)return;const M=(0,p.$OG)(w,"quickPickItemTooltip");return D.then(j=>{const U=[];for(let Z=0;Z<j.length;Z++){const ie=j[Z];if(typeof ie=="string")U.push({label:ie,handle:Z});else if(ie.kind===b.QuickPickItemKind.Separator)U.push({type:"separator",label:ie.label});else{ie.tooltip&&!M&&console.warn(`Extension '${w.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`);const q=ie.iconPath?r(ie.iconPath):void 0;U.push({label:ie.label,iconPath:q?.iconPath,iconClass:q?.iconClass,description:ie.description,detail:ie.detail,picked:ie.picked,alwaysShow:ie.alwaysShow,tooltip:M?y.MarkdownString.fromStrict(ie.tooltip):void 0,handle:Z})}}return m&&typeof m.onDidSelectItem=="function"&&(this.c=Z=>{m.onDidSelectItem(j[Z])}),n.$setItems(P,U),I.then(Z=>{if(typeof Z=="number")return j[Z];if(Array.isArray(Z))return Z.map(ie=>j[ie])})})}).then(void 0,z=>{if(!(0,$.$4)(z))return n.$setError(P,z),Promise.reject(z)})}$onItemSelected(w){this.c?.(w)}showInput(w,S=d.CancellationToken.None){return this.d=w?.validateInput,n.$input(w,typeof this.d=="function",S).then(void 0,m=>{if(!(0,$.$4)(m))return Promise.reject(m)})}async $validateInput(w){if(!this.d)return;const S=await this.d(w);if(!S||typeof S=="string")return S;let m;switch(S.severity){case b.InputBoxValidationSeverity.Info:m=A.default.Info;break;case b.InputBoxValidationSeverity.Warning:m=A.default.Warning;break;case b.InputBoxValidationSeverity.Error:m=A.default.Error;break;default:m=S.message?A.default.Error:A.default.Ignore;break}return{content:S.message,severity:m}}async showWorkspaceFolderPick(w,S=d.CancellationToken.None){const m=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[w]);if(!m)return;const E=await this.a.getWorkspaceFolders2();if(E)return E.find(D=>D.uri.toString()===m.uri.toString())}createQuickPick(w){const S=new a(w,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(w){const S=new f(w,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(w,S){this.e.get(w)?._fireDidChangeValue(S)}$onDidAccept(w){this.e.get(w)?._fireDidAccept()}$onDidChangeActive(w,S){const m=this.e.get(w);m instanceof a&&m._fireDidChangeActive(S)}$onDidChangeSelection(w,S){const m=this.e.get(w);m instanceof a&&m._fireDidChangeSelection(S)}$onDidTriggerButton(w,S){this.e.get(w)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(w,S,m){const E=this.e.get(w);E instanceof a&&E._fireDidTriggerItemButton(S,m)}$onDidHide(w){this.e.get(w)?._fireDidHide()}}class u{static{this.a=1}constructor(w,S){this.x=w,this.y=S,this._id=a.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$de,this.q=new O.$de,this.r=new O.$de,this.s=new O.$de,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(w){this.b=w,this.z({title:w})}get step(){return this.c}set step(w){this.c=w,this.z({step:w})}get totalSteps(){return this.d}set totalSteps(w){this.d=w,this.z({totalSteps:w})}get enabled(){return this.g}set enabled(w){this.g=w,this.z({enabled:w})}get busy(){return this.j}set busy(w){this.j=w,this.z({busy:w})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(w){this.k=w,this.z({ignoreFocusOut:w})}get value(){return this.l}set value(w){this.l=w,this.z({value:w})}get placeholder(){return this.m}set placeholder(w){this.m=w,this.z({placeholder:w})}get buttons(){return this.n}set buttons(w){this.n=w.slice(),this.o.clear(),w.forEach((S,m)=>{const E=S===b.$zO.Back?-1:m;this.o.set(E,S)}),this.z({buttons:w.map((S,m)=>({...r(S.iconPath),tooltip:S.tooltip,handle:S===b.$zO.Back?-1:m}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(w){this.l=w,this.q.fire(w)}_fireDidTriggerButton(w){const S=this.o.get(w);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,L.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(w){if(!this.v){for(const S of Object.keys(w)){const m=w[S];this.u[S]=m===void 0?null:m}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function s(g){if(g instanceof b.$0N)return{id:g.id};const w=c(g),S=t(g);return{dark:typeof w=="string"?N.URI.file(w):w,light:typeof S=="string"?N.URI.file(S):S}}function t(g){return typeof g=="object"&&"light"in g?g.light:g}function c(g){return typeof g=="object"&&"dark"in g?g.dark:g}function r(g){const w=s(g);let S,m;return"id"in w?m=C.ThemeIcon.asClassName(w):S=w,{iconPath:S,iconClass:m}}class a extends u{constructor(w,S){super(w.identifier,S),this.O=w,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$de,this.L=[],this.M=new O.$de,this.N=new O.$de,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(w){this.B=w.slice(),this.C.clear(),this.D.clear(),w.forEach((E,D)=>{this.C.set(D,E),this.D.set(E,D)});const S=(0,p.$OG)(this.O,"quickPickItemTooltip"),m=[];for(let E=0;E<w.length;E++){const D=w[E];if(D.kind===b.QuickPickItemKind.Separator)m.push({type:"separator",label:D.label});else{D.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=D.iconPath?r(D.iconPath):void 0;m.push({handle:E,label:D.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:D.description,detail:D.detail,picked:D.picked,alwaysShow:D.alwaysShow,tooltip:S?y.MarkdownString.fromStrict(D.tooltip):void 0,buttons:D.buttons?.map((I,F)=>({...r(I.iconPath),tooltip:I.tooltip,handle:F}))})}}this.z({items:m})}get canSelectMany(){return this.E}set canSelectMany(w){this.E=w,this.z({canSelectMany:w})}get matchOnDescription(){return this.F}set matchOnDescription(w){this.F=w,this.z({matchOnDescription:w})}get matchOnDetail(){return this.G}set matchOnDetail(w){this.G=w,this.z({matchOnDetail:w})}get sortByLabel(){return this.H}set sortByLabel(w){this.H=w,this.z({sortByLabel:w})}get keepScrollPosition(){return this.I}set keepScrollPosition(w){this.I=w,this.z({keepScrollPosition:w})}get activeItems(){return this.J}set activeItems(w){this.J=w.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(w){this.L=w.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(w){const S=(0,k.$Hb)(w.map(m=>this.C.get(m)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(w){const S=(0,k.$Hb)(w.map(m=>this.C.get(m)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(w,S){const m=this.C.get(w);if(!m||!m.buttons||!m.buttons.length)return;const E=m.buttons[S];E&&this.N.fire({button:E,item:m})}}class f extends u{constructor(w,S){super(w.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(w){this.B=w,this.z({password:w})}get prompt(){return this.C}set prompt(w){this.C=w,this.z({prompt:w})}get valueSelection(){return this.D}set valueSelection(w){this.D=w,this.z({valueSelection:w})}get validationMessage(){return this.E}set validationMessage(w){this.E=w,w?typeof w=="string"?this.z({validationMessage:w,severity:A.default.Error}):this.z({validationMessage:w.message,severity:w.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new i(l,o)}}),define(Se[352],De([1,0,2,4,56,3,7,6,19,132,11,25,50,16,26,15,12]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$bnc=e.$anc=void 0;function n(P){return P instanceof d.URI}function i(P,I){return P.scheme===h.Schemas.file&&I.scheme===h.Schemas.file&&l.$k?P.toString()===I.toString():P.toString().toLowerCase()===I.toString().toLowerCase()}function u(P){if(P)return typeof P.iconPath=="string"?d.URI.file(P.iconPath):d.URI.isUri(P.iconPath)||p.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function s(P){if(P.icon){if(d.URI.isUri(P.icon))return P.icon;if(p.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const I=P.icon;return{light:I.light,dark:I.dark}}}else return}function t(P,I){if(!P.iconPath&&!I.iconPath)return 0;if(P.iconPath){if(!I.iconPath)return 1}else return-1;const F=typeof P.iconPath=="string"?P.iconPath:d.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,T=typeof I.iconPath=="string"?I.iconPath:d.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id;return(0,k.$qr)(F,T)}function c(P,I){let F=0;if(P.strikeThrough!==I.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==I.faded)return P.faded?1:-1;if(P.tooltip!==I.tooltip)return(P.tooltip||"").localeCompare(I.tooltip||"");if(F=t(P,I),F!==0)return F;if(P.light&&I.light)F=t(P.light,I.light);else{if(P.light)return 1;if(I.light)return-1}if(F!==0)return F;if(P.dark&&I.dark)F=t(P.dark,I.dark);else{if(P.dark)return 1;if(I.dark)return-1}return F}function r(P,I){if(P.command!==I.command)return P.command<I.command?-1:1;if(P.title!==I.title)return P.title<I.title?-1:1;if(P.tooltip!==I.tooltip){if(P.tooltip!==void 0&&I.tooltip!==void 0)return P.tooltip<I.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(I.tooltip!==void 0)return-1}if(P.arguments===I.arguments)return 0;if(P.arguments)if(I.arguments){if(P.arguments.length!==I.arguments.length)return P.arguments.length-I.arguments.length}else return 1;else return-1;for(let F=0;F<P.arguments.length;F++){const T=P.arguments[F],z=I.arguments[F];if(T!==z&&!(n(T)&&n(z)&&i(T,z)))return T<z?-1:1}return 0}function a(P,I){let F=(0,k.$qr)(P.resourceUri.fsPath,I.resourceUri.fsPath,!0);if(F!==0)return F;if(P.command&&I.command)F=r(P.command,I.command);else{if(P.command)return 1;if(I.command)return-1}if(F!==0)return F;if(P.decorations&&I.decorations)F=c(P.decorations,I.decorations);else{if(P.decorations)return 1;if(I.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&I.multiFileDiffEditorModifiedUri)F=(0,k.$qr)(P.multiFileDiffEditorModifiedUri.fsPath,I.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(I.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&I.multiDiffEditorOriginalUri)F=(0,k.$qr)(P.multiDiffEditorOriginalUri.fsPath,I.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(I.multiDiffEditorOriginalUri)return-1}return F}function f(P,I){for(let F=0;F<P.length;F++)if(P[F]!==I[F])return!1;return!0}function g(P,I){return P.command===I.command&&P.title===I.title&&P.tooltip===I.tooltip&&(P.arguments&&I.arguments?f(P.arguments,I.arguments):P.arguments===I.arguments)}function w(P,I){return(0,$.$ub)(P,I,g)}class S{#e;#t;get value(){return this.d}set value(I){I=I??"",this.#e.$setInputBoxValue(this.l,I),this.n(I)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(I){this.#e.$setInputBoxPlaceholder(this.l,I),this.f=I}get validateInput(){return(0,v.$PG)(this.k,"scmValidation"),this.g}set validateInput(I){if((0,v.$PG)(this.k,"scmValidation"),I&&typeof I!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=I,this.#e.$setValidationProviderIsEnabled(this.l,!!I)}get enabled(){return this.h}set enabled(I){I=!!I,this.h!==I&&(this.h=I,this.#e.$setInputBoxEnablement(this.l,I))}get visible(){return this.j}set visible(I){I=!!I,this.j!==I&&(this.j=I,this.#e.$setInputBoxVisibility(this.l,I))}get document(){return(0,v.$PG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(I,F,T,z,M){this.k=I,this.l=z,this.m=M,this.d="",this.e=new O.$de,this.f="",this.h=!0,this.j=!0,this.#t=F,this.#e=T}showValidationMessage(I,F){(0,v.$PG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,I,F)}$onInputBoxValueChange(I){this.n(I)}n(I){this.d=I,this.e.fire(I)}}e.$anc=S;class m{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(I){this.v=I,this.q.$updateGroupLabel(this.t,this.handle,I)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(I){this.p=I,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(I){this.f=[...I],this.k.fire()}constructor(I,F,T,z,M,j,U){this.q=I,this.s=F,this.t=T,this.u=z,this.v=M,this.multiDiffEditorEnableViewChanges=j,this.w=U,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$de,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$de,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=m.d++}getResourceState(I){return this.g.get(I)}$executeResourceCommand(I,F){const T=this.h.get(I);return T?(0,N.$oh)(()=>this.s.executeCommand(T.command,...T.arguments||[],F)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const I=[...this.f].sort(a),T=(0,$.$Db)(this.o,I,a).map(j=>{const U=j.toInsert.map(Z=>{const ie=this.e++;this.g.set(ie,Z);const q=Z.resourceUri;let G;if(Z.command)if(Z.command.command==="vscode.open"||Z.command.command==="vscode.diff"||Z.command.command==="vscode.changes"){const le=new R.$Tc;G=this.s.converter.toInternal(Z.command,le),this.j.set(ie,le)}else this.h.set(ie,Z.command);const x=(0,v.$OG)(this.w,"scmMultiDiffEditor"),ne=x?Z.multiDiffEditorOriginalUri:void 0,be=x?Z.multiFileDiffEditorModifiedUri:void 0,ae=u(Z.decorations),Ce=Z.decorations&&u(Z.decorations.light)||ae,ee=Z.decorations&&u(Z.decorations.dark)||ae,B=[Ce,ee],_=Z.decorations&&Z.decorations.tooltip||"",pe=Z.decorations&&!!Z.decorations.strikeThrough,ue=Z.decorations&&!!Z.decorations.faded,ce=Z.contextValue||"";return{rawResource:[ie,q,B,_,pe,ue,ce,G,ne,be],handle:ie}});return{start:j.start,deleteCount:j.deleteCount,toInsert:U}}),z=T.map(({start:j,deleteCount:U,toInsert:Z})=>[j,U,Z.map(ie=>ie.rawResource)]),M=T.reverse();for(const{start:j,deleteCount:U,toInsert:Z}of M){const ie=Z.map(G=>G.handle),q=this.n.splice(j,U,...ie);for(const G of q)this.g.delete(G),this.h.delete(G),this.j.get(G)?.dispose(),this.j.delete(G)}return this.o=I,z}dispose(){this.l=!0,this.m.fire()}}class E{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(I){this.g!==I&&(this.g=I,this.#e.$updateSourceControl(this.w,{count:I}))}get quickDiffProvider(){return this.h}set quickDiffProvider(I){this.h=I;let F;(0,v.$OG)(this.x,"quickDiffProvider")&&(F=I?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!I,quickDiffLabel:F})}get historyProvider(){return(0,v.$PG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(I){(0,v.$PG)(this.x,"scmHistoryProvider"),this.j=I,this.k.value=new R.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!I}),I&&this.k.value.add(I.onDidChangeCurrentHistoryItemGroup(()=>{this.l=I?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(I){I!==this.m&&(this.m=I,this.#e.$updateSourceControl(this.w,{commitTemplate:I}))}get acceptInputCommand(){return this.o}set acceptInputCommand(I){this.n.value=new R.$Tc,this.o=I;const F=this.y.converter.toInternal(I,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:F})}get actionButton(){return(0,v.$PG)(this.x,"scmActionButton"),this.q}set actionButton(I){(0,v.$PG)(this.x,"scmActionButton"),this.p.value=new R.$Tc,this.q=I;const F=I!==void 0?{command:this.y.converter.toInternal(I.command,this.p.value),secondaryCommands:I.secondaryCommands?.map(T=>T.map(z=>this.y.converter.toInternal(z,this.p.value))),description:I.description,enabled:I.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:F??null})}get statusBarCommands(){return this.t}set statusBarCommands(I){if(this.t&&I&&w(this.t,I))return;this.s.value=new R.$Tc,this.t=I;const F=(I||[]).map(T=>this.y.converter.toInternal(T,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:F})}get selected(){return this.u}constructor(I,F,T,z,M,j,U){this.x=I,this.y=z,this.z=M,this.A=j,this.B=U,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Vc,this.m=void 0,this.n=new R.$Vc,this.o=void 0,this.p=new R.$Vc,this.s=new R.$Vc,this.t=void 0,this.u=!1,this.v=new O.$de,this.onDidChangeSelection=this.v.event,this.w=E.d++,this.C=new Map,this.D=new Set,this.#e=T;const Z=d.URI.from({scheme:h.Schemas.vscodeSourceControl,path:`${M}/scm${this.w}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this.f=new S(I,F,this.#e,this.w,Z),this.#e.$registerSourceControl(this.w,M,j,U,Z)}createResourceGroup(I,F,T){const z=(0,v.$OG)(this.x,"scmMultiDiffEditor")&&T?.multiDiffEditorEnableViewChanges===!0,M=new m(this.#e,this.y,this.w,I,F,z,this.x),j=O.Event.once(M.onDidDispose)(()=>this.C.delete(M));return this.C.set(M,j),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const I=[],F=[];for(const[T,z]of this.C){z.dispose();const M=T.onDidUpdateResourceStates(()=>{this.D.add(T),this.eventuallyUpdateResourceStates()});O.Event.once(T.onDidDispose)(()=>{this.D.delete(T),M.dispose(),this.e.delete(T.handle),this.#e.$unregisterGroup(this.w,T.handle)}),I.push([T.handle,T.id,T.label,T.features,T.multiDiffEditorEnableViewChanges]);const j=T._takeResourceStateSnapshot();j.length>0&&F.push([T.handle,j]),this.e.set(T.handle,T)}this.#e.$registerGroups(this.w,I,F),this.C.clear()}eventuallyUpdateResourceStates(){const I=[];this.D.forEach(F=>{const T=F._takeResourceStateSnapshot();T.length!==0&&I.push([F.handle,T])}),I.length>0&&this.#e.$spliceResourceStates(this.w,I),this.D.clear()}getResourceGroup(I){return this.e.get(I)}setSelectionState(I){this.u=I,this.v.fire(I)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(I=>I.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ge([(0,L.$2h)(100)],E.prototype,"eventuallyAddResourceGroups",null),Ge([(0,L.$2h)(100)],E.prototype,"eventuallyUpdateResourceStates",null);let D=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(I,F,T,z){this.l=F,this.m=T,this.n=z,this.g=new Map,this.h=new C.$Tm,this.j=new O.$de,this.e=I.getProxy(b.$$M.MainThreadSCM),this.f=I.getProxy(b.$$M.MainThreadTelemetry),F.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const j=this.g.get(M.sourceControlHandle);if(!j)return M;const U=j.getResourceGroup(M.groupHandle);return U?U.getResourceState(M.handle):M}else if(M&&M.$mid===4){const j=this.g.get(M.sourceControlHandle);return j?j.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const j=this.g.get(M.handle);return j||M}return M}})}createSourceControl(I,F,T,z){this.n.trace("ExtHostSCM#createSourceControl",I.identifier.value,F,T,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:I.identifier.value});const M=o.d++,j=new E(I,this.m,this.e,this.l,F,T,z);this.g.set(M,j);const U=this.h.get(I.identifier)||[];return U.push(j),this.h.set(I.identifier,U),j}getLastInputBox(I){this.n.trace("ExtHostSCM#getLastInputBox",I.identifier.value);const F=this.h.get(I.identifier),T=F&&F[F.length-1];return T&&T.inputBox}$provideOriginalResource(I,F,T){const z=d.URI.revive(F);this.n.trace("ExtHostSCM#$provideOriginalResource",I,z.toString());const M=this.g.get(I);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,N.$oh)(()=>M.quickDiffProvider.provideOriginalResource(z,T)).then(j=>j||null)}$onInputBoxValueChange(I,F){this.n.trace("ExtHostSCM#$onInputBoxValueChange",I);const T=this.g.get(I);return T&&T.inputBox.$onInputBoxValueChange(F),Promise.resolve(void 0)}$executeResourceCommand(I,F,T,z){this.n.trace("ExtHostSCM#$executeResourceCommand",I,F,T);const M=this.g.get(I);if(!M)return Promise.resolve(void 0);const j=M.getResourceGroup(F);return j?j.$executeResourceCommand(T,z):Promise.resolve(void 0)}$validateInput(I,F,T){this.n.trace("ExtHostSCM#$validateInput",I);const z=this.g.get(I);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,N.$oh)(()=>z.inputBox.validateInput(F,T)).then(M=>{if(!M)return Promise.resolve(void 0);const j=y.MarkdownString.fromStrict(M.message);return j?Promise.resolve([j,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(I){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",I),I!==void 0&&this.g.get(I)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=I,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(I,F,T,z){return await this.g.get(I)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(F,T,z)??void 0}async $provideHistoryItems(I,F,T,z){return(await this.g.get(I)?.historyProvider?.provideHistoryItems(F,T,z))?.map(U=>({...U,icon:s(U)}))??void 0}async $provideHistoryItemSummary(I,F,T,z){const M=this.g.get(I)?.historyProvider;if(typeof M?.provideHistoryItemSummary!="function")return;const j=await M.provideHistoryItemSummary(F,T,z);return j?{...j,icon:s(j)}:void 0}async $provideHistoryItemChanges(I,F,T,z){return await this.g.get(I)?.historyProvider?.provideHistoryItemChanges(F,T,z)??void 0}};e.$bnc=D,e.$bnc=D=o=Ge([We(3,A.$3j)],D)}),define(Se[353],De([1,0,6,16,2]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=void 0;class R{static{this.a=0}constructor(b,$){this.d=$,this.c=new Map,this.b=b.getProxy(d.$$M.MainThreadShare)}async $provideShare(b,$,k){return await this.c.get(b)?.provideShare({selection:O.Range.to($.selection),resourceUri:L.URI.revive($.resourceUri)},k)??void 0}registerShareProvider(b,$){const k=R.a++;return this.c.set(k,$),this.b.$registerShareProvider(k,O.DocumentSelector.from(b,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$cnc=R}),define(Se[354],De([1,0,8,6,230,3,16,18]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fnc=e.$enc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new d.$$N("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.$$N("statusBarItem.warningForeground")]])}#e;#t;constructor(p,y,v,h,l,o=d.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new R.$Tc,this.#e=p,this.#t=y,l&&h){this.c=(0,d.$MN)(h.identifier,l);const i=v.get(this.c);i&&(o=i.alignLeft?d.StatusBarAlignment.Left:d.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String($.a++);this.e=h,this.f=l,this.g=o,this.h=this.u(n)}u(p){if((0,b.$ag)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(p){this.k=p,this.v()}set name(p){this.m=p,this.v()}set tooltip(p){this.l=p,this.v()}set color(p){this.n=p,this.v()}set backgroundColor(p){p&&!$.b.has(p.id)&&(p=void 0),this.o=p,this.v()}set command(p){this.r?.fromApi!==p&&(this.p&&this.q.add(this.p),this.p=new R.$Tc,typeof p=="string"?this.r={fromApi:p,internal:this.#t.toInternal({title:"",command:p},this.p)}:p?this.r={fromApi:p,internal:this.#t.toInternal(p,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(p){this.t=p,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let p;this.e?this.f?p=`${this.e.identifier.value}.${this.f}`:p=this.e.identifier.value:p=this.f;let y;this.m?y=this.m:y=(0,L.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=$.b.get(this.o.id));const h=N.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,p,this.e?.identifier.value,y,this.k,h,this.r?.internal,v,this.o,this.g===d.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$enc=$;class k{constructor(p){this.b=[],this.a=p.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,L.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(p){const y={message:p};return this.b.unshift(y),this.c(),new d.$aN(()=>{const v=this.b.indexOf(y);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(p,y){this.e=new Map,this.a=p.getProxy(O.$$M.MainThreadStatusBar),this.b=y,this.c=new k(this)}$acceptStaticEntries(p){for(const y of p)this.e.set(y.entryId,y)}createStatusBarEntry(p,y,v,h){return new $(this.a,this.b,this.e,p,y,v,h)}setStatusBarMessage(p,y){const v=this.c.setMessage(p);let h;return typeof y=="number"?h=setTimeout(()=>v.dispose(),y):typeof y<"u"&&y.then(()=>v.dispose(),()=>v.dispose()),new d.$aN(()=>{v.dispose(),clearTimeout(h)})}}e.$fnc=A}),define(Se[155],De([1,0,29,145,69,113,89,16,2]),function(he,e,d,O,L,R,N,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OP=e.$NP=e.$MP=e.$LP=void 0;const k=(i,u,s,t)=>{let c=u;return{enumerable:!0,configurable:!1,get(){return c},set(r){if(!s(c,r)){const a=c;c=r,i.listener?.(t(r,a))}}}},A=(i,u)=>i===u,C={range:(i,u)=>i===u?!0:!i||!u?!1:i.isEqual(u),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(i,u)=>!(i.length!==u.length||i.some(s=>!u.find(t=>s.id===t.id)))},p=i=>u=>({op:4,update:i(u)}),y=(i,u)=>({range:(()=>{let s;const t=p(c=>({range:d.$ut.lift(b.Range.from(c))}));return{enumerable:!0,configurable:!1,get(){return s},set(c){i.listener?.({op:6}),C.range(s,c)||(s=c,i.listener?.(t(c)))}}})(),label:k(i,u,C.label,p(s=>({label:s}))),description:k(i,void 0,C.description,p(s=>({description:s}))),sortText:k(i,void 0,C.sortText,p(s=>({sortText:s}))),canResolveChildren:k(i,!1,C.canResolveChildren,s=>({op:2,state:s})),busy:k(i,!1,C.busy,p(s=>({busy:s}))),error:k(i,void 0,C.error,p(s=>({error:b.MarkdownString.fromStrict(s)||null}))),tags:k(i,[],C.tags,(s,t)=>({op:1,new:s.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),v=i=>{const u=L.$WL.fromString(i.extId),s=new l(u.controllerId,u.localId,i.label,$.URI.revive(i.uri)||void 0);return s.range=b.Range.to(i.range||void 0),s.description=i.description||void 0,s.sortText=i.sortText||void 0,s.tags=i.tags.map(t=>b.TestTag.to({id:(0,N.$3L)(t).tagId})),s},h=i=>{let u;for(const s of i.tests){const t=v(s.item);(0,O.$vP)(t).parent=u,u=t}return u};e.$LP=h;class l{constructor(u,s,t,c){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const r=(0,O.$uP)(this,u);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:c,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof o?void 0:r.parent}},children:{value:(0,R.$tP)(r,O.$vP,l),enumerable:!0,writable:!1},...y(r,t)})}}e.$MP=l;class o extends l{constructor(u,s){super(u,u,s,void 0),this._isRoot=!0}}e.$NP=o;class n extends R.$pP{constructor(u,s,t){super({controllerId:u,getDocumentVersion:c=>c&&t.getDocument(c)?.version,getApiFor:O.$vP,getChildren:c=>c.children,root:new o(u,s),toITestItem:b.TestItem.from})}}e.$OP=n}),define(Se[34],De([1,0,18,8,16,24,6,19,11,58,29,51,2,3,5,20,155,21,48,47,40,87,90,30]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n,i,u,s,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZP=e.$YP=e.$XP=e.$WP=e.$VP=e.$UP=void 0;let r=class{#e;#t;#n;constructor(m,E,D){this.b=new Map,this.c=new Map,this.#e=m.getProxy(N.$$M.MainThreadCommands),this.d=E,this.#n=D,this.#t=m.getProxy(N.$$M.MainThreadTelemetry),this.converter=new a(this,P=>{const I=this.c.get(P);return I?.result===g.Void?I:void 0},E),this.f=[{processArgument(P){return(0,k.$6h)(P)}},{processArgument(P){return(0,R.$5n)(P,function(I){if(A.$ut.isIRange(I))return L.Range.to(I);if(C.$tt.isIPosition(I))return L.Position.to(I);if(A.$ut.isIRange(I.range)&&p.URI.isUri(I.uri))return L.location.to(I);if(I instanceof o.$Fe)return I.buffer.buffer;if(!Array.isArray(I))return I})}}]}registerArgumentProcessor(m){this.f.push(m)}registerApiCommand(m){const E=this.registerCommand(!1,m.id,async(...D)=>{const P=m.args.map((F,T)=>{if(!F.validate(D[T]))throw new Error(`Invalid argument '${F.name}' when running '${m.id}', received: ${typeof D[T]=="object"?JSON.stringify(D[T],null,"	"):D[T]} `);return F.convert(D[T])}),I=await this.executeCommand(m.internalId,...P);return m.result.convert(I,D,this.converter)},void 0,{description:m.description,args:m.args,returns:m.result.description});return this.c.set(m.id,m),new O.$aN(()=>{E.dispose(),this.c.delete(m.id)})}registerCommand(m,E,D,P,I,F){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:D,thisArg:P,metadata:I,extension:F}),m&&this.#e.$registerCommand(E),new O.$aN(()=>{this.b.delete(E)&&m&&this.#e.$unregisterCommand(E)})}executeCommand(m,...E){return this.d.trace("ExtHostCommands#executeCommand",m),this.g(m,E,!0)}async g(m,E,D){if(this.b.has(m))return this.#e.$fireCommandActivationEvent(m),this.h(m,E,!1);{let P=!1;const I=(0,R.$5n)(E,function(F){if(F instanceof O.$bN)return L.Position.from(F);if(F instanceof O.$cN)return L.Range.from(F);if(F instanceof O.$mN)return L.location.from(F);if(O.$CO.isNotebookRange(F))return L.NotebookRange.from(F);if(F instanceof ArrayBuffer)return P=!0,o.$Fe.wrap(new Uint8Array(F));if(F instanceof Uint8Array)return P=!0,o.$Fe.wrap(F);if(F instanceof o.$Fe)return P=!0,F;if(!Array.isArray(F))return F});try{const F=await this.#e.$executeCommand(m,P?new n.$Bw(I):I,D);return(0,k.$6h)(F)}catch(F){if(F instanceof Error&&F.message==="$executeCommand:retry")return this.g(m,E,!1);throw F}}}async h(m,E,D){const P=this.b.get(m);if(!P)throw new Error("Unknown command");const{callback:I,thisArg:F,metadata:T}=P;if(T?.args)for(let M=0;M<T.args.length;M++)try{(0,d.$ng)(E[M],T.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${m}' failed. Illegal argument '${T.args[M].name}' - ${T.args[M].description}`)}const z=u.$_d.create();try{return await I.apply(F,E)}catch(M){if(m===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...E);j&&(m=j.command)}if(this.d.error(M,m,P.extension?.identifier),!D)throw M;if(P.extension?.identifier){const j=this.#n.onExtensionError(P.extension.identifier,M);this.d.trace("forwarded error to extension?",j,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$hj)(M)),this.id=m,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,m,z.elapsed())}}j(m,E,D){m.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:m.extension.identifier.value,id:new s.$fp(E),duration:D})}$executeContributedCommand(m,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",m);const D=this.b.get(m);return D?(E=E.map(P=>this.f.reduce((I,F)=>F.processArgument(I,D.extension?.identifier),P)),this.h(m,E,!0)):Promise.reject(new Error(`Contributed command '${m}' does not exist.`))}getCommands(m=!1){return this.d.trace("ExtHostCommands#getCommands",m),this.#e.$getCommands().then(E=>(m&&(E=E.filter(D=>D[0]!=="_")),E))}$getContributedCommandMetadata(){const m=Object.create(null);for(const[E,D]of this.b){const{metadata:P}=D;P&&(m[E]=P)}return Promise.resolve(m)}};e.$UP=r,e.$UP=r=Ge([We(0,h.$zP),We(1,$.$3j),We(2,t.$TP)],r),e.$VP=(0,v.$wi)("IExtHostCommands");class a{constructor(m,E,D){this.d=m,this.f=E,this.g=D,this.delegatingCommandId=`__vsc${(0,c.$Sg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(m,E){if(!m)return;const D={$ident:void 0,id:m.command,title:m.title,tooltip:m.tooltip};if(!m.command)return D;const P=this.f(m.command);if(P)D.id=P.internalId,D.arguments=P.args.map((I,F)=>I.convert(m.arguments&&m.arguments[F]));else if((0,b.$Lb)(m.arguments)){const I=`${m.command} /${++this.c}`;this.b.set(I,m),E.add((0,y.$Sc)(()=>{this.b.delete(I),this.g.trace("CommandsConverter#DISPOSE",I)})),D.$ident=I,D.id=this.delegatingCommandId,D.arguments=[I],this.g.trace("CommandsConverter#CREATE",m.command,I)}return D}fromInternal(m){return typeof m.$ident=="string"?this.b.get(m.$ident):{command:m.id,title:m.title,arguments:m.arguments}}getActualCommand(...m){return this.b.get(m[0])}h(...m){const E=this.getActualCommand(...m);return this.g.trace("CommandsConverter#EXECUTE",m[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${m[0]}`)}}e.$WP=a;class f{static{this.Uri=new f("uri","Uri of a text document",m=>p.URI.isUri(m),m=>m)}static{this.Position=new f("position","A position in a text document",m=>O.$bN.isPosition(m),L.Position.from)}static{this.Range=new f("range","A range in a text document",m=>O.$cN.isRange(m),L.Range.from)}static{this.Selection=new f("selection","A selection in a text document",m=>O.$dN.isSelection(m),L.Selection.from)}static{this.Number=new f("number","",m=>typeof m=="number",m=>m)}static{this.String=new f("string","",m=>typeof m=="string",m=>m)}static{this.StringArray=f.Arr(f.String)}static Arr(m){return new f(`${m.name}_array`,`Array of ${m.name}, ${m.description}`,E=>Array.isArray(E)&&E.every(D=>m.validate(D)),E=>E.map(D=>m.convert(D)))}static{this.CallHierarchyItem=new f("item","A call hierarchy item",m=>m instanceof O.$yN,L.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new f("item","A type hierarchy item",m=>m instanceof O.$WO,L.TypeHierarchyItem.from)}static{this.TestItem=new f("testItem","A VS Code TestItem",m=>m instanceof l.$MP,L.TestItem.from)}constructor(m,E,D,P){this.name=m,this.description=E,this.validate=D,this.convert=P}optional(){return new f(this.name,`(optional) ${this.description}`,m=>m==null||this.validate(m),m=>m===void 0?void 0:m===null?null:this.convert(m))}with(m,E){return new f(m??this.name,E??this.description,this.validate,this.convert)}}e.$XP=f;class g{static{this.Void=new g("no result",m=>m)}constructor(m,E){this.description=m,this.convert=E}}e.$YP=g;class w{constructor(m,E,D,P,I){this.id=m,this.internalId=E,this.description=D,this.args=P,this.result=I}}e.$ZP=w}),define(Se[355],De([1,0,19,15,2,84,135,38,34,16,8]),function(he,e,d,O,L,R,N,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alc=void 0;const C=[new $.$ZP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to an array of DocumentHighlight-instances.",y(k.DocumentHighlight.to))),new $.$ZP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$XP.Uri],new $.$YP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,l)=>{if((0,d.$Kb)(h))return;class o extends A.$tN{static to(i){const u=new o(i.name,k.SymbolKind.to(i.kind),i.containerName||"",new A.$mN(l[0],k.Range.to(i.range)));return u.detail=i.detail,u.range=u.location.range,u.selectionRange=k.Range.to(i.selectionRange),u.children=i.children?i.children.map(o.to):[],u}}return h.map(o.to)})),new $.$ZP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$XP.Uri,new $.$XP("options","Formatting options",h=>!0,h=>h)],new $.$YP("A promise that resolves to an array of TextEdits.",y(k.TextEdit.to))),new $.$ZP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$XP.Uri,$.$XP.Range,new $.$XP("options","Formatting options",h=>!0,h=>h)],new $.$YP("A promise that resolves to an array of TextEdits.",y(k.TextEdit.to))),new $.$ZP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$XP.Uri,$.$XP.Position,new $.$XP("ch","Trigger character",h=>typeof h=="string",h=>h),new $.$XP("options","Formatting options",h=>!0,h=>h)],new $.$YP("A promise that resolves to an array of TextEdits.",y(k.TextEdit.to))),new $.$ZP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$ZP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$ZP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$ZP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$ZP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to an array of Location-instances.",y(k.location.to))),new $.$ZP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to an array of Hover-instances.",y(k.Hover.to))),new $.$ZP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$XP.Uri,new $.$XP("position","A position in a text document",h=>Array.isArray(h)&&h.every(l=>A.$bN.isPosition(l)),h=>h.map(k.Position.from))],new $.$YP("A promise that resolves to an array of ranges.",h=>h.map(l=>{let o;for(const n of l.reverse())o=new A.$xN(k.Range.to(n),o);return o}))),new $.$ZP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$XP.String.with("query","Search string")],new $.$YP("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(k.WorkspaceSymbol.to))),new $.$ZP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to an array of CallHierarchyItem-instances",h=>h.map(k.CallHierarchyItem.to))),new $.$ZP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$XP.CallHierarchyItem],new $.$YP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",h=>h.map(k.CallHierarchyIncomingCall.to))),new $.$ZP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$XP.CallHierarchyItem],new $.$YP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",h=>h.map(k.CallHierarchyOutgoingCall.to))),new $.$ZP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to a range and placeholder text.",h=>{if(h)return{range:k.Range.to(h.range),placeholder:h.text}})),new $.$ZP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$XP.Uri,$.$XP.Position,$.$XP.String.with("newName","The new symbol name")],new $.$YP("A promise that resolves to a WorkspaceEdit.",h=>{if(h){if(h.rejectReason)throw new Error(h.rejectReason);return k.WorkspaceEdit.to(h)}})),new $.$ZP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$XP.Uri,$.$XP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$YP("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(k.DocumentLink.to))),new $.$ZP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$XP.Uri],new $.$YP("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new A.$tO(h.tokenTypes,h.tokenModifiers)})),new $.$ZP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$XP.Uri],new $.$YP("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const l=(0,N.$dcb)(h);if(l.type==="full")return new A.$vO(l.data,void 0)})),new $.$ZP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$XP.Uri,$.$XP.Range.optional()],new $.$YP("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new A.$tO(h.tokenTypes,h.tokenModifiers)})),new $.$ZP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$XP.Uri,$.$XP.Range],new $.$YP("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const l=(0,N.$dcb)(h);if(l.type==="full")return new A.$vO(l.data,void 0)})),new $.$ZP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$XP.Uri,$.$XP.Position,$.$XP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$XP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$YP("A promise that resolves to a CompletionList-instance.",(h,l,o)=>{if(!h)return new A.$JN([]);const n=h.suggestions.map(i=>k.CompletionItem.to(i,o));return new A.$JN(n,h.incomplete)})),new $.$ZP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$XP.Uri,$.$XP.Position,$.$XP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$YP("A promise that resolves to SignatureHelp.",h=>{if(h)return k.SignatureHelp.to(h)})),new $.$ZP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$XP.Uri,$.$XP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$YP("A promise that resolves to an array of CodeLens-instances.",(h,l,o)=>y(n=>new A.$BN(k.Range.to(n.range),n.command&&o.fromInternal(n.command)))(h))),new $.$ZP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$XP.Uri,new $.$XP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>A.$cN.isRange(h),h=>A.$dN.isSelection(h)?k.Selection.from(h):k.Range.from(h)),$.$XP.String.with("kind","Code action kind to return code actions for").optional(),$.$XP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$YP("A promise that resolves to an array of Command-instances.",(h,l,o)=>y(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(n.command)}else{const i=new A.$vN(n.title,n.kind?new A.$wN(n.kind):void 0);return n.edit&&(i.edit=k.WorkspaceEdit.to(n.edit)),n.command&&(i.command=o.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(h))),new $.$ZP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$XP.Uri],new $.$YP("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(l=>new A.$PN(k.Range.to(l.range),k.Color.to(l.color))):[])),new $.$ZP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$XP("color","The color to show and insert",h=>h instanceof A.$ON,k.Color.from),new $.$XP("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:k.Range.from(h.range)}))],new $.$YP("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(k.ColorPresentation.to):[])),new $.$ZP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$XP.Uri,$.$XP.Range],new $.$YP("A promise that resolves to an array of Inlay objects",(h,l,o)=>h.map(k.InlayHint.to.bind(void 0,o)))),new $.$ZP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$XP.Uri],new $.$YP("A promise that resolves to an array of FoldingRange objects",(h,l)=>{if(h)return h.map(k.FoldingRange.to)})),new $.$ZP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$YP("A promise that resolves to an array of NotebookContentProvider static info objects.",y(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(l=>k.NotebookExclusiveDocumentPattern.to(l))})))),new $.$ZP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$XP.Uri,$.$XP.Range,new $.$XP("context","An InlineValueContext",h=>h&&typeof h.frameId=="number"&&h.stoppedLocation instanceof A.$cN,h=>k.InlineValueContext.from(h))],new $.$YP("A promise that resolves to an array of InlineValue objects",h=>h.map(k.InlineValue.to))),new $.$ZP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$XP("uriOrString","Uri-instance or string (only http/https)",h=>L.URI.isUri(h)||typeof h=="string"&&(0,O.$Gg)(h,O.Schemas.http,O.Schemas.https),h=>h),new $.$XP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[k.ViewColumn.from(h),void 0]:[k.ViewColumn.from(h.viewColumn),k.TextEditorOpenOptions.from(h)])).optional(),$.$XP.String.with("label","").optional()],$.$YP.Void),new $.$ZP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$XP.Uri.with("resource","Resource to open"),$.$XP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$XP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[k.ViewColumn.from(h),void 0]:[k.ViewColumn.from(h.viewColumn),k.TextEditorOpenOptions.from(h)])).optional()],$.$YP.Void),new $.$ZP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$XP.Uri.with("left","Left-hand side resource of the diff editor"),$.$XP.Uri.with("right","Right-hand side resource of the diff editor"),$.$XP.String.with("title","Human readable title for the diff editor").optional(),new $.$XP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[k.ViewColumn.from(h.viewColumn),k.TextEditorOpenOptions.from(h)]).optional()],$.$YP.Void),new $.$ZP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$XP.String.with("title","Human readable title for the changes editor"),new $.$XP("resourceList","List of resources to compare",h=>{for(const l of h){if(l.length!==3)return!1;const[o,n,i]=l;if(!L.URI.isUri(o)||!L.URI.isUri(n)&&n!==void 0&&n!==null||!L.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},h=>h)],$.$YP.Void),new $.$ZP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$XP.Uri,$.$XP.Position],new $.$YP("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(k.TypeHierarchyItem.to))),new $.$ZP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$XP.TypeHierarchyItem],new $.$YP("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(k.TypeHierarchyItem.to))),new $.$ZP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$XP.TypeHierarchyItem],new $.$YP("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(k.TypeHierarchyItem.to))),new $.$ZP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$XP.TestItem],$.$YP.Void),new $.$ZP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$XP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$YP.Void),new $.$ZP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$XP.String.with("name","The context key name"),new $.$XP("value","The context key value",()=>!0,h=>h)],$.$YP.Void),new $.$ZP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$XP.Uri,$.$XP.StringArray,new $.$XP("MappedEditsContext","Mapped Edits Context",h=>k.MappedEditsContext.is(h),h=>k.MappedEditsContext.from(h))],new $.$YP("A promise that resolves to a workspace edit or null",h=>h?k.WorkspaceEdit.to(h):null))];class p{static register(l){C.forEach(l.registerApiCommand,l),this.a(l)}static a(l){l.registerCommand(!1,"_validateWhenClauses",b.$vj)}}e.$Alc=p;function y(h){return l=>{if(Array.isArray(l))return l.map(h)}}function v(h){if(!Array.isArray(h))return;const l=[];for(const o of h)R.$_t(o)?l.push(k.DefinitionLink.to(o)):l.push(k.location.to(o));return l}}),define(Se[356],De([1,0,7,3,2,6,34,16,8]),function(he,e,d,O,L,R,N,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=void 0;class k{static{this.a=0}constructor(y,v){this.extension=y,this.provider=v,this.handle=k.a++}}class A{constructor(y){this.session=y,this.responses=[]}}class C{static{this.a=0}constructor(y,v,h,l){this.f=h,this.g=l,this.b=new Map,this.d=new Map,this.e=y.getProxy(R.$$M.MainThreadInlineChat),v.registerApiCommand(new N.$ZP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new N.$XP("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?b.Range.from(o.initialRange):void 0,initialSelection:$.$dN.isSelection(o.initialSelection)?b.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?b.Position.from(o.position):void 0}})],N.$YP.Void))}registerProvider(y,v,h){const l=new k(y,v);return this.b.set(l.handle,l),this.e.$registerInteractiveEditorProvider(l.handle,h?.label??y.displayName??y.name,y.identifier,typeof v.handleInteractiveEditorResponseFeedback=="function",typeof v.provideFollowups=="function",h?.supportReportIssue??!1),(0,O.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(l.handle),this.b.delete(l.handle)})}async $prepareSession(y,v,h,l){const o=this.b.get(y);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(L.URI.revive(v)),i=b.Selection.to(h),u=await o.provider.prepareInteractiveEditorSession({document:n,selection:i},l);if(!u)return;if(u.wholeRange&&!u.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const s=C.a++;return this.d.set(s,new A(u)),{id:s,placeholder:u.placeholder,input:u.input,slashCommands:u.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:b.Range.from(u.wholeRange),message:u.message}}async $provideResponse(y,v,h,l){const o=this.b.get(y);if(!o)return;const n=this.d.get(v.id);if(!n)return;const i={prompt:h.prompt,selection:b.Selection.to(h.selection),wholeRange:b.Range.to(h.wholeRange),attempt:h.attempt,live:h.live,previewDocument:this.f.getDocument(L.URI.revive(h.previewDocument)),withIntentDetection:h.withIntentDetection};let u=!1;const s={report:async S=>{if(!h.live&&S.edits?.length)throw new Error("Progress reporting is only supported for live sessions");u||l.isCancellationRequested||await this.e.$handleProgressChunk(h.requestId,{message:S.message,edits:S.edits?.map(b.TextEdit.from),editsShouldBeInstant:S.editsShouldBeInstant,slashCommand:S.slashCommand?.command,markdownFragment:$.$CN.isMarkdownString(S.content)?S.content.value:S.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(n.session,i,s,l));let c;try{c=await(0,d.$kh)(t,l)}finally{u=!0}if(!c)return;const r=n.responses.push(c)-1,a={wholeRange:b.Range.from(c.wholeRange),placeholder:c.placeholder};if(!C.h(c))return{...a,id:r,type:"editorEdit",message:b.MarkdownString.from(c.contents),edits:[]};const{edits:f,contents:g}=c,w=g!==void 0?b.MarkdownString.from(g):void 0;return f instanceof $.$kN?{...a,id:r,type:"bulkEdit",edits:b.WorkspaceEdit.from(f),message:w}:{...a,id:r,type:"editorEdit",edits:f.map(b.TextEdit.from),message:w}}async $provideFollowups(y,v,h,l){const o=this.b.get(y),n=this.d.get(v),i=n?.responses[h];if(o&&i&&o.provider.provideFollowups){const u=Promise.resolve(o.provider.provideFollowups(n.session,i,l));return(await(0,d.$kh)(u,l))?.map(b.ChatInlineFollowup.from)}}$handleFeedback(y,v,h,l){const o=this.b.get(y),n=this.d.get(v),i=n?.responses[h];if(o&&i){const u=b.InteractiveEditorResponseFeedbackKind.to(l);o.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,u)}}$releaseSession(y,v){}static h(y){return typeof y=="object"&&typeof y.edits=="object"}}e.$Jmc=C}),define(Se[357],De([1,0,2,34]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wmc=void 0;class L{constructor(N,b,$,k,A){this.a=b,this.b=$,this.c=k;const C=new O.$ZP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$XP("showOptions","Show Options",p=>!0,p=>p),new O.$XP("resource","Interactive resource Uri",p=>!0,p=>p),new O.$XP("controllerId","Notebook controller Id",p=>!0,p=>p),new O.$XP("title","Interactive editor title",p=>!0,p=>p)],new O.$YP("Notebook and input URI",p=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const y=this.a.getEditorById(p.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:d.URI.revive(p.notebookUri),inputUri:d.URI.revive(p.inputUri),notebookEditor:y.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:d.URI.revive(p.notebookUri),inputUri:d.URI.revive(p.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(N,b,$,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:$,uri:N,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(N,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[N]})}}e.$Wmc=L}),define(Se[358],De([1,0,19,7,22,4,3,27,2,25,11,6,34,16,8,114,302,26,48,303]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=void 0,e.$5mc=f;let u=class{constructor(w,S,m,E,D){this.m=S,this.n=m,this.o=E,this.q=D,this.b=new b.$Ac,this.c=new b.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$de,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=w.getProxy(C.$$M.MainThreadNotebookKernels);const P=new p.$ZP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$XP("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const T=this.n.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:T}}else if(F&&"notebookEditor"in F){const T=this.n.getIdByEditor(F.notebookEditor);if(T===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:T}}return F})],p.$YP.Void),I=new p.$ZP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[p.$XP.Uri],new p.$YP("A promise that resolves to an array of variables",(F,T)=>F.map(z=>({variable:{name:z.name,value:z.value,expression:z.expression,type:z.type,language:z.language},hasNamedChildren:z.hasNamedChildren,indexedChildrenCount:z.indexedChildrenCount}))));this.o.registerApiCommand(P),this.o.registerApiCommand(I)}createNotebookController(w,S,m,E,D,P){for(const ae of this.j.values())if(ae.controller.id===S&&k.$Rm.equals(w.identifier,ae.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const I=this.k++,F=this;this.q.trace(`NotebookController[${I}], CREATED by ${w.identifier.value}, ${S}`);const T=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${w.identifier}'`);let z=!1;const M=new R.$de,j=new R.$de,U={id:f(w.identifier,S),notebookType:m,extensionId:w.identifier,extensionLocation:w.extensionLocation,label:E||w.identifier.value,preloads:P?P.map(y.NotebookRendererScript.from):[]};let Z=D??T,ie,q;this.a.$addKernel(I,U).catch(ae=>{console.log(ae),z=!0});let G=0;const x=()=>{if(z)return;const ae=++G;Promise.resolve().then(()=>{ae===G&&this.a.$updateKernel(I,U)})},ne=new b.$Ac,be={get id(){return S},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return U.label},set label(ae){U.label=ae??w.displayName??w.name,x()},get detail(){return U.detail??""},set detail(ae){U.detail=ae,x()},get description(){return U.description??""},set description(ae){U.description=ae,x()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(ae){U.supportedLanguages=ae,x()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){U.supportsExecutionOrder=ae,x()},get rendererScripts(){return U.preloads?U.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(ae){Z=ae??T},get interruptHandler(){return ie},set interruptHandler(ae){ie=ae,U.supportsInterrupt=!!ae,x()},set variableProvider(ae){(0,o.$PG)(w,"notebookVariableProvider"),q=ae,U.hasVariableProvider=!!ae,ae?.onDidChangeVariables(Ce=>F.a.$variablesUpdated(Ce.uri)),x()},get variableProvider(){return q},createNotebookCellExecution(ae){if(z)throw new Error("notebook controller is DISPOSED");if(!ne.has(ae.notebook.uri))throw F.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return F._createNotebookCellExecution(ae,f(w.identifier,this.id))},createNotebookExecution(ae){if((0,o.$PG)(w,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!ne.has(ae.uri))throw F.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return F._createNotebookExecution(ae,f(w.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${I}], DISPOSED`),z=!0,this.j.delete(I),M.dispose(),j.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity(ae,Ce){Ce===v.NotebookControllerAffinity2.Hidden&&(0,o.$PG)(w,"notebookControllerAffinityHidden"),F.a.$updateNotebookPriority(I,ae.uri,Ce)},onDidReceiveMessage:j.event,postMessage(ae,Ce){return(0,o.$PG)(w,"notebookMessaging"),F.a.$postMessage(I,Ce&&F.n.getIdByEditor(Ce),ae)},asWebviewUri(ae){return(0,o.$PG)(w,"notebookMessaging"),(0,h.$NAb)(ae,F.m.remote)}};return this.j.set(I,{extensionId:w.identifier,controller:be,onDidReceiveMessage:j,onDidChangeSelection:M,associatedNotebooks:ne}),be}getIdByController(w){for(const[S,m]of this.j)if(m.controller===w)return f(m.extensionId,w.id);return null}createNotebookControllerDetectionTask(w,S){const m=this.g++,E=this;this.q.trace(`NotebookControllerDetectionTask[${m}], CREATED by ${w.identifier.value}`),this.a.$addKernelDetectionTask(m,S);const D={dispose:()=>{this.f.delete(m),E.a.$removeKernelDetectionTask(m)}};return this.f.set(m,D),D}registerKernelSourceActionProvider(w,S,m){const E=this.i++,D=typeof m.onDidChangeNotebookKernelSourceActions=="function"?E:void 0,P=this;this.h.set(E,m),this.q.trace(`NotebookKernelSourceActionProvider[${E}], CREATED by ${w.identifier.value}`),this.a.$addKernelSourceActionProvider(E,E,S);let I;return D!==void 0&&(I=m.onDidChangeNotebookKernelSourceActions(F=>this.a.$emitNotebookKernelSourceActionsChangeEvent(D))),{dispose:()=>{this.h.delete(E),P.a.$removeKernelSourceActionProvider(E,E),I?.dispose()}}}async $provideKernelSourceActions(w,S){const m=this.h.get(w);if(m){const E=new N.$Tc;return(await m.provideNotebookKernelSourceActions(S)??[]).map(P=>y.NotebookKernelSourceAction.from(P,this.o.converter,E))}return[]}$acceptNotebookAssociation(w,S,m){const E=this.j.get(w);if(E){const D=this.n.getNotebookDocument($.URI.revive(S));m?E.associatedNotebooks.set(D.uri,!0):E.associatedNotebooks.delete(D.uri),this.q.trace(`NotebookController[${w}] ASSOCIATE notebook`,D.uri.toString(),m),E.onDidChangeSelection.fire({selected:m,notebook:D.apiNotebook})}}async $executeCells(w,S,m){const E=this.j.get(w);if(!E)return;const D=this.n.getNotebookDocument($.URI.revive(S)),P=[];for(const I of m){const F=D.getCell(I);F&&P.push(F.apiCell)}try{this.q.trace(`NotebookController[${w}] EXECUTE cells`,D.uri.toString(),P.length),await E.controller.executeHandler.call(E.controller,P,D.apiNotebook,E.controller)}catch(I){this.q.error(`NotebookController[${w}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(w,S,m){const E=this.j.get(w);if(!E)return;const D=this.n.getNotebookDocument($.URI.revive(S));if(E.controller.interruptHandler)await E.controller.interruptHandler.call(E.controller,D.apiNotebook);else for(const P of m){const I=D.getCell(P);I&&this.b.get(I.uri)?.cancel()}if(E.controller.interruptHandler){const P=this.c.get(D.uri);this.c.delete(D.uri),m.length&&Array.isArray(P)&&P.length&&P.forEach(I=>I.dispose())}}async $provideVariables(w,S,m,E,D,P,I){const F=this.j.get(w);if(!F)return;const T=this.n.getNotebookDocument($.URI.revive(m)),z=F.controller.variableProvider;if(!z)return;let M;if(E!==void 0){if(M=this.s[E],!M)return}else this.s={};const j=D==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,U=z.provideVariables(T.apiNotebook,M,j,P,I);let Z=0;for await(const ie of U){if(I.isCancellationRequested)return;const q={id:this.r++,name:ie.variable.name,value:ie.variable.value,type:ie.variable.type,interfaces:ie.variable.interfaces,language:ie.variable.language,expression:ie.variable.expression,hasNamedChildren:ie.hasNamedChildren,indexedChildrenCount:ie.indexedChildrenCount,extensionId:F.extensionId.value};if(this.s[q.id]=ie.variable,this.a.$receiveVariable(S,q),Z++>=i.$hjb)return}}$acceptKernelMessageFromRenderer(w,S,m){const E=this.j.get(w);if(!E)return;const D=this.n.getEditorById(S);E.onDidReceiveMessage.fire(Object.freeze({editor:D.apiEditor,message:m}))}$cellExecutionChanged(w,S,m){const D=this.n.getNotebookDocument($.URI.revive(w)).getCell(S);if(D){const P=m?y.NotebookCellExecutionState.to(m):v.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:D.apiCell,state:P})}}_createNotebookCellExecution(w,S){if(w.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const E=this.n.getNotebookDocument(w.notebook.uri).getCellFromApiCell(w);if(!E)throw new Error("invalid cell");if(this.b.has(E.uri))throw new Error(`duplicate execution for ${E.uri}`);const D=new t(S,E,this.a);this.b.set(E.uri,D);const P=D.onDidChangeState(()=>{D.state===s.Resolved&&(D.dispose(),P.dispose(),this.b.delete(E.uri))});return D.asApiObject()}_createNotebookExecution(w,S){const m=this.n.getNotebookDocument(w.uri),E=w.getCells().find(I=>{const F=m.getCellFromApiCell(I);return F&&this.b.has(F.uri)});if(E)throw new Error(`duplicate cell execution for ${E.document.uri}`);if(this.c.has(m.uri))throw new Error(`duplicate notebook execution for ${m.uri}`);const D=new r(S,m,this.a),P=D.onDidChangeState(()=>{D.state===c.Resolved&&(D.dispose(),P.dispose(),this.c.delete(m.uri))});return this.c.set(m.uri,[D,P]),D.asApiObject()}};e.$4mc=u,e.$4mc=u=Ge([We(4,A.$3j)],u);var s;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(s||(s={}));class t extends N.$Uc{static{this.a=0}get state(){return this.f}constructor(w,S,m){super(),this.m=S,this.n=m,this.b=t.a++,this.c=new R.$de,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new L.$oe),this.h=new a(10,E=>this.s(E)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,w,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(w){await this.h.addItem(w)}async s(w){const S=Array.isArray(w)?w:[w];return this.n.$updateExecution(this.b,new n.$Bw(S))}t(){if(this.f===s.Init)throw new Error("Must call start before modifying cell output");if(this.f===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(w){let S=this.m;if(w&&(S=this.m.notebook.getCellFromApiCell(w)),!S)throw new Error("INVALID cell");return S.handle}y(w){return w.map(S=>{const m=v.$GO.ensureUniqueMimeTypes(S.items,!0);return m===S.items?y.NotebookCellOutput.from(S):y.NotebookCellOutput.from({items:m,id:S.id,metadata:S.metadata})})}async z(w,S,m){const E=this.w(S),D=this.y((0,d.$2b)(w));return this.r({editType:l.CellExecutionUpdateType.Output,cellHandle:E,append:m,outputs:D})}async C(w,S,m){return w=v.$GO.ensureUniqueMimeTypes((0,d.$2b)(w),!0),this.r({editType:l.CellExecutionUpdateType.OutputItems,items:w.map(y.NotebookCellOutputItem.from),outputId:S.id,append:m})}asApiObject(){const w=this;return Object.freeze({get token(){return w.g.token},get cell(){return w.m.apiCell},get executionOrder(){return w.j},set executionOrder(m){w.j=m,w.s([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:w.j}])},start(m){if(w.f===s.Resolved||w.f===s.Started)throw new Error("Cannot call start again");w.f=s.Started,w.c.fire(),w.s({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:m})},end(m,E,D){if(w.f===s.Resolved)throw new Error("Cannot call resolve twice");w.f=s.Resolved,w.c.fire(),w.h.flush();const P=D?{message:D.message,stack:D.stack,location:D?.location?{startLineNumber:D.location.start.line,startColumn:D.location.start.character,endLineNumber:D.location.end.line,endColumn:D.location.end.character}:void 0,uri:D.uri}:void 0;w.n.$completeExecution(w.b,new n.$Bw({runEndTime:E,lastRunSuccess:m,error:P}))},clearOutput(m){return w.t(),w.z([],m,!1)},appendOutput(m,E){return w.t(),w.z(m,E,!0)},replaceOutput(m,E){return w.t(),w.z(m,E,!1)},appendOutputItems(m,E){return w.t(),w.C(m,E,!0)},replaceOutputItems(m,E){return w.t(),w.C(m,E,!1)}})}}var c;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(c||(c={}));class r extends N.$Uc{static{this.a=0}get state(){return this.f}constructor(w,S,m){super(),this.h=S,this.j=m,this.b=r.a++,this.c=new R.$de,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new L.$oe),this.j.$createNotebookExecution(this.b,w,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===c.Resolved||this.f===c.Started)throw new Error("Cannot call start again");this.f=c.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===c.Resolved)throw new Error("Cannot call resolve twice");this.f=c.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class a{constructor(w,S){this.f=w,this.g=S,this.a=[],this.b=Date.now()}addItem(w){return this.a.push(w),this.c||(this.c=new O.$Th,this.b=Date.now(),(0,O.$xh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const w=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>w.complete())}}function f(g,w){return`${g.value}/${w}`}}),define(Se[43],De([1,0,4,6,5,2,20,3,8,232,13,279,22,30,280,50,7,16,34]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmc=e.$emc=e.$dmc=e.$cmc=void 0,e.$cmc=(0,L.$wi)("IExtHostTerminalService");class i extends b.$Uc{constructor(m,E,D,P){super(),this.u=m,this._id=E,this.w=D,this.y=P,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new d.$de),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(F=>this.g=F);const I=this;this.value={get name(){return I.y||""},get processId(){return I.b},get creationOptions(){return I.w},get exitStatus(){return I.j},get state(){return I.m},get selection(){return I.n},get shellIntegration(){return I.shellIntegration},sendText(F,T=!0){I.C(),I.u.$sendText(I._id,F,T)},show(F){I.C(),I.u.$show(I._id,F)},hide(){I.C(),I.u.$hide(I._id)},dispose(){I.a||(I.a=!0,I.u.$dispose(I._id))},get dimensions(){if(!(I.f===void 0||I.h===void 0))return{columns:I.f,rows:I.h}}}}dispose(){this.s.fire(),super.dispose()}async create(m,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:m.name,shellPath:m.shellPath??void 0,shellArgs:m.shellArgs??void 0,cwd:m.cwd??E?.cwd??void 0,env:m.env??void 0,icon:f(m.iconPath)??void 0,color:h.ThemeColor.isThemeColor(m.color)?m.color.id:void 0,initialText:m.message??void 0,strictEnv:m.strictEnv??void 0,hideFromUser:m.hideFromUser??void 0,forceShellIntegration:E?.forceShellIntegration??void 0,isFeatureTerminal:E?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:E?.useShellEnvironment??void 0,location:E?.location||this.z(m.location,E?.resolvedExtHostIdentifier),isTransient:m.isTransient??void 0})}async createExtensionTerminal(m,E,D,P,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:P,color:h.ThemeColor.isThemeColor(I)?I.id:void 0,location:E?.location||this.z(m,D),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(m,E){return typeof m=="object"?"parentTerminal"in m&&m.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in m?{viewColumn:o.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus}:void 0:m}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(m){this.y=m}setExitStatus(m,E){this.j=Object.freeze({code:m,reason:E})}setDimensions(m,E){return m===this.f&&E===this.h||m===0||E===0?!1:(this.f=m,this.h=E,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(m){this.n=m}_setProcessId(m){this.g?(this.g(m),this.g=void 0):this.b.then(E=>{E!==m&&(this.b=Promise.resolve(m))})}}e.$dmc=i;class u{get onProcessReady(){return this.b.event}constructor(m){this.g=m,this.id=0,this.shouldPersist=!1,this.a=new d.$de,this.onProcessData=this.a.event,this.b=new d.$de,this.d=new d.$de,this.onDidChangeProperty=this.d.event,this.f=new d.$de,this.onProcessExit=this.f.event}refreshProperty(m){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${m}`)}updateProperty(m,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${m}, value: ${E}`)}async start(){}shutdown(){this.g.close()}input(m){this.g.handleInput?.(m)}resize(m,E){this.g.setDimensions?.({columns:m,rows:E})}clearBuffer(){}async processBinary(m){}acknowledgeDataEvent(m){}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(m){this.g.onDidWrite(E=>this.a.fire(E)),this.g.onDidClose?.((E=void 0)=>{this.f.fire(E===void 0?void 0:E)}),this.g.onDidOverrideDimensions?.(E=>{E&&this.d.fire({type:"overrideDimensions",value:{cols:E.columns,rows:E.rows}})}),this.g.onDidChangeName?.(E=>{this.d.fire({type:"title",value:E})}),this.g.open(m||void 0),m&&this.g.setDimensions?.(m),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,t=class extends b.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(m=>m.value)}constructor(m,E,D){super(),this.Q=E,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new d.$de,this.onDidCloseTerminal=this.H.event,this.I=new d.$de,this.onDidOpenTerminal=this.I.event,this.J=new d.$de,this.onDidChangeActiveTerminal=this.J.event,this.L=new d.$de,this.onDidChangeTerminalDimensions=this.L.event,this.M=new d.$de,this.onDidChangeTerminalState=this.M.event,this.N=new d.$de,this.onDidChangeShell=this.N.event,this.O=new d.$de({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new d.$de({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=D.getProxy(O.$$M.MainThreadTerminalService),this.y=new v.$Fvb(this.a.$sendProcessData),this.a.$registerProcessSupport(m),this.Q.registerArgumentProcessor({processArgument:P=>{const I=F=>{const T=F;return this.getTerminalById(T.instanceId)?.value};switch(P?.$mid){case 15:return I(P);default:{if(Array.isArray(P))for(let F=0;F<P.length&&P[F].$mid===15;F++)P[F]=I(P[F]);return P}}}}),this.B({dispose:()=>{for(const[P,I]of this.g)I.shutdown(!0)}})}getDefaultShell(m){return(m?this.u:this.s)?.path||""}getDefaultShellArgs(m){return(m?this.u:this.s)?.args||[]}createExtensionTerminal(m,E){const D=new i(this.a,(0,y.$Sg)(),m,m.name),P=new u(m.pty);return D.createExtensionTerminal(m.location,E,this.R(m,E).resolvedExtHostIdentifier,f(m.iconPath),g(m.color)).then(I=>{const F=this.S(I,P);this.h[I]=F}),this.f.push(D),D.value}R(m,E){if(E=E||{},m.location&&typeof m.location=="object"&&"parentTerminal"in m.location){const D=m.location.parentTerminal;if(D){const P=this.f.find(I=>I.value===D);P&&(E.resolvedExtHostIdentifier=P._id)}}else m.location&&typeof m.location!="object"?E.location=m.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(m,E){if(!this.getTerminalById(m))throw new Error(`Cannot resolve terminal with id ${m} for virtual process`);const P=new u(E),I=this.S(m,P);this.h[m]=I}async $acceptActiveTerminalChanged(m){const E=this.b;if(m===null){this.b=void 0,E!==this.b&&this.J.fire(this.b);return}const D=this.getTerminalById(m);D&&(this.b=D,E!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(m,E){const D=this.getTerminalById(m);D&&this.O.fire({terminal:D.value,data:E})}async $acceptTerminalDimensions(m,E,D){const P=this.getTerminalById(m);P&&P.setDimensions(E,D)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(m,E){const D=this.getTerminalById(m);D&&this.P.fire({terminal:D.value,...E})}async $acceptTerminalMaximumDimensions(m,E,D){this.g.get(m)?.resize(E,D)}async $acceptTerminalTitleChange(m,E){const D=this.getTerminalById(m);D&&(D.name=E)}async $acceptTerminalClosed(m,E,D){const P=this.X(this.f,m);if(P!==null){const I=this.f.splice(P,1)[0];I.setExitStatus(E,D),this.H.fire(I.value)}}$acceptTerminalOpened(m,E,D,P){if(E){const T=this.X(this.f,E);if(T!==null){this.f[T]._id=m,this.I.fire(this.terminals[T]),this.f[T].isOpen=!0;return}}const I={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:R.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},F=new i(this.a,m,I,D);this.f.push(F),this.I.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId(m,E){this.getTerminalById(m)?._setProcessId(E)}async $startExtensionTerminal(m,E){const D=this.getTerminalById(m);if(!D)return{message:(0,k.localize)(0,null,m)};D.isOpen||await new Promise(I=>{const F=this.onDidOpenTerminal(async T=>{T===D.value&&(F.dispose(),I())})});const P=this.g.get(m);P?P.startSendingEvents(E):this.j[m]={initialDimensions:E}}S(m,E){const D=new b.$Tc;D.add(E.onProcessReady(I=>this.a.$sendProcessReady(m,I.pid,I.cwd,I.windowsPty))),D.add(E.onDidChangeProperty(I=>this.a.$sendProcessProperty(m,I))),this.y.startBuffering(m,E.onProcessData),D.add(E.onProcessExit(I=>this.U(m,I))),this.g.set(m,E);const P=this.j[m];return P&&E instanceof u&&(E.startSendingEvents(P.initialDimensions),delete this.j[m]),D}$acceptProcessAckDataEvent(m,E){this.g.get(m)?.acknowledgeDataEvent(E)}$acceptProcessInput(m,E){this.g.get(m)?.input(E)}$acceptTerminalInteraction(m){const E=this.getTerminalById(m);E?.setInteractedWith()&&this.M.fire(E.value)}$acceptTerminalSelection(m,E){this.getTerminalById(m)?.setSelection(E)}$acceptProcessResize(m,E,D){try{this.g.get(m)?.resize(E,D)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(m,E){this.g.get(m)?.shutdown(E)}$acceptProcessRequestInitialCwd(m){this.g.get(m)?.getInitialCwd().then(E=>this.a.$sendProcessProperty(m,{type:"initialCwd",value:E}))}$acceptProcessRequestCwd(m){this.g.get(m)?.getCwd().then(E=>this.a.$sendProcessProperty(m,{type:"cwd",value:E}))}$acceptProcessRequestLatency(m){return Promise.resolve(m)}registerLinkProvider(m){return this.z.add(m),this.z.size===1&&this.a.$startLinkProvider(),new $.$aN(()=>{this.z.delete(m),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(m,E,D){if(this.C.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this.C.set(E,D),this.a.$registerProfileProvider(E,m.identifier.value),new $.$aN(()=>{this.C.delete(E),this.a.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(m,E,D){if(this.D.has(m))throw new Error(`Terminal quick fix provider "${m}" is already registered`);return this.D.set(m,D),this.a.$registerQuickFixProvider(m,E),new $.$aN(()=>{this.D.delete(m),this.a.$unregisterQuickFixProvider(m)})}async $provideTerminalQuickFixes(m,E){const D=new p.$oe().token;if(D.isCancellationRequested)return;const P=this.D.get(m);if(!P)return;const I=await P.provideTerminalQuickFixes(E,D);if(I===null||Array.isArray(I)&&I.length===0)return;const F=new b.$Tc;if(this.w.value=F,!Array.isArray(I))return I?o.TerminalQuickFix.from(I,this.Q.converter,F):void 0;const T=[];for(const z of I){const M=o.TerminalQuickFix.from(z,this.Q.converter,F);M&&T.push(M)}return T}async $createContributedProfileTerminal(m,E){const D=new p.$oe().token;let P=await this.C.get(m)?.provideTerminalProfile(D);if(!D.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${m}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,E);return}this.createTerminalFromOptions(P.options,E)}}async $provideLinks(m,E){const D=this.getTerminalById(m);if(!D)return[];this.F.delete(m),this.G.get(m)?.dispose(!0);const I=new p.$oe;this.G.set(m,I);const F=[],T={terminal:D.value,line:E},z=[];for(const U of this.z)z.push(l.Promises.withAsyncBody(async Z=>{I.token.onCancellationRequested(()=>Z({provider:U,links:[]}));const ie=await U.provideTerminalLinks(T,I.token)||[];I.token.isCancellationRequested||Z({provider:U,links:ie})}));const M=await Promise.all(z);if(I.token.isCancellationRequested)return[];const j=new Map;for(const U of M)U&&U.links.length>0&&F.push(...U.links.map(Z=>{const ie={id:s++,startIndex:Z.startIndex,length:Z.length,label:Z.tooltip};return j.set(ie.id,{provider:U.provider,link:Z}),ie}));return this.F.set(m,j),F}$activateLink(m,E){const D=this.F.get(m)?.get(E);D&&D.provider.handleTerminalLink(D.link)}U(m,E){this.y.stopBuffering(m),this.g.delete(m),delete this.j[m];const D=this.h[m];D&&(D.dispose(),delete this.h[m]),this.a.$sendProcessExit(m,E)}getTerminalById(m){return this.W(this.f,m)}getTerminalIdByApiObject(m){const E=this.f.findIndex(D=>D.value===m);return E>=0?E:null}W(m,E){const D=this.X(m,E);return D!==null?m[D]:null}X(m,E){const D=m.findIndex(P=>P._id===E);return D>=0?D:null}getEnvironmentVariableCollection(m){let E=this.n.get(m.identifier.value);return E||(E=new c,this.Z(m.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}Y(m,E){const D=(0,C.$ls)(E.map),P=(0,C.$ms)(E.descriptionMap);this.a.$setEnvironmentVariableCollection(m,E.persistent,D.length===0?void 0:D,P)}$initEnvironmentVariableCollections(m){m.forEach(E=>{const D=E[0],P=new c(E[1]);this.Z(D,P)})}$acceptDefaultProfile(m,E){const D=this.s;this.s=m,this.u=E,D?.path!==m.path&&this.N.fire(m.path)}Z(m,E){this.n.set(m,E),E.onDidChangeCollection(()=>{this.Y(m,E)})}};e.$emc=t,e.$emc=t=Ge([We(1,n.$VP),We(2,N.$zP)],t);class c{get persistent(){return this.b}set persistent(m){this.b=m,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(m){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new d.$de,this.map=new Map(m)}getScopedEnvironmentVariableCollection(m){const E=this.h(m);let D=this.a.get(E);return D||(D=new r(this,m),this.a.set(E,D),D.onDidChangeCollection(()=>this.d.fire())),D}replace(m,E,D,P){this.f(m,{value:E,type:$.EnvironmentVariableMutatorType.Replace,options:D??{applyAtProcessCreation:!0},scope:P})}append(m,E,D,P){this.f(m,{value:E,type:$.EnvironmentVariableMutatorType.Append,options:D??{applyAtProcessCreation:!0},scope:P})}prepend(m,E,D,P){this.f(m,{value:E,type:$.EnvironmentVariableMutatorType.Prepend,options:D??{applyAtProcessCreation:!0},scope:P})}f(m,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const D=this.g(m,E.scope),P=this.map.get(D),I=E.options?{applyAtProcessCreation:E.options.applyAtProcessCreation??!1,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==E.value||P.type!==E.type||P.options?.applyAtProcessCreation!==I.applyAtProcessCreation||P.options?.applyAtShellIntegration!==I.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const F=this.g(m,E.scope),T={variable:m,...E,options:I};this.map.set(F,T),this.d.fire()}}get(m,E){const D=this.g(m,E),P=this.map.get(D);return P?w(P):void 0}g(m,E){const D=this.h(E);return D.length?`${m}:::${D}`:m}h(m){return this.j(m?.workspaceFolder)??""}j(m){return m?m.uri.toString():void 0}getVariableMap(m){const E=new Map;for(const[D,P]of this.map)this.h(P.scope)===this.h(m)&&E.set(P.variable,w(P));return E}delete(m,E){const D=this.g(m,E);this.map.delete(D),this.d.fire()}clear(m){if(m?.workspaceFolder){for(const[E,D]of this.map)D.scope?.workspaceFolder?.index===m.workspaceFolder.index&&this.map.delete(E);this.k(m)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(m,E){const D=this.h(E),P=this.descriptionMap.get(D);if(!P||P.description!==m){let I;typeof m=="string"?I=m:I=m?.value.split(`

`)[0];const F={description:I,scope:E};this.descriptionMap.set(D,F),this.d.fire()}}getDescription(m){const E=this.h(m);return this.descriptionMap.get(E)?.description}k(m){const E=this.h(m);this.descriptionMap.delete(E)}}class r{get persistent(){return this.b.persistent}set persistent(m){this.b.persistent=m}get onDidChangeCollection(){return this.a&&this.a.event}constructor(m,E){this.b=m,this.d=E,this.a=new d.$de}getScoped(m){return this.b.getScopedEnvironmentVariableCollection(m)}replace(m,E,D){this.b.replace(m,E,D,this.d)}append(m,E,D){this.b.append(m,E,D,this.d)}prepend(m,E,D){this.b.prepend(m,E,D,this.d)}get(m){return this.b.get(m,this.d)}forEach(m,E){this.b.getVariableMap(this.d).forEach((D,P)=>m.call(E,P,D,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(m){this.b.delete(m,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(m){this.b.setDescription(m,this.d)}get description(){return this.b.getDescription(this.d)}}let a=class extends t{constructor(m,E){super(!1,m,E)}createTerminal(m,E,D){throw new A.$_}createTerminalFromOptions(m,E){throw new A.$_}};e.$fmc=a,e.$fmc=a=Ge([We(0,n.$VP),We(1,N.$zP)],a);function f(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function g(S){return h.ThemeColor.isThemeColor(S)?S:void 0}function w(S){const m={...S};return delete m.scope,m.options=m.options??void 0,delete m.variable,m}}),define(Se[156],De([1,0,8,3,5,6,20,43,4,2,7]),function(he,e,d,O,L,R,N,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=e.$jnc=void 0,e.$jnc=(0,L.$wi)("IExtHostTerminalShellIntegration");let C=class extends O.$Uc{constructor(l,o){super(),this.h=o,this.b=new Map,this.c=new $.$de,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$de,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$de,this.onDidEndTerminalShellExecution=this.g.event,this.a=l.getProxy(R.$$M.MainThreadTerminalShellIntegration),this.B((0,O.$Sc)(()=>{for(const[n,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(l){const o=this.h.getTerminalById(l);if(!o)return;const n=o.value;let i=this.b.get(l);i||(i=new p(o.value,this.f),this.b.set(l,i),i.store.add(o.onWillDispose(()=>this.b.get(l)?.dispose())),i.store.add(i.onDidRequestShellExecution(u=>this.a.$executeCommand(l,u))),i.store.add(i.onDidRequestEndExecution(u=>this.g.fire(u))),i.store.add(i.onDidRequestChangeShellIntegration(u=>this.c.fire(u))),o.shellIntegration=i.value),this.c.fire({terminal:n,shellIntegration:i.value})}$shellExecutionStart(l,o,n,i,u){this.b.has(l)||this.$shellIntegrationChange(l);const s={value:o,confidence:n,isTrusted:i};this.b.get(l)?.startShellExecution(s,u)}$shellExecutionEnd(l,o,n,i,u){const s={value:o,confidence:n,isTrusted:i};this.b.get(l)?.endShellExecution(s,u)}$shellExecutionData(l,o){this.b.get(l)?.emitData(o)}$cwdChange(l,o){this.b.get(l)?.setCwd((0,k.$vc)(o)?k.URI.revive(o):o)}$closeTerminal(l){this.b.get(l)?.dispose(),this.b.delete(l)}};e.$knc=C,e.$knc=C=Ge([We(0,N.$zP),We(1,b.$cmc)],C);class p extends O.$Uc{get currentExecution(){return this.a}constructor(l,o){super(),this.j=l,this.m=o,this.b=!1,this.store=this.B(new O.$Tc),this.f=this.B(new $.$de),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$de),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$de),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(i,u){let s=i;u&&(s+=` "${u.map(r=>`${r.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(s);const t={value:s,confidence:d.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},c=n.startShellExecution(t,n.c,!0).value;return n.b=!0,c}}}startShellExecution(l,o,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new y(l,o);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(l){this.currentExecution?.emitData(l)}endShellExecution(l,o){this.a&&(this.a.endExecution(l),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:o}),this.a=void 0)}setCwd(l){let o=!1;k.URI.isUri(this.c)?o=!k.URI.isUri(l)||this.c.toString()!==l.toString():this.c!==l&&(o=!0),o&&(this.c=l,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class y{constructor(l,o){this.c=l,this.cwd=o,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return A.$Wh.EMPTY;this.a=new v}return this.a.createIterable()}emitData(l){this.a?.emitData(l)}endExecution(l){l&&(this.c=l),this.a?.endExecution(),this.a=void 0,this.b=!0}}class v extends O.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new A.$vh);const l=this.a;return new A.$Wh(async n=>{this.b.push(n),await l.wait()})}emitData(l){for(const o of this.b)o.emitOne(l)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Se[359],De([1,0,7,21,22,4,75,57,3,18,30,11,6,20,155,16,8,69,113,89]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$onc=e.$nnc=e.$mnc=e.$lnc=void 0;let u=class extends $.$Uc{constructor(I,F,T,z){super(),this.w=z,this.f=this.B(new R.$de),this.g=new Map,this.s=this.B(new R.$de),this.onResultsChanged=this.f.event,this.results=[],this.h=I.getProxy(p.$$M.MainThreadTesting),this.m=new S(this.h),this.j=new r(this.h,F),T.registerArgumentProcessor({processArgument:M=>{switch(M?.$mid){case 16:{const j=M,U=j.tests[j.tests.length-1].item.extId;return this.g.get(o.$WL.root(U))?.collection.tree.get(U)?.actual??(0,v.$LP)(M)}case 18:{const{test:j,message:U}=M,Z=j.item.extId;return{test:this.g.get(o.$WL.root(Z))?.collection.tree.get(Z)?.actual??(0,v.$LP)({$mid:16,tests:[j]}),message:h.TestMessage.to(U)}}default:return M}}}),T.registerCommand(!1,"testing.getExplorerSelection",async()=>{const M=await T.executeCommand("_testing.getExplorerSelection"),j=U=>{const Z=this.g.get(o.$WL.root(U));if(Z)return o.$WL.isRoot(U)?Z.controller:Z.collection.tree.get(U)?.actual};return{include:M?.include.map(j).filter(k.$eg)||[],exclude:M?.exclude.map(j).filter(k.$eg)||[]}})}createTestController(I,F,T,z){if(this.g.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const M=new $.$Tc,j=M.add(new v.$OP(F,T,this.w));j.root.label=T;const U=new Map,Z=new Set,ie=this.h,q={items:j.root.children,get label(){return T},set label(x){T=x,j.root.label=x,ie.$updateController(F,{label:T})},get refreshHandler(){return z},set refreshHandler(x){z=x,ie.$updateController(F,{canRefresh:!!x})},get id(){return F},createRunProfile:(x,ne,be,ae,Ce,ee)=>{let B=(0,b.$kj)(x);for(;U.has(B);)B++;return new E(this.h,U,Z,this.s.event,F,B,x,ne,be,ae,Ce,ee)},createTestItem(x,ne,be){return new v.$MP(F,x,ne,be)},createTestRun:(x,ne,be=!0)=>this.j.createTestRun(F,j,x,ne,be),invalidateTestResults:x=>{if(x===void 0)this.h.$markTestRetired(void 0);else{const ne=x instanceof Array?x:[x];this.h.$markTestRetired(ne.map(be=>o.$WL.fromExtHostTestItem(be,F).toString()))}},set resolveHandler(x){j.resolveHandler=x},get resolveHandler(){return j.resolveHandler},dispose:()=>{M.dispose()}};ie.$registerTestController(F,T,!!z),M.add((0,$.$Sc)(()=>ie.$unregisterTestController(F)));const G={controller:q,collection:j,profiles:U,extension:I,activeProfiles:Z};return this.g.set(F,G),M.add((0,$.$Sc)(()=>this.g.delete(F))),M.add(j.onDidGenerateDiff(x=>ie.$publishDiff(F,x.map(i.TestsDiffOp.serialize)))),q}createTestObserver(){return this.m.checkout()}async runTests(I,F=L.CancellationToken.None){const T=a(I);if(!T)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.g.get(T.controllerId);if(!z)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:I.preserveFocus??!0,targets:[{testIds:I.include?.map(M=>o.$WL.fromExtHostTestItem(M,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:D[T.kind],profileId:T.profileId,controllerId:T.controllerId}],exclude:I.exclude?.map(M=>M.id)},F)}$syncTests(){for(const{collection:I}of this.g.values())I.flushDiff();return Promise.resolve()}async $getCoverageDetails(I,F){return(await this.j.getCoverageDetails(I,F))?.map(h.TestCoverage.fromDetails)}async $disposeRun(I){this.j.disposeTestRun(I)}$configureRunProfile(I,F){this.g.get(I)?.profiles.get(F)?.configureHandler?.()}$setDefaultRunProfiles(I){const F=new Map;for(const[T,z]of Object.entries(I)){const M=this.g.get(T);if(!M)continue;const j=new Map,U=z.filter(ie=>!M.activeProfiles.has(ie)),Z=[...M.activeProfiles].filter(ie=>!z.includes(ie));for(const ie of U)j.set(ie,!0),M.activeProfiles.add(ie);for(const ie of Z)j.set(ie,!1),M.activeProfiles.delete(ie);j.size&&F.set(T,j)}this.s.fire(F)}async $refreshTests(I,F){await this.g.get(I)?.controller.refreshHandler?.(F)}$publishTestResults(I){this.results=Object.freeze(I.map(h.TestResults.to).concat(this.results).sort((F,T)=>T.completedAt-F.completedAt).slice(0,32)),this.f.fire()}async $expandTest(I,F){const T=this.g.get(o.$WL.fromString(I).controllerId)?.collection;T&&(await T.expand(I,F<0?1/0:F),T.flushDiff())}$acceptDiff(I){this.m.applyDiff(I.map(F=>i.TestsDiffOp.deserialize({asCanonicalUri:T=>T},F)))}async $runControllerTests(I,F){return Promise.all(I.map(T=>this.y(T,!1,F)))}async $startContinuousRun(I,F){const T=new L.$oe(F),z=await Promise.all(I.map(M=>this.y(M,!0,T.token)));return!F.isCancellationRequested&&!z.some(M=>M.error)&&await new Promise(M=>F.onCancellationRequested(M)),T.dispose(!0),z}async y(I,F,T){const z=this.g.get(I.controllerId);if(!z)return{};const{collection:M,profiles:j}=z,U=j.get(I.profileId);if(!U)return{};const Z=I.testIds.map(x=>M.tree.get(x)).filter(k.$eg),ie=I.excludeExtIds.map(x=>z.collection.tree.get(x)).filter(k.$eg).filter(x=>Z.some(ne=>ne.fullId.compare(x.fullId)===2));if(!Z.length)return{};const q=new l.$NO(Z.some(x=>x.actual instanceof v.$NP)?void 0:Z.map(x=>x.actual),ie.map(x=>x.actual),U,F),G=(0,i.$ZL)(I)&&this.j.prepareForMainThreadTestRun(q,f.fromInternal(I,z.collection),U,T);try{return await U.runHandler(q,T),{}}catch(x){return{error:String(x)}}finally{G&&G.hasRunningTasks&&!T.isCancellationRequested&&await R.Event.toPromise(G.onEnd)}}$cancelExtensionTestRun(I){I===void 0?this.j.cancelAllRuns():this.j.cancelRunById(I)}};e.$lnc=u,e.$lnc=u=Ge([We(0,y.$zP),We(1,C.$3j)],u);const s=1e4;var t;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(t||(t={}));class c extends $.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(I,F,T,z,M){super(),this.y=I,this.z=F,this.C=T,this.D=z,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$de),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new L.$oe(M));const j=this.B(new d.$Ih(()=>this.F(),s));this.B(this.j.token.onCancellationRequested(()=>j.schedule()));const U=new R.$de;this.s=U.event,this.B((0,$.$Sc)(()=>{U.fire(),U.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(I,F){const[,T,z]=o.$WL.fromString(I).path,M=this.w.get(z);if(!M)return[];const j=this.g.get(T);if(!j)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(j.run,M,F)??[]}createRun(I){const F=this.y.id,T=this.y.controllerId,z=(0,A.$Sg)(),M=ie=>(q,...G)=>{if(U){this.C.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}this.y.isIncluded(q)&&(this.H(q),ie(q,...G))},j=(ie,q)=>{const G=q instanceof Array?q.map(h.TestMessage.from):[h.TestMessage.from(q)];if(ie.uri&&ie.range){const x={range:h.Range.from(ie.range),uri:ie.uri};for(const ne of G)ne.location=ne.location||x}this.z.$appendTestMessagesInRun(F,z,o.$WL.fromExtHostTestItem(ie,T).toString(),G)};let U=!1;const Z={isPersisted:this.y.isPersisted,token:this.j.token,name:I,onDidDispose:this.s,addCoverage:ie=>{const q=ie.uri.toString(),G=new o.$WL([F,z,q]).toString();this.w.set(q,ie),this.z.$appendCoverage(F,z,h.TestCoverage.fromFile(G,ie))},enqueued:M(ie=>{this.z.$updateTestStateInRun(F,z,o.$WL.fromExtHostTestItem(ie,T).toString(),1)}),skipped:M(ie=>{this.z.$updateTestStateInRun(F,z,o.$WL.fromExtHostTestItem(ie,T).toString(),5)}),started:M(ie=>{this.z.$updateTestStateInRun(F,z,o.$WL.fromExtHostTestItem(ie,T).toString(),2)}),errored:M((ie,q,G)=>{j(ie,q),this.z.$updateTestStateInRun(F,z,o.$WL.fromExtHostTestItem(ie,T).toString(),6,G)}),failed:M((ie,q,G)=>{j(ie,q),this.z.$updateTestStateInRun(F,z,o.$WL.fromExtHostTestItem(ie,T).toString(),4,G)}),passed:M((ie,q)=>{this.z.$updateTestStateInRun(F,z,o.$WL.fromExtHostTestItem(ie,this.y.controllerId).toString(),3,q)}),appendOutput:(ie,q,G)=>{U||(G&&(this.y.isIncluded(G)?this.H(G):G=void 0),this.z.$appendOutputToRun(F,z,O.$Fe.fromString(ie),q&&h.location.from(q),G&&o.$WL.fromExtHostTestItem(G,T).toString()))},end:()=>{U||(U=!0,this.z.$finishedTestRunTask(F,z),--this.f||this.G())}};return this.f++,this.g.set(z,{run:Z}),this.z.$startedTestRunTask(F,{id:z,name:I,running:!0}),Z}F(){for(const{run:I}of this.g.values())I.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(I){if(!(I instanceof v.$MP))throw new n.$rP(I.id);if(this.h.has(o.$WL.fromExtHostTestItem(I,this.y.controllerId).toString()))return;const F=[],T=this.y.colllection.root;for(;;){const z=h.TestItem.from(I);if(F.unshift(z),this.h.has(z.extId)||(this.h.add(z.extId),I===T))break;I=I.parent||T}this.z.$addTestsToRun(this.y.controllerId,this.y.id,F)}dispose(){this.G(),super.dispose()}}class r{get trackers(){return this.c.values()}constructor(I,F){this.g=I,this.h=F,this.c=new Map,this.f=new Map}getCoverageDetails(I,F){const T=o.$WL.root(I);return this.f.get(T)?.getCoverageDetails(I,F)||[]}disposeTestRun(I){this.f.get(I)?.dispose(),this.f.delete(I);for(const[F,{id:T}]of this.c)T===I&&this.c.delete(F)}prepareForMainThreadTestRun(I,F,T,z){return this.j(I,F,T,z)}cancelRunById(I){this.f.get(I)?.cancel()}cancelAllRuns(){for(const I of this.c.values())I.cancel()}createTestRun(I,F,T,z,M){const j=this.c.get(T);if(j)return j.createRun(z);const U=f.fromPublic(I,F,T,M),Z=a(T);this.g.$startedExtensionTestRun({controllerId:I,continuous:!!T.continuous,profile:Z&&{group:D[Z.kind],id:Z.profileId},exclude:T.exclude?.map(q=>o.$WL.fromExtHostTestItem(q,F.root.id).toString())??[],id:U.id,include:T.include?.map(q=>o.$WL.fromExtHostTestItem(q,F.root.id).toString())??[F.root.id],preserveFocus:T.preserveFocus??!0,persist:M});const ie=this.j(T,U,T.profile);return R.Event.once(ie.onEnd)(()=>{this.g.$finishedExtensionTestRun(U.id)}),ie.createRun(z)}j(I,F,T,z){const M=new c(F,this.g,this.h,T,z);return this.c.set(I,M),this.f.set(M.id,M),M}}e.$mnc=r;const a=P=>{if(P.profile){if(!(P.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class f{static fromPublic(I,F,T,z){return new f(I,(0,A.$Sg)(),T.include?.map(M=>o.$WL.fromExtHostTestItem(M,I).toString())??[I],T.exclude?.map(M=>o.$WL.fromExtHostTestItem(M,I).toString())??[],z,F)}static fromInternal(I,F){return new f(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,F)}constructor(I,F,T,z,M,j){this.controllerId=I,this.id=F,this.isPersisted=M,this.colllection=j,this.c=T.map(U=>U+"\0"),this.f=z.map(U=>U+"\0")}isIncluded(I){const F=o.$WL.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const T of this.f)if(F===T||F.startsWith(T))return!1;for(const T of this.c)if(F===T||F.startsWith(T))return!0;return!1}}e.$nnc=f;class g{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(I){this.j=I,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(I){this.c.add(I)}update(I){Object.assign(I.revived,h.TestItem.toPlain(I.item)),this.c.has(I)||this.f.add(I)}remove(I){if(this.c.has(I)){this.c.delete(I);return}this.f.delete(I);const F=o.$WL.parentId(I.item.extId);if(F&&this.h.has(F.toString())){this.h.add(I.item.extId);return}this.g.add(I)}getChangeEvent(){const{c:I,f:F,g:T}=this;return{get added(){return[...I].map(z=>z.revived)},get updated(){return[...F].map(z=>z.revived)},get removed(){return[...T].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class w extends i.$6L{constructor(){super(...arguments),this.s=new R.$de,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(I){return this.f.get(I)}getMirroredTestDataByReference(I){return this.f.get(I.id)}w(I,F){return{...I,revived:h.TestItem.toPlain(I.item),depth:F?F.depth+1:0,children:new Set}}v(){return new g(this.s)}}class S{constructor(I){this.f=I}checkout(){this.c||(this.c=this.g());const I=this.c;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(F=>F.revived)},dispose:(0,N.$db)(()=>{--I.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(I){return this.c?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.c?.tests.apply(I)}g(){const I=new w({asCanonicalUri:F=>F});return this.f.$subscribeToDiffs(),{observers:0,tests:I}}}const m=(P,I,F,T)=>{F?Object.assign(F,T):I.$updateTestRunConfig(P.controllerId,P.profileId,T)};class E{#e;#t;#n;#i;#s;get label(){return this.f}set label(I){I!==this.f&&(this.f=I,m(this,this.#e,this.#i,{label:I}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(I){I!==this.g&&(this.g=I,m(this,this.#e,this.#i,{supportsContinuousRun:I}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(I){I!==this.isDefault&&(I?this.#t.add(this.profileId):this.#t.delete(this.profileId),m(this,this.#e,this.#i,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,m(this,this.#e,this.#i,{tag:I?h.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this.c}set configureHandler(I){I!==this.c&&(this.c=I,m(this,this.#e,this.#i,{hasConfigurationHandler:!!I}))}get onDidChangeDefault(){return R.Event.chain(this.#n,I=>I.map(F=>F.get(this.controllerId)?.get(this.profileId)).filter(k.$eg))}constructor(I,F,T,z,M,j,U,Z,ie,q=!1,G=void 0,x=!1){this.controllerId=M,this.profileId=j,this.f=U,this.kind=Z,this.runHandler=ie,this._tag=G,this.g=x,this.#e=I,this.#s=F,this.#t=T,this.#n=z,F.set(j,this);const ne=D[Z];if(typeof ne!="number")throw new Error(`Unknown TestRunProfile.group ${Z}`);q&&T.add(j),this.#i={profileId:j,controllerId:M,tag:G?h.TestTag.namespace(this.controllerId,G.id):null,label:U,group:ne,isDefault:q,hasConfigurationHandler:!1,supportsContinuousRun:x},queueMicrotask(()=>{this.#i&&(this.#e.$publishTestRunProfile(this.#i),this.#i=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#i=void 0}}e.$onc=E;const D={[l.TestRunProfileKind.Coverage]:8,[l.TestRunProfileKind.Debug]:4,[l.TestRunProfileKind.Run]:2}}),define(Se[157],De([1,0,62,13,125,16,8]),function(he,e,d,O,L,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=e.$HP=e.$GP=void 0;class b{static{this.c=new L.$EP("TextEditorDecorationType")}constructor(p,y,v){const h=b.c.nextId();p.$registerTextEditorDecorationType(y.identifier,h,R.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:h,dispose(){p.$removeTextEditorDecorationType(h)}})}}e.$GP=b;class ${constructor(p,y){this.g=[],this.h=void 0,this.j=!1,this.c=p,this.d=p.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(p,y){this.k();let v=null;if(p instanceof N.$bN)v=new N.$cN(p,p);else if(p instanceof N.$cN)v=p;else throw new Error("Unrecognized location");this.l(v,y,!1)}insert(p,y){this.k(),this.l(new N.$cN(p,p),y,!0)}delete(p){this.k();let y=null;if(p instanceof N.$cN)y=p;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(p,y,v){const h=this.c.validateRange(p);this.g.push({range:h,text:y,forceMoveMarkers:v})}setEndOfLine(p){if(this.k(),p!==N.EndOfLine.LF&&p!==N.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=p}}class k{constructor(p,y,v,h){this.c=p,this.d=y,this._accept(v),this.e=h;const l=this;this.value={get tabSize(){return l.f},set tabSize(o){l.n(o)},get indentSize(){return l.g},set indentSize(o){l.p(o)},get insertSpaces(){return l.j},set insertSpaces(o){l.s(o)},get cursorStyle(){return l.k},set cursorStyle(o){l.t(o)},get lineNumbers(){return l.l},set lineNumbers(o){l.u(o)}}}_accept(p){this.f=p.tabSize,this.g=p.indentSize,this.h=p.originalIndentSize,this.j=p.insertSpaces,this.k=p.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(p.lineNumbers)}m(p){if(p==="auto")return"auto";if(typeof p=="number"){const y=Math.floor(p);return y>0?y:null}if(typeof p=="string"){const y=parseInt(p,10);return isNaN(y)?null:y>0?y:null}return null}n(p){const y=this.m(p);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}o(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const y=Math.floor(p);return y>0?y:null}if(typeof p=="string"){const y=parseInt(p,10);return isNaN(y)?null:y>0?y:null}return null}p(p){const y=this.o(p);if(y!==null){if(typeof y=="number"){if(this.h===y)return;this.g=y,this.h=y}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}q(p){return p==="auto"?"auto":p==="false"?!1:!!p}s(p){const y=this.q(p);if(typeof y=="boolean"){if(this.j===y)return;this.j=y}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}t(p){this.k!==p&&(this.k=p,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:p})))}u(p){this.l!==p&&(this.l=p,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(p)})))}assign(p){const y={};let v=!1;if(typeof p.tabSize<"u"){const h=this.m(p.tabSize);h==="auto"?(v=!0,y.tabSize=h):typeof h=="number"&&this.f!==h&&(this.f=h,v=!0,y.tabSize=h)}if(typeof p.indentSize<"u"){const h=this.o(p.indentSize);h==="tabSize"?(v=!0,y.indentSize=h):typeof h=="number"&&this.h!==h&&(this.g=h,this.h=h,v=!0,y.indentSize=h)}if(typeof p.insertSpaces<"u"){const h=this.q(p.insertSpaces);h==="auto"?(v=!0,y.insertSpaces=h):this.j!==h&&(this.j=h,v=!0,y.insertSpaces=h)}typeof p.cursorStyle<"u"&&this.k!==p.cursorStyle&&(this.k=p.cursorStyle,v=!0,y.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this.l!==p.lineNumbers&&(this.l=p.lineNumbers,v=!0,y.lineNumbers=R.TextEditorLineNumbersStyle.from(p.lineNumbers)),v&&this.v("setOptions",this.c.$trySetOptions(this.d,y))}v(p,y){y.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this.e.warn(v)})}}e.$HP=k;class A{constructor(p,y,v,h,l,o,n,i){this.id=p,this.j=y,this.k=v,this.g=!1,this.h=new Set,this.c=l,this.d=new k(this.j,this.id,o,v),this.e=n,this.f=i;const u=this;this.value=Object.freeze({get document(){return h.value},set document(s){throw new O.$9("document")},get selection(){return u.c&&u.c[0]},set selection(s){if(!(s instanceof N.$dN))throw(0,O.$7)("selection");u.c=[s],u.l()},get selections(){return u.c},set selections(s){if(!Array.isArray(s)||s.some(t=>!(t instanceof N.$dN)))throw(0,O.$7)("selections");u.c=s,u.l()},get visibleRanges(){return u.e},set visibleRanges(s){throw new O.$9("visibleRanges")},get options(){return u.d.value},set options(s){u.g||u.d.assign(s)},get viewColumn(){return u.f},set viewColumn(s){throw new O.$9("viewColumn")},edit(s,t={undoStopBefore:!0,undoStopAfter:!0}){if(u.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const c=new $(h.value,t);return s(c),u.m(c)},insertSnippet(s,t,c={undoStopBefore:!0,undoStopAfter:!0}){if(u.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=u.c.map(a=>R.Range.from(a));else if(t instanceof N.$bN){const{lineNumber:a,column:f}=R.Position.from(t);r=[{startLineNumber:a,startColumn:f,endLineNumber:a,endColumn:f}]}else if(t instanceof N.$cN)r=[R.Range.from(t)];else{r=[];for(const a of t)if(a instanceof N.$cN)r.push(R.Range.from(a));else{const{lineNumber:f,column:g}=R.Position.from(a);r.push({startLineNumber:f,startColumn:g,endLineNumber:f,endColumn:g})}}return y.$tryInsertSnippet(p,h.value.version,s.value,r,c)},setDecorations(s,t){const c=t.length===0;c&&!u.h.has(s.key)||(c?u.h.delete(s.key):u.h.add(s.key),u.n(()=>{if(R.$wP(t))return y.$trySetDecorations(p,s.key,R.$xP(t));{const r=new Array(4*t.length);for(let a=0,f=t.length;a<f;a++){const g=t[a];r[4*a]=g.start.line+1,r[4*a+1]=g.start.character+1,r[4*a+2]=g.end.line+1,r[4*a+3]=g.end.character+1}return y.$trySetDecorationsFast(p,s.key,r)}}))},revealRange(s,t){u.n(()=>y.$tryRevealRange(p,R.Range.from(s),t||N.TextEditorRevealType.Default))},show(s){y.$tryShowEditor(p,R.ViewColumn.from(s))},hide(){y.$tryHideEditor(p)}})}dispose(){(0,d.ok)(!this.g),this.g=!0}_acceptOptions(p){(0,d.ok)(!this.g),this.d._accept(p)}_acceptVisibleRanges(p){(0,d.ok)(!this.g),this.e=p}_acceptViewColumn(p){(0,d.ok)(!this.g),this.f=p}_acceptSelections(p){(0,d.ok)(!this.g),this.c=p}async l(){const p=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,p)),this.value}m(p){const y=p.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const v=y.edits.map(l=>l.range);v.sort((l,o)=>l.end.line===o.end.line?l.end.character===o.end.character?l.start.line===o.start.line?l.start.character-o.start.character:l.start.line-o.start.line:l.end.character-o.end.character:l.end.line-o.end.line);for(let l=0,o=v.length-1;l<o;l++){const n=v[l].end;if(v[l+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=y.edits.map(l=>({range:R.Range.from(l.range),text:l.text,forceMoveMarkers:l.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,h,{setEndOfLine:typeof y.setEndOfLine=="number"?R.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(p){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$IP=A}),define(Se[73],De([1,0,62,4,3,2,5,6,153,20,157,16,11,27,15,39,46]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KP=e.$JP=void 0;class o{constructor(u){this.value=u,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(u,s){this.h=u,this.i=s,this.a=null,this.b=new Map,this.c=new y.$Ac,this.d=new O.$de,this.e=new O.$de,this.f=new O.$de,this.g=new O.$de,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const s=[],t=[],c=[];if(u.removedDocuments)for(const r of u.removedDocuments){const a=R.URI.revive(r),f=this.c.get(a);f?.unref()&&(this.c.delete(a),s.push(f.value))}if(u.addedDocuments)for(const r of u.addedDocuments){const a=R.URI.revive(r.uri);let f=this.c.get(a);if(f&&a.scheme!==v.Schemas.vscodeNotebookCell&&a.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);f||(f=new o(new $.$CP(this.h.getProxy(b.$$M.MainThreadDocuments),a,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty)),this.c.set(a,f),t.push(f.value)),f.ref()}if(u.removedEditors)for(const r of u.removedEditors){const a=this.b.get(r);this.b.delete(r),a&&c.push(a)}if(u.addedEditors)for(const r of u.addedEditors){const a=R.URI.revive(r.documentUri);d.ok(this.c.has(a),`document '${a}' does not exist`),d.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const f=this.c.get(a).value,g=new A.$IP(r.id,this.h.getProxy(b.$$M.MainThreadTextEditors),this.i,new l.$V(()=>f.document),r.selections.map(C.Selection.to),r.options,r.visibleRanges.map(w=>C.Range.to(w)),typeof r.editorPosition=="number"?C.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,g)}u.newActiveEditor!==void 0&&(d.ok(u.newActiveEditor===null||this.b.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this.a=u.newActiveEditor),(0,L.$Pc)(s),(0,L.$Pc)(c),u.removedDocuments&&this.e.fire(s),u.addedDocuments&&this.d.fire(t),(u.removedEditors||u.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),u.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(u){return this.c.get(u)?.value}allDocuments(){return h.Iterable.map(this.c.values(),u=>u.value)}getEditor(u){return this.b.get(u)}activeEditor(u){if(!this.a)return;const s=this.b.get(this.a);return u?s:s?.value}allEditors(){return[...this.b.values()]}};e.$JP=n,e.$JP=n=Ge([We(0,k.$zP),We(1,p.$3j)],n),e.$KP=(0,N.$wi)("IExtHostDocumentsAndEditors")}),define(Se[360],De([1,0,19,4,6,157,16,8]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=void 0;class ${constructor(A,C){this.i=C,this.a=new O.$de,this.b=new O.$de,this.c=new O.$de,this.d=new O.$de,this.f=new O.$de,this.g=new O.$de,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(L.$$M.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const C=this.i.allEditors();return A?C:C.map(p=>p.value)}async showTextDocument(A,C,p){let y;typeof C=="number"?y={position:N.ViewColumn.from(C),preserveFocus:p}:typeof C=="object"?y={position:N.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?N.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:y={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(A.uri,y),h=v&&this.i.getEditor(v);if(h)return h.value;throw v?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,C){return new R.$GP(this.h,A,C).value}$acceptEditorPropertiesChanged(A,C){const p=this.i.getEditor(A);if(!p)throw new Error("unknown text editor");if(C.options&&p._acceptOptions(C.options),C.selections){const y=C.selections.selections.map(N.Selection.to);p._acceptSelections(y)}if(C.visibleRanges){const y=d.$Hb(C.visibleRanges.map(N.Range.to));p._acceptVisibleRanges(y)}if(C.options&&this.b.fire({textEditor:p.value,options:{...C.options,lineNumbers:N.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const y=b.TextEditorSelectionChangeKind.fromValue(C.selections.source),v=C.selections.selections.map(N.Selection.to);this.a.fire({textEditor:p.value,selections:v,kind:y})}if(C.visibleRanges){const y=d.$Hb(C.visibleRanges.map(N.Range.to));this.c.fire({textEditor:p.value,visibleRanges:y})}}$acceptEditorPositionData(A){for(const C in A){const p=this.i.getEditor(C);if(!p)throw new Error("Unknown text editor");const y=N.ViewColumn.to(A[C]);p.value.viewColumn!==y&&(p._acceptViewColumn(y),this.d.fire({textEditor:p.value,viewColumn:y}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$Hlc=$}),define(Se[361],De([1,0,2,5,6,3,8,16,25,18]),function(he,e,d,O,L,R,N,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rnc=e.$qnc=void 0,e.$qnc=(0,O.$wi)("IExtHostTimeline");class A{constructor(y,v){this.b=new Map,this.c=new Map,this.a=y.getProxy(L.$$M.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(h,l)=>{if(h&&h.$mid===12)if(this.b.get(h.source)&&$.$Rm.equals(l,this.b.get(h.source)?.extension)){const o=h.uri===void 0?void 0:d.URI.revive(h.uri);return this.c.get(h.source)?.get(C(o))?.get(h.handle)}else return;return h}})}async $getTimeline(y,v,h,l){return this.b.get(y)?.provider.provideTimeline(d.URI.revive(v),h,l)}registerTimelineProvider(y,v,h,l){const o=new R.$Tc,n=this.d(v.id,l,o).bind(this);let i;v.onDidChange&&(i=v.onDidChange(s=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...s,id:v.id}),this));const u=this.c;return this.f({...v,scheme:y,onDidChange:void 0,async provideTimeline(s,t,c){t?.resetCache&&(o.clear(),u.get(v.id)?.clear());const r=await v.provideTimeline(s,t,c);if(r==null)return;const a=n(s,t);return{...r,source:v.id,items:r.items.map(a)}},dispose(){for(const s of u.values())s.get(v.id)?.clear();i?.dispose(),o.dispose()}},h)}d(y,v,h){return(l,o)=>{let n;if(o?.cacheResults){let i=this.c.get(y);i===void 0&&(i=new Map,this.c.set(y,i));const u=C(l);n=i.get(u),n===void 0&&(n=new Map,i.set(u,n))}return i=>{const{iconPath:u,...s}=i,t=`${y}|${i.id??i.timestamp}`;n?.set(t,i);let c,r,a;i.iconPath&&(u instanceof N.$0N?a={id:u.id,color:u.color}:d.URI.isUri(u)?(c=u,r=u):{light:c,dark:r}=u);let f;return N.$CN.isMarkdownString(s.tooltip)?f=b.MarkdownString.from(s.tooltip):(0,k.$9f)(s.tooltip)?f=s.tooltip:N.$CN.isMarkdownString(s.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),f=b.MarkdownString.from(s.detail)):(0,k.$9f)(s.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),f=s.detail),{...s,id:s.id??void 0,handle:t,source:y,command:i.command?v.toInternal(i.command,h):void 0,icon:c,iconDark:r,themeIcon:a,tooltip:f,accessibilityInformation:i.accessibilityInformation}}}}f(y,v){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:v}),(0,R.$Sc)(()=>{for(const l of this.c.values())l.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$rnc=A;function C(p){return p?.toString()}}),define(Se[362],De([1,0,233,23,2,4,3,294,7,8,18,19,16,81,22,189,26]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=void 0;function o(u,s){if((0,A.$9f)(u))return{label:u};if(u&&typeof u=="object"&&typeof u.label=="string"){let t;return Array.isArray(u.highlights)&&(t=u.highlights.filter(c=>c.length===2&&typeof c[0]=="number"&&typeof c[1]=="number"),t=t.length?t:void 0),{label:u.label,highlights:t}}}class n extends N.$Uc{constructor(s,t,c){super(),this.f=s,this.g=t,this.h=c,this.a=new Map,this.b=new h.$v$;function r(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:a=>r(a)?this.r(a):Array.isArray(a)&&a.length>0?a.map(f=>r(f)?this.r(f):f):a})}registerTreeDataProvider(s,t,c){const r=this.createTreeView(s,{treeDataProvider:t},c);return{dispose:()=>r.dispose()}}createTreeView(s,t,c){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],a=t.dragAndDropController?.dragMimeTypes??[],f=!!t.dragAndDropController?.handleDrag,g=!!t.dragAndDropController?.handleDrop,w=this.m(s,t,c),S={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:a,hasHandleDrag:f,hasHandleDrop:g,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},m=this.f.$registerTreeViewDataProvider(s,S),E={get onDidCollapseElement(){return w.onDidCollapseElement},get onDidExpandElement(){return w.onDidExpandElement},get selection(){return w.selectedElements},get onDidChangeSelection(){return w.onDidChangeSelection},get activeItem(){return(0,l.$PG)(c,"treeViewActiveItem"),w.focusedElement},get onDidChangeActiveItem(){return(0,l.$PG)(c,"treeViewActiveItem"),w.onDidChangeActiveItem},get visible(){return w.visible},get onDidChangeVisibility(){return w.onDidChangeVisibility},get onDidChangeCheckboxState(){return w.onDidChangeCheckboxState},get message(){return w.message},set message(D){(0,y.$Vk)(D)&&(0,l.$PG)(c,"treeViewMarkdownMessage"),w.message=D},get title(){return w.title},set title(D){w.title=D},get description(){return w.description},set description(D){w.description=D},get badge(){return w.badge},set badge(D){D!==void 0&&k.ViewBadge.isViewBadge(D)?w.badge={value:Math.floor(Math.abs(D.value)),tooltip:D.tooltip}:D===void 0&&(w.badge=void 0)},reveal:(D,P)=>w.reveal(D,P),dispose:async()=>{await m,this.a.delete(s),w.dispose()}};return this.B(E),E}$getChildren(s,t){const c=this.a.get(s);return c?c.getChildren(t):Promise.reject(new b.$4F(s))}async $handleDrop(s,t,c,r,a,f,g,w){const S=this.a.get(s);if(!S)return Promise.reject(new b.$4F(s));const m=p.DataTransfer.toDataTransfer(c,async E=>(await this.f.$resolveDropFileData(s,t,E)).buffer);return g===s&&w&&await this.j(m,S,w,a,f),S.onDrop(m,r,a)}async j(s,t,c,r,a){const f=this.b.removeDragOperationTransfer(a);if(f)(await f)?.forEach((g,w)=>{g&&s.set(w,g)});else if(a&&t.handleDrag){const g=t.handleDrag(c,s,r);this.b.addDragOperationTransfer(a,g),await g}return s}async $handleDrag(s,t,c,r){const a=this.a.get(s);if(!a)return Promise.reject(new b.$4F(s));const f=await this.j(new k.$6N,a,t,r,c);if(!(!f||r.isCancellationRequested))return p.DataTransfer.from(f)}async $hasResolve(s){const t=this.a.get(s);if(!t)throw new b.$4F(s);return t.hasResolve}$resolve(s,t,c){const r=this.a.get(s);if(!r)throw new b.$4F(s);return r.resolveTreeItem(t,c)}$setExpanded(s,t,c){const r=this.a.get(s);if(!r)throw new b.$4F(s);r.setExpanded(t,c)}$setSelectionAndFocus(s,t,c){const r=this.a.get(s);if(!r)throw new b.$4F(s);r.setSelectionAndFocus(t,c)}$setVisible(s,t){const c=this.a.get(s);if(!c){if(!t)return;throw new b.$4F(s)}c.setVisible(t)}$changeCheckboxState(s,t){const c=this.a.get(s);if(!c)throw new b.$4F(s);c.setCheckboxState(t)}m(s,t,c){const r=this.B(new i(s,t,this.f,this.g.converter,this.h,c));return this.a.set(s,r),r}r(s){const t=this.a.get(s.$treeViewId);return t&&"$treeItemHandle"in s?t.getExtensionElement(s.$treeItemHandle):t&&"$focusedTreeItem"in s&&s.$focusedTreeItem?t.focusedElement:null}}e.$snc=n;class i extends N.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(s=>this.getExtensionElement(s)).filter(s=>!(0,A.$fg)(s))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(s,t,c,r,a,f){if(super(),this.I=s,this.J=c,this.L=r,this.M=a,this.N=f,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$de),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$de),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$de),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$de),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$de),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$de),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$de),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$oe,f.contributes&&f.contributes.views)for(const m in f.contributes.views)for(const E of f.contributes.views[m])E.id===s&&(this.P=E.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(m=>{Array.isArray(m)&&m.length===0||this.F.fire({message:!1,element:m})}));let g,w;const S=R.Event.debounce(this.F.event,(m,E)=>(m||(m={message:!1,elements:[]}),E.element!==!1&&(g||(g=new Promise(D=>w=D),this.G=this.G.then(()=>g)),Array.isArray(E.element)?m.elements.push(...E.element):m.elements.push(E.element)),E.message&&(m.message=!0),m),200,!0);this.B(S(({message:m,elements:E})=>{E.length&&(this.H=this.H.then(()=>{const D=w;return g=null,this.$(E).then(()=>D())})),m&&this.J.$setMessage(this.I,p.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(s){const t=s?this.getExtensionElement(s):void 0;if(s&&!t)return this.M.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let c=this.X(s);return c||(c=await this.Y(t)),c?c.map(r=>r.item):void 0}getExtensionElement(s){return this.j.get(s)}reveal(s,t){t=t||{select:!0,focus:!1};const c=(0,A.$fg)(t.select)?!0:t.select,r=(0,A.$fg)(t.focus)?!1:t.focus,a=(0,A.$fg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.G.then(()=>this.S(s)).then(f=>this.W(s,f[f.length-1]).then(g=>this.J.$reveal(this.I,{item:g.item,parentChain:f.map(w=>w.item)},{select:c,focus:r,expand:a})),f=>this.M.error(f)):this.J.$reveal(this.I,void 0,{select:c,focus:r,expand:a})}get message(){return this.O}set message(s){this.O=s,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(s){this.P=s,this.J.$setTitle(this.I,s,this.Q)}get description(){return this.Q}set description(s){this.Q=s,this.J.$setTitle(this.I,this.P,s)}get badge(){return this.R}set badge(s){this.R?.value===s?.value&&this.R?.tooltip===s?.tooltip||(this.R=p.ViewBadge.from(s),this.J.$setBadge(this.I,s))}setExpanded(s,t){const c=this.getExtensionElement(s);c&&(t?this.u.fire(Object.freeze({element:c})):this.w.fire(Object.freeze({element:c})))}setSelectionAndFocus(s,t){const c=!(0,C.$ub)(this.s,s);this.s=s;const r=this.t!==t;this.t=t,c&&this.y.fire(Object.freeze({selection:this.selectedElements})),r&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(s){s!==this.r&&(this.r=s,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(s){const t=(await Promise.all(s.map(async c=>{const r=this.getExtensionElement(c.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:c.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(c=>c!==void 0);t.forEach(c=>{c.treeItem.checkboxState=c.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(c=>[c.extensionItem,c.newState])})}async handleDrag(s,t,c){const r=[];for(const a of s){const f=this.getExtensionElement(a);f&&r.push(f)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,c),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(s,t,c){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,$.$oh)(()=>this.g?.handleDrop?this.g.handleDrop(r,s,c):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(s,t){if(!this.f.resolveTreeItem)return;const c=this.j.get(s);if(c){const r=this.m.get(c);if(r){const a=await this.f.resolveTreeItem(r.extensionItem,c,t)??r.extensionItem;return this.hb(a),r.item.tooltip=this.eb(a.tooltip),r.item.command=this.fb(r.disposableStore,a.command),r.item}}}S(s){return this.U(s).then(t=>t?this.S(t).then(c=>this.W(t,c[c.length-1]).then(r=>(c.push(r),c))):Promise.resolve([]))}U(s){const t=this.m.get(s);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$oh)(()=>this.f.getParent(s))}W(s,t){const c=this.m.get(s);return c?Promise.resolve(c):(0,$.$oh)(()=>this.f.getTreeItem(s)).then(r=>this.kb(s,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const a=this.getExtensionElement(r);if(a){const f=this.m.get(a);if(f)return Promise.resolve(f)}throw new Error(`Cannot resolve tree item for element ${r} from extension ${this.N.identifier.value}`)}))}X(s){if(s){let t;if(typeof s=="string"){const c=this.getExtensionElement(s);t=c?this.m.get(c):void 0}else t=s;return t&&t.children||void 0}return this.h}async Y(s){this.rb(s);const t=new v.$oe(this.Z.token);try{const c=s?this.m.get(s):void 0,r=await this.f.getChildren(s);if(t.token.isCancellationRequested)return;const a=(0,C.$Hb)(r||[]),f=await Promise.all((0,C.$Hb)(a).map(w=>this.f.getTreeItem(w)));if(t.token.isCancellationRequested)return;const g=f.map((w,S)=>w?this.db(a[S],w,c):null);return(0,C.$Hb)(g)}finally{t.dispose()}}$(s){if(s.some(c=>!c))return this.Z.dispose(!0),this.Z=new v.$oe,this.tb(),this.J.$refresh(this.I);{const c=this.ab(s);if(c.length)return this.bb(c)}return Promise.resolve(void 0)}ab(s){const t=new Set,c=s.map(a=>this.m.get(a));for(const a of c)if(a&&!t.has(a.item.handle)){let f=a;for(;f&&f.parent&&c.findIndex(g=>f&&f.parent&&g&&g.item.handle===f.parent.item.handle)===-1;){const g=this.j.get(f.parent.item.handle);f=g?this.m.get(g):void 0}f&&!f.parent&&t.add(a.item.handle)}const r=[];return t.forEach(a=>{const f=this.j.get(a);if(f){const g=this.m.get(f);g&&(!g.parent||!t.has(g.parent.item.handle))&&r.push(a)}}),r}bb(s){const t={};return Promise.all(s.map(c=>this.cb(c).then(r=>{r&&(t[c]=r.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(s){const t=this.getExtensionElement(s);if(t){const c=this.m.get(t);if(c)return this.rb(t),(0,$.$oh)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const a=this.ib(t,r,c.parent);return this.pb(t,a,c,c.parent),c.dispose(),a}return null})}return Promise.resolve(null)}db(s,t,c){const r=this.ib(s,t,c);if(t.id&&this.j.has(r.item.handle))throw new Error((0,d.localize)(0,null,t.id));return this.ob(s,r),this.qb(r,c),r}eb(s){return k.$CN.isMarkdownString(s)?p.MarkdownString.from(s):s}fb(s,t){return t?{...this.L.toInternal(t,s),originalId:t.command}:void 0}gb(s){if(s.checkboxState===void 0)return;let t,c,r;return typeof s.checkboxState=="number"?t=s.checkboxState:(t=s.checkboxState.state,c=s.checkboxState.tooltip,r=s.checkboxState.accessibilityInformation),{isChecked:t===k.TreeItemCheckboxState.Checked,tooltip:c,accessibilityInformation:r}}hb(s){if(!k.$1N.isTreeItem(s,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(s,t,c){this.hb(t);const r=this.B(new N.$Tc),a=this.kb(s,t,c),f=this.lb(t);return{item:{handle:a,parentHandle:c?c.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(r,t.command),contextValue:t.contextValue,icon:f,iconDark:this.mb(t)||f,themeIcon:this.jb(t),collapsibleState:(0,A.$fg)(t.collapsibleState)?k.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:c,children:void 0,disposableStore:r,dispose(){r.dispose()}}}jb(s){return s.iconPath instanceof k.$0N?s.iconPath:void 0}kb(s,{id:t,label:c,resourceUri:r},a,f){if(t)return`${i.b}/${t}`;const g=o(c,this.N),w=a?a.item.handle:i.a;let S=g?g.label:r?(0,O.$7g)(r):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const m=this.m.has(s)?this.m.get(s).item.handle:void 0,E=this.X(a)||[];let D,P=0;do{if(D=`${w}/${P}:${S}`,f||!this.j.has(D)||m===D)break;P++}while(P<=E.length);return D}lb(s){if(s.iconPath&&!(s.iconPath instanceof k.$0N))return typeof s.iconPath=="string"||L.URI.isUri(s.iconPath)?this.nb(s.iconPath):this.nb(s.iconPath.light)}mb(s){if(s.iconPath&&!(s.iconPath instanceof k.$0N)&&s.iconPath.dark)return this.nb(s.iconPath.dark)}nb(s){return L.URI.isUri(s)?s:L.URI.file(s)}ob(s,t){this.j.set(t.item.handle,s),this.m.set(s,t)}pb(s,t,c,r){this.j.delete(t.item.handle),this.m.delete(s),t.item.handle!==c.item.handle&&this.j.delete(c.item.handle),this.ob(s,t);const a=this.X(r)||[],f=a.filter(g=>g.item.handle===c.item.handle)[0];f&&a.splice(a.indexOf(f),1,t)}qb(s,t){t?(t.children||(t.children=[]),t.children.push(s)):(this.h||(this.h=[]),this.h.push(s))}rb(s){if(s){const t=this.m.get(s);if(t){if(t.children)for(const c of t.children){const r=this.j.get(c.item.handle);r&&this.sb(r)}t.children=void 0}}else this.tb()}sb(s){const t=this.m.get(s);if(t){if(t.children)for(const c of t.children){const r=this.j.get(c.item.handle);r&&this.sb(r)}this.m.delete(s),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(s=>s.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[363],De([1,0,4,3,2,30,16,92,6,8]),function(he,e,d,O,L,R,N,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=void 0;class A extends O.$Uc{#e;#t;#n;#i;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(v,h,l,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new d.$de),this.onDidDispose=this.#d.event,this.#h=this.B(new d.$de),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=h,this.#i=l,this.#n=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#i.dispose(),super.dispose())}get webview(){return this.c(),this.#i}get viewType(){return this.c(),this.#n}get title(){return this.c(),this.#r}set title(v){this.c(),this.#r!==v&&(this.#r=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,L.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#o=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,h){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:N.ViewColumn.from(v),preserveFocus:!!h})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends O.$Uc{static c(){return(0,R.$Sg)()}constructor(v,h,l){super(),this.j=h,this.m=l,this.g=new Map,this.h=new Map,this.f=v.getProxy($.$$M.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,h,l,o,n={}){const i=typeof o=="object"?o.viewColumn:o,u={viewColumn:N.ViewColumn.from(i),preserveFocus:typeof o=="object"&&!!o.preserveFocus},s=(0,b.$Wlc)(v),t=C.c();this.f.$createWebviewPanel((0,b.$Ylc)(v),t,h,{title:l,panelOptions:p(n),webviewOptions:(0,b.$Zlc)(v,this.m,n),serializeBuffersForPostMessage:s},u);const c=this.j.createNewWebview(t,n,v);return this.createNewWebviewPanel(t,h,l,i,n,c,!0)}$onDidChangeWebviewPanelViewStates(v){const h=Object.keys(v);h.sort((l,o)=>{const n=v[l],i=v[o];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const l of h){const o=this.getWebviewPanel(l);if(!o)continue;const n=v[l];o._updateViewState({active:n.active,visible:n.visible,viewColumn:N.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,h,l){if(this.h.has(h))throw new Error(`Serializer for '${h}' already registered`);return this.h.set(h,{serializer:l,extension:v}),this.f.$registerSerializer(h,{serializeBuffersForPostMessage:(0,b.$Wlc)(v)}),new k.$aN(()=>{this.h.delete(h),this.f.$unregisterSerializer(h)})}async $deserializeWebviewPanel(v,h,l,o){const n=this.h.get(h);if(!n)throw new Error(`No serializer found for '${h}'`);const{serializer:i,extension:u}=n,s=this.j.createNewWebview(v,l.webviewOptions,u),t=this.createNewWebviewPanel(v,h,l.title,o,l.panelOptions,s,l.active);await i.deserializeWebviewPanel(t,l.state)}createNewWebviewPanel(v,h,l,o,n,i,u){const s=new A(v,this.f,i,{viewType:h,title:l,viewColumn:o,panelOptions:n,active:u});return this.g.set(v,s),s}getWebviewPanel(v){return this.g.get(v)}}e.$1lc=C;function p(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(Se[364],De([1,0,4,3,92,16,6,8]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vnc=void 0;class $ extends O.$Uc{#e;#t;#n;#i;#s;#r;#a;#o;#c;constructor(C,p,y,v,h,l){super(),this.#s=!1,this.#u=this.B(new d.$de),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new d.$de),this.onDidDispose=this.#l.event,this.#n=y,this.#a=v,this.#e=C,this.#t=p,this.#i=h,this.#r=l}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#i.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#o}set description(C){this.a(),this.#o!==C&&(this.#o=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#r}get webview(){return this.#i}get viewType(){return this.#n}_setVisible(C){C===this.#r||this.#s||(this.#r=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#s)throw new Error("Webview is disposed")}}class k{constructor(C,p){this.d=p,this.b=new Map,this.c=new Map,this.a=C.getProxy(N.$$M.MainThreadWebviewViews)}registerWebviewViewProvider(C,p,y,v){if(this.b.has(p))throw new Error(`View provider for '${p}' already registered`);return this.b.set(p,{provider:y,extension:C}),this.a.$registerWebviewViewProvider((0,L.$Ylc)(C),p,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,L.$Wlc)(C)}),new b.$aN(()=>{this.b.delete(p),this.a.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(C,p,y,v,h){const l=this.b.get(p);if(!l)throw new Error(`No view provider found for '${p}'`);const{provider:o,extension:n}=l,i=this.d.createNewWebview(C,{},n),u=new $(C,this.a,p,y,i,!0);this.c.set(C,u),await o.resolveWebviewView(u,{state:v},h)}async $onDidChangeWebviewViewVisibility(C,p){this.e(C)._setVisible(p)}async $disposeWebviewView(C){const p=this.e(C);this.c.delete(C),p.dispose(),this.d.deleteWebview(C)}e(C){const p=this.c.get(C);if(!p)throw new Error("No webview found");return p}}e.$vnc=k}),define(Se[365],De([1,0,70,15,11,265,33,12]),function(he,e,d,O,L,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aoc=void 0;let $=class{constructor(C,p){C.addFileSystemProvider(O.Schemas.file,new k(p),{isCaseSensitive:b.$k})}};e.$aoc=$,e.$aoc=$=Ge([We(0,d.$Slc),We(1,L.$3j)],$);class k{constructor(C){this.b=C,this.a=new R.$_q(this.b)}async stat(C){const p=await this.a.stat(C);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===N.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,p,y){return this.a.writeFile(C,p,{...y,unlock:!1,atomic:!1})}delete(C,p){return this.a.delete(C,{...p,useTrash:!1,atomic:!1})}rename(C,p,y){return this.a.rename(C,p,y)}copy(C,p,y){return this.a.copy(C,p,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,p){throw new Error("Method not implemented.")}}}),define(Se[366],De([1,0,17,64,30,34,3,6,2,20]),function(he,e,d,O,L,R,N,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$nc=void 0;let A=class extends N.$Uc{constructor(p,y){super();const v=p.getProxy(b.$$M.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async h=>{const l=$.URI.file((0,d.$jc)((0,O.tmpdir)(),(0,L.$Sg)()));return await v.$download(h,l),l})}};e.$$nc=A,e.$$nc=A=Ge([We(0,k.$zP),We(1,R.$VP)],A)}),define(Se[367],De([1,0,53,17,2,93,3,15,7,32]),function(he,e,d,O,L,R,N,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$koc=void 0;class A extends R.$Ulc{constructor(){super(...arguments),this.i=null}async g(t){const c=await super.g(t);if(c.scheme!==b.Schemas.file)return c;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${c.fsPath}.`),c;const r=c.fsPath;let a=0;do{let f;a===0?f=r:f=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${a}`:`${r}-${a}`,await C(f);const g=O.$jc(f,"vscode.lock"),w=await h(this.d,g,!1);if(w)return this.i=w,process.on("exit",()=>{w.dispose()}),L.URI.file(f);a++}while(a<10);return c}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$koc=A;async function C(s){try{await k.Promises.stat(s);return}catch{}try{await k.Promises.mkdir(s,{recursive:!0})}catch{}}const p=1e3,y=10*60*1e3;class v extends N.$Uc{constructor(t,c){super(),this.b=t,this.c=c,this.a=this.B(new $.$Hh),this.a.cancelAndSet(async()=>{const r=await l(t,c);(!r||r.pid!==process.pid)&&(t.info(`Lock '${c}': The lock was lost unexpectedly.`),this.a.cancel());try{await k.Promises.utimes(c,new Date,new Date)}catch(a){t.error(a),t.info(`Lock '${c}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{d.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const c={pid:process.pid,willReleaseAt:Date.now()+t};await k.Promises.writeFile(this.c,JSON.stringify(c),{flag:"w"})}catch(c){this.b.error(c)}}}async function h(s,t,c){try{const a={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(t,JSON.stringify(a),{flag:"wx"})}catch(a){s.error(a)}const r=await l(s,t);return!r||r.pid!==process.pid?c?(s.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(s.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(s,t)):(s.info(`Lock '${t}': Lock acquired.`),new v(s,t))}async function l(s,t){let c;try{c=await k.Promises.readFile(t)}catch(r){return s.error(r),null}try{return JSON.parse(String(c))}catch(r){return s.error(r),null}}async function o(s,t){let c;try{c=await k.Promises.stat(t)}catch(r){return s.error(r),0}return c.mtime.getTime()}function n(s){try{return process.kill(s,0),!0}catch{return!1}}async function i(s,t){const c=await l(s,t);if(!c)return s.info(`Lock '${t}': Could not read pid of lock holder.`),u(s,t);if(c.willReleaseAt){let w=c.willReleaseAt-Date.now();if(w<5e3){for(w>0?s.info(`Lock '${t}': The lockfile is scheduled to be released in ${w} ms.`):s.info(`Lock '${t}': The lockfile is scheduled to have been released.`);w>0;){if(await(0,$.$xh)(Math.min(100,w)),await o(s,t)===0)return u(s,t);w=c.willReleaseAt-Date.now()}return u(s,t)}}if(!n(c.pid))return s.info(`Lock '${t}': The pid ${c.pid} appears to be gone.`),u(s,t);const r=await o(s,t),a=Date.now()-r;if(a<=y)return s.info(`Lock '${t}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null;s.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$xh)(2e3);const f=await o(s,t),g=Date.now()-f;return g<=y?(s.info(`Lock '${t}': The lock does not look stale, elapsed: ${g} ms, giving up.`),null):(s.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),u(s,t))}async function u(s,t){s.info(`Lock '${t}': Deleting a stale lock.`);try{await k.Promises.unlink(t)}catch{}return h(s,t,!0)}}),define(Se[368],De([1,0,30,20,43,34]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fnc=void 0;let N=class extends L.$emc{constructor($,k){super(!0,$,k)}createTerminal($,k,A){return this.createTerminalFromOptions({name:$,shellPath:k,shellArgs:A})}createTerminalFromOptions($,k){const A=new L.$dmc(this.a,(0,d.$Sg)(),$,$.name);return this.f.push(A),A.create($,this.R($,k)),A.value}};e.$Fnc=N,e.$Fnc=N=Ge([We(0,R.$VP),We(1,O.$zP)],N)}),define(Se[369],De([1,0,4,36,38,5]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=e.$tM=e.OutputChannelUpdateMode=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=void 0,e.$gM="text/x-code-output",e.$hM="output",e.$iM="Log",e.$jM="text/x-code-log-output",e.$kM="log",e.$lM="workbench.panel.output",e.$mM=new L.$Nj("inOutput",!1),e.$nM=new L.$Nj("activeLogOutput",!1),e.$oM=new L.$Nj("activeLogOutput.levelSettable",!1),e.$pM=new L.$Nj("activeLogOutput.level",""),e.$qM=new L.$Nj("activeLogOutput.levelIsDefault",!1),e.$rM=new L.$Nj("outputView.scrollLock",!1),e.$sM=(0,R.$wi)("outputService");var N;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(N||(e.OutputChannelUpdateMode=N={})),e.$tM={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new d.$de,this.onDidRegisterChannel=this.b.event,this.c=new d.$de,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(A=>k.push(A)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}O.$co.add(e.$tM.OutputChannels,new b),e.$uM=new L.$Nj("activeOutputChannel","")}),define(Se[158],De([1,0,6,5,20,25,11,369,70,28,60,194,21,18,33,4,3]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8mc=e.$7mc=void 0;class o extends N.$9j{get disposed(){return this.n}constructor(s,t,c,r,a){super(),this.id=s,this.name=t,this.r=c,this.s=r,this.extension=a,this.m=0,this.n=!1,this.visible=!1,this.setLevel(c.getLevel()),this.B(c.onDidChangeLogLevel(f=>this.setLevel(f)))}get logLevel(){return this.getLevel()}appendLine(s){this.append(s+`
`)}append(s){this.info(s)}clear(){const s=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,s)}replace(s){const t=this.m;this.info(s),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(s,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof s=="boolean"?s:t))}hide(){this.s.$close(this.id)}g(s,t){this.m+=p.$Fe.fromString(t).byteLength,(0,N.log)(this.r,s,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends o{appendLine(s){this.append(s)}}let i=class{constructor(s,t,c,r,a,f){this.i=t,this.j=c,this.k=r,this.l=a,this.m=f,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=s.getProxy(d.$$M.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(s){this.h=s;for(const[t,c]of this.g)c.visible=t===this.h}createOutputChannel(s,t,c){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,a=(0,y.$9f)(t)?t:void 0;if((0,y.$9f)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let f;const g=this.i.environment.extensionLogLevel?.find(([S])=>R.$Rm.equals(c.identifier,S))?.[1];g&&(f=(0,N.$hk)(g));const w=r?this.o(s,f,c):this.n(s,a,c);return w.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),r?this.r(s,f??this.m.getLevel(),w):this.q(s,w)}async n(s,t,c){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,a=this.k.extUri.joinPath(r,`${this.f++}-${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),f=this.l.createLogger(a,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),g=await this.a.$register(s,a,t,c.identifier.value);return new o(g,s,f,this.a,c)}async o(s,t,c){const r=await this.p(c),a=s.replace(/[\\/:\*\?"<>\|]/g,""),f=this.k.extUri.joinPath(r,`${a}.log`),g=`${c.identifier.value}.${a}`,w=this.l.createLogger(f,{id:g,name:s,logLevel:t,extensionId:c.identifier.value});return new n(g,s,w,this.a,c)}p(s){let t=this.d.get(s.identifier.value);if(!t){const c=this.k.extUri.joinPath(this.i.logsLocation,s.identifier.value);this.d.set(s.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(c)}catch(r){if((0,v.$gl)(r)!==v.FileSystemProviderErrorCode.FileExists)throw r}return c})())}return t}q(s,t){let c=!1;const r=()=>{if(c)throw new Error("Channel has been closed")};return{get name(){return s},append(a){r(),t.then(f=>f.append(a))},appendLine(a){r(),t.then(f=>f.appendLine(a))},clear(){r(),t.then(a=>a.clear())},replace(a){r(),t.then(f=>f.replace(a))},show(a,f){r(),t.then(g=>g.show(a,f))},hide(){r(),t.then(a=>a.hide())},dispose(){c=!0,t.then(a=>a.dispose())}}}r(s,t,c){const r=new l.$Tc,a=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},f=r.add(new h.$de);function g(w){t=w,f.fire(w)}return c.then(w=>{r.add(w),w.logLevel!==t&&g(w.logLevel),r.add(w.onDidChangeLogLevel(S=>g(S)))}),{...this.q(s,c),get logLevel(){return t},onDidChangeLogLevel:f.event,trace(w,...S){a(),c.then(m=>m.trace(w,...S))},debug(w,...S){a(),c.then(m=>m.debug(w,...S))},info(w,...S){a(),c.then(m=>m.info(w,...S))},warn(w,...S){a(),c.then(m=>m.warn(w,...S))},error(w,...S){a(),c.then(m=>m.error(w,...S))},dispose(){r.dispose()}}}};e.$7mc=i,e.$7mc=i=Ge([We(0,L.$zP),We(1,k.$PP),We(2,$.$Slc),We(3,A.$vlc),We(4,N.$4j),We(5,N.$3j)],i),e.$8mc=(0,O.$wi)("IExtHostOutputService")}),define(Se[159],De([1,0,5,7]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=void 0,e.$gn=(0,d.$wi)("remoteAgentService"),e.$hn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(L){let R=1/0;for(let b=0;b<this.maxSampleCount;b++){const $=await L.getRoundTripTime();if($===void 0)return;R=Math.min(R,$/2),await(0,O.$xh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let N;return this.initial.length<this.maxInitialCount?this.initial.push(R):N=this.initial.reduce((b,$)=>b+$,0)/this.initial.length,this.lastMeasurement={initial:N,current:R,average:this.average.reduce((b,$)=>b+$,0)/this.average.length,high:typeof N>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>N*this.highLatencyMultiple},this.lastMeasurement}}}),define(Se[370],De([1,0,237,66,36,42,55,3,4,159,12,24,7]),function(he,e,d,O,L,R,N,b,$,k,A,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=void 0,e.$KJ=Object.freeze({id:"application",order:100,title:(0,d.localize)(0,null),type:"object"}),e.$LJ=Object.freeze({id:"workbench",order:7,title:(0,d.localize)(1,null),type:"object"}),e.$MJ=Object.freeze({id:"security",scope:1,title:(0,d.localize)(2,null),type:"object",order:7}),e.$NJ=Object.freeze({id:"problems",title:(0,d.localize)(3,null),type:"object",order:101}),e.$OJ={ConfigurationMigration:"base.contributions.configuration.migration"};class y{constructor(){this.migrations=[],this.a=new $.$de,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const v=new y;L.$co.add(e.$OJ.ConfigurationMigration,v);let h=class extends b.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async u=>{for(const s of u.added)await this.f(s,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(u=>this.c(u)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(u=>this.g(u,n?.uri))])}async g(n,i){const u=this.a.inspect(n.key,{resource:i}),s=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,c]of s){const r=u[t];if(!r)continue;const a=[];if(r.value!==void 0){const f=await this.h(n,t,r.value,i,void 0);for(const g of f??[])a.push([g,[]])}for(const{identifiers:f,value:g}of r.overrides??[])if(g!==void 0){const w=await this.h(n,t,g,i,f);for(const S of w??[])a.push([S,f])}a.length&&await Promise.allSettled(a.map(async([[f,g],w])=>this.a.updateValue(f,g.value,{resource:i,overrideIdentifiers:w},c)))}}async h(n,i,u,s,t){const c=a=>{const g=this.a.inspect(a,{resource:s})[i];if(g)return t?g.overrides?.find(({identifiers:w})=>(0,C.$7n)(w,t))?.value:g.value},r=await n.migrateFn(u,c);return Array.isArray(r)?r:[[n.key,r]]}};e.$PJ=h,e.$PJ=h=Ge([We(0,N.$3i),We(1,R.$Fi)],h);let l=class extends b.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new p.$Th,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==1)return;L.$co.as(O.$ho.Configuration).registerConfiguration({...e.$MJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,d.localize)(4,null)},default:[],markdownDescription:(0,d.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,d.localize)(6,null),scope:2}}})}};e.$QJ=l,e.$QJ=l=Ge([We(0,k.$gn)],l)}),define(Se[371],De([1,0,35,15,17,23,247,370,66,5,36]),function(he,e,d,O,L,R,N,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$hhb=e.$ghb=void 0,e.$ihb=h,e.$jhb=l,e.$ghb=(0,k.$wi)("editorResolverService"),e.$hhb="workbench.editorAssociations";const C=A.$co.as($.$ho.Configuration),p={...b.$LJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,N.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(p);var y;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(y||(e.RegisteredEditorPriority=y={}));var v;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function h(o){switch(o){case y.exclusive:return 5;case y.default:return 4;case y.builtin:return 3;case y.option:default:return 1}}function l(o,n){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(n.scheme))return!1;const s=typeof o=="string"&&o.indexOf(L.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,R.$7g)(n);return d.$pk(typeof o=="string"?o.toLowerCase():o,s.toLowerCase())}}),define(Se[372],De([1,0,31,15,17,12,23,2,5,284,42,148,159]),function(he,e,d,O,L,R,N,b,$,k,A,C,p){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=void 0,e.$MM=(0,$.$wi)("pathService");let v=y=class{constructor(l,o,n,i){this.d=l,this.e=o,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const u=await this.e.getEnvironment();return this.c=u?.userHome??l})()}hasValidBasename(l,o,n){return typeof o=="string"||typeof o>"u"?this.a.then(i=>this.h(l,i,o)):this.h(l,o,n)}h(l,o,n){return l.scheme===O.Schemas.file||l.scheme===O.Schemas.vscodeRemote?(0,d.$tg)(n??(0,N.$7g)(l),o===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(l,o){if(l.remoteAuthority)return O.Schemas.vscodeRemote;const n=(0,k.$JM)(o.getWorkspace());if(n)return n;const i=o.getWorkspace().folders[0];if(i)return i.uri.scheme;const u=o.getWorkspace().configuration;return u?u.scheme:O.Schemas.file}userHome(l){return l?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(l=>l===1?L.$fc:L.$gc)}async fileURI(l){let o="";if(await this.a===1&&(l=l.replace(/\\/g,"/")),l[0]==="/"&&l[1]==="/"){const i=l.indexOf("/",2);i===-1?(o=l.substring(2),l="/"):(o=l.substring(2,i),l=l.substring(i)||"/")}return b.URI.from({scheme:O.Schemas.file,authority:o,path:l,query:"",fragment:""})}};e.$NM=v,e.$NM=v=y=Ge([We(1,p.$gn),We(2,C.$vM),We(3,A.$Fi)],v)}),define(Se[373],De([1,0,249,56,4,57,3,2,55,254,11,67,142,88,42,148,26,22,18,24,38]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=e.$FM=e.OnPortForward=e.$AM=e.$zM=e.TunnelSource=e.TunnelCloseReason=e.$xM=e.$wM=void 0,e.$yM=a,e.$BM=w,e.$CM=S,e.$DM=m,e.$EM=D;const s=10*1e3,t="remote.tunnels.toRestore",c="remote.tunnels.toRestoreExpiration",r=1e3*60*60*24*14;e.$wM="onTunnel",e.$xM=new u.$Nj("forwardedPortsViewEnabled",!1,d.localize(0,null));function a(F){const T=F.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(T)return{host:T[1]?.substring(0,T[1].length-1)||"localhost",port:Number(T[2])}}var f;(function(F){F.Other="Other",F.User="User",F.AutoForwardEnd="AutoForwardEnd"})(f||(e.TunnelCloseReason=f={}));var g;(function(F){F[F.User=0]="User",F[F.Auto=1]="Auto",F[F.Extension=2]="Extension"})(g||(e.TunnelSource=g={})),e.$zM={source:g.User,description:d.localize(1,null)},e.$AM={source:g.Auto,description:d.localize(2,null)};function w(F,T,z){const M=F.get(m(T,z));if(M)return M;if((0,y.$ow)(T))for(const j of y.$nw){const U=m(j,z);if(F.has(U))return F.get(U)}else if((0,y.$qw)(T))for(const j of y.$pw){const U=m(j,z);if(F.has(U))return F.get(U)}}function S(F,T,z){const M=w(F,T,z);if(M)return M;const j=(0,y.$qw)(T)?"localhost":(0,y.$ow)(T)?"0.0.0.0":void 0;if(j)return w(F,j,z)}function m(F,T){return F+":"+T}var E;(function(F){F.Notify="notify",F.OpenBrowser="openBrowser",F.OpenBrowserOnce="openBrowserOnce",F.OpenPreview="openPreview",F.Silent="silent",F.Ignore="ignore"})(E||(e.OnPortForward=E={}));function D(F){return F&&"host"in F&&typeof F.host=="string"&&"port"in F&&typeof F.port=="number"&&(!("detail"in F)||typeof F.detail=="string")&&(!("pid"in F)||typeof F.pid=="string")}class P extends N.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(T){super(),this.r=T,this.j=[],this.n=new L.$de,this.onDidChangeAttributes=this.n.event,this.B(T.onDidChangeConfiguration(z=>{(z.affectsConfiguration(P.c)||z.affectsConfiguration(P.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(T,z,M){let j=this.w(T,z,M,this.j,0);const U={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;j>=0;){const Z=this.j[j];Z.key===T?(U.onAutoForward=Z.onAutoForward??U.onAutoForward,U.elevateIfNeeded=Z.elevateIfNeeded!==void 0?Z.elevateIfNeeded:U.elevateIfNeeded,U.label=Z.label??U.label,U.requireLocalPort=Z.requireLocalPort,U.protocol=Z.protocol):(U.onAutoForward=U.onAutoForward??Z.onAutoForward,U.elevateIfNeeded=U.elevateIfNeeded!==void 0?U.elevateIfNeeded:Z.elevateIfNeeded,U.label=U.label??Z.label,U.requireLocalPort=U.requireLocalPort!==void 0?U.requireLocalPort:void 0,U.protocol=U.protocol??Z.protocol),j=this.w(T,z,M,this.j,j+1)}return U.onAutoForward!==void 0||U.elevateIfNeeded!==void 0||U.label!==void 0||U.requireLocalPort!==void 0||U.protocol!==void 0?U:this.C()}t(T){return T.start!==void 0&&T.end!==void 0}u(T){return T.host!==void 0&&T.port!==void 0&&(0,n.$9f)(T.host)&&(0,n.$ag)(T.port)}w(T,z,M,j,U){if(U>=j.length)return-1;const Z=!(0,y.$ow)(z)&&!(0,y.$qw)(z),q=j.slice(U).findIndex(G=>(0,n.$ag)(G.key)?Z?!1:G.key===T:this.t(G.key)?Z?!1:T>=G.key.start&&T<=G.key.end:this.u(G.key)?T===G.key.port&&z===G.key.host:M?G.key.test(M):!1);return q>=0?q+U:-1}y(){const T=this.r.getValue(P.c);if(!T||!(0,n.$$f)(T))return[];const z=[];for(const j in T){if(j===void 0)continue;const U=T[j];let Z;if(Number(j))Z=Number(j);else if((0,n.$9f)(j))if(P.g.test(j)){const ie=j.match(P.g);Z={start:Number(ie[1]),end:Number(ie[2])}}else if(P.h.test(j)){const ie=j.match(P.h);Z={host:ie[1],port:Number(ie[2])}}else{let ie;try{ie=RegExp(j)}catch{}ie&&(Z=ie)}Z&&z.push({key:Z,elevateIfNeeded:U.elevateIfNeeded,onAutoForward:U.onAutoForward,label:U.label,requireLocalPort:U.requireLocalPort,protocol:U.protocol})}const M=this.r.getValue(P.f);return M&&(this.m={elevateIfNeeded:M.elevateIfNeeded,label:M.label,onAutoForward:M.onAutoForward,requireLocalPort:M.requireLocalPort,protocol:M.protocol}),this.z(z)}z(T){function z(M,j){return(0,n.$ag)(M.key)?M.key:j.t(M.key)?M.key.start:j.u(M.key)?M.key.port:Number.MAX_VALUE}return T.sort((M,j)=>z(M,this)-z(j,this))}C(){return this.m}static providedActionToAction(T){switch(T){case y.ProvidedOnAutoForward.Notify:return E.Notify;case y.ProvidedOnAutoForward.OpenBrowser:return E.OpenBrowser;case y.ProvidedOnAutoForward.OpenBrowserOnce:return E.OpenBrowserOnce;case y.ProvidedOnAutoForward.OpenPreview:return E.OpenPreview;case y.ProvidedOnAutoForward.Silent:return E.Silent;case y.ProvidedOnAutoForward.Ignore:return E.Ignore;default:return}}async addAttributes(T,z,M){const U=this.r.inspect(P.c).userRemoteValue;let Z;!U||!(0,n.$$f)(U)?Z={}:Z=(0,i.$3n)(U),Z[`${T}`]||(Z[`${T}`]={});for(const ie in z)Z[`${T}`][ie]=z[ie];return this.r.updateValue(P.c,Z,M)}}e.$FM=P;let I=class extends N.$Uc{constructor(T,z,M,j,U,Z,ie,q,G,x){super(),this.H=T,this.I=z,this.J=M,this.L=j,this.M=U,this.N=Z,this.O=ie,this.P=q,this.Q=G,this.R=x,this.c=new Map,this.g=new L.$de,this.onForwardPort=this.g.event,this.h=new L.$de,this.onClosePort=this.h.event,this.j=new L.$de,this.onPortName=this.j.event,this.n=new L.$de,this.onCandidatesChanged=this.n.event,this.t=new L.$de,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new L.$de,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new P(M),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ne=>{const be=await this.getAttributes(ne.map(ae=>({port:ae.tunnelRemotePort,host:ae.tunnelRemoteHost})));for(const ae of ne)if(ae.localAddress){const Ce=m(ae.tunnelRemoteHost,ae.tunnelRemotePort),ee=S(this.m??new Map,ae.tunnelRemoteHost,ae.tunnelRemotePort);this.forwarded.set(Ce,{remotePort:ae.tunnelRemotePort,remoteHost:ae.tunnelRemoteHost,localAddress:ae.localAddress,protocol:be?.get(ae.tunnelRemotePort)?.protocol??y.TunnelProtocol.Http,localUri:await this.X(ae.localAddress,be?.get(ae.tunnelRemotePort)),localPort:ae.tunnelLocalPort,runningProcess:ee?.detail,hasRunningProcess:!!ee,pid:ee?.pid,privacy:ae.privacy,source:e.$zM}),this.f.set(Ce,ae)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ne=>{const be=m(ne.tunnelRemoteHost,ne.tunnelRemotePort);if(!S(this.forwarded,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&!S(this.detected,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&!S(this.c,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&ne.localAddress){const ae=S(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort),Ce=(await this.getAttributes([{port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost}]))?.get(ne.tunnelRemotePort);this.forwarded.set(be,{remoteHost:ne.tunnelRemoteHost,remotePort:ne.tunnelRemotePort,localAddress:ne.localAddress,protocol:Ce?.protocol??y.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,Ce),localPort:ne.tunnelLocalPort,closeable:!0,runningProcess:ae?.detail,hasRunningProcess:!!ae,pid:ae?.pid,privacy:ne.privacy,source:e.$zM})}await this.cb(),this.f.set(be,ne),this.g.fire(this.forwarded.get(be))})),this.B(this.H.onTunnelClosed(ne=>this.W(ne,f.Other))),this.U()}S(){return this.Q.extensions.find(T=>T.activationEvents?.includes(e.$wM))?(this.R.createKey(e.$xM.key,!0),!0):!1}U(){if(this.S())return;const T=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&T.dispose()}))}async W(T,z){const M=m(T.host,T.port);this.forwarded.has(M)&&(this.forwarded.delete(M),await this.cb(),this.h.fire(T))}X(T,z){if(T.startsWith("http"))return b.URI.parse(T);const M=z?.protocol??"http";return b.URI.parse(`${M}://${T}`)}async Y(T){const z=this.N.getWorkspace(),M=z.configuration?(0,R.$kj)(z.configuration.path):z.folders.length>0?(0,R.$kj)(z.folders[0].uri.path):void 0;if(M===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${T}.${this.L.remoteAuthority}.${M}`}async Z(){return this.Y(t)}async $(){return this.Y(c)}async ab(){const T=this.I.get(t,1);if(T)return this.I.remove(t,1),await this.cb(),T;const z=await this.Z();if(z)return this.I.get(z,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const T=await this.s;if(T&&T!==this.y){const z=JSON.parse(T)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${z.map(M=>M.remotePort).join(", ")}`);for(const M of z){const j=S(this.detected,M.remoteHost,M.remotePort);M.source.source!==g.Extension&&!j||M.source.source===g.Extension&&j?await this.fb({remote:{host:M.remoteHost,port:M.remotePort},local:M.localPort,name:M.name,elevateIfNeeded:!0,source:M.source}):M.source.source===g.Extension&&!j&&this.D.set(m(M.remoteHost,M.remotePort),M)}}}if(this.z=!0,this.C.fire(),!this.w){const T=await this.Z();this.w=this.B(new N.$Tc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async z=>{z.key===T&&(this.s=Promise.resolve(this.I.get(T,0)),await this.restoreForwarded())}))}}bb(){const T=this.I.keys(0,0).filter(z=>z.startsWith(c));for(const z of T){const M=this.I.getNumber(z,0);if(M&&M<Date.now()){this.s=Promise.resolve(void 0);const j=z.replace(c,t);this.I.remove(z,0),this.I.remove(j,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const T=Array.from(this.forwarded.values()),z=T.map(Z=>({remoteHost:Z.remoteHost,remotePort:Z.remotePort,localPort:Z.localPort,name:Z.name,localAddress:Z.localAddress,localUri:Z.localUri,protocol:Z.protocol,source:Z.source}));let M;T.length>0&&(M=JSON.stringify(z));const j=await this.Z(),U=await this.$();!M&&j&&U?(this.I.remove(j,0),this.I.remove(U,0)):M!==this.y&&j&&U&&(this.I.store(j,M,0,0),this.I.store(U,Date.now()+r,0,0)),this.y=M}}async eb(T,z,M){if(!T.tunnelLocalPort||!M?.requireLocalPort||T.tunnelLocalPort===z)return;const j=new Date;if(this.db.getTime()+s>j.getTime())return;this.db=j;const U=d.localize(3,null,z,T.tunnelRemotePort,T.tunnelLocalPort);return this.P.info(U)}async forward(T,z){return!this.z&&this.L.remoteAuthority&&await L.Event.toPromise(this.C.event),this.fb(T,z)}async fb(T,z){await this.Q.activateByEvent(e.$wM);const M=S(this.forwarded,T.remote.host,T.remote.port);z=z??(z!==null?(await this.getAttributes([T.remote]))?.get(T.remote.port):void 0);const j=T.local!==void 0?T.local:T.remote.port;let U;if(M)return this.hb(M,T,z);{const Z=this.L.remoteAuthority,ie=Z?{getAddress:async()=>(await this.M.resolveAuthority(Z)).authority}:void 0,q=m(T.remote.host,T.remote.port);this.c.set(q,!0),T=this.gb(q,T);const G=await this.H.openTunnel(ie,T.remote.host,T.remote.port,void 0,j,T.elevateIfNeeded?T.elevateIfNeeded:z?.elevateIfNeeded,T.privacy,z?.protocol);if(typeof G=="string")U=G;else if(G&&G.localAddress){const x=S(this.m??new Map,T.remote.host,T.remote.port),ne=G.protocol?G.protocol===y.TunnelProtocol.Https?y.TunnelProtocol.Https:y.TunnelProtocol.Http:z?.protocol??y.TunnelProtocol.Http,be={remoteHost:G.tunnelRemoteHost,remotePort:G.tunnelRemotePort,localPort:G.tunnelLocalPort,name:z?.label??T.name,closeable:!0,localAddress:G.localAddress,protocol:ne,localUri:await this.X(G.localAddress,z),runningProcess:x?.detail,hasRunningProcess:!!x,pid:x?.pid,source:T.source??e.$zM,privacy:G.privacy};return this.forwarded.set(q,be),this.f.set(q,G),this.c.delete(q),await this.cb(),await this.eb(G,j,z),this.g.fire(be),G}this.c.delete(q)}return U}gb(T,z){const M=this.D.has(T)?this.D:this.F.has(T)?this.F:void 0;if(M){const j=M.get(T);M.delete(T),j&&(z.name=j.name??z.name,z.local=("local"in j?j.local:"localPort"in j?j.localPort:void 0)??z.local,z.privacy=z.privacy)}return z}async hb(T,z,M){const j=M?.label??z.name;let U;(function(ie){ie[ie.None=0]="None",ie[ie.Fire=1]="Fire",ie[ie.Reopen=2]="Reopen"})(U||(U={}));let Z=U.None;switch(j!==T.name&&(T.name=j,Z=U.Fire),(M?.protocol||T.protocol!==y.TunnelProtocol.Http)&&M?.protocol!==T.protocol&&(z.source=T.source,Z=U.Reopen),z.privacy&&T.privacy!==z.privacy&&(Z=U.Reopen),Z){case U.Fire:{this.g.fire();break}case U.Reopen:await this.close(T.remoteHost,T.remotePort,f.User),await this.fb(z,M)}return S(this.f,z.remote.host,z.remote.port)}async name(T,z,M){const j=S(this.forwarded,T,z),U=m(T,z);if(j){j.name=M,await this.cb(),this.j.fire({host:T,port:z});return}else this.detected.has(U)&&(this.detected.get(U).name=M,this.j.fire({host:T,port:z}))}async close(T,z,M){const j=m(T,z),U=this.forwarded.get(j);return M===f.AutoForwardEnd&&U&&U.source.source===g.Auto&&this.F.set(j,{local:U.localPort,name:U.name,privacy:U.privacy}),await this.H.closeTunnel(T,z),this.W({host:T,port:z},M)}address(T,z){const M=m(T,z);return(this.forwarded.get(M)||this.detected.get(M))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(T){if(T)for(const z of T){const M=S(this.m??new Map,z.remoteAddress.host,z.remoteAddress.port),j=typeof z.localAddress=="string"?z.localAddress:m(z.localAddress.host,z.localAddress.port);this.detected.set(m(z.remoteAddress.host,z.remoteAddress.port),{remoteHost:z.remoteAddress.host,remotePort:z.remoteAddress.port,localAddress:j,protocol:y.TunnelProtocol.Http,localUri:this.X(j),closeable:!1,runningProcess:M?.detail,hasRunningProcess:!!M,pid:M?.pid,privacy:y.TunnelPrivacyId.ConstantPrivate,source:{source:g.Extension,description:d.localize(4,null)}}),this.H.setEnvironmentTunnel(z.remoteAddress.host,z.remoteAddress.port,j,y.TunnelPrivacyId.ConstantPrivate,y.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(T){this.r=T}async setCandidates(T){let z=T;this.r&&(z=await this.r(T));const M=this.ib(z);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(M.values()).map(j=>j.port).join(", ")}`),this.n.fire(M)}ib(T){const z=this.m??new Map,M=new Map;return this.m=M,T.forEach(j=>{const U=m(j.host,j.port);M.set(U,{host:j.host,port:j.port,detail:j.detail,pid:j.pid}),z.has(U)&&z.delete(U);const Z=S(this.forwarded,j.host,j.port);Z&&(Z.runningProcess=j.detail,Z.hasRunningProcess=!0,Z.pid=j.pid)}),z.forEach((j,U)=>{const Z=a(U);if(!Z)return;const ie=S(this.forwarded,Z.host,Z.port);ie&&(ie.runningProcess=void 0,ie.hasRunningProcess=!1,ie.pid=void 0);const q=S(this.detected,Z.host,Z.port);q&&(q.runningProcess=void 0,q.hasRunningProcess=!1,q.pid=void 0)}),z}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const T=Array.from(this.forwarded.values()),z=await this.getAttributes(T.map(M=>({port:M.remotePort,host:M.remoteHost})),!1);if(z)for(const M of T){const j=z.get(M.remotePort);(j?.protocol||M.protocol!==y.TunnelProtocol.Http)&&j?.protocol!==M.protocol&&await this.fb({remote:{host:M.remoteHost,port:M.remotePort},local:M.localPort,name:M.name,source:M.source},j),j&&j.label&&j.label!==M.name&&await this.name(M.remoteHost,M.remotePort,j.label)}}async getAttributes(T,z=!0){const M=new Map,j=new Map;T.forEach(G=>{const x=S(this.m??new Map,y.$nw[0],G.port)??G;if(x){M.set(G.port,x);const ne=D(x)?x.pid:void 0;j.has(ne)||j.set(ne,[]),j.get(ne)?.push(G.port)}});const U=new Map;if(T.forEach(G=>{const x=this.configPortsAttributes.getAttributes(G.port,G.host,M.get(G.port)?.detail);x&&U.set(G.port,x)}),this.G.length===0||!z)return U.size>0?U:void 0;const Z=await Promise.all(this.G.flatMap(G=>Array.from(j.entries()).map(x=>{const ne=x[1],be=M.get(ne[0]);return G.providePortAttributes(ne,be?.pid,be?.detail,o.CancellationToken.None)}))),ie=new Map;if(Z.forEach(G=>G.forEach(x=>{x&&ie.set(x.port,x)})),!U&&!ie)return;const q=new Map;return T.forEach(G=>{const x=U.get(G.port),ne=ie.get(G.port);q.set(G.port,{elevateIfNeeded:x?.elevateIfNeeded,label:x?.label,onAutoForward:x?.onAutoForward??P.providedActionToAction(ne?.autoForwardAction),requireLocalPort:x?.requireLocalPort,protocol:x?.protocol})}),q}addAttributesProvider(T){this.G.push(T)}};e.$GM=I,Ge([(0,O.$2h)(1e3)],I.prototype,"cb",null),e.$GM=I=Ge([We(0,y.$iw),We(1,p.$1p),We(2,$.$3i),We(3,h.$vM),We(4,C.$Hl),We(5,v.$Fi),We(6,A.$3j),We(7,k.$Nw),We(8,l.$LG),We(9,u.$Oj)],I)}),define(Se[94],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$fL=e.$eL=void 0;class d{constructor(N,b){this.line=N,this.character=b}isBefore(N){return!1}isBeforeOrEqual(N){return!1}isAfter(N){return!1}isAfterOrEqual(N){return!1}isEqual(N){return!1}compareTo(N){return 0}translate(N,b){return new d(0,0)}with(N){return new d(0,0)}}e.$eL=d;class O{constructor(N,b,$,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(N,b),this.end=new d($,k)}contains(N){return!1}isEqual(N){return!1}intersection(N){}union(N){return new O(0,0,0,0)}with(N){return new O(0,0,0,0)}}e.$fL=O;var L;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(L||(e.TextSearchCompleteMessageType=L={}))}),define(Se[37],De([1,0,19,35,24,31,14,5,17,13,94,7]),function(he,e,d,O,L,R,N,b,$,k,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.$CL=e.$vL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$sL=e.$rL=e.$qL=e.$pL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.TextSearchCompleteMessageType=void 0,e.$mL=o,e.$nL=n,e.$oL=i,e.$tL=w,e.$uL=S,e.$wL=D,e.$xL=P,e.$yL=I,e.$zL=F,e.$AL=T,e.$BL=z,e.$DL=j,e.$FL=ie,e.$GL=q,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$gL="workbench.view.search",e.$hL="workbench.panel.search",e.$iL="workbench.view.search",e.$jL="search-result",e.$kL="search.exclude";const p="\u27EA ",y=" characters skipped \u27EB",v=(p.length+y.length+5)*2;e.$lL=(0,b.$wi)("searchService");var h;(function(x){x[x.file=0]="file",x[x.text=1]="text",x[x.aiText=2]="aiText"})(h||(e.SearchProviderType=h={}));var l;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.aiText=3]="aiText"})(l||(e.QueryType=l={}));function o(x){return!!x.preview}function n(x){return!!x.resource}function i(x){return!!x.message}var u;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(u||(e.SearchCompletionExitCode=u={}));class s{constructor(ne){this.resource=ne,this.results=[]}}e.$pL=s;class t{constructor(ne,be,ae,Ce){this.ranges=be,this.webviewIndex=Ce;const ee=Array.isArray(be)?be:[be];if(ae&&ae.matchLines===1&&c(ee)){ne=(0,N.$2f)(ne,ae.matchLines);let B="",_=0,pe=0;const ue=Math.floor(ae.charsPerLine/5),ce=[];for(const oe of ee){const le=Math.max(oe.startColumn-ue,0),K=oe.startColumn+ae.charsPerLine;if(le>pe+ue+v){const se=p+(le-pe)+y;B+=se+ne.slice(le,K),_+=le-(pe+se.length)}else B+=ne.slice(pe,K);ce.push(new a(0,oe.startColumn-_,oe.endColumn-_)),pe=K}this.preview={text:B,matches:Array.isArray(this.ranges)?ce:ce[0]}}else{const B=Array.isArray(be)?be[0].startLineNumber:be.startLineNumber;this.preview={text:ne,matches:(0,d.$1b)(be,_=>new r(_.startLineNumber-B,_.startColumn,_.endLineNumber-B,_.endColumn))}}}}e.$qL=t;function c(x){const ne=x[0].startLineNumber;for(const be of x)if(be.startLineNumber!==ne||be.endLineNumber!==ne)return!1;return!0}class r{constructor(ne,be,ae,Ce){this.startLineNumber=ne,this.startColumn=be,this.endLineNumber=ae,this.endColumn=Ce}}e.$rL=r;class a extends r{constructor(ne,be,ae){super(ne,be,ne,ae)}}e.$sL=a;var f;(function(x){x.List="list",x.Tree="tree"})(f||(e.ViewMode=f={}));var g;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(g||(e.SearchSortOrder=g={}));function w(x,ne=!0){const be=x&&x.files&&x.files.exclude,ae=ne&&x&&x.search&&x.search.exclude;if(!be&&!ae)return;if(!be||!ae)return be||ae;let Ce=Object.create(null);return Ce=L.$6n(Ce,L.$3n(be)),Ce=L.$6n(Ce,L.$3n(ae),!0),Ce}function S(x,ne){return x.excludePattern&&O.$pk(x.excludePattern,ne)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&O.$pk(x.includePattern,ne)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(be=>{const ae=be.folder.fsPath;if(R.$vg(ne,ae)){const Ce=$.$lc(ae,ne);return!be.includePattern||!!O.$pk(be.includePattern,Ce)}else return!1}):!1:!0}var m;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(m||(e.SearchErrorCode=m={}));class E extends Error{constructor(ne,be){super(ne),this.code=be}}e.$vL=E;function D(x){const ne=x.message;if((0,k.$4)(x))return new E(ne,m.canceled);try{const be=JSON.parse(ne);return new E(be.message,be.code)}catch{return new E(ne,m.other)}}function P(x){const ne={message:x.message,code:x.code};return new Error(JSON.stringify(ne))}function I(x){return x.type==="error"?!0:x.type==="success"}function F(x){return x.type==="success"}function T(x){return!!x.path}function z(x,ne,be=!0){const ae=x.searchPath?x.searchPath:x.relativePath;return be?(0,N.$Yf)(ae,ne):O.$pk(ne,ae)}class M{constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$CL=M;function j(x,ne){const be={...x||{},...ne||{}};return Object.keys(be).filter(ae=>{const Ce=be[ae];return typeof Ce=="boolean"&&Ce})}class U{constructor(ne,be){this.c=null,this.a={...ne.excludePattern||{},...be.excludePattern||{}},this.b=O.$qk(this.a);let ae=ne.includePattern;be.includePattern&&(ae?ae={...ae,...be.includePattern}:ae=be.includePattern),ae&&(this.c=O.$qk(ae))}matchesExcludesSync(ne,be,ae){return!!(this.b&&this.b(ne,be,ae))}includedInQuerySync(ne,be,ae){return!(this.b&&this.b(ne,be,ae)||this.c&&!this.c(ne,be,ae))}includedInQuery(ne,be,ae){const Ce=this.b(ne,be,ae),ee=()=>this.c?!!this.c(ne,be,ae):!0;return(0,C.$ih)(Ce)?Ce.then(B=>B?!1:ee()):ee()}hasSiblingExcludeClauses(){return Z(this.a)}}e.$EL=U;function Z(x){for(const ne in x)if(typeof x[ne]!="boolean")return!0;return!1}function ie(x){if(!x)return;let ne;return be=>(ne||(ne=(x()||Promise.resolve([])).then(ae=>ae?G(ae):{})),ne.then(ae=>!!ae[be]))}function q(x){if(!x)return;let ne;return be=>{if(!ne){const ae=x();ne=ae?G(ae):{}}return!!ne[be]}}function G(x){const ne={};for(const be of x)ne[be]=!0;return ne}}),define(Se[44],De([1,0,19,7,22,4,3,78,15,126,23,14,2,235,5,11,268,42,60,28,20,16,8,68,37,6,58]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n,i,u,s,t,c,r,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=e.$Mlc=void 0;function g(F,T,z){return new A.$Yg(M=>E(M,z)).isEqual(F,T)}function w(F,T,z){return g(F.uri,T.uri,z)?0:(0,C.$qf)(F.uri.toString(),T.uri.toString())}function S(F,T,z){return F.index!==T.index?F.index<T.index?-1:1:g(F.uri,T.uri,z)?(0,C.$qf)(F.name,T.name):(0,C.$qf)(F.uri.toString(),T.uri.toString())}function m(F,T,z,M){const j=F.slice(0).sort((Z,ie)=>z(Z,ie,M)),U=T.slice(0).sort((Z,ie)=>z(Z,ie,M));return(0,d.$Eb)(j,U,(Z,ie)=>z(Z,ie,M))}function E(F,T){const z=T.getCapabilities(F.scheme);return!(z&&z&1024)}class D extends o.$Pi{static toExtHostWorkspace(T,z,M,j){if(!T)return{workspace:null,added:[],removed:[]};const{id:U,name:Z,folders:ie,configuration:q,transient:G,isUntitled:x}=T,ne=[],be=z;z?ie.forEach((B,_)=>{const pe=p.URI.revive(B.uri),ue=D.o(M||z,pe,j);ue?(ue.name=B.name,ue.index=B.index,ne.push(ue)):ne.push({uri:pe,name:B.name,index:_})}):ne.push(...ie.map(({uri:B,name:_,index:pe})=>({uri:p.URI.revive(B),name:_,index:pe}))),ne.sort((B,_)=>B.index<_.index?-1:1);const ae=new D(U,Z,ne,!!G,q?p.URI.revive(q):null,!!x,B=>E(B,j)),{added:Ce,removed:ee}=m(be?be.workspaceFolders:[],ae.workspaceFolders,w,j);return{workspace:ae,added:Ce,removed:ee}}static o(T,z,M){for(let j=0;j<T.folders.length;j++){const U=T.workspaceFolders[j];if(g(U.uri,z,M))return U}}constructor(T,z,M,j,U,Z,ie){super(T,M.map(q=>new o.$Qi(q)),j,U,ie),this.t=z,this.u=Z,this.q=[],this.s=b.$Ci.forUris(ie),M.forEach(q=>{this.q.push(q),this.s.set(q.uri,q)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(T,z){return z&&this.s.get(T)&&(T=(0,A.$9g)(T)),this.s.findSubstr(T)}resolveWorkspaceFolder(T){return this.s.get(T)}}let P=class{constructor(T,z,M,j,U){this.c=new R.$de,this.onDidChangeWorkspace=this.c.event,this.g=new R.$de,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$fe,this.C=new Map,this.h=j,this.s=M,this.t=U,this.j=new k.$Dm,this.k=new O.$vh,this.o=T.getProxy(a.$$M.MainThreadWorkspace),this.q=T.getProxy(a.$$M.MainThreadMessageService);const Z=z.workspace;this.l=Z?new D(Z.id,Z.name,[],!!Z.transient,Z.configuration?p.URI.revive(Z.configuration):null,!!Z.isUntitled,ie=>E(ie,M)):void 0}$initializeWorkspace(T,z){this.v=z,this.$acceptWorkspaceData(T),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?p.URI.from({scheme:$.Schemas.untitled,path:(0,A.$7g)((0,A.$9g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(T,z,M,...j){const U=[];if(Array.isArray(j)&&j.forEach(x=>{p.URI.isUri(x.uri)&&!U.some(ne=>g(ne.uri,x.uri,this.s))&&U.push({uri:x.uri,name:x.name||(0,A.$6g)(x.uri)})}),this.n||[z,M].some(x=>typeof x!="number"||x<0)||M===0&&U.length===0)return!1;const Z=this.x?this.x.workspaceFolders:[];if(z+M>Z.length)return!1;const ie=Z.slice(0);ie.splice(z,M,...U.map(x=>({uri:x.uri,name:x.name||(0,A.$6g)(x.uri),index:void 0})));for(let x=0;x<ie.length;x++){const ne=ie[x];if(ie.some((be,ae)=>ae!==x&&g(ne.uri,be.uri,this.s)))return!1}ie.forEach((x,ne)=>x.index=ne);const{added:q,removed:G}=m(Z,ie,S,this.s);if(q.length===0&&G.length===0)return!1;if(this.o){const x=T.displayName||T.name;this.o.$updateWorkspaceFolders(x,z,M,U).then(void 0,ne=>{this.n=void 0;const be={source:{identifier:T.identifier,label:T.displayName||T.name}};this.q.$showMessage(l.Severity.Error,(0,y.localize)(0,null,x,ne.toString()),be,[])})}return this.y(ie),!0}getWorkspaceFolder(T,z){if(this.x)return this.x.getWorkspaceFolder(T,z)}async getWorkspaceFolder2(T,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(T,z)}async resolveWorkspaceFolder(T){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(T)}getPath(){if(!this.x)return;const{folders:T}=this.x;if(T.length!==0)return T[0].uri.fsPath}getRelativePath(T,z){let M,j="";if(typeof T=="string"?(M=p.URI.file(T),j=T):typeof T<"u"&&(M=T,j=T.fsPath),!M)return j;const U=this.getWorkspaceFolder(M,!0);if(!U)return j;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let Z=(0,A.$_g)(U.uri,M);return z&&U.name&&(Z=`${U.name}/${Z}`),Z}y(T){this.x&&(this.n=D.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:T,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(T){const{workspace:z,added:M,removed:j}=D.toExtHostWorkspace(T,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:j}))}findFiles(T,z,M,j,U=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let Z="",ie=!0;return z===null?ie=!1:z!==void 0&&(typeof z=="string"?Z=z:Z=z.pattern),this.z(T,void 0,{exclude:Z,maxResults:M,useDefaultExcludes:ie,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},U)}findFiles2(T,z={},M,j=L.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${M.value}, entryPoint: findFiles2`),this.z(void 0,T,z,j)}async z(T,z,M,j=L.CancellationToken.None){if(j&&j.isCancellationRequested)return Promise.resolve([]);const U=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,Z={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof M.useDefaultSearchExcludes=="boolean"?!M.useDefaultSearchExcludes:!1,maxResults:M.maxResults,excludePattern:U,shouldGlobSearch:typeof M.fuzzy=="boolean"?!M.fuzzy:!0,_reason:"startFileSearch"};let ie;if(T){const{includePattern:q,folder:G}=I(s.GlobPattern.from(T));ie=G,Z.includePattern=q}else{const{includePattern:q,folder:G}=I(s.GlobPattern.from(z));ie=G,Z.filePattern=q}return this.o.$startFileSearch(ie??null,Z,j).then(q=>Array.isArray(q)?q.map(G=>p.URI.revive(G)):[])}async findTextInFiles(T,z,M,j,U=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const Z=this.j.getNext(),ie=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:q,folder:G}=I(s.GlobPattern.from(z.include)),x=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ne={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:ie,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:q,excludePattern:x},be=!1;if(this.u[Z]=ae=>{if(be)return;const Ce=p.URI.revive(ae.resource);ae.results.forEach(ee=>{const B=(0,f.$6h)(ee);(0,r.$mL)(B)?M({uri:Ce,preview:{text:B.preview.text,matches:(0,d.$1b)(B.preview.matches,_=>new t.$cN(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))},ranges:(0,d.$1b)(B.ranges,_=>new t.$cN(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))}):M({uri:Ce,text:B.text,lineNumber:B.lineNumber})})},U.isCancellationRequested)return{};try{const ae=await this.o.$startTextSearch(T,G??null,ne,Z,U);return delete this.u[Z],ae||{}}catch(ae){throw delete this.u[Z],ae}}$handleTextSearchResult(T,z){this.u[z]?.(T)}async save(T){const z=await this.o.$save(T,{saveAs:!1});return p.URI.revive(z)}async saveAs(T){const z=await this.o.$save(T,{saveAs:!0});return p.URI.revive(z)}saveAll(T){return this.o.$saveAll(T)}resolveProxy(T){return this.o.$resolveProxy(T)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(T){return this.o.$requestWorkspaceTrust(T)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(T,z){if(this.w.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.w.set(T,z);const M=this.t.transformOutgoingScheme(T),j=this.A++;return this.o.$registerEditSessionIdentityProvider(j,M),(0,N.$Sc)(()=>{this.w.delete(T),this.o.$unregisterEditSessionIdentityProvider(j)})}async $getEditSessionIdentifier(T,z){this.h.info("Getting edit session identifier for workspaceFolder",T);const M=await this.resolveWorkspaceFolder(p.URI.revive(T));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const j=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!j),!j)return;const U=await j.provideEditSessionIdentity(M,z);if(this.h.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(T,z,M,j){this.h.info("Getting edit session identifier for workspaceFolder",T);const U=await this.resolveWorkspaceFolder(p.URI.revive(T));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const Z=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!Z),!Z)return;const ie=await Z.provideEditSessionIdentityMatch?.(z,M,j);if(this.h.info("Provider returned edit session identifier match result: ",ie),!!ie)return ie}getOnWillCreateEditSessionIdentityEvent(T){return(z,M,j)=>{const U=function(ie){z.call(M,ie)};return U.extension=T,this.B.event(U,void 0,j)}}async $onWillCreateEditSessionIdentity(T,z,M){const j=await this.resolveWorkspaceFolder(p.URI.revive(T));if(j===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:j},z,async(U,Z)=>{const ie=Date.now();await Promise.resolve(U),Date.now()-ie>M&&this.h.warn("SLOW edit session create-participant",Z.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(T,z){if(this.C.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.C.set(T,z);const M=this.t.transformOutgoingScheme(T),j=this.A++;return this.o.$registerCanonicalUriProvider(j,M),(0,N.$Sc)(()=>{this.C.delete(T),this.o.$unregisterCanonicalUriProvider(j)})}async provideCanonicalUri(T,z,M){const j=this.C.get(T.scheme);if(!j)return;const U=await j.provideCanonicalUri?.(p.URI.revive(T),z,M);if(U)return U}async $provideCanonicalUri(T,z,M){return this.provideCanonicalUri(p.URI.revive(T),{targetScheme:z},M)}};e.$Mlc=P,e.$Mlc=P=Ge([We(0,u.$zP),We(1,i.$PP),We(2,n.$vlc),We(3,h.$3j),We(4,c.$Klc)],P),e.$Nlc=(0,v.$wi)("IExtHostWorkspace");function I(F){let T,z;return F&&(typeof F=="string"?T=F:(T=F.pattern,z=p.URI.revive(F.baseUri))),{includePattern:T,folder:z}}}),define(Se[45],De([1,0,24,4,44,6,8,270,66,18,7,5,20,11,2]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=e.$Plc=e.$Olc=void 0;function h(c,r){if(r){const a=r.split(".");let f=c;for(let g=0;f&&g<a.length;g++)f=f[a[g]];return f}}function l(c){return c instanceof v.URI}function o(c){return c&&c.uri instanceof v.URI&&c.languageId&&typeof c.languageId=="string"}function n(c){return c&&!c.uri&&c.languageId&&typeof c.languageId=="string"}function i(c){return c&&c.uri instanceof v.URI&&(!c.name||typeof c.name=="string")&&(!c.index||typeof c.index=="number")}function u(c){if(l(c))return{resource:c};if(o(c))return{resource:c.uri,overrideIdentifier:c.languageId};if(n(c))return{overrideIdentifier:c.languageId};if(i(c))return{resource:c.uri};if(c===null)return{resource:null}}let s=class{constructor(r,a,f){this.a=r.getProxy(R.$$M.MainThreadConfiguration),this.c=a,this.b=f,this.d=new A.$vh,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,a){this.getConfigProvider().then(f=>f.$acceptConfigurationChanged(r,a))}};e.$Olc=s,e.$Olc=s=Ge([We(0,p.$zP),We(1,L.$Nlc),We(2,y.$3j)],s);class t{constructor(r,a,f,g){this.a=new O.$de,this.b=r,this.f=g,this.c=a,this.e=b.$Ao.parse(f,g),this.d=this.k(f.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,a){const f={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$Ao.parse(r,this.f),this.d=this.k(r.configurationScopes),this.a.fire(this.j(a,f))}getConfiguration(r,a,f){const g=u(a)||{},w=this.g(r?h(this.e.getValue(void 0,g,this.c.workspace),r):this.e.getValue(void 0,g,this.c.workspace));r&&this.h(r,g,f?.identifier);function S(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case N.ConfigurationTarget.Global:return 2;case N.ConfigurationTarget.Workspace:return 5;case N.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(E){return typeof h(w,E)<"u"},get:(E,D)=>{this.h(r?`${r}.${E}`:E,g,f?.identifier);let P=h(w,E);if(typeof P>"u")P=D;else{let I;const F=(T,z)=>{if((0,k.$$f)(T)){let M;const j=()=>{I=I||(0,d.$3n)(w),M=M||h(I,z)};return new Proxy(T,{get:(U,Z)=>{if(typeof Z=="string"&&Z.toLowerCase()==="tojson")return j(),()=>M;if(I)return M=M||h(I,z),M[Z];const ie=U[Z];return typeof Z=="string"?F(ie,`${z}.${Z}`):ie},set:(U,Z,ie)=>(j(),M&&(M[Z]=ie),!0),deleteProperty:(U,Z)=>(j(),M&&delete M[Z],!0),defineProperty:(U,Z,ie)=>(j(),M&&Object.defineProperty(M,Z,ie),!0)})}return Array.isArray(T)?(0,d.$3n)(T):T};P=F(P,E)}return P},update:(E,D,P,I)=>{E=r?`${r}.${E}`:E;const F=S(P);return D!==void 0?this.b.$updateConfigurationOption(F,E,D,g,I):this.b.$removeConfigurationOption(F,E,g,I)},inspect:E=>{E=r?`${r}.${E}`:E;const D=this.e.inspect(E,g,this.c.workspace);if(D)return{key:E,defaultValue:(0,d.$3n)(D.policy?.value??D.default?.value),globalValue:(0,d.$3n)(D.user?.value??D.application?.value),workspaceValue:(0,d.$3n)(D.workspace?.value),workspaceFolderValue:(0,d.$3n)(D.workspaceFolder?.value),defaultLanguageValue:(0,d.$3n)(D.default?.override),globalLanguageValue:(0,d.$3n)(D.user?.override??D.application?.override),workspaceLanguageValue:(0,d.$3n)(D.workspace?.override),workspaceFolderLanguageValue:(0,d.$3n)(D.workspaceFolder?.override),languageIds:(0,d.$3n)(D.overrideIdentifiers)}}};return typeof w=="object"&&(0,d.$6n)(m,w,!1),Object.freeze(m)}g(r){const a=f=>(0,k.$$f)(f)?new Proxy(f,{get:(g,w)=>a(g[w]),set:(g,w,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(g,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(g,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):f;return a(r)}h(r,a,f){const g=$.$ro.test(r)?4:this.d.get(r),w=f?`[${f.value}] `:"";if(g===4){typeof a?.resource>"u"&&this.f.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){a?.resource&&this.f.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,a){const f=new b.$Co(r,a,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(g,w)=>f.affectsConfiguration(g,u(w))})}k(r){return r.reduce((a,f)=>(a.set(f[0],f[1]),a),new Map)}}e.$Plc=t,e.$Qlc=(0,C.$wi)("IExtHostConfiguration")}),define(Se[95],De([1,0,2,7,4,6,8,44,73,45,22,43,20,28,5,15,12,11,91,314,13]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=e.$hnc=e.$gnc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(F){function T(M){if(M!=null)return M}F.from=T;function z(M){if(M!=null)return M}F.to=z})(s||(s={}));var t;(function(F){function T(M){if(M!=null)return M}F.from=T;function z(M){if(M!=null)return M}F.to=z})(t||(t={}));var c;(function(F){function T(M){if(M!=null)return M}F.from=T;function z(M){if(M!=null)return M}F.to=z})(c||(c={}));var r;(function(F){function T(j){if(j){const U=j;return U&&!!U.process}else return!1}F.is=T;function z(j){if(j==null)return;const U={process:j.process,args:j.args};return j.options&&(U.options=c.from(j.options)),U}F.from=z;function M(j){if(j!=null)return new N.$WN(j.process,j.args,j.options)}F.to=M})(r||(r={}));var a;(function(F){function T(M){if(M!=null)return M}F.from=T;function z(M){if(M!=null)return M}F.to=z})(a||(a={}));var f;(function(F){function T(j){if(j){const U=j;return U&&(!!U.commandLine||!!U.command)}else return!1}F.is=T;function z(j){if(j==null)return;const U={};return j.commandLine!==void 0?U.commandLine=j.commandLine:(U.command=j.command,U.args=j.args),j.options&&(U.options=a.from(j.options)),U}F.from=z;function M(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new N.$XN(j.commandLine,j.options):new N.$XN(j.command,j.args?j.args:[],j.options)}F.to=M})(f||(f={}));var g;(function(F){function T(j){if(j){const U=j;return U&&U.customExecution==="customExecution"}else return!1}F.is=T;function z(j){return{customExecution:"customExecution"}}F.from=z;function M(j,U){return U.get(j)}F.to=M})(g||(e.CustomExecutionDTO=g={}));var w;(function(F){function T(z,M){let j;return z.scope!==void 0&&typeof z.scope!="number"?j=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===N.TaskScope.Workspace&&M&&M.workspaceFile?j=M.workspaceFile:j=i.$dI),{id:z._id,workspaceFolder:j}}F.from=T})(w||(e.TaskHandleDTO=w={}));var S;(function(F){function T(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}F.from=T})(S||(S={}));var m;(function(F){function T(j,U){if(j==null)return[];const Z=[];for(const ie of j){const q=z(ie,U);q&&Z.push(q)}return Z}F.fromMany=T;function z(j,U){if(j==null)return;let Z;j.execution instanceof N.$WN?Z=r.from(j.execution):j.execution instanceof N.$XN?Z=f.from(j.execution):j.execution&&j.execution instanceof N.$YN&&(Z=g.from(j.execution));const ie=s.from(j.definition);let q;return j.scope?typeof j.scope=="number"?q=j.scope:q=j.scope.uri:q=N.TaskScope.Workspace,!ie||!q?void 0:{_id:j._id,definition:ie,name:j.name,source:{extensionId:U.identifier.value,label:j.source,scope:q},execution:Z,isBackground:j.isBackground,group:S.from(j.group),presentationOptions:t.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}F.from=z;async function M(j,U,Z){if(j==null)return;let ie;r.is(j.execution)?ie=r.to(j.execution):f.is(j.execution)?ie=f.to(j.execution):g.is(j.execution)&&(ie=g.to(j._id,Z));const q=s.to(j.definition);let G;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?G=j.source.scope:G=await U.resolveWorkspaceFolder(d.URI.revive(j.source.scope)):G=N.TaskScope.Workspace),!q||!G)return;const x=new N.$ZN(q,G,j.name,j.source.label,ie,j.problemMatchers);return j.isBackground!==void 0&&(x.isBackground=j.isBackground),j.group!==void 0&&(x.group=N.$VN.from(j.group._id),x.group&&j.group.isDefault&&(x.group=new N.$VN(x.group.id,x.group.label),j.group.isDefault===!0&&(x.group.isDefault=j.group.isDefault))),j.presentationOptions&&(x.presentationOptions=t.to(j.presentationOptions)),j._id&&(x._id=j._id),j.detail&&(x.detail=j.detail),x}F.to=M})(m||(e.TaskDTO=m={}));var E;(function(F){function T(M){return M}F.from=T;function z(M){if(M)return Object.assign(Object.create(null),M)}F.to=z})(E||(E={}));class D{#e;constructor(T,z,M){this._id=z,this.a=M,this.#e=T}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}let P=class{constructor(T,z,M,j,U,Z,ie,q){this.q=new L.$de,this.r=new L.$de,this.s=new L.$de,this.u=new L.$de,this.a=T.getProxy(R.$$M.MainThreadTask),this.b=M,this.c=j,this.d=U,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ie,this.g=q,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,z,M){if(!M)return new N.$aN(()=>{});const j=this.x();return this.j.set(j,{type:z,provider:M,extension:T}),this.a.$registerTaskProvider(j,z),new N.$aN(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(T,z){this.a.$registerTaskSystem(T,z)}fetchTasks(T){return this.a.$fetchTasks(E.from(T)).then(async z=>{const M=[];for(const j of z){const U=await m.to(j,this.b,this.m);U&&M.push(U)}return M})}get taskExecutions(){const T=[];return this.k.forEach(z=>T.push(z)),T}terminateTask(T){if(!(T instanceof D))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,z,M){const j=this.m.get(T.id);j&&(this.o.set(T.id,j),this.e.attachPtyToTerminal(z,await j.callback(M))),this.p=T.id,this.q.fire({execution:await this.z(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){if(!this.l.has(T.id))return;const z=await this.z(T);this.l.delete(T.id),this.k.delete(T.id),this.B(T),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const z=await this.z(T.id);this.s.fire({execution:z,processId:T.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(T){const z=await this.z(T.id);this.u.fire({execution:z,exitCode:T.exitCode})}$provideTasks(T,z){const M=this.j.get(T);if(!M)return Promise.reject(new Error("no handler found"));const j=[],U=(0,O.$oh)(()=>M.provider.provideTasks(A.CancellationToken.None)).then(Z=>this.v(z,j,M,Z));return new Promise(Z=>{U.then(ie=>{Promise.all(j).then(()=>{Z(ie)})})})}async $resolveTask(T,z){const M=this.j.get(T);if(!M)return Promise.reject(new Error("no handler found"));if(z.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${M.type}].`);const j=await m.to(z,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const U=await M.provider.resolveTask(j,A.CancellationToken.None);if(!U)return;this.A(U,M);const Z=m.from(U,M.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(Z.execution)&&await this.y(Z,U,!0),await this.w(Z)}x(){return this.h++}async y(T,z,M){const j=await this.a.$createTaskId(T);!M&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,z.execution)),this.m.set(j,z.execution)}async z(T,z){if(typeof T=="string"){const U=this.l.get(T);if(!U)throw new u.$bb("Unexpected: The specified task is missing an execution");return U}const M=this.l.get(T.id);if(M)return M;let j;return z?j=Promise.resolve(new D(this,T.id,z)):j=m.to(T.task,this.b,this.m).then(U=>{if(!U)throw new u.$bb("Unexpected: Task does not exist.");return new D(this,T.id,U)}),this.l.set(T.id,j),j.then(U=>(this.k.set(T.id,U),U))}A(T,z){T._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}B(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const M=this.n.values();let j=M.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=M.next()}};e.$gnc=P,e.$gnc=P=Ge([We(0,p.$zP),We(1,y.$PP),We(2,b.$Nlc),We(3,$.$KP),We(4,k.$Qlc),We(5,C.$cmc),We(6,o.$3j),We(7,n.$rlc)],P);let I=class extends P{constructor(T,z,M,j,U,Z,ie,q){super(T,z,M,j,U,Z,ie,q),this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:l.$h(0)})}async executeTask(T,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const M=m.from(z,T);if(M===void 0)throw new Error("Task is not valid");if(g.is(M.execution))await this.y(M,z,!1);else throw new u.$_;const j=await this.z(await this.a.$getTaskExecution(M),z);return this.a.$executeTask(M).catch(U=>{throw new Error(U)}),j}v(T,z,M,j){const U=[];if(j)for(const Z of j){if(this.A(Z,M),!Z.definition||!T[Z.definition.type]){const q=Z.source?Z.source:"No task source";this.f.warn(`The task [${q}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`)}const ie=m.from(Z,M.extension);ie&&g.is(ie.execution)?(U.push(ie),z.push(this.y(ie,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:U,extension:M.extension}}async w(T){if(g.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,z,M){}};e.$hnc=I,e.$hnc=I=Ge([We(0,p.$zP),We(1,y.$PP),We(2,b.$Nlc),We(3,$.$KP),We(4,k.$Qlc),We(5,C.$cmc),We(6,o.$3j),We(7,n.$rlc)],I),e.$inc=(0,v.$wi)("IExtHostTask")}),define(Se[374],De([1,0,37,29]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NL=void 0,e.$ML=L,e.$OL=R;function L(N){return"cellResults"in N}e.$NL="rawCell#";function R(N,b){let $=-1;const k=[];let A=[];return N.forEach(p=>{p.range.startLineNumber!==$&&A.length>0&&(k.push([...A]),A=[]),A.push(p),$=p.range.endLineNumber}),A.length>0&&k.push([...A]),k.map(p=>{const y=[],v=p[0].range.startLineNumber,h=p[p.length-1].range.endLineNumber;for(let l=v;l<=h;l++)y.push(b.getLineContent(l));return new d.$qL(y.join(`
`)+`
`,p.map(l=>new O.$ut(l.range.startLineNumber-1,l.range.startColumn-1,l.range.endLineNumber-1,l.range.endColumn-1)))})}}),define(Se[375],De([1,0,229,21,4,3,27,14,18,2,33,112,6,34,16,8,48,345,154,24,15,304,374,371]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n,i,u,s,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=void 0;class r{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(f=>f.apiEditor)}constructor(f,g,w,S,m,E){this.q=w,this.r=S,this.s=m,this.t=E,this.f=new Map,this.g=new N.$Ac,this.h=new Map,this.j=new L.$de,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new L.$de,this.onDidOpenNotebookDocument=this.m.event,this.n=new L.$de,this.onDidCloseNotebookDocument=this.n.event,this.o=new L.$de,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$plc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=f.getProxy(p.$$M.MainThreadNotebook),this.c=f.getProxy(p.$$M.MainThreadNotebookDocuments),this.d=f.getProxy(p.$$M.MainThreadNotebookEditors),this.i=g.converter,g.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===13){const P=D.notebookEditor?.notebookUri,I=D.cell.handle,T=this.g.get(P)?.getCell(I);if(T)return T.apiCell}if(D&&D.$mid===14){const P=D.uri,I=this.g.get(P);if(I)return I.apiNotebook}return D}}),r.B(g)}getEditorById(f){const g=this.h.get(f);if(!g)throw new Error(`unknown text editor: ${f}. known editors: ${[...this.h.keys()]} `);return g}getIdByEditor(f){for(const[g,w]of this.h)if(w.apiEditor===f)return g}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(f,g){const w=this.g.get(f);if(!w&&!g)throw new Error(`NO notebook document for '${f}'`);return w}static u(f,g){if(!g)return;const w=g.filenamePattern.map(S=>v.NotebookExclusiveDocumentPattern.from(S)).filter(S=>S!==void 0);if(g.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${g.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:g.displayName,filenamePattern:w,exclusive:g.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,g,w){const S=r.a++,m=typeof w.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set(S,w),this.b.$registerNotebookCellStatusBarItemProvider(S,m,g);let E;return m!==void 0&&(E=w.onDidChangeCellStatusBarItems(D=>this.b.$emitCellStatusBarEvent(m))),new h.$aN(()=>{this.f.delete(S),this.b.$unregisterNotebookCellStatusBarItemProvider(S,m),E?.dispose()})}async createNotebookDocument(f){const g=await this.c.$tryCreateNotebook({viewType:f.viewType,content:f.content&&v.NotebookData.from(f.content)});return k.URI.revive(g)}async openNotebookDocument(f){const g=this.g.get(f);if(g)return g.apiNotebook;const w=await this.c.$tryOpenNotebook(f),S=this.g.get(k.URI.revive(w));return(0,$.$hg)(S?.apiNotebook)}async showNotebookDocument(f,g){k.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let w;typeof g=="object"?w={position:v.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selections:g.selections&&g.selections.map(v.NotebookRange.from),pinned:typeof g.preview=="boolean"?!g.preview:void 0}:w={preserveFocus:!1};const S=await this.d.$tryShowNotebookDocument(f.uri,f.notebookType,w),m=S&&this.h.get(S)?.apiEditor;if(m)return m;throw S?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,g,w,S){const m=this.f.get(f),E=k.URI.revive(g),D=this.g.get(E);if(!D||!m)return;const P=D.getCellFromIndex(w);if(!P)return;const I=await m.provideCellStatusBarItems(P.apiCell,S);if(!I)return;const F=new R.$Tc,T=this.p.add([F]),M=(Array.isArray(I)?I:[I]).map(j=>v.NotebookStatusBarItem.from(j,this.i,F));return{cacheId:T,items:M}}$releaseNotebookCellStatusBarItems(f){this.p.delete(f)}registerNotebookSerializer(f,g,w,S,m){if((0,b.$7e)(g))throw new Error("viewType cannot be empty or just whitespace");const E=this.w++;return this.x.set(E,{viewType:g,serializer:w,options:S}),this.b.$registerNotebookSerializer(E,{id:f.identifier,location:f.extensionLocation},g,v.NotebookDocumentContentOptions.from(S),r.u(f,m)),(0,R.$Sc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(f,g,w){const S=this.x.get(f);if(!S)throw new Error("NO serializer found");const m=await S.serializer.deserializeNotebook(g.buffer,w);return new l.$Bw(v.NotebookData.from(m))}async $notebookToData(f,g,w){const S=this.x.get(f);if(!S)throw new Error("NO serializer found");const m=await S.serializer.serializeNotebook(v.NotebookData.to(g.value),w);return O.$Fe.wrap(m)}async $saveNotebook(f,g,w,S,m){const E=k.URI.revive(g),D=this.x.get(f);if(!D)throw new Error("NO serializer found");const P=this.g.get(E);if(!P)throw new Error("Document NOT found");if(P.versionId!==w)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new A.$ll((0,d.localize)(0,null,this.z(E)),6);await this.y(E,S);const I={metadata:(0,i.$$n)(P.apiNotebook.metadata,j=>!(D.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of P.apiNotebook.getCells()){const U=new h.$DO(j.kind,j.document.getText(),j.document.languageId,j.mime,D.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);U.metadata=(0,i.$$n)(j.metadata,Z=>!(D.options?.transientCellMetadata??{})[Z]),I.cells.push(U)}const F=await D.serializer.serializeNotebook(I,m);await this.s.value.writeFile(E,F);const T=this.s.getFileSystemProviderExtUri(E.scheme),z=await this.s.value.stat(E);return{name:T.basename(E),isFile:(z.type&A.FileType.File)!==0,isDirectory:(z.type&A.FileType.Directory)!==0,isSymbolicLink:(z.type&A.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((z.permissions??0)&A.FilePermission.Locked),etag:A.$wl({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks(f,g,w,S,m){const E=this.x.get(f)?.serializer;if(!E)return{limitHit:!1,results:[]};const D=new N.$Bc;await(async(z,M,j)=>{await Promise.all(z.map(async U=>await Promise.all(U.filenamePatterns.map(Z=>{const ie={_reason:j._reason,folderQueries:j.folderQueries,includePattern:j.includePattern,excludePattern:j.excludePattern,maxResults:j.maxResults,type:1,filePattern:Z};return this.t.doInternalFileSearchWithCustomCallback(ie,M,q=>{q.forEach(G=>{D.has(G)||S.some(ne=>U.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(be=>(0,c.$jhb)(be,G)))||D.add(G)})}).catch(q=>{if(q.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw q})}))))})(w,m,g);const I=new N.$Ac;let F=!1;const T=Array.from(D).map(async z=>{const M=[];try{if(m.isCancellationRequested)return;if(g.maxResults&&[...I.values()].reduce((ie,q)=>ie+q.cellResults.length,0)>g.maxResults){F=!0;return}const j=[],U=this.g.get(z);if(U)U.apiNotebook.getCells().forEach(q=>j.push({input:q.document.getText(),outputs:q.outputs.flatMap(G=>G.items.map(x=>x.data.toString()))}));else{const ie=await this.s.value.readFile(z),q=O.$Fe.fromString(ie.toString()),G=await E.deserializeNotebook(q.buffer,m);if(m.isCancellationRequested)return;v.NotebookData.from(G).cells.forEach(ne=>j.push({input:ne.source,outputs:ne.outputs.flatMap(be=>be.items.map(ae=>ae.valueBytes.toString()))}))}if(m.isCancellationRequested)return;j.forEach((ie,q)=>{const G=g.contentPattern.pattern,x=new s.$nXb(ie.input,void 0,ie.outputs),ne=x.findInInputs(G),be=x.findInOutputs(G),ae=be.flatMap(Ce=>(0,t.$OL)(Ce.matches,Ce.textBuffer)).map((Ce,ee)=>(Ce.webviewIndex=ee,Ce));if(ne.length>0||be.length>0){const Ce={index:q,contentResults:(0,t.$OL)(ne,x.inputTextBuffer),webviewResults:ae};M.push(Ce)}});const Z={resource:z,cellResults:M};I.set(z,Z);return}catch{return}});return await Promise.all(T),{limitHit:F,results:[...I.values()]}}async y(f,g){const w=await this.s.value.stat(f);if(typeof g?.mtime=="number"&&typeof g.etag=="string"&&g.etag!==A.$vl&&typeof w.mtime=="number"&&typeof w.size=="number"&&g.mtime<w.mtime&&g.etag!==A.$wl({mtime:g.mtime,size:w.size}))throw new A.$ll((0,d.localize)(1,null),3,g)}z(f){return f.scheme===u.Schemas.file?f.fsPath:f.toString()}A(f,g,w){if(this.h.has(g))throw new Error(`editor with id ALREADY EXSIST: ${g}`);const S=new n.$Mmc(g,this.d,f,w.visibleRanges.map(v.NotebookRange.to),w.selections.map(v.NotebookRange.to),typeof w.viewColumn=="number"?v.ViewColumn.to(w.viewColumn):void 0);this.h.set(g,S)}$acceptDocumentAndEditorsDelta(f){if(f.value.removedDocuments)for(const w of f.value.removedDocuments){const S=k.URI.revive(w),m=this.g.get(S);m&&(m.dispose(),this.g.delete(S),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:m.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(m.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===S.toString()&&this.h.delete(E.id)}if(f.value.addedDocuments){const w=[];for(const S of f.value.addedDocuments){const m=k.URI.revive(S.uri);if(this.g.has(m))throw new Error(`adding EXISTING notebook ${m} `);const E=new o.$Lmc(this.c,this.q,this.r,m,S);w.push(...S.cells.map(D=>o.$Kmc.asModelAddData(D))),this.g.get(m)?.dispose(),this.g.set(m,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(E.apiNotebook)}}if(f.value.addedEditors)for(const w of f.value.addedEditors){if(this.h.has(w.id))return;const S=k.URI.revive(w.documentUri),m=this.g.get(S);m&&this.A(m,w.id,w)}const g=[];if(f.value.removedEditors)for(const w of f.value.removedEditors){const S=this.h.get(w);S&&(this.h.delete(w),this.k?.id===S.id&&(this.k=void 0),g.push(S))}if(f.value.visibleEditors){this.l=f.value.visibleEditors.map(S=>this.h.get(S)).filter(S=>!!S);const w=new Set;this.l.forEach(S=>w.add(S.id));for(const S of this.h.values()){const m=w.has(S.id);S._acceptVisibility(m)}this.l=[...this.h.values()].map(S=>S).filter(S=>S.visible),this.o.fire(this.visibleNotebookEditors)}f.value.newActiveEditor===null?this.k=void 0:f.value.newActiveEditor&&(this.h.get(f.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${f.value.newActiveEditor}`),this.k=this.h.get(f.value.newActiveEditor)),f.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(f){const g=y.$XP.String.with("notebookType","A notebook type"),w=new y.$ZP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[g,new y.$XP("data","Bytes to convert to data",m=>m instanceof Uint8Array,m=>O.$Fe.wrap(m))],new y.$YP("Notebook Data",m=>v.NotebookData.to(m.value))),S=new y.$ZP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[g,new y.$XP("NotebookData","Notebook data to convert to bytes",m=>!0,m=>new l.$Bw(v.NotebookData.from(m)))],new y.$YP("Bytes",m=>m.buffer));f.registerApiCommand(w),f.registerApiCommand(S)}}e.$Vmc=r}),define(Se[376],De([1,0,17,22,47,35,23,40,37]),function(he,e,d,O,L,R,N,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nmc=void 0;class k{constructor(p,y,v){this.k=p,this.l=y,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=p.filePattern,this.b=p.includePattern&&R.$qk(p.includePattern),this.c=p.maxResults||void 0,this.d=p.exists,this.h=new Set,this.j=p.excludePattern&&R.$qk(p.excludePattern)}cancel(){this.g=!0,this.h.forEach(p=>p.cancel()),this.h=new Set}search(p){const y=this.k.folderQueries||[];return new Promise((v,h)=>{const l=o=>{this.f++,p(o)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const n=o.toString(),i=d.$nc(n);this.j&&this.j(n,i)||this.v(l,{base:o,basename:i})}),Promise.all(y.map(o=>this.p(o,l))).then(o=>{v({limitHit:this.e,stats:o[0]||void 0})},o=>{h(new Error((0,L.$hj)(o)))})})}async p(p,y){const v=new O.$oe,h=this.q(p),l=this.r(),o=new $.$EL(this.k,p),n=!o.hasSiblingExcludeClauses();let i;try{this.h.add(v),i=b.$_d.create();const u=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},h,v.token),s=i.elapsed(),t=b.$_d.create();return this.g&&!this.e||(u&&u.forEach(c=>{const r=d.$gc.relative(p.folder.path,c.path);if(n){const a=d.$nc(c.path);this.v(y,{base:p.folder,relativePath:r,basename:a});return}this.s(l,p.folder,r,y)}),this.g&&!this.e)?null:(this.u(l,o,y),{providerTime:s,postProcessTime:t.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(p){const y=(0,$.$DL)(this.k.includePattern,p.includePattern),v=(0,$.$DL)(this.k.excludePattern,p.excludePattern);return{folder:p.folder,excludes:v,includes:y,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}s({pathToEntries:p},y,v,h){if(v===this.a){const o=d.$nc(this.a);this.v(h,{base:y,relativePath:this.a,basename:o})}function l(o){const n=d.$nc(o),i=d.$mc(o);let u=p[i];u||(u=p[i]=[],l(i)),u.push({base:y,relativePath:o,basename:n})}l(v)}u({rootEntries:p,pathToEntries:y},v,h){const l=this,o=this.a;function n(i){const u=(0,$.$GL)(()=>i.map(s=>s.basename));for(let s=0,t=i.length;s<t;s++){const c=i[s],{relativePath:r,basename:a}=c;if(v.matchesExcludesSync(r,a,o!==a?u:void 0))continue;const f=y[r];if(f)n(f);else{if(r===o)continue;l.v(h,c)}if(l.e)break}}n(p)}v(p,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||p(y))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(p,y,v,h){const l=this.c(p.cacheKey),o=new k(p,y,l&&l.token);let n=0;const i=u=>{n+=u.length,v(u.map(s=>this.d(s)))};return this.e(o,A.a,i,h).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:u.stats}}))}clearCache(p){this.c(p)?.cancel()}c(p){if(p)return this.b.has(p)||this.b.set(p,new O.$oe),this.b.get(p)}d(p){return p.relativePath?{resource:N.$0g(p.base,p.relativePath)}:{resource:p.base}}e(p,y,v,h){const l=h.onCancellationRequested(()=>{p.cancel()}),o=i=>{i&&(n.push(i),y>0&&n.length>=y&&(v(n),n=[]))};let n=[];return p.search(o).then(i=>(n.length&&v(n),l.dispose(),i),i=>(n.length&&v(n),l.dispose(),Promise.reject(i)))}}e.$Nmc=A}),define(Se[377],De([1,0,19,74,35,103,27,15,17,23,14,18,2,100,250,55,11,42,147,372,37]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=void 0,e.$PM=S;let s=class{constructor(E,D,P,I,F){this.a=E,this.b=D,this.c=P,this.d=I,this.e=F}text(E,D,P={}){E=this.f(E,P);const I=this.a.getValue(),F=D&&D.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(D?.map(o.$Ri),P),type:2,contentPattern:E,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:I.search.usePCRE2||F||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(E,D){const P=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const I={...E,wordSeparators:P.editor.wordSeparators};return this.j(E,D)&&(I.isCaseSensitive=!0),this.k(E)&&(I.isMultiline=!0),D.notebookSearchConfig?.includeMarkupInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownInput=D.notebookSearchConfig.includeMarkupInput),D.notebookSearchConfig?.includeMarkupPreview&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownPreview=D.notebookSearchConfig.includeMarkupPreview),D.notebookSearchConfig?.includeCodeInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellInput=D.notebookSearchConfig.includeCodeInput),D.notebookSearchConfig?.includeOutput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellOutput=D.notebookSearchConfig.includeOutput),I}file(E,D={}){return{...this.h(E,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey,shouldGlobMatchFilePattern:D.shouldGlobSearch}}g(E,D){return E?(E=Array.isArray(E)?E.map(f):f(E),D?this.parseSearchPaths(E):{pattern:c(...Array.isArray(E)?E:[E])}):{}}h(E=[],D={}){const P=this.g(D.includePattern,D.expandPatterns),I=this.g(D.excludePattern,D.expandPatterns),F=E.length>1,T=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(j=>this.q(j,D,I)):E.map(j=>this.r(j,D,I,F))).filter(j=>!!j),z={_reason:D._reason,folderQueries:T,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:I.pattern,includePattern:P.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const j=d.$Hb(this.c.groups.flatMap(ie=>ie.editors.map(q=>q.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const U=j.filter(ie=>(0,u.$uL)(z,ie.fsPath)),Z=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Z)),{...z,...Z}}const M=D.extraFileResources&&D.extraFileResources.filter(j=>(0,u.$uL)(z,j.fsPath));return z.extraFileResources=M&&M.length?M:void 0,z}i(E){const D=[],P=new N.$Ac,I={};let F=!1;return E.forEach(T=>{if(T.scheme===b.Schemas.walkThrough)return;if((0,k.$bh)(T)){const M=this.b.getWorkspaceFolder(T)?.uri??T.with({path:$.$mc(T.fsPath)});let j=P.get(M);j||(F=!0,j={folder:M,includePattern:{}},D.push(j),P.set(M,j));const U=$.$lc(M.fsPath,T.fsPath);(0,C.$hg)(j.includePattern)[U.replace(/\\/g,"/")]=!0}else T.fsPath&&(F=!0,I[T.fsPath]=!0)}),{folderQueries:D,includePattern:I,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}j(E,D){if(D.isSmartCase){if(E.isRegExp){if(A.$Zf(E.pattern,!0))return!0}else if(A.$Zf(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,y.$QC)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const D=Z=>$.$ic(Z)||/^\.\.?([\/\\]|$)/.test(Z),I=(Array.isArray(E)?E:r(E)).map(Z=>{const ie=this.e.resolvedUserHome;return ie?(0,R.$Gw)(Z,ie.scheme===b.Schemas.file?ie.fsPath:ie.path):Z}),F=O.$K(I,Z=>D(Z)?"searchPaths":"exprSegments"),T=(F.exprSegments||[]).map(Z=>A.$ff(Z,"/")).map(Z=>A.$ff(Z,"\\")).map(Z=>(Z[0]==="."&&(Z="*"+Z),a(Z))),z={},M=this.m(F.searchPaths||[]);M&&M.length&&(z.searchPaths=M);const j=T.flat(),U=c(...j);return U&&(z.pattern=U),z}l(E,D){return D.disregardExcludeSettings?void 0:(0,u.$tL)(E,!D.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const D=E.flatMap(I=>{let{pathPortion:F,globPortion:T}=t(I);return T&&(T=g(T)),this.n(F).flatMap(M=>this.o(M,T))}),P=new Map;return D.forEach(I=>{const F=I.searchPath.toString(),T=P.get(F);T?I.pattern&&(T.pattern=T.pattern||{},T.pattern[I.pattern]=!0):P.set(F,{searchPath:I.searchPath,pattern:I.pattern?c(I.pattern):void 0})}),Array.from(P.values())}n(E){if($.$ic(E)){const D=this.b.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==b.Schemas.file?[{searchPath:D[0].uri.with({path:E})}]:[{searchPath:p.URI.file($.$hc(E))}]}if(this.b.getWorkbenchState()===2){const D=this.b.getWorkspace().folders[0].uri;if(E=f(E),E.startsWith("../")||E===".."){const I=$.$gc.resolve(D.path,E);return[{searchPath:D.with({path:I})}]}const P=g(E);return[{searchPath:D,pattern:P}]}else{if(E==="./"||E===".\\")return[];{const D=E.replace(/^\.[\/\\]/,""),I=this.b.getWorkspace().folders.map(F=>{const T=D.match(new RegExp(`^${A.$_e(F.name)}(?:/(.*)|$)`));return T?{match:T,folder:F}:null}).filter(C.$eg);if(I.length)return I.map(F=>{const T=F.match[1];return{searchPath:F.folder.uri,pattern:T&&g(T)}});{const F=E.match(/\.[\/\\](.+)[\/\\]?/),T=F?F[1]:E,z=v.localize(0,null,T);throw new Error(z)}}}}o(E,D){const P=E.pattern&&D?`${E.pattern}/${D}`:E.pattern||D,I=[{searchPath:E.searchPath,pattern:P}];return P&&!P.endsWith("**")&&I.push({searchPath:E.searchPath,pattern:P+"/**"}),I}q(E,D,P){const I=this.r((0,o.$Ri)(E.searchPath),D,P,!1);return I?{...I,includePattern:E.pattern}:null}r(E,D,P,I){let F;const T=p.URI.isUri(E)?E:E.uri;if(P.searchPaths){const Z=P.searchPaths.filter(ie=>(0,k.$3g)(ie.searchPath,T))[0];if(Z&&!Z.pattern)return null;Z&&(F=Z.pattern)}const z=this.a.getValue({resource:T}),j={...this.l(z,D)||{},...F||{}},U=p.URI.isUri(E)?(0,k.$7g)(E):E.name;return{folder:T,folderName:I?U:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof D.disregardParentIgnoreFiles=="boolean"?D.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!z.search.followSymlinks}}};e.$OM=s,e.$OM=s=Ge([We(0,h.$3i),We(1,o.$Fi),We(2,n.$YD),We(3,l.$3j),We(4,i.$MM)],s);function t(m){const E=m.match(/[\*\{\}\(\)\[\]\?]/);if(E){const D=E.index,P=m.substr(0,D).match(/[/|\\][^/\\]*$/);if(P){let I=m.substr(0,P.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:m.substr((P.index||0)+1)}}}return{pathPortion:m}}function c(...m){return m.length?m.reduce((E,D)=>(E[D]=!0,E),Object.create(null)):void 0}function r(m){return L.$ok(m,",").map(E=>E.trim()).filter(E=>!!E.length)}function a(m){return[`**/${m}/**`,`**/${m}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function f(m){return m.replace(/\\/g,"/")}function g(m){return f(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function w(m){return m.replace(/([?*[\]])/g,"[$1]")}function S(m,E){m=d.$Mb(m,I=>I.toString());const D=[],P=E.getWorkspace();return m&&m.forEach(I=>{let F;if(E.getWorkbenchState()===2)F=(0,k.$_g)(P.folders[0].uri,I),F&&F!=="."&&(F="./"+F);else{const T=E.getWorkspaceFolder(I);if(T){const z=T.name;if(P.folders.filter(j=>j.name===z).length===1){const j=(0,k.$_g)(T.uri,I);j===""?F=`./${T.name}`:F=`./${T.name}/${j}`}else F=I.fsPath}}F&&D.push(w(F))}),D}}),define(Se[378],De([1,0,23,2,22,13,5,377,37,42,7]),function(he,e,d,O,L,R,N,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mwb=p,e.$nwb=h;const C=7e3;function p(l,o){const n=o.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],u=[];for(const f of n)if(/^workspaceContains:/.test(f)){const g=f.substr(18);g.indexOf("*")>=0||g.indexOf("?")>=0||l.forceUsingSearch?u.push(g):i.push(g)}if(i.length===0&&u.length===0)return Promise.resolve(void 0);const{promise:s,resolve:t}=(0,A.$ph)(),c=f=>t({activationEvent:f}),r=Promise.all(i.map(f=>y(l,f,c))).then(()=>{}),a=v(l,o.identifier,u,c);return Promise.all([r,a]).then(()=>{t(void 0)}),s}async function y(l,o,n){for(const i of l.folders)if(await l.exists(d.$0g(O.URI.revive(i),o))){n(`workspaceContains:${o}`);return}}async function v(l,o,n,i){if(n.length===0)return Promise.resolve(void 0);const u=new L.$oe,s=l.checkExists(l.folders,n,u.token),t=setTimeout(async()=>{u.cancel(),l.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},C);let c=!1;try{c=await s}catch(r){R.$4(r)||R.$1(r)}u.dispose(),clearTimeout(t),c&&i(`workspaceContains:${n.join(",")}`)}function h(l,o,n,i){const u=l.get(N.$vi),s=l.get($.$lL),c=u.createInstance(b.$OM).file(o.map(r=>(0,k.$Ri)(O.URI.revive(r))),{_reason:"checkExists",includePattern:n,exists:!0});return s.fileSearch(c,i).then(r=>!!r.limitHit,r=>R.$4(r)?!1:Promise.reject(r))}}),define(Se[49],De([1,0,225,17,59,23,7,3,78,2,11,6,45,310,119,44,26,149,13,25,21,287,8,67,5,28,93,20,107,71,43,122,4,378,118,289,15,116,40,12,117]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n,i,u,s,t,c,r,a,f,g,w,S,m,E,D,P,I,F,T,z,M,j,U){"use strict";var Z;Object.defineProperty(e,"__esModule",{value:!0}),e.$tmc=e.$smc=e.$rmc=e.$qmc=e.$pmc=void 0,e.$pmc=(0,r.$wi)("IHostUtils");let ie=Z=class extends b.$Uc{constructor(B,_,pe,ue,ce,oe,le,K,se,$e,ve,Re,ge){super(),this.Y=Re,this.Z=ge,this.a=this.B(new D.$de),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=_,this.g=pe,this.f=le,this.j=ue,this.m=ce,this.s=oe,this.t=se,this.u=$e,this.w=ve,this.y=this.g.getProxy(C.$$M.MainThreadWorkspace),this.z=this.g.getProxy(C.$$M.MainThreadTelemetry),this.C=this.g.getProxy(C.$$M.MainThreadExtensionService),this.D=new N.$vh,this.F=new N.$vh,this.G=new N.$vh,this.H=new N.$vh,this.I=new Ce(this.f.extensions.activationEvents),this.L=new o.$3_b(this.I,this.f.extensions.allExtensions);const Ie=new i.$Sm(this.f.extensions.myExtensions);this.J=new o.$3_b(this.I,be(this.L,Ie)),j.$t&&(this.s.info(`Creating extension host with the following global extensions: ${x(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${x(this.J)}`)),this.M=new v.$$lc(this.g,this.s),this.N=new I.$imc(this.g),this.O=K,this.h=B.createChild(new w.$ui([v.$_lc,this.M],[I.$jmc,this.N])),this.P=this.B(new y.$0lc(this.J,this.L,{onExtensionActivationError:(Ae,ze,V)=>{this.C.$onExtensionActivationError(Ae,n.$3(ze),V)},actualActivateExtension:async(Ae,ze)=>{if(o.$3_b.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,ze),new y.$9lc;const V=this.J.getExtensionDescription(Ae);return this.fb(V,ze)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),L.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(B){n.$1(B)}}async $(){this.O.onWillDeactivateAll();let B=[];try{B=this.J.getAllExtensionDescriptions().map(ce=>ce.identifier).filter(ce=>this.isActivated(ce)).map(ce=>this.eb(ce))}catch{}await Promise.all(B)}terminate(B,_=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${B}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(ue=>{this.s.error(ue)}),this.g.dispose();const pe=this.$();Promise.race([(0,N.$xh)(5e3),pe]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${_}`):this.s.info(`Extension host exiting with code ${_}`),this.s.flush(),this.s.dispose(),this.c.exit(_)})}isActivated(B){return this.G.isOpen()?this.P.isActivated(B):!1}async getExtension(B){const _=await this.C.$getExtension(B);return _&&{..._,identifier:new i.$Rm(_.identifier.value),extensionLocation:k.URI.revive(_.extensionLocation)}}ab(B,_){return this.P.activateByEvent(B,_)}bb(B,_){return this.P.activateById(B,_)}activateByIdWithErrors(B,_){return this.bb(B,_).then(()=>{const pe=this.P.getActivatedExtension(B);if(pe.activationFailed)return Promise.reject(pe.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(B=>this.J)}getExtensionExports(B){if(this.G.isOpen())return this.P.getActivatedExtension(B).exports;try{return this.P.getActivatedExtension(B).exports}catch{return null}}async cb(B){if(B.scheme===T.Schemas.file&&this.c.fsRealpath){const _=B.fsPath;this.R.has(_)||this.R.set(_,this.c.fsRealpath(_));const pe=await this.R.get(_);return k.URI.file(pe)}return B}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(B=>new ae(B))),this.Q}async db(B){const _=$.$Ci.forUris(pe=>R.$1g.ignorePathCasing(pe));return await Promise.all(B.map(async pe=>{if(this.wb(pe)){const ue=await this.cb(pe.extensionLocation);_.set(ue,pe)}})),_}eb(B){let _=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(B))return _;const pe=this.P.getActivatedExtension(B);if(!pe)return _;try{typeof pe.module.deactivate=="function"&&(_=Promise.resolve(pe.module.deactivate()).then(void 0,ue=>(this.s.error(ue),Promise.resolve(void 0))))}catch(ue){this.s.error(`An error occurred when deactivating the extension '${B.value}':`),this.s.error(ue)}try{(0,b.$Pc)(pe.subscriptions)}catch(ue){this.s.error(`An error occurred when deactivating the subscriptions for extension '${B.value}':`),this.s.error(ue)}return _}async fb(B,_){return this.f.remote.isRemote?this.C.$onWillActivateExtension(B.identifier):await this.C.$onWillActivateExtension(B.identifier),this.hb(B,_).then(pe=>{const ue=pe.activationTimes;return this.C.$onDidActivateExtension(B.identifier,ue.codeLoadingTime,ue.activateCallTime,ue.activateResolvedTime,_),this.gb(B,_,"success",ue),pe},pe=>{throw this.gb(B,_,"failure"),pe})}gb(B,_,pe,ue){const ce=G(B,_);this.z.$publicLog2("extensionActivationTimes",{...ce,...ue||{},outcome:pe})}hb(B,_){const pe=G(B,_);this.z.$publicLog2("activatePlugin",pe);const ue=this.wb(B);if(!ue)return Promise.resolve(new y.$8lc(y.$5lc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${B.identifier.value}, startup: ${_.startup}, activationEvent: '${_.activationEvent}'${B.identifier.value!==_.extensionId.value?`, root cause: ${_.extensionId.value}`:""}`),this.s.flush();const ce=new y.$6lc(_.startup);return Promise.all([this.xb(B,(0,R.$0g)(B.extensionLocation,ue),ce),this.ib(B)]).then(oe=>(L.mark(`code/extHost/willActivateExtension/${B.identifier.value}`),Z.jb(this.s,B.identifier,oe[0],oe[1],ce))).then(oe=>(L.mark(`code/extHost/didActivateExtension/${B.identifier.value}`),oe))}ib(B){const _=this.Z.createLanguageModelAccessInformation(B),pe=new s.$bmc(B,this.M),ue=new s.$amc(B.identifier.value,!1,this.M),ce=new F.$kmc(B,this.N),oe=B.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,le=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${B.identifier.value}`),Promise.all([pe.whenReady,ue.whenReady,this.O.whenReady]).then(()=>{const K=this;let se,$e;const ve=(0,l.$OG)(B,"ipc")?this.f.messagePorts?.get(i.$Rm.toKey(B.identifier)):void 0;return Object.freeze({globalState:pe,workspaceState:ue,secrets:ce,subscriptions:[],get languageModelAccessInformation(){return _},get extensionUri(){return B.extensionLocation},get extensionPath(){return B.extensionLocation.fsPath},asAbsolutePath(Re){return O.$jc(B.extensionLocation.fsPath,Re)},get storagePath(){return K.O.workspaceValue(B)?.fsPath},get globalStoragePath(){return K.O.globalValue(B).fsPath},get logPath(){return O.$jc(K.f.logsLocation.fsPath,B.identifier.value)},get logUri(){return k.URI.joinPath(K.f.logsLocation,B.identifier.value)},get storageUri(){return K.O.workspaceValue(B)},get globalStorageUri(){return K.O.globalValue(B)},get extensionMode(){return oe},get extension(){return se===void 0&&(se=new ne(K,B.identifier,B,le,!1)),se},get extensionRuntime(){return(0,l.$PG)(B,"extensionRuntime"),K.extensionRuntime},get environmentVariableCollection(){return K.u.getEnvironmentVariableCollection(B)},get messagePassingProtocol(){if(!$e){if(!ve)return;const Re=D.Event.buffer(D.Event.fromDOMEventEmitter(ve,"message",ge=>ge.data));ve.start(),$e={onDidReceiveMessage:Re,postMessage:ve.postMessage.bind(ve)}}return $e}})})}static jb(B,_,pe,ue,ce){return pe=pe||{activate:void 0,deactivate:void 0},this.kb(B,_,pe,ue,ce).then(oe=>new y.$7lc(!1,null,ce.build(),pe,oe,ue.subscriptions))}static kb(B,_,pe,ue,ce){if(typeof pe.activate=="function")try{ce.activateCallStart(),B.trace(`ExtensionService#_callActivateOptional ${_.value}`);const oe=typeof global=="object"?global:self,le=pe.activate.apply(oe,[ue]);return ce.activateCallStop(),ce.activateResolveStart(),Promise.resolve(le).then(K=>(ce.activateResolveStop(),K))}catch(oe){return Promise.reject(oe)}else return Promise.resolve(pe)}lb(B,_){this.bb(B.identifier,{startup:!1,extensionId:B.identifier,activationEvent:_}).then(void 0,pe=>{this.s.error(pe)})}mb(B,_=0){const ue=Date.now();(0,j.$B)(()=>{for(let ce=_;ce<B.length;ce+=1){const oe=B[ce];for(const le of oe.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-ue>50){this.mb(B,ce);break}else this.lb(oe,le)}})}nb(){this.C.$setPerformanceMarks(L.getMarks()),this.m.getConfigProvider().then(B=>{const _=B.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),pe=this.J.getAllExtensionDescriptions();if(_)this.mb(pe);else for(const ue of pe)if(ue.activationEvents)for(const ce of ue.activationEvents)ce==="onStartupFinished"&&this.lb(ue,ce)})}ob(){const B=this.ab("*",!0).then(void 0,oe=>{this.s.error(oe)});this.B(this.j.onDidChangeWorkspace(oe=>this.pb(oe.added)));const _=this.j.workspace?this.j.workspace.folders:[],pe=this.pb(_),ue=this.rb(),ce=Promise.all([ue,B,pe]).then(()=>{});return Promise.race([ce,(0,N.$xh)(1e4)]).then(()=>{this.nb()}),ce}pb(B){return B.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(_=>this.qb(B,_))).then(()=>{})}async qb(B,_){if(this.isActivated(_.identifier))return;const pe=!this.f.remote.isRemote&&!!this.f.remote.authority,ue={logService:this.s,folders:B.map(oe=>oe.uri),forceUsingSearch:pe||!this.c.fsExists,exists:oe=>this.c.fsExists(oe.fsPath),checkExists:(oe,le,K)=>this.y.$checkExists(oe,le,K)},ce=await(0,P.$mwb)(ue,_);if(ce)return this.bb(_.identifier,{startup:!0,extensionId:_.identifier,activationEvent:ce.activationEvent}).then(void 0,oe=>this.s.error(oe))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(B){throw console.error(B),B}}async sb(){const{extensionDevelopmentLocationURI:B,extensionTestsLocationURI:_}=this.f.environment;if(!B||!_)throw new Error(d.localize(0,null));const pe=await this.xb(null,_,new y.$6lc(!1));if(!pe||typeof pe.run!="function")throw new Error(d.localize(1,null,_.toString()));return new Promise((ue,ce)=>{const oe=(se,$e)=>{se?(j.$t&&this.s.error("Test runner called back with error",se),ce(se)):(j.$t&&($e?this.s.info(`Test runner called back with ${$e} failures.`):this.s.info("Test runner called back with successful outcome.")),ue(typeof $e=="number"&&$e>0?1:0))},le=(0,R.$Xg)(_),K=pe.run(le,oe);K&&K.then&&K.then(()=>{j.$t&&this.s.info("Test runner finished successfully."),ue(0)}).catch(se=>{j.$t&&this.s.error("Test runner finished with error",se),ce(se instanceof Error&&se.stack?se.stack:String(se))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,N.$xh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(B,_){return this.S[B]=_,(0,b.$Sc)(()=>{delete this.S[B]})}async getRemoteExecServer(B){const{resolver:_}=await this.ub(B);return _?.resolveExecServer?.(B,{resolveAttempt:0})}async ub(B){const _=B.indexOf("+");if(_===-1)throw new t.$gN("Not an authority that can be resolved!",c.RemoteAuthorityResolverErrorCode.InvalidAuthority);const pe=B.substr(0,_);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${pe}`,!1),{authorityPrefix:pe,resolver:this.S[pe]}}async $resolveAuthority(B,_){const pe=M.$_d.create(!1),ue=()=>`[resolveAuthority(${(0,c.$Ll)(B)},${_})][${pe.elapsed()}ms] `,ce=W=>this.s.info(`${ue()}${W}`),oe=W=>this.s.warn(`${ue()}${W}`),le=(W,J=void 0)=>this.s.error(`${ue()}${W}`,J),K=W=>{if(W instanceof t.$gN)return{type:"error",error:{code:W._code,message:W._message,detail:W._detail}};throw W},se=async W=>{ce(`activating resolver for ${W}...`);const{resolver:J,authorityPrefix:X}=await this.ub(W);if(!J)throw le(`no resolver for ${X}`),new t.$gN(`No remote extension installed to resolve ${X}.`,c.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:X,remoteAuthority:W}},$e=B.split(/@|%40/g).reverse();ce(`activating remote resolvers ${$e.join(" -> ")}`);let ve;try{ve=await Promise.all($e.map(se)).catch(async W=>{if(!(W instanceof t.$gN)||W._code!==c.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw W;return oe(`resolving nested authorities failed: ${W.message}`),[await se(B)]})}catch(W){return K(W)}const Re=new N.$Hh;Re.cancelAndSet(()=>ce("waiting..."),1e3);let ge,Ie;for(const[W,{authorityPrefix:J,resolver:X,remoteAuthority:de}]of ve.entries())try{if(W===ve.length-1)ce("invoking final resolve()..."),L.mark(`code/extHost/willResolveAuthority/${J}`),ge=await X.resolve(de,{resolveAttempt:_,execServer:Ie}),L.mark(`code/extHost/didResolveAuthorityOK/${J}`),ce("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(X,t.$fN.isManagedResolvedAuthority(ge)?ge:void 0));else{if(ce(`invoking resolveExecServer() for ${de}`),L.mark(`code/extHost/willResolveExecServer/${J}`),Ie=await X.resolveExecServer?.(de,{resolveAttempt:_,execServer:Ie}),!Ie)throw new t.$gN(`Exec server was not available for ${de}`,c.RemoteAuthorityResolverErrorCode.NoResolverFound);L.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(we){return L.mark(`code/extHost/didResolveAuthorityError/${J}`),le("returned an error",we),Re.dispose(),K(we)}Re.dispose();const Ae={environmentTunnels:ge.environmentTunnels,features:ge.tunnelFeatures?{elevation:ge.tunnelFeatures.elevation,privacyOptions:ge.tunnelFeatures.privacyOptions,protocol:ge.tunnelFeatures.protocol===void 0?!0:ge.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:ge.extensionHostEnv,isTrusted:ge.isTrusted,authenticationSession:ge.authenticationSessionForInitializingExtensions?{id:ge.authenticationSessionForInitializingExtensions.id,providerId:ge.authenticationSessionForInitializingExtensions.providerId}:void 0};ce(`returned ${t.$fN.isManagedResolvedAuthority(ge)?"managed authority":`${ge.host}:${ge.port}`}`);let V;if(t.$fN.isManagedResolvedAuthority(ge)){const W=_;this.Y.setFactory(W,ge.makeConnection),V={authority:B,connectTo:new c.$Il(W),connectionToken:ge.connectionToken}}else V={authority:B,connectTo:new c.$Jl(ge.host,ge.port),connectionToken:ge.connectionToken};return{type:"ok",value:{authority:V,options:ze,tunnelInformation:Ae}}}async $getCanonicalURI(B,_){this.s.info(`$getCanonicalURI invoked for authority (${(0,c.$Ll)(B)})`);const{resolver:pe}=await this.ub(B);if(!pe)return null;const ue=k.URI.revive(_);if(typeof pe.getCanonicalURI>"u")return ue;const ce=await(0,N.$oh)(()=>pe.getCanonicalURI(ue));return ce||ue}async $startExtensionHost(B){B.toAdd.forEach(oe=>oe.extensionLocation=k.URI.revive(oe.extensionLocation));const{globalRegistry:_,myExtensions:pe}=q(this.I,this.L,this.J,B),ue=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(ue),this.L.set(_.getAllExtensionDescriptions()),this.J.set(pe),j.$t&&(this.s.info(`$startExtensionHost: global extensions: ${x(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${x(this.J)}`)),this.tb()}$activateByEvent(B,_){return _===1?this.D.wait().then(pe=>this.ab(B,!1)):this.G.wait().then(pe=>this.ab(B,!1))}async $activate(B,_){return await this.G.wait(),this.J.getExtensionDescription(B)?(await this.bb(B,_),!0):!1}async $deltaExtensions(B){B.toAdd.forEach(oe=>oe.extensionLocation=k.URI.revive(oe.extensionLocation));const{globalRegistry:_,myExtensions:pe}=q(this.I,this.L,this.J,B),ue=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(ue),this.L.set(_.getAllExtensionDescriptions()),this.J.set(pe),j.$t&&(this.s.info(`$deltaExtensions: global extensions: ${x(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${x(this.J)}`)),Promise.resolve(void 0)}async $test_latency(B){return B}async $test_up(B){return B.byteLength}async $test_down(B){const _=u.$Fe.alloc(B),pe=Math.random()%256;for(let ue=0;ue<B;ue++)_.writeUInt8(pe,ue);return _}async $updateRemoteConnectionData(B){this.X=B,this.a.fire()}};e.$qmc=ie,e.$qmc=ie=Z=Ge([We(0,r.$vi),We(1,e.$pmc),We(2,g.$zP),We(3,h.$Nlc),We(4,p.$Qlc),We(5,A.$3j),We(6,a.$PP),We(7,f.$Tlc),We(8,S.$sDb),We(9,m.$cmc),We(10,z.$mmc),We(11,U.$nmc),We(12,E.$gmc)],ie);function q(ee,B,_,pe){ee.addActivationEvents(pe.addActivationEvents);const ue=new o.$3_b(ee,B.getAllExtensionDescriptions());ue.deltaExtensions(pe.toAdd,pe.toRemove);const ce=new i.$Sm(_.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of pe.myToRemove)ce.delete(le);for(const le of pe.myToAdd)ce.add(le);const oe=be(ue,ce);return{globalRegistry:ue,myExtensions:oe}}function G(ee,B){return{id:ee.identifier.value,name:ee.name,extensionVersion:ee.version,publisherDisplayName:ee.publisher,activationEvents:ee.activationEvents?ee.activationEvents.join(","):null,isBuiltin:ee.isBuiltin,reason:B.activationEvent,reasonId:B.extensionId.value}}function x(ee){return ee.getAllExtensionDescriptions().map(B=>B.identifier.value).join(",")}e.$rmc=(0,r.$wi)("IExtHostExtensionService");class ne{#e;#t;#n;constructor(B,_,pe,ue,ce){this.#e=B,this.#t=_,this.#n=pe.identifier,this.id=pe.identifier.value,this.extensionUri=pe.extensionLocation,this.extensionPath=O.$hc((0,R.$Xg)(pe.extensionLocation)),this.packageJSON=pe,this.extensionKind=ue,this.isFromDifferentExtensionHost=ce}get isActive(){return this.#e.isActivated(this.#n)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#n)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#n,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$smc=ne;function be(ee,B){return ee.getAllExtensionDescriptions().filter(_=>B.has(_.identifier))}class ae{constructor(B){this.a=B}setSearchTree(B){this.a=B}findSubstr(B){return this.a.findSubstr(B)}forEach(B){return this.a.forEach(B)}}e.$tmc=ae;class Ce{constructor(B){this.a=new i.$Tm,this.addActivationEvents(B)}readActivationEvents(B){return this.a.get(B.identifier)??[]}addActivationEvents(B){for(const _ of Object.keys(B))this.a.set(_,B[_])}}}),define(Se[379],De([1,0,59,2,6,45,26,25,20,28,5,49,11,14]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cnc=void 0;let h=class{constructor(u,s,t,c,r,a,f){this.c=u,this.d=s,this.e=t,this.f=c,this.g=r,this.h=a,this.i=f,this.a=new Map,this.b=[]}async install(){this.j(),d.mark("code/extHost/willWaitForConfig");const u=await this.f.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new o(this.c,s,this.d,u,this.i)),this.register(this.e.createInstance(l)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,s,this.h.environment.appUriScheme))}register(u){if("nodeModuleName"in u)if(Array.isArray(u.nodeModuleName))for(const s of u.nodeModuleName)this.a.set(s,u);else this.a.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this.b.push(s=>u.alternativeModuleName(s))}};e.$Cnc=h,e.$Cnc=h=Ge([We(2,A.$vi),We(3,R.$Qlc),We(4,C.$rmc),We(5,k.$PP),We(6,p.$3j)],h);let l=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(u){if(u.environment.appRoot&&v.a.size){const s=(0,y.$_e)(this.c(u.environment.appRoot.fsPath)),t="[a-z0-9_.-]",c=`@${t}+\\/${t}+|${t}+`,r="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${r}\\/)(${c})(.*)$`,"i")}}alternativeModuleName(u){if(!this.b)return;const s=this.b.exec(this.c(u));if(!s)return;const[,t,c,r]=s,a=v.a.get(c);if(a!==void 0)return console.warn(`${c} as been renamed to ${a}, please update your imports`),t+a+r}c(u){return u.replace(/\\/g,"/")}};l=v=Ge([We(0,k.$PP)],l);class o{constructor(u,s,t,c,r){this.c=u,this.d=s,this.e=t,this.f=c,this.g=r,this.nodeModuleName="vscode",this.a=new b.$Tm}load(u,s){const t=this.d.findSubstr(s);if(t){let c=this.a.get(t.identifier);return c||(c=this.c(t,this.e,this.f),this.a.set(t.identifier,c)),c}if(!this.b){let c="";this.d.forEach((r,a)=>c+=`	${a} -> ${r.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${c}`),this.b=this.c(N.$JG,this.e,this.f)}return this.b}}let n=class{constructor(u,s,t){this.e=u,this.f=s,this.nodeModuleName=["open","opn"],this.d=t.getProxy(L.$$M.MainThreadTelemetry);const c=t.getProxy(L.$$M.MainThreadWindow);this.c=(r,a)=>{const f=O.URI.parse(r);return a?this.g(r,a):f.scheme==="http"||f.scheme==="https"?c.$openUri(f,r,{allowTunneling:!0}):f.scheme==="mailto"||f.scheme===this.f?c.$openUri(f,r,{}):this.g(r,a)}}load(u,s,t){const c=this.e.findSubstr(s);return c&&(this.a=c.identifier.value,this.h()),this.b=t(u),this.c}g(u,s){return this.i(),this.b(u,s)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Ge([We(2,$.$zP)],n)}),define(Se[61],De([1,0,46,3,17,52,5,73,72,49,8,44,307,45]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=e.$umc=void 0,e.$umc=(0,N.$wi)("IExtHostVariableResolverProvider");class v extends p.$DQ{constructor(o,n,i,u,s,t,c){function r(){if(i){const a=i.activeEditor();if(a)return a.document.uri;const f=u.tabGroups.all.find(g=>g.isActive)?.activeTab;if(f!==void 0){if(f.input instanceof A.$YO||f.input instanceof A.$4O)return f.input.modified;if(f.input instanceof A.$XO||f.input instanceof A.$3O||f.input instanceof A.$1O)return f.input.uri}}}super({getFolderUri:a=>{const f=t.folders.filter(g=>g.name===a);if(f&&f.length>0)return f[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(a,f)=>s.getConfiguration(void 0,a).get(f),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const a=r();if(a)return L.$hc(a.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const a=r();if(a){const f=n.getWorkspaceFolder(a);if(f)return L.$hc(f.uri.fsPath)}}},getSelectedText:()=>{if(i){const a=i.activeEditor();if(a&&!a.selection.isEmpty)return a.document.getText(a.selection)}},getLineNumber:()=>{if(i){const a=i.activeEditor();if(a)return String(a.selection.end.line+1)}},getExtension:a=>o.getExtension(a)},void 0,c?Promise.resolve(c):void 0,Promise.resolve(R.env))}}let h=class extends O.$Uc{constructor(o,n,i,u,s){super(),this.b=o,this.c=n,this.g=i,this.h=u,this.j=s,this.a=new d.$V(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async a=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,t,r,this.m())})}getResolver(){return this.a.value}m(){}};e.$vmc=h,e.$vmc=h=Ge([We(0,k.$rmc),We(1,C.$Nlc),We(2,b.$KP),We(3,y.$Qlc),We(4,$.$3lc)],h)}),define(Se[96],De([1,0,7,4,2,25,5,6,72,49,20,8,44,144,299,45,61,3,50,34,16,19]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n,i,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Amc=e.$zmc=e.$ymc=e.$xmc=e.$wmc=void 0,e.$wmc=(0,N.$wi)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(S,m,E,D,P,I,F){this.N=m,this.O=E,this.P=D,this.Q=P,this.R=I,this.S=F,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new O.$de,this.o=new O.$de,this.q=new O.$de,this.w=new O.$de,this.l=S.getProxy(b.$$M.MainThreadDebugService),this.A=new O.$de,this.C=new O.$de,this.y=new r(this.l),this.z=new Map,this.O.getExtensionRegistry().then(T=>{T.onDidChange(z=>{this.V(T)}),this.V(T)})}async $getVisualizerTreeItem(S,m){const E=this.W(m);if(!E)return;const D=await this.H.get(S)?.getTreeItem?.(E);return D?this.U(S,D):void 0}registerDebugVisualizationTree(S,m,E){const D=R.$Rm.toKey(S.identifier),P=this.jb(D,m);if(this.G.has(P))throw new Error(`A debug visualization provider with id '${m}' is already registered`);return this.H.set(P,E),this.l.$registerDebugVisualizerTree(P,!!E.editItem),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(P),this.H.delete(m)})}async $getVisualizerTreeItemChildren(S,m){const E=this.J.get(m)?.item;return E?(await this.H.get(S)?.getChildren?.(E))?.map(P=>this.U(S,P))||[]:[]}async $editVisualizerTreeItem(S,m){const E=this.J.get(S);if(!E)return;const D=await this.H.get(E.provider)?.editItem?.(E.item,m);return this.U(E.provider,D||E.item)}$disposeVisualizedTree(S){const m=this.J.get(S);if(!m)return;const E=[m.children];for(const D of E)if(D)for(const P of D)E.push(this.J.get(P)?.children),this.J.delete(P)}U(S,m){let E=this.I.get(m);return E||(E=this.F++,this.I.set(m,E),this.J.set(E,{provider:S,item:m})),u.DebugTreeItem.from(m,E)}asDebugSourceUri(S,m){const E=S;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let D=`debug:${encodeURIComponent(E.path||"")}`,P="?";return m&&(D+=`${P}session=${encodeURIComponent(m.id)}`,P="&"),D+=`${P}ref=${E.sourceReference}`,L.URI.parse(D)}else{if(E.path)return L.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(S){const m=[];for(const E of S.getAllExtensionDescriptions())if(E.contributes){const D=E.contributes.debuggers;if(D&&D.length>0)for(const P of D)(0,v.$tH)(P)&&m.push(P.type)}this.l.$registerDebugTypes(m)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const S=[];return this.z.forEach(m=>S.push(m)),S}async $resolveDebugVisualizer(S,m){const E=this.L.get(S);if(!E)throw new Error(`No debug visualizer found with id '${S}'`);let{v:D,provider:P,extensionId:I}=E;if(D.visualization||(D=await P.resolveDebugVisualization?.(D,m)||D,E.v=D),!D.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${P}'`);return this.kb(I,D.visualization)}async $executeDebugVisualizerCommand(S){const m=this.L.get(S);if(!m)throw new Error(`No debug visualizer found with id '${S}'`);const E=m.v.visualization;E&&"command"in E&&this.S.executeCommand(E.command,...E.arguments||[])}W(S){const m=this.m.get(S.sessionId);return m&&{session:m.api,variable:S.variable,containerId:S.containerId,frameId:S.frameId,threadId:S.threadId}}async $provideDebugVisualizers(S,m,E,D){const P=this.W(E),I=this.jb(S,m),F=this.G.get(I);if(!P||!F)return[];const T=await F.provideDebugVisualization(P,D);return T?T.map(z=>{const M=++this.M;this.L.set(M,{v:z,provider:F,extensionId:S});const j=z.iconPath?this.lb(z.iconPath):void 0;return{id:M,name:z.name,iconClass:j?.iconClass,iconPath:j?.iconPath,visualization:this.kb(S,z.visualization)}}):[]}$disposeDebugVisualizers(S){for(const m of S)this.L.delete(m)}registerDebugVisualizationProvider(S,m,E){if(!S.contributes?.debugVisualizers?.some(I=>I.id===m))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${m})`);const D=R.$Rm.toKey(S.identifier),P=this.jb(D,m);if(this.G.has(P))throw new Error(`A debug visualization provider with id '${m}' is already registered`);return this.G.set(P,E),this.l.$registerDebugVisualizer(D,m),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizer(D,m),this.G.delete(m)})}addBreakpoints(S){const m=S.filter(P=>{const I=P.id;return this.z.has(I)?!1:(this.z.set(I,P),!0)});this.gb(m,[],[]);const E=[],D=new Map;for(const P of m)if(P instanceof C.$cO){let I=D.get(P.location.uri.toString());I||(I={type:"sourceMulti",uri:P.location.uri,lines:[]},D.set(P.location.uri.toString(),I),E.push(I)),I.lines.push({id:P.id,enabled:P.enabled,condition:P.condition,hitCondition:P.hitCondition,logMessage:P.logMessage,line:P.location.range.start.line,character:P.location.range.start.character,mode:P.mode})}else P instanceof C.$dO&&E.push({type:"function",id:P.id,enabled:P.enabled,hitCondition:P.hitCondition,logMessage:P.logMessage,condition:P.condition,functionName:P.functionName,mode:P.mode});return this.l.$registerBreakpoints(E)}removeBreakpoints(S){const m=S.filter(I=>this.z.delete(I.id));this.gb([],m,[]);const E=m.filter(I=>I instanceof C.$cO).map(I=>I.id),D=m.filter(I=>I instanceof C.$dO).map(I=>I.id),P=m.filter(I=>I instanceof C.$eO).map(I=>I.id);return this.l.$unregisterBreakpoints(E,D,P)}startDebugging(S,m,E){return this.l.$startDebugging(S?S.uri:void 0,m,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,suppressSaveBeforeStart:E.suppressSaveBeforeStart,suppressDebugStatusbar:E.suppressDebugStatusbar??E.debugUI?.simple,suppressDebugToolbar:E.suppressDebugToolbar??E.debugUI?.simple,suppressDebugView:E.suppressDebugView??E.debugUI?.simple})}stopDebugging(S){return this.l.$stopDebugging(S?S.id:void 0)}registerDebugConfigurationProvider(S,m,E){if(!m)return new C.$aN(()=>{});const D=this.d++;return this.f.push({type:S,handle:D,provider:m}),this.l.$registerDebugConfigurationProvider(S,E,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,D),new C.$aN(()=>{this.f=this.f.filter(P=>P.provider!==m),this.l.$unregisterDebugConfigurationProvider(D)})}registerDebugAdapterDescriptorFactory(S,m,E){if(!E)return new C.$aN(()=>{});if(!this.cb(S,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.$(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const D=this.g++;return this.h.push({type:m,handle:D,factory:E}),this.l.$registerDebugAdapterDescriptorFactory(m,D),new C.$aN(()=>{this.h=this.h.filter(P=>P.factory!==E),this.l.$unregisterDebugAdapterDescriptorFactory(D)})}registerDebugAdapterTrackerFactory(S,m){if(!m)return new C.$aN(()=>{});const E=this.j++;return this.k.push({type:S,handle:E,factory:m}),new C.$aN(()=>{this.k=this.k.filter(D=>D.factory!==m)})}async $runInTerminal(S,m){return Promise.resolve(void 0)}async $substituteVariables(S,m){let E;const D=await this.ib(S);return D&&(E={uri:D.uri,name:D.name,index:D.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(E,m)}X(S,m){if(S.type==="implementation")return new f(S.implementation)}Y(){}async $startDASession(S,m){const E=this,D=await this.hb(m);return this.eb(this.$(D.type),D).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}' (extension might have failed to activate)`);const I=this.Z(P),F=this.X(I,D);if(!F)throw new Error(`Couldn't create a debug adapter for type '${D.type}'.`);const T=F;return this.D.set(S,T),this.db(D).then(z=>(z&&this.E.set(S,z),T.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const j=M,U={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const Z=await this.K.sign(j.arguments.value);U.body={signature:Z},T.sendResponse(U)}else throw new Error("no signer")}catch(Z){U.success=!1,U.message=Z.message,T.sendResponse(U)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(M),M=(0,v.$yH)(M,!0),E.l.$acceptDAMessage(S,M)}),T.onError(M=>{z&&z.onError&&z.onError(M),this.l.$acceptDAError(S,M.name,M.message,M.stack)}),T.onExit(M=>{z&&z.onExit&&z.onExit(M??void 0,void 0),this.l.$acceptDAExit(S,M??void 0,void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),T.startSession()))})}$sendDAMessage(S,m){m=(0,v.$xH)(m,!1);const E=this.E.get(S);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(m),this.D.get(S)?.sendMessage(m)}$stopDASession(S){const m=this.E.get(S);this.E.delete(S),m&&m.onWillStopSession&&m.onWillStopSession();const E=this.D.get(S);return this.D.delete(S),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(S){const m=[],E=[],D=[];if(S.added)for(const P of S.added){const I=P.id;if(I&&!this.z.has(I)){let F;if(P.type==="function")F=new C.$dO(P.functionName,P.enabled,P.condition,P.hitCondition,P.logMessage,P.mode);else if(P.type==="data")F=new C.$eO(P.label,P.dataId,P.canPersist,P.enabled,P.hitCondition,P.condition,P.logMessage,P.mode);else{const T=L.URI.revive(P.uri);F=new C.$cO(new C.$mN(T,new C.$bN(P.line,P.character)),P.enabled,P.condition,P.hitCondition,P.logMessage,P.mode)}(0,C.$aO)(F,I),this.z.set(I,F),m.push(F)}}if(S.removed)for(const P of S.removed){const I=this.z.get(P);I&&(this.z.delete(P),E.push(I))}if(S.changed){for(const P of S.changed)if(P.id){const I=this.z.get(P.id);if(I){if(I instanceof C.$dO&&P.type==="function"){const F=I;F.enabled=P.enabled,F.condition=P.condition,F.hitCondition=P.hitCondition,F.logMessage=P.logMessage,F.functionName=P.functionName}else if(I instanceof C.$cO&&P.type==="source"){const F=I;F.enabled=P.enabled,F.condition=P.condition,F.hitCondition=P.hitCondition,F.logMessage=P.logMessage,F.location=new C.$mN(L.URI.revive(P.uri),new C.$bN(P.line,P.character))}D.push(I)}}}this.gb(m,E,D)}async $acceptStackFrameFocus(S){let m;if(S){const E=await this.hb(S.sessionId);S.kind==="thread"?m=new C.$kO(E.api,S.threadId):m=new C.$jO(E.api,S.threadId,S.frameId)}this.B=m,this.C.fire(this.B)}$provideDebugConfigurations(S,m,E){return(0,d.$oh)(async()=>{const D=this.bb(S);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const P=await this.ib(m);return D.provideDebugConfigurations(P,E)}).then(D=>{if(!D)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return D})}$resolveDebugConfiguration(S,m,E,D){return(0,d.$oh)(async()=>{const P=this.bb(S);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.ib(m);return P.resolveDebugConfiguration(I,E,D)})}$resolveDebugConfigurationWithSubstitutedVariables(S,m,E,D){return(0,d.$oh)(async()=>{const P=this.bb(S);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.ib(m);return P.resolveDebugConfigurationWithSubstitutedVariables(I,E,D)})}async $provideDebugAdapter(S,m){const E=this.ab(S);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const D=await this.hb(m);return this.eb(E,D).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}'`);return this.Z(P)})}async $acceptDebugSessionStarted(S){const m=await this.hb(S);this.n.fire(m.api)}async $acceptDebugSessionTerminated(S){const m=await this.hb(S);m&&(this.o.fire(m.api),this.m.delete(m.id))}async $acceptDebugSessionActiveChanged(S){this.u=S?await this.hb(S):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(S,m){(await this.hb(S))?._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(S,m){const D={session:(await this.hb(S)).api,event:m.event,body:m.body};this.w.fire(D)}Z(S){if(S instanceof C.$fO)return{type:"executable",command:S.command,args:S.args,options:S.options};if(S instanceof C.$gO)return{type:"server",port:S.port,host:S.host};if(S instanceof C.$hO)return{type:"pipeServer",path:S.path};if(S instanceof C.$iO)return{type:"implementation",implementation:S.implementation};throw new Error("convertToDto unexpected type")}$(S){const m=this.h.filter(E=>E.type===S);if(m.length>0)return m[0].factory}ab(S){const m=this.h.filter(E=>E.handle===S);if(m.length>0)return m[0].factory}bb(S){const m=this.f.filter(E=>E.handle===S);if(m.length>0)return m[0].provider}cb(S,m){if(S.contributes){const E=S.contributes.debuggers;if(E&&E.length>0){for(const D of E)if(D.label&&D.type&&D.type===m)return!0}}return!1}db(S){const E=S.configuration.type,D=this.k.filter(P=>P.type===E||P.type==="*").map(P=>(0,d.$oh)(()=>P.factory.createDebugAdapterTracker(S.api)).then(I=>I,I=>null));return Promise.race([Promise.all(D).then(P=>{const I=(0,s.$Hb)(P);if(I.length>0)return new a(I)}),new Promise(P=>setTimeout(()=>P(void 0),1e3))]).catch(P=>{})}async eb(S,m){const E=m.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new C.$gO(E));if(S){const P=await this.O.getExtensionRegistry();return(0,d.$oh)(()=>S.createDebugAdapterDescriptor(m.api,this.fb(m,P))).then(I=>{if(I)return I})}const D=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(m,D))}fb(S,m){}gb(S,m,E){(S.length>0||m.length>0||E.length>0)&&this.A.fire(Object.freeze({added:S,removed:m,changed:E}))}async hb(S){if(S)if(typeof S=="string"){const m=this.m.get(S);if(m)return m}else{let m=this.m.get(S.id);if(!m){const E=await this.ib(S.folderUri),D=S.parent?this.m.get(S.parent):void 0;m=new c(this.l,S.id,S.type,S.name,E,S.configuration,D?.api),this.m.set(m.id,m),this.l.$sessionCached(m.id)}return m}throw new Error("cannot find session")}ib(S){if(S){const m=L.URI.revive(S);return this.N.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}jb(S,m){return`${S}\0${m}`}kb(S,m){if(m){if("title"in m&&"command"in m)return{type:0};if("treeId"in m)return{type:1,id:`${S}\0${m.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(S){const m=this.mb(S);let E,D;return"id"in m?D=n.ThemeIcon.asClassName(m):E=m,{iconPath:E,iconClass:D}}mb(S){if(S instanceof C.$0N)return{id:S.id};const m=typeof S=="object"&&"dark"in S?S.dark:S,E=typeof S=="object"&&"light"in S?S.light:S;return{dark:typeof m=="string"?L.URI.file(m):m,light:typeof E=="string"?L.URI.file(E):E}}};e.$xmc=t,e.$xmc=t=Ge([We(0,A.$zP),We(1,p.$Nlc),We(2,k.$rmc),We(3,h.$Qlc),We(4,$.$3lc),We(5,l.$umc),We(6,i.$VP)],t);class c{constructor(S,m,E,D,P,I,F){this.f=S,this.g=m,this.h=E,this.j=D,this.k=P,this.l=I,this.m=F}get api(){const S=this;return this.d??=Object.freeze({id:S.g,type:S.h,get name(){return S.j},set name(m){S.j=m,S.f.$setDebugSessionName(S.g,m)},parentSession:S.m,workspaceFolder:S.k,configuration:S.l,customRequest(m,E){return S.f.$customDebugAdapterRequest(S.g,m,E)},getDebugProtocolBreakpoint(m){return S.f.$getDebugProtocolBreakpoint(S.g,m.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(S){this.j=S}get configuration(){return this.l}}e.$ymc=c;class r{constructor(S){this.value=Object.freeze({append(m){S.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.$zmc=r;class a{constructor(S){this.d=S}onWillStartSession(){this.d.forEach(S=>S.onWillStartSession?S.onWillStartSession():void 0)}onWillReceiveMessage(S){this.d.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(S):void 0)}onDidSendMessage(S){this.d.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(S):void 0)}onWillStopSession(){this.d.forEach(S=>S.onWillStopSession?S.onWillStopSession():void 0)}onError(S){this.d.forEach(m=>m.onError?m.onError(S):void 0)}onExit(S,m){this.d.forEach(E=>E.onExit?E.onExit(S,m):void 0)}}class f extends y.$Rrb{constructor(S){super(),this.h=S,S.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(S){this.h.handleMessage(S)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let g=class extends t{constructor(S,m,E,D,P,I,F){super(S,m,E,D,P,I,F)}};e.$Amc=g,e.$Amc=g=Ge([We(0,A.$zP),We(1,p.$Nlc),We(2,k.$rmc),We(3,h.$Qlc),We(4,$.$3lc),We(5,l.$umc),We(6,i.$VP)],g)}),define(Se[380],De([1,0,13,59,2,6,327,11,85,107,28,263,20,68,49,90]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enc=e.$Dnc=void 0;class l{static async installEarlyHandler(i){Error.stackTraceLimit=100;const u=i.get(b.$3j),t=i.get(p.$zP).getProxy(R.$$M.MainThreadErrors);d.setUnexpectedErrorHandler(c=>{u.error(c);const r=d.$3(c);t.$onUnexpectedError(r)})}static async installFullHandler(i){const u=i.get(b.$3j),s=i.get(p.$zP),t=i.get(v.$rmc),c=i.get(h.$TP),r=s.getProxy(R.$$M.MainThreadExtensionService),a=s.getProxy(R.$$M.MainThreadErrors),f=await t.getExtensionPathIndex(),g=new WeakMap;function w(E,D){if(g.has(E))return g.get(E).stack;let P="",I,F;for(const z of D)P+=`
	at ${z.toString()}`,F=z.getFileName(),!I&&F&&(I=f.findSubstr(L.URI.file(F)));const T=`${E.name||"Error"}: ${E.message||""}${P}`;return g.set(E,{extensionIdentifier:I?.identifier,stack:T}),T}const S=Symbol("prepareStackTrace wrapped");let m=w;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return m},set(E){if(E===w||!E||E[S]){m=E||w;return}m=function(D,P){return w(D,P),E.call(Error,D,P)},Object.assign(m,{[S]:!0})}}),d.setUnexpectedErrorHandler(E=>{u.error(E);const D=d.$3(E),P=g.get(E);if(!P?.extensionIdentifier){a.$onUnexpectedError(D);return}r.$onExtensionRuntimeError(P.extensionIdentifier,D);const I=c.onExtensionError(P.extensionIdentifier,E);u.trace("forwarded error to extension?",I,P)})}}e.$Dnc=l;class o{constructor(i,u,s,t,c){this.a=s,this.b=new N.$$_b(i,null,t),u=o.e(u,this.b);const r=new k.$ui(...(0,$.$ys)());r.set(A.$PP,{_serviceBrand:void 0,...u,messagePorts:c}),r.set(p.$zP,new p.$AP(this.b)),r.set(y.$Klc,new y.$Llc(t)),r.set(v.$pmc,s);const a=new C.$cr(r,!0);a.invokeFunction(l.installEarlyHandler),this.d=a.invokeFunction(f=>f.get(b.$3j)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",u),this.c=a.invokeFunction(f=>f.get(v.$rmc)),this.c.initialize(),a.invokeFunction(l.installFullHandler)}async asBrowserUri(i){const u=this.b.getProxy(R.$$M.MainThreadExtensionService);return L.URI.revive(await u.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,u){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=L.URI.revive(u.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=L.URI.revive(u.transformIncomingURIs(i.environment.appRoot));const s=i.environment.extensionDevelopmentLocationURI;return s&&(i.environment.extensionDevelopmentLocationURI=s.map(t=>L.URI.revive(u.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=L.URI.revive(u.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=L.URI.revive(u.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=L.URI.revive(u.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=L.URI.revive(u.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=L.URI.revive(u.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=L.URI.revive(u.transformIncomingURIs(i.logsLocation)),i.workspace=u.transformIncomingURIs(i.workspace),i}}e.$Enc=o}),define(Se[381],De([1,0,7,12,236,256,141,96,72,49,20,43,8,61,44,300,301,45,34]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onc=void 0;let i=class extends b.$xmc{constructor(r,a,f,g,w,S,m,E){super(r,a,f,g,S,m,E),this.pb=w,this.nb=new t}X(r,a){switch(r.type){case"server":return new h.$Jnc(r);case"pipeServer":return new h.$Knc(r);case"executable":return new h.$Lnc(r,a.type)}return super.X(r,a)}fb(r,a){const f=h.$Lnc.platformAdapterExecutable(a.getAllExtensionDescriptions(),r.type);if(f)return new p.$fO(f.command,f.args,f.options)}Y(){return new N.$Ydc}async $runInTerminal(r,a){if(r.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(z=>{this.nb.onTerminalClosed(z)}));const f=await this.P.getConfigProvider(),g=this.pb.getDefaultShell(!0),w=this.pb.getDefaultShellArgs(!0),S=r.title||L.localize(0,null),m=JSON.stringify({shell:g,shellArgs:w});let E=await this.nb.checkout(m,S),D,P=!1;if(E)D=r.cwd;else{const z={shellPath:g,shellArgs:w,cwd:r.cwd,name:S,iconPath:new p.$0N("debug")};P=!0,E=this.pb.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(E,m)}E.show(!0);const I=await E.processId;P?await new Promise(z=>setTimeout(z,1e3)):(E.state.isInteractedWith&&(E.sendText(""),await(0,d.$xh)(200)),f.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0||g.indexOf("cmd.exe")>=0?E.sendText("cls"):g.indexOf("bash")>=0?E.sendText("clear"):O.$i?E.sendText("cls"):E.sendText("clear")));const F=(0,l.$Nnc)(g,r.args,!!r.argsCanBeInterpretedByShell,D,r.env);E.sendText(F);const T=this.onDidTerminateDebugSession(z=>{z.id===a&&(this.nb.free(E),T.dispose())});return I}else if(r.kind==="external")return s(r,await this.P.getConfigProvider());return super.$runInTerminal(r,a)}};e.$Onc=i,e.$Onc=i=Ge([We(0,A.$zP),We(1,v.$Nlc),We(2,k.$rmc),We(3,o.$Qlc),We(4,C.$cmc),We(5,$.$3lc),We(6,y.$umc),We(7,n.$VP)],i);let u;function s(c,r){if(!u)if(O.$i)u=new R.$Jcc;else if(O.$j)u=new R.$Kcc;else if(O.$k)u=new R.$Lcc;else throw new Error("external terminals not supported on this platform");const a=r.getConfiguration("terminal");return u.runInTerminal(c.title,c.cwd,c.args,c.env||{},a.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,a,f=!1){const w=[...this.b.entries()].map(([S,m])=>(0,d.$jh)(async E=>{if(S.name!==a||m.lastUsedAt!==-1&&await(0,l.$Mnc)(await S.processId))return null;const D=Date.now();return m.lastUsedAt+t.a>D||E.isCancellationRequested?null:m.config!==r?(f&&S.dispose(),null):(m.lastUsedAt=D,S)}));return await(0,d.$Bh)(w,S=>!!S)}insert(r,a){this.b.set(r,{lastUsedAt:Date.now(),config:a})}free(r){const a=this.b.get(r);a&&(a.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(Se[382],De([1,0,17,2,105,44,73,45,42,43,20,28,95,15,11,91,23,64,61]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gnc=void 0;let i=class extends p.$gnc{constructor(s,t,c,r,a,f,g,w,S){super(s,t,c,r,a,f,g,w),this.C=c,this.D=S,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(s,t){const c=t;if(!t.execution&&c._id===void 0)throw new Error("Tasks to execute must include an execution");if(c._id!==void 0){const r=p.TaskHandleDTO.from(c,this.C),a=await this.a.$getTaskExecution(r);if(a.task===void 0)throw new Error("Task from execution DTO is undefined");const f=await this.z(a,t);return this.a.$executeTask(r).catch(()=>{}),f}else{const r=p.TaskDTO.from(t,s);if(r===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(r.execution)&&await this.y(r,t,!1);const a=await this.z(await this.a.$getTaskExecution(r),t);return this.a.$executeTask(r).catch(()=>{}),a}}v(s,t,c,r){const a=[];if(r)for(const f of r){this.A(f,c),(!f.definition||!s[f.definition.type])&&this.f.warn(`The task [${f.source}, ${f.name}] uses an undefined task type. The task will be ignored in the future.`);const g=p.TaskDTO.from(f,c.extension);g&&(a.push(g),p.CustomExecutionDTO.is(g.execution)&&t.push(this.y(g,f,!0)))}return{tasks:a,extension:c.extension}}async w(s){return s}async G(s){let t=s&&s.length>0?s[0]:void 0;if(!t){const c=O.URI.file((0,o.homedir)());t=new $.$Qi({uri:c,name:l.$7g(c),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(s,t){const c=O.URI.revive(s),r={process:void 0,variables:Object.create(null)},a=await this.b.resolveWorkspaceFolder(c),f=await this.b.getWorkspaceFolders2()??[],g=await this.D.getResolver(),w=a?{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(f);for(const S of t.variables)r.variables[S]=await g.resolveAsync(w,S);if(t.process!==void 0){let S;if(t.process.path!==void 0){S=t.process.path.split(d.$tc);for(let m=0;m<S.length;m++)S[m]=await g.resolveAsync(w,S[m])}r.process=await L.win32.findExecutable(await g.resolveAsync(w,t.process.name),t.process.cwd!==void 0?await g.resolveAsync(w,t.process.cwd):void 0,S)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(s,t,c){return L.win32.findExecutable(s,t,c)}};e.$Gnc=i,e.$Gnc=i=Ge([We(0,A.$zP),We(1,C.$PP),We(2,R.$Nlc),We(3,N.$KP),We(4,b.$Qlc),We(5,k.$cmc),We(6,v.$3j),We(7,h.$rlc),We(8,n.$umc)],i)}),define(Se[383],De([1,0,64,61]),function(he,e,d,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$moc=void 0;class L extends O.$vmc{m(){return(0,d.homedir)()}}e.$moc=L}),define(Se[160],De([1,0,19,7,22,47,15,17,23,2,37]),function(he,e,d,O,L,R,N,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=e.$Pmc=e.$Omc=void 0,e.$Qmc=h;class C{constructor(n,i,u){this.d=n,this.e=i,this.f=u,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const u=this.g.folderQueries||[],s=new L.$oe(i);return new Promise((t,c)=>{this.a=new y(n);let r=!1;const a=(f,g)=>{if(!r&&!this.b){const w=this.h(f);h(f)&&typeof this.g.maxResults=="number"&&this.c+w>this.g.maxResults&&(this.b=!0,r=!0,s.cancel(),f=this.j(f,this.g.maxResults-this.c));const S=this.h(f);this.c+=S,(S>0||!h(f))&&this.a.add(f,g)}};Promise.all(u.map((f,g)=>this.k(f,w=>a(w,g),s.token))).then(f=>{s.dispose(),this.a.flush();const g=f.some(w=>!!w&&!!w.limitHit);t({limitHit:this.b||g,messages:f.flatMap(w=>w?.message?Array.isArray(w.message)?w.message:[w.message]:[]),stats:{type:this.f}})},f=>{s.dispose();const g=(0,R.$hj)(f);c(new Error(g))})})}h(n){return h(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const u=Array.isArray(n.ranges)?n.ranges:[n.ranges],s=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:u.slice(0,i),preview:{matches:s.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,u){const s=new A.$EL(this.g,n),t=[],c={report:f=>{if(!this.l(f))return;const g=n.folder.scheme===N.Schemas.file?(0,A.$FL)(()=>this.e.readdir($.$9g(f.uri))):void 0,w=$.$_g(n.folder,f.uri);if(w){const S=s.includedInQuery(w,b.$nc(w),g);(0,O.$ih)(S)?t.push(S.then(m=>{m&&i(f)})):S&&i(f)}}},r=this.n(n);let a;return this.d.query.type===3?a=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,r,c,u):a=await this.d.provider.provideTextSearchResults(p(this.d.query.contentPattern),r,c,u),t.length&&await Promise.all(t),a}l(n){if(h(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,A.$DL)(this.g.includePattern,n.includePattern),u=(0,A.$DL)(this.g.excludePattern,n.excludePattern),s={folder:k.URI.from(n.folder),excludes:u,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(s.usePCRE2=this.g.usePCRE2),s}}e.$Omc=C;function p(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class y{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new l(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!$.$3g(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(v(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Pmc=y;function v(o){return h(o)?{preview:{matches:(0,d.$1b)(o.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:o.preview.text},ranges:(0,d.$1b)(o.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function h(o){return!!o.preview}class l{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<l.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},l.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Rmc=l}),define(Se[97],De([1,0,3,6,5,376,20,68,11,2,160]),function(he,e,d,O,L,R,N,b,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=e.$Smc=void 0,e.$Umc=p,e.$Smc=(0,L.$wi)("IExtHostSearch");let C=class{constructor(h,l,o){this.n=h,this.o=l,this.q=o,this.c=this.n.getProxy(O.$$M.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$Nmc}s(h){return this.o.transformOutgoingScheme(h)}registerTextSearchProvider(h,l){if(this.g.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this.g.add(h);const o=this.d++;return this.e.set(o,l),this.c.$registerTextSearchProvider(o,this.s(h)),(0,d.$Sc)(()=>{this.g.delete(h),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(h,l){if(this.i.has(h))throw new Error(`an AI text search provider for the scheme '${h}'is already registered`);this.i.add(h);const o=this.d++;return this.h.set(o,l),this.c.$registerAITextSearchProvider(o,this.s(h)),(0,d.$Sc)(()=>{this.i.delete(h),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(h,l){if(this.k.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this.k.add(h);const o=this.d++;return this.j.set(o,l),this.c.$registerFileSearchProvider(o,this.s(h)),(0,d.$Sc)(()=>{this.k.delete(h),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(h,l,o,n){const i=p(o),u=this.j.get(h);if(u)return this.l.fileSearch(i,u,s=>{this.c.$handleFileMatch(h,l,s.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+h)}async doInternalFileSearchWithCustomCallback(h,l,o){return{messages:[]}}$clearCache(h){return this.l.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,l,o,n){const i=this.e.get(h);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${h}`);const u=p(o);return this.t(u,i).search(t=>this.c.$handleTextMatch(h,l,t),n)}$provideAITextSearchResults(h,l,o,n){const i=this.h.get(h);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${h}`);const u=p(o);return this.v(u,i).search(t=>this.c.$handleTextMatch(h,l,t),n)}$enableExtensionHostSearch(){}t(h,l){return new A.$Omc({query:h,provider:l},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(h,l){return new A.$Omc({query:h,provider:l},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$Tmc=C,e.$Tmc=C=Ge([We(0,N.$zP),We(1,b.$Klc),We(2,$.$3j)],C);function p(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(y),extraFileResources:v.extraFileResources&&v.extraFileResources.map(h=>k.URI.revive(h))}}function y(v){return{...v,folder:k.URI.revive(v.folder)}}}),define(Se[384],De([1,0,22,13,4,3,15,41,2,136,203,184,80,25,33,11,86,87,283,6,329,355,91,121,333,334,335,316,305,34,336,45,337,96,152,338,318,330,339,340,73,72,331,49,341,70,342,60,28,356,357,319,343,122,344,116,117,320,375,346,288,347,358,348,158,321,349,350,351,20,352,97,118,353,322,354,119,93,95,90,43,156,359,360,332,361,362,71,16,8,323,68,324,92,363,364,151,44,298,115,26,94]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n,i,u,s,t,c,r,a,f,g,w,S,m,E,D,P,I,F,T,z,M,j,U,Z,ie,q,G,x,ne,be,ae,Ce,ee,B,_,pe,ue,ce,oe,le,K,se,$e,ve,Re,ge,Ie,Ae,ze,V,W,J,X,de,we,je,Ve,Je,tt,_e,nt,it,rt,at,Ne,ye,qe,te,re,Pe,He,Le,st,lt,mt,Pt,It,Bt,Ut,kt,Yt,xt,xe,on){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=Kt;function Kt(ft){const $t=ft.get(ae.$PP),_t=ft.get(be.$vlc),Jt=ft.get(x.$Slc),Tt=ft.get(q.$rmc),gt=ft.get(kt.$Nlc),Vt=ft.get(it.$TP),en=ft.get(E.$Qlc),Wt=ft.get(lt.$Klc),Ze=ft.get(J.$zP),un=ft.get(tt.$_lc),Xt=ft.get(_e.$Tlc),Ht=ft.get(h.$4j),wt=ft.get(h.$3j),Ft=ft.get(Pe.$sDb),Rt=ft.get(t.$rlc),jt=ft.get(Ut.$xnc),tn=ft.get(we.$jmc),qt=ft.get(Z.$3lc),an=ft.get(oe.$nmc),Ot=ft.get(c.$Blc),Lt=ft.get(pe.$gmc);Ze.set(i.$_M.ExtHostFileSystemInfo,_t),Ze.set(i.$_M.ExtHostLogLevelServiceShape,Ht),Ze.set(i.$_M.ExtHostWorkspace,gt),Ze.set(i.$_M.ExtHostConfiguration,en),Ze.set(i.$_M.ExtHostExtensionService,Tt),Ze.set(i.$_M.ExtHostStorage,un),Ze.set(i.$_M.ExtHostTunnelService,Ft),Ze.set(i.$_M.ExtHostWindow,jt),Ze.set(i.$_M.ExtHostSecretState,tn),Ze.set(i.$_M.ExtHostTelemetry,Vt),Ze.set(i.$_M.ExtHostEditorTabs,qt),Ze.set(i.$_M.ExtHostManagedSockets,an),Ze.set(i.$_M.ExtHostAuthentication,Ot),Ze.set(i.$_M.ExtHostChatProvider,Lt);const Mt=Ze.set(i.$_M.ExtHostDecorations,ft.get(I.$Cmc)),At=Ze.set(i.$_M.ExtHostDocumentsAndEditors,ft.get(U.$KP)),pt=Ze.set(i.$_M.ExtHostCommands,ft.get(S.$VP)),St=Ze.set(i.$_M.ExtHostTerminalService,ft.get(rt.$cmc)),sn=Ze.set(i.$_M.ExtHostTerminalShellIntegration,ft.get(at.$jnc)),Dt=Ze.set(i.$_M.ExtHostDebugService,ft.get(P.$wmc)),mn=Ze.set(i.$_M.ExtHostSearch,ft.get(de.$Smc)),nn=Ze.set(i.$_M.ExtHostTask,ft.get(nt.$inc)),bn=Ze.set(i.$_M.ExtHostOutputService,ft.get(Ie.$8mc)),ln=Ze.set(i.$_M.ExtHostLocalization,ft.get(ce.$mmc)),wn=Ze.set(i.$_M.ExtHostUrls,new mt.$unc(Ze)),Ct=Ze.set(i.$_M.ExtHostDocuments,new j.$ylc(Ze,At)),Dn=Ze.set(i.$_M.ExtHostDocumentContentProviders,new z.$Emc(Ze,At,wt)),Oe=Ze.set(i.$_M.ExtHostDocumentSaveParticipant,new M.$Fmc(wt,Ct,Ze.getProxy(i.$$M.MainThreadBulkEdits))),Te=Ze.set(i.$_M.ExtHostNotebook,new K.$Vmc(Ze,pt,At,Ct,Jt,mn)),ke=Ze.set(i.$_M.ExtHostNotebookDocuments,new $e.$2mc(Te)),Y=Ze.set(i.$_M.ExtHostNotebookEditors,new ve.$3mc(wt,Te)),Fe=Ze.set(i.$_M.ExtHostNotebookKernels,new Re.$4mc(Ze,$t,Te,pt,wt)),Qe=Ze.set(i.$_M.ExtHostNotebookRenderers,new ge.$6mc(Ze,Te)),Ye=Ze.set(i.$_M.ExtHostNotebookDocumentSaveParticipant,new se.$1mc(wt,Te,Ze.getProxy(i.$$M.MainThreadBulkEdits))),Ke=Ze.set(i.$_M.ExtHostEditors,new ye.$Hlc(Ze,At)),ht=Ze.set(i.$_M.ExtHostTreeViews,new re.$snc(Ze.getProxy(i.$$M.MainThreadTreeViews),pt,wt)),Et=Ze.set(i.$_M.ExtHostEditorInsets,new w.$Ilc(Ze.getProxy(i.$$M.MainThreadEditorInsets),Ke,$t.remote)),zt=Ze.set(i.$_M.ExtHostDiagnostics,new F.$xlc(Ze,wt,_t,At)),Qt=Ze.set(i.$_M.ExtHostLanguages,new ue.$Ymc(Ze,Ct,pt.converter,Wt)),ut=Ze.set(i.$_M.ExtHostLanguageFeatures,new _.$zlc(Ze,Wt,Ct,pt,zt,wt,Rt,Vt)),Zt=Ze.set(i.$_M.ExtHostFileSystem,new G.$Hmc(Ze,ut)),$n=Ze.set(i.$_M.ExtHostFileSystemEventService,new ne.$Imc(Ze,wt,At)),En=Ze.set(i.$_M.ExtHostQuickOpen,(0,W.$_mc)(Ze,gt,pt)),Pn=Ze.set(i.$_M.ExtHostSCM,new X.$bnc(Ze,pt,Ct,wt)),Kn=Ze.set(i.$_M.ExtHostQuickDiff,new V.$$mc(Ze,Wt)),On=Ze.set(i.$_M.ExtHostShare,new je.$cnc(Ze,Wt)),Mn=Ze.set(i.$_M.ExtHostComments,(0,m.$Jlc)(Ze,pt,Ct)),Cn=Ze.set(i.$_M.ExtHostProgress,new ze.$0mc(Ze.getProxy(i.$$M.MainThreadProgress))),Tn=Ze.set(i.$_M.ExtHostLabelService,new B.$Xmc(Ze)),Fn=Ze.set(i.$_M.ExtHostTheming,new qe.$pnc(Ze)),Jn=Ze.set(i.$_M.ExtHostTimeline,new te.$rnc(Ze,pt)),jn=Ze.set(i.$_M.ExtHostWebviews,new Pt.$Xlc(Ze,$t.remote,gt,wt,Rt)),In=Ze.set(i.$_M.ExtHostWebviewPanels,new It.$1lc(Ze,jn,gt)),zn=Ze.set(i.$_M.ExtHostCustomEditors,new D.$2lc(Ze,Ct,Xt,jn,In)),Bn=Ze.set(i.$_M.ExtHostWebviewViews,new Bt.$vnc(Ze,jn)),vn=Ze.set(i.$_M.ExtHostTesting,new Ne.$lnc(Ze,wt,pt,At)),Xn=Ze.set(i.$_M.ExtHostUriOpeners,new st.$tnc(Ze)),Zn=Ze.set(i.$_M.ExtHostProfileContentHandlers,new Ae.$9mc(Ze));Ze.set(i.$_M.ExtHostInteractive,new ee.$Wmc(Ze,Te,At,pt,wt));const Yn=Ze.set(i.$_M.ExtHostInlineChat,new Ce.$Jmc(Ze,pt,Ct,wt)),An=Ze.set(i.$_M.ExtHostChatAgents2,new a.$Elc(Ze,wt,pt)),xn=Ze.set(i.$_M.ExtHostChatVariables,new f.$Flc(Ze)),_n=Ze.set(i.$_M.ExtHostAiRelatedInformation,new u.$qlc(Ze)),di=Ze.set(i.$_M.ExtHostAiEmbeddingVector,new ie.$Gmc(Ze)),Rn=Ze.set(i.$_M.ExtHostStatusBar,new Je.$fnc(Ze,pt.converter)),Un=Ze.set(i.$_M.ExtHostSpeech,new Ve.$dnc(Ze)),fi=Object.values(i.$_M);Ze.assertRegistered(fi);const gi=new r.$Dlc(Ze,At),ei=new g.$Glc(Ze),Wn=new le.$Zmc(Ze,wt),Nn=new T.$Dmc(Ze);return s.$Alc.register(pt),function(Ue,hn,Vn){function ot(fe){return(Ee,Be,ct)=>{const yt=fe(Nt=>{try{Ee.call(Be,Nt)}catch(Sn){O.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${Sn.toString()}`,{cause:Sn})),Vt.onExtensionError(Ue.identifier,Sn)}});return ct?.push(yt),yt}}const vt=function(){let fe=!Ue.isUnderDevelopment;function Ee(){fe||(wt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),fe=!0)}return function Be(ct){if(Array.isArray(ct))ct.forEach(Be);else if(typeof ct=="string")Ee();else{const yt=ct;typeof yt.scheme>"u"&&Ee(),typeof yt.exclusive=="boolean"&&(0,xe.$PG)(Ue,"documentFiltersExclusive")}return ct}}(),ti={getSession(fe,Ee,Be){return typeof Be?.forceNewSession=="object"&&Be.forceNewSession.learnMore&&(0,xe.$PG)(Ue,"authLearnMore"),Ot.getSession(Ue,fe,Ee,Be)},getSessions(fe,Ee){return(0,xe.$PG)(Ue,"authGetSessions"),Ot.getSessions(Ue,fe,Ee)},async hasSession(fe,Ee){return(0,xe.$PG)(Ue,"authSession"),!!await Ot.getSession(Ue,fe,Ee,{silent:!0})},get onDidChangeSessions(){return ot(Ot.onDidChangeSessions)},registerAuthenticationProvider(fe,Ee,Be,ct){return Ot.registerAuthenticationProvider(fe,Ee,Be,ct)}},fn={registerCommand(fe,Ee,Be){return pt.registerCommand(!0,fe,Ee,Be,void 0,Ue)},registerTextEditorCommand(fe,Ee,Be){return pt.registerCommand(!0,fe,(...ct)=>{const yt=Ke.getActiveTextEditor();if(!yt){wt.warn("Cannot execute "+fe+" because there is no active text editor.");return}return yt.edit(Nt=>{Ee.apply(Be,[yt,Nt,...ct])}).then(Nt=>{Nt||wt.warn("Edits from command "+fe+" were not applied.")},Nt=>{wt.warn("An error occurred while running command "+fe,Nt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(fe,Ee,Be)=>((0,xe.$PG)(Ue,"diffCommand"),pt.registerCommand(!0,fe,async(...ct)=>{const yt=At.activeEditor(!0);if(!yt){wt.warn("Cannot execute "+fe+" because there is no active text editor.");return}const Nt=await Ke.getDiffInformation(yt.id);Ee.apply(Be,[Nt,...ct])},void 0,void 0,Ue)),executeCommand(fe,...Ee){return pt.executeCommand(fe,...Ee)},getCommands(fe=!1){return pt.getCommands(fe)}},kn={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return ei.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return ot(St.onDidChangeShell)},get isTelemetryEnabled(){return Vt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Vt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,xe.$PG)(Ue,"telemetry"),Vt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,xe.$PG)(Ue,"telemetry"),ot(Vt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,it.$SP)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(fe,Ee){return it.$RP.validateSender(fe),Vt.instantiateLogger(Ue,fe,Ee)},openExternal(fe,Ee){return jt.openUri(fe,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(fe){if(fe.scheme===$t.environment.appUriScheme)return wn.createAppUri(fe);try{return await jt.asExternalUri(fe,{allowTunneling:!!$t.remote.authority})}catch(Ee){if((0,N.$Fg)(fe,N.Schemas.http)||(0,N.$Fg)(fe,N.Schemas.https))return fe;throw Ee}},get remoteName(){return(0,l.$Im)($t.remote.authority)},get remoteAuthority(){return(0,xe.$PG)(Ue,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return wt.getLevel()},get onDidChangeLogLevel(){return ot(wt.onDidChangeLogLevel)},get appQuality(){return(0,xe.$PG)(Ue,"resolvers"),$t.quality},get appCommit(){return(0,xe.$PG)(Ue,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(kn);const mi={createTestController(fe,Ee,Be){return vn.createTestController(Ue,fe,Ee,Be)},createTestObserver(){return(0,xe.$PG)(Ue,"testObserver"),vn.createTestObserver()},runTests(fe){return(0,xe.$PG)(Ue,"testObserver"),vn.runTests(fe)},get onDidChangeTestResults(){return(0,xe.$PG)(Ue,"testObserver"),ot(vn.onResultsChanged)},get testResults(){return(0,xe.$PG)(Ue,"testObserver"),vn.results}},rn=$t.remote.isRemote?Le.ExtensionKind.Workspace:Le.ExtensionKind.UI,Ln={getExtension(fe,Ee){(0,xe.$OG)(Ue,"extensionsAny")||(Ee=!1);const Be=hn.mine.getExtensionDescription(fe);if(Be)return new q.$smc(Tt,Ue.identifier,Be,rn,!1);if(Ee){const ct=hn.all.getExtensionDescription(fe);if(ct)return new q.$smc(Tt,Ue.identifier,ct,rn,!0)}},get all(){const fe=[];for(const Ee of hn.mine.getAllExtensionDescriptions())fe.push(new q.$smc(Tt,Ue.identifier,Ee,rn,!1));return fe},get allAcrossExtensionHosts(){(0,xe.$PG)(Ue,"extensionsAny");const fe=new y.$Sm(hn.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),Ee=[];for(const Be of hn.all.getAllExtensionDescriptions()){const ct=!fe.has(Be.identifier);Ee.push(new q.$smc(Tt,Ue.identifier,Be,rn,ct))}return Ee},get onDidChange(){return(0,xe.$OG)(Ue,"extensionsAny")?ot(L.Event.any(hn.mine.onDidChange,hn.all.onDidChange)):ot(hn.mine.onDidChange)}},ni={createDiagnosticCollection(fe){return zt.createDiagnosticCollection(Ue.identifier,fe)},get onDidChangeDiagnostics(){return ot(zt.onDidChangeDiagnostics)},getDiagnostics:fe=>zt.getDiagnostics(fe),getLanguages(){return Qt.getLanguages()},setTextDocumentLanguage(fe,Ee){return Qt.changeLanguage(fe.uri,Ee)},match(fe,Ee){const Be=He.LanguageSelector.from(fe);let ct;return(0,A.$Yt)(Be)&&(ct=Te.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(Nt=>Nt.document===Ee))?.apiNotebook),(0,A.$Xt)(Be,Ee.uri,Ee.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(fe,Ee,Be){return ut.registerCodeActionProvider(Ue,vt(fe),Ee,Be)},registerDocumentPasteEditProvider(fe,Ee,Be){return(0,xe.$PG)(Ue,"documentPaste"),ut.registerDocumentPasteEditProvider(Ue,vt(fe),Ee,Be)},registerCodeLensProvider(fe,Ee){return ut.registerCodeLensProvider(Ue,vt(fe),Ee)},registerDefinitionProvider(fe,Ee){return ut.registerDefinitionProvider(Ue,vt(fe),Ee)},registerDeclarationProvider(fe,Ee){return ut.registerDeclarationProvider(Ue,vt(fe),Ee)},registerImplementationProvider(fe,Ee){return ut.registerImplementationProvider(Ue,vt(fe),Ee)},registerTypeDefinitionProvider(fe,Ee){return ut.registerTypeDefinitionProvider(Ue,vt(fe),Ee)},registerHoverProvider(fe,Ee){return ut.registerHoverProvider(Ue,vt(fe),Ee,Ue.identifier)},registerEvaluatableExpressionProvider(fe,Ee){return ut.registerEvaluatableExpressionProvider(Ue,vt(fe),Ee,Ue.identifier)},registerInlineValuesProvider(fe,Ee){return ut.registerInlineValuesProvider(Ue,vt(fe),Ee,Ue.identifier)},registerDocumentHighlightProvider(fe,Ee){return ut.registerDocumentHighlightProvider(Ue,vt(fe),Ee)},registerMultiDocumentHighlightProvider(fe,Ee){return ut.registerMultiDocumentHighlightProvider(Ue,vt(fe),Ee)},registerLinkedEditingRangeProvider(fe,Ee){return ut.registerLinkedEditingRangeProvider(Ue,vt(fe),Ee)},registerReferenceProvider(fe,Ee){return ut.registerReferenceProvider(Ue,vt(fe),Ee)},registerRenameProvider(fe,Ee){return ut.registerRenameProvider(Ue,vt(fe),Ee)},registerNewSymbolNamesProvider(fe,Ee){return(0,xe.$PG)(Ue,"newSymbolNamesProvider"),ut.registerNewSymbolNamesProvider(Ue,vt(fe),Ee)},registerDocumentSymbolProvider(fe,Ee,Be){return ut.registerDocumentSymbolProvider(Ue,vt(fe),Ee,Be)},registerWorkspaceSymbolProvider(fe){return ut.registerWorkspaceSymbolProvider(Ue,fe)},registerDocumentFormattingEditProvider(fe,Ee){return ut.registerDocumentFormattingEditProvider(Ue,vt(fe),Ee)},registerDocumentRangeFormattingEditProvider(fe,Ee){return ut.registerDocumentRangeFormattingEditProvider(Ue,vt(fe),Ee)},registerOnTypeFormattingEditProvider(fe,Ee,Be,...ct){return ut.registerOnTypeFormattingEditProvider(Ue,vt(fe),Ee,[Be].concat(ct))},registerDocumentSemanticTokensProvider(fe,Ee,Be){return ut.registerDocumentSemanticTokensProvider(Ue,vt(fe),Ee,Be)},registerDocumentRangeSemanticTokensProvider(fe,Ee,Be){return ut.registerDocumentRangeSemanticTokensProvider(Ue,vt(fe),Ee,Be)},registerSignatureHelpProvider(fe,Ee,Be,...ct){return typeof Be=="object"?ut.registerSignatureHelpProvider(Ue,vt(fe),Ee,Be):ut.registerSignatureHelpProvider(Ue,vt(fe),Ee,typeof Be>"u"?[]:[Be,...ct])},registerCompletionItemProvider(fe,Ee,...Be){return ut.registerCompletionItemProvider(Ue,vt(fe),Ee,Be)},registerInlineCompletionItemProvider(fe,Ee,Be){return Ee.handleDidShowCompletionItem&&(0,xe.$PG)(Ue,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,xe.$PG)(Ue,"inlineCompletionsAdditions"),Be&&(0,xe.$PG)(Ue,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Ue,vt(fe),Ee,Be)},registerInlineEditProvider(fe,Ee){return(0,xe.$PG)(Ue,"inlineEdit"),ut.registerInlineEditProvider(Ue,vt(fe),Ee)},registerDocumentLinkProvider(fe,Ee){return ut.registerDocumentLinkProvider(Ue,vt(fe),Ee)},registerColorProvider(fe,Ee){return ut.registerColorProvider(Ue,vt(fe),Ee)},registerFoldingRangeProvider(fe,Ee){return ut.registerFoldingRangeProvider(Ue,vt(fe),Ee)},registerSelectionRangeProvider(fe,Ee){return ut.registerSelectionRangeProvider(Ue,fe,Ee)},registerCallHierarchyProvider(fe,Ee){return ut.registerCallHierarchyProvider(Ue,fe,Ee)},registerTypeHierarchyProvider(fe,Ee){return ut.registerTypeHierarchyProvider(Ue,fe,Ee)},setLanguageConfiguration:(fe,Ee)=>ut.setLanguageConfiguration(Ue,fe,Ee),getTokenInformationAtPosition(fe,Ee){return(0,xe.$PG)(Ue,"tokenInformation"),Qt.tokenAtPosition(fe,Ee)},registerInlayHintsProvider(fe,Ee){return ut.registerInlayHintsProvider(Ue,fe,Ee)},createLanguageStatusItem(fe,Ee){return Qt.createLanguageStatusItem(Ue,fe,Ee)},registerDocumentDropEditProvider(fe,Ee,Be){return ut.registerDocumentOnDropEditProvider(Ue,fe,Ee,(0,xe.$OG)(Ue,"documentPaste")?Be:void 0)}},ii={get activeTextEditor(){return Ke.getActiveTextEditor()},get visibleTextEditors(){return Ke.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(fe,Ee,Be){$.URI.isUri(fe)&&fe.scheme===N.Schemas.vscodeRemote&&!fe.authority&&Rt.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await($.URI.isUri(fe)?Promise.resolve(qn.openTextDocument(fe)):Promise.resolve(fe));return Ke.showTextDocument(ct,Ee,Be)},createTextEditorDecorationType(fe){return Ke.createTextEditorDecorationType(Ue,fe)},onDidChangeActiveTextEditor(fe,Ee,Be){return ot(Ke.onDidChangeActiveTextEditor)(fe,Ee,Be)},onDidChangeVisibleTextEditors(fe,Ee,Be){return ot(Ke.onDidChangeVisibleTextEditors)(fe,Ee,Be)},onDidChangeTextEditorSelection(fe,Ee,Be){return ot(Ke.onDidChangeTextEditorSelection)(fe,Ee,Be)},onDidChangeTextEditorOptions(fe,Ee,Be){return ot(Ke.onDidChangeTextEditorOptions)(fe,Ee,Be)},onDidChangeTextEditorVisibleRanges(fe,Ee,Be){return ot(Ke.onDidChangeTextEditorVisibleRanges)(fe,Ee,Be)},onDidChangeTextEditorViewColumn(fe,Ee,Be){return ot(Ke.onDidChangeTextEditorViewColumn)(fe,Ee,Be)},onDidCloseTerminal(fe,Ee,Be){return ot(St.onDidCloseTerminal)(fe,Ee,Be)},onDidOpenTerminal(fe,Ee,Be){return ot(St.onDidOpenTerminal)(fe,Ee,Be)},onDidChangeActiveTerminal(fe,Ee,Be){return ot(St.onDidChangeActiveTerminal)(fe,Ee,Be)},onDidChangeTerminalDimensions(fe,Ee,Be){return(0,xe.$PG)(Ue,"terminalDimensions"),ot(St.onDidChangeTerminalDimensions)(fe,Ee,Be)},onDidChangeTerminalState(fe,Ee,Be){return ot(St.onDidChangeTerminalState)(fe,Ee,Be)},onDidWriteTerminalData(fe,Ee,Be){return(0,xe.$PG)(Ue,"terminalDataWriteEvent"),ot(St.onDidWriteTerminalData)(fe,Ee,Be)},onDidExecuteTerminalCommand(fe,Ee,Be){return(0,xe.$PG)(Ue,"terminalExecuteCommandEvent"),ot(St.onDidExecuteTerminalCommand)(fe,Ee,Be)},onDidChangeTerminalShellIntegration(fe,Ee,Be){return(0,xe.$PG)(Ue,"terminalShellIntegration"),ot(sn.onDidChangeTerminalShellIntegration)(fe,Ee,Be)},onDidStartTerminalShellExecution(fe,Ee,Be){return(0,xe.$PG)(Ue,"terminalShellIntegration"),ot(sn.onDidStartTerminalShellExecution)(fe,Ee,Be)},onDidEndTerminalShellExecution(fe,Ee,Be){return(0,xe.$PG)(Ue,"terminalShellIntegration"),ot(sn.onDidEndTerminalShellExecution)(fe,Ee,Be)},get state(){return jt.getState()},onDidChangeWindowState(fe,Ee,Be){return ot(jt.onDidChangeWindowState)(fe,Ee,Be)},showInformationMessage(fe,...Ee){return Wn.showMessage(Ue,b.default.Info,fe,Ee[0],Ee.slice(1))},showWarningMessage(fe,...Ee){return Wn.showMessage(Ue,b.default.Warning,fe,Ee[0],Ee.slice(1))},showErrorMessage(fe,...Ee){return Wn.showMessage(Ue,b.default.Error,fe,Ee[0],Ee.slice(1))},showQuickPick(fe,Ee,Be){return En.showQuickPick(Ue,fe,Ee,Be)},showWorkspaceFolderPick(fe){return En.showWorkspaceFolderPick(fe)},showInputBox(fe,Ee){return En.showInput(fe,Ee)},showOpenDialog(fe){return Nn.showOpenDialog(Ue,fe)},showSaveDialog(fe){return Nn.showSaveDialog(fe)},createStatusBarItem(fe,Ee,Be){let ct,yt,Nt;return typeof fe=="string"?(ct=fe,yt=Ee,Nt=Be):(yt=fe,Nt=Ee),Rn.createStatusBarEntry(Ue,ct,yt,Nt)},setStatusBarMessage(fe,Ee){return Rn.setStatusBarMessage(fe,Ee)},withScmProgress(fe){return Rt.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Cn.withProgress(Ue,{location:Le.ProgressLocation.SourceControl},(Ee,Be)=>fe({report(ct){}}))},withProgress(fe,Ee){return Cn.withProgress(Ue,fe,Ee)},createOutputChannel(fe,Ee){return bn.createOutputChannel(fe,Ee,Ue)},createWebviewPanel(fe,Ee,Be,ct){return In.createWebviewPanel(Ue,fe,Ee,Be,ct)},createWebviewTextEditorInset(fe,Ee,Be,ct){return(0,xe.$PG)(Ue,"editorInsets"),Et.createWebviewEditorInset(fe,Ee,Be,ct,Ue)},createTerminal(fe,Ee,Be){return typeof fe=="object"?"pty"in fe?St.createExtensionTerminal(fe):St.createTerminalFromOptions(fe):St.createTerminal(fe,Ee,Be)},registerTerminalLinkProvider(fe){return St.registerLinkProvider(fe)},registerTerminalProfileProvider(fe,Ee){return St.registerProfileProvider(Ue,fe,Ee)},registerTerminalQuickFixProvider(fe,Ee){return(0,xe.$PG)(Ue,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(fe,Ue.identifier.value,Ee)},registerTreeDataProvider(fe,Ee){return ht.registerTreeDataProvider(fe,Ee,Ue)},createTreeView(fe,Ee){return ht.createTreeView(fe,Ee,Ue)},registerWebviewPanelSerializer:(fe,Ee)=>In.registerWebviewPanelSerializer(Ue,fe,Ee),registerCustomEditorProvider:(fe,Ee,Be={})=>zn.registerCustomEditorProvider(Ue,fe,Ee,Be),registerFileDecorationProvider(fe){return Mt.registerFileDecorationProvider(fe,Ue)},registerUriHandler(fe){return wn.registerUriHandler(Ue,fe)},createQuickPick(){return En.createQuickPick(Ue)},createInputBox(){return En.createInputBox(Ue)},get activeColorTheme(){return Fn.activeColorTheme},onDidChangeActiveColorTheme(fe,Ee,Be){return ot(Fn.onDidChangeActiveColorTheme)(fe,Ee,Be)},registerWebviewViewProvider(fe,Ee,Be){return Bn.registerWebviewViewProvider(Ue,fe,Ee,Be?.webviewOptions)},get activeNotebookEditor(){return Te.activeNotebookEditor},onDidChangeActiveNotebookEditor(fe,Ee,Be){return ot(Te.onDidChangeActiveNotebookEditor)(fe,Ee,Be)},get visibleNotebookEditors(){return Te.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Te.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(fe,Ee,Be){return ot(Y.onDidChangeNotebookEditorSelection)(fe,Ee,Be)},onDidChangeNotebookEditorVisibleRanges(fe,Ee,Be){return ot(Y.onDidChangeNotebookEditorVisibleRanges)(fe,Ee,Be)},showNotebookDocument(fe,Ee){return Te.showNotebookDocument(fe,Ee)},registerExternalUriOpener(fe,Ee,Be){return(0,xe.$PG)(Ue,"externalUriOpener"),Xn.registerExternalUriOpener(Ue.identifier,fe,Ee,Be)},registerProfileContentHandler(fe,Ee){return(0,xe.$PG)(Ue,"profileContentHandlers"),Zn.registerProfileContentHandler(Ue,fe,Ee)},registerQuickDiffProvider(fe,Ee,Be,ct){return(0,xe.$PG)(Ue,"quickDiffProvider"),Kn.registerQuickDiffProvider(vt(fe),Ee,Be,ct)},get tabGroups(){return qt.tabGroups},registerShareProvider(fe,Ee){return(0,xe.$PG)(Ue,"shareProvider"),On.registerShareProvider(vt(fe),Ee)}},qn={get rootPath(){return Rt.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(fe){throw new O.$9("rootPath")},getWorkspaceFolder(fe){return gt.getWorkspaceFolder(fe)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(fe){throw new O.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(fe){throw new O.$9("workspaceFile")},updateWorkspaceFolders:(fe,Ee,...Be)=>gt.updateWorkspaceFolders(Ue,fe,Ee||0,...Be),onDidChangeWorkspaceFolders:function(fe,Ee,Be){return ot(gt.onDidChangeWorkspace)(fe,Ee,Be)},asRelativePath:(fe,Ee)=>gt.getRelativePath(fe,Ee),findFiles:(fe,Ee,Be,ct)=>gt.findFiles(fe,Ee,Be,Ue.identifier,ct),findFiles2:(fe,Ee,Be)=>((0,xe.$PG)(Ue,"findFiles2"),gt.findFiles2(fe,Ee,Ue.identifier,Be)),findTextInFiles:(fe,Ee,Be,ct)=>{(0,xe.$PG)(Ue,"findTextInFiles");let yt,Nt;return typeof Ee=="object"?(yt=Ee,Nt=Be):(yt={},Nt=Ee,ct=Be),gt.findTextInFiles(fe,yt||{},Nt,Ue.identifier,ct)},save:fe=>gt.save(fe),saveAs:fe=>gt.saveAs(fe),saveAll:fe=>gt.saveAll(fe),applyEdit(fe,Ee){return gi.applyWorkspaceEdit(fe,Ue,Ee)},createFileSystemWatcher:(fe,Ee,Be,ct)=>{let yt;return typeof Ee=="boolean"?yt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!Be,ignoreDeleteEvents:!!ct,correlate:!1}:Ee&&((0,xe.$PG)(Ue,"createFileSystemWatcher"),yt={...Ee,correlate:!0}),$n.createFileSystemWatcher(gt,Ue,fe,yt)},get textDocuments(){return Ct.getAllDocumentData().map(fe=>fe.document)},set textDocuments(fe){throw new O.$9("textDocuments")},openTextDocument(fe){let Ee;const Be=fe;if(typeof fe=="string")Ee=Promise.resolve($.URI.file(fe));else if($.URI.isUri(fe))Ee=Promise.resolve(fe);else if(!Be||typeof Be=="object")Ee=Ct.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ct=>(ct.scheme===N.Schemas.vscodeRemote&&!ct.authority&&Rt.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),Ct.ensureDocumentData(ct).then(yt=>yt.document)))},onDidOpenTextDocument:(fe,Ee,Be)=>ot(Ct.onDidAddDocument)(fe,Ee,Be),onDidCloseTextDocument:(fe,Ee,Be)=>ot(Ct.onDidRemoveDocument)(fe,Ee,Be),onDidChangeTextDocument:(fe,Ee,Be)=>ot(Ct.onDidChangeDocument)(fe,Ee,Be),onDidSaveTextDocument:(fe,Ee,Be)=>ot(Ct.onDidSaveDocument)(fe,Ee,Be),onWillSaveTextDocument:(fe,Ee,Be)=>ot(Oe.getOnWillSaveTextDocumentEvent(Ue))(fe,Ee,Be),get notebookDocuments(){return Te.notebookDocuments.map(fe=>fe.apiNotebook)},async openNotebookDocument(fe,Ee){let Be;if($.URI.isUri(fe))Be=fe,await Te.openNotebookDocument(fe);else if(typeof fe=="string")Be=$.URI.revive(await Te.createNotebookDocument({viewType:fe,content:Ee}));else throw new Error("Invalid arguments");return Te.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(fe,Ee,Be){return ot(ke.onDidSaveNotebookDocument)(fe,Ee,Be)},onDidChangeNotebookDocument(fe,Ee,Be){return ot(ke.onDidChangeNotebookDocument)(fe,Ee,Be)},onWillSaveNotebookDocument(fe,Ee,Be){return ot(Ye.getOnWillSaveNotebookDocumentEvent(Ue))(fe,Ee,Be)},get onDidOpenNotebookDocument(){return ot(Te.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Te.onDidCloseNotebookDocument)},registerNotebookSerializer(fe,Ee,Be,ct){return Te.registerNotebookSerializer(Ue,fe,Ee,Be,(0,xe.$OG)(Ue,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(fe,Ee,Be)=>ot(Vn.onDidChangeConfiguration)(fe,Ee,Be),getConfiguration(fe,Ee){return Ee=arguments.length===1?void 0:Ee,Vn.getConfiguration(fe,Ee,Ue)},registerTextDocumentContentProvider(fe,Ee){return Dn.registerTextDocumentContentProvider(fe,Ee)},registerTaskProvider:(fe,Ee)=>(Rt.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),nn.registerTaskProvider(Ue,fe,Ee)),registerFileSystemProvider(fe,Ee,Be){return(0,R.$Rc)(Zt.registerFileSystemProvider(Ue,fe,Ee,Be),Jt.addFileSystemProvider(fe,Ee,Be))},get fs(){return Jt.value},registerFileSearchProvider:(fe,Ee)=>((0,xe.$PG)(Ue,"fileSearchProvider"),mn.registerFileSearchProvider(fe,Ee)),registerTextSearchProvider:(fe,Ee)=>((0,xe.$PG)(Ue,"textSearchProvider"),mn.registerTextSearchProvider(fe,Ee)),registerAITextSearchProvider:(fe,Ee)=>((0,xe.$PG)(Ue,"aiTextSearchProvider"),(0,xe.$PG)(Ue,"textSearchProvider"),mn.registerAITextSearchProvider(fe,Ee)),registerRemoteAuthorityResolver:(fe,Ee)=>((0,xe.$PG)(Ue,"resolvers"),Tt.registerRemoteAuthorityResolver(fe,Ee)),registerResourceLabelFormatter:fe=>((0,xe.$PG)(Ue,"resolvers"),Tn.$registerResourceLabelFormatter(fe)),getRemoteExecServer:fe=>((0,xe.$PG)(Ue,"resolvers"),Tt.getRemoteExecServer(fe)),onDidCreateFiles:(fe,Ee,Be)=>ot($n.onDidCreateFile)(fe,Ee,Be),onDidDeleteFiles:(fe,Ee,Be)=>ot($n.onDidDeleteFile)(fe,Ee,Be),onDidRenameFiles:(fe,Ee,Be)=>ot($n.onDidRenameFile)(fe,Ee,Be),onWillCreateFiles:(fe,Ee,Be)=>ot($n.getOnWillCreateFileEvent(Ue))(fe,Ee,Be),onWillDeleteFiles:(fe,Ee,Be)=>ot($n.getOnWillDeleteFileEvent(Ue))(fe,Ee,Be),onWillRenameFiles:(fe,Ee,Be)=>ot($n.getOnWillRenameFileEvent(Ue))(fe,Ee,Be),openTunnel:fe=>((0,xe.$PG)(Ue,"tunnels"),Ft.openTunnel(Ue,fe).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,xe.$PG)(Ue,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(fe,Ee,Be)=>((0,xe.$PG)(Ue,"tunnels"),ot(Ft.onDidChangeTunnels)(fe,Ee,Be)),registerPortAttributesProvider:(fe,Ee)=>((0,xe.$PG)(Ue,"portsAttributes"),Ft.registerPortsAttributesProvider(fe,Ee)),registerTunnelProvider:(fe,Ee)=>((0,xe.$PG)(Ue,"tunnelFactory"),Ft.registerTunnelProvider(fe,Ee)),registerTimelineProvider:(fe,Ee)=>((0,xe.$PG)(Ue,"timeline"),Jn.registerTimelineProvider(fe,Ee,Ue.identifier,pt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:fe=>((0,xe.$PG)(Ue,"workspaceTrust"),gt.requestWorkspaceTrust(fe)),onDidGrantWorkspaceTrust:(fe,Ee,Be)=>ot(gt.onDidGrantWorkspaceTrust)(fe,Ee,Be),registerEditSessionIdentityProvider:(fe,Ee)=>((0,xe.$PG)(Ue,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(fe,Ee)),onWillCreateEditSessionIdentity:(fe,Ee,Be)=>((0,xe.$PG)(Ue,"editSessionIdentityProvider"),ot(gt.getOnWillCreateEditSessionIdentityEvent(Ue))(fe,Ee,Be)),registerCanonicalUriProvider:(fe,Ee)=>((0,xe.$PG)(Ue,"canonicalUriProvider"),gt.registerCanonicalUriProvider(fe,Ee)),getCanonicalUri:(fe,Ee,Be)=>((0,xe.$PG)(Ue,"canonicalUriProvider"),gt.provideCanonicalUri(fe,Ee,Be))},ri={get inputBox(){return Rt.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Pn.getLastInputBox(Ue)},createSourceControl(fe,Ee,Be){return Pn.createSourceControl(Ue,fe,Ee,Be)}},$i={createCommentController(fe,Ee){return Mn.createCommentController(Ue,fe,Ee)}},si={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){if((0,xe.$OG)(Ue,"debugFocus"))return Dt.activeStackItem},registerDebugVisualizationProvider(fe,Ee){return(0,xe.$PG)(Ue,"debugVisualization"),Dt.registerDebugVisualizationProvider(Ue,fe,Ee)},registerDebugVisualizationTreeProvider(fe,Ee){return(0,xe.$PG)(Ue,"debugVisualization"),Dt.registerDebugVisualizationTree(Ue,fe,Ee)},onDidStartDebugSession(fe,Ee,Be){return ot(Dt.onDidStartDebugSession)(fe,Ee,Be)},onDidTerminateDebugSession(fe,Ee,Be){return ot(Dt.onDidTerminateDebugSession)(fe,Ee,Be)},onDidChangeActiveDebugSession(fe,Ee,Be){return ot(Dt.onDidChangeActiveDebugSession)(fe,Ee,Be)},onDidReceiveDebugSessionCustomEvent(fe,Ee,Be){return ot(Dt.onDidReceiveDebugSessionCustomEvent)(fe,Ee,Be)},onDidChangeBreakpoints(fe,Ee,Be){return ot(Dt.onDidChangeBreakpoints)(fe,Ee,Be)},onDidChangeActiveStackItem(fe,Ee,Be){return(0,xe.$PG)(Ue,"debugFocus"),ot(Dt.onDidChangeActiveStackItem)(fe,Ee,Be)},registerDebugConfigurationProvider(fe,Ee,Be){return Dt.registerDebugConfigurationProvider(fe,Ee,Be||Yt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(fe,Ee){return Dt.registerDebugAdapterDescriptorFactory(Ue,fe,Ee)},registerDebugAdapterTrackerFactory(fe,Ee){return Dt.registerDebugAdapterTrackerFactory(fe,Ee)},startDebugging(fe,Ee,Be){return!Be||typeof Be=="object"&&"configuration"in Be?Dt.startDebugging(fe,Ee,{parentSession:Be}):Dt.startDebugging(fe,Ee,Be||{})},stopDebugging(fe){return Dt.stopDebugging(fe)},addBreakpoints(fe){return Dt.addBreakpoints(fe)},removeBreakpoints(fe){return Dt.removeBreakpoints(fe)},asDebugSourceUri(fe,Ee){return Dt.asDebugSourceUri(fe,Ee)}},oi={registerTaskProvider:(fe,Ee)=>nn.registerTaskProvider(Ue,fe,Ee),fetchTasks:fe=>nn.fetchTasks(fe),executeTask:fe=>nn.executeTask(Ue,fe),get taskExecutions(){return nn.taskExecutions},onDidStartTask:(fe,Ee,Be)=>ot(nn.onDidStartTask)(fe,Ee,Be),onDidEndTask:(fe,Ee,Be)=>ot(nn.onDidEndTask)(fe,Ee,Be),onDidStartTaskProcess:(fe,Ee,Be)=>ot(nn.onDidStartTaskProcess)(fe,Ee,Be),onDidEndTaskProcess:(fe,Ee,Be)=>ot(nn.onDidEndTaskProcess)(fe,Ee,Be)},pi={createNotebookController(fe,Ee,Be,ct,yt){return Fe.createNotebookController(Ue,fe,Ee,Be,ct,(0,xe.$OG)(Ue,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(fe,Ee)=>Te.registerNotebookCellStatusBarItemProvider(Ue,fe,Ee),createRendererMessaging(fe){return Qe.createRendererMessaging(Ue,fe)},createNotebookControllerDetectionTask(fe){return(0,xe.$PG)(Ue,"notebookKernelSource"),Fe.createNotebookControllerDetectionTask(Ue,fe)},registerKernelSourceActionProvider(fe,Ee){return(0,xe.$PG)(Ue,"notebookKernelSource"),Fe.registerKernelSourceActionProvider(Ue,fe,Ee)},onDidChangeNotebookCellExecutionState(fe,Ee,Be){return(0,xe.$PG)(Ue,"notebookCellExecutionState"),ot(Fe.onDidChangeNotebookCellExecutionState)(fe,Ee,Be)}},bi={t(...fe){if(typeof fe[0]=="string"){const Ee=fe.shift(),Be=!fe||typeof fe[0]!="object"?fe:fe[0];return ln.getMessage(Ue.identifier.value,{message:Ee,args:Be})}return ln.getMessage(Ue.identifier.value,fe[0])},get bundle(){return ln.getBundle(Ue.identifier.value)},get uri(){return ln.getBundleUri(Ue.identifier.value)}},ai={_version:1,registerInteractiveEditorSessionProvider(fe,Ee){return(0,xe.$PG)(Ue,"interactive"),Yn.registerProvider(Ue,fe,Ee)},transferActiveChat(fe){return(0,xe.$PG)(Ue,"interactive"),An.transferActiveChat(fe)}},Qn={getRelatedInformation(fe,Ee){return(0,xe.$PG)(Ue,"aiRelatedInformation"),_n.getRelatedInformation(Ue,fe,Ee)},registerRelatedInformationProvider(fe,Ee){return(0,xe.$PG)(Ue,"aiRelatedInformation"),_n.registerRelatedInformationProvider(Ue,fe,Ee)},registerEmbeddingVectorProvider(fe,Ee){return(0,xe.$PG)(Ue,"aiRelatedInformation"),di.registerEmbeddingVectorProvider(Ue,fe,Ee)}},ci={registerChatResponseProvider(fe,Ee,Be){return(0,xe.$PG)(Ue,"chatProvider"),Lt.registerLanguageModel(Ue,fe,Ee,Be)},registerChatVariableResolver(fe,Ee,Be){return(0,xe.$PG)(Ue,"chatVariableResolver"),xn.registerVariableResolver(Ue,fe,Ee,Be)},registerMappedEditsProvider(fe,Ee){return(0,xe.$PG)(Ue,"mappedEditsProvider"),ut.registerMappedEditsProvider(Ue,fe,Ee)},createChatParticipant(fe,Ee){return(0,xe.$PG)(Ue,"chatParticipant"),An.createChatAgent(Ue,fe,Ee)},createDynamicChatParticipant(fe,Ee,Be,ct){return(0,xe.$PG)(Ue,"chatParticipantAdditions"),An.createDynamicChatAgent(Ue,fe,Ee,Be,ct)}},ui={get languageModels(){return(0,xe.$PG)(Ue,"languageModels"),Lt.getLanguageModelIds()},onDidChangeLanguageModels:(fe,Ee,Be)=>((0,xe.$PG)(Ue,"languageModels"),Lt.onDidChangeProviders(fe,Ee,Be)),sendChatRequest(fe,Ee,Be,ct){return(0,xe.$PG)(Ue,"languageModels"),Lt.sendChatRequest(Ue,fe,Ee,Be,ct)},computeTokenLength(fe,Ee,Be){return(0,xe.$PG)(Ue,"languageModels"),Be??=d.CancellationToken.None,Lt.computeTokenLength(fe,Ee,Be)},getLanguageModelInformation(fe){return(0,xe.$PG)(Ue,"languageModels"),Lt.getLanguageModelInfo(fe)}},li={registerSpeechProvider(fe,Ee){return(0,xe.$PG)(Ue,"speech"),Un.registerProvider(Ue.identifier,fe,Ee)}};return{version:$t.version,ai:Qn,authentication:ti,commands:fn,comments:$i,chat:ci,debug:si,env:kn,extensions:Ln,interactive:ai,l10n:bi,languages:ni,lm:ui,notebooks:pi,scm:ri,speech:li,tasks:oi,tests:mi,window:ii,workspace:qn,Breakpoint:Le.$bO,TerminalOutputAnchor:Le.TerminalOutputAnchor,ChatResultFeedbackKind:Le.ChatResultFeedbackKind,ChatVariableLevel:Le.ChatVariableLevel,ChatCompletionItem:Le.$9O,CallHierarchyIncomingCall:Le.$zN,CallHierarchyItem:Le.$yN,CallHierarchyOutgoingCall:Le.$AN,CancellationError:O.$5,CancellationTokenSource:d.$oe,CandidatePortSource:i.CandidatePortSource,CodeAction:Le.$vN,CodeActionKind:Le.$wN,CodeActionTriggerKind:Le.CodeActionTriggerKind,CodeLens:Le.$BN,Color:Le.$ON,ColorInformation:Le.$PN,ColorPresentation:Le.$QN,ColorThemeKind:Le.ColorThemeKind,CommentMode:Le.CommentMode,CommentState:Le.CommentState,CommentThreadCollapsibleState:Le.CommentThreadCollapsibleState,CommentThreadState:Le.CommentThreadState,CommentThreadApplicability:Le.CommentThreadApplicability,CompletionItem:Le.$IN,CompletionItemKind:Le.CompletionItemKind,CompletionItemTag:Le.CompletionItemTag,CompletionList:Le.$JN,CompletionTriggerKind:Le.CompletionTriggerKind,ConfigurationTarget:Le.ConfigurationTarget,CustomExecution:Le.$YN,DebugAdapterExecutable:Le.$fO,DebugAdapterInlineImplementation:Le.$iO,DebugAdapterNamedPipeServer:Le.$hO,DebugAdapterServer:Le.$gO,DebugConfigurationProviderTriggerKind:Yt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Le.DebugConsoleMode,DebugVisualization:Le.$yO,DecorationRangeBehavior:Le.DecorationRangeBehavior,Diagnostic:Le.$oN,DiagnosticRelatedInformation:Le.$nN,DiagnosticSeverity:Le.DiagnosticSeverity,DiagnosticTag:Le.DiagnosticTag,Disposable:Le.$aN,DocumentHighlight:Le.$rN,DocumentHighlightKind:Le.DocumentHighlightKind,MultiDocumentHighlight:Le.$sN,DocumentLink:Le.$NN,DocumentSymbol:Le.$uN,EndOfLine:Le.EndOfLine,EnvironmentVariableMutatorType:Le.EnvironmentVariableMutatorType,EvaluatableExpression:Le.$lO,InlineValueText:Le.$mO,InlineValueVariableLookup:Le.$nO,InlineValueEvaluatableExpression:Le.$oO,InlineCompletionTriggerKind:Le.InlineCompletionTriggerKind,EventEmitter:L.$de,ExtensionKind:Le.ExtensionKind,ExtensionMode:Le.ExtensionMode,ExternalUriOpenerPriority:Le.ExternalUriOpenerPriority,FileChangeType:Le.FileChangeType,FileDecoration:Le.$AO,FileDecoration2:Le.$AO,FileSystemError:Le.$rO,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Le.$sO,FoldingRangeKind:Le.FoldingRangeKind,FunctionBreakpoint:Le.$dO,InlineCompletionItem:Le.$KN,InlineCompletionList:Le.$LN,Hover:Le.$pN,VerboseHover:Le.$qN,HoverVerbosityAction:Le.HoverVerbosityAction,IndentAction:C.IndentAction,Location:Le.$mN,MarkdownString:Le.$CN,OverviewRulerLane:p.OverviewRulerLane,ParameterInformation:Le.$DN,PortAutoForwardAction:Le.PortAutoForwardAction,Position:Le.$bN,ProcessExecution:Le.$WN,ProgressLocation:Le.ProgressLocation,QuickInputButtons:Le.$zO,Range:Le.$cN,RelativePattern:Le.$_N,Selection:Le.$dN,SelectionRange:Le.$xN,SemanticTokens:Le.$vO,SemanticTokensBuilder:Le.$uO,SemanticTokensEdit:Le.$wO,SemanticTokensEdits:Le.$xO,SemanticTokensLegend:Le.$tO,ShellExecution:Le.$XN,ShellQuoting:Le.ShellQuoting,SignatureHelp:Le.$FN,SignatureHelpTriggerKind:Le.SignatureHelpTriggerKind,SignatureInformation:Le.$EN,SnippetString:Le.$lN,SourceBreakpoint:Le.$cO,StandardTokenType:Le.StandardTokenType,StatusBarAlignment:Le.StatusBarAlignment,SymbolInformation:Le.$tN,SymbolKind:Le.SymbolKind,SymbolTag:Le.SymbolTag,Task:Le.$ZN,TaskGroup:Le.$VN,TaskPanelKind:Le.TaskPanelKind,TaskRevealKind:Le.TaskRevealKind,TaskScope:Le.TaskScope,TerminalLink:Le.$RN,TerminalQuickFixTerminalCommand:Le.$TN,TerminalQuickFixOpener:Le.$SN,TerminalLocation:Le.TerminalLocation,TerminalProfile:Le.$UN,TerminalExitReason:Le.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Le.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Le.TextDocumentSaveReason,TextEdit:Le.$hN,SnippetTextEdit:Le.$jN,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:Le.TextEditorLineNumbersStyle,TextEditorRevealType:Le.TextEditorRevealType,TextEditorSelectionChangeKind:Le.TextEditorSelectionChangeKind,SyntaxTokenType:Le.SyntaxTokenType,TextDocumentChangeReason:Le.TextDocumentChangeReason,ThemeColor:Le.$$N,ThemeIcon:Le.$0N,TreeItem:Le.$1N,TreeItemCheckboxState:Le.TreeItemCheckboxState,TreeItemCollapsibleState:Le.TreeItemCollapsibleState,TypeHierarchyItem:Le.$WO,UIKind:xt.UIKind,Uri:$.URI,ViewColumn:Le.ViewColumn,WorkspaceEdit:Le.$kN,DocumentPasteTriggerKind:Le.DocumentPasteTriggerKind,DocumentDropEdit:Le.$7N,DocumentDropOrPasteEditKind:Le.$8N,DocumentPasteEdit:Le.$9N,InlayHint:Le.$HN,InlayHintLabelPart:Le.$GN,InlayHintKind:Le.InlayHintKind,RemoteAuthorityResolverError:Le.$gN,ResolvedAuthority:Le.$eN,ManagedResolvedAuthority:Le.$fN,SourceControlInputBoxValidationType:Le.SourceControlInputBoxValidationType,ExtensionRuntime:Le.ExtensionRuntime,TimelineItem:Le.$KO,NotebookRange:Le.$CO,NotebookCellKind:Le.NotebookCellKind,NotebookCellExecutionState:Le.NotebookCellExecutionState,NotebookCellData:Le.$DO,NotebookData:Le.$EO,NotebookRendererScript:Le.$IO,NotebookCellStatusBarAlignment:Le.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Le.NotebookEditorRevealType,NotebookCellOutput:Le.$GO,NotebookCellOutputItem:Le.$FO,NotebookCellStatusBarItem:Le.$HO,NotebookControllerAffinity:Le.NotebookControllerAffinity,NotebookControllerAffinity2:Le.NotebookControllerAffinity2,NotebookEdit:Le.$iN,NotebookKernelSourceAction:Le.$JO,NotebookVariablesRequestKind:Le.NotebookVariablesRequestKind,PortAttributes:Le.$MO,LinkedEditingRanges:Le.$LO,TestResultState:Le.TestResultState,TestRunRequest:Le.$NO,TestRunRequest2:Le.$NO,TestMessage:Le.$OO,TestTag:Le.$PO,TestRunProfileKind:Le.TestRunProfileKind,TextSearchCompleteMessageType:on.TextSearchCompleteMessageType,DataTransfer:Le.$6N,DataTransferItem:Le.$2N,TestCoverageCount:Le.$QO,FileCoverage:Le.$SO,StatementCoverage:Le.$TO,BranchCoverage:Le.$UO,DeclarationCoverage:Le.$VO,WorkspaceTrustState:Le.WorkspaceTrustState,LanguageStatusSeverity:Le.LanguageStatusSeverity,QuickPickItemKind:Le.QuickPickItemKind,InputBoxValidationSeverity:Le.InputBoxValidationSeverity,TabInputText:Le.$XO,TabInputTextDiff:Le.$YO,TabInputTextMerge:Le.$ZO,TabInputCustom:Le.$1O,TabInputNotebook:Le.$3O,TabInputNotebookDiff:Le.$4O,TabInputWebview:Le.$2O,TabInputTerminal:Le.$5O,TabInputInteractiveWindow:Le.$6O,TabInputChat:Le.$7O,TabInputTextMultiDiff:Le.$8O,TelemetryTrustedValue:o.$fp,LogLevel:h.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Le.InteractiveSessionVoteDirection,ChatCopyKind:Le.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Le.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Le.$jO,DebugThread:Le.$kO,RelatedInformationType:Le.RelatedInformationType,SpeechToTextStatus:Le.SpeechToTextStatus,TextToSpeechStatus:Le.TextToSpeechStatus,PartialAcceptTriggerKind:Le.PartialAcceptTriggerKind,KeywordRecognitionStatus:Le.KeywordRecognitionStatus,ChatResponseMarkdownPart:Le.$0O,ChatResponseFileTreePart:Le.$aP,ChatResponseAnchorPart:Le.$bP,ChatResponseProgressPart:Le.$cP,ChatResponseReferencePart:Le.$fP,ChatResponseWarningPart:Le.$dP,ChatResponseTextEditPart:Le.$gP,ChatResponseMarkdownWithVulnerabilitiesPart:Le.$$O,ChatResponseCommandButtonPart:Le.$eP,ChatResponseDetectedParticipantPart:Le.$_O,ChatRequestTurn:Le.$hP,ChatResponseTurn:Le.$iP,ChatLocation:Le.ChatLocation,LanguageModelChatSystemMessage:Le.$jP,LanguageModelChatUserMessage:Le.$kP,LanguageModelChatAssistantMessage:Le.$lP,LanguageModelSystemMessage:Le.$jP,LanguageModelUserMessage:Le.$kP,LanguageModelAssistantMessage:Le.$lP,LanguageModelError:Le.$mP,NewSymbolName:Le.$qO,NewSymbolNameTag:Le.NewSymbolNameTag,NewSymbolNameTriggerKind:Le.NewSymbolNameTriggerKind,InlineEdit:Le.$nP,InlineEditTriggerKind:Le.InlineEditTriggerKind}}}}),define(Se[385],De([1,0,85,158,44,152,45,34,73,43,95,96,97,119,71,91,151,70,60,118,90,72,150,11,61,116,117,121,122,156]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n,i,u,s,t,c,r,a,f,g,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.$xs)(a.$mmc,a.$lmc,1),(0,d.$xs)(c.$4j,t.$znc,1),(0,d.$xs)(h.$rlc,h.$slc,1),(0,d.$xs)(b.$VP,b.$UP,0),(0,d.$xs)(g.$Blc,g.$Clc,0),(0,d.$xs)(w.$gmc,w.$hmc,0),(0,d.$xs)(N.$Qlc,N.$Olc,0),(0,d.$xs)(o.$Slc,o.$Rlc,0),(0,d.$xs)(C.$wmc,C.$Amc,0),(0,d.$xs)(R.$Cmc,R.$Bmc,0),(0,d.$xs)($.$KP,$.$JP,0),(0,d.$xs)(f.$nmc,f.$omc,0),(0,d.$xs)(n.$vlc,n.$ulc,0),(0,d.$xs)(O.$8mc,O.$7mc,1),(0,d.$xs)(p.$Smc,p.$Tmc,0),(0,d.$xs)(y.$_lc,y.$$lc,0),(0,d.$xs)(A.$inc,A.$hnc,0),(0,d.$xs)(k.$cmc,k.$fmc,0),(0,d.$xs)(S.$jnc,S.$knc,0),(0,d.$xs)(v.$sDb,v.$tDb,0),(0,d.$xs)(l.$xnc,l.$wnc,0),(0,d.$xs)(L.$Nlc,L.$Mlc,0),(0,d.$xs)(i.$jmc,i.$imc,0),(0,d.$xs)(u.$TP,u.$QP,0),(0,d.$xs)(s.$3lc,s.$4lc,0),(0,d.$xs)(r.$umc,r.$vmc,0)}),define(Se[123],De([1,0,19,11,37,94]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rnc=void 0,e.$Pnc=N,e.$Qnc=b;function N(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}function b(C,p,y,v){const h=(0,d.$1b)(y,$),l=new L.$qL(p,h,v),o=l.preview.matches;return{ranges:(0,d.$1b)(h,k),uri:C,preview:{text:l.preview.text,matches:(0,d.$1b)(o,k)}}}function $(C){return new L.$rL(C.start.line,C.start.character,C.end.line,C.end.character)}function k(C){return new R.$fL(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let A=class{constructor(p,y){this.a=p,this.b=y}appendLine(p){this.b.debug(`${this.a}#search`,p)}};e.$Rnc=A,e.$Rnc=A=Ge([We(1,O.$3j)],A)}),define(Se[386],De([1,0,54,17,77,31,12,14,123,387]),function(he,e,d,O,L,R,N,b,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Snc=C,e.$Tnc=l,e.$Unc=n;const A=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(i,u,s,t){const c=p(i,u,s,t),r=u.folder.fsPath;return{cmd:d.spawn(A,c.args,{cwd:r}),rgDiskPath:A,siblingClauses:c.siblingClauses,rgArgs:c,cwd:r}}function p(i,u,s,t){const c=["--files","--hidden","--case-sensitive","--no-require-git"];v([u],s,!1).forEach(a=>{const f=(0,$.$Pnc)(a);if(c.push("-g",f),N.$j){const g=(0,L.$cm)(f);g!==f&&c.push("-g",g)}});const r=y([u],t,void 0,!1);return r.globArgs.forEach(a=>{const f=`!${(0,$.$Pnc)(a)}`;if(c.push("-g",f),N.$j){const g=(0,L.$cm)(f);g!==f&&c.push("-g",g)}}),u.disregardIgnoreFiles!==!1?c.push("--no-ignore"):u.disregardParentIgnoreFiles!==!1&&c.push("--no-ignore-parent"),u.ignoreSymlinks||c.push("--follow"),i.exists&&c.push("--quiet"),c.push("--no-config"),u.disregardGlobalIgnoreFiles&&c.push("--no-ignore-global"),{args:c,siblingClauses:r.siblingClauses}}function y(i,u,s,t=!0){const c=[];let r={};return i.forEach(a=>{const f=Object.assign({},a.excludePattern||{},u||{}),g=h(f,t?a.folder.fsPath:void 0,s);c.push(...g.globArgs),g.siblingClauses&&(r=Object.assign(r,g.siblingClauses))}),{globArgs:c,siblingClauses:r}}function v(i,u,s=!0){const t=[];return i.forEach(c=>{const r=Object.assign({},u||{},c.includePattern||{}),a=h(r,s?c.folder.fsPath:void 0);t.push(...a.globArgs)}),t}function h(i,u,s){const t=[],c={};return Object.keys(i).forEach(r=>{if(s&&s.has(r)||!r)return;const a=i[r];r=o(u?l(u,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof a=="boolean"&&a?(r.startsWith("\\\\")&&(r+="**"),t.push(n(r))):a&&a.when&&(c[r]=a)}),{globArgs:t,siblingClauses:c}}function l(i,u){return O.$ic(u)?u:O.$jc(i,u)}function o(i){return i=b.$ff(i,"\\"),b.$ff(i,"/")}function n(i){return R.$rg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(Se[388],De([1,0,54,53,17,389,19,47,35,77,31,12,40,14,18,32,37,386,133]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=e.$Vnc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(r=>r())});class u{constructor(a){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=a,this.b=a.filePattern||"",this.d=a.includePattern&&$.$qk(a.includePattern),this.f=a.maxResults||null,this.g=!!a.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=a.shouldGlobMatchFilePattern?null:(0,n.$xr)(this.b).normalizedLowercase),this.u=a.excludePattern&&$.$qk(a.excludePattern),this.t=new Map,a.folderQueries.forEach(f=>{const g=Object.assign({},f.excludePattern||{},this.a.excludePattern||{}),w=f.folder.fsPath;a.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==w).forEach(S=>{(0,A.$vg)(S,w)&&(g[L.$lc(w,S)]=!0)}),this.t.set(w,new t(g,w))})}cancel(){this.l=!0,i.forEach(a=>a())}walk(a,f,g,w,S){if(this.m=p.$_d.create(!1),this.l)return S(null,this.j);f.forEach(m=>{const E=L.$nc(m.fsPath);this.u&&this.u(m.fsPath,E)||this.J(g,{relativePath:m.fsPath,searchPath:void 0})}),this.r=p.$_d.create(!1),this.w(a,(m,E)=>{this.x(this.y,this,m,g,w,D=>{if(D){const P=(0,b.$hj)(D);console.error(P),this.q.push(P),E(D,void 0)}else E(null,void 0)})},(m,E)=>{this.m.stop();const D=m?N.$Hb(m)[0]:null;S(D,this.j)})}w(a,f,g){const w=new Array(a.length),S=new Array(a.length);let m=!1,E=0;if(a.length===0)return g(null,[]);a.forEach((D,P)=>{f(D,(I,F)=>{if(I?(m=!0,w[P]=null,S[P]=I):(w[P]=F,S[P]=null),++E===a.length)return g(m?S:null,w)})})}x(a,f,...g){try{a.apply(f,g)}catch(w){g[g.length-1](w)}}y(a,f,g,w){const S=a.folder.fsPath,m=C.$j,E=()=>T&&T.kill();i.add(E);let D=U=>{i.delete(E),D=()=>{},w(U)},P="";const I=this.D(),F=(0,o.$Snc)(this.a,a,this.a.includePattern,this.t.get(a.folder.fsPath).expression),T=F.cmd,z=!Object.keys(F.siblingClauses).length,M=F.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let j=`${F.rgDiskPath} ${M}
 - cwd: ${F.cwd}`;F.rgArgs.siblingClauses&&(j+=`
 - Sibling clauses: ${JSON.stringify(F.rgArgs.siblingClauses)}`),g({message:j}),this.s=0,this.z(T,"utf8",g,(U,Z,ie)=>{if(U){D(U);return}if(this.j){D();return}const G=(P+(m?k.$bm(Z||""):Z)).split(`
`);if(ie){const x=G.length;G[x-1]=G[x-1].trim(),G[x-1]||G.pop()}else P=G.pop()||"";if(G.length&&G[0].indexOf(`
`)!==-1){D(new Error("Splitting up files failed"));return}if(this.s+=G.length,z){for(const x of G)if(this.J(f,{base:S,relativePath:x,searchPath:this.N(a,x)}),this.j){E();break}(ie||this.j)&&D();return}this.G(a,I,S,G,f),ie&&(this.H(I,S,f),D())})}spawnFindCmd(a){const f=this.t.get(a.folder.fsPath),g=f.getBasenameTerms(),w=f.getPathTerms(),S=["-L","."];if(g.length||w.length){S.push("-not","(","(");for(const m of g)S.push("-name",m),S.push("-o");for(const m of w)S.push("-path",m),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),d.spawn("find",S,{cwd:a.folder.fsPath})}readStdout(a,f,g){let w="";this.z(a,f,()=>{},(S,m,E)=>{if(S){g(S);return}w+=m,E&&g(null,w)})}z(a,f,g,w){let S=(D,P,I)=>{(D||I)&&(S=()=>{},this.r?.stop()),w(D,P,I)},m=!1;a.stdout?(this.A(a.stdout,f,S),a.stdout.once("data",()=>m=!0)):g({message:"stdout is null"});let E;a.stderr?E=this.B(a.stderr):g({message:"stderr is null"}),a.on("error",D=>{S(D)}),a.on("close",D=>{let P;!m&&(P=this.C(E,f))&&c(P)?S(new Error(`command failed with error code ${D}: ${this.C(E,f)}`)):(this.g&&D===0&&(this.j=!0),S(null,"",!0))})}A(a,f,g){const w=new R.StringDecoder(f);return a.on("data",S=>{g(null,w.write(S))}),w}B(a){const f=[];return a.on("data",g=>{f.push(g)}),f}C(a,f){const g=new R.StringDecoder(f);return a.map(w=>g.write(w)).join("")}D(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}G(a,{pathToEntries:f},g,w,S){w.indexOf(this.b)!==-1&&this.J(S,{base:g,relativePath:this.b,searchPath:this.N(a,this.b)});const m=E=>{const D=L.$nc(E),P=L.$mc(E);let I=f[P];I||(I=f[P]=[],m(P)),I.push({base:g,relativePath:E,basename:D,searchPath:this.N(a,E)})};w.forEach(m)}H({rootEntries:a,pathToEntries:f},g,w){const S=this,m=this.t.get(g),E=this.b;function D(P){S.o++;const I=(0,l.$GL)(()=>P.map(F=>F.basename));for(let F=0,T=P.length;F<T;F++){const z=P[F],{relativePath:M,basename:j}=z;if(m.test(M,j,E!==j?I:void 0))continue;const U=f[M];if(U)D(U);else{if(S.p++,M===E)continue;S.J(w,z)}if(S.j)break}}D(a)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(a,f,g,w,S){const m=a.folder,E=(0,l.$GL)(()=>g);this.w(g,(D,P)=>{if(this.l||this.j)return P(null);const I=f?[f,D].join(L.sep):D;if(this.t.get(a.folder.fsPath).test(I,D,this.a.filePattern!==D?E:void 0))return P(null);const F=[m.fsPath,I].join(L.sep);O.lstat(F,(T,z)=>{if(T||this.l||this.j)return P(null);this.L(F,z,(M,j)=>M||this.l||this.j?P(null):j.isDirectory()?(this.o++,this.M(F,z,(U,Z)=>U||this.l||this.j||(Z=Z||"",this.v[Z])?P(null):(this.v[Z]=!0,h.Promises.readdir(F).then(ie=>{if(this.l||this.j)return P(null);this.I(a,I,ie,w,q=>P(q||null))},ie=>{P(null)})))):(this.p++,I===this.b||this.h&&v.$ag(j.size)&&j.size>this.h||this.J(w,{base:m.fsPath,relativePath:I,searchPath:this.N(a,I)}),P(null,void 0)))})},D=>{const P=D&&N.$Hb(D);return S(P&&P.length>0?P[0]:void 0)})}J(a,f){this.K(f)&&(!this.d||this.d(f.relativePath,L.$nc(f.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||a(f))}K(a){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,l.$BL)(a,this.c);if(this.b)return(0,l.$BL)(a,this.b,!1)}return!0}L(a,f,g){return f.isSymbolicLink()?O.stat(a,g):g(null,f)}M(a,f,g){return f.isSymbolicLink()?O.realpath(a,(w,S)=>w?g(w):g(null,S)):g(null,a)}N(a,f){return a.folderName?L.$jc(a.folderName,f):f}}e.$Vnc=u;class s{constructor(a){this.a=a.folderQueries,this.b=a.extraFileResources||[],this.c=new u(a)}search(a,f,g){this.c.walk(this.a,this.b,a,f,(w,S)=>{g(w,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Wnc=s;class t{constructor(a,f){this.expression=a,this.c=f,this.d(a)}d(a){let f,g;Object.keys(a).filter(w=>a[w]).forEach(w=>{L.$ic(w)?(f=f||$.$lk(),f[w]=a[w]):(g=g||$.$lk(),g[w]=a[w])}),this.a=f&&$.$qk(f,{trimForExclusions:!0}),this.b=g&&$.$qk(g,{trimForExclusions:!0})}test(a,f,g){return this.b&&this.b(a,f,g)||this.a&&this.a(L.$jc(this.c,a),f,g)}getBasenameTerms(){const a=[];return this.a&&a.push(...$.$sk(this.a)),this.b&&a.push(...$.$sk(this.b)),a}getPathTerms(){const a=[];return this.a&&a.push(...$.$tk(this.a)),this.b&&a.push(...$.$tk(this.b)),a}}function c(r){const a=r.trim().split(`
`),f=a[0].trim();if(f.startsWith("Error parsing regex"))return f;if(f.startsWith("regex parse error"))return y.$1f(a[a.length-1].trim());if(f.startsWith("error parsing glob")||f.startsWith("unsupported encoding"))return f.charAt(0).toUpperCase()+f.substr(1);if(f==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(f.startsWith("Literal "))return f}}),define(Se[390],De([1,0,98,21,198,22]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mE=e.$eE=e.DecodeStreamErrorKind=e.$dE=e.$cE=e.$bE=e.$_D=e.$$D=e.$0D=e.$9D=void 0,e.$aE=N,e.$fE=v,e.$gE=h,e.$hE=l,e.$iE=o,e.$jE=n,e.$kE=r,e.$lE=a,e.$9D="utf8",e.$0D="utf8bom",e.$$D="utf16be",e.$_D="utf16le";function N(f){return[e.$9D,e.$0D,e.$$D,e.$_D].some(g=>g===f)}e.$bE=[254,255],e.$cE=[255,254],e.$dE=[239,187,191];const b=512,$=512,k=512*8,A=512*128;var C;(function(f){f[f.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class p extends Error{constructor(g,w){super(g),this.decodeStreamErrorKind=w}}e.$eE=p;class y{static async create(g){let w;if(g!==e.$9D)w=(await(0,L.$8D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(g));else{const S=new TextDecoder;w={write(m){return S.decode(m,{stream:!0})},end(){return S.decode()}}}return new y(w)}constructor(g){this.a=g}write(g){return this.a.write(g)}end(){return this.a.end()}}function v(f,g){const w=g.minBytesRequiredForDetection??g.guessEncoding?k:$;return new Promise((S,m)=>{const E=(0,d.$te)(z=>z.join("")),D=[];let P=0,I;const F=new R.$oe,T=async()=>{try{const z=await a({buffer:O.$Fe.concat(D),bytesRead:P},g.guessEncoding);if(z.seemsBinary&&g.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);z.encoding=await g.overwriteEncoding(z.encoding),I=await y.create(z.encoding);const M=I.write(O.$Fe.concat(D).buffer);E.write(M),D.length=0,P=0,S({stream:E,detected:z})}catch(z){F.cancel(),E.destroy(),m(z)}};(0,d.$xe)(f,{onData:async z=>{I?E.write(I.write(z.buffer)):(D.push(z),P+=z.byteLength,P>=w&&(f.pause(),await T(),setTimeout(()=>f.resume())))},onError:z=>E.error(z),onEnd:async()=>{I||await T(),E.end(I?.end())}},F.token)})}async function h(f,g,w){const m=(await(0,L.$8D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(g),w);let E=!1,D=!1;return{read(){if(D)return null;const P=f.read();if(typeof P!="string"){if(D=!0,!E&&w?.addBOM)switch(g){case e.$9D:case e.$0D:return O.$Fe.wrap(Uint8Array.from(e.$dE));case e.$$D:return O.$Fe.wrap(Uint8Array.from(e.$bE));case e.$_D:return O.$Fe.wrap(Uint8Array.from(e.$cE))}const I=m.end();return I&&I.length>0?(E=!0,O.$Fe.wrap(I)):null}return E=!0,O.$Fe.wrap(m.write(P))}}}async function l(f){return(await(0,L.$8D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(f))}function o(f){return f===e.$0D||f===null?e.$9D:f}function n(f,g){if(!f||g<e.$bE.length)return null;const w=f.readUInt8(0),S=f.readUInt8(1);if(w===e.$bE[0]&&S===e.$bE[1])return e.$$D;if(w===e.$cE[0]&&S===e.$cE[1])return e.$_D;if(g<e.$dE.length)return null;const m=f.readUInt8(2);return w===e.$dE[0]&&S===e.$dE[1]&&m===e.$dE[2]?e.$0D:null}const i=["ascii","utf-16","utf-32"];async function u(f){const g=await(0,L.$8D)("jschardet","dist/jschardet.min.js"),w=f.slice(0,A),S=c(w.buffer),m=g.detect(S);if(!m||!m.encoding)return null;const E=m.encoding.toLowerCase();return 0<=i.indexOf(E)?null:t(m.encoding)}const s={ibm866:"cp866",big5:"cp950"};function t(f){const g=f.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return s[g]||g}function c(f){let g="";for(let w=0;w<f.length;w++)g+=String.fromCharCode(f[w]);return g}function r(f){switch(f){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const g=f.match(/windows(\d+)/);return g?"windows-"+g[1]:f}}}function a({buffer:f,bytesRead:g},w){let S=n(f,g),m=!1;if(S!==e.$$D&&S!==e.$_D&&f){let E=!0,D=!0,P=!1;for(let I=0;I<g&&I<b;I++){const F=I%2===1,T=f.readUInt8(I)===0;if(T&&(P=!0),E&&(F&&!T||!F&&T)&&(E=!1),D&&(F&&T||!F&&!T)&&(D=!1),T&&!E&&!D)break}P&&(E?S=e.$_D:D?S=e.$$D:m=!0)}return w&&!m&&!S&&f?u(f.slice(0,g)).then(E=>({seemsBinary:!1,encoding:E})):{seemsBinary:m,encoding:S}}e.$mE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[161],De([1,0,390,32,160]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5nc=void 0;class R extends L.$Omc{constructor(b,$,k=O,A="searchProcess"){super({query:b,provider:$},{readdir:C=>k.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,d.$kE)(C)},A)}}e.$5nc=R}),define(Se[162],De([1,0,54,406,389,19,74,35,14,2,37,94,407,387,123]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ync=e.$Xnc=void 0,e.$Znc=t,e.$1nc=r,e.$2nc=f,e.$3nc=g,e.$4nc=S;const h=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class l{constructor(E){this.a=E}provideTextSearchResults(E,D,P,I){return this.a.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...D,folder:D.folder.toString()})}`),new Promise((F,T)=>{I.onCancellationRequested(()=>G());const z=t(E,D),M=D.folder.fsPath,j=z.map(Ce=>Ce.match(/^-/)?Ce:`'${Ce}'`).join(" ");this.a.appendLine(`${h} ${j}
 - cwd: ${M}`);let U=d.spawn(h,z,{cwd:M});U.on("error",Ce=>{console.error(Ce),this.a.appendLine("Error: "+(Ce&&Ce.message)),T((0,A.$xL)(new A.$vL(Ce&&Ce.message,A.SearchErrorCode.rgProcessError)))});let Z=!1;const ie=new i(D.maxResults,D.folder,D.previewOptions);ie.on("result",Ce=>{Z=!0,ne="",P.report(Ce)});let q=!1;const G=()=>{q=!0,U?.kill(),ie?.cancel()};let x=!1;ie.on("hitLimit",()=>{x=!0,G()});let ne="";U.stdout.on("data",Ce=>{ie.handleData(Ce),Z||(ne+=Ce)});let be=!1;U.stdout.once("data",()=>be=!0);let ae="";U.stderr.on("data",Ce=>{const ee=Ce.toString();this.a.appendLine(ee),ae.length+ee.length<1e6&&(ae+=ee)}),U.on("close",()=>{if(this.a.appendLine(be?"Got data from stdout":"No data from stdout"),this.a.appendLine(Z?"Got result from parser":"No result from parser"),ne&&this.a.appendLine(`Got data without result: ${ne}`),this.a.appendLine(""),q)F({limitHit:x});else{ie.flush(),U=null;let Ce;ae&&!be&&(Ce=o(ae))?T((0,A.$xL)(new A.$vL(Ce.message,Ce.code))):F({limitHit:x})}})})}}e.$Xnc=l;function o(m){const E=m.split(`
`),D=E[0].trim();if(E.some(I=>I.startsWith("regex parse error")))return new A.$vL(n(E),A.SearchErrorCode.regexParseError);const P=D.match(/grep config error: unknown encoding: (.*)/);if(P)return new A.$vL(`Unknown encoding: ${P[1]}`,A.SearchErrorCode.unknownEncoding);if(D.startsWith("error parsing glob"))return new A.$vL(D.charAt(0).toUpperCase()+D.substr(1),A.SearchErrorCode.globParseError);if(D.startsWith("the literal"))return new A.$vL(D.charAt(0).toUpperCase()+D.substr(1),A.SearchErrorCode.invalidLiteral);if(D.startsWith("PCRE2: error compiling pattern"))return new A.$vL(D,A.SearchErrorCode.regexParseError)}function n(m){const E=["Regex parse error"],D=m.filter(P=>P.startsWith("PCRE2:"));if(D.length>=1){const P=D[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const I=P.split(":")[1];E.push(":"+I)}}return E.join("")}class i extends O.EventEmitter{constructor(E,D,P){super(),this.g=E,this.h=D,this.j=P,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new L.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(E,D){return super.on(E,D),this}handleData(E){if(this.b)return;const D=typeof E=="string"?E:this.d.write(E);this.k(D)}k(E){let D=E.indexOf(`
`);const P=this.a+E;if(D>=0)D+=this.a.length;else{this.a=P;return}let I=0;for(;D>=0;)this.m(P.substring(I,D).trim()),I=D+1,D=P.indexOf(`
`,I);this.a=P.substring(I)}m(E){if(this.b||!E)return;let D;try{D=JSON.parse(E)}catch{throw new Error(`malformed line from rg: ${E}`)}if(D.type==="match"){const P=u(D.data.path),I=k.URI.joinPath(this.h,P),F=this.n(D.data,I);this.p(F),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(D.type==="context"){const P=u(D.data.path),I=k.URI.joinPath(this.h,P);this.o(D.data,I).forEach(T=>this.p(T))}}n(E,D){const P=E.line_number-1,I=u(E.lines),F=Buffer.from(I);let T=0,z=0,M=P;E.submatches.length===0&&E.submatches.push(I.length?{start:0,end:1,match:{text:I[0]}}:{start:0,end:0,match:{text:""}});const j=(0,R.$Hb)(E.submatches.map((U,Z)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ie=u(U.match),q=F.slice(T,U.start).toString(),G=s(q),x=G.numLines>0?G.lastLineLength:G.lastLineLength+z,ne=s(ie),be=G.numLines+M,ae=ne.numLines+be,Ce=ne.numLines>0?ne.lastLineLength:ne.lastLineLength+x;return T=U.end,z=Ce,M=ae,new C.$fL(be,x,ae,Ce)}));return(0,v.$Qnc)(D,I,j,this.j)}o(E,D){const P=u(E.lines),I=E.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((F,T)=>({text:F,uri:D,lineNumber:I+T}))}p(E){this.emit("result",E)}}e.$Ync=i;function u(m){return m.bytes?Buffer.from(m.bytes,"base64").toString():m.text}function s(m){const E=/\n/g;let D=0,P=-1,I;for(;I=E.exec(m);)D++,P=I.index;const F=P>=0?m.length-P-1:m.length;return{numLines:D,lastLineLength:F}}function t(m,E){const D=["--hidden","--no-require-git"];D.push(m.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:I}=(0,N.$K)(E.includes,T=>T.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(I&&I.length){const T=new Set;I.forEach(z=>{T.add(z)}),D.push("-g","!*"),T.forEach(z=>{c(z).map(v.$Pnc).forEach(M=>{D.push("-g",M)})})}P&&P.length&&P.forEach(T=>{D.push("-g",T)}),E.excludes.map(v.$Pnc).forEach(T=>D.push("-g",`!${T}`)),E.maxFileSize&&D.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?E.useParentIgnoreFiles||D.push("--no-ignore-parent"):D.push("--no-ignore"),E.followSymlinks&&D.push("--follow"),E.encoding&&E.encoding!=="utf8"&&D.push("--encoding",E.encoding),m.pattern==="--"&&(m.isRegExp=!0,m.pattern="\\-\\-"),m.isMultiline&&!m.isRegExp&&(m.pattern=(0,$.$_e)(m.pattern),m.isRegExp=!0),E.usePCRE2&&D.push("--pcre2"),D.push("--crlf"),m.isRegExp&&(m.pattern=r(m.pattern),D.push("--engine","auto"));let F;if(m.isWordMatch){const z=(0,$.$if)(m.pattern,!!m.isRegExp,{wholeWord:m.isWordMatch}).source.replace(/\\\//g,"/");D.push("--regexp",z)}else if(m.isRegExp){let T=f(m.pattern);T=g(T),D.push("--regexp",T)}else F=m.pattern,D.push("--fixed-strings");return D.push("--no-config"),E.useGlobalIgnoreFiles||D.push("--no-ignore-global"),D.push("--json"),m.isMultiline&&D.push("--multiline"),E.beforeContext&&D.push("--before-context",E.beforeContext+""),E.afterContext&&D.push("--after-context",E.afterContext+""),D.push("--"),F&&D.push(F),D.push("."),D}function c(m){return S(m).flatMap(D=>{const P=(0,b.$ok)(D,"/");return P.map((I,F)=>P.slice(0,F+1).join("/"))})}function r(m){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;m.match(E);)m=m.replace(E,"$1\\x{$2}");const D=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;m.match(D);)m=m.replace(D,"$1\\x{$2}");return m}const a=m=>m.type==="Assertion"&&m.kind==="lookbehind";function f(m){let E;try{E=new p.RegExpParser().parsePattern(m)}catch{return m}let D="",P=0;const I=(z,M,j)=>{D+=m.slice(P,z)+j,P=M},F=[];return new p.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const M=F[0];if(!M)I(z.start,z.end,"\\r?\\n");else if(!F.some(a))if(M.type==="CharacterClass")if(M.negate){const j=m.slice(M.start+2,z.start)+m.slice(z.end,M.end-1);M.parent?.type==="Quantifier"?I(M.start,M.end,j?`[^${j}]`:"."):I(M.start,M.end,"(?!\\r?\\n"+(j?`|[${j}]`:"")+")")}else{const j=m.slice(M.start+1,z.start)+m.slice(z.end,M.end-1);I(M.start,M.end,j===""?"\\r?\\n":`(?:[${j}]|\\r?\\n)`)}else M.type==="Quantifier"&&I(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){F.unshift(z)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(z){F.unshift(z)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(z){F.unshift(z)},onCharacterClassLeave(){F.shift()},onAssertionEnter(z){a(z)&&F.push(z)},onAssertionLeave(z){F[0]===z&&F.shift()}}).visit(E),D+=m.slice(P),D}function g(m){return m.replace(/\n/g,"\\r?\\n")}function w(m){let E=!1,D=!1,P="",I="";for(let F=0;F<m.length;F++){const T=m[F];switch(T){case"\\":D?(E?I+="\\"+T:P+="\\"+T,D=!1):D=!0;break;case"{":if(D)E?I+=T:P+=T,D=!1;else{if(E)return{strInBraces:P+"{"+I+"{"+m.substring(F+1)};E=!0}break;case"}":if(D)E?I+=T:P+=T,D=!1;else{if(E)return{fixedStart:P,strInBraces:I,fixedEnd:m.substring(F+1)};P+=T}break;default:E?I+=(D?"\\":"")+T:P+=(D?"\\":"")+T,D=!1;break}}return{strInBraces:P+(E?"{"+I:"")}}function S(m){const{fixedStart:E,strInBraces:D,fixedEnd:P}=w(m);if(E===void 0||P===void 0)return[D];let I=(0,b.$ok)(D,",");I.length||(I=[""]);const F=S(P);return I.flatMap(T=>{const z=E+T;return F.map(M=>z+M)})}}),define(Se[391],De([1,0,22,162,109,15]),function(he,e,d,O,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8nc=void 0;class N{constructor(k){this.b=k,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(k,A,C,p){const y=new O.$Xnc(this.b);if(A.folder.scheme===R.Schemas.vscodeUserData){const v={...A,folder:A.folder.with({scheme:R.Schemas.file})},h=new L.$dw(l=>C.report({...l,uri:l.uri.with({scheme:A.folder.scheme})}));return this.c(p,l=>y.provideTextSearchResults(k,v,h,l))}else return this.c(p,v=>y.provideTextSearchResults(k,A,C,v))}async c(k,A){const C=b(k);this.a.add(C);const p=await A(C.token);return this.a.delete(C),p}d(){this.a.forEach(k=>k.cancel())}}e.$8nc=N;function b($){const k=new d.$oe;return $.onCancellationRequested(()=>k.cancel()),k}}),define(Se[392],De([1,0,32,162,161]),function(he,e,d,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=void 0;class R{constructor($){this.a=$}search($,k,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(y){A({message:y})}},p=new L.$5nc(this.a,new O.$Xnc(C),d);return new Promise((y,v)=>p.search(h=>{k(h.map(N))},$).then(h=>y({limitHit:h.limitHit,type:"success",stats:h.stats}),v))}}e.$6nc=R;function N(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce(($,k)=>{if(k.ranges){const A=k;return $+(Array.isArray(A.ranges)?A.ranges.length:1)}else return $+1},0)}}}),define(Se[393],De([1,0,19,7,13,4,133,17,40,2,33,37,388,392]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7nc=void 0;class v{static{this.a=512}constructor(u="searchProcess"){this.d=u,this.b=Object.create(null)}fileSearch(u){let s;const t=o(u),c=new R.$de({onDidAddFirstListener:()=>{s=(0,O.$jh)(r=>this.doFileSearchWithEngine(p.$Wnc,t,a=>c.fire(a),r)),s.then(r=>c.fire(r),r=>c.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return c.event}textSearch(u){let s;const t=o(u),c=new R.$de({onDidAddFirstListener:()=>{s=(0,O.$jh)(r=>this.f(t,a=>c.fire(a),r)),s.then(r=>c.fire(r),r=>c.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return c.event}f(u,s,t){return u.maxFileSize=this.g().maxFileSize,new y.$6nc(u).search(t,s,s)}g(){return{maxFileSize:16*A.$yl.GB}}doFileSearch(u,s,t){return this.doFileSearchWithEngine(p.$Wnc,u,s,t)}doFileSearchWithEngine(u,s,t,c,r=v.a){let a=0;const f=w=>{Array.isArray(w)?(a+=w.length,t(w.map(S=>this.h(S)))):w.relativePath?(a++,t(this.h(w))):t(w)};if(s.sortByScore){let w=this.l(s,f,c);if(!w){const S=s.maxResults?Object.assign({},s,{maxResults:null}):s,m=new u(S);w=this.j(m,s,t,f,c)}return new Promise((S,m)=>{w.then(([E,D])=>{const P=D.map(I=>this.h(I));this.o(P,t,r),S(E)},m)})}const g=new u(s);return this.r(g,f,r,c).then(w=>({limitHit:w.limitHit,type:"success",stats:{detailStats:w.stats,type:this.d,fromCache:!1,resultCount:a,sortingTime:void 0}}))}h(u){return{path:u.base?(0,b.$jc)(u.base,u.relativePath):u.relativePath}}j(u,s,t,c,r){const a=new R.$de;let f=(0,O.$jh)(w=>{let S=[];const m=E=>{Array.isArray(E)?S=E:(c(E),a.fire(E))};return this.r(u,m,-1,w).then(E=>[E,S])}),g;if(s.cacheKey){g=this.k(s.cacheKey);const w={promise:f,event:a.event,resolved:!1};g.resultsToSearchCache[s.filePattern||""]=w,f.then(()=>{w.resolved=!0},S=>{delete g.resultsToSearchCache[s.filePattern||""]}),f=this.s(f)}return f.then(([w,S])=>{const m=g?g.scorerCache:Object.create(null),E=(typeof s.maxResults!="number"||s.maxResults>0)&&$.$_d.create(!1);return this.n(s,S,m,r).then(D=>{const P=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:w.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:s.folderQueries.length,resultCount:D.length},messages:w.messages,limitHit:w.limitHit||typeof s.maxResults=="number"&&S.length>s.maxResults},D]})})}k(u){const s=this.b[u];return s||(this.b[u]=new h)}l(u,s,t){const c=u.cacheKey&&this.b[u.cacheKey];if(!c)return;const r=this.q(c,u.filePattern||"",s,t);if(r)return r.then(([a,f,g])=>{const w=$.$_d.create(!1);return this.n(u,f,c.scorerCache,t).then(S=>{const m=w.elapsed(),E={fromCache:!0,detailStats:g,type:this.d,resultCount:f.length,sortingTime:m};return[{type:"success",limitHit:a.limitHit||typeof u.maxResults=="number"&&f.length>u.maxResults,stats:E},S]})})}n(u,s,t,c){const r=(0,N.$xr)(u.filePattern||""),a=(g,w)=>(0,N.$wr)(g,w,r,!0,l,t),f=typeof u.maxResults=="number"?u.maxResults:Number.MAX_VALUE;return d.$Gb(s,a,f,1e4,c)}o(u,s,t){if(t&&t>0)for(let c=0;c<u.length;c+=t)s(u.slice(c,c+t));else s(u)}q(u,s,t,c){const r=$.$_d.create(!1),a=s.indexOf(b.sep)>=0;let f;for(const m in u.resultsToSearchCache)if(s.startsWith(m)){if(a&&m.indexOf(b.sep)<0&&m!=="")continue;const E=u.resultsToSearchCache[m];f={promise:this.s(E.promise),event:E.event,resolved:E.resolved};break}if(!f)return null;const g=r.elapsed(),w=$.$_d.create(!1),S=f.event(t);return c&&c.onCancellationRequested(()=>{S.dispose()}),f.promise.then(([m,E])=>{if(c&&c.isCancellationRequested)throw(0,L.$6)();const D=[],P=(0,N.$xr)(s).normalizedLowercase;for(const I of E)(0,C.$BL)(I,P)&&D.push(I);return[m,D,{cacheWasResolved:f.resolved,cacheLookupTime:g,cacheFilterTime:w.elapsed(),cacheEntryCount:E.length}]})}r(u,s,t,c){return new Promise((r,a)=>{let f=[];c?.onCancellationRequested(()=>u.cancel()),u.search(g=>{g&&(t?(f.push(g),t>0&&f.length>=t&&(s(f),f=[])):s(g))},g=>{s(g)},(g,w)=>{f.length&&s(f),g?(s({message:"Search finished. Error: "+g.message}),a(g)):(s({message:"Search finished. Stats: "+JSON.stringify(w.stats)}),r(w))})})}clearCache(u){return delete this.b[u],Promise.resolve(void 0)}s(u){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,t){return u.then(s,t)}catch(s){return this.then(void 0,s)}finally(s){return u.finally(s)}}}}e.$7nc=v;class h{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const l=new class{getItemLabel(i){return(0,b.$nc)(i.relativePath)}getItemDescription(i){return(0,b.$mc)(i.relativePath)}getItemPath(i){return i.relativePath}};function o(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(u=>k.URI.revive(u))}}function n(i){return{...i,folder:k.URI.revive(i.folder)}}}),define(Se[394],De([1,0,3,15,2,32,11,28,20,97,68,37,393,391,123,161]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9nc=void 0;let l=class extends k.$Tmc{constructor(n,i,u,s){super(n,u,s),this.w=R,this.x=-1,this.y=null,this.z=!1,this.A=new d.$Tc;const t=new v.$Rnc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(O.Schemas.vscodeUserData,new y.$8nc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new v.$Rnc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(O.Schemas.file,new y.$8nc(n))),this.A.add(this.C(O.Schemas.file,new p.$7nc("fileSearchProvider")))}C(n,i){const u=this.d++;return this.y=i,this.x=u,this.c.$registerFileSearchProvider(u,this.s(n)),(0,d.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(u)})}$provideFileSearchResults(n,i,u,s){const t=(0,k.$Umc)(u);if(n===this.x){const c=Date.now();return this.D(n,i,t,s).then(r=>{const a=Date.now()-c;return this.q.debug(`Ext host file search time: ${a}ms`),r})}return super.$provideFileSearchResults(n,i,u,s)}doInternalFileSearchWithCustomCallback(n,i,u){const s=t=>{if((0,C.$AL)(t)&&(t=[t]),Array.isArray(t)){u(t.map(c=>L.URI.file(c.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,s,i)}async D(n,i,u,s){return this.doInternalFileSearchWithCustomCallback(u,s,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new h.$5nc(n,i,void 0,"textSearchProvider")}};e.$9nc=l,e.$9nc=l=Ge([We(0,$.$zP),We(1,b.$PP),We(2,A.$Klc),We(3,N.$3j)],l)}),define(Se[124],De([1,0,408,63,64,409,21,13,4,3,17,12,30,82,83]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$ni=e.$mi=e.$li=void 0,e.$oi=r,e.$pi=a,e.$ri=w,e.$si=S;class h{traceSocketEvent(E,D){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,D)}constructor(E,D=""){this.f=!0,this.debugLabel=D,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,b.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const D=P=>{this.traceSocketEvent("read",P),E(N.$Fe.wrap(P))};return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(E){const D=P=>{E({type:0,hadError:P,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(E){const D=()=>{E()};return this.socket.on("end",D),{dispose:()=>this.socket.off("end",D)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,b.$1)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,b.$1)(D)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,D)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$li=h;var l;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize",m[m.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(l||(l={}));var o;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(o||(o={}));class n extends k.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,D){this.socket.traceSocketEvent(E,D)}constructor(E,D,P,I){super(),this.f=this.B(new $.$de),this.g=this.B(new $.$de),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:D,inflateBytesLength:P?.byteLength||0,recordInflateBytes:I}),this.a=this.B(new i(this,D,P,I,this.f,(F,T)=>this.m(F,T))),this.B(this.a.onError(F=>{console.error(F),(0,b.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new v.$gi,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let D=0;for(;D<E.byteLength;)this.a.writeMessage(E.slice(D,Math.min(D+262144,E.byteLength)),{compressed:!0,opcode:2}),D+=262144}m(E,{compressed:D,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let I=2;E.byteLength<126?I+=0:E.byteLength<2**16?I+=2:I+=8;const F=N.$Fe.alloc(I),T=D?64:0,z=P&15;if(F.writeUInt8(128|T|z,0),E.byteLength<126)F.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){F.writeUInt8(126,1);let M=1;F.writeUInt8(E.byteLength>>>8&255,++M),F.writeUInt8(E.byteLength>>>0&255,++M)}else{F.writeUInt8(127,1);let M=1;F.writeUInt8(0,++M),F.writeUInt8(0,++M),F.writeUInt8(0,++M),F.writeUInt8(0,++M),F.writeUInt8(E.byteLength>>>24&255,++M),F.writeUInt8(E.byteLength>>>16&255,++M),F.writeUInt8(E.byteLength>>>8&255,++M),F.writeUInt8(E.byteLength>>>0&255,++M)}this.socket.write(N.$Fe.concat([F,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const D=this.b.peek(this.j.readLen),P=D.readUInt8(0),I=(P&128)>>>7,F=(P&64)>>>6,T=P&15,z=D.readUInt8(1),M=(z&128)>>>7,j=z&127;this.j.state=2,this.j.readLen=2+(M?4:0)+(j===126?2:0)+(j===127?8:0),this.j.fin=I,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!I,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const D=this.b.read(this.j.readLen),P=D.readUInt8(1),I=(P&128)>>>7;let F=P&127,T=1;F===126?F=D.readUInt8(++T)*2**8+D.readUInt8(++T):F===127&&(F=D.readUInt8(++T)*0+D.readUInt8(++T)*0+D.readUInt8(++T)*0+D.readUInt8(++T)*0+D.readUInt8(++T)*2**24+D.readUInt8(++T)*2**16+D.readUInt8(++T)*2**8+D.readUInt8(++T));let z=0;I&&(z=D.readUInt8(++T)*2**24+D.readUInt8(++T)*2**16+D.readUInt8(++T)*2**8+D.readUInt8(++T)),this.j.state=3,this.j.readLen=F,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const D=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",D),t(D,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",D),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(D,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(D,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$mi=n;class i extends k.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:N.$Fe.alloc(0)}constructor(E,D,P,I,F,T){super(),this.n=E,this.r=F,this.s=T,this.a=this.B(new $.$de),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$de),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$de),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,D?(this.b=this.B(new u(this.n,I,P,{windowBits:15})),this.f=this.B(new s(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(E,D){this.g.push({data:E,options:D}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:D}=this.g.shift();if(this.f&&D.compressed){const P=await this.w(this.f,E);this.s(P,D)}else this.s(E,{...D,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,D){return new Promise((P,I)=>{E.write(D),E.flush(F=>P(F))})}acceptFrame(E,D,P){this.h.push({data:E,isCompressed:D,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const D=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(D)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,D,P){return new Promise((I,F)=>{E.write(D),P&&E.write(N.$Fe.fromByteArray([0,0,255,255])),E.flush(T=>I(T))})}}class u extends k.$Uc{get recordedInflateBytes(){return this.j?N.$Fe.concat(this.f):N.$Fe.alloc(0)}constructor(E,D,P,I){super(),this.h=E,this.j=D,this.a=this.B(new $.$de),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(I),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(N.$Fe.wrap(F))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const D=N.$Fe.concat(this.g);this.g.length=0,E(D)})}}class s extends k.$Uc{constructor(E,D){super(),this.g=E,this.a=this.B(new $.$de),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(N.$Fe.wrap(P))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let D=N.$Fe.concat(this.f);this.f.length=0,D=D.slice(0,D.byteLength-4),E(D)})}}function t(m,E){if(E===0)return;const D=m.byteLength>>>2;for(let M=0;M<D;M++){const j=m.readUInt32BE(M*4);m.writeUInt32BE(j^E,M*4)}const P=D*4,I=m.byteLength-P,F=E>>>24&255,T=E>>>16&255,z=E>>>8&255;I>=1&&m.writeUInt8(m.readUInt8(P)^F,P),I>=2&&m.writeUInt8(m.readUInt8(P+1)^T,P+1),I>=3&&m.writeUInt8(m.readUInt8(P+2)^z,P+2)}e.$ni=process.env.XDG_RUNTIME_DIR;const c={2:107,1:103};function r(){const m=(0,p.$Sg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;const E=process.platform!=="darwin"&&e.$ni?e.$ni:(0,L.tmpdir)(),D=(0,A.$jc)(E,`vscode-ipc-${m}.sock`);return f(D),D}function a(m,E,D){const I=(0,d.createHash)("sha256").update(m).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${D}-${E}-sock`;const F=D.substr(0,4),T=E.substr(0,6);let z;return process.platform!=="darwin"&&e.$ni&&!process.env.VSCODE_PORTABLE?z=(0,A.$jc)(e.$ni,`vscode-${I}-${F}-${T}.sock`):z=(0,A.$jc)(m,`${F}-${T}.sock`),f(z),z}function f(m){const E=c[C.$u];typeof E=="number"&&m.length>=E&&console.warn(`WARNING: IPC handle "${m}" is longer than ${E} chars, try a shorter --user-data-dir`)}class g extends y.$ai{static b(E){const D=$.Event.fromNodeEventEmitter(E,"connection");return $.Event.map(D,P=>({protocol:new v.$hi(new h(P,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(P,"close"))}))}constructor(E){super(g.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$qi=g;function w(m){return new Promise((E,D)=>{const P=(0,O.createServer)();P.on("error",D),P.listen(m,()=>{P.removeListener("error",D),E(new g(P))})})}function S(m,E){return new Promise((D,P)=>{const I=(0,O.createConnection)(m,()=>{I.removeListener("error",P),D(v.$ii.fromSocket(new h(I,`ipc-client${E}`),E))});I.once("error",P)})}}),define(Se[395],De([1,0,63,64,178,124,7,3,12,55,11,108,272,273,111,88,21]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=e.$Vdc=e.$Udc=e.$Tdc=void 0;async function o(t,c,r,a,f){let g;for(let w=3;w&&(g?.dispose(),g=await new n(t,c,r,a,f).waitForReady(),!(f&&L.$Vg[f]||!L.$Vg[g.tunnelLocalPort]));w--);return g}class n extends b.$Uc{constructor(c,r,a,f,g){super(),this.m=r,this.n=g,this.privacy=h.TunnelPrivacyId.Private,this.j=new Map,this.a=c,this.b=d.createServer(),this.c=new N.$vh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=w=>this.r(w),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=f,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const c=this.n??this.tunnelRemotePort,r=(0,h.$qw)(this.m)?"0.0.0.0":"127.0.0.1";let a=await(0,L.$Wg)(c,2,1e3,r),f=null;return this.b.listen(a,this.m),await this.c.wait(),f=this.b.address(),f||(a=0,this.b.listen(a,this.m),await this.c.wait(),f=this.b.address()),this.tunnelLocalPort=f.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${f.port}`,this}async r(c){c.pause();const r=(0,h.$ow)(this.tunnelRemoteHost)||(0,h.$qw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,p.$Sl)(this.a,r,this.tunnelRemotePort),f=a.getSocket(),g=a.readEntireBuffer();a.dispose(),g.byteLength>0&&c.write(g.buffer),c.on("end",()=>{c.localAddress&&this.j.delete(c.localAddress),f.end()}),c.on("close",()=>f.end()),c.on("error",()=>{c.localAddress&&this.j.delete(c.localAddress),f instanceof R.$li?f.socket.destroy():f.end()}),f instanceof R.$li?this.t(c,f):this.s(c,f),c.localAddress&&this.j.set(c.localAddress,()=>{c.end(),f.end()})}s(c,r){r.onClose(()=>c.destroy()),r.onEnd(()=>c.end()),r.onData(a=>c.write(a.buffer)),c.on("data",a=>r.write(l.$Fe.wrap(a))),c.resume()}t(c,r){const a=r.socket;a.on("end",()=>c.end()),a.on("close",()=>c.end()),a.on("error",()=>{c.destroy()}),a.pipe(c),c.pipe(a)}}e.$Tdc=n;let i=class extends h.$tw{constructor(c,r,a,f,g){super(r,g),this.v=c,this.w=a,this.y=f}isPortPrivileged(c){return(0,h.$rw)(c,this.m,$.OS,O.release())}t(c,r,a,f,g,w,S,m){const E=this.s(r,a);if(E)return++E.refcount,E.value;if((0,h.$kw)(c))return this.u(c,r,a,g,w,S,m);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${a} on local port ${g}.`);const D={commit:this.y.commit,quality:this.y.quality,addressProvider:c,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=o(D,f,r,a,g);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(r,a,P),P}}};e.$Udc=i,e.$Udc=i=Ge([We(0,y.$Ml),We(1,A.$3j),We(2,v.$Pl),We(3,C.$jk),We(4,k.$3i)],i);let u=class extends i{constructor(c,r,a,f,g){super(c,r,a,f,g)}};e.$Vdc=u,e.$Vdc=u=Ge([We(0,y.$Ml),We(1,A.$3j),We(2,v.$Pl),We(3,C.$jk),We(4,k.$3i)],u);let s=class extends b.$Uc{constructor(c,r,a,f,g){super(),this.b=c,this.c=r,this.f=a,this.g=f,this.h=g,this.a=new Map}async openTunnel(c,r,a,f,g,w,S,m,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${f} on local port ${w}.`),!this.a.has(c)){const D=new u(this.b,this.c,this.g,this.f,this.h);this.B(D),this.a.set(c,D),D.onTunnelClosed(async()=>{(await D.tunnels).length===0&&(D.dispose(),this.a.delete(c))})}return this.a.get(c).openTunnel(r,a,f,g,w,S,m,E)}};e.$Wdc=s,e.$Wdc=s=Ge([We(0,y.$Ml),We(1,A.$3j),We(2,C.$jk),We(3,v.$Pl),We(4,k.$3i)],s)}),define(Se[396],De([1,0,124,292,53,34,2,11,42]),function(he,e,d,O,L,R,N,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.$1P=void 0;class k{constructor(p,y,v){this.b=p,this.c=y,this.f=v,this.a=O.createServer((h,l)=>this.h(h,l)),this.g().catch(h=>(y.error(h),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,y){const v=(l,o)=>{y.writeHead(l,{"content-type":"application/json"}),y.end(JSON.stringify(o||null),n=>n&&this.c.error(n))},h=[];p.setEncoding("utf8"),p.on("data",l=>h.push(l)),p.on("end",async()=>{try{const l=JSON.parse(h.join(""));let o;switch(l.type){case"open":o=await this.i(l);break;case"openExternal":o=await this.j(l);break;case"status":o=await this.l(l);break;case"extensionManagement":o=await this.k(l);break;default:v(404,`Unknown message type: ${l.type}`);break}v(200,o)}catch(l){const o=l instanceof Error?l.message:JSON.stringify(l);v(500,o),this.c.error("Error while processing pipe request",l)}})}async i(p){const{fileURIs:y,folderURIs:v,forceNewWindow:h,diffMode:l,mergeMode:o,addMode:n,forceReuseWindow:i,gotoLineMode:u,waitMarkerFilePath:s,remoteAuthority:t}=p,c=[];if(Array.isArray(v))for(const g of v)try{c.push({folderUri:N.URI.parse(g)})}catch{}if(Array.isArray(y))for(const g of y)try{(0,$.$2i)(g)?c.push({workspaceUri:N.URI.parse(g)}):c.push({fileUri:N.URI.parse(g)})}catch{}const r=s?N.URI.file(s):void 0,f={forceNewWindow:h,diffMode:l,mergeMode:o,addMode:n,gotoLineMode:u,forceReuseWindow:i,preferNewWindow:!i&&!r&&!n,waitMarkerFileURI:r,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",c,f)}async j(p){for(const y of p.uris){const v=N.URI.parse(y),h=v.scheme==="file"?v:y;await this.b.executeCommand("_remoteCLI.openExternal",h)}}async k(p){const y=h=>h?.map(l=>/\.vsix$/i.test(l)?N.URI.parse(l):l),v={list:p.list,install:y(p.install),uninstall:y(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&L.existsSync(this.f)&&L.unlinkSync(this.f)}}e.$1P=k;let A=class extends k{constructor(p,y){super(p,y,(0,d.$oi)())}};e.$2P=A,e.$2P=A=Ge([We(0,R.$VP),We(1,b.$3j)],A)}),define(Se[397],De([1,0,59,384,379,291,49,366,2,15,8,396,104,325,365]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$boc=void 0;class h extends L.$Cnc{j(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,u=i._load;i._load=function(r,a,f){return r=t(r),n.a.has(r)?n.a.get(r).load(r,$.URI.file((0,p.$7q)(a.filename)),g=>u.apply(this,[g,a,f])):u.apply(this,arguments)};const s=i._resolveLookupPaths;i._resolveLookupPaths=(c,r)=>s.call(this,t(c),r);const t=c=>{for(const r of n.b){const a=r(c);if(a){c=a;break}}return c}}}class l extends N.$qmc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async vb(){this.h.createInstance(y.$_nc);const n=this.h.invokeFunction(O.$ync);if(this.h.createInstance(b.$$nc),this.f.remote.isRemote&&this.f.remote.authority){const s=this.h.createInstance(C.$2P);process.env.VSCODE_IPC_HOOK_CLI=s.ipcHandlePath}this.h.createInstance(v.$aoc),await this.h.createInstance(h,n,{mine:this.J,all:this.L}).install(),d.mark("code/extHost/didInitAPI");const u=await this.m.getConfigProvider();await(0,R.$0nc)(this.j,u,this,this.s,this.z,this.f),d.mark("code/extHost/didInitProxyResolver")}wb(n){return n.main}async xb(n,i,u){if(i.scheme!==k.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let s=null;u.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&d.mark(`code/extHost/willLoadExtensionCode/${t}`),s=he.__$__nodeRequire(i.fsPath)}finally{t&&d.mark(`code/extHost/didLoadExtensionCode/${t}`),u.codeLoadingStop()}return s}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const i in n){const u=n[i];u===null?delete process.env[i]:process.env[i]=u}}}e.$boc=l}),define(Se[398],De([1,0,54,21,4,3,126,12,23,2,32,11,271,67,111,88,395,28,20,71,373]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$joc=void 0,e.$coc=s,e.$doc=t,e.$eoc=c,e.$foc=r,e.$goc=f,e.$hoc=g,e.$ioc=w;function s(E){const D=E.trim().split(`
`),P=[];return D.forEach(F=>{const T=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(F);T&&T.length>=3&&P.push({pid:parseInt(T[1],10),socket:parseInt(T[2],10)})}),P.reduce((F,T)=>(F[T.socket]=T,F),{})}function t(...E){const D=[].concat(...E.map(r));return[...new Map(D.filter(P=>P.st==="0A").map(P=>{const I=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:c(I[0]),port:parseInt(I[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}function c(E){let D="";if(E.length===8)for(let P=E.length-2;P>=0;P-=2)D+=parseInt(E.substr(P,2),16),P!==0&&(D+=".");else for(let P=0;P<E.length;P+=8){const I=E.substring(P,P+8);let F="";for(let T=8;T>=2;T-=2)F+=I.substring(T-2,T),(T===6||T===2)&&(F=parseInt(F,16).toString(16),D+=`${F}`,F="",P+T!==E.length-6&&(D+=":"))}return D}function r(E){const D=E.trim().split(`
`),P=D.shift().trim().split(/\s+/).filter(F=>F!=="rx_queue"&&F!=="tm->when");return D.map(F=>F.trim().split(/\s+/).reduce((T,z,M)=>(T[P[M]||M]=z,T),{}))}function a(E){return!!E.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||E.indexOf("out/server-main.js")!==-1||E.indexOf("_productName=VSCode")!==-1}function f(E){const D=E.trim().split(`
`),P=[];return D.forEach(I=>{const F=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(I);F&&F.length>=4&&P.push({pid:parseInt(F[1],10),ppid:parseInt(F[2]),cmd:F[3]})}),P}async function g(E,D,P){const I=P.reduce((T,z)=>(T[z.pid]=z,T),{}),F=[];return E.forEach(({socket:T,ip:z,port:M})=>{const j=D[T]?D[T].pid:void 0,U=j?I[j]?.cmd:void 0;j&&U&&!a(U)&&F.push({host:z,port:M,detail:U,pid:j})}),F}function w(E,D,P){const I=new Map,F=f(D);for(const T of E){const z=P.get(T.port);if(z){I.set(T.port,z);continue}const M=F.find(j=>j.cmd.includes(`${T.port}`));if(M){let j=M,U;do U=F.find(Z=>Z.ppid===j.pid),U&&(j=U);while(U);I.set(T.port,{host:T.ip,port:T.port,pid:j.pid,detail:j.cmd,ppid:j.ppid})}else I.set(T.port,{host:T.ip,port:T.port,ppid:Number.MAX_VALUE})}return I}let S=class extends i.$tDb{constructor(D,P,I,F){super(D,P,I),this.D=P,this.F=F,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(D){if(D&&this.C)return;this.C=D;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const I=new N.$Em;let F=0;for(;this.C;){const T=new Date().getTime(),z=(await this.I()).filter(U=>(0,h.$ow)(U.host)||(0,h.$qw)(U.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(U=>U.port).join(", ")}`);const M=new Date().getTime()-T;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${M} ms.`),F++>3&&I.update(M),(!P||JSON.stringify(P)!==JSON.stringify(z))&&(P=z,await this.a.$onFoundNewCandidates(P));const j=this.G(I.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${j} ms.`),await new Promise(U=>setTimeout(()=>U(),j))}}G(D){return Math.max(D*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(D=>D.port).join(", ")}`)}async I(){let D="",P="";try{D=await A.Promises.readFile("/proc/net/tcp","utf8"),P=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const I=t(D,P),F=await new Promise(q=>{(0,d.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(G,x,ne)=>{q(x)})}),T=s(F),z=await A.Promises.readdir("/proc"),M=[];for(const q of z)try{const G=Number(q),x=$.$0g(k.URI.file("/proc"),q);if((await A.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(G)){const be=await A.Promises.readlink($.$0g(x,"cwd").fsPath),ae=await A.Promises.readFile($.$0g(x,"cmdline").fsPath,"utf8");M.push({pid:G,cwd:be,cmd:ae})}}catch{}const j=[],U=I.filter(q=>{const G=T[q.socket];return G||j.push(q),G}),Z=g(U,T,M);let ie;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${j.length}`),j.length>0){const q=await new Promise(G=>{(0,d.exec)("ps -F -A -l | grep root",(x,ne,be)=>{G(ne)})});this.z=w(j,q,this.z),ie=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ie.map(G=>G.port).join(", ")}`)}return Z.then(q=>ie?q.concat(ie):q)}w(D){return async P=>{const I=new l.$Tdc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(T,z,M,j){const U=await D.makeConnection();return m.connect(U,z,M,j)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$Il(0),connectionToken:D.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await I.waitForReady();const F=new L.$de;return{localAddress:(0,u.$yM)(I.localAddress)??I.localAddress,remoteAddress:{port:I.tunnelRemotePort,host:I.tunnelRemoteHost},onDidDispose:F.event,dispose:()=>{I.dispose(),F.fire(),F.dispose()}}}}};e.$joc=S,e.$joc=S=Ge([We(0,n.$zP),We(1,o.$PP),We(2,C.$3j),We(3,v.$Pl)],S);class m extends p.$nvb{static connect(D,P,I,F){const T=new R.$Tc,z={onClose:T.add(new L.$de),onData:T.add(new L.$de),onEnd:T.add(new L.$de)};T.add(D.onDidReceiveMessage(j=>z.onData.fire(O.$Fe.wrap(j)))),T.add(D.onDidEnd(()=>z.onEnd.fire())),T.add(D.onDidClose(j=>z.onClose.fire({type:0,error:j,hadError:!!j})));const M=new m(D,F,z);return M.B(T),(0,p.$mvb)(M,P,I,F,z)}constructor(D,P,I){super(P,I),this.n=D}write(D){this.n.send(D.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[399],De([1,0,85,368,382,381,394,397,398,96,49,97,95,43,71,93,367,326,11,383,61,286,106,111,141]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o,n,i,u,s,t,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.$xs)(A.$rmc,b.$boc,0),(0,d.$xs)(n.$4j,o.$loc,1),(0,d.$xs)(n.$3j,new t.$ti(s.$Bnc,[!1],!0)),(0,d.$xs)(c.$Pl,r.$Ydc,1),(0,d.$xs)(h.$Tlc,l.$koc,0),(0,d.$xs)(k.$wmc,R.$Onc,0),(0,d.$xs)(C.$Smc,N.$9nc,0),(0,d.$xs)(p.$inc,L.$Gnc,0),(0,d.$xs)(y.$cmc,O.$Fnc,0),(0,d.$xs)(v.$sDb,$.$joc,0),(0,d.$xs)(u.$umc,i.$moc,0)}),define(Se[410],De([1,0,63,411,59,13,83,124,269,115,380,21,32,104,7,136,293,309,385,399]),function(he,e,d,O,L,R,N,b,$,k,A,C,p,y,v,h,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let w=0;w<process.execArgv.length;w++)process.execArgv[w]==="--inspect-port=0"&&(process.execArgv.splice(w,1),w--)}();const n=O(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const g=globalThis._VSCODE_NODE_MODULES.module,w=g._load;g._load=function(S){if(S==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return w.apply(this,arguments)}})();const i=process.exit.bind(process),u=process.on.bind(process);function s(g){process.exit=function(w){if(g)i(w);else{const S=new Error("An extension called process.exit() and this was prevented.");console.warn(S.stack)}},process.crash=function(){const w=new Error("An extension called process.crash() and this was prevented.");console.warn(w.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(w,S){w==="uncaughtException"&&(S=function(){try{return S.call(void 0,arguments)}catch{}}),u(w,S)}}let t=function(g){i()};function c(){const g=(0,o.$on)(process.env);if(g.type===3)return new Promise((w,S)=>{const m=E=>{const D=E[0],P=new N.$ji;D.on("message",I=>P.fire(C.$Fe.wrap(I.data))),D.on("close",()=>{t("renderer closed the MessagePort")}),D.start(),w({onMessage:P.event,send:I=>D.postMessage(I.buffer)})};process.parentPort.on("message",E=>m(E.ports))});if(g.type===2)return new Promise((w,S)=>{let m=null;const E=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),D=108e5,P=3e5,I=new v.$Jh(()=>t("renderer disconnected for too long (1)"),D),F=new v.$Jh(()=>t("renderer disconnected for too long (2)"),P);process.on("message",(z,M)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){M.setNoDelay(!0);const j=C.$Fe.wrap(Buffer.from(z.initialDataChunk,"base64"));let U;if(z.skipWebSocketFrames)U=new b.$li(M,"extHost-socket");else{const Z=C.$Fe.wrap(Buffer.from(z.inflateBytes,"base64"));U=new b.$mi(new b.$li(M,"extHost-socket"),z.permessageDeflate,Z,!1)}m?(I.cancel(),F.cancel(),m.beginAcceptReconnection(U,j),m.endAcceptReconnection(),m.sendResume()):(clearTimeout(E),m=new N.$ki({socket:U,initialChunk:j}),m.sendResume(),m.onDidDispose(()=>t("renderer disconnected")),w(m),m.onSocketClose(()=>{I.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(F.isScheduled())return;I.isScheduled()&&F.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(T)});{const w=g.pipeName;return new Promise((S,m)=>{const E=d.createConnection(w,()=>{E.removeListener("error",m);const D=new N.$ki({socket:new b.$li(E,"extHost-renderer")});D.sendResume(),S(D)});E.once("error",m),E.on("close",()=>{t("renderer closed the socket")})})}}async function r(){const g=await c();return new class{constructor(){this.a=new N.$ji,this.onMessage=this.a.event,this.b=!1,g.onMessage(w=>{(0,k.$1m)(w,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(w)})}send(w){this.b||g.send(w)}async drain(){if(g.drain)return g.drain()}}}function a(g){return new Promise(w=>{const S=g.onMessage(m=>{S.dispose();const E=JSON.parse(m.toString()),D=E.commit,P=$.default.commit;if(D&&P&&D!==P&&i(55),E.parentPid){let I=0;setInterval(function(){try{process.kill(E.parentPid,0),I=0}catch(T){T&&T.code==="EPERM"?(I++,I>=3&&t(`parent process ${E.parentPid} does not exist anymore (3 x EPERM): ${T.message} (code: ${T.code}) (errno: ${T.errno})`)):t(`parent process ${E.parentPid} does not exist anymore: ${T.message} (code: ${T.code}) (errno: ${T.errno})`)}},1e3);let F;try{F=globalThis._VSCODE_NODE_MODULES["native-watchdog"],F.start(E.parentPid)}catch(T){(0,R.$1)(T)}}g.send((0,k.$Zm)(0)),w({protocol:g,initData:E})});g.send((0,k.$Zm)(1))})}async function f(){const g=[];process.on("unhandledRejection",(I,F)=>{g.push(F),setTimeout(()=>{const T=g.indexOf(F);T>=0&&F.catch(z=>{g.splice(T,1),(0,R.$4)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),I&&(0,R.$1)(I))})},1e3)}),process.on("rejectionHandled",I=>{const F=g.indexOf(I);F>=0&&g.splice(F,1)}),process.on("uncaughtException",function(I){(0,R.$Z)(I)||(0,R.$1)(I)}),L.mark("code/extHost/willConnectToRenderer");const w=await r();L.mark("code/extHost/didConnectToRenderer");const S=await a(w);L.mark("code/extHost/didWaitForInitData");const{initData:m}=S;s(!!m.environment.extensionTestsLocationURI),m.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,m.environment.skipWorkspaceStorageLock=(0,h.boolean)(n.skipWorkspaceStorageLock,!1);const E=new class{constructor(){this.pid=process.pid}exit(F){i(F)}fsExists(F){return p.Promises.exists(F)}fsRealpath(F){return(0,y.$6q)(F)}};let D=null;m.remote.authority&&n.transformURIs&&(D=(0,l.$Bs)(m.remote.authority));const P=new A.$Enc(S.protocol,m,E,D);t=I=>P.terminate(I)}f().catch(g=>console.log(g))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a1f2ea3162c704a5890c35dde4df6ee46283d957/core/vs/workbench/api/node/extensionHostProcess.js.map
