/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/registry/common/platform","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/themables","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/common/marshalling","vs/platform/configuration/common/configuration","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Pe=function(le){for(var e=[],C=0,O=le.length;C<O;C++)e[C]=Se[le[C]];return e};define(Se[69],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=O,e.$2h=R,e.$3h=M;function C(A){return($,m,E)=>{let T=null,k=null;if(typeof E.value=="function"?(T="value",k=E.value):typeof E.get=="function"&&(T="get",k=E.get),!k)throw new Error("not supported");E[T]=A(k,m)}}function O(A,$,m){let E=null,T=null;if(typeof m.value=="function"?(E="value",T=m.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(E="get",T=m.get),!T)throw new Error("not supported");const k=`$memoize$${$}`;m[E]=function(...l){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,l)}),this[k]}}function R(A,$,m){return C((E,T)=>{const k=`$debounce$${T}`,l=`$debounce$result$${T}`;return function(...w){this[l]||(this[l]=m?m():void 0),clearTimeout(this[k]),$&&(this[l]=$(this[l],...w),w=[this[l]]),this[k]=setTimeout(()=>{E.apply(this,w),this[l]=m?m():void 0},A)}})}function M(A,$,m){return C((E,T)=>{const k=`$throttle$timer$${T}`,l=`$throttle$result$${T}`,w=`$throttle$lastRun$${T}`,f=`$throttle$pending$${T}`;return function(...s){if(this[l]||(this[l]=m?m():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),$&&(this[l]=$(this[l],...s)),this[f])return;const r=this[w]+A;r<=Date.now()?(this[w]=Date.now(),E.apply(this,[this[l]]),this[l]=m?m():void 0):(this[f]=!0,this[k]=setTimeout(()=>{this[f]=!1,this[w]=Date.now(),E.apply(this,[this[l]]),this[l]=m?m():void 0},r-Date.now()))}})}}),define(Se[125],Pe([1,0,18]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=R,e.$8c=M,e.$9c=A,e.$0c=$,e.$$c=m,e.$_c=E;const O=(w,f)=>w===f;e.$6c=O;function R(w=e.$6c){return(f,s)=>C.$ub(f,s,w)}function M(){return(w,f)=>JSON.stringify(w)===JSON.stringify(f)}function A(){return(w,f)=>w.equals(f)}function $(w,f,s){return!w||!f?w===f:s(w,f)}function m(w,f){if(w===f)return!0;if(Array.isArray(w)&&Array.isArray(f)){if(w.length!==f.length)return!1;for(let s=0;s<w.length;s++)if(!m(w[s],f[s]))return!1;return!0}if(w&&typeof w=="object"&&f&&typeof f=="object"&&Object.getPrototypeOf(w)===Object.prototype&&Object.getPrototypeOf(f)===Object.prototype){const s=w,r=f,o=Object.keys(s),n=Object.keys(r),i=new Set(n);if(o.length!==n.length)return!1;for(const c of o)if(!i.has(c)||!m(s[c],r[c]))return!1;return!0}return!1}function E(w){return JSON.stringify(l(w))}let T=0;const k=new WeakMap;function l(w){if(Array.isArray(w))return w.map(l);if(w&&typeof w=="object")if(Object.getPrototypeOf(w)===Object.prototype){const f=w,s=Object.create(null);for(const r of Object.keys(f).sort())s[r]=l(f[r]);return s}else{let f=k.get(w);return f===void 0&&(f=T++,k.set(w,f)),f+"----2b76a038c20c4bcc"}return w}}),define(Se[91],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FP=e.$EP=void 0;class C{constructor(R){this.a=R,this.b=0}nextId(){return this.a+ ++this.b}}e.$EP=C,e.$FP=new C("id#")}),define(Se[126],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Hn=A,e.$In=k,e.$Jn=l,e.$Kn=w,e.$Ln=f,e.$Mn=s,e.$Nn=r,e.$On=o,e.$Pn=n,e.$Qn=i,e.$Rn=c,e.$Sn=u;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function A(t,d=!1){let a=0;const g=t.length;let b="",p=0,v=16,y=0;function h(q){let N=0,B=0;for(;N<q;){const K=t.charCodeAt(a);if(K>=48&&K<=57)B=B*16+K-48;else if(K>=65&&K<=70)B=B*16+K-65+10;else if(K>=97&&K<=102)B=B*16+K-97+10;else break;a++,N++}return N<q&&(B=-1),B}function D(q){a=q,b="",p=0,v=16,y=0}function S(){const q=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&E(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&E(t.charCodeAt(a)))for(a++;a<t.length&&E(t.charCodeAt(a));)a++;else return y=3,t.substring(q,a);let N=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&E(t.charCodeAt(a))){for(a++;a<t.length&&E(t.charCodeAt(a));)a++;N=a}else y=3;return t.substring(q,N)}function I(){let q="",N=a;for(;;){if(a>=g){q+=t.substring(N,a),y=2;break}const B=t.charCodeAt(a);if(B===34){q+=t.substring(N,a),a++;break}if(B===92){if(q+=t.substring(N,a),a++,a>=g){y=2;break}switch(t.charCodeAt(a++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const ie=h(4);ie>=0?q+=String.fromCharCode(ie):y=4;break}default:y=5}N=a;continue}if(B>=0&&B<=31)if(m(B)){q+=t.substring(N,a),y=2;break}else y=6;a++}return q}function P(){if(b="",y=0,p=a,a>=g)return p=g,v=17;let q=t.charCodeAt(a);if($(q)){do a++,b+=String.fromCharCode(q),q=t.charCodeAt(a);while($(q));return v=15}if(m(q))return a++,b+=String.fromCharCode(q),q===13&&t.charCodeAt(a)===10&&(a++,b+=`
`),v=14;switch(q){case 123:return a++,v=1;case 125:return a++,v=2;case 91:return a++,v=3;case 93:return a++,v=4;case 58:return a++,v=6;case 44:return a++,v=5;case 34:return a++,b=I(),v=10;case 47:{const N=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<g&&!m(t.charCodeAt(a));)a++;return b=t.substring(N,a),v=12}if(t.charCodeAt(a+1)===42){a+=2;const B=g-1;let K=!1;for(;a<B;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,K=!0;break}a++}return K||(a++,y=1),b=t.substring(N,a),v=13}return b+=String.fromCharCode(q),a++,v=16}case 45:if(b+=String.fromCharCode(q),a++,a===g||!E(t.charCodeAt(a)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return b+=S(),v=11;default:for(;a<g&&W(q);)a++,q=t.charCodeAt(a);if(p!==a){switch(b=t.substring(p,a),b){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return b+=String.fromCharCode(q),a++,v=16}}function W(q){if($(q)||m(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let q;do q=P();while(q>=12&&q<=15);return q}return{setPosition:D,getPosition:()=>a,scan:d?V:P,getToken:()=>v,getTokenValue:()=>b,getTokenOffset:()=>p,getTokenLength:()=>a-p,getTokenError:()=>y}}function $(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function k(t,d){const a=[],g=new Object;let b;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function y(h,D,S,I){p.value=h,p.offset=D,p.length=S,p.type=I,p.colonOffset=void 0,b=p}try{i(t,{onObjectBegin:(h,D)=>{if(d<=h)throw g;b=void 0,v=d>h,a.push("")},onObjectProperty:(h,D,S)=>{if(d<D||(y(h,D,S,"property"),a[a.length-1]=h,d<=D+S))throw g},onObjectEnd:(h,D)=>{if(d<=h)throw g;b=void 0,a.pop()},onArrayBegin:(h,D)=>{if(d<=h)throw g;b=void 0,a.push(0)},onArrayEnd:(h,D)=>{if(d<=h)throw g;b=void 0,a.pop()},onLiteralValue:(h,D,S)=>{if(d<D||(y(h,D,S,u(h)),d<=D+S))throw g},onSeparator:(h,D,S)=>{if(d<=D)throw g;if(h===":"&&b&&b.type==="property")b.colonOffset=D,v=!1,b=void 0;else if(h===","){const I=a[a.length-1];typeof I=="number"?a[a.length-1]=I+1:(v=!0,a[a.length-1]=""),b=void 0}}})}catch(h){if(h!==g)throw h}return{path:a,previousNode:b,isAtPropertyKey:v,matches:h=>{let D=0;for(let S=0;D<h.length&&S<a.length;S++)if(h[D]===a[S]||h[D]==="*")D++;else if(h[D]!=="**")return!1;return D===h.length}}}function l(t,d=[],a=M.DEFAULT){let g=null,b=[];const p=[];function v(h){Array.isArray(b)?b.push(h):g!==null&&(b[g]=h)}return i(t,{onObjectBegin:()=>{const h={};v(h),p.push(b),b=h,g=null},onObjectProperty:h=>{g=h},onObjectEnd:()=>{b=p.pop()},onArrayBegin:()=>{const h=[];v(h),p.push(b),b=h,g=null},onArrayEnd:()=>{b=p.pop()},onLiteralValue:v,onError:(h,D,S)=>{d.push({error:h,offset:D,length:S})}},a),b[0]}function w(t,d=[],a=M.DEFAULT){let g={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(h){g.type==="property"&&(g.length=h-g.offset,g=g.parent)}function p(h){return g.children.push(h),h}i(t,{onObjectBegin:h=>{g=p({type:"object",offset:h,length:-1,parent:g,children:[]})},onObjectProperty:(h,D,S)=>{g=p({type:"property",offset:D,length:-1,parent:g,children:[]}),g.children.push({type:"string",value:h,offset:D,length:S,parent:g})},onObjectEnd:(h,D)=>{g.length=h+D-g.offset,g=g.parent,b(h+D)},onArrayBegin:(h,D)=>{g=p({type:"array",offset:h,length:-1,parent:g,children:[]})},onArrayEnd:(h,D)=>{g.length=h+D-g.offset,g=g.parent,b(h+D)},onLiteralValue:(h,D,S)=>{p({type:u(h),offset:D,length:S,parent:g,value:h}),b(D+S)},onSeparator:(h,D,S)=>{g.type==="property"&&(h===":"?g.colonOffset=D:h===","&&b(D))},onError:(h,D,S)=>{d.push({error:h,offset:D,length:S})}},a);const y=g.children[0];return y&&delete y.parent,y}function f(t,d){if(!t)return;let a=t;for(const g of d)if(typeof g=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let b=!1;for(const p of a.children)if(Array.isArray(p.children)&&p.children[0].value===g){a=p.children[1],b=!0;break}if(!b)return}else{const b=g;if(a.type!=="array"||b<0||!Array.isArray(a.children)||b>=a.children.length)return;a=a.children[b]}return a}function s(t){if(!t.parent||!t.parent.children)return[];const d=s(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;d.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&d.push(a)}return d}function r(t){switch(t.type){case"array":return t.children.map(r);case"object":{const d=Object.create(null);for(const a of t.children){const g=a.children[1];g&&(d[a.children[0].value]=r(g))}return d}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,d,a=!1){return d>=t.offset&&d<t.offset+t.length||a&&d===t.offset+t.length}function n(t,d,a=!1){if(o(t,d,a)){const g=t.children;if(Array.isArray(g))for(let b=0;b<g.length&&g[b].offset<=d;b++){const p=n(g[b],d,a);if(p)return p}return t}}function i(t,d,a=M.DEFAULT){const g=A(t,!1);function b(Te){return Te?()=>Te(g.getTokenOffset(),g.getTokenLength()):()=>!0}function p(Te){return Te?ae=>Te(ae,g.getTokenOffset(),g.getTokenLength()):()=>!0}const v=b(d.onObjectBegin),y=p(d.onObjectProperty),h=b(d.onObjectEnd),D=b(d.onArrayBegin),S=b(d.onArrayEnd),I=p(d.onLiteralValue),P=p(d.onSeparator),W=b(d.onComment),V=p(d.onError),q=a&&a.disallowComments,N=a&&a.allowTrailingComma;function B(){for(;;){const Te=g.scan();switch(g.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:q||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(Te){case 12:case 13:q?K(10):W();break;case 16:K(1);break;case 15:case 14:break;default:return Te}}}function K(Te,ae=[],Ne=[]){if(V(Te),ae.length+Ne.length>0){let ne=g.getToken();for(;ne!==17;){if(ae.indexOf(ne)!==-1){B();break}else if(Ne.indexOf(ne)!==-1)break;ne=B()}}}function ie(Te){const ae=g.getTokenValue();return Te?I(ae):y(ae),B(),!0}function ce(){switch(g.getToken()){case 11:{let Te=0;try{Te=JSON.parse(g.getTokenValue()),typeof Te!="number"&&(K(2),Te=0)}catch{K(2)}I(Te);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return B(),!0}function ye(){return g.getToken()!==10?(K(3,[],[2,5]),!1):(ie(!1),g.getToken()===6?(P(":"),B(),$e()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function ke(){v(),B();let Te=!1;for(;g.getToken()!==2&&g.getToken()!==17;){if(g.getToken()===5){if(Te||K(4,[],[]),P(","),B(),g.getToken()===2&&N)break}else Te&&K(6,[],[]);ye()||K(4,[],[2,5]),Te=!0}return h(),g.getToken()!==2?K(7,[2],[]):B(),!0}function fe(){D(),B();let Te=!1;for(;g.getToken()!==4&&g.getToken()!==17;){if(g.getToken()===5){if(Te||K(4,[],[]),P(","),B(),g.getToken()===4&&N)break}else Te&&K(6,[],[]);$e()||K(4,[],[4,5]),Te=!0}return S(),g.getToken()!==4?K(8,[4],[]):B(),!0}function $e(){switch(g.getToken()){case 3:return fe();case 1:return ke();case 10:return ie(!0);default:return ce()}}return B(),g.getToken()===17?a.allowEmptyContent?!0:(K(4,[],[]),!1):$e()?(g.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function c(t,d){const a=A(t),g=[];let b,p=0,v;do switch(v=a.getPosition(),b=a.scan(),b){case 12:case 13:case 17:p!==v&&g.push(t.substring(p,v)),d!==void 0&&g.push(a.getTokenValue().replace(/[^\r\n]/g,d)),p=a.getPosition();break}while(b!==17);return g.join("")}function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(le,e){typeof define=="function"&&define.amd?define(Se[127],Pe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(De,pe){for(var ge=0;ge<pe.length;ge++){var Q=pe[ge];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(De,Q.key,Q)}}function C(De,pe,ge){return pe&&e(De.prototype,pe),ge&&e(De,ge),Object.defineProperty(De,"prototype",{writable:!1}),De}function O(De,pe){if(De){if(typeof De=="string")return R(De,pe);var ge=Object.prototype.toString.call(De).slice(8,-1);if(ge==="Object"&&De.constructor&&(ge=De.constructor.name),ge==="Map"||ge==="Set")return Array.from(De);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return R(De,pe)}}function R(De,pe){(pe==null||pe>De.length)&&(pe=De.length);for(var ge=0,Q=new Array(pe);ge<pe;ge++)Q[ge]=De[ge];return Q}function M(De,pe){var ge=typeof Symbol<"u"&&De[Symbol.iterator]||De["@@iterator"];if(ge)return(ge=ge.call(De)).next.bind(ge);if(Array.isArray(De)||(ge=O(De))||pe&&De&&typeof De.length=="number"){ge&&(De=ge);var Q=0;return function(){return Q>=De.length?{done:!0}:{done:!1,value:De[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=A();function $(De){le.defaults=De}var m=/[&<>"']/,E=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(pe){return l[pe]};function f(De,pe){if(pe){if(m.test(De))return De.replace(E,w)}else if(T.test(De))return De.replace(k,w);return De}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(De){return De.replace(s,function(pe,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var o=/(^|[^\[])\^/g;function n(De,pe){De=typeof De=="string"?De:De.source,pe=pe||"";var ge={replace:function(Y,he){return he=he.source||he,he=he.replace(o,"$1"),De=De.replace(Y,he),ge},getRegex:function(){return new RegExp(De,pe)}};return ge}var i=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(De,pe,ge){if(De){var Q;try{Q=decodeURIComponent(r(ge)).replace(i,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}pe&&!c.test(ge)&&(ge=b(pe,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var t={},d=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,g=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(De,pe){t[" "+De]||(d.test(De)?t[" "+De]=De+"/":t[" "+De]=h(De,"/",!0)),De=t[" "+De];var ge=De.indexOf(":")===-1;return pe.substring(0,2)==="//"?ge?pe:De.replace(a,"$1")+pe:pe.charAt(0)==="/"?ge?pe:De.replace(g,"$1")+pe:De+pe}var p={exec:function(){}};function v(De){for(var pe=1,ge,Q;pe<arguments.length;pe++){ge=arguments[pe];for(Q in ge)Object.prototype.hasOwnProperty.call(ge,Q)&&(De[Q]=ge[Q])}return De}function y(De,pe){var ge=De.replace(/\|/g,function(he,ue,Me){for(var de=!1,Ce=ue;--Ce>=0&&Me[Ce]==="\\";)de=!de;return de?"|":" |"}),Q=ge.split(/ \|/),Y=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>pe)Q.splice(pe);else for(;Q.length<pe;)Q.push("");for(;Y<Q.length;Y++)Q[Y]=Q[Y].trim().replace(/\\\|/g,"|");return Q}function h(De,pe,ge){var Q=De.length;if(Q===0)return"";for(var Y=0;Y<Q;){var he=De.charAt(Q-Y-1);if(he===pe&&!ge)Y++;else if(he!==pe&&ge)Y++;else break}return De.slice(0,Q-Y)}function D(De,pe){if(De.indexOf(pe[1])===-1)return-1;for(var ge=De.length,Q=0,Y=0;Y<ge;Y++)if(De[Y]==="\\")Y++;else if(De[Y]===pe[0])Q++;else if(De[Y]===pe[1]&&(Q--,Q<0))return Y;return-1}function S(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(De,pe){if(pe<1)return"";for(var ge="";pe>1;)pe&1&&(ge+=De),pe>>=1,De+=De;return ge+De}function P(De,pe,ge,Q){var Y=pe.href,he=pe.title?f(pe.title):null,ue=De[1].replace(/\\([\[\]])/g,"$1");if(De[0].charAt(0)!=="!"){Q.state.inLink=!0;var Me={type:"link",raw:ge,href:Y,title:he,text:ue,tokens:Q.inlineTokens(ue)};return Q.state.inLink=!1,Me}return{type:"image",raw:ge,href:Y,title:he,text:f(ue)}}function W(De,pe){var ge=De.match(/^(\s+)(?:```)/);if(ge===null)return pe;var Q=ge[1];return pe.split(`
`).map(function(Y){var he=Y.match(/^\s+/);if(he===null)return Y;var ue=he[0];return ue.length>=Q.length?Y.slice(Q.length):Y}).join(`
`)}var V=function(){function De(ge){this.options=ge||le.defaults}var pe=De.prototype;return pe.space=function(Q){var Y=this.rules.block.newline.exec(Q);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},pe.code=function(Q){var Y=this.rules.block.code.exec(Q);if(Y){var he=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?he:h(he,`
`)}}},pe.fences=function(Q){var Y=this.rules.block.fences.exec(Q);if(Y){var he=Y[0],ue=W(he,Y[3]||"");return{type:"code",raw:he,lang:Y[2]?Y[2].trim():Y[2],text:ue}}},pe.heading=function(Q){var Y=this.rules.block.heading.exec(Q);if(Y){var he=Y[2].trim();if(/#$/.test(he)){var ue=h(he,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(he=ue.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:he,tokens:this.lexer.inline(he)}}},pe.hr=function(Q){var Y=this.rules.block.hr.exec(Q);if(Y)return{type:"hr",raw:Y[0]}},pe.blockquote=function(Q){var Y=this.rules.block.blockquote.exec(Q);if(Y){var he=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},pe.list=function(Q){var Y=this.rules.block.list.exec(Q);if(Y){var he,ue,Me,de,Ce,Ae,je,U,F,G,H,ee,re=Y[1].trim(),Oe=re.length>1,Be={type:"list",raw:"",ordered:Oe,start:Oe?+re.slice(0,-1):"",loose:!1,items:[]};re=Oe?"\\d{1,9}\\"+re.slice(-1):"\\"+re,this.options.pedantic&&(re=Oe?re:"[*+-]");for(var He=new RegExp("^( {0,3}"+re+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(ee=!1,!(!(Y=He.exec(Q))||this.rules.block.hr.test(Q)));){if(he=Y[0],Q=Q.substring(he.length),U=Y[2].split(`
`,1)[0],F=Q.split(`
`,1)[0],this.options.pedantic?(de=2,H=U.trimLeft()):(de=Y[2].search(/[^ ]/),de=de>4?1:de,H=U.slice(de),de+=Y[1].length),Ae=!1,!U&&/^ *$/.test(F)&&(he+=F+`
`,Q=Q.substring(F.length+1),ee=!0),!ee)for(var _e=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");Q&&(G=Q.split(`
`,1)[0],U=G,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(U)||tt.test(U)||_e.test(U)||xe.test(Q)));){if(U.search(/[^ ]/)>=de||!U.trim())H+=`
`+U.slice(de);else if(!Ae)H+=`
`+U;else break;!Ae&&!U.trim()&&(Ae=!0),he+=G+`
`,Q=Q.substring(G.length+1)}Be.loose||(je?Be.loose=!0:/\n *\n *$/.test(he)&&(je=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(H),ue&&(Me=ue[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:he,task:!!ue,checked:Me,loose:!1,text:H}),Be.raw+=he}Be.items[Be.items.length-1].raw=he.trimRight(),Be.items[Be.items.length-1].text=H.trimRight(),Be.raw=Be.raw.trimRight();var it=Be.items.length;for(Ce=0;Ce<it;Ce++){this.lexer.state.top=!1,Be.items[Ce].tokens=this.lexer.blockTokens(Be.items[Ce].text,[]);var ct=Be.items[Ce].tokens.filter(function(Ue){return Ue.type==="space"}),gt=ct.every(function(Ue){for(var ot=Ue.raw.split(""),X=0,Z=M(ot),me;!(me=Z()).done;){var Ge=me.value;if(Ge===`
`&&(X+=1),X>1)return!0}return!1});!Be.loose&&ct.length&&gt&&(Be.loose=!0,Be.items[Ce].loose=!0)}return Be}},pe.html=function(Q){var Y=this.rules.block.html.exec(Q);if(Y){var he={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(Y[0]):f(Y[0]);he.type="paragraph",he.text=ue,he.tokens=this.lexer.inline(ue)}return he}},pe.def=function(Q){var Y=this.rules.block.def.exec(Q);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var he=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:Y[0],href:Y[2],title:Y[3]}}},pe.table=function(Q){var Y=this.rules.block.table.exec(Q);if(Y){var he={type:"table",header:y(Y[1]).map(function(je){return{text:je}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=Y[0];var ue=he.align.length,Me,de,Ce,Ae;for(Me=0;Me<ue;Me++)/^ *-+: *$/.test(he.align[Me])?he.align[Me]="right":/^ *:-+: *$/.test(he.align[Me])?he.align[Me]="center":/^ *:-+ *$/.test(he.align[Me])?he.align[Me]="left":he.align[Me]=null;for(ue=he.rows.length,Me=0;Me<ue;Me++)he.rows[Me]=y(he.rows[Me],he.header.length).map(function(je){return{text:je}});for(ue=he.header.length,de=0;de<ue;de++)he.header[de].tokens=this.lexer.inline(he.header[de].text);for(ue=he.rows.length,de=0;de<ue;de++)for(Ae=he.rows[de],Ce=0;Ce<Ae.length;Ce++)Ae[Ce].tokens=this.lexer.inline(Ae[Ce].text);return he}}},pe.lheading=function(Q){var Y=this.rules.block.lheading.exec(Q);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},pe.paragraph=function(Q){var Y=this.rules.block.paragraph.exec(Q);if(Y){var he=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:he,tokens:this.lexer.inline(he)}}},pe.text=function(Q){var Y=this.rules.block.text.exec(Q);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},pe.escape=function(Q){var Y=this.rules.inline.escape.exec(Q);if(Y)return{type:"escape",raw:Y[0],text:f(Y[1])}},pe.tag=function(Q){var Y=this.rules.inline.tag.exec(Q);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):f(Y[0]):Y[0]}},pe.link=function(Q){var Y=this.rules.inline.link.exec(Q);if(Y){var he=Y[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var ue=h(he.slice(0,-1),"\\");if((he.length-ue.length)%2===0)return}else{var Me=D(Y[2],"()");if(Me>-1){var de=Y[0].indexOf("!")===0?5:4,Ce=de+Y[1].length+Me;Y[2]=Y[2].substring(0,Me),Y[0]=Y[0].substring(0,Ce).trim(),Y[3]=""}}var Ae=Y[2],je="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);U&&(Ae=U[1],je=U[3])}else je=Y[3]?Y[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(he)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),P(Y,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},pe.reflink=function(Q,Y){var he;if((he=this.rules.inline.reflink.exec(Q))||(he=this.rules.inline.nolink.exec(Q))){var ue=(he[2]||he[1]).replace(/\s+/g," ");if(ue=Y[ue.toLowerCase()],!ue||!ue.href){var Me=he[0].charAt(0);return{type:"text",raw:Me,text:Me}}return P(he,ue,he[0],this.lexer)}},pe.emStrong=function(Q,Y,he){he===void 0&&(he="");var ue=this.rules.inline.emStrong.lDelim.exec(Q);if(ue&&!(ue[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=ue[1]||ue[2]||"";if(!Me||Me&&(he===""||this.rules.inline.punctuation.exec(he))){var de=ue[0].length-1,Ce,Ae,je=de,U=0,F=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(F.lastIndex=0,Y=Y.slice(-1*Q.length+de);(ue=F.exec(Y))!=null;)if(Ce=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!Ce){if(Ae=Ce.length,ue[3]||ue[4]){je+=Ae;continue}else if((ue[5]||ue[6])&&de%3&&!((de+Ae)%3)){U+=Ae;continue}if(je-=Ae,!(je>0)){if(Ae=Math.min(Ae,Ae+je+U),Math.min(de,Ae)%2){var G=Q.slice(1,de+ue.index+Ae);return{type:"em",raw:Q.slice(0,de+ue.index+Ae+1),text:G,tokens:this.lexer.inlineTokens(G)}}var H=Q.slice(2,de+ue.index+Ae-1);return{type:"strong",raw:Q.slice(0,de+ue.index+Ae+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},pe.codespan=function(Q){var Y=this.rules.inline.code.exec(Q);if(Y){var he=Y[2].replace(/\n/g," "),ue=/[^ ]/.test(he),Me=/^ /.test(he)&&/ $/.test(he);return ue&&Me&&(he=he.substring(1,he.length-1)),he=f(he,!0),{type:"codespan",raw:Y[0],text:he}}},pe.br=function(Q){var Y=this.rules.inline.br.exec(Q);if(Y)return{type:"br",raw:Y[0]}},pe.del=function(Q){var Y=this.rules.inline.del.exec(Q);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},pe.autolink=function(Q,Y){var he=this.rules.inline.autolink.exec(Q);if(he){var ue,Me;return he[2]==="@"?(ue=f(this.options.mangle?Y(he[1]):he[1]),Me="mailto:"+ue):(ue=f(he[1]),Me=ue),{type:"link",raw:he[0],text:ue,href:Me,tokens:[{type:"text",raw:ue,text:ue}]}}},pe.url=function(Q,Y){var he;if(he=this.rules.inline.url.exec(Q)){var ue,Me;if(he[2]==="@")ue=f(this.options.mangle?Y(he[0]):he[0]),Me="mailto:"+ue;else{var de;do de=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(de!==he[0]);ue=f(he[0]),he[1]==="www."?Me="http://"+ue:Me=ue}return{type:"link",raw:he[0],text:ue,href:Me,tokens:[{type:"text",raw:ue,text:ue}]}}},pe.inlineText=function(Q,Y){var he=this.rules.inline.text.exec(Q);if(he){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):f(he[0]):he[0]:ue=f(this.options.smartypants?Y(he[0]):he[0]),{type:"text",raw:he[0],text:ue}}},De}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=n(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=n(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=n(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=n(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=n(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=v({},q),q.gfm=v({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=n(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=v({},q.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:n(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=n(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=n(q._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=n(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=n(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=n(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=n(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=n(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=n(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=n(N.reflink).replace("label",N._label).replace("ref",q._label).getRegex(),N.nolink=n(N.nolink).replace("ref",q._label).getRegex(),N.reflinkSearch=n(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=v({},N),N.pedantic=v({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=v({},N.normal,{escape:n(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=n(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=v({},N.gfm,{br:n(N.br).replace("{2,}","*").getRegex(),text:n(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(De){var pe="",ge,Q,Y=De.length;for(ge=0;ge<Y;ge++)Q=De.charCodeAt(ge),Math.random()>.5&&(Q="x"+Q.toString(16)),pe+="&#"+Q+";";return pe}var ie=function(){function De(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||le.defaults,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:q.normal,inline:N.normal};this.options.pedantic?(Q.block=q.pedantic,Q.inline=N.pedantic):this.options.gfm&&(Q.block=q.gfm,this.options.breaks?Q.inline=N.breaks:Q.inline=N.gfm),this.tokenizer.rules=Q}De.lex=function(Q,Y){var he=new De(Y);return he.lex(Q)},De.lexInline=function(Q,Y){var he=new De(Y);return he.inlineTokens(Q)};var pe=De.prototype;return pe.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},pe.blockTokens=function(Q,Y){var he=this;Y===void 0&&(Y=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(je,U,F){return U+"    ".repeat(F.length)});for(var ue,Me,de,Ce;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(je){return(ue=je.call({lexer:he},Q,Y))?(Q=Q.substring(ue.raw.length),Y.push(ue),!0):!1}))){if(ue=this.tokenizer.space(Q)){Q=Q.substring(ue.raw.length),ue.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(ue);continue}if(ue=this.tokenizer.code(Q)){Q=Q.substring(ue.raw.length),Me=Y[Y.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+ue.raw,Me.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):Y.push(ue);continue}if(ue=this.tokenizer.fences(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.heading(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.hr(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.blockquote(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.list(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.html(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.def(Q)){Q=Q.substring(ue.raw.length),Me=Y[Y.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+ue.raw,Me.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.lheading(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(de=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var je=1/0,U=Q.slice(1),F=void 0;he.options.extensions.startBlock.forEach(function(G){F=G.call({lexer:this},U),typeof F=="number"&&F>=0&&(je=Math.min(je,F))}),je<1/0&&je>=0&&(de=Q.substring(0,je+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(de))){Me=Y[Y.length-1],Ce&&Me.type==="paragraph"?(Me.raw+=`
`+ue.raw,Me.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):Y.push(ue),Ce=de.length!==Q.length,Q=Q.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(Q)){Q=Q.substring(ue.raw.length),Me=Y[Y.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+ue.raw,Me.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):Y.push(ue);continue}if(Q){var Ae="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,Y},pe.inline=function(Q,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:Q,tokens:Y}),Y},pe.inlineTokens=function(Q,Y){var he=this;Y===void 0&&(Y=[]);var ue,Me,de,Ce=Q,Ae,je,U;if(this.tokens.links){var F=Object.keys(this.tokens.links);if(F.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)F.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Ae.index)+"["+I("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"["+I("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(je||(U=""),je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(ue=H.call({lexer:he},Q,Y))?(Q=Q.substring(ue.raw.length),Y.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.tag(Q)){Q=Q.substring(ue.raw.length),Me=Y[Y.length-1],Me&&ue.type==="text"&&Me.type==="text"?(Me.raw+=ue.raw,Me.text+=ue.text):Y.push(ue);continue}if(ue=this.tokenizer.link(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(ue.raw.length),Me=Y[Y.length-1],Me&&ue.type==="text"&&Me.type==="text"?(Me.raw+=ue.raw,Me.text+=ue.text):Y.push(ue);continue}if(ue=this.tokenizer.emStrong(Q,Ce,U)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.codespan(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.br(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.del(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.autolink(Q,K)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(Q,K))){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(de=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ee=Q.slice(1),re=void 0;he.options.extensions.startInline.forEach(function(Oe){re=Oe.call({lexer:this},ee),typeof re=="number"&&re>=0&&(H=Math.min(H,re))}),H<1/0&&H>=0&&(de=Q.substring(0,H+1))}(),ue=this.tokenizer.inlineText(de,B)){Q=Q.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(U=ue.raw.slice(-1)),je=!0,Me=Y[Y.length-1],Me&&Me.type==="text"?(Me.raw+=ue.raw,Me.text+=ue.text):Y.push(ue);continue}if(Q){var G="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return Y},C(De,null,[{key:"rules",get:function(){return{block:q,inline:N}}}]),De}(),ce=function(){function De(ge){this.options=ge||le.defaults}var pe=De.prototype;return pe.code=function(Q,Y,he){var ue=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(Q,ue);Me!=null&&Me!==Q&&(he=!0,Q=Me)}return Q=Q.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+f(ue,!0)+'">'+(he?Q:f(Q,!0))+`</code></pre>
`:"<pre><code>"+(he?Q:f(Q,!0))+`</code></pre>
`},pe.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},pe.html=function(Q){return Q},pe.heading=function(Q,Y,he,ue){if(this.options.headerIds){var Me=this.options.headerPrefix+ue.slug(he);return"<h"+Y+' id="'+Me+'">'+Q+"</h"+Y+`>
`}return"<h"+Y+">"+Q+"</h"+Y+`>
`},pe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},pe.list=function(Q,Y,he){var ue=Y?"ol":"ul",Me=Y&&he!==1?' start="'+he+'"':"";return"<"+ue+Me+`>
`+Q+"</"+ue+`>
`},pe.listitem=function(Q){return"<li>"+Q+`</li>
`},pe.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},pe.paragraph=function(Q){return"<p>"+Q+`</p>
`},pe.table=function(Q,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+Y+`</table>
`},pe.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},pe.tablecell=function(Q,Y){var he=Y.header?"th":"td",ue=Y.align?"<"+he+' align="'+Y.align+'">':"<"+he+">";return ue+Q+("</"+he+`>
`)},pe.strong=function(Q){return"<strong>"+Q+"</strong>"},pe.em=function(Q){return"<em>"+Q+"</em>"},pe.codespan=function(Q){return"<code>"+Q+"</code>"},pe.br=function(){return this.options.xhtml?"<br/>":"<br>"},pe.del=function(Q){return"<del>"+Q+"</del>"},pe.link=function(Q,Y,he){if(Q=u(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var ue='<a href="'+f(Q)+'"';return Y&&(ue+=' title="'+Y+'"'),ue+=">"+he+"</a>",ue},pe.image=function(Q,Y,he){if(Q=u(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var ue='<img src="'+Q+'" alt="'+he+'"';return Y&&(ue+=' title="'+Y+'"'),ue+=this.options.xhtml?"/>":">",ue},pe.text=function(Q){return Q},De}(),ye=function(){function De(){}var pe=De.prototype;return pe.strong=function(Q){return Q},pe.em=function(Q){return Q},pe.codespan=function(Q){return Q},pe.del=function(Q){return Q},pe.html=function(Q){return Q},pe.text=function(Q){return Q},pe.link=function(Q,Y,he){return""+he},pe.image=function(Q,Y,he){return""+he},pe.br=function(){return""},De}(),ke=function(){function De(){this.seen={}}var pe=De.prototype;return pe.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},pe.getNextSafeSlug=function(Q,Y){var he=Q,ue=0;if(this.seen.hasOwnProperty(he)){ue=this.seen[Q];do ue++,he=Q+"-"+ue;while(this.seen.hasOwnProperty(he))}return Y||(this.seen[Q]=ue,this.seen[he]=0),he},pe.slug=function(Q,Y){Y===void 0&&(Y={});var he=this.serialize(Q);return this.getNextSafeSlug(he,Y.dryrun)},De}(),fe=function(){function De(ge){this.options=ge||le.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new ke}De.parse=function(Q,Y){var he=new De(Y);return he.parse(Q)},De.parseInline=function(Q,Y){var he=new De(Y);return he.parseInline(Q)};var pe=De.prototype;return pe.parse=function(Q,Y){Y===void 0&&(Y=!0);var he="",ue,Me,de,Ce,Ae,je,U,F,G,H,ee,re,Oe,Be,He,_e,xe,et,tt,it=Q.length;for(ue=0;ue<it;ue++){if(H=Q[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(tt=this.options.extensions.renderers[H.type].call({parser:this},H),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){he+=tt||"";continue}switch(H.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(H.tokens),H.depth,r(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(F="",U="",Ce=H.header.length,Me=0;Me<Ce;Me++)U+=this.renderer.tablecell(this.parseInline(H.header[Me].tokens),{header:!0,align:H.align[Me]});for(F+=this.renderer.tablerow(U),G="",Ce=H.rows.length,Me=0;Me<Ce;Me++){for(je=H.rows[Me],U="",Ae=je.length,de=0;de<Ae;de++)U+=this.renderer.tablecell(this.parseInline(je[de].tokens),{header:!1,align:H.align[de]});G+=this.renderer.tablerow(U)}he+=this.renderer.table(F,G);continue}case"blockquote":{G=this.parse(H.tokens),he+=this.renderer.blockquote(G);continue}case"list":{for(ee=H.ordered,re=H.start,Oe=H.loose,Ce=H.items.length,G="",Me=0;Me<Ce;Me++)He=H.items[Me],_e=He.checked,xe=He.task,Be="",He.task&&(et=this.renderer.checkbox(_e),Oe?He.tokens.length>0&&He.tokens[0].type==="paragraph"?(He.tokens[0].text=et+" "+He.tokens[0].text,He.tokens[0].tokens&&He.tokens[0].tokens.length>0&&He.tokens[0].tokens[0].type==="text"&&(He.tokens[0].tokens[0].text=et+" "+He.tokens[0].tokens[0].text)):He.tokens.unshift({type:"text",text:et}):Be+=et),Be+=this.parse(He.tokens,Oe),G+=this.renderer.listitem(Be,xe,_e);he+=this.renderer.list(G,ee,re);continue}case"html":{he+=this.renderer.html(H.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(G=H.tokens?this.parseInline(H.tokens):H.text;ue+1<it&&Q[ue+1].type==="text";)H=Q[++ue],G+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);he+=Y?this.renderer.paragraph(G):G;continue}default:{var ct='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(ct);return}else throw new Error(ct)}}}return he},pe.parseInline=function(Q,Y){Y=Y||this.renderer;var he="",ue,Me,de,Ce=Q.length;for(ue=0;ue<Ce;ue++){if(Me=Q[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(de=this.options.extensions.renderers[Me.type].call({parser:this},Me),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){he+=de||"";continue}switch(Me.type){case"escape":{he+=Y.text(Me.text);break}case"html":{he+=Y.html(Me.text);break}case"link":{he+=Y.link(Me.href,Me.title,this.parseInline(Me.tokens,Y));break}case"image":{he+=Y.image(Me.href,Me.title,Me.text);break}case"strong":{he+=Y.strong(this.parseInline(Me.tokens,Y));break}case"em":{he+=Y.em(this.parseInline(Me.tokens,Y));break}case"codespan":{he+=Y.codespan(Me.text);break}case"br":{he+=Y.br();break}case"del":{he+=Y.del(this.parseInline(Me.tokens,Y));break}case"text":{he+=Y.text(Me.text);break}default:{var Ae='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return he},De}();function $e(De,pe,ge){if(typeof De>"u"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof pe=="function"&&(ge=pe,pe=null),pe=v({},$e.defaults,pe||{}),S(pe),ge){var Q=pe.highlight,Y;try{Y=ie.lex(De,pe)}catch(Ce){return ge(Ce)}var he=function(Ae){var je;if(!Ae)try{pe.walkTokens&&$e.walkTokens(Y,pe.walkTokens),je=fe.parse(Y,pe)}catch(U){Ae=U}return pe.highlight=Q,Ae?ge(Ae):ge(null,je)};if(!Q||Q.length<3||(delete pe.highlight,!Y.length))return he();var ue=0;$e.walkTokens(Y,function(Ce){Ce.type==="code"&&(ue++,setTimeout(function(){Q(Ce.text,Ce.lang,function(Ae,je){if(Ae)return he(Ae);je!=null&&je!==Ce.text&&(Ce.text=je,Ce.escaped=!0),ue--,ue===0&&he()})},0))}),ue===0&&he();return}function Me(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+f(Ce.message+"",!0)+"</pre>";throw Ce}try{var de=ie.lex(De,pe);if(pe.walkTokens){if(pe.async)return Promise.all($e.walkTokens(de,pe.walkTokens)).then(function(){return fe.parse(de,pe)}).catch(Me);$e.walkTokens(de,pe.walkTokens)}return fe.parse(de,pe)}catch(Ce){Me(Ce)}}$e.options=$e.setOptions=function(De){return v($e.defaults,De),$($e.defaults),$e},$e.getDefaults=A,$e.defaults=le.defaults,$e.use=function(){for(var De=arguments.length,pe=new Array(De),ge=0;ge<De;ge++)pe[ge]=arguments[ge];var Q=v.apply(void 0,[{}].concat(pe)),Y=$e.defaults.extensions||{renderers:{},childTokens:{}},he;pe.forEach(function(ue){if(ue.extensions&&(he=!0,ue.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var Ce=Y.renderers?Y.renderers[de.name]:null;Ce?Y.renderers[de.name]=function(){for(var Ae=arguments.length,je=new Array(Ae),U=0;U<Ae;U++)je[U]=arguments[U];var F=de.renderer.apply(this,je);return F===!1&&(F=Ce.apply(this,je)),F}:Y.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[de.level]?Y[de.level].unshift(de.tokenizer):Y[de.level]=[de.tokenizer],de.start&&(de.level==="block"?Y.startBlock?Y.startBlock.push(de.start):Y.startBlock=[de.start]:de.level==="inline"&&(Y.startInline?Y.startInline.push(de.start):Y.startInline=[de.start]))}de.childTokens&&(Y.childTokens[de.name]=de.childTokens)})),ue.renderer&&function(){var de=$e.defaults.renderer||new ce,Ce=function(U){var F=de[U];de[U]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var re=ue.renderer[U].apply(de,H);return re===!1&&(re=F.apply(de,H)),re}};for(var Ae in ue.renderer)Ce(Ae);Q.renderer=de}(),ue.tokenizer&&function(){var de=$e.defaults.tokenizer||new V,Ce=function(U){var F=de[U];de[U]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var re=ue.tokenizer[U].apply(de,H);return re===!1&&(re=F.apply(de,H)),re}};for(var Ae in ue.tokenizer)Ce(Ae);Q.tokenizer=de}(),ue.walkTokens){var Me=$e.defaults.walkTokens;Q.walkTokens=function(de){var Ce=[];return Ce.push(ue.walkTokens.call(this,de)),Me&&(Ce=Ce.concat(Me.call(this,de))),Ce}}he&&(Q.extensions=Y),$e.setOptions(Q)})},$e.walkTokens=function(De,pe){for(var ge=[],Q=function(){var Me=he.value;switch(ge=ge.concat(pe.call($e,Me)),Me.type){case"table":{for(var de=M(Me.header),Ce;!(Ce=de()).done;){var Ae=Ce.value;ge=ge.concat($e.walkTokens(Ae.tokens,pe))}for(var je=M(Me.rows),U;!(U=je()).done;)for(var F=U.value,G=M(F),H;!(H=G()).done;){var ee=H.value;ge=ge.concat($e.walkTokens(ee.tokens,pe))}break}case"list":{ge=ge.concat($e.walkTokens(Me.items,pe));break}default:$e.defaults.extensions&&$e.defaults.extensions.childTokens&&$e.defaults.extensions.childTokens[Me.type]?$e.defaults.extensions.childTokens[Me.type].forEach(function(re){ge=ge.concat($e.walkTokens(Me[re],pe))}):Me.tokens&&(ge=ge.concat($e.walkTokens(Me.tokens,pe)))}},Y=M(De),he;!(he=Y()).done;)Q();return ge},$e.parseInline=function(De,pe){if(typeof De>"u"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");pe=v({},$e.defaults,pe||{}),S(pe);try{var ge=ie.lexInline(De,pe);return pe.walkTokens&&$e.walkTokens(ge,pe.walkTokens),fe.parseInline(ge,pe)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+f(Q.message+"",!0)+"</pre>";throw Q}},$e.Parser=fe,$e.parser=fe.parse,$e.Renderer=ce,$e.TextRenderer=ye,$e.Lexer=ie,$e.lexer=ie.lex,$e.Tokenizer=V,$e.Slugger=ke,$e.parse=$e;var Te=$e.options,ae=$e.setOptions,Ne=$e.use,ne=$e.walkTokens,z=$e.parseInline,x=$e,be=fe.parse,Fe=ie.lex;le.Lexer=ie,le.Parser=fe,le.Renderer=ce,le.Slugger=ke,le.TextRenderer=ye,le.Tokenizer=V,le.getDefaults=A,le.lexer=Fe,le.marked=$e,le.options=Te,le.parse=x,le.parseInline=z,le.parser=be,le.setOptions=ae,le.use=Ne,le.walkTokens=ne,Object.defineProperty(le,"__esModule",{value:!0})}),define(Se[128],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=C;function C(s){const r=M(s);if(r&&r.length>0)return new Uint32Array(r)}let O=0;const R=new Uint32Array(10);function M(s){if(O=0,A(s,k,4352),O>0||(A(s,l,4449),O>0)||(A(s,w,4520),O>0)||(A(s,f,12593),O))return R.subarray(0,O);if(s>=44032&&s<=55203){const r=s-44032,o=r%588,n=Math.floor(r/588),i=Math.floor(o/28),c=o%28-1;if(n<k.length?A(n,k,0):4352+n-12593<f.length&&A(4352+n,f,12593),i<l.length?A(i,l,0):4449+i-12593<f.length&&A(4449+i-12593,f,12593),c>=0&&(c<w.length?A(c,w,0):4520+c-12593<f.length&&A(4520+c-12593,f,12593)),O>0)return R.subarray(0,O)}}function A(s,r,o){s>=o&&s<o+r.length&&$(r[s-o])}function $(s){s!==0&&(R[O++]=s&255,s>>8&&(R[O++]=s>>8&255),s>>16&&(R[O++]=s>>16&255))}var m;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var E;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(E||(E={}));var T;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(T||(T={}));const k=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),w=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),f=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Se[129],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=void 0,e.$Bm=C,e.rot=O;function C($,m,E){return Math.min(Math.max($,m),E)}function O($,m){return(m+$%m)%m}class R{constructor(){this.a=0}getNext(){return this.a++}}e.$Dm=R;class M{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Em=M;class A{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const E=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Fm=A}),define(Se[130],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=M,e.$cd=l;class C{constructor(f,s,r){this.owner=f,this.debugNameSource=s,this.referenceFn=r}getDebugName(f){return M(f,this)}}e.$ad=C;const O=new Map,R=new WeakMap;function M(w,f){const s=R.get(w);if(s)return s;const r=A(w,f);if(r){let o=O.get(r)??0;o++,O.set(r,o);const n=o===1?r:`${r}#${o}`;return R.set(w,n),n}}function A(w,f){const s=R.get(w);if(s)return s;const r=f.owner?T(f.owner)+".":"";let o;const n=f.debugNameSource;if(n!==void 0)if(typeof n=="function"){if(o=n(),o!==void 0)return r+o}else return r+n;const i=f.referenceFn;if(i!==void 0&&(o=l(i),o!==void 0))return r+o;if(f.owner!==void 0){const c=$(f.owner,w);if(c!==void 0)return r+c}}function $(w,f){for(const s in w)if(w[s]===f)return s}const m=new Map,E=new WeakMap;function T(w){const f=E.get(w);if(f)return f;const s=k(w);let r=m.get(s)??0;r++,m.set(s,r);const o=r===1?s:`${s}#${r}`;return E.set(w,o),o}function k(w){const f=w.constructor;return f?f.name:"Object"}function l(w){const f=w.toString(),r=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(f);return(r?r[1]:void 0)?.trim()}}),define(Se[131],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=O,e.$Id=R;let C;function O(s){C=s}function R(){return C}class M{constructor(){this.a=0,this.d=new WeakMap}b(r){return A([$(w("|  ",this.a)),r])}c(r){return r.hadValue?r.didChange?[$(" "),E(T(r.oldValue,70),{color:"red",strikeThrough:!0}),$(" "),E(T(r.newValue,60),{color:"green"})]:[$(" (unchanged)")]:[$(" "),E(T(r.newValue,60),{color:"green"}),$(" (initial)")]}handleObservableChanged(r,o){console.log(...this.b([m("observable value changed"),E(r.debugName,{color:"BlueViolet"}),...this.c(o)]))}formatChanges(r){if(r.size!==0)return E(" (changed deps: "+[...r].map(o=>o.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const o=r.handleChange;this.d.set(r,new Set),r.handleChange=(n,i)=>(this.d.get(r).add(n),o.apply(r,[n,i]))}handleDerivedRecomputed(r,o){const n=this.d.get(r);console.log(...this.b([m("derived recomputed"),E(r.debugName,{color:"BlueViolet"}),...this.c(o),this.formatChanges(n),{data:[{fn:r._computeFn}]}])),n.clear()}handleFromEventObservableTriggered(r,o){console.log(...this.b([m("observable from event triggered"),E(r.debugName,{color:"BlueViolet"}),...this.c(o),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const o=r.handleChange;this.d.set(r,new Set),r.handleChange=(n,i)=>(this.d.get(r).add(n),o.apply(r,[n,i]))}handleAutorunTriggered(r){const o=this.d.get(r);console.log(...this.b([m("autorun"),E(r.debugName,{color:"BlueViolet"}),this.formatChanges(o),{data:[{fn:r._runFn}]}])),o.clear(),this.a++}handleAutorunFinished(r){this.a--}handleBeginTransaction(r){let o=r.getDebugName();o===void 0&&(o=""),console.log(...this.b([m("transaction"),E(o,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=M;function A(s){const r=new Array,o=[];let n="";function i(u){if("length"in u)for(const t of u)t&&i(t);else"text"in u?(n+=`%c${u.text}`,r.push(u.style),u.data&&o.push(...u.data)):"data"in u&&o.push(...u.data)}i(s);const c=[n,...r];return c.push(...o),c}function $(s){return E(s,{color:"black"})}function m(s){return E(f(`${s}: `,10),{color:"black",bold:!0})}function E(s,r={color:"black"}){function o(i){return Object.entries(i).reduce((c,[u,t])=>`${c}${u}:${t};`,"")}const n={color:r.color};return r.strikeThrough&&(n["text-decoration"]="line-through"),r.bold&&(n["font-weight"]="bold"),{text:s,style:o(n)}}function T(s,r){switch(typeof s){case"number":return""+s;case"string":return s.length+2<=r?`"${s}"`:`"${s.substr(0,r-7)}"+...`;case"boolean":return s?"true":"false";case"undefined":return"undefined";case"object":return s===null?"null":Array.isArray(s)?k(s,r):l(s,r);case"symbol":return s.toString();case"function":return`[[Function${s.name?" "+s.name:""}]]`;default:return""+s}}function k(s,r){let o="[ ",n=!0;for(const i of s){if(n||(o+=", "),o.length-5>r){o+="...";break}n=!1,o+=`${T(i,r-o.length)}`}return o+=" ]",o}function l(s,r){let o="{ ",n=!0;for(const[i,c]of Object.entries(s)){if(n||(o+=", "),o.length-5>r){o+="...";break}n=!1,o+=`${i}: ${T(c,r-o.length)}`}return o+=" }",o}function w(s,r){let o="";for(let n=1;n<=r;n++)o+=s;return o}function f(s,r){for(;s.length<r;)s+=" ";return s}}),define(Se[132],Pe([1,0,125,130,131]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5d=e.$3d=e.$Zd=e.$Ud=e.$Td=void 0,e.$Qd=A,e.$Rd=m,e.$Sd=T,e.$Vd=w,e.$Wd=s,e.$Xd=r,e.$Yd=o,e.$1d=i,e.$2d=c,e.$4d=t;let M;function A(a){M=a}let $;function m(a){$=a}let E;function T(a){E=a}class k{get TChange(){return null}reportChanges(){this.get()}read(g){return g?g.readObservable(this):this.get()}map(g,b){const p=b===void 0?void 0:g,v=b===void 0?g:b;return E({owner:p,debugName:()=>{const y=(0,O.$cd)(v);if(y!==void 0)return y;const D=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(v.toString());if(D)return`${this.debugName}.${D[2]}`;if(!p)return`${this.debugName} (mapped)`},debugReferenceFn:v},y=>v(this.read(y),y))}recomputeInitiallyAndOnChange(g,b){return g.add(M(this,b)),this}keepObserved(g){return g.add($(this)),this}get a(){return this.get()}}e.$Td=k;class l extends k{constructor(){super(...arguments),this.b=new Set}addObserver(g){const b=this.b.size;this.b.add(g),b===0&&this.c()}removeObserver(g){this.b.delete(g)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Ud=l;function w(a,g){const b=new n(a,g);try{a(b)}finally{b.finish()}}let f;function s(a){if(f)a(f);else{const g=new n(a,void 0);f=g;try{a(g)}finally{g.finish(),f=void 0}}}async function r(a,g){const b=new n(a,g);try{await a(b)}finally{b.finish()}}function o(a,g,b){a?g(a):w(g,b)}class n{constructor(g,b){this._fn=g,this.b=b,this.a=[],(0,R.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,O.$cd)(this._fn)}updateObserver(g,b){this.a.push({observer:g,observable:b}),g.beginUpdate(b)}finish(){const g=this.a;for(let b=0;b<g.length;b++){const{observer:p,observable:v}=g[b];p.endUpdate(v)}this.a=null,(0,R.$Id)()?.handleEndTransaction()}}e.$Zd=n;function i(a,g){let b;return typeof a=="string"?b=new O.$ad(void 0,a,void 0):b=new O.$ad(a,void 0,void 0),new u(b,g,C.$6c)}function c(a,g){return new u(new O.$ad(a.owner,a.debugName,void 0),g,a.equalsFn??C.$6c)}class u extends l{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(g,b,p){super(),this.e=g,this.g=p,this.d=b}get(){return this.d}set(g,b,p){if(this.g(this.d,g))return;let v;b||(b=v=new n(()=>{},()=>`Setting ${this.debugName}`));try{const y=this.d;this.h(g),(0,R.$Id)()?.handleObservableChanged(this,{oldValue:y,newValue:g,change:p,didChange:!0,hadValue:!0});for(const h of this.b)b.updateObserver(h,this),h.handleChange(this,p)}finally{v&&v.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(g){this.d=g}}e.$3d=u;function t(a,g){let b;return typeof a=="string"?b=new O.$ad(void 0,a,void 0):b=new O.$ad(a,void 0,void 0),new d(b,g,C.$6c)}class d extends u{h(g){this.d!==g&&(this.d&&this.d.dispose(),this.d=g)}dispose(){this.d?.dispose()}}e.$5d=d}),function(){function le(R){const M=[];typeof R=="number"&&M.push("code/timeOrigin",R);function A(m){M.push(m,Date.now())}function $(){const m=[];for(let E=0;E<M.length;E+=2)m.push({name:M[E],startTime:M[E+1]});return m}return{mark:A,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const A of performance.getEntriesByType("mark"))M.push({name:A.name,startTime:Math.round(R+A.startTime)});return M}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function C(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=C(O))}(),define(Se[133],Pe([1,0,42]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oP=void 0;const O=Symbol("unset");class R{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||C.Iterable.empty()}insert(m,E,T){this.d(m,k=>k._value=E,T)}mutate(m,E){this.d(m,T=>T._value=E(T._value===O?void 0:T._value))}delete(m){const E=this.c(m);if(!E)return;let T=E.length-1;const k=E[T].node._value;if(k!==O){for(this.b--,E[T].node._value=O;T>0;T--){const{node:l,part:w}=E[T];if(l.children?.size||l._value!==O)break;E[T-1].node.children.delete(w)}return k}}*deleteRecursive(m){const E=this.c(m);if(!E)return;const T=E[E.length-1].node;for(let k=E.length-1;k>0;k--){const l=E[k-1];if(l.node.children.delete(E[k].part),l.node.children.size>0||l.node._value!==O)break}for(const k of M(T))k._value!==O&&(this.b--,yield k._value)}find(m){let E=this.a;for(const T of m){const k=E.children?.get(T);if(!k)return;E=k}return E._value===O?void 0:E._value}hasKeyOrParent(m){let E=this.a;for(const T of m){const k=E.children?.get(T);if(!k)return!1;if(k._value!==O)return!0;E=k}return!1}hasKeyOrChildren(m){let E=this.a;for(const T of m){const k=E.children?.get(T);if(!k)return!1;E=k}return!0}hasKey(m){let E=this.a;for(const T of m){const k=E.children?.get(T);if(!k)return!1;E=k}return E._value!==O}c(m){const E=[{part:"",node:this.a}];let T=0;for(const k of m){const l=E[T].node.children?.get(k);if(!l)return;E.push({part:k,node:l}),T++}return E}d(m,E,T){let k=this.a;for(const f of m){if(k.children)if(k.children.has(f))k=k.children.get(f);else{const s=new A;k.children.set(f,s),k=s}else{const s=new A;k.children=new Map([[f,s]]),k=s}T?.(k)}const l=k._value===O?0:1;E(k);const w=k._value===O?0:1;this.b+=w-l}*values(){for(const{_value:m}of M(this.a))m!==O&&(yield m)}}e.$oP=R;function*M($){const m=[$];for(;m.length>0;){const E=m.pop();if(yield E,E.children)for(const T of E.children.values())m.push(T)}}class A{constructor(){this._value=O}get value(){return this._value===O?void 0:this._value}set value(m){this._value=m===void 0?O:m}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var O in C)(typeof exports=="object"?exports:le)[O]=C[O]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function C(O){if(e[O])return e[O].exports;var R=e[O]={i:O,l:!1,exports:{}};return le[O].call(R.exports,R,R.exports,C),R.l=!0,R.exports}return C.m=le,C.c=e,C.d=function(O,R,M){C.o(O,R)||Object.defineProperty(O,R,{enumerable:!0,get:M})},C.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},C.t=function(O,R){if(1&R&&(O=C(O)),8&R||4&R&&typeof O=="object"&&O&&O.__esModule)return O;var M=Object.create(null);if(C.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:O}),2&R&&typeof O!="string")for(var A in O)C.d(M,A,function($){return O[$]}.bind(null,A));return M},C.n=function(O){var R=O&&O.__esModule?function(){return O.default}:function(){return O};return C.d(R,"a",R),R},C.o=function(O,R){return Object.prototype.hasOwnProperty.call(O,R)},C.p="",C(C.s=0)}([function(le,e,C){(function(O){var R;e=le.exports=Ne,R=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],m=e.src=[],E=0,T=E++;m[T]="0|[1-9]\\d*";var k=E++;m[k]="[0-9]+";var l=E++;m[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=E++;m[w]="("+m[T]+")\\.("+m[T]+")\\.("+m[T]+")";var f=E++;m[f]="("+m[k]+")\\.("+m[k]+")\\.("+m[k]+")";var s=E++;m[s]="(?:"+m[T]+"|"+m[l]+")";var r=E++;m[r]="(?:"+m[k]+"|"+m[l]+")";var o=E++;m[o]="(?:-("+m[s]+"(?:\\."+m[s]+")*))";var n=E++;m[n]="(?:-?("+m[r]+"(?:\\."+m[r]+")*))";var i=E++;m[i]="[0-9A-Za-z-]+";var c=E++;m[c]="(?:\\+("+m[i]+"(?:\\."+m[i]+")*))";var u=E++,t="v?"+m[w]+m[o]+"?"+m[c]+"?";m[u]="^"+t+"$";var d="[v=\\s]*"+m[f]+m[n]+"?"+m[c]+"?",a=E++;m[a]="^"+d+"$";var g=E++;m[g]="((?:<|>)?=?)";var b=E++;m[b]=m[k]+"|x|X|\\*";var p=E++;m[p]=m[T]+"|x|X|\\*";var v=E++;m[v]="[v=\\s]*("+m[p]+")(?:\\.("+m[p]+")(?:\\.("+m[p]+")(?:"+m[o]+")?"+m[c]+"?)?)?";var y=E++;m[y]="[v=\\s]*("+m[b]+")(?:\\.("+m[b]+")(?:\\.("+m[b]+")(?:"+m[n]+")?"+m[c]+"?)?)?";var h=E++;m[h]="^"+m[g]+"\\s*"+m[v]+"$";var D=E++;m[D]="^"+m[g]+"\\s*"+m[y]+"$";var S=E++;m[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=E++;m[I]="(?:~>?)";var P=E++;m[P]="(\\s*)"+m[I]+"\\s+",$[P]=new RegExp(m[P],"g");var W=E++;m[W]="^"+m[I]+m[v]+"$";var V=E++;m[V]="^"+m[I]+m[y]+"$";var q=E++;m[q]="(?:\\^)";var N=E++;m[N]="(\\s*)"+m[q]+"\\s+",$[N]=new RegExp(m[N],"g");var B=E++;m[B]="^"+m[q]+m[v]+"$";var K=E++;m[K]="^"+m[q]+m[y]+"$";var ie=E++;m[ie]="^"+m[g]+"\\s*("+d+")$|^$";var ce=E++;m[ce]="^"+m[g]+"\\s*("+t+")$|^$";var ye=E++;m[ye]="(\\s*)"+m[g]+"\\s*("+d+"|"+m[v]+")",$[ye]=new RegExp(m[ye],"g");var ke=E++;m[ke]="^\\s*("+m[v]+")\\s+-\\s+("+m[v]+")\\s*$";var fe=E++;m[fe]="^\\s*("+m[y]+")\\s+-\\s+("+m[y]+")\\s*$";var $e=E++;m[$e]="(<|>)?=?\\s*\\*";for(var Te=0;Te<35;Te++)R(Te,m[Te]),$[Te]||($[Te]=new RegExp(m[Te]));function ae(F,G){if(F instanceof Ne)return F;if(typeof F!="string"||F.length>M||!(G?$[a]:$[u]).test(F))return null;try{return new Ne(F,G)}catch{return null}}function Ne(F,G){if(F instanceof Ne){if(F.loose===G)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof Ne))return new Ne(F,G);R("SemVer",F,G),this.loose=G;var H=F.trim().match(G?$[a]:$[u]);if(!H)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var re=+ee;if(re>=0&&re<A)return re}return ee}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=ae,e.valid=function(F,G){var H=ae(F,G);return H?H.version:null},e.clean=function(F,G){var H=ae(F.trim().replace(/^[=v]+/,""),G);return H?H.version:null},e.SemVer=Ne,Ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ne.prototype.toString=function(){return this.version},Ne.prototype.compare=function(F){return R("SemVer.compare",this.version,this.loose,F),F instanceof Ne||(F=new Ne(F,this.loose)),this.compareMain(F)||this.comparePre(F)},Ne.prototype.compareMain=function(F){return F instanceof Ne||(F=new Ne(F,this.loose)),z(this.major,F.major)||z(this.minor,F.minor)||z(this.patch,F.patch)},Ne.prototype.comparePre=function(F){if(F instanceof Ne||(F=new Ne(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var G=0;do{var H=this.prerelease[G],ee=F.prerelease[G];if(R("prerelease compare",G,H,ee),H===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(H===void 0)return-1;if(H!==ee)return z(H,ee)}while(++G)},Ne.prototype.inc=function(F,G){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},e.inc=function(F,G,H,ee){typeof H=="string"&&(ee=H,H=void 0);try{return new Ne(F,H).inc(G,ee).version}catch{return null}},e.diff=function(F,G){if(De(F,G))return null;var H=ae(F),ee=ae(G);if(H.prerelease.length||ee.prerelease.length){for(var re in H)if((re==="major"||re==="minor"||re==="patch")&&H[re]!==ee[re])return"pre"+re;return"prerelease"}for(var re in H)if((re==="major"||re==="minor"||re==="patch")&&H[re]!==ee[re])return re},e.compareIdentifiers=z;var ne=/^[0-9]+$/;function z(F,G){var H=ne.test(F),ee=ne.test(G);return H&&ee&&(F=+F,G=+G),H&&!ee?-1:ee&&!H?1:F<G?-1:F>G?1:0}function x(F,G,H){return new Ne(F,H).compare(new Ne(G,H))}function be(F,G,H){return x(F,G,H)>0}function Fe(F,G,H){return x(F,G,H)<0}function De(F,G,H){return x(F,G,H)===0}function pe(F,G,H){return x(F,G,H)!==0}function ge(F,G,H){return x(F,G,H)>=0}function Q(F,G,H){return x(F,G,H)<=0}function Y(F,G,H,ee){var re;switch(G){case"===":typeof F=="object"&&(F=F.version),typeof H=="object"&&(H=H.version),re=F===H;break;case"!==":typeof F=="object"&&(F=F.version),typeof H=="object"&&(H=H.version),re=F!==H;break;case"":case"=":case"==":re=De(F,H,ee);break;case"!=":re=pe(F,H,ee);break;case">":re=be(F,H,ee);break;case">=":re=ge(F,H,ee);break;case"<":re=Fe(F,H,ee);break;case"<=":re=Q(F,H,ee);break;default:throw new TypeError("Invalid operator: "+G)}return re}function he(F,G){if(F instanceof he){if(F.loose===G)return F;F=F.value}if(!(this instanceof he))return new he(F,G);R("comparator",F,G),this.loose=G,this.parse(F),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(F,G){return z(G,F)},e.major=function(F,G){return new Ne(F,G).major},e.minor=function(F,G){return new Ne(F,G).minor},e.patch=function(F,G){return new Ne(F,G).patch},e.compare=x,e.compareLoose=function(F,G){return x(F,G,!0)},e.rcompare=function(F,G,H){return x(G,F,H)},e.sort=function(F,G){return F.sort(function(H,ee){return e.compare(H,ee,G)})},e.rsort=function(F,G){return F.sort(function(H,ee){return e.rcompare(H,ee,G)})},e.gt=be,e.lt=Fe,e.eq=De,e.neq=pe,e.gte=ge,e.lte=Q,e.cmp=Y,e.Comparator=he;var ue={};function Me(F,G){if(F instanceof Me)return F.loose===G?F:new Me(F.raw,G);if(F instanceof he)return new Me(F.value,G);if(!(this instanceof Me))return new Me(F,G);if(this.loose=G,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function de(F){return!F||F.toLowerCase()==="x"||F==="*"}function Ce(F,G,H,ee,re,Oe,Be,He,_e,xe,et,tt,it){return((G=de(H)?"":de(ee)?">="+H+".0.0":de(re)?">="+H+"."+ee+".0":">="+G)+" "+(He=de(_e)?"":de(xe)?"<"+(+_e+1)+".0.0":de(et)?"<"+_e+"."+(+xe+1)+".0":tt?"<="+_e+"."+xe+"."+et+"-"+tt:"<="+He)).trim()}function Ae(F,G){for(var H=0;H<F.length;H++)if(!F[H].test(G))return!1;if(G.prerelease.length){for(H=0;H<F.length;H++)if(R(F[H].semver),F[H].semver!==ue&&F[H].semver.prerelease.length>0){var ee=F[H].semver;if(ee.major===G.major&&ee.minor===G.minor&&ee.patch===G.patch)return!0}return!1}return!0}function je(F,G,H){try{G=new Me(G,H)}catch{return!1}return G.test(F)}function U(F,G,H,ee){var re,Oe,Be,He,_e;switch(F=new Ne(F,ee),G=new Me(G,ee),H){case">":re=be,Oe=Q,Be=Fe,He=">",_e=">=";break;case"<":re=Fe,Oe=ge,Be=be,He="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(F,G,ee))return!1;for(var xe=0;xe<G.set.length;++xe){var et=G.set[xe],tt=null,it=null;if(et.forEach(function(ct){ct.semver===ue&&(ct=new he(">=0.0.0")),tt=tt||ct,it=it||ct,re(ct.semver,tt.semver,ee)?tt=ct:Be(ct.semver,it.semver,ee)&&(it=ct)}),tt.operator===He||tt.operator===_e||(!it.operator||it.operator===He)&&Oe(F,it.semver)||it.operator===_e&&Be(F,it.semver))return!1}return!0}he.prototype.parse=function(F){var G=this.loose?$[ie]:$[ce],H=F.match(G);if(!H)throw new TypeError("Invalid comparator: "+F);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new Ne(H[2],this.loose):this.semver=ue},he.prototype.toString=function(){return this.value},he.prototype.test=function(F){return R("Comparator.test",F,this.loose),this.semver===ue||(typeof F=="string"&&(F=new Ne(F,this.loose)),Y(F,this.operator,this.semver,this.loose))},he.prototype.intersects=function(F,G){if(!(F instanceof he))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Me(F.value,G),je(this.value,H,G);if(F.operator==="")return H=new Me(this.value,G),je(F.semver,H,G);var ee=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),re=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Oe=this.semver.version===F.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),He=Y(this.semver,"<",F.semver,G)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),_e=Y(this.semver,">",F.semver,G)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return ee||re||Oe&&Be||He||_e},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(F){var G=this.loose;F=F.trim(),R("range",F,G);var H=G?$[fe]:$[ke];F=F.replace(H,Ce),R("hyphen replace",F),F=F.replace($[ye],"$1$2$3"),R("comparator trim",F,$[ye]),F=(F=(F=F.replace($[P],"$1~")).replace($[N],"$1^")).split(/\s+/).join(" ");var ee=G?$[ie]:$[ce],re=F.split(" ").map(function(Oe){return function(Be,He){return R("comp",Be),Be=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,it){R("caret",tt,it);var ct=it?$[K]:$[B];return tt.replace(ct,function(gt,Ue,ot,X,Z){var me;return R("caret",tt,gt,Ue,ot,X,Z),de(Ue)?me="":de(ot)?me=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":de(X)?me=Ue==="0"?">="+Ue+"."+ot+".0 <"+Ue+"."+(+ot+1)+".0":">="+Ue+"."+ot+".0 <"+(+Ue+1)+".0.0":Z?(R("replaceCaret pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),me=Ue==="0"?ot==="0"?">="+Ue+"."+ot+"."+X+Z+" <"+Ue+"."+ot+"."+(+X+1):">="+Ue+"."+ot+"."+X+Z+" <"+Ue+"."+(+ot+1)+".0":">="+Ue+"."+ot+"."+X+Z+" <"+(+Ue+1)+".0.0"):(R("no pr"),me=Ue==="0"?ot==="0"?">="+Ue+"."+ot+"."+X+" <"+Ue+"."+ot+"."+(+X+1):">="+Ue+"."+ot+"."+X+" <"+Ue+"."+(+ot+1)+".0":">="+Ue+"."+ot+"."+X+" <"+(+Ue+1)+".0.0"),R("caret return",me),me})}(et,xe)}).join(" ")}(Be,He),R("caret",Be),Be=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,it){var ct=it?$[V]:$[W];return tt.replace(ct,function(gt,Ue,ot,X,Z){var me;return R("tilde",tt,gt,Ue,ot,X,Z),de(Ue)?me="":de(ot)?me=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":de(X)?me=">="+Ue+"."+ot+".0 <"+Ue+"."+(+ot+1)+".0":Z?(R("replaceTilde pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),me=">="+Ue+"."+ot+"."+X+Z+" <"+Ue+"."+(+ot+1)+".0"):me=">="+Ue+"."+ot+"."+X+" <"+Ue+"."+(+ot+1)+".0",R("tilde return",me),me})}(et,xe)}).join(" ")}(Be,He),R("tildes",Be),Be=function(_e,xe){return R("replaceXRanges",_e,xe),_e.split(/\s+/).map(function(et){return function(tt,it){tt=tt.trim();var ct=it?$[D]:$[h];return tt.replace(ct,function(gt,Ue,ot,X,Z,me){R("xRange",tt,gt,Ue,ot,X,Z,me);var Ge=de(ot),we=Ge||de(X),at=we||de(Z);return Ue==="="&&at&&(Ue=""),Ge?gt=Ue===">"||Ue==="<"?"<0.0.0":"*":Ue&&at?(we&&(X=0),at&&(Z=0),Ue===">"?(Ue=">=",we?(ot=+ot+1,X=0,Z=0):at&&(X=+X+1,Z=0)):Ue==="<="&&(Ue="<",we?ot=+ot+1:X=+X+1),gt=Ue+ot+"."+X+"."+Z):we?gt=">="+ot+".0.0 <"+(+ot+1)+".0.0":at&&(gt=">="+ot+"."+X+".0 <"+ot+"."+(+X+1)+".0"),R("xRange return",gt),gt})}(et,xe)}).join(" ")}(Be,He),R("xrange",Be),Be=function(_e,xe){return R("replaceStars",_e,xe),_e.trim().replace($[$e],"")}(Be,He),R("stars",Be),Be}(Oe,G)}).join(" ").split(/\s+/);return this.loose&&(re=re.filter(function(Oe){return!!Oe.match(ee)})),re=re.map(function(Oe){return new he(Oe,G)})},Me.prototype.intersects=function(F,G){if(!(F instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ee){return F.set.some(function(re){return re.every(function(Oe){return ee.intersects(Oe,G)})})})})},e.toComparators=function(F,G){return new Me(F,G).set.map(function(H){return H.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new Ne(F,this.loose));for(var G=0;G<this.set.length;G++)if(Ae(this.set[G],F))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(F,G,H){var ee=null,re=null;try{var Oe=new Me(G,H)}catch{return null}return F.forEach(function(Be){Oe.test(Be)&&(ee&&re.compare(Be)!==-1||(re=new Ne(ee=Be,H)))}),ee},e.minSatisfying=function(F,G,H){var ee=null,re=null;try{var Oe=new Me(G,H)}catch{return null}return F.forEach(function(Be){Oe.test(Be)&&(ee&&re.compare(Be)!==1||(re=new Ne(ee=Be,H)))}),ee},e.validRange=function(F,G){try{return new Me(F,G).range||"*"}catch{return null}},e.ltr=function(F,G,H){return U(F,G,"<",H)},e.gtr=function(F,G,H){return U(F,G,">",H)},e.outside=U,e.prerelease=function(F,G){var H=ae(F,G);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(F,G,H){return F=new Me(F,H),G=new Me(G,H),F.intersects(G)},e.coerce=function(F){if(F instanceof Ne)return F;if(typeof F!="string")return null;var G=F.match($[S]);return G==null?null:ae((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,C(1))},function(le,e){var C,O,R=le.exports={};function M(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function $(r){if(C===setTimeout)return setTimeout(r,0);if((C===M||!C)&&setTimeout)return C=setTimeout,setTimeout(r,0);try{return C(r,0)}catch{try{return C.call(null,r,0)}catch{return C.call(this,r,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:M}catch{C=M}try{O=typeof clearTimeout=="function"?clearTimeout:A}catch{O=A}})();var m,E=[],T=!1,k=-1;function l(){T&&m&&(T=!1,m.length?E=m.concat(E):k=-1,E.length&&w())}function w(){if(!T){var r=$(l);T=!0;for(var o=E.length;o;){for(m=E,E=[];++k<o;)m&&m[k].run();k=-1,o=E.length}m=null,T=!1,function(n){if(O===clearTimeout)return clearTimeout(n);if((O===A||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(n);try{O(n)}catch{try{return O.call(null,n)}catch{return O.call(this,n)}}}(r)}}function f(r,o){this.fun=r,this.array=o}function s(){}R.nextTick=function(r){var o=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)o[n-1]=arguments[n];E.push(new f(r,o)),E.length!==1||T||$(w)},f.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=s,R.addListener=s,R.once=s,R.off=s,R.removeListener=s,R.removeAllListeners=s,R.emit=s,R.prependListener=s,R.prependOnceListener=s,R.listeners=function(r){return[]},R.binding=function(r){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(r){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Se[134],Pe([1,0,14,6]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=R,e.$re=M,e.$se=A,e.$te=$,e.$ue=E,e.$ve=T,e.$we=k,e.$xe=l,e.$ye=w,e.$ze=f,e.$Ae=s,e.$Be=r,e.$Ce=o,e.$De=n,e.$Ee=i;function R(c){const u=c;return u?typeof u.read=="function":!1}function M(c){const u=c;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}function A(c){const u=c;return u?M(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}function $(c,u){return new m(c,u)}class m{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,C.$1)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let d;switch(u){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const a=d.indexOf(t);a>=0&&d.splice(a,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(c,u){const t=[];let d;for(;(d=c.read())!==null;)t.push(d);return u(t)}function T(c,u,t){const d=[];let a;for(;(a=c.read())!==null&&d.length<t;)d.push(a);return a===null&&d.length>0?u(d):{read:()=>{if(d.length>0)return d.shift();if(typeof a<"u"){const g=a;return a=void 0,g}return c.read()}}}function k(c,u){return new Promise((t,d)=>{const a=[];l(c,{onData:g=>{u&&a.push(g)},onError:g=>{u?d(g):t(void 0)},onEnd:()=>{t(u?u(a):void 0)}})})}function l(c,u,t){c.on("error",d=>{t?.isCancellationRequested||u.onError(d)}),c.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),c.on("data",d=>{t?.isCancellationRequested||u.onData(d)})}function w(c,u){return new Promise((t,d)=>{const a=new O.$Tc,g=[],b=y=>{if(g.push(y),g.length>u)return a.dispose(),c.pause(),t({stream:c,buffer:g,ended:!1})},p=y=>(a.dispose(),d(y)),v=()=>(a.dispose(),t({stream:c,buffer:g,ended:!0}));a.add((0,O.$Sc)(()=>c.removeListener("error",p))),c.on("error",p),a.add((0,O.$Sc)(()=>c.removeListener("end",v))),c.on("end",v),a.add((0,O.$Sc)(()=>c.removeListener("data",b))),c.on("data",b)})}function f(c,u){const t=$(u);return t.end(c),t}function s(){const c=$(()=>{throw new Error("not supported")});return c.end(),c}function r(c){let u=!1;return{read:()=>u?null:(u=!0,c)}}function o(c,u,t){const d=$(t);return l(c,{onData:a=>d.write(u.data(a)),onError:a=>d.error(u.error?u.error(a):a),onEnd:()=>d.end()}),d}function n(c,u,t){let d=!1;return{read:()=>{const a=u.read();return d?a:(d=!0,a!==null?t([c,a]):c)}}}function i(c,u,t){let d=!1;const a=$(t);return l(u,{onData:g=>d?a.write(g):(d=!0,a.write(t([c,g]))),onError:g=>a.error(g),onEnd:()=>{d||(d=!0,a.write(c)),a.end()}}),a}}),define(Se[21],Pe([1,0,43,134]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=void 0,e.$Ge=E,e.$He=T,e.$Ie=k,e.$Je=l,e.$Ke=w,e.$Le=f,e.$Me=s,e.$Ne=r,e.$Oe=o,e.$Pe=n,e.$Qe=i,e.$Re=c,e.$Se=u,e.$Te=t,e.$Ue=d,e.$Ve=a,e.$We=g,e.$Xe=b,e.$Ye=p,e.$Ze=h;const R=typeof Buffer<"u",M=new C.$V(()=>new Uint8Array(256));let A,$;class m{static alloc(S){return R?new m(Buffer.allocUnsafe(S)):new m(new Uint8Array(S))}static wrap(S){return R&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new m(S)}static fromString(S,I){return!(I?.dontUseNodeBuffer||!1)&&R?new m(Buffer.from(S)):(A||(A=new TextEncoder),new m(A.encode(S)))}static fromByteArray(S){const I=m.alloc(S.length);for(let P=0,W=S.length;P<W;P++)I.buffer[P]=S[P];return I}static concat(S,I){if(typeof I>"u"){I=0;for(let V=0,q=S.length;V<q;V++)I+=S[V].byteLength}const P=m.alloc(I);let W=0;for(let V=0,q=S.length;V<q;V++){const N=S[V];P.set(N,W),W+=N.byteLength}return P}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=m.alloc(this.byteLength);return S.set(this),S}toString(){return R?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(S,I){return new m(this.buffer.subarray(S,I))}set(S,I){if(S instanceof m)this.buffer.set(S.buffer,I);else if(S instanceof Uint8Array)this.buffer.set(S,I);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),I);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return l(this.buffer,S)}writeUInt32BE(S,I){w(this.buffer,S,I)}readUInt32LE(S){return f(this.buffer,S)}writeUInt32LE(S,I){s(this.buffer,S,I)}readUInt8(S){return r(this.buffer,S)}writeUInt8(S,I){o(this.buffer,S,I)}indexOf(S,I=0){return E(this.buffer,S instanceof m?S.buffer:S,I)}}e.$Fe=m;function E(D,S,I=0){const P=S.byteLength,W=D.byteLength;if(P===0)return 0;if(P===1)return D.indexOf(S[0]);if(P>W-I)return-1;const V=M.value;V.fill(S.length);for(let K=0;K<S.length;K++)V[S[K]]=S.length-K-1;let q=I+S.length-1,N=q,B=-1;for(;q<W;)if(D[q]===S[N]){if(N===0){B=q;break}q--,N--}else q+=Math.max(S.length-N,V[D[q]]),N=S.length-1;return B}function T(D,S){return D[S+0]<<0>>>0|D[S+1]<<8>>>0}function k(D,S,I){D[I+0]=S&255,S=S>>>8,D[I+1]=S&255}function l(D,S){return D[S]*2**24+D[S+1]*2**16+D[S+2]*2**8+D[S+3]}function w(D,S,I){D[I+3]=S,S=S>>>8,D[I+2]=S,S=S>>>8,D[I+1]=S,S=S>>>8,D[I]=S}function f(D,S){return D[S+0]<<0>>>0|D[S+1]<<8>>>0|D[S+2]<<16>>>0|D[S+3]<<24>>>0}function s(D,S,I){D[I+0]=S&255,S=S>>>8,D[I+1]=S&255,S=S>>>8,D[I+2]=S&255,S=S>>>8,D[I+3]=S&255}function r(D,S){return D[S]}function o(D,S,I){D[I]=S}function n(D){return O.$ue(D,S=>m.concat(S))}function i(D){return O.$Be(D)}function c(D){return O.$we(D,S=>m.concat(S))}async function u(D){return D.ended?m.concat(D.buffer):m.concat([...D.buffer,await c(D.stream)])}function t(D){return O.$ze(D,S=>m.concat(S))}function d(D){return O.$Ce(D,{data:S=>typeof S=="string"?m.fromString(S):m.wrap(S)},S=>m.concat(S))}function a(D){return O.$te(S=>m.concat(S),D)}function g(D,S){return O.$De(D,S,I=>m.concat(I))}function b(D,S){return O.$Ee(D,S,I=>m.concat(I))}function p(D){let S=0,I=0,P=0;const W=new Uint8Array(Math.floor(D.length/4*3)),V=N=>{switch(I){case 3:W[P++]=S|N,I=0;break;case 2:W[P++]=S|N>>>2,S=N<<6,I=3;break;case 1:W[P++]=S|N>>>4,S=N<<4,I=2;break;default:S=N<<2,I=1}};for(let N=0;N<D.length;N++){const B=D.charCodeAt(N);if(B>=65&&B<=90)V(B-65);else if(B>=97&&B<=122)V(B-97+26);else if(B>=48&&B<=57)V(B-48+52);else if(B===43||B===45)V(62);else if(B===47||B===95)V(63);else{if(B===61)break;throw new SyntaxError(`Unexpected base64 character ${D[N]}`)}}const q=P;for(;I>0;)V(0);return m.wrap(W).slice(0,q)}const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:D},S=!0,I=!1){const P=I?y:v;let W="";const V=D.byteLength%3;let q=0;for(;q<D.byteLength-V;q+=3){const N=D[q+0],B=D[q+1],K=D[q+2];W+=P[N>>>2],W+=P[(N<<4|B>>>4)&63],W+=P[(B<<2|K>>>6)&63],W+=P[K&63]}if(V===1){const N=D[q+0];W+=P[N>>>2],W+=P[N<<4&63],S&&(W+="==")}else if(V===2){const N=D[q+0],B=D[q+1];W+=P[N>>>2],W+=P[(N<<4|B>>>4)&63],W+=P[B<<2&63],S&&(W+="=")}return W}}),define(Se[135],Pe([1,0,28,128,13]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.FuzzyScore=e.$yk=e.$xk=void 0,e.or=M,e.$zk=$,e.$Ak=m,e.$Bk=k,e.$Ck=p,e.$Dk=v,e.$Ek=P,e.$Fk=W,e.$Gk=V,e.$Hk=q,e.$Ik=x,e.$Kk=pe,e.$Lk=Y,e.$Mk=he;function M(...de){return function(Ce,Ae){for(let je=0,U=de.length;je<U;je++){const F=de[je](Ce,Ae);if(F)return F}return null}}e.$xk=A.bind(void 0,!1),e.$yk=A.bind(void 0,!0);function A(de,Ce,Ae){if(!Ae||Ae.length<Ce.length)return null;let je;return de?je=R.$yf(Ae,Ce):je=Ae.indexOf(Ce)===0,je?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function $(de,Ce){const Ae=Ce.toLowerCase().indexOf(de.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+de.length}]}function m(de,Ce){return E(de.toLowerCase(),Ce.toLowerCase(),0,0)}function E(de,Ce,Ae,je){if(Ae===de.length)return[];if(je===Ce.length)return null;if(de[Ae]===Ce[je]){let U=null;return(U=E(de,Ce,Ae+1,je+1))?c({start:je,end:je+1},U):null}return E(de,Ce,Ae,je+1)}function T(de){return 97<=de&&de<=122}function k(de){return 65<=de&&de<=90}function l(de){return 48<=de&&de<=57}function w(de){return de===32||de===9||de===10||de===13}const f=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>f.add(de.charCodeAt(0)));function s(de){return w(de)||f.has(de)}function r(de,Ce){return de===Ce||s(de)&&s(Ce)}const o=new Map;function n(de){if(o.has(de))return o.get(de);let Ce;const Ae=(0,O.$vk)(de);return Ae&&(Ce=Ae),o.set(de,Ce),Ce}function i(de){return T(de)||k(de)||l(de)}function c(de,Ce){return Ce.length===0?Ce=[de]:de.end===Ce[0].start?Ce[0].start=de.start:Ce.unshift(de),Ce}function u(de,Ce){for(let Ae=Ce;Ae<de.length;Ae++){const je=de.charCodeAt(Ae);if(k(je)||l(je)||Ae>0&&!i(de.charCodeAt(Ae-1)))return Ae}return de.length}function t(de,Ce,Ae,je){if(Ae===de.length)return[];if(je===Ce.length)return null;if(de[Ae]!==Ce[je].toLowerCase())return null;{let U=null,F=je+1;for(U=t(de,Ce,Ae+1,je+1);!U&&(F=u(Ce,F))<Ce.length;)U=t(de,Ce,Ae+1,F),F++;return U===null?null:c({start:je,end:je+1},U)}}function d(de){let Ce=0,Ae=0,je=0,U=0,F=0;for(let Oe=0;Oe<de.length;Oe++)F=de.charCodeAt(Oe),k(F)&&Ce++,T(F)&&Ae++,i(F)&&je++,l(F)&&U++;const G=Ce/de.length,H=Ae/de.length,ee=je/de.length,re=U/de.length;return{upperPercent:G,lowerPercent:H,alphaPercent:ee,numericPercent:re}}function a(de){const{upperPercent:Ce,lowerPercent:Ae}=de;return Ae===0&&Ce>.6}function g(de){const{upperPercent:Ce,lowerPercent:Ae,alphaPercent:je,numericPercent:U}=de;return Ae>.2&&Ce<.8&&je>.6&&U<.2}function b(de){let Ce=0,Ae=0,je=0,U=0;for(let F=0;F<de.length;F++)je=de.charCodeAt(F),k(je)&&Ce++,T(je)&&Ae++,w(je)&&U++;return(Ce===0||Ae===0)&&U===0?de.length<=30:Ce<=5}function p(de,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!b(de))return null;Ce.length>60&&(Ce=Ce.substring(0,60));const Ae=d(Ce);if(!g(Ae)){if(!a(Ae))return null;Ce=Ce.toLowerCase()}let je=null,U=0;for(de=de.toLowerCase();U<Ce.length&&(je=t(de,Ce,0,U))===null;)U=u(Ce,U+1);return je}function v(de,Ce,Ae=!1){if(!Ce||Ce.length===0)return null;let je=null,U=0;for(de=de.toLowerCase(),Ce=Ce.toLowerCase();U<Ce.length&&(je=y(de,Ce,0,U,Ae),je===null);)U=h(Ce,U+1);return je}function y(de,Ce,Ae,je,U){let F=0;if(Ae===de.length)return[];if(je===Ce.length)return null;if(!r(de.charCodeAt(Ae),Ce.charCodeAt(je))){const ee=n(de.charCodeAt(Ae));if(!ee)return null;for(let re=0;re<ee.length;re++)if(!r(ee[re],Ce.charCodeAt(je+re)))return null;F+=ee.length-1}let G=null,H=je+F+1;if(G=y(de,Ce,Ae+1,H,U),!U)for(;!G&&(H=h(Ce,H))<Ce.length;)G=y(de,Ce,Ae+1,H,U),H++;if(!G)return null;if(de.charCodeAt(Ae)!==Ce.charCodeAt(je)){const ee=n(de.charCodeAt(Ae));if(!ee)return G;for(let re=0;re<ee.length;re++)if(ee[re]!==Ce.charCodeAt(je+re))return G}return c({start:je,end:je+F+1},G)}function h(de,Ce){for(let Ae=Ce;Ae<de.length;Ae++)if(s(de.charCodeAt(Ae))||Ae>0&&s(de.charCodeAt(Ae-1)))return Ae;return de.length}const D=M(e.$yk,p,$),S=M(e.$yk,p,m),I=new C.$Dc(1e4);function P(de,Ce,Ae=!1){if(typeof de!="string"||typeof Ce!="string")return null;let je=I.get(de);je||(je=new RegExp(R.$gf(de),"i"),I.set(de,je));const U=je.exec(Ce);return U?[{start:U.index,end:U.index+U[0].length}]:Ae?S(de,Ce):D(de,Ce)}function W(de,Ce){const Ae=pe(de,de.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?q(Ae):null}function V(de,Ce,Ae,je,U,F){const G=Math.min(13,de.length);for(;Ae<G;Ae++){const H=pe(de,Ce,Ae,je,U,F,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,F]}function q(de){if(typeof de>"u")return[];const Ce=[],Ae=de[1];for(let je=de.length-1;je>1;je--){const U=de[je]+Ae,F=Ce[Ce.length-1];F&&F.end===U?F.end=U+1:Ce.push({start:U,end:U+1})}return Ce}const N=128;function B(){const de=[],Ce=[];for(let Ae=0;Ae<=N;Ae++)Ce[Ae]=0;for(let Ae=0;Ae<=N;Ae++)de.push(Ce.slice(0));return de}function K(de){const Ce=[];for(let Ae=0;Ae<=de;Ae++)Ce[Ae]=0;return Ce}const ie=K(2*N),ce=K(2*N),ye=B(),ke=B(),fe=B(),$e=!1;function Te(de,Ce,Ae,je,U){function F(H,ee,re=" "){for(;H.length<ee;)H=re+H;return H}let G=` |   |${je.split("").map(H=>F(H,3)).join("|")}
`;for(let H=0;H<=Ae;H++)H===0?G+=" |":G+=`${Ce[H-1]}|`,G+=de[H].slice(0,U+1).map(ee=>F(ee.toString(),3)).join("|")+`
`;return G}function ae(de,Ce,Ae,je){de=de.substr(Ce),Ae=Ae.substr(je),console.log(Te(ke,de,de.length,Ae,Ae.length)),console.log(Te(fe,de,de.length,Ae,Ae.length)),console.log(Te(ye,de,de.length,Ae,Ae.length))}function Ne(de,Ce){if(Ce<0||Ce>=de.length)return!1;const Ae=de.codePointAt(Ce);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$Qf(Ae)}}function ne(de,Ce){if(Ce<0||Ce>=de.length)return!1;switch(de.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function z(de,Ce,Ae){return Ce[de]!==Ae[de]}function x(de,Ce,Ae,je,U,F,G=!1){for(;Ce<Ae&&U<F;)de[Ce]===je[U]&&(G&&(ie[Ce]=U),Ce+=1),U+=1;return Ce===Ae}var be;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(be||(be={}));var Fe;(function(de){de.Default=[-100,0];function Ce(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}de.isDefault=Ce})(Fe||(e.FuzzyScore=Fe={}));class De{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,Ae){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=Ae}}e.$Jk=De;function pe(de,Ce,Ae,je,U,F,G=De.default){const H=de.length>N?N:de.length,ee=je.length>N?N:je.length;if(Ae>=H||F>=ee||H-Ae>ee-F||!x(Ce,Ae,H,U,F,ee,!0))return;ge(H,ee,Ae,F,Ce,U);let re=1,Oe=1,Be=Ae,He=F;const _e=[!1];for(re=1,Be=Ae;Be<H;re++,Be++){const ct=ie[Be],gt=ce[Be],Ue=Be+1<H?ce[Be+1]:ee;for(Oe=ct-F+1,He=ct;He<Ue;Oe++,He++){let ot=Number.MIN_SAFE_INTEGER,X=!1;He<=gt&&(ot=Q(de,Ce,Be,Ae,je,U,He,ee,F,ye[re-1][Oe-1]===0,_e));let Z=0;ot!==Number.MAX_SAFE_INTEGER&&(X=!0,Z=ot+ke[re-1][Oe-1]);const me=He>ct,Ge=me?ke[re][Oe-1]+(ye[re][Oe-1]>0?-5:0):0,we=He>ct+1&&ye[re][Oe-1]>0,at=we?ke[re][Oe-2]+(ye[re][Oe-2]>0?-5:0):0;if(we&&(!me||at>=Ge)&&(!X||at>=Z))ke[re][Oe]=at,fe[re][Oe]=3,ye[re][Oe]=0;else if(me&&(!X||Ge>=Z))ke[re][Oe]=Ge,fe[re][Oe]=2,ye[re][Oe]=0;else if(X)ke[re][Oe]=Z,fe[re][Oe]=1,ye[re][Oe]=ye[re-1][Oe-1]+1;else throw new Error("not possible")}}if($e&&ae(de,Ae,je,F),!_e[0]&&!G.firstMatchCanBeWeak)return;re--,Oe--;const xe=[ke[re][Oe],F];let et=0,tt=0;for(;re>=1;){let ct=Oe;do{const gt=fe[re][ct];if(gt===3)ct=ct-2;else if(gt===2)ct=ct-1;else break}while(ct>=1);et>1&&Ce[Ae+re-1]===U[F+Oe-1]&&!z(ct+F-1,je,U)&&et+1>ye[re][ct]&&(ct=Oe),ct===Oe?et++:et=1,tt||(tt=ct),re--,Oe=ct-1,xe.push(Oe)}ee-F===H&&G.boostFullMatch&&(xe[0]+=2);const it=tt-H;return xe[0]-=it,xe}function ge(de,Ce,Ae,je,U,F){let G=de-1,H=Ce-1;for(;G>=Ae&&H>=je;)U[G]===F[H]&&(ce[G]=H,G--),H--}function Q(de,Ce,Ae,je,U,F,G,H,ee,re,Oe){if(Ce[Ae]!==F[G])return Number.MIN_SAFE_INTEGER;let Be=1,He=!1;return G===Ae-je?Be=de[Ae]===U[G]?7:5:z(G,U,F)&&(G===0||!z(G-1,U,F))?(Be=de[Ae]===U[G]?7:5,He=!0):Ne(F,G)&&(G===0||!Ne(F,G-1))?Be=5:(Ne(F,G-1)||ne(F,G-1))&&(Be=5,He=!0),Be>1&&Ae===je&&(Oe[0]=!0),He||(He=z(G,U,F)||Ne(F,G-1)||ne(F,G-1)),Ae===je?G>ee&&(Be-=He?3:5):re?Be+=He?2:0:Be+=He?0:1,G+1===H&&(Be-=He?3:5),Be}function Y(de,Ce,Ae,je,U,F,G){return ue(de,Ce,Ae,je,U,F,!0,G)}function he(de,Ce,Ae,je,U,F,G){return ue(de,Ce,Ae,je,U,F,!1,G)}function ue(de,Ce,Ae,je,U,F,G,H){let ee=pe(de,Ce,Ae,je,U,F,H);if(ee&&!G)return ee;if(de.length>=3){const re=Math.min(7,de.length-1);for(let Oe=Ae+1;Oe<re;Oe++){const Be=Me(de,Oe);if(Be){const He=pe(Be,Be.toLowerCase(),Ae,je,U,F,H);He&&(He[0]-=3,(!ee||He[0]>ee[0])&&(ee=He))}}}return ee}function Me(de,Ce){if(Ce+1>=de.length)return;const Ae=de[Ce],je=de[Ce+1];if(Ae!==je)return de.slice(0,Ce)+je+Ae+de.slice(Ce+2)}}),define(Se[33],Pe([1,0,13]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(O||(O={})),function(R){const M="error",A="warning",$="warn",m="info",E="ignore";function T(l){return l?C.$xf(M,l)?R.Error:C.$xf(A,l)||C.$xf($,l)?R.Warning:C.$xf(m,l)?R.Info:R.Ignore:R.Ignore}R.fromValue=T;function k(l){switch(l){case R.Error:return M;case R.Warning:return A;case R.Info:return m;default:return E}}R.toString=k}(O||(O={})),e.default=O}),define(Se[136],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=void 0,e.$ae=Symbol("MicrotaskDelay")}),define(Se[54],Pe([1,0,18,13]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class R{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const f=w.charCodeAt(0),s=this.b.charCodeAt(this.c);return f-s}value(){return this.b[this.c]}}e.$yi=R;class M{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,O.$rf)(w,this.b,0,w.length,this.c,this.d):(0,O.$tf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$zi=M;class A{constructor(w=!0,f=!0){this.f=w,this.g=f}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let f=w.length-1;f>=0;f--,this.c--){const s=this.b.charCodeAt(f);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,O.$rf)(w,this.b,0,w.length,this.d,this.e):(0,O.$tf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ai=A;var $;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})($||($={}));class m{constructor(w,f){this.f=w,this.g=f,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(3)),this.g(w)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===1)return(0,O.$sf)(w,this.c.scheme);if(this.d[this.e]===2)return(0,O.$sf)(w,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(w);if(this.d[this.e]===4)return(0,O.$qf)(w,this.c.query);if(this.d[this.e]===5)return(0,O.$qf)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Bi=m;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(T||(T={}));class k{static forUris(w=()=>!1,f=()=>!1){return new k(new m(w,f))}static forPaths(w=!1){return new k(new A(void 0,!w))}static forStrings(){return new k(new R)}static forConfigKeys(){return new k(new M)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,f){if(f){const s=f.slice(0);(0,C.$Wb)(s);for(const r of s)this.set(r,w)}else{const s=w.slice(0);(0,C.$Wb)(s);for(const r of s)this.set(r[0],r[1])}}set(w,f){const s=this.b.reset(w);let r;this.c||(this.c=new E,this.c.segment=s.value());const o=[];for(r=this.c;;){const i=s.cmp(r.segment);if(i>0)r.left||(r.left=new E,r.left.segment=s.value()),o.push([-1,r]),r=r.left;else if(i<0)r.right||(r.right=new E,r.right.segment=s.value()),o.push([1,r]),r=r.right;else if(s.hasNext())s.next(),r.mid||(r.mid=new E,r.mid.segment=s.value()),o.push([0,r]),r=r.mid;else break}const n=r.value;r.value=f,r.key=w;for(let i=o.length-1;i>=0;i--){const c=o[i][1];c.updateHeight();const u=c.balanceFactor();if(u<-1||u>1){const t=o[i][0],d=o[i+1][0];if(t===1&&d===1)o[i][1]=c.rotateLeft();else if(t===-1&&d===-1)o[i][1]=c.rotateRight();else if(t===1&&d===-1)c.right=o[i+1][1]=o[i+1][1].rotateRight(),o[i][1]=c.rotateLeft();else if(t===-1&&d===1)c.left=o[i+1][1]=o[i+1][1].rotateLeft(),o[i][1]=c.rotateRight();else throw new Error;if(i>0)switch(o[i-1][0]){case-1:o[i-1][1].left=o[i][1];break;case 1:o[i-1][1].right=o[i][1];break;case 0:o[i-1][1].mid=o[i][1];break}else this.c=o[0][1]}}return n}get(w){return this.d(w)?.value}d(w){const f=this.b.reset(w);let s=this.c;for(;s;){const r=f.cmp(s.segment);if(r>0)s=s.left;else if(r<0)s=s.right;else if(f.hasNext())f.next(),s=s.mid;else break}return s}has(w){const f=this.d(w);return!(f?.value===void 0&&f?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,f){const s=this.b.reset(w),r=[];let o=this.c;for(;o;){const n=s.cmp(o.segment);if(n>0)r.push([-1,o]),o=o.left;else if(n<0)r.push([1,o]),o=o.right;else if(s.hasNext())s.next(),r.push([0,o]),o=o.mid;else break}if(o){if(f?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const n=this.f(o.right);if(n.key){const{key:i,value:c,segment:u}=n;this.e(n.key,!1),o.key=i,o.value=c,o.segment=u}}else{const n=o.left??o.right;if(r.length>0){const[i,c]=r[r.length-1];switch(i){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=r.length-1;n>=0;n--){const i=r[n][1];i.updateHeight();const c=i.balanceFactor();if(c>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),r[n][1]=i.rotateLeft()):c<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),r[n][1]=i.rotateRight()),n>0)switch(r[n-1][0]){case-1:r[n-1][1].left=r[n][1];break;case 1:r[n-1][1].right=r[n][1];break;case 0:r[n-1][1].mid=r[n][1];break}else this.c=r[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const f=this.b.reset(w);let s=this.c,r;for(;s;){const o=f.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(f.hasNext())f.next(),r=s.value||r,s=s.mid;else break}return s&&s.value||r}findSuperstr(w){return this.g(w,!1)}g(w,f){const s=this.b.reset(w);let r=this.c;for(;r;){const o=s.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else return r.mid?this.h(r.mid):f?r.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[f,s]of this)w(s,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const f=[];return this.j(w,f),f[Symbol.iterator]()}j(w,f){w&&(w.left&&this.j(w.left,f),w.value&&f.push([w.key,w.value]),w.mid&&this.j(w.mid,f),w.right&&this.j(w.right,f))}_isBalanced(){const w=f=>{if(!f)return!0;const s=f.balanceFactor();return s<-1||s>1?!1:w(f.left)&&w(f.right)};return w(this.c)}}e.$Ci=k}),define(Se[36],Pe([1,0,92]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Wj=R;var O;(function(A){function $(m){return m&&typeof m=="object"&&typeof m.id=="string"}A.isThemeColor=$})(O||(e.ThemeColor=O={}));function R(A){return{id:A}}var M;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function m(n){const i=$.exec(n.id);if(!i)return m(C.$Vj.error);const[,c,u]=i,t=["codicon","codicon-"+c];return u&&t.push("codicon-modifier-"+u.substring(1)),t}A.asClassNameArray=m;function E(n){return m(n).join(" ")}A.asClassName=E;function T(n){return"."+m(n).join(".")}A.asCSSSelector=T;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||O.isThemeColor(n.color))}A.isThemeIcon=k;const l=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function w(n){const i=l.exec(n);if(!i)return;const[,c]=i;return{id:c}}A.fromString=w;function f(n){return{id:n}}A.fromId=f;function s(n,i){let c=n.id;const u=c.lastIndexOf("~");return u!==-1&&(c=c.substring(0,u)),i&&(c=`${c}~${i}`),{id:c}}A.modify=s;function r(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}A.getModifier=r;function o(n,i){return n.id===i.id&&n.color?.id===i.color?.id}A.isEqual=o})(M||(e.ThemeIcon=M={}))}),define(Se[137],Pe([1,0,135,13,36]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=m,e.$Ok=T,e.$Pk=l,e.$Qk=w,e.$Rk=s,e.$Sk=r;const M="$(",A=new RegExp(`\\$\\(${R.ThemeIcon.iconNameExpression}(?:${R.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${A.source}`,"g");function m(o){return o.replace($,(n,i)=>i?n:`\\${n}`)}const E=new RegExp(`\\\\${A.source}`,"g");function T(o){return o.replace(E,n=>`\\${n}`)}const k=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function l(o){return o.indexOf(M)===-1?o:o.replace(k,(n,i,c,u)=>c?n:i||u||"")}function w(o){return o?o.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const f=new RegExp(`\\$\\(${R.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(o){f.lastIndex=0;let n="";const i=[];let c=0;for(;;){const u=f.lastIndex,t=f.exec(o),d=o.substring(u,t?.index);if(d.length>0){n+=d;for(let a=0;a<d.length;a++)i.push(c)}if(!t)break;c+=t[0].length}return{text:n,iconOffsets:i}}function r(o,n,i=!1){const{text:c,iconOffsets:u}=n;if(!u||u.length===0)return(0,C.$Ek)(o,c,i);const t=(0,O.$ef)(c," "),d=c.length-t.length,a=(0,C.$Ek)(o,t,i);if(a)for(const g of a){const b=u[g.start+d]+d;g.start+=b,g.end+=b}return a}}),define(Se[34],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=O;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(R){return C.test(R)}e.$Sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function($){for(let m=0;m<$.length;m++)$[m]=Math.floor(Math.random()*256);return $};const M=new Uint8Array(16),A=[];for(let $=0;$<256;$++)A.push($.toString(16).padStart(2,"0"));return function(){R(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let m=0,E="";return E+=A[M[m++]],E+=A[M[m++]],E+=A[M[m++]],E+=A[M[m++]],E+="-",E+=A[M[m++]],E+=A[M[m++]],E+="-",E+=A[M[m++]],E+=A[M[m++]],E+="-",E+=A[M[m++]],E+=A[M[m++]],E+="-",E+=A[M[m++]],E+=A[M[m++]],E+=A[M[m++]],E+=A[M[m++]],E+=A[M[m++]],E+=A[M[m++]],E}}()}),define(Se[138],Pe([1,0,18,42,34]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.$St=void 0,e.$Qt=M,e.$Rt=A,e.$Tt=E;function M(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}function A(k,l,w){const f={id:(0,R.$Sg)(),name:k,uri:l,data:w};return{asString:async()=>"",asFile:()=>f,value:void 0}}class ${constructor(){this.a=new Map}get size(){let l=0;for(const w of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const w=[...this.a.keys()];return O.Iterable.some(this,([f,s])=>s.asFile())&&w.push("files"),T(m(l),w)}get(l){return this.a.get(this.b(l))?.[0]}append(l,w){const f=this.a.get(l);f?f.push(w):this.a.set(this.b(l),[w])}replace(l,w){this.a.set(this.b(l),[w])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,w]of this.a)for(const f of w)yield[l,f]}b(l){return m(l)}}e.$St=$;function m(k){return k.toLowerCase()}function E(k,l){return T(m(k),l.map(m))}function T(k,l){if(k==="*/*")return l.length>0;if(l.includes(k))return!0;const w=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[f,s,r]=w;return r==="*"?l.some(o=>o.startsWith(s+"/")):!1}e.$Ut=Object.freeze({create:k=>(0,C.$Mb)(k.map(l=>l.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$Ut.split(k).filter(l=>!l.startsWith("#"))})}),define(Se[139],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$1t=O;var C;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(C||(e.StringEOL=C={}));function O(R){let M=0,A=0,$=0,m=0;for(let E=0,T=R.length;E<T;E++){const k=R.charCodeAt(E);k===13?(M===0&&(A=E),M++,E+1<T&&R.charCodeAt(E+1)===10?(m|=2,E++):m|=3,$=E+1):k===10&&(m|=1,M===0&&(A=E),M++,$=E+1)}return M===0&&(A=R.length),[M,A,R.length-$,m]}}),define(Se[140],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=void 0,e.$4s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[141],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=e.$ku=e.IndentAction=void 0;var C;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class O{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let m=0,E=$.notIn.length;m<E;m++)switch($.notIn[m]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,m){if($.getTokenCount()===0)return!0;const E=$.findTokenIndexAtOffset(m-2),T=$.getStandardTokenType(E);return this.isOK(T)}g($,m){for(let E=$;E<=m;E++){const T=String.fromCharCode(E);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$ku=O;class R{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const m of $)M(this.autoClosingPairsOpenByStart,m.open.charAt(0),m),M(this.autoClosingPairsOpenByEnd,m.open.charAt(m.open.length-1),m),M(this.autoClosingPairsCloseByStart,m.close.charAt(0),m),M(this.autoClosingPairsCloseByEnd,m.close.charAt(m.close.length-1),m),m.close.length===1&&m.open.length===1&&M(this.autoClosingPairsCloseSingleChar,m.close,m)}}e.$lu=R;function M(A,$,m){A.has($)?A.get($).push(m):A.set($,[m])}}),define(Se[142],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GC=e.NodeColor=e.$FC=void 0,e.$HC=R,e.$IC=M,e.$JC=E,e.$KC=T,e.$LC=k,e.$MC=l,e.$NC=w,e.$OC=f;class C{constructor(r,o){this.piece=r,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$GC)return R(this.right);let r=this;for(;r.parent!==e.$GC&&r.parent.left!==r;)r=r.parent;return r.parent===e.$GC?e.$GC:r.parent}prev(){if(this.left!==e.$GC)return M(this.left);let r=this;for(;r.parent!==e.$GC&&r.parent.right!==r;)r=r.parent;return r.parent===e.$GC?e.$GC:r.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$FC=C;var O;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$GC=new C(null,0),e.$GC.parent=e.$GC,e.$GC.left=e.$GC,e.$GC.right=e.$GC,e.$GC.color=0;function R(s){for(;s.left!==e.$GC;)s=s.left;return s}function M(s){for(;s.right!==e.$GC;)s=s.right;return s}function A(s){return s===e.$GC?0:s.size_left+s.piece.length+A(s.right)}function $(s){return s===e.$GC?0:s.lf_left+s.piece.lineFeedCnt+$(s.right)}function m(){e.$GC.parent=e.$GC}function E(s,r){const o=r.right;o.size_left+=r.size_left+(r.piece?r.piece.length:0),o.lf_left+=r.lf_left+(r.piece?r.piece.lineFeedCnt:0),r.right=o.left,o.left!==e.$GC&&(o.left.parent=r),o.parent=r.parent,r.parent===e.$GC?s.root=o:r.parent.left===r?r.parent.left=o:r.parent.right=o,o.left=r,r.parent=o}function T(s,r){const o=r.left;r.left=o.right,o.right!==e.$GC&&(o.right.parent=r),o.parent=r.parent,r.size_left-=o.size_left+(o.piece?o.piece.length:0),r.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),r.parent===e.$GC?s.root=o:r===r.parent.right?r.parent.right=o:r.parent.left=o,o.right=r,r.parent=o}function k(s,r){let o,n;if(r.left===e.$GC?(n=r,o=n.right):r.right===e.$GC?(n=r,o=n.left):(n=R(r.right),o=n.right),n===s.root){s.root=o,o.color=0,r.detach(),m(),s.root.parent=e.$GC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=o:n.parent.right=o,n===r?(o.parent=n.parent,f(s,o)):(n.parent===r?o.parent=n:o.parent=n.parent,f(s,o),n.left=r.left,n.right=r.right,n.parent=r.parent,n.color=r.color,r===s.root?s.root=n:r===r.parent.left?r.parent.left=n:r.parent.right=n,n.left!==e.$GC&&(n.left.parent=n),n.right!==e.$GC&&(n.right.parent=n),n.size_left=r.size_left,n.lf_left=r.lf_left,f(s,n)),r.detach(),o.parent.left===o){const u=A(o),t=$(o);if(u!==o.parent.size_left||t!==o.parent.lf_left){const d=u-o.parent.size_left,a=t-o.parent.lf_left;o.parent.size_left=u,o.parent.lf_left=t,w(s,o.parent,d,a)}}if(f(s,o.parent),i){m();return}let c;for(;o!==s.root&&o.color===0;)o===o.parent.left?(c=o.parent.right,c.color===1&&(c.color=0,o.parent.color=1,E(s,o.parent),c=o.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,o=o.parent):(c.right.color===0&&(c.left.color=0,c.color=1,T(s,c),c=o.parent.right),c.color=o.parent.color,o.parent.color=0,c.right.color=0,E(s,o.parent),o=s.root)):(c=o.parent.left,c.color===1&&(c.color=0,o.parent.color=1,T(s,o.parent),c=o.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,o=o.parent):(c.left.color===0&&(c.right.color=0,c.color=1,E(s,c),c=o.parent.left),c.color=o.parent.color,o.parent.color=0,c.left.color=0,T(s,o.parent),o=s.root));o.color=0,m()}function l(s,r){for(f(s,r);r!==s.root&&r.parent.color===1;)if(r.parent===r.parent.parent.left){const o=r.parent.parent.right;o.color===1?(r.parent.color=0,o.color=0,r.parent.parent.color=1,r=r.parent.parent):(r===r.parent.right&&(r=r.parent,E(s,r)),r.parent.color=0,r.parent.parent.color=1,T(s,r.parent.parent))}else{const o=r.parent.parent.left;o.color===1?(r.parent.color=0,o.color=0,r.parent.parent.color=1,r=r.parent.parent):(r===r.parent.left&&(r=r.parent,T(s,r)),r.parent.color=0,r.parent.parent.color=1,E(s,r.parent.parent))}s.root.color=0}function w(s,r,o,n){for(;r!==s.root&&r!==e.$GC;)r.parent.left===r&&(r.parent.size_left+=o,r.parent.lf_left+=n),r=r.parent}function f(s,r){let o=0,n=0;if(r!==s.root){for(;r!==s.root&&r===r.parent.right;)r=r.parent;if(r!==s.root)for(r=r.parent,o=A(r.left)-r.size_left,n=$(r.left)-r.lf_left,r.size_left+=o,r.lf_left+=n;r!==s.root&&(o!==0||n!==0);)r.parent.left===r&&(r.parent.size_left+=o,r.parent.lf_left+=n),r=r.parent}}}),define(Se[93],Pe([1,0,94,30,95,142,96]),function(le,e,C,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZC=e.$YC=e.$XC=void 0,e.$VC=T,e.$WC=k;const $=65535;function m(o){let n;return o[o.length-1]<65536?n=new Uint16Array(o.length):n=new Uint32Array(o.length),n.set(o,0),n}class E{constructor(n,i,c,u,t){this.lineStarts=n,this.cr=i,this.lf=c,this.crlf=u,this.isBasicASCII=t}}function T(o,n=!0){const i=[0];let c=1;for(let u=0,t=o.length;u<t;u++){const d=o.charCodeAt(u);d===13?u+1<t&&o.charCodeAt(u+1)===10?(i[c++]=u+2,u++):i[c++]=u+1:d===10&&(i[c++]=u+1)}return n?m(i):i}function k(o,n){o.length=0,o[0]=0;let i=1,c=0,u=0,t=0,d=!0;for(let g=0,b=n.length;g<b;g++){const p=n.charCodeAt(g);p===13?g+1<b&&n.charCodeAt(g+1)===10?(t++,o[i++]=g+2,g++):(c++,o[i++]=g+1):p===10?(u++,o[i++]=g+1):d&&p!==9&&(p<32||p>126)&&(d=!1)}const a=new E(m(o),c,u,t,d);return o.length=0,a}class l{constructor(n,i,c,u,t){this.bufferIndex=n,this.start=i,this.end=c,this.lineFeedCnt=u,this.length=t}}e.$XC=l;class w{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$YC=w;class f{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==M.$GC&&n.iterate(n.root,c=>(c!==M.$GC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const c=this.b[i];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const c=this.b[i];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const c=this.b;for(let u=0;u<c.length;u++){const t=c[u];if(t.node.parent===null||t.nodeStartOffset>=n){c[u]=null,i=!0;continue}}if(i){const u=[];for(const t of c)t!==null&&u.push(t);this.b=u}}}class r{constructor(n,i,c){this.create(n,i,c)}create(n,i,c){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=M.$GC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=c;let u=null;for(let t=0,d=n.length;t<d;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=T(n[t].buffer));const a=new l(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),u=this.S(u,a)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=$,c=i-Math.floor(i/3),u=c*2;let t="",d=0;const a=[];if(this.iterate(this.root,g=>{const b=this.R(g),p=b.length;if(d<=c||d+p<u)return t+=b,d+=p,!0;const v=t.replace(/\r\n|\r|\n/g,n);return a.push(new w(v,T(v))),t=b,d=p,!0}),d>0){const g=t.replace(/\r\n|\r|\n/g,n);a.push(new w(g,T(g)))}this.create(a,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new f(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,u=>{if(u===M.$GC)return!0;const t=this.R(u),d=t.length,a=n.G(i),g=n.G(i+d),b=n.getValueInRange2(a,g);return i+=d,t===b})}getOffsetAt(n,i){let c=0,u=this.root;for(;u!==M.$GC;)if(u.left!==M.$GC&&u.lf_left+1>=n)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt+1>=n){c+=u.size_left;const t=this.B(u,n-u.lf_left-2);return c+=t+i-1}else n-=u.lf_left+u.piece.lineFeedCnt,c+=u.size_left+u.piece.length,u=u.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,c=0;const u=n;for(;i!==M.$GC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(c+=i.lf_left+t.index,t.index===0){const d=this.getOffsetAt(c+1,1),a=u-d;return new C.$tt(c+1,a+1)}return new C.$tt(c+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,c+=i.lf_left+i.piece.lineFeedCnt,i.right===M.$GC){const t=this.getOffsetAt(c+1,1),d=u-n-t;return new C.$tt(c+1,d+1)}else i=i.right;return new C.$tt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),u=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(c,u);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const a=n.node,g=this.a[a.piece.bufferIndex].buffer,b=this.u(a.piece.bufferIndex,a.piece.start);return g.substring(b+n.remainder,b+i.remainder)}let c=n.node;const u=this.a[c.piece.bufferIndex].buffer,t=this.u(c.piece.bufferIndex,c.piece.start);let d=u.substring(t+n.remainder,t+c.piece.length);for(c=c.next();c!==M.$GC;){const a=this.a[c.piece.bufferIndex].buffer,g=this.u(c.piece.bufferIndex,c.piece.start);if(c===i.node){d+=a.substring(g,g+i.remainder);break}else d+=a.substr(g,c.piece.length);c=c.next()}return d}getLinesContent(){const n=[];let i=0,c="",u=!1;return this.iterate(this.root,t=>{if(t===M.$GC)return!0;const d=t.piece;let a=d.length;if(a===0)return!0;const g=this.a[d.bufferIndex].buffer,b=this.a[d.bufferIndex].lineStarts,p=d.start.line,v=d.end.line;let y=b[p]+d.start.column;if(u&&(g.charCodeAt(y)===10&&(y++,a--),n[i++]=c,c="",u=!1,a===0))return!0;if(p===v)return!this.f&&g.charCodeAt(y+a-1)===13?(u=!0,c+=g.substr(y,a-1)):c+=g.substr(y,a),!0;c+=this.f?g.substring(y,Math.max(y,b[p+1]-this.e)):g.substring(y,b[p+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=c;for(let h=p+1;h<v;h++)c=this.f?g.substring(b[h],b[h+1]-this.e):g.substring(b[h],b[h+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=c;return!this.f&&g.charCodeAt(b[v]+d.end.column-1)===13?(u=!0,d.end.column===0?i--:c=g.substr(b[v],d.end.column-1)):c=g.substr(b[v],d.end.column),!0}),u&&(n[i++]=c,c=""),n[i++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const c=this.a[i.piece.bufferIndex],u=this.u(i.piece.bufferIndex,i.piece.start);return c.buffer.charCodeAt(u)}else{const i=this.a[n.node.piece.bufferIndex],u=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(u)}}getLineCharCode(n,i){const c=this.H(n,i+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,c,u,t,d,a,g,b,p,v){const y=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start),D=this.u(n.piece.bufferIndex,t),S=this.u(n.piece.bufferIndex,d);let I;const P={line:0,column:0};let W,V;i._wordSeparators?(W=y.buffer.substring(D,S),V=q=>q+D,i.reset(0)):(W=y.buffer,V=q=>q,i.reset(D));do if(I=i.next(W),I){if(V(I.index)>=S)return p;this.s(n,V(I.index)-h,P);const q=this.t(n.piece.bufferIndex,t,P),N=P.line===t.line?P.column-t.column+u:P.column+1,B=N+I[0].length;if(v[p++]=(0,A.$RC)(new O.$ut(c+q,N,c+q,B),I,g),V(I.index)+I[0].length>=S||p>=b)return p}while(I);return p}findMatchesLineByLine(n,i,c,u){const t=[];let d=0;const a=new A.$UC(i.wordSeparators,i.regex);let g=this.H(n.startLineNumber,n.startColumn);if(g===null)return[];const b=this.H(n.endLineNumber,n.endColumn);if(b===null)return[];let p=this.s(g.node,g.remainder);const v=this.s(b.node,b.remainder);if(g.node===b.node)return this.findMatchesInNode(g.node,a,n.startLineNumber,n.startColumn,p,v,i,c,u,d,t),t;let y=n.startLineNumber,h=g.node;for(;h!==b.node;){const S=this.t(h.piece.bufferIndex,p,h.piece.end);if(S>=1){const P=this.a[h.piece.bufferIndex].lineStarts,W=this.u(h.piece.bufferIndex,h.piece.start),V=P[p.line+S],q=y===n.startLineNumber?n.startColumn:1;if(d=this.findMatchesInNode(h,a,y,q,p,this.s(h,V-W),i,c,u,d,t),d>=u)return t;y+=S}const I=y===n.startLineNumber?n.startColumn-1:0;if(y===n.endLineNumber){const P=this.getLineContent(y).substring(I,n.endColumn-1);return d=this.n(i,a,P,n.endLineNumber,I,d,t,c,u),t}if(d=this.n(i,a,this.getLineContent(y).substr(I),y,I,d,t,c,u),d>=u)return t;y++,g=this.H(y,1),h=g.node,p=this.s(g.node,g.remainder)}if(y===n.endLineNumber){const S=y===n.startLineNumber?n.startColumn-1:0,I=this.getLineContent(y).substring(S,n.endColumn-1);return d=this.n(i,a,I,n.endLineNumber,S,d,t,c,u),t}const D=y===n.startLineNumber?n.startColumn:1;return d=this.findMatchesInNode(b.node,a,y,D,p,v,i,c,u,d,t),t}n(n,i,c,u,t,d,a,g,b){const p=n.wordSeparators;if(!g&&n.simpleSearch){const y=n.simpleSearch,h=y.length,D=c.length;let S=-h;for(;(S=c.indexOf(y,S+h))!==-1;)if((!p||(0,A.$TC)(p,c,D,S,h))&&(a[d++]=new R.$Fv(new O.$ut(u,S+1+t,u,S+1+h+t),null),d>=b))return d;return d}let v;i.reset(0);do if(v=i.next(c),v&&(a[d++]=(0,A.$RC)(new O.$ut(u,v.index+1+t,u,v.index+1+v[0].length+t),v,g),d>=b))return d;while(v);return d}insert(n,i,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==M.$GC){const{node:u,remainder:t,nodeStartOffset:d}=this.G(n),a=u.piece,g=a.bufferIndex,b=this.s(u,t);if(u.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&d+a.length===n&&i.length<$){this.F(u,i),this.y();return}if(d===n)this.o(i,u),this.h.validate(n);else if(d+u.piece.length>n){const p=[];let v=new l(a.bufferIndex,b,a.end,this.t(a.bufferIndex,b,a.end),this.u(g,a.end)-this.u(g,b));if(this.K()&&this.M(i)&&this.I(u,t)===10){const S={line:v.start.line+1,column:0};v=new l(v.bufferIndex,S,v.end,this.t(v.bufferIndex,S,v.end),v.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(u,t-1)===13){const S=this.s(u,t-1);this.C(u,S),i="\r"+i,u.piece.length===0&&p.push(u)}else this.C(u,b);else this.C(u,b);const y=this.w(i);v.length>0&&this.S(u,v);let h=u;for(let D=0;D<y.length;D++)h=this.S(h,y[D]);this.v(p)}else this.q(i,u)}else{const u=this.w(i);let t=this.T(null,u[0]);for(let d=1;d<u.length;d++)t=this.S(t,u[d])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===M.$GC)return;const c=this.G(n),u=this.G(n+i),t=c.node,d=u.node;if(t===d){const y=this.s(t,c.remainder),h=this.s(t,u.remainder);if(c.nodeStartOffset===n){if(i===t.piece.length){const D=t.next();(0,M.$LC)(this,t),this.N(D),this.y();return}this.D(t,h),this.h.validate(n),this.N(t),this.y();return}if(c.nodeStartOffset+t.piece.length===n+i){this.C(t,y),this.O(t),this.y();return}this.E(t,y,h),this.y();return}const a=[],g=this.s(t,c.remainder);this.C(t,g),this.h.validate(n),t.piece.length===0&&a.push(t);const b=this.s(d,u.remainder);this.D(d,b),d.piece.length===0&&a.push(d);const p=t.next();for(let y=p;y!==M.$GC&&y!==d;y=y.next())a.push(y);const v=t.piece.length===0?t.prev():t;this.v(a),this.O(v),this.y()}o(n,i){const c=[];if(this.K()&&this.M(n)&&this.L(i)){const d=i.piece,a={line:d.start.line+1,column:0},g=new l(d.bufferIndex,a,d.end,this.t(d.bufferIndex,a,d.end),d.length-1);i.piece=g,n+=`
`,(0,M.$NC)(this,i,-1,-1),i.piece.length===0&&c.push(i)}const u=this.w(n);let t=this.T(i,u[u.length-1]);for(let d=u.length-2;d>=0;d--)t=this.T(t,u[d]);this.N(t),this.v(c)}q(n,i){this.Q(n,i)&&(n+=`
`);const c=this.w(n),u=this.S(i,c[0]);let t=u;for(let d=1;d<c.length;d++)t=this.S(t,c[d]);this.N(u)}s(n,i,c){const u=n.piece,t=n.piece.bufferIndex,d=this.a[t].lineStarts,g=d[u.start.line]+u.start.column+i;let b=u.start.line,p=u.end.line,v=0,y=0,h=0;for(;b<=p&&(v=b+(p-b)/2|0,h=d[v],v!==p);)if(y=d[v+1],g<h)p=v-1;else if(g>=y)b=v+1;else break;return c?(c.line=v,c.column=g-h,null):{line:v,column:g-h}}t(n,i,c){if(c.column===0)return c.line-i.line;const u=this.a[n].lineStarts;if(c.line===u.length-1)return c.line-i.line;const t=u[c.line+1],d=u[c.line]+c.column;if(t>d+1)return c.line-i.line;const a=d-1;return this.a[n].buffer.charCodeAt(a)===13?c.line-i.line+1:c.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,M.$LC)(this,n[i])}w(n){if(n.length>$){const p=[];for(;n.length>$;){const y=n.charCodeAt($-1);let h;y===13||y>=55296&&y<=56319?(h=n.substring(0,$-1),n=n.substring($-1)):(h=n.substring(0,$),n=n.substring($));const D=T(h);p.push(new l(this.a.length,{line:0,column:0},{line:D.length-1,column:h.length-D[D.length-1]},D.length-1,h.length)),this.a.push(new w(h,D))}const v=T(n);return p.push(new l(this.a.length,{line:0,column:0},{line:v.length-1,column:n.length-v[v.length-1]},v.length-1,n.length)),this.a.push(new w(n,v)),p}let i=this.a[0].buffer.length;const c=T(n,!1);let u=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},u=this.g;for(let p=0;p<c.length;p++)c[p]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let p=0;p<c.length;p++)c[p]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,a=t-this.a[0].lineStarts[d],g={line:d,column:a},b=new l(0,u,g,this.t(0,u,g),t-i);return this.g=g,[b]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let c=this.root,u="";const t=this.h.get2(n);if(t){c=t.node;const d=this.B(c,n-t.nodeStartLineNumber-1),a=this.a[c.piece.bufferIndex].buffer,g=this.u(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===n)u=a.substring(g+d,g+c.piece.length);else{const b=this.B(c,n-t.nodeStartLineNumber);return a.substring(g+d,g+b-i)}}else{let d=0;const a=n;for(;c!==M.$GC;)if(c.left!==M.$GC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const g=this.B(c,n-c.lf_left-2),b=this.B(c,n-c.lf_left-1),p=this.a[c.piece.bufferIndex].buffer,v=this.u(c.piece.bufferIndex,c.piece.start);return d+=c.size_left,this.h.set({node:c,nodeStartOffset:d,nodeStartLineNumber:a-(n-1-c.lf_left)}),p.substring(v+g,v+b-i)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const g=this.B(c,n-c.lf_left-2),b=this.a[c.piece.bufferIndex].buffer,p=this.u(c.piece.bufferIndex,c.piece.start);u=b.substring(p+g,p+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,d+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==M.$GC;){const d=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const a=this.B(c,0),g=this.u(c.piece.bufferIndex,c.piece.start);return u+=d.substring(g,g+a-i),u}else{const a=this.u(c.piece.bufferIndex,c.piece.start);u+=d.substr(a,c.piece.length)}c=c.next()}return u}y(){let n=this.root,i=1,c=0;for(;n!==M.$GC;)i+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=c,this.h.validate(this.c)}A(n,i){const c=n.piece,u=this.s(n,i),t=u.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===i){const d=this.t(n.piece.bufferIndex,c.start,u);if(d!==t)return{index:d,remainder:0}}return{index:t,remainder:u.column}}B(n,i){if(i<0)return 0;const c=n.piece,u=this.a[c.bufferIndex].lineStarts,t=c.start.line+i+1;return t>c.end.line?u[c.end.line]+c.end.column-u[c.start.line]-c.start.column:u[t]-u[c.start.line]-c.start.column}C(n,i){const c=n.piece,u=c.lineFeedCnt,t=this.u(c.bufferIndex,c.end),d=i,a=this.u(c.bufferIndex,d),g=this.t(c.bufferIndex,c.start,d),b=g-u,p=a-t,v=c.length+p;n.piece=new l(c.bufferIndex,c.start,d,g,v),(0,M.$NC)(this,n,p,b)}D(n,i){const c=n.piece,u=c.lineFeedCnt,t=this.u(c.bufferIndex,c.start),d=i,a=this.t(c.bufferIndex,d,c.end),g=this.u(c.bufferIndex,d),b=a-u,p=t-g,v=c.length+p;n.piece=new l(c.bufferIndex,d,c.end,a,v),(0,M.$NC)(this,n,p,b)}E(n,i,c){const u=n.piece,t=u.start,d=u.end,a=u.length,g=u.lineFeedCnt,b=i,p=this.t(u.bufferIndex,u.start,b),v=this.u(u.bufferIndex,i)-this.u(u.bufferIndex,t);n.piece=new l(u.bufferIndex,u.start,b,p,v),(0,M.$NC)(this,n,v-a,p-g);const y=new l(u.bufferIndex,c,d,this.t(u.bufferIndex,c,d),this.u(u.bufferIndex,d)-this.u(u.bufferIndex,c)),h=this.S(n,y);this.N(h)}F(n,i){this.Q(i,n)&&(i+=`
`);const c=this.K()&&this.L(i)&&this.M(n),u=this.a[0].buffer.length;this.a[0].buffer+=i;const t=T(i,!1);for(let h=0;h<t.length;h++)t[h]+=u;if(c){const h=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:u-h}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const d=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[d],g={line:d,column:a},b=n.piece.length+i.length,p=n.piece.lineFeedCnt,v=this.t(0,n.piece.start,g),y=v-p;n.piece=new l(n.piece.bufferIndex,n.piece.start,g,v,b),this.g=g,(0,M.$NC)(this,n,i.length,y)}G(n){let i=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let u=0;for(;i!==M.$GC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){u+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:u};return this.h.set(t),t}else n-=i.size_left+i.piece.length,u+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let c=this.root,u=0;for(;c!==M.$GC;)if(c.left!==M.$GC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const t=this.B(c,n-c.lf_left-2),d=this.B(c,n-c.lf_left-1);return u+=c.size_left,{node:c,remainder:Math.min(t+i-1,d),nodeStartOffset:u}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const t=this.B(c,n-c.lf_left-2);if(t+i-1<=c.piece.length)return{node:c,remainder:t+i-1,nodeStartOffset:u};i-=c.piece.length-t;break}else n-=c.lf_left+c.piece.lineFeedCnt,u+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==M.$GC;){if(c.piece.lineFeedCnt>0){const t=this.B(c,0),d=this.J(c);return{node:c,remainder:Math.min(i-1,t),nodeStartOffset:d}}else if(c.piece.length>=i-1){const t=this.J(c);return{node:c,remainder:i-1,nodeStartOffset:t}}else i-=c.piece.length;c=c.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],u=this.u(n.piece.bufferIndex,n.piece.start)+i;return c.buffer.charCodeAt(u)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===M.$GC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,c=this.a[i.bufferIndex].lineStarts,u=i.start.line,t=c[u]+i.start.column;return u===c.length-1||c[u+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===M.$GC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const c=[],u=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:u[n.piece.end.line]-u[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const d=n.piece.length-1,a=n.piece.lineFeedCnt-1;n.piece=new l(n.piece.bufferIndex,n.piece.start,t,a,d),(0,M.$NC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const g={line:i.piece.start.line+1,column:0},b=i.piece.length-1,p=this.t(i.piece.bufferIndex,g,i.piece.end);i.piece=new l(i.piece.bufferIndex,g,i.piece.end,p,b),(0,M.$NC)(this,i,-1,-1),i.piece.length===0&&c.push(i);const v=this.w(`\r
`);this.S(n,v[0]);for(let y=0;y<c.length;y++)(0,M.$LC)(this,c[y])}Q(n,i){if(this.K()&&this.M(n)){const c=i.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,M.$LC)(this,c);else{const u=c.piece,t={line:u.start.line+1,column:0},d=u.length-1,a=this.t(u.bufferIndex,t,u.end);c.piece=new l(u.bufferIndex,t,u.end,a,d),(0,M.$NC)(this,c,-1,-1)}return!0}}return!1}iterate(n,i){if(n===M.$GC)return i(M.$GC);const c=this.iterate(n.left,i);return c&&i(n)&&this.iterate(n.right,i)}R(n){if(n===M.$GC)return"";const i=this.a[n.piece.bufferIndex],c=n.piece,u=this.u(c.bufferIndex,c.start),t=this.u(c.bufferIndex,c.end);return i.buffer.substring(u,t)}getPieceContent(n){const i=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),u=this.u(n.bufferIndex,n.end);return i.buffer.substring(c,u)}S(n,i){const c=new M.$FC(i,1);if(c.left=M.$GC,c.right=M.$GC,c.parent=M.$GC,c.size_left=0,c.lf_left=0,this.root===M.$GC)this.root=c,c.color=0;else if(n.right===M.$GC)n.right=c,c.parent=n;else{const t=(0,M.$HC)(n.right);t.left=c,c.parent=t}return(0,M.$MC)(this,c),c}T(n,i){const c=new M.$FC(i,1);if(c.left=M.$GC,c.right=M.$GC,c.parent=M.$GC,c.size_left=0,c.lf_left=0,this.root===M.$GC)this.root=c,c.color=0;else if(n.left===M.$GC)n.left=c,c.parent=n;else{const u=(0,M.$IC)(n.left);u.right=c,c.parent=u}return(0,M.$MC)(this,c),c}U(n){let i="";return this.iterate(n,c=>(i+=this.R(c),!0)),i}}e.$ZC=r}),define(Se[143],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w$=e.$v$=void 0;class C{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const A=this.a.get(M);return this.a.delete(M),A}}addDragOperationTransfer(M,A){this.a.set(M,A)}}e.$v$=C;class O{constructor(M){this.identifier=M}}e.$w$=O}),define(Se[144],Pe([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(Se[145],Pe([1,0,5,6,144]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=void 0,e.$gj=T;class M extends O.$Uc{constructor(l,w="",f="",s=!0,r){super(),this.h=this.B(new C.$de),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=w,this.u=f,this.w=s,this.C=r}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,w){this.C&&await this.C(l)}}e.$bj=M;class A extends O.$Uc{constructor(){super(...arguments),this.f=this.B(new C.$de),this.onWillRun=this.f.event,this.m=this.B(new C.$de),this.onDidRun=this.m.event}async run(l,w){if(!l.enabled)return;this.f.fire({action:l});let f;try{await this.u(l,w)}catch(s){f=s}this.m.fire({action:l,error:f})}async u(l,w){await l.run(w)}}e.$cj=A;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let w=[];for(const f of l)f.length&&(w.length?w=[...w,new $,...f]:w=f);return w}static{this.ID="vs.actions.separator"}async run(){}}e.$dj=$;class m{get actions(){return this.a}constructor(l,w,f,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=w,this.class=s,this.a=f}async run(){}}e.$ej=m;class E extends M{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,R.localize(0,null),void 0,!1)}}e.$fj=E;function T(k){return{id:k.id,label:k.label,class:k.class,enabled:k.enabled??!0,checked:k.checked,run:async(...l)=>k.run(...l),tooltip:k.label}}}),define(Se[146],Pe([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(Se[147],Pe([1,0,146]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=E,e.$3m=T,e.$4m=k;const O=60,R=O*60,M=R*24,A=M*7,$=M*30,m=M*365;function E(l,w,f,s){typeof l!="number"&&(l=l.getTime());const r=Math.round((new Date().getTime()-l)/1e3);if(r<-30)return(0,C.localize)(0,null,E(new Date().getTime()+r*1e3,!1));if(!s&&r<30)return(0,C.localize)(1,null);let o;return r<O?(o=r,w?o===1?f?(0,C.localize)(2,null,o):(0,C.localize)(3,null,o):f?(0,C.localize)(4,null,o):(0,C.localize)(5,null,o):o===1?f?(0,C.localize)(6,null,o):(0,C.localize)(7,null,o):f?(0,C.localize)(8,null,o):(0,C.localize)(9,null,o)):r<R?(o=Math.floor(r/O),w?o===1?f?(0,C.localize)(10,null,o):(0,C.localize)(11,null,o):f?(0,C.localize)(12,null,o):(0,C.localize)(13,null,o):o===1?f?(0,C.localize)(14,null,o):(0,C.localize)(15,null,o):f?(0,C.localize)(16,null,o):(0,C.localize)(17,null,o)):r<M?(o=Math.floor(r/R),w?o===1?f?(0,C.localize)(18,null,o):(0,C.localize)(19,null,o):f?(0,C.localize)(20,null,o):(0,C.localize)(21,null,o):o===1?f?(0,C.localize)(22,null,o):(0,C.localize)(23,null,o):f?(0,C.localize)(24,null,o):(0,C.localize)(25,null,o)):r<A?(o=Math.floor(r/M),w?o===1?(0,C.localize)(26,null,o):(0,C.localize)(27,null,o):o===1?(0,C.localize)(28,null,o):(0,C.localize)(29,null,o)):r<$?(o=Math.floor(r/A),w?o===1?f?(0,C.localize)(30,null,o):(0,C.localize)(31,null,o):f?(0,C.localize)(32,null,o):(0,C.localize)(33,null,o):o===1?f?(0,C.localize)(34,null,o):(0,C.localize)(35,null,o):f?(0,C.localize)(36,null,o):(0,C.localize)(37,null,o)):r<m?(o=Math.floor(r/$),w?o===1?f?(0,C.localize)(38,null,o):(0,C.localize)(39,null,o):f?(0,C.localize)(40,null,o):(0,C.localize)(41,null,o):o===1?f?(0,C.localize)(42,null,o):(0,C.localize)(43,null,o):f?(0,C.localize)(44,null,o):(0,C.localize)(45,null,o)):(o=Math.floor(r/m),w?o===1?f?(0,C.localize)(46,null,o):(0,C.localize)(47,null,o):f?(0,C.localize)(48,null,o):(0,C.localize)(49,null,o):o===1?f?(0,C.localize)(50,null,o):(0,C.localize)(51,null,o):f?(0,C.localize)(52,null,o):(0,C.localize)(53,null,o))}function T(l,w){const f=Math.abs(l/1e3);return f<1?w?(0,C.localize)(54,null,l):(0,C.localize)(55,null,l):f<O?w?(0,C.localize)(56,null,Math.round(l)/1e3):(0,C.localize)(57,null,Math.round(l)/1e3):f<R?w?(0,C.localize)(58,null,Math.round(l/(1e3*O))):(0,C.localize)(59,null,Math.round(l/(1e3*O))):f<M?w?(0,C.localize)(60,null,Math.round(l/(1e3*R))):(0,C.localize)(61,null,Math.round(l/(1e3*R))):(0,C.localize)(62,null,Math.round(l/(1e3*M)))}function k(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Se[148],Pe([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(Se[44],Pe([1,0,18,15,148]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=m,e.$ij=E,e.$jj=T;function M(k,l){return l&&(k.stack||k.stacktrace)?R.localize(0,null,$(k),A(k.stack)||A(k.stacktrace)):$(k)}function A(k){return Array.isArray(k)?k.join(`
`):k}function $(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?R.localize(1,null,k.message):k.message||R.localize(2,null)}function m(k=null,l=!1){if(!k)return R.localize(3,null);if(Array.isArray(k)){const w=C.$Hb(k),f=m(w[0],l);return w.length>1?R.localize(4,null,f,w.length):f}if(O.$9f(k))return k;if(k.detail){const w=k.detail;if(w.error)return M(w.error,l);if(w.exception)return M(w.exception,l)}return k.stack?M(k,l):k.message?k.message:R.localize(5,null)}function E(k){const l=k;return l instanceof Error&&Array.isArray(l.actions)}function T(k,l){let w;return typeof k=="string"?w=new Error(k):w=k,w.actions=l,w}}),define(Se[149],Pe([1,0,43,19]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=$,e.$hr=m,e.$ir=E,e.$jr=T,e.$kr=k,e.$lr=l,e.$mr=w,e.$nr=f,e.$or=s,e.$pr=r,e.$qr=b,e.$rr=p,e.$sr=v;const R=new C.$V(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),M=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(y,h,D=!1){const S=y||"",I=h||"",P=R.value.collator.compare(S,I);return R.value.collatorIsNumeric&&P===0&&S!==I?S<I?-1:1:P}function m(y,h){const D=M.value.collator;return y=y||"",h=h||"",c(D,y,h)}function E(y,h){const D=M.value.collator;return y=y||"",h=h||"",a(y,h)||c(D,y,h)}function T(y,h){const D=M.value.collator;return y=y||"",h=h||"",d(y,h)||c(D,y,h)}function k(y,h){return y=y||"",h=h||"",y===h?0:y<h?-1:1}function l(y,h){const[D,S]=n(y),[I,P]=n(h);let W=R.value.collator.compare(S,P);if(W===0){if(R.value.collatorIsNumeric&&S!==P)return S<P?-1:1;if(W=R.value.collator.compare(D,I),R.value.collatorIsNumeric&&W===0&&D!==I)return D<I?-1:1}return W}function w(y,h){y=y||"",h=h||"";const D=i(y),S=i(h),I=M.value.collator,P=A.value.collator;return c(P,D,S)||c(I,y,h)}function f(y,h){y=y||"",h=h||"";const D=i(y),S=i(h),I=M.value.collator,P=A.value.collator;return c(P,D,S)||a(y,h)||c(I,y,h)}function s(y,h){y=y||"",h=h||"";const D=i(y),S=i(h),I=M.value.collator,P=A.value.collator;return c(P,D,S)||d(y,h)||c(I,y,h)}function r(y,h){y=y||"",h=h||"";const D=i(y).toLowerCase(),S=i(h).toLowerCase();return D!==S?D<S?-1:1:y!==h?y<h?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function n(y,h=!1){const D=y?o.exec(y):[];let S=[D&&D[1]||"",D&&D[3]||""];return h&&(!S[0]&&S[1]||S[0]&&S[0].charAt(0)===".")&&(S=[S[0]+"."+S[1],""]),S}function i(y){const h=y?o.exec(y):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function c(y,h,D){const S=y.compare(h,D);return S!==0?S:h.length!==D.length?h.length<D.length?-1:1:0}function u(y){const h=y.charAt(0);return h.toLocaleUpperCase()!==h}function t(y){const h=y.charAt(0);return h.toLocaleLowerCase()!==h}function d(y,h){return u(y)&&t(h)?-1:t(y)&&u(h)?1:0}function a(y,h){return t(y)&&u(h)?-1:u(y)&&t(h)?1:0}function g(y,h,D=!1){return D||(y=y&&y.toLowerCase(),h=h&&h.toLowerCase()),y===h?0:y<h?-1:1}function b(y,h,D=!1){const S=y.split(O.sep),I=h.split(O.sep),P=S.length-1,W=I.length-1;let V,q;for(let N=0;;N++){if(V=P===N,q=W===N,V&&q)return $(S[N],I[N],D);if(V)return-1;if(q)return 1;const B=g(S[N],I[N],D);if(B!==0)return B}}function p(y,h,D){const S=y.toLowerCase(),I=h.toLowerCase(),P=v(y,h,D);if(P)return P;const W=S.endsWith(D),V=I.endsWith(D);if(W!==V)return W?-1:1;const q=$(S,I);return q!==0?q:S.localeCompare(I)}function v(y,h,D){const S=y.toLowerCase(),I=h.toLowerCase(),P=S.startsWith(D),W=I.startsWith(D);if(P!==W)return P?-1:1;if(P&&W){if(S.length<I.length)return-1;if(S.length>I.length)return 1}return 0}}),define(Se[48],Pe([1,0,19,22,13,15]),function(le,e,C,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=A,e.$pg=$,e.$qg=m,e.$rg=E,e.$sg=T,e.$tg=f,e.$ug=s,e.$vg=r,e.$wg=o,e.$xg=n,e.$yg=i,e.$zg=c,e.$Ag=u,e.$Bg=t,e.$Cg=d,e.$Dg=a,e.$Eg=p;function A(v){return v===47||v===92}function $(v){return v.replace(/[\\/]/g,C.$gc.sep)}function m(v){return v.indexOf("/")===-1&&(v=$(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}function E(v,y=C.$gc.sep){if(!v)return"";const h=v.length,D=v.charCodeAt(0);if(A(D)){if(A(v.charCodeAt(1))&&!A(v.charCodeAt(2))){let I=3;const P=I;for(;I<h&&!A(v.charCodeAt(I));I++);if(P!==I&&!A(v.charCodeAt(I+1))){for(I+=1;I<h;I++)if(A(v.charCodeAt(I)))return v.slice(0,I+1).replace(/[\\/]/g,y)}}return y}else if(o(D)&&v.charCodeAt(1)===58)return A(v.charCodeAt(2))?v.slice(0,2)+y:v.slice(0,2);let S=v.indexOf("://");if(S!==-1){for(S+=3;S<h;S++)if(A(v.charCodeAt(S)))return v.slice(0,S+1)}return""}function T(v){if(!O.$i||!v||v.length<5)return!1;let y=v.charCodeAt(0);if(y!==92||(y=v.charCodeAt(1),y!==92))return!1;let h=2;const D=h;for(;h<v.length&&(y=v.charCodeAt(h),y!==92);h++);return!(D===h||(y=v.charCodeAt(h+1),isNaN(y)||y===92))}const k=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(v,y=O.$i){const h=y?k:l;return!(!v||v.length===0||/^\s+$/.test(v)||(h.lastIndex=0,h.test(v))||y&&w.test(v)||v==="."||v===".."||y&&v[v.length-1]==="."||y&&v.length!==v.trim().length||v.length>255)}function s(v,y,h){const D=v===y;return!h||D?D:!v||!y?!1:(0,R.$xf)(v,y)}function r(v,y,h,D=C.sep){if(v===y)return!0;if(!v||!y||y.length>v.length)return!1;if(h){if(!(0,R.$yf)(v,y))return!1;if(y.length===v.length)return!0;let I=y.length;return y.charAt(y.length-1)===D&&I--,v.charAt(I)===D}return y.charAt(y.length-1)!==D&&(y+=D),v.indexOf(y)===0}function o(v){return v>=65&&v<=90||v>=97&&v<=122}function n(v,y){return O.$i&&v.endsWith(":")&&(v+=C.sep),(0,C.$ic)(v)||(v=(0,C.$jc)(y,v)),v=(0,C.$hc)(v),i(v)}function i(v){return O.$i?(v=(0,R.$ff)(v,C.sep),v.endsWith(":")&&(v+=C.sep)):(v=(0,R.$ff)(v,C.sep),v||(v=C.sep)),v}function c(v){const y=(0,C.$hc)(v);return O.$i?v.length>3?!1:u(y)&&(v.length===2||y.charCodeAt(2)===92):y===C.$gc.sep}function u(v,y=O.$i){return y?o(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}function t(v,y=O.$i){return u(v,y)?v[0]:void 0}function d(v,y,h){return y.length>v.length?-1:v===y?0:(h&&(v=v.toLowerCase(),y=y.toLowerCase()),v.indexOf(y))}function a(v){const y=v.split(":");let h,D,S;for(const I of y){const P=Number(I);(0,M.$ag)(P)?D===void 0?D=P:S===void 0&&(S=P):h=h?[h,I].join(":"):I}if(!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:D!==void 0?D:void 0,column:S!==void 0?S:D!==void 0?1:void 0}}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",b="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function p(v,y,h=8){let D="";for(let I=0;I<h;I++){let P;I===0&&O.$i&&!y&&(h===3||h===4)?P=b:P=g,D+=P.charAt(Math.floor(Math.random()*P.length))}let S;return y?S=`${y}-${D}`:S=D,v?(0,C.$jc)(v,S):S}}),define(Se[70],Pe([1,0,19]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0,e.$Rs=M,e.$Ss=A,e.$Ts=$,e.$Us=E,e.$Qs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(T){const k=(0,C.$oc)(T),l=O[k.toLowerCase()];return l!==void 0?l:A(T)}function A(T){const k=(0,C.$oc)(T);return R[k.toLowerCase()]}function $(T){for(const k in R)if(R[k]===T)return k}const m=/^(.+)\/(.+?)(;.+)?$/;function E(T,k){const l=m.exec(T);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:k?void 0:T}}),define(Se[49],Pe([1,0,21,2]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=R,e.$5h=M,e.$6h=$;function R(m){return JSON.stringify(m,A)}function M(m){let E=JSON.parse(m);return E=$(E),E}function A(m,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function $(m,E=0){if(!m||E>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return O.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof C.$Fe||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let T=0;T<m.length;++T)m[T]=$(m[T],E+1);else for(const T in m)Object.hasOwnProperty.call(m,T)&&(m[T]=$(m[T],E+1))}return m}}),define(Se[16],Pe([1,0,14,22,13,2,19]),function(le,e,C,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Jg=e.$Ig=e.$Hg=e.Schemas=void 0,e.$Fg=m,e.$Gg=E,e.$Kg=k;var $;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})($||(e.Schemas=$={}));function m(f,s){return M.URI.isUri(f)?(0,R.$xf)(f.scheme,s):(0,R.$yf)(f,s+":")}function E(f,...s){return s.some(r=>m(f,r))}e.$Hg="vscode-tkn",e.$Ig="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,r){this.f=k(s,r)}getServerRootPath(){return this.f}get g(){return A.$gc.join(this.f,$.vscodeRemoteResource)}set(s,r,o){this.a[s]=r,this.b[s]=o}setConnectionToken(s,r){this.c[s]=r}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(u){return C.$1(u),s}const r=s.authority;let o=this.a[r];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const n=this.b[r],i=this.c[r];let c=`path=${encodeURIComponent(s.path)}`;return typeof i=="string"&&(c+=`&${e.$Ig}=${encodeURIComponent(i)}`),M.URI.from({scheme:O.$o?this.d:$.vscodeRemoteResource,authority:`${o}:${n}`,path:this.g,query:c})}}e.$Jg=new T;function k(f,s){return A.$gc.join(s??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Lg="vs/../../extensions",e.$Mg="vs/../../node_modules",e.$Ng="vs/../../node_modules.asar",e.$Og="vs/../../node_modules.asar.unpacked",e.$Pg="vscode-app";class l{static{this.a=e.$Pg}asBrowserUri(s){const r=this.b(s,le);return this.uriToBrowserUri(r)}uriToBrowserUri(s){return s.scheme===$.vscodeRemote?e.$Jg.rewrite(s):s.scheme===$.file&&(O.$m||O.$q===`${$.vscodeFileResource}://${l.a}`)?s.with({scheme:$.vscodeFileResource,authority:s.authority||l.a,query:null,fragment:null}):s}asFileUri(s){const r=this.b(s,le);return this.uriToFileUri(r)}uriToFileUri(s){return s.scheme===$.vscodeFileResource?s.with({scheme:$.file,authority:s.authority!==l.a?s.authority:null,query:null,fragment:null}):s}b(s,r){return M.URI.isUri(s)?s:M.URI.parse(r.toUrl(s))}}e.$Qg=new l;var w;(function(f){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(s.get("3"));const r="vscode-coi";function o(i){let c;typeof i=="string"?c=new URL(i).searchParams:i instanceof URL?c=i.searchParams:M.URI.isUri(i)&&(c=new URL(i.toString(!0)).searchParams);const u=c?.get(r);if(u)return s.get(u)}f.getHeadersFromQuery=o;function n(i,c,u){if(!globalThis.crossOriginIsolated)return;const t=c&&u?"3":u?"2":"1";i instanceof URLSearchParams?i.set(r,t):i[r]=t}f.addSearchParam=n})(w||(e.COI=w={}))}),define(Se[23],Pe([1,0,48,16,19,22,13,2]),function(le,e,C,O,R,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=void 0,e.$Xg=m,e.$gh=T,e.$hh=l;function m(w){return(0,$.$wc)(w,!0)}class E{constructor(f){this.a=f}compare(f,s,r=!1){return f===s?0:(0,A.$qf)(this.getComparisonKey(f,r),this.getComparisonKey(s,r))}isEqual(f,s,r=!1){return f===s?!0:!f||!s?!1:this.getComparisonKey(f,r)===this.getComparisonKey(s,r)}getComparisonKey(f,s=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,s,r=!1){if(f.scheme===s.scheme){if(f.scheme===O.Schemas.file)return C.$vg(m(f),m(s),this.a(f))&&f.query===s.query&&(r||f.fragment===s.fragment);if((0,e.$ch)(f.authority,s.authority))return C.$vg(f.path,s.path,this.a(f),"/")&&f.query===s.query&&(r||f.fragment===s.fragment)}return!1}joinPath(f,...s){return $.URI.joinPath(f,...s)}basenameOrAuthority(f){return(0,e.$7g)(f)||f.authority}basename(f){return R.$gc.basename(f.path)}extname(f){return R.$gc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let s;return f.scheme===O.Schemas.file?s=$.URI.file(R.$mc(m(f))).path:(s=R.$gc.dirname(f.path),f.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),s="/")),f.with({path:s})}normalizePath(f){if(!f.path.length)return f;let s;return f.scheme===O.Schemas.file?s=$.URI.file(R.$hc(m(f))).path:s=R.$gc.normalize(f.path),f.with({path:s})}relativePath(f,s){if(f.scheme!==s.scheme||!(0,e.$ch)(f.authority,s.authority))return;if(f.scheme===O.Schemas.file){const n=R.$lc(m(f),m(s));return M.$i?C.$pg(n):n}let r=f.path||"/";const o=s.path||"/";if(this.a(f)){let n=0;for(const i=Math.min(r.length,o.length);n<i&&!(r.charCodeAt(n)!==o.charCodeAt(n)&&r.charAt(n).toLowerCase()!==o.charAt(n).toLowerCase());n++);r=o.substr(0,n)+r.substr(n)}return R.$gc.relative(r,o)}resolvePath(f,s){if(f.scheme===O.Schemas.file){const r=$.URI.file(R.$kc(m(f),s));return f.with({authority:r.authority,path:r.path})}return s=C.$qg(s),f.with({path:R.$gc.resolve(f.path,s)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,s){return f===s||f!==void 0&&s!==void 0&&(0,A.$xf)(f,s)}hasTrailingPathSeparator(f,s=R.sep){if(f.scheme===O.Schemas.file){const r=m(f);return r.length>C.$rg(r).length&&r[r.length-1]===s}else{const r=f.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,s=R.sep){return(0,e.$dh)(f,s)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,s=R.sep){let r=!1;if(f.scheme===O.Schemas.file){const o=m(f);r=o!==void 0&&o.length===C.$rg(o).length&&o[o.length-1]===s}else{s="/";const o=f.path;r=o.length===1&&o.charCodeAt(o.length-1)===47}return!r&&!(0,e.$dh)(f,s)?f.with({path:f.path+"/"}):f}}e.$Yg=E,e.$Zg=new E(()=>!1),e.$1g=new E(w=>w.scheme===O.Schemas.file?!M.$k:!0),e.$2g=new E(w=>!0),e.$3g=e.$Zg.isEqual.bind(e.$Zg),e.$4g=e.$Zg.isEqualOrParent.bind(e.$Zg),e.$5g=e.$Zg.getComparisonKey.bind(e.$Zg),e.$6g=e.$Zg.basenameOrAuthority.bind(e.$Zg),e.$7g=e.$Zg.basename.bind(e.$Zg),e.$8g=e.$Zg.extname.bind(e.$Zg),e.$9g=e.$Zg.dirname.bind(e.$Zg),e.$0g=e.$Zg.joinPath.bind(e.$Zg),e.$$g=e.$Zg.normalizePath.bind(e.$Zg),e.$_g=e.$Zg.relativePath.bind(e.$Zg),e.$ah=e.$Zg.resolvePath.bind(e.$Zg),e.$bh=e.$Zg.isAbsolutePath.bind(e.$Zg),e.$ch=e.$Zg.isEqualAuthority.bind(e.$Zg),e.$dh=e.$Zg.hasTrailingPathSeparator.bind(e.$Zg),e.$eh=e.$Zg.removeTrailingPathSeparator.bind(e.$Zg),e.$fh=e.$Zg.addTrailingPathSeparator.bind(e.$Zg);function T(w,f){const s=[];for(let r=0;r<w.length;r++){const o=f(w[r]);w.some((n,i)=>i===r?!1:(0,e.$4g)(o,f(n)))||s.push(w[r])}return s}var k;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function f(s){const r=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(i=>{const[c,u]=i.split(":");c&&u&&r.set(c,u)});const n=s.path.substring(0,s.path.indexOf(";"));return n&&r.set(w.META_DATA_MIME,n),r}w.parseMetaData=f})(k||(e.DataUri=k={}));function l(w,f,s){if(f){let r=w.path;return r&&r[0]!==R.$gc.sep&&(r=R.$gc.sep+r),w.with({scheme:s,authority:f,path:r})}return w.with({scheme:s})}}),define(Se[11],Pe([1,0,24,14,5,6,23,22,136,43]),function(le,e,C,O,R,M,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.Promises=e.$Th=e.$Sh=e.$Rh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0,e.$ih=T,e.$jh=k,e.$kh=l,e.$lh=w,e.$mh=f,e.$nh=s,e.$oh=r,e.$ph=o,e.$xh=p,e.$yh=v,e.$zh=y,e.$Ah=h,e.$Bh=D,e.$Qh=ke,e.$Yh=De;function T(ge){return!!ge&&typeof ge.then=="function"}function k(ge){const Q=new C.$oe,Y=ge(Q.token),he=new Promise((ue,Me)=>{const de=Q.token.onCancellationRequested(()=>{de.dispose(),Me(new O.$5)});Promise.resolve(Y).then(Ce=>{de.dispose(),Q.dispose(),ue(Ce)},Ce=>{de.dispose(),Q.dispose(),Me(Ce)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(ue,Me){return he.then(ue,Me)}catch(ue){return this.then(void 0,ue)}finally(ue){return he.finally(ue)}}}function l(ge,Q,Y){return new Promise((he,ue)=>{const Me=Q.onCancellationRequested(()=>{Me.dispose(),he(Y)});ge.then(he,ue).finally(()=>Me.dispose())})}function w(ge,Q){return new Promise((Y,he)=>{const ue=Q.onCancellationRequested(()=>{ue.dispose(),he(new O.$5)});ge.then(Y,he).finally(()=>ue.dispose())})}async function f(ge){let Q=-1;const Y=ge.map((he,ue)=>he.then(Me=>(Q=ue,Me)));try{return await Promise.race(Y)}finally{ge.forEach((he,ue)=>{ue!==Q&&he.cancel()})}}function s(ge,Q,Y){let he;const ue=setTimeout(()=>{he?.(void 0),Y?.()},Q);return Promise.race([ge.finally(()=>clearTimeout(ue)),new Promise(Me=>he=Me)])}function r(ge){return new Promise((Q,Y)=>{const he=ge();T(he)?he.then(Q,Y):Q(he)})}function o(){let ge,Q;return{promise:new Promise((he,ue)=>{ge=he,Q=ue}),resolve:ge,reject:Q}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const Y=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Y,Y).then(he)})}return new Promise((Y,he)=>{this.b.then(Y,he)})}return this.a=Q(),new Promise((Y,he)=>{this.a.then(ue=>{this.a=null,Y(ue)},ue=>{this.a=null,he(ue)})})}dispose(){this.f=!0}}e.$qh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$rh=i;class c{constructor(){this.a=new Map}queue(Q,Y){const ue=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(Q)===ue&&this.a.delete(Q)});return this.a.set(Q,ue),ue}}e.$sh=c;const u=(ge,Q)=>{let Y=!0;const he=setTimeout(()=>{Y=!1,Q()},ge);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(he),Y=!1}}},t=ge=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,ge())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class d{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,Y=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((ue,Me)=>{this.d=ue,this.f=Me}).then(()=>{if(this.b=null,this.d=null,this.g){const ue=this.g;return this.g=null,ue()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Y===m.$ae?t(he):u(Y,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$th=d;class a{constructor(Q){this.a=new d(Q),this.b=new n}trigger(Q,Y){return this.a.trigger(()=>this.b.queue(Q),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$uh=a;class g{constructor(){this.a=!1,this.b=new Promise((Q,Y)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$vh=g;class b extends g{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$wh=b;function p(ge,Q){return Q?new Promise((Y,he)=>{const ue=setTimeout(()=>{Me.dispose(),Y()},ge),Me=Q.onCancellationRequested(()=>{clearTimeout(ue),Me.dispose(),he(new O.$5)})}):k(Y=>p(ge,Y))}function v(ge,Q=0,Y){const he=setTimeout(()=>{ge(),Y&&ue.dispose()},Q),ue=(0,M.$Sc)(()=>{clearTimeout(he),Y?.deleteAndLeak(ue)});return Y?.add(ue),ue}function y(ge){const Q=[];let Y=0;const he=ge.length;function ue(){return Y<he?ge[Y++]():null}function Me(de){de!=null&&Q.push(de);const Ce=ue();return Ce?Ce.then(Me):Promise.resolve(Q)}return Promise.resolve(null).then(Me)}function h(ge,Q=he=>!!he,Y=null){let he=0;const ue=ge.length,Me=()=>{if(he>=ue)return Promise.resolve(Y);const de=ge[he++];return Promise.resolve(de()).then(Ae=>Q(Ae)?Promise.resolve(Ae):Me())};return Me()}function D(ge,Q=he=>!!he,Y=null){if(ge.length===0)return Promise.resolve(Y);let he=ge.length;const ue=()=>{he=-1;for(const Me of ge)Me.cancel?.()};return new Promise((Me,de)=>{for(const Ce of ge)Ce.then(Ae=>{--he>=0&&Q(Ae)?(ue(),Me(Ae)):he===0&&Me(Y)}).catch(Ae=>{--he>=0&&(ue(),de(Ae))})})}class S{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new R.$de}whenIdle(){return this.size>0?R.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,he)=>{this.g.push({factory:Q,c:Y,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const Y=Q.factory();Y.then(Q.c,Q.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ch=S;class I extends S{constructor(){super(1)}}e.$Dh=I;class P{constructor(){this.a=new fe,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$Eh=P;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new ae;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,Y=A.$Zg){const he=Y.getComparisonKey(Q);return this.a.get(he)?.size??0}queueFor(Q,Y,he=A.$Zg){const ue=he.getComparisonKey(Q);let Me=this.a.get(ue);if(!Me){Me=new I;const de=this.f++,Ce=R.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(ue),this.h(),this.d?.deleteAndDispose(de),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$4c),this.d.set(de,Ce),this.a.set(ue,Me)}return Me.queue(Y)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Fh=W;class V{constructor(Q,Y){this.a=-1,typeof Q=="function"&&typeof Y=="number"&&this.setIfNotSet(Q,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},Y)}setIfNotSet(Q,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},Y))}}e.$Gh=V;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,Y,he=globalThis){this.cancel();const ue=he.setInterval(()=>{Q()},Y);this.d=(0,M.$Sc)(()=>{he.clearInterval(ue),this.d=void 0})}dispose(){this.cancel()}}e.$Hh=q;class N{constructor(Q,Y){this.b=-1,this.a=Q,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ih=N;class B{constructor(Q,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=Q,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Jh=B;class K extends N{constructor(Q,Y){super(Q,Y),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Kh=K;class ie extends M.$Uc{constructor(Q,Y){super(),this.g=Q,this.h=Y,this.a=[],this.b=this.B(new M.$Vc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of Q)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new N(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Lh=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Nh=(ge,Q)=>{(0,$.$B)(()=>{if(Y)return;const he=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$Nh=(ge,Q,Y)=>{const he=ge.requestIdleCallback(Q,typeof Y=="number"?{timeout:Y}:void 0);let ue=!1;return{dispose(){ue||(ue=!0,ge.cancelIdleCallback(he))}}},e.$Mh=ge=>(0,e.$Nh)(globalThis,ge)}();class ce{constructor(Q,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Nh)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Oh=ce;class ye extends ce{constructor(Q){super(globalThis,Q)}}e.$Ph=ye;async function ke(ge,Q,Y){let he;for(let ue=0;ue<Y;ue++)try{return await ge()}catch(Me){he=Me,await p(Q)}throw he}class fe{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,Y,he){return this.a={taskId:Q,cancel:()=>he?.(),promise:Y},Y.then(()=>this.d(Q),()=>this.d(Q)),Y}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:Y,resolve:he,reject:ue}=o();this.b={run:Q,promise:Y,promiseResolve:he,promiseReject:ue}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Rh=fe;class $e{constructor(Q,Y=()=>Date.now()){this.d=Q,this.f=Y,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Sh=$e;var Te;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(Te||(Te={}));class ae{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,Y)=>{this.a=Q,this.b=Y})}complete(Q){return new Promise(Y=>{this.a(Q),this.d={outcome:0,value:Q},Y()})}error(Q){return new Promise(Y=>{this.b(Q),this.d={outcome:1,value:Q},Y()})}cancel(){return this.error(new O.$5)}}e.$Th=ae;var Ne;(function(ge){async function Q(he){let ue;const Me=await Promise.all(he.map(de=>de.then(Ce=>Ce,Ce=>{ue||(ue=Ce)})));if(typeof ue<"u")throw ue;return Me}ge.settled=Q;function Y(he){return new Promise(async(ue,Me)=>{try{await he(ue,Me)}catch(de){Me(de)}})}ge.withAsyncBody=Y})(Ne||(e.Promises=Ne={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Uh=ne;class z{constructor(Q){this.b=Q,this.a=new E.$V(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Vh=z;var x;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(x||(x={}));class be{static fromArray(Q){return new be(Y=>{Y.emitMany(Q)})}static fromPromise(Q){return new be(async Y=>{Y.emitMany(await Q)})}static fromPromises(Q){return new be(async Y=>{await Promise.all(Q.map(async he=>Y.emitOne(await he)))})}static merge(Q){return new be(async Y=>{await Promise.all(Q.map(async he=>{for await(const ue of he)Y.emitOne(ue)}))})}static{this.EMPTY=be.fromArray([])}constructor(Q,Y){this.a=0,this.b=[],this.d=null,this.f=Y,this.g=new R.$de,queueMicrotask(async()=>{const he={emitOne:ue=>this.h(ue),emitMany:ue=>this.j(ue),reject:ue=>this.l(ue)};try{await Promise.resolve(Q(he)),this.k()}catch(ue){this.l(ue)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await R.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Q,Y){return new be(async he=>{for await(const ue of Q)he.emitOne(Y(ue))})}map(Q){return be.map(this,Q)}static filter(Q,Y){return new be(async he=>{for await(const ue of Q)Y(ue)&&he.emitOne(ue)})}filter(Q){return be.filter(this,Q)}static coalesce(Q){return be.filter(Q,Y=>!!Y)}coalesce(){return be.coalesce(this)}static async toPromise(Q){const Y=[];for await(const he of Q)Y.push(he);return Y}toPromise(){return be.toPromise(this)}h(Q){this.a===0&&(this.b.push(Q),this.g.fire())}j(Q){this.a===0&&(this.b=this.b.concat(Q),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Q){this.a===0&&(this.a=2,this.d=Q,this.g.fire())}}e.$Wh=be;class Fe extends be{constructor(Q,Y){super(Y),this.m=Q}cancel(){this.m.cancel()}}e.$Xh=Fe;function De(ge){const Q=new C.$oe,Y=ge(Q.token);return new Fe(Q,async he=>{const ue=Q.token.onCancellationRequested(()=>{ue.dispose(),Q.dispose(),he.reject(new O.$5)});try{for await(const Me of Y){if(Q.token.isCancellationRequested)return;he.emitOne(Me)}ue.dispose(),Q.dispose()}catch(Me){ue.dispose(),Q.dispose(),he.reject(Me)}})}class pe{constructor(Q){this.a=new ae,this.b=new be(ue=>{if(Y){ue.reject(Y);return}return he&&ue.emitMany(he),this.d=Me=>ue.reject(Me),this.f=Me=>ue.emitOne(Me),this.a.p},Q);let Y,he;this.f=ue=>{he||(he=[]),he.push(ue)},this.d=ue=>{Y||(Y=ue)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$Zh=pe}),define(Se[37],Pe([1,0,18,11,48,28,19,22,13]),function(le,e,C,O,R,M,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nk=e.$mk=void 0,e.$lk=E,e.$ok=f,e.$pk=I,e.$qk=P,e.$rk=W,e.$sk=V,e.$tk=q,e.$uk=ie;function E(){return Object.create(null)}e.$mk="**",e.$nk="/";const T="[/\\\\]",k="[^/\\\\]",l=/\//g;function w(ce,ye){switch(ce){case 0:return"";case 1:return`${k}*?`;default:return`(?:${T}|${k}+${T}${ye?`|${T}${k}+`:""})*?`}}function f(ce,ye){if(!ce)return[];const ke=[];let fe=!1,$e=!1,Te="";for(const ae of ce){switch(ae){case ye:if(!fe&&!$e){ke.push(Te),Te="";continue}break;case"{":fe=!0;break;case"}":fe=!1;break;case"[":$e=!0;break;case"]":$e=!1;break}Te+=ae}return Te&&ke.push(Te),ke}function s(ce){if(!ce)return"";let ye="";const ke=f(ce,e.$nk);if(ke.every(fe=>fe===e.$mk))ye=".*";else{let fe=!1;ke.forEach(($e,Te)=>{if($e===e.$mk){if(fe)return;ye+=w(2,Te===ke.length-1)}else{let ae=!1,Ne="",ne=!1,z="";for(const x of $e){if(x!=="}"&&ae){Ne+=x;continue}if(ne&&(x!=="]"||!z)){let be;x==="-"?be=x:(x==="^"||x==="!")&&!z?be="^":x===e.$nk?be="":be=(0,m.$_e)(x),z+=be;continue}switch(x){case"{":ae=!0;continue;case"[":ne=!0;continue;case"}":{const Fe=`(?:${f(Ne,",").map(De=>s(De)).join("|")})`;ye+=Fe,ae=!1,Ne="";break}case"]":{ye+="["+z+"]",ne=!1,z="";break}case"?":ye+=k;continue;case"*":ye+=w(1);continue;default:ye+=(0,m.$_e)(x)}}Te<ke.length-1&&(ke[Te+1]!==e.$mk||Te+2<ke.length)&&(ye+=T)}fe=$e===e.$mk})}return ye}const r=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Dc(1e4),d=function(){return!1},a=function(){return null};function g(ce,ye){if(!ce)return a;let ke;typeof ce!="string"?ke=ce.pattern:ke=ce,ke=ke.trim();const fe=`${ke}_${!!ye.trimForExclusions}`;let $e=t.get(fe);if($e)return b($e,ce);let Te;return r.test(ke)?$e=v(ke.substr(4),ke):(Te=o.exec(p(ke,ye)))?$e=y(Te[1],ke):(ye.trimForExclusions?i:n).test(ke)?$e=h(ke,ye):(Te=c.exec(p(ke,ye)))?$e=D(Te[1].substr(1),ke,!0):(Te=u.exec(p(ke,ye)))?$e=D(Te[1],ke,!1):$e=S(ke),t.set(fe,$e),b($e,ce)}function b(ce,ye){if(typeof ye=="string")return ce;const ke=function(fe,$e){return(0,R.$vg)(fe,ye.base,!$.$k)?ce((0,m.$ef)(fe.substr(ye.base.length),A.sep),$e):null};return ke.allBasenames=ce.allBasenames,ke.allPaths=ce.allPaths,ke.basenames=ce.basenames,ke.patterns=ce.patterns,ke}function p(ce,ye){return ye.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function v(ce,ye){return function(ke,fe){return typeof ke=="string"&&ke.endsWith(ce)?ye:null}}function y(ce,ye){const ke=`/${ce}`,fe=`\\${ce}`,$e=function(ae,Ne){return typeof ae!="string"?null:Ne?Ne===ce?ye:null:ae===ce||ae.endsWith(ke)||ae.endsWith(fe)?ye:null},Te=[ce];return $e.basenames=Te,$e.patterns=[ye],$e.allBasenames=Te,$e}function h(ce,ye){const ke=K(ce.slice(1,-1).split(",").map(Ne=>g(Ne,ye)).filter(Ne=>Ne!==a),ce),fe=ke.length;if(!fe)return a;if(fe===1)return ke[0];const $e=function(Ne,ne){for(let z=0,x=ke.length;z<x;z++)if(ke[z](Ne,ne))return ce;return null},Te=ke.find(Ne=>!!Ne.allBasenames);Te&&($e.allBasenames=Te.allBasenames);const ae=ke.reduce((Ne,ne)=>ne.allPaths?Ne.concat(ne.allPaths):Ne,[]);return ae.length&&($e.allPaths=ae),$e}function D(ce,ye,ke){const fe=A.sep===A.$gc.sep,$e=fe?ce:ce.replace(l,A.sep),Te=A.sep+$e,ae=A.$gc.sep+ce;let Ne;return ke?Ne=function(ne,z){return typeof ne=="string"&&(ne===$e||ne.endsWith(Te)||!fe&&(ne===ce||ne.endsWith(ae)))?ye:null}:Ne=function(ne,z){return typeof ne=="string"&&(ne===$e||!fe&&ne===ce)?ye:null},Ne.allPaths=[(ke?"*/":"./")+ce],Ne}function S(ce){try{const ye=new RegExp(`^${s(ce)}$`);return function(ke){return ye.lastIndex=0,typeof ke=="string"&&ye.test(ke)?ce:null}}catch{return a}}function I(ce,ye,ke){return!ce||typeof ye!="string"?!1:P(ce)(ye,void 0,ke)}function P(ce,ye={}){if(!ce)return d;if(typeof ce=="string"||W(ce)){const ke=g(ce,ye);if(ke===a)return d;const fe=function($e,Te){return!!ke($e,Te)};return ke.allBasenames&&(fe.allBasenames=ke.allBasenames),ke.allPaths&&(fe.allPaths=ke.allPaths),fe}return N(ce,ye)}function W(ce){const ye=ce;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}function V(ce){return ce.allBasenames||[]}function q(ce){return ce.allPaths||[]}function N(ce,ye){const ke=K(Object.getOwnPropertyNames(ce).map(Ne=>B(Ne,ce[Ne],ye)).filter(Ne=>Ne!==a)),fe=ke.length;if(!fe)return a;if(!ke.some(Ne=>!!Ne.requiresSiblings)){if(fe===1)return ke[0];const Ne=function(x,be){let Fe;for(let De=0,pe=ke.length;De<pe;De++){const ge=ke[De](x,be);if(typeof ge=="string")return ge;(0,O.$ih)(ge)&&(Fe||(Fe=[]),Fe.push(ge))}return Fe?(async()=>{for(const De of Fe){const pe=await De;if(typeof pe=="string")return pe}return null})():null},ne=ke.find(x=>!!x.allBasenames);ne&&(Ne.allBasenames=ne.allBasenames);const z=ke.reduce((x,be)=>be.allPaths?x.concat(be.allPaths):x,[]);return z.length&&(Ne.allPaths=z),Ne}const $e=function(Ne,ne,z){let x,be;for(let Fe=0,De=ke.length;Fe<De;Fe++){const pe=ke[Fe];pe.requiresSiblings&&z&&(ne||(ne=(0,A.$nc)(Ne)),x||(x=ne.substr(0,ne.length-(0,A.$oc)(Ne).length)));const ge=pe(Ne,ne,x,z);if(typeof ge=="string")return ge;(0,O.$ih)(ge)&&(be||(be=[]),be.push(ge))}return be?(async()=>{for(const Fe of be){const De=await Fe;if(typeof De=="string")return De}return null})():null},Te=ke.find(Ne=>!!Ne.allBasenames);Te&&($e.allBasenames=Te.allBasenames);const ae=ke.reduce((Ne,ne)=>ne.allPaths?Ne.concat(ne.allPaths):Ne,[]);return ae.length&&($e.allPaths=ae),$e}function B(ce,ye,ke){if(ye===!1)return a;const fe=g(ce,ke);if(fe===a)return a;if(typeof ye=="boolean")return fe;if(ye){const $e=ye.when;if(typeof $e=="string"){const Te=(ae,Ne,ne,z)=>{if(!z||!fe(ae,Ne))return null;const x=$e.replace("$(basename)",()=>ne),be=z(x);return(0,O.$ih)(be)?be.then(Fe=>Fe?ce:null):be?ce:null};return Te.requiresSiblings=!0,Te}}return fe}function K(ce,ye){const ke=ce.filter(Ne=>!!Ne.basenames);if(ke.length<2)return ce;const fe=ke.reduce((Ne,ne)=>{const z=ne.basenames;return z?Ne.concat(z):Ne},[]);let $e;if(ye){$e=[];for(let Ne=0,ne=fe.length;Ne<ne;Ne++)$e.push(ye)}else $e=ke.reduce((Ne,ne)=>{const z=ne.patterns;return z?Ne.concat(z):Ne},[]);const Te=function(Ne,ne){if(typeof Ne!="string")return null;if(!ne){let x;for(x=Ne.length;x>0;x--){const be=Ne.charCodeAt(x-1);if(be===47||be===92)break}ne=Ne.substr(x)}const z=fe.indexOf(ne);return z!==-1?$e[z]:null};Te.basenames=fe,Te.patterns=$e,Te.allBasenames=fe;const ae=ce.filter(Ne=>!Ne.basenames);return ae.push(Te),ae}function ie(ce,ye){return(0,C.$ub)(ce,ye,(ke,fe)=>typeof ke=="string"&&typeof fe=="string"?ke===fe:typeof ke!="string"&&typeof fe!="string"?ke.base===fe.base&&ke.pattern===fe.pattern:!1)}}),define(Se[55],Pe([1,0,14,137,23,13,2]),function(le,e,C,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.MarkdownStringTextNewlineStyle=void 0,e.$Uk=E,e.$Vk=T,e.$Wk=k,e.$Xk=l,e.$Yk=w,e.$Zk=f,e.$1k=s,e.$2k=r;var $;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class m{constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,C.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=l(this.supportThemeIcons?(0,O.$Nk)(n):n).replace(/([ \t]+)/g,(c,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${w(i,n)}
`,this}appendLink(n,i,c){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,i){const c=new RegExp((0,M.$_e)(i),"g");return n.replace(c,(u,t)=>n.charAt(t-1)!=="\\"?`\\${u}`:u)}}e.$Tk=m;function E(o){return T(o)?!o.value:Array.isArray(o)?o.every(E):!0}function T(o){return o instanceof m?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function k(o,n){return o===n?!0:!o||!n?!1:o.value===n.value&&o.isTrusted===n.isTrusted&&o.supportThemeIcons===n.supportThemeIcons&&o.supportHtml===n.supportHtml&&(o.baseUri===n.baseUri||!!o.baseUri&&!!n.baseUri&&(0,R.$3g)(A.URI.from(o.baseUri),A.URI.from(n.baseUri)))}function l(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function w(o,n){const i=o.match(/^`+/gm)?.reduce((u,t)=>u.length>t.length?u:t).length??0,c=i>=3?i+1:3;return[`${"`".repeat(c)}${n}`,o,`${"`".repeat(c)}`].join(`
`)}function f(o){return o.replace(/"/g,"&quot;")}function s(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function r(o){const n=[],i=o.split("|").map(u=>u.trim());o=i[0];const c=i[1];if(c){const u=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),d=u?u[1]:"",a=t?t[1]:"",g=isFinite(parseInt(a)),b=isFinite(parseInt(d));g&&n.push(`width="${a}"`),b&&n.push(`height="${d}"`)}return{href:o,dimensions:n}}}),define(Se[97],Pe([1,0,18,48,19,22,23,13]),function(le,e,C,O,R,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dw=m,e.$Ew=T,e.$Fw=l,e.$Gw=w,e.$Hw=o,e.$Iw=i,e.$Jw=c,e.$Kw=u,e.$Lw=t,e.$Mw=d;function m(g,b){const{os:p,tildify:v,relative:y}=b;if(y){const S=E(g,y,p);if(typeof S=="string")return S}let h=g.fsPath;if(p===1&&!M.$i?h=h.replace(/\//g,"\\"):p!==1&&M.$i&&(h=h.replace(/\\/g,"/")),p!==1&&v?.userHome){const S=v.userHome.fsPath;let I;g.scheme!==v.userHome.scheme&&g.path[0]===R.$gc.sep&&g.path[1]!==R.$gc.sep?I=v.userHome.with({path:g.path}).fsPath:I=h,h=l(I,S,p)}return(p===1?R.$fc:R.$gc).normalize(T(h,p===1))}function E(g,b,p){const v=p===1?R.$fc:R.$gc,y=p===3?A.$Zg:A.$2g,h=b.getWorkspace(),D=(0,C.$Ob)(h.folders);if(!D)return;g.scheme!==D.uri.scheme&&g.path[0]===R.$gc.sep&&g.path[1]!==R.$gc.sep&&(g=D.uri.with({path:g.path}));const S=b.getWorkspaceFolder(g);if(!S)return;let I;if(y.isEqual(S.uri,g)?I="":I=y.relativePath(S.uri,g)??"",I&&(I=v.normalize(I)),h.folders.length>1&&!b.noPrefix){const P=S.name?S.name:y.basenameOrAuthority(S.uri);I=I?`${P} \u2022 ${I}`:P}return I}function T(g,b=M.$i){return(0,O.$Ag)(g,b)?g.charAt(0).toUpperCase()+g.slice(1):g}let k=Object.create(null);function l(g,b,p=M.OS){if(p===1||!g||!b)return g;let v=k.original===b?k.normalized:void 0;v||(v=b,M.$i&&(v=(0,O.$pg)(v)),v=`${(0,$.$ff)(v,R.$gc.sep)}${R.$gc.sep}`,k={original:b,normalized:v});let y=g;return M.$i&&(y=(0,O.$pg)(y)),(p===3?y.startsWith(v):(0,$.$yf)(y,v))?`~/${y.substr(v.length)}`:g}function w(g,b){return g.replace(/^~($|\/|\\)/,`${b}$1`)}const f="\u2026",s="\\\\",r="~";function o(g,b=R.sep){const p=new Array(g.length);let v=!1;for(let y=0;y<g.length;y++){const h=g[y];if(h===""){p[y]=`.${b}`;continue}if(!h){p[y]=h;continue}v=!0;let D="",S=h;S.indexOf(s)===0?(D=S.substr(0,S.indexOf(s)+s.length),S=S.substr(S.indexOf(s)+s.length)):S.indexOf(b)===0?(D=S.substr(0,S.indexOf(b)+b.length),S=S.substr(S.indexOf(b)+b.length)):S.indexOf(r)===0&&(D=S.substr(0,S.indexOf(r)+r.length),S=S.substr(S.indexOf(r)+r.length));const I=S.split(b);for(let P=1;v&&P<=I.length;P++)for(let W=I.length-P;v&&W>=0;W--){v=!1;let V=I.slice(W,W+P).join(b);for(let q=0;!v&&q<g.length;q++)if(q!==y&&g[q]&&g[q].indexOf(V)>-1){const N=W+P===I.length,B=W>0&&g[q].indexOf(b)>-1?b+V:V,K=g[q].endsWith(B);v=!N||K}if(!v){let q="";(I[0].endsWith(":")||D!=="")&&(W===1&&(W=0,P++,V=I[0]+b+V),W>0&&(q=I[0]+b),q=D+q),W>0&&(q=q+f+b),q=q+V,W+P<I.length&&(q=q+b+f),p[y]=q}}v&&(p[y]=h)}return p}var n;(function(g){g[g.TEXT=0]="TEXT",g[g.VARIABLE=1]="VARIABLE",g[g.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(g,b=Object.create(null)){const p=[];let v=!1,y="";for(const h of g)if(h==="$"||v&&h==="{")y&&p.push({value:y,type:n.TEXT}),y="",v=!0;else if(h==="}"&&v){const D=b[y];if(typeof D=="string")D.length&&p.push({value:D,type:n.VARIABLE});else if(D){const S=p[p.length-1];(!S||S.type!==n.SEPARATOR)&&p.push({value:D.label,type:n.SEPARATOR})}y="",v=!1}else y+=h;return y&&!v&&p.push({value:y,type:n.TEXT}),p.filter((h,D)=>{if(h.type===n.SEPARATOR){const S=p[D-1],I=p[D+1];return[S,I].every(P=>P&&(P.type===n.VARIABLE||P.type===n.TEXT)&&P.value.length>0)}return!0}).map(h=>h.value).join("")}function c(g,b){return M.$j||b?g.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):g.replace(/&&|&/g,p=>p==="&"?"&&":"&")}function u(g,b){return M.$j||b?g.replace(/\(&&\w\)|&&/g,""):M.$i?g.replace(/&&|&/g,p=>p==="&"?"&&":"&"):g.replace(/&&/g,"_")}function t(g){return g.replace(/&/g,"&&")}function d(g){if(g.endsWith("]")){const b=g.lastIndexOf(" [",g.length-2);if(b!==-1){const p=a(g.substring(0,b)),v=g.substring(b);return{name:p.name+v,parentPath:p.parentPath}}}return a(g)}function a(g){const b=g.indexOf("/")!==-1?R.$gc:R.$fc,p=b.basename(g),v=b.dirname(g);return p.length?{name:p,parentPath:v}:{name:v,parentPath:""}}}),define(Se[150],Pe([1,0,21,2]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=void 0,e.$An=$,e.$Bn=E,e.$Cn=T;function R(k){return k.toJSON()}class M{constructor(l){this.a=l}transformIncoming(l){const w=this.a.transformIncoming(l);return w===l?l:R(O.URI.from(w))}transformOutgoing(l){const w=this.a.transformOutgoing(l);return w===l?l:R(O.URI.from(w))}transformOutgoingURI(l){const w=this.a.transformOutgoing(l);return w===l?l:O.URI.from(w)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$yn=M,e.$zn=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function A(k,l,w){if(!k||w>200)return null;if(typeof k=="object"){if(k instanceof O.URI)return l.transformOutgoing(k);for(const f in k)if(Object.hasOwnProperty.call(k,f)){const s=A(k[f],l,w+1);s!==null&&(k[f]=s)}}return null}function $(k,l){const w=A(k,l,0);return w===null?k:w}function m(k,l,w,f){if(!k||f>200)return null;if(typeof k=="object"){if(k.$mid===1)return w?O.URI.revive(l.transformIncoming(k)):l.transformIncoming(k);if(k instanceof C.$Fe)return null;for(const s in k)if(Object.hasOwnProperty.call(k,s)){const r=m(k[s],l,w,f+1);r!==null&&(k[s]=r)}}return null}function E(k,l){const w=m(k,l,!1,0);return w===null?k:w}function T(k,l){const w=m(k,l,!0,0);return w===null?k:w}}),define(Se[151],Pe([1,0,11,5,6,49,15]),function(le,e,C,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.StorageState=e.StorageHint=void 0,e.$Vp=m;var $;(function(l){l[l.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",l[l.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})($||(e.StorageHint=$={}));function m(l){const w=l;return w?.changed instanceof Map||w?.deleted instanceof Set}var E;(function(l){l[l.None=0]="None",l[l.Initialized=1]="Initialized",l[l.Closed=2]="Closed"})(E||(e.StorageState=E={}));class T extends R.$Uc{static{this.a=100}constructor(w,f=Object.create(null)){super(),this.r=w,this.s=f,this.b=this.B(new O.$ge),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new C.$uh(T.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((f,s)=>this.w(s,f)),w.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(w,f){if(this.c===E.Closed)return;let s=!1;(0,A.$fg)(f)?s=this.f.delete(w):this.f.get(w)!==f&&(this.f.set(w,f),s=!0),s&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==$.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,f){const s=this.f.get(w);return(0,A.$fg)(s)?f:s}getBoolean(w,f){const s=this.get(w);return(0,A.$fg)(s)?f:s==="true"}getNumber(w,f){const s=this.get(w);return(0,A.$fg)(s)?f:parseInt(s,10)}getObject(w,f){const s=this.get(w);return(0,A.$fg)(s)?f:(0,M.$5h)(s)}async set(w,f,s=!1){if(this.c===E.Closed)return;if((0,A.$fg)(f))return this.delete(w,s);const r=(0,A.$$f)(f)||Array.isArray(f)?(0,M.$4h)(f):String(f);if(this.f.get(w)!==r)return this.f.set(w,r),this.j.set(w,r),this.h.delete(w),this.b.fire({key:w,external:s}),this.D()}async delete(w,f=!1){if(!(this.c===E.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:f}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===E.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===$.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===$.STORAGE_IN_MEMORY}}e.$Wp=T;class k{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((f,s)=>this.a.set(s,f)),w.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$Xp=k}),define(Se[152],Pe([1,0,13,22,21]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=void 0,e.$Dt=T,e.$Et=k;let M;function A(){return M||(M=new TextDecoder("UTF-16LE")),M}let $;function m(){return $||($=new TextDecoder("UTF-16BE")),$}let E;function T(){return E||(E=O.$D()?A():m()),E}function k(f,s,r){const o=new Uint16Array(f.buffer,s,r);return r>0&&(o[0]===65279||o[0]===65534)?l(f,s,r):A().decode(o)}function l(f,s,r){const o=[];let n=0;for(let i=0;i<r;i++){const c=R.$He(f,s);s+=2,o[n++]=String.fromCharCode(c)}return o.join("")}class w{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return T().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const r=this.a-this.d;r<=1&&(r===0||C.$Bf(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const r=s.length;if(this.d+r>=this.a){this.f(),this.c[this.c.length]=s;return}for(let o=0;o<r;o++)this.b[this.d++]=s.charCodeAt(o)}}e.$Ft=w}),define(Se[153],Pe([1,0,21,152]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=void 0,e.$Ht=A;function R(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,T,k,l){this.oldPosition=E,this.oldText=T,this.newPosition=k,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${R(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${R(this.oldText)}")`:`(replace@${this.oldPosition} "${R(this.oldText)}" with "${R(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,T,k){const l=T.length;C.$Ke(E,l,k),k+=4;for(let w=0;w<l;w++)C.$Ie(E,T.charCodeAt(w),k),k+=2;return k}static d(E,T){const k=C.$Je(E,T);return T+=4,(0,O.$Et)(E,T,k)}writeSize(){return 8+M.a(this.oldText)+M.a(this.newText)}write(E,T){return C.$Ke(E,this.oldPosition,T),T+=4,C.$Ke(E,this.newPosition,T),T+=4,T=M.c(E,this.oldText,T),T=M.c(E,this.newText,T),T}static read(E,T,k){const l=C.$Je(E,T);T+=4;const w=C.$Je(E,T);T+=4;const f=M.d(E,T);T+=M.a(f);const s=M.d(E,T);return T+=M.a(s),k.push(new M(l,f,w,s)),T}}e.$Gt=M;function A(m,E){return m===null||m.length===0?E:new $(m,E).compress()}class ${constructor(E,T){this.a=E,this.c=T,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,T=0,k=this.n(E),l=this.l(T);for(;E<this.f||T<this.h;){if(k===null){this.k(l),l=this.l(++T);continue}if(l===null){this.m(k),k=this.n(++E);continue}if(l.oldEnd<=k.newPosition){this.k(l),l=this.l(++T);continue}if(k.newEnd<=l.oldPosition){this.m(k),k=this.n(++E);continue}if(l.oldPosition<k.newPosition){const[o,n]=$.r(l,k.newPosition-l.oldPosition);this.k(o),l=n;continue}if(k.newPosition<l.oldPosition){const[o,n]=$.q(k,l.oldPosition-k.newPosition);this.m(o),k=n;continue}let s,r;if(l.oldEnd===k.newEnd)s=k,r=l,k=this.n(++E),l=this.l(++T);else if(l.oldEnd<k.newEnd){const[o,n]=$.q(k,l.oldLength);s=o,r=l,k=n,l=this.l(++T)}else{const[o,n]=$.r(l,k.newLength);s=k,r=o,k=this.n(++E),l=n}this.d[this.e++]=new M(s.oldPosition,s.oldText,r.newPosition,r.newText),this.g+=s.newLength-s.oldLength,this.j+=r.newLength-r.oldLength}const w=$.s(this.d);return $.t(w)}k(E){this.d[this.e++]=$.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=$.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,T){return new M(T.oldPosition-E,T.oldText,T.newPosition,T.newText)}static p(E,T){return new M(T.oldPosition,T.oldText,T.newPosition+E,T.newText)}static q(E,T){const k=E.newText.substr(0,T),l=E.newText.substr(T);return[new M(E.oldPosition,E.oldText,E.newPosition,k),new M(E.oldEnd,"",E.newPosition+T,l)]}static r(E,T){const k=E.oldText.substr(0,T),l=E.oldText.substr(T);return[new M(E.oldPosition,k,E.newPosition,E.newText),new M(E.oldPosition+T,l,E.newEnd,"")]}static s(E){if(E.length===0)return E;const T=[];let k=0,l=E[0];for(let w=1;w<E.length;w++){const f=E[w];l.oldEnd===f.oldPosition?l=new M(l.oldPosition,l.oldText+f.oldText,l.newPosition,l.newText+f.newText):(T[k++]=l,l=f)}return T[k++]=l,T}static t(E){if(E.length===0)return E;const T=[];let k=0;for(let l=0;l<E.length;l++){const w=E[l];w.oldText!==w.newText&&(T[k++]=w)}return T}}}),define(Se[154],Pe([1,0,37,19]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xt=R,e.$Yt=M;function R(A,$,m,E,T,k){if(Array.isArray(A)){let l=0;for(const w of A){const f=R(w,$,m,E,T,k);if(f===10)return f;f>l&&(l=f)}return l}else{if(typeof A=="string")return E?A==="*"?5:A===m?10:0:0;if(A){const{language:l,pattern:w,scheme:f,hasAccessToAllModels:s,notebookType:r}=A;if(!E&&!s)return 0;r&&T&&($=T);let o=0;if(f)if(f===$.scheme)o=10;else if(f==="*")o=5;else return 0;if(l)if(l===m)o=10;else if(l==="*")o=Math.max(o,5);else return 0;if(r)if(r===k)o=10;else if(r==="*"&&k!==void 0)o=Math.max(o,5);else return 0;if(w){let n;if(typeof w=="string"?n=w:n={...w,base:(0,O.$hc)(w.base)},n===$.fsPath||(0,C.$pk)(n,$.fsPath))o=10;else return 0}return o}else return 0}}function M(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(M):!!A.notebookType}}),define(Se[155],Pe([1,0,5,13,30,95,93,139,153,6]),function(le,e,C,O,R,M,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1C=void 0;class T extends E.$Uc{constructor(l,w,f,s,r,o,n){super(),this.m=this.B(new C.$de),this.onDidChangeContent=this.m.event,this.f=w,this.j=!o,this.g=s,this.h=r,this.c=new A.$ZC(l,f,n)}equals(l){return!(l instanceof T)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,w){return this.c.getOffsetAt(l,w)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,w){const f=l+w,s=this.getPositionAt(l),r=this.getPositionAt(f);return new R.$ut(s.lineNumber,s.column,r.lineNumber,r.column)}getValueInRange(l,w=0){if(l.isEmpty())return"";const f=this.n(w);return this.c.getValueInRange(l,f)}getValueLengthInRange(l,w=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const f=this.getOffsetAt(l.startLineNumber,l.startColumn),s=this.getOffsetAt(l.endLineNumber,l.endColumn);let r=0;const o=this.n(w),n=this.getEOL();if(o.length!==n.length){const i=o.length-n.length,c=l.endLineNumber-l.startLineNumber;r=i*c}return s-f+r}getCharacterCountInRange(l,w=0){if(this.j){let f=0;const s=l.startLineNumber,r=l.endLineNumber;for(let o=s;o<=r;o++){const n=this.getLineContent(o),i=o===s?l.startColumn-1:0,c=o===r?l.endColumn-1:n.length;for(let u=i;u<c;u++)O.$Bf(n.charCodeAt(u))?(f=f+1,u=u+1):f=f+1}return f+=this.n(w).length*(r-s),f}return this.getValueLengthInRange(l,w)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,w){return this.c.getLineCharCode(l,w)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const w=O.$mf(this.getLineContent(l));return w===-1?0:w+1}getLineLastNonWhitespaceColumn(l){const w=O.$of(this.getLineContent(l));return w===-1?0:w+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,w,f){let s=this.g,r=this.h,o=this.j,n=!0,i=[];for(let b=0;b<l.length;b++){const p=l[b];n&&p._isTracked&&(n=!1);const v=p.range;if(p.text){let I=!0;o||(I=!O.$Mf(p.text),o=I),!s&&I&&(s=O.$Lf(p.text)),!r&&I&&(r=O.$Of(p.text))}let y="",h=0,D=0,S=0;if(p.text){let I;[h,D,S,I]=(0,$.$1t)(p.text);const P=this.getEOL();I===0||I===(P===`\r
`?2:1)?y=p.text:y=p.text.replace(/\r\n|\r|\n/g,P)}i[b]={sortIndex:b,identifier:p.identifier||null,range:v,rangeOffset:this.getOffsetAt(v.startLineNumber,v.startColumn),rangeLength:this.getValueLengthInRange(v),text:y,eolCount:h,firstLineLength:D,lastLineLength:S,forceMoveMarkers:!!p.forceMoveMarkers,isAutoWhitespaceEdit:p.isAutoWhitespaceEdit||!1}}i.sort(T.u);let c=!1;for(let b=0,p=i.length-1;b<p;b++){const v=i[b].range.getEndPosition(),y=i[b+1].range.getStartPosition();if(y.isBeforeOrEqual(v)){if(y.isBefore(v))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(i=this.s(i));const u=f||w?T._getInverseEditRanges(i):[],t=[];if(w)for(let b=0;b<i.length;b++){const p=i[b],v=u[b];if(p.isAutoWhitespaceEdit&&p.range.isEmpty())for(let y=v.startLineNumber;y<=v.endLineNumber;y++){let h="";y===v.startLineNumber&&(h=this.getLineContent(p.range.startLineNumber),O.$mf(h)!==-1)||t.push({lineNumber:y,oldContent:h})}}let d=null;if(f){let b=0;d=[];for(let p=0;p<i.length;p++){const v=i[p],y=u[p],h=this.getValueInRange(v.range),D=v.rangeOffset+b;b+=v.text.length-h.length,d[p]={sortIndex:v.sortIndex,identifier:v.identifier,range:y,text:h,textChange:new m.$Gt(v.rangeOffset,h,D,v.text)}}c||d.sort((p,v)=>p.sortIndex-v.sortIndex)}this.g=s,this.h=r,this.j=o;const a=this.t(i);let g=null;if(w&&t.length>0){t.sort((b,p)=>p.lineNumber-b.lineNumber),g=[];for(let b=0,p=t.length;b<p;b++){const v=t[b].lineNumber;if(b>0&&t[b-1].lineNumber===v)continue;const y=t[b].oldContent,h=this.getLineContent(v);h.length===0||h===y||O.$mf(h)!==-1||g.push(v)}}return this.m.fire(),new M.$Jv(d,a,g)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let w=!1;const f=l[0].range,s=l[l.length-1].range,r=new R.$ut(f.startLineNumber,f.startColumn,s.endLineNumber,s.endColumn);let o=f.startLineNumber,n=f.startColumn;const i=[];for(let a=0,g=l.length;a<g;a++){const b=l[a],p=b.range;w=w||b.forceMoveMarkers,i.push(this.getValueInRange(new R.$ut(o,n,p.startLineNumber,p.startColumn))),b.text.length>0&&i.push(b.text),o=p.endLineNumber,n=p.endColumn}const c=i.join(""),[u,t,d]=(0,$.$1t)(c);return{sortIndex:0,identifier:l[0].identifier,range:r,rangeOffset:this.getOffsetAt(r.startLineNumber,r.startColumn),rangeLength:this.getValueLengthInRange(r,0),text:c,eolCount:u,firstLineLength:t,lastLineLength:d,forceMoveMarkers:w,isAutoWhitespaceEdit:!1}}t(l){l.sort(T.w);const w=[];for(let f=0;f<l.length;f++){const s=l[f],r=s.range.startLineNumber,o=s.range.startColumn,n=s.range.endLineNumber,i=s.range.endColumn;if(r===n&&o===i&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const c=new R.$ut(r,o,n,i);w.push({range:c,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return w}findMatchesLineByLine(l,w,f,s){return this.c.findMatchesLineByLine(l,w,f,s)}getPieceTree(){return this.c}static _getInverseEditRange(l,w){const f=l.startLineNumber,s=l.startColumn,[r,o,n]=(0,$.$1t)(w);let i;if(w.length>0){const c=r+1;c===1?i=new R.$ut(f,s,f,s+o):i=new R.$ut(f,s,f+c-1,n+1)}else i=new R.$ut(f,s,f,s);return i}static _getInverseEditRanges(l){const w=[];let f=0,s=0,r=null;for(let o=0,n=l.length;o<n;o++){const i=l[o];let c,u;r?r.range.endLineNumber===i.range.startLineNumber?(c=f,u=s+(i.range.startColumn-r.range.endColumn)):(c=f+(i.range.startLineNumber-r.range.endLineNumber),u=i.range.startColumn):(c=i.range.startLineNumber,u=i.range.startColumn);let t;if(i.text.length>0){const d=i.eolCount+1;d===1?t=new R.$ut(c,u,c,u+i.firstLineLength):t=new R.$ut(c,u,c+d-1,i.lastLineLength+1)}else t=new R.$ut(c,u,c,u);f=t.endLineNumber,s=t.endColumn,w.push(t),r=i}return w}static u(l,w){const f=R.$ut.compareRangesUsingEnds(l.range,w.range);return f===0?l.sortIndex-w.sortIndex:f}static w(l,w){const f=R.$ut.compareRangesUsingEnds(l.range,w.range);return f===0?w.sortIndex-l.sortIndex:-f}}e.$1C=T}),define(Se[156],Pe([1,0,13,93,155]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=void 0;class M{constructor(m,E,T,k,l,w,f,s,r){this.a=m,this.b=E,this.c=T,this.d=k,this.e=l,this.f=w,this.g=f,this.h=s,this.j=r}k(m){const E=this.c+this.d+this.e,T=this.c+this.e;return E===0?m===1?`
`:`\r
`:T>E/2?`\r
`:`
`}create(m){const E=this.k(m),T=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let l=0,w=T.length;l<w;l++){const f=T[l].buffer.replace(/\r\n|\r|\n/g,E),s=(0,O.$VC)(f);T[l]=new O.$YC(f,s)}const k=new R.$1C(T,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(m){return this.a[0].buffer.substr(0,m).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(m){if(m.length===0)return;this.a.length===0&&C.$Wf(m)&&(this.b=C.$Vf,m=m.substr(1));const E=m.charCodeAt(m.length-1);E===13||E>=55296&&E<=56319?(this.m(m.substr(0,m.length-1),!1),this.c=!0,this.d=E):(this.m(m,!1),this.c=!1,this.d=E)}m(m,E){!E&&m.length===0||(this.c?this.n(String.fromCharCode(this.d)+m):this.n(m))}n(m){const E=(0,O.$WC)(this.e,m);this.a.push(new O.$YC(m,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=C.$Lf(m)),this.k||(this.k=C.$Of(m)))}finish(m=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,m)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const m=this.a[this.a.length-1];m.buffer+=String.fromCharCode(this.d);const E=(0,O.$VC)(m.buffer);m.lineStarts=E,this.d===13&&this.f++}}}e.$2C=A}),define(Se[98],Pe([1,0,21,22]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccb=m,e.$dcb=T;var R;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(R||(R={}));function M(k){for(let l=0,w=k.length;l<w;l+=4){const f=k[l+0],s=k[l+1],r=k[l+2],o=k[l+3];k[l+0]=o,k[l+1]=r,k[l+2]=s,k[l+3]=f}}function A(k){const l=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return O.$D()||M(l),C.$Fe.wrap(l)}function $(k){const l=k.buffer;if(O.$D()||M(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const w=new Uint8Array(l.byteLength);return w.set(l),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function m(k){const l=new Uint32Array(E(k));let w=0;if(l[w++]=k.id,k.type==="full")l[w++]=1,l[w++]=k.data.length,l.set(k.data,w),w+=k.data.length;else{l[w++]=2,l[w++]=k.deltas.length;for(const f of k.deltas)l[w++]=f.start,l[w++]=f.deleteCount,f.data?(l[w++]=f.data.length,l.set(f.data,w),w+=f.data.length):l[w++]=0}return A(l)}function E(k){let l=0;if(l+=2,k.type==="full")l+=1+k.data.length;else{l+=1,l+=3*k.deltas.length;for(const w of k.deltas)w.data&&(l+=w.data.length)}return l}function T(k){const l=$(k);let w=0;const f=l[w++];if(l[w++]===1){const n=l[w++],i=l.subarray(w,w+n);return w+=n,{id:f,type:"full",data:i}}const r=l[w++],o=[];for(let n=0;n<r;n++){const i=l[w++],c=l[w++],u=l[w++];let t;u>0&&(t=l.subarray(w,w+u),w+=u),o[n]={start:i,deleteCount:c,data:t}}return{id:f,type:"delta",deltas:o}}}),define(Se[157],Pe([9,10]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(Se[158],Pe([1,0,18,25,22,140,159,157]),function(le,e,C,O,R,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=r,e.clampedInt=n,e.clampedFloat=c,e.stringSet=d,e.cursorStyleToString=S,e.filterValidationDecorations=ue;var m;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(m||(e.EditorAutoIndentStrategy=m={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=E;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class k{constructor(Z,me,Ge,we){this.id=Z,this.name=me,this.defaultValue=Ge,this.schema=we}applyUpdate(Z,me){return w(Z,me)}compute(Z,me,Ge){return Ge}}class l{constructor(Z,me){this.newValue=Z,this.didChange=me}}e.ApplyUpdateResult=l;function w(X,Z){if(typeof X!="object"||typeof Z!="object"||!X||!Z)return new l(Z,X!==Z);if(Array.isArray(X)||Array.isArray(Z)){const Ge=Array.isArray(X)&&Array.isArray(Z)&&C.$ub(X,Z);return new l(Z,!Ge)}let me=!1;for(const Ge in Z)if(Z.hasOwnProperty(Ge)){const we=w(X[Ge],Z[Ge]);we.didChange&&(X[Ge]=we.newValue,me=!0)}return new l(X,me)}class f{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,me){return w(Z,me)}validate(Z){return this.defaultValue}}class s{constructor(Z,me,Ge,we){this.id=Z,this.name=me,this.defaultValue=Ge,this.schema=we}applyUpdate(Z,me){return w(Z,me)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,me,Ge){return Ge}}function r(X,Z){return typeof X>"u"?Z:X==="false"?!1:!!X}class o extends s{constructor(Z,me,Ge,we=void 0){typeof we<"u"&&(we.type="boolean",we.default=Ge),super(Z,me,Ge,we)}validate(Z){return r(Z,this.defaultValue)}}function n(X,Z,me,Ge){if(typeof X>"u")return Z;let we=parseInt(X,10);return isNaN(we)?Z:(we=Math.max(me,we),we=Math.min(Ge,we),we|0)}class i extends s{static clampedInt(Z,me,Ge,we){return n(Z,me,Ge,we)}constructor(Z,me,Ge,we,at,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=Ge,dt.minimum=we,dt.maximum=at),super(Z,me,Ge,dt),this.minimum=we,this.maximum=at}validate(Z){return i.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function c(X,Z,me,Ge){if(typeof X>"u")return Z;const we=u.float(X,Z);return u.clamp(we,me,Ge)}class u extends s{static clamp(Z,me,Ge){return Z<me?me:Z>Ge?Ge:Z}static float(Z,me){if(typeof Z=="number")return Z;if(typeof Z>"u")return me;const Ge=parseFloat(Z);return isNaN(Ge)?me:Ge}constructor(Z,me,Ge,we,at){typeof at<"u"&&(at.type="number",at.default=Ge),super(Z,me,Ge,at),this.validationFn=we}validate(Z){return this.validationFn(u.float(Z,this.defaultValue))}}class t extends s{static string(Z,me){return typeof Z!="string"?me:Z}constructor(Z,me,Ge,we=void 0){typeof we<"u"&&(we.type="string",we.default=Ge),super(Z,me,Ge,we)}validate(Z){return t.string(Z,this.defaultValue)}}function d(X,Z,me,Ge){return typeof X!="string"?Z:Ge&&X in Ge?Ge[X]:me.indexOf(X)===-1?Z:X}class a extends s{constructor(Z,me,Ge,we,at=void 0){typeof at<"u"&&(at.type="string",at.enum=we,at.default=Ge),super(Z,me,Ge,at),this.c=we}validate(Z){return d(Z,this.defaultValue,this.c)}}class g extends k{constructor(Z,me,Ge,we,at,dt,It=void 0){typeof It<"u"&&(It.type="string",It.enum=at,It.default=we),super(Z,me,Ge,It),this.c=at,this.d=dt}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function b(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,me,Ge){return Ge===0?Z.accessibilitySupport:Ge}}class v extends k{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:$.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertSpace:r(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:r(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var y;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(y||(e.TextEditorCursorBlinkingStyle=y={}));function h(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var D;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(D||(e.TextEditorCursorStyle=D={}));function S(X){switch(X){case D.Line:return"line";case D.Block:return"block";case D.Underline:return"underline";case D.LineThin:return"line-thin";case D.BlockOutline:return"block-outline";case D.UnderlineThin:return"underline-thin"}}function I(X){switch(X){case"line":return D.Line;case"block":return D.Block;case"underline":return D.Underline;case"line-thin":return D.LineThin;case"block-outline":return D.BlockOutline;case"underline-thin":return D.UnderlineThin}}class P extends f{constructor(){super(142)}compute(Z,me,Ge){const we=["monaco-editor"];return me.get(39)&&we.push(me.get(39)),Z.extraEditorClassName&&we.push(Z.extraEditorClassName),me.get(74)==="default"?we.push("mouse-default"):me.get(74)==="copy"&&we.push("mouse-copy"),me.get(111)&&we.push("showUnused"),me.get(140)&&we.push("showDeprecated"),we.join(" ")}}class W extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(Z,me,Ge){return Ge&&Z.emptySelectionClipboard}}class V extends k{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:$.localize(16,null),included:R.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:$.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{cursorMoveOnType:r(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":d(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":d(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:r(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:r(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:r(me.loop,this.defaultValue.loop)}}}class q extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"||Z.length===0?q.OFF:Z==="true"?q.ON:Z:Z?q.ON:q.OFF}}e.EditorFontLigatures=q;class N extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?N.OFF:Z==="true"?N.TRANSLATE:Z:Z?N.TRANSLATE:N.OFF}compute(Z,me,Ge){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class B extends f{constructor(){super(50)}compute(Z,me,Ge){return Z.fontInfo}}class K extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(Z){const me=u.float(Z,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(me,6,100)}compute(Z,me,Ge){return Z.fontInfo.fontSize}}class ie extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ie.d,maximum:ie.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ie.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(i.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,ie.d,ie.e))}}class ce extends k{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:Ge,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:Ge,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:Ge,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:Ge,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:Ge,description:$.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{multiple:d(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??d(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??d(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??d(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??d(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??d(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends k{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:$.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:r(me.enabled,this.defaultValue.enabled),delay:i.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:r(me.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(me.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:r(me.above,this.defaultValue.above)}}}var ke;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(ke||(e.RenderMinimap=ke={}));class fe extends f{constructor(){super(145)}compute(Z,me,Ge){return fe.computeLayout(me,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const me=Z.height/Z.lineHeight,Ge=Math.floor(Z.paddingTop/Z.lineHeight);let we=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(we=Math.max(we,me-1));const at=(Ge+Z.viewLineCount+we)/(Z.pixelRatio*Z.height),dt=Math.floor(Z.viewLineCount/at);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:we,desiredRatio:at,minimapLineCount:dt}}static c(Z,me){const Ge=Z.outerWidth,we=Z.outerHeight,at=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(at*we),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:we};const dt=me.stableMinimapLayoutInput,It=dt&&Z.outerHeight===dt.outerHeight&&Z.lineHeight===dt.lineHeight&&Z.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===dt.pixelRatio&&Z.scrollBeyondLastLine===dt.scrollBeyondLastLine&&Z.paddingTop===dt.paddingTop&&Z.paddingBottom===dt.paddingBottom&&Z.minimap.enabled===dt.minimap.enabled&&Z.minimap.side===dt.minimap.side&&Z.minimap.size===dt.minimap.size&&Z.minimap.showSlider===dt.minimap.showSlider&&Z.minimap.renderCharacters===dt.minimap.renderCharacters&&Z.minimap.maxColumn===dt.minimap.maxColumn&&Z.minimap.scale===dt.minimap.scale&&Z.verticalScrollbarWidth===dt.verticalScrollbarWidth&&Z.isViewportWrapping===dt.isViewportWrapping,Vt=Z.lineHeight,Qt=Z.typicalHalfwidthCharacterWidth,ni=Z.scrollBeyondLastLine,Zt=Z.minimap.renderCharacters;let Et=at>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Xt=Z.minimap.maxColumn,Yt=Z.minimap.size,Xe=Z.minimap.side,si=Z.verticalScrollbarWidth,Gt=Z.viewLineCount,ht=Z.remainingWidth,mt=Z.isViewportWrapping,xt=Zt?2:3;let Ht=Math.floor(at*we);const Mt=Ht/at;let ft=!1,Ut=!1,_t=xt*Et,zt=Et/at,Qe=1;if(Yt==="fill"||Yt==="fit"){const{typicalViewportLineCount:Ft,extraLinesBeforeFirstLine:ei,extraLinesBeyondLastLine:jt,desiredRatio:oi,minimapLineCount:Nt}=fe.computeContainedMinimapLineCount({viewLineCount:Gt,scrollBeyondLastLine:ni,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:we,lineHeight:Vt,pixelRatio:at});if(Gt/Nt>1)ft=!0,Ut=!0,Et=1,_t=1,zt=Et/at;else{let Ot=!1,Pt=Et+1;if(Yt==="fit"){const $t=Math.ceil((ei+Gt+jt)*_t);mt&&It&&ht<=me.stableFitRemainingWidth?(Ot=!0,Pt=me.stableFitMaxMinimapScale):Ot=$t>Ht}if(Yt==="fill"||Ot){ft=!0;const $t=Et;_t=Math.min(Vt*at,Math.max(1,Math.floor(1/oi))),mt&&It&&ht<=me.stableFitRemainingWidth&&(Pt=me.stableFitMaxMinimapScale),Et=Math.min(Pt,Math.max(1,Math.floor(_t/xt))),Et>$t&&(Qe=Math.min(2,Et/$t)),zt=Et/at/Qe,Ht=Math.ceil(Math.max(Ft,ei+Gt+jt)*_t),mt?(me.stableMinimapLayoutInput=Z,me.stableFitRemainingWidth=ht,me.stableFitMaxMinimapScale=Et):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const ci=Math.floor(Xt*zt),Kt=Math.min(ci,Math.max(0,Math.floor((ht-si-2)*zt/(Qt+zt)))+e.MINIMAP_GUTTER_WIDTH);let Wt=Math.floor(at*Kt);const wt=Wt/at;Wt=Math.floor(Wt*Qe);const Tt=Zt?1:2,Ct=Xe==="left"?0:Ge-Kt-si;return{renderMinimap:Tt,minimapLeft:Ct,minimapWidth:Kt,minimapHeightIsEditorHeight:ft,minimapIsSampling:Ut,minimapScale:Et,minimapLineHeight:_t,minimapCanvasInnerWidth:Wt,minimapCanvasInnerHeight:Ht,minimapCanvasOuterWidth:wt,minimapCanvasOuterHeight:Mt}}static computeLayout(Z,me){const Ge=me.outerWidth|0,we=me.outerHeight|0,at=me.lineHeight|0,dt=me.lineNumbersDigitCount|0,It=me.typicalHalfwidthCharacterWidth,Vt=me.maxDigitWidth,Qt=me.pixelRatio,ni=me.viewLineCount,Zt=Z.get(137),Et=Zt==="inherit"?Z.get(136):Zt,Xt=Et==="inherit"?Z.get(132):Et,Yt=Z.get(135),Xe=me.isDominatedByLongLines,si=Z.get(57),Gt=Z.get(68).renderType!==0,ht=Z.get(69),mt=Z.get(105),xt=Z.get(84),Ht=Z.get(73),Mt=Z.get(103),ft=Mt.verticalScrollbarSize,Ut=Mt.verticalHasArrows,_t=Mt.arrowSize,zt=Mt.horizontalScrollbarSize,Qe=Z.get(43),ci=Z.get(110)!=="never";let Kt=Z.get(66);Qe&&ci&&(Kt+=16);let Wt=0;if(Gt){const ri=Math.max(dt,ht);Wt=Math.round(ri*Vt)}let wt=0;si&&(wt=at*me.glyphMarginDecorationLaneCount);let Tt=0,Ct=Tt+wt,Ft=Ct+Wt,ei=Ft+Kt;const jt=Ge-wt-Wt-Kt;let oi=!1,Nt=!1,At=-1;Et==="inherit"&&Xe?(oi=!0,Nt=!0):Xt==="on"||Xt==="bounded"?Nt=!0:Xt==="wordWrapColumn"&&(At=Yt);const Ot=fe.c({outerWidth:Ge,outerHeight:we,lineHeight:at,typicalHalfwidthCharacterWidth:It,pixelRatio:Qt,scrollBeyondLastLine:mt,paddingTop:xt.top,paddingBottom:xt.bottom,minimap:Ht,verticalScrollbarWidth:ft,viewLineCount:ni,remainingWidth:jt,isViewportWrapping:Nt},me.memory||new T);Ot.renderMinimap!==0&&Ot.minimapLeft===0&&(Tt+=Ot.minimapWidth,Ct+=Ot.minimapWidth,Ft+=Ot.minimapWidth,ei+=Ot.minimapWidth);const Pt=jt-Ot.minimapWidth,$t=Math.max(1,Math.floor((Pt-ft-2)/It)),Dt=Ut?_t:0;return Nt&&(At=Math.max(1,$t),Xt==="bounded"&&(At=Math.min(At,Yt))),{width:Ge,height:we,glyphMarginLeft:Tt,glyphMarginWidth:wt,glyphMarginDecorationLaneCount:me.glyphMarginDecorationLaneCount,lineNumbersLeft:Ct,lineNumbersWidth:Wt,decorationsLeft:Ft,decorationsWidth:Kt,contentLeft:ei,contentWidth:Pt,minimap:Ot,viewportColumn:$t,isWordWrapMinified:oi,isViewportWrapping:Nt,wrappingColumn:At,verticalScrollbarWidth:ft,horizontalScrollbarHeight:zt,overviewRuler:{top:Dt,width:ft,height:we-2*Dt,right:0}}}}e.EditorLayoutInfoComputer=fe;class $e extends k{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(Z){return d(Z,"simple",["simple","advanced"])}compute(Z,me,Ge){return me.get(2)===2?"advanced":Ge}}var Te;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(Te||(e.ShowLightbulbIconMode=Te={}));class ae extends k{constructor(){const Z={enabled:Te.On};super(65,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Te.Off,Te.OnCode,Te.On],default:Z.enabled,enumDescriptions:[$.localize(50,null),$.localize(51,null),$.localize(52,null)],description:$.localize(53,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:d(Z.enabled,this.defaultValue.enabled,[Te.Off,Te.OnCode,Te.On])}}}class Ne extends k{constructor(){const Z={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:$.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:20,description:$.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:$.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:$.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:r(me.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:d(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:r(me.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends k{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:$.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(59,null),$.localize(60,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(61,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:$.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:$.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:$.localize(65,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:d(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),padding:r(me.padding,this.defaultValue.padding)}}}class z extends k{constructor(){super(66,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):i.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,me,Ge){return Ge<0?i.clampedInt(-Ge*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class x extends u{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>u.clamp(Z,0,150),{markdownDescription:$.localize(66,null)})}compute(Z,me,Ge){return Z.fontInfo.lineHeight}}class be extends k{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:$.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:$.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(69,null),$.localize(70,null),$.localize(71,null)],default:Z.size,description:$.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:$.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:$.localize(74,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:$.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:$.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Z.showRegionSectionHeaders,description:$.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Z.showMarkSectionHeaders,description:$.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Z.sectionHeaderFontSize,description:$.localize(80,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:r(me.enabled,this.defaultValue.enabled),autohide:r(me.autohide,this.defaultValue.autohide),size:d(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(me.side,this.defaultValue.side,["right","left"]),showSlider:d(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:r(me.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(me.scale,1,1,3),maxColumn:i.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:r(me.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:r(me.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:u.clamp(me.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Fe(X){return X==="ctrlCmd"?R.$j?"metaKey":"ctrlKey":"altKey"}class De extends k{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(82,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{top:i.clampedInt(me.top,0,0,1e3),bottom:i.clampedInt(me.bottom,0,0,1e3)}}}class pe extends k{constructor(){const Z={enabled:!0,cycle:!0};super(86,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:$.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:$.localize(84,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:r(me.enabled,this.defaultValue.enabled),cycle:r(me.cycle,this.defaultValue.cycle)}}}class ge extends f{constructor(){super(143)}compute(Z,me,Ge){return Z.pixelRatio}}class Q extends k{constructor(){const Z={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(85,null),$.localize(86,null),$.localize(87,null)]}];super(89,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Z.strings,description:$.localize(88,null)},comments:{anyOf:me,default:Z.comments,description:$.localize(89,null)},other:{anyOf:me,default:Z.other,description:$.localize(90,null)}},default:Z,markdownDescription:$.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Qt=Z?"on":"off";return{comments:Qt,strings:Qt,other:Qt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:me,comments:Ge,strings:we}=Z,at=["on","inline","off"];let dt,It,Vt;return typeof me=="boolean"?dt=me?"on":"off":dt=d(me,this.defaultValue.other,at),typeof Ge=="boolean"?It=Ge?"on":"off":It=d(Ge,this.defaultValue.comments,at),typeof we=="boolean"?Vt=we?"on":"off":Vt=d(we,this.defaultValue.strings,at),{other:dt,comments:It,strings:Vt}}}var Y;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class he extends k{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(92,null),$.localize(93,null),$.localize(94,null),$.localize(95,null)],default:"on",description:$.localize(96,null)})}validate(Z){let me=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(me=4,Ge=Z):Z==="interval"?me=3:Z==="relative"?me=2:Z==="on"?me=1:me=0),{renderType:me,renderFn:Ge}}}function ue(X){const Z=X.get(98);return Z==="editable"?X.get(91):Z!=="on"}class Me extends k{constructor(){const Z=[],me={type:"number",description:$.localize(97,null)};super(102,"rulers",Z,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:$.localize(98,null),format:"color-hex"}}}]},default:Z,description:$.localize(99,null)})}validate(Z){if(Array.isArray(Z)){const me=[];for(const Ge of Z)if(typeof Ge=="number")me.push({column:i.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const we=Ge;me.push({column:i.clampedInt(we.column,0,0,1e4),color:we.color})}return me.sort((Ge,we)=>Ge.column-we.column),me}return this.defaultValue}}class de extends k{constructor(){super(92,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ce(X,Z){if(typeof X!="string")return Z;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends k{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(100,null),$.localize(101,null),$.localize(102,null)],default:"auto",description:$.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(104,null),$.localize(105,null),$.localize(106,null)],default:"auto",description:$.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:$.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:$.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:$.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:$.localize(111,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z,Ge=i.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),we=i.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(me.vertical,this.defaultValue.vertical),horizontal:Ce(me.horizontal,this.defaultValue.horizontal),useShadows:r(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:r(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:r(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:r(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:r(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:i.clampedInt(me.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:we,verticalSliderSize:i.clampedInt(me.verticalSliderSize,we,0,1e3),scrollByPage:r(me.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:r(me.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class je extends k{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:$.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:$.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:$.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:$.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:$.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:$.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:$.localize(118,null)}})}applyUpdate(Z,me){let Ge=!1;me.allowedCharacters&&Z&&(O.$7n(Z.allowedCharacters,me.allowedCharacters)||(Z={...Z,allowedCharacters:me.allowedCharacters},Ge=!0)),me.allowedLocales&&Z&&(O.$7n(Z.allowedLocales,me.allowedLocales)||(Z={...Z,allowedLocales:me.allowedLocales},Ge=!0));const we=super.applyUpdate(Z,me);return Ge?new l(we.newValue,!0):we}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{nonBasicASCII:ee(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:r(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:r(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,me){if(typeof Z!="object"||!Z)return me;const Ge={};for(const[we,at]of Object.entries(Z))at===!0&&(Ge[we]=!0);return Ge}}class U extends k{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:$.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[$.localize(120,null),$.localize(121,null),$.localize(122,null)],description:$.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:$.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Z.fontFamily,description:$.localize(125,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:r(me.enabled,this.defaultValue.enabled),mode:d(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:d(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:r(me.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:r(me.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily)}}}class F extends k{constructor(){const Z={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Z,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Z.enabled,description:$.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[$.localize(127,null),$.localize(128,null),$.localize(129,null)],description:$.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Z.fontFamily,description:$.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Z.backgroundColoring,description:$.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:r(me.enabled,this.defaultValue.enabled),showToolbar:d(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),keepOnBlur:r(me.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:r(me.backgroundColoring,this.defaultValue.backgroundColoring)}}}class G extends k{constructor(){const Z={enabled:M.$4s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$4s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:$.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:$.localize(134,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:r(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:r(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends k{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(135,null),$.localize(136,null),$.localize(137,null)],default:Z.bracketPairs,description:$.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(139,null),$.localize(140,null),$.localize(141,null)],default:Z.bracketPairsHorizontal,description:$.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:$.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:$.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(145,null),$.localize(146,null),$.localize(147,null)],default:Z.highlightActiveIndentation,description:$.localize(148,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{bracketPairs:ee(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:r(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:r(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(X,Z,me){const Ge=me.indexOf(X);return Ge===-1?Z:me[Ge]}class re extends k{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(149,null),$.localize(150,null)],default:Z.insertMode,description:$.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:$.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:$.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:$.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(155,null),$.localize(156,null),$.localize(157,null),$.localize(158,null)],default:Z.selectionMode,markdownDescription:$.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:$.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:$.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:$.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:$.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:$.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(196,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertMode:d(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:r(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:r(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:r(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:r(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:d(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:r(me.showIcons,this.defaultValue.showIcons),showStatusBar:r(me.showStatusBar,this.defaultValue.showStatusBar),preview:r(me.preview,this.defaultValue.preview),previewMode:d(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:r(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:r(me.showMethods,this.defaultValue.showMethods),showFunctions:r(me.showFunctions,this.defaultValue.showFunctions),showConstructors:r(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:r(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:r(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:r(me.showFields,this.defaultValue.showFields),showVariables:r(me.showVariables,this.defaultValue.showVariables),showClasses:r(me.showClasses,this.defaultValue.showClasses),showStructs:r(me.showStructs,this.defaultValue.showStructs),showInterfaces:r(me.showInterfaces,this.defaultValue.showInterfaces),showModules:r(me.showModules,this.defaultValue.showModules),showProperties:r(me.showProperties,this.defaultValue.showProperties),showEvents:r(me.showEvents,this.defaultValue.showEvents),showOperators:r(me.showOperators,this.defaultValue.showOperators),showUnits:r(me.showUnits,this.defaultValue.showUnits),showValues:r(me.showValues,this.defaultValue.showValues),showConstants:r(me.showConstants,this.defaultValue.showConstants),showEnums:r(me.showEnums,this.defaultValue.showEnums),showEnumMembers:r(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:r(me.showKeywords,this.defaultValue.showKeywords),showWords:r(me.showWords,this.defaultValue.showWords),showColors:r(me.showColors,this.defaultValue.showColors),showFiles:r(me.showFiles,this.defaultValue.showFiles),showReferences:r(me.showReferences,this.defaultValue.showReferences),showFolders:r(me.showFolders,this.defaultValue.showFolders),showTypeParameters:r(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:r(me.showSnippets,this.defaultValue.showSnippets),showUsers:r(me.showUsers,this.defaultValue.showUsers),showIssues:r(me.showIssues,this.defaultValue.showIssues)}}}class Oe extends k{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(198,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:r(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:r(Z.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends k{constructor(){const Z=[];super(130,"wordSegmenterLocales",Z,{anyOf:[{description:$.localize(199,null),type:"string"},{description:$.localize(200,null),type:"array",items:{type:"string"}}]})}validate(Z){if(typeof Z=="string"&&(Z=[Z]),Array.isArray(Z)){const me=[];for(const Ge of Z)if(typeof Ge=="string")try{Intl.Segmenter.supportedLocalesOf(Ge).length>0&&me.push(Ge)}catch{}return me}return this.defaultValue}}var He;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class _e extends k{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(201,null),$.localize(202,null),$.localize(203,null),$.localize(204,null)],description:$.localize(205,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,me,Ge){return me.get(2)===2?0:Ge}}class xe extends f{constructor(){super(146)}compute(Z,me,Ge){const we=me.get(145);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:we.isWordWrapMinified,isViewportWrapping:we.isViewportWrapping,wrappingColumn:we.wrappingColumn}}}class et extends k{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:$.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(208,null),$.localize(209,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:r(me.enabled,this.defaultValue.enabled),showDropSelector:d(me.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends k{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:$.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(212,null),$.localize(213,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:r(me.enabled,this.defaultValue.enabled),showPasteSelector:d(me.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const it="Consolas, 'Courier New', monospace",ct="Menlo, Monaco, 'Courier New', monospace",gt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:R.$j?ct:R.$k?gt:it,fontWeight:"normal",fontSize:R.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(X){return e.editorOptionsRegistry[X.id]=X,X}var ot;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.inlineEdit=63]="inlineEdit",X[X.letterSpacing=64]="letterSpacing",X[X.lightbulb=65]="lightbulb",X[X.lineDecorationsWidth=66]="lineDecorationsWidth",X[X.lineHeight=67]="lineHeight",X[X.lineNumbers=68]="lineNumbers",X[X.lineNumbersMinChars=69]="lineNumbersMinChars",X[X.linkedEditing=70]="linkedEditing",X[X.links=71]="links",X[X.matchBrackets=72]="matchBrackets",X[X.minimap=73]="minimap",X[X.mouseStyle=74]="mouseStyle",X[X.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=76]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",X[X.multiCursorModifier=78]="multiCursorModifier",X[X.multiCursorPaste=79]="multiCursorPaste",X[X.multiCursorLimit=80]="multiCursorLimit",X[X.occurrencesHighlight=81]="occurrencesHighlight",X[X.overviewRulerBorder=82]="overviewRulerBorder",X[X.overviewRulerLanes=83]="overviewRulerLanes",X[X.padding=84]="padding",X[X.pasteAs=85]="pasteAs",X[X.parameterHints=86]="parameterHints",X[X.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",X[X.quickSuggestions=89]="quickSuggestions",X[X.quickSuggestionsDelay=90]="quickSuggestionsDelay",X[X.readOnly=91]="readOnly",X[X.readOnlyMessage=92]="readOnlyMessage",X[X.renameOnType=93]="renameOnType",X[X.renderControlCharacters=94]="renderControlCharacters",X[X.renderFinalNewline=95]="renderFinalNewline",X[X.renderLineHighlight=96]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=98]="renderValidationDecorations",X[X.renderWhitespace=99]="renderWhitespace",X[X.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",X[X.roundedSelection=101]="roundedSelection",X[X.rulers=102]="rulers",X[X.scrollbar=103]="scrollbar",X[X.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=105]="scrollBeyondLastLine",X[X.scrollPredominantAxis=106]="scrollPredominantAxis",X[X.selectionClipboard=107]="selectionClipboard",X[X.selectionHighlight=108]="selectionHighlight",X[X.selectOnLineNumbers=109]="selectOnLineNumbers",X[X.showFoldingControls=110]="showFoldingControls",X[X.showUnused=111]="showUnused",X[X.snippetSuggestions=112]="snippetSuggestions",X[X.smartSelect=113]="smartSelect",X[X.smoothScrolling=114]="smoothScrolling",X[X.stickyScroll=115]="stickyScroll",X[X.stickyTabStops=116]="stickyTabStops",X[X.stopRenderingLineAfter=117]="stopRenderingLineAfter",X[X.suggest=118]="suggest",X[X.suggestFontSize=119]="suggestFontSize",X[X.suggestLineHeight=120]="suggestLineHeight",X[X.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",X[X.suggestSelection=122]="suggestSelection",X[X.tabCompletion=123]="tabCompletion",X[X.tabIndex=124]="tabIndex",X[X.unicodeHighlighting=125]="unicodeHighlighting",X[X.unusualLineTerminators=126]="unusualLineTerminators",X[X.useShadowDOM=127]="useShadowDOM",X[X.useTabStops=128]="useTabStops",X[X.wordBreak=129]="wordBreak",X[X.wordSegmenterLocales=130]="wordSegmenterLocales",X[X.wordSeparators=131]="wordSeparators",X[X.wordWrap=132]="wordWrap",X[X.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=135]="wordWrapColumn",X[X.wordWrapOverride1=136]="wordWrapOverride1",X[X.wordWrapOverride2=137]="wordWrapOverride2",X[X.wrappingIndent=138]="wrappingIndent",X[X.wrappingStrategy=139]="wrappingStrategy",X[X.showDeprecated=140]="showDeprecated",X[X.inlayHints=141]="inlayHints",X[X.editorClassName=142]="editorClassName",X[X.pixelRatio=143]="pixelRatio",X[X.tabFocusMode=144]="tabFocusMode",X[X.layoutInfo=145]="layoutInfo",X[X.wrappingInfo=146]="wrappingInfo",X[X.defaultColorDecorators=147]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(ot||(e.EditorOption=ot={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(214,null)})),acceptSuggestionOnEnter:Ue(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(215,null),""],markdownDescription:$.localize(216,null)})),accessibilitySupport:Ue(new p),accessibilityPageSize:Ue(new i(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(217,null),tags:["accessibility"]})),ariaLabel:Ue(new t(4,"ariaLabel",$.localize(218,null))),ariaRequired:Ue(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(220,null),$.localize(221,null),""],description:$.localize(222,null)})),autoClosingComments:Ue(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(223,null),$.localize(224,null),""],description:$.localize(225,null)})),autoClosingDelete:Ue(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(226,null),""],description:$.localize(227,null)})),autoClosingOvertype:Ue(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(228,null),""],description:$.localize(229,null)})),autoClosingQuotes:Ue(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(230,null),$.localize(231,null),""],description:$.localize(232,null)})),autoIndent:Ue(new g(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[$.localize(233,null),$.localize(234,null),$.localize(235,null),$.localize(236,null),$.localize(237,null)],description:$.localize(238,null)})),automaticLayout:Ue(new o(13,"automaticLayout",!1)),autoSurround:Ue(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(239,null),$.localize(240,null),$.localize(241,null),""],description:$.localize(242,null)})),bracketPairColorization:Ue(new G),bracketPairGuides:Ue(new H),stickyTabStops:Ue(new o(116,"stickyTabStops",!1,{description:$.localize(243,null)})),codeLens:Ue(new o(17,"codeLens",!0,{description:$.localize(244,null)})),codeLensFontFamily:Ue(new t(18,"codeLensFontFamily","",{description:$.localize(245,null)})),codeLensFontSize:Ue(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(246,null)})),colorDecorators:Ue(new o(20,"colorDecorators",!0,{description:$.localize(247,null)})),colorDecoratorActivatedOn:Ue(new a(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(248,null),$.localize(249,null),$.localize(250,null)],description:$.localize(251,null)})),colorDecoratorsLimit:Ue(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(252,null)})),columnSelection:Ue(new o(22,"columnSelection",!1,{description:$.localize(253,null)})),comments:Ue(new v),contextmenu:Ue(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new o(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(254,null)})),cursorBlinking:Ue(new g(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:$.localize(255,null)})),cursorSmoothCaretAnimation:Ue(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(256,null),$.localize(257,null),$.localize(258,null)],description:$.localize(259,null)})),cursorStyle:Ue(new g(28,"cursorStyle",D.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],I,{description:$.localize(260,null)})),cursorSurroundingLines:Ue(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(261,null)})),cursorSurroundingLinesStyle:Ue(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(262,null),$.localize(263,null)],markdownDescription:$.localize(264,null)})),cursorWidth:Ue(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(265,null)})),disableLayerHinting:Ue(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new o(34,"domReadOnly",!1)),dragAndDrop:Ue(new o(35,"dragAndDrop",!0,{description:$.localize(266,null)})),emptySelectionClipboard:Ue(new W),dropIntoEditor:Ue(new et),stickyScroll:Ue(new Ne),experimentalWhitespaceRendering:Ue(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(267,null),$.localize(268,null),$.localize(269,null)],description:$.localize(270,null)})),extraEditorClassName:Ue(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new u(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:$.localize(271,null)})),find:Ue(new V),fixedOverflowWidgets:Ue(new o(42,"fixedOverflowWidgets",!1)),folding:Ue(new o(43,"folding",!0,{description:$.localize(272,null)})),foldingStrategy:Ue(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(273,null),$.localize(274,null)],description:$.localize(275,null)})),foldingHighlight:Ue(new o(45,"foldingHighlight",!0,{description:$.localize(276,null)})),foldingImportsByDefault:Ue(new o(46,"foldingImportsByDefault",!1,{description:$.localize(277,null)})),foldingMaximumRegions:Ue(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ue(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(279,null)})),fontFamily:Ue(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(280,null)})),fontInfo:Ue(new B),fontLigatures2:Ue(new q),fontSize:Ue(new K),fontWeight:Ue(new ie),fontVariations:Ue(new N),formatOnPaste:Ue(new o(55,"formatOnPaste",!1,{description:$.localize(281,null)})),formatOnType:Ue(new o(56,"formatOnType",!1,{description:$.localize(282,null)})),glyphMargin:Ue(new o(57,"glyphMargin",!0,{description:$.localize(283,null)})),gotoLocation:Ue(new ce),hideCursorInOverviewRuler:Ue(new o(59,"hideCursorInOverviewRuler",!1,{description:$.localize(284,null)})),hover:Ue(new ye),inDiffEditor:Ue(new o(61,"inDiffEditor",!1)),letterSpacing:Ue(new u(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>u.clamp(X,-5,20),{description:$.localize(285,null)})),lightbulb:Ue(new ae),lineDecorationsWidth:Ue(new z),lineHeight:Ue(new x),lineNumbers:Ue(new he),lineNumbersMinChars:Ue(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new o(70,"linkedEditing",!1,{description:$.localize(286,null)})),links:Ue(new o(71,"links",!0,{description:$.localize(287,null)})),matchBrackets:Ue(new a(72,"matchBrackets","always",["always","near","never"],{description:$.localize(288,null)})),minimap:Ue(new be),mouseStyle:Ue(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new u(75,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:$.localize(289,null)})),mouseWheelZoom:Ue(new o(76,"mouseWheelZoom",!1,{markdownDescription:R.$j?$.localize(290,null):$.localize(291,null)})),multiCursorMergeOverlapping:Ue(new o(77,"multiCursorMergeOverlapping",!0,{description:$.localize(292,null)})),multiCursorModifier:Ue(new g(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Fe,{markdownEnumDescriptions:[$.localize(293,null),$.localize(294,null)],markdownDescription:$.localize(295,null)})),multiCursorPaste:Ue(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(296,null),$.localize(297,null)],markdownDescription:$.localize(298,null)})),multiCursorLimit:Ue(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(299,null)})),occurrencesHighlight:Ue(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[$.localize(300,null),$.localize(301,null),$.localize(302,null)],markdownDescription:$.localize(303,null)})),overviewRulerBorder:Ue(new o(82,"overviewRulerBorder",!0,{description:$.localize(304,null)})),overviewRulerLanes:Ue(new i(83,"overviewRulerLanes",3,0,3)),padding:Ue(new De),pasteAs:Ue(new tt),parameterHints:Ue(new pe),peekWidgetDefaultFocus:Ue(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(305,null),$.localize(306,null)],description:$.localize(307,null)})),definitionLinkOpensInPeek:Ue(new o(88,"definitionLinkOpensInPeek",!1,{description:$.localize(308,null)})),quickSuggestions:Ue(new Q),quickSuggestionsDelay:Ue(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(309,null)})),readOnly:Ue(new o(91,"readOnly",!1)),readOnlyMessage:Ue(new de),renameOnType:Ue(new o(93,"renameOnType",!1,{description:$.localize(310,null),markdownDeprecationMessage:$.localize(311,null)})),renderControlCharacters:Ue(new o(94,"renderControlCharacters",!0,{description:$.localize(312,null),restricted:!0})),renderFinalNewline:Ue(new a(95,"renderFinalNewline",R.$k?"dimmed":"on",["off","on","dimmed"],{description:$.localize(313,null)})),renderLineHighlight:Ue(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(314,null)],description:$.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ue(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(316,null)})),renderValidationDecorations:Ue(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(317,null),$.localize(318,null),$.localize(319,null),""],description:$.localize(320,null)})),revealHorizontalRightPadding:Ue(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new o(101,"roundedSelection",!0,{description:$.localize(321,null)})),rulers:Ue(new Me),scrollbar:Ue(new Ae),scrollBeyondLastColumn:Ue(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(322,null)})),scrollBeyondLastLine:Ue(new o(105,"scrollBeyondLastLine",!0,{description:$.localize(323,null)})),scrollPredominantAxis:Ue(new o(106,"scrollPredominantAxis",!0,{description:$.localize(324,null)})),selectionClipboard:Ue(new o(107,"selectionClipboard",!0,{description:$.localize(325,null),included:R.$k})),selectionHighlight:Ue(new o(108,"selectionHighlight",!0,{description:$.localize(326,null)})),selectOnLineNumbers:Ue(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(327,null),$.localize(328,null),$.localize(329,null)],description:$.localize(330,null)})),showUnused:Ue(new o(111,"showUnused",!0,{description:$.localize(331,null)})),showDeprecated:Ue(new o(140,"showDeprecated",!0,{description:$.localize(332,null)})),inlayHints:Ue(new ne),snippetSuggestions:Ue(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(333,null),$.localize(334,null),$.localize(335,null),$.localize(336,null)],description:$.localize(337,null)})),smartSelect:Ue(new Oe),smoothScrolling:Ue(new o(114,"smoothScrolling",!1,{description:$.localize(338,null)})),stopRenderingLineAfter:Ue(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new re),inlineSuggest:Ue(new U),inlineEdit:Ue(new F),inlineCompletionsAccessibilityVerbose:Ue(new o(149,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(339,null)})),suggestFontSize:Ue(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new o(121,"suggestOnTriggerCharacters",!0,{description:$.localize(342,null)})),suggestSelection:Ue(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(343,null),$.localize(344,null),$.localize(345,null)],description:$.localize(346,null)})),tabCompletion:Ue(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(347,null),$.localize(348,null),$.localize(349,null)],description:$.localize(350,null)})),tabIndex:Ue(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new je),unusualLineTerminators:Ue(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(351,null),$.localize(352,null),$.localize(353,null)],description:$.localize(354,null)})),useShadowDOM:Ue(new o(127,"useShadowDOM",!0)),useTabStops:Ue(new o(128,"useTabStops",!0,{description:$.localize(355,null)})),wordBreak:Ue(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(356,null),$.localize(357,null)],description:$.localize(358,null)})),wordSegmenterLocales:Ue(new Be),wordSeparators:Ue(new t(131,"wordSeparators",A.$5s,{description:$.localize(359,null)})),wordWrap:Ue(new a(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(360,null),$.localize(361,null),$.localize(362,null),$.localize(363,null)],description:$.localize(364,null)})),wordWrapBreakAfterCharacters:Ue(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(365,null)})),wordWrapOverride1:Ue(new a(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new a(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new P),defaultColorDecorators:Ue(new o(147,"defaultColorDecorators",!1,{markdownDescription:$.localize(366,null)})),pixelRatio:Ue(new ge),tabFocusMode:Ue(new o(144,"tabFocusMode",!1,{markdownDescription:$.localize(367,null)})),layoutInfo:Ue(new fe),wrappingInfo:Ue(new xe),wrappingIndent:Ue(new _e),wrappingStrategy:Ue(new $e)}}),define(Se[160],Pe([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[161],Pe([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[162],Pe([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(Se[163],Pe([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[164],Pe([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[165],Pe([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(Se[166],Pe([9,10]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(Se[167],Pe([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(Se[168],Pe([9,10]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(Se[169],Pe([9,10]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[170],Pe([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[171],Pe([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(Se[172],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[173],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[174],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[175],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Se[176],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[177],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[178],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[179],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[180],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[181],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[182],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[183],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[184],Pe([9,10]),function(le,e){return le.create("vs/workbench/common/configuration",e)}),define(Se[185],Pe([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(Se[186],Pe([9,10]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(Se[187],Pe([9,10]),function(le,e){return le.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Se[188],Pe([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[189],Pe([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[190],Pe([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[191],Pe([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[192],Pe([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[193],Pe([9,10]),function(le,e){return le.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[194],Pe([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[195],Pe([9,10]),function(le,e){return le.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[196],Pe([1,0,14,162]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.TokenType=void 0;var R;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(R||(e.TokenType=R={}));function M(...E){switch(E.length){case 1:return(0,O.localize)(0,null,E[0]);case 2:return(0,O.localize)(1,null,E[0],E[1]);case 3:return(0,O.localize)(2,null,E[0],E[1],E[2]);default:return}}const A=(0,O.localize)(3,null),$=(0,O.localize)(4,null);class m{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,C.$8)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(T=>T.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(T){return this.c=T,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(T){return this.r()||this.c.charCodeAt(this.e)!==T?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(T){this.f.push({type:T,offset:this.d})}l(T){const k=this.d,l=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:l};this.g.push({offset:k,lexeme:l,additionalInfo:T}),this.f.push(w)}n(){this.m.lastIndex=this.d;const T=this.m.exec(this.c);if(T){this.e=this.d+T[0].length;const k=this.c.substring(this.d,this.e),l=m.b.get(k);l?this.k(l):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let T=this.e,k=!1,l=!1;for(;;){if(T>=this.c.length){this.e=T,this.l($);return}const f=this.c.charCodeAt(T);if(k)k=!1;else if(f===47&&!l){T++;break}else f===91?l=!0:f===92?k=!0:f===93&&(l=!1);T++}for(;T<this.c.length&&m.a.has(this.c.charCodeAt(T));)T++;this.e=T;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$rj=m}),define(Se[197],Pe([1,0,23,33,164,311]),function(le,e,C,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=m,e.$Hp=E,e.$Ip=T,e.$Jp=k,e.$Kp=l,e.$Lp=w,e.$Mp=f;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function m(o){return o=o.trim(),o==="*"||A.test(o)}function E(o){if(!m(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=o.match(A);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function T(o){if(!o)return null;const n=o.majorBase,i=o.majorMustEqual,c=o.minorBase;let u=o.minorMustEqual;const t=o.patchBase;let d=o.patchMustEqual;o.hasCaret&&(n===0||(u=!1),d=!1);let a=0;if(o.preRelease){const g=$.exec(o.preRelease);if(g){const[,b,p,v]=g;a=Date.UTC(Number(b),Number(p)-1,Number(v))}}return{majorBase:n,majorMustEqual:i,minorBase:c,minorMustEqual:u,patchBase:t,patchMustEqual:d,isMinimum:o.hasGreaterEquals,notBefore:a}}function k(o,n,i){let c;typeof o=="string"?c=T(E(o)):c=o;let u;n instanceof Date?u=n.getTime():typeof n=="string"&&(u=new Date(n).getTime());let t;if(typeof i=="string"?t=T(E(i)):t=i,!c||!t)return!1;const d=c.majorBase,a=c.minorBase,g=c.patchBase;let b=t.majorBase,p=t.minorBase,v=t.patchBase;const y=t.notBefore;let h=t.majorMustEqual,D=t.minorMustEqual,S=t.patchMustEqual;return t.isMinimum?d>b?!0:d<b?!1:a>p?!0:a<p||u&&u<y?!1:g>=v:(d===1&&b===0&&(!h||!D||!S)&&(b=1,p=0,v=0,h=!0,D=!1,S=!1),d<b?!1:d>b?!h:a<p?!1:a>p?!D:g<v?!1:g>v?!S:!(u&&u<y))}function l(o,n,i,c,u){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([O.default.Error,R.localize(0,null)]),t;if(typeof c.name!="string")return t.push([O.default.Error,R.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([O.default.Error,R.localize(2,null,"version")]),t;if(!c.engines)return t.push([O.default.Error,R.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([O.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!r(c.extensionDependencies))return t.push([O.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!r(c.activationEvents))return t.push([O.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([O.default.Error,R.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([O.default.Warning,R.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([O.default.Error,R.localize(9,null,"main")]),t;{const g=(0,C.$0g)(i,c.main);(0,C.$4g)(g,i)||t.push([O.default.Warning,R.localize(10,null,g.path,i.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([O.default.Error,R.localize(11,null,"browser")]),t;{const g=(0,C.$0g)(i,c.browser);(0,C.$4g)(g,i)||t.push([O.default.Warning,R.localize(12,null,g.path,i.path)])}}if(!M.valid(c.version))return t.push([O.default.Error,R.localize(13,null)]),t;const d=[];if(!w(o,n,c,u,d))for(const g of d)t.push([O.default.Error,g]);return t}function w(o,n,i,c,u){return c||typeof i.main>"u"&&typeof i.browser>"u"?!0:s(o,n,i.engines.vscode,u)}function f(o,n,i){return o==="*"||s(n,i,o)}function s(o,n,i,c=[]){const u=T(E(i));if(!u)return c.push(R.localize(14,null,i)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return c.push(R.localize(15,null,i)),!1}else if(!u.majorMustEqual)return c.push(R.localize(16,null,i)),!1;return k(o,n,u)?!0:(c.push(R.localize(17,null,o,i)),!1)}function r(o){if(!Array.isArray(o))return!1;for(let n=0,i=o.length;n<i;n++)if(typeof o[n]!="string")return!1;return!0}}),define(Se[71],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class C{constructor(R,M=[],A=!1){this.ctor=R,this.staticArguments=M,this.supportsDelayedInstantiation=A}}e.$ti=C}),define(Se[56],Pe([1,0,71]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$xs=M,e.$ys=A;const O=[];var R;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function M($,m,E){m instanceof C.$ti||(m=new C.$ti(m,[],!!E)),O.push([$,m])}function A(){return O}}),define(Se[198],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0;class C{constructor(M,A){this.key=M,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$ar=C;class O{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const A of this.a.values())A.outgoing.size===0&&M.push(A);return M}insertEdge(M,A){const $=this.lookupOrInsertNode(M),m=this.lookupOrInsertNode(A);$.outgoing.set(m.key,m),m.incoming.set($.key,$)}removeNode(M){const A=this.b(M);this.a.delete(A);for(const $ of this.a.values())$.outgoing.delete(A),$.incoming.delete(A)}lookupOrInsertNode(M){const A=this.b(M);let $=this.a.get(A);return $||($=new C(A,M),this.a.set(A,$)),$}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[A,$]of this.a)M.push(`${A}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,A]of this.a){const $=new Set([M]),m=this.c(A,$);if(m)return m}}c(M,A){for(const[$,m]of M.outgoing){if(A.has($))return[...A,$].join(" -> ");A.add($);const E=this.c(m,A);if(E)return E;A.delete($)}}}e.$br=O}),define(Se[3],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e._util=void 0,e.$wi=R,e.$xi=M;var C;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function $(m){return m[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=$})(C||(e._util=C={})),e.$vi=R("instantiationService");function O(A,$,m){$[C.DI_TARGET]===$?$[C.DI_DEPENDENCIES].push({id:A,index:m}):($[C.DI_DEPENDENCIES]=[{id:A,index:m}],$[C.DI_TARGET]=$)}function R(A){if(C.serviceIds.has(A))return C.serviceIds.get(A);const $=function(m,E,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O($,m,T)};return $.toString=()=>A,C.serviceIds.set(A,$),$}function M(A){return A}}),define(Se[50],Pe([1,0,15,2,3]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$3i=void 0,e.$4i=M,e.$5i=A,e.$6i=m,e.$7i=E,e.$8i=T,e.$9i=k,e.$0i=l,e.$$i=f,e.$_i=s,e.$aj=r,e.$3i=(0,R.$wi)("configurationService");function M(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof O.URI)}function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof O.URI)}var $;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function m(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function T(o,n){const i=Object.create(null);for(const c in o)k(i,c,o[c],n);return i}function k(o,n,i,c){const u=n.split("."),t=u.pop();let d=o;for(let a=0;a<u.length;a++){const g=u[a];let b=d[g];switch(typeof b){case"undefined":b=d[g]=Object.create(null);break;case"object":if(b===null){c(`Ignoring ${n} as ${u.slice(0,a+1).join(".")} is null`);return}break;default:c(`Ignoring ${n} as ${u.slice(0,a+1).join(".")} is ${JSON.stringify(b)}`);return}d=b}if(typeof d=="object"&&d!==null)try{d[t]=i}catch{c(`Ignoring ${n} as ${u.join(".")} is ${JSON.stringify(d)}`)}else c(`Ignoring ${n} as ${u.join(".")} is ${JSON.stringify(d)}`)}function l(o,n){const i=n.split(".");w(o,i)}function w(o,n){const i=n.shift();if(n.length===0){delete o[i];return}if(Object.keys(o).indexOf(i)!==-1){const c=o[i];typeof c=="object"&&!Array.isArray(c)&&(w(c,n),Object.keys(c).length===0&&delete o[i])}}function f(o,n,i){function c(d,a){let g=d;for(const b of a){if(typeof g!="object"||g===null)return;g=g[b]}return g}const u=n.split("."),t=c(o,u);return typeof t>"u"?i:t}function s(o,n,i){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in o?C.$$f(o[c])&&C.$$f(n[c])?s(o[c],n[c],i):i&&(o[c]=n[c]):o[c]=n[c])})}function r(o){return o.replace(/[\[\]]/g,"")}}),define(Se[31],Pe([1,0,22,13,196,3,161,14]),function(le,e,C,O,R,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$uj=e.$tj=e.ContextKeyExprType=void 0,e.$sj=E,e.$vj=d,e.$wj=a,e.$Pj=Te;const m=new Map;m.set("false",!1),m.set("true",!0),m.set("isMac",C.$j),m.set("isLinux",C.$k),m.set("isWindows",C.$i),m.set("isWeb",C.$o),m.set("isMacNative",C.$j&&!C.$o),m.set("isEdge",C.$H),m.set("isFirefox",C.$F),m.set("isChrome",C.$E),m.set("isSafari",C.$G);function E(ne,z){if(m.get(ne)!==void 0)throw(0,$.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");m.set(ne,z)}const T=Object.prototype.hasOwnProperty;var k;(function(ne){ne[ne.False=0]="False",ne[ne.True=1]="True",ne[ne.Defined=2]="Defined",ne[ne.Not=3]="Not",ne[ne.Equals=4]="Equals",ne[ne.NotEquals=5]="NotEquals",ne[ne.And=6]="And",ne[ne.Regex=7]="Regex",ne[ne.NotRegex=8]="NotRegex",ne[ne.Or=9]="Or",ne[ne.In=10]="In",ne[ne.NotIn=11]="NotIn",ne[ne.Greater=12]="Greater",ne[ne.GreaterEquals=13]="GreaterEquals",ne[ne.Smaller=14]="Smaller",ne[ne.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const l={regexParsingWithErrorRecovery:!0},w=(0,A.localize)(0,null),f=(0,A.localize)(1,null),s=(0,A.localize)(2,null),r=(0,A.localize)(3,null),o=(0,A.localize)(4,null),n=(0,A.localize)(5,null),i=(0,A.localize)(6,null),c=(0,A.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=l){this.k=z,this.d=new R.$rj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const be=this.D(),Fe=be.type===17?n:void 0;throw this.h.push({message:o,offset:be.offset,lexeme:R.$rj.getLexeme(be),additionalInfo:Fe}),u.c}return x}catch(x){if(x!==u.c)throw x;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const x=this.o();z.push(x)}return z.length===1?z[0]:t.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const x=this.s();z.push(x)}return z.length===1?z[0]:t.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),b.INSTANCE;case 12:return this.z(),p.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,r),x?.negate()}case 17:return this.z(),I.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const x=this.l();return this.A(1,r),x}case 17:{const x=z.lexeme;if(this.z(),this.y(9)){const Fe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Fe.type!==10)throw this.B("REGEX",Fe);const De=Fe.lexeme,pe=De.lastIndexOf("/"),ge=pe===De.length-1?void 0:this.w(De.substring(pe+1));let Q;try{Q=new RegExp(De.substring(1,pe),ge)}catch{throw this.B("REGEX",Fe)}return B.create(x,Q)}switch(Fe.type){case 10:case 19:{const De=[Fe.lexeme];this.z();let pe=this.D(),ge=0;for(let Me=0;Me<Fe.lexeme.length;Me++)Fe.lexeme.charCodeAt(Me)===40?ge++:Fe.lexeme.charCodeAt(Me)===41&&ge--;for(;!this.E()&&pe.type!==15&&pe.type!==16;){switch(pe.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Me=0;Me<pe.lexeme.length;Me++)pe.lexeme.charCodeAt(Me)===40?ge++:Fe.lexeme.charCodeAt(Me)===41&&ge--}if(ge<0)break;De.push(R.$rj.getLexeme(pe)),this.z(),pe=this.D()}const Q=De.join(""),Y=Q.lastIndexOf("/"),he=Y===Q.length-1?void 0:this.w(Q.substring(Y+1));let ue;try{ue=new RegExp(Q.substring(1,Y),he)}catch{throw this.B("REGEX",Fe)}return t.regex(x,ue)}case 18:{const De=Fe.lexeme;this.z();let pe=null;if(!(0,O.$7e)(De)){const ge=De.indexOf("/"),Q=De.lastIndexOf("/");if(ge!==Q&&ge>=0){const Y=De.slice(ge+1,Q),he=De[Q+1]==="i"?"i":"";try{pe=new RegExp(Y,he)}catch{throw this.B("REGEX",Fe)}}}if(pe===null)throw this.B("REGEX",Fe);return B.create(x,pe)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Fe=this.u();return t.notIn(x,Fe)}switch(this.D().type){case 3:{this.z();const Fe=this.u();if(this.x().type===18)return t.equals(x,Fe);switch(Fe){case"true":return t.has(x);case"false":return t.not(x);default:return t.equals(x,Fe)}}case 4:{this.z();const Fe=this.u();if(this.x().type===18)return t.notEquals(x,Fe);switch(Fe){case"true":return t.not(x);case"false":return t.has(x);default:return t.notEquals(x,Fe)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),N.create(x,this.u());case 7:return this.z(),W.create(x,this.u());case 8:return this.z(),V.create(x,this.u());case 13:return this.z(),t.in(x,this.u());default:return t.has(x)}}case 20:throw this.h.push({message:i,offset:z.offset,lexeme:"",additionalInfo:c}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,x){if(this.C(z))return this.z();throw this.B(x,this.D())}B(z,x,be){const Fe=(0,A.localize)(8,null,z,R.$rj.getLexeme(x)),De=x.offset,pe=R.$rj.getLexeme(x);return this.h.push({message:Fe,offset:De,lexeme:pe,additionalInfo:be}),u.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$tj=u;class t{static false(){return b.INSTANCE}static true(){return p.INSTANCE}static has(z){return v.create(z)}static equals(z,x){return y.create(z,x)}static notEquals(z,x){return S.create(z,x)}static regex(z,x){return B.create(z,x)}static in(z,x){return h.create(z,x)}static notIn(z,x){return D.create(z,x)}static not(z){return I.create(z)}static and(...z){return ce.create(z,null,!0)}static or(...z){return ye.create(z,null,!0)}static greater(z,x){return W.create(z,x)}static greaterEquals(z,x){return V.create(z,x)}static smaller(z,x){return q.create(z,x)}static smallerEquals(z,x){return N.create(z,x)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$uj=t;function d(ne){const z=new u({regexParsingWithErrorRecovery:!1});return ne.map(x=>(z.parse(x),z.lexingErrors.length>0?z.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,A.localize)(9,null,be.additionalInfo):(0,A.localize)(10,null),offset:be.offset,length:be.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function a(ne,z){const x=ne?ne.substituteConstants():void 0,be=z?z.substituteConstants():void 0;return!x&&!be?!0:!x||!be?!1:x.equals(be)}function g(ne,z){return ne.cmp(z)}class b{static{this.INSTANCE=new b}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return p.INSTANCE}}e.$xj=b;class p{static{this.INSTANCE=new p}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return b.INSTANCE}}e.$yj=p;class v{static create(z,x=null){const be=m.get(z);return typeof be=="boolean"?be?p.INSTANCE:b.INSTANCE:new v(z,x)}constructor(z,x){this.key=z,this.c=x,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:fe(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=m.get(this.key);return typeof z=="boolean"?z?p.INSTANCE:b.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=I.create(this.key,this)),this.c}}e.$zj=v;class y{static create(z,x,be=null){if(typeof x=="boolean")return x?v.create(z,be):I.create(z,be);const Fe=m.get(z);return typeof Fe=="boolean"?x===(Fe?"true":"false")?p.INSTANCE:b.INSTANCE:new y(z,x,be)}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=m.get(this.c);if(typeof z=="boolean"){const x=z?"true":"false";return this.d===x?p.INSTANCE:b.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Aj=y;class h{static create(z,x){return new h(z,x)}constructor(z,x){this.d=z,this.f=x,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const x=z.getValue(this.f),be=z.getValue(this.d);return Array.isArray(x)?x.includes(be):typeof be=="string"&&typeof x=="object"&&x!==null?T.call(x,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$Bj=h;class D{static create(z,x){return new D(z,x)}constructor(z,x){this.d=z,this.f=x,this.type=11,this.c=h.create(z,x)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Cj=D;class S{static create(z,x,be=null){if(typeof x=="boolean")return x?I.create(z,be):v.create(z,be);const Fe=m.get(z);return typeof Fe=="boolean"?x===(Fe?"true":"false")?b.INSTANCE:p.INSTANCE:new S(z,x,be)}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=m.get(this.c);if(typeof z=="boolean"){const x=z?"true":"false";return this.d===x?b.INSTANCE:p.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Dj=S;class I{static create(z,x=null){const be=m.get(z);return typeof be=="boolean"?be?b.INSTANCE:p.INSTANCE:new I(z,x)}constructor(z,x){this.c=z,this.d=x,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:fe(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=m.get(this.c);return typeof z=="boolean"?z?b.INSTANCE:p.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$Ej=I;function P(ne,z){if(typeof ne=="string"){const x=parseFloat(ne);isNaN(x)||(ne=x)}return typeof ne=="string"||typeof ne=="number"?z(ne):b.INSTANCE}class W{static create(z,x,be=null){return P(x,Fe=>new W(z,Fe,be))}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Fj=W;class V{static create(z,x,be=null){return P(x,Fe=>new V(z,Fe,be))}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Gj=V;class q{static create(z,x,be=null){return P(x,Fe=>new q(z,Fe,be))}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Hj=q;class N{static create(z,x,be=null){return P(x,Fe=>new N(z,Fe,be))}constructor(z,x,be){this.c=z,this.d=x,this.f=be,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Ij=N;class B{static create(z,x){return new B(z,x)}constructor(z,x){this.d=z,this.f=x,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const x=this.f?this.f.source:"",be=z.f?z.f.source:"";return x<be?-1:x>be?1:0}equals(z){if(z.type===this.type){const x=this.f?this.f.source:"",be=z.f?z.f.source:"";return this.d===z.d&&x===be}return!1}substituteConstants(){return this}evaluate(z){const x=z.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Jj=B;class K{static create(z){return new K(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new K(this.c.map(z))}negate(){return this.c}}e.$Kj=K;function ie(ne){let z=null;for(let x=0,be=ne.length;x<be;x++){const Fe=ne[x].substituteConstants();if(ne[x]!==Fe&&z===null){z=[];for(let De=0;De<x;De++)z[De]=ne[De]}z!==null&&(z[x]=Fe)}return z===null?ne:z}class ce{static create(z,x,be){return ce.d(z,x,be)}constructor(z,x){this.expr=z,this.c=x,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let x=0,be=this.expr.length;x<be;x++){const Fe=g(this.expr[x],z.expr[x]);if(Fe!==0)return Fe}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].equals(z.expr[x]))return!1;return!0}return!1}substituteConstants(){const z=ie(this.expr);return z===this.expr?this:ce.create(z,this.c,!1)}evaluate(z){for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].evaluate(z))return!1;return!0}static d(z,x,be){const Fe=[];let De=!1;for(const pe of z)if(pe){if(pe.type===1){De=!0;continue}if(pe.type===0)return b.INSTANCE;if(pe.type===6){Fe.push(...pe.expr);continue}Fe.push(pe)}if(Fe.length===0&&De)return p.INSTANCE;if(Fe.length!==0){if(Fe.length===1)return Fe[0];Fe.sort(g);for(let pe=1;pe<Fe.length;pe++)Fe[pe-1].equals(Fe[pe])&&(Fe.splice(pe,1),pe--);if(Fe.length===1)return Fe[0];for(;Fe.length>1;){const pe=Fe[Fe.length-1];if(pe.type!==9)break;Fe.pop();const ge=Fe.pop(),Q=Fe.length===0,Y=ye.create(pe.expr.map(he=>ce.create([he,ge],null,be)),null,Q);Y&&(Fe.push(Y),Fe.sort(g))}if(Fe.length===1)return Fe[0];if(be){for(let pe=0;pe<Fe.length;pe++)for(let ge=pe+1;ge<Fe.length;ge++)if(Fe[pe].negate().equals(Fe[ge]))return b.INSTANCE;if(Fe.length===1)return Fe[0]}return new ce(Fe,x)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const x of this.expr)z.push(...x.keys());return z}map(z){return new ce(this.expr.map(x=>x.map(z)),null)}negate(){if(!this.c){const z=[];for(const x of this.expr)z.push(x.negate());this.c=ye.create(z,this,!0)}return this.c}}e.$Lj=ce;class ye{static create(z,x,be){return ye.d(z,x,be)}constructor(z,x){this.expr=z,this.c=x,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let x=0,be=this.expr.length;x<be;x++){const Fe=g(this.expr[x],z.expr[x]);if(Fe!==0)return Fe}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].equals(z.expr[x]))return!1;return!0}return!1}substituteConstants(){const z=ie(this.expr);return z===this.expr?this:ye.create(z,this.c,!1)}evaluate(z){for(let x=0,be=this.expr.length;x<be;x++)if(this.expr[x].evaluate(z))return!0;return!1}static d(z,x,be){let Fe=[],De=!1;if(z){for(let pe=0,ge=z.length;pe<ge;pe++){const Q=z[pe];if(Q){if(Q.type===0){De=!0;continue}if(Q.type===1)return p.INSTANCE;if(Q.type===9){Fe=Fe.concat(Q.expr);continue}Fe.push(Q)}}if(Fe.length===0&&De)return b.INSTANCE;Fe.sort(g)}if(Fe.length!==0){if(Fe.length===1)return Fe[0];for(let pe=1;pe<Fe.length;pe++)Fe[pe-1].equals(Fe[pe])&&(Fe.splice(pe,1),pe--);if(Fe.length===1)return Fe[0];if(be){for(let pe=0;pe<Fe.length;pe++)for(let ge=pe+1;ge<Fe.length;ge++)if(Fe[pe].negate().equals(Fe[ge]))return p.INSTANCE;if(Fe.length===1)return Fe[0]}return new ye(Fe,x)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const x of this.expr)z.push(...x.keys());return z}map(z){return new ye(this.expr.map(x=>x.map(z)),null)}negate(){if(!this.c){const z=[];for(const x of this.expr)z.push(x.negate());for(;z.length>1;){const x=z.shift(),be=z.shift(),Fe=[];for(const De of Ne(x))for(const pe of Ne(be))Fe.push(ce.create([De,pe],null,!1));z.unshift(ye.create(Fe,null,!1))}this.c=ye.create(z,this,!0)}return this.c}}e.$Mj=ye;class ke extends v{static{this.d=[]}static all(){return ke.d.values()}constructor(z,x,be){super(z,null),this.f=x,typeof be=="object"?ke.d.push({...be,key:z}):be!==!0&&ke.d.push({key:z,description:be,type:x!=null?typeof x:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return y.create(this.key,z)}notEqualsTo(z){return S.create(this.key,z)}}e.$Nj=ke,e.$Oj=(0,M.$wi)("contextKeyService");function fe(ne,z){return ne<z?-1:ne>z?1:0}function $e(ne,z,x,be){return ne<x?-1:ne>x?1:z<be?-1:z>be?1:0}function Te(ne,z){if(ne.type===0||z.type===1)return!0;if(ne.type===9)return z.type===9?ae(ne.expr,z.expr):!1;if(z.type===9){for(const x of z.expr)if(Te(ne,x))return!0;return!1}if(ne.type===6){if(z.type===6)return ae(z.expr,ne.expr);for(const x of ne.expr)if(Te(x,z))return!0;return!1}return ne.equals(z)}function ae(ne,z){let x=0,be=0;for(;x<ne.length&&be<z.length;){const Fe=ne[x].cmp(z[be]);if(Fe<0)return!1;Fe===0&&x++,be++}return x===ne.length}function Ne(ne){return ne.type===9?ne.expr:[ne]}}),define(Se[99],Pe([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=void 0,e.$Di=(0,C.$wi)("environmentService"),e.$Ei=(0,C.$xi)(e.$Di)}),define(Se[100],Pe([1,0,163,3]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.ExtensionGalleryErrorCode=e.$7o=e.ExtensionManagementErrorCode=e.$6o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0,e.$Zo=R,e.$1o=M,e.$2o=A,e.$3o=$,e.$4o=m,e.$5o=E,e.$To="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Uo=new RegExp(e.$To),e.$Vo="__web_extension",e.$Wo="skipWalkthrough",e.$Xo="extensionsSync",e.$Yo="dependecyOrPackExtensionInstall";function R(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function M(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function A(n,i){switch(n){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function $(n,i){return i==="web"&&!n.includes("web")}function m(n,i,c){return $(i,c)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===c}function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var T;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(T||(e.SortBy=T={}));var k;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var l;(function(n){n.Install="install",n.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var w;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$6o=(0,O.$wi)("extensionGalleryService");var f;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Cancelled="Cancelled",n.Unknown="Unknown",n.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));class s extends Error{constructor(i,c){super(i),this.code=c,this.name=c}}e.$7o=s;var r;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(r||(e.ExtensionGalleryErrorCode=r={}));class o extends Error{constructor(i,c){super(i),this.code=c,this.name=c}}e.$8o=o,e.$9o=(0,O.$wi)("extensionManagementService"),e.$0o="extensionsIdentifiers/disabled",e.$$o="extensionsIdentifiers/enabled",e.$_o=(0,O.$wi)("IGlobalExtensionEnablementService"),e.$ap=(0,O.$wi)("IExtensionTipsService"),e.$bp=(0,C.localize2)(0,"Extensions"),e.$cp=(0,C.localize2)(1,"Preferences")}),define(Se[38],Pe([1,0,54,19,13,15,2,165,3,22,16,43]),function(le,e,C,O,R,M,A,$,m,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$vl=e.FileKind=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.FileOperationResult=e.$nl=e.$ml=e.$ll=e.$jl=e.FileChangeType=e.$il=e.FileOperation=e.$cl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$3k=void 0,e.$4k=l,e.$5k=r,e.$6k=n,e.$7k=i,e.$8k=c,e.$9k=u,e.$0k=t,e.$$k=d,e.$_k=a,e.$al=g,e.$bl=b,e.$dl=y,e.$el=h,e.$fl=D,e.$gl=S,e.$hl=I,e.$kl=N,e.$wl=ke,e.$xl=fe,e.$zl=Te,e.$3k=(0,m.$wi)("fileService");function l(ae){return ae.create===!0}var w;(function(ae){ae[ae.Unknown=0]="Unknown",ae[ae.File=1]="File",ae[ae.Directory=2]="Directory",ae[ae.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var f;(function(ae){ae[ae.Readonly=1]="Readonly",ae[ae.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var s;(function(ae){ae[ae.UPDATED=2]="UPDATED",ae[ae.ADDED=4]="ADDED",ae[ae.DELETED=8]="DELETED"})(s||(e.FileChangeFilter=s={}));function r(ae){const Ne=ae;return!!Ne&&typeof Ne.onDidChange=="function"}var o;(function(ae){ae[ae.None=0]="None",ae[ae.FileReadWrite=2]="FileReadWrite",ae[ae.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ae[ae.FileReadStream=16]="FileReadStream",ae[ae.FileFolderCopy=8]="FileFolderCopy",ae[ae.PathCaseSensitive=1024]="PathCaseSensitive",ae[ae.Readonly=2048]="Readonly",ae[ae.Trash=4096]="Trash",ae[ae.FileWriteUnlock=8192]="FileWriteUnlock",ae[ae.FileAtomicRead=16384]="FileAtomicRead",ae[ae.FileAtomicWrite=32768]="FileAtomicWrite",ae[ae.FileAtomicDelete=65536]="FileAtomicDelete",ae[ae.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function n(ae){return!!(ae.capabilities&2)}function i(ae){return!!(ae.capabilities&8)}function c(ae){return!!(ae.capabilities&131072)}function u(ae){return!!(ae.capabilities&4)}function t(ae){return!!(ae.capabilities&16)}function d(ae){return n(ae)?!!(ae.capabilities&16384):!1}function a(ae){return n(ae)?!!(ae.capabilities&32768):!1}function g(ae){return!!(ae.capabilities&65536)}function b(ae){return!!(ae.capabilities&2048)}var p;(function(ae){ae.FileExists="EntryExists",ae.FileNotFound="EntryNotFound",ae.FileNotADirectory="EntryNotADirectory",ae.FileIsADirectory="EntryIsADirectory",ae.FileExceedsStorageQuota="EntryExceedsStorageQuota",ae.FileTooLarge="EntryTooLarge",ae.FileWriteLocked="EntryWriteLocked",ae.NoPermissions="NoPermissions",ae.Unavailable="Unavailable",ae.Unknown="Unknown"})(p||(e.FileSystemProviderErrorCode=p={}));class v extends Error{static create(Ne,ne){const z=new v(Ne.toString(),ne);return D(z,ne),z}constructor(Ne,ne){super(Ne),this.code=ne}}e.$cl=v;function y(ae,Ne){return v.create(ae,Ne)}function h(ae){return ae||y((0,$.localize)(0,null),p.Unknown)}function D(ae,Ne){return ae.name=Ne?`${Ne} (FileSystemError)`:"FileSystemError",ae}function S(ae){if(!ae)return p.Unknown;if(ae instanceof v)return ae.code;const Ne=/^(.+) \(FileSystemError\)$/.exec(ae.name);if(!Ne)return p.Unknown;switch(Ne[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}function I(ae){if(ae instanceof B)return ae.fileOperationResult;switch(S(ae)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 9;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileTooLarge:return 7;default:return 10}}var P;(function(ae){ae[ae.CREATE=0]="CREATE",ae[ae.DELETE=1]="DELETE",ae[ae.MOVE=2]="MOVE",ae[ae.COPY=3]="COPY",ae[ae.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class W{constructor(Ne,ne,z){this.resource=Ne,this.operation=ne,this.target=z}isOperation(Ne){return this.operation===Ne}}e.$il=W;var V;(function(ae){ae[ae.UPDATED=0]="UPDATED",ae[ae.ADDED=1]="ADDED",ae[ae.DELETED=2]="DELETED"})(V||(e.FileChangeType=V={}));class q{static{this.a=null}constructor(Ne,ne){this.c=ne,this.b=void 0,this.d=new k.$V(()=>{const z=C.$Ci.forUris(()=>this.c);return z.fill(this.rawAdded.map(x=>[x,!0])),z}),this.f=new k.$V(()=>{const z=C.$Ci.forUris(()=>this.c);return z.fill(this.rawUpdated.map(x=>[x,!0])),z}),this.g=new k.$V(()=>{const z=C.$Ci.forUris(()=>this.c);return z.fill(this.rawDeleted.map(x=>[x,!0])),z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const z of Ne){switch(z.type){case 1:this.rawAdded.push(z.resource);break;case 0:this.rawUpdated.push(z.resource);break;case 2:this.rawDeleted.push(z.resource);break}this.b!==q.a&&(typeof z.cId=="number"?this.b===void 0?this.b=z.cId:this.b!==z.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(Ne,...ne){return this.h(Ne,{includeChildren:!1},...ne)}affects(Ne,...ne){return this.h(Ne,{includeChildren:!0},...ne)}h(Ne,ne,...z){if(!Ne)return!1;const x=z.length>0;return!!((!x||z.includes(1))&&(this.d.value.get(Ne)||ne.includeChildren&&this.d.value.findSuperstr(Ne))||(!x||z.includes(0))&&(this.f.value.get(Ne)||ne.includeChildren&&this.f.value.findSuperstr(Ne))||(!x||z.includes(2))&&(this.g.value.findSubstr(Ne)||ne.includeChildren&&this.g.value.findSuperstr(Ne)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ne){return this.b===Ne}hasCorrelation(){return typeof this.b=="number"}}e.$jl=q;function N(ae,Ne,ne){return!ae||!Ne||ae===Ne||Ne.length>ae.length?!1:(Ne.charAt(Ne.length-1)!==O.sep&&(Ne+=O.sep),ne?(0,R.$yf)(ae,Ne):ae.indexOf(Ne)===0)}class B extends Error{constructor(Ne,ne,z){super(Ne),this.fileOperationResult=ne,this.options=z}}e.$ll=B;class K extends B{constructor(Ne,ne,z,x){super(Ne,ne,x),this.fileOperationResult=ne,this.size=z}}e.$ml=K;class ie extends B{constructor(Ne,ne,z){super(Ne,2,z),this.stat=ne}}e.$nl=ie;var ce;(function(ae){ae[ae.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ae[ae.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ae[ae.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ae[ae.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ae[ae.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ae[ae.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ae[ae.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ae[ae.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ae[ae.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ae[ae.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ae[ae.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ce||(e.FileOperationResult=ce={})),e.$ol={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ql="files.associations",e.$rl="files.exclude",e.$sl="files.readonlyInclude",e.$tl="files.readonlyExclude",e.$ul="files.readonlyFromPermissions";var ye;(function(ae){ae[ae.FILE=0]="FILE",ae[ae.FOLDER=1]="FOLDER",ae[ae.ROOT_FOLDER=2]="ROOT_FOLDER"})(ye||(e.FileKind=ye={})),e.$vl="";function ke(ae){if(!(typeof ae.size!="number"||typeof ae.mtime!="number"))return ae.mtime.toString(29)+ae.size.toString(31)}async function fe(ae,Ne){if(!Ne.hasProvider(A.URI.from({scheme:ae.scheme})))return new Promise(ne=>{const z=Ne.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===ae.scheme&&x.added&&(z.dispose(),ne())})})}class $e{static{this.KB=1024}static{this.MB=$e.KB*$e.KB}static{this.GB=$e.MB*$e.KB}static{this.TB=$e.GB*$e.KB}static formatSize(Ne){return(0,M.$ag)(Ne)||(Ne=0),Ne<$e.KB?(0,$.localize)(1,null,Ne.toFixed(0)):Ne<$e.MB?(0,$.localize)(2,null,(Ne/$e.KB).toFixed(2)):Ne<$e.GB?(0,$.localize)(3,null,(Ne/$e.MB).toFixed(2)):Ne<$e.TB?(0,$.localize)(4,null,(Ne/$e.GB).toFixed(2)):(0,$.localize)(5,null,(Ne/$e.TB).toFixed(2))}}e.$yl=$e;function Te(ae){const Ne=typeof ae=="string"||ae?.scheme===T.Schemas.vscodeRemote;return typeof ae!="string"&&ae?.scheme===T.Schemas.file?1024*$e.MB:Ne?10*$e.MB:E.$o?50*$e.MB:1024*$e.MB}}),define(Se[72],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=void 0;class C{constructor(...R){this.a=new Map;for(const[M,A]of R)this.set(M,A)}set(R,M){const A=this.a.get(R);return this.a.set(R,M),A}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$ui=C}),define(Se[199],Pe([1,0,11,14,6,71,198,3,72,200]),function(le,e,C,O,R,M,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=void 0;const T=!1;class k extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class l{constructor(r=new m.$ui,o=!1,n,i=T){this.i=r,this.j=o,this.k=n,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set($.$vi,this),this._globalGraph=i?n?._globalGraph??new A.$br(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,R.$Pc)(this.h),this.h.clear();for(const r of this.g)(0,R.$Oc)(r)&&r.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(r){this.m();const o=new class extends l{dispose(){this.h.delete(o),super.dispose()}}(r,this.j,this,this.l);return this.h.add(o),o}invokeFunction(r,...o){this.m();const n=f.traceInvocation(this.l,r);let i=!1;try{return r({get:u=>{if(i)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(u,n);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...o)}finally{i=!0,n.stop()}}createInstance(r,...o){this.m();let n,i;return r instanceof M.$ti?(n=f.traceCreation(this.l,r.ctor),i=this.o(r.ctor,r.staticArguments.concat(o),n)):(n=f.traceCreation(this.l,r),i=this.o(r,o,n)),n.stop(),i}o(r,o=[],n){const i=$._util.getServiceDependencies(r).sort((t,d)=>t.index-d.index),c=[];for(const t of i){const d=this.s(t.id,n);d||this.y(`[createInstance] ${r.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(d)}const u=i.length>0?i[0].index:o.length;if(o.length!==u){console.trace(`[createInstance] First service dependency of ${r.name} at position ${u+1} conflicts with ${o.length} static arguments`);const t=u-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,u)}return Reflect.construct(r,o.concat(c))}q(r,o){if(this.i.get(r)instanceof M.$ti)this.i.set(r,o);else if(this.k)this.k.q(r,o);else throw new Error("illegalState - setting UNKNOWN service instance")}r(r){const o=this.i.get(r);return!o&&this.k?this.k.r(r):o}s(r,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const n=this.r(r);return n instanceof M.$ti?this.u(r,n,o.branch(r,!0)):(o.branch(r,!1),n)}u(r,o,n){if(this.t.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.t.add(r);try{return this.v(r,o,n)}finally{this.t.delete(r)}}v(r,o,n){const i=new A.$br(t=>t.id.toString());let c=0;const u=[{id:r,desc:o,_trace:n}];for(;u.length;){const t=u.pop();if(i.lookupOrInsertNode(t),c++>1e3)throw new k(i);for(const d of $._util.getServiceDependencies(t.desc.ctor)){const a=this.r(d.id);if(a||this.y(`[createInstance] ${r} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(d.id)),a instanceof M.$ti){const g={id:d.id,desc:a,_trace:t._trace.branch(d.id,!0)};i.insertEdge(t,g),u.push(g)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new k(i);break}for(const{data:d}of t){if(this.r(d.id)instanceof M.$ti){const g=this.w(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.q(d.id,g)}i.removeNode(d)}}return this.r(r)}w(r,o,n=[],i,c){if(this.i.get(r)instanceof M.$ti)return this.x(r,o,n,i,c,this.g);if(this.k)return this.k.w(r,o,n,i,c);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}x(r,o,n=[],i,c,u){if(i){const t=new l(void 0,this.j,this,this.l);t.c=String(r);const d=new Map,a=new C.$Ph(()=>{const g=t.o(o,n,c);for(const[b,p]of d){const v=g[b];if(typeof v=="function")for(const y of p)y.disposable=v.apply(g,y.listener)}return d.clear(),u.add(g),g});return new Proxy(Object.create(null),{get(g,b){if(!a.isInitialized&&typeof b=="string"&&(b.startsWith("onDid")||b.startsWith("onWill"))){let y=d.get(b);return y||(y=new E.$5c,d.set(b,y)),(D,S,I)=>{if(a.isInitialized)return a.value[b](D,S,I);{const P={listener:[D,S,I],disposable:void 0},W=y.push(P);return(0,R.$Sc)(()=>{W(),P.disposable?.dispose()})}}}if(b in g)return g[b];const p=a.value;let v=p[b];return typeof v!="function"||(v=v.bind(p),g[b]=v),v},set(g,b,p){return a.value[b]=p,!0},getPrototypeOf(g){return o.prototype}})}else{const t=this.o(o,n,c);return u.add(t),t}}y(r,o){if(o&&console.warn(r),this.j)throw new Error(r)}}e.$cr=l;var w;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(w||(w={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(r,o){return r?new f(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(r,o){return r?new f(1,o.name):f.c}static{this.f=0}constructor(r,o){this.type=r,this.name=o,this.g=Date.now(),this.h=[]}branch(r,o){const n=new f(3,r.toString());return this.h.push([r,o,n]),n}stop(){const r=Date.now()-this.g;f.f+=r;let o=!1;function n(c,u){const t=[],d=new Array(c+1).join("	");for(const[a,g,b]of u.h)if(g&&b){o=!0,t.push(`${d}CREATES -> ${a}`);const p=n(c+1,b);p&&t.push(p)}else t.push(`${d}uses -> ${a}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(r>2||o)&&f.all.add(i.join(`
`))}}e.$dr=f}),define(Se[12],Pe([1,0,166,44,5,73,6,28,22,23,15,2,31,3]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$6j=e.LogLevel=e.$4j=e.$3j=void 0,e.$5j=s,e.log=o,e.$ek=v,e.$fk=y,e.$gk=h,e.$hk=D,e.$3j=(0,w.$wi)("logService"),e.$4j=(0,w.$wi)("loggerService");function f(){return new Date().toISOString()}function s(S){return(0,T.$ag)(S)}var r;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(r||(e.LogLevel=r={})),e.$6j=r.Info;function o(S,I,P){switch(I){case r.Trace:S.trace(P);break;case r.Debug:S.debug(P);break;case r.Info:S.info(P);break;case r.Warning:S.warn(P);break;case r.Error:S.error(P);break;case r.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function n(S,I=!1){let P="";for(let W=0;W<S.length;W++){let V=S[W];if(V instanceof Error&&(V=(0,O.$hj)(V,I)),typeof V=="object")try{V=JSON.stringify(V)}catch{}P+=(W>0?" ":"")+V}return P}class i extends A.$Uc{constructor(){super(...arguments),this.b=e.$6j,this.c=this.B(new R.$de),this.onDidChangeLogLevel=this.c.event}setLevel(I){this.b!==I&&(this.b=I,this.c.fire(this.b))}getLevel(){return this.b}f(I){return this.b!==r.Off&&this.b<=I}}e.$8j=i;class c extends i{constructor(I){super(),this.h=I}f(I){return this.h||super.f(I)}trace(I,...P){this.f(r.Trace)&&this.g(r.Trace,n([I,...P],!0))}debug(I,...P){this.f(r.Debug)&&this.g(r.Debug,n([I,...P]))}info(I,...P){this.f(r.Info)&&this.g(r.Info,n([I,...P]))}warn(I,...P){this.f(r.Warning)&&this.g(r.Warning,n([I,...P]))}error(I,...P){if(this.f(r.Error))if(I instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=I.stack,this.g(r.Error,n(W))}else this.g(r.Error,n([I,...P]))}flush(){}}e.$9j=c;class u extends i{constructor(I=e.$6j){super(),this.setLevel(I),this.g=!m.$i}trace(I,...P){this.f(r.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,I,...P):console.log(`[main ${f()}]`,I,...P))}debug(I,...P){this.f(r.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,I,...P):console.log(`[main ${f()}]`,I,...P))}info(I,...P){this.f(r.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,I,...P):console.log(`[main ${f()}]`,I,...P))}warn(I,...P){this.f(r.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,I,...P):console.warn(`[main ${f()}]`,I,...P))}error(I,...P){this.f(r.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,I,...P):console.error(`[main ${f()}]`,I,...P))}flush(){}}e.$0j=u;class t extends i{constructor(I=e.$6j,P=!0){super(),this.g=P,this.setLevel(I)}trace(I,...P){this.f(r.Trace)&&(this.g?console.log("%cTRACE","color: #888",I,...P):console.log(I,...P))}debug(I,...P){this.f(r.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",I,...P):console.log(I,...P))}info(I,...P){this.f(r.Info)&&(this.g?console.log("%c INFO","color: #33f",I,...P):console.log(I,...P))}warn(I,...P){this.f(r.Warning)&&(this.g?console.log("%c WARN","color: #993",I,...P):console.log(I,...P))}error(I,...P){this.f(r.Error)&&(this.g?console.log("%c  ERR","color: #f33",I,...P):console.error(I,...P))}flush(){}}e.$$j=t;class d extends i{constructor(I,P=e.$6j){super(),this.g=I,this.setLevel(P)}trace(I,...P){this.f(r.Trace)&&this.g.log(r.Trace,[this.h(I),...P])}debug(I,...P){this.f(r.Debug)&&this.g.log(r.Debug,[this.h(I),...P])}info(I,...P){this.f(r.Info)&&this.g.log(r.Info,[this.h(I),...P])}warn(I,...P){this.f(r.Warning)&&this.g.log(r.Warning,[this.h(I),...P])}error(I,...P){this.f(r.Error)&&this.g.log(r.Error,[this.h(I),...P])}h(I){return typeof I=="string"?I:(0,O.$hj)(I,this.f(r.Trace))}flush(){}}e.$_j=d;class a extends i{constructor(I){super(),this.g=I,I.length&&this.setLevel(I[0].getLevel())}setLevel(I){for(const P of this.g)P.setLevel(I);super.setLevel(I)}trace(I,...P){for(const W of this.g)W.trace(I,...P)}debug(I,...P){for(const W of this.g)W.debug(I,...P)}info(I,...P){for(const W of this.g)W.info(I,...P)}warn(I,...P){for(const W of this.g)W.warn(I,...P)}error(I,...P){for(const W of this.g)W.error(I,...P)}flush(){for(const I of this.g)I.flush()}dispose(){for(const I of this.g)I.dispose();super.dispose()}}e.$ak=a;class g extends A.$Uc{constructor(I,P,W){if(super(),this.h=I,this.j=P,this.b=new $.$Ac,this.c=this.B(new R.$de),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$de),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$de),this.onDidChangeVisibility=this.g.event,W)for(const V of W)this.b.set(V.resource,{logger:void 0,info:V})}m(I){return(0,T.$9f)(I)?[...this.b.values()].find(P=>P.info.id===I):this.b.get(I)}getLogger(I){return this.m(I)?.logger}createLogger(I,P){const W=this.n(I),V=(0,T.$9f)(I)?I:P?.id??(0,M.$kj)(W.toString()).toString(16);let q=this.b.get(W)?.logger;const N=P?.logLevel==="always"?r.Trace:P?.logLevel;q||(q=this.s(W,N??this.getLogLevel(W)??this.h,{...P,id:V}));const B={logger:q,info:{resource:W,id:V,logLevel:N,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(B.info),this.b.set(W,B),q}n(I){return(0,T.$9f)(I)?(0,E.$0g)(this.j,`${I}.log`):I}setLogLevel(I,P){if(k.URI.isUri(I)){const W=I,V=P,q=this.b.get(W);q&&V!==q.info.logLevel&&(q.info.logLevel=V===this.h?void 0:V,q.logger?.setLevel(V),this.b.set(q.info.resource,q),this.f.fire([W,V]))}else{this.h=I;for(const[W,V]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(I,P){const W=this.m(I);W&&P!==!W.info.hidden&&(W.info.hidden=!P,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,P]))}getLogLevel(I){let P;return I&&(P=this.b.get(I)?.info.logLevel),P??this.h}registerLogger(I){const P=this.b.get(I.resource);P?P.info.hidden!==I.hidden&&this.setVisibility(I.resource,!I.hidden):(this.b.set(I.resource,{info:I,logger:void 0}),this.c.fire({added:[I],removed:[]}))}deregisterLogger(I){const P=this.b.get(I);P&&(P.logger&&P.logger.dispose(),this.b.delete(I),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const I of this.b.values())yield I.info}getRegisteredLogger(I){return this.b.get(I)?.info}dispose(){this.b.forEach(I=>I.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bk=g;class b{constructor(){this.onDidChangeLogLevel=new R.$de().event}setLevel(I){}getLevel(){return r.Info}trace(I,...P){}debug(I,...P){}info(I,...P){}warn(I,...P){}error(I,...P){}critical(I,...P){}dispose(){}flush(){}}e.$ck=b;class p extends b{}e.$dk=p;function v(S){if(S.verbose)return r.Trace;if(typeof S.logLevel=="string"){const I=D(S.logLevel.toLowerCase());if(I!==void 0)return I}return e.$6j}function y(S){switch(S){case r.Trace:return"trace";case r.Debug:return"debug";case r.Info:return"info";case r.Warning:return"warn";case r.Error:return"error";case r.Off:return"off"}}function h(S){switch(S){case r.Trace:return{original:"Trace",value:C.localize(0,null)};case r.Debug:return{original:"Debug",value:C.localize(1,null)};case r.Info:return{original:"Info",value:C.localize(2,null)};case r.Warning:return{original:"Warning",value:C.localize(3,null)};case r.Error:return{original:"Error",value:C.localize(4,null)};case r.Off:return{original:"Off",value:C.localize(5,null)}}}function D(S){switch(S){case"trace":return r.Trace;case"debug":return r.Debug;case"info":return r.Info;case"warn":return r.Warning;case"error":return r.Error;case"critical":return r.Error;case"off":return r.Off}}e.$ik=new l.$Nj("logLevel",y(r.Info))}),define(Se[201],Pe([1,0,6,12]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZQ=void 0;class R extends C.$Uc{constructor(A,$=[]){super(),this.a=new O.$ak([A,...$]),this.B(A.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...$){this.a.trace(A,...$)}debug(A,...$){this.a.debug(A,...$)}info(A,...$){this.a.info(A,...$)}warn(A,...$){this.a.warn(A,...$)}error(A,...$){this.a.error(A,...$)}flush(){this.a.flush()}}e.$ZQ=R}),define(Se[101],Pe([1,0,33,167,3]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7t=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var A;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(m){function E(f,s){return s-f}m.compare=E;const T=Object.create(null);T[m.Error]=(0,O.localize)(0,null),T[m.Warning]=(0,O.localize)(1,null),T[m.Info]=(0,O.localize)(2,null);function k(f){return T[f]||""}m.toString=k;function l(f){switch(f){case C.default.Error:return m.Error;case C.default.Warning:return m.Warning;case C.default.Info:return m.Info;case C.default.Ignore:return m.Hint}}m.fromSeverity=l;function w(f){switch(f){case m.Error:return C.default.Error;case m.Warning:return C.default.Warning;case m.Info:return C.default.Info;case m.Hint:return C.default.Ignore}}m.toSeverity=w}(A||(e.MarkerSeverity=A={}));var $;(function(m){const E="";function T(l){return k(l,!0)}m.makeKey=T;function k(l,w){const f=[E];return l.source?f.push(l.source.replace("\xA6","\\\xA6")):f.push(E),l.code?typeof l.code=="string"?f.push(l.code.replace("\xA6","\\\xA6")):f.push(l.code.value.replace("\xA6","\\\xA6")):f.push(E),l.severity!==void 0&&l.severity!==null?f.push(A.toString(l.severity)):f.push(E),l.message&&w?f.push(l.message.replace("\xA6","\\\xA6")):f.push(E),l.startLineNumber!==void 0&&l.startLineNumber!==null?f.push(l.startLineNumber.toString()):f.push(E),l.startColumn!==void 0&&l.startColumn!==null?f.push(l.startColumn.toString()):f.push(E),l.endLineNumber!==void 0&&l.endLineNumber!==null?f.push(l.endLineNumber.toString()):f.push(E),l.endColumn!==void 0&&l.endColumn!==null?f.push(l.endColumn.toString()):f.push(E),f.push(E),f.join("\xA6")}m.makeKeyOptionalMessage=k})($||(e.IMarkerData=$={})),e.$7t=(0,R.$wi)("markerService")}),define(Se[202],Pe([1,0,5,33,3]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$0v=e.Severity=void 0,e.$$v=$,e.Severity=O.default,e.$0v=(0,R.$wi)("notificationService");var M;(function(k){k[k.DEFAULT=0]="DEFAULT",k[k.SILENT=1]="SILENT",k[k.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var A;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function $(k){if(k){const l=k;return typeof l.id=="string"&&typeof l.label=="string"}return!1}var m;(function(k){k[k.OFF=0]="OFF",k[k.ERROR=1]="ERROR"})(m||(e.NotificationsFilter=m={}));class E{constructor(){this.progress=new T,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$_v=E;class T{infinite(){}done(){}total(l){}worked(l){}}e.$aw=T}),define(Se[102],Pe([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$jk=(0,C.$wi)("productService"),e.$kk="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(le,e,C,O){var R=arguments.length,M=R<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,C):O,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(le,e,C,O);else for(var $=le.length-1;$>=0;$--)(A=le[$])&&(M=(R<3?A(M):R>3?A(e,C,M):A(e,C))||M);return R>3&&M&&Object.defineProperty(e,C,M),M},We=this&&this.__param||function(le,e){return function(C,O){e(C,O,le)}};define(Se[103],Pe([1,0,11,24,6,3]),function(le,e,C,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.ProgressLocation=e.$bw=void 0,e.$bw=(0,M.$wi)("progressService");var A;(function(k){k[k.Explorer=1]="Explorer",k[k.Scm=3]="Scm",k[k.Extensions=5]="Extensions",k[k.Window=10]="Window",k[k.Notification=15]="Notification",k[k.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$cw=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$dw=$;class m{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const w=this.d;this.d=()=>{w?.(),l()}}):Promise.resolve()}}e.$ew=m;let E=class extends R.$Uc{constructor(l,w){super(),this.a=new C.$Th,w.withProgress(l,f=>(this.b=f,this.c&&f.report(this.c),this.a.p)),this.B((0,R.$Sc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$fw=E,e.$fw=E=Je([We(1,e.$bw)],E);class T extends R.$Uc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new R.$Tc)}start(l){this.stop();const w=++this.a,f=new O.$oe;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,R.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,R.$Sc)(()=>f.cancel())),this.b.add((0,R.$Sc)(()=>this.c?this.c.done():void 0)),{id:w,token:f.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$gw=T,e.$hw=(0,M.$wi)("editorProgressService")}),define(Se[29],Pe([1,0,57,15]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class R{constructor(){this.a=new Map}add(A,$){C.ok(O.$9f(A)),C.ok(O.$$f($)),C.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,$)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$co=new R}),define(Se[74],Pe([1,0,5,29]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=void 0,e.$do={JSONContribution:"base.contributions.json"};function R($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class M{constructor(){this.b=new C.$de,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,E){this.a[R(m)]=E,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const A=new M;O.$co.add(e.$do.JSONContribution,A)}),define(Se[51],Pe([1,0,18,5,15,160,50,74,29]),function(le,e,C,O,R,M,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.ConfigurationScope=e.$ho=e.EditPresentationTypes=void 0,e.$so=s,e.$to=r,e.$uo=o,e.$vo=i,e.$wo=c;var E;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$ho={Configuration:"base.contributions.configuration"};var T;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo="vscode://schemas/settings/resourceLanguage",e.$po="vscode://schemas/settings/configurationDefaults";const k=m.$co.as($.$do.JSONContribution);class l{constructor(){this.h=new Set,this.i=new O.$de,this.onDidSchemaChange=this.i.event,this.j=new O.$de,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$oo,this.g),this.v()}registerConfiguration(t,d=!0){this.registerConfigurations([t],d)}registerConfigurations(t,d=!0){const a=new Set;this.n(t,d,a),k.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const d=new Set;this.o(t,d),k.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:d})}updateConfigurations({add:t,remove:d}){const a=new Set;this.o(d,a),this.n(t,!1,a),k.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const d=new Set;this.k(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}k(t,d){const a=[];for(const{overrides:g,source:b}of t)for(const p in g)if(d.add(p),e.$ro.test(p)){const v=this.a.get(p),y=v?.valuesSources??new Map;if(b)for(const I of Object.keys(g[p]))y.set(I,b);const h={...v?.value||{},...g[p]};this.a.set(p,{source:b,value:h,valuesSources:y});const D=(0,A.$aj)(p),S={type:"object",default:h,description:M.localize(1,null,D),$ref:e.$oo,defaultDefaultValue:h,source:R.$9f(b)?void 0:b,defaultValueSource:b};a.push(...s(p)),this.d[p]=S,this.b.properties[p]=S}else{this.a.set(p,{value:g[p],source:b});const v=this.d[p];v&&(this.w(p,v),this.r(p,v))}this.m(a)}deregisterDefaultConfigurations(t){const d=new Set;this.l(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}l(t,d){for(const{overrides:a,source:g}of t)for(const b in a){const p=this.a.get(b),v=R.$9f(g)?g:g?.id,y=R.$9f(p?.source)?p?.source:p?.source?.id;if(v===y)if(d.add(b),this.a.delete(b),e.$ro.test(b))delete this.d[b],delete this.b.properties[b];else{const h=this.d[b];h&&(this.w(b,h),this.r(b,h))}}this.u()}deltaConfiguration(t){let d=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),d=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),d=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const d of t)this.h.add(d);this.u()}n(t,d,a){t.forEach(g=>{this.p(g,d,g.extensionInfo,g.restrictedProperties,void 0,a),this.c.push(g),this.q(g)})}o(t,d){const a=g=>{if(g.properties)for(const b in g.properties){d.add(b);const p=this.d[b];p?.policy?.name&&this.e.delete(p.policy.name),delete this.d[b],this.s(b,g.properties[b])}g.allOf?.forEach(b=>a(b))};for(const g of t){a(g);const b=this.c.indexOf(g);b!==-1&&this.c.splice(b,1)}}p(t,d=!0,a,g,b=3,p){b=R.$fg(t.scope)?b:t.scope;const v=t.properties;if(v)for(const h in v){const D=v[h];if(d&&i(h,D)){delete v[h];continue}if(D.source=a,D.defaultDefaultValue=v[h].default,this.w(h,D),e.$ro.test(h)?D.scope=void 0:(D.scope=R.$fg(D.scope)?b:D.scope,D.restricted=R.$fg(D.restricted)?!!g?.includes(h):D.restricted),v[h].hasOwnProperty("included")&&!v[h].included){this.f[h]=v[h],delete v[h];continue}else this.d[h]=v[h],v[h].policy?.name&&this.e.set(v[h].policy.name,h);!v[h].deprecationMessage&&v[h].markdownDeprecationMessage&&(v[h].deprecationMessage=v[h].markdownDeprecationMessage),p.add(h)}const y=t.allOf;if(y)for(const h of y)this.p(h,d,a,g,b,p)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const d=a=>{const g=a.properties;if(g)for(const p in g)this.r(p,g[p]);a.allOf?.forEach(d)};d(t)}r(t,d){switch(e.$io.properties[t]=d,d.scope){case 1:e.$jo.properties[t]=d;break;case 2:e.$ko.properties[t]=d;break;case 6:e.$lo.properties[t]=d;break;case 3:e.$mo.properties[t]=d;break;case 4:e.$no.properties[t]=d;break;case 5:e.$no.properties[t]=d,this.g.properties[t]=d;break}}s(t,d){switch(delete e.$io.properties[t],d.scope){case 1:delete e.$jo.properties[t];break;case 2:delete e.$ko.properties[t];break;case 6:delete e.$lo.properties[t];break;case 3:delete e.$mo.properties[t];break;case 4:case 5:delete e.$no.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const d=`[${t}]`,a={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$oo};this.w(d,a),e.$io.properties[d]=a,e.$jo.properties[d]=a,e.$ko.properties[d]=a,e.$lo.properties[d]=a,e.$mo.properties[d]=a,e.$no.properties[d]=a}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$oo};e.$io.patternProperties[e.$qo]=t,e.$jo.patternProperties[e.$qo]=t,e.$ko.patternProperties[e.$qo]=t,e.$lo.patternProperties[e.$qo]=t,e.$mo.patternProperties[e.$qo]=t,e.$no.patternProperties[e.$qo]=t,this.i.fire()}w(t,d){const a=this.a.get(t);let g=a?.value,b=a?.source;R.$dg(g)&&(g=d.defaultDefaultValue,b=void 0),R.$dg(g)&&(g=o(d.type)),d.default=g,d.defaultValueSource=b}}const w="\\[([^\\]]+)\\]",f=new RegExp(w,"g");e.$qo=`^(${w})+$`,e.$ro=new RegExp(e.$qo);function s(u){const t=[];if(e.$ro.test(u)){let d=f.exec(u);for(;d?.length;){const a=d[1].trim();a&&t.push(a),d=f.exec(u)}}return(0,C.$Mb)(t)}function r(u){return u.reduce((t,d)=>`${t}[${d}]`,"")}function o(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new l;m.$co.add(e.$ho.Configuration,n);function i(u,t){return u.trim()?e.$ro.test(u)?M.localize(7,null,u):n.getConfigurationProperties()[u]!==void 0?M.localize(8,null,u):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,u,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}function c(){const u=[],t=n.getConfigurationProperties();for(const d of Object.keys(t))u.push([d,t[d].scope]);return u.push(["launch",4]),u.push(["task",4]),u}}),define(Se[203],Pe([1,0,18,5,126,6,28,25,15,2,50,51,29]),function(le,e,C,O,R,M,A,$,m,E,T,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Ao=e.$zo=e.$yo=e.$xo=void 0,e.$Bo=i;function w(d){return Object.isFrozen(d)?d:$.$4n(d)}class f{static createEmptyModel(a){return new f({},[],[],void 0,a)}constructor(a,g,b,p,v){this.b=a,this.c=g,this.d=b,this.raw=p,this.f=v,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map(g=>{if(g instanceof f)return g;const b=new s("",this.f);return b.parseRaw(g),b.configurationModel});this.g=a.reduce((g,b)=>b===g?b:g.merge(b),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,T.$$i)(this.contents,a):this.contents}inspect(a,g){const b=this;return{get value(){return w(b.rawConfiguration.getValue(a))},get override(){return g?w(b.rawConfiguration.getOverrideValue(a,g)):void 0},get merged(){return w(g?b.rawConfiguration.override(g).getValue(a):b.rawConfiguration.getValue(a))},get overrides(){const p=[];for(const{contents:v,identifiers:y,keys:h}of b.rawConfiguration.overrides){const D=new f(v,h,[],void 0,b.f).getValue(a);D!==void 0&&p.push({identifiers:y,value:D})}return p.length?w(p):void 0}}}getOverrideValue(a,g){const b=this.j(g);return b?a?(0,T.$$i)(b,a):b:void 0}getKeysForOverrideIdentifier(a){const g=[];for(const b of this.overrides)b.identifiers.includes(a)&&g.push(...b.keys);return C.$Mb(g)}getAllOverrideIdentifiers(){const a=[];for(const g of this.overrides)a.push(...g.identifiers);return C.$Mb(a)}override(a){let g=this.a.get(a);return g||(g=this.h(a),this.a.set(a,g)),g}merge(...a){const g=$.$3n(this.contents),b=$.$3n(this.overrides),p=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const y of a)if(v.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.i(g,y.contents);for(const h of y.overrides){const[D]=b.filter(S=>C.$ub(S.identifiers,h.identifiers));D?(this.i(D.contents,h.contents),D.keys.push(...h.keys),D.keys=C.$Mb(D.keys)):b.push($.$3n(h))}for(const h of y.keys)p.indexOf(h)===-1&&p.push(h)}return new f(g,p,b,v.every(y=>y instanceof f)?void 0:v,this.f)}h(a){const g=this.j(a);if(!g||typeof g!="object"||!Object.keys(g).length)return this;const b={};for(const p of C.$Mb([...Object.keys(this.contents),...Object.keys(g)])){let v=this.contents[p];const y=g[p];y&&(typeof v=="object"&&typeof y=="object"?(v=$.$3n(v),this.i(v,y)):v=y),b[p]=v}return new f(b,this.keys,this.overrides,void 0,this.f)}i(a,g){for(const b of Object.keys(g)){if(b in a&&m.$$f(a[b])&&m.$$f(g[b])){this.i(a[b],g[b]);continue}a[b]=$.$3n(g[b])}}j(a){let g=null,b=null;const p=v=>{v&&(b?this.i(b,v):b=$.$3n(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===a?g=v.contents:v.identifiers.includes(a)&&p(v.contents);return p(g),b}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,g){this.k(a,g,!0)}setValue(a,g){this.k(a,g,!1)}removeValue(a){const g=this.keys.indexOf(a);g!==-1&&(this.keys.splice(g,1),(0,T.$0i)(this.contents,a),k.$ro.test(a)&&this.overrides.splice(this.overrides.findIndex(b=>C.$ub(b.identifiers,(0,k.$so)(a))),1))}k(a,g,b){(0,T.$9i)(this.contents,a,g,p=>this.f.error(p)),b=b||this.keys.indexOf(a)===-1,b&&this.keys.push(a),k.$ro.test(a)&&this.overrides.push({identifiers:(0,k.$so)(a),keys:Object.keys(this.contents[a]),contents:(0,T.$8i)(this.contents[a],p=>this.f.error(p))})}}e.$xo=f;class s{constructor(a,g){this.f=a,this.g=g,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||f.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,g){if(!m.$fg(a)){const b=this.h(a);this.parseRaw(b,g)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,g){this.a=a;const{contents:b,keys:p,overrides:v,restricted:y,hasExcludedProperties:h}=this.i(a,g);this.b=new f(b,p,v,h?[a]:void 0,this.g),this.c=y||[]}h(a){let g={},b=null,p=[];const v=[],y=[];function h(S){Array.isArray(p)?p.push(S):b!==null&&(p[b]=S)}const D={onObjectBegin:()=>{const S={};h(S),v.push(p),p=S,b=null},onObjectProperty:S=>{b=S},onObjectEnd:()=>{p=v.pop()},onArrayBegin:()=>{const S=[];h(S),v.push(p),p=S,b=null},onArrayEnd:()=>{p=v.pop()},onLiteralValue:h,onError:(S,I,P)=>{y.push({error:S,offset:I,length:P})}};if(a)try{R.$Qn(a,D),g=p[0]||{}}catch(S){this.g.error(`Error while parsing settings file ${this.f}: ${S}`),this.d=[S]}return g}i(a,g){const b=l.$co.as(k.$ho.Configuration).getConfigurationProperties(),p=this.j(a,b,!0,g);a=p.raw;const v=(0,T.$8i)(a,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`)),y=Object.keys(a),h=this.l(a,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:v,keys:y,overrides:h,restricted:p.restricted,hasExcludedProperties:p.hasExcludedProperties}}j(a,g,b,p){let v=!1;if(!p?.scopes&&!p?.skipRestricted&&!p?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:v};const y={},h=[];for(const D in a)if(k.$ro.test(D)&&b){const S=this.j(a[D],g,!1,p);y[D]=S.raw,v=v||S.hasExcludedProperties,h.push(...S.restricted)}else{const S=g[D],I=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&h.push(D),!p.exclude?.includes(D)&&(p.include?.includes(D)||(I===void 0||p.scopes===void 0||p.scopes.includes(I))&&!(p.skipRestricted&&S?.restricted))?y[D]=a[D]:v=!0}return{raw:y,restricted:h,hasExcludedProperties:v}}l(a,g){const b=[];for(const p of Object.keys(a))if(k.$ro.test(p)){const v={};for(const y in a[p])v[y]=a[p][y];b.push({identifiers:(0,k.$so)(p),keys:Object.keys(v),contents:(0,T.$8i)(v,g)})}return b}}e.$yo=s;class r extends M.$Uc{constructor(a,g,b,p,v){super(),this.c=a,this.f=g,this.g=p,this.h=v,this.b=this.B(new O.$de),this.onDidChange=this.b.event,this.a=new s(this.c.toString(),v),this.B(this.g.watch(b.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(0)||y.isOperation(3)||y.isOperation(1)||y.isOperation(4))&&b.isEqual(y.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return f.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$zo=r;class o{constructor(a,g,b,p,v,y,h,D,S,I,P,W,V){this.a=a,this.b=g,this.c=b,this.overrideIdentifiers=p,this.d=v,this.f=y,this.g=h,this.h=D,this.i=S,this.j=I,this.k=P,this.l=W,this.m=V}get value(){return w(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(a,g,b,p,v,y,h,D,S,I){this.j=a,this.l=g,this.m=b,this.n=p,this.p=v,this.q=y,this.r=h,this.s=D,this.t=S,this.u=I,this.h=null,this.i=new A.$Ac,this.v=null}getValue(a,g,b){return this.w(a,g,b).getValue(a)}updateValue(a,g,b={}){let p;b.resource?(p=this.t.get(b.resource),p||(p=f.createEmptyModel(this.u),this.t.set(b.resource,p))):p=this.s,g===void 0?p.removeValue(a):p.setValue(a,g),b.resource||(this.h=null)}inspect(a,g,b){const p=this.w(a,g,b),v=this.A(g.resource,b),y=g.resource?this.t.get(g.resource)||this.s:this.s,h=new Set;for(const D of p.overrides)for(const S of D.identifiers)p.getOverrideValue(a,S)!==void 0&&h.add(S);return new o(a,g,p.getValue(a),h.size?[...h]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,b?this.q:void 0,v||void 0,y)}keys(a){const g=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:g?g.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,g){this.r.set(a,g),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,g){const b=[];if(!g){const{added:p,updated:v,removed:y}=u(this.j,a);g=[...p,...v,...y]}for(const p of g)for(const v of(0,k.$so)(p)){const y=this.j.getKeysForOverrideIdentifier(v),h=a.getKeysForOverrideIdentifier(v),D=[...h.filter(S=>y.indexOf(S)===-1),...y.filter(S=>h.indexOf(S)===-1),...y.filter(S=>!$.$7n(this.j.override(v).getValue(S),a.override(v).getValue(S)))];b.push([v,D])}return this.updateDefaultConfiguration(a),{keys:g,overrides:b}}compareAndUpdatePolicyConfiguration(a){const{added:g,updated:b,removed:p}=u(this.l,a),v=[...g,...b,...p];return v.length&&this.updatePolicyConfiguration(a),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:g,updated:b,removed:p,overrides:v}=u(this.applicationConfiguration,a),y=[...g,...b,...p];return y.length&&this.updateApplicationConfiguration(a),{keys:y,overrides:v}}compareAndUpdateLocalUserConfiguration(a){const{added:g,updated:b,removed:p,overrides:v}=u(this.localUserConfiguration,a),y=[...g,...b,...p];return y.length&&this.updateLocalUserConfiguration(a),{keys:y,overrides:v}}compareAndUpdateRemoteUserConfiguration(a){const{added:g,updated:b,removed:p,overrides:v}=u(this.remoteUserConfiguration,a),y=[...g,...b,...p];return y.length&&this.updateRemoteUserConfiguration(a),{keys:y,overrides:v}}compareAndUpdateWorkspaceConfiguration(a){const{added:g,updated:b,removed:p,overrides:v}=u(this.workspaceConfiguration,a),y=[...g,...b,...p];return y.length&&this.updateWorkspaceConfiguration(a),{keys:y,overrides:v}}compareAndUpdateFolderConfiguration(a,g){const b=this.folderConfigurations.get(a),{added:p,updated:v,removed:y,overrides:h}=u(b,g),D=[...p,...v,...y];return(D.length||!b)&&this.updateFolderConfiguration(a,g),{keys:D,overrides:h}}compareAndDeleteFolderConfiguration(a){const g=this.folderConfigurations.get(a);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:b,updated:p,removed:v,overrides:y}=u(g,void 0);return{keys:[...b,...p,...v],overrides:y}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,g,b){let p=this.x(g,b);return g.overrideIdentifier&&(p=p.override(g.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&(p=p.merge(this.l)),p}x({resource:a},g){let b=this.y();if(g&&a){const p=g.getFolder(a);p&&(b=this.z(p.uri)||b);const v=this.t.get(a);v&&(b=b.merge(v))}return b}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let g=this.i.get(a);if(!g){const b=this.y(),p=this.r.get(a);p?(g=b.merge(p),this.i.set(a,g)):g=b}return g}A(a,g){if(g&&a){const b=g.getFolder(a);if(b)return this.r.get(b.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,g)=>{const{contents:b,overrides:p,keys:v}=this.r.get(g);return a.push([g,{contents:b,overrides:p,keys:v}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach(g=>a.add(g)),this.userConfiguration.keys.forEach(g=>a.add(g)),this.q.keys.forEach(g=>a.add(g)),this.r.forEach(g=>g.keys.forEach(b=>a.add(b))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach(g=>a.add(g)),this.userConfiguration.getAllOverrideIdentifiers().forEach(g=>a.add(g)),this.q.getAllOverrideIdentifiers().forEach(g=>a.add(g)),this.r.forEach(g=>g.getAllOverrideIdentifiers().forEach(b=>a.add(b))),[...a.values()]}D(a){const g=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach(b=>g.add(b)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(b=>g.add(b)),this.q.getKeysForOverrideIdentifier(a).forEach(b=>g.add(b)),this.r.forEach(b=>b.getKeysForOverrideIdentifier(a).forEach(p=>g.add(p))),[...g.values()]}static parse(a,g){const b=this.E(a.defaults,g),p=this.E(a.policy,g),v=this.E(a.application,g),y=this.E(a.user,g),h=this.E(a.workspace,g),D=a.folders.reduce((S,I)=>(S.set(E.URI.revive(I[0]),this.E(I[1],g)),S),new A.$Ac);return new n(b,p,v,y,f.createEmptyModel(g),h,D,f.createEmptyModel(g),new A.$Ac,g)}static E(a,g){return new f(a.contents,a.keys,a.overrides,void 0,g)}}e.$Ao=n;function i(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const a=new Set,g=new Map;for(const p of d)p.keys.forEach(v=>a.add(v)),p.overrides.forEach(([v,y])=>{const h=(0,A.$xc)(g,v,new Set);y.forEach(D=>h.add(D))});const b=[];return g.forEach((p,v)=>b.push([v,[...p.values()]])),{keys:[...a.values()],overrides:b}}class c{constructor(a,g,b,p,v){this.change=a,this.f=g,this.g=b,this.h=p,this.i=v,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const y of a.keys)this.affectedKeys.add(y);for(const[,y]of a.overrides)for(const h of y)this.affectedKeys.add(h);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,g){const b=this.a+a,p=this.d.indexOf(b);if(p<0)return!1;const v=p+b.length;if(v>=this.d.length)return!1;const y=this.d.charCodeAt(v);if(y!==this.b&&y!==this.c)return!1;if(g){const h=this.previousConfiguration?this.previousConfiguration.getValue(a,g,this.f?.workspace):void 0,D=this.g.getValue(a,g,this.h);return!$.$7n(h,D)}return!0}}e.$Co=c;function u(d,a){const{added:g,removed:b,updated:p}=t(a?.rawConfiguration,d?.rawConfiguration),v=[],y=d?.getAllOverrideIdentifiers()||[],h=a?.getAllOverrideIdentifiers()||[];if(a){const D=h.filter(S=>!y.includes(S));for(const S of D)v.push([S,a.getKeysForOverrideIdentifier(S)])}if(d){const D=y.filter(S=>!h.includes(S));for(const S of D)v.push([S,d.getKeysForOverrideIdentifier(S)])}if(a&&d){for(const D of y)if(h.includes(D)){const S=t({contents:d.getOverrideValue(void 0,D)||{},keys:d.getKeysForOverrideIdentifier(D)},{contents:a.getOverrideValue(void 0,D)||{},keys:a.getKeysForOverrideIdentifier(D)});v.push([D,[...S.added,...S.removed,...S.updated]])}}return{added:g,removed:b,updated:p,overrides:v}}function t(d,a){const g=d?a?d.keys.filter(v=>a.keys.indexOf(v)===-1):[...d.keys]:[],b=a?d?a.keys.filter(v=>d.keys.indexOf(v)===-1):[...a.keys]:[],p=[];if(d&&a){for(const v of a.keys)if(d.keys.indexOf(v)!==-1){const y=(0,T.$$i)(a.contents,v),h=(0,T.$$i)(d.contents,v);$.$7n(y,h)||p.push(v)}}return{added:g,removed:b,updated:p}}}),define(Se[104],Pe([1,0,14,3]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.RemoteAuthorityResolverErrorCode=e.$Jl=e.$Il=e.RemoteConnectionType=e.$Hl=void 0,e.$Ll=E,e.$Hl=(0,O.$wi)("remoteAuthorityResolverService");var R;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(R||(e.RemoteConnectionType=R={}));class M{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$Il=M;class A{constructor(k,l){this.host=k,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jl=A;var $;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound",T.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class m extends C.$bb{static isNotAvailable(k){return k instanceof m&&k._code===$.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof m&&k._code===$.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof m&&k._code===$.NoResolverFound}static isInvalidAuthority(k){return k instanceof m&&k._code===$.InvalidAuthority}static isHandled(k){return k instanceof m&&k.isHandled}constructor(k,l=$.Unknown,w){super(k),this._message=k,this._code=l,this._detail=w,this.isHandled=l===$.NotAvailable&&w===!0,Object.setPrototypeOf(this,m.prototype)}}e.$Kl=m;function E(T){const k=T.indexOf("+");return k===-1?T:T.substring(0,k)}}),define(Se[58],Pe([1,0,16]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=O,e.$Im=R,e.$Jm=M,e.$Km=A;function O(m){return m.scheme===C.Schemas.vscodeRemote?m.authority:void 0}function R(m){if(!m)return;const E=m.indexOf("+");return E<0?m:m.substr(0,E)}function M(m){const{host:E,port:T}=$(m);if(typeof T>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:T}}function A(m,E){let{host:T,port:k}=$(m);return typeof k>"u"&&(k=E),{host:T,port:k}}function $(m){const E=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const T=m.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const k=m.match(/(.*):(\d+)$/);return k?{host:k[1],port:parseInt(k[2],10)}:{host:m,port:void 0}}}),define(Se[20],Pe([1,0,13,3,58]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Tm=e.$Sm=e.$Rm=e.TargetPlatform=e.ExtensionType=e.$Qm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0,e.$Pm=M,e.$Um=k,e.$Vm=l,e.$Wm=w,e.$Xm=f,e.$Lm="extensions.user.cache",e.$Mm="extensions.builtin.cache",e.$Nm="undefined_publisher",e.$Om=["ui","workspace","web"];function M(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$Qm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(A||(e.ExtensionType=A={}));var $;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class m{constructor(r){this.value=r,this._lower=r.toLowerCase()}static equals(r,o){if(typeof r>"u"||r===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof r=="string"||typeof o=="string"){const n=typeof r=="string"?r:r.value,i=typeof o=="string"?o:o.value;return C.$xf(n,i)}return r._lower===o._lower}static toKey(r){return typeof r=="string"?r.toLowerCase():r._lower}}e.$Rm=m;class E{get size(){return this.c.size}constructor(r){if(this.c=new Set,r)for(const o of r)this.add(o)}add(r){this.c.add(m.toKey(r))}delete(r){return this.c.delete(m.toKey(r))}has(r){return this.c.has(m.toKey(r))}}e.$Sm=E;class T{constructor(){this.c=new Map}clear(){this.c.clear()}delete(r){this.c.delete(m.toKey(r))}get(r){return this.c.get(m.toKey(r))}has(r){return this.c.has(m.toKey(r))}set(r,o){this.c.set(m.toKey(r),o)}values(){return this.c.values()}forEach(r){this.c.forEach(r)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Tm=T;function k(s){return l(s)}function l(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}function w(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}function f(s,r){if(r){const o=`onResolveRemoteAuthority:${(0,R.$Im)(r)}`;return!!s.activationEvents?.includes(o)}return!1}e.$Ym=(0,O.$wi)("IBuiltinExtensionsScannerService")}),define(Se[105],Pe([1,0,14,20]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uG=e.$tG=void 0;class R{constructor(){this.a=new Map,this.b=new WeakMap}register(A,$){this.a.set(A,$)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const $=Object.create(null);for(const m of A){const E=this.readActivationEvents(m);E.length>0&&($[O.$Rm.toKey(m.identifier)]=E)}return $}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const $=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let m=0;m<$.length;m++)$[m]==="onUri"&&($[m]=`onUri:${O.$Rm.toKey(A.identifier)}`);if(!A.contributes)return $;for(const m in A.contributes){const E=this.a.get(m);if(!E)continue;const T=A.contributes[m],k=Array.isArray(T)?T:[T];try{E(k,$)}catch(l){(0,C.$1)(l)}}return $}}e.$tG=R,e.$uG=new R}),define(Se[204],Pe([1,0,21,14,6,168,51,3,12,29]),function(le,e,C,O,R,M,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=void 0,e.$Pp=l,e.$Qp=w,e.$Rp=f,e.$Sp=s,e.$Tp=r,e.$Up=o,e.$Np=(0,$.$wi)("requestService");class T{constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?u[t]="*****":u[t]=this.b[t];this.a=u}return this.a}}class k extends R.$Uc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,M.localize)(0,null),when:m.$ik.isEqualTo((0,m.$fk)(m.LogLevel.Trace)).serialize()})}async c(u,t,d){const a=`${u} #${++this.b}: ${t.url}`;this.a.trace(`${a} - begin`,t.type,new T(t.headers??{}));try{const g=await d();return this.a.trace(`${a} - end`,t.type,g.res.statusCode,g.res.headers),g}catch(g){throw this.a.error(`${a} - error`,t.type,(0,O.$0)(g)),g}}}e.$Op=k;function l(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function w(c){return c.res.statusCode===204}async function f(c){return w(c)?null:(await(0,C.$Re)(c.stream)).toString()}async function s(c){if(!l(c))throw new Error("Server returned "+c.res.statusCode);return f(c)}async function r(c){if(!l(c))throw new Error("Server returned "+c.res.statusCode);if(w(c))return null;const t=(await(0,C.$Re)(c.stream)).toString();try{return JSON.parse(t)}catch(d){throw d.message+=`:
`+t,d}}function o(c){i(c)}let n;function i(c){const u=E.$co.as(A.$ho.Configuration),t=n;n={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[n],remove:t?[t]:[]})}i(1)}),define(Se[205],Pe([1,0,22,75,34]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=A,e.$ep=$;function M(m){if(C.$u===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}function A(m,E,T,k,l,w,f,s,r){const o=Object.create(null);o["common.machineId"]=w,o["common.sqmId"]=f,o.sessionID=(0,R.$Sg)()+Date.now(),o.commitHash=k,o.version=l,o["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,C.$h)(C.$u),o["common.nodePlatform"]=O.$dc,o["common.nodeArch"]=T,o["common.product"]=r||"desktop",s&&(o["common.msftInternal"]=s);let n=0;const i=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),C.$l&&(o["common.snap"]="true");const c=M(E);return c&&(o["common.platformDetail"]=c),o}function $(m){const E=O.env.USERDNSDOMAIN;if(!E)return!1;const T=E.toLowerCase();return m.some(k=>T===k)}}),define(Se[206],Pe([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=void 0,e.$2l=(0,C.$wi)("telemetryService"),e.$3l=(0,C.$wi)("customEndpointTelemetryService"),e.$4l="telemetry.currentSessionDate",e.$5l="telemetry.firstSessionDate",e.$6l="telemetry.lastSessionDate",e.$7l="telemetry.machineId",e.$8l="telemetry.sqmId",e.$9l="telemetry",e.$0l="telemetry.telemetryLevel",e.$$l="telemetry.enableCrashReporter",e.$_l="telemetry.enableTelemetry";var O;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var R;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(Se[59],Pe([1,0,25,15,58,205,206]),function(le,e,C,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=void 0,e.$mp=T,e.$np=k,e.$op=l,e.$pp=w,e.$qp=s,e.$rp=o,e.$sp=n,e.$tp=u;class ${constructor(d){this.value=d,this.isTrustedTelemetryValue=!0}}e.$fp=$;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$gp=m,e.$hp=new m;class E{async publicLog(d,a,g){}async publicLogError(d,a,g){}}e.$ip=E,e.$jp="telemetry",e.$kp="extensionTelemetryLog",e.$lp={log:()=>null,flush:()=>Promise.resolve(null)};function T(t,d){return!d.isBuilt&&!d.disableTelemetry?!0:!(d.disableTelemetry||!t.enableTelemetry)}function k(t,d){return d.extensionTestsLocationURI?!0:!(d.isBuilt||d.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function l(t){const d=t.getValue(A.$0l),a=t.getValue(A.$$l);if(t.getValue(A.$_l)===!1||a===!1)return 0;switch(d??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function w(t){const d={},a={},g={};r(t,g);for(let b in g){b=b.length>150?b.substr(b.length-149):b;const p=g[b];typeof p=="number"?a[b]=p:typeof p=="boolean"?a[b]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${b} has been trimmed to 8192, the original length is ${p.length}`),d[b]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(d[b]=p)}return{properties:d,measurements:a}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(t){if(!t)return"none";const d=(0,R.$Im)(t);return f.has(d)?d:"other"}function r(t,d,a=0,g){if(t)for(const b of Object.getOwnPropertyNames(t)){const p=t[b],v=g?g+b:b;Array.isArray(p)?d[v]=(0,C.$8n)(p):p instanceof Date?d[v]=p.toISOString():(0,O.$$f)(p)?a<2?r(p,d,a+1,v+"."):d[v]=(0,C.$8n)(p):d[v]=p}}function o(t,d){const a=t.msftInternalDomains||[],g=d.getValue("telemetry.internalTesting");return(0,M.$ep)(a)||g}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,d){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let a=t;const g=[];for(const y of d)for(;;){const h=y.exec(t);if(!h)break;g.push([h.index,y.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(a="";;){const y=p.exec(t);if(!y)break;const h=g.some(([D,S])=>y.index<S&&D<p.lastIndex);!b.test(y[0])&&!h&&(a+=t.substring(v,y.index)+"<REDACTED: user-file-path>",v=p.lastIndex)}return v<t.length&&(a+=t.substr(v)),a}function c(t){if(!t)return t;const d=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of d)if(a.regex.test(t))return`<REDACTED: ${a.label}>`;return t}function u(t,d){return(0,C.$5n)(t,a=>{if(a instanceof $||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let g=a.replaceAll("%20"," ");g=i(g,d);for(const b of d)g=g.replace(b,"");return g=c(g),g}})}}),define(Se[207],Pe([1,0,13,100,20,22,2,14,75,59]),function(le,e,C,O,R,M,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$vp=void 0,e.$up=T,e.$wp=f,e.$xp=s,e.$yp=r,e.$zp=o,e.$Ap=n,e.$Bp=i,e.$Cp=c,e.$Ep=u,e.$Fp=d;function T(a,g){return a.uuid&&g.uuid?a.uuid===g.uuid:a.id===g.id?!0:(0,C.$sf)(a.id,g.id)===0}const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(g){const b=g.manifest?g.manifest.version:g.version,p=g.manifest?g.targetPlatform:g.properties.targetPlatform;return new l(g.identifier,b,p)}static parse(g){const b=k.exec(g);return b&&b[1]&&b[2]?new l({id:b[1]},b[2],b[4]||void 0):null}constructor(g,b,p="undefined"){this.version=b,this.targetPlatform=p,this.id=g.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(g){return g instanceof l?T(this,g)&&this.version===g.version&&this.targetPlatform===g.targetPlatform:!1}}e.$vp=l;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(a){const g=w.exec(a);return g&&g[1]?[r(g[1]),g[2]]:[r(a),void 0]}function s(a,g){return`${a}.${g}`}function r(a){return a.toLowerCase()}function o(a,g){return r(s(a??R.$Nm,g))}function n(a,g){const b=[],p=v=>{for(const y of b)if(y.some(h=>T(g(h),g(v))))return y;return null};for(const v of a){const y=p(v);y?y.push(v):b.push([v])}return b}function i(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function c(a){return{id:new E.$fp(a.identifier.id),name:new E.$fp(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Dp=new R.$Rm("pprice.better-merge");function u(a,g){const b=[],p=g.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const v=p.shift();if(v&&b.every(y=>!T(y.identifier,{id:v}))){const y=a.filter(h=>T(h.identifier,{id:v}));y.length===1&&(b.push(y[0]),p.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}async function t(a,g){if(!M.$k)return!1;let b;try{b=(await a.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{b=(await a.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){g.debug("Error while getting the os-release file.",(0,$.$0)(v))}}return!!b&&(b.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function d(a,g){const b=await t(a,g),p=(0,O.$2o)(b?"alpine":M.$u,m.$ec);return g.debug("ComputeTargetPlatform:",p),p}}),define(Se[208],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=C,e.$ms=O,e.$ns=R,e.$os=M,e.$ps=A,e.$qs=$;function C(m){return[...m.entries()]}function O(m){return m?[...m.entries()]:[]}function R(m){return new Map(m)}function M(m){return new Map(m??[])}function A(m){return Array.from(m.entries()).map(E=>[E[0],C(E[1].map),O(E[1].descriptionMap)])}function $(m){return new Map(m.map(E=>[E[0],{map:R(E[1]),descriptionMap:M(E[2])}]))}}),define(Se[209],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fvb=void 0;class C{constructor(R){this.b=R,this.a=new Map}dispose(){for(const R of this.a.values())R.dispose()}startBuffering(R,M,A=5){const $=M(m=>{const E=typeof m=="string"?m:m.data;let T=this.a.get(R);if(T){T.data.push(E);return}const k=setTimeout(()=>this.flushBuffer(R),A);T={data:[E],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(R),$.dispose()}},this.a.set(R,T)});return $}stopBuffering(R){this.a.get(R)?.dispose()}flushBuffer(R){const M=this.a.get(R);M&&(this.a.delete(R),this.b(R,M.data.join("")))}}e.$Fvb=C}),define(Se[210],Pe([1,0,11,92,312,36,5,15,2,169,74,29]),function(le,e,C,O,R,M,A,$,m,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mx=e.$lx=e.$kx=e.$jx=e.$ix=e.$hx=e.IconFontDefinition=e.IconContribution=e.$ex=void 0,e.$fx=r,e.$gx=o,e.$ex={IconContribution:"base.contributions.icons"};var l;(function(u){function t(d,a){let g=d.defaults;for(;M.ThemeIcon.isThemeIcon(g);){const b=s.getIcon(g.id);if(!b)return;g=b.defaults}return g}u.getDefinition=t})(l||(e.IconContribution=l={}));var w;(function(u){function t(a){return{weight:a.weight,style:a.style,src:a.src.map(g=>({format:g.format,location:g.location.toString()}))}}u.toJSONObject=t;function d(a){const g=b=>(0,$.$9f)(b)?b:void 0;if(a&&Array.isArray(a.src)&&a.src.every(b=>(0,$.$9f)(b.format)&&(0,$.$9f)(b.location)))return{weight:g(a.weight),style:g(a.style),src:a.src.map(b=>({format:b.format,location:m.URI.parse(b.location)}))}}u.fromJSONObject=d})(w||(e.IconFontDefinition=w={}));class f{constructor(){this.a=new A.$de,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${M.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,d,a,g){const b=this.b[t];if(b){if(a&&!b.description){b.description=a,this.d.properties[t].markdownDescription=`${a} $(${t})`;const y=this.e.enum.indexOf(t);y!==-1&&(this.e.enumDescriptions[y]=a),this.a.fire()}return b}const p={id:t,description:a,defaults:d,deprecationMessage:g};this.b[t]=p;const v={$ref:"#/definitions/icons"};return g&&(v.deprecationMessage=g),a&&(v.markdownDescription=`${a}: $(${t})`),this.d.properties[t]=v,this.e.enum.push(t),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const d=this.e.enum.indexOf(t);d!==-1&&(this.e.enum.splice(d,1),this.e.enumDescriptions.splice(d,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,d){const a=this.f[t];return a||(this.f[t]=d,this.a.fire(),d)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(b,p)=>b.id.localeCompare(p.id),d=b=>{for(;M.ThemeIcon.isThemeIcon(b.defaults);)b=this.b[b.defaults.id];return`codicon codicon-${b?b.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const g=Object.keys(this.b).map(b=>this.b[b]);for(const b of g.filter(p=>!!p.description).sort(t))a.push(`|<i class="${d(b)}"></i>|${b.id}|${M.ThemeIcon.isThemeIcon(b.defaults)?b.defaults.id:b.id}|${b.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const b of g.filter(p=>!M.ThemeIcon.isThemeIcon(p.defaults)).sort(t))a.push(`|<i class="${d(b)}"></i>|${b.id}|`);return a.join(`
`)}}const s=new f;k.$co.add(e.$ex.IconContribution,s);function r(u,t,d,a){return s.registerIcon(u,t,d,a)}function o(){return s}function n(){const u=(0,R.$Rj)();for(const t in u){const d="\\"+u[t].toString(16);s.registerIcon(t,{fontCharacter:d})}}n(),e.$hx="vscode://schemas/icons";const i=k.$co.as(T.$do.JSONContribution);i.registerSchema(e.$hx,s.getIconSchema());const c=new C.$Ih(()=>i.notifySchemaChanged(e.$hx),200);s.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$ix=r("widget-close",O.$Vj.close,(0,E.localize)(2,null)),e.$jx=r("goto-previous-location",O.$Vj.arrowUp,(0,E.localize)(3,null)),e.$kx=r("goto-next-location",O.$Vj.arrowDown,(0,E.localize)(4,null)),e.$lx=M.ThemeIcon.modify(O.$Vj.sync,"spin"),e.$mx=M.ThemeIcon.modify(O.$Vj.loading,"spin")}),define(Se[211],Pe([1,0,5,2,50,3,12]),function(le,e,C,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tw=e.$sw=e.$pw=e.$nw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$jw=e.$iw=void 0,e.$kw=E,e.$lw=k,e.$mw=l,e.$ow=w,e.$qw=f,e.$rw=s,e.$iw=(0,M.$wi)("tunnelService"),e.$jw=(0,M.$wi)("sharedTunnelsService");var $;(function(n){n.Http="http",n.Https="https"})($||(e.TunnelProtocol=$={}));var m;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(m||(e.TunnelPrivacyId=m={}));function E(n){return!!n.forwardPort}var T;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(T||(e.ProvidedOnAutoForward=T={}));function k(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function l(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const c of i){const u=c.split("=")[1];if(/^https?:/.exec(u)){const t=k(O.URI.parse(u));if(t)return t}}}e.$nw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(n){return e.$nw.indexOf(n)>=0}e.$pw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function f(n){return e.$pw.indexOf(n)>=0}function s(n,i,c,u){if(c===1)return!1;if(c===2&&f(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class r{constructor(i,c,u){this.remoteAddress=i,this.localAddress=c,this.b=u,this.a=new C.$de,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$sw=r;let o=class{constructor(i,c){this.k=i,this.l=c,this.a=new C.$de,this.onTunnelOpened=this.a.event,this.b=new C.$de,this.onTunnelClosed=this.b.event,this.c=new C.$de,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],c=Array.from(this.e.values());for(const u of c){const t=Array.from(u.values());for(const d of t){const a=await d.value;a&&typeof a!="string"&&i.push(a)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:c}of i.values())await c.then(u=>typeof u!="string"?u?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,c,u,t,d){this.q(i,c,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:c,localAddress:u,privacy:t,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,c){(f(i)||w(i))&&(i=e.$nw[0]);const u=this.s(i,c);if(u)return++u.refcount,u.value}openTunnel(i,c,u,t,d,a=!1,g,b){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${u} on local port ${d}.`);const p=this.f??i;if(!p)return;if(c||(c="localhost"),t||(t=this.m),this.f&&this.j.has(u)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.t(p,c,u,t,d,a,g,b);return v?v.then(y=>{if(y){if(typeof y=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,u),y}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,u);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const h=this.o(y);return(y.tunnelRemoteHost!==c||y.tunnelRemotePort!==u)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),g&&y.privacy!==g&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(h),h}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const c=this.e.get(i.tunnelRemoteHost);if(c){const u=c.get(i.tunnelRemotePort);u&&(u.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,u))}}}}async p(i,c,u){if(u.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${c}.`);const t=u.value.then(async d=>{d&&typeof d!="string"&&(await d.dispose(!0),this.b.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(c),t}}async closeTunnel(i,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${c} `);const u=this.e.get(i);if(u&&u.has(c)){const t=u.get(c);t.refcount=0,await this.p(i,c,t)}}q(i,c,u){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(c,{refcount:1,value:u})}async r(i,c){const u=this.e.get(i);if(u){const t=u.get(c),d=t?await t.value:void 0;(!d||typeof d=="string")&&u.delete(c),u.size===0&&this.e.delete(i)}}s(i,c){const u=[i];w(i)?(u.push(...e.$nw),u.push(...e.$pw)):f(i)&&u.push(...e.$pw);const t=u.map(d=>this.e.get(d));for(const d of t){const a=d?.get(c);if(a)return a}}canTunnel(i){return!!k(i)}u(i,c,u,t,d,a,g){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${u} on local port ${t}.`);const b=u;this.j.add(b);const p=t===void 0?u:t,v={elevationRequired:d?this.isPortPrivileged(p):!1},y={remoteAddress:{host:c,port:u},localAddressPort:t,privacy:a,public:a?a!==m.Private:void 0,protocol:g},h=i.forwardPort(y,v);return h?(this.q(c,u,h),h.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(b)})):this.j.delete(b),h}};e.$tw=o,e.$tw=o=Je([We(0,A.$3j),We(1,R.$3i)],o)}),define(Se[212],Pe([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=void 0,e.$Al=(0,C.$wi)("IUriIdentityService")}),define(Se[213],Pe([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$uw=void 0,e.$uw=(0,C.$wi)("editSessionIdentityService");var O;(function(R){R[R.Complete=100]="Complete",R[R.Partial=50]="Partial",R[R.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(Se[214],Pe([1,0,16]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=O,e.$IM=R,e.$JM=M,e.$KM=A,e.$LM=$;function O(m){return m.scheme!==C.Schemas.file&&m.scheme!==C.Schemas.vscodeRemote}function R(m){if(m.folders.length)return m.folders.every(E=>O(E.uri))?m.folders[0].uri:void 0;if(m.configuration&&O(m.configuration))return m.configuration}function M(m){return R(m)?.scheme}function A(m){return R(m)?.authority}function $(m){return R(m)!==void 0}}),define(Se[45],Pe([1,0,171,19,54,23,2,3,16]),function(le,e,C,O,R,M,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Qi=e.$Pi=e.WorkbenchState=e.$Ji=e.$Ii=e.$Fi=void 0,e.$Gi=E,e.$Hi=T,e.$Ki=k,e.$Li=l,e.$Mi=w,e.$Ni=s,e.$Oi=r,e.$Ri=i,e.$Wi=c,e.$Xi=u,e.$Zi=t,e.$1i=d,e.$2i=a,e.$Fi=(0,$.$wi)("contextService");function E(g){const b=g;return typeof b?.id=="string"&&A.URI.isUri(b.uri)}function T(g){return typeof g?.id=="string"&&!E(g)&&!l(g)}e.$Ii={id:"ext-dev"},e.$Ji={id:"empty-window"};function k(g,b){if(typeof g=="string"||typeof g>"u")return typeof g=="string"?{id:(0,O.$nc)(g)}:b?e.$Ii:e.$Ji;const p=g;return p.configuration?{id:p.id,configPath:p.configuration}:p.folders.length===1?{id:p.id,uri:p.folders[0].uri}:{id:p.id}}function l(g){const b=g;return typeof b?.id=="string"&&A.URI.isUri(b.configPath)}function w(g){const b=g;if(b?.uri)return{id:b.id,uri:A.URI.revive(b.uri)};const p=g;if(p?.configPath)return{id:p.id,configPath:A.URI.revive(p.configPath)};if(g?.id)return{id:g.id}}var f;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function s(g){const b=g;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}function r(g){const b=g;return!!(b&&typeof b=="object"&&A.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}class o{constructor(b,p,v,y,h){this.h=b,this.j=v,this.k=y,this.l=h,this.c=R.$Ci.forUris(this.l,()=>!0),this.folders=p}update(b){this.h=b.id,this.k=b.configuration,this.j=b.transient,this.l=b.l,this.folders=b.folders}get folders(){return this.g}set folders(b){this.g=b,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(b){this.k=b}getFolder(b){return b&&this.c.findSubstr(b)||null}n(){this.c=R.$Ci.forUris(this.l,()=>!0);for(const b of this.folders)this.c.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Pi=o;class n{constructor(b,p){this.raw=p,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,M.$0g)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Qi=n;function i(g){return new n({uri:g,index:0,name:(0,M.$6g)(g)},{uri:g.toString()})}e.$Si="code-workspace",e.$Ti=`.${e.$Si}`,e.$Ui=[{name:(0,C.localize)(0,null),extensions:[e.$Si]}],e.$Vi="workspace.json";function c(g,b){return M.$1g.isEqualOrParent(g,b.untitledWorkspacesHome)}function u(g){let b;return A.URI.isUri(g)?b=g:b=g.configuration,b?.scheme===m.Schemas.tmp}e.$Yi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(g){return g.id===e.$Yi}function d(g,b){return!c(g,b)&&!u(g)}function a(g){return(typeof g=="string"?(0,O.$oc)(g):(0,M.$8g)(g))===e.$Ti}}),define(Se[215],Pe([1,0,73,5,6,23,2,170,99,38,3,12,45,28,212,11,34,13,15]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$Cl=e.ProfileResourceType=void 0,e.$Bl=c,e.$Dl=u,e.$El=t;var i;(function(g){g.Settings="settings",g.Keybindings="keybindings",g.Snippets="snippets",g.Tasks="tasks",g.Extensions="extensions",g.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function c(g){const b=g;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&typeof b.isDefault=="boolean"&&typeof b.name=="string"&&A.URI.isUri(b.location)&&A.URI.isUri(b.globalStorageHome)&&A.URI.isUri(b.settingsResource)&&A.URI.isUri(b.keybindingsResource)&&A.URI.isUri(b.tasksResource)&&A.URI.isUri(b.snippetsHome)&&A.URI.isUri(b.extensionsResource))}e.$Cl=(0,T.$wi)("IUserDataProfilesService");function u(g,b){return{id:g.id,isDefault:g.isDefault,name:g.name,shortName:g.shortName,icon:g.icon,location:A.URI.revive(g.location).with({scheme:b}),globalStorageHome:A.URI.revive(g.globalStorageHome).with({scheme:b}),settingsResource:A.URI.revive(g.settingsResource).with({scheme:b}),keybindingsResource:A.URI.revive(g.keybindingsResource).with({scheme:b}),tasksResource:A.URI.revive(g.tasksResource).with({scheme:b}),snippetsHome:A.URI.revive(g.snippetsHome).with({scheme:b}),extensionsResource:A.URI.revive(g.extensionsResource).with({scheme:b}),cacheHome:A.URI.revive(g.cacheHome).with({scheme:b}),useDefaultFlags:g.useDefaultFlags,isTransient:g.isTransient}}function t(g,b,p,v,y,h){return{id:g,name:b,location:p,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:h&&y?.useDefaultFlags?.globalState?h.globalStorageHome:(0,M.$0g)(p,"globalStorage"),settingsResource:h&&y?.useDefaultFlags?.settings?h.settingsResource:(0,M.$0g)(p,"settings.json"),keybindingsResource:h&&y?.useDefaultFlags?.keybindings?h.keybindingsResource:(0,M.$0g)(p,"keybindings.json"),tasksResource:h&&y?.useDefaultFlags?.tasks?h.tasksResource:(0,M.$0g)(p,"tasks.json"),snippetsHome:h&&y?.useDefaultFlags?.snippets?h.snippetsHome:(0,M.$0g)(p,"snippets"),extensionsResource:h&&y?.useDefaultFlags?.extensions?h.extensionsResource:(0,M.$0g)(p,"extensions.json"),cacheHome:(0,M.$0g)(v,g),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let d=class extends R.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(b,p,v,y){super(),this.t=b,this.u=p,this.w=v,this.y=y,this.f=!0,this.h=this.B(new O.$de),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$de),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$de),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$de),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new w.$Ac,emptyWindows:new Map},this.profilesHome=(0,M.$0g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$0g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(b){this.f!==b&&(this.z=void 0,this.f=b)}isEnabled(){return this.f}get C(){if(!this.z){const b=this.D(),p=[b];if(this.f)try{for(const h of this.O()){if(!h.name||!(0,n.$9f)(h.name)||!h.location){this.y.warn("Skipping the invalid stored profile",h.location||h.name);continue}p.push(t((0,M.$7g)(h.location),h.name,h.location,this.g,{shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags},b))}}catch(h){this.y.error(h)}const v=new w.$Ac,y=new Map;if(p.length)try{const h=this.Q();if(h.workspaces)for(const[D,S]of Object.entries(h.workspaces)){const I=A.URI.parse(D),P=p.find(W=>W.id===S);P&&v.set(I,P)}if(h.emptyWindows)for(const[D,S]of Object.entries(h.emptyWindows)){const I=p.find(P=>P.id===S);I&&y.set(D,I)}}catch(h){this.y.error(h)}this.z={profiles:p,workspaces:v,emptyWindows:y}}return this.z}D(){const b=t("__default__profile__",(0,$.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...b,extensionsResource:this.S()??b.extensionsResource,isDefault:!0}}async createTransientProfile(b){const p="Temp",v=new RegExp(`${(0,o.$_e)(p)}\\s(\\d+)`);let y=0;for(const D of this.profiles){const S=v.exec(D.name),I=S?parseInt(S[1]):0;y=I>y?I:y}const h=`${p} ${y+1}`;return this.createProfile((0,C.$kj)((0,r.$Sg)()).toString(16),h,{transient:!0},b)}async createNamedProfile(b,p,v){return this.createProfile((0,C.$kj)((0,r.$Sg)()).toString(16),b,p,v)}async createProfile(b,p,v,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=await this.F(b,p,v);return y&&await this.setProfileForWorkspace(y,h),h}async F(b,p,v){if(!(0,n.$9f)(p)||!p)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(p);return y||(y=(async()=>{try{if(this.profiles.find(I=>I.name===p||I.id===b))throw new Error(`Profile with ${p} name already exists`);const D=t(b,p,(0,M.$0g)(this.profilesHome,b),this.g,v,this.defaultProfile);await this.u.createFolder(D.location);const S=[];return this.j.fire({profile:D,join(I){S.push(I)}}),await s.Promises.settled(S),this.I([D],[],[]),D}finally{this.r.delete(p)}})(),this.r.set(p,y)),y}async updateProfile(b,p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let v=this.profiles.find(y=>y.id===b.id);if(!v)throw new Error(`Profile '${b.name}' does not exist`);return v=t(v.id,p.name??v.name,v.location,this.g,{shortName:p.shortName??v.shortName,icon:p.icon===null?void 0:p.icon??v.icon,transient:p.transient??v.isTransient,useDefaultFlags:p.useDefaultFlags??v.useDefaultFlags},this.defaultProfile),this.I([],[],[v]),v}async removeProfile(b){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(b.isDefault)throw new Error("Cannot remove default profile");const p=this.profiles.find(y=>y.id===b.id);if(!p)throw new Error(`Profile '${b.name}' does not exist`);const v=[];this.m.fire({profile:p,join(y){v.push(y)}});try{await Promise.allSettled(v)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])p.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])p.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[p],[]);try{await this.u.del(p.cacheHome,{recursive:!0})}catch(y){(0,E.$hl)(y)!==1&&this.y.error(y)}}async setProfileForWorkspace(b,p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=this.profiles.find(y=>y.id===p.id);if(!v)throw new Error(`Profile '${p.name}' does not exist`);this.L(b,v)}unsetWorkspace(b,p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(b,void 0,p)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const b=await this.u.resolve(this.profilesHome);await Promise.all((b.children||[]).filter(p=>p.isDirectory&&this.profiles.every(v=>!this.w.extUri.isEqual(v.location,p.resource))).map(p=>this.u.del(p.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const b=this.s.profiles.filter(p=>!this.H(p));await Promise.allSettled(b.map(p=>this.removeProfile(p)))}getProfileForWorkspace(b){const p=this.G(b);return A.URI.isUri(p)?this.s.workspaces.get(p)??this.C.workspaces.get(p):this.s.emptyWindows.get(p)??this.C.emptyWindows.get(p)}G(b){return(0,l.$Gi)(b)?b.uri:(0,l.$Li)(b)?b.configPath:b.id}H(b){return!!([...this.s.emptyWindows.values()].some(p=>this.w.extUri.isEqual(p.location,b.location))||[...this.s.workspaces.values()].some(p=>this.w.extUri.isEqual(p.location,b.location))||[...this.C.emptyWindows.values()].some(p=>this.w.extUri.isEqual(p.location,b.location))||[...this.C.workspaces.values()].some(p=>this.w.extUri.isEqual(p.location,b.location)))}I(b,p,v){const y=[...this.profiles,...b],h=[];this.s.profiles=[];for(let D of y)D.isDefault||p.some(S=>D.id===S.id)||(D=v.find(S=>D.id===S.id)??D,D.isTransient?this.s.profiles.push(D):h.push({location:D.location,name:D.name,shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags}));this.P(h),this.z=void 0,this.J(b,p,v)}J(b,p,v){this.h.fire({added:b,removed:p,updated:v,all:this.profiles})}L(b,p,v){v=p?.isTransient?!0:v,v||this.L(b,void 0,!0);const y=this.G(b),h=v?this.s:this.C;A.URI.isUri(y)?(h.workspaces.delete(y),p&&h.workspaces.set(y,p)):(h.emptyWindows.delete(y),p&&h.emptyWindows.set(y,p)),v||this.M()}M(){const b={};for(const[v,y]of this.C.workspaces.entries())b[v.toString()]=y.id;const p={};for(const[v,y]of this.C.emptyWindows.entries())p[v.toString()]=y.id;this.R({workspaces:b,emptyWindows:p}),this.z=void 0}N(b){const p={},v=this.D();if(b.workspaces)for(const[h,D]of Object.entries(b.workspaces)){const S=A.URI.parse(D);p[h]=this.w.extUri.isEqual(S,v.location)?v.id:this.w.extUri.basename(S)}const y={};if(b.emptyWindows)for(const[h,D]of Object.entries(b.emptyWindows)){const S=A.URI.parse(D);y[h]=this.w.extUri.isEqual(S,v.location)?v.id:this.w.extUri.basename(S)}return{workspaces:p,emptyWindows:y}}O(){return[]}P(b){throw new Error("not implemented")}Q(){return{}}R(b){throw new Error("not implemented")}S(){}};e.$Fl=d,e.$Fl=d=Je([We(0,m.$Di),We(1,E.$3k),We(2,f.$Al),We(3,k.$3j)],d);class a extends d{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(b){this.a=b}Q(){return this.X}R(b){this.X=b}}e.$Gl=a}),define(Se[216],Pe([1,0,11,5,6,60,15,151,3,215]),function(le,e,C,O,R,M,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$3p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$1p=e.$Zp=e.$Yp=void 0,e.$2p=w,e.$4p=s,e.$6p=o,e.$Yp="__$__isNewStorageMarker",e.$Zp="__$__targetStorageMarker",e.$1p=(0,m.$wi)("storageService");var T;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(T||(e.WillSaveStateReason=T={}));var k;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(k||(e.StorageScope=k={}));var l;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(l||(e.StorageTarget=l={}));function w(n){const i=n.get(e.$Zp);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class f extends R.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:f.a}){super(),this.m=i,this.b=this.B(new O.$ge),this.c=this.B(new O.$ge),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$de),this.onWillSaveState=this.f.event,this.h=this.B(new C.$Ih(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,c,u){return O.Event.filter(this.b.event,t=>t.scope===i&&(c===void 0||t.key===c),u)}n(){this.j.value=(0,C.$Mh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,c){const{key:u,external:t}=c;if(u===e.$Zp){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:u,target:this.J(i)[u],external:t})}w(i){this.f.fire({reason:i})}get(i,c,u){return this.P(c)?.get(i,u)}getBoolean(i,c,u){return this.P(c)?.getBoolean(i,u)}getNumber(i,c,u){return this.P(c)?.getNumber(i,u)}getObject(i,c,u){return this.P(c)?.getObject(i,u)}storeAll(i,c){this.y(()=>{for(const u of i)this.store(u.key,u.value,u.scope,u.target,c)})}store(i,c,u,t,d=!1){if((0,A.$fg)(c)){this.remove(i,u,d);return}this.y(()=>{this.z(i,u,t),this.P(u)?.set(i,c,d)})}remove(i,c,u=!1){this.y(()=>{this.z(i,c,void 0),this.P(c)?.delete(i,u)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,c){const u=[],t=this.J(i);for(const d of Object.keys(t))t[d]===c&&u.push(d);return u}z(i,c,u,t=!1){const d=this.J(c);typeof u=="number"?d[i]!==u&&(d[i]=u,this.P(c)?.set(e.$Zp,JSON.stringify(d),t)):typeof d[i]=="number"&&(delete d[i],this.P(c)?.set(e.$Zp,JSON.stringify(d),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const c=this.P(i);return c?w(c):Object.create(null)}isNew(i){return this.getBoolean(e.$Yp,i)===!0}async flush(i=T.NONE){this.f.fire({reason:i});const c=this.P(-1),u=this.P(0),t=this.P(1);switch(i){case T.NONE:await C.Promises.settled([c?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await C.Promises.settled([c?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,u=this.P(1)?.items??new Map;return o(i,c,u,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,c){return this.w(T.NONE),(0,E.$Bl)(i)?this.R(i,c):this.S(i,c)}M(i,c){return!(i.id===c.id||s(c)&&s(i))}N(i,c,u){this.y(()=>{const t=new Set;for(const[d,a]of i)t.add(d),c.get(d)!==a&&this.u(u,{key:d,external:!0});for(const[d]of c.items)t.has(d)||this.u(u,{key:d,external:!0})})}}e.$3p=f;function s(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class r extends f{constructor(){super(),this.U=this.B(new $.$Wp(new $.$Xp,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new $.$Wp(new $.$Xp,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new $.$Wp(new $.$Xp,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$5p=r;async function o(n,i,c,u,t,d){const a=I=>{try{return JSON.parse(I)}catch{return I}},g=new Map,b=new Map;n.forEach((I,P)=>{g.set(P,I),b.set(P,a(I))});const p=new Map,v=new Map;i.forEach((I,P)=>{p.set(P,I),v.set(P,a(I))});const y=new Map,h=new Map;c.forEach((I,P)=>{y.set(P,I),h.set(P,a(I))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const D=[];if(g.forEach((I,P)=>{D.push({key:P,value:I})}),console.table(D),console.groupEnd(),console.log(b),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const I=[];p.forEach((P,W)=>{I.push({key:W,value:P})}),console.table(I),console.groupEnd(),console.log(v)}console.group(`Storage: Workspace (path: ${d})`);const S=[];y.forEach((I,P)=>{S.push({key:P,value:I})}),console.table(S),console.groupEnd(),console.log(h)}}),define(Se[76],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=void 0;class C{static{this.a=!1}constructor(R){this.d=R,this.b=new Map,this.c=1}add(R){const M=this.c++;return this.b.set(M,R),this.e(),M}get(R,M){return this.b.has(R)?this.b.get(R)[M]:void 0}delete(R){this.b.delete(R),this.e()}e(){C.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$plc=C}),define(Se[46],Pe([1,0,16,23,3]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=e.$ulc=void 0;class M{constructor(){this.a=new Set(Object.keys(C.Schemas)),this.b=new Map,this.extUri=new O.$Yg($=>{const m=this.b.get($.scheme);return!(m===void 0||m&1024)})}$acceptProviderInfos($,m){m===null?this.b.delete($.scheme):this.b.set($.scheme,m)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$ulc=M,e.$vlc=(0,R.$wi)("IExtHostFileSystemInfo")}),define(Se[27],Pe([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PP=void 0,e.$PP=(0,C.$wi)("IExtHostInitDataService")}),define(Se[217],Pe([1,0,176,12,201,27]),function(le,e,C,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bnc=void 0;let A=class extends R.$ZQ{constructor(m,E,T){const k=T.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",l=T.remote.isRemote?(0,C.localize)(0,null):m?(0,C.localize)(1,null):(0,C.localize)(2,null);super(E.createLogger(k,{name:l}))}};e.$Bnc=A,e.$Bnc=A=Je([We(1,O.$4j),We(2,M.$PP)],A)}),define(Se[218],Pe([1,0,11]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=e.$amc=void 0;class O{constructor(A,$,m){this.h=new Map,this.a=A,this.b=$,this.c=m,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new C.$Ih(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const T of E.values())T.complete()}catch(T){for(const k of E.values())k.error(T)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,$){let m=this.f[A];return typeof m>"u"&&(m=$),m}update(A,$){this.f[A]=$;const m=this.h.get(A);if(m!==void 0)return m.p;const E=new C.$Th;return this.h.set(A,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$amc=O;class R extends O{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,$){super(A.identifier.value,!0,$),this.j=A}}e.$bmc=R}),define(Se[219],Pe([1,0,5,2]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=void 0;class R{constructor(A){this.c=A,this.a=new C.$de,this.onDidSaveNotebookDocument=this.a.event,this.b=new C.$de,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,$,m,E){const k=this.c.getNotebookDocument(O.URI.revive(A)).acceptModelChanged($.value,m,E);this.b.fire(k)}$acceptDirtyStateChanged(A,$){this.c.getNotebookDocument(O.URI.revive(A)).acceptDirty($)}$acceptModelSaved(A){const $=this.c.getNotebookDocument(O.URI.revive(A));this.a.fire($.apiNotebook)}}e.$2mc=R}),define(Se[17],Pe([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AP=e.$zP=void 0,e.$zP=(0,C.$wi)("IExtHostRpcService");class O{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$AP=O}),define(Se[220],Pe([1,0,20,5]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kmc=void 0;class R{#e;constructor(A,$){this.b=new O.$de,this.onDidChange=this.b.event,this.a=C.$Rm.toKey(A.identifier),this.#e=$,this.#e.onDidChangePassword(m=>{m.extensionId===this.a&&this.b.fire({key:m.key})})}get(A){return this.#e.get(this.a,A)}store(A,$){return this.#e.store(this.a,A,$)}delete(A){return this.#e.delete(this.a,A)}}e.$kmc=R}),define(Se[61],Pe([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Llc=e.$Klc=void 0,e.$Klc=(0,C.$wi)("IURITransformerService");class O{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Llc=O}),define(Se[221],Pe([1,0,21]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Erb=R,e.$Frb=A;class O{constructor(){this.buffers=[]}add(m){let E=this.buffers.indexOf(m);return E<0&&(E=this.buffers.length,this.buffers.push(m)),E}}function R($,m){if(m.serializeBuffersForPostMessage){const E=new O,k=JSON.stringify($,(w,f)=>{if(f instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(f)};if(ArrayBuffer.isView(f)){const s=M(f);if(s)return{$$vscode_array_buffer_reference$$:!0,index:E.add(f.buffer),view:{type:s,byteLength:f.byteLength,byteOffset:f.byteOffset}}}return f}),l=E.buffers.map(w=>{const f=new Uint8Array(w);return C.$Fe.wrap(f)});return{message:k,buffers:l}}else return{message:JSON.stringify($),buffers:[]}}function M($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A($,m){const E=m.map(l=>{const w=new ArrayBuffer(l.byteLength);return new Uint8Array(w).set(l.buffer),w}),T=m.length?(l,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const f=w,{index:s}=f,r=E[s];if(f.view)switch(f.view.type){case 1:return new Int8Array(r,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(r,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(r,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(r,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(r,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(r,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(r,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(r,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(r,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(r,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(r,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return r}return w}:void 0;return{message:JSON.parse($,T),arrayBuffers:E}}}),define(Se[106],Pe([1,0,185,15,2,6,3,29,38,16,44,145,33]),function(le,e,C,O,R,M,A,$,m,E,T,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$RF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$IF=e.EditorInputCapabilities=e.$HF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=void 0,e.$yF=s,e.$zF=r,e.$AF=o,e.$BF=n,e.$CF=i,e.$DF=c,e.$EF=u,e.$FF=t,e.$GF=d,e.$JF=y,e.$KF=D,e.$LF=S,e.$MF=I,e.$NF=P,e.$OF=W,e.$PF=V,e.$QF=ce,e.$SF=fe,e.$TF=Te,e.$UF=ae,e.$VF=Ne,e.$tF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$uF={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.$vF="workbench.editor.sidebysideEditor",e.$wF="workbench.editors.textDiffEditor",e.$xF="workbench.editors.binaryResourceDiffEditor";var w;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var f;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(f||(e.EditorPaneSelectionCompareResult=f={}));function s(ne){const z=ne;return!!z&&typeof z.getSelection=="function"&&!!z.onDidChangeSelection}function r(ne){const z=ne;return!!z&&typeof z.getScrollPosition=="function"&&typeof z.setScrollPosition=="function"&&!!z.onDidChangeScroll}function o(ne,z,x){for(const be of x.visibleEditorPanes)if(be.group.id===z&&ne.matches(be.input))return be.getViewState()}function n(ne){if(y(ne))return!1;const z=ne;return R.URI.isUri(z?.resource)}function i(ne){if(y(ne))return!1;const z=ne;return z?.original!==void 0&&z.modified!==void 0}function c(ne){if(y(ne))return!1;const z=ne;return!z||z.resources&&!Array.isArray(z.resources)?!1:!!z.resources||!!z.multiDiffSource}function u(ne){if(y(ne)||i(ne))return!1;const z=ne;return z?.primary!==void 0&&z.secondary!==void 0}function t(ne){if(y(ne))return!1;const z=ne;return z?z.resource===void 0||z.resource.scheme===E.Schemas.untitled||z.forceUntitled===!0:!1}function d(ne){if(y(ne))return!1;const z=ne;return R.URI.isUri(z?.base?.resource)&&R.URI.isUri(z?.input1?.resource)&&R.URI.isUri(z?.input2?.resource)&&R.URI.isUri(z?.result?.resource)}var a;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var g;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(g||(e.SaveReason=g={}));class b{constructor(){this.a=new Map}registerSource(z,x){let be=this.a.get(z);return be||(be={source:z,label:x},this.a.set(z,be)),be.source}getSourceLabel(z){return this.a.get(z)?.label??z}}e.$HF=new b;var p;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad"})(p||(e.EditorInputCapabilities=p={}));class v extends M.$Uc{}e.$IF=v;function y(ne){return ne instanceof v}function h(ne){const z=ne;return R.URI.isUri(z?.preferredResource)}function D(ne){const z=ne;return y(z?.primary)&&y(z?.secondary)}function S(ne){const z=ne;return y(z?.modified)&&y(z?.original)}function I(ne,z,x,be,Fe){return Ne(be,[(0,k.$gj)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const De={...x,limits:{size:Number.MAX_VALUE}};ne.openEditor(z,De)}}),(0,k.$gj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>Fe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}function P(ne){return y(ne?.editor)}function W(ne){const z=ne;return P(ne)&&z?.group!==void 0}function V(ne){const z=ne;return typeof z?.groupId=="number"&&y(z.editor)}var q;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var N;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ne[ne.EDITOR_STICKY=12]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=13]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var B;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class K{getOriginalUri(z,x){if(!z)return;if(d(z))return e.$RF.getOriginalUri(z.result,x);if(x?.supportSideBySide){const{primary:Fe,secondary:De}=this.a(z);if(Fe&&De){if(x?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(Fe,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(De,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===B.ANY)return this.getOriginalUri(Fe,{filterByScheme:x.filterByScheme})??this.getOriginalUri(De,{filterByScheme:x.filterByScheme});z=x.supportSideBySide===B.PRIMARY?Fe:De}}if(i(z)||c(z)||u(z)||d(z))return;const be=h(z)?z.preferredResource:z.resource;return!be||!x||!x.filterByScheme?be:this.b(be,x.filterByScheme)}a(z){return D(z)||u(z)?{primary:z.primary,secondary:z.secondary}:S(z)||i(z)?{primary:z.modified,secondary:z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(z,x){if(!z)return;if(d(z))return e.$RF.getCanonicalUri(z.result,x);if(x?.supportSideBySide){const{primary:Fe,secondary:De}=this.a(z);if(Fe&&De){if(x?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(Fe,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(De,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===B.ANY)return this.getCanonicalUri(Fe,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(De,{filterByScheme:x.filterByScheme});z=x.supportSideBySide===B.PRIMARY?Fe:De}}if(i(z)||c(z)||u(z)||d(z))return;const be=z.resource;return!be||!x||!x.filterByScheme?be:this.b(be,x.filterByScheme)}b(z,x){if(Array.isArray(x)){if(x.some(be=>z.scheme===be))return z}else if(x===z.scheme)return z}}var ie;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function ce(ne,z,x,be){if(!ne.isSticky(z))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return x===ie.MOUSE||x===ie.KEYBOARD;case"mouse":return x===ie.MOUSE;case"keyboard":return x===ie.KEYBOARD}return!1}e.$RF=new K;var ye;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(ye||(e.CloseDirection=ye={}));class ke{constructor(){this.c=new Map,this.d=new Map}start(z){const x=this.a=z.get(A.$vi);for(const[be,Fe]of this.c)this.e(be,Fe,x);this.c.clear()}e(z,x,be){const Fe=be.createInstance(x);this.d.set(z,Fe)}registerFileEditorFactory(z){if(this.b)throw new Error("Can only register one file editor factory.");this.b=z}getFileEditorFactory(){return(0,O.$hg)(this.b)}registerEditorSerializer(z,x){if(this.c.has(z)||this.d.has(z))throw new Error(`A editor serializer with type ID '${z}' was already registered.`);return this.a?this.e(z,x,this.a):this.c.set(z,x),(0,M.$Sc)(()=>{this.c.delete(z),this.d.delete(z)})}getEditorSerializer(z){return this.d.get(typeof z=="string"?z:z.typeId)}}$.$co.add(e.$tF.EditorFactory,new ke);async function fe(ne,z,x){return!ne||!ne.length?[]:await Promise.all(ne.map(async be=>{const Fe=R.URI.revive(be.fileUri);if(!Fe){x.info("Cannot resolve the path because it is not valid.",be);return}if(!await z.canHandleResource(Fe)){x.info("Cannot resolve the path because it cannot be handled",be);return}let pe=be.exists,ge=be.type;if(typeof pe!="boolean"||typeof ge!="number")try{ge=(await z.stat(Fe)).isDirectory?m.FileType.Directory:m.FileType.Unknown,pe=!0}catch(Y){x.error(Y),pe=!1}if(!pe&&be.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",be);return}if(ge===m.FileType.Directory){x.info("Cannot resolve the path because it is a directory",be);return}const Q={...be.options,pinned:!0};return pe?{resource:Fe,options:Q}:{resource:Fe,options:Q,forceUntitled:!0}}))}var $e;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})($e||(e.EditorsOrder=$e={}));function Te(ne){const z=ne;if(!z)return!1;const x=z;if(x.modified)return Te(x.modified);const be=z;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function ae(ne){return(0,T.$ij)(ne)}function Ne(ne,z,x){const be=(0,T.$jj)(ne,z);return be.forceMessage=x?.forceMessage,be.forceSeverity=x?.forceSeverity,be.allowDialog=x?.allowDialog,be}}),define(Se[222],Pe([1,0,5,186,3,6,28,29,25,92,210]),function(le,e,C,O,R,M,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4F=e.$3F=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$2F=e.ViewContentGroups=e.$ZF=e.ViewContainerLocation=e.Extensions=e.$YF=e.$XF=e.$WF=void 0,e.$1F=w,e.$WF="views",e.$XF=(0,O.localize)(0,null),e.$YF=(0,T.$fx)("default-view-icon",E.$Vj.window,(0,O.localize)(1,null));var k;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(k||(e.Extensions=k={}));var l;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(l||(e.ViewContainerLocation=l={})),e.$ZF=[0,1,2];function w(t){switch(t){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class f extends M.$Uc{constructor(){super(...arguments),this.c=this.B(new C.$de),this.onDidRegister=this.c.event,this.f=this.B(new C.$de),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(d,a,g){const b=this.get(d.id);if(b)return b;const p=d;return p.openCommandActionDescriptor=g?.doNotRegisterOpenCommand?void 0:p.openCommandActionDescriptor??{id:p.id},(0,A.$xc)(this.g,a,[]).push(p),g?.isDefault&&this.h.push(p),this.c.fire({viewContainer:p,viewContainerLocation:a}),p}deregisterViewContainer(d){for(const a of this.g.keys()){const g=this.g.get(a),b=g?.indexOf(d);if(b!==-1){g?.splice(b,1),g.length===0&&this.g.delete(a),this.f.fire({viewContainer:d,viewContainerLocation:a});return}}}get(d){return this.all.filter(a=>a.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(a=>this.getViewContainers(a).filter(g=>g?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(a=>this.getViewContainerLocation(a)===d)}}$.$co.add(k.ViewContainersRegistry,new f);var s;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(s||(e.ViewContentGroups=s={}));function r(t,d){const a=t.group??s.More,g=d.group??s.More;return a!==g?a.localeCompare(g):(t.order??5)-(d.order??5)}class o extends M.$Uc{constructor(){super(...arguments),this.c=this.B(new C.$de),this.onViewsRegistered=this.c.event,this.f=this.B(new C.$de),this.onViewsDeregistered=this.f.event,this.g=this.B(new C.$de),this.onDidChangeContainer=this.g.event,this.h=this.B(new C.$de),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Hc}registerViews(d,a){this.registerViews2([{views:d,viewContainer:a}])}registerViews2(d){d.forEach(({views:a,viewContainer:g})=>this.r(a,g)),this.c.fire(d)}deregisterViews(d,a){const g=this.s(d,a);g.length&&this.f.fire({views:g,viewContainer:a})}moveViews(d,a){for(const g of this.m.keys())if(g!==a){const b=this.s(d,g);b.length&&(this.r(b,a),this.g.fire({views:b,from:g,to:a}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const a of this.j){const g=(this.m.get(a)||[]).filter(b=>b.id===d)[0];if(g)return g}return null}getViewContainer(d){for(const a of this.j)if((this.m.get(a)||[]).filter(b=>b.id===d)[0])return a;return null}registerViewWelcomeContent(d,a){return this.n.add(d,a),this.h.fire(d),(0,M.$Sc)(()=>{this.n.delete(d,a),this.h.fire(d)})}registerViewWelcomeContent2(d,a){const g=new Map;for(const[b,p]of a)this.n.add(d,p),g.set(b,(0,M.$Sc)(()=>{this.n.delete(d,p),this.h.fire(d)}));return this.h.fire(d),g}getViewWelcomeContent(d){const a=[];return this.n.forEach(d,g=>a.push(g)),a.sort(r)}r(d,a){let g=this.m.get(a);g||(g=[],this.m.set(a,g),this.j.push(a));for(const b of d){if(this.getView(b.id)!==null)throw new Error((0,O.localize)(2,null,b.id));g.push(b)}}s(d,a){const g=this.m.get(a);if(!g)return[];const b=[],p=[];for(const v of g)d.includes(v)?b.push(v):p.push(v);return b.length&&(p.length?this.m.set(a,p):(this.m.delete(a),this.j.splice(this.j.indexOf(a),1))),b}}$.$co.add(k.ViewsRegistry,new o),e.$2F=(0,R.$wi)("viewDescriptorService");var n;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var i;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class c{constructor(d,a){this.c=!1,this.d=!1,(0,m.$6n)(this,d),this.d=!!a,this.resolve=async g=>{if(a&&!this.c){const b=await a(g);b&&(this.tooltip=this.tooltip??b.tooltip,this.command=this.command??b.command)}g.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$3F=c;class u extends Error{constructor(d){super((0,O.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$4F=u}),define(Se[223],Pe([1,0,187,31]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=void 0,e.$8F=new O.$Nj("chatSessionResponseVote","",{type:"string",description:(0,C.localize)(0,null)}),e.$9F=new O.$Nj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,C.localize)(1,null)}),e.$0F=new O.$Nj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,C.localize)(2,null)}),e.$$F=new O.$Nj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,C.localize)(3,null)}),e.$_F=new O.$Nj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,C.localize)(4,null)}),e.$aG=new O.$Nj("chatResponse",!1,{type:"boolean",description:(0,C.localize)(5,null)}),e.$bG=new O.$Nj("chatRequest",!1,{type:"boolean",description:(0,C.localize)(6,null)}),e.$cG=new O.$Nj("chatEditApplied",!1,{type:"boolean",description:(0,C.localize)(7,null)}),e.$dG=new O.$Nj("chatInputHasText",!1,{type:"boolean",description:(0,C.localize)(8,null)}),e.$eG=new O.$Nj("chatInputHasFocus",!1,{type:"boolean",description:(0,C.localize)(9,null)}),e.$fG=new O.$Nj("inChatInput",!1,{type:"boolean",description:(0,C.localize)(10,null)}),e.$gG=new O.$Nj("inChat",!1,{type:"boolean",description:(0,C.localize)(11,null)}),e.$hG=new O.$Nj("chatIsEnabled",!1,{type:"boolean",description:(0,C.localize)(12,null)}),e.$iG=new O.$Nj("chatCursorAtTop",!1),e.$jG=new O.$Nj("chatInputHasAgent",!1),e.$kG=new O.$Nj("chatLocation",void 0)}),define(Se[224],Pe([1,0,11,24,5,42,6,132,13,31,3,12,102,204,216,223]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.ChatAgentLocation=void 0;var o;(function(u){u.Panel="panel",u.Terminal="terminal",u.Notebook="notebook",u.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(u){function t(d){switch(d){case"panel":return u.Panel;case"terminal":return u.Terminal;case"notebook":return u.Notebook;case"editor":return u.Editor}return u.Panel}u.fromRaw=t}(o||(e.ChatAgentLocation=o={})),e.$iH=(0,T.$wi)("chatAgentService");let n=class{static{this.AGENT_LEADER="@"}constructor(t){this.f=t,this.b=[],this.d=new R.$de,this.onDidChangeAgents=this.d.event,this.e=s.$hG.bindTo(this.f)}registerAgent(t,d){if(this.getAgent(t))throw new Error(`Agent already registered: ${JSON.stringify(t)}`);const g=this,b=d.slashCommands;d={...d,get slashCommands(){return b.filter(v=>!v.when||g.f.contextMatchesRules(E.$uj.deserialize(v.when)))}};const p={data:d};return this.b.push(p),(0,A.$Sc)(()=>{this.b=this.b.filter(v=>v!==p),this.d.fire(void 0)})}registerAgentImplementation(t,d){const a=this.g(t);if(!a)throw new Error(`Unknown agent: ${JSON.stringify(t)}`);if(a.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(t)}`);return a.data.isDefault&&this.e.set(!0),a.impl=d,this.d.fire(new i(a.data,d)),(0,A.$Sc)(()=>{a.impl=void 0,this.d.fire(void 0),a.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(t,d){const a={data:t,impl:d};return this.b.push(a),this.d.fire(new i(t,d)),(0,A.$Sc)(()=>{this.b=this.b.filter(g=>g!==a),this.d.fire(void 0)})}updateAgent(t,d){const a=this.g(t);if(!a?.impl)throw new Error(`No activated agent with id ${JSON.stringify(t)} registered`);a.data.metadata={...a.data.metadata,...d},this.d.fire(new i(a.data,a.impl))}getDefaultAgent(t){return this.getActivatedAgents().find(d=>!!d.isDefault&&d.locations.includes(t))}getContributedDefaultAgent(t){return this.getAgents().find(d=>!!d.isDefault&&d.locations.includes(t))}getSecondaryAgent(){return M.Iterable.find(this.b.values(),t=>!!t.data.metadata.isSecondary)?.data}g(t){return this.b.find(d=>d.data.id===t)}getAgent(t){return this.g(t)?.data}getAgents(){return this.b.map(t=>t.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(t=>!!t.impl).map(t=>new i(t.data,t.impl))}getAgentsByName(t){return this.getAgents().filter(d=>d.name===t)}async invokeAgent(t,d,a,g,b){const p=this.g(t);if(!p?.impl)throw new Error(`No activated agent with id ${t}`);return await p.impl.invoke(d,a,g,b)}async getFollowups(t,d,a,g,b){const p=this.g(t);if(!p?.impl)throw new Error(`No activated agent with id ${t}`);return p.impl?.provideFollowups?p.impl.provideFollowups(d,a,g,b):[]}};e.$jH=n,e.$jH=n=Je([We(0,E.$Oj)],n);class i{constructor(t,d){this.b=t,this.d=d}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.extensionPublisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(t,d,a,g){return this.d.invoke(t,d,a,g)}async provideFollowups(t,d,a,g){return this.d.provideFollowups?this.d.provideFollowups(t,d,a,g):[]}provideWelcomeMessage(t,d){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(t,d)}provideSampleQuestions(t,d){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(t,d)}}e.$kH=i,e.$lH=(0,T.$wi)("chatAgentNameService");let c=class{static{r=this}static{this.b="chat.participantNameRegistry"}constructor(t,d,a,g){if(this.g=d,this.h=a,this.i=g,this.e=(0,$.$1d)(this,Object.create(null)),this.f=!1,!t.chatParticipantRegistry)return;this.d=t.chatParticipantRegistry;const b=g.get(r.b,-1);try{this.e.set(JSON.parse(b??"{}"),void 0)}catch{g.remove(r.b,-1)}this.j()}j(){this.f||this.k().catch(t=>this.h.warn("Failed to fetch chat participant registry",t)).then(()=>(0,C.$xh)(5*60*1e3)).then(()=>this.j())}async k(){const t=await this.g.request({type:"GET",url:this.d},O.CancellationToken.None);if(t.res.statusCode!==200)throw new Error("Could not get extensions report.");const d=await(0,w.$Tp)(t);if(!d||d.version!==1)throw new Error("Unexpected chat participant registry response.");const a=d.restrictedChatParticipants;this.e.set(a,void 0),this.i.store(r.b,JSON.stringify(a),-1,1)}getAgentNameRestriction(t){return this.e.map(a=>a[t.name.toLowerCase()]).map(a=>a?a.some(g=>(0,m.$xf)(g,g.includes(".")?t.extensionId.value:t.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$mH=c,e.$mH=c=r=Je([We(0,l.$jk),We(1,w.$Np),We(2,k.$3j),We(3,f.$1p)],c)}),define(Se[225],Pe([1,0,2,30,3]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sG=e.$rG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$pG=M,e.$qG=A;function M(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof C.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(O.$ut.isIRange)}function A(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(M)}var $;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var m;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(m||(e.ChatCopyKind=m={})),e.$rG=(0,R.$wi)("IChatService"),e.$sG="accessibility.voice.keywordActivation"}),define(Se[226],Pe([1,0,5,11,188]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rrb=void 0;class M{constructor(){this.f=new Map,this.m=[],this.n=new C.$de,this.o=new C.$de,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage($){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=$}onEvent($){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=$}onRequest($){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.u("response",$)}sendRequest($,m,E,T){const k={command:$};if(m&&Object.keys(m).length>0&&(k.arguments=m),this.u("request",k),typeof T=="number"){const l=setTimeout(()=>{clearTimeout(l);const w=this.f.get(k.seq);if(w){this.f.delete(k.seq);const f={type:"response",seq:0,request_seq:k.seq,success:!1,command:$,message:(0,R.localize)(0,null,T,$)};w(f)}},T)}return E&&this.f.set(k.seq,E),k.seq}acceptMessage($){this.k?this.k($):(this.m.push($),this.m.length===1&&this.s())}q($,m){return $.type!=="event"||m.type!=="event"}async s(){let $;for(;this.m.length;){if((!$||this.q(this.m[0],$))&&await(0,O.$xh)(0),$=this.m.shift(),!$)return;switch($.type){case"event":this.j?.($);break;case"request":this.g?.($);break;case"response":{const m=$,E=this.f.get(m.request_seq);E&&(this.f.delete(m.request_seq),E(m));break}}}}u($,m){m.type=$,m.seq=this.d++,this.sendMessage(m)}async w(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((m,E)=>$.set(E,m)),await(0,O.$xh)(500),$.forEach((m,E)=>{m({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Rrb=M}),define(Se[227],Pe([1,0,2,189,31,3]),function(le,e,C,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$CJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$AJ=e.MemoryRangeType=e.State=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=void 0,e.$zJ=m,e.$BJ=T,e.$nI="workbench.view.debug",e.$oI="workbench.debug.variablesView",e.$pI="workbench.debug.watchExpressionsView",e.$qI="workbench.debug.callStackView",e.$rI="workbench.debug.loadedScriptsView",e.$sI="workbench.debug.breakPointsView",e.$tI="workbench.debug.disassemblyView",e.$uI="workbench.panel.repl",e.$vI="workbench.panel.repl.view",e.$wI=new R.$Nj("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.$xI=new R.$Nj("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.$yI=new R.$Nj("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.$zI="debugUx",e.$AI=new R.$Nj(e.$zI,"default",{type:"string",description:O.localize(3,null)}),e.$BI=new R.$Nj("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.$CI=new R.$Nj("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.$DI=new R.$Nj("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.$EI=new R.$Nj("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.$FI=new R.$Nj("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.$GI=new R.$Nj("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.$HI=new R.$Nj("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.$II=new R.$Nj("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.$JI=new R.$Nj("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.$KI=new R.$Nj("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.$LI=new R.$Nj("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.$MI=new R.$Nj("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.$NI=new R.$Nj("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.$OI=new R.$Nj("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.$PI=new R.$Nj("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.$QI=new R.$Nj("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.$RI=new R.$Nj("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.$SI=new R.$Nj("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.$TI=new R.$Nj("breakpointItemBytes",void 0,{type:"boolean",description:O.localize(22,null)}),e.$UI=new R.$Nj("breakpointHasModes",!1,{type:"boolean",description:O.localize(23,null)}),e.$VI=new R.$Nj("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(24,null)}),e.$WI=new R.$Nj("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(25,null)}),e.$XI=new R.$Nj("loadedScriptsItemType",void 0,{type:"string",description:O.localize(26,null)}),e.$YI=new R.$Nj("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(27,null)}),e.$ZI=new R.$Nj("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(28,null)}),e.$1I=new R.$Nj("stepBackSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.$2I=new R.$Nj("restartFrameSupported",!1,{type:"boolean",description:O.localize(30,null)}),e.$3I=new R.$Nj("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(31,null)}),e.$4I=new R.$Nj("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.$5I=new R.$Nj("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(33,null)}),e.$6I=new R.$Nj("breakpointsExist",!1,{type:"boolean",description:O.localize(34,null)}),e.$7I=new R.$Nj("debuggersAvailable",!1,{type:"boolean",description:O.localize(35,null)}),e.$8I=new R.$Nj("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(36,null)}),e.$9I=new R.$Nj("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(37,null)}),e.$0I=new R.$Nj("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.$$I=new R.$Nj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.$_I=new R.$Nj("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.$aJ=new R.$Nj("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.$bJ=new R.$Nj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.$cJ=new R.$Nj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.$dJ=new R.$Nj("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(44,null)}),e.$eJ=new R.$Nj("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(45,null)}),e.$fJ=new R.$Nj("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(46,null)}),e.$gJ=new R.$Nj("variableIsReadonly",!1,{type:"boolean",description:O.localize(47,null)}),e.$hJ=new R.$Nj("variableValue",!1,{type:"string",description:O.localize(48,null)}),e.$iJ=new R.$Nj("variableType",!1,{type:"string",description:O.localize(49,null)}),e.$jJ=new R.$Nj("variableInterfaces",!1,{type:"array",description:O.localize(50,null)}),e.$kJ=new R.$Nj("variableName",!1,{type:"string",description:O.localize(51,null)}),e.$lJ=new R.$Nj("variableLanguage",!1,{type:"string",description:O.localize(52,null)}),e.$mJ=new R.$Nj("variableExtensionId",!1,{type:"string",description:O.localize(53,null)}),e.$nJ=new R.$Nj("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(54,null)}),e.$oJ=new R.$Nj("multiSessionRepl",!1,{type:"boolean",description:O.localize(55,null)}),e.$pJ=new R.$Nj("multiSessionDebug",!1,{type:"boolean",description:O.localize(56,null)}),e.$qJ=new R.$Nj("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(57,null)}),e.$rJ=new R.$Nj("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(58,null)}),e.$sJ=new R.$Nj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(59,null)}),e.$tJ=new R.$Nj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(60,null)});const A=i=>O.localize(61,null,i);e.$uJ=A,e.$vJ="editor.contrib.debug",e.$wJ="editor.contrib.breakpoint",e.$xJ="debug",e.$yJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(62,null)};var $;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})($||(e.State=$={}));function m(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$AJ="vscode-debug-memory";function T(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var k;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(k||(e.DataBreakpointSetType=k={}));var l;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(l||(e.DebugConfigurationProviderTriggerKind=l={}));var w;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(w||(e.DebuggerString=w={})),e.$CJ=(0,M.$wi)("debugService");var f;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(f||(e.BreakpointWidgetContext=f={}));var s;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(s||(e.DebugVisualizationType=s={}));var r;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(r||(e.DebugTreeItemCollapsibleState=r={}));var o;(function(i){i.deserialize=c=>c,i.serialize=c=>c})(o||(e.IDebugVisualizationTreeItem=o={}));var n;(function(i){i.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:C.URI.revive(c.iconPath.light),dark:C.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),i.serialize=c=>c})(n||(e.IDebugVisualization=n={}))}),define(Se[228],Pe([1,0,13,2,19,25,16,30,24,18]),function(le,e,C,O,R,M,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BH=void 0,e.$pH=k,e.$qH=l,e.$rH=w,e.$sH=f,e.$tH=s,e.$uH=r,e.$vH=o,e.$wH=i,e.$xH=t,e.$yH=d,e.$zH=g,e.$AH=p;const T=/{([^}]+)}/g;function k(y,h,D){return y.replace(T,function(S,I){return h&&I.length>0&&I[0]!=="_"?S:D&&D.hasOwnProperty(I)?D[I]:S})}function l(y){const h={};for(const D of Object.keys(y))D.startsWith("!")||(h[D]=y[D]);return h}function w(y){return y.configuration.request==="attach"&&!f(y)&&(!y.parentSession||w(y.parentSession))}function f(y){let h=y.configuration.type;if(h)return h==="vslsShare"&&(h=y.configuration.adapterProxy.configuration.type),(0,C.$xf)(h,"extensionhost")||(0,C.$xf)(h,"pwa-extensionhost")?y:y.parentSession?f(y.parentSession):void 0}function s(y){return y.type&&(y.label||y.program||y.runtime)}function r(y,h,D){let S,I=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=P.exec(y);){const V=W.index+1,q=V+W[0].length;if(V<=h&&q>=D){S=W[0],I=V;break}}if(S){const V=/\w+/g;let q=null;for(;(q=V.exec(S))&&!(q.index+1+I+q[0].length>=D););q&&(S=S.substring(0,V.lastIndex))}return S?{start:I,end:I+S.length-1}:{start:0,end:0}}async function o(y,h,D,S){if(y.evaluatableExpressionProvider.has(h)){const I=y.evaluatableExpressionProvider.ordered(h),P=(0,E.$Hb)(await Promise.all(I.map(async W=>{try{return await W.provideEvaluatableExpression(h,D,S??m.CancellationToken.None)}catch{return}})));if(P.length>0){let W=P[0].expression;const V=P[0].range;return W||(W=h.getLineContent(D.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:W}}}else{const I=h.getLineContent(D.lineNumber),{start:P,end:W}=r(I,D.column,D.column),V=I.substring(P-1,W);return{matchingExpression:V,range:new $.$ut(D.lineNumber,P,D.lineNumber,P+V.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(y){return!!(y&&y.match(n))}function c(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(i(y.path))return O.URI.parse(y.path);if((0,R.$ic)(y.path))return O.URI.file(y.path)}return y.path}function u(y){if(typeof y.path=="object"){const h=O.URI.revive(y.path);if(h)return h.scheme===A.Schemas.file?h.fsPath:h.toString()}return y.path}function t(y,h){const D=h?c:u,S=(0,M.$3n)(y);return a(S,(I,P)=>{I&&P&&(P.path=D(P))}),S}function d(y,h){const D=h?c:u,S=(0,M.$3n)(y);return a(S,(I,P)=>{!I&&P&&(P.path=D(P))}),S}function a(y,h){switch(y.type){case"event":{const D=y;switch(D.event){case"output":h(!1,D.body.source);break;case"loadedSource":h(!1,D.body.source);break;case"breakpoint":h(!1,D.body.breakpoint.source);break;default:break}break}case"request":{const D=y;switch(D.command){case"setBreakpoints":h(!0,D.arguments.source);break;case"breakpointLocations":h(!0,D.arguments.source);break;case"source":h(!0,D.arguments.source);break;case"gotoTargets":h(!0,D.arguments.source);break;case"launchVSCode":D.arguments.args.forEach(S=>h(!1,S));break;default:break}break}case"response":{const D=y;if(D.success&&D.body)switch(D.command){case"stackTrace":D.body.stackFrames.forEach(S=>h(!1,S.source));break;case"loadedSources":D.body.sources.forEach(S=>h(!1,S));break;case"scopes":D.body.scopes.forEach(S=>h(!1,S.source));break;case"setFunctionBreakpoints":D.body.breakpoints.forEach(S=>h(!1,S.source));break;case"setBreakpoints":D.body.breakpoints.forEach(S=>h(!1,S.source));break;case"disassemble":D.body?.instructions.forEach(I=>h(!1,I.location));break;default:break}break}}}function g(y){return y.filter(h=>!h.presentation?.hidden).sort((h,D)=>h.presentation?D.presentation?h.presentation.group?D.presentation.group?h.presentation.group!==D.presentation.group?h.presentation.group.localeCompare(D.presentation.group):b(h.presentation.order,D.presentation.order):-1:D.presentation.group?1:b(h.presentation.order,D.presentation.order):-1:D.presentation?1:0)}function b(y,h){return typeof y!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:y-h}async function p(y,h){const D=y.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(D!=="none"&&(await h.saveAll(),D==="allEditorsInActiveGroup")){const S=h.activeEditorPane;S&&S.input.resource?.scheme===A.Schemas.untitled&&await h.save({editor:S.input,groupId:S.group.id})}await y.reloadConfiguration()}const v=(y,h)=>!y||!h?y===h:y.name===h.name&&y.path===h.path&&y.sourceReference===h.sourceReference;e.$BH=v}),define(Se[229],Pe([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.CellExecutionUpdateType=void 0;var O;(function(R){R[R.Output=1]="Output",R[R.OutputItems=2]="OutputItems",R[R.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$PK=(0,C.$wi)("INotebookExecutionService")}),define(Se[230],Pe([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jjb=e.$ijb=e.ProxyKernelState=e.$hjb=void 0,e.$hjb=100;var O;(function(R){R[R.Disconnected=1]="Disconnected",R[R.Connected=2]="Connected",R[R.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.$ijb=(0,C.$wi)("INotebookKernelService"),e.$jjb=(0,C.$wi)("INotebookKernelHistoryService")}),define(Se[231],Pe([1,0,6,30,156,96]),function(le,e,C,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nXb=void 0;class A extends C.$Uc{constructor(m,E,T){super(),this._source=m,this.b=E,this.c=T,this.a=void 0}f(m){const E=m.getLineCount();return new O.$ut(1,1,E,this.g(m,E))}g(m,E){if(E<1||E>m.getLineCount())throw new Error("Illegal value for lineNumber");return m.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const m=new R.$2C;m.acceptChunk(this._source);const E=m.finish(!0),{textBuffer:T,disposable:k}=E.create(1);this.b=T,this.B(k)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(m=>{const E=new R.$2C;E.acceptChunk(m);const T=E.finish(!0),{textBuffer:k,disposable:l}=T.create(1);return this.B(l),k})),this.a}findInInputs(m){const T=new M.$PC(m,!1,!1,null).parseSearchRequest();if(!T)return[];const k=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(k,T,!0,5e3)}findInOutputs(m){const T=new M.$PC(m,!1,!1,null).parseSearchRequest();return T?this.outputTextBuffers.map(k=>{const l=k.findMatchesLineByLine(this.f(k),T,!0,5e3);if(l.length!==0)return{textBuffer:k,matches:l}}).filter(k=>!!k):[]}}e.$nXb=A}),define(Se[52],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(M){M.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var O;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class R{static fromExtHostTestItem(A,$,m=A.parent){if(A._isRoot)return new R([$]);const E=[A.id];for(let T=m;T&&T.id!==$;T=T.parent)E.push(T.id);return E.push($),new R(E.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const $=A.indexOf("\0");return $===-1?A:A.slice(0,$)}static fromString(A){return new R(A.split("\0"))}static join(A,$){return new R([...A.path,$])}static joinToString(A,$){return A.toString()+"\0"+$}static parentId(A){const $=A.lastIndexOf("\0");return $===-1?void 0:A.slice(0,$)}static localId(A){const $=A.lastIndexOf("\0");return $===-1?A:A.slice($+1)}static isChild(A,$){return $.startsWith(A)&&$[A.length]==="\0"}static compare(A,$){return A===$?0:R.isChild(A,$)?2:R.isChild($,A)?3:1}constructor(A,$=A.length){if(this.path=A,this.d=$,A.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new R(this.path,1)}get parentId(){return this.d>1?new R(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new R(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new R(this.path,A)}compare(A){if(typeof A=="string")return R.compare(this.toString(),A);for(let $=0;$<A.d&&$<this.d;$++)if(A.path[$]!==this.path[$])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$WL=R}),define(Se[62],Pe([1,0,2,94,30,52]),function(le,e,C,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$5L=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$4L=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$3L=e.$2L=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$1L=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$ZL=e.$YL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$XL=e.TestResultState=void 0;var A;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$XL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var $;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})($||(e.ExtTestRunProfileKind=$={}));var m;(function(N){N[N.Run=2]="Run",N[N.Debug=4]="Debug",N[N.Coverage=8]="Coverage",N[N.HasNonDefaultProfile=16]="HasNonDefaultProfile",N[N.HasConfigurable=32]="HasConfigurable",N[N.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$YL=[2,4,8,16,32,64];const E=N=>"runId"in N;e.$ZL=E;var T;(function(N){N.serialize=B=>({range:B.range.toJSON(),uri:B.uri.toJSON()}),N.deserialize=(B,K)=>({range:R.$ut.lift(K.range),uri:B.asCanonicalUri(C.URI.revive(K.uri))})})(T||(e.IRichLocation=T={}));var k;(function(N){N[N.Error=0]="Error",N[N.Output=1]="Output"})(k||(e.TestMessageType=k={}));var l;(function(N){N.serialize=B=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&T.serialize(B.location)}),N.deserialize=(B,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&T.deserialize(B,K.location)})})(l||(e.ITestErrorMessage=l={}));const w=(N,B)=>`${B?"s":"e"}${N}`;e.$1L=w;var f;(function(N){N.serialize=B=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&T.serialize(B.location)}),N.deserialize=(B,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&T.deserialize(B,K.location)})})(f||(e.ITestOutputMessage=f={}));var s;(function(N){N.serialize=B=>B.type===0?l.serialize(B):f.serialize(B),N.deserialize=(B,K)=>K.type===0?l.deserialize(B,K):f.deserialize(B,K)})(s||(e.ITestMessage=s={}));var r;(function(N){N.serializeWithoutMessages=B=>({state:B.state,duration:B.duration,messages:[]}),N.serialize=B=>({state:B.state,duration:B.duration,messages:B.messages.map(s.serialize)}),N.deserialize=(B,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(ie=>s.deserialize(B,ie))})})(r||(e.ITestTaskState=r={}));const o="\0",n=(N,B)=>N+o+B;e.$2L=n;const i=N=>{const B=N.indexOf(o);return{ctrlId:N.slice(0,B),tagId:N.slice(B+1)}};e.$3L=i;var c;(function(N){N.serialize=B=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?.toJSON(),range:B.range?.toJSON()||null,description:B.description,error:B.error,sortText:B.sortText}),N.deserialize=(B,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?B.asCanonicalUri(C.URI.revive(K.uri)):void 0,range:K.range?R.$ut.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(c||(e.ITestItem=c={}));var u;(function(N){N[N.NotExpandable=0]="NotExpandable",N[N.Expandable=1]="Expandable",N[N.BusyExpanding=2]="BusyExpanding",N[N.Expanded=3]="Expanded"})(u||(e.TestItemExpandState=u={}));var t;(function(N){N.serialize=B=>({expand:B.expand,item:c.serialize(B.item)}),N.deserialize=(B,K)=>({controllerId:M.$WL.root(K.item.extId),expand:K.expand,item:c.deserialize(B,K.item)})})(t||(e.InternalTestItem=t={}));var d;(function(N){N.serialize=B=>{let K;return B.item&&(K={},B.item.label!==void 0&&(K.label=B.item.label),B.item.tags!==void 0&&(K.tags=B.item.tags),B.item.busy!==void 0&&(K.busy=B.item.busy),B.item.uri!==void 0&&(K.uri=B.item.uri?.toJSON()),B.item.range!==void 0&&(K.range=B.item.range?.toJSON()),B.item.description!==void 0&&(K.description=B.item.description),B.item.error!==void 0&&(K.error=B.item.error),B.item.sortText!==void 0&&(K.sortText=B.item.sortText)),{extId:B.extId,expand:B.expand,item:K}},N.deserialize=B=>{let K;return B.item&&(K={},B.item.label!==void 0&&(K.label=B.item.label),B.item.tags!==void 0&&(K.tags=B.item.tags),B.item.busy!==void 0&&(K.busy=B.item.busy),B.item.range!==void 0&&(K.range=B.item.range?R.$ut.lift(B.item.range):null),B.item.description!==void 0&&(K.description=B.item.description),B.item.error!==void 0&&(K.error=B.item.error),B.item.sortText!==void 0&&(K.sortText=B.item.sortText)),{extId:B.extId,expand:B.expand,item:K}}})(d||(e.ITestItemUpdate=d={}));const a=(N,B)=>{B.expand!==void 0&&(N.expand=B.expand),B.item!==void 0&&(N.item=N.item?Object.assign(N.item,B.item):B.item)};e.$4L=a;var g;(function(N){N.serializeWithoutMessages=B=>({...t.serialize(B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(r.serializeWithoutMessages)}),N.serialize=B=>({...t.serialize(B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(r.serialize)}),N.deserialize=(B,K)=>({...t.deserialize(B,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(ie=>r.deserialize(B,ie)),retired:!0})})(g||(e.TestResultItem=g={}));var b;(function(N){N.empty=()=>({covered:0,total:0}),N.sum=(B,K)=>{B.covered+=K.covered,B.total+=K.total}})(b||(e.ICoverageCount=b={}));var p;(function(N){N.serialize=B=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,uri:B.uri.toJSON()}),N.deserialize=(B,K)=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,uri:B.asCanonicalUri(C.URI.revive(K.uri))})})(p||(e.IFileCoverage=p={}));function v(N){return{...N,location:N.location?.toJSON()}}function y(N){return N.location=N.location?O.$tt.isIPosition(N.location)?O.$tt.lift(N.location):R.$ut.lift(N.location):void 0,N}e.$5L=3;var h;(function(N){N[N.Declaration=0]="Declaration",N[N.Statement=1]="Statement",N[N.Branch=2]="Branch"})(h||(e.DetailType=h={}));var D;(function(N){N.serialize=B=>B.type===0?I.serialize(B):P.serialize(B),N.deserialize=B=>B.type===0?I.deserialize(B):P.deserialize(B)})(D||(e.CoverageDetails=D={}));var S;(function(N){N.serialize=v,N.deserialize=y})(S||(e.IBranchCoverage=S={}));var I;(function(N){N.serialize=v,N.deserialize=y})(I||(e.IDeclarationCoverage=I={}));var P;(function(N){N.serialize=B=>({...v(B),branches:B.branches?.map(S.serialize)}),N.deserialize=B=>({...y(B),branches:B.branches?.map(S.deserialize)})})(P||(e.IStatementCoverage=P={}));var W;(function(N){N[N.Add=0]="Add",N[N.Update=1]="Update",N[N.DocumentSynced=2]="DocumentSynced",N[N.Remove=3]="Remove",N[N.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",N[N.Retire=5]="Retire",N[N.AddTag=6]="AddTag",N[N.RemoveTag=7]="RemoveTag"})(W||(e.TestDiffOpType=W={}));var V;(function(N){N.deserialize=(B,K)=>K.op===0?{op:K.op,item:t.deserialize(B,K.item)}:K.op===1?{op:K.op,item:d.deserialize(K.item)}:K.op===2?{op:K.op,uri:B.asCanonicalUri(C.URI.revive(K.uri)),docv:K.docv}:K,N.serialize=B=>B.op===0?{op:B.op,item:t.serialize(B.item)}:B.op===1?{op:B.op,item:d.serialize(B.item)}:B})(V||(e.TestsDiffOp=V={}));class q{constructor(B){this.k=B,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(B){const K=this.v();for(const ie of B)switch(ie.op){case 0:this.l(t.deserialize(this.k,ie.item),K);break;case 1:this.o(d.deserialize(ie.item),K);break;case 3:this.p(ie.itemId,K);break;case 5:this.q(ie.itemId);break;case 4:this.updatePendingRoots(ie.amount);break;case 6:this.c.set(ie.tag.id,ie.tag);break;case 7:this.c.delete(ie.id);break}K.complete?.()}l(B,K){const ie=M.$WL.parentId(B.item.extId)?.toString();let ce;if(!ie)ce=this.w(B),this.g.add(ce),this.f.set(B.item.extId,ce);else if(this.f.has(ie)){const ye=this.f.get(ie);ye.children.add(B.item.extId),ce=this.w(B,ye),this.f.set(B.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(B)}`);return}return K.add?.(ce),B.expand===2&&this.h++,ce}o(B,K){const ie=this.f.get(B.extId);if(ie)return B.expand!==void 0&&(ie.expand===2&&this.h--,B.expand===2&&this.h++),(0,e.$4L)(ie,B),K.update?.(ie),ie}p(B,K){const ie=this.f.get(B);if(!ie)return;const ce=M.$WL.parentId(ie.item.extId)?.toString();ce?this.f.get(ce).children.delete(ie.item.extId):this.g.delete(ie);const ye=[[B]];for(;ye.length;)for(const ke of ye.pop()){const fe=this.f.get(ke);fe&&(ye.push(fe.children),this.f.delete(ke),K.remove?.(fe,fe!==ie),fe.expand===2&&this.h--)}}q(B){}updatePendingRoots(B){this.j+=B}v(){return{}}}e.$6L=q}),define(Se[77],Pe([1,0,11,5,6,57,62,52]),function(le,e,C,O,R,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tP=e.$sP=e.$rP=e.$qP=e.$pP=e.TestItemEventOp=void 0;var m;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const E=(n,i)=>n===i,k=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:E,label:E,description:E,error:E,sortText:E,tags:(n,i)=>!(n.length!==i.length||n.some(c=>!i.includes(c)))}),l=(n,i)=>{let c;for(const[u,t]of k)t(n[u],i[u])||(c?c[u]=i[u]:c={[u]:i[u]});return c};class w extends R.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new C.$Ih(()=>this.flushDiff(),200)),this.g=this.B(new O.$de),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===i.uri){c.docv=i.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===i.item.extId){(0,A.$4L)(c.item,i.item);return}if(c.op===0&&c.item.item.extId===i.item.extId){(0,A.$4L)(c.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,c){const u=this.tree.get(i);if(u){if((u.expandLevels===void 0||c>u.expandLevels)&&(u.expandLevels=c),u.expand===1){const t=this.M(u);return t.isOpen()?this.L(u,c-1):t.wait().then(()=>this.L(u,c-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.L(u,c-1)):this.L(u,c-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,c){switch(c.op){case 3:this.O($.$WL.joinToString(i.fullId,c.id));break;case 0:this.z(c.item,i);break;case 5:for(const u of c.ops)this.w(i,u);break;case 1:this.C(c.new,c.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:c.update}});break;case 6:this.y(i.actual.uri);break;default:(0,M.$ed)(c)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,c){const u=$.$WL.fromExtHostTestItem(i,this.root.id,c?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==c?.actual&&this.s.getChildren(t.parent).delete(i.id);let d=this.tree.get(u.toString());if(!d){d={fullId:u,actual:i,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(d.fullId.toString(),d),this.G(i,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:d.expand,item:this.s.toITestItem(i)}}),this.I(i,d,c);return}if(d.actual===i){this.H(i,d,c);return}if(d.actual.uri?.toString()!==i.uri?.toString())return this.O(u.toString()),this.z(i,c);const a=this.s.getChildren(d.actual),g=d.actual,b=l(this.s.toITestItem(g),this.s.toITestItem(i));this.s.getApiFor(g).listener=void 0,d.actual=i,d.resolveBarrier=void 0,d.expand=0,b&&(b.hasOwnProperty("tags")&&(this.C(i.tags,g.tags,u.toString()),delete b.tags),this.w(d,{op:4,update:b})),this.I(i,d,c);for(const[v,y]of a)this.s.getChildren(i).get(y.id)||this.O($.$WL.joinToString(u,y.id));const p=d.expandLevels;p!==void 0&&queueMicrotask(()=>{d.expand===1&&(d.expandLevels=void 0,this.expand(u.toString(),p))}),this.y(d.actual.uri)}C(i,c,u){const t=new Set(c.map(d=>d.id));for(const d of i)t.delete(d.id)||this.D(d);this.pushDiff({op:1,item:{extId:u,item:{tags:i.map(d=>(0,A.$2L)(this.s.controllerId,d.id))}}}),t.forEach(this.F,this)}D(i){const c=this.j.get(i.id);c?c.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$2L)(this.s.controllerId,i.id)}}))}F(i){const c=this.j.get(i);c&&!--c.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,A.$2L)(this.s.controllerId,i)}))}G(i,c){this.s.getApiFor(i).parent=c&&c.actual!==this.root?c.actual:void 0}H(i,c,u){this.G(i,u);const t=this.s.getApiFor(i);t.parent=u?.actual,t.listener=d=>this.w(c,d),this.J(c)}I(i,c,u){this.H(i,c,u);for(const[t,d]of this.s.getChildren(i))this.z(d,c)}J(i){let c;this.h?i.resolveBarrier?c=i.resolveBarrier.isOpen()?3:2:c=i.actual.canResolveChildren?1:0:c=0,c!==i.expand&&(i.expand=c,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:c}}),c===1&&i.expandLevels!==void 0&&this.M(i))}L(i,c){if(c<0)return;const u=[];for(const[t,d]of this.s.getChildren(i.actual)){const a=this.expand($.$WL.joinToString(i.fullId,d.id),c);(0,C.$ih)(a)&&u.push(a)}if(u.length)return Promise.all(u).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const d=new C.$vh;return d.open(),d}i.expand=2,this.N(i);const c=i.resolveBarrier=new C.$vh,u=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,d)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(d){u(d)}return(0,C.$ih)(t)?t.catch(u).then(()=>{c.open(),this.J(i)}):(c.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const c=this.tree.get(i);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const u=[c];for(;u.length;){const t=u.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const d of t.actual.tags)this.F(d.id);this.tree.delete(t.fullId.toString());for(const[d,a]of this.s.getChildren(t.actual))u.push(this.tree.get($.$WL.joinToString(t.fullId,a.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$pP=w;class f extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$qP=f;class s extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$rP=s;class r extends Error{constructor(i,c,u){super(`TestItem with ID "${i}" is from controller "${c}" and cannot be added as a child of an item from controller "${u}".`)}}e.$sP=r;const o=(n,i,c)=>{let u=new Map;return{get size(){return u.size},forEach(t,d){for(const a of u.values())t.call(d,a,this)},[Symbol.iterator](){return u.entries()},replace(t){const d=new Map,a=new Set(u.keys()),g={op:5,ops:[]};for(const b of t){if(!(b instanceof c))throw new s(b.id);const p=i(b).controllerId;if(p!==n.controllerId)throw new r(b.id,p,n.controllerId);if(d.has(b.id))throw new f(b.id);d.set(b.id,b),a.delete(b.id),g.ops.push({op:0,item:b})}for(const b of a.keys())g.ops.push({op:3,id:b});n.listener?.(g),u=d},add(t){if(!(t instanceof c))throw new s(t.id);u.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){u.delete(t)&&n.listener?.({op:3,id:t})},get(t){return u.get(t)},toJSON(){return Array.from(u.values())}}};e.$tP=o}),define(Se[107],Pe([1,0,77]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vP=e.$uP=void 0;const O=new WeakMap,R=(A,$)=>{const m={controllerId:$};return O.set(A,m),m};e.$uP=R;const M=A=>{const $=O.get(A);if(!$)throw new C.$rP(A?.id||"<unknown>");return $};e.$vP=M}),define(Se[78],Pe([1,0,16,2]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MAb=e.$LAb=e.$KAb=void 0,e.$NAb=R,e.$OAb=A,e.$KAb="vscode-cdn.net",e.$LAb=`vscode-resource.${e.$KAb}`,e.$MAb=`'self' https://*.${e.$KAb}`;function R($,m){return $.scheme===C.Schemas.http||$.scheme===C.Schemas.https?$:(m&&m.authority&&m.isRemote&&$.scheme===C.Schemas.file&&($=O.URI.from({scheme:C.Schemas.vscodeRemote,authority:m.authority,path:$.path})),O.URI.from({scheme:C.Schemas.https,authority:`${$.scheme}+${M($.authority)}.${e.$LAb}`,path:$.path,fragment:$.fragment,query:$.query}))}function M($){return $.replace(/./g,m=>{const E=m.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?m:"-"+E.toString(16).padStart(4,"0")})}function A($){return $.replace(/-([0-9a-f]{4})/g,(m,E)=>String.fromCharCode(parseInt(E,16)))}}),define(Se[232],Pe([1,0,5,6,78]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=void 0;class M{constructor($,m,E){this.d=$,this.e=m,this.f=E,this.a=0,this.b=new O.$Tc,this.c=new Map,this.b.add(m.onDidChangeVisibleTextEditors(()=>{const T=m.getVisibleTextEditors();for(const k of this.c.values())T.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,m,E,T,k){let l;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===$){l=i;break}if(!l)throw new Error("not a visible editor");const w=this,f=this.a++,s=new C.$de,r=new C.$de,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,R.$NAb)(i,w.f)}get cspSource(){return R.$MAb}set options(i){this.b=i,w.d.$setOptions(f,i)}get options(){return this.b}set html(i){this.a=i,w.d.$setHtml(f,i)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(i){return w.d.$postMessage(f,i)}},n=new class{constructor(){this.editor=$,this.line=m,this.height=E,this.webview=o,this.onDidDispose=r.event}dispose(){w.c.has(f)&&(w.c.delete(f),w.d.$disposeEditorInset(f),r.fire(),r.dispose(),s.dispose())}};return this.d.$createEditorInset(f,l.id,l.value.document.uri,m+1,E,T||{},k.identifier,k.extensionLocation),this.c.set(f,{editor:$,inset:n,onDidReceiveMessage:s}),n}$onDidDispose($){const m=this.c.get($);m&&m.inset.dispose()}$onDidReceiveMessage($,m){this.c.get($)?.onDidReceiveMessage.fire(m)}}e.$Ilc=M}),define(Se[108],Pe([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=e.$bM=e.$aM=void 0,e.$aM="__",e.$bM=(0,C.$wi)("IAuthenticationService"),e.$cM=(0,C.$wi)("IAuthenticationExtensionsService")}),define(Se[233],Pe([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=e.VariableKind=e.$nQ=void 0,e.$nQ=(0,C.$wi)("configurationResolverService");var O;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator",M.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class R extends Error{constructor(A,$){super($),this.variable=A}}e.$oQ=R}),define(Se[234],Pe([1,0,19,75,15,25,22,97,192,233,13]),function(le,e,C,O,R,M,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(w,f,s,r){this.h=new Map,this.a=w,this.b=f,this.g=s,r&&(this.c=r.then(o=>this.i(o)))}i(w){if(A.$i){const f=Object.create(null);return Object.keys(w).forEach(s=>{f[s.toLowerCase()]=w[s]}),f}return w}resolveWithEnvironment(w,f,s){return this.l({env:this.i(w),userHome:void 0},f?f.uri:void 0,s)}async resolveAsync(w,f){const s={env:await this.c,userHome:await this.g};return this.l(s,w?w.uri:void 0,f)}async j(w,f,s,r){const o=M.$3n(f);A.$i&&o.windows?Object.keys(o.windows).forEach(i=>o[i]=o.windows[i]):A.$j&&o.osx?Object.keys(o.osx).forEach(i=>o[i]=o.osx[i]):A.$k&&o.linux&&Object.keys(o.linux).forEach(i=>o[i]=o.linux[i]),delete o.windows,delete o.osx,delete o.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,w?w.uri:void 0,o,s,r)}async resolveAnyAsync(w,f,s){return this.j(w,f,s)}async resolveAnyMap(w,f,s){const r=new Map;return{newConfig:await this.j(w,f,s,r),resolvedVariables:r}}resolveWithInteractionReplace(w,f,s,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,f,s,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,f){if(this.h.has(w))throw new Error("Variable "+w+" is contributed twice.");this.h.set(w,f)}async l(w,f,s,r,o){if(R.$9f(s))return this.m(w,f,s,r,o);if(Array.isArray(s))return Promise.all(s.map(n=>this.l(w,f,n,r,o)));if(R.$$f(s)){const n=Object.create(null),i=await Promise.all(Object.keys(s).map(async c=>[await this.m(w,f,c,r,o),await this.l(w,f,s[c],r,o)]));for(const[c,u]of i)n[c]=u;return n}return s}m(w,f,s,r,o){return(0,T.$pf)(s,k.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(k.VARIABLE_LHS))return n;let c=await this.o(w,n,i,f,r);return o?.set(i,c),c!==n&&R.$9f(c)&&c.match(k.VARIABLE_REGEXP)&&(c=await this.m(w,f,c,r,o)),c})}n(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async o(w,f,s,r,o){let n;const i=s.split(":");i.length>1&&(s=i[0],n=i[1]);const c=d=>{const a=this.a.getFilePath();if(a)return(0,$.$Ew)(a);throw new E.$oQ(d,(0,m.localize)(0,null,f))},u=d=>{const a=c(d);if(this.a.getWorkspaceFolderPathForFile){const g=this.a.getWorkspaceFolderPathForFile();if(g)return(0,$.$Ew)(g)}throw new E.$oQ(d,(0,m.localize)(1,null,f,C.$nc(a)))},t=d=>{if(n){const a=this.a.getFolderUri(n);if(a)return a;throw new E.$oQ(d,(0,m.localize)(2,null,f,n))}if(r)return r;throw this.a.getWorkspaceFolderCount()>1?new E.$oQ(d,(0,m.localize)(3,null,f)):new E.$oQ(d,(0,m.localize)(4,null,f))};switch(s){case"env":if(n){if(w.env){const d=w.env[A.$i?n.toLowerCase():n];if(R.$9f(d))return d}return""}throw new E.$oQ(E.VariableKind.Env,(0,m.localize)(5,null,f));case"config":if(n){const d=this.a.getConfigurationValue(r,n);if(R.$fg(d))throw new E.$oQ(E.VariableKind.Config,(0,m.localize)(6,null,f,n));if(R.$$f(d))throw new E.$oQ(E.VariableKind.Config,(0,m.localize)(7,null,f,n));return d}throw new E.$oQ(E.VariableKind.Config,(0,m.localize)(8,null,f));case"command":return this.p(E.VariableKind.Command,f,n,o,"command");case"input":return this.p(E.VariableKind.Input,f,n,o,"input");case"extensionInstallFolder":if(n){const d=await this.a.getExtension(n);if(!d)throw new E.$oQ(E.VariableKind.ExtensionInstallFolder,(0,m.localize)(9,null,f,n));return this.n(d.extensionLocation)}throw new E.$oQ(E.VariableKind.ExtensionInstallFolder,(0,m.localize)(10,null,f));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,$.$Ew)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return r||n?(0,$.$Ew)(this.n(t(E.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$Ew)(C.$nc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new E.$oQ(E.VariableKind.UserHome,(0,m.localize)(11,null,f))}case"lineNumber":{const d=this.a.getLineNumber();if(d)return d;throw new E.$oQ(E.VariableKind.LineNumber,(0,m.localize)(12,null,f))}case"selectedText":{const d=this.a.getSelectedText();if(d)return d;throw new E.$oQ(E.VariableKind.SelectedText,(0,m.localize)(13,null,f))}case"file":return c(E.VariableKind.File);case"fileWorkspaceFolder":return u(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return C.$nc(u(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return r||n?C.$lc(this.n(t(E.VariableKind.RelativeFile)),c(E.VariableKind.RelativeFile)):c(E.VariableKind.RelativeFile);case"relativeFileDirname":{const d=C.$mc(c(E.VariableKind.RelativeFileDirname));if(r||n){const a=C.$lc(this.n(t(E.VariableKind.RelativeFileDirname)),d);return a.length===0?".":a}return d}case"fileDirname":return C.$mc(c(E.VariableKind.FileDirname));case"fileExtname":return C.$oc(c(E.VariableKind.FileExtname));case"fileBasename":return C.$nc(c(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=C.$nc(c(E.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-C.$oc(d).length)}case"fileDirnameBasename":return C.$nc(C.$mc(c(E.VariableKind.FileDirnameBasename)));case"execPath":{const d=this.a.getExecPath();return d||f}case"execInstallFolder":{const d=this.a.getAppRoot();return d||f}case"pathSeparator":case"/":return C.sep;default:try{const d=n?`${s}:${n}`:s;return this.p(E.VariableKind.Unknown,f,d,o,void 0)}catch{return f}}}}p(w,f,s,r,o){if(s&&r){const n=o===void 0?r[s]:r[o+":"+s];if(typeof n=="string")return n;throw new E.$oQ(w,(0,m.localize)(14,null,f))}return f}}e.$DQ=k}),define(Se[109],Pe([1,0,3,106]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$YD=void 0,e.$ZD=E,e.$1D=l,e.$2D=w,e.$YD=(0,C.$wi)("editorGroupsService");var R;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(R||(e.GroupDirection=R={}));var M;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var A;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var $;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EXPAND=1]="EXPAND",f[f.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var m;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function E(f){const s=f;return(0,O.$JF)(s?.editor)&&(0,O.$JF)(s?.replacement)}var T;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var k;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function l(f){const s=f;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}function w(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Se[235],Pe([1,0,3,109]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6D=e.$5D=e.$4D=e.$3D=void 0,e.$7D=R,e.$3D=(0,C.$wi)("editorService"),e.$4D=-1,e.$5D=-2,e.$6D=-3;function R(M){const A=M;return typeof M=="number"||(0,O.$1D)(A)}}),define(Se[236],Pe([1,0,3,99]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=void 0,e.$vM=(0,C.$xi)(O.$Di)}),define(Se[110],Pe([1,0,20,5,19,6,11]),function(le,e,C,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6_b=e.$5_b=e.$4_b=e.$3_b=e.$2_b=void 0;class ${constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$2_b=$;class m{static isHostExtension(n,i,c){if(i.getExtensionDescription(n))return!1;const u=c.getExtensionDescription(n);return u?!!((u.main||u.browser)&&u.api==="none"):!1}constructor(n,i){this.j=n,this.c=new O.$de,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(s),this.f=new C.$Tm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const c of i)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=r(this.e,i),this.e=this.e.concat(n);const c=m.l(this.e);return this.e=r(this.e,c.map(u=>u.identifier)),this.k(),this.d++,this.c.fire(void 0),new $(this.d,c)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,g){this.addNode(a),this.addNode(g),this.c.has(a)?this.c.get(a).push(g):this.c.set(a,[g])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,g){const b=i.getArcs(a);for(let p=0;p<b.length;p++)if(!g.has(b[p]))return!1;return!0}getNodes(){return this.e}},c=new C.$Tm;for(const a of n)if(c.set(a.identifier,a),a.extensionDependencies)for(const g of a.extensionDependencies)i.addArc(C.$Rm.toKey(a.identifier),C.$Rm.toKey(g));const u=new Set;i.getNodes().filter(a=>i.getArcs(a).length===0).forEach(a=>u.add(a));const t=i.getNodes().filter(a=>!u.has(a));let d;do{d=!1;for(let a=0;a<t.length;a++){const g=t[a];i.hasOnlyGoodArcs(g,u)&&(t.splice(a,1),a--,u.add(g),d=!0)}}while(d);return t.map(a=>c.get(a))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$3_b=m;class E{constructor(n,i){this.versionId=n,this.extensions=i}}e.$4_b=E;class T{constructor(n){this.d=new w,this.c=new m(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new k(this,i)}deltaExtensions(n,i,c){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,c)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$5_b=T;class k extends M.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$6_b=k;class l{constructor(n){this.name=n;const i=(0,A.$ph)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class w{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new l(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const c=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),u=()=>{i&&(clearTimeout(c),i=!1,this.d=!1,this.e())};n.resolve((0,M.$Sc)(u))}}var f;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(f||(f={}));function s(o,n){const i=o.isBuiltin?0:o.isUnderDevelopment?2:1,c=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==c)return i-c;const u=R.$gc.basename(o.extensionLocation.path),t=R.$gc.basename(n.extensionLocation.path);return u<t?-1:u>t?1:0}function r(o,n){const i=new C.$Sm(n);return o.filter(c=>!i.has(c.identifier))}}),define(Se[79],Pe([1,0,21]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Zm=A,e.$1m=$;var O;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(O||(e.UIKind=O={}));var R;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(R||(e.ExtensionHostExitCode=R={}));var M;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function A(E){const T=C.$Fe.alloc(1);switch(E){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}function $(E,T){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}var m;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(Se[63],Pe([1,0,3,5,12,27,79,58,59,25,2,6,179]),function(le,e,C,O,R,M,A,$,m,E,T,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TP=e.$RP=e.$QP=void 0,e.$SP=s;let w=class extends k.$Uc{constructor(o,n){super(),this.s=o,this.t=n,this.a=this.B(new O.$de),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$de),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=T.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:m.$kp,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,R.$5j)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,n,i){const c=this.getTelemetryDetails(),u=new f(n,i,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,u]),u.apiTelemetryLogger}$initializeTelemetryLevel(o,n,i){this.f=o,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const n=Object.create(null);switch(n["common.extname"]=`${o.publisher}.${o.name}`,n["common.extversion"]=o.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:n["common.uikind"]="web";break;case A.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$Im)((0,m.$qp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const n=this.getTelemetryDetails();this.r.forEach((i,c)=>{const u=i.filter(t=>!t.isDisposed);u.length===0?this.r.delete(c):this.r.set(c,u)}),this.r.forEach(i=>{for(const c of i)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,n){const c=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!c)return this.r.delete(o.value),!1;let u=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(n),u=!0);return u}};e.$QP=w,e.$QP=w=Je([We(0,M.$PP),We(1,R.$4j)],w);class f{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,n,i,c,u,t,d){this.g=i,this.h=c,this.i=u,this.j=t,this.a=new O.$de,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(o,n){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let n="properties"in o?o.properties??{}:o;return n=(0,m.$tp)(n,[]),this.c&&(n=(0,E.$6n)(n,this.c)),this.b||(n=(0,E.$6n)(n,this.j)),"properties"in o?o.properties=n:o=n,o}k(o,n){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(o,n),this.h.trace(o,n))}logUsage(o,n){this.d.isUsageEnabled&&this.k(o,n)}logError(o,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,n);else{const i={name:o.name,message:o.message,stack:o.stack,cause:o.cause},c=(0,m.$tp)(i,[]),u=new Error(c.message,{cause:c.cause});u.stack=c.stack,u.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(u,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const o=this,n={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$RP=f;function s(r){const o=Date.now()-new Date(r).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$TP=(0,C.$wi)("IExtHostTelemetry")}),define(Se[26],Pe([1,0,5,2,207,105,20,3]),function(le,e,C,O,R,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UG=e.ActivationKind=e.$RG=e.$QG=e.$NG=e.ExtensionHostStartup=e.$MG=e.$LG=e.$KG=e.$JG=void 0,e.$OG=l,e.$PG=w,e.$SG=o,e.$TG=n,e.$JG=Object.freeze({identifier:new A.$Rm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$KG="extensions.webWorker",e.$LG=(0,$.$wi)("extensionService");class m{constructor(u){this.dependency=u}}e.$MG=m;var E;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class T{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(u,t,d){this.c=u,this.d=t.slice(0),this.e=d.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$uG.createActivationEventsMap(this.d)}}set(u,t,d){if(this.c>u)throw new Error(`ExtensionHostExtensions: invalid versionId ${u} (current: ${this.c})`);const a=[],g=[],b=[],p=[],v=k(this.d),y=k(t),h=(W,V)=>W.extensionLocation.toString()===V.extensionLocation.toString()||W.isBuiltin===V.isBuiltin||W.isUserBuiltin===V.isUserBuiltin||W.isUnderDevelopment===V.isUnderDevelopment;for(const W of this.d){const V=y.get(W.identifier);if(!V){a.push(W.identifier),v.delete(W.identifier);continue}if(!h(W,V)){a.push(W.identifier),v.delete(W.identifier);continue}}for(const W of t){const V=v.get(W.identifier);if(!V){g.push(W);continue}if(!h(V,W)){a.push(V.identifier),v.delete(V.identifier);continue}}const D=new A.$Sm(this.e),S=new A.$Sm(d);for(const W of this.e)S.has(W)||b.push(W);for(const W of d)D.has(W)||p.push(W);const I=M.$uG.createActivationEventsMap(g),P={versionId:u,toRemove:a,toAdd:g,addActivationEvents:I,myToRemove:b,myToAdd:p};return this.delta(P),P}delta(u){if(this.c>=u.versionId)return null;const{toRemove:t,toAdd:d,myToRemove:a,myToAdd:g}=u,b=new A.$Sm(t),p=new A.$Sm(a);for(let v=0;v<this.d.length;v++)b.has(this.d[v].identifier)&&(this.d.splice(v,1),v--);for(let v=0;v<this.e.length;v++)p.has(this.e[v])&&(this.e.splice(v,1),v--);for(const v of d)this.d.push(v);for(const v of g)this.e.push(v);return this.f=null,u}containsExtension(u){for(const t of this.e)if(A.$Rm.equals(t,u))return!0;return!1}containsActivationEvent(u){return this.f||(this.f=this.g()),this.f.has(u)}g(){const u=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const d=M.$uG.readActivationEvents(t);for(const a of d)u.add(a)}return u}}e.$NG=T;function k(c){const u=new A.$Tm;for(const t of c)u.set(t.identifier,t);return u}function l(c,u){return c.enabledApiProposals?c.enabledApiProposals.includes(u):!1}function w(c,u){if(!l(c,u))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class f{constructor(u,t,d,a){this.codeLoadingTime=u,this.activateCallTime=t,this.activateResolvedTime=d,this.activationReason=a}}e.$QG=f;class s{constructor(u,t){this.description=u,this.value=t}}e.$RG=s;var r;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(r||(e.ActivationKind=r={}));function o(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,R.$zp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function n(c,u){return{identifier:new A.$Rm((0,R.$xp)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!u,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,publisherDisplayName:c.publisherDisplayName}}class i{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activateById(u,t){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(u,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$UG=i}),define(Se[237],Pe([1,0,14,110,20,26,12,11]),function(le,e,C,O,R,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=e.$9lc=e.$8lc=e.$7lc=e.$6lc=e.$5lc=void 0;class m{static{this.NONE=new m(!1,-1,-1,-1)}constructor(o,n,i,c){this.startup=o,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=c}}e.$5lc=m;class E{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,n){return o===-1||n===-1?-1:n-o}build(){return new m(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$6lc=E;class T{constructor(o,n,i,c,u,t){this.activationFailed=o,this.activationFailedError=n,this.activationTimes=i,this.module=c,this.exports=u,this.subscriptions=t}}e.$7lc=T;class k extends T{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$8lc=k;class l extends T{constructor(){super(!1,null,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$9lc=l;class w extends T{constructor(o){super(!0,o,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(o,n,i,c){this.g=c,this.a=o,this.b=n,this.c=i,this.d=new R.$Tm,this.f=Object.create(null)}dispose(){for(const[o,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const o=[];for(const[n,i]of this.d)o.push(i.wait());await Promise.all(o)}isActivated(o){const n=this.d.get(o);return!!(n&&n.value)}getActivatedExtension(o){const n=this.d.get(o);if(!n||!n.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return n.value}async activateByEvent(o,n){if(this.f[o])return;const i=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(i.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,n){const i=this.a.getExtensionDescription(o);if(!i)throw new Error(`Extension '${o.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(o){const n=o.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const n=this.a.getExtensionDescription(o.id);if(!n){const u=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new w(u));return this.c.onExtensionActivationError(o.id,u,new M.$MG(o.id.value)),t}const i=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const u of c){if(this.m(u))continue;const t=this.d.get(u);if(t){i.push(t);continue}if(this.l(u)){i.push(this.j({id:this.b.getExtensionDescription(u).identifier,reason:o.reason}));continue}const d=this.a.getExtensionDescription(u);if(d){if(!d.main&&!d.browser)continue;i.push(this.j({id:d.identifier,reason:o.reason}));continue}const a=n.displayName||n.identifier.value,g=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${u}'`),b=this.k(o,n.displayName,[],new w(g));return this.c.onExtensionActivationError(n.identifier,g,new M.$MG(u)),b}return this.k(o,n.displayName,i,null)}k(o,n,i,c){const u=new s(o.id,n,o.reason,i,c,this.c,this.g);return this.d.set(o.id,u),u}l(o){return O.$3_b.isHostExtension(o,this.a,this.b)}m(o){const n=this.b.getExtensionDescription(o);return n?!n.main&&!n.browser:!1}};e.$0lc=f,e.$0lc=f=Je([We(3,A.$3j)],f);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,n,i,c,u,t,d){this.c=o,this.d=n,this.f=i,this.g=c,this.h=u,this.j=t,this.k=d,this.a=new $.$vh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const n=this.g[o];if(n.value&&!n.value.activationFailed){this.g.splice(o,1),o--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new w(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const n=new Error;if(o&&o.name&&(n.name=o.name),o&&o.message?n.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(n.stack=o.stack),this.h=new w(n),this.b&&C.$4(o))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};s=Je([We(6,A.$3j)],s)}),define(Se[238],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testPreserveFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testPreserveFocus.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[239],Pe([1,0,194,14,33,100,74,29,20,238,102,105]),function(le,e,C,O,R,M,A,$,m,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=void 0;const l=$.$co.as(A.$do.JSONContribution);class w{constructor(u,t,d){this.a=u,this.b=t,this.c=d}d(u,t){this.a({type:u,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(u){this.d(R.default.Error,u)}warn(u){this.d(R.default.Warning,u)}info(u){this.d(R.default.Info,u)}}e.$DG=w;class f{static a(u){const t=new m.$Sm;for(let d=0,a=u.length;d<a;d++)t.add(u[d].description.identifier);return t}static compute(u,t){if(!u||!u.length)return new f(t,[]);if(!t||!t.length)return new f([],u);const d=this.a(u),a=this.a(t),g=t.filter(p=>!d.has(p.description.identifier)),b=u.filter(p=>!a.has(p.description.identifier));return new f(g,b)}constructor(u,t){this.added=u,this.removed=t}}e.$EG=f;class s{constructor(u,t){this.name=u,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(u){if(this.a!==null)throw new Error("Handler already set!");this.a=u,this.d()}acceptUsers(u){this.c=f.compute(this.b,u),this.b=u,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(u){(0,O.$1)(u)}}}e.$FG=s;const r={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$GG={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.$Qm},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:C.localize(42,null)},{label:"*",description:C.localize(43,null),body:"*"}]}},badges:{type:"array",description:C.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(45,null)},href:{type:"string",description:C.localize(46,null)},description:{type:"string",description:C.localize(47,null)}}}},markdown:{type:"string",description:C.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$To}},extensionPack:{description:C.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$To}},extensionKind:{description:C.localize(52,null),type:"array",items:r,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(53,null)},{body:["workspace"],description:C.localize(54,null)},{body:["ui","workspace"],description:C.localize(55,null)},{body:["workspace","ui"],description:C.localize(56,null)},{body:[],description:C.localize(57,null)}]},capabilities:{description:C.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(61,null),C.localize(62,null),C.localize(63,null)]},description:{type:"string",markdownDescription:C.localize(64,null)}}},untrustedWorkspaces:{description:C.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(67,null),C.localize(68,null),C.localize(69,null)]},restrictedConfigurations:{description:C.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(71,null)}}}}},sponsor:{description:C.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(74,null),type:"string"},"vscode:uninstall":{description:C.localize(75,null),type:"string"}}},icon:{type:"string",description:C.localize(76,null)},l10n:{type:"string",description:C.localize(77,null)},pricing:{type:"string",markdownDescription:C.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(u){if(this.a.has(u.extensionPoint))throw new Error("Duplicate extension point: "+u.extensionPoint);const t=new s(u.extensionPoint,u.defaultExtensionKind);return this.a.set(u.extensionPoint,t),u.activationEventsGenerator&&k.$uG.register(u.extensionPoint,u.activationEventsGenerator),e.$GG.properties.contributes.properties[u.extensionPoint]=u.jsonSchema,l.registerSchema(o,e.$GG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$HG=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};$.$co.add(i.ExtensionsRegistry,new n),e.$IG=$.$co.as(i.ExtensionsRegistry),l.registerSchema(o,e.$GG),l.registerSchema(T.$kk,{properties:{extensionEnabledApiProposals:{description:C.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Se[240],Pe([1,0,190,15,25,239,31,5]),function(le,e,C,O,R,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cI=void 0;const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var E;(function(l){function w(f,s,r){if(!f)return;const o=O.$9f(f.type)?f.type:void 0;if(!o||o.length===0){r.error(C.localize(3,null));return}const n=[];if(Array.isArray(f.required))for(const i of f.required)O.$9f(i)&&n.push(i);return{extensionId:s.value,taskType:o,required:n,properties:f.properties?R.$3n(f.properties):{},when:f.when?A.$uj.deserialize(f.when):void 0}}l.from=w})(E||(E={}));const T=M.$IG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,w)=>{for(const f of l)f.type&&w.push(`onTaskType:${f.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:m}});class k{constructor(){this.d=new $.$de,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((w,f)=>{T.setHandler((s,r)=>{this.c=void 0;try{for(const o of r.removed){const n=o.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const o of r.added){const n=o.value;for(const i of n){const c=E.from(i,o.description.identifier,o.collector);c&&(this.a[c.taskType]=c)}}(r.removed.length>0||r.added.length>0)&&this.d.fire()}catch{}w(void 0)})})}onReady(){return this.b}get(w){return this.a[w]}all(){return Object.keys(this.a).map(w=>this.a[w])}getJsonSchema(){if(this.c===void 0){const w=[];for(const f of this.all()){const s={type:"object",additionalProperties:!1};f.required.length>0&&(s.required=f.required.slice(0)),f.properties!==void 0?s.properties=R.$3n(f.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[f.taskType]},w.push(s)}this.c={oneOf:w}}return this.c}}e.$cI=new k}),define(Se[241],Pe([1,0,191,15,23,25,31,240]),function(le,e,C,O,R,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$mI=e.JsonSchemaVersion=e.ExecutionEngine=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$gI=e.ShellQuoting=e.$fI=e.$eI=e.$dI=void 0,e.$dI="settings",e.$eI=new A.$Nj("taskRunning",!1,C.localize(0,null)),e.$fI=C.localize2(2,"Tasks");var m;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(m||(e.ShellQuoting=m={})),e.$gI="$customized",function(N){function B(K){if(!K)return N.Strong;switch(K.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=B}(m||(e.ShellQuoting=m={}));var E;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var T;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(T||(e.RevealKind=T={})),function(N){function B(K){switch(K.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=B}(T||(e.RevealKind=T={}));var k;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(N){function B(K){switch(K.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=B}(k||(e.RevealProblemKind=k={}));var l;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(l||(e.PanelKind=l={})),function(N){function B(K){switch(K.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=B}(l||(e.PanelKind=l={}));var w;(function(N){N.defaults={echo:!0,reveal:T.Always,revealProblems:k.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var f;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(f||(e.RuntimeType=f={})),function(N){function B(ie){switch(ie.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=B;function K(ie){switch(ie){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=K}(f||(e.RuntimeType=f={}));var s;(function(N){function B(K){return O.$9f(K)?K:K.value}N.value=B})(s||(e.CommandString=s={}));var r;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function B(ie){return ie===N.Clean._id||ie===N.Build._id||ie===N.Rebuild._id||ie===N.Test._id}N.is=B;function K(ie){if(ie!==void 0)return O.$9f(ie)?B(ie)?{_id:ie,isDefault:!1}:void 0:ie}N.from=K})(r||(e.TaskGroup=r={}));var o;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var n;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function B(K){switch(K){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=B})(n||(e.TaskSourceKind=n={}));var i;(function(N){N.parallel="parallel",N.sequence="sequence"})(i||(e.DependsOrder=i={}));var c;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var u;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(u||(e.RunOptions=u={}));class t{constructor(B,K,ie,ce,ye,ke){this._label="",this._id=B,K&&(this._label=K),ie&&(this.type=ie),this.runOptions=ce,this.configurationProperties=ye,this._source=ke}getDefinition(B){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,K=!1){if(B===void 0)return!1;if(O.$9f(B))return B===this._label||B===this.configurationProperties.identifier||K&&B===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.$hI=t;class d extends t{constructor(B,K,ie,ce,ye,ke,fe,$e){super(B,ie,void 0,fe,$e,K),this.command={},this._source=K,this.hasDefinedMatchers=ke,ye&&(this.command=ye)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case f.Shell:K="shell";break;case f.Process:K="process";break;case f.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(B){return B instanceof d}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$dI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const B=this.d();if(!B)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const ie={type:e.$gI,folder:B,id:K};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$7g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new d(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$iI=d;class a extends t{constructor(B,K,ie,ce,ye,ke,fe){super(B,ie,ce,ke,fe,K),this._source=K,this.configures=ye}static is(B){return B instanceof a}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$7g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$dI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const B=this.d();if(!B)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const ie={type:e.$gI,folder:B,id:K};return JSON.stringify(ie)}}e.$jI=a;class g extends t{constructor(B,K,ie,ce,ye,ke,fe,$e,Te){super(B,ie,ce,$e,Te,K),this.defines=ye,this.hasDefinedMatchers=fe,this.command=ke,this.icon=Te.icon,this.hide=Te.hide}clone(){return new g(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof g}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new g(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$kI=g;class b extends t{constructor(B,K,ie,ce,ye,ke){super(B,ie,ce,ye,ke,K),this._source=K}clone(){return new b(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof b}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new b(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.$lI=b;var p;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(p||(e.ExecutionEngine=p={})),function(N){N._default=N.Terminal}(p||(e.ExecutionEngine=p={}));var v;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(v||(e.JsonSchemaVersion=v={}));class y{constructor(B){this.c=new Map;for(let K=0;K<B.length;K++)this.c.set(B[K].uri.toString(),K)}compare(B,K){const ie=B.getWorkspaceFolder(),ce=K.getWorkspaceFolder();if(ie&&ce){let ye=this.c.get(ie.uri.toString());ye=ye===void 0?0:ye+1;let ke=this.c.get(ce.uri.toString());return ke=ke===void 0?0:ke+1,ye===ke?B._label.localeCompare(K._label):ye-ke}else return!ie&&ce?-1:ie&&!ce?1:0}}e.$mI=y;var h;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(h||(e.TaskEventKind=h={}));var D;(function(N){N.SingleRun="singleRun",N.Background="background"})(D||(e.TaskRunType=D={}));var S;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(S||(e.TaskRunSource=S={}));var I;(function(N){function B($e){return{taskId:$e._id,taskName:$e.configurationProperties.name,runType:$e.configurationProperties.isBackground?"background":"singleRun",group:$e.configurationProperties.group,__task:$e}}function K($e,Te,ae){return{...B($e),kind:"start",terminalId:Te,resolvedVariables:ae}}N.start=K;function ie($e,Te,ae){return{...B($e),kind:"processStarted",terminalId:Te,processId:ae}}N.processStarted=ie;function ce($e,Te,ae){return{...B($e),kind:"processEnded",terminalId:Te,exitCode:ae}}N.processEnded=ce;function ye($e,Te,ae){return{...B($e),kind:"terminated",exitReason:ae,terminalId:Te}}N.terminated=ye;function ke($e,Te,ae){return{...B(Te),kind:$e,terminalId:ae}}N.general=ke;function fe(){return{kind:"changed"}}N.changed=fe})(I||(e.TaskEvent=I={}));var P;(function(N){function B(ie){const ce=Object.keys(ie).sort();let ye="";for(const ke of ce){let fe=ie[ke];fe instanceof Object?fe=B(fe):typeof fe=="string"&&(fe=fe.replace(/,/g,",,")),ye+=ke+","+fe+","}return ye}function K(ie){const ye={_key:B(ie),type:ie.taskType};return Object.assign(ye,ie),ye}N.create=K})(P||(e.KeyedTaskIdentifier=P={}));var W;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(W||(e.TaskSettingId=W={}));var V;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var q;(function(N){function B(K,ie){const ce=$.$cI.get(K.type);if(ce===void 0){const $e=M.$3n(K);return delete $e._key,P.create($e)}const ye=Object.create(null);ye.type=ce.taskType;const ke=new Set;ce.required.forEach($e=>ke.add($e));const fe=ce.properties;for(const $e of Object.keys(fe)){const Te=K[$e];if(Te!=null)ye[$e]=Te;else if(ke.has($e)){const ae=fe[$e];if(ae.default!==void 0)ye[$e]=M.$3n(ae.default);else switch(ae.type){case"boolean":ye[$e]=!1;break;case"number":case"integer":ye[$e]=0;break;case"string":ye[$e]="";break;default:ie.error(C.localize(1,null,JSON.stringify(K,void 0,0),$e));return}}}return P.create(ye)}N.createTaskIdentifier=B})(q||(e.TaskDefinition=q={}))}),define(Se[242],Pe([1,0,14]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8_b=e.$7_b=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,$)=>{this.b=A,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,C.$1)(A))}then(A,$){return this.j().then(A,$)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$7_b=O;class R extends O{constructor(){super(),this.h=!0,this.i=new C.$5}}e.$8_b=R}),define(Se[35],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bw=e.$yw=void 0,e.$zw=R,e.$Aw=M;class C{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++C.count}}e.$yw=C;const O=[];function R($){const m=new C($);return O[m.nid]=m,m}function M($){return O[$].sid}class A{constructor(m){this.value=m}}e.$Bw=A}),define(Se[4],Pe([1,0,35]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=e.$$M=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$0M=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var R;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput",s[s.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(R||(e.TabInputKind=R={}));var M;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var A;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var $;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var m;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var E;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var T;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output",s[s.Hybrid=3]="Hybrid"})(T||(e.CandidatePortSource=T={}));class k{static{this.a=0}static mixin(r){return r._id=k.a++,r}}e.$0M=k;var l;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var w;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var f;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(f||(e.ExtHostTestingResource=f={})),e.$$M={MainThreadAuthentication:(0,C.$zw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.$zw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,C.$zw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,C.$zw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,C.$zw)("MainThreadChatVariables"),MainThreadClipboard:(0,C.$zw)("MainThreadClipboard"),MainThreadCommands:(0,C.$zw)("MainThreadCommands"),MainThreadComments:(0,C.$zw)("MainThreadComments"),MainThreadConfiguration:(0,C.$zw)("MainThreadConfiguration"),MainThreadConsole:(0,C.$zw)("MainThreadConsole"),MainThreadDebugService:(0,C.$zw)("MainThreadDebugService"),MainThreadDecorations:(0,C.$zw)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.$zw)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.$zw)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.$zw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.$zw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.$zw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.$zw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.$zw)("MainThreadEditorTabs"),MainThreadErrors:(0,C.$zw)("MainThreadErrors"),MainThreadTreeViews:(0,C.$zw)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.$zw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,C.$zw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.$zw)("MainThreadLanguages"),MainThreadLogger:(0,C.$zw)("MainThreadLogger"),MainThreadMessageService:(0,C.$zw)("MainThreadMessageService"),MainThreadOutputService:(0,C.$zw)("MainThreadOutputService"),MainThreadProgress:(0,C.$zw)("MainThreadProgress"),MainThreadQuickDiff:(0,C.$zw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.$zw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.$zw)("MainThreadStatusBar"),MainThreadSecretState:(0,C.$zw)("MainThreadSecretState"),MainThreadStorage:(0,C.$zw)("MainThreadStorage"),MainThreadSpeech:(0,C.$zw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,C.$zw)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.$zw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,C.$zw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,C.$zw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.$zw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.$zw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.$zw)("MainThreadCustomEditors"),MainThreadUrls:(0,C.$zw)("MainThreadUrls"),MainThreadUriOpeners:(0,C.$zw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.$zw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.$zw)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.$zw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,C.$zw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,C.$zw)("MainThreadExtensionService"),MainThreadSCM:(0,C.$zw)("MainThreadSCM"),MainThreadSearch:(0,C.$zw)("MainThreadSearch"),MainThreadShare:(0,C.$zw)("MainThreadShare"),MainThreadTask:(0,C.$zw)("MainThreadTask"),MainThreadWindow:(0,C.$zw)("MainThreadWindow"),MainThreadLabelService:(0,C.$zw)("MainThreadLabelService"),MainThreadNotebook:(0,C.$zw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.$zw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.$zw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.$zw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.$zw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.$zw)("MainThreadInteractive"),MainThreadInlineChat:(0,C.$zw)("MainThreadInlineChatShape"),MainThreadTheming:(0,C.$zw)("MainThreadTheming"),MainThreadTunnelService:(0,C.$zw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.$zw)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.$zw)("MainThreadTimeline"),MainThreadTesting:(0,C.$zw)("MainThreadTesting"),MainThreadLocalization:(0,C.$zw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.$zw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.$zw)("MainThreadAiEmbeddingVector")},e.$_M={ExtHostCommands:(0,C.$zw)("ExtHostCommands"),ExtHostConfiguration:(0,C.$zw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.$zw)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.$zw)("ExtHostDebugService"),ExtHostDecorations:(0,C.$zw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.$zw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.$zw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.$zw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.$zw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.$zw)("ExtHostEditors"),ExtHostTreeViews:(0,C.$zw)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.$zw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.$zw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.$zw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.$zw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.$zw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.$zw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.$zw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.$zw)("ExtHostStatusBar"),ExtHostShare:(0,C.$zw)("ExtHostShare"),ExtHostExtensionService:(0,C.$zw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.$zw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.$zw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,C.$zw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,C.$zw)("ExtHostSCM"),ExtHostSearch:(0,C.$zw)("ExtHostSearch"),ExtHostTask:(0,C.$zw)("ExtHostTask"),ExtHostWorkspace:(0,C.$zw)("ExtHostWorkspace"),ExtHostWindow:(0,C.$zw)("ExtHostWindow"),ExtHostWebviews:(0,C.$zw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.$zw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.$zw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.$zw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.$zw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.$zw)("ExtHostEditorTabs"),ExtHostProgress:(0,C.$zw)("ExtHostProgress"),ExtHostComments:(0,C.$zw)("ExtHostComments"),ExtHostSecretState:(0,C.$zw)("ExtHostSecretState"),ExtHostStorage:(0,C.$zw)("ExtHostStorage"),ExtHostUrls:(0,C.$zw)("ExtHostUrls"),ExtHostUriOpeners:(0,C.$zw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.$zw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.$zw)("ExtHostOutputService"),ExtHostLabelService:(0,C.$zw)("ExtHostLabelService"),ExtHostNotebook:(0,C.$zw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.$zw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.$zw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.$zw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.$zw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.$zw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.$zw)("ExtHostInteractive"),ExtHostInlineChat:(0,C.$zw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,C.$zw)("ExtHostChatAgents"),ExtHostChatVariables:(0,C.$zw)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.$zw)("ExtHostChatProvider"),ExtHostSpeech:(0,C.$zw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,C.$zw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.$zw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.$zw)("ExtHostTheming"),ExtHostTunnelService:(0,C.$zw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.$zw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.$zw)("ExtHostAuthentication"),ExtHostTimeline:(0,C.$zw)("ExtHostTimeline"),ExtHostTesting:(0,C.$zw)("ExtHostTesting"),ExtHostTelemetry:(0,C.$zw)("ExtHostTelemetry"),ExtHostLocalization:(0,C.$zw)("ExtHostLocalization")}}),define(Se[80],Pe([1,0,3,12,4,17]),function(le,e,C,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=e.$slc=e.$rlc=void 0,e.$rlc=(0,C.$wi)("IExtHostApiDeprecationService");let A=class{constructor(m,E){this.c=E,this.a=new Set,this.b=m.getProxy(R.$$M.MainThreadTelemetry)}report(m,E,T){const k=this.d(m,E);this.a.has(k)||(this.a.add(k),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${m}' is deprecated. ${T}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:m}))}d(m,E){return`${m}-${E.identifier.value}`}};e.$slc=A,e.$slc=A=Je([We(0,M.$zP),We(1,O.$3j)],A),e.$tlc=Object.freeze(new class{report($,m,E){}})}),define(Se[243],Pe([1,0,4]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=void 0;class O{constructor(M){const A=M.getProxy(C.$$M.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText($){return A.$writeText($)}})}}e.$Glc=O}),define(Se[244],Pe([1,0,25,4,27,17]),function(le,e,C,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Anc=void 0;let A=class{constructor(T,k){this.a=T.getProxy(O.$$M.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(T,k){const l=this,w=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){l.e(T,k,w,arguments)}})}e(T,k,l,w){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:m(w,this.b)}),this.c&&this.f(T,l,w)}};e.$Anc=A,e.$Anc=A=Je([We(0,M.$zP),We(1,R.$PP)],A);const $=1e5;function m(E,T){const k=[];if(E.length)for(let l=0;l<E.length;l++){let w=E[l];if(typeof w>"u")w="undefined";else if(w instanceof Error){const f=w;f.stack?w=f.stack:w=f.toString()}k.push(w)}if(T){const l=new Error().stack;l&&k.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,C.$8n)(k);return l.length>$?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Se[245],Pe([1,0,2,4,26]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dmc=void 0;class M{constructor($){this.a=$.getProxy(O.$$M.MainThreadDialogs)}showOpenDialog($,m){return m?.allowUIResources&&(0,R.$PG)($,"showLocal"),this.a.$showOpenDialog(m).then(E=>E?E.map(T=>C.URI.revive(T)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(m=>m?C.URI.revive(m):void 0)}}e.$Dmc=M}),define(Se[246],Pe([1,0,6,4]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=void 0;class R{constructor(A){this.b=0,this.a=A.getProxy(O.$$M.MainThreadLabelService)}$registerResourceLabelFormatter(A){const $=this.b++;return this.a.$registerResourceLabelFormatter($,A),(0,C.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$Xmc=R}),define(Se[81],Pe([1,0,22,13,2,3,12,4,27,17]),function(le,e,C,O,R,M,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=e.$lmc=void 0;let T=class{constructor(l,w,f){this.f=f,this.d=new Map,this.a=w.getProxy($.$$M.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===C.$g}getMessage(l,w){const{message:f,args:s,comment:r}=w;if(this.c)return(0,O.$9e)(f,s??{});let o=f;r&&r.length>0&&(o+=`/${Array.isArray(r)?r.join(""):r}`);const n=this.d.get(l)?.contents[o];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,O.$9e)(n??f,s??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let w;const f=await this.g(l);if(!f){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(f),r=JSON.parse(s);w=l.isBuiltin?r.contents?.bundle:r}catch(s){this.f.error(`Failed to load translations for ${l.identifier.value} from ${f}: ${s.message}`);return}w&&this.d.set(l.identifier.value,{contents:w,uri:f})}async g(l){if(l.isBuiltin){const w=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return R.URI.revive(w)}return l.l10n?R.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$lmc=T,e.$lmc=T=Je([We(0,m.$PP),We(1,E.$zP),We(2,A.$3j)],T),e.$mmc=(0,M.$wi)("IExtHostLocalizationService")}),define(Se[247],Pe([1,0,12,4,27,17,2,49]),function(le,e,C,O,R,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$znc=void 0;let m=class extends C.$bk{constructor(k,l){super(l.logLevel,l.logsLocation,l.loggers.map(w=>(0,$.$6h)(w))),this.r=k.getProxy(O.$$M.MainThreadLogger)}$setLogLevel(k,l){l?this.setLogLevel(A.URI.revive(l),k):this.setLogLevel(k)}setVisibility(k,l){super.setVisibility(k,l),this.r.$setVisibility(k,l)}s(k,l,w){return new E(this.r,k,l,w)}};e.$znc=m,e.$znc=m=Je([We(0,M.$zP),We(1,R.$PP)],m);class E extends C.$9j{constructor(k,l,w,f){super(f?.logLevel==="always"),this.r=k,this.s=l,this.m=!1,this.n=[],this.setLevel(w),this.r.$createLogger(l,f).then(()=>{this.u(this.n),this.m=!0})}g(k,l){const w=[[k,l]];this.m?this.u(w):this.n.push(...w)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Se[82],Pe([1,0,4,3,6,17,21]),function(le,e,C,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$omc=e.$nmc=void 0,e.$nmc=(0,O.$wi)("IExtHostManagedSockets");let $=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(C.$$M.MainThreadManagedSockets)}setFactory(k,l){for(const w of this.d.values())w.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new m(k,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const l=++this.b,w=await this.c.makeConnection(),f=new R.$Tc;return this.d.set(l,new E(l,w,f)),f.add((0,R.$Sc)(()=>this.d.delete(l))),f.add(w.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),f.dispose()})),f.add(w.onDidClose(s=>{this.a.$onDidManagedSocketClose(l,s?.stack??s?.message),f.dispose()})),f.add(w.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(l,A.$Fe.wrap(s)))),l}$remoteSocketWrite(k,l){this.d.get(k)?.actual.send(l.buffer)}$remoteSocketEnd(k){const l=this.d.get(k);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$omc=$,e.$omc=$=Je([We(0,M.$zP)],$);class m{constructor(k,l){this.socketFactoryId=k,this.makeConnection=l}}class E extends R.$Uc{constructor(k,l,w){super(),this.socketId=k,this.actual=l,this.B(w)}}}),define(Se[248],Pe([1,0,4,12,26]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=void 0;function M($){return $&&$.title}let A=class{constructor(m,E){this.b=E,this.a=m.getProxy(C.$$M.MainThreadMessageService)}showMessage(m,E,T,k,l){const w={source:{identifier:m.identifier,label:m.displayName||m.name}};let f;typeof k=="string"||M(k)?f=[k,...l]:(w.modal=k?.modal,w.useCustom=k?.useCustom,w.detail=k?.detail,f=l),w.useCustom&&(0,R.$PG)(m,"resolvers");const s=[];let r=!1;for(let o=0;o<f.length;o++){const n=f[o];if(typeof n=="string")s.push({title:n,handle:o,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:c}=n;s.push({title:i,isCloseAffordance:!!c,handle:o}),c&&(r?this.b.warn(`[${m.identifier}] Only one message item can have 'isCloseAffordance':`,n):r=!0)}else this.b.warn(`[${m.identifier}] Invalid message item:`,n)}return this.a.$showMessage(E,T,w,s).then(o=>{if(typeof o=="number")return f[o]})}};e.$Zmc=A,e.$Zmc=A=Je([We(1,O.$3j)],A)}),define(Se[249],Pe([1,0,6,15,2,26,4]),function(le,e,C,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9mc=void 0;class ${constructor(E){this.b=new Map,this.a=E.getProxy(A.$$M.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,T,k){if((0,M.$PG)(E,"profileContentHandlers"),this.b.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.b.set(T,k),this.a.$registerProfileContentHandler(T,k.name,k.description,E.identifier.value),(0,C.$Sc)(()=>{this.b.delete(T),this.a.$unregisterProfileContentHandler(T)})}async $saveProfile(E,T,k,l){const w=this.b.get(E);if(!w)throw new Error(`Unknown handler with id: ${E}`);return w.saveProfile(T,k,l)}async $readProfile(E,T,k){const l=this.b.get(E);if(!l)throw new Error(`Unknown handler with id: ${E}`);return l.readProfile((0,O.$9f)(T)?T:R.URI.revive(T),k)}}e.$9mc=$}),define(Se[83],Pe([1,0,4,5,3]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=e.$imc=void 0;class M{constructor($){this.b=new O.$de,this.onDidChangePassword=this.b.event,this.a=$.getProxy(C.$$M.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,m){return this.a.$getPassword($,m)}store($,m,E){return this.a.$setPassword($,m,E)}delete($,m){return this.a.$deletePassword($,m)}}e.$imc=M,e.$jmc=(0,R.$wi)("IExtHostSecretState")}),define(Se[250],Pe([1,0,24,6,4]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dnc=void 0;class M{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.f=new Map,this.b=$.getProxy(R.$$M.MainThreadSpeech)}async $createSpeechToTextSession($,m,E){const T=this.c.get($);if(!T)return;const k=new O.$Tc,l=new C.$oe;this.d.set(m,l);const w=k.add(T.provideSpeechToTextSession(l.token,E?{language:E}:void 0));k.add(w.onDidChange(f=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(m,f)})),k.add(l.token.onCancellationRequested(()=>k.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}async $createTextToSpeechSession($,m){const E=this.c.get($);if(!E)return;const T=new O.$Tc,k=new C.$oe;this.d.set(m,k);const l=T.add(E.provideTextToSpeechSession(k.token));this.f.set(m,l),T.add(l.onDidChange(w=>{k.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(m,w)})),T.add(k.token.onCancellationRequested(()=>T.dispose()))}async $synthesizeSpeech($,m){const E=this.f.get($);E&&E.synthesize(m)}async $cancelTextToSpeechSession($){this.d.get($)?.dispose(!0),this.d.delete($),this.f.delete($)}async $createKeywordRecognitionSession($,m){const E=this.c.get($);if(!E)return;const T=new O.$Tc,k=new C.$oe;this.d.set(m,k);const l=T.add(E.provideKeywordRecognitionSession(k.token));T.add(l.onDidChange(w=>{k.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(m,w)})),T.add(k.token.onCancellationRequested(()=>T.dispose()))}async $cancelKeywordRecognitionSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,m,E){const T=M.a++;return this.c.set(T,E),this.b.$registerProvider(T,m,{extension:$,displayName:$.value}),(0,O.$Sc)(()=>{this.b.$unregisterProvider(T),this.c.delete(T)})}}e.$dnc=M}),define(Se[84],Pe([1,0,4,5,3]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=e.$$lc=void 0;class M{constructor($,m){this.c=m,this.b=new O.$de,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(C.$$M.MainThreadStorage)}registerExtensionStorageKeysToSync($,m){this.a.$registerExtensionStorageKeysToSync($,m)}async initializeExtensionStorage($,m,E){const T=await this.a.$initializeExtensionStorage($,m);let k;return T&&(k=this.d($,m,T)),k||E}setValue($,m,E){return this.a.$setValue($,m,E)}$acceptValue($,m,E){const T=this.d($,m,E);T&&this.b.fire({shared:$,key:m,value:T})}d($,m,E){try{return JSON.parse(E)}catch(T){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${$}): ${T}`)}}}e.$$lc=M,e.$_lc=(0,R.$wi)("IExtHostStorage")}),define(Se[251],Pe([1,0,6,16,2,4]),function(le,e,C,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tnc=void 0;class A{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor(m){this.c=new Map,this.b=m.getProxy(M.$$M.MainThreadUriOpeners)}registerExternalUriOpener(m,E,T,k){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const l=k.schemes.find(w=>!A.a.has(w));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(E,T),this.b.$registerUriOpener(E,k.schemes,m,k.label),(0,C.$Sc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(m,E,T){const k=this.c.get(m);if(!k)throw new Error(`Unknown opener with id: ${m}`);const l=R.URI.revive(E);return k.canOpenExternalUri(l,T)}async $openUri(m,E,T){const k=this.c.get(m);if(!k)throw new Error(`Unknown opener id: '${m}'`);return k.openExternalUri(R.URI.revive(E.resolvedUri),{sourceUri:R.URI.revive(E.sourceUri)},T)}}e.$tnc=A}),define(Se[252],Pe([1,0,4,2,6,14,20]),function(le,e,C,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=void 0;class ${static{this.a=0}constructor(E){this.c=new A.$Sm,this.d=new Map,this.b=E.getProxy(C.$$M.MainThreadUrls)}registerUriHandler(E,T){const k=E.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const l=$.a++;return this.c.add(k),this.d.set(l,T),this.b.$registerUriHandler(l,k,E.displayName||E.name),(0,R.$Sc)(()=>{this.c.delete(k),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(E,T){const k=this.d.get(E);if(!k)return Promise.resolve(void 0);try{k.handleUri(O.URI.revive(T))}catch(l){(0,M.$1)(l)}return Promise.resolve(void 0)}async createAppUri(E){return O.URI.revive(await this.b.$createAppUri(E))}}e.$unc=$}),define(Se[64],Pe([1,0,5,6,16,25,2,197,221,78,4]),function(le,e,C,O,R,M,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=e.$Vlc=void 0,e.$Wlc=l,e.$Ylc=s,e.$Zlc=r;class k{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,u,t,d,a,g,b){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new C.$de,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new C.$de,this._onDidDispose=this.#h.event,this.#e=c,this.#t=u,this.#o=t,this.#n=d,this.#s=a,this.#r=g,this.#l=l(g),this.#d=w(g),this.#i=b}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,E.$NAb)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===R.Schemas.https||c.scheme===R.Schemas.http){let u=c.toString();return u.endsWith("/")||(u+="/"),u+" "+E.$MAb}return E.$MAb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),M.$7n(this.#o,c)||this.#t.$setOptions(this.#e,r(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const u=(0,m.$Erb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,u.message,...u.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const u=this.#r.extensionLocation?.scheme===R.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===R.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(d,a,g,b,p,v)=>{const y=A.URI.from({scheme:b||"file",path:decodeURIComponent(p)}),h=(0,E.$NAb)(y,{isRemote:u,authority:t}).toString();return`${a}${h}${v}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(d,a,g,b,p,v)=>{const y=A.URI.from({scheme:b||"file",path:decodeURIComponent(p)}),h=(0,E.$NAb)(y,{isRemote:u,authority:t}).toString();return`${a}${h}${v}`})}}e.$Vlc=k;function l(i){try{const c=(0,$.$Ip)((0,$.$Hp)(i.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function w(i){try{const c=(0,$.$Ip)((0,$.$Hp)(i.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class f extends O.$Uc{constructor(c,u,t,d,a){super(),this.c=u,this.f=t,this.g=d,this.h=a,this.b=new Map,this.a=c.getProxy(T.$$M.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,u,t){const d=this.j(c);if(d){const{message:a}=(0,m.$Frb)(u,t.value);d._onMessageEmitter.fire(a)}}$onMissingCsp(c,u){this.g.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,u,t){const d=new k(c,this.a,o(u),this.c,this.f,t,this.h);this.b.set(c,d);const a=d._onDidDispose(()=>{a.dispose(),this.deleteWebview(c)});return d}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$Xlc=f;function s(i){return{id:i.identifier,location:i.extensionLocation}}function r(i,c,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||n(i,c)}}function o(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(c=>A.URI.from(c))}}function n(i,c){return[...(c?.getWorkspaceFolders()||[]).map(u=>u.uri),i.extensionLocation]}}),define(Se[111],Pe([1,0,5,16,13,2,3,17,4]),function(le,e,C,O,R,M,A,$,m){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$xnc=e.$wnc=void 0;let T=class{static{E=this}static{this.a={focused:!0,active:!0}}getState(){const l=this.d;return{get focused(){return l.focused},get active(){return l.active}}}constructor(l){this.c=new C.$de,this.onDidChangeWindowState=this.c.event,this.d=E.a,this.b=l.getProxy(m.$$M.MainThreadWindow),this.b.$getInitialState().then(({isFocused:w,isActive:f})=>{this.onDidChangeWindowProperty("focused",w),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(l){this.onDidChangeWindowProperty("focused",l)}$onDidChangeWindowActive(l){this.onDidChangeWindowProperty("active",l)}onDidChangeWindowProperty(l,w){w!==this.d[l]&&(this.d={...this.d,[l]:w},this.c.fire(this.d))}openUri(l,w){let f;if(typeof l=="string"){f=l;try{l=M.URI.parse(l)}catch{return Promise.reject(`Invalid uri - '${l}'`)}}return(0,R.$7e)(l.scheme)?Promise.reject("Invalid scheme - cannot be empty"):l.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${l.scheme}'`):this.b.$openUri(l,f,w)}async asExternalUri(l,w){if((0,R.$7e)(l.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(l,w);return M.URI.from(f)}};e.$wnc=T,e.$wnc=T=E=Je([We(0,$.$zP)],T),e.$xnc=(0,A.$wi)("IExtHostWindow")}),define(Se[253],Pe([1,0,244,27,17]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=void 0;let M=class extends C.$Anc{constructor($,m){super($,m)}f($,m,E){m.apply(console,E)}};e.$Ipc=M,e.$Ipc=M=Je([We(0,R.$zP),We(1,O.$PP)],M)}),define(Se[254],Pe([1,0,11,21,24,14,5,6,150,242,35]),function(le,e,C,O,R,M,A,$,m,E,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$$_b=e.ResponsiveState=e.RequestInitiator=void 0,e.$9_b=r,e.$0_b=o;function l(S,I){try{return JSON.stringify(S,I)}catch{return"null"}}const w="$$ref$$",f={[w]:-1};class s{constructor(I,P){this.jsonString=I,this.referencedBuffers=P}}function r(S,I=null,P=!1){const W=[];return{jsonString:(P?l:JSON.stringify)(S,(q,N)=>{if(typeof N>"u")return f;if(typeof N=="object"){if(N instanceof O.$Fe){const B=W.push(N)-1;return{[w]:B}}if(I)return I(q,N)}return N}),referencedBuffers:W}}function o(S,I,P){return JSON.parse(S,(W,V)=>{if(V){const q=V[w];if(typeof q=="number")return I[q];if(P&&V.$mid===1)return P.transformIncoming(V)}return V})}function n(S,I){return JSON.stringify(S,I)}function i(S){return S?(I,P)=>P&&P.$mid===1?S.transformOutgoing(P):P:null}var c;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var u;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const t=()=>{},d=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class g extends $.$Uc{static{k=d}static{this.a=3*1e3}constructor(I,P=null,W=null){super(),this[k]=!0,this.b=this.B(new A.$de),this.onDidChangeResponsiveState=this.b.event,this.c=I,this.f=P,this.g=W,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,q=T.$yw.count;V<q;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new C.$Ih(()=>this.H(),1e3)),this.c.onMessage(V=>this.L(V))}dispose(){this.j=!0,Object.keys(this.w).forEach(I=>{const P=this.w[I];delete this.w[I],P.resolveErr(M.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(I){this.z===0&&(this.C=Date.now()+g.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(I){this.C=Date.now()+g.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(I){this.y!==I&&(this.y=I,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(I){return this.g?(0,m.$Bn)(I,this.g):I}getProxy(I){const{nid:P,sid:W}=I;return this.s[P]||(this.s[P]=this.J(P,W)),this.s[P]}J(I,P){const W={get:(V,q)=>(typeof q=="string"&&!V[q]&&q.charCodeAt(0)===36&&(V[q]=(...N)=>this.U(I,q,N)),q===a?P:V[q])};return new Proxy(Object.create(null),W)}set(I,P){return this.m[I.nid]=P,P}assertRegistered(I){for(let P=0,W=I.length;P<W;P++){const V=I[P];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(I){if(this.j)return;const P=I.byteLength,W=p.read(I,0),V=W.readUInt8(),q=W.readUInt32();switch(V){case 1:case 2:{let{rpcId:N,method:B,args:K}=y.deserializeRequestJSONArgs(W);this.g&&(K=(0,m.$Bn)(K,this.g)),this.M(P,q,N,B,K,V===2);break}case 3:case 4:{let{rpcId:N,method:B,args:K}=y.deserializeRequestMixedArgs(W);this.g&&(K=(0,m.$Bn)(K,this.g)),this.M(P,q,N,B,K,V===4);break}case 5:{this.f?.logIncoming(P,q,0,"ack"),this.G(q);break}case 6:{this.N(P,q);break}case 7:{this.O(P,q,void 0);break}case 9:{let N=y.deserializeReplyOKJSON(W);this.g&&(N=(0,m.$Bn)(N,this.g)),this.O(P,q,N);break}case 10:{const N=y.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(P,q,N);break}case 8:{const N=y.deserializeReplyOKVSBuffer(W);this.O(P,q,N);break}case 11:{let N=y.deserializeReplyErrError(W);this.g&&(N=(0,m.$Bn)(N,this.g)),this.P(P,q,N);break}case 12:{this.P(P,q,void 0);break}default:console.error("received unexpected message"),console.error(I)}}M(I,P,W,V,q,N){this.f?.logIncoming(I,P,1,`receiveRequest ${(0,T.$Aw)(W)}.${V}(`,q);const B=String(P);let K,ie;if(N){const ye=new R.$oe;q.push(ye.token),K=this.Q(W,V,q),ie=()=>ye.cancel()}else K=this.Q(W,V,q),ie=t;this.u[B]=ie;const ce=y.serializeAcknowledged(P);this.f?.logOutgoing(ce.byteLength,P,1,"ack"),this.c.send(ce),K.then(ye=>{delete this.u[B];const ke=y.serializeReplyOK(P,ye,this.h);this.f?.logOutgoing(ke.byteLength,P,1,"reply:",ye),this.c.send(ke)},ye=>{delete this.u[B];const ke=y.serializeReplyErr(P,ye);this.f?.logOutgoing(ke.byteLength,P,1,"replyErr:",ye),this.c.send(ke)})}N(I,P){this.f?.logIncoming(I,P,1,"receiveCancel");const W=String(P);this.u[W]?.()}O(I,P,W){this.f?.logIncoming(I,P,0,"receiveReply:",W);const V=String(P);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V],q.resolveOk(W)}P(I,P,W){this.f?.logIncoming(I,P,0,"receiveReplyErr:",W);const V=String(P);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V];let N;W&&(W.$isError?(N=new Error,N.name=W.name,N.message=W.message,N.stack=W.stack):N=W),q.resolveErr(N)}Q(I,P,W){try{return Promise.resolve(this.S(I,P,W))}catch(V){return Promise.reject(V)}}S(I,P,W){const V=this.m[I];if(!V)throw new Error("Unknown actor "+(0,T.$Aw)(I));const q=V[P];if(typeof q!="function")throw new Error("Unknown method "+P+" on actor "+(0,T.$Aw)(I));return q.apply(V,W)}U(I,P,W){if(this.j)return new E.$8_b;let V=null;if(W.length>0&&R.CancellationToken.isCancellationToken(W[W.length-1])&&(V=W.pop()),V&&V.isCancellationRequested)return Promise.reject(M.$6());const q=y.serializeRequestArguments(W,this.h),N=++this.t,B=String(N),K=new E.$7_b,ie=new $.$Tc;V&&ie.add(V.onCancellationRequested(()=>{const ye=y.serializeCancel(N);this.f?.logOutgoing(ye.byteLength,N,0,"cancel"),this.c.send(y.serializeCancel(N))})),this.w[B]=new b(K,ie),this.F(N);const ce=y.serializeRequest(N,I,P,q,!!V);return this.f?.logOutgoing(ce.byteLength,N,0,`request: ${(0,T.$Aw)(I)}.${P}(`,W),this.c.send(ce),K}}e.$$_b=g;class b{constructor(I,P){this.a=I,this.b=P}resolveOk(I){this.a.resolveOk(I),this.b.dispose()}resolveErr(I){this.a.resolveErr(I),this.b.dispose()}}class p{static alloc(I,P,W){const V=new p(O.$Fe.alloc(W+1+4),0);return V.writeUInt8(I),V.writeUInt32(P),V}static read(I,P){return new p(I,P)}get buffer(){return this.a}constructor(I,P){this.a=I,this.b=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(I){this.a.writeUInt8(I,this.b),this.b+=1}readUInt8(){const I=this.a.readUInt8(this.b);return this.b+=1,I}writeUInt32(I){this.a.writeUInt32BE(I,this.b),this.b+=4}readUInt32(){const I=this.a.readUInt32BE(this.b);return this.b+=4,I}static sizeShortString(I){return 1+I.byteLength}writeShortString(I){this.a.writeUInt8(I.byteLength,this.b),this.b+=1,this.a.set(I,this.b),this.b+=I.byteLength}readShortString(){const I=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+I).toString();return this.b+=I,W}static sizeLongString(I){return 4+I.byteLength}writeLongString(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readLongString(){const I=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+I).toString();return this.b+=I,W}writeBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}static sizeVSBuffer(I){return 4+I.byteLength}writeVSBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readVSBuffer(){const I=this.a.readUInt32BE(this.b);this.b+=4;const P=this.a.slice(this.b,this.b+I);return this.b+=I,P}static sizeMixedArray(I){let P=0;P+=1;for(let W=0,V=I.length;W<V;W++){const q=I[W];switch(P+=1,q.type){case 1:P+=this.sizeLongString(q.value);break;case 2:P+=this.sizeVSBuffer(q.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(q.value);for(let N=0;N<q.buffers.length;++N)P+=this.sizeVSBuffer(q.buffers[N]);break;case 4:break}}return P}writeMixedArray(I){this.a.writeUInt8(I.length,this.b),this.b+=1;for(let P=0,W=I.length;P<W;P++){const V=I[P];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let q=0;q<V.buffers.length;++q)this.writeBuffer(V.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const I=this.a.readUInt8(this.b);this.b+=1;const P=new Array(I);for(let W=0;W<I;W++)switch(this.readUInt8()){case 1:P[W]=this.readLongString();break;case 2:P[W]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),N=this.readLongString(),B=[];for(let K=0;K<q;++K)B.push(this.readVSBuffer());P[W]=new T.$Bw(o(N,B,null));break}case 4:P[W]=void 0;break}return P}}var v;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(v||(v={}));class y{static a(I){for(let P=0,W=I.length;P<W;P++)if(I[P]instanceof O.$Fe||I[P]instanceof T.$Bw||typeof I[P]>"u")return!0;return!1}static serializeRequestArguments(I,P){if(this.a(I)){const W=[];for(let V=0,q=I.length;V<q;V++){const N=I[V];if(N instanceof O.$Fe)W[V]={type:2,value:N};else if(typeof N>"u")W[V]={type:4};else if(N instanceof T.$Bw){const{jsonString:B,referencedBuffers:K}=r(N.value,P);W[V]={type:3,value:O.$Fe.fromString(B),buffers:K}}else W[V]={type:1,value:O.$Fe.fromString(n(N,P))}}return{type:1,args:W}}return{type:0,args:n(I,P)}}static serializeRequest(I,P,W,V,q){switch(V.type){case 0:return this.b(I,P,W,V.args,q);case 1:return this.c(I,P,W,V.args,q)}}static b(I,P,W,V,q){const N=O.$Fe.fromString(W),B=O.$Fe.fromString(V);let K=0;K+=p.sizeUInt8(),K+=p.sizeShortString(N),K+=p.sizeLongString(B);const ie=p.alloc(q?2:1,I,K);return ie.writeUInt8(P),ie.writeShortString(N),ie.writeLongString(B),ie.buffer}static deserializeRequestJSONArgs(I){const P=I.readUInt8(),W=I.readShortString(),V=I.readLongString();return{rpcId:P,method:W,args:JSON.parse(V)}}static c(I,P,W,V,q){const N=O.$Fe.fromString(W);let B=0;B+=p.sizeUInt8(),B+=p.sizeShortString(N),B+=p.sizeMixedArray(V);const K=p.alloc(q?4:3,I,B);return K.writeUInt8(P),K.writeShortString(N),K.writeMixedArray(V),K.buffer}static deserializeRequestMixedArgs(I){const P=I.readUInt8(),W=I.readShortString(),V=I.readMixedArray(),q=new Array(V.length);for(let N=0,B=V.length;N<B;N++){const K=V[N];typeof K=="string"?q[N]=JSON.parse(K):q[N]=K}return{rpcId:P,method:W,args:q}}static serializeAcknowledged(I){return p.alloc(5,I,0).buffer}static serializeCancel(I){return p.alloc(6,I,0).buffer}static serializeReplyOK(I,P,W){if(typeof P>"u")return this.d(I);if(P instanceof O.$Fe)return this.e(I,P);if(P instanceof T.$Bw){const{jsonString:V,referencedBuffers:q}=r(P.value,W,!0);return this.g(I,V,q)}else return this.f(I,l(P,W))}static d(I){return p.alloc(7,I,0).buffer}static e(I,P){let W=0;W+=p.sizeVSBuffer(P);const V=p.alloc(8,I,W);return V.writeVSBuffer(P),V.buffer}static deserializeReplyOKVSBuffer(I){return I.readVSBuffer()}static f(I,P){const W=O.$Fe.fromString(P);let V=0;V+=p.sizeLongString(W);const q=p.alloc(9,I,V);return q.writeLongString(W),q.buffer}static g(I,P,W){const V=O.$Fe.fromString(P);let q=0;q+=p.sizeUInt32,q+=p.sizeLongString(V);for(const B of W)q+=p.sizeVSBuffer(B);const N=p.alloc(10,I,q);N.writeUInt32(W.length),N.writeLongString(V);for(const B of W)N.writeBuffer(B);return N.buffer}static deserializeReplyOKJSON(I){const P=I.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(I,P){const W=I.readUInt32(),V=I.readLongString(),q=[];for(let N=0;N<W;++N)q.push(I.readVSBuffer());return new T.$Bw(o(V,q,P))}static serializeReplyErr(I,P){const W=P?l(M.$3(P),null):void 0;if(typeof W!="string")return this.h(I);const V=O.$Fe.fromString(W);let q=0;q+=p.sizeLongString(V);const N=p.alloc(11,I,q);return N.writeLongString(V),N.buffer}static deserializeReplyErrError(I){const P=I.readLongString();return JSON.parse(P)}static h(I){return p.alloc(12,I,0).buffer}}var h;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var D;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(D||(D={}))}),define(Se[255],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kpc=void 0;const C=function(M){const A=$=>{globalThis.removeEventListener("message",A);const m=$.data;Object.defineProperties(globalThis,{postMessage:{value(E,T){m.postMessage(E,T)}},onmessage:{get(){return m.onmessage},set(E){m.onmessage=E}}}),m.addEventListener("message",E=>{globalThis.dispatchEvent(new MessageEvent("message",{data:E.data,ports:E.ports?[...E.ports]:void 0}))}),m.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",A)}.toString();class O extends EventTarget{constructor(M,A,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const m=`((${C})('${A}'))`,E=new Blob([m],{type:"application/javascript"}),T=URL.createObjectURL(E),k=new MessageChannel,l=T,w={type:"_newWorker",id:l,port:k.port2,url:T,options:$};M(w,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{M({type:"_terminateWorker",id:l}),URL.revokeObjectURL(T),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(f){k.port1.onmessage=f}},onmessageerror:{get(){return k.port1.onmessageerror},set(f){k.port1.onmessageerror=f}}}),k.port1.addEventListener("messageerror",f=>{const s=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(s)}),k.port1.addEventListener("message",f=>{const s=new MessageEvent("message",{data:f.data});this.dispatchEvent(s)}),k.port1.start()}}e.$Kpc=O}),define(Se[256],Pe([1,0,21,28,16,56,3]),function(le,e,C,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$LK=void 0,e.$MK=T,e.$NK=k,e.$LK=(0,A.$wi)("notebookDocumentService");const $=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${$.join("")}]+`),E=7;function T(w){if(w.scheme!==R.Schemas.vscodeNotebookCell)return;const f=w.fragment.indexOf("s");if(f<0)return;const s=parseInt(w.fragment.substring(0,f).replace(m,""),E),r=(0,C.$Ye)(w.fragment.substring(f+1)).toString();if(!isNaN(s))return{handle:s,notebook:w.with({scheme:r,fragment:null})}}function k(w,f){const s=f.toString(E),o=`${s.length<$.length?$[s.length-1]:"z"}${s}s${(0,C.$Ze)(C.$Fe.fromString(w.scheme),!0,!0)}`;return w.with({scheme:R.Schemas.vscodeNotebookCell,fragment:o})}class l{constructor(){this.a=new O.$Ac}getNotebook(f){if(f.scheme===R.Schemas.vscodeNotebookCell){const s=T(f);if(s){const r=this.a.get(s.notebook);if(r)return r}}return this.a.get(f)}addNotebookDocument(f){this.a.set(f.uri,f)}removeNotebookDocument(f){this.a.delete(f.uri)}}e.$OK=l,(0,M.$xs)(e.$LK,l,1)}),define(Se[85],Pe([1,0,21,37,42,70,16,19,22,31,256]),function(le,e,C,O,R,M,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9K=e.$6K=e.CellStatusbarAlignment=e.$5K=e.NotebookEditorPriority=e.$2K=e.$1K=e.$YK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$XK=e.$WK=e.$VK=e.$UK=e.CellKind=e.$TK=e.$SK=e.$RK=void 0,e.$ZK=d,e.$3K=g,e.$4K=b,e.$7K=y,e.$8K=D,e.$RK="workbench.editor.notebook",e.$SK="workbench.editor.notebookTextDiffEditor",e.$TK="workbench.editor.interactive";var k;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(k||(e.CellKind=k={})),e.$UK=["application/json","application/javascript","text/html","image/svg+xml",M.$Qs.latex,M.$Qs.markdown,"image/png","image/jpeg",M.$Qs.text],e.$VK=[M.$Qs.latex,M.$Qs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$Qs.text],e.$WK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$XK="_notAvailable";var l;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var w;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var f;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(f||(e.NotebookExecutionState=f={}));var s;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var r;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(r||(e.RendererMessagingSpec=r={}));var o;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var n;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var c;(function(K){K.scheme=A.Schemas.vscodeNotebookCell;function ie(Te,ae){return(0,T.$NK)(Te,ae)}K.generate=ie;function ce(Te){return(0,T.$MK)(Te)}K.parse=ce;function ye(Te,ae){return Te.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ae??""},${Te.scheme!==A.Schemas.file?Te.scheme:""}`})}K.generateCellOutputUri=ye;function ke(Te){if(Te.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ae=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Te.fragment);if(!ae)return;const Ne=ae[1]&&ae[1]!==""?ae[1]:void 0,ne=ae[2];return{outputId:Ne,notebook:Te.with({scheme:ne||A.Schemas.file,fragment:null})}}K.parseCellOutputUri=ke;function fe(Te,ae,Ne){return K.generate(Te,ae).with({scheme:Ne})}K.generateCellPropertyUri=fe;function $e(Te,ae){if(Te.scheme===ae)return K.parse(Te.with({scheme:K.scheme}))}K.parseCellPropertyUri=$e})(c||(e.CellUri=c={}));const u=K=>m.$i?K.replace(/\//g,"\\"):K;class t{constructor(ie=[],ce=e.$UK){this.e=ce,this.d=[...new Set(ie)].map(ye=>({pattern:ye,matches:O.$qk(u(ye))}))}sort(ie){const ce=new Map(R.Iterable.map(ie,ke=>[ke,u(ke)]));let ye=[];for(const{matches:ke}of this.d)for(const[fe,$e]of ce)if(ke($e)){ye.push(fe),ce.delete(fe);break}return ce.size&&(ye=ye.concat([...ce.keys()].sort((ke,fe)=>this.e.indexOf(ke)-this.e.indexOf(fe)))),ye}prioritize(ie,ce){const ye=this.f(ie);if(ye===-1){this.d.unshift({pattern:ie,matches:O.$qk(u(ie))});return}const ke=new Set(ce.map($e=>this.f($e,ye)));ke.delete(-1);const fe=Array.from(ke).sort();this.d.splice(ye+1,0,...fe.map($e=>this.d[$e]));for(let $e=fe.length-1;$e>=0;$e--)this.d.splice(fe[$e],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,ce=this.d.length){const ye=u(ie);for(let ke=0;ke<ce;ke++)if(this.d[ke].matches(ye))return ke;return-1}}e.$YK=t;function d(K,ie,ce,ye=(ke,fe)=>ke===fe){const ke=[];function fe(ae,Ne,ne){if(Ne===0&&ne.length===0)return;const z=ke[ke.length-1];z&&z.start+z.deleteCount===ae?(z.deleteCount+=Ne,z.toInsert.push(...ne)):ke.push({start:ae,deleteCount:Ne,toInsert:ne})}let $e=0,Te=0;for(;;){if($e===K.length){fe($e,0,ie.slice(Te));break}if(Te===ie.length){fe($e,K.length-$e,[]);break}const ae=K[$e],Ne=ie[Te];if(ye(ae,Ne)){$e+=1,Te+=1;continue}ce(Ne)?(fe($e,1,[]),$e+=1):(fe($e,0,[Ne]),Te+=1)}return ke}e.$1K=new E.$Nj("notebookEditorCursorAtBoundary","none"),e.$2K=new E.$Nj("notebookEditorCursorAtLineBoundary","none");var a;(function(K){K.default="default",K.option="option"})(a||(e.NotebookEditorPriority=a={}));function g(K){const ie=K;return!!((typeof ie.include=="string"||O.$rk(ie.include))&&(typeof ie.exclude=="string"||O.$rk(ie.exclude)))}function b(K,ie,ce){if(Array.isArray(K.viewType)&&K.viewType.indexOf(ie)>=0||K.viewType===ie)return!0;if(K.filenamePattern){const ye=g(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,ke=g(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(O.$pk(ye,(0,$.$nc)(ce.fsPath).toLowerCase()))return!(ke&&O.$pk(ke,(0,$.$nc)(ce.fsPath).toLowerCase()))}return!1}e.$5K={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var p;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(p||(e.CellStatusbarAlignment=p={}));class v{static{this.d="notebook/"}static create(ie){return`${v.d}${ie}`}static parse(ie){if(ie.startsWith(v.d))return ie.substring(v.d.length)}}e.$6K=v;function y(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const h=new TextDecoder;function D(K){const ie=[];let ce=!1;for(const $e of K)(ie.length===0||ce)&&(ie.push($e),ce=!0);let ye=P(ie);const ke=C.$Fe.concat(ie.map($e=>C.$Fe.wrap($e))),fe=B(ke);return ye=ye||fe.byteLength!==ke.byteLength,{data:fe,didCompression:ye}}e.$9K="\x1B[A";const S=e.$9K.split("").map(K=>K.charCodeAt(0)),I=10;function P(K){let ie=!1;return K.forEach((ce,ye)=>{if(ye===0||ce.length<e.$9K.length)return;const ke=K[ye-1],fe=ce.subarray(0,e.$9K.length);if(fe[0]===S[0]&&fe[1]===S[1]&&fe[2]===S[2]){const $e=ke.lastIndexOf(I);if($e===-1)return;ie=!0,K[ye-1]=ke.subarray(0,$e),K[ye]=ce.subarray(e.$9K.length)}}),ie}function W(K){let ie=K;do K=ie,ie=K.replace(/[^\n]\x08/gm,"");while(ie.length<K.length);return K}function V(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const ie=K.match(/^(.*)\r+/m)[1];let ce=K.match(/\r+(.*)$/m)[1];ce=ce+ie.slice(ce.length,ie.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return K}const q=8,N=13;function B(K){return!K.buffer.includes(q)&&!K.buffer.includes(N)?K:C.$Fe.fromString(V(W(h.decode(K.buffer))))}}),define(Se[7],Pe([1,0,18,14,55,28,70,13,15,2,34,20,38,104,85]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f){"use strict";var s,r,o,n,i,c,u,t,d,a,g,b,p,v,y,h,D;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$nP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$mP=e.$lP=e.$kP=e.$jP=e.ChatLocation=e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$9O=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$8O=e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$VO=e.$UO=e.$TO=e.$SO=e.$QO=e.$PO=e.$OO=e.$NO=e.TestRunProfileKind=e.TestResultState=e.$MO=e.$LO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$KO=e.NotebookVariablesRequestKind=e.$JO=e.$IO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$HO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.ColorThemeKind=e.$BO=e.$AO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$zO=e.$yO=e.DebugConsoleMode=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$sO=e.$rO=e.FileChangeType=e.$qO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$pO=e.$oO=e.$nO=e.$mO=e.InlineCompletionTriggerKind=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$_N=e.ConfigurationTarget=e.$$N=e.$0N=e.$9N=e.$8N=e.DocumentPasteTriggerKind=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$1N=e.ViewBadge=e.ProgressLocation=e.$ZN=e.$YN=e.TaskScope=e.ShellQuoting=e.$XN=e.$WN=e.$VN=e.TaskPanelKind=e.TaskRevealKind=e.$UN=e.TerminalLocation=e.$TN=e.$SN=e.$RN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$QN=e.$PN=e.$ON=e.$NN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$LN=e.$KN=e.$JN=e.$IN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$HN=e.$GN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.LanguageStatusSeverity=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.CodeActionTriggerKind=e.$uN=e.$tN=e.SymbolTag=e.SymbolKind=e.$sN=e.$rN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.DiagnosticSeverity=e.DiagnosticTag=e.$lN=e.$kN=e.FileEditType=e.$jN=e.$iN=e.$hN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$MN=Vt,e.$aO=Ve,e.$RO=vn;function S(j){return Object.assign(j,{apply:function(...te){if(te.length===0)return Reflect.construct(j,[]);{const Ee=te.length===1?[]:te[1];return Reflect.construct(j,Ee,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(j,[]);{const[Ee,...Ke]=te;return Reflect.construct(j,Ke,Ee.constructor)}}})}var I;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(I||(e.TerminalOutputAnchor=I={}));var P;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(P||(e.TerminalQuickFixType=P={}));let W=s=class{static from(...L){let te=L;return new s(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$aN=W,e.$aN=W=s=Je([S],W);let V=r=class{static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Ee=1;Ee<L.length;Ee++){const Ke=L[Ee];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Ee=1;Ee<L.length;Ee++){const Ke=L[Ee];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(L){if(!L)return!1;if(L instanceof r)return!0;const{line:te,character:Ee}=L;return typeof te=="number"&&typeof Ee=="number"}static of(L){if(L instanceof r)return L;if(this.isPosition(L))return new r(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,te){if(L<0)throw(0,O.$7)("line must be non-negative");if(te<0)throw(0,O.$7)("character must be non-negative");this.c=L,this.e=te}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,te=0){if(L===null||te===null)throw(0,O.$7)();let Ee;return typeof L>"u"?Ee=0:typeof L=="number"?Ee=L:(Ee=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),Ee===0&&te===0?this:new r(this.line+Ee,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,O.$7)();let Ee;return typeof L>"u"?Ee=this.line:typeof L=="number"?Ee=L:(Ee=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),Ee===this.line&&te===this.character?this:new r(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};e.$bN=V,e.$bN=V=r=Je([S],V);let q=o=class{static isRange(L){return L instanceof o?!0:L?V.isPosition(L.start)&&V.isPosition(L.end):!1}static of(L){if(L instanceof o)return L;if(this.isRange(L))return new o(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,te,Ee,Ke){let Ye,lt;if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(Ye=new V(L,te),lt=new V(Ee,Ke)):V.isPosition(L)&&V.isPosition(te)&&(Ye=V.of(L),lt=V.of(te)),!Ye||!lt)throw new Error("Invalid arguments");Ye.isBefore(lt)?(this.c=Ye,this.e=lt):(this.c=lt,this.e=Ye)}contains(L){return o.isRange(L)?this.contains(L.start)&&this.contains(L.end):V.isPosition(L)?!(V.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const te=V.Max(L.start,this.c),Ee=V.Min(L.end,this.e);if(!te.isAfter(Ee))return new o(te,Ee)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=V.Min(L.start,this.c),Ee=V.Max(L.end,this.end);return new o(te,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,te=this.end){if(L===null||te===null)throw(0,O.$7)();let Ee;return L?V.isPosition(L)?Ee=L:(Ee=L.start||this.start,te=L.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&te.isEqual(this.end)?this:new o(Ee,te)}toJSON(){return[this.start,this.end]}};e.$cN=q,e.$cN=q=o=Je([S],q);let N=n=class extends q{static isSelection(L){return L instanceof n?!0:L?q.isRange(L)&&V.isPosition(L.anchor)&&V.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,te,Ee,Ke){let Ye,lt;if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(Ye=new V(L,te),lt=new V(Ee,Ke)):V.isPosition(L)&&V.isPosition(te)&&(Ye=V.of(L),lt=V.of(te)),!Ye||!lt)throw new Error("Invalid arguments");super(Ye,lt),this.f=Ye,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$dN=N,e.$dN=N=n=Je([S],N);const B=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,O.$7)("connectionToken")};class K{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,te,Ee){if(typeof L!="string"||L.length===0)throw(0,O.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,O.$7)("port");typeof Ee<"u"&&B(Ee),this.host=L,this.port=Math.round(te),this.connectionToken=Ee}}e.$eN=K;class ie{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,te){this.makeConnection=L,this.connectionToken=te,typeof te<"u"&&B(te)}}e.$fN=ie;class ce extends Error{static NotAvailable(L,te){return new ce(L,w.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new ce(L,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,te=w.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(L),this._message=L,this._code=te,this._detail=Ee,Object.setPrototypeOf(this,ce.prototype)}}e.$gN=ce;var ye;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(ye||(e.EndOfLine=ye={}));var ke;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(ke||(e.EnvironmentVariableMutatorType=ke={}));let fe=i=class{static isTextEdit(L){return L instanceof i?!0:L?q.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new i(L,te)}static insert(L,te){return i.replace(new q(L,L),te)}static delete(L){return i.replace(L,"")}static setEndOfLine(L){const te=new i(new q(new V(0,0),new V(0,0)),"");return te.newEol=L,te}get range(){return this.c}set range(L){if(L&&!q.isRange(L))throw(0,O.$7)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,O.$7)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,O.$7)("newEol");this.f=L}constructor(L,te){this.c=L,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$hN=fe,e.$hN=fe=i=Je([S],fe);let $e=c=class{static isNotebookCellEdit(L){return L instanceof c?!0:L?di.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,te){return new c(L,te)}static insertCells(L,te){return new c(new di(L,L),te)}static deleteCells(L){return new c(L,[])}static updateCellMetadata(L,te){const Ee=new c(new di(L,L),[]);return Ee.newCellMetadata=te,Ee}static updateNotebookMetadata(L){const te=new c(new di(0,0),[]);return te.newNotebookMetadata=L,te}constructor(L,te){this.range=L,this.newCells=te}};e.$iN=$e,e.$iN=$e=c=Je([S],$e);class Te{static isSnippetTextEdit(L){return L instanceof Te?!0:L?q.isRange(L.range)&&ne.isSnippetString(L.snippet):!1}static replace(L,te){return new Te(L,te)}static insert(L,te){return Te.replace(new q(L,L),te)}constructor(L,te){this.range=L,this.snippet=te}}e.$jN=Te;var ae;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(ae||(e.FileEditType=ae={}));let Ne=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,te,Ee,Ke){this.c.push({_type:1,from:L,to:te,options:Ee,metadata:Ke})}createFile(L,te,Ee){this.c.push({_type:1,from:void 0,to:L,options:te,metadata:Ee})}deleteFile(L,te,Ee){this.c.push({_type:1,from:L,to:void 0,options:te,metadata:Ee})}e(L,te,Ee){this.c.push({_type:3,metadata:Ee,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}f(L,te,Ee,Ke){const Ye=te.start,lt=te.end;(Ye!==lt||Ee.length>0)&&this.c.push({_type:5,uri:L,index:Ye,count:lt-Ye,cells:Ee,metadata:Ke})}g(L,te,Ee,Ke){this.c.push({_type:3,metadata:Ke,uri:L,edit:{editType:3,index:te,metadata:Ee}})}replace(L,te,Ee,Ke){this.c.push({_type:2,uri:L,edit:new fe(te,Ee),metadata:Ke})}insert(L,te,Ee,Ke){this.replace(L,new q(te,te),Ee,Ke)}delete(L,te,Ee){this.replace(L,te,"",Ee)}has(L){return this.c.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const Ee of te){if(!Ee)continue;let Ke,Ye;Array.isArray(Ee)?(Ke=Ee[0],Ye=Ee[1]):Ke=Ee,$e.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(L,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(L,Ke.newNotebookMetadata,Ye):this.f(L,Ke.range,Ke.newCells,Ye):Te.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:L,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:L,edit:Ke,metadata:Ye})}else{for(let Ee=0;Ee<this.c.length;Ee++){const Ke=this.c[Ee];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===L.toString()&&(this.c[Ee]=void 0);break}}(0,C.$Ib)(this.c)}}get(L){const te=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===L.toString()&&te.push(Ee.edit);return te}entries(){const L=new M.$Ac;for(const te of this.c)if(te._type===2){let Ee=L.get(te.uri);Ee||(Ee=[te.uri,[]],L.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$kN=Ne,e.$kN=Ne=Je([S],Ne);let ne=u=class{static isSnippetString(L){return L instanceof u?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=u.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this.e++){if(typeof L=="function"){const Ee=new u;Ee.e=this.e,L(Ee),this.e=Ee.e,L=Ee.value}else L=u.c(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this.e++){const Ee=L.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const Ee=new u;Ee.e=this.e,te(Ee),this.e=Ee.e,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$lN=ne,e.$lN=ne=u=Je([S],ne);var z;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(z||(e.DiagnosticTag=z={}));var x;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let be=t=class{static isLocation(L){return L instanceof t?!0:L?q.isRange(L.range)&&E.URI.isUri(L.uri):!1}constructor(L,te){if(this.uri=L,te)if(q.isRange(te))this.range=q.of(te);else if(V.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$mN=be,e.$mN=be=t=Je([S],be);let Fe=class{static is(L){return L?typeof L.message=="string"&&L.location&&q.isRange(L.location.range)&&E.URI.isUri(L.location.uri):!1}constructor(L,te){this.location=L,this.message=te}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};e.$nN=Fe,e.$nN=Fe=Je([S],Fe);let De=class{constructor(L,te,Ee=x.Error){if(!q.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=Ee}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,C.$ub)(L.tags,te.tags)&&(0,C.$ub)(L.relatedInformation,te.relatedInformation,Fe.isEqual)}};e.$oN=De,e.$oN=De=Je([S],De);let pe=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};e.$pN=pe,e.$pN=pe=Je([S],pe);let ge=class extends pe{constructor(L,te,Ee,Ke){super(L,te),this.canIncreaseHover=Ee,this.canDecreaseHover=Ke}};e.$qN=ge,e.$qN=ge=Je([S],ge);var Q;(function(j){j[j.Increase=0]="Increase",j[j.Decrease=1]="Decrease"})(Q||(e.HoverVerbosityAction=Q={}));var Y;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Y||(e.DocumentHighlightKind=Y={}));let he=class{constructor(L,te=Y.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:Y[this.kind]}}};e.$rN=he,e.$rN=he=Je([S],he);let ue=class{constructor(L,te){this.uri=L,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(L=>L.toJSON())}}};e.$sN=ue,e.$sN=ue=Je([S],ue);var Me;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Me||(e.SymbolKind=Me={}));var de;(function(j){j[j.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Ce=d=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,te,Ee,Ke,Ye){this.name=L,this.kind=te,this.containerName=Ye,typeof Ee=="string"&&(this.containerName=Ee),Ke instanceof be?this.location=Ke:Ee instanceof q&&(this.location=new be(Ke,Ee)),d.validate(this)}toJSON(){return{name:this.name,kind:Me[this.kind],location:this.location,containerName:this.containerName}}};e.$tN=Ce,e.$tN=Ce=d=Je([S],Ce);let Ae=a=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(a.validate)}constructor(L,te,Ee,Ke,Ye){this.name=L,this.detail=te,this.kind=Ee,this.range=Ke,this.selectionRange=Ye,this.children=[],a.validate(this)}};e.$uN=Ae,e.$uN=Ae=a=Je([S],Ae);var je;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(je||(e.CodeActionTriggerKind=je={}));let U=class{constructor(L,te){this.title=L,this.kind=te}};e.$vN=U,e.$vN=U=Je([S],U);let F=class{static{g=this}static{this.c="."}constructor(L){this.value=L}append(L){return new g(this.value?this.value+g.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+g.c)}};e.$wN=F,e.$wN=F=g=Je([S],F),F.Empty=new F(""),F.QuickFix=F.Empty.append("quickfix"),F.Refactor=F.Empty.append("refactor"),F.RefactorExtract=F.Refactor.append("extract"),F.RefactorInline=F.Refactor.append("inline"),F.RefactorMove=F.Refactor.append("move"),F.RefactorRewrite=F.Refactor.append("rewrite"),F.Source=F.Empty.append("source"),F.SourceOrganizeImports=F.Source.append("organizeImports"),F.SourceFixAll=F.Source.append("fixAll"),F.Notebook=F.Empty.append("notebook");let G=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$xN=G,e.$xN=G=Je([S],G);class H{constructor(L,te,Ee,Ke,Ye,lt){this.kind=L,this.name=te,this.detail=Ee,this.uri=Ke,this.range=Ye,this.selectionRange=lt}}e.$yN=H;class ee{constructor(L,te){this.fromRanges=te,this.from=L}}e.$zN=ee;class re{constructor(L,te){this.fromRanges=te,this.to=L}}e.$AN=re;var Oe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Oe||(e.LanguageStatusSeverity=Oe={}));let Be=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};e.$BN=Be,e.$BN=Be=Je([S],Be);let He=b=class{#e;static isMarkdownString(L){return L instanceof b?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,te=!1){this.#e=new R.$Tk(L,{supportThemeIcons:te})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,te){return this.#e.appendCodeblock(te??"",L),this}};e.$CN=He,e.$CN=He=b=Je([S],He);let _e=class{constructor(L,te){this.label=L,this.documentation=te}};e.$DN=_e,e.$DN=_e=Je([S],_e);let xe=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};e.$EN=xe,e.$EN=xe=Je([S],xe);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$FN=et,e.$FN=et=Je([S],et);var tt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var it;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let ct=class{constructor(L){this.value=L}};e.$GN=ct,e.$GN=ct=Je([S],ct);let gt=class{constructor(L,te,Ee){this.position=L,this.label=te,this.kind=Ee}};e.$HN=gt,e.$HN=gt=Je([S],gt);var Ue;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue||(e.CompletionTriggerKind=Ue={}));var ot;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(ot||(e.CompletionItemKind=ot={}));var X;(function(j){j[j.Deprecated=1]="Deprecated"})(X||(e.CompletionItemTag=X={}));let Z=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&ot[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$IN=Z,e.$IN=Z=Je([S],Z);let me=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};e.$JN=me,e.$JN=me=Je([S],me);let Ge=class{constructor(L,te,Ee){this.insertText=L,this.range=te,this.command=Ee}};e.$KN=Ge,e.$KN=Ge=Je([S],Ge);let we=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$LN=we,e.$LN=we=Je([S],we);var at;(function(j){j[j.Unknown=0]="Unknown",j[j.Word=1]="Word",j[j.Line=2]="Line",j[j.Suggest=3]="Suggest"})(at||(e.PartialAcceptTriggerKind=at={}));var dt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(dt||(e.ViewColumn=dt={}));var It;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(It||(e.StatusBarAlignment=It={}));function Vt(j,L){return`${k.$Rm.toKey(j)}.${L}`}var Qt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval"})(Qt||(e.TextEditorLineNumbersStyle=Qt={}));var ni;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(ni||(e.TextDocumentSaveReason=ni={}));var Zt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Zt||(e.TextEditorRevealType=Zt={}));var Et;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Et||(e.TextEditorSelectionChangeKind=Et={}));var Xt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Xt||(e.TextDocumentChangeReason=Xt={}));var Yt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Yt||(e.DecorationRangeBehavior=Yt={})),function(j){function L(te){switch(te){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=L}(Et||(e.TextEditorSelectionChangeKind=Et={}));var Xe;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Xe||(e.SyntaxTokenType=Xe={})),function(j){function L(te){switch(te){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=L}(Xe||(e.SyntaxTokenType=Xe={}));let si=class{constructor(L,te){if(te&&!E.URI.isUri(te))throw(0,O.$7)("target");if(!q.isRange(L)||L.isEmpty)throw(0,O.$7)("range");this.range=L,this.target=te}};e.$NN=si,e.$NN=si=Je([S],si);let Gt=class{constructor(L,te,Ee,Ke){this.red=L,this.green=te,this.blue=Ee,this.alpha=Ke}};e.$ON=Gt,e.$ON=Gt=Je([S],Gt);let ht=class{constructor(L,te){if(te&&!(te instanceof Gt))throw(0,O.$7)("color");if(!q.isRange(L)||L.isEmpty)throw(0,O.$7)("range");this.range=L,this.color=te}};e.$PN=ht,e.$PN=ht=Je([S],ht);let mt=class{constructor(L){if(!L||typeof L!="string")throw(0,O.$7)("label");this.label=L}};e.$QN=mt,e.$QN=mt=Je([S],mt);var xt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(xt||(e.ColorFormat=xt={}));var Ht;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Ht||(e.SourceControlInputBoxValidationType=Ht={}));var Mt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(Mt||(e.TerminalExitReason=Mt={}));var ft;(function(j){j[j.Low=0]="Low",j[j.Medium=1]="Medium",j[j.High=2]="High"})(ft||(e.TerminalShellExecutionCommandLineConfidence=ft={}));class Ut{constructor(L,te,Ee){if(this.startIndex=L,this.length=te,this.tooltip=Ee,typeof L!="number"||L<0)throw(0,O.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,O.$7)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,O.$7)("tooltip")}}e.$RN=Ut;class _t{constructor(L){this.uri=L}}e.$SN=_t;class zt{constructor(L){this.terminalCommand=L}}e.$TN=zt;var Qe;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Qe||(e.TerminalLocation=Qe={}));class ci{constructor(L){if(this.options=L,typeof L!="object")throw(0,O.$7)("options")}}e.$UN=ci;var Kt;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(Kt||(e.TaskRevealKind=Kt={}));var Wt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Wt||(e.TaskPanelKind=Wt={}));let wt=class{static{p=this}static{this.Clean=new p("clean","Clean")}static{this.Build=new p("build","Build")}static{this.Rebuild=new p("rebuild","Rebuild")}static{this.Test=new p("test","Test")}static from(L){switch(L){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}constructor(L,te){if(this.label=te,typeof L!="string"||typeof te!="string")throw(0,O.$7)("name");this.c=L}get id(){return this.c}};e.$VN=wt,e.$VN=wt=p=Je([S],wt);function Tt(j){let L="";for(let te=0;te<j.length;te++)L+=j[te].replace(/,/g,",,")+",";return L}let Ct=class{constructor(L,te,Ee){if(typeof L!="string")throw(0,O.$7)("process");this.e=[],this.c=L,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Ee):this.f=te)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,O.$7)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const te of this.e)L.push(te);return Tt(L)}};e.$WN=Ct,e.$WN=Ct=Je([S],Ct);let Ft=class{constructor(L,te,Ee){if(this.f=[],Array.isArray(te)){if(!L)throw(0,O.$7)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,O.$7)("command");this.e=L,this.f=te,this.g=Ee}else{if(typeof L!="string")throw(0,O.$7)("commandLine");this.c=L,this.g=te}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,O.$7)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,O.$7)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)L.push(typeof te=="string"?te:te.value);return Tt(L)}};e.$XN=Ft,e.$XN=Ft=Je([S],Ft);var ei;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(ei||(e.ShellQuoting=ei={}));var jt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(jt||(e.TaskScope=jt={}));class oi{constructor(L){this.c=L}computeId(){return"customExecution"+(0,T.$Sg)()}set callback(L){this.c=L}get callback(){return this.c}}e.$YN=oi;let Nt=class{static{v=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(L,te,Ee,Ke,Ye,lt){this.k=!1,this.l=this.definition=L;let pt;typeof te=="string"?(this.o=this.name=te,this.w=this.source=Ee,this.execution=Ke,pt=Ye,this.k=!0):te===jt.Global||te===jt.Workspace?(this.target=te,this.o=this.name=Ee,this.w=this.source=Ke,this.execution=Ye,pt=lt):(this.target=te,this.o=this.name=Ee,this.w=this.source=Ke,this.execution=Ye,pt=lt),typeof pt=="string"?(this.r=[pt],this.t=!0):Array.isArray(pt)?(this.r=pt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(L){this.j=L}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Ct?this.l={type:v.e,id:this.q.computeId()}:this.q instanceof Ft?this.l={type:v.f,id:this.q.computeId()}:this.q instanceof oi?this.l={type:v.c,id:this.q.computeId()}:this.l={type:v.g,id:(0,T.$Sg)()}}get definition(){return this.l}set definition(L){if(L==null)throw(0,O.$7)("Kind can't be undefined or null");this.B(),this.l=L}get scope(){return this.m}set target(L){this.B(),this.m=L}get name(){return this.o}set name(L){if(typeof L!="string")throw(0,O.$7)("name");this.B(),this.o=L}get execution(){return this.q}set execution(L){L===null&&(L=void 0),this.B(),this.q=L;const te=this.l.type;(v.g===te||v.e===te||v.f===te||v.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(L){if(Array.isArray(L))this.B(),this.r=L,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.B(),this.u=L}get source(){return this.w}set source(L){if(typeof L!="string"||L.length===0)throw(0,O.$7)("source must be a string of length > 0");this.B(),this.w=L}get group(){return this.x}set group(L){L===null&&(L=void 0),this.B(),this.x=L}get detail(){return this.A}set detail(L){L===null&&(L=void 0),this.A=L}get presentationOptions(){return this.y}set presentationOptions(L){L==null&&(L=Object.create(null)),this.B(),this.y=L}get runOptions(){return this.z}set runOptions(L){L==null&&(L=Object.create(null)),this.B(),this.z=L}};e.$ZN=Nt,e.$ZN=Nt=v=Je([S],Nt);var At;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(At||(e.ProgressLocation=At={}));var Ot;(function(j){function L(te){const Ee=te;return(0,m.$ag)(Ee.value)?Ee.tooltip&&!(0,m.$9f)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}j.isViewBadge=L})(Ot||(e.ViewBadge=Ot={}));let Pt=y=class{static isTreeItem(L,te){const Ee=L;if(Ee.checkboxState!==void 0){const Ke=(0,m.$ag)(Ee.checkboxState)?Ee.checkboxState:(0,m.$$f)(Ee.checkboxState)&&(0,m.$ag)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,Ye=!(0,m.$ag)(Ee.checkboxState)&&(0,m.$$f)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Dt.Checked&&Ke!==Dt.Unchecked||Ye!==void 0&&!(0,m.$9f)(Ye))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}if(L instanceof y)return!0;if(Ee.label!==void 0&&!(0,m.$9f)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,m.$9f)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,m.$9f)(Ee.iconPath)&&!E.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,m.$9f)(Ee.iconPath.id))){const Ke=Ee.iconPath;if(!Ke||!(0,m.$9f)(Ke.light)&&!E.URI.isUri(Ke.light)&&!(0,m.$9f)(Ke.dark)&&!E.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}return Ee.description!==void 0&&!(0,m.$9f)(Ee.description)&&typeof Ee.description!="boolean"?(console.log("INVALID tree item, invalid description",Ee.description),!1):Ee.resourceUri!==void 0&&!E.URI.isUri(Ee.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1):Ee.tooltip!==void 0&&!(0,m.$9f)(Ee.tooltip)&&!(Ee.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1):Ee.command!==void 0&&!Ee.command.command?(console.log("INVALID tree item, invalid command",Ee.command),!1):Ee.collapsibleState!==void 0&&Ee.collapsibleState<$t.None&&Ee.collapsibleState>$t.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1):Ee.contextValue!==void 0&&!(0,m.$9f)(Ee.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1):Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1):!0}constructor(L,te=$t.None){this.collapsibleState=te,E.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$1N=Pt,e.$1N=Pt=y=Je([S],Pt);var $t;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})($t||(e.TreeItemCollapsibleState=$t={}));var Dt;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(Dt||(e.TreeItemCheckboxState=Dt={}));let ri=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$2N=ri,e.$2N=ri=Je([S],ri);class kt extends ri{}e.$3N=kt;class gi extends kt{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.$4N=gi;class ti{constructor(L,te,Ee,Ke){this.name=L,this.uri=te,this._itemId=Ee,this.c=Ke}data(){return this.c()}}e.$5N=ti;let pi=class{#e=new Map;constructor(L){for(const[te,Ee]of L??[]){const Ke=this.#e.get(this.#t(te));Ke?Ke.push(Ee):this.#e.set(this.#t(te),[Ee])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,te){this.#e.set(this.#t(L),[te])}forEach(L,te){for(const[Ee,Ke]of this.#e)for(const Ye of Ke)L.call(te,Ye,Ee,this)}*[Symbol.iterator](){for(const[L,te]of this.#e)for(const Ee of te)yield[L,Ee]}#t(L){return L.toLowerCase()}};e.$6N=pi,e.$6N=pi=Je([S],pi);let ui=class{constructor(L,te,Ee){this.insertText=L,this.title=te,this.kind=Ee}};e.$7N=ui,e.$7N=ui=Je([S],ui);var wi;(function(j){j[j.Automatic=0]="Automatic",j[j.PasteAs=1]="PasteAs"})(wi||(e.DocumentPasteTriggerKind=wi={}));class St{static{this.c="."}constructor(L){this.value=L}append(...L){return new St((this.value?[this.value,...L]:L).join(St.c))}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+St.c)}}e.$8N=St,St.Empty=new St("");class ki{constructor(L,te,Ee){this.title=te,this.insertText=L,this.kind=Ee}}e.$9N=ki;let ve=class{constructor(L,te){this.id=L,this.color=te}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$0N=ve,e.$0N=ve=Je([S],ve),ve.File=new ve("file"),ve.Folder=new ve("folder");let Ie=class{constructor(L){this.id=L}};e.$$N=Ie,e.$$N=Ie=Je([S],Ie);var oe;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(oe||(e.ConfigurationTarget=oe={}));let J=class{get base(){return this.c}set base(L){this.c=L,this.e=E.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,te){if(typeof L!="string"&&(!L||!E.URI.isUri(L)&&!E.URI.isUri(L.uri)))throw(0,O.$7)("base");if(typeof te!="string")throw(0,O.$7)("pattern");typeof L=="string"?this.baseUri=E.URI.file(L):E.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$_N=J,e.$_N=J=Je([S],J);const Re=new WeakMap;function Ve(j,L){Re.set(j,L)}let Ze=class{constructor(L,te,Ee,Ke,Ye){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ke=="string"&&(this.logMessage=Ke),typeof Ye=="string"&&(this.mode=Ye)}get id(){return this.c||(this.c=Re.get(this)??(0,T.$Sg)()),this.c}};e.$bO=Ze,e.$bO=Ze=Je([S],Ze);let qe=class extends Ze{constructor(L,te,Ee,Ke,Ye,lt){if(super(te,Ee,Ke,Ye,lt),L===null)throw(0,O.$7)("location");this.location=L}};e.$cO=qe,e.$cO=qe=Je([S],qe);let ut=class extends Ze{constructor(L,te,Ee,Ke,Ye,lt){super(te,Ee,Ke,Ye,lt),this.functionName=L}};e.$dO=ut,e.$dO=ut=Je([S],ut);let yt=class extends Ze{constructor(L,te,Ee,Ke,Ye,lt,pt,qt){if(super(Ke,Ye,lt,pt,qt),!te)throw(0,O.$7)("dataId");this.label=L,this.dataId=te,this.canPersist=Ee}};e.$eO=yt,e.$eO=yt=Je([S],yt);let Lt=class{constructor(L,te,Ee){this.command=L,this.args=te||[],this.options=Ee}};e.$fO=Lt,e.$fO=Lt=Je([S],Lt);let Bt=class{constructor(L,te){this.port=L,this.host=te}};e.$gO=Bt,e.$gO=Bt=Je([S],Bt);let st=class{constructor(L){this.path=L}};e.$hO=st,e.$hO=st=Je([S],st);let Jt=class{constructor(L){this.implementation=L}};e.$iO=Jt,e.$iO=Jt=Je([S],Jt);class mi{constructor(L,te,Ee){this.session=L,this.threadId=te,this.frameId=Ee}}e.$jO=mi;class yi{constructor(L,te){this.session=L,this.threadId=te}}e.$kO=yi;let Si=class{constructor(L,te){this.range=L,this.expression=te}};e.$lO=Si,e.$lO=Si=Je([S],Si);var Ki;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Ki||(e.InlineCompletionTriggerKind=Ki={}));let Oi=class{constructor(L,te){this.range=L,this.text=te}};e.$mO=Oi,e.$mO=Oi=Je([S],Oi);let Mi=class{constructor(L,te,Ee=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=Ee}};e.$nO=Mi,e.$nO=Mi=Je([S],Mi);let Pi=class{constructor(L,te){this.range=L,this.expression=te}};e.$oO=Pi,e.$oO=Pi=Je([S],Pi);let Ti=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};e.$pO=Ti,e.$pO=Ti=Je([S],Ti);var Fi;(function(j){j[j.AIGenerated=1]="AIGenerated"})(Fi||(e.NewSymbolNameTag=Fi={}));var Ji;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Ji||(e.NewSymbolNameTriggerKind=Ji={}));class Li{constructor(L,te){this.newSymbolName=L,this.tags=te}}e.$qO=Li;var Ii;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Ii||(e.FileChangeType=Ii={}));let zi=h=class extends Error{static FileExists(L){return new h(L,l.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(L){return new h(L,l.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(L){return new h(L,l.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(L){return new h(L,l.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(L){return new h(L,l.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(L){return new h(L,l.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}constructor(L,te=l.FileSystemProviderErrorCode.Unknown,Ee){super(E.URI.isUri(L)?L.toString(!0):L),this.code=Ee?.name??"Unknown",(0,l.$fl)(this,te),Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};e.$rO=zi,e.$rO=zi=h=Je([S],zi);let Ui=class{constructor(L,te,Ee){this.start=L,this.end=te,this.kind=Ee}};e.$sO=Ui,e.$sO=Ui=Je([S],Ui);var bi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(bi||(e.FoldingRangeKind=bi={}));var Qi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Qi||(e.CommentThreadCollapsibleState=Qi={}));var Zi;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Zi||(e.CommentMode=Zi={}));var Xi;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Xi||(e.CommentState=Xi={}));var Ci;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Ci||(e.CommentThreadState=Ci={}));var Yi;(function(j){j[j.Current=0]="Current",j[j.Outdated=1]="Outdated"})(Yi||(e.CommentThreadApplicability=Yi={}));class xi{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.$tO=xi;function dn(j){return typeof j>"u"||(0,m.$0f)(j)}class Ri{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,L){this.m=!0;for(let te=0,Ee=L.tokenTypes.length;te<Ee;te++)this.k.set(L.tokenTypes[te],te);for(let te=0,Ee=L.tokenModifiers.length;te<Ee;te++)this.l.set(L.tokenModifiers[te],te)}}push(L,te,Ee,Ke,Ye){if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.q(L,te,Ee,Ke,Ye);if(q.isRange(L)&&typeof te=="string"&&dn(Ee))return this.o(L,te,Ee);throw(0,O.$7)()}o(L,te,Ee){if(!this.m)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=L.start.line,Ye=L.start.character,lt=L.end.character-L.start.character,pt=this.k.get(te);let qt=0;if(Ee)for(const ai of Ee){if(!this.l.has(ai))throw new Error("`tokenModifier` is not in the provided legend");const hi=this.l.get(ai);qt|=1<<hi>>>0}this.q(Ke,Ye,lt,pt,qt)}q(L,te,Ee,Ke,Ye){if(this.f&&(L<this.c||L===this.c&&te<this.e)){this.f=!1;const qt=this.g.length/5|0;let ai=0,hi=0;for(let fi=0;fi<qt;fi++){let $i=this.g[5*fi],Gi=this.g[5*fi+1];$i===0?($i=ai,Gi+=hi):$i+=ai,this.g[5*fi]=$i,this.g[5*fi+1]=Gi,ai=$i,hi=Gi}}let lt=L,pt=te;this.f&&this.j>0&&(lt-=this.c,lt===0&&(pt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=pt,this.g[this.j++]=Ee,this.g[this.j++]=Ke,this.g[this.j++]=Ye,this.c=L,this.e=te}static r(L){const te=[],Ee=L.length/5|0;for(let pt=0;pt<Ee;pt++)te[pt]=pt;te.sort((pt,qt)=>{const ai=L[5*pt],hi=L[5*qt];if(ai===hi){const fi=L[5*pt+1],$i=L[5*qt+1];return fi-$i}return ai-hi});const Ke=new Uint32Array(L.length);let Ye=0,lt=0;for(let pt=0;pt<Ee;pt++){const qt=5*te[pt],ai=L[qt+0],hi=L[qt+1],fi=L[qt+2],$i=L[qt+3],Gi=L[qt+4],Fn=ai-Ye,gr=Fn===0?hi-lt:hi,Hi=5*pt;Ke[Hi+0]=Fn,Ke[Hi+1]=gr,Ke[Hi+2]=fi,Ke[Hi+3]=$i,Ke[Hi+4]=Gi,Ye=ai,lt=hi}return Ke}build(L){return this.f?new ji(new Uint32Array(this.g),L):new ji(Ri.r(this.g),L)}}e.$uO=Ri;class ji{constructor(L,te){this.resultId=te,this.data=L}}e.$vO=ji;class fn{constructor(L,te,Ee){this.start=L,this.deleteCount=te,this.data=Ee}}e.$wO=fn;class gn{constructor(L,te){this.resultId=te,this.edits=L}}e.$xO=gn;var _i;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(_i||(e.DebugConsoleMode=_i={}));class Bi{constructor(L){this.name=L}}e.$yO=Bi;let Ai=class{static{this.Back={iconPath:new ve("arrow-left")}}constructor(){}};e.$zO=Ai,e.$zO=Ai=Je([S],Ai);var ze;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(ze||(e.QuickPickItemKind=ze={}));var li;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(li||(e.InputBoxValidationSeverity=li={}));var Vi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Vi||(e.ExtensionKind=Vi={}));class nt{static validate(L){if(typeof L.badge=="string"){let te=(0,$.$Hf)(L.badge,0);if(te<L.badge.length&&(te+=(0,$.$Hf)(L.badge,te)),L.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!ve.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,te,Ee){this.badge=L,this.tooltip=te,this.color=Ee}}e.$AO=nt;let bt=class{constructor(L){this.kind=L}};e.$BO=bt,e.$BO=bt=Je([S],bt);var en;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(en||(e.ColorThemeKind=en={}));class di{static isNotebookRange(L){return L instanceof di?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,te){if(L<0)throw(0,O.$7)("start must be positive");if(te<0)throw(0,O.$7)("end must be positive");L<=te?(this.c=L,this.e=te):(this.c=te,this.e=L)}with(L){let te=this.c,Ee=this.e;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(Ee=L.end),te===this.c&&Ee===this.e?this:new di(te,Ee)}}e.$CO=di;class Ei{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>Ei.isNotebookCellData(te))}static isNotebookCellData(L){return!0}constructor(L,te,Ee,Ke,Ye,lt,pt){this.kind=L,this.value=te,this.languageId=Ee,this.mime=Ke,this.outputs=Ye??[],this.metadata=lt,this.executionSummary=pt,Ei.validate(this)}}e.$DO=Ei;class mn{constructor(L){this.cells=L}}e.$EO=mn;class ii{static isNotebookCellOutputItem(L){return L instanceof ii?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return ii.json(te,"application/vnd.code.notebook.error")}static stdout(L){return ii.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return ii.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new ii(L,te)}static#e=new TextEncoder;static text(L,te=A.$Qs.text){const Ee=ii.#e.encode(String(L));return new ii(Ee,te)}static json(L,te="text/x-json"){const Ee=JSON.stringify(L,void 0,"	");return ii.text(Ee,te)}constructor(L,te){this.data=L,this.mime=te;const Ee=(0,A.$Us)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.$FO=ii;class Ni{static isNotebookCellOutput(L){return L instanceof Ni?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,te=!1){const Ee=new Set,Ke=new Set;for(let Ye=0;Ye<L.length;Ye++){const lt=L[Ye],pt=(0,A.$Us)(lt.mime);if(!Ee.has(pt)||(0,f.$7K)(pt)){Ee.add(pt);continue}Ke.add(Ye),te&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ke.size===0?L:L.filter((Ye,lt)=>!Ke.has(lt))}constructor(L,te,Ee){this.items=Ni.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,T.$Sg)(),this.metadata=te??Ee)}}e.$GO=Ni;var tn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var Wi;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Wi||(e.NotebookCellStatusBarAlignment=Wi={}));var rn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(rn||(e.NotebookEditorRevealType=rn={}));class $n{constructor(L,te){this.text=L,this.alignment=te}}e.$HO=$n;var sn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var on;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(on||(e.NotebookControllerAffinity2=on={}));class pn{constructor(L,te=[]){this.uri=L,this.provides=(0,C.$2b)(te)}}e.$IO=pn;class wn{constructor(L){this.label=L}}e.$JO=wn;var an;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(an||(e.NotebookVariablesRequestKind=an={}));let qi=class{constructor(L,te){this.label=L,this.timestamp=te}};e.$KO=qi,e.$KO=qi=Je([S],qi);var cn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(cn||(e.ExtensionMode=cn={}));var un;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(un||(e.ExtensionRuntime=un={}));var ln;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(ln||(e.StandardTokenType=ln={}));class _{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.$LO=_;class se{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$MO=se;var Le;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Le||(e.TestResultState=Le={}));var rt;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(rt||(e.TestRunProfileKind=rt={}));let vt=class{constructor(L=void 0,te=void 0,Ee=void 0,Ke=!1,Ye=!0){this.include=L,this.exclude=te,this.profile=Ee,this.continuous=Ke,this.preserveFocus=Ye}};e.$NO=vt,e.$NO=vt=Je([S],vt);let Rt=D=class{static diff(L,te,Ee){const Ke=new D(L);return Ke.expectedOutput=te,Ke.actualOutput=Ee,Ke}constructor(L){this.message=L}};e.$OO=Rt,e.$OO=Rt=D=Je([S],Rt);let Di=class{constructor(L){this.id=L}};e.$PO=Di,e.$PO=Di=Je([S],Di);class hn{constructor(L,te){this.covered=L,this.total=te,vn(this)}}e.$QO=hn;function vn(j){if(j){if(j.covered>j.total)throw new Error(`The total number of covered items (${j.covered}) cannot be greater than the total (${j.total})`);if(j.total<0)throw new Error(`The number of covered items (${j.total}) cannot be negative`)}}class bn{static fromDetails(L,te){const Ee=new hn(0,0),Ke=new hn(0,0),Ye=new hn(0,0);for(const pt of te)if("branches"in pt){Ee.total+=1,Ee.covered+=pt.executed?1:0;for(const qt of pt.branches)Ke.total+=1,Ke.covered+=qt.executed?1:0}else Ye.total+=1,Ye.covered+=pt.executed?1:0;const lt=new bn(L,Ee,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return lt.detailedCoverage=te,lt}constructor(L,te,Ee,Ke){this.uri=L,this.statementCoverage=te,this.branchCoverage=Ee,this.declarationCoverage=Ke}}e.$SO=bn;class Ln{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,te,Ee=[]){this.executed=L,this.location=te,this.branches=Ee}}e.$TO=Ln;class zn{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,te,Ee){this.executed=L,this.location=te,this.label=Ee}}e.$UO=zn;class Un{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,te,Ee){this.name=L,this.executed=te,this.location=Ee}}e.$VO=Un;var yn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(yn||(e.ExternalUriOpenerPriority=yn={}));var En;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(En||(e.WorkspaceTrustState=En={}));var Dn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Dn||(e.PortAutoForwardAction=Dn={}));class jn{constructor(L,te,Ee,Ke,Ye,lt){this.kind=L,this.name=te,this.detail=Ee,this.uri=Ke,this.range=Ye,this.selectionRange=lt}}e.$WO=jn;class Bn{constructor(L){this.uri=L}}e.$XO=Bn;class Vn{constructor(L,te){this.original=L,this.modified=te}}e.$YO=Vn;class Wn{constructor(L,te,Ee,Ke){this.base=L,this.input1=te,this.input2=Ee,this.result=Ke}}e.$ZO=Wn;class qn{constructor(L,te){this.uri=L,this.viewType=te}}e.$1O=qn;class Gn{constructor(L){this.viewType=L}}e.$2O=Gn;class Hn{constructor(L,te){this.uri=L,this.notebookType=te}}e.$3O=Hn;class Kn{constructor(L,te,Ee){this.original=L,this.modified=te,this.notebookType=Ee}}e.$4O=Kn;class Jn{constructor(){}}e.$5O=Jn;class Qn{constructor(L,te){this.uri=L,this.inputBoxUri=te}}e.$6O=Qn;class Zn{constructor(){}}e.$7O=Zn;class Xn{constructor(L){this.textDiffs=L}}e.$8O=Xn;var kn;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(kn||(e.InteractiveSessionVoteDirection=kn={}));var Sn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(Sn||(e.ChatCopyKind=Sn={}));var Pn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(Pn||(e.ChatVariableLevel=Pn={}));class Yn{constructor(L,te){this.label=L,this.values=te}}e.$9O=Yn;var In;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(In||(e.InteractiveEditorResponseFeedbackKind=In={}));var Cn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(Cn||(e.ChatResultFeedbackKind=Cn={}));class xn{constructor(L){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new He(L):L}}e.$0O=xn;class _n{constructor(L,te){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new He(L):L,this.vulnerabilities=te}}e.$$O=_n;class er{constructor(L,te){this.participant=L,this.command=te}}e.$_O=er;class tr{constructor(L,te){this.value=L,this.baseUri=te}}e.$aP=tr;class ir{constructor(L,te){this.value=L,this.title=te}}e.$bP=ir;class nr{constructor(L){this.value=L}}e.$cP=nr;class rr{constructor(L){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new He(L):L}}e.$dP=rr;class sr{constructor(L){this.value=L}}e.$eP=sr;class or{constructor(L,te){this.value=L,this.iconPath=te}}e.$fP=or;class ar{constructor(L,te){this.uri=L,this.edits=Array.isArray(te)?te:[te]}}e.$gP=ar;class cr{constructor(L,te,Ee,Ke){this.prompt=L,this.command=te,this.variables=Ee,this.participant=Ke}}e.$hP=cr;class ur{constructor(L,te,Ee,Ke){this.response=L,this.result=te,this.participant=Ee,this.command=Ke}}e.$iP=ur;var Rn;(function(j){j[j.Panel=1]="Panel",j[j.Terminal=2]="Terminal",j[j.Notebook=3]="Notebook",j[j.Editor=4]="Editor"})(Rn||(e.ChatLocation=Rn={}));class lr{constructor(L){this.content=L}}e.$jP=lr;class hr{constructor(L,te){this.content=L,this.name=te}}e.$kP=hr;class dr{constructor(L,te){this.content=L,this.name=te}}e.$lP=dr;class vi extends Error{static NotFound(L){return new vi(L,vi.NotFound.name)}static NoPermissions(L){return new vi(L,vi.NoPermissions.name)}static Blocked(L){return new vi(L,vi.Blocked.name)}constructor(L,te,Ee){super(L,{cause:Ee}),this.name="LanguageModelError",this.code=te??""}}e.$mP=vi;var An;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(An||(e.RelatedInformationType=An={}));var Nn;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped",j[j.Error=5]="Error"})(Nn||(e.SpeechToTextStatus=Nn={}));var On;(function(j){j[j.Started=1]="Started",j[j.Stopped=2]="Stopped",j[j.Error=3]="Error"})(On||(e.TextToSpeechStatus=On={}));var Mn;(function(j){j[j.Recognized=1]="Recognized",j[j.Stopped=2]="Stopped"})(Mn||(e.KeywordRecognitionStatus=Mn={}));class fr{constructor(L,te){this.text=L,this.range=te}}e.$nP=fr;var Tn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Tn||(e.InlineEditTriggerKind=Tn={}))}),define(Se[257],Pe([1,0,4,7]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=void 0;class R{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$$M.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,$,m){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(A);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation($,m)??[]}getRelatedInformation(A,$,m){return this.c.$getAiRelatedInformation($,m)}registerRelatedInformationProvider(A,$,m){const E=this.b;return this.b++,this.a.set(E,m),this.c.$registerAiRelatedInformationProvider(E,$),new O.$aN(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$qlc=R}),define(Se[86],Pe([1,0,5,4,7,20,108,3,17]),function(le,e,C,O,R,M,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Clc=e.$Blc=void 0,e.$Blc=(0,$.$wi)("IExtHostAuthentication");let E=class{constructor(l){this.b=new Map,this.c=new C.$de,this.onDidChangeSessions=this.c.event,this.d=new T,this.f=new T,this.a=l.getProxy(O.$$M.MainThreadAuthentication)}async getSession(l,w,f,s={}){const r=M.$Rm.toKey(l.identifier),o=[...f].sort().join(" ");return await this.d.getOrCreate(`${r} ${w} ${o}`,async()=>{await this.a.$ensureProvider(w);const n=l.displayName||l.name;return this.a.$getSession(w,f,r,n,s)})}async getSessions(l,w,f){const s=M.$Rm.toKey(l.identifier),r=[...f].sort().join(" ");return await this.f.getOrCreate(`${s} ${r}`,async()=>{await this.a.$ensureProvider(w);const o=l.displayName||l.name;return this.a.$getSessions(w,f,s,o)})}async removeSession(l,w){const f=this.b.get(l);return f?f.provider.removeSession(w):this.a.$removeSession(l,w)}registerAuthenticationProvider(l,w,f,s){if(this.b.get(l))throw new Error(`An authentication provider with id '${l}' is already registered.`);this.b.set(l,{label:w,provider:f,options:s??{supportsMultipleAccounts:!1}});const r=f.onDidChangeSessions(o=>this.a.$sendDidChangeSessions(l,o));return this.a.$registerAuthenticationProvider(l,w,s?.supportsMultipleAccounts??!1),new R.$aN(()=>{r.dispose(),this.b.delete(l),this.a.$unregisterAuthenticationProvider(l)})}async $createSession(l,w,f){const s=this.b.get(l);if(s)return await s.provider.createSession(w,f);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $removeSession(l,w){const f=this.b.get(l);if(f)return await f.provider.removeSession(w);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $getSessions(l,w){const f=this.b.get(l);if(f)return await f.provider.getSessions(w);throw new Error(`Unable to find authentication provider with handle: ${l}`)}$onDidChangeAuthenticationSessions(l,w){return l.startsWith(A.$aM)||this.c.fire({provider:{id:l,label:w}}),Promise.resolve()}};e.$Clc=E,e.$Clc=E=Je([We(0,m.$zP)],E);class T{constructor(){this.a=new Map}getOrCreate(l,w){const f=this.a.get(l);if(f)return f;const s=w().finally(()=>this.a.delete(l));return this.a.set(l,s),s}}}),define(Se[112],Pe([1,0,2,4,7,3,17,12,18,13,19,26]),function(le,e,C,O,R,M,A,$,m,E,T,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=e.$Bmc=void 0;let w=class{static{l=this}static{this.c=0}static{this.d=250}constructor(s,r){this.h=r,this.f=new Map,this.g=s.getProxy(O.$$M.MainThreadDecorations)}registerFileDecorationProvider(s,r){const o=l.c++;this.f.set(o,{provider:s,extensionDescription:r}),this.g.$registerDecorationProvider(o,r.identifier.value);const n=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(o,null);return}const c=(0,m.$2b)(i);if(c.length<=l.d){this.g.$onDidChange(o,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",r.identifier.value,c.length);const u=c.map(a=>({uri:a,rank:(0,E.$af)(a.path,"/")})),t=(0,m.$zb)(u,(a,g)=>a.rank-g.rank||(0,E.$qf)(a.uri.path,g.uri.path)),d=[];e:for(const a of t){let g;for(const b of a){const p=(0,T.$mc)(b.uri.path);if(g!==p&&(g=p,d.push(b.uri)>=l.d))break e}}this.g.$onDidChange(o,d)});return new R.$aN(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(s,r,o){if(!this.f.has(s))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:c}=this.f.get(s);return await Promise.all(r.map(async u=>{try{const{uri:t,id:d}=u,a=await Promise.resolve(i.provideFileDecoration(C.URI.revive(t),o));if(!a)return;try{R.$AO.validate(a),a.badge&&typeof a.badge!="string"&&(0,k.$PG)(c,"codiconDecoration"),n[d]=[a.propagate,a.tooltip,a.badge,a.color]}catch(g){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${g}`)}}catch(t){this.h.error(t)}})),n}};e.$Bmc=w,e.$Bmc=w=l=Je([We(0,A.$zP),We(1,$.$3j)],w),e.$Cmc=(0,M.$wi)("IExtHostDecorations")}),define(Se[258],Pe([1,0,14,2,7,4,16,24,13]),function(le,e,C,O,R,M,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=void 0;class E{static{this.a=0}constructor(k,l,w){this.d=l,this.e=w,this.b=new Map,this.c=k.getProxy(M.$$M.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,l){if(Object.keys(A.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const w=E.a++;this.b.set(w,l),this.c.$registerTextContentProvider(w,k);let f;if(typeof l.onDidChange=="function"){let s;f=l.onDidChange(async r=>{if(r.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${r.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(r))return;s&&await s;const o=this.$provideTextDocumentContent(w,r).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(r);if(!i)return;const c=(0,m.$kf)(n);if(!i.equalLines(c))return this.c.$onVirtualDocumentChange(r,n)}).catch(C.$1).finally(()=>{s===o&&(s=void 0)});s=o})}return new R.$aN(()=>{this.b.delete(w)&&this.c.$unregisterTextContentProvider(w),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(k,l){const w=this.b.get(k);return w?Promise.resolve(w.provideTextDocumentContent(O.URI.revive(l),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$Emc=E}),define(Se[113],Pe([1,0,57,16,13,313,159,7,18]),function(le,e,C,O,R,M,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=e.$CP=void 0,e.$BP=T;const E=new Map;function T(f,s){s?E.set(f,s):E.delete(f)}function k(f){return E.get(f)}class l extends M.$6v{constructor(s,r,o,n,i,c,u){super(r,o,n,i),this.c=s,this.m=c,this.q=u,this.b=!1}dispose(){(0,C.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,m.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===O.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(r){return r?s.s(r):s.getText()},get eol(){return s.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(r){return s.t(r)},offsetAt(r){return s.u(r)},positionAt(r){return s.v(r)},validateRange(r){return s.w(r)},validatePosition(r){return s.x(r)},getWordRangeAtPosition(r,o){return s.y(r,o)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,C.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,C.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const r=this.w(s);if(r.isEmpty)return"";if(r.isSingleLine)return this.f[r.start.line].substring(r.start.character,r.end.character);const o=this.g,n=r.start.line,i=r.end.line,c=[];c.push(this.f[n].substring(r.start.character));for(let u=n+1;u<i;u++)c.push(this.f[u]);return c.push(this.f[i].substring(0,r.end.character)),c.join(o)}t(s){let r;if(s instanceof $.$bN?r=s.line:typeof s=="number"&&(r=s),typeof r!="number"||r<0||r>=this.f.length||Math.floor(r)!==r)throw new Error("Illegal value for `line`");return new w(r,this.f[r],r===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const r=this.j.getIndexOf(s),o=this.f[r.index].length;return new $.$bN(r.index,Math.min(r.remainder,o))}w(s){if(!(s instanceof $.$cN))throw new Error("Invalid argument");const r=this.x(s.start),o=this.x(s.end);return r===s.start&&o===s.end?s:new $.$cN(r.line,r.character,o.line,o.character)}x(s){if(!(s instanceof $.$bN))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:r,character:o}=s,n=!1;if(r<0)r=0,o=0,n=!0;else if(r>=this.f.length)r=this.f.length-1,o=this.f[r].length,n=!0;else{const i=this.f[r].length;o<0?(o=0,n=!0):o>i&&(o=i,n=!0)}return n?new $.$bN(r,o):s}y(s,r){const o=this.x(s);if(!r)r=k(this.m);else if((0,R.$jf)(r))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${r.source}' because it matches the empty string.`);const n=(0,A.$9s)(o.character+1,(0,A.$7s)(r),this.f[o.line],0);if(n)return new $.$cN(o.line,n.startColumn-1,o.line,n.endColumn-1)}}e.$CP=l;class w{constructor(s,r,o){this.a=s,this.b=r,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$cN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$cN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$DP=w}),define(Se[259],Pe([1,0,4,7]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=void 0;class R{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$$M.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,$,m){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(A);if(!E)throw new Error("Embedding vector provider not found");const T=await E.provideEmbeddingVector($,m);if(!T)throw new Error("Embedding vector provider returned undefined");return T}registerEmbeddingVectorProvider(A,$,m){const E=this.b;return this.b++,this.a.set(E,m),this.c.$registerAiEmbeddingVectorProvider($,E),new O.$aN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$Gmc=R}),define(Se[65],Pe([1,0,4,38,7,21,3,17,46,6,11,23,16]),function(le,e,C,O,R,M,A,$,m,E,T,k,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=e.$Rlc=void 0;let f=w=class{constructor(r,o){this.b=new Map,this.c=new T.$Fh,this.a=r.getProxy(C.$$M.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let c;const u=n.b.get(i.scheme);return u?(await n.a.$ensureActivation(i.scheme),c=await u.impl.stat(i)):c=await n.a.$stat(i),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===O.FilePermission.Readonly?1:void 0}}catch(c){w.e(c)}},async readDirectory(i){try{const c=n.b.get(i.scheme);return c?(await n.a.$ensureActivation(i.scheme),(await c.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(c){return w.e(c)}},async createDirectory(i){try{const c=n.b.get(i.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(c.impl,c.extUri,i)):await n.a.$mkdir(i)}catch(c){return w.e(c)}},async readFile(i){try{const c=n.b.get(i.scheme);return c?(await n.a.$ensureActivation(i.scheme),(await c.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(c){return w.e(c)}},async writeFile(i,c){try{const u=n.b.get(i.scheme);return u&&!u.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(u.impl,u.extUri,u.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(u.impl.writeFile(i,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,M.$Fe.wrap(c))}catch(u){return w.e(u)}},async delete(i,c){try{const u=n.b.get(i.scheme);return u&&!u.isReadonly&&!c?.useTrash?(await n.a.$ensureActivation(i.scheme),await u.impl.delete(i,{recursive:!1,...c})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(u){return w.e(u)}},async rename(i,c,u){try{return await n.a.$rename(i,c,{overwrite:!1,...u})}catch(t){return w.e(t)}},async copy(i,c,u){try{return await n.a.$copy(i,c,{overwrite:!1,...u})}catch(t){return w.e(t)}},isWritableFileSystem(i){const c=o.getCapabilities(i);if(typeof c=="number")return!(c&2048)}})}async d(r,o,n){const i=[];for(;!o.isEqual(n,o.dirname(n));)try{if(!((await r.stat(n)).type&O.FileType.Directory))throw R.$rO.FileExists(`Unable to create folder '${n.scheme===l.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(O.$gl(c)!==O.FileSystemProviderErrorCode.FileNotFound)throw c;i.push(o.basename(n)),n=o.dirname(n)}for(let c=i.length-1;c>=0;c--){n=o.joinPath(n,i[c]);try{await r.createDirectory(n)}catch(u){if(O.$gl(u)!==O.FileSystemProviderErrorCode.FileExists)throw u}}}static e(r){if(r instanceof R.$rO)throw r;if(r instanceof O.$cl)switch(r.code){case O.FileSystemProviderErrorCode.FileExists:throw R.$rO.FileExists(r.message);case O.FileSystemProviderErrorCode.FileNotFound:throw R.$rO.FileNotFound(r.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw R.$rO.FileNotADirectory(r.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw R.$rO.FileIsADirectory(r.message);case O.FileSystemProviderErrorCode.NoPermissions:throw R.$rO.NoPermissions(r.message);case O.FileSystemProviderErrorCode.Unavailable:throw R.$rO.Unavailable(r.message);default:throw new R.$rO(r.message,r.name)}if(!(r instanceof Error))throw new R.$rO(String(r));if(r.name==="ENOPRO"||r.message.includes("ENOPRO"))throw R.$rO.Unavailable(r.message);switch(r.name){case O.FileSystemProviderErrorCode.FileExists:throw R.$rO.FileExists(r.message);case O.FileSystemProviderErrorCode.FileNotFound:throw R.$rO.FileNotFound(r.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw R.$rO.FileNotADirectory(r.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw R.$rO.FileIsADirectory(r.message);case O.FileSystemProviderErrorCode.NoPermissions:throw R.$rO.NoPermissions(r.message);case O.FileSystemProviderErrorCode.Unavailable:throw R.$rO.Unavailable(r.message);default:throw new R.$rO(r.message,r.name)}}addFileSystemProvider(r,o,n){return this.b.set(r,{impl:o,extUri:n?.isCaseSensitive?k.$Zg:k.$2g,isReadonly:!!n?.isReadonly}),(0,E.$Sc)(()=>this.b.delete(r))}getFileSystemProviderExtUri(r){return this.b.get(r)?.extUri??k.$Zg}};e.$Rlc=f,e.$Rlc=f=w=Je([We(0,$.$zP),We(1,m.$vlc)],f),e.$Slc=(0,A.$wi)("IExtHostConsumerFileSystem")}),define(Se[87],Pe([1,0,3,27,12,65,2]),function(le,e,C,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=e.$Tlc=void 0,e.$Tlc=(0,C.$wi)("IExtensionStoragePaths");let $=class{constructor(E,T,k){this.d=T,this.f=k,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(E){return A.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,T=await this.g(E);try{return await this.f.value.stat(T),this.d.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",T),await this.f.value.createDirectory(T),await this.f.value.writeFile(A.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),T}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(E){if(this.c)return A.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return A.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Ulc=$,e.$Ulc=$=Je([We(0,O.$PP),We(1,R.$3j),We(2,M.$Slc)],$)}),define(Se[260],Pe([1,0,7,17,5]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pnc=void 0;let M=class{constructor($){this.a=new C.$BO(C.ColorThemeKind.Dark),this.b=new R.$de}get activeColorTheme(){return this.a}$onColorThemeChange($){let m;switch($){case"light":m=C.ColorThemeKind.Light;break;case"hcDark":m=C.ColorThemeKind.HighContrast;break;case"hcLight":m=C.ColorThemeKind.HighContrastLight;break;default:m=C.ColorThemeKind.Dark}this.a=new C.$BO(m),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$pnc=M,e.$pnc=M=Je([We(0,O.$zP)],M)}),define(Se[88],Pe([1,0,24,5,6,182,3,12,211,4,27,17,7]),function(le,e,C,O,R,M,A,$,m,E,T,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tDb=e.$sDb=e.TunnelDtoConverter=void 0;class w extends m.$sw{}var f;(function(r){function o(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:i.protocol}}r.fromApiTunnel=o;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==m.TunnelPrivacyId.ConstantPrivate&&i.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}r.fromServiceTunnel=n})(f||(e.TunnelDtoConverter=f={})),e.$sDb=(0,A.$wi)("IExtHostTunnelService");let s=class extends R.$Uc{constructor(o,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$de,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(E.$$M.MainThreadTunnelService)}async openTunnel(o,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,o.displayName);if(i){const c=new w(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,n){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:o,provider:n}),this.a.$registerPortsAttributesProvider(o,i),new l.$aN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(o,n,i,c,u){const t=[];for(const a of o){const g=this.r.get(a);if(!g)return[];t.push(...await Promise.all(n.map(async b=>{let p;try{p=await g.provider.providePortAttributes({port:b,pid:i,commandLine:c},u)}catch{p=await g.provider.providePortAttributes(b,i,c,u)}return{providedAttributes:p,port:b}})))}const d=t.filter(a=>!!a.providedAttributes);return d.length>0?d.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,u)=>await o.provideTunnel(c,u,C.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,R.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,n){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const i=o.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let c=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const u=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(u)}}else this.b=void 0;return(0,R.$Sc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,n){if(this.g.has(o.host)){const i=this.g.get(o.host);i.has(o.port)&&(n&&i.get(o.port).disposeListener.dispose(),await i.get(o.port).tunnel.dispose(),i.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(o,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const c=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const u=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:c,disposeListener:u}),f.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(o){const n=await Promise.all(o.map(c=>this.f(c.host,c.port,c.detail??""))),i=o.filter((c,u)=>n[u]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(c=>c.port).join(", ")} to ${i.map(c=>c.port).join(", ")}`),i}};e.$tDb=s,e.$tDb=s=Je([We(0,k.$zP),We(1,T.$PP),We(2,$.$3j)],s)}),define(Se[8],Pe([1,0,18,21,138,261,55,28,127,49,70,25,133,23,36,15,2,30,89,101,107,106,224,85,52,62,235,7]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r,o,n,i,c,u,t,d,a,g,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$wP=K,e.$xP=ce,e.$yP=ye;var v;(function(ve){function Ie(J){const{selectionStartLineNumber:Re,selectionStartColumn:Ve,positionLineNumber:Ze,positionColumn:qe}=J,ut=new p.$bN(Re-1,Ve-1),yt=new p.$bN(Ze-1,qe-1);return new p.$dN(ut,yt)}ve.to=Ie;function oe(J){const{anchor:Re,active:Ve}=J;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}ve.from=oe})(v||(e.Selection=v={}));var y;(function(ve){function Ie(J){if(!J)return;const{start:Re,end:Ve}=J;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}ve.from=Ie;function oe(J){if(!J)return;const{startLineNumber:Re,startColumn:Ve,endLineNumber:Ze,endColumn:qe}=J;return new p.$cN(Re-1,Ve-1,Ze-1,qe-1)}ve.to=oe})(y||(e.Range=y={}));var h;(function(ve){function Ie(J){return{uri:J.uri,range:y.from(J.range)}}ve.from=Ie;function oe(J){return new p.$mN(r.URI.revive(J.uri),y.to(J.range))}ve.to=oe})(h||(e.Location=h={}));var D;(function(ve){function Ie(oe){switch(oe){case 1:return p.StandardTokenType.Comment;case 0:return p.StandardTokenType.Other;case 3:return p.StandardTokenType.RegEx;case 2:return p.StandardTokenType.String}}ve.to=Ie})(D||(e.TokenType=D={}));var S;(function(ve){function Ie(J){return new p.$bN(J.lineNumber-1,J.column-1)}ve.to=Ie;function oe(J){return{lineNumber:J.line+1,column:J.character+1}}ve.from=oe})(S||(e.Position=S={}));var I;(function(ve){function Ie(Re,Ve,Ze){return(0,C.$Hb)((0,C.$2b)(Re).map(qe=>oe(qe,Ve,Ze)))}ve.from=Ie;function oe(Re,Ve,Ze){if(typeof Re=="string")return{$serialized:!0,language:Re,isBuiltin:Ze?.isBuiltin};if(Re)return{$serialized:!0,language:Re.language,scheme:J(Re.scheme,Ve),pattern:me.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType,isBuiltin:Ze?.isBuiltin}}function J(Re,Ve){return Ve&&typeof Re=="string"?Ve.transformOutgoingScheme(Re):Re}})(I||(e.DocumentSelector=I={}));var P;(function(ve){function Ie(J){switch(J){case p.DiagnosticTag.Unnecessary:return 1;case p.DiagnosticTag.Deprecated:return 2}}ve.from=Ie;function oe(J){switch(J){case 1:return p.DiagnosticTag.Unnecessary;case 2:return p.DiagnosticTag.Deprecated;default:return}}ve.to=oe})(P||(e.DiagnosticTag=P={}));var W;(function(ve){function Ie(J){let Re;return J.code&&((0,s.$9f)(J.code)||(0,s.$ag)(J.code)?Re=String(J.code):Re={value:String(J.code.value),target:J.code.target}),{...y.from(J.range),message:J.message,source:J.source,code:Re,severity:q.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(V.from),tags:Array.isArray(J.tags)?(0,C.$Hb)(J.tags.map(P.from)):void 0}}ve.from=Ie;function oe(J){const Re=new p.$oN(y.to(J),J.message,q.to(J.severity));return Re.source=J.source,Re.code=(0,s.$9f)(J.code)?J.code:J.code?.value,Re.relatedInformation=J.relatedInformation&&J.relatedInformation.map(V.to),Re.tags=J.tags&&(0,C.$Hb)(J.tags.map(P.to)),Re}ve.to=oe})(W||(e.Diagnostic=W={}));var V;(function(ve){function Ie(J){return{...y.from(J.location.range),message:J.message,resource:J.location.uri}}ve.from=Ie;function oe(J){return new p.$nN(new p.$mN(J.resource,y.to(J)),J.message)}ve.to=oe})(V||(e.DiagnosticRelatedInformation=V={}));var q;(function(ve){function Ie(J){switch(J){case p.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case p.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case p.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case p.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}ve.from=Ie;function oe(J){switch(J){case i.MarkerSeverity.Info:return p.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return p.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return p.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return p.DiagnosticSeverity.Hint;default:return p.DiagnosticSeverity.Error}}ve.to=oe})(q||(e.DiagnosticSeverity=q={}));var N;(function(ve){function Ie(J){return typeof J=="number"&&J>=p.ViewColumn.One?J-1:J===p.ViewColumn.Beside?b.$5D:b.$4D}ve.from=Ie;function oe(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=oe})(N||(e.ViewColumn=N={}));function B(ve){return typeof ve.range<"u"}function K(ve){return ve.length===0?!0:!!B(ve[0])}var ie;(function(ve){function Ie(qe){return qe.map(ve.from)}ve.fromMany=Ie;function oe(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function J(qe){let ut;if(oe(qe)){const{language:st,value:Jt}=qe;ut={value:"```"+st+`
`+Jt+"\n```\n"}}else p.$CN.isMarkdownString(qe)?ut={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ut={value:qe}:ut={value:""};const yt=Object.create(null);ut.uris=yt;const Lt=st=>{try{let Jt=r.URI.parse(st,!0);Jt=Jt.with({query:Re(Jt.query,yt)}),yt[st]=Jt}catch{}return""},Bt=new m.marked.Renderer;return Bt.link=Lt,Bt.image=st=>typeof st=="string"?Lt(A.$2k(st).href):"",(0,m.marked)(ut.value,{renderer:Bt}),ut}ve.from=J;function Re(qe,ut){if(!qe)return qe;let yt;try{yt=(0,E.$5h)(qe)}catch{}if(!yt)return qe;let Lt=!1;return yt=(0,k.$5n)(yt,Bt=>{if(r.URI.isUri(Bt)){const st=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[st]=Bt,Lt=!0,st}else return}),Lt?JSON.stringify(yt):qe}function Ve(qe){const ut=new p.$CN(qe.value,qe.supportThemeIcons);return ut.isTrusted=qe.isTrusted,ut.supportHtml=qe.supportHtml,ut.baseUri=qe.baseUri?r.URI.from(qe.baseUri):void 0,ut}ve.to=Ve;function Ze(qe){if(qe)return typeof qe=="string"?qe:ve.from(qe)}ve.fromStrict=Ze})(ie||(e.MarkdownString=ie={}));function ce(ve){return K(ve)?ve.map(Ie=>({range:y.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?ie.fromMany(Ie.hoverMessage):Ie.hoverMessage?ie.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):ve.map(Ie=>({range:y.from(Ie)}))}function ye(ve){return typeof ve>"u"?ve:typeof ve=="string"?r.URI.file(ve):ve}var ke;(function(ve){function Ie(oe){return typeof oe>"u"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?ye(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}ve.from=Ie})(ke||(e.ThemableDecorationAttachmentRenderOptions=ke={}));var fe;(function(ve){function Ie(oe){return typeof oe>"u"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?ye(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?ke.from(oe.before):void 0,after:oe.after?ke.from(oe.after):void 0}}ve.from=Ie})(fe||(e.ThemableDecorationRenderOptions=fe={}));var $e;(function(ve){function Ie(oe){if(typeof oe>"u")return oe;switch(oe){case p.DecorationRangeBehavior.OpenOpen:return 0;case p.DecorationRangeBehavior.ClosedClosed:return 1;case p.DecorationRangeBehavior.OpenClosed:return 2;case p.DecorationRangeBehavior.ClosedOpen:return 3}}ve.from=Ie})($e||(e.DecorationRangeBehavior=$e={}));var Te;(function(ve){function Ie(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?$e.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?fe.from(oe.light):void 0,dark:oe.dark?fe.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?ye(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?ke.from(oe.before):void 0,after:oe.after?ke.from(oe.after):void 0}}ve.from=Ie})(Te||(e.DecorationRenderOptions=Te={}));var ae;(function(ve){function Ie(J){return{text:J.newText,eol:J.newEol&&gt.from(J.newEol),range:y.from(J.range)}}ve.from=Ie;function oe(J){const Re=new p.$hN(y.to(J.range),J.text);return Re.newEol=typeof J.eol>"u"?void 0:gt.to(J.eol),Re}ve.to=oe})(ae||(e.TextEdit=ae={}));var Ne;(function(ve){function Ie(J,Re){const Ve={edits:[]};if(J instanceof p.$kN){const Ze=new $.$Bc;for(const qe of J._allEntries())qe._type===1&&r.URI.isUri(qe.to)&&qe.from===void 0&&Ze.add(qe.to);for(const qe of J._allEntries())if(qe._type===1){let ut;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ut={type:"base64",value:(0,O.$Ze)(O.$Fe.wrap(qe.options.contents))}:ut={type:"dataTransferItem",id:qe.options.contents._itemId}),Ve.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ut},metadata:qe.metadata})}else qe._type===2?Ve.edits.push({resource:qe.uri,textEdit:ae.from(qe.edit),versionId:Ze.has(qe.uri)?void 0:Re?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Ve.edits.push({resource:qe.uri,textEdit:{range:y.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Ze.has(qe.uri)?void 0:Re?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Ve.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Ve.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Re?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(ni.from)}})}return Ve}ve.from=Ie;function oe(J){const Re=new p.$kN,Ve=new $.$Ac;for(const Ze of J.edits)if(Ze.textEdit){const qe=Ze,ut=r.URI.revive(qe.resource),yt=y.to(qe.textEdit.range),Lt=qe.textEdit.text,Bt=qe.textEdit.insertAsSnippet;let st;Bt?st=p.$jN.replace(yt,new p.$lN(Lt)):st=p.$hN.replace(yt,Lt);const Jt=Ve.get(ut);Jt?Jt.push(st):Ve.set(ut,[st])}else Re.renameFile(r.URI.revive(Ze.oldResource),r.URI.revive(Ze.newResource),Ze.options);for(const[Ze,qe]of Ve)Re.set(Ze,qe);return Re}ve.to=oe})(Ne||(e.WorkspaceEdit=Ne={}));var ne;(function(ve){const Ie=Object.create(null);Ie[p.SymbolKind.File]=0,Ie[p.SymbolKind.Module]=1,Ie[p.SymbolKind.Namespace]=2,Ie[p.SymbolKind.Package]=3,Ie[p.SymbolKind.Class]=4,Ie[p.SymbolKind.Method]=5,Ie[p.SymbolKind.Property]=6,Ie[p.SymbolKind.Field]=7,Ie[p.SymbolKind.Constructor]=8,Ie[p.SymbolKind.Enum]=9,Ie[p.SymbolKind.Interface]=10,Ie[p.SymbolKind.Function]=11,Ie[p.SymbolKind.Variable]=12,Ie[p.SymbolKind.Constant]=13,Ie[p.SymbolKind.String]=14,Ie[p.SymbolKind.Number]=15,Ie[p.SymbolKind.Boolean]=16,Ie[p.SymbolKind.Array]=17,Ie[p.SymbolKind.Object]=18,Ie[p.SymbolKind.Key]=19,Ie[p.SymbolKind.Null]=20,Ie[p.SymbolKind.EnumMember]=21,Ie[p.SymbolKind.Struct]=22,Ie[p.SymbolKind.Event]=23,Ie[p.SymbolKind.Operator]=24,Ie[p.SymbolKind.TypeParameter]=25;function oe(Re){return typeof Ie[Re]=="number"?Ie[Re]:6}ve.from=oe;function J(Re){for(const Ve in Ie)if(Ie[Ve]===Re)return Number(Ve);return p.SymbolKind.Property}ve.to=J})(ne||(e.SymbolKind=ne={}));var z;(function(ve){function Ie(J){switch(J){case p.SymbolTag.Deprecated:return 1}}ve.from=Ie;function oe(J){switch(J){case 1:return p.SymbolTag.Deprecated}}ve.to=oe})(z||(e.SymbolTag=z={}));var x;(function(ve){function Ie(J){return{name:J.name,kind:ne.from(J.kind),tags:J.tags&&J.tags.map(z.from),containerName:J.containerName,location:ge.from(J.location)}}ve.from=Ie;function oe(J){const Re=new p.$tN(J.name,ne.to(J.kind),J.containerName,ge.to(J.location));return Re.tags=J.tags&&J.tags.map(z.to),Re}ve.to=oe})(x||(e.WorkspaceSymbol=x={}));var be;(function(ve){function Ie(J){const Re={name:J.name||"!!MISSING: name!!",detail:J.detail,range:y.from(J.range),selectionRange:y.from(J.selectionRange),kind:ne.from(J.kind),tags:J.tags?.map(z.from)??[]};return J.children&&(Re.children=J.children.map(Ie)),Re}ve.from=Ie;function oe(J){const Re=new p.$uN(J.name,J.detail,ne.to(J.kind),y.to(J.range),y.to(J.selectionRange));return(0,C.$Lb)(J.tags)&&(Re.tags=J.tags.map(z.to)),J.children&&(Re.children=J.children.map(oe)),Re}ve.to=oe})(be||(e.DocumentSymbol=be={}));var Fe;(function(ve){function Ie(J){const Re=new p.$yN(ne.to(J.kind),J.name,J.detail||"",r.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return Re._sessionId=J._sessionId,Re._itemId=J._itemId,Re}ve.to=Ie;function oe(J,Re,Ve){if(Re=Re??J._sessionId,Ve=Ve??J._itemId,Re===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Ve,name:J.name,detail:J.detail,kind:ne.from(J.kind),uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(z.from)}}ve.from=oe})(Fe||(e.CallHierarchyItem=Fe={}));var De;(function(ve){function Ie(oe){return new p.$zN(Fe.to(oe.from),oe.fromRanges.map(J=>y.to(J)))}ve.to=Ie})(De||(e.CallHierarchyIncomingCall=De={}));var pe;(function(ve){function Ie(oe){return new p.$AN(Fe.to(oe.to),oe.fromRanges.map(J=>y.to(J)))}ve.to=Ie})(pe||(e.CallHierarchyOutgoingCall=pe={}));var ge;(function(ve){function Ie(J){return{range:J.range&&y.from(J.range),uri:J.uri}}ve.from=Ie;function oe(J){return new p.$mN(r.URI.revive(J.uri),y.to(J.range))}ve.to=oe})(ge||(e.location=ge={}));var Q;(function(ve){function Ie(J){const Re=J,Ve=J;return{originSelectionRange:Re.originSelectionRange?y.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Ve.uri,range:y.from(Re.targetRange?Re.targetRange:Ve.range),targetSelectionRange:Re.targetSelectionRange?y.from(Re.targetSelectionRange):void 0}}ve.from=Ie;function oe(J){return{targetUri:r.URI.revive(J.uri),targetRange:y.to(J.range),targetSelectionRange:J.targetSelectionRange?y.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?y.to(J.originSelectionRange):void 0}}ve.to=oe})(Q||(e.DefinitionLink=Q={}));var Y;(function(ve){function Ie(J){return{range:y.from(J.range),contents:ie.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}ve.from=Ie;function oe(J){const Re=J.contents.map(ie.to),Ve=y.to(J.range),Ze=J.canIncreaseVerbosity,qe=J.canDecreaseVerbosity;return new p.$qN(Re,Ve,Ze,qe)}ve.to=oe})(Y||(e.Hover=Y={}));var he;(function(ve){function Ie(J){return{range:y.from(J.range),expression:J.expression}}ve.from=Ie;function oe(J){return new p.$lO(y.to(J.range),J.expression)}ve.to=oe})(he||(e.EvaluatableExpression=he={}));var ue;(function(ve){function Ie(J){if(J instanceof p.$mO)return{type:"text",range:y.from(J.range),text:J.text};if(J instanceof p.$nO)return{type:"variable",range:y.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof p.$oO)return{type:"expression",range:y.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=Ie;function oe(J){switch(J.type){case"text":return{range:y.to(J.range),text:J.text};case"variable":return{range:y.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:y.to(J.range),expression:J.expression}}}ve.to=oe})(ue||(e.InlineValue=ue={}));var Me;(function(ve){function Ie(J){return{frameId:J.frameId,stoppedLocation:y.from(J.stoppedLocation)}}ve.from=Ie;function oe(J){return new p.$pO(J.frameId,y.to(J.stoppedLocation))}ve.to=oe})(Me||(e.InlineValueContext=Me={}));var de;(function(ve){function Ie(J){return{range:y.from(J.range),kind:J.kind}}ve.from=Ie;function oe(J){return new p.$rN(y.to(J.range),J.kind)}ve.to=oe})(de||(e.DocumentHighlight=de={}));var Ce;(function(ve){function Ie(J){return{uri:J.uri,highlights:J.highlights.map(de.from)}}ve.from=Ie;function oe(J){return new p.$sN(r.URI.revive(J.uri),J.highlights.map(de.to))}ve.to=oe})(Ce||(e.MultiDocumentHighlight=Ce={}));var Ae;(function(ve){function Ie(oe){switch(oe){case 1:return p.CompletionTriggerKind.TriggerCharacter;case 2:return p.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return p.CompletionTriggerKind.Invoke}}ve.to=Ie})(Ae||(e.CompletionTriggerKind=Ae={}));var je;(function(ve){function Ie(oe){return{triggerKind:Ae.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}ve.to=Ie})(je||(e.CompletionContext=je={}));var U;(function(ve){function Ie(J){switch(J){case p.CompletionItemTag.Deprecated:return 1}}ve.from=Ie;function oe(J){switch(J){case 1:return p.CompletionItemTag.Deprecated}}ve.to=oe})(U||(e.CompletionItemTag=U={}));var F;(function(ve){const Ie=new Map([[p.CompletionItemKind.Method,0],[p.CompletionItemKind.Function,1],[p.CompletionItemKind.Constructor,2],[p.CompletionItemKind.Field,3],[p.CompletionItemKind.Variable,4],[p.CompletionItemKind.Class,5],[p.CompletionItemKind.Interface,7],[p.CompletionItemKind.Struct,6],[p.CompletionItemKind.Module,8],[p.CompletionItemKind.Property,9],[p.CompletionItemKind.Unit,12],[p.CompletionItemKind.Value,13],[p.CompletionItemKind.Constant,14],[p.CompletionItemKind.Enum,15],[p.CompletionItemKind.EnumMember,16],[p.CompletionItemKind.Keyword,17],[p.CompletionItemKind.Snippet,27],[p.CompletionItemKind.Text,18],[p.CompletionItemKind.Color,19],[p.CompletionItemKind.File,20],[p.CompletionItemKind.Reference,21],[p.CompletionItemKind.Folder,23],[p.CompletionItemKind.Event,10],[p.CompletionItemKind.Operator,11],[p.CompletionItemKind.TypeParameter,24],[p.CompletionItemKind.Issue,26],[p.CompletionItemKind.User,25]]);function oe(Ve){return Ie.get(Ve)??9}ve.from=oe;const J=new Map([[0,p.CompletionItemKind.Method],[1,p.CompletionItemKind.Function],[2,p.CompletionItemKind.Constructor],[3,p.CompletionItemKind.Field],[4,p.CompletionItemKind.Variable],[5,p.CompletionItemKind.Class],[7,p.CompletionItemKind.Interface],[6,p.CompletionItemKind.Struct],[8,p.CompletionItemKind.Module],[9,p.CompletionItemKind.Property],[12,p.CompletionItemKind.Unit],[13,p.CompletionItemKind.Value],[14,p.CompletionItemKind.Constant],[15,p.CompletionItemKind.Enum],[16,p.CompletionItemKind.EnumMember],[17,p.CompletionItemKind.Keyword],[27,p.CompletionItemKind.Snippet],[18,p.CompletionItemKind.Text],[19,p.CompletionItemKind.Color],[20,p.CompletionItemKind.File],[21,p.CompletionItemKind.Reference],[23,p.CompletionItemKind.Folder],[10,p.CompletionItemKind.Event],[11,p.CompletionItemKind.Operator],[24,p.CompletionItemKind.TypeParameter],[25,p.CompletionItemKind.User],[26,p.CompletionItemKind.Issue]]);function Re(Ve){return J.get(Ve)??p.CompletionItemKind.Property}ve.to=Re})(F||(e.CompletionItemKind=F={}));var G;(function(ve){function Ie(oe,J){const Re=new p.$IN(oe.label);return Re.insertText=oe.insertText,Re.kind=F.to(oe.kind),Re.tags=oe.tags?.map(U.to),Re.detail=oe.detail,Re.documentation=A.$Vk(oe.documentation)?ie.to(oe.documentation):oe.documentation,Re.sortText=oe.sortText,Re.filterText=oe.filterText,Re.preselect=oe.preselect,Re.commitCharacters=oe.commitCharacters,o.$ut.isIRange(oe.range)?Re.range=y.to(oe.range):typeof oe.range=="object"&&(Re.range={inserting:y.to(oe.range.insert),replacing:y.to(oe.range.replace)}),Re.keepWhitespace=typeof oe.insertTextRules>"u"?!1:!!(oe.insertTextRules&1),typeof oe.insertTextRules<"u"&&oe.insertTextRules&4?Re.insertText=new p.$lN(oe.insertText):(Re.insertText=oe.insertText,Re.textEdit=Re.range instanceof p.$cN?new p.$hN(Re.range,Re.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(Re.additionalTextEdits=oe.additionalTextEdits.map(Ve=>ae.to(Ve))),Re.command=J&&oe.command?J.fromInternal(oe.command):void 0,Re}ve.to=Ie})(G||(e.CompletionItem=G={}));var H;(function(ve){function Ie(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:ie.fromStrict(J.documentation)}}ve.from=Ie;function oe(J){return{label:J.label,documentation:A.$Vk(J.documentation)?ie.to(J.documentation):J.documentation}}ve.to=oe})(H||(e.ParameterInformation=H={}));var ee;(function(ve){function Ie(J){return{label:J.label,documentation:ie.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(H.from):[],activeParameter:J.activeParameter}}ve.from=Ie;function oe(J){return{label:J.label,documentation:A.$Vk(J.documentation)?ie.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(H.to):[],activeParameter:J.activeParameter}}ve.to=oe})(ee||(e.SignatureInformation=ee={}));var re;(function(ve){function Ie(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.from):[]}}ve.from=Ie;function oe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.to):[]}}ve.to=oe})(re||(e.SignatureHelp=re={}));var Oe;(function(ve){function Ie(oe,J){const Re=new p.$HN(S.to(J.position),typeof J.label=="string"?J.label:J.label.map(Be.to.bind(void 0,oe)),J.kind&&He.to(J.kind));return Re.textEdits=J.textEdits&&J.textEdits.map(ae.to),Re.tooltip=A.$Vk(J.tooltip)?ie.to(J.tooltip):J.tooltip,Re.paddingLeft=J.paddingLeft,Re.paddingRight=J.paddingRight,Re}ve.to=Ie})(Oe||(e.InlayHint=Oe={}));var Be;(function(ve){function Ie(oe,J){const Re=new p.$GN(J.label);return Re.tooltip=A.$Vk(J.tooltip)?ie.to(J.tooltip):J.tooltip,n.Command.is(J.command)&&(Re.command=oe.fromInternal(J.command)),J.location&&(Re.location=ge.to(J.location)),Re}ve.to=Ie})(Be||(e.InlayHintLabelPart=Be={}));var He;(function(ve){function Ie(J){return J}ve.from=Ie;function oe(J){return J}ve.to=oe})(He||(e.InlayHintKind=He={}));var _e;(function(ve){function Ie(J){return{range:y.from(J.range),url:J.target,tooltip:J.tooltip}}ve.from=Ie;function oe(J){let Re;if(J.url)try{Re=typeof J.url=="string"?r.URI.parse(J.url,!0):r.URI.revive(J.url)}catch{}return new p.$NN(y.to(J.range),Re)}ve.to=oe})(_e||(e.DocumentLink=_e={}));var xe;(function(ve){function Ie(J){const Re=new p.$QN(J.label);return J.textEdit&&(Re.textEdit=ae.to(J.textEdit)),J.additionalTextEdits&&(Re.additionalTextEdits=J.additionalTextEdits.map(Ve=>ae.to(Ve))),Re}ve.to=Ie;function oe(J){return{label:J.label,textEdit:J.textEdit?ae.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Re=>ae.from(Re)):void 0}}ve.from=oe})(xe||(e.ColorPresentation=xe={}));var et;(function(ve){function Ie(J){return new p.$ON(J[0],J[1],J[2],J[3])}ve.to=Ie;function oe(J){return[J.red,J.green,J.blue,J.alpha]}ve.from=oe})(et||(e.Color=et={}));var tt;(function(ve){function Ie(J){return{range:y.from(J.range)}}ve.from=Ie;function oe(J){return new p.$xN(y.to(J.range))}ve.to=oe})(tt||(e.SelectionRange=tt={}));var it;(function(ve){function Ie(oe){switch(oe){case 2:return p.TextDocumentSaveReason.AfterDelay;case 1:return p.TextDocumentSaveReason.Manual;case 3:case 4:return p.TextDocumentSaveReason.FocusOut}}ve.to=Ie})(it||(e.TextDocumentSaveReason=it={}));var ct;(function(ve){function Ie(J){switch(J){case p.TextEditorLineNumbersStyle.Off:return 0;case p.TextEditorLineNumbersStyle.Relative:return 2;case p.TextEditorLineNumbersStyle.Interval:return 3;case p.TextEditorLineNumbersStyle.On:default:return 1}}ve.from=Ie;function oe(J){switch(J){case 0:return p.TextEditorLineNumbersStyle.Off;case 2:return p.TextEditorLineNumbersStyle.Relative;case 3:return p.TextEditorLineNumbersStyle.Interval;case 1:default:return p.TextEditorLineNumbersStyle.On}}ve.to=oe})(ct||(e.TextEditorLineNumbersStyle=ct={}));var gt;(function(ve){function Ie(J){if(J===p.EndOfLine.CRLF)return 1;if(J===p.EndOfLine.LF)return 0}ve.from=Ie;function oe(J){if(J===1)return p.EndOfLine.CRLF;if(J===0)return p.EndOfLine.LF}ve.to=oe})(gt||(e.EndOfLine=gt={}));var Ue;(function(ve){function Ie(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case p.ProgressLocation.SourceControl:return 3;case p.ProgressLocation.Window:return 10;case p.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ve.from=Ie})(Ue||(e.ProgressLocation=Ue={}));var ot;(function(ve){function Ie(J){const Re={start:J.start+1,end:J.end+1};return J.kind&&(Re.kind=X.from(J.kind)),Re}ve.from=Ie;function oe(J){const Re={start:J.start-1,end:J.end-1};return J.kind&&(Re.kind=X.to(J.kind)),Re}ve.to=oe})(ot||(e.FoldingRange=ot={}));var X;(function(ve){function Ie(J){if(J)switch(J){case p.FoldingRangeKind.Comment:return n.$du.Comment;case p.FoldingRangeKind.Imports:return n.$du.Imports;case p.FoldingRangeKind.Region:return n.$du.Region}}ve.from=Ie;function oe(J){if(J)switch(J.value){case n.$du.Comment.value:return p.FoldingRangeKind.Comment;case n.$du.Imports.value:return p.FoldingRangeKind.Imports;case n.$du.Region.value:return p.FoldingRangeKind.Region}}ve.to=oe})(X||(e.FoldingRangeKind=X={}));var Z;(function(ve){function Ie(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?y.from(oe.selection):void 0,override:typeof oe.override=="boolean"?u.$uF.id:void 0}}ve.from=Ie})(Z||(e.TextEditorOpenOptions=Z={}));var me;(function(ve){function Ie(Ve){return Ve instanceof p.$_N?Ve.toJSON():typeof Ve=="string"?Ve:oe(Ve)||J(Ve)?new p.$_N(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}ve.from=Ie;function oe(Ve){const Ze=Ve;return Ze?r.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function J(Ve){const Ze=Ve;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Re(Ve){return typeof Ve=="string"?Ve:new p.$_N(r.URI.revive(Ve.baseUri),Ve.pattern)}ve.to=Re})(me||(e.GlobPattern=me={}));var Ge;(function(ve){function Ie(oe){if(oe){if(Array.isArray(oe))return oe.map(Ie);if(typeof oe=="string")return oe;{const J=oe;return{language:J.language,scheme:J.scheme,pattern:me.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}ve.from=Ie})(Ge||(e.LanguageSelector=Ge={}));var we;(function(ve){function Ie(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Re=>Array.isArray(Re)&&Re.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&r.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(Ze=>Ze instanceof p.$cN)))}ve.is=Ie;function oe(J){return{documents:J.documents.map(Re=>Re.map(Ve=>({uri:r.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(Ze=>y.from(Ze))})))}}ve.from=oe})(we||(e.MappedEditsContext=we={}));var at;(function(ve){function Ie(J){return{start:J.start,end:J.end}}ve.from=Ie;function oe(J){return new p.$CO(J.start,J.end)}ve.to=oe})(at||(e.NotebookRange=at={}));var dt;(function(ve){function Ie(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}ve.to=Ie;function oe(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}ve.from=oe})(dt||(e.NotebookCellExecutionSummary=dt={}));var It;(function(ve){function Ie(oe){if(oe===d.NotebookCellExecutionState.Unconfirmed)return p.NotebookCellExecutionState.Pending;if(oe===d.NotebookCellExecutionState.Pending)return;if(oe===d.NotebookCellExecutionState.Executing)return p.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${oe}`)}ve.to=Ie})(It||(e.NotebookCellExecutionState=It={}));var Vt;(function(ve){function Ie(J){switch(J){case p.NotebookCellKind.Markup:return d.CellKind.Markup;case p.NotebookCellKind.Code:default:return d.CellKind.Code}}ve.from=Ie;function oe(J){switch(J){case d.CellKind.Markup:return p.NotebookCellKind.Markup;case d.CellKind.Code:default:return p.NotebookCellKind.Code}}ve.to=oe})(Vt||(e.NotebookCellKind=Vt={}));var Qt;(function(ve){function Ie(J){const Re={metadata:J.metadata??Object.create(null),cells:[]};for(const Ve of J.cells)p.$DO.validate(Ve),Re.cells.push(ni.from(Ve));return Re}ve.from=Ie;function oe(J){const Re=new p.$EO(J.cells.map(ni.to));return(0,s.$jg)(J.metadata)||(Re.metadata=J.metadata),Re}ve.to=oe})(Qt||(e.NotebookData=Qt={}));var ni;(function(ve){function Ie(J){return{cellKind:Vt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:dt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Et.from):[]}}ve.from=Ie;function oe(J){return new p.$DO(Vt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Et.to):void 0,J.metadata,J.internalMetadata?dt.to(J.internalMetadata):void 0)}ve.to=oe})(ni||(e.NotebookCellData=ni={}));var Zt;(function(ve){function Ie(J){return{mime:J.mime,valueBytes:O.$Fe.wrap(J.data)}}ve.from=Ie;function oe(J){return new p.$FO(J.valueBytes.buffer,J.mime)}ve.to=oe})(Zt||(e.NotebookCellOutputItem=Zt={}));var Et;(function(ve){function Ie(J){return{outputId:J.id,items:J.items.map(Zt.from),metadata:J.metadata}}ve.from=Ie;function oe(J){const Re=J.items.map(Zt.to);return new p.$GO(Re,J.outputId,J.metadata)}ve.to=oe})(Et||(e.NotebookCellOutput=Et={}));var Xt;(function(ve){function Ie(Re){return J(Re)?{include:me.from(Re.include)??void 0,exclude:me.from(Re.exclude)??void 0}:me.from(Re)??void 0}ve.from=Ie;function oe(Re){return J(Re)?{include:me.to(Re.include),exclude:me.to(Re.exclude)}:me.to(Re)}ve.to=oe;function J(Re){const Ve=Re;return Ve?!(0,s.$fg)(Ve.include)&&!(0,s.$fg)(Ve.exclude):!1}})(Xt||(e.NotebookExclusiveDocumentPattern=Xt={}));var Yt;(function(ve){function Ie(oe,J,Re){const Ve=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===p.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ve,Re),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}ve.from=Ie})(Yt||(e.NotebookStatusBarItem=Yt={}));var Xe;(function(ve){function Ie(oe,J,Re){const Ve=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{command:J.toInternal(Ve,Re),label:oe.label,description:oe.description,detail:oe.detail,documentation:oe.documentation}}ve.from=Ie})(Xe||(e.NotebookKernelSourceAction=Xe={}));var si;(function(ve){function Ie(oe){return{transientOutputs:oe?.transientOutputs??!1,transientCellMetadata:oe?.transientCellMetadata??{},transientDocumentMetadata:oe?.transientDocumentMetadata??{},cellContentMetadata:oe?.cellContentMetadata??{}}}ve.from=Ie})(si||(e.NotebookDocumentContentOptions=si={}));var Gt;(function(ve){function Ie(J){return{uri:J.uri,provides:J.provides}}ve.from=Ie;function oe(J){return new p.$IO(r.URI.revive(J.uri),J.provides)}ve.to=oe})(Gt||(e.NotebookRendererScript=Gt={}));var ht;(function(ve){function Ie(J){return{message:ie.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:y.from(J.location.range),uri:J.location.uri}}}ve.from=Ie;function oe(J){const Re=new p.$OO(typeof J.message=="string"?J.message:ie.to(J.message));return Re.actualOutput=J.actual,Re.expectedOutput=J.expected,Re.contextValue=J.contextValue,Re.location=J.location?ge.to(J.location):void 0,Re}ve.to=oe})(ht||(e.TestMessage=ht={}));var mt;(function(ve){ve.namespace=g.$2L,ve.denamespace=g.$3L})(mt||(e.TestTag=mt={}));var xt;(function(ve){function Ie(J){const Re=(0,c.$vP)(J).controllerId;return{extId:a.$WL.fromExtHostTestItem(J,Re).toString(),label:J.label,uri:r.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ve=>mt.namespace(Re,Ve.id)),range:o.$ut.lift(y.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&ie.fromStrict(J.error)||null}}ve.from=Ie;function oe(J){return{parent:void 0,error:void 0,id:a.$WL.fromString(J.extId).localId,label:J.label,uri:r.URI.revive(J.uri),tags:(J.tags||[]).map(Re=>{const{tagId:Ve}=mt.denamespace(Re);return new p.$PO(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:y.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}ve.toPlain=oe})(xt||(e.TestItem=xt={})),function(ve){function Ie(J){return{id:J.id}}ve.from=Ie;function oe(J){return new p.$PO(J.id)}ve.to=oe}(mt||(e.TestTag=mt={}));var Ht;(function(ve){const Ie=(J,Re)=>{const Ve=J.value;if(!Ve)return;const Ze={...xt.toPlain(Ve.item),parent:Re,taskStates:Ve.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ut=>ut.type===0).map(ht.to)})),children:[]};if(J.children)for(const qe of J.children.values()){const ut=Ie(qe,Ze);ut&&Ze.children.push(ut)}return Ze};function oe(J){const Re=new l.$oP;for(const qe of J.items)Re.insert(a.$WL.fromString(qe.item.extId).path,qe);const Ve=[Re.nodes],Ze=[];for(;Ve.length;)for(const qe of Ve.pop())qe.value?Ze.push(qe):qe.children&&Ve.push(qe.children.values());return{completedAt:J.completedAt,results:Ze.map(qe=>Ie(qe)).filter(s.$eg)}}ve.to=oe})(Ht||(e.TestResults=Ht={}));var Mt;(function(ve){function Ie(Ve){return{covered:Ve.covered,total:Ve.total}}function oe(Ve){return"line"in Ve?S.from(Ve):y.from(Ve)}function J(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:oe(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&oe(Ze.location),label:Ze.label})):void 0}:{type:0,name:Ve.name,count:Ve.executed,location:oe(Ve.location)}}ve.fromDetails=J;function Re(Ve,Ze){return p.$RO(Ze.statementCoverage),p.$RO(Ze.branchCoverage),p.$RO(Ze.declarationCoverage),{id:Ve,uri:Ze.uri,statement:Ie(Ze.statementCoverage),branch:Ze.branchCoverage&&Ie(Ze.branchCoverage),declaration:Ze.declarationCoverage&&Ie(Ze.declarationCoverage)}}ve.fromFile=Re})(Mt||(e.TestCoverage=Mt={}));var ft;(function(ve){function Ie(oe){switch(oe){case 1:return p.CodeActionTriggerKind.Invoke;case 2:return p.CodeActionTriggerKind.Automatic}}ve.to=Ie})(ft||(e.CodeActionTriggerKind=ft={}));var Ut;(function(ve){function Ie(J){const Re=new p.$WO(ne.to(J.kind),J.name,J.detail||"",r.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return Re._sessionId=J._sessionId,Re._itemId=J._itemId,Re}ve.to=Ie;function oe(J,Re,Ve){if(Re=Re??J._sessionId,Ve=Ve??J._itemId,Re===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Ve,kind:ne.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(z.from)}}ve.from=oe})(Ut||(e.TypeHierarchyItem=Ut={}));var _t;(function(ve){function Ie(oe){if(oe)return{value:oe.value,tooltip:oe.tooltip}}ve.from=Ie})(_t||(e.ViewBadge=_t={}));var zt;(function(ve){function Ie(Ve,Ze,qe){const ut=Ze.fileData;return ut?new p.$4N(new p.$5N(ut.name,r.URI.revive(ut.uri),ut.id,(0,M.$db)(()=>qe(ut.id)))):Ve===T.$Qs.uriList&&Ze.uriListData?new p.$3N(Re(Ze.uriListData)):new p.$3N(Ze.asString)}ve.to=Ie;async function oe(Ve,Ze){const qe=await Ze.asString();if(Ve===T.$Qs.uriList)return{asString:qe,fileData:void 0,uriListData:J(qe)};const ut=Ze.asFile();return{asString:qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}ve.from=oe;function J(Ve){return R.$Ut.split(Ve).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return r.URI.parse(Ze)}catch{}return Ze})}function Re(Ve){return R.$Ut.create(Ve.map(Ze=>typeof Ze=="string"?Ze:r.URI.revive(Ze)))}})(zt||(e.DataTransferItem=zt={}));var Qe;(function(ve){function Ie(J,Re){const Ve=J.items.map(([Ze,qe])=>[Ze,zt.to(Ze,qe,Re)]);return new p.$6N(Ve)}ve.toDataTransfer=Ie;async function oe(J){const Re={items:[]},Ve=[];for(const[Ze,qe]of J)Ve.push((async()=>{Re.items.push([Ze,await zt.from(Ze,qe)])})());return await Promise.all(Ve),Re}ve.from=oe})(Qe||(e.DataTransfer=Qe={}));var ci;(function(ve){function Ie(J,Re){return{kind:"reply",agentId:J.participant??Re?.agentId??"",subCommand:J.command??Re?.command,message:J.prompt,title:J.label}}ve.from=Ie;function oe(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}ve.to=oe})(ci||(e.ChatFollowup=ci={}));var Kt;(function(ve){function Ie(oe){return"commandId"in oe?{kind:"command",title:oe.title??"",commandId:oe.commandId??"",when:oe.when??"",args:oe.args}:{kind:"reply",message:oe.message,title:oe.title,tooltip:oe.tooltip}}ve.from=Ie})(Kt||(e.ChatInlineFollowup=Kt={}));var Wt;(function(ve){function Ie(J){switch(J.role){case 0:return new p.$jP(J.content);case 1:return new p.$kP(J.content);case 2:return new p.$lP(J.content)}}ve.to=Ie;function oe(J){if(J instanceof p.$jP)return{role:0,content:J.content};if(J instanceof p.$kP)return{role:1,content:J.content};if(J instanceof p.$lP)return{role:2,content:J.content};throw new Error("Invalid LanguageModelMessage")}ve.from=oe})(Wt||(e.LanguageModelMessage=Wt={}));var wt;(function(ve){function Ie(oe){switch(oe){case 1:return p.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return p.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return p.InteractiveEditorResponseFeedbackKind.Undone;case 3:return p.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return p.InteractiveEditorResponseFeedbackKind.Bug}}ve.to=Ie})(wt||(e.InteractiveEditorResponseFeedbackKind=wt={}));var Tt;(function(ve){function Ie(J){return{kind:"markdownContent",content:ie.from(J.value)}}ve.from=Ie;function oe(J){return new p.$0O(ie.to(J.content))}ve.to=oe})(Tt||(e.ChatResponseMarkdownPart=Tt={}));var Ct;(function(ve){function Ie(J){return{kind:"markdownVuln",content:ie.from(J.value),vulnerabilities:J.vulnerabilities}}ve.from=Ie;function oe(J){return new p.$$O(ie.to(J.content),J.vulnerabilities)}ve.to=oe})(Ct||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Ct={}));var Ft;(function(ve){function Ie(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}ve.from=Ie;function oe(J){return new p.$_O(J.agentId,J.command)}ve.to=oe})(Ft||(e.ChatResponseDetectedParticipantPart=Ft={}));var ei;(function(ve){function Ie(J){const{value:Re,baseUri:Ve}=J;function Ze(qe,ut){return qe.map(yt=>{const Lt=r.URI.joinPath(ut,yt.name);return{label:yt.name,uri:Lt,children:yt.children&&Ze(yt.children,Lt)}})}return{kind:"treeData",treeData:{label:(0,w.$7g)(Ve),uri:Ve,children:Ze(Re,Ve)}}}ve.from=Ie;function oe(J){const Re=(0,E.$6h)(J.treeData);function Ve(ut){return ut.map(yt=>({name:yt.label,children:yt.children&&Ve(yt.children)}))}const Ze=Re.uri,qe=Re.children?Ve(Re.children):[];return new p.$aP(qe,Ze)}ve.to=oe})(ei||(e.ChatResponseFilesPart=ei={}));var jt;(function(ve){function Ie(J){return{kind:"inlineReference",name:J.title,inlineReference:r.URI.isUri(J.value)?J.value:h.from(J.value)}}ve.from=Ie;function oe(J){const Re=(0,E.$6h)(J);return new p.$bP(r.URI.isUri(Re.inlineReference)?Re.inlineReference:h.to(Re.inlineReference),J.name)}ve.to=oe})(jt||(e.ChatResponseAnchorPart=jt={}));var oi;(function(ve){function Ie(J){return{kind:"progressMessage",content:ie.from(J.value)}}ve.from=Ie;function oe(J){return new p.$cP(J.content.value)}ve.to=oe})(oi||(e.ChatResponseProgressPart=oi={}));var Nt;(function(ve){function Ie(J){return{kind:"warning",content:ie.from(J.value)}}ve.from=Ie;function oe(J){return new p.$dP(J.content.value)}ve.to=oe})(Nt||(e.ChatResponseWarningPart=Nt={}));var At;(function(ve){function Ie(J,Re,Ve){return{kind:"command",command:Re.toInternal(J.value,Ve)??{command:J.value.command,title:J.value.title}}}ve.from=Ie;function oe(J,Re){return new p.$eP(Re.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}ve.to=oe})(At||(e.ChatResponseCommandButtonPart=At={}));var Ot;(function(ve){function Ie(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(Re=>ae.from(Re))}}ve.from=Ie;function oe(J){return new p.$gP(r.URI.revive(J.uri),J.edits.map(Re=>ae.to(Re)))}ve.to=oe})(Ot||(e.ChatResponseTextEditPart=Ot={}));var Pt;(function(ve){function Ie(J){const Re=f.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:J.iconPath&&"light"in J.iconPath&&"dark"in J.iconPath&&r.URI.isUri(J.iconPath.light)&&r.URI.isUri(J.iconPath.dark)?{light:r.URI.revive(J.iconPath.light),dark:r.URI.revive(J.iconPath.dark)}:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:r.URI.isUri(J.value.value)||!J.value.value?J.value.value:h.from(J.value.value)},iconPath:Re}:{kind:"reference",reference:r.URI.isUri(J.value)?J.value:h.from(J.value),iconPath:Re}}ve.from=Ie;function oe(J){const Re=(0,E.$6h)(J),Ve=Ze=>r.URI.isUri(Ze)?Ze:h.to(Ze);return new p.$fP("variableName"in Re.reference?{variableName:Re.reference.variableName,value:Re.reference.value&&Ve(Re.reference.value)}:Ve(Re.reference))}ve.to=oe})(Pt||(e.ChatResponseReferencePart=Pt={}));var $t;(function(ve){function Ie(Re,Ve,Ze){return Re instanceof p.$0O?Tt.from(Re):Re instanceof p.$bP?jt.from(Re):Re instanceof p.$fP?Pt.from(Re):Re instanceof p.$cP?oi.from(Re):Re instanceof p.$aP?ei.from(Re):Re instanceof p.$eP?At.from(Re,Ve,Ze):Re instanceof p.$gP?Ot.from(Re):Re instanceof p.$$O?Ct.from(Re):Re instanceof p.$_O?Ft.from(Re):{kind:"markdownContent",content:ie.from("")}}ve.from=Ie;function oe(Re,Ve){switch(Re.kind){case"reference":return Pt.to(Re);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(Re,Ve)}}ve.to=oe;function J(Re,Ve){switch(Re.kind){case"markdownContent":return Tt.to(Re);case"inlineReference":return jt.to(Re);case"progressMessage":return;case"treeData":return ei.to(Re);case"command":return At.to(Re,Ve)}}ve.toContent=J})($t||(e.ChatResponsePart=$t={}));var Dt;(function(ve){function Ie(oe){return{prompt:oe.message,command:oe.command,attempt:oe.attempt??0,enableCommandDetection:oe.enableCommandDetection??!0,variables:oe.variables.variables.map(kt.to),location:ri.to(oe.location)}}ve.to=Ie})(Dt||(e.ChatAgentRequest=Dt={}));var ri;(function(ve){function Ie(oe){switch(oe){case t.ChatAgentLocation.Notebook:return p.ChatLocation.Notebook;case t.ChatAgentLocation.Terminal:return p.ChatLocation.Terminal;case t.ChatAgentLocation.Panel:return p.ChatLocation.Panel;case t.ChatAgentLocation.Editor:return p.ChatLocation.Editor}}ve.to=Ie})(ri||(e.ChatLocation=ri={}));var kt;(function(ve){function Ie(oe){const J=oe.value;if(!J)throw new Error("Invalid value reference");return{name:oe.name,range:oe.range&&[oe.range.start,oe.range.endExclusive],value:(0,r.$vc)(J)?r.URI.revive(J):J}}ve.to=Ie})(kt||(e.ChatAgentValueReference=kt={}));var gi;(function(ve){function Ie(oe,J,Re){return{label:oe.label,value:oe.values[0].value,insertText:oe.insertText,detail:oe.detail,documentation:oe.documentation,command:J.toInternal(oe.command,Re)}}ve.from=Ie})(gi||(e.ChatAgentCompletionItem=gi={}));var ti;(function(ve){function Ie(oe){return{errorDetails:oe.errorDetails,metadata:oe.metadata}}ve.to=Ie})(ti||(e.ChatAgentResult=ti={}));var pi;(function(ve){function Ie(oe,J,Re){if(J.action.kind==="vote")return;const Ve=ti.to(oe);if(J.action.kind==="command"){const Ze=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Re.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:Ve}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:ci.to(J.action.followup)},result:Ve}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Ve}:{action:J.action,result:Ve}}ve.to=Ie})(pi||(e.ChatAgentUserActionEvent=pi={}));var ui;(function(ve){function Ie(oe,J,Re){return"terminalCommand"in oe?{terminalCommand:oe.terminalCommand,shouldExecute:oe.shouldExecute}:"uri"in oe?{uri:oe.uri}:J.toInternal(oe,Re)}ve.from=Ie})(ui||(e.TerminalQuickFix=ui={}));var wi;(function(ve){function Ie(oe){return{kind:St.to(oe.kind)}}ve.to=Ie})(wi||(e.PartialAcceptInfo=wi={}));var St;(function(ve){function Ie(oe){switch(oe){case 0:return p.PartialAcceptTriggerKind.Word;case 1:return p.PartialAcceptTriggerKind.Line;case 2:return p.PartialAcceptTriggerKind.Suggest;default:return p.PartialAcceptTriggerKind.Unknown}}ve.to=Ie})(St||(e.PartialAcceptTriggerKind=St={}));var ki;(function(ve){function Ie(oe,J){return{id:J,label:oe.label,description:oe.description,canEdit:oe.canEdit,collapsibleState:oe.collapsibleState||0,contextValue:oe.contextValue}}ve.from=Ie})(ki||(e.DebugTreeItem=ki={}))}),define(Se[262],Pe([1,0,4,17,8,35]),function(le,e,C,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=void 0;let A=class{constructor(m,E){this.a=m.getProxy(C.$$M.MainThreadBulkEdits),this.b={getTextDocumentVersion:T=>E.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,E,T){const k=new M.$Bw(R.WorkspaceEdit.from(m,this.b));return this.a.$tryApplyWorkspaceEdit(k,void 0,T?.isRefactoring??!1)}};e.$Dlc=A,e.$Dlc=A=Je([We(0,O.$zP)],A)}),define(Se[263],Pe([1,0,18,11,44,5,42,6,66,15,2,20,4,8,7,225,26]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Elc=void 0;class o{constructor(u,t,d,a,g){this.j=u,this.k=t,this.l=d,this.m=a,this.n=g,this.b=m.$_d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(a){if(u.c){const g=new Error("Response stream has been closed");throw Error.captureStackTrace(g,a),g}};const u=this;this.b.reset();const d=a=>{typeof this.d>"u"&&"content"in a&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,a)};this.g={markdown(a){t(this.markdown);const g=new f.$0O(a),b=w.ChatResponseMarkdownPart.from(g);return d(b),this},markdownWithVulnerabilities(a,g){t(this.markdown),g&&(0,r.$PG)(u.j,"chatParticipantAdditions");const b=new f.$$O(a,g),p=w.ChatResponseMarkdownWithVulnerabilitiesPart.from(b);return d(p),this},filetree(a,g){t(this.filetree);const b=new f.$aP(a,g),p=w.ChatResponseFilesPart.from(b);return d(p),this},anchor(a,g){t(this.anchor);const b=new f.$bP(a,g),p=w.ChatResponseAnchorPart.from(b);return d(p),this},button(a){t(this.anchor);const g=new f.$eP(a),b=w.ChatResponseCommandButtonPart.from(g,u.m,u.n);return d(b),this},progress(a){t(this.progress);const g=new f.$cP(a),b=w.ChatResponseProgressPart.from(g);return d(b),this},warning(a){t(this.progress);const g=new f.$dP(a),b=w.ChatResponseWarningPart.from(g);return d(b),this},reference(a,g){if(t(this.reference),"variableName"in a&&!a.value){const b=u.k.variables.variables.find(p=>p.name===a.variableName);if(b){let p;if(b.references?.length)p=b.references.map(v=>({kind:"reference",reference:{variableName:a.variableName,value:v.reference}}));else{const v=new f.$fP(a,g);p=[w.ChatResponseReferencePart.from(v)]}return p.forEach(v=>d(v)),this}}else{const b=new f.$fP(a,g),p=w.ChatResponseReferencePart.from(b);d(p)}return this},textEdit(a,g){t(this.textEdit),(0,r.$PG)(u.j,"chatParticipantAdditions");const b=new f.$gP(a,g),p=w.ChatResponseTextEditPart.from(b);return d(p),this},detectedParticipant(a,g){t(this.detectedParticipant),(0,r.$PG)(u.j,"chatParticipantAdditions");const b=new f.$_O(a,g),p=w.ChatResponseDetectedParticipantPart.from(b);return d(p),this},push(a){if(t(this.push),(a instanceof f.$gP||a instanceof f.$$O||a instanceof f.$_O)&&(0,r.$PG)(u.j,"chatParticipantAdditions"),a instanceof f.$fP)this.reference(a.value,a.iconPath);else{const g=w.ChatResponsePart.from(a,u.m,u.n);d(g)}return this}}}return this.g}}class n extends $.$Uc{static{this.b=0}constructor(u,t,d){super(),this.n=t,this.s=d,this.c=new Map,this.j=this.B(new $.$4c),this.m=this.B(new $.$4c),this.g=u.getProxy(l.$$M.MainThreadChatAgents2)}transferActiveChat(u){this.g.$transferActiveChatSession(u)}createChatAgent(u,t,d){const a=n.b++,g=new i(u,t,this.g,a,d);return this.c.set(a,g),this.g.$registerAgent(a,u.identifier,t,{},void 0),g.apiAgent}createDynamicChatAgent(u,t,d,a,g){const b=n.b++,p=new i(u,t,this.g,b,g);return this.c.set(b,p),this.g.$registerAgent(b,u.identifier,t,{isSticky:!0},{name:d,description:a}),p.apiAgent}async $invokeAgent(u,t,d,a){const g=this.c.get(u);if(!g)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);let b=this.j.get(t.sessionId);b||(b=new $.$Tc,this.j.set(t.sessionId,b));const p=new o(g.extension,t,this.g,this.s.converter,b);try{const v=await this.t(t.agentId,d),y=g.invoke(w.ChatAgentRequest.to(t),{history:v},p.apiObject,a);return await(0,O.$kh)(Promise.resolve(y).then(h=>{if(h?.metadata)try{JSON.stringify(h.metadata)}catch(D){const S=`result.metadata MUST be JSON.stringify-able. Got error: ${D.message}`;return this.n.error(`[${g.extension.identifier.value}] [@${g.id}] ${S}`,g.extension),{errorDetails:{message:S},timings:p.timings}}return{errorDetails:h?.errorDetails,timings:p.timings,metadata:h?.metadata}}),a)}catch(v){return this.n.error(v,g.extension),{errorDetails:{message:(0,R.$hj)(v),responseIsIncomplete:!0}}}finally{p.close()}}async t(u,t){const d=[];for(const a of t.history){const g=w.ChatAgentResult.to(a.result),b=u===a.request.agentId?g:{...g,metadata:void 0};d.push(new f.$hP(a.request.message,a.request.command,a.request.variables.variables.map(w.ChatAgentValueReference.to),a.request.agentId));const p=(0,C.$Hb)(a.response.map(v=>w.ChatResponsePart.toContent(v,this.s.converter)));d.push(new f.$iP(p,b,a.request.agentId,a.request.command))}return d}$releaseSession(u){this.j.deleteAndDispose(u)}async $provideFollowups(u,t,d,a,g){const b=this.c.get(t);if(!b)return Promise.resolve([]);const p=await this.t(b.id,a),v=w.ChatAgentResult.to(d);return(await b.provideFollowups(v,{history:p},g)).filter(y=>{const h=!y.participant||A.Iterable.some(this.c.values(),D=>D.id===y.participant&&k.$Rm.equals(D.extension.identifier,b.extension.identifier));return h||this.n.warn(`[@${b.id}] ChatFollowup refers to an unknown participant: ${y.participant}`),h}).map(y=>w.ChatFollowup.from(y,u))}$acceptFeedback(u,t,d,a){const g=this.c.get(u);if(!g)return;const b=w.ChatAgentResult.to(t);let p;switch(d){case s.InteractiveSessionVoteDirection.Down:p=f.ChatResultFeedbackKind.Unhelpful;break;case s.InteractiveSessionVoteDirection.Up:p=f.ChatResultFeedbackKind.Helpful;break}g.acceptFeedback(Object.freeze(a?{result:b,kind:p,reportIssue:a}:{result:b,kind:p}))}$acceptAction(u,t,d){const a=this.c.get(u);if(!a||d.action.kind==="vote")return;const g=w.ChatAgentUserActionEvent.to(t,d,this.s.converter);g&&a.acceptAction(Object.freeze(g))}async $invokeCompletionProvider(u,t,d){const a=this.c.get(u);if(!a)return[];let g=this.m.get(u);return g?g.clear():(g=new $.$Tc,this.m.set(u,g)),(await a.invokeCompletionProvider(t,d)).map(p=>w.ChatAgentCompletionItem.from(p,this.s.converter,g))}async $provideWelcomeMessage(u,t,d){const a=this.c.get(u);if(a)return await a.provideWelcomeMessage(w.ChatLocation.to(t),d)}async $provideSampleQuestions(u,t,d){const a=this.c.get(u);if(a)return(await a.provideSampleQuestions(w.ChatLocation.to(t),d)).map(g=>w.ChatFollowup.from(g,void 0))}}e.$Elc=n;class i{constructor(u,t,d,a,g){this.extension=u,this.id=t,this.u=d,this.w=a,this.x=g,this.n=new M.$de,this.o=new M.$de}acceptFeedback(u){this.n.fire(u)}acceptAction(u){this.o.fire(u)}async invokeCompletionProvider(u,t){return this.q?await this.q.provider.provideCompletionItems(u,t)??[]:[]}async provideFollowups(u,t,d){if(!this.b)return[];const a=await this.b.provideFollowups(u,t,d);return a?a.filter(g=>!(g&&"commandId"in g)).filter(g=>!(g&&"message"in g)):[]}async provideWelcomeMessage(u,t){if(!this.s)return[];const d=await this.s.provideWelcomeMessage(u,t);return d?d.map(a=>typeof a=="string"?a:w.MarkdownString.from(a)):[]}async provideSampleQuestions(u,t){if(!this.s||!this.s.provideSampleQuestions)return[];const d=await this.s.provideSampleQuestions(u,t);return d||[]}get apiAgent(){let u=!1,t=!1;const d=()=>{u||t||(t=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof T.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof f.$0N?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:w.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:w.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:w.MarkdownString.from(this.l),supportIssueReporting:this.p,requester:this.t}),t=!1}))},a=this;return{get id(){return a.id},get fullName(){return(0,r.$PG)(a.extension,"defaultChatParticipant"),a.c??a.extension.displayName??a.extension.name},set fullName(g){(0,r.$PG)(a.extension,"defaultChatParticipant"),a.c=g,d()},get iconPath(){return a.d},set iconPath(g){a.d=g,d()},get requestHandler(){return a.x},set requestHandler(g){(0,E.$gg)(typeof g=="function","Invalid request handler"),a.x=g},get followupProvider(){return a.b},set followupProvider(g){a.b=g,d()},get isDefault(){return(0,r.$PG)(a.extension,"defaultChatParticipant"),a.g},set isDefault(g){(0,r.$PG)(a.extension,"defaultChatParticipant"),a.g=g,d()},get helpTextPrefix(){return(0,r.$PG)(a.extension,"defaultChatParticipant"),a.j},set helpTextPrefix(g){(0,r.$PG)(a.extension,"defaultChatParticipant"),a.j=g,d()},get helpTextVariablesPrefix(){return(0,r.$PG)(a.extension,"defaultChatParticipant"),a.k},set helpTextVariablesPrefix(g){(0,r.$PG)(a.extension,"defaultChatParticipant"),a.k=g,d()},get helpTextPostfix(){return(0,r.$PG)(a.extension,"defaultChatParticipant"),a.l},set helpTextPostfix(g){(0,r.$PG)(a.extension,"defaultChatParticipant"),a.l=g,d()},get isSecondary(){return(0,r.$PG)(a.extension,"defaultChatParticipant"),a.m},set isSecondary(g){(0,r.$PG)(a.extension,"defaultChatParticipant"),a.m=g,d()},get supportIssueReporting(){return(0,r.$PG)(a.extension,"chatParticipantAdditions"),a.p},set supportIssueReporting(g){(0,r.$PG)(a.extension,"chatParticipantAdditions"),a.p=g,d()},get onDidReceiveFeedback(){return a.n.event},set participantVariableProvider(g){if((0,r.$PG)(a.extension,"chatParticipantAdditions"),a.q=g,g){if(!g.triggerCharacters.length)throw new Error("triggerCharacters are required");a.u.$registerAgentCompletionsProvider(a.w,g.triggerCharacters)}else a.u.$unregisterAgentCompletionsProvider(a.w)},get participantVariableProvider(){return(0,r.$PG)(a.extension,"chatParticipantAdditions"),a.q},set welcomeMessageProvider(g){(0,r.$PG)(a.extension,"defaultChatParticipant"),a.s=g,d()},get welcomeMessageProvider(){return(0,r.$PG)(a.extension,"defaultChatParticipant"),a.s},onDidPerformAction:(0,r.$OG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(g){a.t=g,d()},get requester(){return a.t},dispose(){u=!0,a.b=void 0,a.n.dispose(),a.u.$unregisterAgent(a.w)}}}invoke(u,t,d,a){return this.x(u,t,d,a)}}}),define(Se[264],Pe([1,0,14,6,4,8,7,26]),function(le,e,C,O,R,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=void 0;class m{static{this.a=0}constructor(k){this.b=new Map,this.c=k.getProxy(R.$$M.MainThreadChatVariables)}async $resolveVariable(k,l,w,f){const s=this.b.get(k);if(s)try{if(s.resolver.resolve2){(0,$.$PG)(s.extension,"chatParticipantAdditions");const r=new E(l,this.c),o=await s.resolver.resolve2(s.data.name,{prompt:w},r.apiObject,f);if(o&&o[0])return o[0].value}else{const r=await s.resolver.resolve(s.data.name,{prompt:w},f);if(r&&r[0])return r[0].value}}catch(r){(0,C.$2)(r)}}registerVariableResolver(k,l,w,f){const s=m.a++;return this.b.set(s,{extension:k,data:{name:l,description:w},resolver:f}),this.c.$registerVariable(s,{name:l,description:w}),(0,O.$Sc)(()=>{this.b.delete(s),this.c.$unregisterVariable(s)})}}e.$Flc=m;class E{constructor(k,l){this.c=k,this.d=l,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let l=function(f){if(k.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,f),s}};const k=this,w=f=>{this.d.$handleProgressChunk(this.c,f)};this.b={progress(f){l(this.progress);const s=new A.$cP(f),r=M.ChatResponseProgressPart.from(s);return w(r),this},reference(f){l(this.reference);const s=new A.$fP(f),r=M.ChatResponseReferencePart.from(s);return w(r),this},push(f){return l(this.push),f instanceof A.$fP?w(M.ChatResponseReferencePart.from(f)):f instanceof A.$cP&&w(M.ChatResponseProgressPart.from(f)),this}}}return this.b}}}),define(Se[265],Pe([1,0,11,69,5,6,2,89,20,8,7,4,26]),function(le,e,C,O,R,M,A,$,m,E,T,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=w;function w(f,s,r){const o=f.getProxy(k.$$M.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new m.$Tm,s.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===6){const y=this.b.get(v.handle);return y?y.value:v}else if(v&&v.$mid===7){const y=v,h=this.b.get(y.commentControlHandle);if(!h)return y;const D=h.getCommentThread(y.commentThreadHandle);return D?D.value:y}else if(v&&(v.$mid===9||v.$mid===8)){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);return h?v.$mid===8?h.value:{thread:h.value,text:v.text}:v}else if(v&&v.$mid===10){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);if(!h)return v;const D=v.commentUniqueId,S=h.getCommentByUniqueId(D);return S||v}else if(v&&v.$mid===11){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);if(!h)return v;const D=v.text,S=v.commentUniqueId,I=h.getCommentByUniqueId(S);return I?(typeof I.body=="string"?I.body=D:I.body=new T.$CN(D),I):v}return v}})}createCommentController(v,y,h){const D=n.a++,S=new c(v,D,y,h);this.b.set(S.handle,S);const I=this.c.get(v.identifier)||[];return I.push(S),this.c.set(v.identifier,I),S.value}async $createCommentThreadTemplate(v,y,h){const D=this.b.get(v);D&&D.$createCommentThreadTemplate(y,h)}async $setActiveComment(v,y){const h=this.b.get(v);h&&h.$setActiveComment(y??void 0)}async $updateCommentThreadTemplate(v,y,h){const D=this.b.get(v);D&&D.$updateCommentThreadTemplate(y,h)}$deleteCommentThread(v,y){this.b.get(v)?.$deleteCommentThread(y)}async $provideCommentingRanges(v,y,h){const D=this.b.get(v);if(!D||!D.commentingRangeProvider)return Promise.resolve(void 0);const S=await r.ensureDocumentData(A.URI.revive(y));return(0,C.$oh)(async()=>{const I=await D.commentingRangeProvider.provideCommentingRanges(S.document,h);let P;return Array.isArray(I)?P={ranges:I,fileComments:!1}:I?P={ranges:I.ranges||[],fileComments:I.fileComments||!1}:P=I??void 0,P}).then(I=>{let P;return I&&(P={ranges:I.ranges.map(W=>E.Range.from(W)),fileComments:I.fileComments}),P})}$toggleReaction(v,y,h,D,S){const I=this.b.get(v);return!I||!I.reactionHandler?Promise.resolve(void 0):(0,C.$oh)(()=>{const P=I.getCommentThread(y);if(P){const W=P.getCommentByUniqueId(D.uniqueIdInThread);if(I!==void 0&&W&&I.reactionHandler)return I.reactionHandler(W,d(S))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(v){this.n=v}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(v){(v===void 0!=(this.p===void 0)||!v||!this.p||!v.isEqual(this.p))&&(this.p=v,this.b.range=v,this.c.fire())}get range(){return this.p}set canReply(v){this.d!==v&&(this.d=v,this.b.canReply=v,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(v){this.e=v,this.b.label=v,this.c.fire()}get contextValue(){return this.f}set contextValue(v){this.f=v,this.b.contextValue=v,this.c.fire()}get comments(){return this.q}set comments(v){this.q=v,this.b.comments=v,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(v){this.g=v,this.b.collapsibleState=v,this.c.fire()}get state(){return this.h}set state(v){this.h=v,typeof v=="object"?((0,l.$PG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=v.resolved,this.b.applicability=v.applicability):this.b.state=v,this.c.fire()}get isDisposed(){return this.j}constructor(v,y,h,D,S,I,P,W){this.m=y,this.n=h,this.o=D,this.p=S,this.q=I,this.extensionDescription=P,this.r=W,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new R.$de,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Vc,this.l.value=new M.$Tc,this.n===void 0&&(this.n=`${v}.${this.handle}`),o.$createCommentThread(y,this.handle,this.n,this.o,E.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=I,this.i.push({dispose:()=>{o.$deleteCommentThread(y,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(q){V.range=q},get comments(){return V.comments},set comments(q){V.comments=q},get collapsibleState(){return V.collapsibleState},set collapsibleState(q){V.collapsibleState=q},get canReply(){return V.canReply},set canReply(q){V.canReply=q},get contextValue(){return V.contextValue},set contextValue(q){V.contextValue=q},get label(){return V.label},set label(q){V.label=q},get state(){return V.state},set state(q){V.state=q},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Tc);const v=h=>Object.prototype.hasOwnProperty.call(this.b,h),y={};v("range")&&(y.range=E.Range.from(this.p)),v("label")&&(y.label=this.label),v("contextValue")&&(y.contextValue=this.contextValue??null),v("comments")&&(y.comments=this.q.map(h=>u(this,h,this.k,this.extensionDescription))),v("collapsibleState")&&(y.collapseState=a(this.g)),v("canReply")&&(y.canReply=this.canReply),v("state")&&(y.state=g(this.h)),v("applicability")&&(y.applicability=b(this.h)),v("isTemplate")&&(y.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,y)}getCommentByUniqueId(v){for(const y of this.k){const h=y[0],D=y[1];if(v===D)return h}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(v=>v.dispose())}}Je([(0,O.$2h)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(v){this.b=v,v?.resourceHints&&(0,l.$PG)(this.h,"commentingRangeHint"),o.$updateCommentingRanges(this.handle,v?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(v){this.c=v,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!v})}get options(){return this.d}set options(v){this.d=v,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,l.$PG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,l.$PG)(this.h,"activeComment"),this.f}constructor(v,y,h,D){this.h=v,this.i=y,this.j=h,this.k=D,this.a=new Map,o.$registerCommentController(this.handle,h,D,this.h.identifier.value);const S=this;this.value=Object.freeze({id:S.id,label:S.label,get options(){return S.options},set options(I){S.options=I},get commentingRangeProvider(){return S.commentingRangeProvider},set commentingRangeProvider(I){S.commentingRangeProvider=I},get reactionHandler(){return S.reactionHandler},set reactionHandler(I){S.reactionHandler=I},get activeCommentThread(){return S.activeCommentThread},createCommentThread(I,P,W){return S.createCommentThread(I,P,W).value},dispose:()=>{S.dispose()}}),this.g=[],this.g.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(v,y,h){y===void 0&&(0,l.$PG)(this.h,"fileComments");const D=new i(this.id,this.handle,void 0,v,y,h,this.h,!1);return this.a.set(D.handle,D),D}$setActiveComment(v){if(!v){this.e=void 0,this.f=void 0;return}const y=this.a.get(v.commentThreadHandle);y&&(this.e=v.uniqueIdInThread?y.getCommentByUniqueId(v.uniqueIdInThread):void 0,this.f=y)}$createCommentThreadTemplate(v,y){const h=new i(this.id,this.handle,void 0,A.URI.revive(v),E.Range.to(y),[],this.h,!0);return h.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(h.handle,h),h}$updateCommentThreadTemplate(v,y){const h=this.a.get(v);h&&(h.range=E.Range.to(y))}$deleteCommentThread(v){this.a.get(v)?.dispose(),this.a.delete(v)}getCommentThread(v){return this.a.get(v)}dispose(){this.a.forEach(v=>{v.dispose()}),this.g.forEach(v=>v.dispose())}}function u(p,v,y,h){let D=y.get(v);return D||(D=++p.commentHandle,y.set(v,D)),v.state!==void 0&&(0,l.$PG)(h,"commentsDraftState"),v.reactions?.some(S=>S.reactors!==void 0)&&(0,l.$PG)(h,"commentReactor"),{mode:v.mode,contextValue:v.contextValue,uniqueIdInThread:D,body:typeof v.body=="string"?v.body:E.MarkdownString.from(v.body),userName:v.author.name,userIconPath:v.author.iconPath,label:v.label,commentReactions:v.reactions?v.reactions.map(S=>t(S)):void 0,state:v.state,timestamp:v.timestamp?.toJSON()}}function t(p){return{label:p.label,iconPath:p.iconPath?E.$yP(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted,reactors:p.reactors&&p.reactors.length>0&&typeof p.reactors[0]!="string"?p.reactors.map(v=>v.name):p.reactors}}function d(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?A.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1,reactors:p.reactors?.map(v=>({name:v}))}}function a(p){if(p!==void 0)switch(p){case T.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function g(p){let v;if(typeof p=="object"?v=p.resolved:v=p,v!==void 0)switch(v){case T.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case T.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}function b(p){let v;if(typeof p=="object"&&(v=p.applicability),v!==void 0)switch(v){case T.CommentThreadApplicability.Current:return $.CommentThreadApplicability.Current;case T.CommentThreadApplicability.Outdated:return $.CommentThreadApplicability.Outdated}return $.CommentThreadApplicability.Current}return new n}}),define(Se[266],Pe([1,0,24,73,6,16,23,2,8,64,76,4,7]),function(le,e,C,O,R,M,A,$,m,E,T,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=void 0;class w{constructor(d,a){this.document=d,this.b=a,this.a=1,this.c=new T.$plc("custom documents")}addEdit(d){return this.c.add([d])}async undo(d,a){await this.f(d).undo(),a||this.disposeBackup()}async redo(d,a){await this.f(d).redo(),a||this.disposeBackup()}disposeEdits(d){for(const a of d)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const d=u(this.document.uri)+this.a++;return(0,A.$0g)(this.b,d)}updateBackup(d){this.d?.delete(),this.d=d}disposeBackup(){this.d?.delete(),this.d=void 0}f(d){const a=this.c.get(d,0);if(!a)throw new Error("No edit found");return a}}class f{constructor(){this.a=new Map}get(d,a){return this.a.get(this.b(d,a))}add(d,a,g){const b=this.b(d,a.uri);if(this.a.has(b))throw new Error(`Document already exists for viewType:${d} resource:${a.uri}`);const p=new w(a,g);return this.a.set(b,p),p}delete(d,a){const g=this.b(d,a.uri);this.a.delete(g)}b(d,a){return`${d}@@@${a}`}}var s;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(s||(s={}));class r{constructor(){this.a=new Map}addTextProvider(d,a,g){return this.b(d,{type:0,extension:a,provider:g})}addCustomProvider(d,a,g){return this.b(d,{type:1,extension:a,provider:g})}get(d){return this.a.get(d)}b(d,a){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,a),new l.$aN(()=>this.a.delete(d))}}class o{constructor(d,a,g,b,p){this.d=a,this.f=g,this.g=b,this.h=p,this.b=new r,this.c=new f,this.a=d.getProxy(k.$$M.MainThreadCustomEditors)}registerCustomEditorProvider(d,a,g,b){const p=new R.$Tc;return i(g)?(p.add(this.b.addTextProvider(a,d,g)),this.a.$registerTextEditorProvider((0,E.$Ylc)(d),a,b.webviewOptions||{},{supportsMove:!!g.moveCustomTextEditor},(0,E.$Wlc)(d))):(p.add(this.b.addCustomProvider(a,d,g)),n(g)&&p.add(g.onDidChangeCustomDocument(v=>{const y=this.i(a,v.document.uri);if(c(v)){const h=y.addEdit(v);this.a.$onDidEdit(v.document.uri,a,h,v.label)}else this.a.$onContentChange(v.document.uri,a)})),this.a.$registerCustomEditorProvider((0,E.$Ylc)(d),a,b.webviewOptions||{},!!b.supportsMultipleEditorsPerDocument,(0,E.$Wlc)(d))),l.$aN.from(p,new l.$aN(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(d,a,g,b,p){const v=this.b.get(a);if(!v)throw new Error(`No provider found for '${a}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${a}'`);const y=$.URI.revive(d),h=await v.provider.openCustomDocument(y,{backupId:g,untitledDocumentData:b?.buffer},p);let D;return n(v.provider)&&this.f&&(D=this.f.workspaceValue(v.extension)??this.f.globalValue(v.extension)),this.c.add(a,h,D),{editable:n(v.provider)}}async $disposeCustomDocument(d,a){const g=this.b.get(a);if(!g)throw new Error(`No provider found for '${a}'`);if(g.type!==1)throw new Error(`Invalid provider type for '${a}'`);const b=$.URI.revive(d),{document:p}=this.i(a,b);this.c.delete(a,p),p.dispose()}async $resolveCustomEditor(d,a,g,b,p,v){const y=this.b.get(g);if(!y)throw new Error(`No provider found for '${g}'`);const h=m.ViewColumn.to(p),D=this.g.createNewWebview(a,b.contentOptions,y.extension),S=this.h.createNewWebviewPanel(a,g,b.title,h,b.options,D,b.active),I=$.URI.revive(d);switch(y.type){case 1:{const{document:P}=this.i(g,I);return y.provider.resolveCustomEditor(P,S,v)}case 0:{const P=this.d.getDocument(I);return y.provider.resolveCustomTextEditor(P,S,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,a,g){this.i(a,d).disposeEdits(g)}async $onMoveCustomEditor(d,a,g){const b=this.b.get(g);if(!b)throw new Error(`No provider found for '${g}'`);if(!b.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${g}'`);const p=this.h.getWebviewPanel(d);if(!p)throw new Error("No webview found");const v=$.URI.revive(a),y=this.d.getDocument(v);await b.provider.moveCustomTextEditor(y,p,C.CancellationToken.None)}async $undo(d,a,g,b){return this.i(a,d).undo(g,b)}async $redo(d,a,g,b){return this.i(a,d).redo(g,b)}async $revert(d,a,g){const b=this.i(a,d);await this.j(a).revertCustomDocument(b.document,g),b.disposeBackup()}async $onSave(d,a,g){const b=this.i(a,d);await this.j(a).saveCustomDocument(b.document,g),b.disposeBackup()}async $onSaveAs(d,a,g,b){const p=this.i(a,d);return this.j(a).saveCustomDocumentAs(p.document,$.URI.revive(g),b)}async $backup(d,a,g){const b=this.i(a,d),v=await this.j(a).backupCustomDocument(b.document,{destination:b.getNewBackupUri()},g);return b.updateBackup(v),v.id}i(d,a){const g=this.c.get(d,$.URI.revive(a));if(!g)throw new Error("No custom document found");return g}j(d){const g=this.b.get(d)?.provider;if(!g||!n(g))throw new Error("Custom document is not editable");return g}}e.$2lc=o;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function u(t){const d=t.scheme===M.Schemas.file||t.scheme===M.Schemas.untitled?t.fsPath:t.toString();return(0,O.$kj)(d)+""}}),define(Se[267],Pe([1,0,172,101,2,4,7,8,5,12,28,46]),function(le,e,C,O,R,M,A,$,m,E,T,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=e.$wlc=void 0;class w{#e;#t;#i;constructor(r,o,n,i,c,u,t,d){this.d=r,this.e=o,this.f=n,this.g=i,this.h=c,this.c=!1,this.f=Math.max(i,n),this.#i=new T.$Ac(a=>u.getComparisonKey(a)),this.#e=t,this.#t=d}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(r,o){if(!r){this.clear();return}this.j();let n=[];if(R.URI.isUri(r)){if(!o){this.delete(r);return}this.#i.set(r,o.slice()),n=[r]}else if(Array.isArray(r)){n=[];let u;r=[...r].sort(w.k);for(const t of r){const[d,a]=t;if((!u||d.toString()!==u.toString())&&(u&&this.#i.get(u).length===0&&this.#i.delete(u),u=d,n.push(d),this.#i.set(d,[])),a)this.#i.get(d)?.push(...a);else{const g=this.#i.get(d);g&&(g.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let c=0;for(const u of n){let t=[];const d=this.#i.get(u);if(d)if(d.length>this.g){t=[];const a=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let g=0;g<4;g++)for(const b of d)if(b.severity===a[g]&&t.push({...$.Diagnostic.from(b),modelVersionId:this.h(u)})===this.g)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,C.localize)(0,null,d.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=d.map(a=>({...$.Diagnostic.from(a),modelVersionId:this.h(u)}));if(i.push([u,t]),c+=t.length,c>this.f)break}this.#e.$changeMany(this.e,i)}delete(r){this.j(),this.#t.fire([r]),this.#i.delete(r),this.#e?.$changeMany(this.e,[[r,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(r,o){this.j();for(const[n,i]of this)r.call(o,n,i,this)}*[Symbol.iterator](){this.j();for(const r of this.#i.keys())yield[r,this.get(r)]}get(r){this.j();const o=this.#i.get(r);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(r){return this.j(),Array.isArray(this.#i.get(r))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(r,o){return r[0].toString()<o[0].toString()?-1:r[0].toString()>o[0].toString()?1:0}}e.$wlc=w;let f=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(r){const o=new T.$Ac;for(const n of r)o.set(n,n);return{uris:Object.freeze(Array.from(o.values()))}}constructor(r,o,n,i){this.j=o,this.k=n,this.l=i,this.g=new Map,this.h=new m.$he({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this.h.event,l._mapper),this.f=r.getProxy(M.$$M.MainThreadDiagnostics)}createDiagnosticCollection(r,o){const{g:n,f:i,h:c,j:u,k:t,l:d}=this,a=new class{$changeMany(p,v){i.$changeMany(p,v),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,p,v.length===0?"CLEARING":v)}$clear(p){i.$clear(p),u.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,p)}dispose(){i.dispose()}};let g;if(!o)o="_generated_diagnostic_collection_name_#"+l.c++,g=o;else if(!n.has(o))g=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do g=o+l.c++;while(n.has(g))}return new class extends w{constructor(){super(o,g,l.e,l.d,p=>d.getDocument(p)?.version,t.extUri,a,c),n.set(g,this)}dispose(){super.dispose(),n.delete(g)}}}getDiagnostics(r){if(r)return this.m(r);{const o=new Map,n=[];for(const i of this.g.values())i.forEach((c,u)=>{let t=o.get(c.toString());typeof t>"u"&&(t=n.length,o.set(c.toString(),t),n.push([c,[]])),n[t][1]=n[t][1].concat(...u)});return n}}m(r){let o=[];for(const n of this.g.values())n.has(r)&&(o=o.concat(n.get(r)));return o}$acceptMarkersChange(r){if(!this.n){const o="_generated_mirror",n=new w(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(o,n),this.n=n}for(const[o,n]of r)this.n.set(R.URI.revive(o),n.map($.Diagnostic.to))}};e.$xlc=f,e.$xlc=f=l=Je([We(1,E.$3j),We(2,k.$vlc)],f)}),define(Se[268],Pe([1,0,2,14,7,8,200,35]),function(le,e,C,O,R,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=void 0;class m{constructor(T,k,l,w={timeout:1500,errors:3}){this.c=T,this.d=k,this.f=l,this.g=w,this.a=new A.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(T){return(k,l,w)=>{const s={dispose:this.a.push([k,l,T])};return Array.isArray(w)&&w.push(s),s}}async $participateInSave(T,k){const l=C.URI.revive(T);let w=!1;const f=setTimeout(()=>w=!0,this.g.timeout),s=[];try{for(const r of[...this.a]){if(w)break;const o=this.d.getDocument(l),n=await this.h(r,{document:o,reason:M.TextDocumentSaveReason.to(k)});s.push(n)}}finally{clearTimeout(f)}return s}h([T,k,l],w){const f=this.b.get(T);return typeof f=="number"&&f>this.g.errors?Promise.resolve(!1):this.i(l,T,k,w).then(()=>!0,s=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' threw ERROR`),this.c.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const r=this.b.get(T);this.b.set(T,r?r+1:1),typeof r=="number"&&r>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(T,k,l,w){const f=[],s=Date.now(),{document:r,reason:o}=w,{version:n}=r,i=Object.freeze({document:r,reason:o,waitUntil(c){if(Object.isFrozen(f))throw(0,O.$8)("waitUntil can not be called async");f.push(Promise.resolve(c))}});try{k.apply(l,[i])}catch(c){return Promise.reject(c)}return Object.freeze(f),new Promise((c,u)=>{const t=setTimeout(()=>u(new Error("timeout")),this.g.timeout);return Promise.all(f).then(d=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(t),c(d)}).catch(d=>{clearTimeout(t),u(d)})}).then(c=>{const u={edits:[]};for(const t of c)if(Array.isArray(t)&&t.every(d=>d instanceof R.$hN))for(const{newText:d,newEol:a,range:g}of t)u.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:g&&M.Range.from(g),text:d,eol:a&&M.EndOfLine.from(a)}});if(u.edits.length!==0)return n===r.version?this.f.$tryApplyWorkspaceEdit(new $.$Bw(u)):Promise.reject(new Error("concurrent_edits"))})}}e.$Fmc=m}),define(Se[269],Pe([1,0,5,6,2,4,113,8,15,25,7]),function(le,e,C,O,R,M,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylc=void 0;class k{constructor(w,f){this.a=new C.$de,this.b=new C.$de,this.c=new C.$de,this.d=new C.$de,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Tc,this.h=new Map,this.f=w.getProxy(M.$$M.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(s=>{for(const r of s)this.b.fire(r.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const r of s)this.a.fire(r.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(w){if(!w)return;const f=this.g.getDocument(w);if(f)return f}getDocument(w){const f=this.getDocumentData(w);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return f.document}ensureDocumentData(w){const f=this.g.getDocument(w);if(f)return Promise.resolve(f);let s=this.h.get(w.toString());return s||(s=this.f.$tryOpenDocument(w).then(r=>{this.h.delete(w.toString());const o=R.URI.revive(r);return(0,m.$hg)(this.g.getDocument(o))},r=>(this.h.delete(w.toString()),Promise.reject(r))),this.h.set(w.toString(),s)),s}createDocumentData(w){return this.f.$tryCreateDocument(w).then(f=>R.URI.revive(f))}$acceptModelLanguageChanged(w,f){const s=R.URI.revive(w),r=this.g.getDocument(s);if(!r)throw new Error("unknown document");this.b.fire(r.document),r._acceptLanguageId(f),this.a.fire(r.document)}$acceptModelSaved(w){const f=R.URI.revive(w),s=this.g.getDocument(f);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(w,f){const s=R.URI.revive(w),r=this.g.getDocument(s);if(!r)throw new Error("unknown document");r._acceptIsDirty(f),this.c.fire({document:r.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,f,s){const r=R.URI.revive(w),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(s),o.onEvents(f);let n;f.isUndoing?n=T.TextDocumentChangeReason.Undo:f.isRedoing&&(n=T.TextDocumentChangeReason.Redo),this.c.fire((0,E.$4n)({document:o.document,contentChanges:f.changes.map(i=>({range:$.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(w,f){(0,A.$BP)(w,f)}}e.$ylc=k}),define(Se[67],Pe([1,0,270,5,15,2,3,4,17,8,7]),function(le,e,C,O,R,M,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=e.$3lc=void 0,e.$3lc=(0,A.$wi)("IExtHostEditorTabs");class k{constructor(r,o,n){this.e=n,this.d=o,this.acceptDtoUpdate(r)}get apiObject(){if(!this.a){const r=this,o={get isActive(){return r.b.id===r.e()},get label(){return r.b.label},get input(){return r.c},get isDirty(){return r.b.isDirty},get isPinned(){return r.b.isPinned},get isPreview(){return r.b.isPreview},get group(){return r.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(r){this.b=r,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.$XO(M.URI.revive(this.b.input.uri));case 2:return new T.$YO(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new T.$ZO(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new T.$1O(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.$2O(this.b.input.viewType);case 4:return new T.$3O(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.$4O(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.$5O;case 9:return new T.$6O(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new T.$7O;case 11:return new T.$8O(this.b.input.diffEditors.map(r=>new T.$YO(M.URI.revive(r.original),M.URI.revive(r.modified))));default:return}}}class l{constructor(r,o){this.c=[],this.d="",this.b=r,this.e=o;for(const n of r.tabs)n.isActive&&(this.d=n.id),this.c.push(new k(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const r=this,o={get isActive(){return r.b.groupId===r.e()},get viewColumn(){return E.ViewColumn.to(r.b.viewColumn)},get activeTab(){return r.c.find(n=>n.tabId===r.d)?.apiObject},get tabs(){return Object.freeze(r.c.map(n=>n.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(r){this.b=r}acceptTabOperation(r){if(r.kind===0){const n=new k(r.tabDto,this,()=>this.activeTabId());return this.c.splice(r.index,0,n),r.tabDto.isActive&&(this.d=n.tabId),n}else if(r.kind===1){const n=this.c.splice(r.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${r.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(r.kind===3){if(r.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(r.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${r.oldIndex} which does not exist`);return this.c.splice(r.index,0,n),n}const o=this.c.find(n=>n.tabId===r.tabDto.id);if(!o)throw new Error("INVALID tab");return r.tabDto.isActive?this.d=r.tabDto.id:this.d===r.tabDto.id&&!r.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(r.tabDto),o}activeTabId(){return this.d}}let w=class{constructor(r){this.b=new O.$de,this.c=new O.$de,this.e=[],this.a=r.getProxy($.$$M.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const r=this,o={onDidChangeTabGroups:r.c.event,onDidChangeTabs:r.b.event,get all(){return Object.freeze(r.e.map(n=>n.apiObject))},get activeTabGroup(){const n=r.d;return(0,R.$hg)(r.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,i)=>{const c=Array.isArray(n)?n:[n];return c.length?f(c[0])?this.j(c,i):this.i(c,i):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(r){const o=new Set(this.e.map(a=>a.groupId)),n=new Set(r.map(a=>a.groupId)),i=(0,C.$L)(o,n),c=this.e.filter(a=>i.removed.includes(a.groupId)).map(a=>a.apiObject),u=[],t=[];this.e=r.map(a=>{const g=new l(a,()=>this.d);return i.added.includes(g.groupId)?u.push(g.apiObject):t.push(g.apiObject),g});const d=(0,R.$hg)(r.find(a=>a.isActive===!0)?.groupId);d!==void 0&&this.d!==d&&(this.d=d),this.c.fire(Object.freeze({opened:u,closed:c,changed:t}))}$acceptTabGroupUpdate(r){const o=this.e.find(n=>n.groupId===r.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(r),r.isActive&&(this.d=r.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(r){const o=this.e.find(i=>i.groupId===r.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const n=o.acceptTabOperation(r);switch(r.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(r){for(const o of this.e)for(const n of o.tabs)if(n.apiObject===r)return n}h(r){return this.e.find(o=>o.apiObject===r)}async i(r,o){const n=[];for(const i of r){const c=this.g(i);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,o)}async j(r,o){const n=[];for(const i of r){const c=this.h(i);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,o)}};e.$4lc=w,e.$4lc=w=Je([We(0,m.$zP)],w);function f(s){return s.tabs!==void 0}}),define(Se[271],Pe([1,0,2,4,6,7,8,314,13,21,26,55]),function(le,e,C,O,R,M,A,$,m,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=void 0;class l{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const r=this.a.indexOf(s);r>=0&&(this.a.splice(r,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),r=[];let o,n,i=14,c=14;for(const u of s){let t=o?(0,m.$zf)(o,u):0;for(t===0?n=1:n=c;t<u.length;t++)t+1===u.length?(i=c,c=9):c+=1,r.push([n,u.toUpperCase().charCodeAt(t),c]),r.push([n,u.toLowerCase().charCodeAt(t),c]),n=c;o=u,c=i}r.push([9,58,10]),r.push([10,47,12]),this.b=new $.$w3(r)}}provideDocumentLinks(s){this.c();const r=[],o=$.$x3.computeLinks({getLineContent(n){return s.lineAt(n-1).text},getLineCount(){return s.lineCount}},this.b);for(const n of o){const i=A.DocumentLink.to(n);i.target&&r.push(i)}return r}}class w{constructor(s,r){this.i=r,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(O.$$M.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,r,o,n={}){if(w.j(o),this.d.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const i=this.h++;this.b.add(r),this.d.add(r),this.c.set(i,o);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof o.copy=="function"&&(c+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,T.$PG)(s,"fsChunks"),c+=4);let u;n.isReadonly&&(0,k.$Vk)(n.isReadonly)&&n.isReadonly.value!==""&&(u={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,r,c,u).catch(d=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${r}`),console.error(d)});const t=o.onDidChangeFile(d=>{const a=[];for(const g of d){const{uri:b,type:p}=g;if(b.scheme!==r)continue;let v;switch(p){case M.FileChangeType.Changed:v=0;break;case M.FileChangeType.Created:v=1;break;case M.FileChangeType.Deleted:v=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:b,type:v})}this.a.$onFileSystemChange(i,a)});return(0,R.$Sc)(()=>{t.dispose(),this.b.delete(r),this.d.delete(r),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:r,ctime:o,mtime:n,size:i,permissions:c}=s;return{type:r,ctime:o,mtime:n,size:i,permissions:c}}$stat(s,r){return Promise.resolve(this.l(s).stat(C.URI.revive(r))).then(o=>w.k(o))}$readdir(s,r){return Promise.resolve(this.l(s).readDirectory(C.URI.revive(r)))}$readFile(s,r){return Promise.resolve(this.l(s).readFile(C.URI.revive(r))).then(o=>E.$Fe.wrap(o))}$writeFile(s,r,o,n){return Promise.resolve(this.l(s).writeFile(C.URI.revive(r),o.buffer,n))}$delete(s,r,o){return Promise.resolve(this.l(s).delete(C.URI.revive(r),o))}$rename(s,r,o,n){return Promise.resolve(this.l(s).rename(C.URI.revive(r),C.URI.revive(o),n))}$copy(s,r,o,n){const i=this.l(s);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(C.URI.revive(r),C.URI.revive(o),n))}$mkdir(s,r){return Promise.resolve(this.l(s).createDirectory(C.URI.revive(r)))}$watch(s,r,o,n){const i=this.l(s).watch(C.URI.revive(o),n);this.f.set(r,i)}$unwatch(s,r){const o=this.f.get(r);o&&(o.dispose(),this.f.delete(r))}$open(s,r,o){const n=this.l(s);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(C.URI.revive(r),o))}$close(s,r){const o=this.l(s);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(r))}$read(s,r,o,n){const i=this.l(s);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const c=E.$Fe.alloc(n);return Promise.resolve(i.read(r,o,c.buffer,0,n)).then(u=>c.slice(0,u))}$write(s,r,o,n){const i=this.l(s);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(r,o,n.buffer,0,n.byteLength))}l(s){const r=this.c.get(s);if(!r){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return r}}e.$Hmc=w}),define(Se[272],Pe([1,0,5,37,2,4,8,7,43]),function(le,e,C,O,R,M,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,f,s,r,o,n){this.a=Math.random(),this.b=new C.$de,this.c=new C.$de,this.d=new C.$de,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,O.$qk)(o),c=typeof o=="string",u=n?.correlate,t=r(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(u&&typeof d.session>"u")){if(!n?.ignoreCreateEvents)for(const a of d.created){const g=R.URI.revive(a);i(g.fsPath)&&(!c||f.getWorkspaceFolder(g))&&this.b.fire(g)}if(!n?.ignoreChangeEvents)for(const a of d.changed){const g=R.URI.revive(a);i(g.fsPath)&&(!c||f.getWorkspaceFolder(g))&&this.c.fire(g)}if(!n?.ignoreDeleteEvents)for(const a of d.deleted){const g=R.URI.revive(a);i(g.fsPath)&&(!c||f.getWorkspaceFolder(g))&&this.d.fire(g)}}});this.g=$.$aN.from(this.i(w,s,o,n,n?.correlate),this.b,this.c,this.d,t)}i(w,f,s,r,o){const n=$.$aN.from();if(typeof s=="string"||r?.ignoreChangeEvents&&r?.ignoreCreateEvents&&r?.ignoreDeleteEvents)return n;const i=w.getProxy(M.$$M.MainThreadFileSystemEventService);let c=!1;(s.pattern.includes(O.$mk)||s.pattern.includes(O.$nk))&&(c=!0);let u;return o&&(r?.ignoreChangeEvents||r?.ignoreCreateEvents||r?.ignoreDeleteEvents)&&(u=14,r?.ignoreChangeEvents&&(u&=-3),r?.ignoreCreateEvents&&(u&=-5),r?.ignoreDeleteEvents&&(u&=-9)),i.$watch(f.identifier.value,this.a,s.baseUri,{recursive:c,excludes:r?.excludes??[],filter:u},!!o),$.$aN.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class T{constructor(w){this.a=w,this.session=this.a.session,this.b=new m.$V(()=>this.a.created.map(R.URI.revive)),this.c=new m.$V(()=>this.a.changed.map(R.URI.revive)),this.d=new m.$V(()=>this.a.deleted.map(R.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(w,f,s){this.j=w,this.k=f,this.l=s,this.a=new C.$de,this.b=new C.$de,this.c=new C.$de,this.d=new C.$de,this.g=new C.$fe,this.h=new C.$fe,this.i=new C.$fe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,f,s,r){return new E(this.j,w,f,this.a.event,A.GlobPattern.from(s),r)}$onFileEvent(w){this.a.fire(new T(w))}$onDidRunFileOperation(w,f){switch(w){case 2:this.b.fire(Object.freeze({files:f.map(s=>({oldUri:R.URI.revive(s.source),newUri:R.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:f.map(s=>R.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:f.map(s=>R.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,f){return(s,r,o)=>{const n=function(c){s.call(r,c)};return n.extension=w,f.event(n,void 0,o)}}async $onWillRunFileOperation(w,f,s,r){switch(w){case 2:return await this.n(this.g,{files:f.map(o=>({oldUri:R.URI.revive(o.source),newUri:R.URI.revive(o.target)}))},s,r);case 1:return await this.n(this.i,{files:f.map(o=>R.URI.revive(o.target))},s,r);case 0:case 3:return await this.n(this.h,{files:f.map(o=>R.URI.revive(o.target))},s,r)}}async n(w,f,s,r){const o=new Set,n=[];if(await w.fireAsync(f,r,async(c,u)=>{const t=Date.now(),d=await Promise.resolve(c);d instanceof $.$kN&&(n.push([u.extension,d]),o.add(u.extension.displayName??u.extension.identifier.value)),Date.now()-t>s&&this.k.warn("SLOW file-participant",u.extension.identifier)}),r.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,c]of n){const{edits:u}=A.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(u)}return{edit:i,extensionNames:Array.from(o)}}}e.$Imc=k}),define(Se[273],Pe([1,0,18,11,24,14,91,6,25,66,13,15,2,30,315,89,98,174,20,8,7,26,76,4]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r,o,n,i,c,u,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=void 0;class a{constructor(U,F){this.d=U,this.e=F}async provideDocumentSymbols(U,F){const G=this.d.getDocument(U),H=await this.e.provideDocumentSymbols(G,F);if(!(0,C.$Kb)(H))return H[0]instanceof c.$uN?H.map(i.DocumentSymbol.from):a.f(H)}static f(U){U=U.slice(0).sort((H,ee)=>{let re=H.location.range.start.compareTo(ee.location.range.start);return re===0&&(re=ee.location.range.end.compareTo(H.location.range.end)),re});const F=[],G=[];for(const H of U){const ee={name:H.name||"!!MISSING: name!!",kind:i.SymbolKind.from(H.kind),tags:H.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:i.Range.from(H.location.range),selectionRange:i.Range.from(H.location.range),children:[]};for(;;){if(G.length===0){G.push(ee),F.push(ee);break}const re=G[G.length-1];if(w.$ut.containsRange(re.range,ee.range)&&!w.$ut.equalsRange(re.range,ee.range)){re.children?.push(ee),G.push(ee);break}G.pop()}}return F}}class g{constructor(U,F,G,H,ee,re){this.f=U,this.g=F,this.h=G,this.j=H,this.k=ee,this.l=re,this.d=new t.$plc("CodeLens"),this.e=new Map}async provideCodeLenses(U,F){const G=this.f.getDocument(U),H=await this.h.provideCodeLenses(G,F);if(!H||F.isCancellationRequested)return;const ee=this.d.add(H),re=new $.$Tc;this.e.set(ee,re);const Oe={cacheId:ee,lenses:[]};for(let Be=0;Be<H.length;Be++)Oe.lenses.push({cacheId:[ee,Be],range:i.Range.from(H[Be].range),command:this.g.toInternal(H[Be].command,re)});return Oe}async resolveCodeLens(U,F){const G=U.cacheId&&this.d.get(...U.cacheId);if(!G)return;let H;if(typeof this.h.resolveCodeLens!="function"||G.isResolved?H=G:H=await this.h.resolveCodeLens(G,F),H||(H=G),F.isCancellationRequested)return;const ee=U.cacheId&&this.e.get(U.cacheId[0]);if(ee){if(!H.command){const re=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,re),this.l.error(re);return}return U.command=this.g.toInternal(H.command,ee),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function b(je){return Array.isArray(je)?je.map(i.DefinitionLink.from):je?[i.DefinitionLink.from(je)]:[]}class p{constructor(U,F){this.d=U,this.e=F}async provideDefinition(U,F,G){const H=this.d.getDocument(U),ee=i.Position.to(F),re=await this.e.provideDefinition(H,ee,G);return b(re)}}class v{constructor(U,F){this.d=U,this.e=F}async provideDeclaration(U,F,G){const H=this.d.getDocument(U),ee=i.Position.to(F),re=await this.e.provideDeclaration(H,ee,G);return b(re)}}class y{constructor(U,F){this.d=U,this.e=F}async provideImplementation(U,F,G){const H=this.d.getDocument(U),ee=i.Position.to(F),re=await this.e.provideImplementation(H,ee,G);return b(re)}}class h{constructor(U,F){this.d=U,this.e=F}async provideTypeDefinition(U,F,G){const H=this.d.getDocument(U),ee=i.Position.to(F),re=await this.e.provideTypeDefinition(H,ee,G);return b(re)}}class D{static{this.f=10}constructor(U,F){this.g=U,this.h=F,this.d=0,this.e=new Map}async provideHover(U,F,G,H){const ee=this.g.getDocument(U),re=i.Position.to(F);let Oe;if(G&&G.verbosityRequest){const xe=G.verbosityRequest.previousHover.id,et=this.e.get(xe);if(!et)throw new Error(`Hover with id ${xe} not found`);const tt={action:G.verbosityRequest.action,previousHover:et};Oe=await this.h.provideHover(ee,re,H,tt)}else Oe=await this.h.provideHover(ee,re,H);if(!Oe||(0,C.$Kb)(Oe.contents))return;Oe.range||(Oe.range=ee.getWordRangeAtPosition(re)),Oe.range||(Oe.range=new c.$cN(re,re));const Be=i.Hover.from(Oe),He=this.d;if(this.e.size===D.f){const xe=Math.min(...this.e.keys());this.e.delete(xe)}return this.e.set(He,Oe),this.d+=1,{...Be,id:He}}releaseHover(U){this.e.delete(U)}}class S{constructor(U,F){this.d=U,this.e=F}async provideEvaluatableExpression(U,F,G){const H=this.d.getDocument(U),ee=i.Position.to(F),re=await this.e.provideEvaluatableExpression(H,ee,G);if(re)return i.EvaluatableExpression.from(re)}}class I{constructor(U,F){this.d=U,this.e=F}async provideInlineValues(U,F,G,H){const ee=this.d.getDocument(U),re=await this.e.provideInlineValues(ee,i.Range.to(F),i.InlineValueContext.to(G),H);if(Array.isArray(re))return re.map(Oe=>i.InlineValue.from(Oe))}}class P{constructor(U,F){this.d=U,this.e=F}async provideDocumentHighlights(U,F,G){const H=this.d.getDocument(U),ee=i.Position.to(F),re=await this.e.provideDocumentHighlights(H,ee,G);if(Array.isArray(re))return re.map(i.DocumentHighlight.from)}}class W{constructor(U,F){this.d=U,this.e=F}async provideMultiDocumentHighlights(U,F,G,H){const ee=this.d.getDocument(U),re=G.map(He=>this.d.getDocument(He)),Oe=i.Position.to(F),Be=await this.e.provideMultiDocumentHighlights(ee,Oe,re,H);if(Array.isArray(Be))return Be.map(i.MultiDocumentHighlight.from)}}class V{constructor(U,F){this.d=U,this.e=F}async provideLinkedEditingRanges(U,F,G){const H=this.d.getDocument(U),ee=i.Position.to(F),re=await this.e.provideLinkedEditingRanges(H,ee,G);if(re&&Array.isArray(re.ranges))return{ranges:(0,C.$Hb)(re.ranges.map(i.Range.from)),wordPattern:re.wordPattern}}}class q{constructor(U,F){this.d=U,this.e=F}async provideReferences(U,F,G,H){const ee=this.d.getDocument(U),re=i.Position.to(F),Oe=await this.e.provideReferences(ee,re,G,H);if(Array.isArray(Oe))return Oe.map(i.location.from)}}class N{static{this.d=1e3}constructor(U,F,G,H,ee,re,Oe){this.g=U,this.h=F,this.j=G,this.k=H,this.l=ee,this.m=re,this.n=Oe,this.e=new t.$plc("CodeAction"),this.f=new Map}async provideCodeActions(U,F,G,H){const ee=this.g.getDocument(U),re=f.$wt.isISelection(F)?i.Selection.to(F):i.Range.to(F),Oe=[];for(const tt of this.j.getDiagnostics(U))if(re.intersection(tt.range)&&Oe.push(tt)>N.d)break;const Be={diagnostics:Oe,only:G.only?new c.$wN(G.only):void 0,triggerKind:i.CodeActionTriggerKind.to(G.trigger)},He=await this.k.provideCodeActions(ee,re,Be,H);if(!(0,C.$Lb)(He)||H.isCancellationRequested)return;const _e=this.e.add(He),xe=new $.$Tc;this.f.set(_e,xe);const et=[];for(let tt=0;tt<He.length;tt++){const it=He[tt];if(it)if(N.o(it))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:it.title,command:this.h.toInternal(it,xe)});else{Be.only&&(it.kind?Be.only.contains(it.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ct=it.ranges??[];et.push({cacheId:[_e,tt],title:it.title,command:it.command&&this.h.toInternal(it.command,xe),diagnostics:it.diagnostics&&it.diagnostics.map(i.Diagnostic.from),edit:it.edit&&i.WorkspaceEdit.from(it.edit,void 0),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,isAI:(0,u.$OG)(this.m,"codeActionAI")?it.isAI:!1,ranges:(0,u.$OG)(this.m,"codeActionRanges")?(0,C.$Hb)(ct.map(i.Range.from)):void 0,disabled:it.disabled?.reason})}}return{cacheId:_e,actions:et}}async resolveCodeAction(U,F){const[G,H]=U,ee=this.e.get(G,H);if(!ee||N.o(ee))return{};if(!this.k.resolveCodeAction)return{};const re=await this.k.resolveCodeAction(ee,F)??ee;let Oe;re.edit&&(Oe=i.WorkspaceEdit.from(re.edit,void 0));let Be;if(re.command){const He=this.f.get(G);He&&(Be=this.h.toInternal(re.command,He))}return{edit:Oe,command:Be}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class B{constructor(U,F,G,H,ee){this.e=U,this.f=F,this.g=G,this.h=H,this.j=ee,this.d=new t.$plc("DocumentPasteEdit")}async prepareDocumentPaste(U,F,G,H){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(U),re=F.map(He=>i.Range.to(He)),Oe=i.DataTransfer.toDataTransfer(G,()=>{throw new M.$$});if(await this.g.prepareDocumentPaste(ee,re,Oe,H),H.isCancellationRequested)return;const Be=Array.from(Oe).filter(([,He])=>!(He instanceof c.$3N));return i.DataTransfer.from(Be)}async providePasteEdits(U,F,G,H,ee,re){if(!this.g.provideDocumentPasteEdits)return[];const Oe=this.f.getDocument(F),Be=G.map(et=>i.Range.to(et)),He=i.DataTransfer.toDataTransfer(H,async et=>(await this.e.$resolvePasteFileData(this.h,U,et)).buffer),_e=await this.g.provideDocumentPasteEdits(Oe,Be,He,{only:ee.only?new c.$8N(ee.only):void 0,triggerKind:ee.triggerKind},re);if(!_e||re.isCancellationRequested)return[];const xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,o.localize)(0,null,this.j.displayName||this.j.name),kind:et.kind,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?i.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,F){const[G,H]=U,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const re=await this.g.resolveDocumentPasteEdit(ee,F)??ee;return{additionalEdit:re.additionalEdit?i.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class K{constructor(U,F){this.d=U,this.e=F}async provideDocumentFormattingEdits(U,F,G){const H=this.d.getDocument(U),ee=await this.e.provideDocumentFormattingEdits(H,F,G);if(Array.isArray(ee))return ee.map(i.TextEdit.from)}}class ie{constructor(U,F){this.d=U,this.e=F}async provideDocumentRangeFormattingEdits(U,F,G,H){const ee=this.d.getDocument(U),re=i.Range.to(F),Oe=await this.e.provideDocumentRangeFormattingEdits(ee,re,G,H);if(Array.isArray(Oe))return Oe.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,F,G,H){(0,k.$gg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(U),re=F.map(i.Range.to),Oe=await this.e.provideDocumentRangesFormattingEdits(ee,re,G,H);if(Array.isArray(Oe))return Oe.map(i.TextEdit.from)}}class ce{constructor(U,F){this.d=U,this.e=F,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,F,G,H,ee){const re=this.d.getDocument(U),Oe=i.Position.to(F),Be=await this.e.provideOnTypeFormattingEdits(re,Oe,G,H,ee);if(Array.isArray(Be))return Be.map(i.TextEdit.from)}}class ye{constructor(U,F){this.e=U,this.f=F,this.d=new t.$plc("WorkspaceSymbols")}async provideWorkspaceSymbols(U,F){const G=await this.e.provideWorkspaceSymbols(U,F);if(!(0,C.$Lb)(G))return{symbols:[]};const H=this.d.add(G),ee={cacheId:H,symbols:[]};for(let re=0;re<G.length;re++){const Oe=G[re];if(!Oe||!Oe.name){this.f.warn("INVALID SymbolInformation",Oe);continue}ee.symbols.push({...i.WorkspaceSymbol.from(Oe),cacheId:[H,re]})}return ee}async resolveWorkspaceSymbol(U,F){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const G=this.d.get(...U.cacheId);if(G){const H=await this.e.resolveWorkspaceSymbol(G,F);return H&&(0,m.$6n)(U,i.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class ke{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,F,G){this.d=U,this.e=F,this.f=G}async provideRenameEdits(U,F,G,H){const ee=this.d.getDocument(U),re=i.Position.to(F);try{const Oe=await this.e.provideRenameEdits(ee,re,G,H);return Oe?i.WorkspaceEdit.from(Oe):void 0}catch(Oe){const Be=ke.g(Oe);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(U,F,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(U),ee=i.Position.to(F);try{const re=await this.e.prepareRename(H,ee,G);let Oe,Be;if(c.$cN.isRange(re)?(Oe=re,Be=H.getText(re)):(0,k.$$f)(re)&&(Oe=re.range,Be=re.placeholder),!Oe||!Be)return;if(Oe.start.line>ee.line||Oe.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Oe),text:Be}}catch(re){const Oe=ke.g(re);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(re)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class fe{static{this.d={[s.NewSymbolNameTriggerKind.Invoke]:c.NewSymbolNameTriggerKind.Invoke,[s.NewSymbolNameTriggerKind.Automatic]:c.NewSymbolNameTriggerKind.Automatic}}constructor(U,F,G){this.e=U,this.f=F,this.g=G}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(U,F,G,H){const ee=this.e.getDocument(U),re=i.Range.to(F);try{const Oe=fe.d[G],Be=await this.f.provideNewSymbolNames(ee,re,Oe,H);return Be?Be.map(He=>typeof He=="string"?{newSymbolName:He}:{newSymbolName:He.newSymbolName,tags:He.tags}):void 0}catch(Oe){this.g.error(fe.h(Oe)??JSON.stringify(Oe,null,"	"));return}}static h(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class $e{constructor(U,F){this.resultId=U,this.tokens=F}}class Te{constructor(U,F){this.f=U,this.g=F,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,F,G){const H=this.f.getDocument(U),ee=F!==0?this.d.get(F):null;let re=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ee.resultId,G):await this.g.provideDocumentSemanticTokens(H,G);return ee&&this.d.delete(F),re?(re=Te.h(re),this.o(Te.n(ee,re),re)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return Te.j(U)?Te.k(U)?U:new c.$vO(new Uint32Array(U.data),U.resultId):Te.l(U)?Te.m(U)?U:new c.$xO(U.edits.map(F=>new c.$wO(F.start,F.deleteCount,F.data?new Uint32Array(F.data):F.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const F of U.edits)if(!(F.data instanceof Uint32Array))return!1;return!0}static n(U,F){if(!Te.j(F)||!U||!U.tokens)return F;const G=U.tokens,H=G.length,ee=F.data,re=ee.length;let Oe=0;const Be=Math.min(H,re);for(;Oe<Be&&G[Oe]===ee[Oe];)Oe++;if(Oe===H&&Oe===re)return new c.$xO([],F.resultId);let He=0;const _e=Be-Oe;for(;He<_e&&G[H-He-1]===ee[re-He-1];)He++;return new c.$xO([{start:Oe,deleteCount:H-Oe-He,data:ee.subarray(Oe,re-He)}],F.resultId)}o(U,F){if(Te.j(U)){const G=this.e++;return this.d.set(G,new $e(U.resultId,U.data)),(0,r.$ccb)({id:G,type:"full",data:U.data})}if(Te.l(U)){const G=this.e++;return Te.j(F)?this.d.set(G,new $e(F.resultId,F.data)):this.d.set(G,new $e(U.resultId)),(0,r.$ccb)({id:G,type:"delta",deltas:(U.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class ae{constructor(U,F){this.d=U,this.e=F}async provideDocumentRangeSemanticTokens(U,F,G){const H=this.d.getDocument(U),ee=await this.e.provideDocumentRangeSemanticTokens(H,i.Range.to(F),G);return ee?this.f(ee):null}f(U){return(0,r.$ccb)({id:0,type:"full",data:U.data})}}class Ne{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,F,G,H,ee){this.f=U,this.g=F,this.h=G,this.j=H,this.k=ee,this.d=new t.$plc("CompletionItem"),this.e=new Map}async provideCompletionItems(U,F,G,H){const ee=this.f.getDocument(U),re=i.Position.to(F),Oe=ee.getWordRangeAtPosition(re)||new c.$cN(re,re),Be=Oe.with({end:re}),He=new E.$_d,_e=await this.h.provideCompletionItems(ee,re,H,i.CompletionContext.to(G));if(!_e||H.isCancellationRequested)return;const xe=Array.isArray(_e)?new c.$JN(_e):_e,et=Ne.supportsResolving(this.h)?this.d.add(xe.items):this.d.add([]),tt=new $.$Tc;this.e.set(et,tt);const it=[],ct={x:et,b:it,a:{replace:i.Range.from(Oe),insert:i.Range.from(Be)},c:xe.isIncomplete||void 0,d:He.elapsed()};for(let gt=0;gt<xe.items.length;gt++){const Ue=xe.items[gt],ot=this.l(Ue,[et,gt],Be,Oe);it.push(ot)}return ct}async resolveCompletionItem(U,F){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...U);if(!G)return;const H=this.l(G,U),ee=await this.h.resolveCompletionItem(G,F);if(!ee)return;const re=this.l(ee,U);return(H.h!==re.h||H.i!==re.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==re.n||H.o!==re.o||!(0,m.$7n)(H.p,re.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:re.d,c:re.c,l:re.l,h:re.h,i:re.i,n:re.n,o:re.o,p:re.p}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,F,G,H){const ee=this.e.get(F[0]);if(!ee)throw Error("DisposableStore is missing...");const re=this.g.toInternal(U.command,ee),Oe={x:F,a:U.label,b:U.kind!==void 0?i.CompletionItemKind.from(U.kind):void 0,m:U.tags&&U.tags.map(i.CompletionItemTag.from),c:U.detail,d:typeof U.documentation>"u"?void 0:i.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters?.join(""),l:U.additionalTextEdits&&U.additionalTextEdits.map(i.TextEdit.from),n:re?.$ident,o:re?.id,p:re?.$ident?void 0:re?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=U.textEdit.newText):typeof U.insertText=="string"?Oe.h=U.insertText:U.insertText instanceof c.$lN&&(Oe.h=U.insertText.value,Oe.i|=4);let Be;return U.textEdit?Be=U.textEdit.range:U.range&&(Be=U.range),c.$cN.isRange(Be)?Oe.j=i.Range.from(Be):Be&&(!G?.isEqual(Be.inserting)||!H?.isEqual(Be.replacing))&&(Oe.j={insert:i.Range.from(Be.inserting),replace:i.Range.from(Be.replacing)}),Oe}}class ne{async provideInlineCompletions(U,F,G,H){}disposeCompletions(U){}handleDidShowCompletionItem(U,F,G){}handlePartialAccept(U,F,G,H){}}class z extends ne{constructor(U,F,G,H){super(),this.f=U,this.g=F,this.h=G,this.j=H,this.d=new be,this.e=(0,u.$OG)(this.f,"inlineCompletionsAdditions"),this.k={[s.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[s.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,u.$OG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,F,G,H){const ee=this.g.getDocument(U),re=i.Position.to(F),Oe=await this.h.provideInlineCompletionItems(ee,re,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:i.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},H);if(!Oe||H.isCancellationRequested)return;const Be=Array.isArray(Oe)?Oe:Oe.items,He=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],_e=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let xe;return{pid:this.d.createReferenceId({dispose(){xe?.dispose()},items:Be}),items:Be.map((tt,it)=>{let ct;tt.command&&(xe||(xe=new $.$Tc),ct=this.j.toInternal(tt.command,xe));const gt=tt.insertText;return{insertText:typeof gt=="string"?gt:{snippet:gt.value},filterText:tt.filterText,range:tt.range?i.Range.from(tt.range):void 0,command:ct,idx:it,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:He.map(tt=>(xe||(xe=new $.$Tc),this.j.toInternal(tt,xe))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,F,G){const H=this.d.get(U)?.items[F];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,G)}handlePartialAccept(U,F,G,H){const ee=this.d.get(U)?.items[F];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,G),this.h.handleDidPartiallyAcceptCompletionItem(ee,i.PartialAcceptInfo.to(H)))}}class x{async provideInlineEdits(U,F,G){const H=this.f.getDocument(U),ee=await this.g.provideInlineEdit(H,{triggerKind:this.e[F.triggerKind]},G);if(!ee||G.isCancellationRequested)return;let re;const Oe=this.d.createReferenceId({dispose(){re?.dispose()},item:ee});let Be;ee.accepted&&(re||(re=new $.$Tc),Be=this.h.toInternal(ee.accepted,re));let He;return ee.rejected&&(re||(re=new $.$Tc),He=this.h.toInternal(ee.rejected,re)),{pid:Oe,text:ee.text,range:i.Range.from(ee.range),accepted:Be,rejected:He}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,F,G,H){this.f=F,this.g=G,this.h=H,this.d=new be,this.e={[s.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[s.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class be{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const F=this.e++;return this.d.set(F,U),F}disposeReferenceId(U){const F=this.d.get(U);return this.d.delete(U),F}get(U){return this.d.get(U)}}class Fe{constructor(U,F){this.e=U,this.f=F,this.d=new t.$plc("SignatureHelp")}async provideSignatureHelp(U,F,G,H){const ee=this.e.getDocument(U),re=i.Position.to(F),Oe=this.g(G),Be=await this.f.provideSignatureHelp(ee,re,H,Oe);if(Be){const He=this.d.add([Be]);return{...i.SignatureHelp.from(Be),id:He}}}g(U){let F;if(U.activeSignatureHelp){const G=i.SignatureHelp.to(U.activeSignatureHelp),H=this.d.get(U.activeSignatureHelp.id,0);H?(F=H,F.activeSignature=G.activeSignature,F.activeParameter=G.activeParameter):F=G}return{...U,activeSignatureHelp:F}}releaseSignatureHelp(U){this.d.delete(U)}}class De{constructor(U,F,G,H,ee){this.f=U,this.g=F,this.h=G,this.j=H,this.k=ee,this.d=new t.$plc("InlayHints"),this.e=new Map}async provideInlayHints(U,F,G){const H=this.f.getDocument(U),ee=i.Range.to(F),re=await this.h.provideInlayHints(H,ee,G);if(!Array.isArray(re)||re.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(F)}`);return}if(G.isCancellationRequested)return;const Oe=this.d.add(re);this.e.set(Oe,new $.$Tc);const Be={hints:[],cacheId:Oe};for(let He=0;He<re.length;He++)this.l(re[He],ee)&&Be.hints.push(this.m(re[He],[Oe,He]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(F)}`),Be}async resolveInlayHint(U,F){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...U);if(!G)return;const H=await this.h.resolveInlayHint(G,F);if(H&&this.l(H))return this.m(H,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,F){return U.label.length===0||Array.isArray(U.label)&&U.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(F&&!F.contains(U.position))}m(U,F){const G=this.e.get(F[0]);if(!G)throw Error("DisposableStore is missing...");const H={label:"",cacheId:F,tooltip:i.MarkdownString.fromStrict(U.tooltip),position:i.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(i.TextEdit.from),kind:U.kind&&i.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")H.label=U.label;else{const ee=[];H.label=ee;for(const re of U.label){if(!re.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Oe={label:re.value,tooltip:i.MarkdownString.fromStrict(re.tooltip)};c.$mN.isLocation(re.location)&&(Oe.location=i.location.from(re.location)),re.command&&(Oe.command=this.g.toInternal(re.command,G)),ee.push(Oe)}}return H}}class pe{constructor(U,F){this.e=U,this.f=F,this.d=new t.$plc("DocumentLink")}async provideLinks(U,F){const G=this.e.getDocument(U),H=await this.f.provideDocumentLinks(G,F);if(!(!Array.isArray(H)||H.length===0)&&!F.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(pe.g).map(i.DocumentLink.from)};{const ee=this.d.add(H),re={links:[],cacheId:ee};for(let Oe=0;Oe<H.length;Oe++){if(!pe.g(H[Oe]))continue;const Be=i.DocumentLink.from(H[Oe]);Be.cacheId=[ee,Oe],re.links.push(Be)}return re}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,F){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...U);if(!G)return;const H=await this.f.resolveDocumentLink(G,F);if(!(!H||!pe.g(H)))return i.DocumentLink.from(H)}releaseLinks(U){this.d.delete(U)}}class ge{constructor(U,F){this.d=U,this.e=F}async provideColors(U,F){const G=this.d.getDocument(U),H=await this.e.provideDocumentColors(G,F);return Array.isArray(H)?H.map(re=>({color:i.Color.from(re.color),range:i.Range.from(re.range)})):[]}async provideColorPresentations(U,F,G){const H=this.d.getDocument(U),ee=i.Range.to(F.range),re=i.Color.to(F.color),Oe=await this.e.provideColorPresentations(re,{document:H,range:ee},G);if(Array.isArray(Oe))return Oe.map(i.ColorPresentation.from)}}class Q{constructor(U,F){this.d=U,this.e=F}async provideFoldingRanges(U,F,G){const H=this.d.getDocument(U),ee=await this.e.provideFoldingRanges(H,F,G);if(Array.isArray(ee))return ee.map(i.FoldingRange.from)}}class Y{constructor(U,F,G){this.d=U,this.e=F,this.f=G}async provideSelectionRanges(U,F,G){const H=this.d.getDocument(U),ee=F.map(i.Position.to),re=await this.e.provideSelectionRanges(H,ee,G);if(!(0,C.$Lb)(re))return[];if(re.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let Be=0;Be<ee.length;Be++){const He=[];Oe.push(He);let _e=ee[Be],xe=re[Be];for(;;){if(!xe.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(He.push(i.SelectionRange.from(xe)),!xe.parent)break;_e=xe.range,xe=xe.parent}}return Oe}}class he{constructor(U,F){this.f=U,this.g=F,this.d=new A.$EP(""),this.e=new Map}async prepareSession(U,F,G){const H=this.f.getDocument(U),ee=i.Position.to(F),re=await this.g.prepareCallHierarchy(H,ee,G);if(!re)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(re)?re.map(Be=>this.h(Oe,Be)):[this.h(Oe,re)]}async provideCallsTo(U,F,G){const H=this.j(U,F);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(H,G);if(ee)return ee.map(re=>({from:this.h(U,re.from),fromRanges:re.fromRanges.map(Oe=>i.Range.from(Oe))}))}async provideCallsFrom(U,F,G){const H=this.j(U,F);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(H,G);if(ee)return ee.map(re=>({to:this.h(U,re.to),fromRanges:re.fromRanges.map(Oe=>i.Range.from(Oe))}))}releaseSession(U){this.e.delete(U)}h(U,F){const G=this.e.get(U),H=i.CallHierarchyItem.from(F,U,G.size.toString(36));return G.set(H._itemId,F),H}j(U,F){return this.e.get(U)?.get(F)}}class ue{constructor(U,F){this.f=U,this.g=F,this.d=new A.$EP(""),this.e=new Map}async prepareSession(U,F,G){const H=this.f.getDocument(U),ee=i.Position.to(F),re=await this.g.prepareTypeHierarchy(H,ee,G);if(!re)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(re)?re.map(Be=>this.h(Oe,Be)):[this.h(Oe,re)]}async provideSupertypes(U,F,G){const H=this.j(U,F);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(H,G);if(ee)return ee.map(re=>this.h(U,re))}async provideSubtypes(U,F,G){const H=this.j(U,F);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(H,G);if(ee)return ee.map(re=>this.h(U,re))}releaseSession(U){this.e.delete(U)}h(U,F){const G=this.e.get(U),H=i.TypeHierarchyItem.from(F,U,G.size.toString(36));return G.set(H._itemId,F),H}j(U,F){return this.e.get(U)?.get(F)}}class Me{constructor(U,F,G,H,ee){this.e=U,this.f=F,this.g=G,this.h=H,this.j=ee,this.d=new t.$plc("DocumentDropEdit")}async provideDocumentOnDropEdits(U,F,G,H,ee){const re=this.f.getDocument(F),Oe=i.Position.to(G),Be=i.DataTransfer.toDataTransfer(H,async et=>(await this.e.$resolveDocumentOnDropFileData(this.h,U,et)).buffer),He=await this.g.provideDocumentDropEdits(re,Oe,Be,ee);if(!He)return;const _e=(0,C.$2b)(He),xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,o.localize)(1,null,this.j.displayName||this.j.name),kind:et.kind?.value,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?i.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolveDropEdit(U,F){const[G,H]=U,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentDropEdit)return{};const re=await this.g.resolveDocumentDropEdit(ee,F)??ee;return{additionalEdit:re.additionalEdit?i.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releaseDropEdits(U){this.d.delete(U)}}class de{constructor(U,F){this.d=U,this.e=F}async provideMappedEdits(U,F,G,H){const ee=l.URI.revive(U),re=this.d.getDocument(ee),Oe=G.documents.map(_e=>_e.map(xe=>({uri:l.URI.revive(xe.uri),version:xe.version,ranges:xe.ranges.map(et=>i.Range.to(et))}))),Be={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(re,F,Be,H);return He?i.WorkspaceEdit.from(He):null}}class Ce{constructor(U,F){this.adapter=U,this.extension=F}}class Ae{static{this.d=0}constructor(U,F,G,H,ee,re,Oe,Be){this.g=F,this.h=G,this.j=H,this.k=ee,this.l=re,this.m=Oe,this.n=Be,this.f=new Map,this.e=U.getProxy(d.$$M.MainThreadLanguageFeatures)}o(U,F){return i.DocumentSelector.from(U,this.g,F)}p(U){return new c.$aN(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return Ae.d++}async s(U,F,G,H,ee,re=!1){const Oe=this.f.get(U);if(!Oe||!(Oe.adapter instanceof F))return H;const Be=Date.now();re||this.l.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const He=G(Oe.adapter,Oe.extension);return Promise.resolve(He).catch(_e=>{(0,M.$4)(_e)||(this.l.error(`[${Oe.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Oe.extension.identifier,_e))}).finally(()=>{re||this.l.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),R.CancellationToken.isCancellationToken(ee)?(0,O.$lh)(He,ee):He}t(U,F){const G=this.q();return this.f.set(G,new Ce(U,F)),G}static u(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,F,G,H){const ee=this.t(new a(this.h,G),U),re=H&&H.label||Ae.u(U);return this.e.$registerDocumentSymbolProvider(ee,this.o(F,U),re),this.p(ee)}$provideDocumentSymbols(U,F,G){return this.s(U,a,H=>H.provideDocumentSymbols(l.URI.revive(F),G),void 0,G)}registerCodeLensProvider(U,F,G){const H=this.q(),ee=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Ce(new g(this.h,this.j.converter,G,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(H,this.o(F,U),ee);let re=this.p(H);if(ee!==void 0){const Oe=G.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(ee));re=c.$aN.from(re,Oe)}return re}$provideCodeLenses(U,F,G){return this.s(U,g,H=>H.provideCodeLenses(l.URI.revive(F),G),void 0,G)}$resolveCodeLens(U,F,G){return this.s(U,g,H=>H.resolveCodeLens(F,G),void 0,void 0)}$releaseCodeLenses(U,F){this.s(U,g,G=>Promise.resolve(G.releaseCodeLenses(F)),void 0,void 0)}registerDefinitionProvider(U,F,G){const H=this.t(new p(this.h,G),U);return this.e.$registerDefinitionSupport(H,this.o(F,U)),this.p(H)}$provideDefinition(U,F,G,H){return this.s(U,p,ee=>ee.provideDefinition(l.URI.revive(F),G,H),[],H)}registerDeclarationProvider(U,F,G){const H=this.t(new v(this.h,G),U);return this.e.$registerDeclarationSupport(H,this.o(F,U)),this.p(H)}$provideDeclaration(U,F,G,H){return this.s(U,v,ee=>ee.provideDeclaration(l.URI.revive(F),G,H),[],H)}registerImplementationProvider(U,F,G){const H=this.t(new y(this.h,G),U);return this.e.$registerImplementationSupport(H,this.o(F,U)),this.p(H)}$provideImplementation(U,F,G,H){return this.s(U,y,ee=>ee.provideImplementation(l.URI.revive(F),G,H),[],H)}registerTypeDefinitionProvider(U,F,G){const H=this.t(new h(this.h,G),U);return this.e.$registerTypeDefinitionSupport(H,this.o(F,U)),this.p(H)}$provideTypeDefinition(U,F,G,H){return this.s(U,h,ee=>ee.provideTypeDefinition(l.URI.revive(F),G,H),[],H)}registerHoverProvider(U,F,G,H){const ee=this.t(new D(this.h,G),U);return this.e.$registerHoverProvider(ee,this.o(F,U)),this.p(ee)}$provideHover(U,F,G,H,ee){return this.s(U,D,re=>re.provideHover(l.URI.revive(F),G,H,ee),void 0,ee)}$releaseHover(U,F){this.s(U,D,G=>Promise.resolve(G.releaseHover(F)),void 0,void 0)}registerEvaluatableExpressionProvider(U,F,G,H){const ee=this.t(new S(this.h,G),U);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(F,U)),this.p(ee)}$provideEvaluatableExpression(U,F,G,H){return this.s(U,S,ee=>ee.provideEvaluatableExpression(l.URI.revive(F),G,H),void 0,H)}registerInlineValuesProvider(U,F,G,H){const ee=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,re=this.t(new I(this.h,G),U);this.e.$registerInlineValuesProvider(re,this.o(F,U),ee);let Oe=this.p(re);if(ee!==void 0){const Be=G.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(ee));Oe=c.$aN.from(Oe,Be)}return Oe}$provideInlineValues(U,F,G,H,ee){return this.s(U,I,re=>re.provideInlineValues(l.URI.revive(F),G,H,ee),void 0,ee)}registerDocumentHighlightProvider(U,F,G){const H=this.t(new P(this.h,G),U);return this.e.$registerDocumentHighlightProvider(H,this.o(F,U)),this.p(H)}registerMultiDocumentHighlightProvider(U,F,G){const H=this.t(new W(this.h,G),U);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(F,U)),this.p(H)}$provideDocumentHighlights(U,F,G,H){return this.s(U,P,ee=>ee.provideDocumentHighlights(l.URI.revive(F),G,H),void 0,H)}$provideMultiDocumentHighlights(U,F,G,H,ee){return this.s(U,W,re=>re.provideMultiDocumentHighlights(l.URI.revive(F),G,H.map(Oe=>l.URI.revive(Oe)),ee),void 0,ee)}registerLinkedEditingRangeProvider(U,F,G){const H=this.t(new V(this.h,G),U);return this.e.$registerLinkedEditingRangeProvider(H,this.o(F,U)),this.p(H)}$provideLinkedEditingRanges(U,F,G,H){return this.s(U,V,async ee=>{const re=await ee.provideLinkedEditingRanges(l.URI.revive(F),G,H);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?Ae.w(re.wordPattern):void 0}},void 0,H)}registerReferenceProvider(U,F,G){const H=this.t(new q(this.h,G),U);return this.e.$registerReferenceSupport(H,this.o(F,U)),this.p(H)}$provideReferences(U,F,G,H,ee){return this.s(U,q,re=>re.provideReferences(l.URI.revive(F),G,H,ee),void 0,ee)}registerCodeActionProvider(U,F,G,H){const ee=new $.$Tc,re=this.t(new N(this.h,this.j.converter,this.k,G,this.l,U,this.m),U);return this.e.$registerQuickFixSupport(re,this.o(F,U),{providedKinds:H?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:H?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this.j.converter.toInternal(Oe.command,ee)}))},Ae.u(U),!!G.resolveCodeAction),ee.add(this.p(re)),ee}$provideCodeActions(U,F,G,H,ee){return this.s(U,N,re=>re.provideCodeActions(l.URI.revive(F),G,H,ee),void 0,ee)}$resolveCodeAction(U,F,G){return this.s(U,N,H=>H.resolveCodeAction(F,G),{},void 0)}$releaseCodeActions(U,F){this.s(U,N,G=>Promise.resolve(G.releaseCodeActions(F)),void 0,void 0)}registerDocumentFormattingEditProvider(U,F,G){const H=this.t(new K(this.h,G),U);return this.e.$registerDocumentFormattingSupport(H,this.o(F,U),U.identifier,U.displayName||U.name),this.p(H)}$provideDocumentFormattingEdits(U,F,G,H){return this.s(U,K,ee=>ee.provideDocumentFormattingEdits(l.URI.revive(F),G,H),void 0,H)}registerDocumentRangeFormattingEditProvider(U,F,G){const H=typeof G.provideDocumentRangesFormattingEdits=="function",ee=this.t(new ie(this.h,G),U);return this.e.$registerRangeFormattingSupport(ee,this.o(F,U),U.identifier,U.displayName||U.name,H),this.p(ee)}$provideDocumentRangeFormattingEdits(U,F,G,H,ee){return this.s(U,ie,re=>re.provideDocumentRangeFormattingEdits(l.URI.revive(F),G,H,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(U,F,G,H,ee){return this.s(U,ie,re=>re.provideDocumentRangesFormattingEdits(l.URI.revive(F),G,H,ee),void 0,ee)}registerOnTypeFormattingEditProvider(U,F,G,H){const ee=this.t(new ce(this.h,G),U);return this.e.$registerOnTypeFormattingSupport(ee,this.o(F,U),H,U.identifier),this.p(ee)}$provideOnTypeFormattingEdits(U,F,G,H,ee,re){return this.s(U,ce,Oe=>Oe.provideOnTypeFormattingEdits(l.URI.revive(F),G,H,ee,re),void 0,re)}registerWorkspaceSymbolProvider(U,F){const G=this.t(new ye(F,this.l),U);return this.e.$registerNavigateTypeSupport(G,typeof F.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(U,F,G){return this.s(U,ye,H=>H.provideWorkspaceSymbols(F,G),{symbols:[]},G)}$resolveWorkspaceSymbol(U,F,G){return this.s(U,ye,H=>H.resolveWorkspaceSymbol(F,G),void 0,void 0)}$releaseWorkspaceSymbols(U,F){this.s(U,ye,G=>G.releaseWorkspaceSymbols(F),void 0,void 0)}registerRenameProvider(U,F,G){const H=this.t(new ke(this.h,G,this.l),U);return this.e.$registerRenameSupport(H,this.o(F,U),ke.supportsResolving(G)),this.p(H)}$provideRenameEdits(U,F,G,H,ee){return this.s(U,ke,re=>re.provideRenameEdits(l.URI.revive(F),G,H,ee),void 0,ee)}$resolveRenameLocation(U,F,G,H){return this.s(U,ke,ee=>ee.resolveRenameLocation(l.URI.revive(F),G,H),void 0,H)}registerNewSymbolNamesProvider(U,F,G){const H=this.t(new fe(this.h,G,this.l),U);return this.e.$registerNewSymbolNamesProvider(H,this.o(F,U)),this.p(H)}$supportsAutomaticNewSymbolNamesTriggerKind(U){return this.s(U,fe,F=>F.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(U,F,G,H,ee){return this.s(U,fe,re=>re.provideNewSymbolNames(l.URI.revive(F),G,H,ee),void 0,ee)}registerDocumentSemanticTokensProvider(U,F,G,H){const ee=this.t(new Te(this.h,G),U),re=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(F,U),H,re);let Oe=this.p(ee);if(re){const Be=G.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(re));Oe=c.$aN.from(Oe,Be)}return Oe}$provideDocumentSemanticTokens(U,F,G,H){return this.s(U,Te,ee=>ee.provideDocumentSemanticTokens(l.URI.revive(F),G,H),null,H)}$releaseDocumentSemanticTokens(U,F){this.s(U,Te,G=>G.releaseDocumentSemanticColoring(F),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,F,G,H){const ee=this.t(new ae(this.h,G),U);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(F,U),H),this.p(ee)}$provideDocumentRangeSemanticTokens(U,F,G,H){return this.s(U,ae,ee=>ee.provideDocumentRangeSemanticTokens(l.URI.revive(F),G,H),null,H)}registerCompletionItemProvider(U,F,G,H){const ee=this.t(new Ne(this.h,this.j.converter,G,this.m,U),U);return this.e.$registerCompletionsProvider(ee,this.o(F,U),H,Ne.supportsResolving(G),U.identifier),this.p(ee)}$provideCompletionItems(U,F,G,H,ee){return this.s(U,Ne,re=>re.provideCompletionItems(l.URI.revive(F),G,H,ee),void 0,ee)}$resolveCompletionItem(U,F,G){return this.s(U,Ne,H=>H.resolveCompletionItem(F,G),void 0,G)}$releaseCompletionItems(U,F){this.s(U,Ne,G=>G.releaseCompletionItems(F),void 0,void 0)}registerInlineCompletionsProvider(U,F,G,H){const ee=new z(U,this.h,G,this.j.converter),re=this.t(ee,U);return this.e.$registerInlineCompletionsSupport(re,this.o(F,U),ee.supportsHandleEvents,n.$Rm.toKey(U.identifier.value),H?.yieldTo?.map(Oe=>n.$Rm.toKey(Oe))||[]),this.p(re)}$provideInlineCompletions(U,F,G,H,ee){return this.s(U,ne,re=>re.provideInlineCompletions(l.URI.revive(F),G,H,ee),void 0,ee)}$handleInlineCompletionDidShow(U,F,G,H){this.s(U,ne,async ee=>{ee.handleDidShowCompletionItem(F,G,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,F,G,H,ee){this.s(U,ne,async re=>{re.handlePartialAccept(F,G,H,ee)},void 0,void 0)}$freeInlineCompletionsList(U,F){this.s(U,ne,async G=>{G.disposeCompletions(F)},void 0,void 0)}registerInlineEditProvider(U,F,G){const H=new x(U,this.h,G,this.j.converter),ee=this.t(H,U);return this.e.$registerInlineEditProvider(ee,this.o(F,U),U.identifier),this.p(ee)}$provideInlineEdit(U,F,G,H){return this.s(U,x,ee=>ee.provideInlineEdits(l.URI.revive(F),G,H),void 0,H)}$freeInlineEdit(U,F){this.s(U,x,async G=>{G.disposeEdit(F)},void 0,void 0)}registerSignatureHelpProvider(U,F,G,H){const ee=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,re=this.t(new Fe(this.h,G),U);return this.e.$registerSignatureHelpProvider(re,this.o(F,U),ee),this.p(re)}$provideSignatureHelp(U,F,G,H,ee){return this.s(U,Fe,re=>re.provideSignatureHelp(l.URI.revive(F),G,H,ee),void 0,ee)}$releaseSignatureHelp(U,F){this.s(U,Fe,G=>G.releaseSignatureHelp(F),void 0,void 0)}registerInlayHintsProvider(U,F,G){const H=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new De(this.h,this.j.converter,G,this.l,U),U);this.e.$registerInlayHintsProvider(ee,this.o(F,U),typeof G.resolveInlayHint=="function",H,Ae.u(U));let re=this.p(ee);if(H!==void 0){const Oe=G.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(H));re=c.$aN.from(re,Oe)}return re}$provideInlayHints(U,F,G,H){return this.s(U,De,ee=>ee.provideInlayHints(l.URI.revive(F),G,H),void 0,H)}$resolveInlayHint(U,F,G){return this.s(U,De,H=>H.resolveInlayHint(F,G),void 0,G)}$releaseInlayHints(U,F){this.s(U,De,G=>G.releaseHints(F),void 0,void 0)}registerDocumentLinkProvider(U,F,G){const H=this.t(new pe(this.h,G),U);return this.e.$registerDocumentLinkProvider(H,this.o(F,U),typeof G.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(U,F,G){return this.s(U,pe,H=>H.provideLinks(l.URI.revive(F),G),void 0,G,F.scheme==="output")}$resolveDocumentLink(U,F,G){return this.s(U,pe,H=>H.resolveLink(F,G),void 0,void 0,!0)}$releaseDocumentLinks(U,F){this.s(U,pe,G=>G.releaseLinks(F),void 0,void 0,!0)}registerColorProvider(U,F,G){const H=this.t(new ge(this.h,G),U);return this.e.$registerDocumentColorProvider(H,this.o(F,U)),this.p(H)}$provideDocumentColors(U,F,G){return this.s(U,ge,H=>H.provideColors(l.URI.revive(F),G),[],G)}$provideColorPresentations(U,F,G,H){return this.s(U,ge,ee=>ee.provideColorPresentations(l.URI.revive(F),G,H),void 0,H)}registerFoldingRangeProvider(U,F,G){const H=this.q(),ee=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Ce(new Q(this.h,G),U)),this.e.$registerFoldingRangeProvider(H,this.o(F,U),U.identifier,ee);let re=this.p(H);if(ee!==void 0){const Oe=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));re=c.$aN.from(re,Oe)}return re}$provideFoldingRanges(U,F,G,H){return this.s(U,Q,ee=>ee.provideFoldingRanges(l.URI.revive(F),G,H),void 0,H)}registerSelectionRangeProvider(U,F,G){const H=this.t(new Y(this.h,G,this.l),U);return this.e.$registerSelectionRangeProvider(H,this.o(F,U)),this.p(H)}$provideSelectionRanges(U,F,G,H){return this.s(U,Y,ee=>ee.provideSelectionRanges(l.URI.revive(F),G,H),[],H)}registerCallHierarchyProvider(U,F,G){const H=this.t(new he(this.h,G),U);return this.e.$registerCallHierarchyProvider(H,this.o(F,U)),this.p(H)}$prepareCallHierarchy(U,F,G,H){return this.s(U,he,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(F),G,H)),void 0,H)}$provideCallHierarchyIncomingCalls(U,F,G,H){return this.s(U,he,ee=>ee.provideCallsTo(F,G,H),void 0,H)}$provideCallHierarchyOutgoingCalls(U,F,G,H){return this.s(U,he,ee=>ee.provideCallsFrom(F,G,H),void 0,H)}$releaseCallHierarchy(U,F){this.s(U,he,G=>Promise.resolve(G.releaseSession(F)),void 0,void 0)}registerTypeHierarchyProvider(U,F,G){const H=this.t(new ue(this.h,G),U);return this.e.$registerTypeHierarchyProvider(H,this.o(F,U)),this.p(H)}$prepareTypeHierarchy(U,F,G,H){return this.s(U,ue,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(F),G,H)),void 0,H)}$provideTypeHierarchySupertypes(U,F,G,H){return this.s(U,ue,ee=>ee.provideSupertypes(F,G,H),void 0,H)}$provideTypeHierarchySubtypes(U,F,G,H){return this.s(U,ue,ee=>ee.provideSubtypes(F,G,H),void 0,H)}$releaseTypeHierarchy(U,F){this.s(U,ue,G=>Promise.resolve(G.releaseSession(F)),void 0,void 0)}registerDocumentOnDropEditProvider(U,F,G,H){const ee=this.q();return this.f.set(ee,new Ce(new Me(this.e,this.h,G,ee,U),U)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(F,U),(0,u.$OG)(U,"documentPaste")&&H?{supportsResolve:!!G.resolveDocumentDropEdit,dropMimeTypes:H.dropMimeTypes}:void 0),this.p(ee)}$provideDocumentOnDropEdits(U,F,G,H,ee,re){return this.s(U,Me,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(F,l.URI.revive(G),H,ee,re)),void 0,void 0)}$resolveDropEdit(U,F,G){return this.s(U,Me,H=>H.resolveDropEdit(F,G),{},void 0)}$releaseDropEdits(U,F){this.s(U,Me,G=>Promise.resolve(G.releaseDropEdits(F)),void 0,void 0)}registerMappedEditsProvider(U,F,G){const H=this.t(new de(this.h,G),U);return this.e.$registerMappedEditsProvider(H,this.o(F,U)),this.p(H)}$provideMappedEdits(U,F,G,H,ee){return this.s(U,de,re=>Promise.resolve(re.provideMappedEdits(F,G,H,ee)),null,ee)}registerDocumentPasteEditProvider(U,F,G,H){const ee=this.q();return this.f.set(ee,new Ce(new B(this.e,this.h,G,ee,U),U)),this.e.$registerPasteEditProvider(ee,this.o(F,U),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,supportsResolve:!!G.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(re=>re.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(U,F,G,H,ee){return this.s(U,B,re=>re.prepareDocumentPaste(l.URI.revive(F),G,H,ee),void 0,ee)}$providePasteEdits(U,F,G,H,ee,re,Oe){return this.s(U,B,Be=>Be.providePasteEdits(F,l.URI.revive(G),H,ee,re,Oe),void 0,Oe)}$resolvePasteEdit(U,F,G){return this.s(U,B,H=>H.resolvePasteEdit(F,G),{},void 0)}$releasePasteEdits(U,F){this.s(U,B,G=>Promise.resolve(G.releasePasteEdits(F)),void 0,void 0)}static w(U){return{pattern:U.source,flags:U.flags}}static y(U){return{decreaseIndentPattern:Ae.w(U.decreaseIndentPattern),increaseIndentPattern:Ae.w(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Ae.w(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Ae.w(U.unIndentedLinePattern):void 0}}static z(U){return{beforeText:Ae.w(U.beforeText),afterText:U.afterText?Ae.w(U.afterText):void 0,previousLineText:U.previousLineText?Ae.w(U.previousLineText):void 0,action:U.action}}static B(U){return U.map(Ae.z)}static C(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(F=>c.SyntaxTokenType.toString(F)):void 0}}static D(U){return U.map(Ae.C)}setLanguageConfiguration(U,F,G){const{wordPattern:H}=G;if(H&&(0,T.$jf)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(F,H):this.h.setWordDefinitionFor(F,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const ee=this.q(),re={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Ae.w(G.wordPattern):void 0,indentationRules:G.indentationRules?Ae.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Ae.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?Ae.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,F,re),this.p(ee)}$setWordDefinitions(U){for(const F of U)this.h.setWordDefinitionFor(F.languageId,new RegExp(F.regexSource,F.regexFlags))}}e.$zlc=Ae}),define(Se[90],Pe([1,0,6,4,8,7,103,20,11,5,175,108,14,3,17,86,12,42]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r,o){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=e.$gmc=void 0,e.$gmc=(0,w.$wi)("IExtHostLanguageModels");class i{constructor(d,a){this.option=d,this.stream=new m.$Zh,this.stream=a??new m.$Zh}}class c{constructor(){this.a=new Map,this.b=new m.$Zh,this.c=!1,this.d=!1;const d=this;this.apiObject={stream:d.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,d]of this.a)yield d.stream;else yield this.b}handleFragment(d){if(this.c)return;this.d=!0;let a=this.a.get(d.index);a||(this.a.size===0?a=new i(d.index,this.b):a=new i(d.index),this.a.set(d.index,a)),a.stream.emitOne(d.part)}get isStreaming(){return this.d}reject(d){this.c=!0;for(const a of this.f())a.reject(d)}resolve(){this.c=!0;for(const d of this.f())d.resolve()}}let u=class{static{n=this}static{this.a=1}constructor(d,a,g){this.j=a,this.k=g,this.c=new E.$de,this.d=new E.$de,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new $.$Tm,this.i=new Map,this.o=new Set,this.b=d.getProxy(O.$$M.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(d,a,g,b){const p=n.a++;this.f.set(p,{extension:d.identifier,provider:g,languageModelId:a});let v;b.auth&&(v={providerLabel:d.displayName||d.name,accountLabel:typeof b.auth=="object"?b.auth.label:void 0}),this.b.$registerLanguageModelProvider(p,a,{extension:d.identifier,identifier:a,name:b.name??"",version:b.version,tokens:b.tokens,auth:v});const y=g.onDidReceiveLanguageModelResponse2?.(({extensionId:h,participant:D,tokenCount:S})=>{this.b.$whenLanguageModelChatRequestMade(a,new $.$Rm(h),D,S)});return(0,C.$Sc)(()=>{this.f.delete(p),this.b.$unregisterProvider(p),y?.dispose()})}async $provideLanguageModelResponse(d,a,g,b,p,v){const y=this.f.get(d);if(!y)return;const h=new A.$dw(async D=>{if(v.isCancellationRequested){this.j.warn(`[CHAT](${y.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(a,{index:D.index,part:D.part})});return y.provider.provideLanguageModelResponse2(b.map(R.LanguageModelMessage.to),p,$.$Rm.toKey(g),h,v)}$provideTokenLength(d,a,g){const b=this.f.get(d);return b?Promise.resolve(b.provider.provideTokenCount(a,g)):Promise.resolve(0)}$updateLanguageModels(d){const a=[],g=[];if(d.added)for(const b of d.added)this.g.set(b.identifier,b),a.push(b.identifier);if(d.removed)for(const b of d.removed){this.g.delete(b),g.push(b);for(const[p,v]of this.i)v.languageModelId===b&&(v.res.reject(new l.$5),this.i.delete(p))}this.d.fire(Object.freeze({added:Object.freeze(a),removed:Object.freeze(g)})),d.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(d){const a=new Array;for(const{from:g,to:b,enabled:p}of d){const v=this.h.get(g)??new $.$Sm;if(v.has(b)!==p){p?v.add(b):v.delete(b),this.h.set(g,v);const h={from:g,to:b};a.push(h),this.c.fire(h)}}}async sendChatRequest(d,a,g,b,p){const v=d.identifier,y=await this.b.$prepareChatAccess(v,a,b.justification);if(!y||!this.g.has(a))throw M.$mP.NotFound(`Language model '${a}' is unknown.`);if(this.m(v,y)&&(!await this.l(d,{identifier:y.extension,displayName:y.auth.providerLabel},b.justification,b.silent)||!this.h.get(v)?.has(y.extension)))throw M.$mP.NoPermissions(`Language model '${a}' cannot be used by '${v.value}'.`);const h=Math.random()*1e6|0,D=this.b.$fetchResponse(v,a,h,g.map(R.LanguageModelMessage.from),b.modelOptions??{},p),S=new m.$vh,I=new c;this.i.set(h,{languageModelId:a,res:I});let P;if(D.catch(W=>{S.isOpen()?I.reject(W):P=W}).finally(()=>{this.i.delete(h),I.resolve(),S.open()}),await S.wait(),P)throw P.name===M.$mP.name?P:new M.$mP(`Language model '${a}' errored, check cause for more details`,"Unknown",P);return I.apiObject}async $handleResponseFragment(d,a){const g=this.i.get(d);g&&g.res.handleFragment(a)}async l(d,a,g,b){const p=k.$aM+a.identifier.value;if(await this.k.getSession(d,p,[],{silent:!0}))return this.$updateModelAccesslist([{from:d.identifier,to:a.identifier,enabled:!0}]),!0;if(b)return!1;try{const y=g?(0,T.localize)(0,null,a.displayName,g):(0,T.localize)(1,null,a.displayName);return await this.k.getSession(d,p,[],{forceNewSession:{detail:y}}),this.$updateModelAccesslist([{from:d.identifier,to:a.identifier,enabled:!0}]),!0}catch{return!1}}m(d,a){return!!a.auth&&!$.$Rm.equals(a.extension,d)}async n(d){for(const a of this.o)try{await this.l(a,{identifier:d.extension,displayName:""},void 0,!0)}catch(g){this.j.error("Fake Auth request failed"),this.j.error(g)}}async computeTokenLength(d,a,g){const b=this.g.get(d);if(!b)throw M.$mP.NotFound(`Language model '${d}' is unknown.`);const p=o.Iterable.find(this.f.values(),v=>v.languageModelId===d);return p?p.provider.provideTokenCount(a,g):this.b.$countTokens(b.identifier,typeof a=="string"?a:R.LanguageModelMessage.from(a),g)}getLanguageModelInfo(d){const a=this.g.get(d);if(a)return{id:a.identifier,name:a.name,version:a.version,tokens:a.tokens}}createLanguageModelAccessInformation(d){this.o.add(d);const a=this,g=E.Event.signal(E.Event.filter(this.c.event,p=>$.$Rm.equals(p.from,d.identifier))),b=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(g,b)},canSendRequest(p){const v=a.g.get(p);if(!v)return;if(!a.m(d.identifier,v))return!0;const y=a.h.get(d.identifier);if(y)return y.has(v.extension)}}}};e.$hmc=u,e.$hmc=u=n=Je([We(0,f.$zP),We(1,r.$3j),We(2,s.$Blc)],u)}),define(Se[274],Pe([1,0,4,8,7,33,11,6,26]),function(le,e,C,O,R,M,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ymc=void 0;class E{constructor(k,l,w,f){this.c=l,this.d=w,this.e=f,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(C.$$M.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,l){await this.a.$changeLanguage(k,l);const w=this.c.getDocumentData(k);if(!w)throw new Error(`document '${k.toString()}' NOT found`);return w.document}async tokenAtPosition(k,l){const w=k.version,f=O.Position.from(l),s=await this.a.$tokensAtPosition(k.uri,f),r={type:R.StandardTokenType.Other,range:k.getWordRangeAtPosition(l)??new R.$cN(l.line,l.character,l.line,l.character)};if(!s)return r;const o={range:O.Range.to(s.range),type:O.TokenType.to(s.type)};return!o.range.contains(l)||w!==k.version?r:o}createLanguageStatusItem(k,l,w){const f=this.f++,s=this.a,r=this.g,o=`${k.identifier.value}/${l}`;if(r.has(o))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);r.add(o);const n={selector:w,id:l,name:k.displayName??k.name,severity:R.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const c=new $.$Tc,u=()=>{if(i?.dispose(),!r.has(o)){console.warn(`LanguageStatusItem (${l}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.$yh)(()=>{c.clear(),this.a.$setLanguageStatus(f,{id:o,name:n.name??k.displayName??k.name,source:k.displayName??k.name,selector:O.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===R.LanguageStatusSeverity.Error?M.default.Error:n.severity===R.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){c.dispose(),i?.dispose(),s.$removeLanguageStatus(f),r.delete(o)},get id(){return n.id},get name(){return n.name},set name(d){n.name=d,u()},get selector(){return n.selector},set selector(d){n.selector=d,u()},get text(){return n.text},set text(d){n.text=d,u()},set text2(d){(0,m.$PG)(k,"languageStatusText"),n.text=d,u()},get text2(){return(0,m.$PG)(k,"languageStatusText"),n.text},get detail(){return n.detail},set detail(d){n.detail=d,u()},get severity(){return n.severity},set severity(d){n.severity=d,u()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(d){n.accessibilityInformation=d,u()},get command(){return n.command},set command(d){n.command=d,u()},get busy(){return n.busy},set busy(d){n.busy=d,u()}};return u(),t}}e.$Ymc=E}),define(Se[275],Pe([1,0,16,2,8,7,85]),function(le,e,C,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=e.$Kmc=void 0;class ${constructor(k,l,w,f){this.start=k,this.deletedCount=l,this.deletedItems=w,this.items=f}asApiEvent(){return{range:new M.$CO(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(k){return{EOL:k.eol,lines:k.source,languageId:k.language,uri:k.uri,isDirty:!1,versionId:1}}constructor(k,l,w){this.notebook=k,this.h=l,this.j=w,this.handle=w.handle,this.uri=O.URI.revive(w.uri),this.cellKind=w.cellKind,this.a=w.outputs.map(R.NotebookCellOutput.to),this.e=w.internalMetadata??{},this.b=Object.freeze(w.metadata??{}),this.d=Object.freeze(R.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:R.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return k.g},set mime(f){k.g=f},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(w)}return this.f}setOutputs(k){this.a=k.map(R.NotebookCellOutput.to)}setOutputItems(k,l,w){const f=w.map(R.NotebookCellOutputItem.to),s=this.a.find(r=>r.id===k);if(s&&(l||(s.items.length=0),s.items.push(...f),s.items.length>1&&s.items.every(r=>A.$7K(r.mime)))){const r=new Map,o=[];s.items.forEach(n=>{let i;r.has(n.mime)?i=r.get(n.mime):(i=[],r.set(n.mime,i),o.push(n.mime)),i.push(n.data)}),s.items.length=0,o.forEach(n=>{const i=A.$8K(r.get(n));s.items.push({mime:n,data:i.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(R.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$Kmc=m;class E{static{this.a=0}constructor(k,l,w,f,s){this.k=k,this.l=l,this.m=w,this.uri=f,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,l={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===C.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(w){return w=k.n(w),k.b[w].apiCell},getCells(w){return(w?k.p(w):k.b).map(s=>s.apiCell)},save(){return k.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,l,w){this.g=k.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:w});const f={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},s=[];for(const o of k.rawEvents)o.kind===A.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,f.contentChanges):o.kind===A.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,f.contentChanges):o.kind===A.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),s.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),s.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),s.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===A.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),s.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),s.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const r=new Map;for(let o=0;o<s.length;o++){const n=s[o],i=r.get(n.cell);if(i===void 0){const c=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});r.set(n.cell,c-1)}else f.cellChanges[i]={...f.cellChanges[i],...n}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let l=k.start|0,w=k.end|0;return l<0&&(l=0),w>this.b.length&&(w=this.b.length),k.with({start:l,end:w})}p(k){k=this.o(k);const l=[];for(let w=k.start;w<k.end;w++)l.push(this.b[w]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,l,w){if(this.j)return;const f=[],s=[],r=[];if(k.reverse().forEach(o=>{const i=o[2].map(t=>{const d=new m(this,this.l,t);return l||s.push(m.asModelAddData(t)),d}),c=new $(o[0],o[1],[],i),u=this.b.splice(o[0],o[1],...i);for(const t of u)r.push(t.uri),c.deletedItems.push(t.apiCell);f.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:r}),w)for(const o of f)w.push(o.asApiEvent())}s(k,l,w,f){const s=this.b.splice(k,l);this.b.splice(w,0,...s);const r=[new $(k,l,s.map(o=>o.apiCell),[]),new $(w,0,[],s)];for(const o of r)f.push(o.asApiEvent())}t(k,l){this.b[k].setOutputs(l)}u(k,l,w,f){this.b[k].setOutputItems(l,w,f)}v(k,l){const w=this.b[k];w.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(w.uri,l)}w(k,l){const w=this.b[k];w.apiCell.mime=l}x(k,l){this.b[k].setMetadata(l)}y(k,l){this.b[k].setInternalMetadata(l)}getCellFromApiCell(k){return this.b.find(l=>l.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(l=>l.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$Lmc=E}),define(Se[276],Pe([1,0,5,2,8,7,35]),function(le,e,C,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=void 0;class ${constructor(E,T,k,l={timeout:1500,errors:3}){this.b=E,this.c=T,this.d=k,this.f=l,this.a=new C.$fe}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(T,k,l)=>{const w=function(s){T.call(k,s)};return w.extension=E,this.a.event(w,void 0,l)}}async $participateInSave(E,T,k){const l=O.URI.revive(E),w=this.c.getNotebookDocument(l);if(!w)throw new Error("Unable to resolve notebook document");const f=[];if(await this.a.fireAsync({notebook:w.apiNotebook,reason:R.TextDocumentSaveReason.to(T)},k,async(r,o)=>{const n=Date.now(),i=await await Promise.resolve(r);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!k.isCancellationRequested&&i&&(i instanceof M.$kN?f.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),k.isCancellationRequested)return!1;if(f.length===0)return!0;const s={edits:[]};for(const r of f){const{edits:o}=R.WorkspaceEdit.from(r);s.edits=s.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(new A.$Bw(s))}}e.$1mc=$}),define(Se[114],Pe([1,0,14,8,7]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor($,m,E,T,k,l){this.id=$,this.f=m,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=T,this.c=l}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(m){this.selections=[m]},get selections(){return $.a},set selections(m){if(!Array.isArray(m)||!m.every(R.$CO.isNotebookRange))throw(0,C.$7)("selections");$.a=m,$.g(m)},get visibleRanges(){return $.b},revealRange(m,E){$.f.$tryRevealRange($.id,O.NotebookRange.from(m),E??R.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(O.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$Mmc=M}),define(Se[277],Pe([1,0,5,12,8]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3mc=void 0;let M=class{constructor($,m){this.c=$,this.d=m,this.a=new C.$de,this.b=new C.$de,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged($,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",$,m);const E=this.d.getEditorById($);m.visibleRanges&&E._acceptVisibleRanges(m.visibleRanges.ranges.map(R.NotebookRange.to)),m.selections&&E._acceptSelections(m.selections.selections.map(R.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns($){for(const m in $)this.d.getEditorById(m)._acceptViewColumn(R.ViewColumn.to($[m]))}};e.$3mc=M,e.$3mc=M=Je([We(0,O.$3j)],M)}),define(Se[278],Pe([1,0,5,4,114]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=void 0;class M{constructor($,m){this.c=m,this.a=new Map,this.b=$.getProxy(O.$$M.MainThreadNotebookRenderers)}$postRendererMessage($,m,E){const T=this.c.getEditorById($);this.a.get(m)?.fire({editor:T.apiEditor,message:E})}createRendererMessaging($,m){if(!$.contributes?.notebookRenderer?.some(T=>T.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(T,k,l)=>this.d(m).event(T,k,l),postMessage:(T,k)=>{R.$Mmc.apiEditorsToExtHost.has(T)&&([T,k]=[k,T]);const l=k&&R.$Mmc.apiEditorsToExtHost.get(k);return this.b.$postMessage(l?.id,m,T)}}}d($){let m=this.a.get($);return m||(m=new C.$de({onDidRemoveLastListener:()=>{m?.dispose(),this.a.delete($)}}),this.a.set($,m),m)}}e.$6mc=M}),define(Se[279],Pe([1,0,8,103,24,69,14]),function(le,e,C,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=void 0;class ${constructor(k){this.b=0,this.c=new Map,this.a=k}async withProgress(k,l,w){const f=this.b++,{title:s,location:r,cancellable:o}=l,n={label:k.displayName||k.name,id:k.identifier.value};return this.a.$startProgress(f,{location:C.ProgressLocation.from(r),title:s,source:n,cancellable:o},k.isUnderDevelopment?void 0:k.identifier.value).catch(A.$2),this.d(f,w,!!o)}d(k,l,w){let f;w&&(f=new R.$oe,this.c.set(k,f));const s=o=>{this.a.$progressEnd(o),this.c.delete(o),f?.dispose()};let r;try{r=l(new E(this.a,k),w&&f?f.token:R.CancellationToken.None)}catch(o){throw s(k),o}return r.then(o=>s(k),o=>s(k)),r}$acceptProgressCanceled(k){const l=this.c.get(k);l&&(l.cancel(),this.c.delete(k))}}e.$0mc=$;function m(T,k){return T.message=k.message,typeof k.increment=="number"&&(typeof T.increment=="number"?T.increment+=k.increment:T.increment=k.increment),T}class E extends O.$dw{constructor(k,l){super(w=>this.throttledReport(w)),this.c=k,this.d=l}throttledReport(k){this.c.$progressReport(this.d,k)}}Je([(0,M.$3h)(100,(T,k)=>m(T,k),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Se[280],Pe([1,0,2,4,11,8]),function(le,e,C,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=void 0;class A{static{this.a=0}constructor(m,E){this.d=E,this.c=new Map,this.b=m.getProxy(O.$$M.MainThreadQuickDiff)}$provideOriginalResource(m,E,T){const k=C.URI.revive(E),l=this.c.get(m);return l?(0,R.$oh)(()=>l.provideOriginalResource(k,T)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider(m,E,T,k){const l=A.a++;return this.c.set(l,E),this.b.$registerQuickDiffProvider(l,M.DocumentSelector.from(m,this.d),T,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$$mc=A}),define(Se[281],Pe([1,0,24,5,6,4,2,7,14,18,33,36,26,8]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=f;function f(s,r,o){const n=s.getProxy(M.$$M.MainThreadQuickOpen);class i{constructor(v,y){this.e=new Map,this.f=0,this.a=v,this.b=y}showQuickPick(v,y,h,D=C.CancellationToken.None){this.c=void 0;const S=Promise.resolve(y),I=++this.f,P=n.$show(I,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},D),W={},V=P.then(()=>W);return Promise.race([V,S]).then(q=>{if(q===W)return;const N=(0,l.$OG)(v,"quickPickItemTooltip");return S.then(B=>{const K=[];for(let ie=0;ie<B.length;ie++){const ce=B[ie];if(typeof ce=="string")K.push({label:ce,handle:ie});else if(ce.kind===$.QuickPickItemKind.Separator)K.push({type:"separator",label:ce.label});else{ce.tooltip&&!N&&console.warn(`Extension '${v.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`);const ye=ce.iconPath?a(ce.iconPath):void 0;K.push({label:ce.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:N?w.MarkdownString.fromStrict(ce.tooltip):void 0,handle:ie})}}return h&&typeof h.onDidSelectItem=="function"&&(this.c=ie=>{h.onDidSelectItem(B[ie])}),n.$setItems(I,K),P.then(ie=>{if(typeof ie=="number")return B[ie];if(Array.isArray(ie))return ie.map(ce=>B[ce])})})}).then(void 0,q=>{if(!(0,m.$4)(q))return n.$setError(I,q),Promise.reject(q)})}$onItemSelected(v){this.c?.(v)}showInput(v,y=C.CancellationToken.None){return this.d=v?.validateInput,n.$input(v,typeof this.d=="function",y).then(void 0,h=>{if(!(0,m.$4)(h))return Promise.reject(h)})}async $validateInput(v){if(!this.d)return;const y=await this.d(v);if(!y||typeof y=="string")return y;let h;switch(y.severity){case $.InputBoxValidationSeverity.Info:h=T.default.Info;break;case $.InputBoxValidationSeverity.Warning:h=T.default.Warning;break;case $.InputBoxValidationSeverity.Error:h=T.default.Error;break;default:h=y.message?T.default.Error:T.default.Ignore;break}return{content:y.message,severity:h}}async showWorkspaceFolderPick(v,y=C.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[v]);if(!h)return;const D=await this.a.getWorkspaceFolders2();if(D)return D.find(S=>S.uri.toString()===h.uri.toString())}createQuickPick(v){const y=new g(v,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(v){const y=new b(v,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(v,y){this.e.get(v)?._fireDidChangeValue(y)}$onDidAccept(v){this.e.get(v)?._fireDidAccept()}$onDidChangeActive(v,y){const h=this.e.get(v);h instanceof g&&h._fireDidChangeActive(y)}$onDidChangeSelection(v,y){const h=this.e.get(v);h instanceof g&&h._fireDidChangeSelection(y)}$onDidTriggerButton(v,y){this.e.get(v)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(v,y,h){const D=this.e.get(v);D instanceof g&&D._fireDidTriggerItemButton(y,h)}$onDidHide(v){this.e.get(v)?._fireDidHide()}}class c{static{this.a=1}constructor(v,y){this.x=v,this.y=y,this._id=g.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$de,this.q=new O.$de,this.r=new O.$de,this.s=new O.$de,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(v){this.b=v,this.z({title:v})}get step(){return this.c}set step(v){this.c=v,this.z({step:v})}get totalSteps(){return this.d}set totalSteps(v){this.d=v,this.z({totalSteps:v})}get enabled(){return this.g}set enabled(v){this.g=v,this.z({enabled:v})}get busy(){return this.j}set busy(v){this.j=v,this.z({busy:v})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(v){this.k=v,this.z({ignoreFocusOut:v})}get value(){return this.l}set value(v){this.l=v,this.z({value:v})}get placeholder(){return this.m}set placeholder(v){this.m=v,this.z({placeholder:v})}get buttons(){return this.n}set buttons(v){this.n=v.slice(),this.o.clear(),v.forEach((y,h)=>{const D=y===$.$zO.Back?-1:h;this.o.set(D,y)}),this.z({buttons:v.map((y,h)=>({...a(y.iconPath),tooltip:y.tooltip,handle:y===$.$zO.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(v){this.l=v,this.q.fire(v)}_fireDidTriggerButton(v){const y=this.o.get(v);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,R.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(v){if(!this.v){for(const y of Object.keys(v)){const h=v[y];this.u[y]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function u(p){if(p instanceof $.$0N)return{id:p.id};const v=d(p),y=t(p);return{dark:typeof v=="string"?A.URI.file(v):v,light:typeof y=="string"?A.URI.file(y):y}}function t(p){return typeof p=="object"&&"light"in p?p.light:p}function d(p){return typeof p=="object"&&"dark"in p?p.dark:p}function a(p){const v=u(p);let y,h;return"id"in v?h=k.ThemeIcon.asClassName(v):y=v,{iconPath:y,iconClass:h}}class g extends c{constructor(v,y){super(v.identifier,y),this.O=v,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$de,this.L=[],this.M=new O.$de,this.N=new O.$de,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(v){this.B=v.slice(),this.C.clear(),this.D.clear(),v.forEach((D,S)=>{this.C.set(S,D),this.D.set(D,S)});const y=(0,l.$OG)(this.O,"quickPickItemTooltip"),h=[];for(let D=0;D<v.length;D++){const S=v[D];if(S.kind===$.QuickPickItemKind.Separator)h.push({type:"separator",label:S.label});else{S.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const I=S.iconPath?a(S.iconPath):void 0;h.push({handle:D,label:S.label,iconPath:I?.iconPath,iconClass:I?.iconClass,description:S.description,detail:S.detail,picked:S.picked,alwaysShow:S.alwaysShow,tooltip:y?w.MarkdownString.fromStrict(S.tooltip):void 0,buttons:S.buttons?.map((P,W)=>({...a(P.iconPath),tooltip:P.tooltip,handle:W}))})}}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(v){this.E=v,this.z({canSelectMany:v})}get matchOnDescription(){return this.F}set matchOnDescription(v){this.F=v,this.z({matchOnDescription:v})}get matchOnDetail(){return this.G}set matchOnDetail(v){this.G=v,this.z({matchOnDetail:v})}get sortByLabel(){return this.H}set sortByLabel(v){this.H=v,this.z({sortByLabel:v})}get keepScrollPosition(){return this.I}set keepScrollPosition(v){this.I=v,this.z({keepScrollPosition:v})}get activeItems(){return this.J}set activeItems(v){this.J=v.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(v){this.L=v.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(v){const y=(0,E.$Hb)(v.map(h=>this.C.get(h)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(v){const y=(0,E.$Hb)(v.map(h=>this.C.get(h)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(v,y){const h=this.C.get(v);if(!h||!h.buttons||!h.buttons.length)return;const D=h.buttons[y];D&&this.N.fire({button:D,item:h})}}class b extends c{constructor(v,y){super(v.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(v){this.B=v,this.z({password:v})}get prompt(){return this.C}set prompt(v){this.C=v,this.z({prompt:v})}get valueSelection(){return this.D}set valueSelection(v){this.D=v,this.z({valueSelection:v})}get validationMessage(){return this.E}set validationMessage(v){this.E=v,v?typeof v=="string"?this.z({validationMessage:v,severity:T.default.Error}):this.z({validationMessage:v.message,severity:v.severity??T.default.Error}):this.z({validationMessage:void 0,severity:T.default.Ignore})}}return new i(r,o)}}),define(Se[282],Pe([1,0,2,5,69,6,11,4,18,149,12,20,36,8,26,16,22]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$bnc=e.$anc=void 0;function n(I){return I instanceof C.URI}function i(I,P){return I.scheme===s.Schemas.file&&P.scheme===s.Schemas.file&&r.$k?I.toString()===P.toString():I.toString().toLowerCase()===P.toString().toLowerCase()}function c(I){if(I)return typeof I.iconPath=="string"?C.URI.file(I.iconPath):C.URI.isUri(I.iconPath)||l.ThemeIcon.isThemeIcon(I.iconPath)?I.iconPath:void 0}function u(I){if(I.icon){if(C.URI.isUri(I.icon))return I.icon;if(l.ThemeIcon.isThemeIcon(I.icon))return I.icon;{const P=I.icon;return{light:P.light,dark:P.dark}}}else return}function t(I,P){if(!I.iconPath&&!P.iconPath)return 0;if(I.iconPath){if(!P.iconPath)return 1}else return-1;const W=typeof I.iconPath=="string"?I.iconPath:C.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id,V=typeof P.iconPath=="string"?P.iconPath:C.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,E.$qr)(W,V)}function d(I,P){let W=0;if(I.strikeThrough!==P.strikeThrough)return I.strikeThrough?1:-1;if(I.faded!==P.faded)return I.faded?1:-1;if(I.tooltip!==P.tooltip)return(I.tooltip||"").localeCompare(P.tooltip||"");if(W=t(I,P),W!==0)return W;if(I.light&&P.light)W=t(I.light,P.light);else{if(I.light)return 1;if(P.light)return-1}if(W!==0)return W;if(I.dark&&P.dark)W=t(I.dark,P.dark);else{if(I.dark)return 1;if(P.dark)return-1}return W}function a(I,P){if(I.command!==P.command)return I.command<P.command?-1:1;if(I.title!==P.title)return I.title<P.title?-1:1;if(I.tooltip!==P.tooltip){if(I.tooltip!==void 0&&P.tooltip!==void 0)return I.tooltip<P.tooltip?-1:1;if(I.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(I.arguments===P.arguments)return 0;if(I.arguments)if(P.arguments){if(I.arguments.length!==P.arguments.length)return I.arguments.length-P.arguments.length}else return 1;else return-1;for(let W=0;W<I.arguments.length;W++){const V=I.arguments[W],q=P.arguments[W];if(V!==q&&!(n(V)&&n(q)&&i(V,q)))return V<q?-1:1}return 0}function g(I,P){let W=(0,E.$qr)(I.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(W!==0)return W;if(I.command&&P.command)W=a(I.command,P.command);else{if(I.command)return 1;if(P.command)return-1}if(W!==0)return W;if(I.decorations&&P.decorations)W=d(I.decorations,P.decorations);else{if(I.decorations)return 1;if(P.decorations)return-1}if(I.multiFileDiffEditorModifiedUri&&P.multiFileDiffEditorModifiedUri)W=(0,E.$qr)(I.multiFileDiffEditorModifiedUri.fsPath,P.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(I.multiFileDiffEditorModifiedUri)return 1;if(P.multiFileDiffEditorModifiedUri)return-1}if(I.multiDiffEditorOriginalUri&&P.multiDiffEditorOriginalUri)W=(0,E.$qr)(I.multiDiffEditorOriginalUri.fsPath,P.multiDiffEditorOriginalUri.fsPath,!0);else{if(I.multiDiffEditorOriginalUri)return 1;if(P.multiDiffEditorOriginalUri)return-1}return W}function b(I,P){for(let W=0;W<I.length;W++)if(I[W]!==P[W])return!1;return!0}function p(I,P){return I.command===P.command&&I.title===P.title&&I.tooltip===P.tooltip&&(I.arguments&&P.arguments?b(I.arguments,P.arguments):I.arguments===P.arguments)}function v(I,P){return(0,m.$ub)(I,P,p)}class y{#e;#t;get value(){return this.d}set value(P){P=P??"",this.#e.$setInputBoxValue(this.l,P),this.n(P)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(P){this.#e.$setInputBoxPlaceholder(this.l,P),this.f=P}get validateInput(){return(0,f.$PG)(this.k,"scmValidation"),this.g}set validateInput(P){if((0,f.$PG)(this.k,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=P,this.#e.$setValidationProviderIsEnabled(this.l,!!P)}get enabled(){return this.h}set enabled(P){P=!!P,this.h!==P&&(this.h=P,this.#e.$setInputBoxEnablement(this.l,P))}get visible(){return this.j}set visible(P){P=!!P,this.j!==P&&(this.j=P,this.#e.$setInputBoxVisibility(this.l,P))}get document(){return(0,f.$PG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(P,W,V,q,N){this.k=P,this.l=q,this.m=N,this.d="",this.e=new O.$de,this.f="",this.h=!0,this.j=!0,this.#t=W,this.#e=V}showValidationMessage(P,W){(0,f.$PG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,P,W)}$onInputBoxValueChange(P){this.n(P)}n(P){this.d=P,this.e.fire(P)}}e.$anc=y;class h{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(P){this.v=P,this.q.$updateGroupLabel(this.t,this.handle,P)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(P){this.p=P,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(P){this.f=[...P],this.k.fire()}constructor(P,W,V,q,N,B,K){this.q=P,this.s=W,this.t=V,this.u=q,this.v=N,this.multiDiffEditorEnableViewChanges=B,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$de,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$de,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=h.d++}getResourceState(P){return this.g.get(P)}$executeResourceCommand(P,W){const V=this.h.get(P);return V?(0,A.$oh)(()=>this.s.executeCommand(V.command,...V.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this.f].sort(g),V=(0,m.$Db)(this.o,P,g).map(B=>{const K=B.toInsert.map(ie=>{const ce=this.e++;this.g.set(ce,ie);const ye=ie.resourceUri;let ke;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"||ie.command.command==="vscode.changes"){const ge=new M.$Tc;ke=this.s.converter.toInternal(ie.command,ge),this.j.set(ce,ge)}else this.h.set(ce,ie.command);const fe=(0,f.$OG)(this.w,"scmMultiDiffEditor"),$e=fe?ie.multiDiffEditorOriginalUri:void 0,Te=fe?ie.multiFileDiffEditorModifiedUri:void 0,ae=c(ie.decorations),Ne=ie.decorations&&c(ie.decorations.light)||ae,ne=ie.decorations&&c(ie.decorations.dark)||ae,z=[Ne,ne],x=ie.decorations&&ie.decorations.tooltip||"",be=ie.decorations&&!!ie.decorations.strikeThrough,Fe=ie.decorations&&!!ie.decorations.faded,De=ie.contextValue||"";return{rawResource:[ce,ye,z,x,be,Fe,De,ke,$e,Te],handle:ce}});return{start:B.start,deleteCount:B.deleteCount,toInsert:K}}),q=V.map(({start:B,deleteCount:K,toInsert:ie})=>[B,K,ie.map(ce=>ce.rawResource)]),N=V.reverse();for(const{start:B,deleteCount:K,toInsert:ie}of N){const ce=ie.map(ke=>ke.handle),ye=this.n.splice(B,K,...ce);for(const ke of ye)this.g.delete(ke),this.h.delete(ke),this.j.get(ke)?.dispose(),this.j.delete(ke)}return this.o=P,q}dispose(){this.l=!0,this.m.fire()}}class D{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(P){this.g!==P&&(this.g=P,this.#e.$updateSourceControl(this.w,{count:P}))}get quickDiffProvider(){return this.h}set quickDiffProvider(P){this.h=P;let W;(0,f.$OG)(this.x,"quickDiffProvider")&&(W=P?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!P,quickDiffLabel:W})}get historyProvider(){return(0,f.$PG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(P){(0,f.$PG)(this.x,"scmHistoryProvider"),this.j=P,this.k.value=new M.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!P}),P&&this.k.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this.l=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(P){P!==this.m&&(this.m=P,this.#e.$updateSourceControl(this.w,{commitTemplate:P}))}get acceptInputCommand(){return this.o}set acceptInputCommand(P){this.n.value=new M.$Tc,this.o=P;const W=this.y.converter.toInternal(P,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:W})}get actionButton(){return(0,f.$PG)(this.x,"scmActionButton"),this.q}set actionButton(P){(0,f.$PG)(this.x,"scmActionButton"),this.p.value=new M.$Tc,this.q=P;const W=P!==void 0?{command:this.y.converter.toInternal(P.command,this.p.value),secondaryCommands:P.secondaryCommands?.map(V=>V.map(q=>this.y.converter.toInternal(q,this.p.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:W??null})}get statusBarCommands(){return this.t}set statusBarCommands(P){if(this.t&&P&&v(this.t,P))return;this.s.value=new M.$Tc,this.t=P;const W=(P||[]).map(V=>this.y.converter.toInternal(V,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:W})}get selected(){return this.u}constructor(P,W,V,q,N,B,K){this.x=P,this.y=q,this.z=N,this.A=B,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Vc,this.m=void 0,this.n=new M.$Vc,this.o=void 0,this.p=new M.$Vc,this.s=new M.$Vc,this.t=void 0,this.u=!1,this.v=new O.$de,this.onDidChangeSelection=this.v.event,this.w=D.d++,this.C=new Map,this.D=new Set,this.#e=V;const ie=C.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${N}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new y(P,W,this.#e,this.w,ie),this.#e.$registerSourceControl(this.w,N,B,K,ie)}createResourceGroup(P,W,V){const q=(0,f.$OG)(this.x,"scmMultiDiffEditor")&&V?.multiDiffEditorEnableViewChanges===!0,N=new h(this.#e,this.y,this.w,P,W,q,this.x),B=O.Event.once(N.onDidDispose)(()=>this.C.delete(N));return this.C.set(N,B),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const P=[],W=[];for(const[V,q]of this.C){q.dispose();const N=V.onDidUpdateResourceStates(()=>{this.D.add(V),this.eventuallyUpdateResourceStates()});O.Event.once(V.onDidDispose)(()=>{this.D.delete(V),N.dispose(),this.e.delete(V.handle),this.#e.$unregisterGroup(this.w,V.handle)}),P.push([V.handle,V.id,V.label,V.features,V.multiDiffEditorEnableViewChanges]);const B=V._takeResourceStateSnapshot();B.length>0&&W.push([V.handle,B]),this.e.set(V.handle,V)}this.#e.$registerGroups(this.w,P,W),this.C.clear()}eventuallyUpdateResourceStates(){const P=[];this.D.forEach(W=>{const V=W._takeResourceStateSnapshot();V.length!==0&&P.push([W.handle,V])}),P.length>0&&this.#e.$spliceResourceStates(this.w,P),this.D.clear()}getResourceGroup(P){return this.e.get(P)}setSelectionState(P){this.u=P,this.v.fire(P)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,R.$2h)(100)],D.prototype,"eventuallyAddResourceGroups",null),Je([(0,R.$2h)(100)],D.prototype,"eventuallyUpdateResourceStates",null);let S=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(P,W,V,q){this.l=W,this.m=V,this.n=q,this.g=new Map,this.h=new k.$Tm,this.j=new O.$de,this.e=P.getProxy($.$$M.MainThreadSCM),this.f=P.getProxy($.$$M.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===3){const B=this.g.get(N.sourceControlHandle);if(!B)return N;const K=B.getResourceGroup(N.groupHandle);return K?K.getResourceState(N.handle):N}else if(N&&N.$mid===4){const B=this.g.get(N.sourceControlHandle);return B?B.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===5){const B=this.g.get(N.handle);return B||N}return N}})}createSourceControl(P,W,V,q){this.n.trace("ExtHostSCM#createSourceControl",P.identifier.value,W,V,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const N=o.d++,B=new D(P,this.m,this.e,this.l,W,V,q);this.g.set(N,B);const K=this.h.get(P.identifier)||[];return K.push(B),this.h.set(P.identifier,K),B}getLastInputBox(P){this.n.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const W=this.h.get(P.identifier),V=W&&W[W.length-1];return V&&V.inputBox}$provideOriginalResource(P,W,V){const q=C.URI.revive(W);this.n.trace("ExtHostSCM#$provideOriginalResource",P,q.toString());const N=this.g.get(P);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$oh)(()=>N.quickDiffProvider.provideOriginalResource(q,V)).then(B=>B||null)}$onInputBoxValueChange(P,W){this.n.trace("ExtHostSCM#$onInputBoxValueChange",P);const V=this.g.get(P);return V&&V.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(P,W,V,q){this.n.trace("ExtHostSCM#$executeResourceCommand",P,W,V);const N=this.g.get(P);if(!N)return Promise.resolve(void 0);const B=N.getResourceGroup(W);return B?B.$executeResourceCommand(V,q):Promise.resolve(void 0)}$validateInput(P,W,V){this.n.trace("ExtHostSCM#$validateInput",P);const q=this.g.get(P);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,A.$oh)(()=>q.inputBox.validateInput(W,V)).then(N=>{if(!N)return Promise.resolve(void 0);const B=w.MarkdownString.fromStrict(N.message);return B?Promise.resolve([B,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this.g.get(P)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(P,W,V,q){return await this.g.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,V,q)??void 0}async $provideHistoryItems(P,W,V,q){return(await this.g.get(P)?.historyProvider?.provideHistoryItems(W,V,q))?.map(K=>({...K,icon:u(K)}))??void 0}async $provideHistoryItemSummary(P,W,V,q){const N=this.g.get(P)?.historyProvider;if(typeof N?.provideHistoryItemSummary!="function")return;const B=await N.provideHistoryItemSummary(W,V,q);return B?{...B,icon:u(B)}:void 0}async $provideHistoryItemChanges(P,W,V,q){return await this.g.get(P)?.historyProvider?.provideHistoryItemChanges(W,V,q)??void 0}};e.$bnc=S,e.$bnc=S=o=Je([We(3,T.$3j)],S)}),define(Se[283],Pe([1,0,4,8,2]),function(le,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=void 0;class M{static{this.a=0}constructor($,m){this.d=m,this.c=new Map,this.b=$.getProxy(C.$$M.MainThreadShare)}async $provideShare($,m,E){return await this.c.get($)?.provideShare({selection:O.Range.to(m.selection),resourceUri:R.URI.revive(m.resourceUri)},E)??void 0}registerShareProvider($,m){const E=M.a++;return this.c.set(E,m),this.b.$registerShareProvider(E,O.DocumentSelector.from($,this.d),m.id,m.label,m.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$cnc=M}),define(Se[284],Pe([1,0,7,4,178,6,8,15]),function(le,e,C,O,R,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fnc=e.$enc=void 0;class m{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new C.$$N("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.$$N("statusBarItem.warningForeground")]])}#e;#t;constructor(l,w,f,s,r,o=C.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new M.$Tc,this.#e=l,this.#t=w,r&&s){this.c=(0,C.$MN)(s.identifier,r);const i=f.get(this.c);i&&(o=i.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(m.a++);this.e=s,this.f=r,this.g=o,this.h=this.u(n)}u(l){if((0,$.$ag)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!m.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new M.$Tc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let w;this.m?w=this.m:w=(0,R.localize)(0,null,this.e.displayName||this.e.name);let f=this.n;this.o&&(f=m.b.get(this.o.id));const s=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,w,this.k,s,this.r?.internal,f,this.o,this.g===C.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$enc=m;class E{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,R.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const w={message:l};return this.b.unshift(w),this.c(),new C.$aN(()=>{const f=this.b.indexOf(w);f>=0&&(this.b.splice(f,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class T{constructor(l,w){this.e=new Map,this.a=l.getProxy(O.$$M.MainThreadStatusBar),this.b=w,this.c=new E(this)}$acceptStaticEntries(l){for(const w of l)this.e.set(w.entryId,w)}createStatusBarEntry(l,w,f,s){return new m(this.a,this.b,this.e,l,w,f,s)}setStatusBarMessage(l,w){const f=this.c.setMessage(l);let s;return typeof w=="number"?s=setTimeout(()=>f.dispose(),w):typeof w<"u"&&w.then(()=>f.dispose(),()=>f.dispose()),new C.$aN(()=>{f.dispose(),clearTimeout(s)})}}e.$fnc=T}),define(Se[115],Pe([1,0,30,107,52,77,62,8,2]),function(le,e,C,O,R,M,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OP=e.$NP=e.$MP=e.$LP=void 0;const E=(i,c,u,t)=>{let d=c;return{enumerable:!0,configurable:!1,get(){return d},set(a){if(!u(d,a)){const g=d;d=a,i.listener?.(t(a,g))}}}},T=(i,c)=>i===c,k={range:(i,c)=>i===c?!0:!i||!c?!1:i.isEqual(c),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(i,c)=>!(i.length!==c.length||i.some(u=>!c.find(t=>u.id===t.id)))},l=i=>c=>({op:4,update:i(c)}),w=(i,c)=>({range:(()=>{let u;const t=l(d=>({range:C.$ut.lift($.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return u},set(d){i.listener?.({op:6}),k.range(u,d)||(u=d,i.listener?.(t(d)))}}})(),label:E(i,c,k.label,l(u=>({label:u}))),description:E(i,void 0,k.description,l(u=>({description:u}))),sortText:E(i,void 0,k.sortText,l(u=>({sortText:u}))),canResolveChildren:E(i,!1,k.canResolveChildren,u=>({op:2,state:u})),busy:E(i,!1,k.busy,l(u=>({busy:u}))),error:E(i,void 0,k.error,l(u=>({error:$.MarkdownString.fromStrict(u)||null}))),tags:E(i,[],k.tags,(u,t)=>({op:1,new:u.map($.TestTag.from),old:t.map($.TestTag.from)}))}),f=i=>{const c=R.$WL.fromString(i.extId),u=new r(c.controllerId,c.localId,i.label,m.URI.revive(i.uri)||void 0);return u.range=$.Range.to(i.range||void 0),u.description=i.description||void 0,u.sortText=i.sortText||void 0,u.tags=i.tags.map(t=>$.TestTag.to({id:(0,A.$3L)(t).tagId})),u},s=i=>{let c;for(const u of i.tests){const t=f(u.item);(0,O.$vP)(t).parent=c,c=t}return c};e.$LP=s;class r{constructor(c,u,t,d){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const a=(0,O.$uP)(this,c);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof o?void 0:a.parent}},children:{value:(0,M.$tP)(a,O.$vP,r),enumerable:!0,writable:!1},...w(a,t)})}}e.$MP=r;class o extends r{constructor(c,u){super(c,c,u,void 0),this._isRoot=!0}}e.$NP=o;class n extends M.$pP{constructor(c,u,t){super({controllerId:c,getDocumentVersion:d=>d&&t.getDocument(d)?.version,getApiFor:O.$vP,getChildren:d=>d.children,root:new o(c,u),toITestItem:$.TestItem.from})}}e.$OP=n}),define(Se[32],Pe([1,0,15,7,8,25,4,18,12,49,30,94,2,6,3,17,115,21,35,44,66,59,63,34]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r,o,n,i,c,u,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZP=e.$YP=e.$XP=e.$WP=e.$VP=e.$UP=void 0;let a=class{#e;#t;#i;constructor(h,D,S){this.b=new Map,this.c=new Map,this.#e=h.getProxy(A.$$M.MainThreadCommands),this.d=D,this.#i=S,this.#t=h.getProxy(A.$$M.MainThreadTelemetry),this.converter=new g(this,I=>{const P=this.c.get(I);return P?.result===p.Void?P:void 0},D),this.f=[{processArgument(I){return(0,E.$6h)(I)}},{processArgument(I){return(0,M.$5n)(I,function(P){if(T.$ut.isIRange(P))return R.Range.to(P);if(k.$tt.isIPosition(P))return R.Position.to(P);if(T.$ut.isIRange(P.range)&&l.URI.isUri(P.uri))return R.location.to(P);if(P instanceof o.$Fe)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(h){this.f.push(h)}registerApiCommand(h){const D=this.registerCommand(!1,h.id,async(...S)=>{const I=h.args.map((W,V)=>{if(!W.validate(S[V]))throw new Error(`Invalid argument '${W.name}' when running '${h.id}', received: ${typeof S[V]=="object"?JSON.stringify(S[V],null,"	"):S[V]} `);return W.convert(S[V])}),P=await this.executeCommand(h.internalId,...I);return h.result.convert(P,S,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this.c.set(h.id,h),new O.$aN(()=>{D.dispose(),this.c.delete(h.id)})}registerCommand(h,D,S,I,P,W){if(this.d.trace("ExtHostCommands#registerCommand",D),!D.trim().length)throw new Error("invalid id");if(this.b.has(D))throw new Error(`command '${D}' already exists`);return this.b.set(D,{callback:S,thisArg:I,metadata:P,extension:W}),h&&this.#e.$registerCommand(D),new O.$aN(()=>{this.b.delete(D)&&h&&this.#e.$unregisterCommand(D)})}executeCommand(h,...D){return this.d.trace("ExtHostCommands#executeCommand",h),this.g(h,D,!0)}async g(h,D,S){if(this.b.has(h))return this.#e.$fireCommandActivationEvent(h),this.h(h,D,!1);{let I=!1;const P=(0,M.$5n)(D,function(W){if(W instanceof O.$bN)return R.Position.from(W);if(W instanceof O.$cN)return R.Range.from(W);if(W instanceof O.$mN)return R.location.from(W);if(O.$CO.isNotebookRange(W))return R.NotebookRange.from(W);if(W instanceof ArrayBuffer)return I=!0,o.$Fe.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return I=!0,o.$Fe.wrap(W);if(W instanceof o.$Fe)return I=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(h,I?new n.$Bw(P):P,S);return(0,E.$6h)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(h,D,!1);throw W}}}async h(h,D,S){const I=this.b.get(h);if(!I)throw new Error("Unknown command");const{callback:P,thisArg:W,metadata:V}=I;if(V?.args)for(let N=0;N<V.args.length;N++)try{(0,C.$ng)(D[N],V.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${V.args[N].name}' - ${V.args[N].description}`)}const q=c.$_d.create();try{return await P.apply(W,D)}catch(N){if(h===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...D);B&&(h=B.command)}if(this.d.error(N,h,I.extension?.identifier),!S)throw N;if(I.extension?.identifier){const B=this.#i.onExtensionError(I.extension.identifier,N);this.d.trace("forwarded error to extension?",B,I.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$hj)(N)),this.id=h,this.source=I.extension?.displayName??I.extension?.name}}}finally{this.j(I,h,q.elapsed())}}j(h,D,S){h.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:h.extension.identifier.value,id:new u.$fp(D),duration:S})}$executeContributedCommand(h,...D){this.d.trace("ExtHostCommands#$executeContributedCommand",h);const S=this.b.get(h);return S?(D=D.map(I=>this.f.reduce((P,W)=>W.processArgument(P,S.extension?.identifier),I)),this.h(h,D,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this.d.trace("ExtHostCommands#getCommands",h),this.#e.$getCommands().then(D=>(h&&(D=D.filter(S=>S[0]!=="_")),D))}$getContributedCommandMetadata(){const h=Object.create(null);for(const[D,S]of this.b){const{metadata:I}=S;I&&(h[D]=I)}return Promise.resolve(h)}};e.$UP=a,e.$UP=a=Je([We(0,s.$zP),We(1,m.$3j),We(2,t.$TP)],a),e.$VP=(0,f.$wi)("IExtHostCommands");class g{constructor(h,D,S){this.d=h,this.f=D,this.g=S,this.delegatingCommandId=`__vsc${(0,d.$Sg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(h,D){if(!h)return;const S={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return S;const I=this.f(h.command);if(I)S.id=I.internalId,S.arguments=I.args.map((P,W)=>P.convert(h.arguments&&h.arguments[W]));else if((0,$.$Lb)(h.arguments)){const P=`${h.command} /${++this.c}`;this.b.set(P,h),D.add((0,w.$Sc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),S.$ident=P,S.id=this.delegatingCommandId,S.arguments=[P],this.g.trace("CommandsConverter#CREATE",h.command,P)}return S}fromInternal(h){return typeof h.$ident=="string"?this.b.get(h.$ident):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this.b.get(h[0])}h(...h){const D=this.getActualCommand(...h);return this.g.trace("CommandsConverter#EXECUTE",h[0],D?D.command:"MISSING"),D?this.d.executeCommand(D.command,...D.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${h[0]}`)}}e.$WP=g;class b{static{this.Uri=new b("uri","Uri of a text document",h=>l.URI.isUri(h),h=>h)}static{this.Position=new b("position","A position in a text document",h=>O.$bN.isPosition(h),R.Position.from)}static{this.Range=new b("range","A range in a text document",h=>O.$cN.isRange(h),R.Range.from)}static{this.Selection=new b("selection","A selection in a text document",h=>O.$dN.isSelection(h),R.Selection.from)}static{this.Number=new b("number","",h=>typeof h=="number",h=>h)}static{this.String=new b("string","",h=>typeof h=="string",h=>h)}static{this.StringArray=b.Arr(b.String)}static Arr(h){return new b(`${h.name}_array`,`Array of ${h.name}, ${h.description}`,D=>Array.isArray(D)&&D.every(S=>h.validate(S)),D=>D.map(S=>h.convert(S)))}static{this.CallHierarchyItem=new b("item","A call hierarchy item",h=>h instanceof O.$yN,R.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new b("item","A type hierarchy item",h=>h instanceof O.$WO,R.TypeHierarchyItem.from)}static{this.TestItem=new b("testItem","A VS Code TestItem",h=>h instanceof r.$MP,R.TestItem.from)}constructor(h,D,S,I){this.name=h,this.description=D,this.validate=S,this.convert=I}optional(){return new b(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,D){return new b(h??this.name,D??this.description,this.validate,this.convert)}}e.$XP=b;class p{static{this.Void=new p("no result",h=>h)}constructor(h,D){this.description=h,this.convert=D}}e.$YP=p;class v{constructor(h,D,S,I,P){this.id=h,this.internalId=D,this.description=S,this.args=I,this.result=P}}e.$ZP=v}),define(Se[285],Pe([1,0,18,16,2,89,98,31,32,8,7]),function(le,e,C,O,R,M,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alc=void 0;const k=[new m.$ZP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to an array of DocumentHighlight-instances.",w(E.DocumentHighlight.to))),new m.$ZP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$XP.Uri],new m.$YP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,r)=>{if((0,C.$Kb)(s))return;class o extends T.$tN{static to(i){const c=new o(i.name,E.SymbolKind.to(i.kind),i.containerName||"",new T.$mN(r[0],E.Range.to(i.range)));return c.detail=i.detail,c.range=c.location.range,c.selectionRange=E.Range.to(i.selectionRange),c.children=i.children?i.children.map(o.to):[],c}}return s.map(o.to)})),new m.$ZP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$XP.Uri,new m.$XP("options","Formatting options",s=>!0,s=>s)],new m.$YP("A promise that resolves to an array of TextEdits.",w(E.TextEdit.to))),new m.$ZP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$XP.Uri,m.$XP.Range,new m.$XP("options","Formatting options",s=>!0,s=>s)],new m.$YP("A promise that resolves to an array of TextEdits.",w(E.TextEdit.to))),new m.$ZP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$XP.Uri,m.$XP.Position,new m.$XP("ch","Trigger character",s=>typeof s=="string",s=>s),new m.$XP("options","Formatting options",s=>!0,s=>s)],new m.$YP("A promise that resolves to an array of TextEdits.",w(E.TextEdit.to))),new m.$ZP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$ZP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$ZP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$ZP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$ZP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to an array of Location-instances.",w(E.location.to))),new m.$ZP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to an array of Hover-instances.",w(E.Hover.to))),new m.$ZP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$XP.Uri,new m.$XP("position","A position in a text document",s=>Array.isArray(s)&&s.every(r=>T.$bN.isPosition(r)),s=>s.map(E.Position.from))],new m.$YP("A promise that resolves to an array of ranges.",s=>s.map(r=>{let o;for(const n of r.reverse())o=new T.$xN(E.Range.to(n),o);return o}))),new m.$ZP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$XP.String.with("query","Search string")],new m.$YP("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(E.WorkspaceSymbol.to))),new m.$ZP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(E.CallHierarchyItem.to))),new m.$ZP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$XP.CallHierarchyItem],new m.$YP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(E.CallHierarchyIncomingCall.to))),new m.$ZP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$XP.CallHierarchyItem],new m.$YP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(E.CallHierarchyOutgoingCall.to))),new m.$ZP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:E.Range.to(s.range),placeholder:s.text}})),new m.$ZP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$XP.Uri,m.$XP.Position,m.$XP.String.with("newName","The new symbol name")],new m.$YP("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return E.WorkspaceEdit.to(s)}})),new m.$ZP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$XP.Uri,m.$XP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$YP("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(E.DocumentLink.to))),new m.$ZP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$XP.Uri],new m.$YP("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new T.$tO(s.tokenTypes,s.tokenModifiers)})),new m.$ZP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$XP.Uri],new m.$YP("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const r=(0,A.$dcb)(s);if(r.type==="full")return new T.$vO(r.data,void 0)})),new m.$ZP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$XP.Uri,m.$XP.Range.optional()],new m.$YP("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new T.$tO(s.tokenTypes,s.tokenModifiers)})),new m.$ZP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$XP.Uri,m.$XP.Range],new m.$YP("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const r=(0,A.$dcb)(s);if(r.type==="full")return new T.$vO(r.data,void 0)})),new m.$ZP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$XP.Uri,m.$XP.Position,m.$XP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$XP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$YP("A promise that resolves to a CompletionList-instance.",(s,r,o)=>{if(!s)return new T.$JN([]);const n=s.suggestions.map(i=>E.CompletionItem.to(i,o));return new T.$JN(n,s.incomplete)})),new m.$ZP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$XP.Uri,m.$XP.Position,m.$XP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$YP("A promise that resolves to SignatureHelp.",s=>{if(s)return E.SignatureHelp.to(s)})),new m.$ZP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$XP.Uri,m.$XP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$YP("A promise that resolves to an array of CodeLens-instances.",(s,r,o)=>w(n=>new T.$BN(E.Range.to(n.range),n.command&&o.fromInternal(n.command)))(s))),new m.$ZP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$XP.Uri,new m.$XP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>T.$cN.isRange(s),s=>T.$dN.isSelection(s)?E.Selection.from(s):E.Range.from(s)),m.$XP.String.with("kind","Code action kind to return code actions for").optional(),m.$XP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$YP("A promise that resolves to an array of Command-instances.",(s,r,o)=>w(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(n.command)}else{const i=new T.$vN(n.title,n.kind?new T.$wN(n.kind):void 0);return n.edit&&(i.edit=E.WorkspaceEdit.to(n.edit)),n.command&&(i.command=o.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(s))),new m.$ZP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$XP.Uri],new m.$YP("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(r=>new T.$PN(E.Range.to(r.range),E.Color.to(r.color))):[])),new m.$ZP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$XP("color","The color to show and insert",s=>s instanceof T.$ON,E.Color.from),new m.$XP("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:E.Range.from(s.range)}))],new m.$YP("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(E.ColorPresentation.to):[])),new m.$ZP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$XP.Uri,m.$XP.Range],new m.$YP("A promise that resolves to an array of Inlay objects",(s,r,o)=>s.map(E.InlayHint.to.bind(void 0,o)))),new m.$ZP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$XP.Uri],new m.$YP("A promise that resolves to an array of FoldingRange objects",(s,r)=>{if(s)return s.map(E.FoldingRange.to)})),new m.$ZP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$YP("A promise that resolves to an array of NotebookContentProvider static info objects.",w(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(r=>E.NotebookExclusiveDocumentPattern.to(r))})))),new m.$ZP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$XP.Uri,m.$XP.Range,new m.$XP("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof T.$cN,s=>E.InlineValueContext.from(s))],new m.$YP("A promise that resolves to an array of InlineValue objects",s=>s.map(E.InlineValue.to))),new m.$ZP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$XP("uriOrString","Uri-instance or string (only http/https)",s=>R.URI.isUri(s)||typeof s=="string"&&(0,O.$Gg)(s,O.Schemas.http,O.Schemas.https),s=>s),new m.$XP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[E.ViewColumn.from(s),void 0]:[E.ViewColumn.from(s.viewColumn),E.TextEditorOpenOptions.from(s)])).optional(),m.$XP.String.with("label","").optional()],m.$YP.Void),new m.$ZP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$XP.Uri.with("resource","Resource to open"),m.$XP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$XP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[E.ViewColumn.from(s),void 0]:[E.ViewColumn.from(s.viewColumn),E.TextEditorOpenOptions.from(s)])).optional()],m.$YP.Void),new m.$ZP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$XP.Uri.with("left","Left-hand side resource of the diff editor"),m.$XP.Uri.with("right","Right-hand side resource of the diff editor"),m.$XP.String.with("title","Human readable title for the diff editor").optional(),new m.$XP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[E.ViewColumn.from(s.viewColumn),E.TextEditorOpenOptions.from(s)]).optional()],m.$YP.Void),new m.$ZP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$XP.String.with("title","Human readable title for the changes editor"),new m.$XP("resourceList","List of resources to compare",s=>{for(const r of s){if(r.length!==3)return!1;const[o,n,i]=r;if(!R.URI.isUri(o)||!R.URI.isUri(n)&&n!==void 0&&n!==null||!R.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},s=>s)],m.$YP.Void),new m.$ZP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$XP.Uri,m.$XP.Position],new m.$YP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(E.TypeHierarchyItem.to))),new m.$ZP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$XP.TypeHierarchyItem],new m.$YP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(E.TypeHierarchyItem.to))),new m.$ZP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$XP.TypeHierarchyItem],new m.$YP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(E.TypeHierarchyItem.to))),new m.$ZP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$XP.TestItem],m.$YP.Void),new m.$ZP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$XP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$YP.Void),new m.$ZP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$XP.String.with("name","The context key name"),new m.$XP("value","The context key value",()=>!0,s=>s)],m.$YP.Void),new m.$ZP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$XP.Uri,m.$XP.StringArray,new m.$XP("MappedEditsContext","Mapped Edits Context",s=>E.MappedEditsContext.is(s),s=>E.MappedEditsContext.from(s))],new m.$YP("A promise that resolves to a workspace edit or null",s=>s?E.WorkspaceEdit.to(s):null))];class l{static register(r){k.forEach(r.registerApiCommand,r),this.a(r)}static a(r){r.registerCommand(!1,"_validateWhenClauses",$.$vj)}}e.$Alc=l;function w(s){return r=>{if(Array.isArray(r))return r.map(s)}}function f(s){if(!Array.isArray(s))return;const r=[];for(const o of s)M.$_t(o)?r.push(E.DefinitionLink.to(o)):r.push(E.location.to(o));return r}}),define(Se[286],Pe([1,0,11,6,2,4,32,8,7]),function(le,e,C,O,R,M,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=void 0;class E{static{this.a=0}constructor(w,f){this.extension=w,this.provider=f,this.handle=E.a++}}class T{constructor(w){this.session=w,this.responses=[]}}class k{static{this.a=0}constructor(w,f,s,r){this.f=s,this.g=r,this.b=new Map,this.d=new Map,this.e=w.getProxy(M.$$M.MainThreadInlineChat),f.registerApiCommand(new A.$ZP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new A.$XP("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?$.Range.from(o.initialRange):void 0,initialSelection:m.$dN.isSelection(o.initialSelection)?$.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?$.Position.from(o.position):void 0}})],A.$YP.Void))}registerProvider(w,f,s){const r=new E(w,f);return this.b.set(r.handle,r),this.e.$registerInteractiveEditorProvider(r.handle,s?.label??w.displayName??w.name,w.identifier,typeof f.handleInteractiveEditorResponseFeedback=="function",typeof f.provideFollowups=="function",s?.supportReportIssue??!1),(0,O.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(r.handle),this.b.delete(r.handle)})}async $prepareSession(w,f,s,r){const o=this.b.get(w);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(R.URI.revive(f)),i=$.Selection.to(s),c=await o.provider.prepareInteractiveEditorSession({document:n,selection:i},r);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const u=k.a++;return this.d.set(u,new T(c)),{id:u,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:$.Range.from(c.wholeRange),message:c.message}}async $provideResponse(w,f,s,r){const o=this.b.get(w);if(!o)return;const n=this.d.get(f.id);if(!n)return;const i={prompt:s.prompt,selection:$.Selection.to(s.selection),wholeRange:$.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,previewDocument:this.f.getDocument(R.URI.revive(s.previewDocument)),withIntentDetection:s.withIntentDetection};let c=!1;const u={report:async y=>{if(!s.live&&y.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||r.isCancellationRequested||await this.e.$handleProgressChunk(s.requestId,{message:y.message,edits:y.edits?.map($.TextEdit.from),editsShouldBeInstant:y.editsShouldBeInstant,slashCommand:y.slashCommand?.command,markdownFragment:m.$CN.isMarkdownString(y.content)?y.content.value:y.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(n.session,i,u,r));let d;try{d=await(0,C.$kh)(t,r)}finally{c=!0}if(!d)return;const a=n.responses.push(d)-1,g={wholeRange:$.Range.from(d.wholeRange),placeholder:d.placeholder};if(!k.h(d))return{...g,id:a,type:"editorEdit",message:$.MarkdownString.from(d.contents),edits:[]};const{edits:b,contents:p}=d,v=p!==void 0?$.MarkdownString.from(p):void 0;return b instanceof m.$kN?{...g,id:a,type:"bulkEdit",edits:$.WorkspaceEdit.from(b),message:v}:{...g,id:a,type:"editorEdit",edits:b.map($.TextEdit.from),message:v}}async $provideFollowups(w,f,s,r){const o=this.b.get(w),n=this.d.get(f),i=n?.responses[s];if(o&&i&&o.provider.provideFollowups){const c=Promise.resolve(o.provider.provideFollowups(n.session,i,r));return(await(0,C.$kh)(c,r))?.map($.ChatInlineFollowup.from)}}$handleFeedback(w,f,s,r){const o=this.b.get(w),n=this.d.get(f),i=n?.responses[s];if(o&&i){const c=$.InteractiveEditorResponseFeedbackKind.to(r);o.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,c)}}$releaseSession(w,f){}static h(w){return typeof w=="object"&&typeof w.edits=="object"}}e.$Jmc=k}),define(Se[287],Pe([1,0,2,32]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wmc=void 0;class R{constructor(A,$,m,E,T){this.a=$,this.b=m,this.c=E;const k=new O.$ZP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$XP("showOptions","Show Options",l=>!0,l=>l),new O.$XP("resource","Interactive resource Uri",l=>!0,l=>l),new O.$XP("controllerId","Notebook controller Id",l=>!0,l=>l),new O.$XP("title","Interactive editor title",l=>!0,l=>l)],new O.$YP("Notebook and input URI",l=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const w=this.a.getEditorById(l.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:C.URI.revive(l.notebookUri),inputUri:C.URI.revive(l.inputUri),notebookEditor:w.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:C.URI.revive(l.notebookUri),inputUri:C.URI.revive(l.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(A,$,m,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:m,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Wmc=R}),define(Se[288],Pe([1,0,18,11,24,5,6,28,2,20,12,4,32,8,7,78,229,26,35,230]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=void 0,e.$5mc=b;let c=class{constructor(v,y,h,D,S){this.m=y,this.n=h,this.o=D,this.q=S,this.b=new $.$Ac,this.c=new $.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new M.$de,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=v.getProxy(k.$$M.MainThreadNotebookKernels);const I=new l.$ZP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$XP("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const V=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:V}}else if(W&&"notebookEditor"in W){const V=this.n.getIdByEditor(W.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return W})],l.$YP.Void),P=new l.$ZP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$XP.Uri],new l.$YP("A promise that resolves to an array of variables",(W,V)=>W.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(I),this.o.registerApiCommand(P)}createNotebookController(v,y,h,D,S,I){for(const ae of this.j.values())if(ae.controller.id===y&&E.$Rm.equals(v.identifier,ae.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const P=this.k++,W=this;this.q.trace(`NotebookController[${P}], CREATED by ${v.identifier.value}, ${y}`);const V=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${v.identifier}'`);let q=!1;const N=new M.$de,B=new M.$de,K={id:b(v.identifier,y),notebookType:h,extensionId:v.identifier,extensionLocation:v.extensionLocation,label:D||v.identifier.value,preloads:I?I.map(w.NotebookRendererScript.from):[]};let ie=S??V,ce,ye;this.a.$addKernel(P,K).catch(ae=>{console.log(ae),q=!0});let ke=0;const fe=()=>{if(q)return;const ae=++ke;Promise.resolve().then(()=>{ae===ke&&this.a.$updateKernel(P,K)})},$e=new $.$Ac,Te={get id(){return y},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return K.label},set label(ae){K.label=ae??v.displayName??v.name,fe()},get detail(){return K.detail??""},set detail(ae){K.detail=ae,fe()},get description(){return K.description??""},set description(ae){K.description=ae,fe()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(ae){K.supportedLanguages=ae,fe()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){K.supportsExecutionOrder=ae,fe()},get rendererScripts(){return K.preloads?K.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(ae){ie=ae??V},get interruptHandler(){return ce},set interruptHandler(ae){ce=ae,K.supportsInterrupt=!!ae,fe()},set variableProvider(ae){(0,o.$PG)(v,"notebookVariableProvider"),ye=ae,K.hasVariableProvider=!!ae,ae?.onDidChangeVariables(Ne=>W.a.$variablesUpdated(Ne.uri)),fe()},get variableProvider(){return ye},createNotebookCellExecution(ae){if(q)throw new Error("notebook controller is DISPOSED");if(!$e.has(ae.notebook.uri))throw W.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(Ne=>Ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return W._createNotebookCellExecution(ae,b(v.identifier,this.id))},createNotebookExecution(ae){if((0,o.$PG)(v,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!$e.has(ae.uri))throw W.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(Ne=>Ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return W._createNotebookExecution(ae,b(v.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${P}], DISPOSED`),q=!0,this.j.delete(P),N.dispose(),B.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(ae,Ne){Ne===f.NotebookControllerAffinity2.Hidden&&(0,o.$PG)(v,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(P,ae.uri,Ne)},onDidReceiveMessage:B.event,postMessage(ae,Ne){return(0,o.$PG)(v,"notebookMessaging"),W.a.$postMessage(P,Ne&&W.n.getIdByEditor(Ne),ae)},asWebviewUri(ae){return(0,o.$PG)(v,"notebookMessaging"),(0,s.$NAb)(ae,W.m.remote)}};return this.j.set(P,{extensionId:v.identifier,controller:Te,onDidReceiveMessage:B,onDidChangeSelection:N,associatedNotebooks:$e}),Te}getIdByController(v){for(const[y,h]of this.j)if(h.controller===v)return b(h.extensionId,v.id);return null}createNotebookControllerDetectionTask(v,y){const h=this.g++,D=this;this.q.trace(`NotebookControllerDetectionTask[${h}], CREATED by ${v.identifier.value}`),this.a.$addKernelDetectionTask(h,y);const S={dispose:()=>{this.f.delete(h),D.a.$removeKernelDetectionTask(h)}};return this.f.set(h,S),S}registerKernelSourceActionProvider(v,y,h){const D=this.i++,S=typeof h.onDidChangeNotebookKernelSourceActions=="function"?D:void 0,I=this;this.h.set(D,h),this.q.trace(`NotebookKernelSourceActionProvider[${D}], CREATED by ${v.identifier.value}`),this.a.$addKernelSourceActionProvider(D,D,y);let P;return S!==void 0&&(P=h.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(S))),{dispose:()=>{this.h.delete(D),I.a.$removeKernelSourceActionProvider(D,D),P?.dispose()}}}async $provideKernelSourceActions(v,y){const h=this.h.get(v);if(h){const D=new A.$Tc;return(await h.provideNotebookKernelSourceActions(y)??[]).map(I=>w.NotebookKernelSourceAction.from(I,this.o.converter,D))}return[]}$acceptNotebookAssociation(v,y,h){const D=this.j.get(v);if(D){const S=this.n.getNotebookDocument(m.URI.revive(y));h?D.associatedNotebooks.set(S.uri,!0):D.associatedNotebooks.delete(S.uri),this.q.trace(`NotebookController[${v}] ASSOCIATE notebook`,S.uri.toString(),h),D.onDidChangeSelection.fire({selected:h,notebook:S.apiNotebook})}}async $executeCells(v,y,h){const D=this.j.get(v);if(!D)return;const S=this.n.getNotebookDocument(m.URI.revive(y)),I=[];for(const P of h){const W=S.getCell(P);W&&I.push(W.apiCell)}try{this.q.trace(`NotebookController[${v}] EXECUTE cells`,S.uri.toString(),I.length),await D.controller.executeHandler.call(D.controller,I,S.apiNotebook,D.controller)}catch(P){this.q.error(`NotebookController[${v}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(v,y,h){const D=this.j.get(v);if(!D)return;const S=this.n.getNotebookDocument(m.URI.revive(y));if(D.controller.interruptHandler)await D.controller.interruptHandler.call(D.controller,S.apiNotebook);else for(const I of h){const P=S.getCell(I);P&&this.b.get(P.uri)?.cancel()}if(D.controller.interruptHandler){const I=this.c.get(S.uri);this.c.delete(S.uri),h.length&&Array.isArray(I)&&I.length&&I.forEach(P=>P.dispose())}}async $provideVariables(v,y,h,D,S,I,P){const W=this.j.get(v);if(!W)return;const V=this.n.getNotebookDocument(m.URI.revive(h)),q=W.controller.variableProvider;if(!q)return;let N;if(D!==void 0){if(N=this.s[D],!N)return}else this.s={};const B=S==="named"?f.NotebookVariablesRequestKind.Named:f.NotebookVariablesRequestKind.Indexed,K=q.provideVariables(V.apiNotebook,N,B,I,P);let ie=0;for await(const ce of K){if(P.isCancellationRequested)return;const ye={id:this.r++,name:ce.variable.name,value:ce.variable.value,type:ce.variable.type,interfaces:ce.variable.interfaces,language:ce.variable.language,expression:ce.variable.expression,hasNamedChildren:ce.hasNamedChildren,indexedChildrenCount:ce.indexedChildrenCount,extensionId:W.extensionId.value};if(this.s[ye.id]=ce.variable,this.a.$receiveVariable(y,ye),ie++>=i.$hjb)return}}$acceptKernelMessageFromRenderer(v,y,h){const D=this.j.get(v);if(!D)return;const S=this.n.getEditorById(y);D.onDidReceiveMessage.fire(Object.freeze({editor:S.apiEditor,message:h}))}$cellExecutionChanged(v,y,h){const S=this.n.getNotebookDocument(m.URI.revive(v)).getCell(y);if(S){const I=h?w.NotebookCellExecutionState.to(h):f.NotebookCellExecutionState.Idle;I!==void 0&&this.l.fire({cell:S.apiCell,state:I})}}_createNotebookCellExecution(v,y){if(v.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const D=this.n.getNotebookDocument(v.notebook.uri).getCellFromApiCell(v);if(!D)throw new Error("invalid cell");if(this.b.has(D.uri))throw new Error(`duplicate execution for ${D.uri}`);const S=new t(y,D,this.a);this.b.set(D.uri,S);const I=S.onDidChangeState(()=>{S.state===u.Resolved&&(S.dispose(),I.dispose(),this.b.delete(D.uri))});return S.asApiObject()}_createNotebookExecution(v,y){const h=this.n.getNotebookDocument(v.uri),D=v.getCells().find(P=>{const W=h.getCellFromApiCell(P);return W&&this.b.has(W.uri)});if(D)throw new Error(`duplicate cell execution for ${D.document.uri}`);if(this.c.has(h.uri))throw new Error(`duplicate notebook execution for ${h.uri}`);const S=new a(y,h,this.a),I=S.onDidChangeState(()=>{S.state===d.Resolved&&(S.dispose(),I.dispose(),this.c.delete(h.uri))});return this.c.set(h.uri,[S,I]),S.asApiObject()}};e.$4mc=c,e.$4mc=c=Je([We(4,T.$3j)],c);var u;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(u||(u={}));class t extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(v,y,h){super(),this.m=y,this.n=h,this.b=t.a++,this.c=new M.$de,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new R.$oe),this.h=new g(10,D=>this.s(D)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,v,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(v){await this.h.addItem(v)}async s(v){const y=Array.isArray(v)?v:[v];return this.n.$updateExecution(this.b,new n.$Bw(y))}t(){if(this.f===u.Init)throw new Error("Must call start before modifying cell output");if(this.f===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(v){let y=this.m;if(v&&(y=this.m.notebook.getCellFromApiCell(v)),!y)throw new Error("INVALID cell");return y.handle}y(v){return v.map(y=>{const h=f.$GO.ensureUniqueMimeTypes(y.items,!0);return h===y.items?w.NotebookCellOutput.from(y):w.NotebookCellOutput.from({items:h,id:y.id,metadata:y.metadata})})}async z(v,y,h){const D=this.w(y),S=this.y((0,C.$2b)(v));return this.r({editType:r.CellExecutionUpdateType.Output,cellHandle:D,append:h,outputs:S})}async C(v,y,h){return v=f.$GO.ensureUniqueMimeTypes((0,C.$2b)(v),!0),this.r({editType:r.CellExecutionUpdateType.OutputItems,items:v.map(w.NotebookCellOutputItem.from),outputId:y.id,append:h})}asApiObject(){const v=this;return Object.freeze({get token(){return v.g.token},get cell(){return v.m.apiCell},get executionOrder(){return v.j},set executionOrder(h){v.j=h,v.s([{editType:r.CellExecutionUpdateType.ExecutionState,executionOrder:v.j}])},start(h){if(v.f===u.Resolved||v.f===u.Started)throw new Error("Cannot call start again");v.f=u.Started,v.c.fire(),v.s({editType:r.CellExecutionUpdateType.ExecutionState,runStartTime:h})},end(h,D,S){if(v.f===u.Resolved)throw new Error("Cannot call resolve twice");v.f=u.Resolved,v.c.fire(),v.h.flush();const I=S?{message:S.message,stack:S.stack,location:S?.location?{startLineNumber:S.location.start.line,startColumn:S.location.start.character,endLineNumber:S.location.end.line,endColumn:S.location.end.character}:void 0,uri:S.uri}:void 0;v.n.$completeExecution(v.b,new n.$Bw({runEndTime:D,lastRunSuccess:h,error:I}))},clearOutput(h){return v.t(),v.z([],h,!1)},appendOutput(h,D){return v.t(),v.z(h,D,!0)},replaceOutput(h,D){return v.t(),v.z(h,D,!1)},appendOutputItems(h,D){return v.t(),v.C(h,D,!0)},replaceOutputItems(h,D){return v.t(),v.C(h,D,!1)}})}}var d;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(d||(d={}));class a extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(v,y,h){super(),this.h=y,this.j=h,this.b=a.a++,this.c=new M.$de,this.onDidChangeState=this.c.event,this.f=d.Init,this.g=this.B(new R.$oe),this.j.$createNotebookExecution(this.b,v,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===d.Resolved||this.f===d.Started)throw new Error("Cannot call start again");this.f=d.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===d.Resolved)throw new Error("Cannot call resolve twice");this.f=d.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class g{constructor(v,y){this.f=v,this.g=y,this.a=[],this.b=Date.now()}addItem(v){return this.a.push(v),this.c||(this.c=new O.$Th,this.b=Date.now(),(0,O.$xh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const v=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>v.complete())}}function b(p,v){return`${p.value}/${v}`}}),define(Se[53],Pe([1,0,5,4,3,2,17,6,7,180,14,208,24,34,209,36,11,8,32]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmc=e.$emc=e.$dmc=e.$cmc=void 0,e.$cmc=(0,R.$wi)("IExtHostTerminalService");class i extends $.$Uc{constructor(h,D,S,I){super(),this.u=h,this._id=D,this.w=S,this.y=I,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new C.$de),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(W=>this.g=W);const P=this;this.value={get name(){return P.y||""},get processId(){return P.b},get creationOptions(){return P.w},get exitStatus(){return P.j},get state(){return P.m},get selection(){return P.n},get shellIntegration(){return P.shellIntegration},sendText(W,V=!0){P.C(),P.u.$sendText(P._id,W,V)},show(W){P.C(),P.u.$show(P._id,W)},hide(){P.C(),P.u.$hide(P._id)},dispose(){P.a||(P.a=!0,P.u.$dispose(P._id))},get dimensions(){if(!(P.f===void 0||P.h===void 0))return{columns:P.f,rows:P.h}}}}dispose(){this.s.fire(),super.dispose()}async create(h,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??D?.cwd??void 0,env:h.env??void 0,icon:b(h.iconPath)??void 0,color:s.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,forceShellIntegration:D?.forceShellIntegration??void 0,isFeatureTerminal:D?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:D?.useShellEnvironment??void 0,location:D?.location||this.z(h.location,D?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,D,S,I,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:I,color:s.ThemeColor.isThemeColor(P)?P.id:void 0,location:D?.location||this.z(h,S),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(h,D){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&D?{parentTerminal:D}:"viewColumn"in h?{viewColumn:o.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(h){this.y=h}setExitStatus(h,D){this.j=Object.freeze({code:h,reason:D})}setDimensions(h,D){return h===this.f&&D===this.h||h===0||D===0?!1:(this.f=h,this.h=D,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(h){this.n=h}_setProcessId(h){this.g?(this.g(h),this.g=void 0):this.b.then(D=>{D!==h&&(this.b=Promise.resolve(h))})}}e.$dmc=i;class c{get onProcessReady(){return this.b.event}constructor(h){this.g=h,this.id=0,this.shouldPersist=!1,this.a=new C.$de,this.onProcessData=this.a.event,this.b=new C.$de,this.d=new C.$de,this.onDidChangeProperty=this.d.event,this.f=new C.$de,this.onProcessExit=this.f.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,D){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${D}`)}async start(){}shutdown(){this.g.close()}input(h){this.g.handleInput?.(h)}resize(h,D){this.g.setDimensions?.({columns:h,rows:D})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this.g.onDidWrite(D=>this.a.fire(D)),this.g.onDidClose?.((D=void 0)=>{this.f.fire(D===void 0?void 0:D)}),this.g.onDidOverrideDimensions?.(D=>{D&&this.d.fire({type:"overrideDimensions",value:{cols:D.columns,rows:D.rows}})}),this.g.onDidChangeName?.(D=>{this.d.fire({type:"title",value:D})}),this.g.open(h||void 0),h&&this.g.setDimensions?.(h),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,t=class extends $.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(h=>h.value)}constructor(h,D,S){super(),this.Q=D,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new C.$de,this.onDidCloseTerminal=this.H.event,this.I=new C.$de,this.onDidOpenTerminal=this.I.event,this.J=new C.$de,this.onDidChangeActiveTerminal=this.J.event,this.L=new C.$de,this.onDidChangeTerminalDimensions=this.L.event,this.M=new C.$de,this.onDidChangeTerminalState=this.M.event,this.N=new C.$de,this.onDidChangeShell=this.N.event,this.O=new C.$de({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new C.$de({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=S.getProxy(O.$$M.MainThreadTerminalService),this.y=new f.$Fvb(this.a.$sendProcessData),this.a.$registerProcessSupport(h),this.Q.registerArgumentProcessor({processArgument:I=>{const P=W=>{const V=W;return this.getTerminalById(V.instanceId)?.value};switch(I?.$mid){case 15:return P(I);default:{if(Array.isArray(I))for(let W=0;W<I.length&&I[W].$mid===15;W++)I[W]=P(I[W]);return I}}}}),this.B({dispose:()=>{for(const[I,P]of this.g)P.shutdown(!0)}})}getDefaultShell(h){return(h?this.u:this.s)?.path||""}getDefaultShellArgs(h){return(h?this.u:this.s)?.args||[]}createExtensionTerminal(h,D){const S=new i(this.a,(0,w.$Sg)(),h,h.name),I=new c(h.pty);return S.createExtensionTerminal(h.location,D,this.R(h,D).resolvedExtHostIdentifier,b(h.iconPath),p(h.color)).then(P=>{const W=this.S(P,I);this.h[P]=W}),this.f.push(S),S.value}R(h,D){if(D=D||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const S=h.location.parentTerminal;if(S){const I=this.f.find(P=>P.value===S);I&&(D.resolvedExtHostIdentifier=I._id)}}else h.location&&typeof h.location!="object"?D.location=h.location:D.location&&typeof D.location=="object"&&"splitActiveTerminal"in D.location&&(D.location={splitActiveTerminal:!0});return D}attachPtyToTerminal(h,D){if(!this.getTerminalById(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const I=new c(D),P=this.S(h,I);this.h[h]=P}async $acceptActiveTerminalChanged(h){const D=this.b;if(h===null){this.b=void 0,D!==this.b&&this.J.fire(this.b);return}const S=this.getTerminalById(h);S&&(this.b=S,D!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(h,D){const S=this.getTerminalById(h);S&&this.O.fire({terminal:S.value,data:D})}async $acceptTerminalDimensions(h,D,S){const I=this.getTerminalById(h);I&&I.setDimensions(D,S)&&this.L.fire({terminal:I.value,dimensions:I.value.dimensions})}async $acceptDidExecuteCommand(h,D){const S=this.getTerminalById(h);S&&this.P.fire({terminal:S.value,...D})}async $acceptTerminalMaximumDimensions(h,D,S){this.g.get(h)?.resize(D,S)}async $acceptTerminalTitleChange(h,D){const S=this.getTerminalById(h);S&&(S.name=D)}async $acceptTerminalClosed(h,D,S){const I=this.X(this.f,h);if(I!==null){const P=this.f.splice(I,1)[0];P.setExitStatus(D,S),this.H.fire(P.value)}}$acceptTerminalOpened(h,D,S,I){if(D){const V=this.X(this.f,D);if(V!==null){this.f[V]._id=h,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const P={name:I.name,shellPath:I.executable,shellArgs:I.args,cwd:typeof I.cwd=="string"?I.cwd:M.URI.revive(I.cwd),env:I.env,hideFromUser:I.hideFromUser},W=new i(this.a,h,P,S);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(h,D){this.getTerminalById(h)?._setProcessId(D)}async $startExtensionTerminal(h,D){const S=this.getTerminalById(h);if(!S)return{message:(0,E.localize)(0,null,h)};S.isOpen||await new Promise(P=>{const W=this.onDidOpenTerminal(async V=>{V===S.value&&(W.dispose(),P())})});const I=this.g.get(h);I?I.startSendingEvents(D):this.j[h]={initialDimensions:D}}S(h,D){const S=new $.$Tc;S.add(D.onProcessReady(P=>this.a.$sendProcessReady(h,P.pid,P.cwd,P.windowsPty))),S.add(D.onDidChangeProperty(P=>this.a.$sendProcessProperty(h,P))),this.y.startBuffering(h,D.onProcessData),S.add(D.onProcessExit(P=>this.U(h,P))),this.g.set(h,D);const I=this.j[h];return I&&D instanceof c&&(D.startSendingEvents(I.initialDimensions),delete this.j[h]),S}$acceptProcessAckDataEvent(h,D){this.g.get(h)?.acknowledgeDataEvent(D)}$acceptProcessInput(h,D){this.g.get(h)?.input(D)}$acceptTerminalInteraction(h){const D=this.getTerminalById(h);D?.setInteractedWith()&&this.M.fire(D.value)}$acceptTerminalSelection(h,D){this.getTerminalById(h)?.setSelection(D)}$acceptProcessResize(h,D,S){try{this.g.get(h)?.resize(D,S)}catch(I){if(I.code!=="EPIPE"&&I.code!=="ERR_IPC_CHANNEL_CLOSED")throw I}}$acceptProcessShutdown(h,D){this.g.get(h)?.shutdown(D)}$acceptProcessRequestInitialCwd(h){this.g.get(h)?.getInitialCwd().then(D=>this.a.$sendProcessProperty(h,{type:"initialCwd",value:D}))}$acceptProcessRequestCwd(h){this.g.get(h)?.getCwd().then(D=>this.a.$sendProcessProperty(h,{type:"cwd",value:D}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this.z.add(h),this.z.size===1&&this.a.$startLinkProvider(),new m.$aN(()=>{this.z.delete(h),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(h,D,S){if(this.C.has(D))throw new Error(`Terminal profile provider "${D}" already registered`);return this.C.set(D,S),this.a.$registerProfileProvider(D,h.identifier.value),new m.$aN(()=>{this.C.delete(D),this.a.$unregisterProfileProvider(D)})}registerTerminalQuickFixProvider(h,D,S){if(this.D.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this.D.set(h,S),this.a.$registerQuickFixProvider(h,D),new m.$aN(()=>{this.D.delete(h),this.a.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,D){const S=new l.$oe().token;if(S.isCancellationRequested)return;const I=this.D.get(h);if(!I)return;const P=await I.provideTerminalQuickFixes(D,S);if(P===null||Array.isArray(P)&&P.length===0)return;const W=new $.$Tc;if(this.w.value=W,!Array.isArray(P))return P?o.TerminalQuickFix.from(P,this.Q.converter,W):void 0;const V=[];for(const q of P){const N=o.TerminalQuickFix.from(q,this.Q.converter,W);N&&V.push(N)}return V}async $createContributedProfileTerminal(h,D){const S=new l.$oe().token;let I=await this.C.get(h)?.provideTerminalProfile(S);if(!S.isCancellationRequested){if(I&&!("options"in I)&&(I={options:I}),!I||!("options"in I))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in I.options){this.createExtensionTerminal(I.options,D);return}this.createTerminalFromOptions(I.options,D)}}async $provideLinks(h,D){const S=this.getTerminalById(h);if(!S)return[];this.F.delete(h),this.G.get(h)?.dispose(!0);const P=new l.$oe;this.G.set(h,P);const W=[],V={terminal:S.value,line:D},q=[];for(const K of this.z)q.push(r.Promises.withAsyncBody(async ie=>{P.token.onCancellationRequested(()=>ie({provider:K,links:[]}));const ce=await K.provideTerminalLinks(V,P.token)||[];P.token.isCancellationRequested||ie({provider:K,links:ce})}));const N=await Promise.all(q);if(P.token.isCancellationRequested)return[];const B=new Map;for(const K of N)K&&K.links.length>0&&W.push(...K.links.map(ie=>{const ce={id:u++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return B.set(ce.id,{provider:K.provider,link:ie}),ce}));return this.F.set(h,B),W}$activateLink(h,D){const S=this.F.get(h)?.get(D);S&&S.provider.handleTerminalLink(S.link)}U(h,D){this.y.stopBuffering(h),this.g.delete(h),delete this.j[h];const S=this.h[h];S&&(S.dispose(),delete this.h[h]),this.a.$sendProcessExit(h,D)}getTerminalById(h){return this.W(this.f,h)}getTerminalIdByApiObject(h){const D=this.f.findIndex(S=>S.value===h);return D>=0?D:null}W(h,D){const S=this.X(h,D);return S!==null?h[S]:null}X(h,D){const S=h.findIndex(I=>I._id===D);return S>=0?S:null}getEnvironmentVariableCollection(h){let D=this.n.get(h.identifier.value);return D||(D=new d,this.Z(h.identifier.value,D)),D.getScopedEnvironmentVariableCollection(void 0)}Y(h,D){const S=(0,k.$ls)(D.map),I=(0,k.$ms)(D.descriptionMap);this.a.$setEnvironmentVariableCollection(h,D.persistent,S.length===0?void 0:S,I)}$initEnvironmentVariableCollections(h){h.forEach(D=>{const S=D[0],I=new d(D[1]);this.Z(S,I)})}$acceptDefaultProfile(h,D){const S=this.s;this.s=h,this.u=D,S?.path!==h.path&&this.N.fire(h.path)}Z(h,D){this.n.set(h,D),D.onDidChangeCollection(()=>{this.Y(h,D)})}};e.$emc=t,e.$emc=t=Je([We(1,n.$VP),We(2,A.$zP)],t);class d{get persistent(){return this.b}set persistent(h){this.b=h,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(h){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new C.$de,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const D=this.h(h);let S=this.a.get(D);return S||(S=new a(this,h),this.a.set(D,S),S.onDidChangeCollection(()=>this.d.fire())),S}replace(h,D,S,I){this.f(h,{value:D,type:m.EnvironmentVariableMutatorType.Replace,options:S??{applyAtProcessCreation:!0},scope:I})}append(h,D,S,I){this.f(h,{value:D,type:m.EnvironmentVariableMutatorType.Append,options:S??{applyAtProcessCreation:!0},scope:I})}prepend(h,D,S,I){this.f(h,{value:D,type:m.EnvironmentVariableMutatorType.Prepend,options:S??{applyAtProcessCreation:!0},scope:I})}f(h,D){if(D.options&&D.options.applyAtProcessCreation===!1&&!D.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const S=this.g(h,D.scope),I=this.map.get(S),P=D.options?{applyAtProcessCreation:D.options.applyAtProcessCreation??!1,applyAtShellIntegration:D.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!I||I.value!==D.value||I.type!==D.type||I.options?.applyAtProcessCreation!==P.applyAtProcessCreation||I.options?.applyAtShellIntegration!==P.applyAtShellIntegration||I.scope?.workspaceFolder?.index!==D.scope?.workspaceFolder?.index){const W=this.g(h,D.scope),V={variable:h,...D,options:P};this.map.set(W,V),this.d.fire()}}get(h,D){const S=this.g(h,D),I=this.map.get(S);return I?v(I):void 0}g(h,D){const S=this.h(D);return S.length?`${h}:::${S}`:h}h(h){return this.j(h?.workspaceFolder)??""}j(h){return h?h.uri.toString():void 0}getVariableMap(h){const D=new Map;for(const[S,I]of this.map)this.h(I.scope)===this.h(h)&&D.set(I.variable,v(I));return D}delete(h,D){const S=this.g(h,D);this.map.delete(S),this.d.fire()}clear(h){if(h?.workspaceFolder){for(const[D,S]of this.map)S.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(D);this.k(h)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(h,D){const S=this.h(D),I=this.descriptionMap.get(S);if(!I||I.description!==h){let P;typeof h=="string"?P=h:P=h?.value.split(`

`)[0];const W={description:P,scope:D};this.descriptionMap.set(S,W),this.d.fire()}}getDescription(h){const D=this.h(h);return this.descriptionMap.get(D)?.description}k(h){const D=this.h(h);this.descriptionMap.delete(D)}}class a{get persistent(){return this.b.persistent}set persistent(h){this.b.persistent=h}get onDidChangeCollection(){return this.a&&this.a.event}constructor(h,D){this.b=h,this.d=D,this.a=new C.$de}getScoped(h){return this.b.getScopedEnvironmentVariableCollection(h)}replace(h,D,S){this.b.replace(h,D,S,this.d)}append(h,D,S){this.b.append(h,D,S,this.d)}prepend(h,D,S){this.b.prepend(h,D,S,this.d)}get(h){return this.b.get(h,this.d)}forEach(h,D){this.b.getVariableMap(this.d).forEach((S,I)=>h.call(D,I,S,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(h){this.b.delete(h,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(h){this.b.setDescription(h,this.d)}get description(){return this.b.getDescription(this.d)}}let g=class extends t{constructor(h,D){super(!1,h,D)}createTerminal(h,D,S){throw new T.$_}createTerminalFromOptions(h,D){throw new T.$_}};e.$fmc=g,e.$fmc=g=Je([We(0,n.$VP),We(1,A.$zP)],g);function b(y){if(!(!y||typeof y=="string"))return"id"in y?{id:y.id,color:y.color}:y}function p(y){return s.ThemeColor.isThemeColor(y)?y:void 0}function v(y){const h={...y};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}}),define(Se[116],Pe([1,0,7,6,3,4,17,53,5,2,11]),function(le,e,C,O,R,M,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=e.$jnc=void 0,e.$jnc=(0,R.$wi)("IExtHostTerminalShellIntegration");let k=class extends O.$Uc{constructor(r,o){super(),this.h=o,this.b=new Map,this.c=new m.$de,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new m.$de,this.onDidStartTerminalShellExecution=this.f.event,this.g=new m.$de,this.onDidEndTerminalShellExecution=this.g.event,this.a=r.getProxy(M.$$M.MainThreadTerminalShellIntegration),this.B((0,O.$Sc)(()=>{for(const[n,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(r){const o=this.h.getTerminalById(r);if(!o)return;const n=o.value;let i=this.b.get(r);i||(i=new l(o.value,this.f),this.b.set(r,i),i.store.add(o.onWillDispose(()=>this.b.get(r)?.dispose())),i.store.add(i.onDidRequestShellExecution(c=>this.a.$executeCommand(r,c))),i.store.add(i.onDidRequestEndExecution(c=>this.g.fire(c))),i.store.add(i.onDidRequestChangeShellIntegration(c=>this.c.fire(c))),o.shellIntegration=i.value),this.c.fire({terminal:n,shellIntegration:i.value})}$shellExecutionStart(r,o,n,i,c){this.b.has(r)||this.$shellIntegrationChange(r);const u={value:o,confidence:n,isTrusted:i};this.b.get(r)?.startShellExecution(u,c)}$shellExecutionEnd(r,o,n,i,c){const u={value:o,confidence:n,isTrusted:i};this.b.get(r)?.endShellExecution(u,c)}$shellExecutionData(r,o){this.b.get(r)?.emitData(o)}$cwdChange(r,o){this.b.get(r)?.setCwd((0,E.$vc)(o)?E.URI.revive(o):o)}$closeTerminal(r){this.b.get(r)?.dispose(),this.b.delete(r)}};e.$knc=k,e.$knc=k=Je([We(0,A.$zP),We(1,$.$cmc)],k);class l extends O.$Uc{get currentExecution(){return this.a}constructor(r,o){super(),this.j=r,this.m=o,this.b=!1,this.store=this.B(new O.$Tc),this.f=this.B(new m.$de),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new m.$de),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new m.$de),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(i,c){let u=i;c&&(u+=` "${c.map(a=>`${a.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(u);const t={value:u,confidence:C.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},d=n.startShellExecution(t,n.c,!0).value;return n.b=!0,d}}}startShellExecution(r,o,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new w(r,o);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(r){this.currentExecution?.emitData(r)}endShellExecution(r,o){this.a&&(this.a.endExecution(r),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:o}),this.a=void 0)}setCwd(r){let o=!1;E.URI.isUri(this.c)?o=!E.URI.isUri(r)||this.c.toString()!==r.toString():this.c!==r&&(o=!0),o&&(this.c=r,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class w{constructor(r,o){this.c=r,this.cwd=o,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return T.$Wh.EMPTY;this.a=new f}return this.a.createIterable()}emitData(r){this.a?.emitData(r)}endExecution(r){r&&(this.c=r),this.a?.endExecution(),this.a=void 0,this.b=!0}}class f extends O.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new T.$vh);const r=this.a;return new T.$Wh(async n=>{this.b.push(n),await r.wait()})}emitData(r){for(const o of this.b)o.emitOne(r)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Se[289],Pe([1,0,11,21,24,5,261,73,6,15,34,12,4,17,115,8,7,52,77,62]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$onc=e.$nnc=e.$mnc=e.$lnc=void 0;let c=class extends m.$Uc{constructor(P,W,V,q){super(),this.w=q,this.f=this.B(new M.$de),this.g=new Map,this.s=this.B(new M.$de),this.onResultsChanged=this.f.event,this.results=[],this.h=P.getProxy(l.$$M.MainThreadTesting),this.m=new y(this.h),this.j=new a(this.h,W),V.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const B=N,K=B.tests[B.tests.length-1].item.extId;return this.g.get(o.$WL.root(K))?.collection.tree.get(K)?.actual??(0,f.$LP)(N)}case 18:{const{test:B,message:K}=N,ie=B.item.extId;return{test:this.g.get(o.$WL.root(ie))?.collection.tree.get(ie)?.actual??(0,f.$LP)({$mid:16,tests:[B]}),message:s.TestMessage.to(K)}}default:return N}}}),V.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await V.executeCommand("_testing.getExplorerSelection"),B=K=>{const ie=this.g.get(o.$WL.root(K));if(ie)return o.$WL.isRoot(K)?ie.controller:ie.collection.tree.get(K)?.actual};return{include:N?.include.map(B).filter(E.$eg)||[],exclude:N?.exclude.map(B).filter(E.$eg)||[]}})}createTestController(P,W,V,q){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const N=new m.$Tc,B=N.add(new f.$OP(W,V,this.w));B.root.label=V;const K=new Map,ie=new Set,ce=this.h,ye={items:B.root.children,get label(){return V},set label(fe){V=fe,B.root.label=fe,ce.$updateController(W,{label:V})},get refreshHandler(){return q},set refreshHandler(fe){q=fe,ce.$updateController(W,{canRefresh:!!fe})},get id(){return W},createRunProfile:(fe,$e,Te,ae,Ne,ne)=>{let z=(0,$.$kj)(fe);for(;K.has(z);)z++;return new D(this.h,K,ie,this.s.event,W,z,fe,$e,Te,ae,Ne,ne)},createTestItem(fe,$e,Te){return new f.$MP(W,fe,$e,Te)},createTestRun:(fe,$e,Te=!0)=>this.j.createTestRun(W,B,fe,$e,Te),invalidateTestResults:fe=>{if(fe===void 0)this.h.$markTestRetired(void 0);else{const $e=fe instanceof Array?fe:[fe];this.h.$markTestRetired($e.map(Te=>o.$WL.fromExtHostTestItem(Te,W).toString()))}},set resolveHandler(fe){B.resolveHandler=fe},get resolveHandler(){return B.resolveHandler},dispose:()=>{N.dispose()}};ce.$registerTestController(W,V,!!q),N.add((0,m.$Sc)(()=>ce.$unregisterTestController(W)));const ke={controller:ye,collection:B,profiles:K,extension:P,activeProfiles:ie};return this.g.set(W,ke),N.add((0,m.$Sc)(()=>this.g.delete(W))),N.add(B.onDidGenerateDiff(fe=>ce.$publishDiff(W,fe.map(i.TestsDiffOp.serialize)))),ye}createTestObserver(){return this.m.checkout()}async runTests(P,W=R.CancellationToken.None){const V=g(P);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(V.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:P.preserveFocus??!0,targets:[{testIds:P.include?.map(N=>o.$WL.fromExtHostTestItem(N,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:S[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:P.exclude?.map(N=>N.id)},W)}$syncTests(){for(const{collection:P}of this.g.values())P.flushDiff();return Promise.resolve()}async $getCoverageDetails(P,W){return(await this.j.getCoverageDetails(P,W))?.map(s.TestCoverage.fromDetails)}async $disposeRun(P){this.j.disposeTestRun(P)}$configureRunProfile(P,W){this.g.get(P)?.profiles.get(W)?.configureHandler?.()}$setDefaultRunProfiles(P){const W=new Map;for(const[V,q]of Object.entries(P)){const N=this.g.get(V);if(!N)continue;const B=new Map,K=q.filter(ce=>!N.activeProfiles.has(ce)),ie=[...N.activeProfiles].filter(ce=>!q.includes(ce));for(const ce of K)B.set(ce,!0),N.activeProfiles.add(ce);for(const ce of ie)B.set(ce,!1),N.activeProfiles.delete(ce);B.size&&W.set(V,B)}this.s.fire(W)}async $refreshTests(P,W){await this.g.get(P)?.controller.refreshHandler?.(W)}$publishTestResults(P){this.results=Object.freeze(P.map(s.TestResults.to).concat(this.results).sort((W,V)=>V.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(P,W){const V=this.g.get(o.$WL.fromString(P).controllerId)?.collection;V&&(await V.expand(P,W<0?1/0:W),V.flushDiff())}$acceptDiff(P){this.m.applyDiff(P.map(W=>i.TestsDiffOp.deserialize({asCanonicalUri:V=>V},W)))}async $runControllerTests(P,W){return Promise.all(P.map(V=>this.y(V,!1,W)))}async $startContinuousRun(P,W){const V=new R.$oe(W),q=await Promise.all(P.map(N=>this.y(N,!0,V.token)));return!W.isCancellationRequested&&!q.some(N=>N.error)&&await new Promise(N=>W.onCancellationRequested(N)),V.dispose(!0),q}async y(P,W,V){const q=this.g.get(P.controllerId);if(!q)return{};const{collection:N,profiles:B}=q,K=B.get(P.profileId);if(!K)return{};const ie=P.testIds.map(fe=>N.tree.get(fe)).filter(E.$eg),ce=P.excludeExtIds.map(fe=>q.collection.tree.get(fe)).filter(E.$eg).filter(fe=>ie.some($e=>$e.fullId.compare(fe.fullId)===2));if(!ie.length)return{};const ye=new r.$NO(ie.some(fe=>fe.actual instanceof f.$NP)?void 0:ie.map(fe=>fe.actual),ce.map(fe=>fe.actual),K,W),ke=(0,i.$ZL)(P)&&this.j.prepareForMainThreadTestRun(ye,b.fromInternal(P,q.collection),K,V);try{return await K.runHandler(ye,V),{}}catch(fe){return{error:String(fe)}}finally{ke&&ke.hasRunningTasks&&!V.isCancellationRequested&&await M.Event.toPromise(ke.onEnd)}}$cancelExtensionTestRun(P){P===void 0?this.j.cancelAllRuns():this.j.cancelRunById(P)}};e.$lnc=c,e.$lnc=c=Je([We(0,w.$zP),We(1,k.$3j)],c);const u=1e4;var t;(function(I){I[I.Running=0]="Running",I[I.Cancelling=1]="Cancelling",I[I.Ended=2]="Ended"})(t||(t={}));class d extends m.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(P,W,V,q,N){super(),this.y=P,this.z=W,this.C=V,this.D=q,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new M.$de),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new R.$oe(N));const B=this.B(new C.$Ih(()=>this.F(),u));this.B(this.j.token.onCancellationRequested(()=>B.schedule()));const K=new M.$de;this.s=K.event,this.B((0,m.$Sc)(()=>{K.fire(),K.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(P,W){const[,V,q]=o.$WL.fromString(P).path,N=this.w.get(q);if(!N)return[];const B=this.g.get(V);if(!B)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(B.run,N,W)??[]}createRun(P){const W=this.y.id,V=this.y.controllerId,q=(0,T.$Sg)(),N=ce=>(ye,...ke)=>{if(K){this.C.warn(`Setting the state of test "${ye.id}" is a no-op after the run ends.`);return}this.y.isIncluded(ye)&&(this.H(ye),ce(ye,...ke))},B=(ce,ye)=>{const ke=ye instanceof Array?ye.map(s.TestMessage.from):[s.TestMessage.from(ye)];if(ce.uri&&ce.range){const fe={range:s.Range.from(ce.range),uri:ce.uri};for(const $e of ke)$e.location=$e.location||fe}this.z.$appendTestMessagesInRun(W,q,o.$WL.fromExtHostTestItem(ce,V).toString(),ke)};let K=!1;const ie={isPersisted:this.y.isPersisted,token:this.j.token,name:P,onDidDispose:this.s,addCoverage:ce=>{const ye=ce.uri.toString(),ke=new o.$WL([W,q,ye]).toString();this.w.set(ye,ce),this.z.$appendCoverage(W,q,s.TestCoverage.fromFile(ke,ce))},enqueued:N(ce=>{this.z.$updateTestStateInRun(W,q,o.$WL.fromExtHostTestItem(ce,V).toString(),1)}),skipped:N(ce=>{this.z.$updateTestStateInRun(W,q,o.$WL.fromExtHostTestItem(ce,V).toString(),5)}),started:N(ce=>{this.z.$updateTestStateInRun(W,q,o.$WL.fromExtHostTestItem(ce,V).toString(),2)}),errored:N((ce,ye,ke)=>{B(ce,ye),this.z.$updateTestStateInRun(W,q,o.$WL.fromExtHostTestItem(ce,V).toString(),6,ke)}),failed:N((ce,ye,ke)=>{B(ce,ye),this.z.$updateTestStateInRun(W,q,o.$WL.fromExtHostTestItem(ce,V).toString(),4,ke)}),passed:N((ce,ye)=>{this.z.$updateTestStateInRun(W,q,o.$WL.fromExtHostTestItem(ce,this.y.controllerId).toString(),3,ye)}),appendOutput:(ce,ye,ke)=>{K||(ke&&(this.y.isIncluded(ke)?this.H(ke):ke=void 0),this.z.$appendOutputToRun(W,q,O.$Fe.fromString(ce),ye&&s.location.from(ye),ke&&o.$WL.fromExtHostTestItem(ke,V).toString()))},end:()=>{K||(K=!0,this.z.$finishedTestRunTask(W,q),--this.f||this.G())}};return this.f++,this.g.set(q,{run:ie}),this.z.$startedTestRunTask(W,{id:q,name:P,running:!0}),ie}F(){for(const{run:P}of this.g.values())P.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(P){if(!(P instanceof f.$MP))throw new n.$rP(P.id);if(this.h.has(o.$WL.fromExtHostTestItem(P,this.y.controllerId).toString()))return;const W=[],V=this.y.colllection.root;for(;;){const q=s.TestItem.from(P);if(W.unshift(q),this.h.has(q.extId)||(this.h.add(q.extId),P===V))break;P=P.parent||V}this.z.$addTestsToRun(this.y.controllerId,this.y.id,W)}dispose(){this.G(),super.dispose()}}class a{get trackers(){return this.c.values()}constructor(P,W){this.g=P,this.h=W,this.c=new Map,this.f=new Map}getCoverageDetails(P,W){const V=o.$WL.root(P);return this.f.get(V)?.getCoverageDetails(P,W)||[]}disposeTestRun(P){this.f.get(P)?.dispose(),this.f.delete(P);for(const[W,{id:V}]of this.c)V===P&&this.c.delete(W)}prepareForMainThreadTestRun(P,W,V,q){return this.j(P,W,V,q)}cancelRunById(P){this.f.get(P)?.cancel()}cancelAllRuns(){for(const P of this.c.values())P.cancel()}createTestRun(P,W,V,q,N){const B=this.c.get(V);if(B)return B.createRun(q);const K=b.fromPublic(P,W,V,N),ie=g(V);this.g.$startedExtensionTestRun({controllerId:P,continuous:!!V.continuous,profile:ie&&{group:S[ie.kind],id:ie.profileId},exclude:V.exclude?.map(ye=>o.$WL.fromExtHostTestItem(ye,W.root.id).toString())??[],id:K.id,include:V.include?.map(ye=>o.$WL.fromExtHostTestItem(ye,W.root.id).toString())??[W.root.id],preserveFocus:V.preserveFocus??!0,persist:N});const ce=this.j(V,K,V.profile);return M.Event.once(ce.onEnd)(()=>{this.g.$finishedExtensionTestRun(K.id)}),ce.createRun(q)}j(P,W,V,q){const N=new d(W,this.g,this.h,V,q);return this.c.set(P,N),this.f.set(N.id,N),N}}e.$mnc=a;const g=I=>{if(I.profile){if(!(I.profile instanceof D))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return I.profile}};class b{static fromPublic(P,W,V,q){return new b(P,(0,T.$Sg)(),V.include?.map(N=>o.$WL.fromExtHostTestItem(N,P).toString())??[P],V.exclude?.map(N=>o.$WL.fromExtHostTestItem(N,P).toString())??[],q,W)}static fromInternal(P,W){return new b(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,W)}constructor(P,W,V,q,N,B){this.controllerId=P,this.id=W,this.isPersisted=N,this.colllection=B,this.c=V.map(K=>K+"\0"),this.f=q.map(K=>K+"\0")}isIncluded(P){const W=o.$WL.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const V of this.f)if(W===V||W.startsWith(V))return!1;for(const V of this.c)if(W===V||W.startsWith(V))return!0;return!1}}e.$nnc=b;class p{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(P){this.j=P,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(P){this.c.add(P)}update(P){Object.assign(P.revived,s.TestItem.toPlain(P.item)),this.c.has(P)||this.f.add(P)}remove(P){if(this.c.has(P)){this.c.delete(P);return}this.f.delete(P);const W=o.$WL.parentId(P.item.extId);if(W&&this.h.has(W.toString())){this.h.add(P.item.extId);return}this.g.add(P)}getChangeEvent(){const{c:P,f:W,g:V}=this;return{get added(){return[...P].map(q=>q.revived)},get updated(){return[...W].map(q=>q.revived)},get removed(){return[...V].map(q=>q.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class v extends i.$6L{constructor(){super(...arguments),this.s=new M.$de,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(P){return this.f.get(P)}getMirroredTestDataByReference(P){return this.f.get(P.id)}w(P,W){return{...P,revived:s.TestItem.toPlain(P.item),depth:W?W.depth+1:0,children:new Set}}v(){return new p(this.s)}}class y{constructor(P){this.f=P}checkout(){this.c||(this.c=this.g());const P=this.c;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(W=>W.revived)},dispose:(0,A.$db)(()=>{--P.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(P){return this.c?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.c?.tests.apply(P)}g(){const P=new v({asCanonicalUri:W=>W});return this.f.$subscribeToDiffs(),{observers:0,tests:P}}}const h=(I,P,W,V)=>{W?Object.assign(W,V):P.$updateTestRunConfig(I.controllerId,I.profileId,V)};class D{#e;#t;#i;#n;#s;get label(){return this.f}set label(P){P!==this.f&&(this.f=P,h(this,this.#e,this.#n,{label:P}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(P){P!==this.g&&(this.g=P,h(this,this.#e,this.#n,{supportsContinuousRun:P}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(P){P!==this.isDefault&&(P?this.#t.add(this.profileId):this.#t.delete(this.profileId),h(this,this.#e,this.#n,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,h(this,this.#e,this.#n,{tag:P?s.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this.c}set configureHandler(P){P!==this.c&&(this.c=P,h(this,this.#e,this.#n,{hasConfigurationHandler:!!P}))}get onDidChangeDefault(){return M.Event.chain(this.#i,P=>P.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(E.$eg))}constructor(P,W,V,q,N,B,K,ie,ce,ye=!1,ke=void 0,fe=!1){this.controllerId=N,this.profileId=B,this.f=K,this.kind=ie,this.runHandler=ce,this._tag=ke,this.g=fe,this.#e=P,this.#s=W,this.#t=V,this.#i=q,W.set(B,this);const $e=S[ie];if(typeof $e!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);ye&&V.add(B),this.#n={profileId:B,controllerId:N,tag:ke?s.TestTag.namespace(this.controllerId,ke.id):null,label:K,group:$e,isDefault:ye,hasConfigurationHandler:!1,supportsContinuousRun:fe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$onc=D;const S={[r.TestRunProfileKind.Coverage]:8,[r.TestRunProfileKind.Debug]:4,[r.TestRunProfileKind.Run]:2}}),define(Se[117],Pe([1,0,57,14,91,8,7]),function(le,e,C,O,R,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=e.$HP=e.$GP=void 0;class ${static{this.c=new R.$EP("TextEditorDecorationType")}constructor(l,w,f){const s=$.c.nextId();l.$registerTextEditorDecorationType(w.identifier,s,M.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:s,dispose(){l.$removeTextEditorDecorationType(s)}})}}e.$GP=$;class m{constructor(l,w){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=w.undoStopBefore,this.f=w.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,w){this.k();let f=null;if(l instanceof A.$bN)f=new A.$cN(l,l);else if(l instanceof A.$cN)f=l;else throw new Error("Unrecognized location");this.l(f,w,!1)}insert(l,w){this.k(),this.l(new A.$cN(l,l),w,!0)}delete(l){this.k();let w=null;if(l instanceof A.$cN)w=l;else throw new Error("Unrecognized location");this.l(w,null,!0)}l(l,w,f){const s=this.c.validateRange(l);this.g.push({range:s,text:w,forceMoveMarkers:f})}setEndOfLine(l){if(this.k(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=l}}class E{constructor(l,w,f,s){this.c=l,this.d=w,this._accept(f),this.e=s;const r=this;this.value={get tabSize(){return r.f},set tabSize(o){r.n(o)},get indentSize(){return r.g},set indentSize(o){r.p(o)},get insertSpaces(){return r.j},set insertSpaces(o){r.s(o)},get cursorStyle(){return r.k},set cursorStyle(o){r.t(o)},get lineNumbers(){return r.l},set lineNumbers(o){r.u(o)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=M.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const w=Math.floor(l);return w>0?w:null}if(typeof l=="string"){const w=parseInt(l,10);return isNaN(w)?null:w>0?w:null}return null}n(l){const w=this.m(l);if(w!==null){if(typeof w=="number"){if(this.f===w)return;this.f=w}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:w}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const w=Math.floor(l);return w>0?w:null}if(typeof l=="string"){const w=parseInt(l,10);return isNaN(w)?null:w>0?w:null}return null}p(l){const w=this.o(l);if(w!==null){if(typeof w=="number"){if(this.h===w)return;this.g=w,this.h=w}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:w}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const w=this.q(l);if(typeof w=="boolean"){if(this.j===w)return;this.j=w}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:w}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(l)})))}assign(l){const w={};let f=!1;if(typeof l.tabSize<"u"){const s=this.m(l.tabSize);s==="auto"?(f=!0,w.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,f=!0,w.tabSize=s)}if(typeof l.indentSize<"u"){const s=this.o(l.indentSize);s==="tabSize"?(f=!0,w.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,f=!0,w.indentSize=s)}if(typeof l.insertSpaces<"u"){const s=this.q(l.insertSpaces);s==="auto"?(f=!0,w.insertSpaces=s):this.j!==s&&(this.j=s,f=!0,w.insertSpaces=s)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,f=!0,w.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,f=!0,w.lineNumbers=M.TextEditorLineNumbersStyle.from(l.lineNumbers)),f&&this.v("setOptions",this.c.$trySetOptions(this.d,w))}v(l,w){w.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(f)})}}e.$HP=E;class T{constructor(l,w,f,s,r,o,n,i){this.id=l,this.j=w,this.k=f,this.g=!1,this.h=new Set,this.c=r,this.d=new E(this.j,this.id,o,f),this.e=n,this.f=i;const c=this;this.value=Object.freeze({get document(){return s.value},set document(u){throw new O.$9("document")},get selection(){return c.c&&c.c[0]},set selection(u){if(!(u instanceof A.$dN))throw(0,O.$7)("selection");c.c=[u],c.l()},get selections(){return c.c},set selections(u){if(!Array.isArray(u)||u.some(t=>!(t instanceof A.$dN)))throw(0,O.$7)("selections");c.c=u,c.l()},get visibleRanges(){return c.e},set visibleRanges(u){throw new O.$9("visibleRanges")},get options(){return c.d.value},set options(u){c.g||c.d.assign(u)},get viewColumn(){return c.f},set viewColumn(u){throw new O.$9("viewColumn")},edit(u,t={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new m(s.value,t);return u(d),c.m(d)},insertSnippet(u,t,d={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=c.c.map(g=>M.Range.from(g));else if(t instanceof A.$bN){const{lineNumber:g,column:b}=M.Position.from(t);a=[{startLineNumber:g,startColumn:b,endLineNumber:g,endColumn:b}]}else if(t instanceof A.$cN)a=[M.Range.from(t)];else{a=[];for(const g of t)if(g instanceof A.$cN)a.push(M.Range.from(g));else{const{lineNumber:b,column:p}=M.Position.from(g);a.push({startLineNumber:b,startColumn:p,endLineNumber:b,endColumn:p})}}return w.$tryInsertSnippet(l,s.value.version,u.value,a,d)},setDecorations(u,t){const d=t.length===0;d&&!c.h.has(u.key)||(d?c.h.delete(u.key):c.h.add(u.key),c.n(()=>{if(M.$wP(t))return w.$trySetDecorations(l,u.key,M.$xP(t));{const a=new Array(4*t.length);for(let g=0,b=t.length;g<b;g++){const p=t[g];a[4*g]=p.start.line+1,a[4*g+1]=p.start.character+1,a[4*g+2]=p.end.line+1,a[4*g+3]=p.end.character+1}return w.$trySetDecorationsFast(l,u.key,a)}}))},revealRange(u,t){c.n(()=>w.$tryRevealRange(l,M.Range.from(u),t||A.TextEditorRevealType.Default))},show(u){w.$tryShowEditor(l,M.ViewColumn.from(u))},hide(){w.$tryHideEditor(l)}})}dispose(){(0,C.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,C.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,C.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,C.ok)(!this.g),this.f=l}_acceptSelections(l){(0,C.ok)(!this.g),this.c=l}async l(){const l=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const w=l.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const f=w.edits.map(r=>r.range);f.sort((r,o)=>r.end.line===o.end.line?r.end.character===o.end.character?r.start.line===o.start.line?r.start.character-o.start.character:r.start.line-o.start.line:r.end.character-o.end.character:r.end.line-o.end.line);for(let r=0,o=f.length-1;r<o;r++){const n=f[r].end;if(f[r+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=w.edits.map(r=>({range:M.Range.from(r.range),text:r.text,forceMoveMarkers:r.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,w.documentVersionId,s,{setEndOfLine:typeof w.setEndOfLine=="number"?M.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this.k.warn(w),null))}}e.$IP=T}),define(Se[68],Pe([1,0,57,5,6,2,3,4,113,17,117,8,12,28,16,42,43]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KP=e.$JP=void 0;class o{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,u){this.h=c,this.i=u,this.a=null,this.b=new Map,this.c=new w.$Ac,this.d=new O.$de,this.e=new O.$de,this.f=new O.$de,this.g=new O.$de,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const u=[],t=[],d=[];if(c.removedDocuments)for(const a of c.removedDocuments){const g=M.URI.revive(a),b=this.c.get(g);b?.unref()&&(this.c.delete(g),u.push(b.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const g=M.URI.revive(a.uri);let b=this.c.get(g);if(b&&g.scheme!==f.Schemas.vscodeNotebookCell&&g.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${g} already exists!'`);b||(b=new o(new m.$CP(this.h.getProxy($.$$M.MainThreadDocuments),g,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this.c.set(g,b),t.push(b.value)),b.ref()}if(c.removedEditors)for(const a of c.removedEditors){const g=this.b.get(a);this.b.delete(a),g&&d.push(g)}if(c.addedEditors)for(const a of c.addedEditors){const g=M.URI.revive(a.documentUri);C.ok(this.c.has(g),`document '${g}' does not exist`),C.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const b=this.c.get(g).value,p=new T.$IP(a.id,this.h.getProxy($.$$M.MainThreadTextEditors),this.i,new r.$V(()=>b.document),a.selections.map(k.Selection.to),a.options,a.visibleRanges.map(v=>k.Range.to(v)),typeof a.editorPosition=="number"?k.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,p)}c.newActiveEditor!==void 0&&(C.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,R.$Pc)(u),(0,R.$Pc)(d),c.removedDocuments&&this.e.fire(u),c.addedDocuments&&this.d.fire(t),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return s.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const u=this.b.get(this.a);return c?u:u?.value}allEditors(){return[...this.b.values()]}};e.$JP=n,e.$JP=n=Je([We(0,E.$zP),We(1,l.$3j)],n),e.$KP=(0,A.$wi)("IExtHostDocumentsAndEditors")}),define(Se[290],Pe([1,0,18,5,4,117,8,7]),function(le,e,C,O,R,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=void 0;class m{constructor(T,k){this.i=k,this.a=new O.$de,this.b=new O.$de,this.c=new O.$de,this.d=new O.$de,this.f=new O.$de,this.g=new O.$de,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=T.getProxy(R.$$M.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(T){const k=this.i.allEditors();return T?k:k.map(l=>l.value)}async showTextDocument(T,k,l){let w;typeof k=="number"?w={position:A.ViewColumn.from(k),preserveFocus:l}:typeof k=="object"?w={position:A.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?A.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:w={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(T.uri,w),s=f&&this.i.getEditor(f);if(s)return s.value;throw f?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,k){return new M.$GP(this.h,T,k).value}$acceptEditorPropertiesChanged(T,k){const l=this.i.getEditor(T);if(!l)throw new Error("unknown text editor");if(k.options&&l._acceptOptions(k.options),k.selections){const w=k.selections.selections.map(A.Selection.to);l._acceptSelections(w)}if(k.visibleRanges){const w=C.$Hb(k.visibleRanges.map(A.Range.to));l._acceptVisibleRanges(w)}if(k.options&&this.b.fire({textEditor:l.value,options:{...k.options,lineNumbers:A.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const w=$.TextEditorSelectionChangeKind.fromValue(k.selections.source),f=k.selections.selections.map(A.Selection.to);this.a.fire({textEditor:l.value,selections:f,kind:w})}if(k.visibleRanges){const w=C.$Hb(k.visibleRanges.map(A.Range.to));this.c.fire({textEditor:l.value,visibleRanges:w})}}$acceptEditorPositionData(T){for(const k in T){const l=this.i.getEditor(k);if(!l)throw new Error("Unknown text editor");const w=A.ViewColumn.to(T[k]);l.value.viewColumn!==w&&(l._acceptViewColumn(w),this.d.fire({textEditor:l.value,viewColumn:w}))}}getDiffInformation(T){return Promise.resolve(this.h.$getDiffInformation(T))}}e.$Hlc=m}),define(Se[291],Pe([1,0,2,3,4,6,7,8,20,15]),function(le,e,C,O,R,M,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rnc=e.$qnc=void 0,e.$qnc=(0,O.$wi)("IExtHostTimeline");class T{constructor(w,f){this.b=new Map,this.c=new Map,this.a=w.getProxy(R.$$M.MainThreadTimeline),f.registerArgumentProcessor({processArgument:(s,r)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&m.$Rm.equals(r,this.b.get(s.source)?.extension)){const o=s.uri===void 0?void 0:C.URI.revive(s.uri);return this.c.get(s.source)?.get(k(o))?.get(s.handle)}else return;return s}})}async $getTimeline(w,f,s,r){return this.b.get(w)?.provider.provideTimeline(C.URI.revive(f),s,r)}registerTimelineProvider(w,f,s,r){const o=new M.$Tc,n=this.d(f.id,r,o).bind(this);let i;f.onDidChange&&(i=f.onDidChange(u=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...u,id:f.id}),this));const c=this.c;return this.f({...f,scheme:w,onDidChange:void 0,async provideTimeline(u,t,d){t?.resetCache&&(o.clear(),c.get(f.id)?.clear());const a=await f.provideTimeline(u,t,d);if(a==null)return;const g=n(u,t);return{...a,source:f.id,items:a.items.map(g)}},dispose(){for(const u of c.values())u.get(f.id)?.clear();i?.dispose(),o.dispose()}},s)}d(w,f,s){return(r,o)=>{let n;if(o?.cacheResults){let i=this.c.get(w);i===void 0&&(i=new Map,this.c.set(w,i));const c=k(r);n=i.get(c),n===void 0&&(n=new Map,i.set(c,n))}return i=>{const{iconPath:c,...u}=i,t=`${w}|${i.id??i.timestamp}`;n?.set(t,i);let d,a,g;i.iconPath&&(c instanceof A.$0N?g={id:c.id,color:c.color}:C.URI.isUri(c)?(d=c,a=c):{light:d,dark:a}=c);let b;return A.$CN.isMarkdownString(u.tooltip)?b=$.MarkdownString.from(u.tooltip):(0,E.$9f)(u.tooltip)?b=u.tooltip:A.$CN.isMarkdownString(u.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=$.MarkdownString.from(u.detail)):(0,E.$9f)(u.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=u.detail),{...u,id:u.id??void 0,handle:t,source:w,command:i.command?f.toInternal(i.command,s):void 0,icon:d,iconDark:a,themeIcon:g,tooltip:b,accessibilityInformation:i.accessibilityInformation}}}}f(w,f){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:f}),(0,M.$Sc)(()=>{for(const r of this.c.values())r.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$rnc=T;function k(l){return l?.toString()}}),define(Se[292],Pe([1,0,181,23,2,5,6,222,11,7,15,18,8,55,24,143,26]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=void 0;function o(c,u){if((0,T.$9f)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class n extends A.$Uc{constructor(u,t,d){super(),this.f=u,this.g=t,this.h=d,this.a=new Map,this.b=new s.$v$;function a(g){return g&&g.$treeViewId&&(g.$treeItemHandle||g.$selectedTreeItems||g.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:g=>a(g)?this.r(g):Array.isArray(g)&&g.length>0?g.map(b=>a(b)?this.r(b):b):g})}registerTreeDataProvider(u,t,d){const a=this.createTreeView(u,{treeDataProvider:t},d);return{dispose:()=>a.dispose()}}createTreeView(u,t,d){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=t.dragAndDropController?.dropMimeTypes??[],g=t.dragAndDropController?.dragMimeTypes??[],b=!!t.dragAndDropController?.handleDrag,p=!!t.dragAndDropController?.handleDrop,v=this.m(u,t,d),y={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:a,dragMimeTypes:g,hasHandleDrag:b,hasHandleDrop:p,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},h=this.f.$registerTreeViewDataProvider(u,y),D={get onDidCollapseElement(){return v.onDidCollapseElement},get onDidExpandElement(){return v.onDidExpandElement},get selection(){return v.selectedElements},get onDidChangeSelection(){return v.onDidChangeSelection},get activeItem(){return(0,r.$PG)(d,"treeViewActiveItem"),v.focusedElement},get onDidChangeActiveItem(){return(0,r.$PG)(d,"treeViewActiveItem"),v.onDidChangeActiveItem},get visible(){return v.visible},get onDidChangeVisibility(){return v.onDidChangeVisibility},get onDidChangeCheckboxState(){return v.onDidChangeCheckboxState},get message(){return v.message},set message(S){(0,w.$Vk)(S)&&(0,r.$PG)(d,"treeViewMarkdownMessage"),v.message=S},get title(){return v.title},set title(S){v.title=S},get description(){return v.description},set description(S){v.description=S},get badge(){return v.badge},set badge(S){S!==void 0&&E.ViewBadge.isViewBadge(S)?v.badge={value:Math.floor(Math.abs(S.value)),tooltip:S.tooltip}:S===void 0&&(v.badge=void 0)},reveal:(S,I)=>v.reveal(S,I),dispose:async()=>{await h,this.a.delete(u),v.dispose()}};return this.B(D),D}$getChildren(u,t){const d=this.a.get(u);return d?d.getChildren(t):Promise.reject(new $.$4F(u))}async $handleDrop(u,t,d,a,g,b,p,v){const y=this.a.get(u);if(!y)return Promise.reject(new $.$4F(u));const h=l.DataTransfer.toDataTransfer(d,async D=>(await this.f.$resolveDropFileData(u,t,D)).buffer);return p===u&&v&&await this.j(h,y,v,g,b),y.onDrop(h,a,g)}async j(u,t,d,a,g){const b=this.b.removeDragOperationTransfer(g);if(b)(await b)?.forEach((p,v)=>{p&&u.set(v,p)});else if(g&&t.handleDrag){const p=t.handleDrag(d,u,a);this.b.addDragOperationTransfer(g,p),await p}return u}async $handleDrag(u,t,d,a){const g=this.a.get(u);if(!g)return Promise.reject(new $.$4F(u));const b=await this.j(new E.$6N,g,t,a,d);if(!(!b||a.isCancellationRequested))return l.DataTransfer.from(b)}async $hasResolve(u){const t=this.a.get(u);if(!t)throw new $.$4F(u);return t.hasResolve}$resolve(u,t,d){const a=this.a.get(u);if(!a)throw new $.$4F(u);return a.resolveTreeItem(t,d)}$setExpanded(u,t,d){const a=this.a.get(u);if(!a)throw new $.$4F(u);a.setExpanded(t,d)}$setSelectionAndFocus(u,t,d){const a=this.a.get(u);if(!a)throw new $.$4F(u);a.setSelectionAndFocus(t,d)}$setVisible(u,t){const d=this.a.get(u);if(!d){if(!t)return;throw new $.$4F(u)}d.setVisible(t)}$changeCheckboxState(u,t){const d=this.a.get(u);if(!d)throw new $.$4F(u);d.setCheckboxState(t)}m(u,t,d){const a=this.B(new i(u,t,this.f,this.g.converter,this.h,d));return this.a.set(u,a),a}r(u){const t=this.a.get(u.$treeViewId);return t&&"$treeItemHandle"in u?t.getExtensionElement(u.$treeItemHandle):t&&"$focusedTreeItem"in u&&u.$focusedTreeItem?t.focusedElement:null}}e.$snc=n;class i extends A.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(u=>this.getExtensionElement(u)).filter(u=>!(0,T.$fg)(u))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(u,t,d,a,g,b){if(super(),this.I=u,this.J=d,this.L=a,this.M=g,this.N=b,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$de),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$de),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$de),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$de),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$de),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$de),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$de),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new f.$oe,b.contributes&&b.contributes.views)for(const h in b.contributes.views)for(const D of b.contributes.views[h])D.id===u&&(this.P=D.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(h=>{Array.isArray(h)&&h.length===0||this.F.fire({message:!1,element:h})}));let p,v;const y=M.Event.debounce(this.F.event,(h,D)=>(h||(h={message:!1,elements:[]}),D.element!==!1&&(p||(p=new Promise(S=>v=S),this.G=this.G.then(()=>p)),Array.isArray(D.element)?h.elements.push(...D.element):h.elements.push(D.element)),D.message&&(h.message=!0),h),200,!0);this.B(y(({message:h,elements:D})=>{D.length&&(this.H=this.H.then(()=>{const S=v;return p=null,this.$(D).then(()=>S())})),h&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(u){const t=u?this.getExtensionElement(u):void 0;if(u&&!t)return this.M.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let d=this.X(u);return d||(d=await this.Y(t)),d?d.map(a=>a.item):void 0}getExtensionElement(u){return this.j.get(u)}reveal(u,t){t=t||{select:!0,focus:!1};const d=(0,T.$fg)(t.select)?!0:t.select,a=(0,T.$fg)(t.focus)?!1:t.focus,g=(0,T.$fg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.G.then(()=>this.S(u)).then(b=>this.W(u,b[b.length-1]).then(p=>this.J.$reveal(this.I,{item:p.item,parentChain:b.map(v=>v.item)},{select:d,focus:a,expand:g})),b=>this.M.error(b)):this.J.$reveal(this.I,void 0,{select:d,focus:a,expand:g})}get message(){return this.O}set message(u){this.O=u,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(u){this.P=u,this.J.$setTitle(this.I,u,this.Q)}get description(){return this.Q}set description(u){this.Q=u,this.J.$setTitle(this.I,this.P,u)}get badge(){return this.R}set badge(u){this.R?.value===u?.value&&this.R?.tooltip===u?.tooltip||(this.R=l.ViewBadge.from(u),this.J.$setBadge(this.I,u))}setExpanded(u,t){const d=this.getExtensionElement(u);d&&(t?this.u.fire(Object.freeze({element:d})):this.w.fire(Object.freeze({element:d})))}setSelectionAndFocus(u,t){const d=!(0,k.$ub)(this.s,u);this.s=u;const a=this.t!==t;this.t=t,d&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(u){u!==this.r&&(this.r=u,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(u){const t=(await Promise.all(u.map(async d=>{const a=this.getExtensionElement(d.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:d.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);t.forEach(d=>{d.treeItem.checkboxState=d.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(d=>[d.extensionItem,d.newState])})}async handleDrag(u,t,d){const a=[];for(const g of u){const b=this.getExtensionElement(g);b&&a.push(b)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,t,d),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(u,t,d){const a=t?this.getExtensionElement(t):void 0;if(!(!a&&t||!this.g?.handleDrop))return(0,m.$oh)(()=>this.g?.handleDrop?this.g.handleDrop(a,u,d):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(u,t){if(!this.f.resolveTreeItem)return;const d=this.j.get(u);if(d){const a=this.m.get(d);if(a){const g=await this.f.resolveTreeItem(a.extensionItem,d,t)??a.extensionItem;return this.hb(g),a.item.tooltip=this.eb(g.tooltip),a.item.command=this.fb(a.disposableStore,g.command),a.item}}}S(u){return this.U(u).then(t=>t?this.S(t).then(d=>this.W(t,d[d.length-1]).then(a=>(d.push(a),d))):Promise.resolve([]))}U(u){const t=this.m.get(u);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,m.$oh)(()=>this.f.getParent(u))}W(u,t){const d=this.m.get(u);return d?Promise.resolve(d):(0,m.$oh)(()=>this.f.getTreeItem(u)).then(a=>this.kb(u,a,t,!0)).then(a=>this.getChildren(t?t.item.handle:void 0).then(()=>{const g=this.getExtensionElement(a);if(g){const b=this.m.get(g);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(u){if(u){let t;if(typeof u=="string"){const d=this.getExtensionElement(u);t=d?this.m.get(d):void 0}else t=u;return t&&t.children||void 0}return this.h}async Y(u){this.rb(u);const t=new f.$oe(this.Z.token);try{const d=u?this.m.get(u):void 0,a=await this.f.getChildren(u);if(t.token.isCancellationRequested)return;const g=(0,k.$Hb)(a||[]),b=await Promise.all((0,k.$Hb)(g).map(v=>this.f.getTreeItem(v)));if(t.token.isCancellationRequested)return;const p=b.map((v,y)=>v?this.db(g[y],v,d):null);return(0,k.$Hb)(p)}finally{t.dispose()}}$(u){if(u.some(d=>!d))return this.Z.dispose(!0),this.Z=new f.$oe,this.tb(),this.J.$refresh(this.I);{const d=this.ab(u);if(d.length)return this.bb(d)}return Promise.resolve(void 0)}ab(u){const t=new Set,d=u.map(g=>this.m.get(g));for(const g of d)if(g&&!t.has(g.item.handle)){let b=g;for(;b&&b.parent&&d.findIndex(p=>b&&b.parent&&p&&p.item.handle===b.parent.item.handle)===-1;){const p=this.j.get(b.parent.item.handle);b=p?this.m.get(p):void 0}b&&!b.parent&&t.add(g.item.handle)}const a=[];return t.forEach(g=>{const b=this.j.get(g);if(b){const p=this.m.get(b);p&&(!p.parent||!t.has(p.parent.item.handle))&&a.push(g)}}),a}bb(u){const t={};return Promise.all(u.map(d=>this.cb(d).then(a=>{a&&(t[d]=a.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(u){const t=this.getExtensionElement(u);if(t){const d=this.m.get(t);if(d)return this.rb(t),(0,m.$oh)(()=>this.f.getTreeItem(t)).then(a=>{if(a){const g=this.ib(t,a,d.parent);return this.pb(t,g,d,d.parent),d.dispose(),g}return null})}return Promise.resolve(null)}db(u,t,d){const a=this.ib(u,t,d);if(t.id&&this.j.has(a.item.handle))throw new Error((0,C.localize)(0,null,t.id));return this.ob(u,a),this.qb(a,d),a}eb(u){return E.$CN.isMarkdownString(u)?l.MarkdownString.from(u):u}fb(u,t){return t?{...this.L.toInternal(t,u),originalId:t.command}:void 0}gb(u){if(u.checkboxState===void 0)return;let t,d,a;return typeof u.checkboxState=="number"?t=u.checkboxState:(t=u.checkboxState.state,d=u.checkboxState.tooltip,a=u.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:d,accessibilityInformation:a}}hb(u){if(!E.$1N.isTreeItem(u,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(u,t,d){this.hb(t);const a=this.B(new A.$Tc),g=this.kb(u,t,d),b=this.lb(t);return{item:{handle:g,parentHandle:d?d.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(a,t.command),contextValue:t.contextValue,icon:b,iconDark:this.mb(t)||b,themeIcon:this.jb(t),collapsibleState:(0,T.$fg)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:d,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(u){return u.iconPath instanceof E.$0N?u.iconPath:void 0}kb(u,{id:t,label:d,resourceUri:a},g,b){if(t)return`${i.b}/${t}`;const p=o(d,this.N),v=g?g.item.handle:i.a;let y=p?p.label:a?(0,O.$7g)(a):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const h=this.m.has(u)?this.m.get(u).item.handle:void 0,D=this.X(g)||[];let S,I=0;do{if(S=`${v}/${I}:${y}`,b||!this.j.has(S)||h===S)break;I++}while(I<=D.length);return S}lb(u){if(u.iconPath&&!(u.iconPath instanceof E.$0N))return typeof u.iconPath=="string"||R.URI.isUri(u.iconPath)?this.nb(u.iconPath):this.nb(u.iconPath.light)}mb(u){if(u.iconPath&&!(u.iconPath instanceof E.$0N)&&u.iconPath.dark)return this.nb(u.iconPath.dark)}nb(u){return R.URI.isUri(u)?u:R.URI.file(u)}ob(u,t){this.j.set(t.item.handle,u),this.m.set(u,t)}pb(u,t,d,a){this.j.delete(t.item.handle),this.m.delete(u),t.item.handle!==d.item.handle&&this.j.delete(d.item.handle),this.ob(u,t);const g=this.X(a)||[],b=g.filter(p=>p.item.handle===d.item.handle)[0];b&&g.splice(g.indexOf(b),1,t)}qb(u,t){t?(t.children||(t.children=[]),t.children.push(u)):(this.h||(this.h=[]),this.h.push(u))}rb(u){if(u){const t=this.m.get(u);if(t){if(t.children)for(const d of t.children){const a=this.j.get(d.item.handle);a&&this.sb(a)}t.children=void 0}}else this.tb()}sb(u){const t=this.m.get(u);if(t){if(t.children)for(const d of t.children){const a=this.j.get(d.item.handle);a&&this.sb(a)}this.m.delete(u),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(u=>u.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[293],Pe([1,0,5,6,2,34,8,64,4,7]),function(le,e,C,O,R,M,A,$,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=void 0;class T extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(f,s,r,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new C.$de),this.onDidDispose=this.#d.event,this.#h=this.B(new C.$de),this.onDidChangeViewState=this.#h.event,this.#e=f,this.#t=s,this.#n=r,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(f){this.c(),this.#r!==f&&(this.#r=f,this.#t.$setTitle(this.#e,f))}get iconPath(){return this.c(),this.#a}set iconPath(f){this.c(),this.#a!==f&&(this.#a=f,this.#t.$setIconPath(this.#e,R.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(f){this.#l||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(this.#u=f.active,this.#c=f.visible,this.#o=f.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(f,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof f>"u"?void 0:A.ViewColumn.from(f),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class k extends O.$Uc{static c(){return(0,M.$Sg)()}constructor(f,s,r){super(),this.j=s,this.m=r,this.g=new Map,this.h=new Map,this.f=f.getProxy(m.$$M.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(f=>f.dispose()),this.g.clear()}createWebviewPanel(f,s,r,o,n={}){const i=typeof o=="object"?o.viewColumn:o,c={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof o=="object"&&!!o.preserveFocus},u=(0,$.$Wlc)(f),t=k.c();this.f.$createWebviewPanel((0,$.$Ylc)(f),t,s,{title:r,panelOptions:l(n),webviewOptions:(0,$.$Zlc)(f,this.m,n),serializeBuffersForPostMessage:u},c);const d=this.j.createNewWebview(t,n,f);return this.createNewWebviewPanel(t,s,r,i,n,d,!0)}$onDidChangeWebviewPanelViewStates(f){const s=Object.keys(f);s.sort((r,o)=>{const n=f[r],i=f[o];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const r of s){const o=this.getWebviewPanel(r);if(!o)continue;const n=f[r];o._updateViewState({active:n.active,visible:n.visible,viewColumn:A.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this.g.delete(f),this.j.deleteWebview(f)}registerWebviewPanelSerializer(f,s,r){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:r,extension:f}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,$.$Wlc)(f)}),new E.$aN(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel(f,s,r,o){const n=this.h.get(s);if(!n)throw new Error(`No serializer found for '${s}'`);const{serializer:i,extension:c}=n,u=this.j.createNewWebview(f,r.webviewOptions,c),t=this.createNewWebviewPanel(f,s,r.title,o,r.panelOptions,u,r.active);await i.deserializeWebviewPanel(t,r.state)}createNewWebviewPanel(f,s,r,o,n,i,c){const u=new T(f,this.f,i,{viewType:s,title:r,viewColumn:o,panelOptions:n,active:c});return this.g.set(f,u),u}getWebviewPanel(f){return this.g.get(f)}}e.$1lc=k;function l(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}}),define(Se[294],Pe([1,0,5,6,64,8,4,7]),function(le,e,C,O,R,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vnc=void 0;class m extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(k,l,w,f,s,r){super(),this.#s=!1,this.#u=this.B(new C.$de),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new C.$de),this.onDidDispose=this.#l.event,this.#i=w,this.#a=f,this.#e=k,this.#t=l,this.#n=s,this.#r=r}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(k){this.a(),this.#a!==k&&(this.#a=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#o}set description(k){this.a(),this.#o!==k&&(this.#o=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(k){k===this.#r||this.#s||(this.#r=k,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(k){this.a(),!(k?.value===this.#c?.value&&k?.tooltip===this.#c?.tooltip)&&(this.#c=M.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(k,l){this.d=l,this.b=new Map,this.c=new Map,this.a=k.getProxy(A.$$M.MainThreadWebviewViews)}registerWebviewViewProvider(k,l,w,f){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:w,extension:k}),this.a.$registerWebviewViewProvider((0,R.$Ylc)(k),l,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,R.$Wlc)(k)}),new $.$aN(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(k,l,w,f,s){const r=this.b.get(l);if(!r)throw new Error(`No view provider found for '${l}'`);const{provider:o,extension:n}=r,i=this.d.createNewWebview(k,{},n),c=new m(k,this.a,l,w,i,!0);this.c.set(k,c),await o.resolveWebviewView(c,{state:f},s)}async $onDidChangeWebviewViewVisibility(k,l){this.e(k)._setVisible(l)}async $disposeWebviewView(k){const l=this.e(k);this.c.delete(k),l.dispose(),this.d.deleteWebview(k)}e(k){const l=this.c.get(k);if(!l)throw new Error("No webview found");return l}}e.$vnc=E}),define(Se[295],Pe([1,0,5,29,31,3]),function(le,e,C,O,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=e.$tM=e.OutputChannelUpdateMode=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=void 0,e.$gM="text/x-code-output",e.$hM="output",e.$iM="Log",e.$jM="text/x-code-log-output",e.$kM="log",e.$lM="workbench.panel.output",e.$mM=new R.$Nj("inOutput",!1),e.$nM=new R.$Nj("activeLogOutput",!1),e.$oM=new R.$Nj("activeLogOutput.levelSettable",!1),e.$pM=new R.$Nj("activeLogOutput.level",""),e.$qM=new R.$Nj("activeLogOutput.levelIsDefault",!1),e.$rM=new R.$Nj("outputView.scrollLock",!1),e.$sM=(0,M.$wi)("outputService");var A;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$tM={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new C.$de,this.onDidRegisterChannel=this.b.event,this.c=new C.$de,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(T=>E.push(T)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}O.$co.add(e.$tM.OutputChannels,new $),e.$uM=new R.$Nj("activeOutputChannel","")}),define(Se[118],Pe([1,0,4,3,17,20,12,295,65,27,46,147,21,15,38,5,6]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8mc=e.$7mc=void 0;class o extends A.$9j{get disposed(){return this.n}constructor(u,t,d,a,g){super(),this.id=u,this.name=t,this.r=d,this.s=a,this.extension=g,this.m=0,this.n=!1,this.visible=!1,this.setLevel(d.getLevel()),this.B(d.onDidChangeLogLevel(b=>this.setLevel(b)))}get logLevel(){return this.getLevel()}appendLine(u){this.append(u+`
`)}append(u){this.info(u)}clear(){const u=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,u)}replace(u){const t=this.m;this.info(u),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(u,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof u=="boolean"?u:t))}hide(){this.s.$close(this.id)}g(u,t){this.m+=l.$Fe.fromString(t).byteLength,(0,A.log)(this.r,u,t),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends o{appendLine(u){this.append(u)}}let i=class{constructor(u,t,d,a,g,b){this.i=t,this.j=d,this.k=a,this.l=g,this.m=b,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=u.getProxy(C.$$M.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,k.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.h=u;for(const[t,d]of this.g)d.visible=t===this.h}createOutputChannel(u,t,d){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");const a=typeof t=="object"&&t.log,g=(0,w.$9f)(t)?t:void 0;if((0,w.$9f)(g)&&!g.trim())throw new Error("illegal argument `languageId`. must not be empty");let b;const p=this.i.environment.extensionLogLevel?.find(([y])=>M.$Rm.equals(d.identifier,y))?.[1];p&&(b=(0,A.$hk)(p));const v=a?this.o(u,b,d):this.n(u,g,d);return v.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),a?this.r(u,b??this.m.getLevel(),v):this.q(u,v)}async n(u,t,d){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,g=this.k.extUri.joinPath(a,`${this.f++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),b=this.l.createLogger(g,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),p=await this.a.$register(u,g,t,d.identifier.value);return new o(p,u,b,this.a,d)}async o(u,t,d){const a=await this.p(d),g=u.replace(/[\\/:\*\?"<>\|]/g,""),b=this.k.extUri.joinPath(a,`${g}.log`),p=`${d.identifier.value}.${g}`,v=this.l.createLogger(b,{id:p,name:u,logLevel:t,extensionId:d.identifier.value});return new n(p,u,v,this.a,d)}p(u){let t=this.d.get(u.identifier.value);if(!t){const d=this.k.extUri.joinPath(this.i.logsLocation,u.identifier.value);this.d.set(u.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(d)}catch(a){if((0,f.$gl)(a)!==f.FileSystemProviderErrorCode.FileExists)throw a}return d})())}return t}q(u,t){let d=!1;const a=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return u},append(g){a(),t.then(b=>b.append(g))},appendLine(g){a(),t.then(b=>b.appendLine(g))},clear(){a(),t.then(g=>g.clear())},replace(g){a(),t.then(b=>b.replace(g))},show(g,b){a(),t.then(p=>p.show(g,b))},hide(){a(),t.then(g=>g.hide())},dispose(){d=!0,t.then(g=>g.dispose())}}}r(u,t,d){const a=new r.$Tc,g=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},b=a.add(new s.$de);function p(v){t=v,b.fire(v)}return d.then(v=>{a.add(v),v.logLevel!==t&&p(v.logLevel),a.add(v.onDidChangeLogLevel(y=>p(y)))}),{...this.q(u,d),get logLevel(){return t},onDidChangeLogLevel:b.event,trace(v,...y){g(),d.then(h=>h.trace(v,...y))},debug(v,...y){g(),d.then(h=>h.debug(v,...y))},info(v,...y){g(),d.then(h=>h.info(v,...y))},warn(v,...y){g(),d.then(h=>h.warn(v,...y))},error(v,...y){g(),d.then(h=>h.error(v,...y))},dispose(){a.dispose()}}}};e.$7mc=i,e.$7mc=i=Je([We(0,R.$zP),We(1,E.$PP),We(2,m.$Slc),We(3,T.$vlc),We(4,A.$4j),We(5,A.$3j)],i),e.$8mc=(0,O.$wi)("IExtHostOutputService")}),define(Se[119],Pe([1,0,3,11]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=void 0,e.$gn=(0,C.$wi)("remoteAgentService"),e.$hn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(R){let M=1/0;for(let $=0;$<this.maxSampleCount;$++){const m=await R.getRoundTripTime();if(m===void 0)return;M=Math.min(M,m/2),await(0,O.$xh)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(M):A=this.initial.reduce(($,m)=>$+m,0)/this.initial.length,this.lastMeasurement={initial:A,current:M,average:this.average.reduce(($,m)=>$+m,0)/this.average.length,high:typeof A>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Se[296],Pe([1,0,184,51,29,45,50,6,5,119,22,25,11]),function(le,e,C,O,R,M,A,$,m,E,T,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=void 0,e.$KJ=Object.freeze({id:"application",order:100,title:(0,C.localize)(0,null),type:"object"}),e.$LJ=Object.freeze({id:"workbench",order:7,title:(0,C.localize)(1,null),type:"object"}),e.$MJ=Object.freeze({id:"security",scope:1,title:(0,C.localize)(2,null),type:"object",order:7}),e.$NJ=Object.freeze({id:"problems",title:(0,C.localize)(3,null),type:"object",order:101}),e.$OJ={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new m.$de,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const f=new w;R.$co.add(e.$OJ.ConfigurationMigration,f);let s=class extends $.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const u of c.added)await this.f(u,f.migrations)})),this.c(f.migrations),this.B(f.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(c=>this.g(c,n?.uri))])}async g(n,i){const c=this.a.inspect(n.key,{resource:i}),u=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,d]of u){const a=c[t];if(!a)continue;const g=[];if(a.value!==void 0){const b=await this.h(n,t,a.value,i,void 0);for(const p of b??[])g.push([p,[]])}for(const{identifiers:b,value:p}of a.overrides??[])if(p!==void 0){const v=await this.h(n,t,p,i,b);for(const y of v??[])g.push([y,b])}g.length&&await Promise.allSettled(g.map(async([[b,p],v])=>this.a.updateValue(b,p.value,{resource:i,overrideIdentifiers:v},d)))}}async h(n,i,c,u,t){const d=g=>{const p=this.a.inspect(g,{resource:u})[i];if(p)return t?p.overrides?.find(({identifiers:v})=>(0,k.$7n)(v,t))?.value:p.value},a=await n.migrateFn(c,d);return Array.isArray(a)?a:[[n.key,a]]}};e.$PJ=s,e.$PJ=s=Je([We(0,A.$3i),We(1,M.$Fi)],s);let r=class extends $.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new l.$Th,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!T.$i&&(await this.b.getEnvironment())?.os!==1)return;R.$co.as(O.$ho.Configuration).registerConfiguration({...e.$MJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,C.localize)(4,null)},default:[],markdownDescription:(0,C.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,C.localize)(6,null),scope:2}}})}};e.$QJ=r,e.$QJ=r=Je([We(0,E.$gn)],r)}),define(Se[297],Pe([1,0,37,16,19,23,193,296,51,3,29]),function(le,e,C,O,R,M,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$hhb=e.$ghb=void 0,e.$ihb=s,e.$jhb=r,e.$ghb=(0,E.$wi)("editorResolverService"),e.$hhb="workbench.editorAssociations";const k=T.$co.as(m.$ho.Configuration),l={...$.$LJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};k.registerConfiguration(l);var w;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(w||(e.RegisteredEditorPriority=w={}));var f;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(f||(e.ResolvedStatus=f={}));function s(o){switch(o){case w.exclusive:return 5;case w.default:return 4;case w.builtin:return 3;case w.option:default:return 1}}function r(o,n){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(n.scheme))return!1;const u=typeof o=="string"&&o.indexOf(R.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,M.$7g)(n);return C.$pk(typeof o=="string"?o.toLowerCase():o,u.toLowerCase())}}),define(Se[298],Pe([1,0,48,16,19,22,23,2,3,214,45,236,119]),function(le,e,C,O,R,M,A,$,m,E,T,k,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=void 0,e.$MM=(0,m.$wi)("pathService");let f=w=class{constructor(r,o,n,i){this.d=r,this.e=o,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??r})()}hasValidBasename(r,o,n){return typeof o=="string"||typeof o>"u"?this.a.then(i=>this.h(r,i,o)):this.h(r,o,n)}h(r,o,n){return r.scheme===O.Schemas.file||r.scheme===O.Schemas.vscodeRemote?(0,C.$tg)(n??(0,A.$7g)(r),o===1):!0}get defaultUriScheme(){return w.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(r,o){if(r.remoteAuthority)return O.Schemas.vscodeRemote;const n=(0,E.$JM)(o.getWorkspace());if(n)return n;const i=o.getWorkspace().folders[0];if(i)return i.uri.scheme;const c=o.getWorkspace().configuration;return c?c.scheme:O.Schemas.file}userHome(r){return r?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(r=>r===1?R.$fc:R.$gc)}async fileURI(r){let o="";if(await this.a===1&&(r=r.replace(/\\/g,"/")),r[0]==="/"&&r[1]==="/"){const i=r.indexOf("/",2);i===-1?(o=r.substring(2),r="/"):(o=r.substring(2,i),r=r.substring(i)||"/")}return $.URI.from({scheme:O.Schemas.file,authority:o,path:r,query:"",fragment:""})}};e.$NM=f,e.$NM=f=w=Je([We(1,l.$gn),We(2,k.$vM),We(3,T.$Fi)],f)}),define(Se[120],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$fL=e.$eL=void 0;class C{constructor(A,$){this.line=A,this.character=$}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,$){return new C(0,0)}with(A){return new C(0,0)}}e.$eL=C;class O{constructor(A,$,m,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(A,$),this.end=new C(m,E)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new O(0,0,0,0)}with(A){return new O(0,0,0,0)}}e.$fL=O;var R;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(R||(e.TextSearchCompleteMessageType=R={}))}),define(Se[47],Pe([1,0,18,37,25,48,13,3,19,14,120,11]),function(le,e,C,O,R,M,A,$,m,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.$CL=e.$vL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$sL=e.$rL=e.$qL=e.$pL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.TextSearchCompleteMessageType=void 0,e.$mL=o,e.$nL=n,e.$oL=i,e.$tL=v,e.$uL=y,e.$wL=S,e.$xL=I,e.$yL=P,e.$zL=W,e.$AL=V,e.$BL=q,e.$DL=B,e.$FL=ce,e.$GL=ye,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.$gL="workbench.view.search",e.$hL="workbench.panel.search",e.$iL="workbench.view.search",e.$jL="search-result",e.$kL="search.exclude";const l="\u27EA ",w=" characters skipped \u27EB",f=(l.length+w.length+5)*2;e.$lL=(0,$.$wi)("searchService");var s;(function(fe){fe[fe.file=0]="file",fe[fe.text=1]="text",fe[fe.aiText=2]="aiText"})(s||(e.SearchProviderType=s={}));var r;(function(fe){fe[fe.File=1]="File",fe[fe.Text=2]="Text",fe[fe.aiText=3]="aiText"})(r||(e.QueryType=r={}));function o(fe){return!!fe.preview}function n(fe){return!!fe.resource}function i(fe){return!!fe.message}var c;(function(fe){fe[fe.Normal=0]="Normal",fe[fe.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class u{constructor($e){this.resource=$e,this.results=[]}}e.$pL=u;class t{constructor($e,Te,ae,Ne){this.ranges=Te,this.webviewIndex=Ne;const ne=Array.isArray(Te)?Te:[Te];if(ae&&ae.matchLines===1&&d(ne)){$e=(0,A.$2f)($e,ae.matchLines);let z="",x=0,be=0;const Fe=Math.floor(ae.charsPerLine/5),De=[];for(const pe of ne){const ge=Math.max(pe.startColumn-Fe,0),Q=pe.startColumn+ae.charsPerLine;if(ge>be+Fe+f){const Y=l+(ge-be)+w;z+=Y+$e.slice(ge,Q),x+=ge-(be+Y.length)}else z+=$e.slice(be,Q);De.push(new g(0,pe.startColumn-x,pe.endColumn-x)),be=Q}this.preview={text:z,matches:Array.isArray(this.ranges)?De:De[0]}}else{const z=Array.isArray(Te)?Te[0].startLineNumber:Te.startLineNumber;this.preview={text:$e,matches:(0,C.$1b)(Te,x=>new a(x.startLineNumber-z,x.startColumn,x.endLineNumber-z,x.endColumn))}}}}e.$qL=t;function d(fe){const $e=fe[0].startLineNumber;for(const Te of fe)if(Te.startLineNumber!==$e||Te.endLineNumber!==$e)return!1;return!0}class a{constructor($e,Te,ae,Ne){this.startLineNumber=$e,this.startColumn=Te,this.endLineNumber=ae,this.endColumn=Ne}}e.$rL=a;class g extends a{constructor($e,Te,ae){super($e,Te,$e,ae)}}e.$sL=g;var b;(function(fe){fe.List="list",fe.Tree="tree"})(b||(e.ViewMode=b={}));var p;(function(fe){fe.Default="default",fe.FileNames="fileNames",fe.Type="type",fe.Modified="modified",fe.CountDescending="countDescending",fe.CountAscending="countAscending"})(p||(e.SearchSortOrder=p={}));function v(fe,$e=!0){const Te=fe&&fe.files&&fe.files.exclude,ae=$e&&fe&&fe.search&&fe.search.exclude;if(!Te&&!ae)return;if(!Te||!ae)return Te||ae;let Ne=Object.create(null);return Ne=R.$6n(Ne,R.$3n(Te)),Ne=R.$6n(Ne,R.$3n(ae),!0),Ne}function y(fe,$e){return fe.excludePattern&&O.$pk(fe.excludePattern,$e)?!1:fe.includePattern||fe.usingSearchPaths?fe.includePattern&&O.$pk(fe.includePattern,$e)?!0:fe.usingSearchPaths?!!fe.folderQueries&&fe.folderQueries.some(Te=>{const ae=Te.folder.fsPath;if(M.$vg($e,ae)){const Ne=m.$lc(ae,$e);return!Te.includePattern||!!O.$pk(Te.includePattern,Ne)}else return!1}):!1:!0}var h;(function(fe){fe[fe.unknownEncoding=1]="unknownEncoding",fe[fe.regexParseError=2]="regexParseError",fe[fe.globParseError=3]="globParseError",fe[fe.invalidLiteral=4]="invalidLiteral",fe[fe.rgProcessError=5]="rgProcessError",fe[fe.other=6]="other",fe[fe.canceled=7]="canceled"})(h||(e.SearchErrorCode=h={}));class D extends Error{constructor($e,Te){super($e),this.code=Te}}e.$vL=D;function S(fe){const $e=fe.message;if((0,E.$4)(fe))return new D($e,h.canceled);try{const Te=JSON.parse($e);return new D(Te.message,Te.code)}catch{return new D($e,h.other)}}function I(fe){const $e={message:fe.message,code:fe.code};return new Error(JSON.stringify($e))}function P(fe){return fe.type==="error"?!0:fe.type==="success"}function W(fe){return fe.type==="success"}function V(fe){return!!fe.path}function q(fe,$e,Te=!0){const ae=fe.searchPath?fe.searchPath:fe.relativePath;return Te?(0,A.$Yf)(ae,$e):O.$pk($e,ae)}class N{constructor($e){this.path=$e,this.results=[]}addMatch($e){this.results.push($e)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$CL=N;function B(fe,$e){const Te={...fe||{},...$e||{}};return Object.keys(Te).filter(ae=>{const Ne=Te[ae];return typeof Ne=="boolean"&&Ne})}class K{constructor($e,Te){this.c=null,this.a={...$e.excludePattern||{},...Te.excludePattern||{}},this.b=O.$qk(this.a);let ae=$e.includePattern;Te.includePattern&&(ae?ae={...ae,...Te.includePattern}:ae=Te.includePattern),ae&&(this.c=O.$qk(ae))}matchesExcludesSync($e,Te,ae){return!!(this.b&&this.b($e,Te,ae))}includedInQuerySync($e,Te,ae){return!(this.b&&this.b($e,Te,ae)||this.c&&!this.c($e,Te,ae))}includedInQuery($e,Te,ae){const Ne=this.b($e,Te,ae),ne=()=>this.c?!!this.c($e,Te,ae):!0;return(0,k.$ih)(Ne)?Ne.then(z=>z?!1:ne()):ne()}hasSiblingExcludeClauses(){return ie(this.a)}}e.$EL=K;function ie(fe){for(const $e in fe)if(typeof fe[$e]!="boolean")return!0;return!1}function ce(fe){if(!fe)return;let $e;return Te=>($e||($e=(fe()||Promise.resolve([])).then(ae=>ae?ke(ae):{})),$e.then(ae=>!!ae[Te]))}function ye(fe){if(!fe)return;let $e;return Te=>{if(!$e){const ae=fe();$e=ae?ke(ae):{}}return!!$e[Te]}}function ke(fe){const $e={};for(const Te of fe)$e[Te]=!0;return $e}}),define(Se[39],Pe([1,0,18,11,24,5,6,54,16,129,23,13,2,183,3,12,202,45,46,27,17,8,7,61,47,4,49]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r,o,n,i,c,u,t,d,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=e.$Mlc=void 0;function p(W,V,q){return new T.$Yg(N=>D(N,q)).isEqual(W,V)}function v(W,V,q){return p(W.uri,V.uri,q)?0:(0,k.$qf)(W.uri.toString(),V.uri.toString())}function y(W,V,q){return W.index!==V.index?W.index<V.index?-1:1:p(W.uri,V.uri,q)?(0,k.$qf)(W.name,V.name):(0,k.$qf)(W.uri.toString(),V.uri.toString())}function h(W,V,q,N){const B=W.slice(0).sort((ie,ce)=>q(ie,ce,N)),K=V.slice(0).sort((ie,ce)=>q(ie,ce,N));return(0,C.$Eb)(B,K,(ie,ce)=>q(ie,ce,N))}function D(W,V){const q=V.getCapabilities(W.scheme);return!(q&&q&1024)}class S extends o.$Pi{static toExtHostWorkspace(V,q,N,B){if(!V)return{workspace:null,added:[],removed:[]};const{id:K,name:ie,folders:ce,configuration:ye,transient:ke,isUntitled:fe}=V,$e=[],Te=q;q?ce.forEach((z,x)=>{const be=l.URI.revive(z.uri),Fe=S.o(N||q,be,B);Fe?(Fe.name=z.name,Fe.index=z.index,$e.push(Fe)):$e.push({uri:be,name:z.name,index:x})}):$e.push(...ce.map(({uri:z,name:x,index:be})=>({uri:l.URI.revive(z),name:x,index:be}))),$e.sort((z,x)=>z.index<x.index?-1:1);const ae=new S(K,ie,$e,!!ke,ye?l.URI.revive(ye):null,!!fe,z=>D(z,B)),{added:Ne,removed:ne}=h(Te?Te.workspaceFolders:[],ae.workspaceFolders,v,B);return{workspace:ae,added:Ne,removed:ne}}static o(V,q,N){for(let B=0;B<V.folders.length;B++){const K=V.workspaceFolders[B];if(p(K.uri,q,N))return K}}constructor(V,q,N,B,K,ie,ce){super(V,N.map(ye=>new o.$Qi(ye)),B,K,ce),this.t=q,this.u=ie,this.q=[],this.s=$.$Ci.forUris(ce),N.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,q){return q&&this.s.get(V)&&(V=(0,T.$9g)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let I=class{constructor(V,q,N,B,K){this.c=new M.$de,this.onDidChangeWorkspace=this.c.event,this.g=new M.$de,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new M.$fe,this.C=new Map,this.h=B,this.s=N,this.t=K,this.j=new E.$Dm,this.k=new O.$vh,this.o=V.getProxy(g.$$M.MainThreadWorkspace),this.q=V.getProxy(g.$$M.MainThreadMessageService);const ie=q.workspace;this.l=ie?new S(ie.id,ie.name,[],!!ie.transient,ie.configuration?l.URI.revive(ie.configuration):null,!!ie.isUntitled,ce=>D(ce,N)):void 0}$initializeWorkspace(V,q){this.v=q,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:m.Schemas.untitled,path:(0,T.$7g)((0,T.$9g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,q,N,...B){const K=[];if(Array.isArray(B)&&B.forEach(fe=>{l.URI.isUri(fe.uri)&&!K.some($e=>p($e.uri,fe.uri,this.s))&&K.push({uri:fe.uri,name:fe.name||(0,T.$6g)(fe.uri)})}),this.n||[q,N].some(fe=>typeof fe!="number"||fe<0)||N===0&&K.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(q+N>ie.length)return!1;const ce=ie.slice(0);ce.splice(q,N,...K.map(fe=>({uri:fe.uri,name:fe.name||(0,T.$6g)(fe.uri),index:void 0})));for(let fe=0;fe<ce.length;fe++){const $e=ce[fe];if(ce.some((Te,ae)=>ae!==fe&&p($e.uri,Te.uri,this.s)))return!1}ce.forEach((fe,$e)=>fe.index=$e);const{added:ye,removed:ke}=h(ie,ce,y,this.s);if(ye.length===0&&ke.length===0)return!1;if(this.o){const fe=V.displayName||V.name;this.o.$updateWorkspaceFolders(fe,q,N,K).then(void 0,$e=>{this.n=void 0;const Te={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(r.Severity.Error,(0,w.localize)(0,null,fe,$e.toString()),Te,[])})}return this.y(ce),!0}getWorkspaceFolder(V,q){if(this.x)return this.x.getWorkspaceFolder(V,q)}async getWorkspaceFolder2(V,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,q)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,q){let N,B="";if(typeof V=="string"?(N=l.URI.file(V),B=V):typeof V<"u"&&(N=V,B=V.fsPath),!N)return B;const K=this.getWorkspaceFolder(N,!0);if(!K)return B;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let ie=(0,T.$_g)(K.uri,N);return q&&K.name&&(ie=`${K.name}/${ie}`),ie}y(V){this.x&&(this.n=S.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:q,added:N,removed:B}=S.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:B}))}findFiles(V,q,N,B,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let ie="",ce=!0;return q===null?ce=!1:q!==void 0&&(typeof q=="string"?ie=q:ie=q.pattern),this.z(V,void 0,{exclude:ie,maxResults:N,useDefaultExcludes:ce,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(V,q={},N,B=R.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${N.value}, entryPoint: findFiles2`),this.z(void 0,V,q,B)}async z(V,q,N,B=R.CancellationToken.None){if(B&&B.isCancellationRequested)return Promise.resolve([]);const K=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,ie={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof N.useDefaultSearchExcludes=="boolean"?!N.useDefaultSearchExcludes:!1,maxResults:N.maxResults,excludePattern:K,shouldGlobSearch:typeof N.fuzzy=="boolean"?!N.fuzzy:!0,_reason:"startFileSearch"};let ce;if(V){const{includePattern:ye,folder:ke}=P(u.GlobPattern.from(V));ce=ke,ie.includePattern=ye}else{const{includePattern:ye,folder:ke}=P(u.GlobPattern.from(q));ce=ke,ie.filePattern=ye}return this.o.$startFileSearch(ce??null,ie,B).then(ye=>Array.isArray(ye)?ye.map(ke=>l.URI.revive(ke)):[])}async findTextInFiles(V,q,N,B,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),ce=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:ye,folder:ke}=P(u.GlobPattern.from(q.include)),fe=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,$e={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:ce,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:ye,excludePattern:fe},Te=!1;if(this.u[ie]=ae=>{if(Te)return;const Ne=l.URI.revive(ae.resource);ae.results.forEach(ne=>{const z=(0,b.$6h)(ne);(0,a.$mL)(z)?N({uri:Ne,preview:{text:z.preview.text,matches:(0,C.$1b)(z.preview.matches,x=>new t.$cN(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,C.$1b)(z.ranges,x=>new t.$cN(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):N({uri:Ne,text:z.text,lineNumber:z.lineNumber})})},K.isCancellationRequested)return{};try{const ae=await this.o.$startTextSearch(V,ke??null,$e,ie,K);return delete this.u[ie],ae||{}}catch(ae){throw delete this.u[ie],ae}}$handleTextSearchResult(V,q){this.u[q]?.(V)}async save(V){const q=await this.o.$save(V,{saveAs:!1});return l.URI.revive(q)}async saveAs(V){const q=await this.o.$save(V,{saveAs:!0});return l.URI.revive(q)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,q){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,q);const N=this.t.transformOutgoingScheme(V),B=this.A++;return this.o.$registerEditSessionIdentityProvider(B,N),(0,A.$Sc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(V,q){this.h.info("Getting edit session identifier for workspaceFolder",V);const N=await this.resolveWorkspaceFolder(l.URI.revive(V));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const B=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!B),!B)return;const K=await B.provideEditSessionIdentity(N,q);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(V,q,N,B){this.h.info("Getting edit session identifier for workspaceFolder",V);const K=await this.resolveWorkspaceFolder(l.URI.revive(V));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const ie=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!ie),!ie)return;const ce=await ie.provideEditSessionIdentityMatch?.(q,N,B);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(V){return(q,N,B)=>{const K=function(ce){q.call(N,ce)};return K.extension=V,this.B.event(K,void 0,B)}}async $onWillCreateEditSessionIdentity(V,q,N){const B=await this.resolveWorkspaceFolder(l.URI.revive(V));if(B===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:B},q,async(K,ie)=>{const ce=Date.now();await Promise.resolve(K),Date.now()-ce>N&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(V,q){if(this.C.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.C.set(V,q);const N=this.t.transformOutgoingScheme(V),B=this.A++;return this.o.$registerCanonicalUriProvider(B,N),(0,A.$Sc)(()=>{this.C.delete(V),this.o.$unregisterCanonicalUriProvider(B)})}async provideCanonicalUri(V,q,N){const B=this.C.get(V.scheme);if(!B)return;const K=await B.provideCanonicalUri?.(l.URI.revive(V),q,N);if(K)return K}async $provideCanonicalUri(V,q,N){return this.provideCanonicalUri(l.URI.revive(V),{targetScheme:q},N)}};e.$Mlc=I,e.$Mlc=I=Je([We(0,c.$zP),We(1,i.$PP),We(2,n.$vlc),We(3,s.$3j),We(4,d.$Klc)],I),e.$Nlc=(0,f.$wi)("IExtHostWorkspace");function P(W){let V,q;return W&&(typeof W=="string"?V=W:(V=W.pattern,q=l.URI.revive(W.baseUri))),{includePattern:V,folder:q}}}),define(Se[40],Pe([1,0,25,5,39,4,7,203,51,15,11,3,17,12,2]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=e.$Plc=e.$Olc=void 0;function s(d,a){if(a){const g=a.split(".");let b=d;for(let p=0;b&&p<g.length;p++)b=b[g[p]];return b}}function r(d){return d instanceof f.URI}function o(d){return d&&d.uri instanceof f.URI&&d.languageId&&typeof d.languageId=="string"}function n(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function i(d){return d&&d.uri instanceof f.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function c(d){if(r(d))return{resource:d};if(o(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(n(d))return{overrideIdentifier:d.languageId};if(i(d))return{resource:d.uri};if(d===null)return{resource:null}}let u=class{constructor(a,g,b){this.a=a.getProxy(M.$$M.MainThreadConfiguration),this.c=g,this.b=b,this.d=new T.$vh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new t(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,g){this.getConfigProvider().then(b=>b.$acceptConfigurationChanged(a,g))}};e.$Olc=u,e.$Olc=u=Je([We(0,l.$zP),We(1,R.$Nlc),We(2,w.$3j)],u);class t{constructor(a,g,b,p){this.a=new O.$de,this.b=a,this.f=p,this.c=g,this.e=$.$Ao.parse(b,p),this.d=this.k(b.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,g){const b={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Ao.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j(g,b))}getConfiguration(a,g,b){const p=c(g)||{},v=this.g(a?s(this.e.getValue(void 0,p,this.c.workspace),a):this.e.getValue(void 0,p,this.c.workspace));a&&this.h(a,p,b?.identifier);function y(D){if(D==null)return null;if(typeof D=="boolean")return D?2:5;switch(D){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(D){return typeof s(v,D)<"u"},get:(D,S)=>{this.h(a?`${a}.${D}`:D,p,b?.identifier);let I=s(v,D);if(typeof I>"u")I=S;else{let P;const W=(V,q)=>{if((0,E.$$f)(V)){let N;const B=()=>{P=P||(0,C.$3n)(v),N=N||s(P,q)};return new Proxy(V,{get:(K,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return B(),()=>N;if(P)return N=N||s(P,q),N[ie];const ce=K[ie];return typeof ie=="string"?W(ce,`${q}.${ie}`):ce},set:(K,ie,ce)=>(B(),N&&(N[ie]=ce),!0),deleteProperty:(K,ie)=>(B(),N&&delete N[ie],!0),defineProperty:(K,ie,ce)=>(B(),N&&Object.defineProperty(N,ie,ce),!0)})}return Array.isArray(V)?(0,C.$3n)(V):V};I=W(I,D)}return I},update:(D,S,I,P)=>{D=a?`${a}.${D}`:D;const W=y(I);return S!==void 0?this.b.$updateConfigurationOption(W,D,S,p,P):this.b.$removeConfigurationOption(W,D,p,P)},inspect:D=>{D=a?`${a}.${D}`:D;const S=this.e.inspect(D,p,this.c.workspace);if(S)return{key:D,defaultValue:(0,C.$3n)(S.policy?.value??S.default?.value),globalValue:(0,C.$3n)(S.user?.value??S.application?.value),workspaceValue:(0,C.$3n)(S.workspace?.value),workspaceFolderValue:(0,C.$3n)(S.workspaceFolder?.value),defaultLanguageValue:(0,C.$3n)(S.default?.override),globalLanguageValue:(0,C.$3n)(S.user?.override??S.application?.override),workspaceLanguageValue:(0,C.$3n)(S.workspace?.override),workspaceFolderLanguageValue:(0,C.$3n)(S.workspaceFolder?.override),languageIds:(0,C.$3n)(S.overrideIdentifiers)}}};return typeof v=="object"&&(0,C.$6n)(h,v,!1),Object.freeze(h)}g(a){const g=b=>(0,E.$$f)(b)?new Proxy(b,{get:(p,v)=>g(p[v]),set:(p,v,y)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(p,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(p,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):b;return g(a)}h(a,g,b){const p=m.$ro.test(a)?4:this.d.get(a),v=b?`[${b.value}] `:"";if(p===4){typeof g?.resource>"u"&&this.f.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){g?.resource&&this.f.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,g){const b=new $.$Co(a,g,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(p,v)=>b.affectsConfiguration(p,c(v))})}k(a){return a.reduce((g,b)=>(g.set(b[0],b[1]),g),new Map)}}e.$Plc=t,e.$Qlc=(0,k.$wi)("IExtHostConfiguration")}),define(Se[121],Pe([1,0,2,11,5,4,7,39,68,40,24,53,17,27,3,16,22,12,80,241,14]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r,o,n,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=e.$hnc=e.$gnc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var u;(function(W){function V(N){if(N!=null)return N}W.from=V;function q(N){if(N!=null)return N}W.to=q})(u||(u={}));var t;(function(W){function V(N){if(N!=null)return N}W.from=V;function q(N){if(N!=null)return N}W.to=q})(t||(t={}));var d;(function(W){function V(N){if(N!=null)return N}W.from=V;function q(N){if(N!=null)return N}W.to=q})(d||(d={}));var a;(function(W){function V(B){if(B){const K=B;return K&&!!K.process}else return!1}W.is=V;function q(B){if(B==null)return;const K={process:B.process,args:B.args};return B.options&&(K.options=d.from(B.options)),K}W.from=q;function N(B){if(B!=null)return new A.$WN(B.process,B.args,B.options)}W.to=N})(a||(a={}));var g;(function(W){function V(N){if(N!=null)return N}W.from=V;function q(N){if(N!=null)return N}W.to=q})(g||(g={}));var b;(function(W){function V(B){if(B){const K=B;return K&&(!!K.commandLine||!!K.command)}else return!1}W.is=V;function q(B){if(B==null)return;const K={};return B.commandLine!==void 0?K.commandLine=B.commandLine:(K.command=B.command,K.args=B.args),B.options&&(K.options=g.from(B.options)),K}W.from=q;function N(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new A.$XN(B.commandLine,B.options):new A.$XN(B.command,B.args?B.args:[],B.options)}W.to=N})(b||(b={}));var p;(function(W){function V(B){if(B){const K=B;return K&&K.customExecution==="customExecution"}else return!1}W.is=V;function q(B){return{customExecution:"customExecution"}}W.from=q;function N(B,K){return K.get(B)}W.to=N})(p||(e.CustomExecutionDTO=p={}));var v;(function(W){function V(q,N){let B;return q.scope!==void 0&&typeof q.scope!="number"?B=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===A.TaskScope.Workspace&&N&&N.workspaceFile?B=N.workspaceFile:B=i.$dI),{id:q._id,workspaceFolder:B}}W.from=V})(v||(e.TaskHandleDTO=v={}));var y;(function(W){function V(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}W.from=V})(y||(y={}));var h;(function(W){function V(B,K){if(B==null)return[];const ie=[];for(const ce of B){const ye=q(ce,K);ye&&ie.push(ye)}return ie}W.fromMany=V;function q(B,K){if(B==null)return;let ie;B.execution instanceof A.$WN?ie=a.from(B.execution):B.execution instanceof A.$XN?ie=b.from(B.execution):B.execution&&B.execution instanceof A.$YN&&(ie=p.from(B.execution));const ce=u.from(B.definition);let ye;return B.scope?typeof B.scope=="number"?ye=B.scope:ye=B.scope.uri:ye=A.TaskScope.Workspace,!ce||!ye?void 0:{_id:B._id,definition:ce,name:B.name,source:{extensionId:K.identifier.value,label:B.source,scope:ye},execution:ie,isBackground:B.isBackground,group:y.from(B.group),presentationOptions:t.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}W.from=q;async function N(B,K,ie){if(B==null)return;let ce;a.is(B.execution)?ce=a.to(B.execution):b.is(B.execution)?ce=b.to(B.execution):p.is(B.execution)&&(ce=p.to(B._id,ie));const ye=u.to(B.definition);let ke;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?ke=B.source.scope:ke=await K.resolveWorkspaceFolder(C.URI.revive(B.source.scope)):ke=A.TaskScope.Workspace),!ye||!ke)return;const fe=new A.$ZN(ye,ke,B.name,B.source.label,ce,B.problemMatchers);return B.isBackground!==void 0&&(fe.isBackground=B.isBackground),B.group!==void 0&&(fe.group=A.$VN.from(B.group._id),fe.group&&B.group.isDefault&&(fe.group=new A.$VN(fe.group.id,fe.group.label),B.group.isDefault===!0&&(fe.group.isDefault=B.group.isDefault))),B.presentationOptions&&(fe.presentationOptions=t.to(B.presentationOptions)),B._id&&(fe._id=B._id),B.detail&&(fe.detail=B.detail),fe}W.to=N})(h||(e.TaskDTO=h={}));var D;(function(W){function V(N){return N}W.from=V;function q(N){if(N)return Object.assign(Object.create(null),N)}W.to=q})(D||(D={}));class S{#e;constructor(V,q,N){this._id=q,this.a=N,this.#e=V}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}let I=class{constructor(V,q,N,B,K,ie,ce,ye){this.q=new R.$de,this.r=new R.$de,this.s=new R.$de,this.u=new R.$de,this.a=V.getProxy(M.$$M.MainThreadTask),this.b=N,this.c=B,this.d=K,this.e=ie,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(V,q,N){if(!N)return new A.$aN(()=>{});const B=this.x();return this.j.set(B,{type:q,provider:N,extension:V}),this.a.$registerTaskProvider(B,q),new A.$aN(()=>{this.j.delete(B),this.a.$unregisterTaskProvider(B)})}registerTaskSystem(V,q){this.a.$registerTaskSystem(V,q)}fetchTasks(V){return this.a.$fetchTasks(D.from(V)).then(async q=>{const N=[];for(const B of q){const K=await h.to(B,this.b,this.m);K&&N.push(K)}return N})}get taskExecutions(){const V=[];return this.k.forEach(q=>V.push(q)),V}terminateTask(V){if(!(V instanceof S))throw new Error("No valid task execution provided");return this.a.$terminateTask(V._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(V,q,N){const B=this.m.get(V.id);B&&(this.o.set(V.id,B),this.e.attachPtyToTerminal(q,await B.callback(N))),this.p=V.id,this.q.fire({execution:await this.z(V)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(V){if(!this.l.has(V.id))return;const q=await this.z(V);this.l.delete(V.id),this.k.delete(V.id),this.B(V),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(V){const q=await this.z(V.id);this.s.fire({execution:q,processId:V.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(V){const q=await this.z(V.id);this.u.fire({execution:q,exitCode:V.exitCode})}$provideTasks(V,q){const N=this.j.get(V);if(!N)return Promise.reject(new Error("no handler found"));const B=[],K=(0,O.$oh)(()=>N.provider.provideTasks(T.CancellationToken.None)).then(ie=>this.v(q,B,N,ie));return new Promise(ie=>{K.then(ce=>{Promise.all(B).then(()=>{ie(ce)})})})}async $resolveTask(V,q){const N=this.j.get(V);if(!N)return Promise.reject(new Error("no handler found"));if(q.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${N.type}].`);const B=await h.to(q,this.b,this.m);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const K=await N.provider.resolveTask(B,T.CancellationToken.None);if(!K)return;this.A(K,N);const ie=h.from(K,N.extension);if(!ie)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(ie.execution)&&await this.y(ie,K,!0),await this.w(ie)}x(){return this.h++}async y(V,q,N){const B=await this.a.$createTaskId(V);!N&&!this.m.has(B)&&(this.n.add(B),this.o.set(B,q.execution)),this.m.set(B,q.execution)}async z(V,q){if(typeof V=="string"){const K=this.l.get(V);if(!K)throw new c.$bb("Unexpected: The specified task is missing an execution");return K}const N=this.l.get(V.id);if(N)return N;let B;return q?B=Promise.resolve(new S(this,V.id,q)):B=h.to(V.task,this.b,this.m).then(K=>{if(!K)throw new c.$bb("Unexpected: Task does not exist.");return new S(this,V.id,K)}),this.l.set(V.id,B),B.then(K=>(this.k.set(V.id,K),K))}A(V,q){V._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(V){this.o.get(V.id)&&this.o.delete(V.id),this.n.has(V.id)&&this.p!==V.id&&(this.m.delete(V.id),this.n.delete(V.id));const N=this.n.values();let B=N.next();for(;!B.done;)!this.o.has(B.value)&&this.p!==B.value&&(this.m.delete(B.value),this.n.delete(B.value)),B=N.next()}};e.$gnc=I,e.$gnc=I=Je([We(0,l.$zP),We(1,w.$PP),We(2,$.$Nlc),We(3,m.$KP),We(4,E.$Qlc),We(5,k.$cmc),We(6,o.$3j),We(7,n.$rlc)],I);let P=class extends I{constructor(V,q,N,B,K,ie,ce,ye){super(V,q,N,B,K,ie,ce,ye),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:r.$h(0)})}async executeTask(V,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const N=h.from(q,V);if(N===void 0)throw new Error("Task is not valid");if(p.is(N.execution))await this.y(N,q,!1);else throw new c.$_;const B=await this.z(await this.a.$getTaskExecution(N),q);return this.a.$executeTask(N).catch(K=>{throw new Error(K)}),B}v(V,q,N,B){const K=[];if(B)for(const ie of B){if(this.A(ie,N),!ie.definition||!V[ie.definition.type]){const ye=ie.source?ie.source:"No task source";this.f.warn(`The task [${ye}, ${ie.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=h.from(ie,N.extension);ce&&p.is(ce.execution)?(K.push(ce),q.push(this.y(ce,ie,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:N.extension}}async w(V){if(p.is(V.execution))return V;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(V,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,q,N){}};e.$hnc=P,e.$hnc=P=Je([We(0,l.$zP),We(1,w.$PP),We(2,$.$Nlc),We(3,m.$KP),We(4,E.$Qlc),We(5,k.$cmc),We(6,o.$3j),We(7,n.$rlc)],P),e.$inc=(0,f.$wi)("IExtHostTask")}),define(Se[299],Pe([1,0,47,30]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NL=void 0,e.$ML=R,e.$OL=M;function R(A){return"cellResults"in A}e.$NL="rawCell#";function M(A,$){let m=-1;const E=[];let T=[];return A.forEach(l=>{l.range.startLineNumber!==m&&T.length>0&&(E.push([...T]),T=[]),T.push(l),m=l.range.endLineNumber}),T.length>0&&E.push([...T]),E.map(l=>{const w=[],f=l[0].range.startLineNumber,s=l[l.length-1].range.endLineNumber;for(let r=f;r<=s;r++)w.push($.getLineContent(r));return new C.$qL(w.join(`
`)+`
`,l.map(r=>new O.$ut(r.range.startLineNumber-1,r.range.startColumn-1,r.range.endLineNumber-1,r.range.endColumn-1)))})}}),define(Se[300],Pe([1,0,177,21,5,6,28,13,15,2,38,76,4,32,8,7,35,275,114,25,16,231,299,297]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r,o,n,i,c,u,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=void 0;class a{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,p,v,y,h,D){this.q=v,this.r=y,this.s=h,this.t=D,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new R.$de,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new R.$de,this.onDidOpenNotebookDocument=this.m.event,this.n=new R.$de,this.onDidCloseNotebookDocument=this.n.event,this.o=new R.$de,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$plc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=b.getProxy(l.$$M.MainThreadNotebook),this.c=b.getProxy(l.$$M.MainThreadNotebookDocuments),this.d=b.getProxy(l.$$M.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const I=S.notebookEditor?.notebookUri,P=S.cell.handle,V=this.g.get(I)?.getCell(P);if(V)return V.apiCell}if(S&&S.$mid===14){const I=S.uri,P=this.g.get(I);if(P)return P.apiNotebook}return S}}),a.B(p)}getEditorById(b){const p=this.h.get(b);if(!p)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor(b){for(const[p,v]of this.h)if(v.apiEditor===b)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,p){const v=this.g.get(b);if(!v&&!p)throw new Error(`NO notebook document for '${b}'`);return v}static u(b,p){if(!p)return;const v=p.filenamePattern.map(y=>f.NotebookExclusiveDocumentPattern.from(y)).filter(y=>y!==void 0);if(p.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:p.displayName,filenamePattern:v,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,p,v){const y=a.a++,h=typeof v.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(y,v),this.b.$registerNotebookCellStatusBarItemProvider(y,h,p);let D;return h!==void 0&&(D=v.onDidChangeCellStatusBarItems(S=>this.b.$emitCellStatusBarEvent(h))),new s.$aN(()=>{this.f.delete(y),this.b.$unregisterNotebookCellStatusBarItemProvider(y,h),D?.dispose()})}async createNotebookDocument(b){const p=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&f.NotebookData.from(b.content)});return E.URI.revive(p)}async openNotebookDocument(b){const p=this.g.get(b);if(p)return p.apiNotebook;const v=await this.c.$tryOpenNotebook(b),y=this.g.get(E.URI.revive(v));return(0,m.$hg)(y?.apiNotebook)}async showNotebookDocument(b,p){E.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let v;typeof p=="object"?v={position:f.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(f.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:v={preserveFocus:!1};const y=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,v),h=y&&this.h.get(y)?.apiEditor;if(h)return h;throw y?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,p,v,y){const h=this.f.get(b),D=E.URI.revive(p),S=this.g.get(D);if(!S||!h)return;const I=S.getCellFromIndex(v);if(!I)return;const P=await h.provideCellStatusBarItems(I.apiCell,y);if(!P)return;const W=new M.$Tc,V=this.p.add([W]),N=(Array.isArray(P)?P:[P]).map(B=>f.NotebookStatusBarItem.from(B,this.i,W));return{cacheId:V,items:N}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,p,v,y,h){if((0,$.$7e)(p))throw new Error("viewType cannot be empty or just whitespace");const D=this.w++;return this.x.set(D,{viewType:p,serializer:v,options:y}),this.b.$registerNotebookSerializer(D,{id:b.identifier,location:b.extensionLocation},p,f.NotebookDocumentContentOptions.from(y),a.u(b,h)),(0,M.$Sc)(()=>{this.b.$unregisterNotebookSerializer(D)})}async $dataToNotebook(b,p,v){const y=this.x.get(b);if(!y)throw new Error("NO serializer found");const h=await y.serializer.deserializeNotebook(p.buffer,v);return new r.$Bw(f.NotebookData.from(h))}async $notebookToData(b,p,v){const y=this.x.get(b);if(!y)throw new Error("NO serializer found");const h=await y.serializer.serializeNotebook(f.NotebookData.to(p.value),v);return O.$Fe.wrap(h)}async $saveNotebook(b,p,v,y,h){const D=E.URI.revive(p),S=this.x.get(b);if(!S)throw new Error("NO serializer found");const I=this.g.get(D);if(!I)throw new Error("Document NOT found");if(I.versionId!==v)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(D.scheme))throw new T.$ll((0,C.localize)(0,null,this.z(D)),6);await this.y(D,y);const P={metadata:(0,i.$$n)(I.apiNotebook.metadata,B=>!(S.options?.transientDocumentMetadata??{})[B]),cells:[]};for(const B of I.apiNotebook.getCells()){const K=new s.$DO(B.kind,B.document.getText(),B.document.languageId,B.mime,S.options?.transientOutputs?[]:[...B.outputs],B.metadata,B.executionSummary);K.metadata=(0,i.$$n)(B.metadata,ie=>!(S.options?.transientCellMetadata??{})[ie]),P.cells.push(K)}const W=await S.serializer.serializeNotebook(P,h);await this.s.value.writeFile(D,W);const V=this.s.getFileSystemProviderExtUri(D.scheme),q=await this.s.value.stat(D);return{name:V.basename(D),isFile:(q.type&T.FileType.File)!==0,isDirectory:(q.type&T.FileType.Directory)!==0,isSymbolicLink:(q.type&T.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&T.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(D.scheme),locked:!!((q.permissions??0)&T.FilePermission.Locked),etag:T.$wl({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(b,p,v,y,h){const D=this.x.get(b)?.serializer;if(!D)return{limitHit:!1,results:[]};const S=new A.$Bc;await(async(q,N,B)=>{await Promise.all(q.map(async K=>await Promise.all(K.filenamePatterns.map(ie=>{const ce={_reason:B._reason,folderQueries:B.folderQueries,includePattern:B.includePattern,excludePattern:B.excludePattern,maxResults:B.maxResults,type:1,filePattern:ie};return this.t.doInternalFileSearchWithCustomCallback(ce,N,ye=>{ye.forEach(ke=>{S.has(ke)||y.some($e=>K.isFromSettings&&!$e.isFromSettings?!1:$e.filenamePatterns.some(Te=>(0,d.$jhb)(Te,ke)))||S.add(ke)})}).catch(ye=>{if(ye.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ye})}))))})(v,h,p);const P=new A.$Ac;let W=!1;const V=Array.from(S).map(async q=>{const N=[];try{if(h.isCancellationRequested)return;if(p.maxResults&&[...P.values()].reduce((ce,ye)=>ce+ye.cellResults.length,0)>p.maxResults){W=!0;return}const B=[],K=this.g.get(q);if(K)K.apiNotebook.getCells().forEach(ye=>B.push({input:ye.document.getText(),outputs:ye.outputs.flatMap(ke=>ke.items.map(fe=>fe.data.toString()))}));else{const ce=await this.s.value.readFile(q),ye=O.$Fe.fromString(ce.toString()),ke=await D.deserializeNotebook(ye.buffer,h);if(h.isCancellationRequested)return;f.NotebookData.from(ke).cells.forEach($e=>B.push({input:$e.source,outputs:$e.outputs.flatMap(Te=>Te.items.map(ae=>ae.valueBytes.toString()))}))}if(h.isCancellationRequested)return;B.forEach((ce,ye)=>{const ke=p.contentPattern.pattern,fe=new u.$nXb(ce.input,void 0,ce.outputs),$e=fe.findInInputs(ke),Te=fe.findInOutputs(ke),ae=Te.flatMap(Ne=>(0,t.$OL)(Ne.matches,Ne.textBuffer)).map((Ne,ne)=>(Ne.webviewIndex=ne,Ne));if($e.length>0||Te.length>0){const Ne={index:ye,contentResults:(0,t.$OL)($e,fe.inputTextBuffer),webviewResults:ae};N.push(Ne)}});const ie={resource:q,cellResults:N};P.set(q,ie);return}catch{return}});return await Promise.all(V),{limitHit:W,results:[...P.values()]}}async y(b,p){const v=await this.s.value.stat(b);if(typeof p?.mtime=="number"&&typeof p.etag=="string"&&p.etag!==T.$vl&&typeof v.mtime=="number"&&typeof v.size=="number"&&p.mtime<v.mtime&&p.etag!==T.$wl({mtime:p.mtime,size:v.size}))throw new T.$ll((0,C.localize)(1,null),3,p)}z(b){return b.scheme===c.Schemas.file?b.fsPath:b.toString()}A(b,p,v){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const y=new n.$Mmc(p,this.d,b,v.visibleRanges.map(f.NotebookRange.to),v.selections.map(f.NotebookRange.to),typeof v.viewColumn=="number"?f.ViewColumn.to(v.viewColumn):void 0);this.h.set(p,y)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const v of b.value.removedDocuments){const y=E.URI.revive(v),h=this.g.get(y);h&&(h.dispose(),this.g.delete(y),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(D=>D.document.uri)}),this.n.fire(h.apiNotebook));for(const D of this.h.values())D.notebookData.uri.toString()===y.toString()&&this.h.delete(D.id)}if(b.value.addedDocuments){const v=[];for(const y of b.value.addedDocuments){const h=E.URI.revive(y.uri);if(this.g.has(h))throw new Error(`adding EXISTING notebook ${h} `);const D=new o.$Lmc(this.c,this.q,this.r,h,y);v.push(...y.cells.map(S=>o.$Kmc.asModelAddData(S))),this.g.get(h)?.dispose(),this.g.set(h,D),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(D.apiNotebook)}}if(b.value.addedEditors)for(const v of b.value.addedEditors){if(this.h.has(v.id))return;const y=E.URI.revive(v.documentUri),h=this.g.get(y);h&&this.A(h,v.id,v)}const p=[];if(b.value.removedEditors)for(const v of b.value.removedEditors){const y=this.h.get(v);y&&(this.h.delete(v),this.k?.id===y.id&&(this.k=void 0),p.push(y))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(y=>this.h.get(y)).filter(y=>!!y);const v=new Set;this.l.forEach(y=>v.add(y.id));for(const y of this.h.values()){const h=v.has(y.id);y._acceptVisibility(h)}this.l=[...this.h.values()].map(y=>y).filter(y=>y.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.h.get(b.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${b.value.newActiveEditor}`),this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(b){const p=w.$XP.String.with("notebookType","A notebook type"),v=new w.$ZP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new w.$XP("data","Bytes to convert to data",h=>h instanceof Uint8Array,h=>O.$Fe.wrap(h))],new w.$YP("Notebook Data",h=>f.NotebookData.to(h.value))),y=new w.$ZP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new w.$XP("NotebookData","Notebook data to convert to bytes",h=>!0,h=>new r.$Bw(f.NotebookData.from(h)))],new w.$YP("Bytes",h=>h.buffer));b.registerApiCommand(v),b.registerApiCommand(y)}}e.$Vmc=a}),define(Se[301],Pe([1,0,19,24,44,37,23,66,47]),function(le,e,C,O,R,M,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nmc=void 0;class E{constructor(l,w,f){this.k=l,this.l=w,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&M.$qk(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&M.$qk(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const w=this.k.folderQueries||[];return new Promise((f,s)=>{const r=o=>{this.f++,l(o)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const n=o.toString(),i=C.$nc(n);this.j&&this.j(n,i)||this.v(r,{base:o,basename:i})}),Promise.all(w.map(o=>this.p(o,r))).then(o=>{f({limitHit:this.e,stats:o[0]||void 0})},o=>{s(new Error((0,R.$hj)(o)))})})}async p(l,w){const f=new O.$oe,s=this.q(l),r=this.r(),o=new m.$EL(this.k,l),n=!o.hasSiblingExcludeClauses();let i;try{this.h.add(f),i=$.$_d.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,f.token),u=i.elapsed(),t=$.$_d.create();return this.g&&!this.e||(c&&c.forEach(d=>{const a=C.$gc.relative(l.folder.path,d.path);if(n){const g=C.$nc(d.path);this.v(w,{base:l.folder,relativePath:a,basename:g});return}this.s(r,l.folder,a,w)}),this.g&&!this.e)?null:(this.u(r,o,w),{providerTime:u,postProcessTime:t.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(l){const w=(0,m.$DL)(this.k.includePattern,l.includePattern),f=(0,m.$DL)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:f,includes:w,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},w,f,s){if(f===this.a){const o=C.$nc(this.a);this.v(s,{base:w,relativePath:this.a,basename:o})}function r(o){const n=C.$nc(o),i=C.$mc(o);let c=l[i];c||(c=l[i]=[],r(i)),c.push({base:w,relativePath:o,basename:n})}r(f)}u({rootEntries:l,pathToEntries:w},f,s){const r=this,o=this.a;function n(i){const c=(0,m.$GL)(()=>i.map(u=>u.basename));for(let u=0,t=i.length;u<t;u++){const d=i[u],{relativePath:a,basename:g}=d;if(f.matchesExcludesSync(a,g,o!==g?c:void 0))continue;const b=w[a];if(b)n(b);else{if(a===o)continue;r.v(s,d)}if(r.e)break}}n(l)}v(l,w){(!this.b||w.relativePath&&this.b(w.relativePath,w.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(w))}}class T{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,w,f,s){const r=this.c(l.cacheKey),o=new E(l,w,r&&r.token);let n=0;const i=c=>{n+=c.length,f(c.map(u=>this.d(u)))};return this.e(o,T.a,i,s).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new O.$oe),this.b.get(l)}d(l){return l.relativePath?{resource:A.$0g(l.base,l.relativePath)}:{resource:l.base}}e(l,w,f,s){const r=s.onCancellationRequested(()=>{l.cancel()}),o=i=>{i&&(n.push(i),w>0&&n.length>=w&&(f(n),n=[]))};let n=[];return l.search(o).then(i=>(n.length&&f(n),r.dispose(),i),i=>(n.length&&f(n),r.dispose(),Promise.reject(i)))}}e.$Nmc=T}),define(Se[302],Pe([1,0,18,270,37,97,28,16,19,23,13,15,2,96,195,50,12,45,109,298,47]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r,o,n,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=void 0,e.$PM=y;let u=class{constructor(D,S,I,P,W){this.a=D,this.b=S,this.c=I,this.d=P,this.e=W}text(D,S,I={}){D=this.f(D,I);const P=this.a.getValue(),W=S&&S.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(S?.map(o.$Ri),I),type:2,contentPattern:D,previewOptions:I.previewOptions,maxFileSize:I.maxFileSize,usePCRE2:P.search.usePCRE2||W||!1,beforeContext:I.beforeContext,afterContext:I.afterContext,userDisabledExcludesAndIgnoreFiles:I.disregardExcludeSettings&&I.disregardIgnoreFiles}}f(D,S){const I=this.a.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const P={...D,wordSeparators:I.editor.wordSeparators};return this.j(D,S)&&(P.isCaseSensitive=!0),this.k(D)&&(P.isMultiline=!0),S.notebookSearchConfig?.includeMarkupInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownInput=S.notebookSearchConfig.includeMarkupInput),S.notebookSearchConfig?.includeMarkupPreview&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownPreview=S.notebookSearchConfig.includeMarkupPreview),S.notebookSearchConfig?.includeCodeInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellInput=S.notebookSearchConfig.includeCodeInput),S.notebookSearchConfig?.includeOutput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellOutput=S.notebookSearchConfig.includeOutput),P}file(D,S={}){return{...this.h(D,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey,shouldGlobMatchFilePattern:S.shouldGlobSearch}}g(D,S){return D?(D=Array.isArray(D)?D.map(b):b(D),S?this.parseSearchPaths(D):{pattern:d(...Array.isArray(D)?D:[D])}):{}}h(D=[],S={}){const I=this.g(S.includePattern,S.expandPatterns),P=this.g(S.excludePattern,S.expandPatterns),W=D.length>1,V=(I.searchPaths&&I.searchPaths.length?I.searchPaths.map(B=>this.q(B,S,P)):D.map(B=>this.r(B,S,P,W))).filter(B=>!!B),q={_reason:S._reason,folderQueries:V,usingSearchPaths:!!(I.searchPaths&&I.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:P.pattern,includePattern:I.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const B=C.$Hb(this.c.groups.flatMap(ce=>ce.editors.map(ye=>ye.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(B));const K=B.filter(ce=>(0,c.$uL)(q,ce.fsPath)),ie=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...q,...ie}}const N=S.extraFileResources&&S.extraFileResources.filter(B=>(0,c.$uL)(q,B.fsPath));return q.extraFileResources=N&&N.length?N:void 0,q}i(D){const S=[],I=new A.$Ac,P={};let W=!1;return D.forEach(V=>{if(V.scheme===$.Schemas.walkThrough)return;if((0,E.$bh)(V)){const N=this.b.getWorkspaceFolder(V)?.uri??V.with({path:m.$mc(V.fsPath)});let B=I.get(N);B||(W=!0,B={folder:N,includePattern:{}},S.push(B),I.set(N,B));const K=m.$lc(N.fsPath,V.fsPath);(0,k.$hg)(B.includePattern)[K.replace(/\\/g,"/")]=!0}else V.fsPath&&(W=!0,P[V.fsPath]=!0)}),{folderQueries:S,includePattern:P,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}j(D,S){if(S.isSmartCase){if(D.isRegExp){if(T.$Zf(D.pattern,!0))return!0}else if(T.$Zf(D.pattern))return!0}return!!D.isCaseSensitive}k(D){return D.isMultiline||D.isRegExp&&(0,w.$QC)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const S=ie=>m.$ic(ie)||/^\.\.?([\/\\]|$)/.test(ie),P=(Array.isArray(D)?D:a(D)).map(ie=>{const ce=this.e.resolvedUserHome;return ce?(0,M.$Gw)(ie,ce.scheme===$.Schemas.file?ce.fsPath:ce.path):ie}),W=O.$K(P,ie=>S(ie)?"searchPaths":"exprSegments"),V=(W.exprSegments||[]).map(ie=>T.$ff(ie,"/")).map(ie=>T.$ff(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),g(ie))),q={},N=this.m(W.searchPaths||[]);N&&N.length&&(q.searchPaths=N);const B=V.flat(),K=d(...B);return K&&(q.pattern=K),q}l(D,S){return S.disregardExcludeSettings?void 0:(0,c.$tL)(D,!S.disregardSearchExcludeSettings)}m(D){if(!D||!D.length)return[];const S=D.flatMap(P=>{let{pathPortion:W,globPortion:V}=t(P);return V&&(V=p(V)),this.n(W).flatMap(N=>this.o(N,V))}),I=new Map;return S.forEach(P=>{const W=P.searchPath.toString(),V=I.get(W);V?P.pattern&&(V.pattern=V.pattern||{},V.pattern[P.pattern]=!0):I.set(W,{searchPath:P.searchPath,pattern:P.pattern?d(P.pattern):void 0})}),Array.from(I.values())}n(D){if(m.$ic(D)){const S=this.b.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==$.Schemas.file?[{searchPath:S[0].uri.with({path:D})}]:[{searchPath:l.URI.file(m.$hc(D))}]}if(this.b.getWorkbenchState()===2){const S=this.b.getWorkspace().folders[0].uri;if(D=b(D),D.startsWith("../")||D===".."){const P=m.$gc.resolve(S.path,D);return[{searchPath:S.with({path:P})}]}const I=p(D);return[{searchPath:S,pattern:I}]}else{if(D==="./"||D===".\\")return[];{const S=D.replace(/^\.[\/\\]/,""),P=this.b.getWorkspace().folders.map(W=>{const V=S.match(new RegExp(`^${T.$_e(W.name)}(?:/(.*)|$)`));return V?{match:V,folder:W}:null}).filter(k.$eg);if(P.length)return P.map(W=>{const V=W.match[1];return{searchPath:W.folder.uri,pattern:V&&p(V)}});{const W=D.match(/\.[\/\\](.+)[\/\\]?/),V=W?W[1]:D,q=f.localize(0,null,V);throw new Error(q)}}}}o(D,S){const I=D.pattern&&S?`${D.pattern}/${S}`:D.pattern||S,P=[{searchPath:D.searchPath,pattern:I}];return I&&!I.endsWith("**")&&P.push({searchPath:D.searchPath,pattern:I+"/**"}),P}q(D,S,I){const P=this.r((0,o.$Ri)(D.searchPath),S,I,!1);return P?{...P,includePattern:D.pattern}:null}r(D,S,I,P){let W;const V=l.URI.isUri(D)?D:D.uri;if(I.searchPaths){const ie=I.searchPaths.filter(ce=>(0,E.$3g)(ce.searchPath,V))[0];if(ie&&!ie.pattern)return null;ie&&(W=ie.pattern)}const q=this.a.getValue({resource:V}),B={...this.l(q,S)||{},...W||{}},K=l.URI.isUri(D)?(0,E.$7g)(D):D.name;return{folder:V,folderName:P?K:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!q.search.followSymlinks}}};e.$OM=u,e.$OM=u=Je([We(0,s.$3i),We(1,o.$Fi),We(2,n.$YD),We(3,r.$3j),We(4,i.$MM)],u);function t(h){const D=h.match(/[\*\{\}\(\)\[\]\?]/);if(D){const S=D.index,I=h.substr(0,S).match(/[/|\\][^/\\]*$/);if(I){let P=h.substr(0,I.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:h.substr((I.index||0)+1)}}}return{pathPortion:h}}function d(...h){return h.length?h.reduce((D,S)=>(D[S]=!0,D),Object.create(null)):void 0}function a(h){return R.$ok(h,",").map(D=>D.trim()).filter(D=>!!D.length)}function g(h){return[`**/${h}/**`,`**/${h}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function b(h){return h.replace(/\\/g,"/")}function p(h){return b(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(h){return h.replace(/([?*[\]])/g,"[$1]")}function y(h,D){h=C.$Mb(h,P=>P.toString());const S=[],I=D.getWorkspace();return h&&h.forEach(P=>{let W;if(D.getWorkbenchState()===2)W=(0,E.$_g)(I.folders[0].uri,P),W&&W!=="."&&(W="./"+W);else{const V=D.getWorkspaceFolder(P);if(V){const q=V.name;if(I.folders.filter(B=>B.name===q).length===1){const B=(0,E.$_g)(V.uri,P);B===""?W=`./${V.name}`:W=`./${V.name}/${B}`}else W=P.fsPath}}W&&S.push(v(W))}),S}}),define(Se[303],Pe([1,0,23,2,24,14,3,302,47,45,11]),function(le,e,C,O,R,M,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mwb=l,e.$nwb=s;const k=7e3;function l(r,o){const n=o.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],c=[];for(const b of n)if(/^workspaceContains:/.test(b)){const p=b.substr(18);p.indexOf("*")>=0||p.indexOf("?")>=0||r.forceUsingSearch?c.push(p):i.push(p)}if(i.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:u,resolve:t}=(0,T.$ph)(),d=b=>t({activationEvent:b}),a=Promise.all(i.map(b=>w(r,b,d))).then(()=>{}),g=f(r,o.identifier,c,d);return Promise.all([a,g]).then(()=>{t(void 0)}),u}async function w(r,o,n){for(const i of r.folders)if(await r.exists(C.$0g(O.URI.revive(i),o))){n(`workspaceContains:${o}`);return}}async function f(r,o,n,i){if(n.length===0)return Promise.resolve(void 0);const c=new R.$oe,u=r.checkExists(r.folders,n,c.token),t=setTimeout(async()=>{c.cancel(),r.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},k);let d=!1;try{d=await u}catch(a){M.$4(a)||M.$1(a)}c.dispose(),clearTimeout(t),d&&i(`workspaceContains:${n.join(",")}`)}function s(r,o,n,i){const c=r.get(A.$vi),u=r.get(m.$lL),d=c.createInstance($.$OM).file(o.map(a=>(0,E.$Ri)(O.URI.revive(a))),{_reason:"checkExists",includePattern:n,exists:!0});return u.fileSearch(d,i).then(a=>!!a.limitHit,a=>M.$4(a)?!1:Promise.reject(a))}}),define(Se[41],Pe([1,0,173,19,60,23,11,6,54,2,12,4,40,237,84,39,26,110,14,20,21,218,7,104,3,27,87,17,72,88,53,90,5,303,83,220,16,81,66,22,82]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r,o,n,i,c,u,t,d,a,g,b,p,v,y,h,D,S,I,P,W,V,q,N,B,K){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$tmc=e.$smc=e.$rmc=e.$qmc=e.$pmc=void 0,e.$pmc=(0,a.$wi)("IHostUtils");let ce=ie=class extends $.$Uc{constructor(z,x,be,Fe,De,pe,ge,Q,Y,he,ue,Me,de){super(),this.Y=Me,this.Z=de,this.a=this.B(new S.$de),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=be,this.f=ge,this.j=Fe,this.m=De,this.s=pe,this.t=Y,this.u=he,this.w=ue,this.y=this.g.getProxy(k.$$M.MainThreadWorkspace),this.z=this.g.getProxy(k.$$M.MainThreadTelemetry),this.C=this.g.getProxy(k.$$M.MainThreadExtensionService),this.D=new A.$vh,this.F=new A.$vh,this.G=new A.$vh,this.H=new A.$vh,this.I=new Ne(this.f.extensions.activationEvents),this.L=new o.$3_b(this.I,this.f.extensions.allExtensions);const Ce=new i.$Sm(this.f.extensions.myExtensions);this.J=new o.$3_b(this.I,Te(this.L,Ce)),B.$t&&(this.s.info(`Creating extension host with the following global extensions: ${fe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${fe(this.J)}`)),this.M=new f.$$lc(this.g,this.s),this.N=new P.$imc(this.g),this.O=Q,this.h=z.createChild(new v.$ui([f.$_lc,this.M],[P.$jmc,this.N])),this.P=this.B(new w.$0lc(this.J,this.L,{onExtensionActivationError:(Ae,je,U)=>{this.C.$onExtensionActivationError(Ae,n.$3(je),U)},actualActivateExtension:async(Ae,je)=>{if(o.$3_b.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,je),new w.$9lc;const U=this.J.getExtensionDescription(Ae);return this.fb(U,je)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),R.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(z){n.$1(z)}}async $(){this.O.onWillDeactivateAll();let z=[];try{z=this.J.getAllExtensionDescriptions().map(De=>De.identifier).filter(De=>this.isActivated(De)).map(De=>this.eb(De))}catch{}await Promise.all(z)}terminate(z,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${z}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Fe=>{this.s.error(Fe)}),this.g.dispose();const be=this.$();Promise.race([(0,A.$xh)(5e3),be]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(z){return this.G.isOpen()?this.P.isActivated(z):!1}async getExtension(z){const x=await this.C.$getExtension(z);return x&&{...x,identifier:new i.$Rm(x.identifier.value),extensionLocation:E.URI.revive(x.extensionLocation)}}ab(z,x){return this.P.activateByEvent(z,x)}bb(z,x){return this.P.activateById(z,x)}activateByIdWithErrors(z,x){return this.bb(z,x).then(()=>{const be=this.P.getActivatedExtension(z);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(z=>this.J)}getExtensionExports(z){if(this.G.isOpen())return this.P.getActivatedExtension(z).exports;try{return this.P.getActivatedExtension(z).exports}catch{return null}}async cb(z){if(z.scheme===V.Schemas.file&&this.c.fsRealpath){const x=z.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const be=await this.R.get(x);return E.URI.file(be)}return z}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(z=>new ae(z))),this.Q}async db(z){const x=m.$Ci.forUris(be=>M.$1g.ignorePathCasing(be));return await Promise.all(z.map(async be=>{if(this.wb(be)){const Fe=await this.cb(be.extensionLocation);x.set(Fe,be)}})),x}eb(z){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(z))return x;const be=this.P.getActivatedExtension(z);if(!be)return x;try{typeof be.module.deactivate=="function"&&(x=Promise.resolve(be.module.deactivate()).then(void 0,Fe=>(this.s.error(Fe),Promise.resolve(void 0))))}catch(Fe){this.s.error(`An error occurred when deactivating the extension '${z.value}':`),this.s.error(Fe)}try{(0,$.$Pc)(be.subscriptions)}catch(Fe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${z.value}':`),this.s.error(Fe)}return x}async fb(z,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(z.identifier):await this.C.$onWillActivateExtension(z.identifier),this.hb(z,x).then(be=>{const Fe=be.activationTimes;return this.C.$onDidActivateExtension(z.identifier,Fe.codeLoadingTime,Fe.activateCallTime,Fe.activateResolvedTime,x),this.gb(z,x,"success",Fe),be},be=>{throw this.gb(z,x,"failure"),be})}gb(z,x,be,Fe){const De=ke(z,x);this.z.$publicLog2("extensionActivationTimes",{...De,...Fe||{},outcome:be})}hb(z,x){const be=ke(z,x);this.z.$publicLog2("activatePlugin",be);const Fe=this.wb(z);if(!Fe)return Promise.resolve(new w.$8lc(w.$5lc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${z.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${z.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const De=new w.$6lc(x.startup);return Promise.all([this.xb(z,(0,M.$0g)(z.extensionLocation,Fe),De),this.ib(z)]).then(pe=>(R.mark(`code/extHost/willActivateExtension/${z.identifier.value}`),ie.jb(this.s,z.identifier,pe[0],pe[1],De))).then(pe=>(R.mark(`code/extHost/didActivateExtension/${z.identifier.value}`),pe))}ib(z){const x=this.Z.createLanguageModelAccessInformation(z),be=new u.$bmc(z,this.M),Fe=new u.$amc(z.identifier.value,!1,this.M),De=new W.$kmc(z,this.N),pe=z.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${z.identifier.value}`),Promise.all([be.whenReady,Fe.whenReady,this.O.whenReady]).then(()=>{const Q=this;let Y,he;const ue=(0,r.$OG)(z,"ipc")?this.f.messagePorts?.get(i.$Rm.toKey(z.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:Fe,secrets:De,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return z.extensionLocation},get extensionPath(){return z.extensionLocation.fsPath},asAbsolutePath(Me){return O.$jc(z.extensionLocation.fsPath,Me)},get storagePath(){return Q.O.workspaceValue(z)?.fsPath},get globalStoragePath(){return Q.O.globalValue(z).fsPath},get logPath(){return O.$jc(Q.f.logsLocation.fsPath,z.identifier.value)},get logUri(){return E.URI.joinPath(Q.f.logsLocation,z.identifier.value)},get storageUri(){return Q.O.workspaceValue(z)},get globalStorageUri(){return Q.O.globalValue(z)},get extensionMode(){return pe},get extension(){return Y===void 0&&(Y=new $e(Q,z.identifier,z,ge,!1)),Y},get extensionRuntime(){return(0,r.$PG)(z,"extensionRuntime"),Q.extensionRuntime},get environmentVariableCollection(){return Q.u.getEnvironmentVariableCollection(z)},get messagePassingProtocol(){if(!he){if(!ue)return;const Me=S.Event.buffer(S.Event.fromDOMEventEmitter(ue,"message",de=>de.data));ue.start(),he={onDidReceiveMessage:Me,postMessage:ue.postMessage.bind(ue)}}return he}})})}static jb(z,x,be,Fe,De){return be=be||{activate:void 0,deactivate:void 0},this.kb(z,x,be,Fe,De).then(pe=>new w.$7lc(!1,null,De.build(),be,pe,Fe.subscriptions))}static kb(z,x,be,Fe,De){if(typeof be.activate=="function")try{De.activateCallStart(),z.trace(`ExtensionService#_callActivateOptional ${x.value}`);const pe=typeof global=="object"?global:self,ge=be.activate.apply(pe,[Fe]);return De.activateCallStop(),De.activateResolveStart(),Promise.resolve(ge).then(Q=>(De.activateResolveStop(),Q))}catch(pe){return Promise.reject(pe)}else return Promise.resolve(be)}lb(z,x){this.bb(z.identifier,{startup:!1,extensionId:z.identifier,activationEvent:x}).then(void 0,be=>{this.s.error(be)})}mb(z,x=0){const Fe=Date.now();(0,B.$B)(()=>{for(let De=x;De<z.length;De+=1){const pe=z[De];for(const ge of pe.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-Fe>50){this.mb(z,De);break}else this.lb(pe,ge)}})}nb(){this.C.$setPerformanceMarks(R.getMarks()),this.m.getConfigProvider().then(z=>{const x=z.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this.J.getAllExtensionDescriptions();if(x)this.mb(be);else for(const Fe of be)if(Fe.activationEvents)for(const De of Fe.activationEvents)De==="onStartupFinished"&&this.lb(Fe,De)})}ob(){const z=this.ab("*",!0).then(void 0,pe=>{this.s.error(pe)});this.B(this.j.onDidChangeWorkspace(pe=>this.pb(pe.added)));const x=this.j.workspace?this.j.workspace.folders:[],be=this.pb(x),Fe=this.rb(),De=Promise.all([Fe,z,be]).then(()=>{});return Promise.race([De,(0,A.$xh)(1e4)]).then(()=>{this.nb()}),De}pb(z){return z.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(z,x))).then(()=>{})}async qb(z,x){if(this.isActivated(x.identifier))return;const be=!this.f.remote.isRemote&&!!this.f.remote.authority,Fe={logService:this.s,folders:z.map(pe=>pe.uri),forceUsingSearch:be||!this.c.fsExists,exists:pe=>this.c.fsExists(pe.fsPath),checkExists:(pe,ge,Q)=>this.y.$checkExists(pe,ge,Q)},De=await(0,I.$mwb)(Fe,x);if(De)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:De.activationEvent}).then(void 0,pe=>this.s.error(pe))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(z){throw console.error(z),z}}async sb(){const{extensionDevelopmentLocationURI:z,extensionTestsLocationURI:x}=this.f.environment;if(!z||!x)throw new Error(C.localize(0,null));const be=await this.xb(null,x,new w.$6lc(!1));if(!be||typeof be.run!="function")throw new Error(C.localize(1,null,x.toString()));return new Promise((Fe,De)=>{const pe=(Y,he)=>{Y?(B.$t&&this.s.error("Test runner called back with error",Y),De(Y)):(B.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),Fe(typeof he=="number"&&he>0?1:0))},ge=(0,M.$Xg)(x),Q=be.run(ge,pe);Q&&Q.then&&Q.then(()=>{B.$t&&this.s.info("Test runner finished successfully."),Fe(0)}).catch(Y=>{B.$t&&this.s.error("Test runner finished with error",Y),De(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$xh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(z,x){return this.S[z]=x,(0,$.$Sc)(()=>{delete this.S[z]})}async getRemoteExecServer(z){const{resolver:x}=await this.ub(z);return x?.resolveExecServer?.(z,{resolveAttempt:0})}async ub(z){const x=z.indexOf("+");if(x===-1)throw new t.$gN("Not an authority that can be resolved!",d.RemoteAuthorityResolverErrorCode.InvalidAuthority);const be=z.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this.S[be]}}async $resolveAuthority(z,x){const be=N.$_d.create(!1),Fe=()=>`[resolveAuthority(${(0,d.$Ll)(z)},${x})][${be.elapsed()}ms] `,De=F=>this.s.info(`${Fe()}${F}`),pe=F=>this.s.warn(`${Fe()}${F}`),ge=(F,G=void 0)=>this.s.error(`${Fe()}${F}`,G),Q=F=>{if(F instanceof t.$gN)return{type:"error",error:{code:F._code,message:F._message,detail:F._detail}};throw F},Y=async F=>{De(`activating resolver for ${F}...`);const{resolver:G,authorityPrefix:H}=await this.ub(F);if(!G)throw ge(`no resolver for ${H}`),new t.$gN(`No remote extension installed to resolve ${H}.`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:G,authorityPrefix:H,remoteAuthority:F}},he=z.split(/@|%40/g).reverse();De(`activating remote resolvers ${he.join(" -> ")}`);let ue;try{ue=await Promise.all(he.map(Y)).catch(async F=>{if(!(F instanceof t.$gN)||F._code!==d.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw F;return pe(`resolving nested authorities failed: ${F.message}`),[await Y(z)]})}catch(F){return Q(F)}const Me=new A.$Hh;Me.cancelAndSet(()=>De("waiting..."),1e3);let de,Ce;for(const[F,{authorityPrefix:G,resolver:H,remoteAuthority:ee}]of ue.entries())try{if(F===ue.length-1)De("invoking final resolve()..."),R.mark(`code/extHost/willResolveAuthority/${G}`),de=await H.resolve(ee,{resolveAttempt:x,execServer:Ce}),R.mark(`code/extHost/didResolveAuthorityOK/${G}`),De("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$fN.isManagedResolvedAuthority(de)?de:void 0));else{if(De(`invoking resolveExecServer() for ${ee}`),R.mark(`code/extHost/willResolveExecServer/${G}`),Ce=await H.resolveExecServer?.(ee,{resolveAttempt:x,execServer:Ce}),!Ce)throw new t.$gN(`Exec server was not available for ${ee}`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);R.mark(`code/extHost/didResolveExecServerOK/${G}`)}}catch(re){return R.mark(`code/extHost/didResolveAuthorityError/${G}`),ge("returned an error",re),Me.dispose(),Q(re)}Me.dispose();const Ae={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures?{elevation:de.tunnelFeatures.elevation,privacyOptions:de.tunnelFeatures.privacyOptions,protocol:de.tunnelFeatures.protocol===void 0?!0:de.tunnelFeatures.protocol}:void 0},je={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};De(`returned ${t.$fN.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let U;if(t.$fN.isManagedResolvedAuthority(de)){const F=x;this.Y.setFactory(F,de.makeConnection),U={authority:z,connectTo:new d.$Il(F),connectionToken:de.connectionToken}}else U={authority:z,connectTo:new d.$Jl(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:U,options:je,tunnelInformation:Ae}}}async $getCanonicalURI(z,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,d.$Ll)(z)})`);const{resolver:be}=await this.ub(z);if(!be)return null;const Fe=E.URI.revive(x);if(typeof be.getCanonicalURI>"u")return Fe;const De=await(0,A.$oh)(()=>be.getCanonicalURI(Fe));return De||Fe}async $startExtensionHost(z){z.toAdd.forEach(pe=>pe.extensionLocation=E.URI.revive(pe.extensionLocation));const{globalRegistry:x,myExtensions:be}=ye(this.I,this.L,this.J,z),Fe=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Fe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(be),B.$t&&(this.s.info(`$startExtensionHost: global extensions: ${fe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${fe(this.J)}`)),this.tb()}$activateByEvent(z,x){return x===1?this.D.wait().then(be=>this.ab(z,!1)):this.G.wait().then(be=>this.ab(z,!1))}async $activate(z,x){return await this.G.wait(),this.J.getExtensionDescription(z)?(await this.bb(z,x),!0):!1}async $deltaExtensions(z){z.toAdd.forEach(pe=>pe.extensionLocation=E.URI.revive(pe.extensionLocation));const{globalRegistry:x,myExtensions:be}=ye(this.I,this.L,this.J,z),Fe=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Fe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(be),B.$t&&(this.s.info(`$deltaExtensions: global extensions: ${fe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${fe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(z){return z}async $test_up(z){return z.byteLength}async $test_down(z){const x=c.$Fe.alloc(z),be=Math.random()%256;for(let Fe=0;Fe<z;Fe++)x.writeUInt8(be,Fe);return x}async $updateRemoteConnectionData(z){this.X=z,this.a.fire()}};e.$qmc=ce,e.$qmc=ce=ie=Je([We(0,a.$vi),We(1,e.$pmc),We(2,p.$zP),We(3,s.$Nlc),We(4,l.$Qlc),We(5,T.$3j),We(6,g.$PP),We(7,b.$Tlc),We(8,y.$sDb),We(9,h.$cmc),We(10,q.$mmc),We(11,K.$nmc),We(12,D.$gmc)],ce);function ye(ne,z,x,be){ne.addActivationEvents(be.addActivationEvents);const Fe=new o.$3_b(ne,z.getAllExtensionDescriptions());Fe.deltaExtensions(be.toAdd,be.toRemove);const De=new i.$Sm(x.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of be.myToRemove)De.delete(ge);for(const ge of be.myToAdd)De.add(ge);const pe=Te(Fe,De);return{globalRegistry:Fe,myExtensions:pe}}function ke(ne,z){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:z.activationEvent,reasonId:z.extensionId.value}}function fe(ne){return ne.getAllExtensionDescriptions().map(z=>z.identifier.value).join(",")}e.$rmc=(0,a.$wi)("IExtHostExtensionService");class $e{#e;#t;#i;constructor(z,x,be,Fe,De){this.#e=z,this.#t=x,this.#i=be.identifier,this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=O.$hc((0,M.$Xg)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=Fe,this.isFromDifferentExtensionHost=De}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$smc=$e;function Te(ne,z){return ne.getAllExtensionDescriptions().filter(x=>z.has(x.identifier))}class ae{constructor(z){this.a=z}setSearchTree(z){this.a=z}findSubstr(z){return this.a.findSubstr(z)}forEach(z){return this.a.forEach(z)}}e.$tmc=ae;class Ne{constructor(z){this.a=new i.$Tm,this.addActivationEvents(z)}readActivationEvents(z){return this.a.get(z.identifier)??[]}addActivationEvents(z){for(const x of Object.keys(z))this.a.set(x,z[x])}}}),define(Se[304],Pe([1,0,60,2,4,40,26,20,17,27,3,41,12,13]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cnc=void 0;let s=class{constructor(c,u,t,d,a,g,b){this.c=c,this.d=u,this.e=t,this.f=d,this.g=a,this.h=g,this.i=b,this.a=new Map,this.b=[]}async install(){this.j(),C.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const u=await this.g.getExtensionPathIndex();this.register(new o(this.c,u,this.d,c,this.i)),this.register(this.e.createInstance(r)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,u,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const u of c.nodeModuleName)this.a.set(u,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(u=>c.alternativeModuleName(u))}};e.$Cnc=s,e.$Cnc=s=Je([We(2,T.$vi),We(3,M.$Qlc),We(4,k.$rmc),We(5,E.$PP),We(6,l.$3j)],s);let r=class{static{f=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&f.a.size){const u=(0,w.$_e)(this.c(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",d=`@${t}+\\/${t}+|${t}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${u}/${a}\\/)(${d})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const u=this.b.exec(this.c(c));if(!u)return;const[,t,d,a]=u,g=f.a.get(d);if(g!==void 0)return console.warn(`${d} as been renamed to ${g}, please update your imports`),t+g+a}c(c){return c.replace(/\\/g,"/")}};r=f=Je([We(0,E.$PP)],r);class o{constructor(c,u,t,d,a){this.c=c,this.d=u,this.e=t,this.f=d,this.g=a,this.nodeModuleName="vscode",this.a=new $.$Tm}load(c,u){const t=this.d.findSubstr(u);if(t){let d=this.a.get(t.identifier);return d||(d=this.c(t,this.e,this.f),this.a.set(t.identifier,d)),d}if(!this.b){let d="";this.d.forEach((a,g)=>d+=`	${g} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${u}. These are the extension path mappings: 
${d}`),this.b=this.c(A.$JG,this.e,this.f)}return this.b}}let n=class{constructor(c,u,t){this.e=c,this.f=u,this.nodeModuleName=["open","opn"],this.d=t.getProxy(R.$$M.MainThreadTelemetry);const d=t.getProxy(R.$$M.MainThreadWindow);this.c=(a,g)=>{const b=O.URI.parse(a);return g?this.g(a,g):b.scheme==="http"||b.scheme==="https"?d.$openUri(b,a,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this.f?d.$openUri(b,a,{}):this.g(a,g)}}load(c,u,t){const d=this.e.findSubstr(u);return d&&(this.a=d.identifier.value,this.h()),this.b=t(c),this.c}g(c,u){return this.i(),this.b(c,u)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([We(2,m.$zP)],n)}),define(Se[122],Pe([1,0,43,6,19,75,3,68,67,41,7,39,234,40]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=e.$umc=void 0,e.$umc=(0,A.$wi)("IExtHostVariableResolverProvider");class f extends l.$DQ{constructor(o,n,i,c,u,t,d){function a(){if(i){const g=i.activeEditor();if(g)return g.document.uri;const b=c.tabGroups.all.find(p=>p.isActive)?.activeTab;if(b!==void 0){if(b.input instanceof T.$YO||b.input instanceof T.$4O)return b.input.modified;if(b.input instanceof T.$XO||b.input instanceof T.$3O||b.input instanceof T.$1O)return b.input.uri}}}super({getFolderUri:g=>{const b=t.folders.filter(p=>p.name===g);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(g,b)=>u.getConfiguration(void 0,g).get(b),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const g=a();if(g)return R.$hc(g.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const g=a();if(g){const b=n.getWorkspaceFolder(g);if(b)return R.$hc(b.uri.fsPath)}}},getSelectedText:()=>{if(i){const g=i.activeEditor();if(g&&!g.selection.isEmpty)return g.document.getText(g.selection)}},getLineNumber:()=>{if(i){const g=i.activeEditor();if(g)return String(g.selection.end.line+1)}},getExtension:g=>o.getExtension(g)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(M.env))}}let s=class extends O.$Uc{constructor(o,n,i,c,u){super(),this.b=o,this.c=n,this.g=i,this.h=c,this.j=u,this.a=new C.$V(async()=>{const t=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async g=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.j,t,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$vmc=s,e.$vmc=s=Je([We(0,E.$rmc),We(1,k.$Nlc),We(2,$.$KP),We(3,w.$Qlc),We(4,m.$3lc)],s)}),define(Se[123],Pe([1,0,11,5,2,20,3,4,67,41,17,7,39,226,228,40,122,6,36,32,8,18]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r,o,n,i,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Amc=e.$zmc=e.$ymc=e.$xmc=e.$wmc=void 0,e.$wmc=(0,A.$wi)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(y,h,D,S,I,P,W){this.N=h,this.O=D,this.P=S,this.Q=I,this.R=P,this.S=W,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new O.$de,this.o=new O.$de,this.q=new O.$de,this.w=new O.$de,this.l=y.getProxy($.$$M.MainThreadDebugService),this.A=new O.$de,this.C=new O.$de,this.y=new a(this.l),this.z=new Map,this.O.getExtensionRegistry().then(V=>{V.onDidChange(q=>{this.V(V)}),this.V(V)})}async $getVisualizerTreeItem(y,h){const D=this.W(h);if(!D)return;const S=await this.H.get(y)?.getTreeItem?.(D);return S?this.U(y,S):void 0}registerDebugVisualizationTree(y,h,D){const S=M.$Rm.toKey(y.identifier),I=this.jb(S,h);if(this.G.has(I))throw new Error(`A debug visualization provider with id '${h}' is already registered`);return this.H.set(I,D),this.l.$registerDebugVisualizerTree(I,!!D.editItem),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(I),this.H.delete(h)})}async $getVisualizerTreeItemChildren(y,h){const D=this.J.get(h)?.item;return D?(await this.H.get(y)?.getChildren?.(D))?.map(I=>this.U(y,I))||[]:[]}async $editVisualizerTreeItem(y,h){const D=this.J.get(y);if(!D)return;const S=await this.H.get(D.provider)?.editItem?.(D.item,h);return this.U(D.provider,S||D.item)}$disposeVisualizedTree(y){const h=this.J.get(y);if(!h)return;const D=[h.children];for(const S of D)if(S)for(const I of S)D.push(this.J.get(I)?.children),this.J.delete(I)}U(y,h){let D=this.I.get(h);return D||(D=this.F++,this.I.set(h,D),this.J.set(D,{provider:y,item:h})),c.DebugTreeItem.from(h,D)}asDebugSourceUri(y,h){const D=y;if(typeof D.sourceReference=="number"&&D.sourceReference>0){let S=`debug:${encodeURIComponent(D.path||"")}`,I="?";return h&&(S+=`${I}session=${encodeURIComponent(h.id)}`,I="&"),S+=`${I}ref=${D.sourceReference}`,R.URI.parse(S)}else{if(D.path)return R.URI.file(D.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(y){const h=[];for(const D of y.getAllExtensionDescriptions())if(D.contributes){const S=D.contributes.debuggers;if(S&&S.length>0)for(const I of S)(0,f.$tH)(I)&&h.push(I.type)}this.l.$registerDebugTypes(h)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const y=[];return this.z.forEach(h=>y.push(h)),y}async $resolveDebugVisualizer(y,h){const D=this.L.get(y);if(!D)throw new Error(`No debug visualizer found with id '${y}'`);let{v:S,provider:I,extensionId:P}=D;if(S.visualization||(S=await I.resolveDebugVisualization?.(S,h)||S,D.v=S),!S.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${I}'`);return this.kb(P,S.visualization)}async $executeDebugVisualizerCommand(y){const h=this.L.get(y);if(!h)throw new Error(`No debug visualizer found with id '${y}'`);const D=h.v.visualization;D&&"command"in D&&this.S.executeCommand(D.command,...D.arguments||[])}W(y){const h=this.m.get(y.sessionId);return h&&{session:h.api,variable:y.variable,containerId:y.containerId,frameId:y.frameId,threadId:y.threadId}}async $provideDebugVisualizers(y,h,D,S){const I=this.W(D),P=this.jb(y,h),W=this.G.get(P);if(!I||!W)return[];const V=await W.provideDebugVisualization(I,S);return V?V.map(q=>{const N=++this.M;this.L.set(N,{v:q,provider:W,extensionId:y});const B=q.iconPath?this.lb(q.iconPath):void 0;return{id:N,name:q.name,iconClass:B?.iconClass,iconPath:B?.iconPath,visualization:this.kb(y,q.visualization)}}):[]}$disposeDebugVisualizers(y){for(const h of y)this.L.delete(h)}registerDebugVisualizationProvider(y,h,D){if(!y.contributes?.debugVisualizers?.some(P=>P.id===h))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${h})`);const S=M.$Rm.toKey(y.identifier),I=this.jb(S,h);if(this.G.has(I))throw new Error(`A debug visualization provider with id '${h}' is already registered`);return this.G.set(I,D),this.l.$registerDebugVisualizer(S,h),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizer(S,h),this.G.delete(h)})}addBreakpoints(y){const h=y.filter(I=>{const P=I.id;return this.z.has(P)?!1:(this.z.set(P,I),!0)});this.gb(h,[],[]);const D=[],S=new Map;for(const I of h)if(I instanceof k.$cO){let P=S.get(I.location.uri.toString());P||(P={type:"sourceMulti",uri:I.location.uri,lines:[]},S.set(I.location.uri.toString(),P),D.push(P)),P.lines.push({id:I.id,enabled:I.enabled,condition:I.condition,hitCondition:I.hitCondition,logMessage:I.logMessage,line:I.location.range.start.line,character:I.location.range.start.character,mode:I.mode})}else I instanceof k.$dO&&D.push({type:"function",id:I.id,enabled:I.enabled,hitCondition:I.hitCondition,logMessage:I.logMessage,condition:I.condition,functionName:I.functionName,mode:I.mode});return this.l.$registerBreakpoints(D)}removeBreakpoints(y){const h=y.filter(P=>this.z.delete(P.id));this.gb([],h,[]);const D=h.filter(P=>P instanceof k.$cO).map(P=>P.id),S=h.filter(P=>P instanceof k.$dO).map(P=>P.id),I=h.filter(P=>P instanceof k.$eO).map(P=>P.id);return this.l.$unregisterBreakpoints(D,S,I)}startDebugging(y,h,D){return this.l.$startDebugging(y?y.uri:void 0,h,{parentSessionID:D.parentSession?D.parentSession.id:void 0,lifecycleManagedByParent:D.lifecycleManagedByParent,repl:D.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:D.noDebug,compact:D.compact,suppressSaveBeforeStart:D.suppressSaveBeforeStart,suppressDebugStatusbar:D.suppressDebugStatusbar??D.debugUI?.simple,suppressDebugToolbar:D.suppressDebugToolbar??D.debugUI?.simple,suppressDebugView:D.suppressDebugView??D.debugUI?.simple})}stopDebugging(y){return this.l.$stopDebugging(y?y.id:void 0)}registerDebugConfigurationProvider(y,h,D){if(!h)return new k.$aN(()=>{});const S=this.d++;return this.f.push({type:y,handle:S,provider:h}),this.l.$registerDebugConfigurationProvider(y,D,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,S),new k.$aN(()=>{this.f=this.f.filter(I=>I.provider!==h),this.l.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(y,h,D){if(!D)return new k.$aN(()=>{});if(!this.cb(y,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.$(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this.g++;return this.h.push({type:h,handle:S,factory:D}),this.l.$registerDebugAdapterDescriptorFactory(h,S),new k.$aN(()=>{this.h=this.h.filter(I=>I.factory!==D),this.l.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(y,h){if(!h)return new k.$aN(()=>{});const D=this.j++;return this.k.push({type:y,handle:D,factory:h}),new k.$aN(()=>{this.k=this.k.filter(S=>S.factory!==h)})}async $runInTerminal(y,h){return Promise.resolve(void 0)}async $substituteVariables(y,h){let D;const S=await this.ib(y);return S&&(D={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(D,h)}X(y,h){if(y.type==="implementation")return new b(y.implementation)}Y(){}async $startDASession(y,h){const D=this,S=await this.hb(h);return this.eb(this.$(S.type),S).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const P=this.Z(I),W=this.X(P,S);if(!W)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const V=W;return this.D.set(y,V),this.db(S).then(q=>(q&&this.E.set(y,q),V.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const B=N,K={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const ie=await this.K.sign(B.arguments.value);K.body={signature:ie},V.sendResponse(K)}else throw new Error("no signer")}catch(ie){K.success=!1,K.message=ie.message,V.sendResponse(K)}}else q&&q.onDidSendMessage&&q.onDidSendMessage(N),N=(0,f.$yH)(N,!0),D.l.$acceptDAMessage(y,N)}),V.onError(N=>{q&&q.onError&&q.onError(N),this.l.$acceptDAError(y,N.name,N.message,N.stack)}),V.onExit(N=>{q&&q.onExit&&q.onExit(N??void 0,void 0),this.l.$acceptDAExit(y,N??void 0,void 0)}),q&&q.onWillStartSession&&q.onWillStartSession(),V.startSession()))})}$sendDAMessage(y,h){h=(0,f.$xH)(h,!1);const D=this.E.get(y);D&&D.onWillReceiveMessage&&D.onWillReceiveMessage(h),this.D.get(y)?.sendMessage(h)}$stopDASession(y){const h=this.E.get(y);this.E.delete(y),h&&h.onWillStopSession&&h.onWillStopSession();const D=this.D.get(y);return this.D.delete(y),D?D.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(y){const h=[],D=[],S=[];if(y.added)for(const I of y.added){const P=I.id;if(P&&!this.z.has(P)){let W;if(I.type==="function")W=new k.$dO(I.functionName,I.enabled,I.condition,I.hitCondition,I.logMessage,I.mode);else if(I.type==="data")W=new k.$eO(I.label,I.dataId,I.canPersist,I.enabled,I.hitCondition,I.condition,I.logMessage,I.mode);else{const V=R.URI.revive(I.uri);W=new k.$cO(new k.$mN(V,new k.$bN(I.line,I.character)),I.enabled,I.condition,I.hitCondition,I.logMessage,I.mode)}(0,k.$aO)(W,P),this.z.set(P,W),h.push(W)}}if(y.removed)for(const I of y.removed){const P=this.z.get(I);P&&(this.z.delete(I),D.push(P))}if(y.changed){for(const I of y.changed)if(I.id){const P=this.z.get(I.id);if(P){if(P instanceof k.$dO&&I.type==="function"){const W=P;W.enabled=I.enabled,W.condition=I.condition,W.hitCondition=I.hitCondition,W.logMessage=I.logMessage,W.functionName=I.functionName}else if(P instanceof k.$cO&&I.type==="source"){const W=P;W.enabled=I.enabled,W.condition=I.condition,W.hitCondition=I.hitCondition,W.logMessage=I.logMessage,W.location=new k.$mN(R.URI.revive(I.uri),new k.$bN(I.line,I.character))}S.push(P)}}}this.gb(h,D,S)}async $acceptStackFrameFocus(y){let h;if(y){const D=await this.hb(y.sessionId);y.kind==="thread"?h=new k.$kO(D.api,y.threadId):h=new k.$jO(D.api,y.threadId,y.frameId)}this.B=h,this.C.fire(this.B)}$provideDebugConfigurations(y,h,D){return(0,C.$oh)(async()=>{const S=this.bb(y);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const I=await this.ib(h);return S.provideDebugConfigurations(I,D)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(y,h,D,S){return(0,C.$oh)(async()=>{const I=this.bb(y);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(h);return I.resolveDebugConfiguration(P,D,S)})}$resolveDebugConfigurationWithSubstitutedVariables(y,h,D,S){return(0,C.$oh)(async()=>{const I=this.bb(y);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(h);return I.resolveDebugConfigurationWithSubstitutedVariables(P,D,S)})}async $provideDebugAdapter(y,h){const D=this.ab(y);if(!D)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.hb(h);return this.eb(D,S).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.Z(I)})}async $acceptDebugSessionStarted(y){const h=await this.hb(y);this.n.fire(h.api)}async $acceptDebugSessionTerminated(y){const h=await this.hb(y);h&&(this.o.fire(h.api),this.m.delete(h.id))}async $acceptDebugSessionActiveChanged(y){this.u=y?await this.hb(y):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(y,h){(await this.hb(y))?._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(y,h){const S={session:(await this.hb(y)).api,event:h.event,body:h.body};this.w.fire(S)}Z(y){if(y instanceof k.$fO)return{type:"executable",command:y.command,args:y.args,options:y.options};if(y instanceof k.$gO)return{type:"server",port:y.port,host:y.host};if(y instanceof k.$hO)return{type:"pipeServer",path:y.path};if(y instanceof k.$iO)return{type:"implementation",implementation:y.implementation};throw new Error("convertToDto unexpected type")}$(y){const h=this.h.filter(D=>D.type===y);if(h.length>0)return h[0].factory}ab(y){const h=this.h.filter(D=>D.handle===y);if(h.length>0)return h[0].factory}bb(y){const h=this.f.filter(D=>D.handle===y);if(h.length>0)return h[0].provider}cb(y,h){if(y.contributes){const D=y.contributes.debuggers;if(D&&D.length>0){for(const S of D)if(S.label&&S.type&&S.type===h)return!0}}return!1}db(y){const D=y.configuration.type,S=this.k.filter(I=>I.type===D||I.type==="*").map(I=>(0,C.$oh)(()=>I.factory.createDebugAdapterTracker(y.api)).then(P=>P,P=>null));return Promise.race([Promise.all(S).then(I=>{const P=(0,u.$Hb)(I);if(P.length>0)return new g(P)}),new Promise(I=>setTimeout(()=>I(void 0),1e3))]).catch(I=>{})}async eb(y,h){const D=h.configuration.debugServer;if(typeof D=="number")return Promise.resolve(new k.$gO(D));if(y){const I=await this.O.getExtensionRegistry();return(0,C.$oh)(()=>y.createDebugAdapterDescriptor(h.api,this.fb(h,I))).then(P=>{if(P)return P})}const S=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(h,S))}fb(y,h){}gb(y,h,D){(y.length>0||h.length>0||D.length>0)&&this.A.fire(Object.freeze({added:y,removed:h,changed:D}))}async hb(y){if(y)if(typeof y=="string"){const h=this.m.get(y);if(h)return h}else{let h=this.m.get(y.id);if(!h){const D=await this.ib(y.folderUri),S=y.parent?this.m.get(y.parent):void 0;h=new d(this.l,y.id,y.type,y.name,D,y.configuration,S?.api),this.m.set(h.id,h),this.l.$sessionCached(h.id)}return h}throw new Error("cannot find session")}ib(y){if(y){const h=R.URI.revive(y);return this.N.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}jb(y,h){return`${y}\0${h}`}kb(y,h){if(h){if("title"in h&&"command"in h)return{type:0};if("treeId"in h)return{type:1,id:`${y}\0${h.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(y){const h=this.mb(y);let D,S;return"id"in h?S=n.ThemeIcon.asClassName(h):D=h,{iconPath:D,iconClass:S}}mb(y){if(y instanceof k.$0N)return{id:y.id};const h=typeof y=="object"&&"dark"in y?y.dark:y,D=typeof y=="object"&&"light"in y?y.light:y;return{dark:typeof h=="string"?R.URI.file(h):h,light:typeof D=="string"?R.URI.file(D):D}}};e.$xmc=t,e.$xmc=t=Je([We(0,T.$zP),We(1,l.$Nlc),We(2,E.$rmc),We(3,s.$Qlc),We(4,m.$3lc),We(5,r.$umc),We(6,i.$VP)],t);class d{constructor(y,h,D,S,I,P,W){this.f=y,this.g=h,this.h=D,this.j=S,this.k=I,this.l=P,this.m=W}get api(){const y=this;return this.d??=Object.freeze({id:y.g,type:y.h,get name(){return y.j},set name(h){y.j=h,y.f.$setDebugSessionName(y.g,h)},parentSession:y.m,workspaceFolder:y.k,configuration:y.l,customRequest(h,D){return y.f.$customDebugAdapterRequest(y.g,h,D)},getDebugProtocolBreakpoint(h){return y.f.$getDebugProtocolBreakpoint(y.g,h.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(y){this.j=y}get configuration(){return this.l}}e.$ymc=d;class a{constructor(y){this.value=Object.freeze({append(h){y.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.$zmc=a;class g{constructor(y){this.d=y}onWillStartSession(){this.d.forEach(y=>y.onWillStartSession?y.onWillStartSession():void 0)}onWillReceiveMessage(y){this.d.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(y):void 0)}onDidSendMessage(y){this.d.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(y):void 0)}onWillStopSession(){this.d.forEach(y=>y.onWillStopSession?y.onWillStopSession():void 0)}onError(y){this.d.forEach(h=>h.onError?h.onError(y):void 0)}onExit(y,h){this.d.forEach(D=>D.onExit?D.onExit(y,h):void 0)}}class b extends w.$Rrb{constructor(y){super(),this.h=y,y.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(y){this.h.handleMessage(y)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let p=class extends t{constructor(y,h,D,S,I,P,W){super(y,h,D,S,I,P,W)}};e.$Amc=p,e.$Amc=p=Je([We(0,T.$zP),We(1,l.$Nlc),We(2,E.$rmc),We(3,s.$Qlc),We(4,m.$3lc),We(5,r.$umc),We(6,i.$VP)],p)}),define(Se[305],Pe([1,0,14,60,2,4,254,12,56,72,27,199,17,61,41,63]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enc=e.$Dnc=void 0;class r{static async installEarlyHandler(i){Error.stackTraceLimit=100;const c=i.get($.$3j),t=i.get(l.$zP).getProxy(M.$$M.MainThreadErrors);C.setUnexpectedErrorHandler(d=>{c.error(d);const a=C.$3(d);t.$onUnexpectedError(a)})}static async installFullHandler(i){const c=i.get($.$3j),u=i.get(l.$zP),t=i.get(f.$rmc),d=i.get(s.$TP),a=u.getProxy(M.$$M.MainThreadExtensionService),g=u.getProxy(M.$$M.MainThreadErrors),b=await t.getExtensionPathIndex(),p=new WeakMap;function v(D,S){if(p.has(D))return p.get(D).stack;let I="",P,W;for(const q of S)I+=`
	at ${q.toString()}`,W=q.getFileName(),!P&&W&&(P=b.findSubstr(R.URI.file(W)));const V=`${D.name||"Error"}: ${D.message||""}${I}`;return p.set(D,{extensionIdentifier:P?.identifier,stack:V}),V}const y=Symbol("prepareStackTrace wrapped");let h=v;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return h},set(D){if(D===v||!D||D[y]){h=D||v;return}h=function(S,I){return v(S,I),D.call(Error,S,I)},Object.assign(h,{[y]:!0})}}),C.setUnexpectedErrorHandler(D=>{c.error(D);const S=C.$3(D),I=p.get(D);if(!I?.extensionIdentifier){g.$onUnexpectedError(S);return}a.$onExtensionRuntimeError(I.extensionIdentifier,S);const P=d.onExtensionError(I.extensionIdentifier,D);c.trace("forwarded error to extension?",P,I)})}}e.$Dnc=r;class o{constructor(i,c,u,t,d){this.a=u,this.b=new A.$$_b(i,null,t),c=o.e(c,this.b);const a=new E.$ui(...(0,m.$ys)());a.set(T.$PP,{_serviceBrand:void 0,...c,messagePorts:d}),a.set(l.$zP,new l.$AP(this.b)),a.set(w.$Klc,new w.$Llc(t)),a.set(f.$pmc,u);const g=new k.$cr(a,!0);g.invokeFunction(r.installEarlyHandler),this.d=g.invokeFunction(b=>b.get($.$3j)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=g.invokeFunction(b=>b.get(f.$rmc)),this.c.initialize(),g.invokeFunction(r.installFullHandler)}async asBrowserUri(i){const c=this.b.getProxy(M.$$M.MainThreadExtensionService);return R.URI.revive(await c.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,c){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=R.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=R.URI.revive(c.transformIncomingURIs(i.environment.appRoot));const u=i.environment.extensionDevelopmentLocationURI;return u&&(i.environment.extensionDevelopmentLocationURI=u.map(t=>R.URI.revive(c.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=R.URI.revive(c.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=R.URI.revive(c.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=R.URI.revive(c.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=R.URI.revive(c.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=R.URI.revive(c.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=R.URI.revive(c.transformIncomingURIs(i.logsLocation)),i.workspace=c.transformIncomingURIs(i.workspace),i}}e.$Enc=o}),define(Se[306],Pe([1,0,18,11,24,44,16,19,23,2,47]),function(le,e,C,O,R,M,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=e.$Pmc=e.$Omc=void 0,e.$Qmc=s;class k{constructor(n,i,c){this.d=n,this.e=i,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const c=this.g.folderQueries||[],u=new R.$oe(i);return new Promise((t,d)=>{this.a=new w(n);let a=!1;const g=(b,p)=>{if(!a&&!this.b){const v=this.h(b);s(b)&&typeof this.g.maxResults=="number"&&this.c+v>this.g.maxResults&&(this.b=!0,a=!0,u.cancel(),b=this.j(b,this.g.maxResults-this.c));const y=this.h(b);this.c+=y,(y>0||!s(b))&&this.a.add(b,p)}};Promise.all(c.map((b,p)=>this.k(b,v=>g(v,p),u.token))).then(b=>{u.dispose(),this.a.flush();const p=b.some(v=>!!v&&!!v.limitHit);t({limitHit:this.b||p,messages:b.flatMap(v=>v?.message?Array.isArray(v.message)?v.message:[v.message]:[]),stats:{type:this.f}})},b=>{u.dispose();const p=(0,M.$hj)(b);d(new Error(p))})})}h(n){return s(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],u=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,i),preview:{matches:u.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,c){const u=new T.$EL(this.g,n),t=[],d={report:b=>{if(!this.l(b))return;const p=n.folder.scheme===A.Schemas.file?(0,T.$FL)(()=>this.e.readdir(m.$9g(b.uri))):void 0,v=m.$_g(n.folder,b.uri);if(v){const y=u.includedInQuery(v,$.$nc(v),p);(0,O.$ih)(y)?t.push(y.then(h=>{h&&i(b)})):y&&i(b)}}},a=this.n(n);let g;return this.d.query.type===3?g=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,a,d,c):g=await this.d.provider.provideTextSearchResults(l(this.d.query.contentPattern),a,d,c),t.length&&await Promise.all(t),g}l(n){if(s(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,T.$DL)(this.g.includePattern,n.includePattern),c=(0,T.$DL)(this.g.excludePattern,n.excludePattern),u={folder:E.URI.from(n.folder),excludes:c,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(u.usePCRE2=this.g.usePCRE2),u}}e.$Omc=k;function l(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class w{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new r(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!m.$3g(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(f(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Pmc=w;function f(o){return s(o)?{preview:{matches:(0,C.$1b)(o.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:o.preview.text},ranges:(0,C.$1b)(o.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function s(o){return!!o.preview}class r{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<r.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},r.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Rmc=r}),define(Se[124],Pe([1,0,6,4,3,301,17,61,12,2,306]),function(le,e,C,O,R,M,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=e.$Smc=void 0,e.$Umc=l,e.$Smc=(0,R.$wi)("IExtHostSearch");let k=class{constructor(s,r,o){this.n=s,this.o=r,this.q=o,this.c=this.n.getProxy(O.$$M.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new M.$Nmc}s(s){return this.o.transformOutgoingScheme(s)}registerTextSearchProvider(s,r){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const o=this.d++;return this.e.set(o,r),this.c.$registerTextSearchProvider(o,this.s(s)),(0,C.$Sc)(()=>{this.g.delete(s),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(s,r){if(this.i.has(s))throw new Error(`an AI text search provider for the scheme '${s}'is already registered`);this.i.add(s);const o=this.d++;return this.h.set(o,r),this.c.$registerAITextSearchProvider(o,this.s(s)),(0,C.$Sc)(()=>{this.i.delete(s),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(s,r){if(this.k.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.k.add(s);const o=this.d++;return this.j.set(o,r),this.c.$registerFileSearchProvider(o,this.s(s)),(0,C.$Sc)(()=>{this.k.delete(s),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(s,r,o,n){const i=l(o),c=this.j.get(s);if(c)return this.l.fileSearch(i,c,u=>{this.c.$handleFileMatch(s,r,u.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,r,o){return{messages:[]}}$clearCache(s){return this.l.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,r,o,n){const i=this.e.get(s);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${s}`);const c=l(o);return this.t(c,i).search(t=>this.c.$handleTextMatch(s,r,t),n)}$provideAITextSearchResults(s,r,o,n){const i=this.h.get(s);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${s}`);const c=l(o);return this.v(c,i).search(t=>this.c.$handleTextMatch(s,r,t),n)}$enableExtensionHostSearch(){}t(s,r){return new T.$Omc({query:s,provider:r},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(s,r){return new T.$Omc({query:s,provider:r},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$Tmc=k,e.$Tmc=k=Je([We(0,A.$zP),We(1,$.$Klc),We(2,m.$3j)],k);function l(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(w),extraFileResources:f.extraFileResources&&f.extraFileResources.map(s=>E.URI.revive(s))}}function w(f){return{...f,folder:E.URI.revive(f.folder)}}}),define(Se[307],Pe([1,0,24,14,5,6,16,33,2,158,154,141,95,20,38,12,58,59,213,4,257,285,80,86,262,263,264,243,232,32,265,40,266,123,112,267,245,258,268,269,68,67,259,41,271,65,272,46,27,286,287,246,273,90,274,81,82,248,300,276,219,277,288,278,118,249,279,280,281,17,282,124,83,283,250,284,84,87,121,63,53,116,289,290,260,291,292,88,8,7,251,61,252,64,293,294,111,39,227,79,26,120]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r,o,n,i,c,u,t,d,a,g,b,p,v,y,h,D,S,I,P,W,V,q,N,B,K,ie,ce,ye,ke,fe,$e,Te,ae,Ne,ne,z,x,be,Fe,De,pe,ge,Q,Y,he,ue,Me,de,Ce,Ae,je,U,F,G,H,ee,re,Oe,Be,He,_e,xe,et,tt,it,ct,gt,Ue,ot,X,Z,me,Ge,we,at,dt,It,Vt,Qt,ni,Zt,Et,Xt,Yt,Xe,si){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=Gt;function Gt(ht){const mt=ht.get(ae.$PP),xt=ht.get(Te.$vlc),Ht=ht.get(fe.$Slc),Mt=ht.get(ye.$rmc),ft=ht.get(Et.$Nlc),Ut=ht.get(tt.$TP),_t=ht.get(D.$Qlc),zt=ht.get(dt.$Klc),Qe=ht.get(G.$zP),ci=ht.get(_e.$_lc),Kt=ht.get(xe.$Tlc),Wt=ht.get(s.$4j),wt=ht.get(s.$3j),Tt=ht.get(me.$sDb),Ct=ht.get(t.$rlc),Ft=ht.get(Zt.$xnc),ei=ht.get(re.$jmc),jt=ht.get(ie.$3lc),oi=ht.get(pe.$nmc),Nt=ht.get(d.$Blc),At=ht.get(be.$gmc);Qe.set(i.$_M.ExtHostFileSystemInfo,xt),Qe.set(i.$_M.ExtHostLogLevelServiceShape,Wt),Qe.set(i.$_M.ExtHostWorkspace,ft),Qe.set(i.$_M.ExtHostConfiguration,_t),Qe.set(i.$_M.ExtHostExtensionService,Mt),Qe.set(i.$_M.ExtHostStorage,ci),Qe.set(i.$_M.ExtHostTunnelService,Tt),Qe.set(i.$_M.ExtHostWindow,Ft),Qe.set(i.$_M.ExtHostSecretState,ei),Qe.set(i.$_M.ExtHostTelemetry,Ut),Qe.set(i.$_M.ExtHostEditorTabs,jt),Qe.set(i.$_M.ExtHostManagedSockets,oi),Qe.set(i.$_M.ExtHostAuthentication,Nt),Qe.set(i.$_M.ExtHostChatProvider,At);const Ot=Qe.set(i.$_M.ExtHostDecorations,ht.get(P.$Cmc)),Pt=Qe.set(i.$_M.ExtHostDocumentsAndEditors,ht.get(K.$KP)),$t=Qe.set(i.$_M.ExtHostCommands,ht.get(y.$VP)),Dt=Qe.set(i.$_M.ExtHostTerminalService,ht.get(it.$cmc)),ri=Qe.set(i.$_M.ExtHostTerminalShellIntegration,ht.get(ct.$jnc)),kt=Qe.set(i.$_M.ExtHostDebugService,ht.get(I.$wmc)),gi=Qe.set(i.$_M.ExtHostSearch,ht.get(ee.$Smc)),ti=Qe.set(i.$_M.ExtHostTask,ht.get(et.$inc)),pi=Qe.set(i.$_M.ExtHostOutputService,ht.get(Ce.$8mc)),ui=Qe.set(i.$_M.ExtHostLocalization,ht.get(De.$mmc)),wi=Qe.set(i.$_M.ExtHostUrls,new It.$unc(Qe)),St=Qe.set(i.$_M.ExtHostDocuments,new B.$ylc(Qe,Pt)),ki=Qe.set(i.$_M.ExtHostDocumentContentProviders,new q.$Emc(Qe,Pt,wt)),ve=Qe.set(i.$_M.ExtHostDocumentSaveParticipant,new N.$Fmc(wt,St,Qe.getProxy(i.$$M.MainThreadBulkEdits))),Ie=Qe.set(i.$_M.ExtHostNotebook,new Q.$Vmc(Qe,$t,Pt,St,Ht,gi)),oe=Qe.set(i.$_M.ExtHostNotebookDocuments,new he.$2mc(Ie)),J=Qe.set(i.$_M.ExtHostNotebookEditors,new ue.$3mc(wt,Ie)),Re=Qe.set(i.$_M.ExtHostNotebookKernels,new Me.$4mc(Qe,mt,Ie,$t,wt)),Ve=Qe.set(i.$_M.ExtHostNotebookRenderers,new de.$6mc(Qe,Ie)),Ze=Qe.set(i.$_M.ExtHostNotebookDocumentSaveParticipant,new Y.$1mc(wt,Ie,Qe.getProxy(i.$$M.MainThreadBulkEdits))),qe=Qe.set(i.$_M.ExtHostEditors,new Ue.$Hlc(Qe,Pt)),ut=Qe.set(i.$_M.ExtHostTreeViews,new Z.$snc(Qe.getProxy(i.$$M.MainThreadTreeViews),$t,wt)),yt=Qe.set(i.$_M.ExtHostEditorInsets,new v.$Ilc(Qe.getProxy(i.$$M.MainThreadEditorInsets),qe,mt.remote)),Lt=Qe.set(i.$_M.ExtHostDiagnostics,new W.$xlc(Qe,wt,xt,Pt)),Bt=Qe.set(i.$_M.ExtHostLanguages,new Fe.$Ymc(Qe,St,$t.converter,zt)),st=Qe.set(i.$_M.ExtHostLanguageFeatures,new x.$zlc(Qe,zt,St,$t,Lt,wt,Ct,Ut)),Jt=Qe.set(i.$_M.ExtHostFileSystem,new ke.$Hmc(Qe,st)),mi=Qe.set(i.$_M.ExtHostFileSystemEventService,new $e.$Imc(Qe,wt,Pt)),yi=Qe.set(i.$_M.ExtHostQuickOpen,(0,F.$_mc)(Qe,ft,$t)),Si=Qe.set(i.$_M.ExtHostSCM,new H.$bnc(Qe,$t,St,wt)),Ki=Qe.set(i.$_M.ExtHostQuickDiff,new U.$$mc(Qe,zt)),Oi=Qe.set(i.$_M.ExtHostShare,new Oe.$cnc(Qe,zt)),Mi=Qe.set(i.$_M.ExtHostComments,(0,h.$Jlc)(Qe,$t,St)),Pi=Qe.set(i.$_M.ExtHostProgress,new je.$0mc(Qe.getProxy(i.$$M.MainThreadProgress))),Ti=Qe.set(i.$_M.ExtHostLabelService,new z.$Xmc(Qe)),Fi=Qe.set(i.$_M.ExtHostTheming,new ot.$pnc(Qe)),Ji=Qe.set(i.$_M.ExtHostTimeline,new X.$rnc(Qe,$t)),Li=Qe.set(i.$_M.ExtHostWebviews,new Vt.$Xlc(Qe,mt.remote,ft,wt,Ct)),Ii=Qe.set(i.$_M.ExtHostWebviewPanels,new Qt.$1lc(Qe,Li,ft)),zi=Qe.set(i.$_M.ExtHostCustomEditors,new S.$2lc(Qe,St,Kt,Li,Ii)),Ui=Qe.set(i.$_M.ExtHostWebviewViews,new ni.$vnc(Qe,Li)),bi=Qe.set(i.$_M.ExtHostTesting,new gt.$lnc(Qe,wt,$t,Pt)),Qi=Qe.set(i.$_M.ExtHostUriOpeners,new at.$tnc(Qe)),Zi=Qe.set(i.$_M.ExtHostProfileContentHandlers,new Ae.$9mc(Qe));Qe.set(i.$_M.ExtHostInteractive,new ne.$Wmc(Qe,Ie,Pt,$t,wt));const Xi=Qe.set(i.$_M.ExtHostInlineChat,new Ne.$Jmc(Qe,$t,St,wt)),Ci=Qe.set(i.$_M.ExtHostChatAgents2,new g.$Elc(Qe,wt,$t)),Yi=Qe.set(i.$_M.ExtHostChatVariables,new b.$Flc(Qe)),xi=Qe.set(i.$_M.ExtHostAiRelatedInformation,new c.$qlc(Qe)),dn=Qe.set(i.$_M.ExtHostAiEmbeddingVector,new ce.$Gmc(Qe)),Ri=Qe.set(i.$_M.ExtHostStatusBar,new He.$fnc(Qe,$t.converter)),ji=Qe.set(i.$_M.ExtHostSpeech,new Be.$dnc(Qe)),fn=Object.values(i.$_M);Qe.assertRegistered(fn);const gn=new a.$Dlc(Qe,Pt),_i=new p.$Glc(Qe),Bi=new ge.$Zmc(Qe,wt),Ai=new V.$Dmc(Qe);return u.$Alc.register($t),function(ze,li,Vi){function nt(_){return(se,Le,rt)=>{const vt=_(Rt=>{try{se.call(Le,Rt)}catch(Di){O.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${Di.toString()}`,{cause:Di})),Ut.onExtensionError(ze.identifier,Di)}});return rt?.push(vt),vt}}const bt=function(){let _=!ze.isUnderDevelopment;function se(){_||(wt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Le(rt){if(Array.isArray(rt))rt.forEach(Le);else if(typeof rt=="string")se();else{const vt=rt;typeof vt.scheme>"u"&&se(),typeof vt.exclusive=="boolean"&&(0,Xe.$PG)(ze,"documentFiltersExclusive")}return rt}}(),en={getSession(_,se,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Xe.$PG)(ze,"authLearnMore"),Nt.getSession(ze,_,se,Le)},getSessions(_,se){return(0,Xe.$PG)(ze,"authGetSessions"),Nt.getSessions(ze,_,se)},async hasSession(_,se){return(0,Xe.$PG)(ze,"authSession"),!!await Nt.getSession(ze,_,se,{silent:!0})},get onDidChangeSessions(){return nt(Nt.onDidChangeSessions)},registerAuthenticationProvider(_,se,Le,rt){return Nt.registerAuthenticationProvider(_,se,Le,rt)}},di={registerCommand(_,se,Le){return $t.registerCommand(!0,_,se,Le,void 0,ze)},registerTextEditorCommand(_,se,Le){return $t.registerCommand(!0,_,(...rt)=>{const vt=qe.getActiveTextEditor();if(!vt){wt.warn("Cannot execute "+_+" because there is no active text editor.");return}return vt.edit(Rt=>{se.apply(Le,[vt,Rt,...rt])}).then(Rt=>{Rt||wt.warn("Edits from command "+_+" were not applied.")},Rt=>{wt.warn("An error occurred while running command "+_,Rt)})},void 0,void 0,ze)},registerDiffInformationCommand:(_,se,Le)=>((0,Xe.$PG)(ze,"diffCommand"),$t.registerCommand(!0,_,async(...rt)=>{const vt=Pt.activeEditor(!0);if(!vt){wt.warn("Cannot execute "+_+" because there is no active text editor.");return}const Rt=await qe.getDiffInformation(vt.id);se.apply(Le,[Rt,...rt])},void 0,void 0,ze)),executeCommand(_,...se){return $t.executeCommand(_,...se)},getCommands(_=!1){return $t.getCommands(_)}},Ei={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return _i.value},get shell(){return Dt.getDefaultShell(!1)},get onDidChangeShell(){return nt(Dt.onDidChangeShell)},get isTelemetryEnabled(){return Ut.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return nt(Ut.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$PG)(ze,"telemetry"),Ut.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$PG)(ze,"telemetry"),nt(Ut.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,tt.$SP)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,se){return tt.$RP.validateSender(_),Ut.instantiateLogger(ze,_,se)},openExternal(_,se){return Ft.openUri(_,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:se?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===mt.environment.appUriScheme)return wi.createAppUri(_);try{return await Ft.asExternalUri(_,{allowTunneling:!!mt.remote.authority})}catch(se){if((0,A.$Fg)(_,A.Schemas.http)||(0,A.$Fg)(_,A.Schemas.https))return _;throw se}},get remoteName(){return(0,r.$Im)(mt.remote.authority)},get remoteAuthority(){return(0,Xe.$PG)(ze,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return wt.getLevel()},get onDidChangeLogLevel(){return nt(wt.onDidChangeLogLevel)},get appQuality(){return(0,Xe.$PG)(ze,"resolvers"),mt.quality},get appCommit(){return(0,Xe.$PG)(ze,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(Ei);const mn={createTestController(_,se,Le){return bi.createTestController(ze,_,se,Le)},createTestObserver(){return(0,Xe.$PG)(ze,"testObserver"),bi.createTestObserver()},runTests(_){return(0,Xe.$PG)(ze,"testObserver"),bi.runTests(_)},get onDidChangeTestResults(){return(0,Xe.$PG)(ze,"testObserver"),nt(bi.onResultsChanged)},get testResults(){return(0,Xe.$PG)(ze,"testObserver"),bi.results}},ii=mt.remote.isRemote?we.ExtensionKind.Workspace:we.ExtensionKind.UI,Ni={getExtension(_,se){(0,Xe.$OG)(ze,"extensionsAny")||(se=!1);const Le=li.mine.getExtensionDescription(_);if(Le)return new ye.$smc(Mt,ze.identifier,Le,ii,!1);if(se){const rt=li.all.getExtensionDescription(_);if(rt)return new ye.$smc(Mt,ze.identifier,rt,ii,!0)}},get all(){const _=[];for(const se of li.mine.getAllExtensionDescriptions())_.push(new ye.$smc(Mt,ze.identifier,se,ii,!1));return _},get allAcrossExtensionHosts(){(0,Xe.$PG)(ze,"extensionsAny");const _=new w.$Sm(li.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),se=[];for(const Le of li.all.getAllExtensionDescriptions()){const rt=!_.has(Le.identifier);se.push(new ye.$smc(Mt,ze.identifier,Le,ii,rt))}return se},get onDidChange(){return(0,Xe.$OG)(ze,"extensionsAny")?nt(R.Event.any(li.mine.onDidChange,li.all.onDidChange)):nt(li.mine.onDidChange)}},tn={createDiagnosticCollection(_){return Lt.createDiagnosticCollection(ze.identifier,_)},get onDidChangeDiagnostics(){return nt(Lt.onDidChangeDiagnostics)},getDiagnostics:_=>Lt.getDiagnostics(_),getLanguages(){return Bt.getLanguages()},setTextDocumentLanguage(_,se){return Bt.changeLanguage(_.uri,se)},match(_,se){const Le=Ge.LanguageSelector.from(_);let rt;return(0,T.$Yt)(Le)&&(rt=Ie.notebookDocuments.find(vt=>vt.apiNotebook.getCells().find(Rt=>Rt.document===se))?.apiNotebook),(0,T.$Xt)(Le,se.uri,se.languageId,!0,rt?.uri,rt?.notebookType)},registerCodeActionsProvider(_,se,Le){return st.registerCodeActionProvider(ze,bt(_),se,Le)},registerDocumentPasteEditProvider(_,se,Le){return(0,Xe.$PG)(ze,"documentPaste"),st.registerDocumentPasteEditProvider(ze,bt(_),se,Le)},registerCodeLensProvider(_,se){return st.registerCodeLensProvider(ze,bt(_),se)},registerDefinitionProvider(_,se){return st.registerDefinitionProvider(ze,bt(_),se)},registerDeclarationProvider(_,se){return st.registerDeclarationProvider(ze,bt(_),se)},registerImplementationProvider(_,se){return st.registerImplementationProvider(ze,bt(_),se)},registerTypeDefinitionProvider(_,se){return st.registerTypeDefinitionProvider(ze,bt(_),se)},registerHoverProvider(_,se){return st.registerHoverProvider(ze,bt(_),se,ze.identifier)},registerEvaluatableExpressionProvider(_,se){return st.registerEvaluatableExpressionProvider(ze,bt(_),se,ze.identifier)},registerInlineValuesProvider(_,se){return st.registerInlineValuesProvider(ze,bt(_),se,ze.identifier)},registerDocumentHighlightProvider(_,se){return st.registerDocumentHighlightProvider(ze,bt(_),se)},registerMultiDocumentHighlightProvider(_,se){return st.registerMultiDocumentHighlightProvider(ze,bt(_),se)},registerLinkedEditingRangeProvider(_,se){return st.registerLinkedEditingRangeProvider(ze,bt(_),se)},registerReferenceProvider(_,se){return st.registerReferenceProvider(ze,bt(_),se)},registerRenameProvider(_,se){return st.registerRenameProvider(ze,bt(_),se)},registerNewSymbolNamesProvider(_,se){return(0,Xe.$PG)(ze,"newSymbolNamesProvider"),st.registerNewSymbolNamesProvider(ze,bt(_),se)},registerDocumentSymbolProvider(_,se,Le){return st.registerDocumentSymbolProvider(ze,bt(_),se,Le)},registerWorkspaceSymbolProvider(_){return st.registerWorkspaceSymbolProvider(ze,_)},registerDocumentFormattingEditProvider(_,se){return st.registerDocumentFormattingEditProvider(ze,bt(_),se)},registerDocumentRangeFormattingEditProvider(_,se){return st.registerDocumentRangeFormattingEditProvider(ze,bt(_),se)},registerOnTypeFormattingEditProvider(_,se,Le,...rt){return st.registerOnTypeFormattingEditProvider(ze,bt(_),se,[Le].concat(rt))},registerDocumentSemanticTokensProvider(_,se,Le){return st.registerDocumentSemanticTokensProvider(ze,bt(_),se,Le)},registerDocumentRangeSemanticTokensProvider(_,se,Le){return st.registerDocumentRangeSemanticTokensProvider(ze,bt(_),se,Le)},registerSignatureHelpProvider(_,se,Le,...rt){return typeof Le=="object"?st.registerSignatureHelpProvider(ze,bt(_),se,Le):st.registerSignatureHelpProvider(ze,bt(_),se,typeof Le>"u"?[]:[Le,...rt])},registerCompletionItemProvider(_,se,...Le){return st.registerCompletionItemProvider(ze,bt(_),se,Le)},registerInlineCompletionItemProvider(_,se,Le){return se.handleDidShowCompletionItem&&(0,Xe.$PG)(ze,"inlineCompletionsAdditions"),se.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$PG)(ze,"inlineCompletionsAdditions"),Le&&(0,Xe.$PG)(ze,"inlineCompletionsAdditions"),st.registerInlineCompletionsProvider(ze,bt(_),se,Le)},registerInlineEditProvider(_,se){return(0,Xe.$PG)(ze,"inlineEdit"),st.registerInlineEditProvider(ze,bt(_),se)},registerDocumentLinkProvider(_,se){return st.registerDocumentLinkProvider(ze,bt(_),se)},registerColorProvider(_,se){return st.registerColorProvider(ze,bt(_),se)},registerFoldingRangeProvider(_,se){return st.registerFoldingRangeProvider(ze,bt(_),se)},registerSelectionRangeProvider(_,se){return st.registerSelectionRangeProvider(ze,_,se)},registerCallHierarchyProvider(_,se){return st.registerCallHierarchyProvider(ze,_,se)},registerTypeHierarchyProvider(_,se){return st.registerTypeHierarchyProvider(ze,_,se)},setLanguageConfiguration:(_,se)=>st.setLanguageConfiguration(ze,_,se),getTokenInformationAtPosition(_,se){return(0,Xe.$PG)(ze,"tokenInformation"),Bt.tokenAtPosition(_,se)},registerInlayHintsProvider(_,se){return st.registerInlayHintsProvider(ze,_,se)},createLanguageStatusItem(_,se){return Bt.createLanguageStatusItem(ze,_,se)},registerDocumentDropEditProvider(_,se,Le){return st.registerDocumentOnDropEditProvider(ze,_,se,(0,Xe.$OG)(ze,"documentPaste")?Le:void 0)}},nn={get activeTextEditor(){return qe.getActiveTextEditor()},get visibleTextEditors(){return qe.getVisibleTextEditors()},get activeTerminal(){return Dt.activeTerminal},get terminals(){return Dt.terminals},async showTextDocument(_,se,Le){m.URI.isUri(_)&&_.scheme===A.Schemas.vscodeRemote&&!_.authority&&Ct.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const rt=await(m.URI.isUri(_)?Promise.resolve(Wi.openTextDocument(_)):Promise.resolve(_));return qe.showTextDocument(rt,se,Le)},createTextEditorDecorationType(_){return qe.createTextEditorDecorationType(ze,_)},onDidChangeActiveTextEditor(_,se,Le){return nt(qe.onDidChangeActiveTextEditor)(_,se,Le)},onDidChangeVisibleTextEditors(_,se,Le){return nt(qe.onDidChangeVisibleTextEditors)(_,se,Le)},onDidChangeTextEditorSelection(_,se,Le){return nt(qe.onDidChangeTextEditorSelection)(_,se,Le)},onDidChangeTextEditorOptions(_,se,Le){return nt(qe.onDidChangeTextEditorOptions)(_,se,Le)},onDidChangeTextEditorVisibleRanges(_,se,Le){return nt(qe.onDidChangeTextEditorVisibleRanges)(_,se,Le)},onDidChangeTextEditorViewColumn(_,se,Le){return nt(qe.onDidChangeTextEditorViewColumn)(_,se,Le)},onDidCloseTerminal(_,se,Le){return nt(Dt.onDidCloseTerminal)(_,se,Le)},onDidOpenTerminal(_,se,Le){return nt(Dt.onDidOpenTerminal)(_,se,Le)},onDidChangeActiveTerminal(_,se,Le){return nt(Dt.onDidChangeActiveTerminal)(_,se,Le)},onDidChangeTerminalDimensions(_,se,Le){return(0,Xe.$PG)(ze,"terminalDimensions"),nt(Dt.onDidChangeTerminalDimensions)(_,se,Le)},onDidChangeTerminalState(_,se,Le){return nt(Dt.onDidChangeTerminalState)(_,se,Le)},onDidWriteTerminalData(_,se,Le){return(0,Xe.$PG)(ze,"terminalDataWriteEvent"),nt(Dt.onDidWriteTerminalData)(_,se,Le)},onDidExecuteTerminalCommand(_,se,Le){return(0,Xe.$PG)(ze,"terminalExecuteCommandEvent"),nt(Dt.onDidExecuteTerminalCommand)(_,se,Le)},onDidChangeTerminalShellIntegration(_,se,Le){return(0,Xe.$PG)(ze,"terminalShellIntegration"),nt(ri.onDidChangeTerminalShellIntegration)(_,se,Le)},onDidStartTerminalShellExecution(_,se,Le){return(0,Xe.$PG)(ze,"terminalShellIntegration"),nt(ri.onDidStartTerminalShellExecution)(_,se,Le)},onDidEndTerminalShellExecution(_,se,Le){return(0,Xe.$PG)(ze,"terminalShellIntegration"),nt(ri.onDidEndTerminalShellExecution)(_,se,Le)},get state(){return Ft.getState()},onDidChangeWindowState(_,se,Le){return nt(Ft.onDidChangeWindowState)(_,se,Le)},showInformationMessage(_,...se){return Bi.showMessage(ze,$.default.Info,_,se[0],se.slice(1))},showWarningMessage(_,...se){return Bi.showMessage(ze,$.default.Warning,_,se[0],se.slice(1))},showErrorMessage(_,...se){return Bi.showMessage(ze,$.default.Error,_,se[0],se.slice(1))},showQuickPick(_,se,Le){return yi.showQuickPick(ze,_,se,Le)},showWorkspaceFolderPick(_){return yi.showWorkspaceFolderPick(_)},showInputBox(_,se){return yi.showInput(_,se)},showOpenDialog(_){return Ai.showOpenDialog(ze,_)},showSaveDialog(_){return Ai.showSaveDialog(_)},createStatusBarItem(_,se,Le){let rt,vt,Rt;return typeof _=="string"?(rt=_,vt=se,Rt=Le):(vt=_,Rt=se),Ri.createStatusBarEntry(ze,rt,vt,Rt)},setStatusBarMessage(_,se){return Ri.setStatusBarMessage(_,se)},withScmProgress(_){return Ct.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Pi.withProgress(ze,{location:we.ProgressLocation.SourceControl},(se,Le)=>_({report(rt){}}))},withProgress(_,se){return Pi.withProgress(ze,_,se)},createOutputChannel(_,se){return pi.createOutputChannel(_,se,ze)},createWebviewPanel(_,se,Le,rt){return Ii.createWebviewPanel(ze,_,se,Le,rt)},createWebviewTextEditorInset(_,se,Le,rt){return(0,Xe.$PG)(ze,"editorInsets"),yt.createWebviewEditorInset(_,se,Le,rt,ze)},createTerminal(_,se,Le){return typeof _=="object"?"pty"in _?Dt.createExtensionTerminal(_):Dt.createTerminalFromOptions(_):Dt.createTerminal(_,se,Le)},registerTerminalLinkProvider(_){return Dt.registerLinkProvider(_)},registerTerminalProfileProvider(_,se){return Dt.registerProfileProvider(ze,_,se)},registerTerminalQuickFixProvider(_,se){return(0,Xe.$PG)(ze,"terminalQuickFixProvider"),Dt.registerTerminalQuickFixProvider(_,ze.identifier.value,se)},registerTreeDataProvider(_,se){return ut.registerTreeDataProvider(_,se,ze)},createTreeView(_,se){return ut.createTreeView(_,se,ze)},registerWebviewPanelSerializer:(_,se)=>Ii.registerWebviewPanelSerializer(ze,_,se),registerCustomEditorProvider:(_,se,Le={})=>zi.registerCustomEditorProvider(ze,_,se,Le),registerFileDecorationProvider(_){return Ot.registerFileDecorationProvider(_,ze)},registerUriHandler(_){return wi.registerUriHandler(ze,_)},createQuickPick(){return yi.createQuickPick(ze)},createInputBox(){return yi.createInputBox(ze)},get activeColorTheme(){return Fi.activeColorTheme},onDidChangeActiveColorTheme(_,se,Le){return nt(Fi.onDidChangeActiveColorTheme)(_,se,Le)},registerWebviewViewProvider(_,se,Le){return Ui.registerWebviewViewProvider(ze,_,se,Le?.webviewOptions)},get activeNotebookEditor(){return Ie.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,se,Le){return nt(Ie.onDidChangeActiveNotebookEditor)(_,se,Le)},get visibleNotebookEditors(){return Ie.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return nt(Ie.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,se,Le){return nt(J.onDidChangeNotebookEditorSelection)(_,se,Le)},onDidChangeNotebookEditorVisibleRanges(_,se,Le){return nt(J.onDidChangeNotebookEditorVisibleRanges)(_,se,Le)},showNotebookDocument(_,se){return Ie.showNotebookDocument(_,se)},registerExternalUriOpener(_,se,Le){return(0,Xe.$PG)(ze,"externalUriOpener"),Qi.registerExternalUriOpener(ze.identifier,_,se,Le)},registerProfileContentHandler(_,se){return(0,Xe.$PG)(ze,"profileContentHandlers"),Zi.registerProfileContentHandler(ze,_,se)},registerQuickDiffProvider(_,se,Le,rt){return(0,Xe.$PG)(ze,"quickDiffProvider"),Ki.registerQuickDiffProvider(bt(_),se,Le,rt)},get tabGroups(){return jt.tabGroups},registerShareProvider(_,se){return(0,Xe.$PG)(ze,"shareProvider"),Oi.registerShareProvider(bt(_),se)}},Wi={get rootPath(){return Ct.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(_){throw new O.$9("rootPath")},getWorkspaceFolder(_){return ft.getWorkspaceFolder(_)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(_){throw new O.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(_){throw new O.$9("workspaceFile")},updateWorkspaceFolders:(_,se,...Le)=>ft.updateWorkspaceFolders(ze,_,se||0,...Le),onDidChangeWorkspaceFolders:function(_,se,Le){return nt(ft.onDidChangeWorkspace)(_,se,Le)},asRelativePath:(_,se)=>ft.getRelativePath(_,se),findFiles:(_,se,Le,rt)=>ft.findFiles(_,se,Le,ze.identifier,rt),findFiles2:(_,se,Le)=>((0,Xe.$PG)(ze,"findFiles2"),ft.findFiles2(_,se,ze.identifier,Le)),findTextInFiles:(_,se,Le,rt)=>{(0,Xe.$PG)(ze,"findTextInFiles");let vt,Rt;return typeof se=="object"?(vt=se,Rt=Le):(vt={},Rt=se,rt=Le),ft.findTextInFiles(_,vt||{},Rt,ze.identifier,rt)},save:_=>ft.save(_),saveAs:_=>ft.saveAs(_),saveAll:_=>ft.saveAll(_),applyEdit(_,se){return gn.applyWorkspaceEdit(_,ze,se)},createFileSystemWatcher:(_,se,Le,rt)=>{let vt;return typeof se=="boolean"?vt={ignoreCreateEvents:!!se,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!rt,correlate:!1}:se&&((0,Xe.$PG)(ze,"createFileSystemWatcher"),vt={...se,correlate:!0}),mi.createFileSystemWatcher(ft,ze,_,vt)},get textDocuments(){return St.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new O.$9("textDocuments")},openTextDocument(_){let se;const Le=_;if(typeof _=="string")se=Promise.resolve(m.URI.file(_));else if(m.URI.isUri(_))se=Promise.resolve(_);else if(!Le||typeof Le=="object")se=St.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return se.then(rt=>(rt.scheme===A.Schemas.vscodeRemote&&!rt.authority&&Ct.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),St.ensureDocumentData(rt).then(vt=>vt.document)))},onDidOpenTextDocument:(_,se,Le)=>nt(St.onDidAddDocument)(_,se,Le),onDidCloseTextDocument:(_,se,Le)=>nt(St.onDidRemoveDocument)(_,se,Le),onDidChangeTextDocument:(_,se,Le)=>nt(St.onDidChangeDocument)(_,se,Le),onDidSaveTextDocument:(_,se,Le)=>nt(St.onDidSaveDocument)(_,se,Le),onWillSaveTextDocument:(_,se,Le)=>nt(ve.getOnWillSaveTextDocumentEvent(ze))(_,se,Le),get notebookDocuments(){return Ie.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,se){let Le;if(m.URI.isUri(_))Le=_,await Ie.openNotebookDocument(_);else if(typeof _=="string")Le=m.URI.revive(await Ie.createNotebookDocument({viewType:_,content:se}));else throw new Error("Invalid arguments");return Ie.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(_,se,Le){return nt(oe.onDidSaveNotebookDocument)(_,se,Le)},onDidChangeNotebookDocument(_,se,Le){return nt(oe.onDidChangeNotebookDocument)(_,se,Le)},onWillSaveNotebookDocument(_,se,Le){return nt(Ze.getOnWillSaveNotebookDocumentEvent(ze))(_,se,Le)},get onDidOpenNotebookDocument(){return nt(Ie.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return nt(Ie.onDidCloseNotebookDocument)},registerNotebookSerializer(_,se,Le,rt){return Ie.registerNotebookSerializer(ze,_,se,Le,(0,Xe.$OG)(ze,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(_,se,Le)=>nt(Vi.onDidChangeConfiguration)(_,se,Le),getConfiguration(_,se){return se=arguments.length===1?void 0:se,Vi.getConfiguration(_,se,ze)},registerTextDocumentContentProvider(_,se){return ki.registerTextDocumentContentProvider(_,se)},registerTaskProvider:(_,se)=>(Ct.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),ti.registerTaskProvider(ze,_,se)),registerFileSystemProvider(_,se,Le){return(0,M.$Rc)(Jt.registerFileSystemProvider(ze,_,se,Le),Ht.addFileSystemProvider(_,se,Le))},get fs(){return Ht.value},registerFileSearchProvider:(_,se)=>((0,Xe.$PG)(ze,"fileSearchProvider"),gi.registerFileSearchProvider(_,se)),registerTextSearchProvider:(_,se)=>((0,Xe.$PG)(ze,"textSearchProvider"),gi.registerTextSearchProvider(_,se)),registerAITextSearchProvider:(_,se)=>((0,Xe.$PG)(ze,"aiTextSearchProvider"),(0,Xe.$PG)(ze,"textSearchProvider"),gi.registerAITextSearchProvider(_,se)),registerRemoteAuthorityResolver:(_,se)=>((0,Xe.$PG)(ze,"resolvers"),Mt.registerRemoteAuthorityResolver(_,se)),registerResourceLabelFormatter:_=>((0,Xe.$PG)(ze,"resolvers"),Ti.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Xe.$PG)(ze,"resolvers"),Mt.getRemoteExecServer(_)),onDidCreateFiles:(_,se,Le)=>nt(mi.onDidCreateFile)(_,se,Le),onDidDeleteFiles:(_,se,Le)=>nt(mi.onDidDeleteFile)(_,se,Le),onDidRenameFiles:(_,se,Le)=>nt(mi.onDidRenameFile)(_,se,Le),onWillCreateFiles:(_,se,Le)=>nt(mi.getOnWillCreateFileEvent(ze))(_,se,Le),onWillDeleteFiles:(_,se,Le)=>nt(mi.getOnWillDeleteFileEvent(ze))(_,se,Le),onWillRenameFiles:(_,se,Le)=>nt(mi.getOnWillRenameFileEvent(ze))(_,se,Le),openTunnel:_=>((0,Xe.$PG)(ze,"tunnels"),Tt.openTunnel(ze,_).then(se=>{if(!se)throw new Error("cannot open tunnel");return se})),get tunnels(){return(0,Xe.$PG)(ze,"tunnels"),Tt.getTunnels()},onDidChangeTunnels:(_,se,Le)=>((0,Xe.$PG)(ze,"tunnels"),nt(Tt.onDidChangeTunnels)(_,se,Le)),registerPortAttributesProvider:(_,se)=>((0,Xe.$PG)(ze,"portsAttributes"),Tt.registerPortsAttributesProvider(_,se)),registerTunnelProvider:(_,se)=>((0,Xe.$PG)(ze,"tunnelFactory"),Tt.registerTunnelProvider(_,se)),registerTimelineProvider:(_,se)=>((0,Xe.$PG)(ze,"timeline"),Ji.registerTimelineProvider(_,se,ze.identifier,$t.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:_=>((0,Xe.$PG)(ze,"workspaceTrust"),ft.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,se,Le)=>nt(ft.onDidGrantWorkspaceTrust)(_,se,Le),registerEditSessionIdentityProvider:(_,se)=>((0,Xe.$PG)(ze,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(_,se)),onWillCreateEditSessionIdentity:(_,se,Le)=>((0,Xe.$PG)(ze,"editSessionIdentityProvider"),nt(ft.getOnWillCreateEditSessionIdentityEvent(ze))(_,se,Le)),registerCanonicalUriProvider:(_,se)=>((0,Xe.$PG)(ze,"canonicalUriProvider"),ft.registerCanonicalUriProvider(_,se)),getCanonicalUri:(_,se,Le)=>((0,Xe.$PG)(ze,"canonicalUriProvider"),ft.provideCanonicalUri(_,se,Le))},rn={get inputBox(){return Ct.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),Si.getLastInputBox(ze)},createSourceControl(_,se,Le){return Si.createSourceControl(ze,_,se,Le)}},$n={createCommentController(_,se){return Mi.createCommentController(ze,_,se)}},sn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){if((0,Xe.$OG)(ze,"debugFocus"))return kt.activeStackItem},registerDebugVisualizationProvider(_,se){return(0,Xe.$PG)(ze,"debugVisualization"),kt.registerDebugVisualizationProvider(ze,_,se)},registerDebugVisualizationTreeProvider(_,se){return(0,Xe.$PG)(ze,"debugVisualization"),kt.registerDebugVisualizationTree(ze,_,se)},onDidStartDebugSession(_,se,Le){return nt(kt.onDidStartDebugSession)(_,se,Le)},onDidTerminateDebugSession(_,se,Le){return nt(kt.onDidTerminateDebugSession)(_,se,Le)},onDidChangeActiveDebugSession(_,se,Le){return nt(kt.onDidChangeActiveDebugSession)(_,se,Le)},onDidReceiveDebugSessionCustomEvent(_,se,Le){return nt(kt.onDidReceiveDebugSessionCustomEvent)(_,se,Le)},onDidChangeBreakpoints(_,se,Le){return nt(kt.onDidChangeBreakpoints)(_,se,Le)},onDidChangeActiveStackItem(_,se,Le){return(0,Xe.$PG)(ze,"debugFocus"),nt(kt.onDidChangeActiveStackItem)(_,se,Le)},registerDebugConfigurationProvider(_,se,Le){return kt.registerDebugConfigurationProvider(_,se,Le||Xt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,se){return kt.registerDebugAdapterDescriptorFactory(ze,_,se)},registerDebugAdapterTrackerFactory(_,se){return kt.registerDebugAdapterTrackerFactory(_,se)},startDebugging(_,se,Le){return!Le||typeof Le=="object"&&"configuration"in Le?kt.startDebugging(_,se,{parentSession:Le}):kt.startDebugging(_,se,Le||{})},stopDebugging(_){return kt.stopDebugging(_)},addBreakpoints(_){return kt.addBreakpoints(_)},removeBreakpoints(_){return kt.removeBreakpoints(_)},asDebugSourceUri(_,se){return kt.asDebugSourceUri(_,se)}},on={registerTaskProvider:(_,se)=>ti.registerTaskProvider(ze,_,se),fetchTasks:_=>ti.fetchTasks(_),executeTask:_=>ti.executeTask(ze,_),get taskExecutions(){return ti.taskExecutions},onDidStartTask:(_,se,Le)=>nt(ti.onDidStartTask)(_,se,Le),onDidEndTask:(_,se,Le)=>nt(ti.onDidEndTask)(_,se,Le),onDidStartTaskProcess:(_,se,Le)=>nt(ti.onDidStartTaskProcess)(_,se,Le),onDidEndTaskProcess:(_,se,Le)=>nt(ti.onDidEndTaskProcess)(_,se,Le)},pn={createNotebookController(_,se,Le,rt,vt){return Re.createNotebookController(ze,_,se,Le,rt,(0,Xe.$OG)(ze,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(_,se)=>Ie.registerNotebookCellStatusBarItemProvider(ze,_,se),createRendererMessaging(_){return Ve.createRendererMessaging(ze,_)},createNotebookControllerDetectionTask(_){return(0,Xe.$PG)(ze,"notebookKernelSource"),Re.createNotebookControllerDetectionTask(ze,_)},registerKernelSourceActionProvider(_,se){return(0,Xe.$PG)(ze,"notebookKernelSource"),Re.registerKernelSourceActionProvider(ze,_,se)},onDidChangeNotebookCellExecutionState(_,se,Le){return(0,Xe.$PG)(ze,"notebookCellExecutionState"),nt(Re.onDidChangeNotebookCellExecutionState)(_,se,Le)}},wn={t(..._){if(typeof _[0]=="string"){const se=_.shift(),Le=!_||typeof _[0]!="object"?_:_[0];return ui.getMessage(ze.identifier.value,{message:se,args:Le})}return ui.getMessage(ze.identifier.value,_[0])},get bundle(){return ui.getBundle(ze.identifier.value)},get uri(){return ui.getBundleUri(ze.identifier.value)}},an={_version:1,registerInteractiveEditorSessionProvider(_,se){return(0,Xe.$PG)(ze,"interactive"),Xi.registerProvider(ze,_,se)},transferActiveChat(_){return(0,Xe.$PG)(ze,"interactive"),Ci.transferActiveChat(_)}},qi={getRelatedInformation(_,se){return(0,Xe.$PG)(ze,"aiRelatedInformation"),xi.getRelatedInformation(ze,_,se)},registerRelatedInformationProvider(_,se){return(0,Xe.$PG)(ze,"aiRelatedInformation"),xi.registerRelatedInformationProvider(ze,_,se)},registerEmbeddingVectorProvider(_,se){return(0,Xe.$PG)(ze,"aiRelatedInformation"),dn.registerEmbeddingVectorProvider(ze,_,se)}},cn={registerChatResponseProvider(_,se,Le){return(0,Xe.$PG)(ze,"chatProvider"),At.registerLanguageModel(ze,_,se,Le)},registerChatVariableResolver(_,se,Le){return(0,Xe.$PG)(ze,"chatVariableResolver"),Yi.registerVariableResolver(ze,_,se,Le)},registerMappedEditsProvider(_,se){return(0,Xe.$PG)(ze,"mappedEditsProvider"),st.registerMappedEditsProvider(ze,_,se)},createChatParticipant(_,se){return(0,Xe.$PG)(ze,"chatParticipant"),Ci.createChatAgent(ze,_,se)},createDynamicChatParticipant(_,se,Le,rt){return(0,Xe.$PG)(ze,"chatParticipantAdditions"),Ci.createDynamicChatAgent(ze,_,se,Le,rt)}},un={get languageModels(){return(0,Xe.$PG)(ze,"languageModels"),At.getLanguageModelIds()},onDidChangeLanguageModels:(_,se,Le)=>((0,Xe.$PG)(ze,"languageModels"),At.onDidChangeProviders(_,se,Le)),sendChatRequest(_,se,Le,rt){return(0,Xe.$PG)(ze,"languageModels"),At.sendChatRequest(ze,_,se,Le,rt)},computeTokenLength(_,se,Le){return(0,Xe.$PG)(ze,"languageModels"),Le??=C.CancellationToken.None,At.computeTokenLength(_,se,Le)},getLanguageModelInformation(_){return(0,Xe.$PG)(ze,"languageModels"),At.getLanguageModelInfo(_)}},ln={registerSpeechProvider(_,se){return(0,Xe.$PG)(ze,"speech"),ji.registerProvider(ze.identifier,_,se)}};return{version:mt.version,ai:qi,authentication:en,commands:di,comments:$n,chat:cn,debug:sn,env:Ei,extensions:Ni,interactive:an,l10n:wn,languages:tn,lm:un,notebooks:pn,scm:rn,speech:ln,tasks:on,tests:mn,window:nn,workspace:Wi,Breakpoint:we.$bO,TerminalOutputAnchor:we.TerminalOutputAnchor,ChatResultFeedbackKind:we.ChatResultFeedbackKind,ChatVariableLevel:we.ChatVariableLevel,ChatCompletionItem:we.$9O,CallHierarchyIncomingCall:we.$zN,CallHierarchyItem:we.$yN,CallHierarchyOutgoingCall:we.$AN,CancellationError:O.$5,CancellationTokenSource:C.$oe,CandidatePortSource:i.CandidatePortSource,CodeAction:we.$vN,CodeActionKind:we.$wN,CodeActionTriggerKind:we.CodeActionTriggerKind,CodeLens:we.$BN,Color:we.$ON,ColorInformation:we.$PN,ColorPresentation:we.$QN,ColorThemeKind:we.ColorThemeKind,CommentMode:we.CommentMode,CommentState:we.CommentState,CommentThreadCollapsibleState:we.CommentThreadCollapsibleState,CommentThreadState:we.CommentThreadState,CommentThreadApplicability:we.CommentThreadApplicability,CompletionItem:we.$IN,CompletionItemKind:we.CompletionItemKind,CompletionItemTag:we.CompletionItemTag,CompletionList:we.$JN,CompletionTriggerKind:we.CompletionTriggerKind,ConfigurationTarget:we.ConfigurationTarget,CustomExecution:we.$YN,DebugAdapterExecutable:we.$fO,DebugAdapterInlineImplementation:we.$iO,DebugAdapterNamedPipeServer:we.$hO,DebugAdapterServer:we.$gO,DebugConfigurationProviderTriggerKind:Xt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:we.DebugConsoleMode,DebugVisualization:we.$yO,DecorationRangeBehavior:we.DecorationRangeBehavior,Diagnostic:we.$oN,DiagnosticRelatedInformation:we.$nN,DiagnosticSeverity:we.DiagnosticSeverity,DiagnosticTag:we.DiagnosticTag,Disposable:we.$aN,DocumentHighlight:we.$rN,DocumentHighlightKind:we.DocumentHighlightKind,MultiDocumentHighlight:we.$sN,DocumentLink:we.$NN,DocumentSymbol:we.$uN,EndOfLine:we.EndOfLine,EnvironmentVariableMutatorType:we.EnvironmentVariableMutatorType,EvaluatableExpression:we.$lO,InlineValueText:we.$mO,InlineValueVariableLookup:we.$nO,InlineValueEvaluatableExpression:we.$oO,InlineCompletionTriggerKind:we.InlineCompletionTriggerKind,EventEmitter:R.$de,ExtensionKind:we.ExtensionKind,ExtensionMode:we.ExtensionMode,ExternalUriOpenerPriority:we.ExternalUriOpenerPriority,FileChangeType:we.FileChangeType,FileDecoration:we.$AO,FileDecoration2:we.$AO,FileSystemError:we.$rO,FileType:f.FileType,FilePermission:f.FilePermission,FoldingRange:we.$sO,FoldingRangeKind:we.FoldingRangeKind,FunctionBreakpoint:we.$dO,InlineCompletionItem:we.$KN,InlineCompletionList:we.$LN,Hover:we.$pN,VerboseHover:we.$qN,HoverVerbosityAction:we.HoverVerbosityAction,IndentAction:k.IndentAction,Location:we.$mN,MarkdownString:we.$CN,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:we.$DN,PortAutoForwardAction:we.PortAutoForwardAction,Position:we.$bN,ProcessExecution:we.$WN,ProgressLocation:we.ProgressLocation,QuickInputButtons:we.$zO,Range:we.$cN,RelativePattern:we.$_N,Selection:we.$dN,SelectionRange:we.$xN,SemanticTokens:we.$vO,SemanticTokensBuilder:we.$uO,SemanticTokensEdit:we.$wO,SemanticTokensEdits:we.$xO,SemanticTokensLegend:we.$tO,ShellExecution:we.$XN,ShellQuoting:we.ShellQuoting,SignatureHelp:we.$FN,SignatureHelpTriggerKind:we.SignatureHelpTriggerKind,SignatureInformation:we.$EN,SnippetString:we.$lN,SourceBreakpoint:we.$cO,StandardTokenType:we.StandardTokenType,StatusBarAlignment:we.StatusBarAlignment,SymbolInformation:we.$tN,SymbolKind:we.SymbolKind,SymbolTag:we.SymbolTag,Task:we.$ZN,TaskGroup:we.$VN,TaskPanelKind:we.TaskPanelKind,TaskRevealKind:we.TaskRevealKind,TaskScope:we.TaskScope,TerminalLink:we.$RN,TerminalQuickFixTerminalCommand:we.$TN,TerminalQuickFixOpener:we.$SN,TerminalLocation:we.TerminalLocation,TerminalProfile:we.$UN,TerminalExitReason:we.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:we.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:we.TextDocumentSaveReason,TextEdit:we.$hN,SnippetTextEdit:we.$jN,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:we.TextEditorLineNumbersStyle,TextEditorRevealType:we.TextEditorRevealType,TextEditorSelectionChangeKind:we.TextEditorSelectionChangeKind,SyntaxTokenType:we.SyntaxTokenType,TextDocumentChangeReason:we.TextDocumentChangeReason,ThemeColor:we.$$N,ThemeIcon:we.$0N,TreeItem:we.$1N,TreeItemCheckboxState:we.TreeItemCheckboxState,TreeItemCollapsibleState:we.TreeItemCollapsibleState,TypeHierarchyItem:we.$WO,UIKind:Yt.UIKind,Uri:m.URI,ViewColumn:we.ViewColumn,WorkspaceEdit:we.$kN,DocumentPasteTriggerKind:we.DocumentPasteTriggerKind,DocumentDropEdit:we.$7N,DocumentDropOrPasteEditKind:we.$8N,DocumentPasteEdit:we.$9N,InlayHint:we.$HN,InlayHintLabelPart:we.$GN,InlayHintKind:we.InlayHintKind,RemoteAuthorityResolverError:we.$gN,ResolvedAuthority:we.$eN,ManagedResolvedAuthority:we.$fN,SourceControlInputBoxValidationType:we.SourceControlInputBoxValidationType,ExtensionRuntime:we.ExtensionRuntime,TimelineItem:we.$KO,NotebookRange:we.$CO,NotebookCellKind:we.NotebookCellKind,NotebookCellExecutionState:we.NotebookCellExecutionState,NotebookCellData:we.$DO,NotebookData:we.$EO,NotebookRendererScript:we.$IO,NotebookCellStatusBarAlignment:we.NotebookCellStatusBarAlignment,NotebookEditorRevealType:we.NotebookEditorRevealType,NotebookCellOutput:we.$GO,NotebookCellOutputItem:we.$FO,NotebookCellStatusBarItem:we.$HO,NotebookControllerAffinity:we.NotebookControllerAffinity,NotebookControllerAffinity2:we.NotebookControllerAffinity2,NotebookEdit:we.$iN,NotebookKernelSourceAction:we.$JO,NotebookVariablesRequestKind:we.NotebookVariablesRequestKind,PortAttributes:we.$MO,LinkedEditingRanges:we.$LO,TestResultState:we.TestResultState,TestRunRequest:we.$NO,TestRunRequest2:we.$NO,TestMessage:we.$OO,TestTag:we.$PO,TestRunProfileKind:we.TestRunProfileKind,TextSearchCompleteMessageType:si.TextSearchCompleteMessageType,DataTransfer:we.$6N,DataTransferItem:we.$2N,TestCoverageCount:we.$QO,FileCoverage:we.$SO,StatementCoverage:we.$TO,BranchCoverage:we.$UO,DeclarationCoverage:we.$VO,WorkspaceTrustState:we.WorkspaceTrustState,LanguageStatusSeverity:we.LanguageStatusSeverity,QuickPickItemKind:we.QuickPickItemKind,InputBoxValidationSeverity:we.InputBoxValidationSeverity,TabInputText:we.$XO,TabInputTextDiff:we.$YO,TabInputTextMerge:we.$ZO,TabInputCustom:we.$1O,TabInputNotebook:we.$3O,TabInputNotebookDiff:we.$4O,TabInputWebview:we.$2O,TabInputTerminal:we.$5O,TabInputInteractiveWindow:we.$6O,TabInputChat:we.$7O,TabInputTextMultiDiff:we.$8O,TelemetryTrustedValue:o.$fp,LogLevel:s.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:we.InteractiveSessionVoteDirection,ChatCopyKind:we.ChatCopyKind,InteractiveEditorResponseFeedbackKind:we.InteractiveEditorResponseFeedbackKind,DebugStackFrame:we.$jO,DebugThread:we.$kO,RelatedInformationType:we.RelatedInformationType,SpeechToTextStatus:we.SpeechToTextStatus,TextToSpeechStatus:we.TextToSpeechStatus,PartialAcceptTriggerKind:we.PartialAcceptTriggerKind,KeywordRecognitionStatus:we.KeywordRecognitionStatus,ChatResponseMarkdownPart:we.$0O,ChatResponseFileTreePart:we.$aP,ChatResponseAnchorPart:we.$bP,ChatResponseProgressPart:we.$cP,ChatResponseReferencePart:we.$fP,ChatResponseWarningPart:we.$dP,ChatResponseTextEditPart:we.$gP,ChatResponseMarkdownWithVulnerabilitiesPart:we.$$O,ChatResponseCommandButtonPart:we.$eP,ChatResponseDetectedParticipantPart:we.$_O,ChatRequestTurn:we.$hP,ChatResponseTurn:we.$iP,ChatLocation:we.ChatLocation,LanguageModelChatSystemMessage:we.$jP,LanguageModelChatUserMessage:we.$kP,LanguageModelChatAssistantMessage:we.$lP,LanguageModelSystemMessage:we.$jP,LanguageModelUserMessage:we.$kP,LanguageModelAssistantMessage:we.$lP,LanguageModelError:we.$mP,NewSymbolName:we.$qO,NewSymbolNameTag:we.NewSymbolNameTag,NewSymbolNameTriggerKind:we.NewSymbolNameTriggerKind,InlineEdit:we.$nP,InlineEditTriggerKind:we.InlineEditTriggerKind}}}}),define(Se[308],Pe([1,0,56,118,39,112,40,32,68,53,121,123,124,84,88,80,111,65,46,83,63,67,247,12,122,81,82,86,90,116]),function(le,e,C,O,R,M,A,$,m,E,T,k,l,w,f,s,r,o,n,i,c,u,t,d,a,g,b,p,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$xs)(g.$mmc,g.$lmc,1),(0,C.$xs)(d.$4j,t.$znc,1),(0,C.$xs)(s.$rlc,s.$slc,1),(0,C.$xs)($.$VP,$.$UP,0),(0,C.$xs)(p.$Blc,p.$Clc,0),(0,C.$xs)(v.$gmc,v.$hmc,0),(0,C.$xs)(A.$Qlc,A.$Olc,0),(0,C.$xs)(o.$Slc,o.$Rlc,0),(0,C.$xs)(k.$wmc,k.$Amc,0),(0,C.$xs)(M.$Cmc,M.$Bmc,0),(0,C.$xs)(m.$KP,m.$JP,0),(0,C.$xs)(b.$nmc,b.$omc,0),(0,C.$xs)(n.$vlc,n.$ulc,0),(0,C.$xs)(O.$8mc,O.$7mc,1),(0,C.$xs)(l.$Smc,l.$Tmc,0),(0,C.$xs)(w.$_lc,w.$$lc,0),(0,C.$xs)(T.$inc,T.$hnc,0),(0,C.$xs)(E.$cmc,E.$fmc,0),(0,C.$xs)(y.$jnc,y.$knc,0),(0,C.$xs)(f.$sDb,f.$tDb,0),(0,C.$xs)(r.$xnc,r.$wnc,0),(0,C.$xs)(R.$Nlc,R.$Mlc,0),(0,C.$xs)(i.$jmc,i.$imc,0),(0,C.$xs)(c.$TP,c.$QP,0),(0,C.$xs)(u.$3lc,u.$4lc,0),(0,C.$xs)(a.$umc,a.$vmc,0)}),define(Se[309],Pe([1,0,307,41,2,304,7,11,253]),function(le,e,C,O,R,M,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jpc=void 0;class E extends M.$Cnc{j(){}getModule(w,f){for(const s of this.b){const r=s(w);if(r){w=r;break}}if(this.a.has(w))return this.a.get(w).load(w,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class T extends O.$qmc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(m.$Ipc);const w=this.h.invokeFunction(C.$ync);this.r=this.h.createInstance(E,w,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(w){return w.browser}async xb(w,f,s){f=f.with({path:k(f.path,".js")});const r=w?.identifier.value;r&&performance.mark(`code/extHost/willFetchExtensionCode/${r}`);const o=R.URI.revive(await this.C.$asBrowserUri(f)),n=await fetch(o.toString(!0));if(r&&performance.mark(`code/extHost/didFetchExtensionCode/${r}`),n.status!==200)throw new Error(n.statusText);const i=await n.text(),c=`${f.toString(!0)}#vscode-extension`,u=`${i}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",u)}catch(b){throw console.error(r?`Loading code for extension ${r} failed: ${b.message}`:`Loading code failed: ${b.message}`),console.error(`${f.toString(!0)}${typeof b.line=="number"?` line ${b.line}`:""}${typeof b.column=="number"?` column ${b.column}`:""}`),console.error(b),b}w&&await this.w.initializeLocalizedMessages(w);const d={},a={exports:d},g=b=>{const p=this.r.getModule(b,f);if(p===void 0)throw new Error(`Cannot load module '${b}'`);return p};try{return s.codeLoadingStart(),r&&performance.mark(`code/extHost/willLoadExtensionCode/${r}`),t(a,d,g),a.exports!==d?a.exports:d}finally{r&&performance.mark(`code/extHost/didLoadExtensionCode/${r}`),s.codeLoadingStop()}}async $setRemoteEnvironment(w){}async Bb(w=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+w;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,$.$xh)(10)}}e.$Jpc=T;function k(l,w){return l.endsWith(w)?l:l+w}}),define(Se[310],Pe([1,0,71,56,12,41,217,87,309]),function(le,e,C,O,R,M,A,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,O.$xs)(R.$3j,new C.$ti(A.$Bnc,[!0],!0)),(0,O.$xs)(M.$rmc,m.$Jpc,0),(0,O.$xs)($.$Tlc,$.$Ulc,0)}),define(Se[316],Pe([1,0,21,5,79,305,255,19,60,16,2,308,310]),function(le,e,C,O,R,M,A,$,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=u;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function w(t){return/^(file|vscode-remote):/i.test(t)}const f=fetch.bind(self);function s(t){self.fetch=async function(d,a){return d instanceof Request||w(String(d))&&(d=(await t(T.URI.parse(String(d)))).toString(!0)),f(d,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,a,g,b,p){(async()=>(w(a.toString())&&(a=(await t(T.URI.parse(a.toString()))).toString(!0)),super.open(d,a,g??!0,b,p)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(d,a){if(/^file:/i.test(d.toString()))d=E.$Qg.uriToBrowserUri(T.URI.parse(d.toString())).toString(!0);else if(/^vscode-remote:/i.test(d.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const b=`(${function(h){function D(P){return typeof P=="string"||P instanceof URL?String(P).replace(/^file:\/\//i,"vscode-file://vscode-app"):P}const S=fetch.bind(self);self.fetch=function(P,W){return P instanceof Request?S(P,W):S(D(P),W)},self.XMLHttpRequest=class extends XMLHttpRequest{open(P,W,V,q,N){return super.open(P,D(W),V??!0,q,N)}};const I=importScripts.bind(self);self.importScripts=(...P)=>{I(...P.map(D))},I(h)}.toString()}('${d}'))`;a=a||{},a.name=`${name} -> ${a.name||$.$nc(d.toString())}`;const p=new Blob([b],{type:"application/javascript"}),v=URL.createObjectURL(p);return new t(v,a)}}else self.Worker=class extends A.$Kpc{constructor(t,d){super(l,t,{name:$.$nc(t.toString()),...d})}};const r=new class{constructor(){this.pid=void 0}exit(t){k()}};class o{constructor(){const d=new MessageChannel,a=new O.$de;let g=!1;l(d.port2,[d.port2]),d.port1.onmessage=b=>{const{data:p}=b;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const v=C.$Fe.wrap(new Uint8Array(p,0,p.byteLength));if((0,R.$1m)(v,2)){g=!0,i("received terminate message from renderer");return}a.fire(v)},this.protocol={onMessage:a.event,send:b=>{if(!g){const p=b.buffer.buffer.slice(b.buffer.byteOffset,b.buffer.byteOffset+b.buffer.byteLength);d.port1.postMessage(p,[p])}}}}}function n(t){return new Promise(d=>{const a=t.onMessage(g=>{a.dispose();const b=JSON.parse(g.toString());t.send((0,R.$Zm)(0)),d({protocol:t,initData:b})});t.send((0,R.$Zm)(1))})}let i=t=>k();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function u(){m.mark("code/extHost/willConnectToRenderer");const t=new o;return{onmessage(d){c(d)&&n(t.protocol).then(a=>{m.mark("code/extHost/didWaitForInitData");const g=new M.$Enc(a.protocol,a.initData,r,null,d.data);s(b=>g.asBrowserUri(b)),i=b=>g.terminate(b)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a1f2ea3162c704a5890c35dde4df6ee46283d957/core/vs/workbench/api/worker/extensionHostWorker.js.map
